#include <qcolor.h>
#include <qimage.h>
#include <qimageblitz.h>
#include <qline.h>
#include <qnamespace.h>
#include <qobjectdefs.h>
#include <qpaintdevice.h>
#include <qpaintengine.h>
#include <qpainterpath.h>
#include <qpixmap.h>
#include <qpoint.h>
#include <qrect.h>
#include <qsize.h>

#include <smoke.h>

#include <qimageblitz_smoke.h>

static void *qimageblitz_cast(void *xptr, Smoke::Index from, Smoke::Index to) {
    switch(from) {
      case 1:	//Blitz
	switch(to) {
	    case 1: return (void*)(Blitz*)(Blitz*)xptr;
	  default: return xptr;
	}
      case 2:	//QColor
	switch(to) {
	    case 2: return (void*)(QColor*)(QColor*)xptr;
	  default: return xptr;
	}
      case 3:	//QImage
	switch(to) {
	    case 7: return (void*)(QPaintDevice*)(QImage*)xptr;
	    case 3: return (void*)(QImage*)(QImage*)xptr;
	  default: return xptr;
	}
      case 4:	//QLine
	switch(to) {
	    case 4: return (void*)(QLine*)(QLine*)xptr;
	  default: return xptr;
	}
      case 5:	//QLineF
	switch(to) {
	    case 5: return (void*)(QLineF*)(QLineF*)xptr;
	  default: return xptr;
	}
      case 6:	//QMetaObject
	switch(to) {
	    case 6: return (void*)(QMetaObject*)(QMetaObject*)xptr;
	  default: return xptr;
	}
      case 7:	//QPaintDevice
	switch(to) {
	    case 7: return (void*)(QPaintDevice*)(QPaintDevice*)xptr;
	    case 3: return (void*)(QImage*)(QPaintDevice*)xptr;
	    case 11: return (void*)(QPixmap*)(QPaintDevice*)xptr;
	  default: return xptr;
	}
      case 8:	//QPaintEngine
	switch(to) {
	    case 8: return (void*)(QPaintEngine*)(QPaintEngine*)xptr;
	  default: return xptr;
	}
      case 9:	//QPaintEngineState
	switch(to) {
	    case 9: return (void*)(QPaintEngineState*)(QPaintEngineState*)xptr;
	  default: return xptr;
	}
      case 10:	//QPainterPath
	switch(to) {
	    case 10: return (void*)(QPainterPath*)(QPainterPath*)xptr;
	  default: return xptr;
	}
      case 11:	//QPixmap
	switch(to) {
	    case 7: return (void*)(QPaintDevice*)(QPixmap*)xptr;
	    case 11: return (void*)(QPixmap*)(QPixmap*)xptr;
	  default: return xptr;
	}
      case 12:	//QPoint
	switch(to) {
	    case 12: return (void*)(QPoint*)(QPoint*)xptr;
	  default: return xptr;
	}
      case 13:	//QPointF
	switch(to) {
	    case 13: return (void*)(QPointF*)(QPointF*)xptr;
	  default: return xptr;
	}
      case 14:	//QRect
	switch(to) {
	    case 14: return (void*)(QRect*)(QRect*)xptr;
	  default: return xptr;
	}
      case 15:	//QRectF
	switch(to) {
	    case 15: return (void*)(QRectF*)(QRectF*)xptr;
	  default: return xptr;
	}
      case 16:	//QSize
	switch(to) {
	    case 16: return (void*)(QSize*)(QSize*)xptr;
	  default: return xptr;
	}
      default: return xptr;
    }
}

// Group of Indexes (0 separated) used as super class lists.
// Classes with super classes have an index into this array.
static Smoke::Index qimageblitz_inheritanceList[] = {
	0,	// 0: (no super class)
};

// These are the xenum functions for manipulating enum pointers
void xenum_Blitz(Smoke::EnumOperation, Smoke::Index, void*&, long&);

// Those are the xcall functions defined in each x_*.cpp file, for dispatching method calls
void xcall_Blitz(Smoke::Index, void*, Smoke::Stack);

// List of all classes
// Name, index into inheritanceList, method dispatcher, enum dispatcher, class flags
static Smoke::Class qimageblitz_classes[] = {
	{ 0L, false, 0, 0, 0, 0 }, 	// 0 (no class)
	{ "Blitz", false, 0, xcall_Blitz, xenum_Blitz, Smoke::cf_constructor|Smoke::cf_deepcopy }, 	//1
	{ "QColor", true, 0, 0, 0, 0 }, 	// 2
	{ "QImage", true, 0, 0, 0, 0 }, 	// 3
	{ "QLine", true, 0, 0, 0, 0 }, 	// 4
	{ "QLineF", true, 0, 0, 0, 0 }, 	// 5
	{ "QMetaObject", true, 0, 0, 0, 0 }, 	// 6
	{ "QPaintDevice", true, 0, 0, 0, 0 }, 	// 7
	{ "QPaintEngine", true, 0, 0, 0, 0 }, 	// 8
	{ "QPaintEngineState", true, 0, 0, 0, 0 }, 	// 9
	{ "QPainterPath", true, 0, 0, 0, 0 }, 	// 10
	{ "QPixmap", true, 0, 0, 0, 0 }, 	// 11
	{ "QPoint", true, 0, 0, 0, 0 }, 	// 12
	{ "QPointF", true, 0, 0, 0, 0 }, 	// 13
	{ "QRect", true, 0, 0, 0, 0 }, 	// 14
	{ "QRectF", true, 0, 0, 0, 0 }, 	// 15
	{ "QSize", true, 0, 0, 0, 0 }, 	// 16
	{ "Qt", true, 0, 0, 0, 0 }, 	// 17
};

// List of all types needed by the methods (arguments and return values)
// Name, class ID if arg is a class, and TypeId
static Smoke::Type qimageblitz_types[] = {
	{ 0, 0, 0 },	//0 (no type)
	{ "Blitz*", 1, Smoke::t_class | Smoke::tf_ptr },	//1
	{ "Blitz::EffectQuality", 1, Smoke::t_enum | Smoke::tf_stack },	//2
	{ "Blitz::GradientType", 1, Smoke::t_enum | Smoke::tf_stack },	//3
	{ "Blitz::ModulationType", 1, Smoke::t_enum | Smoke::tf_stack },	//4
	{ "Blitz::RGBChannel", 1, Smoke::t_enum | Smoke::tf_stack },	//5
	{ "Blitz::ScaleFilterType", 1, Smoke::t_enum | Smoke::tf_stack },	//6
	{ "QAbstractFileEngine::FileFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//7
	{ "QAbstractFileEngine::FileFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//8
	{ "QAbstractItemView::EditTriggers", 0, Smoke::t_uint | Smoke::tf_stack },	//9
	{ "QAbstractItemView::EditTriggers&", 0, Smoke::t_voidp | Smoke::tf_ref },	//10
	{ "QAbstractPrintDialog::PrintDialogOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//11
	{ "QAbstractPrintDialog::PrintDialogOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//12
	{ "QAbstractSpinBox::StepEnabled", 0, Smoke::t_uint | Smoke::tf_stack },	//13
	{ "QAbstractSpinBox::StepEnabled&", 0, Smoke::t_voidp | Smoke::tf_ref },	//14
	{ "QAccessible::Relation", 0, Smoke::t_uint | Smoke::tf_stack },	//15
	{ "QAccessible::Relation&", 0, Smoke::t_voidp | Smoke::tf_ref },	//16
	{ "QAccessible::State", 0, Smoke::t_uint | Smoke::tf_stack },	//17
	{ "QAccessible::State&", 0, Smoke::t_voidp | Smoke::tf_ref },	//18
	{ "QColor::Spec", 2, Smoke::t_enum | Smoke::tf_stack },	//19
	{ "QColorDialog::ColorDialogOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//20
	{ "QColorDialog::ColorDialogOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//21
	{ "QDBusConnection::RegisterOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//22
	{ "QDBusConnection::RegisterOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//23
	{ "QDateTimeEdit::Sections", 0, Smoke::t_uint | Smoke::tf_stack },	//24
	{ "QDateTimeEdit::Sections&", 0, Smoke::t_voidp | Smoke::tf_ref },	//25
	{ "QDialogButtonBox::StandardButtons", 0, Smoke::t_uint | Smoke::tf_stack },	//26
	{ "QDialogButtonBox::StandardButtons&", 0, Smoke::t_voidp | Smoke::tf_ref },	//27
	{ "QDir::Filters", 0, Smoke::t_uint | Smoke::tf_stack },	//28
	{ "QDir::Filters&", 0, Smoke::t_voidp | Smoke::tf_ref },	//29
	{ "QDir::SortFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//30
	{ "QDir::SortFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//31
	{ "QDirIterator::IteratorFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//32
	{ "QDirIterator::IteratorFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//33
	{ "QDockWidget::DockWidgetFeatures", 0, Smoke::t_uint | Smoke::tf_stack },	//34
	{ "QDockWidget::DockWidgetFeatures&", 0, Smoke::t_voidp | Smoke::tf_ref },	//35
	{ "QEventLoop::ProcessEventsFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//36
	{ "QEventLoop::ProcessEventsFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//37
	{ "QFile::Permissions", 0, Smoke::t_uint | Smoke::tf_stack },	//38
	{ "QFile::Permissions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//39
	{ "QFileDialog::Options", 0, Smoke::t_uint | Smoke::tf_stack },	//40
	{ "QFileDialog::Options&", 0, Smoke::t_voidp | Smoke::tf_ref },	//41
	{ "QFontComboBox::FontFilters", 0, Smoke::t_uint | Smoke::tf_stack },	//42
	{ "QFontComboBox::FontFilters&", 0, Smoke::t_voidp | Smoke::tf_ref },	//43
	{ "QFontDialog::FontDialogOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//44
	{ "QFontDialog::FontDialogOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//45
	{ "QGL::FormatOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//46
	{ "QGL::FormatOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//47
	{ "QGLFormat::OpenGLVersionFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//48
	{ "QGLFormat::OpenGLVersionFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//49
	{ "QGraphicsItem::GraphicsItemFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//50
	{ "QGraphicsItem::GraphicsItemFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//51
	{ "QGraphicsScene::SceneLayers", 0, Smoke::t_uint | Smoke::tf_stack },	//52
	{ "QGraphicsScene::SceneLayers&", 0, Smoke::t_voidp | Smoke::tf_ref },	//53
	{ "QGraphicsView::CacheMode", 0, Smoke::t_uint | Smoke::tf_stack },	//54
	{ "QGraphicsView::CacheMode&", 0, Smoke::t_voidp | Smoke::tf_ref },	//55
	{ "QGraphicsView::OptimizationFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//56
	{ "QGraphicsView::OptimizationFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//57
	{ "QIODevice::OpenMode", 0, Smoke::t_uint | Smoke::tf_stack },	//58
	{ "QIODevice::OpenMode&", 0, Smoke::t_voidp | Smoke::tf_ref },	//59
	{ "QImage", 3, Smoke::t_class | Smoke::tf_stack },	//60
	{ "QImage&", 3, Smoke::t_class | Smoke::tf_ref },	//61
	{ "QImage::Format", 3, Smoke::t_enum | Smoke::tf_stack },	//62
	{ "QImage::InvertMode", 3, Smoke::t_enum | Smoke::tf_stack },	//63
	{ "QInputDialog::InputDialogOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//64
	{ "QInputDialog::InputDialogOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//65
	{ "QItemSelectionModel::SelectionFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//66
	{ "QItemSelectionModel::SelectionFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//67
	{ "QLibrary::LoadHints", 0, Smoke::t_uint | Smoke::tf_stack },	//68
	{ "QLibrary::LoadHints&", 0, Smoke::t_voidp | Smoke::tf_ref },	//69
	{ "QLocale::NumberOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//70
	{ "QLocale::NumberOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//71
	{ "QMainWindow::DockOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//72
	{ "QMainWindow::DockOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//73
	{ "QMdiArea::AreaOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//74
	{ "QMdiArea::AreaOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//75
	{ "QMdiSubWindow::SubWindowOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//76
	{ "QMdiSubWindow::SubWindowOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//77
	{ "QMessageBox::StandardButtons", 0, Smoke::t_uint | Smoke::tf_stack },	//78
	{ "QMessageBox::StandardButtons&", 0, Smoke::t_voidp | Smoke::tf_ref },	//79
	{ "QMetaObject::Call", 6, Smoke::t_enum | Smoke::tf_stack },	//80
	{ "QNetworkInterface::InterfaceFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//81
	{ "QNetworkInterface::InterfaceFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//82
	{ "QNetworkProxy::Capabilities", 0, Smoke::t_uint | Smoke::tf_stack },	//83
	{ "QNetworkProxy::Capabilities&", 0, Smoke::t_voidp | Smoke::tf_ref },	//84
	{ "QPageSetupDialog::PageSetupDialogOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//85
	{ "QPageSetupDialog::PageSetupDialogOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//86
	{ "QPaintDevice*", 7, Smoke::t_class | Smoke::tf_ptr },	//87
	{ "QPaintDevice::PaintDeviceMetric", 7, Smoke::t_enum | Smoke::tf_stack },	//88
	{ "QPaintEngine*", 8, Smoke::t_class | Smoke::tf_ptr },	//89
	{ "QPaintEngine::DirtyFlag", 8, Smoke::t_enum | Smoke::tf_stack },	//90
	{ "QPaintEngine::DirtyFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//91
	{ "QPaintEngine::DirtyFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//92
	{ "QPaintEngine::PaintEngineFeature", 8, Smoke::t_enum | Smoke::tf_stack },	//93
	{ "QPaintEngine::PaintEngineFeatures", 0, Smoke::t_uint | Smoke::tf_stack },	//94
	{ "QPaintEngine::PaintEngineFeatures&", 0, Smoke::t_voidp | Smoke::tf_ref },	//95
	{ "QPaintEngine::PolygonDrawMode", 8, Smoke::t_enum | Smoke::tf_stack },	//96
	{ "QPaintEngine::Type", 8, Smoke::t_enum | Smoke::tf_stack },	//97
	{ "QPainter::RenderHints", 0, Smoke::t_uint | Smoke::tf_stack },	//98
	{ "QPainter::RenderHints&", 0, Smoke::t_voidp | Smoke::tf_ref },	//99
	{ "QPainterPath::ElementType", 10, Smoke::t_enum | Smoke::tf_stack },	//100
	{ "QPixmap::Type", 11, Smoke::t_enum | Smoke::tf_stack },	//101
	{ "QPoint", 12, Smoke::t_class | Smoke::tf_stack },	//102
	{ "QSizePolicy::ControlTypes", 0, Smoke::t_uint | Smoke::tf_stack },	//103
	{ "QSizePolicy::ControlTypes&", 0, Smoke::t_voidp | Smoke::tf_ref },	//104
	{ "QSql::ParamType", 0, Smoke::t_uint | Smoke::tf_stack },	//105
	{ "QSql::ParamType&", 0, Smoke::t_voidp | Smoke::tf_ref },	//106
	{ "QString::SectionFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//107
	{ "QString::SectionFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//108
	{ "QStyle::State", 0, Smoke::t_uint | Smoke::tf_stack },	//109
	{ "QStyle::State&", 0, Smoke::t_voidp | Smoke::tf_ref },	//110
	{ "QStyle::SubControls", 0, Smoke::t_uint | Smoke::tf_stack },	//111
	{ "QStyle::SubControls&", 0, Smoke::t_voidp | Smoke::tf_ref },	//112
	{ "QStyleOptionButton::ButtonFeatures", 0, Smoke::t_uint | Smoke::tf_stack },	//113
	{ "QStyleOptionButton::ButtonFeatures&", 0, Smoke::t_voidp | Smoke::tf_ref },	//114
	{ "QStyleOptionFrameV2::FrameFeatures", 0, Smoke::t_uint | Smoke::tf_stack },	//115
	{ "QStyleOptionFrameV2::FrameFeatures&", 0, Smoke::t_voidp | Smoke::tf_ref },	//116
	{ "QStyleOptionQ3ListViewItem::Q3ListViewItemFeatures", 0, Smoke::t_uint | Smoke::tf_stack },	//117
	{ "QStyleOptionQ3ListViewItem::Q3ListViewItemFeatures&", 0, Smoke::t_voidp | Smoke::tf_ref },	//118
	{ "QStyleOptionTab::CornerWidgets", 0, Smoke::t_uint | Smoke::tf_stack },	//119
	{ "QStyleOptionTab::CornerWidgets&", 0, Smoke::t_voidp | Smoke::tf_ref },	//120
	{ "QStyleOptionToolBar::ToolBarFeatures", 0, Smoke::t_uint | Smoke::tf_stack },	//121
	{ "QStyleOptionToolBar::ToolBarFeatures&", 0, Smoke::t_voidp | Smoke::tf_ref },	//122
	{ "QStyleOptionToolButton::ToolButtonFeatures", 0, Smoke::t_uint | Smoke::tf_stack },	//123
	{ "QStyleOptionToolButton::ToolButtonFeatures&", 0, Smoke::t_voidp | Smoke::tf_ref },	//124
	{ "QStyleOptionViewItemV2::ViewItemFeatures", 0, Smoke::t_uint | Smoke::tf_stack },	//125
	{ "QStyleOptionViewItemV2::ViewItemFeatures&", 0, Smoke::t_voidp | Smoke::tf_ref },	//126
	{ "QTextBoundaryFinder::BoundaryReasons", 0, Smoke::t_uint | Smoke::tf_stack },	//127
	{ "QTextBoundaryFinder::BoundaryReasons&", 0, Smoke::t_voidp | Smoke::tf_ref },	//128
	{ "QTextCodec::ConversionFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//129
	{ "QTextCodec::ConversionFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//130
	{ "QTextDocument::FindFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//131
	{ "QTextDocument::FindFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//132
	{ "QTextEdit::AutoFormatting", 0, Smoke::t_uint | Smoke::tf_stack },	//133
	{ "QTextEdit::AutoFormatting&", 0, Smoke::t_voidp | Smoke::tf_ref },	//134
	{ "QTextFormat::PageBreakFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//135
	{ "QTextFormat::PageBreakFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//136
	{ "QTextItem::RenderFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//137
	{ "QTextItem::RenderFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//138
	{ "QTextOption::Flags", 0, Smoke::t_uint | Smoke::tf_stack },	//139
	{ "QTextOption::Flags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//140
	{ "QTextStream::NumberFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//141
	{ "QTextStream::NumberFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//142
	{ "QTreeWidgetItemIterator::IteratorFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//143
	{ "QTreeWidgetItemIterator::IteratorFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//144
	{ "QUdpSocket::BindMode", 0, Smoke::t_uint | Smoke::tf_stack },	//145
	{ "QUdpSocket::BindMode&", 0, Smoke::t_voidp | Smoke::tf_ref },	//146
	{ "QUrl::FormattingOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//147
	{ "QUrl::FormattingOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//148
	{ "QWidget::RenderFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//149
	{ "QWidget::RenderFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//150
	{ "QWizard::WizardOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//151
	{ "QWizard::WizardOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//152
	{ "Qt::Alignment", 0, Smoke::t_uint | Smoke::tf_stack },	//153
	{ "Qt::Alignment&", 0, Smoke::t_voidp | Smoke::tf_ref },	//154
	{ "Qt::AlignmentFlag", 17, Smoke::t_enum | Smoke::tf_stack },	//155
	{ "Qt::AnchorAttribute", 17, Smoke::t_enum | Smoke::tf_stack },	//156
	{ "Qt::ApplicationAttribute", 17, Smoke::t_enum | Smoke::tf_stack },	//157
	{ "Qt::ArrowType", 17, Smoke::t_enum | Smoke::tf_stack },	//158
	{ "Qt::AspectRatioMode", 17, Smoke::t_enum | Smoke::tf_stack },	//159
	{ "Qt::Axis", 17, Smoke::t_enum | Smoke::tf_stack },	//160
	{ "Qt::BGMode", 17, Smoke::t_enum | Smoke::tf_stack },	//161
	{ "Qt::BrushStyle", 17, Smoke::t_enum | Smoke::tf_stack },	//162
	{ "Qt::CaseSensitivity", 17, Smoke::t_enum | Smoke::tf_stack },	//163
	{ "Qt::CheckState", 17, Smoke::t_enum | Smoke::tf_stack },	//164
	{ "Qt::ClipOperation", 17, Smoke::t_enum | Smoke::tf_stack },	//165
	{ "Qt::ConnectionType", 17, Smoke::t_enum | Smoke::tf_stack },	//166
	{ "Qt::ContextMenuPolicy", 17, Smoke::t_enum | Smoke::tf_stack },	//167
	{ "Qt::Corner", 17, Smoke::t_enum | Smoke::tf_stack },	//168
	{ "Qt::CursorShape", 17, Smoke::t_enum | Smoke::tf_stack },	//169
	{ "Qt::DateFormat", 17, Smoke::t_enum | Smoke::tf_stack },	//170
	{ "Qt::DayOfWeek", 17, Smoke::t_enum | Smoke::tf_stack },	//171
	{ "Qt::DockWidgetArea", 17, Smoke::t_enum | Smoke::tf_stack },	//172
	{ "Qt::DockWidgetAreaSizes", 17, Smoke::t_enum | Smoke::tf_stack },	//173
	{ "Qt::DockWidgetAreas", 0, Smoke::t_uint | Smoke::tf_stack },	//174
	{ "Qt::DockWidgetAreas&", 0, Smoke::t_voidp | Smoke::tf_ref },	//175
	{ "Qt::DropAction", 17, Smoke::t_enum | Smoke::tf_stack },	//176
	{ "Qt::DropActions", 0, Smoke::t_uint | Smoke::tf_stack },	//177
	{ "Qt::DropActions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//178
	{ "Qt::EventPriority", 17, Smoke::t_enum | Smoke::tf_stack },	//179
	{ "Qt::FillRule", 17, Smoke::t_enum | Smoke::tf_stack },	//180
	{ "Qt::FocusPolicy", 17, Smoke::t_enum | Smoke::tf_stack },	//181
	{ "Qt::FocusReason", 17, Smoke::t_enum | Smoke::tf_stack },	//182
	{ "Qt::GlobalColor", 17, Smoke::t_enum | Smoke::tf_stack },	//183
	{ "Qt::HitTestAccuracy", 17, Smoke::t_enum | Smoke::tf_stack },	//184
	{ "Qt::ImageConversionFlag", 17, Smoke::t_enum | Smoke::tf_stack },	//185
	{ "Qt::ImageConversionFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//186
	{ "Qt::ImageConversionFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//187
	{ "Qt::InputMethodQuery", 17, Smoke::t_enum | Smoke::tf_stack },	//188
	{ "Qt::ItemDataRole", 17, Smoke::t_enum | Smoke::tf_stack },	//189
	{ "Qt::ItemFlag", 17, Smoke::t_enum | Smoke::tf_stack },	//190
	{ "Qt::ItemFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//191
	{ "Qt::ItemFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//192
	{ "Qt::ItemSelectionMode", 17, Smoke::t_enum | Smoke::tf_stack },	//193
	{ "Qt::Key", 17, Smoke::t_enum | Smoke::tf_stack },	//194
	{ "Qt::KeyboardModifier", 17, Smoke::t_enum | Smoke::tf_stack },	//195
	{ "Qt::KeyboardModifiers", 0, Smoke::t_uint | Smoke::tf_stack },	//196
	{ "Qt::KeyboardModifiers&", 0, Smoke::t_voidp | Smoke::tf_ref },	//197
	{ "Qt::LayoutDirection", 17, Smoke::t_enum | Smoke::tf_stack },	//198
	{ "Qt::MaskMode", 17, Smoke::t_enum | Smoke::tf_stack },	//199
	{ "Qt::MatchFlag", 17, Smoke::t_enum | Smoke::tf_stack },	//200
	{ "Qt::MatchFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//201
	{ "Qt::MatchFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//202
	{ "Qt::Modifier", 17, Smoke::t_enum | Smoke::tf_stack },	//203
	{ "Qt::MouseButton", 17, Smoke::t_enum | Smoke::tf_stack },	//204
	{ "Qt::MouseButtons", 0, Smoke::t_uint | Smoke::tf_stack },	//205
	{ "Qt::MouseButtons&", 0, Smoke::t_voidp | Smoke::tf_ref },	//206
	{ "Qt::Orientation", 17, Smoke::t_enum | Smoke::tf_stack },	//207
	{ "Qt::Orientations", 0, Smoke::t_uint | Smoke::tf_stack },	//208
	{ "Qt::Orientations&", 0, Smoke::t_voidp | Smoke::tf_ref },	//209
	{ "Qt::PenCapStyle", 17, Smoke::t_enum | Smoke::tf_stack },	//210
	{ "Qt::PenJoinStyle", 17, Smoke::t_enum | Smoke::tf_stack },	//211
	{ "Qt::PenStyle", 17, Smoke::t_enum | Smoke::tf_stack },	//212
	{ "Qt::ScrollBarPolicy", 17, Smoke::t_enum | Smoke::tf_stack },	//213
	{ "Qt::ShortcutContext", 17, Smoke::t_enum | Smoke::tf_stack },	//214
	{ "Qt::SizeHint", 17, Smoke::t_enum | Smoke::tf_stack },	//215
	{ "Qt::SizeMode", 17, Smoke::t_enum | Smoke::tf_stack },	//216
	{ "Qt::SortOrder", 17, Smoke::t_enum | Smoke::tf_stack },	//217
	{ "Qt::TextElideMode", 17, Smoke::t_enum | Smoke::tf_stack },	//218
	{ "Qt::TextFlag", 17, Smoke::t_enum | Smoke::tf_stack },	//219
	{ "Qt::TextFormat", 17, Smoke::t_enum | Smoke::tf_stack },	//220
	{ "Qt::TextInteractionFlag", 17, Smoke::t_enum | Smoke::tf_stack },	//221
	{ "Qt::TextInteractionFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//222
	{ "Qt::TextInteractionFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//223
	{ "Qt::TimeSpec", 17, Smoke::t_enum | Smoke::tf_stack },	//224
	{ "Qt::ToolBarArea", 17, Smoke::t_enum | Smoke::tf_stack },	//225
	{ "Qt::ToolBarAreaSizes", 17, Smoke::t_enum | Smoke::tf_stack },	//226
	{ "Qt::ToolBarAreas", 0, Smoke::t_uint | Smoke::tf_stack },	//227
	{ "Qt::ToolBarAreas&", 0, Smoke::t_voidp | Smoke::tf_ref },	//228
	{ "Qt::ToolButtonStyle", 17, Smoke::t_enum | Smoke::tf_stack },	//229
	{ "Qt::TransformationMode", 17, Smoke::t_enum | Smoke::tf_stack },	//230
	{ "Qt::UIEffect", 17, Smoke::t_enum | Smoke::tf_stack },	//231
	{ "Qt::WhiteSpaceMode", 17, Smoke::t_enum | Smoke::tf_stack },	//232
	{ "Qt::WidgetAttribute", 17, Smoke::t_enum | Smoke::tf_stack },	//233
	{ "Qt::WindowFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//234
	{ "Qt::WindowFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//235
	{ "Qt::WindowFrameSection", 17, Smoke::t_enum | Smoke::tf_stack },	//236
	{ "Qt::WindowModality", 17, Smoke::t_enum | Smoke::tf_stack },	//237
	{ "Qt::WindowState", 17, Smoke::t_enum | Smoke::tf_stack },	//238
	{ "Qt::WindowStates", 0, Smoke::t_uint | Smoke::tf_stack },	//239
	{ "Qt::WindowStates&", 0, Smoke::t_voidp | Smoke::tf_ref },	//240
	{ "Qt::WindowType", 17, Smoke::t_enum | Smoke::tf_stack },	//241
	{ "bool", 0, Smoke::t_bool | Smoke::tf_stack },	//242
	{ "const Blitz&", 1, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//243
	{ "const QColor&", 2, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//244
	{ "const QImage&", 3, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//245
	{ "const QLine*", 4, Smoke::t_class | Smoke::tf_ptr | Smoke::tf_const },	//246
	{ "const QLineF*", 5, Smoke::t_class | Smoke::tf_ptr | Smoke::tf_const },	//247
	{ "const QPaintEngineState&", 9, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//248
	{ "const QPainterPath&", 10, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//249
	{ "const QPixmap&", 11, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//250
	{ "const QPoint*", 12, Smoke::t_class | Smoke::tf_ptr | Smoke::tf_const },	//251
	{ "const QPointF&", 13, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//252
	{ "const QPointF*", 13, Smoke::t_class | Smoke::tf_ptr | Smoke::tf_const },	//253
	{ "const QRect&", 14, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//254
	{ "const QRect*", 14, Smoke::t_class | Smoke::tf_ptr | Smoke::tf_const },	//255
	{ "const QRectF&", 15, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//256
	{ "const QRectF*", 15, Smoke::t_class | Smoke::tf_ptr | Smoke::tf_const },	//257
	{ "const QSize&", 16, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//258
	{ "float", 0, Smoke::t_float | Smoke::tf_stack },	//259
	{ "float*", 0, Smoke::t_voidp | Smoke::tf_ptr },	//260
	{ "int", 0, Smoke::t_int | Smoke::tf_stack },	//261
	{ "int*", 0, Smoke::t_voidp | Smoke::tf_ptr },	//262
	{ "unsigned char", 0, Smoke::t_uchar | Smoke::tf_stack },	//263
	{ "unsigned int", 0, Smoke::t_uint | Smoke::tf_stack },	//264
};

static Smoke::Index qimageblitz_argumentList[] = {
	0,	//0  (void)
	243, 0,	//1  const Blitz&  
	258, 244, 244, 3, 0,	//3  const QSize&, const QColor&, const QColor&, Blitz::GradientType  
	258, 244, 244, 3, 261, 0,	//8  const QSize&, const QColor&, const QColor&, Blitz::GradientType, int  
	258, 244, 244, 3, 261, 261, 0,	//14  const QSize&, const QColor&, const QColor&, Blitz::GradientType, int, int  
	258, 263, 263, 3, 0,	//21  const QSize&, unsigned char, unsigned char, Blitz::GradientType  
	258, 263, 263, 3, 261, 0,	//26  const QSize&, unsigned char, unsigned char, Blitz::GradientType, int  
	258, 263, 263, 3, 261, 261, 0,	//32  const QSize&, unsigned char, unsigned char, Blitz::GradientType, int, int  
	61, 0,	//39  QImage&  
	61, 242, 0,	//41  QImage&, bool  
	61, 242, 261, 0,	//44  QImage&, bool, int  
	61, 244, 244, 0,	//48  QImage&, const QColor&, const QColor&  
	61, 258, 0,	//52  QImage&, const QSize&  
	61, 258, 159, 0,	//55  QImage&, const QSize&, Qt::AspectRatioMode  
	61, 258, 259, 0,	//59  QImage&, const QSize&, float  
	61, 258, 259, 6, 0,	//63  QImage&, const QSize&, float, Blitz::ScaleFilterType  
	61, 258, 259, 6, 159, 0,	//68  QImage&, const QSize&, float, Blitz::ScaleFilterType, Qt::AspectRatioMode  
	61, 259, 0,	//74  QImage&, float  
	61, 259, 2, 0,	//77  QImage&, float, Blitz::EffectQuality  
	61, 259, 244, 0,	//81  QImage&, float, const QColor&  
	61, 259, 259, 0,	//85  QImage&, float, float  
	61, 259, 259, 2, 0,	//89  QImage&, float, float, Blitz::EffectQuality  
	61, 259, 259, 264, 0,	//94  QImage&, float, float, unsigned int  
	61, 259, 5, 0,	//99  QImage&, float, Blitz::RGBChannel  
	61, 261, 0,	//103  QImage&, int  
	61, 261, 260, 0,	//106  QImage&, int, float*  
	61, 261, 261, 0,	//110  QImage&, int, int  
	61, 261, 261, 159, 0,	//114  QImage&, int, int, Qt::AspectRatioMode  
	61, 261, 261, 259, 0,	//119  QImage&, int, int, float  
	61, 261, 261, 259, 6, 0,	//124  QImage&, int, int, float, Blitz::ScaleFilterType  
	61, 261, 261, 259, 6, 159, 0,	//130  QImage&, int, int, float, Blitz::ScaleFilterType, Qt::AspectRatioMode  
	61, 261, 262, 0,	//137  QImage&, int, int*  
	61, 261, 262, 261, 0,	//141  QImage&, int, int*, int  
	61, 263, 0,	//146  QImage&, unsigned char  
	61, 263, 5, 0,	//149  QImage&, unsigned char, Blitz::RGBChannel  
	61, 263, 5, 264, 0,	//153  QImage&, unsigned char, Blitz::RGBChannel, unsigned int  
	61, 263, 5, 264, 264, 0,	//158  QImage&, unsigned char, Blitz::RGBChannel, unsigned int, unsigned int  
	61, 61, 242, 4, 261, 5, 0,	//164  QImage&, QImage&, bool, Blitz::ModulationType, int, Blitz::RGBChannel  
	61, 63, 0,	//171  QImage&, QImage::InvertMode  
};

// Raw list of all methods, using munged names
static const char *qimageblitz_methodNames[] = {
    "",	//0
    "All",	//1
    "Alpha",	//2
    "BesselFilter",	//3
    "BlackmanFilter",	//4
    "Blitz",	//5
    "Blitz#",	//6
    "Blue",	//7
    "BoxFilter",	//8
    "Brightness",	//9
    "CatromFilter",	//10
    "Contrast",	//11
    "CrossDiagonalGradient",	//12
    "CubicFilter",	//13
    "DiagonalGradient",	//14
    "EllipticGradient",	//15
    "GaussianFilter",	//16
    "Grayscale",	//17
    "Green",	//18
    "HammingFilter",	//19
    "HanningFilter",	//20
    "HermiteFilter",	//21
    "High",	//22
    "HorizontalGradient",	//23
    "HueShift",	//24
    "Intensity",	//25
    "LanczosFilter",	//26
    "Low",	//27
    "MitchellFilter",	//28
    "PipeCrossGradient",	//29
    "PointFilter",	//30
    "PyramidGradient",	//31
    "QuadraticFilter",	//32
    "RectangleGradient",	//33
    "Red",	//34
    "Saturation",	//35
    "SincFilter",	//36
    "TriangleFilter",	//37
    "UndefinedFilter",	//38
    "VerticalGradient",	//39
    "antialias",	//40
    "antialias#",	//41
    "blur",	//42
    "blur#",	//43
    "blur#$",	//44
    "channelIntensity",	//45
    "channelIntensity#$$",	//46
    "charcoal",	//47
    "charcoal#",	//48
    "contrast",	//49
    "contrast#$",	//50
    "contrast#$$",	//51
    "convolve",	//52
    "convolve#$$",	//53
    "convolveEdge",	//54
    "convolveEdge#",	//55
    "convolveEdge#$",	//56
    "convolveEdge#$$",	//57
    "convolveInteger",	//58
    "convolveInteger#$$",	//59
    "convolveInteger#$$$",	//60
    "desaturate",	//61
    "desaturate#",	//62
    "desaturate#$",	//63
    "despeckle",	//64
    "despeckle#",	//65
    "edge",	//66
    "edge#",	//67
    "emboss",	//68
    "emboss#",	//69
    "emboss#$",	//70
    "emboss#$$",	//71
    "emboss#$$$",	//72
    "equalize",	//73
    "equalize#",	//74
    "fade",	//75
    "fade#$#",	//76
    "flatten",	//77
    "flatten###",	//78
    "gaussianBlur",	//79
    "gaussianBlur#",	//80
    "gaussianBlur#$",	//81
    "gaussianBlur#$$",	//82
    "gaussianSharpen",	//83
    "gaussianSharpen#",	//84
    "gaussianSharpen#$",	//85
    "gaussianSharpen#$$",	//86
    "gaussianSharpen#$$$",	//87
    "gradient",	//88
    "gradient###$",	//89
    "grayGradient",	//90
    "grayGradient#$$$",	//91
    "grayUnbalancedGradient",	//92
    "grayUnbalancedGradient#$$$",	//93
    "grayUnbalancedGradient#$$$$",	//94
    "grayUnbalancedGradient#$$$$$",	//95
    "grayscale",	//96
    "grayscale#",	//97
    "grayscale#$",	//98
    "implode",	//99
    "implode#",	//100
    "implode#$",	//101
    "intensity",	//102
    "intensity#$",	//103
    "invert",	//104
    "invert#",	//105
    "invert#$",	//106
    "modulate",	//107
    "modulate##$$$$",	//108
    "normalize",	//109
    "normalize#",	//110
    "oilPaint",	//111
    "oilPaint#",	//112
    "oilPaint#$",	//113
    "oilPaint#$$",	//114
    "sharpen",	//115
    "sharpen#",	//116
    "sharpen#$",	//117
    "smoothScale",	//118
    "smoothScale##",	//119
    "smoothScale##$",	//120
    "smoothScale#$$",	//121
    "smoothScale#$$$",	//122
    "smoothScaleFilter",	//123
    "smoothScaleFilter##",	//124
    "smoothScaleFilter##$",	//125
    "smoothScaleFilter##$$",	//126
    "smoothScaleFilter##$$$",	//127
    "smoothScaleFilter#$$",	//128
    "smoothScaleFilter#$$$",	//129
    "smoothScaleFilter#$$$$",	//130
    "smoothScaleFilter#$$$$$",	//131
    "swirl",	//132
    "swirl#",	//133
    "swirl#$",	//134
    "threshold",	//135
    "threshold#",	//136
    "threshold#$",	//137
    "threshold#$$",	//138
    "threshold#$$$",	//139
    "threshold#$$$$",	//140
    "unbalancedGradient",	//141
    "unbalancedGradient###$",	//142
    "unbalancedGradient###$$",	//143
    "unbalancedGradient###$$$",	//144
    "wave",	//145
    "wave#",	//146
    "wave#$",	//147
    "wave#$$",	//148
    "wave#$$$",	//149
    "~Blitz",	//150
};

// (classId, name (index in methodNames), argumentList index, number of args, method flags, return type (index in types), xcall() index)
static Smoke::Method qimageblitz_methods[] = {
	{1, 39, 0, 0, Smoke::mf_static|Smoke::mf_enum, 3, 1},	//0 Blitz::VerticalGradient (enum)
	{1, 23, 0, 0, Smoke::mf_static|Smoke::mf_enum, 3, 2},	//1 Blitz::HorizontalGradient (enum)
	{1, 14, 0, 0, Smoke::mf_static|Smoke::mf_enum, 3, 3},	//2 Blitz::DiagonalGradient (enum)
	{1, 12, 0, 0, Smoke::mf_static|Smoke::mf_enum, 3, 4},	//3 Blitz::CrossDiagonalGradient (enum)
	{1, 31, 0, 0, Smoke::mf_static|Smoke::mf_enum, 3, 5},	//4 Blitz::PyramidGradient (enum)
	{1, 33, 0, 0, Smoke::mf_static|Smoke::mf_enum, 3, 6},	//5 Blitz::RectangleGradient (enum)
	{1, 29, 0, 0, Smoke::mf_static|Smoke::mf_enum, 3, 7},	//6 Blitz::PipeCrossGradient (enum)
	{1, 15, 0, 0, Smoke::mf_static|Smoke::mf_enum, 3, 8},	//7 Blitz::EllipticGradient (enum)
	{1, 17, 0, 0, Smoke::mf_static|Smoke::mf_enum, 5, 9},	//8 Blitz::Grayscale (enum)
	{1, 9, 0, 0, Smoke::mf_static|Smoke::mf_enum, 5, 10},	//9 Blitz::Brightness (enum)
	{1, 34, 0, 0, Smoke::mf_static|Smoke::mf_enum, 5, 11},	//10 Blitz::Red (enum)
	{1, 18, 0, 0, Smoke::mf_static|Smoke::mf_enum, 5, 12},	//11 Blitz::Green (enum)
	{1, 7, 0, 0, Smoke::mf_static|Smoke::mf_enum, 5, 13},	//12 Blitz::Blue (enum)
	{1, 2, 0, 0, Smoke::mf_static|Smoke::mf_enum, 5, 14},	//13 Blitz::Alpha (enum)
	{1, 1, 0, 0, Smoke::mf_static|Smoke::mf_enum, 5, 15},	//14 Blitz::All (enum)
	{1, 27, 0, 0, Smoke::mf_static|Smoke::mf_enum, 2, 16},	//15 Blitz::Low (enum)
	{1, 22, 0, 0, Smoke::mf_static|Smoke::mf_enum, 2, 17},	//16 Blitz::High (enum)
	{1, 38, 0, 0, Smoke::mf_static|Smoke::mf_enum, 6, 18},	//17 Blitz::UndefinedFilter (enum)
	{1, 30, 0, 0, Smoke::mf_static|Smoke::mf_enum, 6, 19},	//18 Blitz::PointFilter (enum)
	{1, 8, 0, 0, Smoke::mf_static|Smoke::mf_enum, 6, 20},	//19 Blitz::BoxFilter (enum)
	{1, 37, 0, 0, Smoke::mf_static|Smoke::mf_enum, 6, 21},	//20 Blitz::TriangleFilter (enum)
	{1, 21, 0, 0, Smoke::mf_static|Smoke::mf_enum, 6, 22},	//21 Blitz::HermiteFilter (enum)
	{1, 20, 0, 0, Smoke::mf_static|Smoke::mf_enum, 6, 23},	//22 Blitz::HanningFilter (enum)
	{1, 19, 0, 0, Smoke::mf_static|Smoke::mf_enum, 6, 24},	//23 Blitz::HammingFilter (enum)
	{1, 4, 0, 0, Smoke::mf_static|Smoke::mf_enum, 6, 25},	//24 Blitz::BlackmanFilter (enum)
	{1, 16, 0, 0, Smoke::mf_static|Smoke::mf_enum, 6, 26},	//25 Blitz::GaussianFilter (enum)
	{1, 32, 0, 0, Smoke::mf_static|Smoke::mf_enum, 6, 27},	//26 Blitz::QuadraticFilter (enum)
	{1, 13, 0, 0, Smoke::mf_static|Smoke::mf_enum, 6, 28},	//27 Blitz::CubicFilter (enum)
	{1, 10, 0, 0, Smoke::mf_static|Smoke::mf_enum, 6, 29},	//28 Blitz::CatromFilter (enum)
	{1, 28, 0, 0, Smoke::mf_static|Smoke::mf_enum, 6, 30},	//29 Blitz::MitchellFilter (enum)
	{1, 26, 0, 0, Smoke::mf_static|Smoke::mf_enum, 6, 31},	//30 Blitz::LanczosFilter (enum)
	{1, 3, 0, 0, Smoke::mf_static|Smoke::mf_enum, 6, 32},	//31 Blitz::BesselFilter (enum)
	{1, 36, 0, 0, Smoke::mf_static|Smoke::mf_enum, 6, 33},	//32 Blitz::SincFilter (enum)
	{1, 25, 0, 0, Smoke::mf_static|Smoke::mf_enum, 4, 34},	//33 Blitz::Intensity (enum)
	{1, 35, 0, 0, Smoke::mf_static|Smoke::mf_enum, 4, 35},	//34 Blitz::Saturation (enum)
	{1, 24, 0, 0, Smoke::mf_static|Smoke::mf_enum, 4, 36},	//35 Blitz::HueShift (enum)
	{1, 11, 0, 0, Smoke::mf_static|Smoke::mf_enum, 4, 37},	//36 Blitz::Contrast (enum)
	{1, 5, 0, 0, Smoke::mf_ctor, 1, 38},	//37 Blitz::Blitz()
	{1, 150, 0, 0, Smoke::mf_dtor, 0, 116},	//38 Blitz::~Blitz()
	{1, 5, 1, 1, Smoke::mf_copyctor|Smoke::mf_internal|Smoke::mf_ctor, 1, 39},	//39 Blitz::Blitz(const Blitz&)
	{1, 104, 171, 2, Smoke::mf_static, 242, 40},	//40 Blitz::invert(QImage&, QImage::InvertMode)
	{1, 104, 39, 1, Smoke::mf_static, 242, 41},	//41 Blitz::invert(QImage&)
	{1, 96, 41, 2, Smoke::mf_static, 242, 42},	//42 Blitz::grayscale(QImage&, bool)
	{1, 96, 39, 1, Smoke::mf_static, 242, 43},	//43 Blitz::grayscale(QImage&)
	{1, 118, 55, 3, Smoke::mf_static, 60, 44},	//44 Blitz::smoothScale(QImage&, const QSize&, Qt::AspectRatioMode)
	{1, 118, 52, 2, Smoke::mf_static, 60, 45},	//45 Blitz::smoothScale(QImage&, const QSize&)
	{1, 118, 114, 4, Smoke::mf_static, 60, 46},	//46 Blitz::smoothScale(QImage&, int, int, Qt::AspectRatioMode)
	{1, 118, 110, 3, Smoke::mf_static, 60, 47},	//47 Blitz::smoothScale(QImage&, int, int)
	{1, 123, 68, 5, Smoke::mf_static, 60, 48},	//48 Blitz::smoothScaleFilter(QImage&, const QSize&, float, Blitz::ScaleFilterType, Qt::AspectRatioMode)
	{1, 123, 63, 4, Smoke::mf_static, 60, 49},	//49 Blitz::smoothScaleFilter(QImage&, const QSize&, float, Blitz::ScaleFilterType)
	{1, 123, 59, 3, Smoke::mf_static, 60, 50},	//50 Blitz::smoothScaleFilter(QImage&, const QSize&, float)
	{1, 123, 52, 2, Smoke::mf_static, 60, 51},	//51 Blitz::smoothScaleFilter(QImage&, const QSize&)
	{1, 123, 130, 6, Smoke::mf_static, 60, 52},	//52 Blitz::smoothScaleFilter(QImage&, int, int, float, Blitz::ScaleFilterType, Qt::AspectRatioMode)
	{1, 123, 124, 5, Smoke::mf_static, 60, 53},	//53 Blitz::smoothScaleFilter(QImage&, int, int, float, Blitz::ScaleFilterType)
	{1, 123, 119, 4, Smoke::mf_static, 60, 54},	//54 Blitz::smoothScaleFilter(QImage&, int, int, float)
	{1, 123, 110, 3, Smoke::mf_static, 60, 55},	//55 Blitz::smoothScaleFilter(QImage&, int, int)
	{1, 52, 106, 3, Smoke::mf_static, 60, 56},	//56 Blitz::convolve(QImage&, int, float*)
	{1, 58, 141, 4, Smoke::mf_static, 60, 57},	//57 Blitz::convolveInteger(QImage&, int, int*, int)
	{1, 58, 137, 3, Smoke::mf_static, 60, 58},	//58 Blitz::convolveInteger(QImage&, int, int*)
	{1, 42, 103, 2, Smoke::mf_static, 60, 59},	//59 Blitz::blur(QImage&, int)
	{1, 42, 39, 1, Smoke::mf_static, 60, 60},	//60 Blitz::blur(QImage&)
	{1, 79, 85, 3, Smoke::mf_static, 60, 61},	//61 Blitz::gaussianBlur(QImage&, float, float)
	{1, 79, 74, 2, Smoke::mf_static, 60, 62},	//62 Blitz::gaussianBlur(QImage&, float)
	{1, 79, 39, 1, Smoke::mf_static, 60, 63},	//63 Blitz::gaussianBlur(QImage&)
	{1, 66, 39, 1, Smoke::mf_static, 60, 64},	//64 Blitz::edge(QImage&)
	{1, 54, 77, 3, Smoke::mf_static, 60, 65},	//65 Blitz::convolveEdge(QImage&, float, Blitz::EffectQuality)
	{1, 54, 74, 2, Smoke::mf_static, 60, 66},	//66 Blitz::convolveEdge(QImage&, float)
	{1, 54, 39, 1, Smoke::mf_static, 60, 67},	//67 Blitz::convolveEdge(QImage&)
	{1, 83, 89, 4, Smoke::mf_static, 60, 68},	//68 Blitz::gaussianSharpen(QImage&, float, float, Blitz::EffectQuality)
	{1, 83, 85, 3, Smoke::mf_static, 60, 69},	//69 Blitz::gaussianSharpen(QImage&, float, float)
	{1, 83, 74, 2, Smoke::mf_static, 60, 70},	//70 Blitz::gaussianSharpen(QImage&, float)
	{1, 83, 39, 1, Smoke::mf_static, 60, 71},	//71 Blitz::gaussianSharpen(QImage&)
	{1, 115, 103, 2, Smoke::mf_static, 60, 72},	//72 Blitz::sharpen(QImage&, int)
	{1, 115, 39, 1, Smoke::mf_static, 60, 73},	//73 Blitz::sharpen(QImage&)
	{1, 68, 89, 4, Smoke::mf_static, 60, 74},	//74 Blitz::emboss(QImage&, float, float, Blitz::EffectQuality)
	{1, 68, 85, 3, Smoke::mf_static, 60, 75},	//75 Blitz::emboss(QImage&, float, float)
	{1, 68, 74, 2, Smoke::mf_static, 60, 76},	//76 Blitz::emboss(QImage&, float)
	{1, 68, 39, 1, Smoke::mf_static, 60, 77},	//77 Blitz::emboss(QImage&)
	{1, 40, 39, 1, Smoke::mf_static, 60, 78},	//78 Blitz::antialias(QImage&)
	{1, 64, 39, 1, Smoke::mf_static, 61, 79},	//79 Blitz::despeckle(QImage&)
	{1, 49, 44, 3, Smoke::mf_static, 61, 80},	//80 Blitz::contrast(QImage&, bool, int)
	{1, 49, 41, 2, Smoke::mf_static, 61, 81},	//81 Blitz::contrast(QImage&, bool)
	{1, 73, 39, 1, Smoke::mf_static, 242, 82},	//82 Blitz::equalize(QImage&)
	{1, 109, 39, 1, Smoke::mf_static, 242, 83},	//83 Blitz::normalize(QImage&)
	{1, 102, 74, 2, Smoke::mf_static, 61, 84},	//84 Blitz::intensity(QImage&, float)
	{1, 45, 99, 3, Smoke::mf_static, 61, 85},	//85 Blitz::channelIntensity(QImage&, float, Blitz::RGBChannel)
	{1, 61, 74, 2, Smoke::mf_static, 61, 86},	//86 Blitz::desaturate(QImage&, float)
	{1, 61, 39, 1, Smoke::mf_static, 61, 87},	//87 Blitz::desaturate(QImage&)
	{1, 75, 81, 3, Smoke::mf_static, 61, 88},	//88 Blitz::fade(QImage&, float, const QColor&)
	{1, 77, 48, 3, Smoke::mf_static, 61, 89},	//89 Blitz::flatten(QImage&, const QColor&, const QColor&)
	{1, 135, 158, 5, Smoke::mf_static, 60, 90},	//90 Blitz::threshold(QImage&, unsigned char, Blitz::RGBChannel, unsigned int, unsigned int)
	{1, 135, 153, 4, Smoke::mf_static, 60, 91},	//91 Blitz::threshold(QImage&, unsigned char, Blitz::RGBChannel, unsigned int)
	{1, 135, 149, 3, Smoke::mf_static, 60, 92},	//92 Blitz::threshold(QImage&, unsigned char, Blitz::RGBChannel)
	{1, 135, 146, 2, Smoke::mf_static, 60, 93},	//93 Blitz::threshold(QImage&, unsigned char)
	{1, 135, 39, 1, Smoke::mf_static, 60, 94},	//94 Blitz::threshold(QImage&)
	{1, 132, 74, 2, Smoke::mf_static, 60, 95},	//95 Blitz::swirl(QImage&, float)
	{1, 132, 39, 1, Smoke::mf_static, 60, 96},	//96 Blitz::swirl(QImage&)
	{1, 99, 74, 2, Smoke::mf_static, 60, 97},	//97 Blitz::implode(QImage&, float)
	{1, 99, 39, 1, Smoke::mf_static, 60, 98},	//98 Blitz::implode(QImage&)
	{1, 145, 94, 4, Smoke::mf_static, 60, 99},	//99 Blitz::wave(QImage&, float, float, unsigned int)
	{1, 145, 85, 3, Smoke::mf_static, 60, 100},	//100 Blitz::wave(QImage&, float, float)
	{1, 145, 74, 2, Smoke::mf_static, 60, 101},	//101 Blitz::wave(QImage&, float)
	{1, 145, 39, 1, Smoke::mf_static, 60, 102},	//102 Blitz::wave(QImage&)
	{1, 111, 77, 3, Smoke::mf_static, 60, 103},	//103 Blitz::oilPaint(QImage&, float, Blitz::EffectQuality)
	{1, 111, 74, 2, Smoke::mf_static, 60, 104},	//104 Blitz::oilPaint(QImage&, float)
	{1, 111, 39, 1, Smoke::mf_static, 60, 105},	//105 Blitz::oilPaint(QImage&)
	{1, 47, 39, 1, Smoke::mf_static, 60, 106},	//106 Blitz::charcoal(QImage&)
	{1, 88, 3, 4, Smoke::mf_static, 60, 107},	//107 Blitz::gradient(const QSize&, const QColor&, const QColor&, Blitz::GradientType)
	{1, 90, 21, 4, Smoke::mf_static, 60, 108},	//108 Blitz::grayGradient(const QSize&, unsigned char, unsigned char, Blitz::GradientType)
	{1, 141, 14, 6, Smoke::mf_static, 60, 109},	//109 Blitz::unbalancedGradient(const QSize&, const QColor&, const QColor&, Blitz::GradientType, int, int)
	{1, 141, 8, 5, Smoke::mf_static, 60, 110},	//110 Blitz::unbalancedGradient(const QSize&, const QColor&, const QColor&, Blitz::GradientType, int)
	{1, 141, 3, 4, Smoke::mf_static, 60, 111},	//111 Blitz::unbalancedGradient(const QSize&, const QColor&, const QColor&, Blitz::GradientType)
	{1, 92, 32, 6, Smoke::mf_static, 60, 112},	//112 Blitz::grayUnbalancedGradient(const QSize&, unsigned char, unsigned char, Blitz::GradientType, int, int)
	{1, 92, 26, 5, Smoke::mf_static, 60, 113},	//113 Blitz::grayUnbalancedGradient(const QSize&, unsigned char, unsigned char, Blitz::GradientType, int)
	{1, 92, 21, 4, Smoke::mf_static, 60, 114},	//114 Blitz::grayUnbalancedGradient(const QSize&, unsigned char, unsigned char, Blitz::GradientType)
	{1, 107, 164, 6, Smoke::mf_static, 61, 115},	//115 Blitz::modulate(QImage&, QImage&, bool, Blitz::ModulationType, int, Blitz::RGBChannel)
};

// Class ID, munged name ID (index into methodNames), method def (see methods) if >0 or number of overloads if <0
static Smoke::MethodMap qimageblitz_methodMaps[] = {
	{ 0, 0, 0 },	//0 (no method)
	{1, 1, 14},	//1 Blitz::All
	{1, 2, 13},	//2 Blitz::Alpha
	{1, 3, 31},	//3 Blitz::BesselFilter
	{1, 4, 24},	//4 Blitz::BlackmanFilter
	{1, 5, 37},	//5 Blitz::Blitz
	{1, 6, 39},	//6 Blitz::Blitz#
	{1, 7, 12},	//7 Blitz::Blue
	{1, 8, 19},	//8 Blitz::BoxFilter
	{1, 9, 9},	//9 Blitz::Brightness
	{1, 10, 28},	//10 Blitz::CatromFilter
	{1, 11, 36},	//11 Blitz::Contrast
	{1, 12, 3},	//12 Blitz::CrossDiagonalGradient
	{1, 13, 27},	//13 Blitz::CubicFilter
	{1, 14, 2},	//14 Blitz::DiagonalGradient
	{1, 15, 7},	//15 Blitz::EllipticGradient
	{1, 16, 25},	//16 Blitz::GaussianFilter
	{1, 17, 8},	//17 Blitz::Grayscale
	{1, 18, 11},	//18 Blitz::Green
	{1, 19, 23},	//19 Blitz::HammingFilter
	{1, 20, 22},	//20 Blitz::HanningFilter
	{1, 21, 21},	//21 Blitz::HermiteFilter
	{1, 22, 16},	//22 Blitz::High
	{1, 23, 1},	//23 Blitz::HorizontalGradient
	{1, 24, 35},	//24 Blitz::HueShift
	{1, 25, 33},	//25 Blitz::Intensity
	{1, 26, 30},	//26 Blitz::LanczosFilter
	{1, 27, 15},	//27 Blitz::Low
	{1, 28, 29},	//28 Blitz::MitchellFilter
	{1, 29, 6},	//29 Blitz::PipeCrossGradient
	{1, 30, 18},	//30 Blitz::PointFilter
	{1, 31, 4},	//31 Blitz::PyramidGradient
	{1, 32, 26},	//32 Blitz::QuadraticFilter
	{1, 33, 5},	//33 Blitz::RectangleGradient
	{1, 34, 10},	//34 Blitz::Red
	{1, 35, 34},	//35 Blitz::Saturation
	{1, 36, 32},	//36 Blitz::SincFilter
	{1, 37, 20},	//37 Blitz::TriangleFilter
	{1, 38, 17},	//38 Blitz::UndefinedFilter
	{1, 39, 0},	//39 Blitz::VerticalGradient
	{1, 41, 78},	//40 Blitz::antialias#
	{1, 43, 60},	//41 Blitz::blur#
	{1, 44, 59},	//42 Blitz::blur#$
	{1, 46, 85},	//43 Blitz::channelIntensity#$$
	{1, 48, 106},	//44 Blitz::charcoal#
	{1, 50, 81},	//45 Blitz::contrast#$
	{1, 51, 80},	//46 Blitz::contrast#$$
	{1, 53, 56},	//47 Blitz::convolve#$$
	{1, 55, 67},	//48 Blitz::convolveEdge#
	{1, 56, 66},	//49 Blitz::convolveEdge#$
	{1, 57, 65},	//50 Blitz::convolveEdge#$$
	{1, 59, 58},	//51 Blitz::convolveInteger#$$
	{1, 60, 57},	//52 Blitz::convolveInteger#$$$
	{1, 62, 87},	//53 Blitz::desaturate#
	{1, 63, 86},	//54 Blitz::desaturate#$
	{1, 65, 79},	//55 Blitz::despeckle#
	{1, 67, 64},	//56 Blitz::edge#
	{1, 69, 77},	//57 Blitz::emboss#
	{1, 70, 76},	//58 Blitz::emboss#$
	{1, 71, 75},	//59 Blitz::emboss#$$
	{1, 72, 74},	//60 Blitz::emboss#$$$
	{1, 74, 82},	//61 Blitz::equalize#
	{1, 76, 88},	//62 Blitz::fade#$#
	{1, 78, 89},	//63 Blitz::flatten###
	{1, 80, 63},	//64 Blitz::gaussianBlur#
	{1, 81, 62},	//65 Blitz::gaussianBlur#$
	{1, 82, 61},	//66 Blitz::gaussianBlur#$$
	{1, 84, 71},	//67 Blitz::gaussianSharpen#
	{1, 85, 70},	//68 Blitz::gaussianSharpen#$
	{1, 86, 69},	//69 Blitz::gaussianSharpen#$$
	{1, 87, 68},	//70 Blitz::gaussianSharpen#$$$
	{1, 89, 107},	//71 Blitz::gradient###$
	{1, 91, 108},	//72 Blitz::grayGradient#$$$
	{1, 93, 114},	//73 Blitz::grayUnbalancedGradient#$$$
	{1, 94, 113},	//74 Blitz::grayUnbalancedGradient#$$$$
	{1, 95, 112},	//75 Blitz::grayUnbalancedGradient#$$$$$
	{1, 97, 43},	//76 Blitz::grayscale#
	{1, 98, 42},	//77 Blitz::grayscale#$
	{1, 100, 98},	//78 Blitz::implode#
	{1, 101, 97},	//79 Blitz::implode#$
	{1, 103, 84},	//80 Blitz::intensity#$
	{1, 105, 41},	//81 Blitz::invert#
	{1, 106, 40},	//82 Blitz::invert#$
	{1, 108, 115},	//83 Blitz::modulate##$$$$
	{1, 110, 83},	//84 Blitz::normalize#
	{1, 112, 105},	//85 Blitz::oilPaint#
	{1, 113, 104},	//86 Blitz::oilPaint#$
	{1, 114, 103},	//87 Blitz::oilPaint#$$
	{1, 116, 73},	//88 Blitz::sharpen#
	{1, 117, 72},	//89 Blitz::sharpen#$
	{1, 119, 45},	//90 Blitz::smoothScale##
	{1, 120, 44},	//91 Blitz::smoothScale##$
	{1, 121, 47},	//92 Blitz::smoothScale#$$
	{1, 122, 46},	//93 Blitz::smoothScale#$$$
	{1, 124, 51},	//94 Blitz::smoothScaleFilter##
	{1, 125, 50},	//95 Blitz::smoothScaleFilter##$
	{1, 126, 49},	//96 Blitz::smoothScaleFilter##$$
	{1, 127, 48},	//97 Blitz::smoothScaleFilter##$$$
	{1, 128, 55},	//98 Blitz::smoothScaleFilter#$$
	{1, 129, 54},	//99 Blitz::smoothScaleFilter#$$$
	{1, 130, 53},	//100 Blitz::smoothScaleFilter#$$$$
	{1, 131, 52},	//101 Blitz::smoothScaleFilter#$$$$$
	{1, 133, 96},	//102 Blitz::swirl#
	{1, 134, 95},	//103 Blitz::swirl#$
	{1, 136, 94},	//104 Blitz::threshold#
	{1, 137, 93},	//105 Blitz::threshold#$
	{1, 138, 92},	//106 Blitz::threshold#$$
	{1, 139, 91},	//107 Blitz::threshold#$$$
	{1, 140, 90},	//108 Blitz::threshold#$$$$
	{1, 142, 111},	//109 Blitz::unbalancedGradient###$
	{1, 143, 110},	//110 Blitz::unbalancedGradient###$$
	{1, 144, 109},	//111 Blitz::unbalancedGradient###$$$
	{1, 146, 102},	//112 Blitz::wave#
	{1, 147, 101},	//113 Blitz::wave#$
	{1, 148, 100},	//114 Blitz::wave#$$
	{1, 149, 99},	//115 Blitz::wave#$$$
	{1, 150, 38},	//116 Blitz::~Blitz
};

static Smoke::Index qimageblitz_ambiguousMethodList[] = {
    0,
};


void init_qt_Smoke();

static bool initialized = false;
Smoke *qimageblitz_Smoke = 0;

// Create the Smoke instance encapsulating all the above.
void init_qimageblitz_Smoke() {
    if (initialized) return;
    init_qt_Smoke();
    qimageblitz_Smoke = new Smoke(
        "qimageblitz",
        qimageblitz_classes, 17,
        qimageblitz_methods, 116,
        qimageblitz_methodMaps, 116,
        qimageblitz_methodNames, 150,
        qimageblitz_types, 264,
        qimageblitz_inheritanceList,
        qimageblitz_argumentList,
        qimageblitz_ambiguousMethodList,
        qimageblitz_cast );
    initialized = true;
}
