#include <qaction.h>
#include <qbytearray.h>
#include <qcoreevent.h>
#include <qdatetime.h>
#include <qevent.h>
#include <qfont.h>
#include <qicon.h>
#include <qimage.h>
#include <qline.h>
#include <qmenu.h>
#include <qnamespace.h>
#include <qnetworkaccessmanager.h>
#include <qnetworkreply.h>
#include <qnetworkrequest.h>
#include <qobject.h>
#include <qobjectdefs.h>
#include <qpaintdevice.h>
#include <qpaintengine.h>
#include <qpainter.h>
#include <qpainterpath.h>
#include <qpalette.h>
#include <qpixmap.h>
#include <qpoint.h>
#include <qprinter.h>
#include <qrect.h>
#include <qregion.h>
#include <qsize.h>
#include <qstyle.h>
#include <qundostack.h>
#include <qurl.h>
#include <qvariant.h>
#include <qwebdatabase.h>
#include <qwebframe.h>
#include <qwebhistory.h>
#include <qwebhistoryinterface.h>
#include <qwebpage.h>
#include <qwebpluginfactory.h>
#include <qwebsecurityorigin.h>
#include <qwebsettings.h>
#include <qwebview.h>
#include <qwidget.h>

#include <smoke.h>

#include <qtwebkit_smoke.h>

static void *qtwebkit_cast(void *xptr, Smoke::Index from, Smoke::Index to) {
    switch(from) {
      case 1:	//QAction
	switch(to) {
	    case 29: return (void*)(QObject*)(QAction*)xptr;
	    case 1: return (void*)(QAction*)(QAction*)xptr;
	  default: return xptr;
	}
      case 2:	//QActionEvent
	switch(to) {
	    case 12: return (void*)(QEvent*)(QActionEvent*)xptr;
	    case 2: return (void*)(QActionEvent*)(QActionEvent*)xptr;
	  default: return xptr;
	}
      case 3:	//QByteArray
	switch(to) {
	    case 3: return (void*)(QByteArray*)(QByteArray*)xptr;
	  default: return xptr;
	}
      case 4:	//QChildEvent
	switch(to) {
	    case 12: return (void*)(QEvent*)(QChildEvent*)xptr;
	    case 4: return (void*)(QChildEvent*)(QChildEvent*)xptr;
	  default: return xptr;
	}
      case 5:	//QCloseEvent
	switch(to) {
	    case 12: return (void*)(QEvent*)(QCloseEvent*)xptr;
	    case 5: return (void*)(QCloseEvent*)(QCloseEvent*)xptr;
	  default: return xptr;
	}
      case 6:	//QContextMenuEvent
	switch(to) {
	    case 12: return (void*)(QEvent*)(QContextMenuEvent*)xptr;
	    case 6: return (void*)(QContextMenuEvent*)(QContextMenuEvent*)xptr;
	  default: return xptr;
	}
      case 7:	//QDateTime
	switch(to) {
	    case 7: return (void*)(QDateTime*)(QDateTime*)xptr;
	  default: return xptr;
	}
      case 8:	//QDragEnterEvent
	switch(to) {
	    case 10: return (void*)(QDragMoveEvent*)(QDragEnterEvent*)xptr;
	    case 11: return (void*)(QDropEvent*)(QDragEnterEvent*)xptr;
	    case 12: return (void*)(QEvent*)(QDragEnterEvent*)xptr;
	    case 8: return (void*)(QDragEnterEvent*)(QDragEnterEvent*)xptr;
	  default: return xptr;
	}
      case 9:	//QDragLeaveEvent
	switch(to) {
	    case 12: return (void*)(QEvent*)(QDragLeaveEvent*)xptr;
	    case 9: return (void*)(QDragLeaveEvent*)(QDragLeaveEvent*)xptr;
	  default: return xptr;
	}
      case 10:	//QDragMoveEvent
	switch(to) {
	    case 11: return (void*)(QDropEvent*)(QDragMoveEvent*)xptr;
	    case 12: return (void*)(QEvent*)(QDragMoveEvent*)xptr;
	    case 10: return (void*)(QDragMoveEvent*)(QDragMoveEvent*)xptr;
	    case 8: return (void*)(QDragEnterEvent*)(QDragMoveEvent*)xptr;
	  default: return xptr;
	}
      case 11:	//QDropEvent
	switch(to) {
	    case 12: return (void*)(QEvent*)(QDropEvent*)xptr;
	    case 11: return (void*)(QDropEvent*)(QDropEvent*)xptr;
	    case 8: return (void*)(QDragEnterEvent*)(QDropEvent*)xptr;
	    case 10: return (void*)(QDragMoveEvent*)(QDropEvent*)xptr;
	  default: return xptr;
	}
      case 12:	//QEvent
	switch(to) {
	    case 12: return (void*)(QEvent*)(QEvent*)xptr;
	    case 2: return (void*)(QActionEvent*)(QEvent*)xptr;
	    case 4: return (void*)(QChildEvent*)(QEvent*)xptr;
	    case 5: return (void*)(QCloseEvent*)(QEvent*)xptr;
	    case 6: return (void*)(QContextMenuEvent*)(QEvent*)xptr;
	    case 8: return (void*)(QDragEnterEvent*)(QEvent*)xptr;
	    case 9: return (void*)(QDragLeaveEvent*)(QEvent*)xptr;
	    case 10: return (void*)(QDragMoveEvent*)(QEvent*)xptr;
	    case 11: return (void*)(QDropEvent*)(QEvent*)xptr;
	    case 13: return (void*)(QFocusEvent*)(QEvent*)xptr;
	    case 15: return (void*)(QHideEvent*)(QEvent*)xptr;
	    case 18: return (void*)(QInputMethodEvent*)(QEvent*)xptr;
	    case 19: return (void*)(QKeyEvent*)(QEvent*)xptr;
	    case 24: return (void*)(QMouseEvent*)(QEvent*)xptr;
	    case 25: return (void*)(QMoveEvent*)(QEvent*)xptr;
	    case 33: return (void*)(QPaintEvent*)(QEvent*)xptr;
	    case 44: return (void*)(QResizeEvent*)(QEvent*)xptr;
	    case 45: return (void*)(QShowEvent*)(QEvent*)xptr;
	    case 48: return (void*)(QTabletEvent*)(QEvent*)xptr;
	    case 49: return (void*)(QTimerEvent*)(QEvent*)xptr;
	    case 64: return (void*)(QWheelEvent*)(QEvent*)xptr;
	  default: return xptr;
	}
      case 13:	//QFocusEvent
	switch(to) {
	    case 12: return (void*)(QEvent*)(QFocusEvent*)xptr;
	    case 13: return (void*)(QFocusEvent*)(QFocusEvent*)xptr;
	  default: return xptr;
	}
      case 14:	//QFont
	switch(to) {
	    case 14: return (void*)(QFont*)(QFont*)xptr;
	  default: return xptr;
	}
      case 15:	//QHideEvent
	switch(to) {
	    case 12: return (void*)(QEvent*)(QHideEvent*)xptr;
	    case 15: return (void*)(QHideEvent*)(QHideEvent*)xptr;
	  default: return xptr;
	}
      case 16:	//QIcon
	switch(to) {
	    case 16: return (void*)(QIcon*)(QIcon*)xptr;
	  default: return xptr;
	}
      case 17:	//QImage
	switch(to) {
	    case 30: return (void*)(QPaintDevice*)(QImage*)xptr;
	    case 17: return (void*)(QImage*)(QImage*)xptr;
	  default: return xptr;
	}
      case 18:	//QInputMethodEvent
	switch(to) {
	    case 12: return (void*)(QEvent*)(QInputMethodEvent*)xptr;
	    case 18: return (void*)(QInputMethodEvent*)(QInputMethodEvent*)xptr;
	  default: return xptr;
	}
      case 19:	//QKeyEvent
	switch(to) {
	    case 12: return (void*)(QEvent*)(QKeyEvent*)xptr;
	    case 19: return (void*)(QKeyEvent*)(QKeyEvent*)xptr;
	  default: return xptr;
	}
      case 20:	//QLine
	switch(to) {
	    case 20: return (void*)(QLine*)(QLine*)xptr;
	  default: return xptr;
	}
      case 21:	//QLineF
	switch(to) {
	    case 21: return (void*)(QLineF*)(QLineF*)xptr;
	  default: return xptr;
	}
      case 22:	//QMenu
	switch(to) {
	    case 65: return (void*)(QWidget*)(QMenu*)xptr;
	    case 29: return (void*)(QObject*)(QMenu*)xptr;
	    case 30: return (void*)(QPaintDevice*)(QMenu*)xptr;
	    case 22: return (void*)(QMenu*)(QMenu*)xptr;
	  default: return xptr;
	}
      case 23:	//QMetaObject
	switch(to) {
	    case 23: return (void*)(QMetaObject*)(QMetaObject*)xptr;
	  default: return xptr;
	}
      case 24:	//QMouseEvent
	switch(to) {
	    case 12: return (void*)(QEvent*)(QMouseEvent*)xptr;
	    case 24: return (void*)(QMouseEvent*)(QMouseEvent*)xptr;
	  default: return xptr;
	}
      case 25:	//QMoveEvent
	switch(to) {
	    case 12: return (void*)(QEvent*)(QMoveEvent*)xptr;
	    case 25: return (void*)(QMoveEvent*)(QMoveEvent*)xptr;
	  default: return xptr;
	}
      case 26:	//QNetworkAccessManager
	switch(to) {
	    case 29: return (void*)(QObject*)(QNetworkAccessManager*)xptr;
	    case 26: return (void*)(QNetworkAccessManager*)(QNetworkAccessManager*)xptr;
	  default: return xptr;
	}
      case 27:	//QNetworkReply
	switch(to) {
	    case 29: return (void*)(QObject*)(QNetworkReply*)xptr;
	    case 27: return (void*)(QNetworkReply*)(QNetworkReply*)xptr;
	  default: return xptr;
	}
      case 28:	//QNetworkRequest
	switch(to) {
	    case 28: return (void*)(QNetworkRequest*)(QNetworkRequest*)xptr;
	  default: return xptr;
	}
      case 29:	//QObject
	switch(to) {
	    case 29: return (void*)(QObject*)(QObject*)xptr;
	    case 1: return (void*)(QAction*)(QObject*)xptr;
	    case 22: return (void*)(QMenu*)(QObject*)xptr;
	    case 26: return (void*)(QNetworkAccessManager*)(QObject*)xptr;
	    case 27: return (void*)(QNetworkReply*)(QObject*)xptr;
	    case 47: return (void*)(QStyle*)(QObject*)xptr;
	    case 50: return (void*)(QUndoStack*)(QObject*)xptr;
	    case 54: return (void*)(QWebFrame*)(QObject*)xptr;
	    case 56: return (void*)(QWebHistoryInterface*)(QObject*)xptr;
	    case 59: return (void*)(QWebPage*)(QObject*)xptr;
	    case 60: return (void*)(QWebPluginFactory*)(QObject*)xptr;
	    case 63: return (void*)(QWebView*)(QObject*)xptr;
	    case 65: return (void*)(QWidget*)(QObject*)xptr;
	  default: return xptr;
	}
      case 30:	//QPaintDevice
	switch(to) {
	    case 30: return (void*)(QPaintDevice*)(QPaintDevice*)xptr;
	    case 17: return (void*)(QImage*)(QPaintDevice*)xptr;
	    case 22: return (void*)(QMenu*)(QPaintDevice*)xptr;
	    case 37: return (void*)(QPixmap*)(QPaintDevice*)xptr;
	    case 40: return (void*)(QPrinter*)(QPaintDevice*)xptr;
	    case 63: return (void*)(QWebView*)(QPaintDevice*)xptr;
	    case 65: return (void*)(QWidget*)(QPaintDevice*)xptr;
	  default: return xptr;
	}
      case 31:	//QPaintEngine
	switch(to) {
	    case 31: return (void*)(QPaintEngine*)(QPaintEngine*)xptr;
	  default: return xptr;
	}
      case 32:	//QPaintEngineState
	switch(to) {
	    case 32: return (void*)(QPaintEngineState*)(QPaintEngineState*)xptr;
	  default: return xptr;
	}
      case 33:	//QPaintEvent
	switch(to) {
	    case 12: return (void*)(QEvent*)(QPaintEvent*)xptr;
	    case 33: return (void*)(QPaintEvent*)(QPaintEvent*)xptr;
	  default: return xptr;
	}
      case 34:	//QPainter
	switch(to) {
	    case 34: return (void*)(QPainter*)(QPainter*)xptr;
	  default: return xptr;
	}
      case 35:	//QPainterPath
	switch(to) {
	    case 35: return (void*)(QPainterPath*)(QPainterPath*)xptr;
	  default: return xptr;
	}
      case 36:	//QPalette
	switch(to) {
	    case 36: return (void*)(QPalette*)(QPalette*)xptr;
	  default: return xptr;
	}
      case 37:	//QPixmap
	switch(to) {
	    case 30: return (void*)(QPaintDevice*)(QPixmap*)xptr;
	    case 37: return (void*)(QPixmap*)(QPixmap*)xptr;
	  default: return xptr;
	}
      case 38:	//QPoint
	switch(to) {
	    case 38: return (void*)(QPoint*)(QPoint*)xptr;
	  default: return xptr;
	}
      case 39:	//QPointF
	switch(to) {
	    case 39: return (void*)(QPointF*)(QPointF*)xptr;
	  default: return xptr;
	}
      case 40:	//QPrinter
	switch(to) {
	    case 30: return (void*)(QPaintDevice*)(QPrinter*)xptr;
	    case 40: return (void*)(QPrinter*)(QPrinter*)xptr;
	  default: return xptr;
	}
      case 41:	//QRect
	switch(to) {
	    case 41: return (void*)(QRect*)(QRect*)xptr;
	  default: return xptr;
	}
      case 42:	//QRectF
	switch(to) {
	    case 42: return (void*)(QRectF*)(QRectF*)xptr;
	  default: return xptr;
	}
      case 43:	//QRegion
	switch(to) {
	    case 43: return (void*)(QRegion*)(QRegion*)xptr;
	  default: return xptr;
	}
      case 44:	//QResizeEvent
	switch(to) {
	    case 12: return (void*)(QEvent*)(QResizeEvent*)xptr;
	    case 44: return (void*)(QResizeEvent*)(QResizeEvent*)xptr;
	  default: return xptr;
	}
      case 45:	//QShowEvent
	switch(to) {
	    case 12: return (void*)(QEvent*)(QShowEvent*)xptr;
	    case 45: return (void*)(QShowEvent*)(QShowEvent*)xptr;
	  default: return xptr;
	}
      case 46:	//QSize
	switch(to) {
	    case 46: return (void*)(QSize*)(QSize*)xptr;
	  default: return xptr;
	}
      case 47:	//QStyle
	switch(to) {
	    case 29: return (void*)(QObject*)(QStyle*)xptr;
	    case 47: return (void*)(QStyle*)(QStyle*)xptr;
	  default: return xptr;
	}
      case 48:	//QTabletEvent
	switch(to) {
	    case 12: return (void*)(QEvent*)(QTabletEvent*)xptr;
	    case 48: return (void*)(QTabletEvent*)(QTabletEvent*)xptr;
	  default: return xptr;
	}
      case 49:	//QTimerEvent
	switch(to) {
	    case 12: return (void*)(QEvent*)(QTimerEvent*)xptr;
	    case 49: return (void*)(QTimerEvent*)(QTimerEvent*)xptr;
	  default: return xptr;
	}
      case 50:	//QUndoStack
	switch(to) {
	    case 29: return (void*)(QObject*)(QUndoStack*)xptr;
	    case 50: return (void*)(QUndoStack*)(QUndoStack*)xptr;
	  default: return xptr;
	}
      case 51:	//QUrl
	switch(to) {
	    case 51: return (void*)(QUrl*)(QUrl*)xptr;
	  default: return xptr;
	}
      case 52:	//QVariant
	switch(to) {
	    case 52: return (void*)(QVariant*)(QVariant*)xptr;
	  default: return xptr;
	}
      case 53:	//QWebDatabase
	switch(to) {
	    case 53: return (void*)(QWebDatabase*)(QWebDatabase*)xptr;
	  default: return xptr;
	}
      case 54:	//QWebFrame
	switch(to) {
	    case 29: return (void*)(QObject*)(QWebFrame*)xptr;
	    case 54: return (void*)(QWebFrame*)(QWebFrame*)xptr;
	  default: return xptr;
	}
      case 55:	//QWebHistory
	switch(to) {
	    case 55: return (void*)(QWebHistory*)(QWebHistory*)xptr;
	  default: return xptr;
	}
      case 56:	//QWebHistoryInterface
	switch(to) {
	    case 29: return (void*)(QObject*)(QWebHistoryInterface*)xptr;
	    case 56: return (void*)(QWebHistoryInterface*)(QWebHistoryInterface*)xptr;
	  default: return xptr;
	}
      case 57:	//QWebHistoryItem
	switch(to) {
	    case 57: return (void*)(QWebHistoryItem*)(QWebHistoryItem*)xptr;
	  default: return xptr;
	}
      case 58:	//QWebHitTestResult
	switch(to) {
	    case 58: return (void*)(QWebHitTestResult*)(QWebHitTestResult*)xptr;
	  default: return xptr;
	}
      case 59:	//QWebPage
	switch(to) {
	    case 29: return (void*)(QObject*)(QWebPage*)xptr;
	    case 59: return (void*)(QWebPage*)(QWebPage*)xptr;
	  default: return xptr;
	}
      case 60:	//QWebPluginFactory
	switch(to) {
	    case 29: return (void*)(QObject*)(QWebPluginFactory*)xptr;
	    case 60: return (void*)(QWebPluginFactory*)(QWebPluginFactory*)xptr;
	  default: return xptr;
	}
      case 61:	//QWebSecurityOrigin
	switch(to) {
	    case 61: return (void*)(QWebSecurityOrigin*)(QWebSecurityOrigin*)xptr;
	  default: return xptr;
	}
      case 62:	//QWebSettings
	switch(to) {
	    case 62: return (void*)(QWebSettings*)(QWebSettings*)xptr;
	  default: return xptr;
	}
      case 63:	//QWebView
	switch(to) {
	    case 65: return (void*)(QWidget*)(QWebView*)xptr;
	    case 29: return (void*)(QObject*)(QWebView*)xptr;
	    case 30: return (void*)(QPaintDevice*)(QWebView*)xptr;
	    case 63: return (void*)(QWebView*)(QWebView*)xptr;
	  default: return xptr;
	}
      case 64:	//QWheelEvent
	switch(to) {
	    case 12: return (void*)(QEvent*)(QWheelEvent*)xptr;
	    case 64: return (void*)(QWheelEvent*)(QWheelEvent*)xptr;
	  default: return xptr;
	}
      case 65:	//QWidget
	switch(to) {
	    case 29: return (void*)(QObject*)(QWidget*)xptr;
	    case 30: return (void*)(QPaintDevice*)(QWidget*)xptr;
	    case 65: return (void*)(QWidget*)(QWidget*)xptr;
	    case 22: return (void*)(QMenu*)(QWidget*)xptr;
	    case 63: return (void*)(QWebView*)(QWidget*)xptr;
	  default: return xptr;
	}
      default: return xptr;
    }
}

// Group of Indexes (0 separated) used as super class lists.
// Classes with super classes have an index into this array.
static Smoke::Index qtwebkit_inheritanceList[] = {
	0,	// 0: (no super class)
	29, 0,	// 1: QObject
	65, 0,	// 3: QWidget
};

// These are the xenum functions for manipulating enum pointers
void xenum_QWebPluginFactory(Smoke::EnumOperation, Smoke::Index, void*&, long&);
void xenum_QWebPage(Smoke::EnumOperation, Smoke::Index, void*&, long&);
void xenum_QWebSettings(Smoke::EnumOperation, Smoke::Index, void*&, long&);

// Those are the xcall functions defined in each x_*.cpp file, for dispatching method calls
void xcall_QWebDatabase(Smoke::Index, void*, Smoke::Stack);
void xcall_QWebFrame(Smoke::Index, void*, Smoke::Stack);
void xcall_QWebHistory(Smoke::Index, void*, Smoke::Stack);
void xcall_QWebHistoryInterface(Smoke::Index, void*, Smoke::Stack);
void xcall_QWebHistoryItem(Smoke::Index, void*, Smoke::Stack);
void xcall_QWebHitTestResult(Smoke::Index, void*, Smoke::Stack);
void xcall_QWebPage(Smoke::Index, void*, Smoke::Stack);
void xcall_QWebPluginFactory(Smoke::Index, void*, Smoke::Stack);
void xcall_QWebSecurityOrigin(Smoke::Index, void*, Smoke::Stack);
void xcall_QWebSettings(Smoke::Index, void*, Smoke::Stack);
void xcall_QWebView(Smoke::Index, void*, Smoke::Stack);

// List of all classes
// Name, index into inheritanceList, method dispatcher, enum dispatcher, class flags
static Smoke::Class qtwebkit_classes[] = {
	{ 0L, false, 0, 0, 0, 0 }, 	// 0 (no class)
	{ "QAction", true, 0, 0, 0, 0 }, 	// 1
	{ "QActionEvent", true, 0, 0, 0, 0 }, 	// 2
	{ "QByteArray", true, 0, 0, 0, 0 }, 	// 3
	{ "QChildEvent", true, 0, 0, 0, 0 }, 	// 4
	{ "QCloseEvent", true, 0, 0, 0, 0 }, 	// 5
	{ "QContextMenuEvent", true, 0, 0, 0, 0 }, 	// 6
	{ "QDateTime", true, 0, 0, 0, 0 }, 	// 7
	{ "QDragEnterEvent", true, 0, 0, 0, 0 }, 	// 8
	{ "QDragLeaveEvent", true, 0, 0, 0, 0 }, 	// 9
	{ "QDragMoveEvent", true, 0, 0, 0, 0 }, 	// 10
	{ "QDropEvent", true, 0, 0, 0, 0 }, 	// 11
	{ "QEvent", true, 0, 0, 0, 0 }, 	// 12
	{ "QFocusEvent", true, 0, 0, 0, 0 }, 	// 13
	{ "QFont", true, 0, 0, 0, 0 }, 	// 14
	{ "QHideEvent", true, 0, 0, 0, 0 }, 	// 15
	{ "QIcon", true, 0, 0, 0, 0 }, 	// 16
	{ "QImage", true, 0, 0, 0, 0 }, 	// 17
	{ "QInputMethodEvent", true, 0, 0, 0, 0 }, 	// 18
	{ "QKeyEvent", true, 0, 0, 0, 0 }, 	// 19
	{ "QLine", true, 0, 0, 0, 0 }, 	// 20
	{ "QLineF", true, 0, 0, 0, 0 }, 	// 21
	{ "QMenu", true, 0, 0, 0, 0 }, 	// 22
	{ "QMetaObject", true, 0, 0, 0, 0 }, 	// 23
	{ "QMouseEvent", true, 0, 0, 0, 0 }, 	// 24
	{ "QMoveEvent", true, 0, 0, 0, 0 }, 	// 25
	{ "QNetworkAccessManager", true, 0, 0, 0, 0 }, 	// 26
	{ "QNetworkReply", true, 0, 0, 0, 0 }, 	// 27
	{ "QNetworkRequest", true, 0, 0, 0, 0 }, 	// 28
	{ "QObject", true, 0, 0, 0, 0 }, 	// 29
	{ "QPaintDevice", true, 0, 0, 0, 0 }, 	// 30
	{ "QPaintEngine", true, 0, 0, 0, 0 }, 	// 31
	{ "QPaintEngineState", true, 0, 0, 0, 0 }, 	// 32
	{ "QPaintEvent", true, 0, 0, 0, 0 }, 	// 33
	{ "QPainter", true, 0, 0, 0, 0 }, 	// 34
	{ "QPainterPath", true, 0, 0, 0, 0 }, 	// 35
	{ "QPalette", true, 0, 0, 0, 0 }, 	// 36
	{ "QPixmap", true, 0, 0, 0, 0 }, 	// 37
	{ "QPoint", true, 0, 0, 0, 0 }, 	// 38
	{ "QPointF", true, 0, 0, 0, 0 }, 	// 39
	{ "QPrinter", true, 0, 0, 0, 0 }, 	// 40
	{ "QRect", true, 0, 0, 0, 0 }, 	// 41
	{ "QRectF", true, 0, 0, 0, 0 }, 	// 42
	{ "QRegion", true, 0, 0, 0, 0 }, 	// 43
	{ "QResizeEvent", true, 0, 0, 0, 0 }, 	// 44
	{ "QShowEvent", true, 0, 0, 0, 0 }, 	// 45
	{ "QSize", true, 0, 0, 0, 0 }, 	// 46
	{ "QStyle", true, 0, 0, 0, 0 }, 	// 47
	{ "QTabletEvent", true, 0, 0, 0, 0 }, 	// 48
	{ "QTimerEvent", true, 0, 0, 0, 0 }, 	// 49
	{ "QUndoStack", true, 0, 0, 0, 0 }, 	// 50
	{ "QUrl", true, 0, 0, 0, 0 }, 	// 51
	{ "QVariant", true, 0, 0, 0, 0 }, 	// 52
	{ "QWebDatabase", false, 0, xcall_QWebDatabase, 0, Smoke::cf_constructor|Smoke::cf_deepcopy }, 	//53
	{ "QWebFrame", false, 1, xcall_QWebFrame, 0, Smoke::cf_virtual }, 	//54
	{ "QWebHistory", false, 0, xcall_QWebHistory, 0, 0 }, 	//55
	{ "QWebHistoryInterface", false, 1, xcall_QWebHistoryInterface, 0, Smoke::cf_constructor|Smoke::cf_virtual }, 	//56
	{ "QWebHistoryItem", false, 0, xcall_QWebHistoryItem, 0, Smoke::cf_constructor|Smoke::cf_deepcopy }, 	//57
	{ "QWebHitTestResult", false, 0, xcall_QWebHitTestResult, 0, Smoke::cf_constructor|Smoke::cf_deepcopy }, 	//58
	{ "QWebPage", false, 1, xcall_QWebPage, xenum_QWebPage, Smoke::cf_constructor|Smoke::cf_virtual }, 	//59
	{ "QWebPluginFactory", false, 1, xcall_QWebPluginFactory, xenum_QWebPluginFactory, Smoke::cf_constructor|Smoke::cf_virtual }, 	//60
	{ "QWebSecurityOrigin", false, 0, xcall_QWebSecurityOrigin, 0, Smoke::cf_constructor|Smoke::cf_deepcopy }, 	//61
	{ "QWebSettings", false, 0, xcall_QWebSettings, xenum_QWebSettings, 0 }, 	//62
	{ "QWebView", false, 3, xcall_QWebView, 0, Smoke::cf_constructor|Smoke::cf_virtual }, 	//63
	{ "QWheelEvent", true, 0, 0, 0, 0 }, 	// 64
	{ "QWidget", true, 0, 0, 0, 0 }, 	// 65
	{ "Qt", true, 0, 0, 0, 0 }, 	// 66
};

// List of all types needed by the methods (arguments and return values)
// Name, class ID if arg is a class, and TypeId
static Smoke::Type qtwebkit_types[] = {
	{ 0, 0, 0 },	//0 (no type)
	{ "QAbstractFileEngine::FileFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//1
	{ "QAbstractFileEngine::FileFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//2
	{ "QAbstractItemView::EditTriggers", 0, Smoke::t_uint | Smoke::tf_stack },	//3
	{ "QAbstractItemView::EditTriggers&", 0, Smoke::t_voidp | Smoke::tf_ref },	//4
	{ "QAbstractPrintDialog::PrintDialogOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//5
	{ "QAbstractPrintDialog::PrintDialogOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//6
	{ "QAbstractSpinBox::StepEnabled", 0, Smoke::t_uint | Smoke::tf_stack },	//7
	{ "QAbstractSpinBox::StepEnabled&", 0, Smoke::t_voidp | Smoke::tf_ref },	//8
	{ "QAccessible::Relation", 0, Smoke::t_uint | Smoke::tf_stack },	//9
	{ "QAccessible::Relation&", 0, Smoke::t_voidp | Smoke::tf_ref },	//10
	{ "QAccessible::State", 0, Smoke::t_uint | Smoke::tf_stack },	//11
	{ "QAccessible::State&", 0, Smoke::t_voidp | Smoke::tf_ref },	//12
	{ "QAction*", 1, Smoke::t_class | Smoke::tf_ptr },	//13
	{ "QActionEvent*", 2, Smoke::t_class | Smoke::tf_ptr },	//14
	{ "QChildEvent*", 4, Smoke::t_class | Smoke::tf_ptr },	//15
	{ "QCloseEvent*", 5, Smoke::t_class | Smoke::tf_ptr },	//16
	{ "QColorDialog::ColorDialogOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//17
	{ "QColorDialog::ColorDialogOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//18
	{ "QContextMenuEvent*", 6, Smoke::t_class | Smoke::tf_ptr },	//19
	{ "QDBusConnection::RegisterOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//20
	{ "QDBusConnection::RegisterOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//21
	{ "QDateTime", 7, Smoke::t_class | Smoke::tf_stack },	//22
	{ "QDateTimeEdit::Sections", 0, Smoke::t_uint | Smoke::tf_stack },	//23
	{ "QDateTimeEdit::Sections&", 0, Smoke::t_voidp | Smoke::tf_ref },	//24
	{ "QDialogButtonBox::StandardButtons", 0, Smoke::t_uint | Smoke::tf_stack },	//25
	{ "QDialogButtonBox::StandardButtons&", 0, Smoke::t_voidp | Smoke::tf_ref },	//26
	{ "QDir::Filters", 0, Smoke::t_uint | Smoke::tf_stack },	//27
	{ "QDir::Filters&", 0, Smoke::t_voidp | Smoke::tf_ref },	//28
	{ "QDir::SortFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//29
	{ "QDir::SortFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//30
	{ "QDirIterator::IteratorFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//31
	{ "QDirIterator::IteratorFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//32
	{ "QDockWidget::DockWidgetFeatures", 0, Smoke::t_uint | Smoke::tf_stack },	//33
	{ "QDockWidget::DockWidgetFeatures&", 0, Smoke::t_voidp | Smoke::tf_ref },	//34
	{ "QDragEnterEvent*", 8, Smoke::t_class | Smoke::tf_ptr },	//35
	{ "QDragLeaveEvent*", 9, Smoke::t_class | Smoke::tf_ptr },	//36
	{ "QDragMoveEvent*", 10, Smoke::t_class | Smoke::tf_ptr },	//37
	{ "QDropEvent*", 11, Smoke::t_class | Smoke::tf_ptr },	//38
	{ "QEvent*", 12, Smoke::t_class | Smoke::tf_ptr },	//39
	{ "QEventLoop::ProcessEventsFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//40
	{ "QEventLoop::ProcessEventsFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//41
	{ "QFile::Permissions", 0, Smoke::t_uint | Smoke::tf_stack },	//42
	{ "QFile::Permissions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//43
	{ "QFileDialog::Options", 0, Smoke::t_uint | Smoke::tf_stack },	//44
	{ "QFileDialog::Options&", 0, Smoke::t_voidp | Smoke::tf_ref },	//45
	{ "QFocusEvent*", 13, Smoke::t_class | Smoke::tf_ptr },	//46
	{ "QFontComboBox::FontFilters", 0, Smoke::t_uint | Smoke::tf_stack },	//47
	{ "QFontComboBox::FontFilters&", 0, Smoke::t_voidp | Smoke::tf_ref },	//48
	{ "QFontDialog::FontDialogOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//49
	{ "QFontDialog::FontDialogOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//50
	{ "QGL::FormatOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//51
	{ "QGL::FormatOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//52
	{ "QGLFormat::OpenGLVersionFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//53
	{ "QGLFormat::OpenGLVersionFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//54
	{ "QGraphicsItem::GraphicsItemFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//55
	{ "QGraphicsItem::GraphicsItemFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//56
	{ "QGraphicsScene::SceneLayers", 0, Smoke::t_uint | Smoke::tf_stack },	//57
	{ "QGraphicsScene::SceneLayers&", 0, Smoke::t_voidp | Smoke::tf_ref },	//58
	{ "QGraphicsView::CacheMode", 0, Smoke::t_uint | Smoke::tf_stack },	//59
	{ "QGraphicsView::CacheMode&", 0, Smoke::t_voidp | Smoke::tf_ref },	//60
	{ "QGraphicsView::OptimizationFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//61
	{ "QGraphicsView::OptimizationFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//62
	{ "QHideEvent*", 15, Smoke::t_class | Smoke::tf_ptr },	//63
	{ "QIODevice::OpenMode", 0, Smoke::t_uint | Smoke::tf_stack },	//64
	{ "QIODevice::OpenMode&", 0, Smoke::t_voidp | Smoke::tf_ref },	//65
	{ "QIcon", 16, Smoke::t_class | Smoke::tf_stack },	//66
	{ "QInputDialog::InputDialogOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//67
	{ "QInputDialog::InputDialogOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//68
	{ "QInputMethodEvent*", 18, Smoke::t_class | Smoke::tf_ptr },	//69
	{ "QItemSelectionModel::SelectionFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//70
	{ "QItemSelectionModel::SelectionFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//71
	{ "QKeyEvent*", 19, Smoke::t_class | Smoke::tf_ptr },	//72
	{ "QLibrary::LoadHints", 0, Smoke::t_uint | Smoke::tf_stack },	//73
	{ "QLibrary::LoadHints&", 0, Smoke::t_voidp | Smoke::tf_ref },	//74
	{ "QList<QWebDatabase>", 0, Smoke::t_voidp | Smoke::tf_stack },	//75
	{ "QList<QWebFrame*>", 0, Smoke::t_voidp | Smoke::tf_stack },	//76
	{ "QList<QWebHistoryItem>", 0, Smoke::t_voidp | Smoke::tf_stack },	//77
	{ "QList<QWebPluginFactory::Plugin>", 0, Smoke::t_voidp | Smoke::tf_stack },	//78
	{ "QList<QWebSecurityOrigin>", 0, Smoke::t_voidp | Smoke::tf_stack },	//79
	{ "QLocale::NumberOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//80
	{ "QLocale::NumberOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//81
	{ "QMainWindow::DockOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//82
	{ "QMainWindow::DockOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//83
	{ "QMdiArea::AreaOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//84
	{ "QMdiArea::AreaOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//85
	{ "QMdiSubWindow::SubWindowOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//86
	{ "QMdiSubWindow::SubWindowOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//87
	{ "QMenu*", 22, Smoke::t_class | Smoke::tf_ptr },	//88
	{ "QMessageBox::StandardButtons", 0, Smoke::t_uint | Smoke::tf_stack },	//89
	{ "QMessageBox::StandardButtons&", 0, Smoke::t_voidp | Smoke::tf_ref },	//90
	{ "QMetaObject::Call", 23, Smoke::t_enum | Smoke::tf_stack },	//91
	{ "QMouseEvent*", 24, Smoke::t_class | Smoke::tf_ptr },	//92
	{ "QMoveEvent*", 25, Smoke::t_class | Smoke::tf_ptr },	//93
	{ "QMultiMap<QString,QString>", 0, Smoke::t_voidp | Smoke::tf_stack },	//94
	{ "QNetworkAccessManager*", 26, Smoke::t_class | Smoke::tf_ptr },	//95
	{ "QNetworkAccessManager::Operation", 26, Smoke::t_enum | Smoke::tf_stack },	//96
	{ "QNetworkInterface::InterfaceFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//97
	{ "QNetworkInterface::InterfaceFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//98
	{ "QNetworkProxy::Capabilities", 0, Smoke::t_uint | Smoke::tf_stack },	//99
	{ "QNetworkProxy::Capabilities&", 0, Smoke::t_voidp | Smoke::tf_ref },	//100
	{ "QNetworkReply*", 27, Smoke::t_class | Smoke::tf_ptr },	//101
	{ "QNetworkRequest&", 28, Smoke::t_class | Smoke::tf_ref },	//102
	{ "QObject*", 29, Smoke::t_class | Smoke::tf_ptr },	//103
	{ "QPageSetupDialog::PageSetupDialogOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//104
	{ "QPageSetupDialog::PageSetupDialogOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//105
	{ "QPaintDevice*", 30, Smoke::t_class | Smoke::tf_ptr },	//106
	{ "QPaintDevice::PaintDeviceMetric", 30, Smoke::t_enum | Smoke::tf_stack },	//107
	{ "QPaintEngine*", 31, Smoke::t_class | Smoke::tf_ptr },	//108
	{ "QPaintEngine::DirtyFlag", 31, Smoke::t_enum | Smoke::tf_stack },	//109
	{ "QPaintEngine::DirtyFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//110
	{ "QPaintEngine::DirtyFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//111
	{ "QPaintEngine::PaintEngineFeature", 31, Smoke::t_enum | Smoke::tf_stack },	//112
	{ "QPaintEngine::PaintEngineFeatures", 0, Smoke::t_uint | Smoke::tf_stack },	//113
	{ "QPaintEngine::PaintEngineFeatures&", 0, Smoke::t_voidp | Smoke::tf_ref },	//114
	{ "QPaintEngine::PolygonDrawMode", 31, Smoke::t_enum | Smoke::tf_stack },	//115
	{ "QPaintEngine::Type", 31, Smoke::t_enum | Smoke::tf_stack },	//116
	{ "QPaintEvent*", 33, Smoke::t_class | Smoke::tf_ptr },	//117
	{ "QPainter*", 34, Smoke::t_class | Smoke::tf_ptr },	//118
	{ "QPainter::RenderHints", 0, Smoke::t_uint | Smoke::tf_stack },	//119
	{ "QPainter::RenderHints&", 0, Smoke::t_voidp | Smoke::tf_ref },	//120
	{ "QPainterPath::ElementType", 35, Smoke::t_enum | Smoke::tf_stack },	//121
	{ "QPalette", 36, Smoke::t_class | Smoke::tf_stack },	//122
	{ "QPixmap", 37, Smoke::t_class | Smoke::tf_stack },	//123
	{ "QPixmap::Type", 37, Smoke::t_enum | Smoke::tf_stack },	//124
	{ "QPoint", 38, Smoke::t_class | Smoke::tf_stack },	//125
	{ "QPrinter*", 40, Smoke::t_class | Smoke::tf_ptr },	//126
	{ "QRect", 41, Smoke::t_class | Smoke::tf_stack },	//127
	{ "QRect&", 41, Smoke::t_class | Smoke::tf_ref },	//128
	{ "QResizeEvent*", 44, Smoke::t_class | Smoke::tf_ptr },	//129
	{ "QScriptEngine::ValueOwnership", 0, Smoke::t_voidp | Smoke::tf_stack },	//130
	{ "QShowEvent*", 45, Smoke::t_class | Smoke::tf_ptr },	//131
	{ "QSize", 46, Smoke::t_class | Smoke::tf_stack },	//132
	{ "QSizePolicy::ControlTypes", 0, Smoke::t_uint | Smoke::tf_stack },	//133
	{ "QSizePolicy::ControlTypes&", 0, Smoke::t_voidp | Smoke::tf_ref },	//134
	{ "QSql::ParamType", 0, Smoke::t_uint | Smoke::tf_stack },	//135
	{ "QSql::ParamType&", 0, Smoke::t_voidp | Smoke::tf_ref },	//136
	{ "QString", 0, Smoke::t_voidp | Smoke::tf_stack },	//137
	{ "QString&", 0, Smoke::t_voidp | Smoke::tf_ref },	//138
	{ "QString*", 0, Smoke::t_voidp | Smoke::tf_ptr },	//139
	{ "QString::SectionFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//140
	{ "QString::SectionFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//141
	{ "QStyle&", 47, Smoke::t_class | Smoke::tf_ref },	//142
	{ "QStyle::State", 0, Smoke::t_uint | Smoke::tf_stack },	//143
	{ "QStyle::State&", 0, Smoke::t_voidp | Smoke::tf_ref },	//144
	{ "QStyle::SubControls", 0, Smoke::t_uint | Smoke::tf_stack },	//145
	{ "QStyle::SubControls&", 0, Smoke::t_voidp | Smoke::tf_ref },	//146
	{ "QStyleOptionButton::ButtonFeatures", 0, Smoke::t_uint | Smoke::tf_stack },	//147
	{ "QStyleOptionButton::ButtonFeatures&", 0, Smoke::t_voidp | Smoke::tf_ref },	//148
	{ "QStyleOptionFrameV2::FrameFeatures", 0, Smoke::t_uint | Smoke::tf_stack },	//149
	{ "QStyleOptionFrameV2::FrameFeatures&", 0, Smoke::t_voidp | Smoke::tf_ref },	//150
	{ "QStyleOptionQ3ListViewItem::Q3ListViewItemFeatures", 0, Smoke::t_uint | Smoke::tf_stack },	//151
	{ "QStyleOptionQ3ListViewItem::Q3ListViewItemFeatures&", 0, Smoke::t_voidp | Smoke::tf_ref },	//152
	{ "QStyleOptionTab::CornerWidgets", 0, Smoke::t_uint | Smoke::tf_stack },	//153
	{ "QStyleOptionTab::CornerWidgets&", 0, Smoke::t_voidp | Smoke::tf_ref },	//154
	{ "QStyleOptionToolBar::ToolBarFeatures", 0, Smoke::t_uint | Smoke::tf_stack },	//155
	{ "QStyleOptionToolBar::ToolBarFeatures&", 0, Smoke::t_voidp | Smoke::tf_ref },	//156
	{ "QStyleOptionToolButton::ToolButtonFeatures", 0, Smoke::t_uint | Smoke::tf_stack },	//157
	{ "QStyleOptionToolButton::ToolButtonFeatures&", 0, Smoke::t_voidp | Smoke::tf_ref },	//158
	{ "QStyleOptionViewItemV2::ViewItemFeatures", 0, Smoke::t_uint | Smoke::tf_stack },	//159
	{ "QStyleOptionViewItemV2::ViewItemFeatures&", 0, Smoke::t_voidp | Smoke::tf_ref },	//160
	{ "QTabletEvent*", 48, Smoke::t_class | Smoke::tf_ptr },	//161
	{ "QTextBoundaryFinder::BoundaryReasons", 0, Smoke::t_uint | Smoke::tf_stack },	//162
	{ "QTextBoundaryFinder::BoundaryReasons&", 0, Smoke::t_voidp | Smoke::tf_ref },	//163
	{ "QTextCodec::ConversionFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//164
	{ "QTextCodec::ConversionFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//165
	{ "QTextDocument::FindFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//166
	{ "QTextDocument::FindFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//167
	{ "QTextEdit::AutoFormatting", 0, Smoke::t_uint | Smoke::tf_stack },	//168
	{ "QTextEdit::AutoFormatting&", 0, Smoke::t_voidp | Smoke::tf_ref },	//169
	{ "QTextFormat::PageBreakFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//170
	{ "QTextFormat::PageBreakFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//171
	{ "QTextItem::RenderFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//172
	{ "QTextItem::RenderFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//173
	{ "QTextOption::Flags", 0, Smoke::t_uint | Smoke::tf_stack },	//174
	{ "QTextOption::Flags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//175
	{ "QTextStream::NumberFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//176
	{ "QTextStream::NumberFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//177
	{ "QTimerEvent*", 49, Smoke::t_class | Smoke::tf_ptr },	//178
	{ "QTreeWidgetItemIterator::IteratorFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//179
	{ "QTreeWidgetItemIterator::IteratorFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//180
	{ "QUdpSocket::BindMode", 0, Smoke::t_uint | Smoke::tf_stack },	//181
	{ "QUdpSocket::BindMode&", 0, Smoke::t_voidp | Smoke::tf_ref },	//182
	{ "QUndoStack*", 50, Smoke::t_class | Smoke::tf_ptr },	//183
	{ "QUrl", 51, Smoke::t_class | Smoke::tf_stack },	//184
	{ "QUrl&", 51, Smoke::t_class | Smoke::tf_ref },	//185
	{ "QUrl::FormattingOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//186
	{ "QUrl::FormattingOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//187
	{ "QVariant", 52, Smoke::t_class | Smoke::tf_stack },	//188
	{ "QWebDatabase&", 53, Smoke::t_class | Smoke::tf_ref },	//189
	{ "QWebDatabase*", 53, Smoke::t_class | Smoke::tf_ptr },	//190
	{ "QWebFrame*", 54, Smoke::t_class | Smoke::tf_ptr },	//191
	{ "QWebHistory*", 55, Smoke::t_class | Smoke::tf_ptr },	//192
	{ "QWebHistoryInterface*", 56, Smoke::t_class | Smoke::tf_ptr },	//193
	{ "QWebHistoryItem", 57, Smoke::t_class | Smoke::tf_stack },	//194
	{ "QWebHistoryItem&", 57, Smoke::t_class | Smoke::tf_ref },	//195
	{ "QWebHistoryItem*", 57, Smoke::t_class | Smoke::tf_ptr },	//196
	{ "QWebHitTestResult", 58, Smoke::t_class | Smoke::tf_stack },	//197
	{ "QWebHitTestResult&", 58, Smoke::t_class | Smoke::tf_ref },	//198
	{ "QWebHitTestResult*", 58, Smoke::t_class | Smoke::tf_ptr },	//199
	{ "QWebPage*", 59, Smoke::t_class | Smoke::tf_ptr },	//200
	{ "QWebPage::Extension", 59, Smoke::t_enum | Smoke::tf_stack },	//201
	{ "QWebPage::ExtensionReturn*", 0, Smoke::t_voidp | Smoke::tf_ptr },	//202
	{ "QWebPage::FindFlag", 59, Smoke::t_enum | Smoke::tf_stack },	//203
	{ "QWebPage::FindFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//204
	{ "QWebPage::FindFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//205
	{ "QWebPage::LinkDelegationPolicy", 59, Smoke::t_enum | Smoke::tf_stack },	//206
	{ "QWebPage::NavigationType", 59, Smoke::t_enum | Smoke::tf_stack },	//207
	{ "QWebPage::WebAction", 59, Smoke::t_enum | Smoke::tf_stack },	//208
	{ "QWebPage::WebWindowType", 59, Smoke::t_enum | Smoke::tf_stack },	//209
	{ "QWebPluginFactory*", 60, Smoke::t_class | Smoke::tf_ptr },	//210
	{ "QWebPluginFactory::Extension", 60, Smoke::t_enum | Smoke::tf_stack },	//211
	{ "QWebPluginFactory::ExtensionReturn*", 0, Smoke::t_voidp | Smoke::tf_ptr },	//212
	{ "QWebSecurityOrigin", 61, Smoke::t_class | Smoke::tf_stack },	//213
	{ "QWebSecurityOrigin&", 61, Smoke::t_class | Smoke::tf_ref },	//214
	{ "QWebSecurityOrigin*", 61, Smoke::t_class | Smoke::tf_ptr },	//215
	{ "QWebSettings*", 62, Smoke::t_class | Smoke::tf_ptr },	//216
	{ "QWebSettings::FontFamily", 62, Smoke::t_enum | Smoke::tf_stack },	//217
	{ "QWebSettings::FontSize", 62, Smoke::t_enum | Smoke::tf_stack },	//218
	{ "QWebSettings::WebAttribute", 62, Smoke::t_enum | Smoke::tf_stack },	//219
	{ "QWebSettings::WebGraphic", 62, Smoke::t_enum | Smoke::tf_stack },	//220
	{ "QWebView*", 63, Smoke::t_class | Smoke::tf_ptr },	//221
	{ "QWheelEvent*", 64, Smoke::t_class | Smoke::tf_ptr },	//222
	{ "QWidget*", 65, Smoke::t_class | Smoke::tf_ptr },	//223
	{ "QWidget::RenderFlag", 65, Smoke::t_enum | Smoke::tf_stack },	//224
	{ "QWidget::RenderFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//225
	{ "QWidget::RenderFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//226
	{ "QWizard::WizardOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//227
	{ "QWizard::WizardOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//228
	{ "Qt::Alignment", 0, Smoke::t_uint | Smoke::tf_stack },	//229
	{ "Qt::Alignment&", 0, Smoke::t_voidp | Smoke::tf_ref },	//230
	{ "Qt::AlignmentFlag", 66, Smoke::t_enum | Smoke::tf_stack },	//231
	{ "Qt::AnchorAttribute", 66, Smoke::t_enum | Smoke::tf_stack },	//232
	{ "Qt::ApplicationAttribute", 66, Smoke::t_enum | Smoke::tf_stack },	//233
	{ "Qt::ArrowType", 66, Smoke::t_enum | Smoke::tf_stack },	//234
	{ "Qt::AspectRatioMode", 66, Smoke::t_enum | Smoke::tf_stack },	//235
	{ "Qt::Axis", 66, Smoke::t_enum | Smoke::tf_stack },	//236
	{ "Qt::BGMode", 66, Smoke::t_enum | Smoke::tf_stack },	//237
	{ "Qt::BrushStyle", 66, Smoke::t_enum | Smoke::tf_stack },	//238
	{ "Qt::CaseSensitivity", 66, Smoke::t_enum | Smoke::tf_stack },	//239
	{ "Qt::CheckState", 66, Smoke::t_enum | Smoke::tf_stack },	//240
	{ "Qt::ClipOperation", 66, Smoke::t_enum | Smoke::tf_stack },	//241
	{ "Qt::ConnectionType", 66, Smoke::t_enum | Smoke::tf_stack },	//242
	{ "Qt::ContextMenuPolicy", 66, Smoke::t_enum | Smoke::tf_stack },	//243
	{ "Qt::Corner", 66, Smoke::t_enum | Smoke::tf_stack },	//244
	{ "Qt::CursorShape", 66, Smoke::t_enum | Smoke::tf_stack },	//245
	{ "Qt::DateFormat", 66, Smoke::t_enum | Smoke::tf_stack },	//246
	{ "Qt::DayOfWeek", 66, Smoke::t_enum | Smoke::tf_stack },	//247
	{ "Qt::DockWidgetArea", 66, Smoke::t_enum | Smoke::tf_stack },	//248
	{ "Qt::DockWidgetAreaSizes", 66, Smoke::t_enum | Smoke::tf_stack },	//249
	{ "Qt::DockWidgetAreas", 0, Smoke::t_uint | Smoke::tf_stack },	//250
	{ "Qt::DockWidgetAreas&", 0, Smoke::t_voidp | Smoke::tf_ref },	//251
	{ "Qt::DropAction", 66, Smoke::t_enum | Smoke::tf_stack },	//252
	{ "Qt::DropActions", 0, Smoke::t_uint | Smoke::tf_stack },	//253
	{ "Qt::DropActions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//254
	{ "Qt::EventPriority", 66, Smoke::t_enum | Smoke::tf_stack },	//255
	{ "Qt::FillRule", 66, Smoke::t_enum | Smoke::tf_stack },	//256
	{ "Qt::FocusPolicy", 66, Smoke::t_enum | Smoke::tf_stack },	//257
	{ "Qt::FocusReason", 66, Smoke::t_enum | Smoke::tf_stack },	//258
	{ "Qt::GlobalColor", 66, Smoke::t_enum | Smoke::tf_stack },	//259
	{ "Qt::HitTestAccuracy", 66, Smoke::t_enum | Smoke::tf_stack },	//260
	{ "Qt::ImageConversionFlag", 66, Smoke::t_enum | Smoke::tf_stack },	//261
	{ "Qt::ImageConversionFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//262
	{ "Qt::ImageConversionFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//263
	{ "Qt::InputMethodQuery", 66, Smoke::t_enum | Smoke::tf_stack },	//264
	{ "Qt::ItemDataRole", 66, Smoke::t_enum | Smoke::tf_stack },	//265
	{ "Qt::ItemFlag", 66, Smoke::t_enum | Smoke::tf_stack },	//266
	{ "Qt::ItemFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//267
	{ "Qt::ItemFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//268
	{ "Qt::ItemSelectionMode", 66, Smoke::t_enum | Smoke::tf_stack },	//269
	{ "Qt::Key", 66, Smoke::t_enum | Smoke::tf_stack },	//270
	{ "Qt::KeyboardModifier", 66, Smoke::t_enum | Smoke::tf_stack },	//271
	{ "Qt::KeyboardModifiers", 0, Smoke::t_uint | Smoke::tf_stack },	//272
	{ "Qt::KeyboardModifiers&", 0, Smoke::t_voidp | Smoke::tf_ref },	//273
	{ "Qt::LayoutDirection", 66, Smoke::t_enum | Smoke::tf_stack },	//274
	{ "Qt::MaskMode", 66, Smoke::t_enum | Smoke::tf_stack },	//275
	{ "Qt::MatchFlag", 66, Smoke::t_enum | Smoke::tf_stack },	//276
	{ "Qt::MatchFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//277
	{ "Qt::MatchFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//278
	{ "Qt::Modifier", 66, Smoke::t_enum | Smoke::tf_stack },	//279
	{ "Qt::MouseButton", 66, Smoke::t_enum | Smoke::tf_stack },	//280
	{ "Qt::MouseButtons", 0, Smoke::t_uint | Smoke::tf_stack },	//281
	{ "Qt::MouseButtons&", 0, Smoke::t_voidp | Smoke::tf_ref },	//282
	{ "Qt::Orientation", 66, Smoke::t_enum | Smoke::tf_stack },	//283
	{ "Qt::Orientations", 0, Smoke::t_uint | Smoke::tf_stack },	//284
	{ "Qt::Orientations&", 0, Smoke::t_voidp | Smoke::tf_ref },	//285
	{ "Qt::PenCapStyle", 66, Smoke::t_enum | Smoke::tf_stack },	//286
	{ "Qt::PenJoinStyle", 66, Smoke::t_enum | Smoke::tf_stack },	//287
	{ "Qt::PenStyle", 66, Smoke::t_enum | Smoke::tf_stack },	//288
	{ "Qt::ScrollBarPolicy", 66, Smoke::t_enum | Smoke::tf_stack },	//289
	{ "Qt::ShortcutContext", 66, Smoke::t_enum | Smoke::tf_stack },	//290
	{ "Qt::SizeHint", 66, Smoke::t_enum | Smoke::tf_stack },	//291
	{ "Qt::SizeMode", 66, Smoke::t_enum | Smoke::tf_stack },	//292
	{ "Qt::SortOrder", 66, Smoke::t_enum | Smoke::tf_stack },	//293
	{ "Qt::TextElideMode", 66, Smoke::t_enum | Smoke::tf_stack },	//294
	{ "Qt::TextFlag", 66, Smoke::t_enum | Smoke::tf_stack },	//295
	{ "Qt::TextFormat", 66, Smoke::t_enum | Smoke::tf_stack },	//296
	{ "Qt::TextInteractionFlag", 66, Smoke::t_enum | Smoke::tf_stack },	//297
	{ "Qt::TextInteractionFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//298
	{ "Qt::TextInteractionFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//299
	{ "Qt::TimeSpec", 66, Smoke::t_enum | Smoke::tf_stack },	//300
	{ "Qt::ToolBarArea", 66, Smoke::t_enum | Smoke::tf_stack },	//301
	{ "Qt::ToolBarAreaSizes", 66, Smoke::t_enum | Smoke::tf_stack },	//302
	{ "Qt::ToolBarAreas", 0, Smoke::t_uint | Smoke::tf_stack },	//303
	{ "Qt::ToolBarAreas&", 0, Smoke::t_voidp | Smoke::tf_ref },	//304
	{ "Qt::ToolButtonStyle", 66, Smoke::t_enum | Smoke::tf_stack },	//305
	{ "Qt::TransformationMode", 66, Smoke::t_enum | Smoke::tf_stack },	//306
	{ "Qt::UIEffect", 66, Smoke::t_enum | Smoke::tf_stack },	//307
	{ "Qt::WhiteSpaceMode", 66, Smoke::t_enum | Smoke::tf_stack },	//308
	{ "Qt::WidgetAttribute", 66, Smoke::t_enum | Smoke::tf_stack },	//309
	{ "Qt::WindowFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//310
	{ "Qt::WindowFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//311
	{ "Qt::WindowFrameSection", 66, Smoke::t_enum | Smoke::tf_stack },	//312
	{ "Qt::WindowModality", 66, Smoke::t_enum | Smoke::tf_stack },	//313
	{ "Qt::WindowState", 66, Smoke::t_enum | Smoke::tf_stack },	//314
	{ "Qt::WindowStates", 0, Smoke::t_uint | Smoke::tf_stack },	//315
	{ "Qt::WindowStates&", 0, Smoke::t_voidp | Smoke::tf_ref },	//316
	{ "Qt::WindowType", 66, Smoke::t_enum | Smoke::tf_stack },	//317
	{ "bool", 0, Smoke::t_bool | Smoke::tf_stack },	//318
	{ "const QByteArray&", 3, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//319
	{ "const QFont&", 14, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//320
	{ "const QImage&", 17, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//321
	{ "const QLine*", 20, Smoke::t_class | Smoke::tf_ptr | Smoke::tf_const },	//322
	{ "const QLineF*", 21, Smoke::t_class | Smoke::tf_ptr | Smoke::tf_const },	//323
	{ "const QMetaObject", 23, Smoke::t_class | Smoke::tf_stack | Smoke::tf_const },	//324
	{ "const QMetaObject*", 23, Smoke::t_class | Smoke::tf_ptr | Smoke::tf_const },	//325
	{ "const QNetworkRequest&", 28, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//326
	{ "const QPaintEngineState&", 32, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//327
	{ "const QPainterPath&", 35, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//328
	{ "const QPalette&", 36, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//329
	{ "const QPixmap&", 37, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//330
	{ "const QPoint&", 38, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//331
	{ "const QPoint*", 38, Smoke::t_class | Smoke::tf_ptr | Smoke::tf_const },	//332
	{ "const QPointF&", 39, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//333
	{ "const QPointF*", 39, Smoke::t_class | Smoke::tf_ptr | Smoke::tf_const },	//334
	{ "const QRect&", 41, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//335
	{ "const QRect*", 41, Smoke::t_class | Smoke::tf_ptr | Smoke::tf_const },	//336
	{ "const QRectF&", 42, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//337
	{ "const QRectF*", 42, Smoke::t_class | Smoke::tf_ptr | Smoke::tf_const },	//338
	{ "const QRegion&", 43, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//339
	{ "const QSize&", 46, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//340
	{ "const QString&", 0, Smoke::t_voidp | Smoke::tf_ref | Smoke::tf_const },	//341
	{ "const QStringList&", 0, Smoke::t_voidp | Smoke::tf_ref | Smoke::tf_const },	//342
	{ "const QUrl&", 51, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//343
	{ "const QVariant&", 52, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//344
	{ "const QWebDatabase&", 53, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//345
	{ "const QWebHistoryItem&", 57, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//346
	{ "const QWebHitTestResult&", 58, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//347
	{ "const QWebPage::ExtensionOption*", 0, Smoke::t_voidp | Smoke::tf_ptr | Smoke::tf_const },	//348
	{ "const QWebPluginFactory::ExtensionOption*", 0, Smoke::t_voidp | Smoke::tf_ptr | Smoke::tf_const },	//349
	{ "const QWebSecurityOrigin&", 61, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//350
	{ "const char*", 0, Smoke::t_voidp | Smoke::tf_ptr | Smoke::tf_const },	//351
	{ "int", 0, Smoke::t_int | Smoke::tf_stack },	//352
	{ "qint64", 0, Smoke::t_long | Smoke::tf_stack },	//353
	{ "qreal", 0, Smoke::t_double | Smoke::tf_stack },	//354
	{ "quint64", 0, Smoke::t_voidp | Smoke::tf_stack },	//355
	{ "void**", 0, Smoke::t_voidp | Smoke::tf_ptr },	//356
};

static Smoke::Index qtwebkit_argumentList[] = {
	0,	//0  (void)
	101, 0,	//1  QNetworkReply*  
	103, 0,	//3  QObject*  
	103, 39, 0,	//5  QObject*, QEvent*  
	107, 0,	//8  QPaintDevice::PaintDeviceMetric  
	117, 0,	//10  QPaintEvent*  
	118, 0,	//12  QPainter*  
	118, 339, 0,	//14  QPainter*, const QRegion&  
	126, 0,	//17  QPrinter*  
	129, 0,	//19  QResizeEvent*  
	131, 0,	//21  QShowEvent*  
	14, 0,	//23  QActionEvent*  
	142, 0,	//25  QStyle&  
	15, 0,	//27  QChildEvent*  
	16, 0,	//29  QCloseEvent*  
	161, 0,	//31  QTabletEvent*  
	178, 0,	//33  QTimerEvent*  
	19, 0,	//35  QContextMenuEvent*  
	191, 0,	//37  QWebFrame*  
	191, 137, 0,	//39  QWebFrame*, QString  
	191, 196, 0,	//42  QWebFrame*, QWebHistoryItem*  
	191, 326, 207, 0,	//45  QWebFrame*, const QNetworkRequest&, QWebPage::NavigationType  
	191, 341, 0,	//49  QWebFrame*, const QString&  
	191, 341, 341, 139, 0,	//52  QWebFrame*, const QString&, const QString&, QString*  
	193, 0,	//57  QWebHistoryInterface*  
	200, 0,	//59  QWebPage*  
	201, 0,	//61  QWebPage::Extension  
	201, 348, 0,	//63  QWebPage::Extension, const QWebPage::ExtensionOption*  
	201, 348, 202, 0,	//66  QWebPage::Extension, const QWebPage::ExtensionOption*, QWebPage::ExtensionReturn*  
	206, 0,	//70  QWebPage::LinkDelegationPolicy  
	208, 0,	//72  QWebPage::WebAction  
	208, 318, 0,	//74  QWebPage::WebAction, bool  
	209, 0,	//77  QWebPage::WebWindowType  
	210, 0,	//79  QWebPluginFactory*  
	211, 0,	//81  QWebPluginFactory::Extension  
	211, 349, 0,	//83  QWebPluginFactory::Extension, const QWebPluginFactory::ExtensionOption*  
	211, 349, 212, 0,	//86  QWebPluginFactory::Extension, const QWebPluginFactory::ExtensionOption*, QWebPluginFactory::ExtensionReturn*  
	217, 0,	//90  QWebSettings::FontFamily  
	217, 341, 0,	//92  QWebSettings::FontFamily, const QString&  
	218, 0,	//95  QWebSettings::FontSize  
	218, 352, 0,	//97  QWebSettings::FontSize, int  
	219, 0,	//100  QWebSettings::WebAttribute  
	219, 318, 0,	//102  QWebSettings::WebAttribute, bool  
	220, 0,	//105  QWebSettings::WebGraphic  
	220, 330, 0,	//107  QWebSettings::WebGraphic, const QPixmap&  
	222, 0,	//110  QWheelEvent*  
	223, 0,	//112  QWidget*  
	264, 0,	//114  Qt::InputMethodQuery  
	283, 0,	//116  Qt::Orientation  
	283, 289, 0,	//118  Qt::Orientation, Qt::ScrollBarPolicy  
	283, 352, 0,	//121  Qt::Orientation, int  
	318, 0,	//124  bool  
	319, 0,	//126  const QByteArray&  
	319, 341, 0,	//128  const QByteArray&, const QString&  
	319, 341, 343, 0,	//131  const QByteArray&, const QString&, const QUrl&  
	320, 0,	//135  const QFont&  
	326, 0,	//137  const QNetworkRequest&  
	326, 96, 0,	//139  const QNetworkRequest&, QNetworkAccessManager::Operation  
	326, 96, 319, 0,	//142  const QNetworkRequest&, QNetworkAccessManager::Operation, const QByteArray&  
	329, 0,	//146  const QPalette&  
	331, 0,	//148  const QPoint&  
	335, 0,	//150  const QRect&  
	340, 0,	//152  const QSize&  
	341, 0,	//154  const QString&  
	341, 103, 0,	//156  const QString&, QObject*  
	341, 103, 130, 0,	//159  const QString&, QObject*, QScriptEngine::ValueOwnership  
	341, 204, 0,	//163  const QString&, QWebPage::FindFlags  
	341, 341, 341, 0,	//166  const QString&, const QString&, const QString&  
	341, 343, 0,	//170  const QString&, const QUrl&  
	341, 343, 342, 342, 0,	//173  const QString&, const QUrl&, const QStringList&, const QStringList&  
	341, 352, 341, 0,	//178  const QString&, int, const QString&  
	343, 0,	//182  const QUrl&  
	344, 0,	//184  const QVariant&  
	345, 0,	//186  const QWebDatabase&  
	346, 0,	//188  const QWebHistoryItem&  
	347, 0,	//190  const QWebHitTestResult&  
	35, 0,	//192  QDragEnterEvent*  
	350, 0,	//194  const QWebSecurityOrigin&  
	351, 0,	//196  const char*  
	351, 351, 0,	//198  const char*, const char*  
	352, 0,	//201  int  
	352, 352, 0,	//203  int, int  
	352, 352, 335, 0,	//206  int, int, const QRect&  
	352, 352, 352, 0,	//210  int, int, int  
	353, 0,	//214  qint64  
	354, 0,	//216  qreal  
	36, 0,	//218  QDragLeaveEvent*  
	37, 0,	//220  QDragMoveEvent*  
	38, 0,	//222  QDropEvent*  
	39, 0,	//224  QEvent*  
	46, 0,	//226  QFocusEvent*  
	63, 0,	//228  QHideEvent*  
	69, 0,	//230  QInputMethodEvent*  
	72, 0,	//232  QKeyEvent*  
	91, 352, 356, 0,	//234  QMetaObject::Call, int, void**  
	92, 0,	//238  QMouseEvent*  
	93, 0,	//240  QMoveEvent*  
	95, 0,	//242  QNetworkAccessManager*  
};

// Raw list of all methods, using munged names
static const char *qtwebkit_methodNames[] = {
    "",	//0
    "AutoLoadImages",	//1
    "Back",	//2
    "ChooseMultipleFilesExtension",	//3
    "Copy",	//4
    "CopyImageToClipboard",	//5
    "CopyLinkToClipboard",	//6
    "CursiveFont",	//7
    "Cut",	//8
    "DefaultFixedFontSize",	//9
    "DefaultFontSize",	//10
    "DefaultFrameIconGraphic",	//11
    "DelegateAllLinks",	//12
    "DelegateExternalLinks",	//13
    "DeleteEndOfWord",	//14
    "DeleteStartOfWord",	//15
    "DeveloperExtrasEnabled",	//16
    "DontDelegateLinks",	//17
    "DownloadImageToDisk",	//18
    "DownloadLinkToDisk",	//19
    "FantasyFont",	//20
    "FindBackward",	//21
    "FindCaseSensitively",	//22
    "FindWrapsAroundDocument",	//23
    "FixedFont",	//24
    "Forward",	//25
    "InsertLineSeparator",	//26
    "InsertParagraphSeparator",	//27
    "InspectElement",	//28
    "JavaEnabled",	//29
    "JavascriptCanAccessClipboard",	//30
    "JavascriptCanOpenWindows",	//31
    "JavascriptEnabled",	//32
    "LinksIncludedInFocusChain",	//33
    "LocalStorageDatabaseEnabled",	//34
    "MinimumFontSize",	//35
    "MinimumLogicalFontSize",	//36
    "MissingImageGraphic",	//37
    "MissingPluginGraphic",	//38
    "MoveToEndOfBlock",	//39
    "MoveToEndOfDocument",	//40
    "MoveToEndOfLine",	//41
    "MoveToNextChar",	//42
    "MoveToNextLine",	//43
    "MoveToNextWord",	//44
    "MoveToPreviousChar",	//45
    "MoveToPreviousLine",	//46
    "MoveToPreviousWord",	//47
    "MoveToStartOfBlock",	//48
    "MoveToStartOfDocument",	//49
    "MoveToStartOfLine",	//50
    "NavigationTypeBackOrForward",	//51
    "NavigationTypeFormResubmitted",	//52
    "NavigationTypeFormSubmitted",	//53
    "NavigationTypeLinkClicked",	//54
    "NavigationTypeOther",	//55
    "NavigationTypeReload",	//56
    "NoWebAction",	//57
    "OfflineStorageDatabaseEnabled",	//58
    "OfflineWebApplicationCacheEnabled",	//59
    "OpenFrameInNewWindow",	//60
    "OpenImageInNewWindow",	//61
    "OpenLink",	//62
    "OpenLinkInNewWindow",	//63
    "Paste",	//64
    "PluginsEnabled",	//65
    "PrintElementBackgrounds",	//66
    "PrivateBrowsingEnabled",	//67
    "QWebDatabase",	//68
    "QWebDatabase#",	//69
    "QWebHistoryInterface",	//70
    "QWebHistoryInterface#",	//71
    "QWebHistoryItem",	//72
    "QWebHistoryItem#",	//73
    "QWebHitTestResult",	//74
    "QWebHitTestResult#",	//75
    "QWebPage",	//76
    "QWebPage#",	//77
    "QWebPluginFactory",	//78
    "QWebPluginFactory#",	//79
    "QWebSecurityOrigin",	//80
    "QWebSecurityOrigin#",	//81
    "QWebView",	//82
    "QWebView#",	//83
    "Redo",	//84
    "Reload",	//85
    "SansSerifFont",	//86
    "SelectAll",	//87
    "SelectEndOfBlock",	//88
    "SelectEndOfDocument",	//89
    "SelectEndOfLine",	//90
    "SelectNextChar",	//91
    "SelectNextLine",	//92
    "SelectNextWord",	//93
    "SelectPreviousChar",	//94
    "SelectPreviousLine",	//95
    "SelectPreviousWord",	//96
    "SelectStartOfBlock",	//97
    "SelectStartOfDocument",	//98
    "SelectStartOfLine",	//99
    "SerifFont",	//100
    "SetTextDirectionDefault",	//101
    "SetTextDirectionLeftToRight",	//102
    "SetTextDirectionRightToLeft",	//103
    "StandardFont",	//104
    "Stop",	//105
    "TextAreaSizeGripCornerGraphic",	//106
    "ToggleBold",	//107
    "ToggleItalic",	//108
    "ToggleUnderline",	//109
    "Undo",	//110
    "WebActionCount",	//111
    "WebBrowserWindow",	//112
    "WebModalDialog",	//113
    "ZoomTextOnly",	//114
    "acceptNavigationRequest",	//115
    "acceptNavigationRequest##$",	//116
    "action",	//117
    "action$",	//118
    "actionEvent",	//119
    "actionEvent#",	//120
    "addHistoryEntry",	//121
    "addHistoryEntry$",	//122
    "addToJavaScriptWindowObject",	//123
    "addToJavaScriptWindowObject$#",	//124
    "addToJavaScriptWindowObject$#?",	//125
    "allOrigins",	//126
    "alternateText",	//127
    "back",	//128
    "backItem",	//129
    "backItems",	//130
    "backItems$",	//131
    "boundingRect",	//132
    "bytesReceived",	//133
    "canGoBack",	//134
    "canGoForward",	//135
    "changeEvent",	//136
    "changeEvent#",	//137
    "childEvent",	//138
    "childEvent#",	//139
    "childFrames",	//140
    "chooseFile",	//141
    "chooseFile#$",	//142
    "clear",	//143
    "clearIconDatabase",	//144
    "closeEvent",	//145
    "closeEvent#",	//146
    "connectNotify",	//147
    "connectNotify$",	//148
    "contentsChanged",	//149
    "contentsSize",	//150
    "contextMenuEvent",	//151
    "contextMenuEvent#",	//152
    "count",	//153
    "create",	//154
    "create$#??",	//155
    "createPlugin",	//156
    "createPlugin$#??",	//157
    "createStandardContextMenu",	//158
    "createWindow",	//159
    "createWindow$",	//160
    "currentFrame",	//161
    "currentItem",	//162
    "currentItemIndex",	//163
    "customEvent",	//164
    "customEvent#",	//165
    "databaseQuota",	//166
    "databaseQuotaExceeded",	//167
    "databaseQuotaExceeded#$",	//168
    "databaseUsage",	//169
    "databases",	//170
    "defaultInterface",	//171
    "devType",	//172
    "disconnectNotify",	//173
    "disconnectNotify$",	//174
    "displayName",	//175
    "downloadRequested",	//176
    "downloadRequested#",	//177
    "dragEnterEvent",	//178
    "dragEnterEvent#",	//179
    "dragLeaveEvent",	//180
    "dragLeaveEvent#",	//181
    "dragMoveEvent",	//182
    "dragMoveEvent#",	//183
    "dropEvent",	//184
    "dropEvent#",	//185
    "enabledChange",	//186
    "enabledChange$",	//187
    "enterEvent",	//188
    "enterEvent#",	//189
    "evaluateJavaScript",	//190
    "evaluateJavaScript$",	//191
    "event",	//192
    "event#",	//193
    "eventFilter",	//194
    "eventFilter##",	//195
    "expectedSize",	//196
    "extension",	//197
    "extension$",	//198
    "extension$?",	//199
    "extension$??",	//200
    "fileName",	//201
    "findText",	//202
    "findText$",	//203
    "findText$$",	//204
    "focusInEvent",	//205
    "focusInEvent#",	//206
    "focusNextPrevChild",	//207
    "focusNextPrevChild$",	//208
    "focusOutEvent",	//209
    "focusOutEvent#",	//210
    "fontChange",	//211
    "fontChange#",	//212
    "fontFamily",	//213
    "fontFamily$",	//214
    "fontSize",	//215
    "fontSize$",	//216
    "forward",	//217
    "forwardItem",	//218
    "forwardItems",	//219
    "forwardItems$",	//220
    "forwardUnsupportedContent",	//221
    "frame",	//222
    "frameCreated",	//223
    "frameCreated#",	//224
    "frameName",	//225
    "geometry",	//226
    "geometryChangeRequested",	//227
    "geometryChangeRequested#",	//228
    "globalSettings",	//229
    "goToItem",	//230
    "goToItem#",	//231
    "heightForWidth",	//232
    "heightForWidth$",	//233
    "hideEvent",	//234
    "hideEvent#",	//235
    "history",	//236
    "historyContains",	//237
    "historyContains$",	//238
    "hitTestContent",	//239
    "hitTestContent#",	//240
    "host",	//241
    "icon",	//242
    "iconChanged",	//243
    "iconDatabasePath",	//244
    "iconForUrl",	//245
    "iconForUrl#",	//246
    "imageUrl",	//247
    "initialLayoutCompleted",	//248
    "inputMethodEvent",	//249
    "inputMethodEvent#",	//250
    "inputMethodQuery",	//251
    "inputMethodQuery$",	//252
    "isContentEditable",	//253
    "isContentSelected",	//254
    "isModified",	//255
    "isNull",	//256
    "isValid",	//257
    "itemAt",	//258
    "itemAt$",	//259
    "items",	//260
    "javaScriptAlert",	//261
    "javaScriptAlert#$",	//262
    "javaScriptConfirm",	//263
    "javaScriptConfirm#$",	//264
    "javaScriptConsoleMessage",	//265
    "javaScriptConsoleMessage$$$",	//266
    "javaScriptPrompt",	//267
    "javaScriptPrompt#$$$",	//268
    "javaScriptWindowObjectCleared",	//269
    "keyPressEvent",	//270
    "keyPressEvent#",	//271
    "keyReleaseEvent",	//272
    "keyReleaseEvent#",	//273
    "languageChange",	//274
    "lastVisited",	//275
    "leaveEvent",	//276
    "leaveEvent#",	//277
    "linkClicked",	//278
    "linkClicked#",	//279
    "linkDelegationPolicy",	//280
    "linkHovered",	//281
    "linkHovered$$$",	//282
    "linkTargetFrame",	//283
    "linkText",	//284
    "linkTitle",	//285
    "linkUrl",	//286
    "load",	//287
    "load#",	//288
    "load#$",	//289
    "load#$#",	//290
    "loadFinished",	//291
    "loadFinished$",	//292
    "loadProgress",	//293
    "loadProgress$",	//294
    "loadStarted",	//295
    "mainFrame",	//296
    "maximumItemCount",	//297
    "maximumPagesInCache",	//298
    "menuBarVisibilityChangeRequested",	//299
    "menuBarVisibilityChangeRequested$",	//300
    "metaData",	//301
    "metaObject",	//302
    "metric",	//303
    "metric$",	//304
    "microFocusChanged",	//305
    "minimumSizeHint",	//306
    "mouseDoubleClickEvent",	//307
    "mouseDoubleClickEvent#",	//308
    "mouseMoveEvent",	//309
    "mouseMoveEvent#",	//310
    "mousePressEvent",	//311
    "mousePressEvent#",	//312
    "mouseReleaseEvent",	//313
    "mouseReleaseEvent#",	//314
    "moveEvent",	//315
    "moveEvent#",	//316
    "name",	//317
    "networkAccessManager",	//318
    "offlineStorageDefaultQuota",	//319
    "offlineStoragePath",	//320
    "operator=",	//321
    "operator=#",	//322
    "origin",	//323
    "originalUrl",	//324
    "page",	//325
    "pageAction",	//326
    "pageAction$",	//327
    "paintEngine",	//328
    "paintEvent",	//329
    "paintEvent#",	//330
    "palette",	//331
    "paletteChange",	//332
    "paletteChange#",	//333
    "parentFrame",	//334
    "pixmap",	//335
    "pluginFactory",	//336
    "plugins",	//337
    "port",	//338
    "pos",	//339
    "print",	//340
    "print#",	//341
    "printRequested",	//342
    "printRequested#",	//343
    "provisionalLoad",	//344
    "qt_metacall",	//345
    "qt_metacall$$?",	//346
    "refreshPlugins",	//347
    "reload",	//348
    "removeDatabase",	//349
    "removeDatabase#",	//350
    "render",	//351
    "render#",	//352
    "render##",	//353
    "renderTreeDump",	//354
    "repaintRequested",	//355
    "repaintRequested#",	//356
    "resetAttribute",	//357
    "resetAttribute$",	//358
    "resetFontFamily",	//359
    "resetFontFamily$",	//360
    "resetFontSize",	//361
    "resetFontSize$",	//362
    "resizeEvent",	//363
    "resizeEvent#",	//364
    "restoreFrameStateRequested",	//365
    "restoreFrameStateRequested#",	//366
    "saveFrameStateRequested",	//367
    "saveFrameStateRequested##",	//368
    "scheme",	//369
    "scroll",	//370
    "scroll$$",	//371
    "scrollBarMaximum",	//372
    "scrollBarMaximum$",	//373
    "scrollBarMinimum",	//374
    "scrollBarMinimum$",	//375
    "scrollBarPolicy",	//376
    "scrollBarPolicy$",	//377
    "scrollBarValue",	//378
    "scrollBarValue$",	//379
    "scrollPosition",	//380
    "scrollRequested",	//381
    "scrollRequested$$#",	//382
    "securityOrigin",	//383
    "selectedText",	//384
    "selectionChanged",	//385
    "setAttribute",	//386
    "setAttribute$$",	//387
    "setContent",	//388
    "setContent#",	//389
    "setContent#$",	//390
    "setContent#$#",	//391
    "setContentEditable",	//392
    "setContentEditable$",	//393
    "setDatabaseQuota",	//394
    "setDatabaseQuota$",	//395
    "setDefaultInterface",	//396
    "setDefaultInterface#",	//397
    "setFontFamily",	//398
    "setFontFamily$$",	//399
    "setFontSize",	//400
    "setFontSize$$",	//401
    "setForwardUnsupportedContent",	//402
    "setForwardUnsupportedContent$",	//403
    "setHtml",	//404
    "setHtml$",	//405
    "setHtml$#",	//406
    "setIconDatabasePath",	//407
    "setIconDatabasePath$",	//408
    "setLinkDelegationPolicy",	//409
    "setLinkDelegationPolicy$",	//410
    "setMaximumItemCount",	//411
    "setMaximumItemCount$",	//412
    "setMaximumPagesInCache",	//413
    "setMaximumPagesInCache$",	//414
    "setNetworkAccessManager",	//415
    "setNetworkAccessManager#",	//416
    "setObjectCacheCapacities",	//417
    "setObjectCacheCapacities$$$",	//418
    "setOfflineStorageDefaultQuota",	//419
    "setOfflineStorageDefaultQuota$",	//420
    "setOfflineStoragePath",	//421
    "setOfflineStoragePath$",	//422
    "setPage",	//423
    "setPage#",	//424
    "setPalette",	//425
    "setPalette#",	//426
    "setPluginFactory",	//427
    "setPluginFactory#",	//428
    "setScrollBarPolicy",	//429
    "setScrollBarPolicy$$",	//430
    "setScrollBarValue",	//431
    "setScrollBarValue$$",	//432
    "setScrollPosition",	//433
    "setScrollPosition#",	//434
    "setTextSizeMultiplier",	//435
    "setTextSizeMultiplier$",	//436
    "setUrl",	//437
    "setUrl#",	//438
    "setUserData",	//439
    "setUserData#",	//440
    "setUserStyleSheetUrl",	//441
    "setUserStyleSheetUrl#",	//442
    "setView",	//443
    "setView#",	//444
    "setViewportSize",	//445
    "setViewportSize#",	//446
    "setVisible",	//447
    "setVisible$",	//448
    "setWebGraphic",	//449
    "setWebGraphic$#",	//450
    "setZoomFactor",	//451
    "setZoomFactor$",	//452
    "settings",	//453
    "showEvent",	//454
    "showEvent#",	//455
    "size",	//456
    "sizeHint",	//457
    "staticMetaObject",	//458
    "statusBarMessage",	//459
    "statusBarMessage$",	//460
    "statusBarVisibilityChangeRequested",	//461
    "statusBarVisibilityChangeRequested$",	//462
    "stop",	//463
    "styleChange",	//464
    "styleChange#",	//465
    "supportsExtension",	//466
    "supportsExtension$",	//467
    "swallowContextMenuEvent",	//468
    "swallowContextMenuEvent#",	//469
    "tabletEvent",	//470
    "tabletEvent#",	//471
    "testAttribute",	//472
    "testAttribute$",	//473
    "textSizeMultiplier",	//474
    "timerEvent",	//475
    "timerEvent#",	//476
    "title",	//477
    "titleChanged",	//478
    "titleChanged$",	//479
    "toHtml",	//480
    "toPlainText",	//481
    "toolBarVisibilityChangeRequested",	//482
    "toolBarVisibilityChangeRequested$",	//483
    "totalBytes",	//484
    "tr",	//485
    "tr$",	//486
    "tr$$",	//487
    "triggerAction",	//488
    "triggerAction$",	//489
    "triggerAction$$",	//490
    "triggerPageAction",	//491
    "triggerPageAction$",	//492
    "triggerPageAction$$",	//493
    "undoStack",	//494
    "unsupportedContent",	//495
    "unsupportedContent#",	//496
    "updatePositionDependentActions",	//497
    "updatePositionDependentActions#",	//498
    "url",	//499
    "urlChanged",	//500
    "urlChanged#",	//501
    "userAgentForUrl",	//502
    "userAgentForUrl#",	//503
    "userData",	//504
    "userStyleSheetUrl",	//505
    "view",	//506
    "viewportSize",	//507
    "webGraphic",	//508
    "webGraphic$",	//509
    "wheelEvent",	//510
    "wheelEvent#",	//511
    "windowActivationChange",	//512
    "windowActivationChange$",	//513
    "windowCloseRequested",	//514
    "zoomFactor",	//515
    "~QWebDatabase",	//516
    "~QWebHistoryInterface",	//517
    "~QWebHistoryItem",	//518
    "~QWebHitTestResult",	//519
    "~QWebPage",	//520
    "~QWebPluginFactory",	//521
    "~QWebSecurityOrigin",	//522
    "~QWebView",	//523
};

// (classId, name (index in methodNames), argumentList index, number of args, method flags, return type (index in types), xcall() index)
static Smoke::Method qtwebkit_methods[] = {
	{29, 302, 0, 0, Smoke::mf_const, 325, 2},	//0 QObject::metaObject() const
	{29, 345, 234, 3, 0, 352, 3},	//1 QObject::qt_metacall(QMetaObject::Call, int, void**)
	{29, 192, 224, 1, 0, 318, 6},	//2 QObject::event(QEvent*)
	{29, 194, 5, 2, 0, 318, 7},	//3 QObject::eventFilter(QObject*, QEvent*)
	{29, 475, 33, 1, Smoke::mf_protected, 0, 49},	//4 QObject::timerEvent(QTimerEvent*)
	{29, 138, 27, 1, Smoke::mf_protected, 0, 50},	//5 QObject::childEvent(QChildEvent*)
	{29, 164, 224, 1, Smoke::mf_protected, 0, 51},	//6 QObject::customEvent(QEvent*)
	{29, 147, 196, 1, Smoke::mf_protected, 0, 52},	//7 QObject::connectNotify(const char*)
	{29, 173, 196, 1, Smoke::mf_protected, 0, 53},	//8 QObject::disconnectNotify(const char*)
	{30, 172, 0, 0, Smoke::mf_const, 352, 11},	//9 QPaintDevice::devType() const
	{30, 328, 0, 0, Smoke::mf_const, 108, 13},	//10 QPaintDevice::paintEngine() const [pure virtual]
	{30, 303, 8, 1, Smoke::mf_const|Smoke::mf_protected, 352, 25},	//11 QPaintDevice::metric(QPaintDevice::PaintDeviceMetric) const
	{53, 68, 186, 1, Smoke::mf_copyctor|Smoke::mf_ctor, 190, 1},	//12 QWebDatabase::QWebDatabase(const QWebDatabase&)
	{53, 321, 186, 1, 0, 189, 2},	//13 QWebDatabase::operator=(const QWebDatabase&)
	{53, 516, 0, 0, Smoke::mf_dtor, 0, 10},	//14 QWebDatabase::~QWebDatabase()
	{53, 317, 0, 0, Smoke::mf_const, 137, 3},	//15 QWebDatabase::name() const
	{53, 175, 0, 0, Smoke::mf_const, 137, 4},	//16 QWebDatabase::displayName() const
	{53, 196, 0, 0, Smoke::mf_const, 353, 5},	//17 QWebDatabase::expectedSize() const
	{53, 456, 0, 0, Smoke::mf_const, 353, 6},	//18 QWebDatabase::size() const
	{53, 201, 0, 0, Smoke::mf_const, 137, 7},	//19 QWebDatabase::fileName() const
	{53, 323, 0, 0, Smoke::mf_const, 213, 8},	//20 QWebDatabase::origin() const
	{53, 349, 186, 1, Smoke::mf_static, 0, 9},	//21 QWebDatabase::removeDatabase(const QWebDatabase&)
	{54, 302, 0, 0, Smoke::mf_const, 325, 2},	//22 QWebFrame::metaObject() const
	{54, 345, 234, 3, 0, 352, 3},	//23 QWebFrame::qt_metacall(QMetaObject::Call, int, void**)
	{54, 325, 0, 0, Smoke::mf_const, 200, 4},	//24 QWebFrame::page() const
	{54, 287, 182, 1, 0, 0, 5},	//25 QWebFrame::load(const QUrl&)
	{54, 287, 142, 3, 0, 0, 6},	//26 QWebFrame::load(const QNetworkRequest&, QNetworkAccessManager::Operation, const QByteArray&)
	{54, 287, 139, 2, 0, 0, 7},	//27 QWebFrame::load(const QNetworkRequest&, QNetworkAccessManager::Operation)
	{54, 287, 137, 1, 0, 0, 8},	//28 QWebFrame::load(const QNetworkRequest&)
	{54, 404, 170, 2, 0, 0, 9},	//29 QWebFrame::setHtml(const QString&, const QUrl&)
	{54, 404, 154, 1, 0, 0, 10},	//30 QWebFrame::setHtml(const QString&)
	{54, 388, 131, 3, 0, 0, 11},	//31 QWebFrame::setContent(const QByteArray&, const QString&, const QUrl&)
	{54, 388, 128, 2, 0, 0, 12},	//32 QWebFrame::setContent(const QByteArray&, const QString&)
	{54, 388, 126, 1, 0, 0, 13},	//33 QWebFrame::setContent(const QByteArray&)
	{54, 123, 156, 2, 0, 0, 14},	//34 QWebFrame::addToJavaScriptWindowObject(const QString&, QObject*)
	{54, 123, 159, 3, 0, 0, 15},	//35 QWebFrame::addToJavaScriptWindowObject(const QString&, QObject*, QScriptEngine::ValueOwnership)
	{54, 480, 0, 0, Smoke::mf_const, 137, 16},	//36 QWebFrame::toHtml() const
	{54, 481, 0, 0, Smoke::mf_const, 137, 17},	//37 QWebFrame::toPlainText() const
	{54, 354, 0, 0, Smoke::mf_const, 137, 18},	//38 QWebFrame::renderTreeDump() const
	{54, 477, 0, 0, Smoke::mf_const, 137, 19},	//39 QWebFrame::title() const
	{54, 437, 182, 1, 0, 0, 20},	//40 QWebFrame::setUrl(const QUrl&)
	{54, 499, 0, 0, Smoke::mf_const, 184, 21},	//41 QWebFrame::url() const
	{54, 242, 0, 0, Smoke::mf_const, 66, 22},	//42 QWebFrame::icon() const
	{54, 301, 0, 0, Smoke::mf_const, 94, 23},	//43 QWebFrame::metaData() const
	{54, 225, 0, 0, Smoke::mf_const, 137, 24},	//44 QWebFrame::frameName() const
	{54, 334, 0, 0, Smoke::mf_const, 191, 25},	//45 QWebFrame::parentFrame() const
	{54, 140, 0, 0, Smoke::mf_const, 76, 26},	//46 QWebFrame::childFrames() const
	{54, 376, 116, 1, Smoke::mf_const, 289, 27},	//47 QWebFrame::scrollBarPolicy(Qt::Orientation) const
	{54, 429, 118, 2, 0, 0, 28},	//48 QWebFrame::setScrollBarPolicy(Qt::Orientation, Qt::ScrollBarPolicy)
	{54, 431, 121, 2, 0, 0, 29},	//49 QWebFrame::setScrollBarValue(Qt::Orientation, int)
	{54, 378, 116, 1, Smoke::mf_const, 352, 30},	//50 QWebFrame::scrollBarValue(Qt::Orientation) const
	{54, 374, 116, 1, Smoke::mf_const, 352, 31},	//51 QWebFrame::scrollBarMinimum(Qt::Orientation) const
	{54, 372, 116, 1, Smoke::mf_const, 352, 32},	//52 QWebFrame::scrollBarMaximum(Qt::Orientation) const
	{54, 370, 203, 2, 0, 0, 33},	//53 QWebFrame::scroll(int, int)
	{54, 380, 0, 0, Smoke::mf_const, 125, 34},	//54 QWebFrame::scrollPosition() const
	{54, 433, 148, 1, 0, 0, 35},	//55 QWebFrame::setScrollPosition(const QPoint&)
	{54, 351, 14, 2, 0, 0, 36},	//56 QWebFrame::render(QPainter*, const QRegion&)
	{54, 351, 12, 1, 0, 0, 37},	//57 QWebFrame::render(QPainter*)
	{54, 435, 216, 1, 0, 0, 38},	//58 QWebFrame::setTextSizeMultiplier(qreal)
	{54, 474, 0, 0, Smoke::mf_const, 354, 39},	//59 QWebFrame::textSizeMultiplier() const
	{54, 515, 0, 0, Smoke::mf_const, 354, 40},	//60 QWebFrame::zoomFactor() const
	{54, 451, 216, 1, 0, 0, 41},	//61 QWebFrame::setZoomFactor(qreal)
	{54, 339, 0, 0, Smoke::mf_const, 125, 42},	//62 QWebFrame::pos() const
	{54, 226, 0, 0, Smoke::mf_const, 127, 43},	//63 QWebFrame::geometry() const
	{54, 150, 0, 0, Smoke::mf_const, 132, 44},	//64 QWebFrame::contentsSize() const
	{54, 239, 148, 1, Smoke::mf_const, 197, 45},	//65 QWebFrame::hitTestContent(const QPoint&) const
	{54, 192, 224, 1, 0, 318, 46},	//66 QWebFrame::event(QEvent*)
	{54, 383, 0, 0, Smoke::mf_const, 213, 47},	//67 QWebFrame::securityOrigin() const
	{54, 190, 154, 1, 0, 188, 48},	//68 QWebFrame::evaluateJavaScript(const QString&)
	{54, 340, 17, 1, Smoke::mf_const, 0, 49},	//69 QWebFrame::print(QPrinter*) const
	{54, 485, 198, 2, Smoke::mf_static, 137, 50},	//70 QWebFrame::tr(const char*, const char*)
	{54, 485, 196, 1, Smoke::mf_static, 137, 51},	//71 QWebFrame::tr(const char*)
	{54, 458, 0, 0, Smoke::mf_static, 324, 1},	//72 QWebFrame::staticMetaObject (static var)
	{55, 143, 0, 0, 0, 0, 1},	//73 QWebHistory::clear()
	{55, 260, 0, 0, Smoke::mf_const, 77, 2},	//74 QWebHistory::items() const
	{55, 130, 201, 1, Smoke::mf_const, 77, 3},	//75 QWebHistory::backItems(int) const
	{55, 219, 201, 1, Smoke::mf_const, 77, 4},	//76 QWebHistory::forwardItems(int) const
	{55, 134, 0, 0, Smoke::mf_const, 318, 5},	//77 QWebHistory::canGoBack() const
	{55, 135, 0, 0, Smoke::mf_const, 318, 6},	//78 QWebHistory::canGoForward() const
	{55, 128, 0, 0, 0, 0, 7},	//79 QWebHistory::back()
	{55, 217, 0, 0, 0, 0, 8},	//80 QWebHistory::forward()
	{55, 230, 188, 1, 0, 0, 9},	//81 QWebHistory::goToItem(const QWebHistoryItem&)
	{55, 129, 0, 0, Smoke::mf_const, 194, 10},	//82 QWebHistory::backItem() const
	{55, 162, 0, 0, Smoke::mf_const, 194, 11},	//83 QWebHistory::currentItem() const
	{55, 218, 0, 0, Smoke::mf_const, 194, 12},	//84 QWebHistory::forwardItem() const
	{55, 258, 201, 1, Smoke::mf_const, 194, 13},	//85 QWebHistory::itemAt(int) const
	{55, 163, 0, 0, Smoke::mf_const, 352, 14},	//86 QWebHistory::currentItemIndex() const
	{55, 153, 0, 0, Smoke::mf_const, 352, 15},	//87 QWebHistory::count() const
	{55, 297, 0, 0, Smoke::mf_const, 352, 16},	//88 QWebHistory::maximumItemCount() const
	{55, 411, 201, 1, 0, 0, 17},	//89 QWebHistory::setMaximumItemCount(int)
	{56, 302, 0, 0, Smoke::mf_const, 325, 2},	//90 QWebHistoryInterface::metaObject() const
	{56, 345, 234, 3, 0, 352, 3},	//91 QWebHistoryInterface::qt_metacall(QMetaObject::Call, int, void**)
	{56, 70, 3, 1, Smoke::mf_ctor, 193, 4},	//92 QWebHistoryInterface::QWebHistoryInterface(QObject*)
	{56, 70, 0, 0, Smoke::mf_ctor, 193, 5},	//93 QWebHistoryInterface::QWebHistoryInterface()
	{56, 517, 0, 0, Smoke::mf_dtor, 0, 12},	//94 QWebHistoryInterface::~QWebHistoryInterface()
	{56, 237, 154, 1, Smoke::mf_const, 318, 6},	//95 QWebHistoryInterface::historyContains(const QString&) const [pure virtual]
	{56, 121, 154, 1, 0, 0, 7},	//96 QWebHistoryInterface::addHistoryEntry(const QString&) [pure virtual]
	{56, 485, 198, 2, Smoke::mf_static, 137, 8},	//97 QWebHistoryInterface::tr(const char*, const char*)
	{56, 485, 196, 1, Smoke::mf_static, 137, 9},	//98 QWebHistoryInterface::tr(const char*)
	{56, 396, 57, 1, Smoke::mf_static, 0, 10},	//99 QWebHistoryInterface::setDefaultInterface(QWebHistoryInterface*)
	{56, 171, 0, 0, Smoke::mf_static, 193, 11},	//100 QWebHistoryInterface::defaultInterface()
	{56, 458, 0, 0, Smoke::mf_static, 324, 1},	//101 QWebHistoryInterface::staticMetaObject (static var)
	{57, 72, 188, 1, Smoke::mf_copyctor|Smoke::mf_ctor, 196, 1},	//102 QWebHistoryItem::QWebHistoryItem(const QWebHistoryItem&)
	{57, 321, 188, 1, 0, 195, 2},	//103 QWebHistoryItem::operator=(const QWebHistoryItem&)
	{57, 518, 0, 0, Smoke::mf_dtor, 0, 11},	//104 QWebHistoryItem::~QWebHistoryItem()
	{57, 324, 0, 0, Smoke::mf_const, 184, 3},	//105 QWebHistoryItem::originalUrl() const
	{57, 499, 0, 0, Smoke::mf_const, 184, 4},	//106 QWebHistoryItem::url() const
	{57, 477, 0, 0, Smoke::mf_const, 137, 5},	//107 QWebHistoryItem::title() const
	{57, 275, 0, 0, Smoke::mf_const, 22, 6},	//108 QWebHistoryItem::lastVisited() const
	{57, 242, 0, 0, Smoke::mf_const, 66, 7},	//109 QWebHistoryItem::icon() const
	{57, 504, 0, 0, Smoke::mf_const, 188, 8},	//110 QWebHistoryItem::userData() const
	{57, 439, 184, 1, 0, 0, 9},	//111 QWebHistoryItem::setUserData(const QVariant&)
	{57, 257, 0, 0, Smoke::mf_const, 318, 10},	//112 QWebHistoryItem::isValid() const
	{58, 74, 0, 0, Smoke::mf_ctor, 199, 1},	//113 QWebHitTestResult::QWebHitTestResult()
	{58, 74, 190, 1, Smoke::mf_copyctor|Smoke::mf_ctor, 199, 2},	//114 QWebHitTestResult::QWebHitTestResult(const QWebHitTestResult&)
	{58, 321, 190, 1, 0, 198, 3},	//115 QWebHitTestResult::operator=(const QWebHitTestResult&)
	{58, 519, 0, 0, Smoke::mf_dtor, 0, 18},	//116 QWebHitTestResult::~QWebHitTestResult()
	{58, 256, 0, 0, Smoke::mf_const, 318, 4},	//117 QWebHitTestResult::isNull() const
	{58, 339, 0, 0, Smoke::mf_const, 125, 5},	//118 QWebHitTestResult::pos() const
	{58, 132, 0, 0, Smoke::mf_const, 127, 6},	//119 QWebHitTestResult::boundingRect() const
	{58, 477, 0, 0, Smoke::mf_const, 137, 7},	//120 QWebHitTestResult::title() const
	{58, 284, 0, 0, Smoke::mf_const, 137, 8},	//121 QWebHitTestResult::linkText() const
	{58, 286, 0, 0, Smoke::mf_const, 184, 9},	//122 QWebHitTestResult::linkUrl() const
	{58, 285, 0, 0, Smoke::mf_const, 184, 10},	//123 QWebHitTestResult::linkTitle() const
	{58, 283, 0, 0, Smoke::mf_const, 191, 11},	//124 QWebHitTestResult::linkTargetFrame() const
	{58, 127, 0, 0, Smoke::mf_const, 137, 12},	//125 QWebHitTestResult::alternateText() const
	{58, 247, 0, 0, Smoke::mf_const, 184, 13},	//126 QWebHitTestResult::imageUrl() const
	{58, 335, 0, 0, Smoke::mf_const, 123, 14},	//127 QWebHitTestResult::pixmap() const
	{58, 253, 0, 0, Smoke::mf_const, 318, 15},	//128 QWebHitTestResult::isContentEditable() const
	{58, 254, 0, 0, Smoke::mf_const, 318, 16},	//129 QWebHitTestResult::isContentSelected() const
	{58, 222, 0, 0, Smoke::mf_const, 191, 17},	//130 QWebHitTestResult::frame() const
	{59, 54, 0, 0, Smoke::mf_static|Smoke::mf_enum, 207, 1},	//131 QWebPage::NavigationTypeLinkClicked (enum)
	{59, 53, 0, 0, Smoke::mf_static|Smoke::mf_enum, 207, 2},	//132 QWebPage::NavigationTypeFormSubmitted (enum)
	{59, 51, 0, 0, Smoke::mf_static|Smoke::mf_enum, 207, 3},	//133 QWebPage::NavigationTypeBackOrForward (enum)
	{59, 56, 0, 0, Smoke::mf_static|Smoke::mf_enum, 207, 4},	//134 QWebPage::NavigationTypeReload (enum)
	{59, 52, 0, 0, Smoke::mf_static|Smoke::mf_enum, 207, 5},	//135 QWebPage::NavigationTypeFormResubmitted (enum)
	{59, 55, 0, 0, Smoke::mf_static|Smoke::mf_enum, 207, 6},	//136 QWebPage::NavigationTypeOther (enum)
	{59, 57, 0, 0, Smoke::mf_static|Smoke::mf_enum, 208, 7},	//137 QWebPage::NoWebAction (enum)
	{59, 62, 0, 0, Smoke::mf_static|Smoke::mf_enum, 208, 8},	//138 QWebPage::OpenLink (enum)
	{59, 63, 0, 0, Smoke::mf_static|Smoke::mf_enum, 208, 9},	//139 QWebPage::OpenLinkInNewWindow (enum)
	{59, 60, 0, 0, Smoke::mf_static|Smoke::mf_enum, 208, 10},	//140 QWebPage::OpenFrameInNewWindow (enum)
	{59, 19, 0, 0, Smoke::mf_static|Smoke::mf_enum, 208, 11},	//141 QWebPage::DownloadLinkToDisk (enum)
	{59, 6, 0, 0, Smoke::mf_static|Smoke::mf_enum, 208, 12},	//142 QWebPage::CopyLinkToClipboard (enum)
	{59, 61, 0, 0, Smoke::mf_static|Smoke::mf_enum, 208, 13},	//143 QWebPage::OpenImageInNewWindow (enum)
	{59, 18, 0, 0, Smoke::mf_static|Smoke::mf_enum, 208, 14},	//144 QWebPage::DownloadImageToDisk (enum)
	{59, 5, 0, 0, Smoke::mf_static|Smoke::mf_enum, 208, 15},	//145 QWebPage::CopyImageToClipboard (enum)
	{59, 2, 0, 0, Smoke::mf_static|Smoke::mf_enum, 208, 16},	//146 QWebPage::Back (enum)
	{59, 25, 0, 0, Smoke::mf_static|Smoke::mf_enum, 208, 17},	//147 QWebPage::Forward (enum)
	{59, 105, 0, 0, Smoke::mf_static|Smoke::mf_enum, 208, 18},	//148 QWebPage::Stop (enum)
	{59, 85, 0, 0, Smoke::mf_static|Smoke::mf_enum, 208, 19},	//149 QWebPage::Reload (enum)
	{59, 8, 0, 0, Smoke::mf_static|Smoke::mf_enum, 208, 20},	//150 QWebPage::Cut (enum)
	{59, 4, 0, 0, Smoke::mf_static|Smoke::mf_enum, 208, 21},	//151 QWebPage::Copy (enum)
	{59, 64, 0, 0, Smoke::mf_static|Smoke::mf_enum, 208, 22},	//152 QWebPage::Paste (enum)
	{59, 110, 0, 0, Smoke::mf_static|Smoke::mf_enum, 208, 23},	//153 QWebPage::Undo (enum)
	{59, 84, 0, 0, Smoke::mf_static|Smoke::mf_enum, 208, 24},	//154 QWebPage::Redo (enum)
	{59, 42, 0, 0, Smoke::mf_static|Smoke::mf_enum, 208, 25},	//155 QWebPage::MoveToNextChar (enum)
	{59, 45, 0, 0, Smoke::mf_static|Smoke::mf_enum, 208, 26},	//156 QWebPage::MoveToPreviousChar (enum)
	{59, 44, 0, 0, Smoke::mf_static|Smoke::mf_enum, 208, 27},	//157 QWebPage::MoveToNextWord (enum)
	{59, 47, 0, 0, Smoke::mf_static|Smoke::mf_enum, 208, 28},	//158 QWebPage::MoveToPreviousWord (enum)
	{59, 43, 0, 0, Smoke::mf_static|Smoke::mf_enum, 208, 29},	//159 QWebPage::MoveToNextLine (enum)
	{59, 46, 0, 0, Smoke::mf_static|Smoke::mf_enum, 208, 30},	//160 QWebPage::MoveToPreviousLine (enum)
	{59, 50, 0, 0, Smoke::mf_static|Smoke::mf_enum, 208, 31},	//161 QWebPage::MoveToStartOfLine (enum)
	{59, 41, 0, 0, Smoke::mf_static|Smoke::mf_enum, 208, 32},	//162 QWebPage::MoveToEndOfLine (enum)
	{59, 48, 0, 0, Smoke::mf_static|Smoke::mf_enum, 208, 33},	//163 QWebPage::MoveToStartOfBlock (enum)
	{59, 39, 0, 0, Smoke::mf_static|Smoke::mf_enum, 208, 34},	//164 QWebPage::MoveToEndOfBlock (enum)
	{59, 49, 0, 0, Smoke::mf_static|Smoke::mf_enum, 208, 35},	//165 QWebPage::MoveToStartOfDocument (enum)
	{59, 40, 0, 0, Smoke::mf_static|Smoke::mf_enum, 208, 36},	//166 QWebPage::MoveToEndOfDocument (enum)
	{59, 91, 0, 0, Smoke::mf_static|Smoke::mf_enum, 208, 37},	//167 QWebPage::SelectNextChar (enum)
	{59, 94, 0, 0, Smoke::mf_static|Smoke::mf_enum, 208, 38},	//168 QWebPage::SelectPreviousChar (enum)
	{59, 93, 0, 0, Smoke::mf_static|Smoke::mf_enum, 208, 39},	//169 QWebPage::SelectNextWord (enum)
	{59, 96, 0, 0, Smoke::mf_static|Smoke::mf_enum, 208, 40},	//170 QWebPage::SelectPreviousWord (enum)
	{59, 92, 0, 0, Smoke::mf_static|Smoke::mf_enum, 208, 41},	//171 QWebPage::SelectNextLine (enum)
	{59, 95, 0, 0, Smoke::mf_static|Smoke::mf_enum, 208, 42},	//172 QWebPage::SelectPreviousLine (enum)
	{59, 99, 0, 0, Smoke::mf_static|Smoke::mf_enum, 208, 43},	//173 QWebPage::SelectStartOfLine (enum)
	{59, 90, 0, 0, Smoke::mf_static|Smoke::mf_enum, 208, 44},	//174 QWebPage::SelectEndOfLine (enum)
	{59, 97, 0, 0, Smoke::mf_static|Smoke::mf_enum, 208, 45},	//175 QWebPage::SelectStartOfBlock (enum)
	{59, 88, 0, 0, Smoke::mf_static|Smoke::mf_enum, 208, 46},	//176 QWebPage::SelectEndOfBlock (enum)
	{59, 98, 0, 0, Smoke::mf_static|Smoke::mf_enum, 208, 47},	//177 QWebPage::SelectStartOfDocument (enum)
	{59, 89, 0, 0, Smoke::mf_static|Smoke::mf_enum, 208, 48},	//178 QWebPage::SelectEndOfDocument (enum)
	{59, 15, 0, 0, Smoke::mf_static|Smoke::mf_enum, 208, 49},	//179 QWebPage::DeleteStartOfWord (enum)
	{59, 14, 0, 0, Smoke::mf_static|Smoke::mf_enum, 208, 50},	//180 QWebPage::DeleteEndOfWord (enum)
	{59, 101, 0, 0, Smoke::mf_static|Smoke::mf_enum, 208, 51},	//181 QWebPage::SetTextDirectionDefault (enum)
	{59, 102, 0, 0, Smoke::mf_static|Smoke::mf_enum, 208, 52},	//182 QWebPage::SetTextDirectionLeftToRight (enum)
	{59, 103, 0, 0, Smoke::mf_static|Smoke::mf_enum, 208, 53},	//183 QWebPage::SetTextDirectionRightToLeft (enum)
	{59, 107, 0, 0, Smoke::mf_static|Smoke::mf_enum, 208, 54},	//184 QWebPage::ToggleBold (enum)
	{59, 108, 0, 0, Smoke::mf_static|Smoke::mf_enum, 208, 55},	//185 QWebPage::ToggleItalic (enum)
	{59, 109, 0, 0, Smoke::mf_static|Smoke::mf_enum, 208, 56},	//186 QWebPage::ToggleUnderline (enum)
	{59, 28, 0, 0, Smoke::mf_static|Smoke::mf_enum, 208, 57},	//187 QWebPage::InspectElement (enum)
	{59, 27, 0, 0, Smoke::mf_static|Smoke::mf_enum, 208, 58},	//188 QWebPage::InsertParagraphSeparator (enum)
	{59, 26, 0, 0, Smoke::mf_static|Smoke::mf_enum, 208, 59},	//189 QWebPage::InsertLineSeparator (enum)
	{59, 87, 0, 0, Smoke::mf_static|Smoke::mf_enum, 208, 60},	//190 QWebPage::SelectAll (enum)
	{59, 111, 0, 0, Smoke::mf_static|Smoke::mf_enum, 208, 61},	//191 QWebPage::WebActionCount (enum)
	{59, 21, 0, 0, Smoke::mf_static|Smoke::mf_enum, 203, 62},	//192 QWebPage::FindBackward (enum)
	{59, 22, 0, 0, Smoke::mf_static|Smoke::mf_enum, 203, 63},	//193 QWebPage::FindCaseSensitively (enum)
	{59, 23, 0, 0, Smoke::mf_static|Smoke::mf_enum, 203, 64},	//194 QWebPage::FindWrapsAroundDocument (enum)
	{59, 17, 0, 0, Smoke::mf_static|Smoke::mf_enum, 206, 65},	//195 QWebPage::DontDelegateLinks (enum)
	{59, 13, 0, 0, Smoke::mf_static|Smoke::mf_enum, 206, 66},	//196 QWebPage::DelegateExternalLinks (enum)
	{59, 12, 0, 0, Smoke::mf_static|Smoke::mf_enum, 206, 67},	//197 QWebPage::DelegateAllLinks (enum)
	{59, 112, 0, 0, Smoke::mf_static|Smoke::mf_enum, 209, 68},	//198 QWebPage::WebBrowserWindow (enum)
	{59, 113, 0, 0, Smoke::mf_static|Smoke::mf_enum, 209, 69},	//199 QWebPage::WebModalDialog (enum)
	{59, 3, 0, 0, Smoke::mf_static|Smoke::mf_enum, 201, 70},	//200 QWebPage::ChooseMultipleFilesExtension (enum)
	{59, 302, 0, 0, Smoke::mf_const, 325, 72},	//201 QWebPage::metaObject() const
	{59, 345, 234, 3, 0, 352, 73},	//202 QWebPage::qt_metacall(QMetaObject::Call, int, void**)
	{59, 76, 3, 1, Smoke::mf_ctor, 200, 74},	//203 QWebPage::QWebPage(QObject*)
	{59, 76, 0, 0, Smoke::mf_ctor, 200, 75},	//204 QWebPage::QWebPage()
	{59, 520, 0, 0, Smoke::mf_dtor, 0, 150},	//205 QWebPage::~QWebPage()
	{59, 296, 0, 0, Smoke::mf_const, 191, 76},	//206 QWebPage::mainFrame() const
	{59, 161, 0, 0, Smoke::mf_const, 191, 77},	//207 QWebPage::currentFrame() const
	{59, 236, 0, 0, Smoke::mf_const, 192, 78},	//208 QWebPage::history() const
	{59, 453, 0, 0, Smoke::mf_const, 216, 79},	//209 QWebPage::settings() const
	{59, 443, 112, 1, 0, 0, 80},	//210 QWebPage::setView(QWidget*)
	{59, 506, 0, 0, Smoke::mf_const, 223, 81},	//211 QWebPage::view() const
	{59, 255, 0, 0, Smoke::mf_const, 318, 82},	//212 QWebPage::isModified() const
	{59, 494, 0, 0, Smoke::mf_const, 183, 83},	//213 QWebPage::undoStack() const
	{59, 415, 242, 1, 0, 0, 84},	//214 QWebPage::setNetworkAccessManager(QNetworkAccessManager*)
	{59, 318, 0, 0, Smoke::mf_const, 95, 85},	//215 QWebPage::networkAccessManager() const
	{59, 427, 79, 1, 0, 0, 86},	//216 QWebPage::setPluginFactory(QWebPluginFactory*)
	{59, 336, 0, 0, Smoke::mf_const, 210, 87},	//217 QWebPage::pluginFactory() const
	{59, 484, 0, 0, Smoke::mf_const, 355, 88},	//218 QWebPage::totalBytes() const
	{59, 133, 0, 0, Smoke::mf_const, 355, 89},	//219 QWebPage::bytesReceived() const
	{59, 384, 0, 0, Smoke::mf_const, 137, 90},	//220 QWebPage::selectedText() const
	{59, 117, 72, 1, Smoke::mf_const, 13, 91},	//221 QWebPage::action(QWebPage::WebAction) const
	{59, 488, 74, 2, 0, 0, 92},	//222 QWebPage::triggerAction(QWebPage::WebAction, bool)
	{59, 488, 72, 1, 0, 0, 93},	//223 QWebPage::triggerAction(QWebPage::WebAction)
	{59, 507, 0, 0, Smoke::mf_const, 132, 94},	//224 QWebPage::viewportSize() const
	{59, 445, 152, 1, Smoke::mf_const, 0, 95},	//225 QWebPage::setViewportSize(const QSize&) const
	{59, 192, 224, 1, 0, 318, 96},	//226 QWebPage::event(QEvent*)
	{59, 207, 124, 1, 0, 318, 97},	//227 QWebPage::focusNextPrevChild(bool)
	{59, 251, 114, 1, Smoke::mf_const, 188, 98},	//228 QWebPage::inputMethodQuery(Qt::InputMethodQuery) const
	{59, 202, 163, 2, 0, 318, 99},	//229 QWebPage::findText(const QString&, QWebPage::FindFlags)
	{59, 202, 154, 1, 0, 318, 100},	//230 QWebPage::findText(const QString&)
	{59, 402, 124, 1, 0, 0, 101},	//231 QWebPage::setForwardUnsupportedContent(bool)
	{59, 221, 0, 0, Smoke::mf_const, 318, 102},	//232 QWebPage::forwardUnsupportedContent() const
	{59, 409, 70, 1, 0, 0, 103},	//233 QWebPage::setLinkDelegationPolicy(QWebPage::LinkDelegationPolicy)
	{59, 280, 0, 0, Smoke::mf_const, 206, 104},	//234 QWebPage::linkDelegationPolicy() const
	{59, 425, 146, 1, 0, 0, 105},	//235 QWebPage::setPalette(const QPalette&)
	{59, 331, 0, 0, Smoke::mf_const, 122, 106},	//236 QWebPage::palette() const
	{59, 392, 124, 1, 0, 0, 107},	//237 QWebPage::setContentEditable(bool)
	{59, 253, 0, 0, Smoke::mf_const, 318, 108},	//238 QWebPage::isContentEditable() const
	{59, 468, 35, 1, 0, 318, 109},	//239 QWebPage::swallowContextMenuEvent(QContextMenuEvent*)
	{59, 497, 148, 1, 0, 0, 110},	//240 QWebPage::updatePositionDependentActions(const QPoint&)
	{59, 158, 0, 0, 0, 88, 111},	//241 QWebPage::createStandardContextMenu()
	{59, 197, 66, 3, 0, 318, 112},	//242 QWebPage::extension(QWebPage::Extension, const QWebPage::ExtensionOption*, QWebPage::ExtensionReturn*)
	{59, 197, 63, 2, 0, 318, 113},	//243 QWebPage::extension(QWebPage::Extension, const QWebPage::ExtensionOption*)
	{59, 197, 61, 1, 0, 318, 114},	//244 QWebPage::extension(QWebPage::Extension)
	{59, 466, 61, 1, Smoke::mf_const, 318, 115},	//245 QWebPage::supportsExtension(QWebPage::Extension) const
	{59, 295, 0, 0, 0, 0, 116},	//246 QWebPage::loadStarted()
	{59, 293, 201, 1, 0, 0, 117},	//247 QWebPage::loadProgress(int)
	{59, 291, 124, 1, 0, 0, 118},	//248 QWebPage::loadFinished(bool)
	{59, 281, 166, 3, 0, 0, 119},	//249 QWebPage::linkHovered(const QString&, const QString&, const QString&)
	{59, 459, 154, 1, 0, 0, 120},	//250 QWebPage::statusBarMessage(const QString&)
	{59, 385, 0, 0, 0, 0, 121},	//251 QWebPage::selectionChanged()
	{59, 223, 37, 1, 0, 0, 122},	//252 QWebPage::frameCreated(QWebFrame*)
	{59, 227, 150, 1, 0, 0, 123},	//253 QWebPage::geometryChangeRequested(const QRect&)
	{59, 355, 150, 1, 0, 0, 124},	//254 QWebPage::repaintRequested(const QRect&)
	{59, 381, 206, 3, 0, 0, 125},	//255 QWebPage::scrollRequested(int, int, const QRect&)
	{59, 514, 0, 0, 0, 0, 126},	//256 QWebPage::windowCloseRequested()
	{59, 342, 37, 1, 0, 0, 127},	//257 QWebPage::printRequested(QWebFrame*)
	{59, 278, 182, 1, 0, 0, 128},	//258 QWebPage::linkClicked(const QUrl&)
	{59, 482, 124, 1, 0, 0, 129},	//259 QWebPage::toolBarVisibilityChangeRequested(bool)
	{59, 461, 124, 1, 0, 0, 130},	//260 QWebPage::statusBarVisibilityChangeRequested(bool)
	{59, 299, 124, 1, 0, 0, 131},	//261 QWebPage::menuBarVisibilityChangeRequested(bool)
	{59, 495, 1, 1, 0, 0, 132},	//262 QWebPage::unsupportedContent(QNetworkReply*)
	{59, 176, 137, 1, 0, 0, 133},	//263 QWebPage::downloadRequested(const QNetworkRequest&)
	{59, 305, 0, 0, 0, 0, 134},	//264 QWebPage::microFocusChanged()
	{59, 149, 0, 0, 0, 0, 135},	//265 QWebPage::contentsChanged()
	{59, 167, 39, 2, 0, 0, 136},	//266 QWebPage::databaseQuotaExceeded(QWebFrame*, QString)
	{59, 367, 42, 2, 0, 0, 137},	//267 QWebPage::saveFrameStateRequested(QWebFrame*, QWebHistoryItem*)
	{59, 365, 37, 1, 0, 0, 138},	//268 QWebPage::restoreFrameStateRequested(QWebFrame*)
	{59, 485, 198, 2, Smoke::mf_static, 137, 139},	//269 QWebPage::tr(const char*, const char*)
	{59, 485, 196, 1, Smoke::mf_static, 137, 140},	//270 QWebPage::tr(const char*)
	{59, 458, 0, 0, Smoke::mf_static, 324, 71},	//271 QWebPage::staticMetaObject (static var)
	{59, 159, 77, 1, Smoke::mf_protected, 200, 141},	//272 QWebPage::createWindow(QWebPage::WebWindowType)
	{59, 156, 173, 4, Smoke::mf_protected, 103, 142},	//273 QWebPage::createPlugin(const QString&, const QUrl&, const QStringList&, const QStringList&)
	{59, 115, 45, 3, Smoke::mf_protected, 318, 143},	//274 QWebPage::acceptNavigationRequest(QWebFrame*, const QNetworkRequest&, QWebPage::NavigationType)
	{59, 141, 49, 2, Smoke::mf_protected, 137, 144},	//275 QWebPage::chooseFile(QWebFrame*, const QString&)
	{59, 261, 49, 2, Smoke::mf_protected, 0, 145},	//276 QWebPage::javaScriptAlert(QWebFrame*, const QString&)
	{59, 263, 49, 2, Smoke::mf_protected, 318, 146},	//277 QWebPage::javaScriptConfirm(QWebFrame*, const QString&)
	{59, 267, 52, 4, Smoke::mf_protected, 318, 147},	//278 QWebPage::javaScriptPrompt(QWebFrame*, const QString&, const QString&, QString*)
	{59, 265, 178, 3, Smoke::mf_protected, 0, 148},	//279 QWebPage::javaScriptConsoleMessage(const QString&, int, const QString&)
	{59, 502, 182, 1, Smoke::mf_const|Smoke::mf_protected, 137, 149},	//280 QWebPage::userAgentForUrl(const QUrl&) const
	{60, 302, 0, 0, Smoke::mf_const, 325, 2},	//281 QWebPluginFactory::metaObject() const
	{60, 345, 234, 3, 0, 352, 3},	//282 QWebPluginFactory::qt_metacall(QMetaObject::Call, int, void**)
	{60, 78, 3, 1, Smoke::mf_ctor, 210, 4},	//283 QWebPluginFactory::QWebPluginFactory(QObject*)
	{60, 78, 0, 0, Smoke::mf_ctor, 210, 5},	//284 QWebPluginFactory::QWebPluginFactory()
	{60, 521, 0, 0, Smoke::mf_dtor, 0, 15},	//285 QWebPluginFactory::~QWebPluginFactory()
	{60, 337, 0, 0, Smoke::mf_const, 78, 6},	//286 QWebPluginFactory::plugins() const [pure virtual]
	{60, 347, 0, 0, 0, 0, 7},	//287 QWebPluginFactory::refreshPlugins()
	{60, 154, 173, 4, Smoke::mf_const, 103, 8},	//288 QWebPluginFactory::create(const QString&, const QUrl&, const QStringList&, const QStringList&) const [pure virtual]
	{60, 197, 86, 3, 0, 318, 9},	//289 QWebPluginFactory::extension(QWebPluginFactory::Extension, const QWebPluginFactory::ExtensionOption*, QWebPluginFactory::ExtensionReturn*)
	{60, 197, 83, 2, 0, 318, 10},	//290 QWebPluginFactory::extension(QWebPluginFactory::Extension, const QWebPluginFactory::ExtensionOption*)
	{60, 197, 81, 1, 0, 318, 11},	//291 QWebPluginFactory::extension(QWebPluginFactory::Extension)
	{60, 466, 81, 1, Smoke::mf_const, 318, 12},	//292 QWebPluginFactory::supportsExtension(QWebPluginFactory::Extension) const
	{60, 485, 198, 2, Smoke::mf_static, 137, 13},	//293 QWebPluginFactory::tr(const char*, const char*)
	{60, 485, 196, 1, Smoke::mf_static, 137, 14},	//294 QWebPluginFactory::tr(const char*)
	{60, 458, 0, 0, Smoke::mf_static, 324, 1},	//295 QWebPluginFactory::staticMetaObject (static var)
	{61, 522, 0, 0, Smoke::mf_dtor, 0, 11},	//296 QWebSecurityOrigin::~QWebSecurityOrigin()
	{61, 369, 0, 0, Smoke::mf_const, 137, 1},	//297 QWebSecurityOrigin::scheme() const
	{61, 241, 0, 0, Smoke::mf_const, 137, 2},	//298 QWebSecurityOrigin::host() const
	{61, 338, 0, 0, Smoke::mf_const, 352, 3},	//299 QWebSecurityOrigin::port() const
	{61, 169, 0, 0, Smoke::mf_const, 353, 4},	//300 QWebSecurityOrigin::databaseUsage() const
	{61, 166, 0, 0, Smoke::mf_const, 353, 5},	//301 QWebSecurityOrigin::databaseQuota() const
	{61, 394, 214, 1, 0, 0, 6},	//302 QWebSecurityOrigin::setDatabaseQuota(qint64)
	{61, 170, 0, 0, Smoke::mf_const, 75, 7},	//303 QWebSecurityOrigin::databases() const
	{61, 80, 194, 1, Smoke::mf_copyctor|Smoke::mf_ctor, 215, 8},	//304 QWebSecurityOrigin::QWebSecurityOrigin(const QWebSecurityOrigin&)
	{61, 321, 194, 1, 0, 214, 9},	//305 QWebSecurityOrigin::operator=(const QWebSecurityOrigin&)
	{61, 126, 0, 0, Smoke::mf_static, 79, 10},	//306 QWebSecurityOrigin::allOrigins()
	{62, 104, 0, 0, Smoke::mf_static|Smoke::mf_enum, 217, 1},	//307 QWebSettings::StandardFont (enum)
	{62, 24, 0, 0, Smoke::mf_static|Smoke::mf_enum, 217, 2},	//308 QWebSettings::FixedFont (enum)
	{62, 100, 0, 0, Smoke::mf_static|Smoke::mf_enum, 217, 3},	//309 QWebSettings::SerifFont (enum)
	{62, 86, 0, 0, Smoke::mf_static|Smoke::mf_enum, 217, 4},	//310 QWebSettings::SansSerifFont (enum)
	{62, 7, 0, 0, Smoke::mf_static|Smoke::mf_enum, 217, 5},	//311 QWebSettings::CursiveFont (enum)
	{62, 20, 0, 0, Smoke::mf_static|Smoke::mf_enum, 217, 6},	//312 QWebSettings::FantasyFont (enum)
	{62, 1, 0, 0, Smoke::mf_static|Smoke::mf_enum, 219, 7},	//313 QWebSettings::AutoLoadImages (enum)
	{62, 32, 0, 0, Smoke::mf_static|Smoke::mf_enum, 219, 8},	//314 QWebSettings::JavascriptEnabled (enum)
	{62, 29, 0, 0, Smoke::mf_static|Smoke::mf_enum, 219, 9},	//315 QWebSettings::JavaEnabled (enum)
	{62, 65, 0, 0, Smoke::mf_static|Smoke::mf_enum, 219, 10},	//316 QWebSettings::PluginsEnabled (enum)
	{62, 67, 0, 0, Smoke::mf_static|Smoke::mf_enum, 219, 11},	//317 QWebSettings::PrivateBrowsingEnabled (enum)
	{62, 31, 0, 0, Smoke::mf_static|Smoke::mf_enum, 219, 12},	//318 QWebSettings::JavascriptCanOpenWindows (enum)
	{62, 30, 0, 0, Smoke::mf_static|Smoke::mf_enum, 219, 13},	//319 QWebSettings::JavascriptCanAccessClipboard (enum)
	{62, 16, 0, 0, Smoke::mf_static|Smoke::mf_enum, 219, 14},	//320 QWebSettings::DeveloperExtrasEnabled (enum)
	{62, 33, 0, 0, Smoke::mf_static|Smoke::mf_enum, 219, 15},	//321 QWebSettings::LinksIncludedInFocusChain (enum)
	{62, 114, 0, 0, Smoke::mf_static|Smoke::mf_enum, 219, 16},	//322 QWebSettings::ZoomTextOnly (enum)
	{62, 66, 0, 0, Smoke::mf_static|Smoke::mf_enum, 219, 17},	//323 QWebSettings::PrintElementBackgrounds (enum)
	{62, 58, 0, 0, Smoke::mf_static|Smoke::mf_enum, 219, 18},	//324 QWebSettings::OfflineStorageDatabaseEnabled (enum)
	{62, 59, 0, 0, Smoke::mf_static|Smoke::mf_enum, 219, 19},	//325 QWebSettings::OfflineWebApplicationCacheEnabled (enum)
	{62, 34, 0, 0, Smoke::mf_static|Smoke::mf_enum, 219, 20},	//326 QWebSettings::LocalStorageDatabaseEnabled (enum)
	{62, 37, 0, 0, Smoke::mf_static|Smoke::mf_enum, 220, 21},	//327 QWebSettings::MissingImageGraphic (enum)
	{62, 38, 0, 0, Smoke::mf_static|Smoke::mf_enum, 220, 22},	//328 QWebSettings::MissingPluginGraphic (enum)
	{62, 11, 0, 0, Smoke::mf_static|Smoke::mf_enum, 220, 23},	//329 QWebSettings::DefaultFrameIconGraphic (enum)
	{62, 106, 0, 0, Smoke::mf_static|Smoke::mf_enum, 220, 24},	//330 QWebSettings::TextAreaSizeGripCornerGraphic (enum)
	{62, 35, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 25},	//331 QWebSettings::MinimumFontSize (enum)
	{62, 36, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 26},	//332 QWebSettings::MinimumLogicalFontSize (enum)
	{62, 10, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 27},	//333 QWebSettings::DefaultFontSize (enum)
	{62, 9, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 28},	//334 QWebSettings::DefaultFixedFontSize (enum)
	{62, 398, 92, 2, 0, 0, 29},	//335 QWebSettings::setFontFamily(QWebSettings::FontFamily, const QString&)
	{62, 213, 90, 1, Smoke::mf_const, 137, 30},	//336 QWebSettings::fontFamily(QWebSettings::FontFamily) const
	{62, 359, 90, 1, 0, 0, 31},	//337 QWebSettings::resetFontFamily(QWebSettings::FontFamily)
	{62, 400, 97, 2, 0, 0, 32},	//338 QWebSettings::setFontSize(QWebSettings::FontSize, int)
	{62, 215, 95, 1, Smoke::mf_const, 352, 33},	//339 QWebSettings::fontSize(QWebSettings::FontSize) const
	{62, 361, 95, 1, 0, 0, 34},	//340 QWebSettings::resetFontSize(QWebSettings::FontSize)
	{62, 386, 102, 2, 0, 0, 35},	//341 QWebSettings::setAttribute(QWebSettings::WebAttribute, bool)
	{62, 472, 100, 1, Smoke::mf_const, 318, 36},	//342 QWebSettings::testAttribute(QWebSettings::WebAttribute) const
	{62, 357, 100, 1, 0, 0, 37},	//343 QWebSettings::resetAttribute(QWebSettings::WebAttribute)
	{62, 441, 182, 1, 0, 0, 38},	//344 QWebSettings::setUserStyleSheetUrl(const QUrl&)
	{62, 505, 0, 0, Smoke::mf_const, 184, 39},	//345 QWebSettings::userStyleSheetUrl() const
	{62, 229, 0, 0, Smoke::mf_static, 216, 40},	//346 QWebSettings::globalSettings()
	{62, 407, 154, 1, Smoke::mf_static, 0, 41},	//347 QWebSettings::setIconDatabasePath(const QString&)
	{62, 244, 0, 0, Smoke::mf_static, 137, 42},	//348 QWebSettings::iconDatabasePath()
	{62, 144, 0, 0, Smoke::mf_static, 0, 43},	//349 QWebSettings::clearIconDatabase()
	{62, 245, 182, 1, Smoke::mf_static, 66, 44},	//350 QWebSettings::iconForUrl(const QUrl&)
	{62, 449, 107, 2, Smoke::mf_static, 0, 45},	//351 QWebSettings::setWebGraphic(QWebSettings::WebGraphic, const QPixmap&)
	{62, 508, 105, 1, Smoke::mf_static, 123, 46},	//352 QWebSettings::webGraphic(QWebSettings::WebGraphic)
	{62, 413, 201, 1, Smoke::mf_static, 0, 47},	//353 QWebSettings::setMaximumPagesInCache(int)
	{62, 298, 0, 0, Smoke::mf_static, 352, 48},	//354 QWebSettings::maximumPagesInCache()
	{62, 417, 210, 3, Smoke::mf_static, 0, 49},	//355 QWebSettings::setObjectCacheCapacities(int, int, int)
	{62, 421, 154, 1, Smoke::mf_static, 0, 50},	//356 QWebSettings::setOfflineStoragePath(const QString&)
	{62, 320, 0, 0, Smoke::mf_static, 137, 51},	//357 QWebSettings::offlineStoragePath()
	{62, 419, 214, 1, Smoke::mf_static, 0, 52},	//358 QWebSettings::setOfflineStorageDefaultQuota(qint64)
	{62, 319, 0, 0, Smoke::mf_static, 353, 53},	//359 QWebSettings::offlineStorageDefaultQuota()
	{63, 302, 0, 0, Smoke::mf_const, 325, 2},	//360 QWebView::metaObject() const
	{63, 345, 234, 3, 0, 352, 3},	//361 QWebView::qt_metacall(QMetaObject::Call, int, void**)
	{63, 82, 112, 1, Smoke::mf_ctor, 221, 4},	//362 QWebView::QWebView(QWidget*)
	{63, 82, 0, 0, Smoke::mf_ctor, 221, 5},	//363 QWebView::QWebView()
	{63, 523, 0, 0, Smoke::mf_dtor, 0, 73},	//364 QWebView::~QWebView()
	{63, 325, 0, 0, Smoke::mf_const, 200, 6},	//365 QWebView::page() const
	{63, 423, 59, 1, 0, 0, 7},	//366 QWebView::setPage(QWebPage*)
	{63, 287, 182, 1, 0, 0, 8},	//367 QWebView::load(const QUrl&)
	{63, 287, 142, 3, 0, 0, 9},	//368 QWebView::load(const QNetworkRequest&, QNetworkAccessManager::Operation, const QByteArray&)
	{63, 287, 139, 2, 0, 0, 10},	//369 QWebView::load(const QNetworkRequest&, QNetworkAccessManager::Operation)
	{63, 287, 137, 1, 0, 0, 11},	//370 QWebView::load(const QNetworkRequest&)
	{63, 404, 170, 2, 0, 0, 12},	//371 QWebView::setHtml(const QString&, const QUrl&)
	{63, 404, 154, 1, 0, 0, 13},	//372 QWebView::setHtml(const QString&)
	{63, 388, 131, 3, 0, 0, 14},	//373 QWebView::setContent(const QByteArray&, const QString&, const QUrl&)
	{63, 388, 128, 2, 0, 0, 15},	//374 QWebView::setContent(const QByteArray&, const QString&)
	{63, 388, 126, 1, 0, 0, 16},	//375 QWebView::setContent(const QByteArray&)
	{63, 236, 0, 0, Smoke::mf_const, 192, 17},	//376 QWebView::history() const
	{63, 453, 0, 0, Smoke::mf_const, 216, 18},	//377 QWebView::settings() const
	{63, 477, 0, 0, Smoke::mf_const, 137, 19},	//378 QWebView::title() const
	{63, 437, 182, 1, 0, 0, 20},	//379 QWebView::setUrl(const QUrl&)
	{63, 499, 0, 0, Smoke::mf_const, 184, 21},	//380 QWebView::url() const
	{63, 242, 0, 0, Smoke::mf_const, 66, 22},	//381 QWebView::icon() const
	{63, 384, 0, 0, Smoke::mf_const, 137, 23},	//382 QWebView::selectedText() const
	{63, 326, 72, 1, Smoke::mf_const, 13, 24},	//383 QWebView::pageAction(QWebPage::WebAction) const
	{63, 491, 74, 2, 0, 0, 25},	//384 QWebView::triggerPageAction(QWebPage::WebAction, bool)
	{63, 491, 72, 1, 0, 0, 26},	//385 QWebView::triggerPageAction(QWebPage::WebAction)
	{63, 255, 0, 0, Smoke::mf_const, 318, 27},	//386 QWebView::isModified() const
	{63, 251, 114, 1, Smoke::mf_const, 188, 28},	//387 QWebView::inputMethodQuery(Qt::InputMethodQuery) const
	{63, 457, 0, 0, Smoke::mf_const, 132, 29},	//388 QWebView::sizeHint() const
	{63, 515, 0, 0, Smoke::mf_const, 354, 30},	//389 QWebView::zoomFactor() const
	{63, 451, 216, 1, 0, 0, 31},	//390 QWebView::setZoomFactor(qreal)
	{63, 435, 216, 1, 0, 0, 32},	//391 QWebView::setTextSizeMultiplier(qreal)
	{63, 474, 0, 0, Smoke::mf_const, 354, 33},	//392 QWebView::textSizeMultiplier() const
	{63, 202, 163, 2, 0, 318, 34},	//393 QWebView::findText(const QString&, QWebPage::FindFlags)
	{63, 202, 154, 1, 0, 318, 35},	//394 QWebView::findText(const QString&)
	{63, 192, 224, 1, 0, 318, 36},	//395 QWebView::event(QEvent*)
	{63, 463, 0, 0, 0, 0, 37},	//396 QWebView::stop()
	{63, 128, 0, 0, 0, 0, 38},	//397 QWebView::back()
	{63, 217, 0, 0, 0, 0, 39},	//398 QWebView::forward()
	{63, 348, 0, 0, 0, 0, 40},	//399 QWebView::reload()
	{63, 340, 17, 1, Smoke::mf_const, 0, 41},	//400 QWebView::print(QPrinter*) const
	{63, 295, 0, 0, 0, 0, 42},	//401 QWebView::loadStarted()
	{63, 293, 201, 1, 0, 0, 43},	//402 QWebView::loadProgress(int)
	{63, 291, 124, 1, 0, 0, 44},	//403 QWebView::loadFinished(bool)
	{63, 478, 154, 1, 0, 0, 45},	//404 QWebView::titleChanged(const QString&)
	{63, 459, 154, 1, 0, 0, 46},	//405 QWebView::statusBarMessage(const QString&)
	{63, 278, 182, 1, 0, 0, 47},	//406 QWebView::linkClicked(const QUrl&)
	{63, 385, 0, 0, 0, 0, 48},	//407 QWebView::selectionChanged()
	{63, 243, 0, 0, 0, 0, 49},	//408 QWebView::iconChanged()
	{63, 500, 182, 1, 0, 0, 50},	//409 QWebView::urlChanged(const QUrl&)
	{63, 485, 198, 2, Smoke::mf_static, 137, 51},	//410 QWebView::tr(const char*, const char*)
	{63, 485, 196, 1, Smoke::mf_static, 137, 52},	//411 QWebView::tr(const char*)
	{63, 458, 0, 0, Smoke::mf_static, 324, 1},	//412 QWebView::staticMetaObject (static var)
	{63, 363, 19, 1, Smoke::mf_protected, 0, 53},	//413 QWebView::resizeEvent(QResizeEvent*)
	{63, 329, 10, 1, Smoke::mf_protected, 0, 54},	//414 QWebView::paintEvent(QPaintEvent*)
	{63, 159, 77, 1, Smoke::mf_protected, 221, 55},	//415 QWebView::createWindow(QWebPage::WebWindowType)
	{63, 136, 224, 1, Smoke::mf_protected, 0, 56},	//416 QWebView::changeEvent(QEvent*)
	{63, 309, 238, 1, Smoke::mf_protected, 0, 57},	//417 QWebView::mouseMoveEvent(QMouseEvent*)
	{63, 311, 238, 1, Smoke::mf_protected, 0, 58},	//418 QWebView::mousePressEvent(QMouseEvent*)
	{63, 307, 238, 1, Smoke::mf_protected, 0, 59},	//419 QWebView::mouseDoubleClickEvent(QMouseEvent*)
	{63, 313, 238, 1, Smoke::mf_protected, 0, 60},	//420 QWebView::mouseReleaseEvent(QMouseEvent*)
	{63, 151, 35, 1, Smoke::mf_protected, 0, 61},	//421 QWebView::contextMenuEvent(QContextMenuEvent*)
	{63, 510, 110, 1, Smoke::mf_protected, 0, 62},	//422 QWebView::wheelEvent(QWheelEvent*)
	{63, 270, 232, 1, Smoke::mf_protected, 0, 63},	//423 QWebView::keyPressEvent(QKeyEvent*)
	{63, 272, 232, 1, Smoke::mf_protected, 0, 64},	//424 QWebView::keyReleaseEvent(QKeyEvent*)
	{63, 178, 192, 1, Smoke::mf_protected, 0, 65},	//425 QWebView::dragEnterEvent(QDragEnterEvent*)
	{63, 180, 218, 1, Smoke::mf_protected, 0, 66},	//426 QWebView::dragLeaveEvent(QDragLeaveEvent*)
	{63, 182, 220, 1, Smoke::mf_protected, 0, 67},	//427 QWebView::dragMoveEvent(QDragMoveEvent*)
	{63, 184, 222, 1, Smoke::mf_protected, 0, 68},	//428 QWebView::dropEvent(QDropEvent*)
	{63, 205, 226, 1, Smoke::mf_protected, 0, 69},	//429 QWebView::focusInEvent(QFocusEvent*)
	{63, 209, 226, 1, Smoke::mf_protected, 0, 70},	//430 QWebView::focusOutEvent(QFocusEvent*)
	{63, 249, 230, 1, Smoke::mf_protected, 0, 71},	//431 QWebView::inputMethodEvent(QInputMethodEvent*)
	{63, 207, 124, 1, Smoke::mf_protected, 318, 72},	//432 QWebView::focusNextPrevChild(bool)
	{65, 302, 0, 0, Smoke::mf_const, 325, 5},	//433 QWidget::metaObject() const
	{65, 345, 234, 3, 0, 352, 6},	//434 QWidget::qt_metacall(QMetaObject::Call, int, void**)
	{65, 457, 0, 0, Smoke::mf_const, 132, 181},	//435 QWidget::sizeHint() const
	{65, 306, 0, 0, Smoke::mf_const, 132, 182},	//436 QWidget::minimumSizeHint() const
	{65, 232, 201, 1, Smoke::mf_const, 352, 186},	//437 QWidget::heightForWidth(int) const
	{65, 251, 114, 1, Smoke::mf_const, 188, 227},	//438 QWidget::inputMethodQuery(Qt::InputMethodQuery) const
	{65, 447, 124, 1, 0, 0, 236},	//439 QWidget::setVisible(bool)
	{65, 311, 238, 1, Smoke::mf_protected, 0, 256},	//440 QWidget::mousePressEvent(QMouseEvent*)
	{65, 313, 238, 1, Smoke::mf_protected, 0, 257},	//441 QWidget::mouseReleaseEvent(QMouseEvent*)
	{65, 307, 238, 1, Smoke::mf_protected, 0, 258},	//442 QWidget::mouseDoubleClickEvent(QMouseEvent*)
	{65, 309, 238, 1, Smoke::mf_protected, 0, 259},	//443 QWidget::mouseMoveEvent(QMouseEvent*)
	{65, 510, 110, 1, Smoke::mf_protected, 0, 260},	//444 QWidget::wheelEvent(QWheelEvent*)
	{65, 270, 232, 1, Smoke::mf_protected, 0, 261},	//445 QWidget::keyPressEvent(QKeyEvent*)
	{65, 272, 232, 1, Smoke::mf_protected, 0, 262},	//446 QWidget::keyReleaseEvent(QKeyEvent*)
	{65, 205, 226, 1, Smoke::mf_protected, 0, 263},	//447 QWidget::focusInEvent(QFocusEvent*)
	{65, 209, 226, 1, Smoke::mf_protected, 0, 264},	//448 QWidget::focusOutEvent(QFocusEvent*)
	{65, 188, 224, 1, Smoke::mf_protected, 0, 265},	//449 QWidget::enterEvent(QEvent*)
	{65, 276, 224, 1, Smoke::mf_protected, 0, 266},	//450 QWidget::leaveEvent(QEvent*)
	{65, 329, 10, 1, Smoke::mf_protected, 0, 267},	//451 QWidget::paintEvent(QPaintEvent*)
	{65, 315, 240, 1, Smoke::mf_protected, 0, 268},	//452 QWidget::moveEvent(QMoveEvent*)
	{65, 363, 19, 1, Smoke::mf_protected, 0, 269},	//453 QWidget::resizeEvent(QResizeEvent*)
	{65, 145, 29, 1, Smoke::mf_protected, 0, 270},	//454 QWidget::closeEvent(QCloseEvent*)
	{65, 151, 35, 1, Smoke::mf_protected, 0, 271},	//455 QWidget::contextMenuEvent(QContextMenuEvent*)
	{65, 470, 31, 1, Smoke::mf_protected, 0, 272},	//456 QWidget::tabletEvent(QTabletEvent*)
	{65, 119, 23, 1, Smoke::mf_protected, 0, 273},	//457 QWidget::actionEvent(QActionEvent*)
	{65, 178, 192, 1, Smoke::mf_protected, 0, 274},	//458 QWidget::dragEnterEvent(QDragEnterEvent*)
	{65, 182, 220, 1, Smoke::mf_protected, 0, 275},	//459 QWidget::dragMoveEvent(QDragMoveEvent*)
	{65, 180, 218, 1, Smoke::mf_protected, 0, 276},	//460 QWidget::dragLeaveEvent(QDragLeaveEvent*)
	{65, 184, 222, 1, Smoke::mf_protected, 0, 277},	//461 QWidget::dropEvent(QDropEvent*)
	{65, 454, 21, 1, Smoke::mf_protected, 0, 278},	//462 QWidget::showEvent(QShowEvent*)
	{65, 234, 228, 1, Smoke::mf_protected, 0, 279},	//463 QWidget::hideEvent(QHideEvent*)
	{65, 136, 224, 1, Smoke::mf_protected, 0, 280},	//464 QWidget::changeEvent(QEvent*)
	{65, 249, 230, 1, Smoke::mf_protected, 0, 282},	//465 QWidget::inputMethodEvent(QInputMethodEvent*)
	{65, 207, 124, 1, Smoke::mf_protected, 318, 291},	//466 QWidget::focusNextPrevChild(bool)
	{65, 464, 25, 1, Smoke::mf_protected, 0, 294},	//467 QWidget::styleChange(QStyle&)
	{65, 186, 124, 1, Smoke::mf_protected, 0, 295},	//468 QWidget::enabledChange(bool)
	{65, 332, 146, 1, Smoke::mf_protected, 0, 296},	//469 QWidget::paletteChange(const QPalette&)
	{65, 211, 135, 1, Smoke::mf_protected, 0, 297},	//470 QWidget::fontChange(const QFont&)
	{65, 512, 124, 1, Smoke::mf_protected, 0, 298},	//471 QWidget::windowActivationChange(bool)
	{65, 274, 0, 0, Smoke::mf_protected, 0, 299},	//472 QWidget::languageChange()
};

// Class ID, munged name ID (index into methodNames), method def (see methods) if >0 or number of overloads if <0
static Smoke::MethodMap qtwebkit_methodMaps[] = {
	{ 0, 0, 0 },	//0 (no method)
	{53, 69, 12},	//1 QWebDatabase::QWebDatabase#
	{53, 175, 16},	//2 QWebDatabase::displayName
	{53, 196, 17},	//3 QWebDatabase::expectedSize
	{53, 201, 19},	//4 QWebDatabase::fileName
	{53, 317, 15},	//5 QWebDatabase::name
	{53, 322, 13},	//6 QWebDatabase::operator=#
	{53, 323, 20},	//7 QWebDatabase::origin
	{53, 350, 21},	//8 QWebDatabase::removeDatabase#
	{53, 456, 18},	//9 QWebDatabase::size
	{53, 516, 14},	//10 QWebDatabase::~QWebDatabase
	{54, 124, 34},	//11 QWebFrame::addToJavaScriptWindowObject$#
	{54, 125, 35},	//12 QWebFrame::addToJavaScriptWindowObject$#?
	{54, 140, 46},	//13 QWebFrame::childFrames
	{54, 150, 64},	//14 QWebFrame::contentsSize
	{54, 191, 68},	//15 QWebFrame::evaluateJavaScript$
	{54, 193, 66},	//16 QWebFrame::event#
	{54, 225, 44},	//17 QWebFrame::frameName
	{54, 226, 63},	//18 QWebFrame::geometry
	{54, 240, 65},	//19 QWebFrame::hitTestContent#
	{54, 242, 42},	//20 QWebFrame::icon
	{54, 288, -1},	//21 QWebFrame::load#
	{54, 289, 27},	//22 QWebFrame::load#$
	{54, 290, 26},	//23 QWebFrame::load#$#
	{54, 301, 43},	//24 QWebFrame::metaData
	{54, 302, 22},	//25 QWebFrame::metaObject
	{54, 325, 24},	//26 QWebFrame::page
	{54, 334, 45},	//27 QWebFrame::parentFrame
	{54, 339, 62},	//28 QWebFrame::pos
	{54, 341, 69},	//29 QWebFrame::print#
	{54, 346, 23},	//30 QWebFrame::qt_metacall$$?
	{54, 352, 57},	//31 QWebFrame::render#
	{54, 353, 56},	//32 QWebFrame::render##
	{54, 354, 38},	//33 QWebFrame::renderTreeDump
	{54, 371, 53},	//34 QWebFrame::scroll$$
	{54, 373, 52},	//35 QWebFrame::scrollBarMaximum$
	{54, 375, 51},	//36 QWebFrame::scrollBarMinimum$
	{54, 377, 47},	//37 QWebFrame::scrollBarPolicy$
	{54, 379, 50},	//38 QWebFrame::scrollBarValue$
	{54, 380, 54},	//39 QWebFrame::scrollPosition
	{54, 383, 67},	//40 QWebFrame::securityOrigin
	{54, 389, 33},	//41 QWebFrame::setContent#
	{54, 390, 32},	//42 QWebFrame::setContent#$
	{54, 391, 31},	//43 QWebFrame::setContent#$#
	{54, 405, 30},	//44 QWebFrame::setHtml$
	{54, 406, 29},	//45 QWebFrame::setHtml$#
	{54, 430, 48},	//46 QWebFrame::setScrollBarPolicy$$
	{54, 432, 49},	//47 QWebFrame::setScrollBarValue$$
	{54, 434, 55},	//48 QWebFrame::setScrollPosition#
	{54, 436, 58},	//49 QWebFrame::setTextSizeMultiplier$
	{54, 438, 40},	//50 QWebFrame::setUrl#
	{54, 452, 61},	//51 QWebFrame::setZoomFactor$
	{54, 458, 72},	//52 QWebFrame::staticMetaObject
	{54, 474, 59},	//53 QWebFrame::textSizeMultiplier
	{54, 477, 39},	//54 QWebFrame::title
	{54, 480, 36},	//55 QWebFrame::toHtml
	{54, 481, 37},	//56 QWebFrame::toPlainText
	{54, 486, 71},	//57 QWebFrame::tr$
	{54, 487, 70},	//58 QWebFrame::tr$$
	{54, 499, 41},	//59 QWebFrame::url
	{54, 515, 60},	//60 QWebFrame::zoomFactor
	{55, 128, 79},	//61 QWebHistory::back
	{55, 129, 82},	//62 QWebHistory::backItem
	{55, 131, 75},	//63 QWebHistory::backItems$
	{55, 134, 77},	//64 QWebHistory::canGoBack
	{55, 135, 78},	//65 QWebHistory::canGoForward
	{55, 143, 73},	//66 QWebHistory::clear
	{55, 153, 87},	//67 QWebHistory::count
	{55, 162, 83},	//68 QWebHistory::currentItem
	{55, 163, 86},	//69 QWebHistory::currentItemIndex
	{55, 217, 80},	//70 QWebHistory::forward
	{55, 218, 84},	//71 QWebHistory::forwardItem
	{55, 220, 76},	//72 QWebHistory::forwardItems$
	{55, 231, 81},	//73 QWebHistory::goToItem#
	{55, 259, 85},	//74 QWebHistory::itemAt$
	{55, 260, 74},	//75 QWebHistory::items
	{55, 297, 88},	//76 QWebHistory::maximumItemCount
	{55, 412, 89},	//77 QWebHistory::setMaximumItemCount$
	{56, 70, 93},	//78 QWebHistoryInterface::QWebHistoryInterface
	{56, 71, 92},	//79 QWebHistoryInterface::QWebHistoryInterface#
	{56, 122, 96},	//80 QWebHistoryInterface::addHistoryEntry$
	{56, 171, 100},	//81 QWebHistoryInterface::defaultInterface
	{56, 238, 95},	//82 QWebHistoryInterface::historyContains$
	{56, 302, 90},	//83 QWebHistoryInterface::metaObject
	{56, 346, 91},	//84 QWebHistoryInterface::qt_metacall$$?
	{56, 397, 99},	//85 QWebHistoryInterface::setDefaultInterface#
	{56, 458, 101},	//86 QWebHistoryInterface::staticMetaObject
	{56, 486, 98},	//87 QWebHistoryInterface::tr$
	{56, 487, 97},	//88 QWebHistoryInterface::tr$$
	{56, 517, 94},	//89 QWebHistoryInterface::~QWebHistoryInterface
	{57, 73, 102},	//90 QWebHistoryItem::QWebHistoryItem#
	{57, 242, 109},	//91 QWebHistoryItem::icon
	{57, 257, 112},	//92 QWebHistoryItem::isValid
	{57, 275, 108},	//93 QWebHistoryItem::lastVisited
	{57, 322, 103},	//94 QWebHistoryItem::operator=#
	{57, 324, 105},	//95 QWebHistoryItem::originalUrl
	{57, 440, 111},	//96 QWebHistoryItem::setUserData#
	{57, 477, 107},	//97 QWebHistoryItem::title
	{57, 499, 106},	//98 QWebHistoryItem::url
	{57, 504, 110},	//99 QWebHistoryItem::userData
	{57, 518, 104},	//100 QWebHistoryItem::~QWebHistoryItem
	{58, 74, 113},	//101 QWebHitTestResult::QWebHitTestResult
	{58, 75, 114},	//102 QWebHitTestResult::QWebHitTestResult#
	{58, 127, 125},	//103 QWebHitTestResult::alternateText
	{58, 132, 119},	//104 QWebHitTestResult::boundingRect
	{58, 222, 130},	//105 QWebHitTestResult::frame
	{58, 247, 126},	//106 QWebHitTestResult::imageUrl
	{58, 253, 128},	//107 QWebHitTestResult::isContentEditable
	{58, 254, 129},	//108 QWebHitTestResult::isContentSelected
	{58, 256, 117},	//109 QWebHitTestResult::isNull
	{58, 283, 124},	//110 QWebHitTestResult::linkTargetFrame
	{58, 284, 121},	//111 QWebHitTestResult::linkText
	{58, 285, 123},	//112 QWebHitTestResult::linkTitle
	{58, 286, 122},	//113 QWebHitTestResult::linkUrl
	{58, 322, 115},	//114 QWebHitTestResult::operator=#
	{58, 335, 127},	//115 QWebHitTestResult::pixmap
	{58, 339, 118},	//116 QWebHitTestResult::pos
	{58, 477, 120},	//117 QWebHitTestResult::title
	{58, 519, 116},	//118 QWebHitTestResult::~QWebHitTestResult
	{59, 2, 146},	//119 QWebPage::Back
	{59, 3, 200},	//120 QWebPage::ChooseMultipleFilesExtension
	{59, 4, 151},	//121 QWebPage::Copy
	{59, 5, 145},	//122 QWebPage::CopyImageToClipboard
	{59, 6, 142},	//123 QWebPage::CopyLinkToClipboard
	{59, 8, 150},	//124 QWebPage::Cut
	{59, 12, 197},	//125 QWebPage::DelegateAllLinks
	{59, 13, 196},	//126 QWebPage::DelegateExternalLinks
	{59, 14, 180},	//127 QWebPage::DeleteEndOfWord
	{59, 15, 179},	//128 QWebPage::DeleteStartOfWord
	{59, 17, 195},	//129 QWebPage::DontDelegateLinks
	{59, 18, 144},	//130 QWebPage::DownloadImageToDisk
	{59, 19, 141},	//131 QWebPage::DownloadLinkToDisk
	{59, 21, 192},	//132 QWebPage::FindBackward
	{59, 22, 193},	//133 QWebPage::FindCaseSensitively
	{59, 23, 194},	//134 QWebPage::FindWrapsAroundDocument
	{59, 25, 147},	//135 QWebPage::Forward
	{59, 26, 189},	//136 QWebPage::InsertLineSeparator
	{59, 27, 188},	//137 QWebPage::InsertParagraphSeparator
	{59, 28, 187},	//138 QWebPage::InspectElement
	{59, 39, 164},	//139 QWebPage::MoveToEndOfBlock
	{59, 40, 166},	//140 QWebPage::MoveToEndOfDocument
	{59, 41, 162},	//141 QWebPage::MoveToEndOfLine
	{59, 42, 155},	//142 QWebPage::MoveToNextChar
	{59, 43, 159},	//143 QWebPage::MoveToNextLine
	{59, 44, 157},	//144 QWebPage::MoveToNextWord
	{59, 45, 156},	//145 QWebPage::MoveToPreviousChar
	{59, 46, 160},	//146 QWebPage::MoveToPreviousLine
	{59, 47, 158},	//147 QWebPage::MoveToPreviousWord
	{59, 48, 163},	//148 QWebPage::MoveToStartOfBlock
	{59, 49, 165},	//149 QWebPage::MoveToStartOfDocument
	{59, 50, 161},	//150 QWebPage::MoveToStartOfLine
	{59, 51, 133},	//151 QWebPage::NavigationTypeBackOrForward
	{59, 52, 135},	//152 QWebPage::NavigationTypeFormResubmitted
	{59, 53, 132},	//153 QWebPage::NavigationTypeFormSubmitted
	{59, 54, 131},	//154 QWebPage::NavigationTypeLinkClicked
	{59, 55, 136},	//155 QWebPage::NavigationTypeOther
	{59, 56, 134},	//156 QWebPage::NavigationTypeReload
	{59, 57, 137},	//157 QWebPage::NoWebAction
	{59, 60, 140},	//158 QWebPage::OpenFrameInNewWindow
	{59, 61, 143},	//159 QWebPage::OpenImageInNewWindow
	{59, 62, 138},	//160 QWebPage::OpenLink
	{59, 63, 139},	//161 QWebPage::OpenLinkInNewWindow
	{59, 64, 152},	//162 QWebPage::Paste
	{59, 76, 204},	//163 QWebPage::QWebPage
	{59, 77, 203},	//164 QWebPage::QWebPage#
	{59, 84, 154},	//165 QWebPage::Redo
	{59, 85, 149},	//166 QWebPage::Reload
	{59, 87, 190},	//167 QWebPage::SelectAll
	{59, 88, 176},	//168 QWebPage::SelectEndOfBlock
	{59, 89, 178},	//169 QWebPage::SelectEndOfDocument
	{59, 90, 174},	//170 QWebPage::SelectEndOfLine
	{59, 91, 167},	//171 QWebPage::SelectNextChar
	{59, 92, 171},	//172 QWebPage::SelectNextLine
	{59, 93, 169},	//173 QWebPage::SelectNextWord
	{59, 94, 168},	//174 QWebPage::SelectPreviousChar
	{59, 95, 172},	//175 QWebPage::SelectPreviousLine
	{59, 96, 170},	//176 QWebPage::SelectPreviousWord
	{59, 97, 175},	//177 QWebPage::SelectStartOfBlock
	{59, 98, 177},	//178 QWebPage::SelectStartOfDocument
	{59, 99, 173},	//179 QWebPage::SelectStartOfLine
	{59, 101, 181},	//180 QWebPage::SetTextDirectionDefault
	{59, 102, 182},	//181 QWebPage::SetTextDirectionLeftToRight
	{59, 103, 183},	//182 QWebPage::SetTextDirectionRightToLeft
	{59, 105, 148},	//183 QWebPage::Stop
	{59, 107, 184},	//184 QWebPage::ToggleBold
	{59, 108, 185},	//185 QWebPage::ToggleItalic
	{59, 109, 186},	//186 QWebPage::ToggleUnderline
	{59, 110, 153},	//187 QWebPage::Undo
	{59, 111, 191},	//188 QWebPage::WebActionCount
	{59, 112, 198},	//189 QWebPage::WebBrowserWindow
	{59, 113, 199},	//190 QWebPage::WebModalDialog
	{59, 116, 274},	//191 QWebPage::acceptNavigationRequest##$
	{59, 118, 221},	//192 QWebPage::action$
	{59, 133, 219},	//193 QWebPage::bytesReceived
	{59, 142, 275},	//194 QWebPage::chooseFile#$
	{59, 149, 265},	//195 QWebPage::contentsChanged
	{59, 157, 273},	//196 QWebPage::createPlugin$#??
	{59, 158, 241},	//197 QWebPage::createStandardContextMenu
	{59, 160, 272},	//198 QWebPage::createWindow$
	{59, 161, 207},	//199 QWebPage::currentFrame
	{59, 168, 266},	//200 QWebPage::databaseQuotaExceeded#$
	{59, 177, 263},	//201 QWebPage::downloadRequested#
	{59, 193, 226},	//202 QWebPage::event#
	{59, 198, 244},	//203 QWebPage::extension$
	{59, 199, 243},	//204 QWebPage::extension$?
	{59, 200, 242},	//205 QWebPage::extension$??
	{59, 203, 230},	//206 QWebPage::findText$
	{59, 204, 229},	//207 QWebPage::findText$$
	{59, 208, 227},	//208 QWebPage::focusNextPrevChild$
	{59, 221, 232},	//209 QWebPage::forwardUnsupportedContent
	{59, 224, 252},	//210 QWebPage::frameCreated#
	{59, 228, 253},	//211 QWebPage::geometryChangeRequested#
	{59, 236, 208},	//212 QWebPage::history
	{59, 252, 228},	//213 QWebPage::inputMethodQuery$
	{59, 253, 238},	//214 QWebPage::isContentEditable
	{59, 255, 212},	//215 QWebPage::isModified
	{59, 262, 276},	//216 QWebPage::javaScriptAlert#$
	{59, 264, 277},	//217 QWebPage::javaScriptConfirm#$
	{59, 266, 279},	//218 QWebPage::javaScriptConsoleMessage$$$
	{59, 268, 278},	//219 QWebPage::javaScriptPrompt#$$$
	{59, 279, 258},	//220 QWebPage::linkClicked#
	{59, 280, 234},	//221 QWebPage::linkDelegationPolicy
	{59, 282, 249},	//222 QWebPage::linkHovered$$$
	{59, 292, 248},	//223 QWebPage::loadFinished$
	{59, 294, 247},	//224 QWebPage::loadProgress$
	{59, 295, 246},	//225 QWebPage::loadStarted
	{59, 296, 206},	//226 QWebPage::mainFrame
	{59, 300, 261},	//227 QWebPage::menuBarVisibilityChangeRequested$
	{59, 302, 201},	//228 QWebPage::metaObject
	{59, 305, 264},	//229 QWebPage::microFocusChanged
	{59, 318, 215},	//230 QWebPage::networkAccessManager
	{59, 331, 236},	//231 QWebPage::palette
	{59, 336, 217},	//232 QWebPage::pluginFactory
	{59, 343, 257},	//233 QWebPage::printRequested#
	{59, 346, 202},	//234 QWebPage::qt_metacall$$?
	{59, 356, 254},	//235 QWebPage::repaintRequested#
	{59, 366, 268},	//236 QWebPage::restoreFrameStateRequested#
	{59, 368, 267},	//237 QWebPage::saveFrameStateRequested##
	{59, 382, 255},	//238 QWebPage::scrollRequested$$#
	{59, 384, 220},	//239 QWebPage::selectedText
	{59, 385, 251},	//240 QWebPage::selectionChanged
	{59, 393, 237},	//241 QWebPage::setContentEditable$
	{59, 403, 231},	//242 QWebPage::setForwardUnsupportedContent$
	{59, 410, 233},	//243 QWebPage::setLinkDelegationPolicy$
	{59, 416, 214},	//244 QWebPage::setNetworkAccessManager#
	{59, 426, 235},	//245 QWebPage::setPalette#
	{59, 428, 216},	//246 QWebPage::setPluginFactory#
	{59, 444, 210},	//247 QWebPage::setView#
	{59, 446, 225},	//248 QWebPage::setViewportSize#
	{59, 453, 209},	//249 QWebPage::settings
	{59, 458, 271},	//250 QWebPage::staticMetaObject
	{59, 460, 250},	//251 QWebPage::statusBarMessage$
	{59, 462, 260},	//252 QWebPage::statusBarVisibilityChangeRequested$
	{59, 467, 245},	//253 QWebPage::supportsExtension$
	{59, 469, 239},	//254 QWebPage::swallowContextMenuEvent#
	{59, 483, 259},	//255 QWebPage::toolBarVisibilityChangeRequested$
	{59, 484, 218},	//256 QWebPage::totalBytes
	{59, 486, 270},	//257 QWebPage::tr$
	{59, 487, 269},	//258 QWebPage::tr$$
	{59, 489, 223},	//259 QWebPage::triggerAction$
	{59, 490, 222},	//260 QWebPage::triggerAction$$
	{59, 494, 213},	//261 QWebPage::undoStack
	{59, 496, 262},	//262 QWebPage::unsupportedContent#
	{59, 498, 240},	//263 QWebPage::updatePositionDependentActions#
	{59, 503, 280},	//264 QWebPage::userAgentForUrl#
	{59, 506, 211},	//265 QWebPage::view
	{59, 507, 224},	//266 QWebPage::viewportSize
	{59, 514, 256},	//267 QWebPage::windowCloseRequested
	{59, 520, 205},	//268 QWebPage::~QWebPage
	{60, 78, 284},	//269 QWebPluginFactory::QWebPluginFactory
	{60, 79, 283},	//270 QWebPluginFactory::QWebPluginFactory#
	{60, 155, 288},	//271 QWebPluginFactory::create$#??
	{60, 198, 291},	//272 QWebPluginFactory::extension$
	{60, 199, 290},	//273 QWebPluginFactory::extension$?
	{60, 200, 289},	//274 QWebPluginFactory::extension$??
	{60, 302, 281},	//275 QWebPluginFactory::metaObject
	{60, 337, 286},	//276 QWebPluginFactory::plugins
	{60, 346, 282},	//277 QWebPluginFactory::qt_metacall$$?
	{60, 347, 287},	//278 QWebPluginFactory::refreshPlugins
	{60, 458, 295},	//279 QWebPluginFactory::staticMetaObject
	{60, 467, 292},	//280 QWebPluginFactory::supportsExtension$
	{60, 486, 294},	//281 QWebPluginFactory::tr$
	{60, 487, 293},	//282 QWebPluginFactory::tr$$
	{60, 521, 285},	//283 QWebPluginFactory::~QWebPluginFactory
	{61, 81, 304},	//284 QWebSecurityOrigin::QWebSecurityOrigin#
	{61, 126, 306},	//285 QWebSecurityOrigin::allOrigins
	{61, 166, 301},	//286 QWebSecurityOrigin::databaseQuota
	{61, 169, 300},	//287 QWebSecurityOrigin::databaseUsage
	{61, 170, 303},	//288 QWebSecurityOrigin::databases
	{61, 241, 298},	//289 QWebSecurityOrigin::host
	{61, 322, 305},	//290 QWebSecurityOrigin::operator=#
	{61, 338, 299},	//291 QWebSecurityOrigin::port
	{61, 369, 297},	//292 QWebSecurityOrigin::scheme
	{61, 395, 302},	//293 QWebSecurityOrigin::setDatabaseQuota$
	{61, 522, 296},	//294 QWebSecurityOrigin::~QWebSecurityOrigin
	{62, 1, 313},	//295 QWebSettings::AutoLoadImages
	{62, 7, 311},	//296 QWebSettings::CursiveFont
	{62, 9, 334},	//297 QWebSettings::DefaultFixedFontSize
	{62, 10, 333},	//298 QWebSettings::DefaultFontSize
	{62, 11, 329},	//299 QWebSettings::DefaultFrameIconGraphic
	{62, 16, 320},	//300 QWebSettings::DeveloperExtrasEnabled
	{62, 20, 312},	//301 QWebSettings::FantasyFont
	{62, 24, 308},	//302 QWebSettings::FixedFont
	{62, 29, 315},	//303 QWebSettings::JavaEnabled
	{62, 30, 319},	//304 QWebSettings::JavascriptCanAccessClipboard
	{62, 31, 318},	//305 QWebSettings::JavascriptCanOpenWindows
	{62, 32, 314},	//306 QWebSettings::JavascriptEnabled
	{62, 33, 321},	//307 QWebSettings::LinksIncludedInFocusChain
	{62, 34, 326},	//308 QWebSettings::LocalStorageDatabaseEnabled
	{62, 35, 331},	//309 QWebSettings::MinimumFontSize
	{62, 36, 332},	//310 QWebSettings::MinimumLogicalFontSize
	{62, 37, 327},	//311 QWebSettings::MissingImageGraphic
	{62, 38, 328},	//312 QWebSettings::MissingPluginGraphic
	{62, 58, 324},	//313 QWebSettings::OfflineStorageDatabaseEnabled
	{62, 59, 325},	//314 QWebSettings::OfflineWebApplicationCacheEnabled
	{62, 65, 316},	//315 QWebSettings::PluginsEnabled
	{62, 66, 323},	//316 QWebSettings::PrintElementBackgrounds
	{62, 67, 317},	//317 QWebSettings::PrivateBrowsingEnabled
	{62, 86, 310},	//318 QWebSettings::SansSerifFont
	{62, 100, 309},	//319 QWebSettings::SerifFont
	{62, 104, 307},	//320 QWebSettings::StandardFont
	{62, 106, 330},	//321 QWebSettings::TextAreaSizeGripCornerGraphic
	{62, 114, 322},	//322 QWebSettings::ZoomTextOnly
	{62, 144, 349},	//323 QWebSettings::clearIconDatabase
	{62, 214, 336},	//324 QWebSettings::fontFamily$
	{62, 216, 339},	//325 QWebSettings::fontSize$
	{62, 229, 346},	//326 QWebSettings::globalSettings
	{62, 244, 348},	//327 QWebSettings::iconDatabasePath
	{62, 246, 350},	//328 QWebSettings::iconForUrl#
	{62, 298, 354},	//329 QWebSettings::maximumPagesInCache
	{62, 319, 359},	//330 QWebSettings::offlineStorageDefaultQuota
	{62, 320, 357},	//331 QWebSettings::offlineStoragePath
	{62, 358, 343},	//332 QWebSettings::resetAttribute$
	{62, 360, 337},	//333 QWebSettings::resetFontFamily$
	{62, 362, 340},	//334 QWebSettings::resetFontSize$
	{62, 387, 341},	//335 QWebSettings::setAttribute$$
	{62, 399, 335},	//336 QWebSettings::setFontFamily$$
	{62, 401, 338},	//337 QWebSettings::setFontSize$$
	{62, 408, 347},	//338 QWebSettings::setIconDatabasePath$
	{62, 414, 353},	//339 QWebSettings::setMaximumPagesInCache$
	{62, 418, 355},	//340 QWebSettings::setObjectCacheCapacities$$$
	{62, 420, 358},	//341 QWebSettings::setOfflineStorageDefaultQuota$
	{62, 422, 356},	//342 QWebSettings::setOfflineStoragePath$
	{62, 442, 344},	//343 QWebSettings::setUserStyleSheetUrl#
	{62, 450, 351},	//344 QWebSettings::setWebGraphic$#
	{62, 473, 342},	//345 QWebSettings::testAttribute$
	{62, 505, 345},	//346 QWebSettings::userStyleSheetUrl
	{62, 509, 352},	//347 QWebSettings::webGraphic$
	{63, 82, 363},	//348 QWebView::QWebView
	{63, 83, 362},	//349 QWebView::QWebView#
	{63, 128, 397},	//350 QWebView::back
	{63, 137, 416},	//351 QWebView::changeEvent#
	{63, 152, 421},	//352 QWebView::contextMenuEvent#
	{63, 160, 415},	//353 QWebView::createWindow$
	{63, 179, 425},	//354 QWebView::dragEnterEvent#
	{63, 181, 426},	//355 QWebView::dragLeaveEvent#
	{63, 183, 427},	//356 QWebView::dragMoveEvent#
	{63, 185, 428},	//357 QWebView::dropEvent#
	{63, 193, 395},	//358 QWebView::event#
	{63, 203, 394},	//359 QWebView::findText$
	{63, 204, 393},	//360 QWebView::findText$$
	{63, 206, 429},	//361 QWebView::focusInEvent#
	{63, 208, 432},	//362 QWebView::focusNextPrevChild$
	{63, 210, 430},	//363 QWebView::focusOutEvent#
	{63, 217, 398},	//364 QWebView::forward
	{63, 236, 376},	//365 QWebView::history
	{63, 242, 381},	//366 QWebView::icon
	{63, 243, 408},	//367 QWebView::iconChanged
	{63, 250, 431},	//368 QWebView::inputMethodEvent#
	{63, 252, 387},	//369 QWebView::inputMethodQuery$
	{63, 255, 386},	//370 QWebView::isModified
	{63, 271, 423},	//371 QWebView::keyPressEvent#
	{63, 273, 424},	//372 QWebView::keyReleaseEvent#
	{63, 279, 406},	//373 QWebView::linkClicked#
	{63, 288, -4},	//374 QWebView::load#
	{63, 289, 369},	//375 QWebView::load#$
	{63, 290, 368},	//376 QWebView::load#$#
	{63, 292, 403},	//377 QWebView::loadFinished$
	{63, 294, 402},	//378 QWebView::loadProgress$
	{63, 295, 401},	//379 QWebView::loadStarted
	{63, 302, 360},	//380 QWebView::metaObject
	{63, 308, 419},	//381 QWebView::mouseDoubleClickEvent#
	{63, 310, 417},	//382 QWebView::mouseMoveEvent#
	{63, 312, 418},	//383 QWebView::mousePressEvent#
	{63, 314, 420},	//384 QWebView::mouseReleaseEvent#
	{63, 325, 365},	//385 QWebView::page
	{63, 327, 383},	//386 QWebView::pageAction$
	{63, 330, 414},	//387 QWebView::paintEvent#
	{63, 341, 400},	//388 QWebView::print#
	{63, 346, 361},	//389 QWebView::qt_metacall$$?
	{63, 348, 399},	//390 QWebView::reload
	{63, 364, 413},	//391 QWebView::resizeEvent#
	{63, 384, 382},	//392 QWebView::selectedText
	{63, 385, 407},	//393 QWebView::selectionChanged
	{63, 389, 375},	//394 QWebView::setContent#
	{63, 390, 374},	//395 QWebView::setContent#$
	{63, 391, 373},	//396 QWebView::setContent#$#
	{63, 405, 372},	//397 QWebView::setHtml$
	{63, 406, 371},	//398 QWebView::setHtml$#
	{63, 424, 366},	//399 QWebView::setPage#
	{63, 436, 391},	//400 QWebView::setTextSizeMultiplier$
	{63, 438, 379},	//401 QWebView::setUrl#
	{63, 452, 390},	//402 QWebView::setZoomFactor$
	{63, 453, 377},	//403 QWebView::settings
	{63, 457, 388},	//404 QWebView::sizeHint
	{63, 458, 412},	//405 QWebView::staticMetaObject
	{63, 460, 405},	//406 QWebView::statusBarMessage$
	{63, 463, 396},	//407 QWebView::stop
	{63, 474, 392},	//408 QWebView::textSizeMultiplier
	{63, 477, 378},	//409 QWebView::title
	{63, 479, 404},	//410 QWebView::titleChanged$
	{63, 486, 411},	//411 QWebView::tr$
	{63, 487, 410},	//412 QWebView::tr$$
	{63, 492, 385},	//413 QWebView::triggerPageAction$
	{63, 493, 384},	//414 QWebView::triggerPageAction$$
	{63, 499, 380},	//415 QWebView::url
	{63, 501, 409},	//416 QWebView::urlChanged#
	{63, 511, 422},	//417 QWebView::wheelEvent#
	{63, 515, 389},	//418 QWebView::zoomFactor
	{63, 523, 364},	//419 QWebView::~QWebView
};

static Smoke::Index qtwebkit_ambiguousMethodList[] = {
    0,
    28,  // QWebFrame::load(const QNetworkRequest&)
    25,  // QWebFrame::load(const QUrl&)
    0,
    370,  // QWebView::load(const QNetworkRequest&)
    367,  // QWebView::load(const QUrl&)
    0,
};


void init_qt_Smoke();

static bool initialized = false;
Smoke *qtwebkit_Smoke = 0;

// Create the Smoke instance encapsulating all the above.
void init_qtwebkit_Smoke() {
    if (initialized) return;
    init_qt_Smoke();
    qtwebkit_Smoke = new Smoke(
        "qtwebkit",
        qtwebkit_classes, 66,
        qtwebkit_methods, 473,
        qtwebkit_methodMaps, 419,
        qtwebkit_methodNames, 523,
        qtwebkit_types, 356,
        qtwebkit_inheritanceList,
        qtwebkit_argumentList,
        qtwebkit_ambiguousMethodList,
        qtwebkit_cast );
    initialized = true;
}
