#include <qcoreevent.h>
#include <qobject.h>
#include <qobjectdefs.h>
#include <qvariant.h>
#include <solid/acadapter.h>
#include <solid/audiointerface.h>
#include <solid/battery.h>
#include <solid/block.h>
#include <solid/button.h>
#include <solid/camera.h>
#include <solid/device.h>
#include <solid/deviceinterface.h>
#include <solid/devicenotifier.h>
#include <solid/dvbinterface.h>
#include <solid/genericinterface.h>
#include <solid/networking.h>
#include <solid/networkinterface.h>
#include <solid/opticaldisc.h>
#include <solid/opticaldrive.h>
#include <solid/portablemediaplayer.h>
#include <solid/powermanagement.h>
#include <solid/predicate.h>
#include <solid/processor.h>
#include <solid/storageaccess.h>
#include <solid/storagedrive.h>
#include <solid/storagevolume.h>
#include <solid/video.h>

#include <smoke.h>

#include <solid_smoke.h>

static void *solid_cast(void *xptr, Smoke::Index from, Smoke::Index to) {
    switch(from) {
      case 1:	//QChildEvent
	switch(to) {
	    case 2: return (void*)(QEvent*)(QChildEvent*)xptr;
	    case 1: return (void*)(QChildEvent*)(QChildEvent*)xptr;
	  default: return xptr;
	}
      case 2:	//QEvent
	switch(to) {
	    case 2: return (void*)(QEvent*)(QEvent*)xptr;
	    case 1: return (void*)(QChildEvent*)(QEvent*)xptr;
	    case 5: return (void*)(QTimerEvent*)(QEvent*)xptr;
	  default: return xptr;
	}
      case 3:	//QMetaObject
	switch(to) {
	    case 3: return (void*)(QMetaObject*)(QMetaObject*)xptr;
	  default: return xptr;
	}
      case 4:	//QObject
	switch(to) {
	    case 4: return (void*)(QObject*)(QObject*)xptr;
	    case 8: return (void*)(Solid::AcAdapter*)(QObject*)xptr;
	    case 9: return (void*)(Solid::AudioInterface*)(QObject*)xptr;
	    case 10: return (void*)(Solid::Battery*)(QObject*)xptr;
	    case 11: return (void*)(Solid::Block*)(QObject*)xptr;
	    case 12: return (void*)(Solid::Button*)(QObject*)xptr;
	    case 13: return (void*)(Solid::Camera*)(QObject*)xptr;
	    case 15: return (void*)(Solid::DeviceInterface*)(QObject*)xptr;
	    case 16: return (void*)(Solid::DeviceNotifier*)(QObject*)xptr;
	    case 17: return (void*)(Solid::DvbInterface*)(QObject*)xptr;
	    case 18: return (void*)(Solid::GenericInterface*)(QObject*)xptr;
	    case 19: return (void*)(Solid::NetworkInterface*)(QObject*)xptr;
	    case 21: return (void*)(Solid::Networking::Notifier*)(QObject*)xptr;
	    case 22: return (void*)(Solid::OpticalDisc*)(QObject*)xptr;
	    case 23: return (void*)(Solid::OpticalDrive*)(QObject*)xptr;
	    case 24: return (void*)(Solid::PortableMediaPlayer*)(QObject*)xptr;
	    case 26: return (void*)(Solid::PowerManagement::Notifier*)(QObject*)xptr;
	    case 28: return (void*)(Solid::Processor*)(QObject*)xptr;
	    case 29: return (void*)(Solid::StorageAccess*)(QObject*)xptr;
	    case 30: return (void*)(Solid::StorageDrive*)(QObject*)xptr;
	    case 31: return (void*)(Solid::StorageVolume*)(QObject*)xptr;
	    case 32: return (void*)(Solid::Video*)(QObject*)xptr;
	  default: return xptr;
	}
      case 5:	//QTimerEvent
	switch(to) {
	    case 2: return (void*)(QEvent*)(QTimerEvent*)xptr;
	    case 5: return (void*)(QTimerEvent*)(QTimerEvent*)xptr;
	  default: return xptr;
	}
      case 6:	//QVariant
	switch(to) {
	    case 6: return (void*)(QVariant*)(QVariant*)xptr;
	  default: return xptr;
	}
      case 8:	//Solid::AcAdapter
	switch(to) {
	    case 15: return (void*)(Solid::DeviceInterface*)(Solid::AcAdapter*)xptr;
	    case 4: return (void*)(QObject*)(Solid::AcAdapter*)xptr;
	    case 8: return (void*)(Solid::AcAdapter*)(Solid::AcAdapter*)xptr;
	  default: return xptr;
	}
      case 9:	//Solid::AudioInterface
	switch(to) {
	    case 15: return (void*)(Solid::DeviceInterface*)(Solid::AudioInterface*)xptr;
	    case 4: return (void*)(QObject*)(Solid::AudioInterface*)xptr;
	    case 9: return (void*)(Solid::AudioInterface*)(Solid::AudioInterface*)xptr;
	  default: return xptr;
	}
      case 10:	//Solid::Battery
	switch(to) {
	    case 15: return (void*)(Solid::DeviceInterface*)(Solid::Battery*)xptr;
	    case 4: return (void*)(QObject*)(Solid::Battery*)xptr;
	    case 10: return (void*)(Solid::Battery*)(Solid::Battery*)xptr;
	  default: return xptr;
	}
      case 11:	//Solid::Block
	switch(to) {
	    case 15: return (void*)(Solid::DeviceInterface*)(Solid::Block*)xptr;
	    case 4: return (void*)(QObject*)(Solid::Block*)xptr;
	    case 11: return (void*)(Solid::Block*)(Solid::Block*)xptr;
	  default: return xptr;
	}
      case 12:	//Solid::Button
	switch(to) {
	    case 15: return (void*)(Solid::DeviceInterface*)(Solid::Button*)xptr;
	    case 4: return (void*)(QObject*)(Solid::Button*)xptr;
	    case 12: return (void*)(Solid::Button*)(Solid::Button*)xptr;
	  default: return xptr;
	}
      case 13:	//Solid::Camera
	switch(to) {
	    case 15: return (void*)(Solid::DeviceInterface*)(Solid::Camera*)xptr;
	    case 4: return (void*)(QObject*)(Solid::Camera*)xptr;
	    case 13: return (void*)(Solid::Camera*)(Solid::Camera*)xptr;
	  default: return xptr;
	}
      case 14:	//Solid::Device
	switch(to) {
	    case 14: return (void*)(Solid::Device*)(Solid::Device*)xptr;
	  default: return xptr;
	}
      case 15:	//Solid::DeviceInterface
	switch(to) {
	    case 4: return (void*)(QObject*)(Solid::DeviceInterface*)xptr;
	    case 15: return (void*)(Solid::DeviceInterface*)(Solid::DeviceInterface*)xptr;
	    case 8: return (void*)(Solid::AcAdapter*)(Solid::DeviceInterface*)xptr;
	    case 9: return (void*)(Solid::AudioInterface*)(Solid::DeviceInterface*)xptr;
	    case 10: return (void*)(Solid::Battery*)(Solid::DeviceInterface*)xptr;
	    case 11: return (void*)(Solid::Block*)(Solid::DeviceInterface*)xptr;
	    case 12: return (void*)(Solid::Button*)(Solid::DeviceInterface*)xptr;
	    case 13: return (void*)(Solid::Camera*)(Solid::DeviceInterface*)xptr;
	    case 17: return (void*)(Solid::DvbInterface*)(Solid::DeviceInterface*)xptr;
	    case 18: return (void*)(Solid::GenericInterface*)(Solid::DeviceInterface*)xptr;
	    case 19: return (void*)(Solid::NetworkInterface*)(Solid::DeviceInterface*)xptr;
	    case 22: return (void*)(Solid::OpticalDisc*)(Solid::DeviceInterface*)xptr;
	    case 23: return (void*)(Solid::OpticalDrive*)(Solid::DeviceInterface*)xptr;
	    case 24: return (void*)(Solid::PortableMediaPlayer*)(Solid::DeviceInterface*)xptr;
	    case 28: return (void*)(Solid::Processor*)(Solid::DeviceInterface*)xptr;
	    case 29: return (void*)(Solid::StorageAccess*)(Solid::DeviceInterface*)xptr;
	    case 30: return (void*)(Solid::StorageDrive*)(Solid::DeviceInterface*)xptr;
	    case 31: return (void*)(Solid::StorageVolume*)(Solid::DeviceInterface*)xptr;
	    case 32: return (void*)(Solid::Video*)(Solid::DeviceInterface*)xptr;
	  default: return xptr;
	}
      case 16:	//Solid::DeviceNotifier
	switch(to) {
	    case 4: return (void*)(QObject*)(Solid::DeviceNotifier*)xptr;
	    case 16: return (void*)(Solid::DeviceNotifier*)(Solid::DeviceNotifier*)xptr;
	  default: return xptr;
	}
      case 17:	//Solid::DvbInterface
	switch(to) {
	    case 15: return (void*)(Solid::DeviceInterface*)(Solid::DvbInterface*)xptr;
	    case 4: return (void*)(QObject*)(Solid::DvbInterface*)xptr;
	    case 17: return (void*)(Solid::DvbInterface*)(Solid::DvbInterface*)xptr;
	  default: return xptr;
	}
      case 18:	//Solid::GenericInterface
	switch(to) {
	    case 15: return (void*)(Solid::DeviceInterface*)(Solid::GenericInterface*)xptr;
	    case 4: return (void*)(QObject*)(Solid::GenericInterface*)xptr;
	    case 18: return (void*)(Solid::GenericInterface*)(Solid::GenericInterface*)xptr;
	  default: return xptr;
	}
      case 19:	//Solid::NetworkInterface
	switch(to) {
	    case 15: return (void*)(Solid::DeviceInterface*)(Solid::NetworkInterface*)xptr;
	    case 4: return (void*)(QObject*)(Solid::NetworkInterface*)xptr;
	    case 19: return (void*)(Solid::NetworkInterface*)(Solid::NetworkInterface*)xptr;
	  default: return xptr;
	}
      case 21:	//Solid::Networking::Notifier
	switch(to) {
	    case 4: return (void*)(QObject*)(Solid::Networking::Notifier*)xptr;
	    case 21: return (void*)(Solid::Networking::Notifier*)(Solid::Networking::Notifier*)xptr;
	  default: return xptr;
	}
      case 22:	//Solid::OpticalDisc
	switch(to) {
	    case 31: return (void*)(Solid::StorageVolume*)(Solid::OpticalDisc*)xptr;
	    case 15: return (void*)(Solid::DeviceInterface*)(Solid::OpticalDisc*)xptr;
	    case 4: return (void*)(QObject*)(Solid::OpticalDisc*)xptr;
	    case 22: return (void*)(Solid::OpticalDisc*)(Solid::OpticalDisc*)xptr;
	  default: return xptr;
	}
      case 23:	//Solid::OpticalDrive
	switch(to) {
	    case 30: return (void*)(Solid::StorageDrive*)(Solid::OpticalDrive*)xptr;
	    case 15: return (void*)(Solid::DeviceInterface*)(Solid::OpticalDrive*)xptr;
	    case 4: return (void*)(QObject*)(Solid::OpticalDrive*)xptr;
	    case 23: return (void*)(Solid::OpticalDrive*)(Solid::OpticalDrive*)xptr;
	  default: return xptr;
	}
      case 24:	//Solid::PortableMediaPlayer
	switch(to) {
	    case 15: return (void*)(Solid::DeviceInterface*)(Solid::PortableMediaPlayer*)xptr;
	    case 4: return (void*)(QObject*)(Solid::PortableMediaPlayer*)xptr;
	    case 24: return (void*)(Solid::PortableMediaPlayer*)(Solid::PortableMediaPlayer*)xptr;
	  default: return xptr;
	}
      case 26:	//Solid::PowerManagement::Notifier
	switch(to) {
	    case 4: return (void*)(QObject*)(Solid::PowerManagement::Notifier*)xptr;
	    case 26: return (void*)(Solid::PowerManagement::Notifier*)(Solid::PowerManagement::Notifier*)xptr;
	  default: return xptr;
	}
      case 27:	//Solid::Predicate
	switch(to) {
	    case 27: return (void*)(Solid::Predicate*)(Solid::Predicate*)xptr;
	  default: return xptr;
	}
      case 28:	//Solid::Processor
	switch(to) {
	    case 15: return (void*)(Solid::DeviceInterface*)(Solid::Processor*)xptr;
	    case 4: return (void*)(QObject*)(Solid::Processor*)xptr;
	    case 28: return (void*)(Solid::Processor*)(Solid::Processor*)xptr;
	  default: return xptr;
	}
      case 29:	//Solid::StorageAccess
	switch(to) {
	    case 15: return (void*)(Solid::DeviceInterface*)(Solid::StorageAccess*)xptr;
	    case 4: return (void*)(QObject*)(Solid::StorageAccess*)xptr;
	    case 29: return (void*)(Solid::StorageAccess*)(Solid::StorageAccess*)xptr;
	  default: return xptr;
	}
      case 30:	//Solid::StorageDrive
	switch(to) {
	    case 15: return (void*)(Solid::DeviceInterface*)(Solid::StorageDrive*)xptr;
	    case 4: return (void*)(QObject*)(Solid::StorageDrive*)xptr;
	    case 30: return (void*)(Solid::StorageDrive*)(Solid::StorageDrive*)xptr;
	    case 23: return (void*)(Solid::OpticalDrive*)(Solid::StorageDrive*)xptr;
	  default: return xptr;
	}
      case 31:	//Solid::StorageVolume
	switch(to) {
	    case 15: return (void*)(Solid::DeviceInterface*)(Solid::StorageVolume*)xptr;
	    case 4: return (void*)(QObject*)(Solid::StorageVolume*)xptr;
	    case 31: return (void*)(Solid::StorageVolume*)(Solid::StorageVolume*)xptr;
	    case 22: return (void*)(Solid::OpticalDisc*)(Solid::StorageVolume*)xptr;
	  default: return xptr;
	}
      case 32:	//Solid::Video
	switch(to) {
	    case 15: return (void*)(Solid::DeviceInterface*)(Solid::Video*)xptr;
	    case 4: return (void*)(QObject*)(Solid::Video*)xptr;
	    case 32: return (void*)(Solid::Video*)(Solid::Video*)xptr;
	  default: return xptr;
	}
      default: return xptr;
    }
}

// Group of Indexes (0 separated) used as super class lists.
// Classes with super classes have an index into this array.
static Smoke::Index solid_inheritanceList[] = {
	0,	// 0: (no super class)
	15, 0,	// 1: Solid::DeviceInterface
	4, 0,	// 3: QObject
	31, 0,	// 5: Solid::StorageVolume
	30, 0,	// 7: Solid::StorageDrive
};

// These are the xenum functions for manipulating enum pointers
void xenum_Solid__Battery(Smoke::EnumOperation, Smoke::Index, void*&, long&);
void xenum_Solid__Processor(Smoke::EnumOperation, Smoke::Index, void*&, long&);
void xenum_Solid__GenericInterface(Smoke::EnumOperation, Smoke::Index, void*&, long&);
void xenum_Solid__Networking(Smoke::EnumOperation, Smoke::Index, void*&, long&);
void xenum_Solid(Smoke::EnumOperation, Smoke::Index, void*&, long&);
void xenum_Solid__DvbInterface(Smoke::EnumOperation, Smoke::Index, void*&, long&);
void xenum_Solid__PowerManagement(Smoke::EnumOperation, Smoke::Index, void*&, long&);
void xenum_Solid__Button(Smoke::EnumOperation, Smoke::Index, void*&, long&);
void xenum_Solid__AudioInterface(Smoke::EnumOperation, Smoke::Index, void*&, long&);
void xenum_Solid__OpticalDrive(Smoke::EnumOperation, Smoke::Index, void*&, long&);
void xenum_Solid__OpticalDisc(Smoke::EnumOperation, Smoke::Index, void*&, long&);
void xenum_Solid__StorageVolume(Smoke::EnumOperation, Smoke::Index, void*&, long&);
void xenum_Solid__Predicate(Smoke::EnumOperation, Smoke::Index, void*&, long&);
void xenum_Solid__StorageDrive(Smoke::EnumOperation, Smoke::Index, void*&, long&);
void xenum_Solid__DeviceInterface(Smoke::EnumOperation, Smoke::Index, void*&, long&);

// Those are the xcall functions defined in each x_*.cpp file, for dispatching method calls
void xcall_Solid(Smoke::Index, void*, Smoke::Stack);
void xcall_Solid__AcAdapter(Smoke::Index, void*, Smoke::Stack);
void xcall_Solid__AudioInterface(Smoke::Index, void*, Smoke::Stack);
void xcall_Solid__Battery(Smoke::Index, void*, Smoke::Stack);
void xcall_Solid__Block(Smoke::Index, void*, Smoke::Stack);
void xcall_Solid__Button(Smoke::Index, void*, Smoke::Stack);
void xcall_Solid__Camera(Smoke::Index, void*, Smoke::Stack);
void xcall_Solid__Device(Smoke::Index, void*, Smoke::Stack);
void xcall_Solid__DeviceInterface(Smoke::Index, void*, Smoke::Stack);
void xcall_Solid__DeviceNotifier(Smoke::Index, void*, Smoke::Stack);
void xcall_Solid__DvbInterface(Smoke::Index, void*, Smoke::Stack);
void xcall_Solid__GenericInterface(Smoke::Index, void*, Smoke::Stack);
void xcall_Solid__NetworkInterface(Smoke::Index, void*, Smoke::Stack);
void xcall_Solid__Networking(Smoke::Index, void*, Smoke::Stack);
void xcall_Solid__OpticalDisc(Smoke::Index, void*, Smoke::Stack);
void xcall_Solid__OpticalDrive(Smoke::Index, void*, Smoke::Stack);
void xcall_Solid__PortableMediaPlayer(Smoke::Index, void*, Smoke::Stack);
void xcall_Solid__PowerManagement(Smoke::Index, void*, Smoke::Stack);
void xcall_Solid__Predicate(Smoke::Index, void*, Smoke::Stack);
void xcall_Solid__Processor(Smoke::Index, void*, Smoke::Stack);
void xcall_Solid__StorageAccess(Smoke::Index, void*, Smoke::Stack);
void xcall_Solid__StorageDrive(Smoke::Index, void*, Smoke::Stack);
void xcall_Solid__StorageVolume(Smoke::Index, void*, Smoke::Stack);
void xcall_Solid__Video(Smoke::Index, void*, Smoke::Stack);

// List of all classes
// Name, index into inheritanceList, method dispatcher, enum dispatcher, class flags
static Smoke::Class solid_classes[] = {
	{ 0L, false, 0, 0, 0, 0 }, 	// 0 (no class)
	{ "QChildEvent", true, 0, 0, 0, 0 }, 	// 1
	{ "QEvent", true, 0, 0, 0, 0 }, 	// 2
	{ "QMetaObject", true, 0, 0, 0, 0 }, 	// 3
	{ "QObject", true, 0, 0, 0, 0 }, 	// 4
	{ "QTimerEvent", true, 0, 0, 0, 0 }, 	// 5
	{ "QVariant", true, 0, 0, 0, 0 }, 	// 6
	{ "Solid", false, 0, xcall_Solid, xenum_Solid, Smoke::cf_deepcopy }, 	//7
	{ "Solid::AcAdapter", false, 1, xcall_Solid__AcAdapter, 0, Smoke::cf_virtual }, 	//8
	{ "Solid::AudioInterface", false, 1, xcall_Solid__AudioInterface, xenum_Solid__AudioInterface, Smoke::cf_virtual }, 	//9
	{ "Solid::Battery", false, 1, xcall_Solid__Battery, xenum_Solid__Battery, Smoke::cf_virtual }, 	//10
	{ "Solid::Block", false, 1, xcall_Solid__Block, 0, Smoke::cf_virtual }, 	//11
	{ "Solid::Button", false, 1, xcall_Solid__Button, xenum_Solid__Button, Smoke::cf_virtual }, 	//12
	{ "Solid::Camera", false, 1, xcall_Solid__Camera, 0, Smoke::cf_virtual }, 	//13
	{ "Solid::Device", false, 0, xcall_Solid__Device, 0, Smoke::cf_constructor|Smoke::cf_deepcopy }, 	//14
	{ "Solid::DeviceInterface", false, 3, xcall_Solid__DeviceInterface, xenum_Solid__DeviceInterface, Smoke::cf_constructor|Smoke::cf_virtual }, 	//15
	{ "Solid::DeviceNotifier", false, 3, xcall_Solid__DeviceNotifier, 0, Smoke::cf_constructor|Smoke::cf_virtual }, 	//16
	{ "Solid::DvbInterface", false, 1, xcall_Solid__DvbInterface, xenum_Solid__DvbInterface, Smoke::cf_virtual }, 	//17
	{ "Solid::GenericInterface", false, 1, xcall_Solid__GenericInterface, xenum_Solid__GenericInterface, Smoke::cf_virtual }, 	//18
	{ "Solid::NetworkInterface", false, 1, xcall_Solid__NetworkInterface, 0, Smoke::cf_virtual }, 	//19
	{ "Solid::Networking", false, 0, xcall_Solid__Networking, xenum_Solid__Networking, Smoke::cf_deepcopy }, 	//20
	{ "Solid::Networking::Notifier", true, 0, 0, 0, 0 }, 	// 21
	{ "Solid::OpticalDisc", false, 5, xcall_Solid__OpticalDisc, xenum_Solid__OpticalDisc, Smoke::cf_virtual }, 	//22
	{ "Solid::OpticalDrive", false, 7, xcall_Solid__OpticalDrive, xenum_Solid__OpticalDrive, Smoke::cf_virtual }, 	//23
	{ "Solid::PortableMediaPlayer", false, 1, xcall_Solid__PortableMediaPlayer, 0, Smoke::cf_virtual }, 	//24
	{ "Solid::PowerManagement", false, 0, xcall_Solid__PowerManagement, xenum_Solid__PowerManagement, Smoke::cf_deepcopy }, 	//25
	{ "Solid::PowerManagement::Notifier", true, 0, 0, 0, 0 }, 	// 26
	{ "Solid::Predicate", false, 0, xcall_Solid__Predicate, xenum_Solid__Predicate, Smoke::cf_constructor|Smoke::cf_deepcopy }, 	//27
	{ "Solid::Processor", false, 1, xcall_Solid__Processor, xenum_Solid__Processor, Smoke::cf_virtual }, 	//28
	{ "Solid::StorageAccess", false, 1, xcall_Solid__StorageAccess, 0, Smoke::cf_constructor|Smoke::cf_virtual }, 	//29
	{ "Solid::StorageDrive", false, 1, xcall_Solid__StorageDrive, xenum_Solid__StorageDrive, Smoke::cf_constructor|Smoke::cf_virtual }, 	//30
	{ "Solid::StorageVolume", false, 1, xcall_Solid__StorageVolume, xenum_Solid__StorageVolume, Smoke::cf_constructor|Smoke::cf_virtual }, 	//31
	{ "Solid::Video", false, 1, xcall_Solid__Video, 0, Smoke::cf_virtual }, 	//32
};

// List of all types needed by the methods (arguments and return values)
// Name, class ID if arg is a class, and TypeId
static Smoke::Type solid_types[] = {
	{ 0, 0, 0 },	//0 (no type)
	{ "KAction::ShortcutTypes", 0, Smoke::t_uint | Smoke::tf_stack },	//1
	{ "KAction::ShortcutTypes&", 0, Smoke::t_voidp | Smoke::tf_ref },	//2
	{ "KAutostart::Conditions", 0, Smoke::t_uint | Smoke::tf_stack },	//3
	{ "KAutostart::Conditions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//4
	{ "KCModule::Buttons", 0, Smoke::t_uint | Smoke::tf_stack },	//5
	{ "KCModule::Buttons&", 0, Smoke::t_voidp | Smoke::tf_ref },	//6
	{ "KCmdLineArgs::StdCmdLineArgs", 0, Smoke::t_uint | Smoke::tf_stack },	//7
	{ "KCmdLineArgs::StdCmdLineArgs&", 0, Smoke::t_voidp | Smoke::tf_ref },	//8
	{ "KConfig::OpenFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//9
	{ "KConfig::OpenFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//10
	{ "KConfigBase::WriteConfigFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//11
	{ "KConfigBase::WriteConfigFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//12
	{ "KCrash::CrashFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//13
	{ "KCrash::CrashFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//14
	{ "KDialog::ButtonCodes", 0, Smoke::t_uint | Smoke::tf_stack },	//15
	{ "KDialog::ButtonCodes&", 0, Smoke::t_voidp | Smoke::tf_ref },	//16
	{ "KDialog::ButtonPopupModes", 0, Smoke::t_uint | Smoke::tf_stack },	//17
	{ "KDialog::ButtonPopupModes&", 0, Smoke::t_voidp | Smoke::tf_ref },	//18
	{ "KDialog::CaptionFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//19
	{ "KDialog::CaptionFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//20
	{ "KDirLister::OpenUrlFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//21
	{ "KDirLister::OpenUrlFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//22
	{ "KDirModel::DropsAllowed", 0, Smoke::t_uint | Smoke::tf_stack },	//23
	{ "KDirModel::DropsAllowed&", 0, Smoke::t_voidp | Smoke::tf_ref },	//24
	{ "KDirWatch::WatchModes", 0, Smoke::t_uint | Smoke::tf_stack },	//25
	{ "KDirWatch::WatchModes&", 0, Smoke::t_voidp | Smoke::tf_ref },	//26
	{ "KEditListBox::Buttons", 0, Smoke::t_uint | Smoke::tf_stack },	//27
	{ "KEditListBox::Buttons&", 0, Smoke::t_voidp | Smoke::tf_ref },	//28
	{ "KFileMetaInfo::WhatFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//29
	{ "KFileMetaInfo::WhatFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//30
	{ "KFontChooser::DisplayFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//31
	{ "KFontChooser::DisplayFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//32
	{ "KFontChooser::FontDiffFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//33
	{ "KFontChooser::FontDiffFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//34
	{ "KGlobalSettings::GraphicEffects", 0, Smoke::t_uint | Smoke::tf_stack },	//35
	{ "KGlobalSettings::GraphicEffects&", 0, Smoke::t_voidp | Smoke::tf_ref },	//36
	{ "KIO::JobFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//37
	{ "KIO::JobFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//38
	{ "KIO::NetRC::LookUpMode", 0, Smoke::t_uint | Smoke::tf_stack },	//39
	{ "KIO::NetRC::LookUpMode&", 0, Smoke::t_voidp | Smoke::tf_ref },	//40
	{ "KIO::TCPSlaveBase::SslResult", 0, Smoke::t_uint | Smoke::tf_stack },	//41
	{ "KIO::TCPSlaveBase::SslResult&", 0, Smoke::t_voidp | Smoke::tf_ref },	//42
	{ "KJob::Capabilities", 0, Smoke::t_uint | Smoke::tf_stack },	//43
	{ "KJob::Capabilities&", 0, Smoke::t_voidp | Smoke::tf_ref },	//44
	{ "KKeySequenceWidget::ShortcutTypes", 0, Smoke::t_uint | Smoke::tf_stack },	//45
	{ "KKeySequenceWidget::ShortcutTypes&", 0, Smoke::t_voidp | Smoke::tf_ref },	//46
	{ "KLocale::DateTimeFormatOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//47
	{ "KLocale::DateTimeFormatOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//48
	{ "KLockFile::LockFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//49
	{ "KLockFile::LockFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//50
	{ "KMessageBox::Options", 0, Smoke::t_uint | Smoke::tf_stack },	//51
	{ "KMessageBox::Options&", 0, Smoke::t_voidp | Smoke::tf_ref },	//52
	{ "KNTLM::AuthFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//53
	{ "KNTLM::AuthFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//54
	{ "KNotification::NotificationFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//55
	{ "KNotification::NotificationFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//56
	{ "KNotificationRestrictions::Services", 0, Smoke::t_uint | Smoke::tf_stack },	//57
	{ "KNotificationRestrictions::Services&", 0, Smoke::t_voidp | Smoke::tf_ref },	//58
	{ "KParts::BrowserExtension::PopupFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//59
	{ "KParts::BrowserExtension::PopupFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//60
	{ "KPasswordDialog::KPasswordDialogFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//61
	{ "KPasswordDialog::KPasswordDialogFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//62
	{ "KPlotObject::PlotTypes", 0, Smoke::t_uint | Smoke::tf_stack },	//63
	{ "KPlotObject::PlotTypes&", 0, Smoke::t_voidp | Smoke::tf_ref },	//64
	{ "KServiceGroup::EntriesOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//65
	{ "KServiceGroup::EntriesOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//66
	{ "KShell::Options", 0, Smoke::t_uint | Smoke::tf_stack },	//67
	{ "KShell::Options&", 0, Smoke::t_voidp | Smoke::tf_ref },	//68
	{ "KShortcutsEditor::ActionTypes", 0, Smoke::t_uint | Smoke::tf_stack },	//69
	{ "KShortcutsEditor::ActionTypes&", 0, Smoke::t_voidp | Smoke::tf_ref },	//70
	{ "KStandardDirs::SearchOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//71
	{ "KStandardDirs::SearchOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//72
	{ "KUniqueApplication::StartFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//73
	{ "KUniqueApplication::StartFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//74
	{ "KUrl::CleanPathOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//75
	{ "KUrl::CleanPathOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//76
	{ "KUrl::DirectoryOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//77
	{ "KUrl::DirectoryOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//78
	{ "KUrl::EncodedPathAndQueryOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//79
	{ "KUrl::EncodedPathAndQueryOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//80
	{ "KUrl::EqualsOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//81
	{ "KUrl::EqualsOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//82
	{ "KUrl::QueryItemsOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//83
	{ "KUrl::QueryItemsOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//84
	{ "KXmlGuiWindow::StandardWindowOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//85
	{ "KXmlGuiWindow::StandardWindowOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//86
	{ "QAbstractFileEngine::FileFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//87
	{ "QAbstractFileEngine::FileFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//88
	{ "QAbstractItemView::EditTriggers", 0, Smoke::t_uint | Smoke::tf_stack },	//89
	{ "QAbstractItemView::EditTriggers&", 0, Smoke::t_voidp | Smoke::tf_ref },	//90
	{ "QAbstractPrintDialog::PrintDialogOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//91
	{ "QAbstractPrintDialog::PrintDialogOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//92
	{ "QAbstractSpinBox::StepEnabled", 0, Smoke::t_uint | Smoke::tf_stack },	//93
	{ "QAbstractSpinBox::StepEnabled&", 0, Smoke::t_voidp | Smoke::tf_ref },	//94
	{ "QAccessible::Relation", 0, Smoke::t_uint | Smoke::tf_stack },	//95
	{ "QAccessible::Relation&", 0, Smoke::t_voidp | Smoke::tf_ref },	//96
	{ "QAccessible::State", 0, Smoke::t_uint | Smoke::tf_stack },	//97
	{ "QAccessible::State&", 0, Smoke::t_voidp | Smoke::tf_ref },	//98
	{ "QChildEvent*", 1, Smoke::t_class | Smoke::tf_ptr },	//99
	{ "QColorDialog::ColorDialogOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//100
	{ "QColorDialog::ColorDialogOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//101
	{ "QDBusConnection::RegisterOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//102
	{ "QDBusConnection::RegisterOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//103
	{ "QDateTimeEdit::Sections", 0, Smoke::t_uint | Smoke::tf_stack },	//104
	{ "QDateTimeEdit::Sections&", 0, Smoke::t_voidp | Smoke::tf_ref },	//105
	{ "QDialogButtonBox::StandardButtons", 0, Smoke::t_uint | Smoke::tf_stack },	//106
	{ "QDialogButtonBox::StandardButtons&", 0, Smoke::t_voidp | Smoke::tf_ref },	//107
	{ "QDir::Filters", 0, Smoke::t_uint | Smoke::tf_stack },	//108
	{ "QDir::Filters&", 0, Smoke::t_voidp | Smoke::tf_ref },	//109
	{ "QDir::SortFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//110
	{ "QDir::SortFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//111
	{ "QDirIterator::IteratorFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//112
	{ "QDirIterator::IteratorFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//113
	{ "QDockWidget::DockWidgetFeatures", 0, Smoke::t_uint | Smoke::tf_stack },	//114
	{ "QDockWidget::DockWidgetFeatures&", 0, Smoke::t_voidp | Smoke::tf_ref },	//115
	{ "QEvent*", 2, Smoke::t_class | Smoke::tf_ptr },	//116
	{ "QEventLoop::ProcessEventsFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//117
	{ "QEventLoop::ProcessEventsFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//118
	{ "QFile::Permissions", 0, Smoke::t_uint | Smoke::tf_stack },	//119
	{ "QFile::Permissions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//120
	{ "QFileDialog::Options", 0, Smoke::t_uint | Smoke::tf_stack },	//121
	{ "QFileDialog::Options&", 0, Smoke::t_voidp | Smoke::tf_ref },	//122
	{ "QFontComboBox::FontFilters", 0, Smoke::t_uint | Smoke::tf_stack },	//123
	{ "QFontComboBox::FontFilters&", 0, Smoke::t_voidp | Smoke::tf_ref },	//124
	{ "QFontDialog::FontDialogOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//125
	{ "QFontDialog::FontDialogOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//126
	{ "QGL::FormatOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//127
	{ "QGL::FormatOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//128
	{ "QGLFormat::OpenGLVersionFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//129
	{ "QGLFormat::OpenGLVersionFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//130
	{ "QGraphicsItem::GraphicsItemFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//131
	{ "QGraphicsItem::GraphicsItemFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//132
	{ "QGraphicsScene::SceneLayers", 0, Smoke::t_uint | Smoke::tf_stack },	//133
	{ "QGraphicsScene::SceneLayers&", 0, Smoke::t_voidp | Smoke::tf_ref },	//134
	{ "QGraphicsView::CacheMode", 0, Smoke::t_uint | Smoke::tf_stack },	//135
	{ "QGraphicsView::CacheMode&", 0, Smoke::t_voidp | Smoke::tf_ref },	//136
	{ "QGraphicsView::OptimizationFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//137
	{ "QGraphicsView::OptimizationFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//138
	{ "QIODevice::OpenMode", 0, Smoke::t_uint | Smoke::tf_stack },	//139
	{ "QIODevice::OpenMode&", 0, Smoke::t_voidp | Smoke::tf_ref },	//140
	{ "QInputDialog::InputDialogOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//141
	{ "QInputDialog::InputDialogOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//142
	{ "QItemSelectionModel::SelectionFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//143
	{ "QItemSelectionModel::SelectionFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//144
	{ "QLibrary::LoadHints", 0, Smoke::t_uint | Smoke::tf_stack },	//145
	{ "QLibrary::LoadHints&", 0, Smoke::t_voidp | Smoke::tf_ref },	//146
	{ "QList<Solid::Device>", 0, Smoke::t_voidp | Smoke::tf_stack },	//147
	{ "QList<int>", 0, Smoke::t_voidp | Smoke::tf_stack },	//148
	{ "QLocale::NumberOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//149
	{ "QLocale::NumberOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//150
	{ "QMainWindow::DockOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//151
	{ "QMainWindow::DockOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//152
	{ "QMap<QString,QVariant>", 0, Smoke::t_voidp | Smoke::tf_stack },	//153
	{ "QMap<QString,int>&", 0, Smoke::t_voidp | Smoke::tf_ref },	//154
	{ "QMdiArea::AreaOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//155
	{ "QMdiArea::AreaOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//156
	{ "QMdiSubWindow::SubWindowOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//157
	{ "QMdiSubWindow::SubWindowOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//158
	{ "QMessageBox::StandardButtons", 0, Smoke::t_uint | Smoke::tf_stack },	//159
	{ "QMessageBox::StandardButtons&", 0, Smoke::t_voidp | Smoke::tf_ref },	//160
	{ "QMetaObject::Call", 3, Smoke::t_enum | Smoke::tf_stack },	//161
	{ "QNetworkInterface::InterfaceFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//162
	{ "QNetworkInterface::InterfaceFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//163
	{ "QNetworkProxy::Capabilities", 0, Smoke::t_uint | Smoke::tf_stack },	//164
	{ "QNetworkProxy::Capabilities&", 0, Smoke::t_voidp | Smoke::tf_ref },	//165
	{ "QObject*", 4, Smoke::t_class | Smoke::tf_ptr },	//166
	{ "QPageSetupDialog::PageSetupDialogOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//167
	{ "QPageSetupDialog::PageSetupDialogOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//168
	{ "QPaintEngine::DirtyFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//169
	{ "QPaintEngine::DirtyFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//170
	{ "QPaintEngine::PaintEngineFeatures", 0, Smoke::t_uint | Smoke::tf_stack },	//171
	{ "QPaintEngine::PaintEngineFeatures&", 0, Smoke::t_voidp | Smoke::tf_ref },	//172
	{ "QPainter::RenderHints", 0, Smoke::t_uint | Smoke::tf_stack },	//173
	{ "QPainter::RenderHints&", 0, Smoke::t_voidp | Smoke::tf_ref },	//174
	{ "QSet<Solid::DeviceInterface::Type>", 0, Smoke::t_voidp | Smoke::tf_stack },	//175
	{ "QSet<Solid::PowerManagement::SleepState>", 0, Smoke::t_voidp | Smoke::tf_stack },	//176
	{ "QSizePolicy::ControlTypes", 0, Smoke::t_uint | Smoke::tf_stack },	//177
	{ "QSizePolicy::ControlTypes&", 0, Smoke::t_voidp | Smoke::tf_ref },	//178
	{ "QSql::ParamType", 0, Smoke::t_uint | Smoke::tf_stack },	//179
	{ "QSql::ParamType&", 0, Smoke::t_voidp | Smoke::tf_ref },	//180
	{ "QString", 0, Smoke::t_voidp | Smoke::tf_stack },	//181
	{ "QString&", 0, Smoke::t_voidp | Smoke::tf_ref },	//182
	{ "QString::SectionFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//183
	{ "QString::SectionFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//184
	{ "QStringList", 0, Smoke::t_voidp | Smoke::tf_stack },	//185
	{ "QStyle::State", 0, Smoke::t_uint | Smoke::tf_stack },	//186
	{ "QStyle::State&", 0, Smoke::t_voidp | Smoke::tf_ref },	//187
	{ "QStyle::SubControls", 0, Smoke::t_uint | Smoke::tf_stack },	//188
	{ "QStyle::SubControls&", 0, Smoke::t_voidp | Smoke::tf_ref },	//189
	{ "QStyleOptionButton::ButtonFeatures", 0, Smoke::t_uint | Smoke::tf_stack },	//190
	{ "QStyleOptionButton::ButtonFeatures&", 0, Smoke::t_voidp | Smoke::tf_ref },	//191
	{ "QStyleOptionFrameV2::FrameFeatures", 0, Smoke::t_uint | Smoke::tf_stack },	//192
	{ "QStyleOptionFrameV2::FrameFeatures&", 0, Smoke::t_voidp | Smoke::tf_ref },	//193
	{ "QStyleOptionQ3ListViewItem::Q3ListViewItemFeatures", 0, Smoke::t_uint | Smoke::tf_stack },	//194
	{ "QStyleOptionQ3ListViewItem::Q3ListViewItemFeatures&", 0, Smoke::t_voidp | Smoke::tf_ref },	//195
	{ "QStyleOptionTab::CornerWidgets", 0, Smoke::t_uint | Smoke::tf_stack },	//196
	{ "QStyleOptionTab::CornerWidgets&", 0, Smoke::t_voidp | Smoke::tf_ref },	//197
	{ "QStyleOptionToolBar::ToolBarFeatures", 0, Smoke::t_uint | Smoke::tf_stack },	//198
	{ "QStyleOptionToolBar::ToolBarFeatures&", 0, Smoke::t_voidp | Smoke::tf_ref },	//199
	{ "QStyleOptionToolButton::ToolButtonFeatures", 0, Smoke::t_uint | Smoke::tf_stack },	//200
	{ "QStyleOptionToolButton::ToolButtonFeatures&", 0, Smoke::t_voidp | Smoke::tf_ref },	//201
	{ "QStyleOptionViewItemV2::ViewItemFeatures", 0, Smoke::t_uint | Smoke::tf_stack },	//202
	{ "QStyleOptionViewItemV2::ViewItemFeatures&", 0, Smoke::t_voidp | Smoke::tf_ref },	//203
	{ "QTextBoundaryFinder::BoundaryReasons", 0, Smoke::t_uint | Smoke::tf_stack },	//204
	{ "QTextBoundaryFinder::BoundaryReasons&", 0, Smoke::t_voidp | Smoke::tf_ref },	//205
	{ "QTextCodec::ConversionFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//206
	{ "QTextCodec::ConversionFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//207
	{ "QTextDocument::FindFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//208
	{ "QTextDocument::FindFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//209
	{ "QTextEdit::AutoFormatting", 0, Smoke::t_uint | Smoke::tf_stack },	//210
	{ "QTextEdit::AutoFormatting&", 0, Smoke::t_voidp | Smoke::tf_ref },	//211
	{ "QTextFormat::PageBreakFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//212
	{ "QTextFormat::PageBreakFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//213
	{ "QTextItem::RenderFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//214
	{ "QTextItem::RenderFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//215
	{ "QTextOption::Flags", 0, Smoke::t_uint | Smoke::tf_stack },	//216
	{ "QTextOption::Flags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//217
	{ "QTextStream::NumberFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//218
	{ "QTextStream::NumberFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//219
	{ "QTimerEvent*", 5, Smoke::t_class | Smoke::tf_ptr },	//220
	{ "QTreeWidgetItemIterator::IteratorFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//221
	{ "QTreeWidgetItemIterator::IteratorFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//222
	{ "QUdpSocket::BindMode", 0, Smoke::t_uint | Smoke::tf_stack },	//223
	{ "QUdpSocket::BindMode&", 0, Smoke::t_voidp | Smoke::tf_ref },	//224
	{ "QUrl::FormattingOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//225
	{ "QUrl::FormattingOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//226
	{ "QVariant", 6, Smoke::t_class | Smoke::tf_stack },	//227
	{ "QWebPage::FindFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//228
	{ "QWebPage::FindFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//229
	{ "QWidget::RenderFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//230
	{ "QWidget::RenderFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//231
	{ "QWizard::WizardOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//232
	{ "QWizard::WizardOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//233
	{ "Qt::Alignment", 0, Smoke::t_uint | Smoke::tf_stack },	//234
	{ "Qt::Alignment&", 0, Smoke::t_voidp | Smoke::tf_ref },	//235
	{ "Qt::DockWidgetAreas", 0, Smoke::t_uint | Smoke::tf_stack },	//236
	{ "Qt::DockWidgetAreas&", 0, Smoke::t_voidp | Smoke::tf_ref },	//237
	{ "Qt::DropActions", 0, Smoke::t_uint | Smoke::tf_stack },	//238
	{ "Qt::DropActions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//239
	{ "Qt::ImageConversionFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//240
	{ "Qt::ImageConversionFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//241
	{ "Qt::ItemFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//242
	{ "Qt::ItemFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//243
	{ "Qt::KeyboardModifiers", 0, Smoke::t_uint | Smoke::tf_stack },	//244
	{ "Qt::KeyboardModifiers&", 0, Smoke::t_voidp | Smoke::tf_ref },	//245
	{ "Qt::MatchFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//246
	{ "Qt::MatchFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//247
	{ "Qt::MouseButtons", 0, Smoke::t_uint | Smoke::tf_stack },	//248
	{ "Qt::MouseButtons&", 0, Smoke::t_voidp | Smoke::tf_ref },	//249
	{ "Qt::Orientations", 0, Smoke::t_uint | Smoke::tf_stack },	//250
	{ "Qt::Orientations&", 0, Smoke::t_voidp | Smoke::tf_ref },	//251
	{ "Qt::TextInteractionFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//252
	{ "Qt::TextInteractionFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//253
	{ "Qt::ToolBarAreas", 0, Smoke::t_uint | Smoke::tf_stack },	//254
	{ "Qt::ToolBarAreas&", 0, Smoke::t_voidp | Smoke::tf_ref },	//255
	{ "Qt::WindowFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//256
	{ "Qt::WindowFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//257
	{ "Qt::WindowStates", 0, Smoke::t_uint | Smoke::tf_stack },	//258
	{ "Qt::WindowStates&", 0, Smoke::t_voidp | Smoke::tf_ref },	//259
	{ "Solid::AudioInterface::AudioDriver", 9, Smoke::t_enum | Smoke::tf_stack },	//260
	{ "Solid::AudioInterface::AudioInterfaceType", 9, Smoke::t_enum | Smoke::tf_stack },	//261
	{ "Solid::AudioInterface::AudioInterfaceTypes", 0, Smoke::t_uint | Smoke::tf_stack },	//262
	{ "Solid::AudioInterface::AudioInterfaceTypes&", 0, Smoke::t_voidp | Smoke::tf_ref },	//263
	{ "Solid::AudioInterface::SoundcardType", 9, Smoke::t_enum | Smoke::tf_stack },	//264
	{ "Solid::Battery::BatteryType", 10, Smoke::t_enum | Smoke::tf_stack },	//265
	{ "Solid::Battery::ChargeState", 10, Smoke::t_enum | Smoke::tf_stack },	//266
	{ "Solid::Button::ButtonType", 12, Smoke::t_enum | Smoke::tf_stack },	//267
	{ "Solid::Device", 14, Smoke::t_class | Smoke::tf_stack },	//268
	{ "Solid::Device&", 14, Smoke::t_class | Smoke::tf_ref },	//269
	{ "Solid::Device*", 14, Smoke::t_class | Smoke::tf_ptr },	//270
	{ "Solid::DeviceInterface*", 15, Smoke::t_class | Smoke::tf_ptr },	//271
	{ "Solid::DeviceInterface::Type", 15, Smoke::t_enum | Smoke::tf_stack },	//272
	{ "Solid::DeviceNotifier*", 16, Smoke::t_class | Smoke::tf_ptr },	//273
	{ "Solid::DvbInterface::DeviceType", 17, Smoke::t_enum | Smoke::tf_stack },	//274
	{ "Solid::ErrorType", 7, Smoke::t_enum | Smoke::tf_stack },	//275
	{ "Solid::GenericInterface::PropertyChange", 18, Smoke::t_enum | Smoke::tf_stack },	//276
	{ "Solid::Networking::ManagementPolicy", 20, Smoke::t_enum | Smoke::tf_stack },	//277
	{ "Solid::Networking::Notifier*", 21, Smoke::t_class | Smoke::tf_ptr },	//278
	{ "Solid::Networking::Status", 20, Smoke::t_enum | Smoke::tf_stack },	//279
	{ "Solid::OpticalDisc::ContentType", 22, Smoke::t_enum | Smoke::tf_stack },	//280
	{ "Solid::OpticalDisc::ContentTypes", 0, Smoke::t_uint | Smoke::tf_stack },	//281
	{ "Solid::OpticalDisc::ContentTypes&", 0, Smoke::t_voidp | Smoke::tf_ref },	//282
	{ "Solid::OpticalDisc::DiscType", 22, Smoke::t_enum | Smoke::tf_stack },	//283
	{ "Solid::OpticalDrive::MediumType", 23, Smoke::t_enum | Smoke::tf_stack },	//284
	{ "Solid::OpticalDrive::MediumTypes", 0, Smoke::t_uint | Smoke::tf_stack },	//285
	{ "Solid::OpticalDrive::MediumTypes&", 0, Smoke::t_voidp | Smoke::tf_ref },	//286
	{ "Solid::PowerManagement::Notifier*", 26, Smoke::t_class | Smoke::tf_ptr },	//287
	{ "Solid::PowerManagement::SleepState", 25, Smoke::t_enum | Smoke::tf_stack },	//288
	{ "Solid::Predicate", 27, Smoke::t_class | Smoke::tf_stack },	//289
	{ "Solid::Predicate&", 27, Smoke::t_class | Smoke::tf_ref },	//290
	{ "Solid::Predicate*", 27, Smoke::t_class | Smoke::tf_ptr },	//291
	{ "Solid::Predicate::ComparisonOperator", 27, Smoke::t_enum | Smoke::tf_stack },	//292
	{ "Solid::Processor::InstructionSet", 28, Smoke::t_enum | Smoke::tf_stack },	//293
	{ "Solid::Processor::InstructionSets", 0, Smoke::t_uint | Smoke::tf_stack },	//294
	{ "Solid::Processor::InstructionSets&", 0, Smoke::t_voidp | Smoke::tf_ref },	//295
	{ "Solid::StorageDrive::Bus", 30, Smoke::t_enum | Smoke::tf_stack },	//296
	{ "Solid::StorageDrive::DriveType", 30, Smoke::t_enum | Smoke::tf_stack },	//297
	{ "Solid::StorageVolume::UsageType", 31, Smoke::t_enum | Smoke::tf_stack },	//298
	{ "bool", 0, Smoke::t_bool | Smoke::tf_stack },	//299
	{ "const QMap<QString,int>&", 0, Smoke::t_voidp | Smoke::tf_ref | Smoke::tf_const },	//300
	{ "const QMetaObject", 3, Smoke::t_class | Smoke::tf_stack | Smoke::tf_const },	//301
	{ "const QMetaObject*", 3, Smoke::t_class | Smoke::tf_ptr | Smoke::tf_const },	//302
	{ "const QString&", 0, Smoke::t_voidp | Smoke::tf_ref | Smoke::tf_const },	//303
	{ "const QVariant&", 6, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//304
	{ "const Solid::Device&", 14, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//305
	{ "const Solid::DeviceInterface*", 15, Smoke::t_class | Smoke::tf_ptr | Smoke::tf_const },	//306
	{ "const Solid::DeviceInterface::Type&", 0, Smoke::t_voidp | Smoke::tf_ref | Smoke::tf_const },	//307
	{ "const Solid::Predicate&", 27, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//308
	{ "const char*", 0, Smoke::t_voidp | Smoke::tf_ptr | Smoke::tf_const },	//309
	{ "int", 0, Smoke::t_int | Smoke::tf_stack },	//310
	{ "qulonglong", 0, Smoke::t_voidp | Smoke::tf_stack },	//311
	{ "void**", 0, Smoke::t_voidp | Smoke::tf_ptr },	//312
};

static Smoke::Index solid_argumentList[] = {
	0,	//0  (void)
	116, 0,	//1  QEvent*  
	161, 310, 312, 0,	//3  QMetaObject::Call, int, void**  
	166, 116, 0,	//7  QObject*, QEvent*  
	181, 0,	//10  QString  
	220, 0,	//12  QTimerEvent*  
	267, 303, 0,	//14  Solid::Button::ButtonType, const QString&  
	272, 0,	//17  Solid::DeviceInterface::Type  
	275, 227, 303, 0,	//19  Solid::ErrorType, QVariant, const QString&  
	288, 166, 309, 0,	//23  Solid::PowerManagement::SleepState, QObject*, const char*  
	299, 303, 0,	//27  bool, const QString&  
	300, 0,	//30  const QMap<QString,int>&  
	303, 0,	//32  const QString&  
	303, 303, 0,	//34  const QString&, const QString&  
	303, 303, 304, 0,	//37  const QString&, const QString&, const QVariant&  
	303, 303, 304, 292, 0,	//41  const QString&, const QString&, const QVariant&, Solid::Predicate::ComparisonOperator  
	305, 0,	//46  const Solid::Device&  
	307, 0,	//48  const Solid::DeviceInterface::Type&  
	307, 303, 0,	//50  const Solid::DeviceInterface::Type&, const QString&  
	307, 303, 304, 0,	//53  const Solid::DeviceInterface::Type&, const QString&, const QVariant&  
	307, 303, 304, 292, 0,	//57  const Solid::DeviceInterface::Type&, const QString&, const QVariant&, Solid::Predicate::ComparisonOperator  
	308, 0,	//62  const Solid::Predicate&  
	308, 303, 0,	//64  const Solid::Predicate&, const QString&  
	309, 0,	//67  const char*  
	310, 0,	//69  int  
	310, 303, 0,	//71  int, const QString&  
	99, 0,	//74  QChildEvent*  
};

// Raw list of all methods, using munged names
static const char *solid_methodNames[] = {
    "",	//0
    "AcAdapter",	//1
    "Alsa",	//2
    "AltiVec",	//3
    "Amd3DNow",	//4
    "Audio",	//5
    "AudioControl",	//6
    "AudioInput",	//7
    "AudioInterface",	//8
    "AudioOutput",	//9
    "Battery",	//10
    "Bd",	//11
    "Bdr",	//12
    "Bdre",	//13
    "Block",	//14
    "BluRayRecordable",	//15
    "BluRayRewritable",	//16
    "BluRayRom",	//17
    "Button",	//18
    "Camera",	//19
    "CameraBattery",	//20
    "CdRecordable",	//21
    "CdRewritable",	//22
    "CdRom",	//23
    "Cdr",	//24
    "CdromDrive",	//25
    "Cdrw",	//26
    "Charging",	//27
    "CompactFlash",	//28
    "Connected",	//29
    "Connecting",	//30
    "Data",	//31
    "Device",	//32
    "Device#",	//33
    "Device$",	//34
    "DeviceNotifier",	//35
    "Discharging",	//36
    "Disconnecting",	//37
    "DvbAudio",	//38
    "DvbCa",	//39
    "DvbDemux",	//40
    "DvbDvr",	//41
    "DvbFrontend",	//42
    "DvbInterface",	//43
    "DvbNet",	//44
    "DvbOsd",	//45
    "DvbSec",	//46
    "DvbUnknown",	//47
    "DvbVideo",	//48
    "Dvd",	//49
    "DvdPlusRecordable",	//50
    "DvdPlusRecordableDuallayer",	//51
    "DvdPlusRewritable",	//52
    "DvdPlusRewritableDuallayer",	//53
    "DvdRam",	//54
    "DvdRecordable",	//55
    "DvdRewritable",	//56
    "DvdRom",	//57
    "Dvdplusdl",	//58
    "Dvdplusdlrw",	//59
    "Dvdplusr",	//60
    "Dvdplusrw",	//61
    "Dvdr",	//62
    "Dvdram",	//63
    "Dvdrw",	//64
    "Encrypted",	//65
    "Equals",	//66
    "FileSystem",	//67
    "FirewireSoundcard",	//68
    "Floppy",	//69
    "GenericInterface",	//70
    "HardDisk",	//71
    "HdDvd",	//72
    "HdDvdRecordable",	//73
    "HdDvdRewritable",	//74
    "HdDvdRom",	//75
    "HdDvdr",	//76
    "HdDvdrw",	//77
    "Headset",	//78
    "HibernateState",	//79
    "Ide",	//80
    "Ieee1394",	//81
    "IntelMmx",	//82
    "IntelSse",	//83
    "IntelSse2",	//84
    "IntelSse3",	//85
    "IntelSse4",	//86
    "InternalSoundcard",	//87
    "KeyboardBattery",	//88
    "KeyboardMouseBattery",	//89
    "Last",	//90
    "LidButton",	//91
    "Managed",	//92
    "Manual",	//93
    "Mask",	//94
    "MemoryStick",	//95
    "Modem",	//96
    "MouseBattery",	//97
    "NetworkInterface",	//98
    "NoCharge",	//99
    "NoError",	//100
    "NoExtensions",	//101
    "OnNextStatusChange",	//102
    "OpenSoundSystem",	//103
    "OpticalDisc",	//104
    "OpticalDrive",	//105
    "Other",	//106
    "PartitionTable",	//107
    "PdaBattery",	//108
    "Platform",	//109
    "PortableMediaPlayer",	//110
    "PowerButton",	//111
    "Predicate",	//112
    "Predicate#",	//113
    "Predicate$",	//114
    "Predicate$$#",	//115
    "Predicate$$#$",	//116
    "PrimaryBattery",	//117
    "Processor",	//118
    "PropertyAdded",	//119
    "PropertyModified",	//120
    "PropertyRemoved",	//121
    "Raid",	//122
    "Sata",	//123
    "Scsi",	//124
    "SdMmc",	//125
    "SerialInterface",	//126
    "SleepButton",	//127
    "SmartCardReader",	//128
    "SmartMedia",	//129
    "StandbyState",	//130
    "StorageAccess",	//131
    "StorageDrive",	//132
    "StorageVolume",	//133
    "SuperVideoCd",	//134
    "SuspendState",	//135
    "TabletButton",	//136
    "Tape",	//137
    "UnauthorizedOperation",	//138
    "Unconnected",	//139
    "Unknown",	//140
    "UnknownAudioDriver",	//141
    "UnknownAudioInterfaceType",	//142
    "UnknownBattery",	//143
    "UnknownButtonType",	//144
    "UnknownDiscType",	//145
    "Unused",	//146
    "UpsBattery",	//147
    "Usb",	//148
    "UsbSoundcard",	//149
    "Video",	//150
    "VideoCd",	//151
    "VideoDvd",	//152
    "Xd",	//153
    "accessibilityChanged",	//154
    "accessibilityChanged$$",	//155
    "allDevices",	//156
    "allProperties",	//157
    "appShouldConserveResources",	//158
    "asDeviceInterface",	//159
    "asDeviceInterface$",	//160
    "availableContent",	//161
    "beginSuppressingSleep",	//162
    "beginSuppressingSleep$",	//163
    "bus",	//164
    "canChangeFrequency",	//165
    "capacity",	//166
    "chargePercent",	//167
    "chargePercentChanged",	//168
    "chargePercentChanged$$",	//169
    "chargeState",	//170
    "chargeStateChanged",	//171
    "chargeStateChanged$$",	//172
    "childEvent",	//173
    "childEvent#",	//174
    "conditionRaised",	//175
    "conditionRaised$$",	//176
    "connectNotify",	//177
    "connectNotify$",	//178
    "customEvent",	//179
    "customEvent#",	//180
    "device",	//181
    "deviceAdapter",	//182
    "deviceAdded",	//183
    "deviceAdded$",	//184
    "deviceIndex",	//185
    "deviceInterfaceType",	//186
    "deviceMajor",	//187
    "deviceMinor",	//188
    "deviceRemoved",	//189
    "deviceRemoved$",	//190
    "deviceType",	//191
    "discType",	//192
    "disconnectNotify",	//193
    "disconnectNotify$",	//194
    "driveType",	//195
    "driver",	//196
    "driverHandle",	//197
    "driverHandle$",	//198
    "eject",	//199
    "ejectDone",	//200
    "ejectDone$#$",	//201
    "ejectPressed",	//202
    "ejectPressed$",	//203
    "encryptedContainer",	//204
    "event",	//205
    "event#",	//206
    "eventFilter",	//207
    "eventFilter##",	//208
    "filePath",	//209
    "fromString",	//210
    "fromString$",	//211
    "fsType",	//212
    "hasState",	//213
    "hwAddress",	//214
    "icon",	//215
    "ifaceName",	//216
    "instance",	//217
    "instructionSets",	//218
    "isAccessible",	//219
    "isAppendable",	//220
    "isBlank",	//221
    "isDeviceInterface",	//222
    "isDeviceInterface$",	//223
    "isHotpluggable",	//224
    "isIgnored",	//225
    "isPlugged",	//226
    "isRechargeable",	//227
    "isRemovable",	//228
    "isRewritable",	//229
    "isValid",	//230
    "isWireless",	//231
    "label",	//232
    "listFromQuery",	//233
    "listFromQuery#",	//234
    "listFromQuery#$",	//235
    "listFromQuery$",	//236
    "listFromQuery$$",	//237
    "listFromType",	//238
    "listFromType$",	//239
    "listFromType$$",	//240
    "macAddress",	//241
    "matches",	//242
    "matches#",	//243
    "maxSpeed",	//244
    "metaObject",	//245
    "name",	//246
    "notifier",	//247
    "number",	//248
    "operator&",	//249
    "operator&#",	//250
    "operator&=",	//251
    "operator&=#",	//252
    "operator=",	//253
    "operator=#",	//254
    "operator|",	//255
    "operator|#",	//256
    "operator|=",	//257
    "operator|=#",	//258
    "parent",	//259
    "parentUdi",	//260
    "plugStateChanged",	//261
    "plugStateChanged$$",	//262
    "pressed",	//263
    "pressed$$",	//264
    "product",	//265
    "property",	//266
    "property$",	//267
    "propertyChanged",	//268
    "propertyChanged?",	//269
    "propertyExists",	//270
    "propertyExists$",	//271
    "qt_metacall",	//272
    "qt_metacall$$?",	//273
    "readSpeed",	//274
    "requestSleep",	//275
    "requestSleep$#$",	//276
    "setup",	//277
    "setupDone",	//278
    "setupDone$#$",	//279
    "size",	//280
    "soundcardType",	//281
    "stateValue",	//282
    "staticMetaObject",	//283
    "status",	//284
    "stopSuppressingSleep",	//285
    "stopSuppressingSleep$",	//286
    "stringToType",	//287
    "stringToType$",	//288
    "supportedDrivers",	//289
    "supportedDrivers$",	//290
    "supportedMedia",	//291
    "supportedProtocols",	//292
    "supportedSleepStates",	//293
    "teardown",	//294
    "teardownDone",	//295
    "teardownDone$#$",	//296
    "timerEvent",	//297
    "timerEvent#",	//298
    "toString",	//299
    "type",	//300
    "typeToString",	//301
    "typeToString$",	//302
    "udi",	//303
    "usage",	//304
    "usedTypes",	//305
    "uuid",	//306
    "vendor",	//307
    "writeSpeed",	//308
    "writeSpeeds",	//309
    "~AcAdapter",	//310
    "~AudioInterface",	//311
    "~Battery",	//312
    "~Block",	//313
    "~Button",	//314
    "~Camera",	//315
    "~Device",	//316
    "~DeviceInterface",	//317
    "~DeviceNotifier",	//318
    "~DvbInterface",	//319
    "~GenericInterface",	//320
    "~NetworkInterface",	//321
    "~OpticalDisc",	//322
    "~OpticalDrive",	//323
    "~PortableMediaPlayer",	//324
    "~Predicate",	//325
    "~Processor",	//326
    "~StorageAccess",	//327
    "~StorageDrive",	//328
    "~StorageVolume",	//329
    "~Video",	//330
};

// (classId, name (index in methodNames), argumentList index, number of args, method flags, return type (index in types), xcall() index)
static Smoke::Method solid_methods[] = {
	{4, 245, 0, 0, Smoke::mf_const, 302, 2},	//0 QObject::metaObject() const
	{4, 272, 3, 3, 0, 310, 3},	//1 QObject::qt_metacall(QMetaObject::Call, int, void**)
	{4, 205, 1, 1, 0, 299, 6},	//2 QObject::event(QEvent*)
	{4, 207, 7, 2, 0, 299, 7},	//3 QObject::eventFilter(QObject*, QEvent*)
	{4, 297, 12, 1, Smoke::mf_protected, 0, 49},	//4 QObject::timerEvent(QTimerEvent*)
	{4, 173, 74, 1, Smoke::mf_protected, 0, 50},	//5 QObject::childEvent(QChildEvent*)
	{4, 179, 1, 1, Smoke::mf_protected, 0, 51},	//6 QObject::customEvent(QEvent*)
	{4, 177, 67, 1, Smoke::mf_protected, 0, 52},	//7 QObject::connectNotify(const char*)
	{4, 193, 67, 1, Smoke::mf_protected, 0, 53},	//8 QObject::disconnectNotify(const char*)
	{7, 100, 0, 0, Smoke::mf_static|Smoke::mf_enum, 275, 1},	//9 Solid::NoError (enum)
	{7, 138, 0, 0, Smoke::mf_static|Smoke::mf_enum, 275, 2},	//10 Solid::UnauthorizedOperation (enum)
	{8, 245, 0, 0, Smoke::mf_const, 302, 2},	//11 Solid::AcAdapter::metaObject() const
	{8, 272, 3, 3, 0, 310, 3},	//12 Solid::AcAdapter::qt_metacall(QMetaObject::Call, int, void**)
	{8, 226, 0, 0, Smoke::mf_const, 299, 4},	//13 Solid::AcAdapter::isPlugged() const
	{8, 186, 0, 0, Smoke::mf_static, 272, 5},	//14 Solid::AcAdapter::deviceInterfaceType()
	{8, 283, 0, 0, Smoke::mf_static, 301, 1},	//15 Solid::AcAdapter::staticMetaObject (static var)
	{9, 2, 0, 0, Smoke::mf_static|Smoke::mf_enum, 260, 1},	//16 Solid::AudioInterface::Alsa (enum)
	{9, 103, 0, 0, Smoke::mf_static|Smoke::mf_enum, 260, 2},	//17 Solid::AudioInterface::OpenSoundSystem (enum)
	{9, 141, 0, 0, Smoke::mf_static|Smoke::mf_enum, 260, 3},	//18 Solid::AudioInterface::UnknownAudioDriver (enum)
	{9, 142, 0, 0, Smoke::mf_static|Smoke::mf_enum, 261, 4},	//19 Solid::AudioInterface::UnknownAudioInterfaceType (enum)
	{9, 6, 0, 0, Smoke::mf_static|Smoke::mf_enum, 261, 5},	//20 Solid::AudioInterface::AudioControl (enum)
	{9, 7, 0, 0, Smoke::mf_static|Smoke::mf_enum, 261, 6},	//21 Solid::AudioInterface::AudioInput (enum)
	{9, 9, 0, 0, Smoke::mf_static|Smoke::mf_enum, 261, 7},	//22 Solid::AudioInterface::AudioOutput (enum)
	{9, 87, 0, 0, Smoke::mf_static|Smoke::mf_enum, 264, 8},	//23 Solid::AudioInterface::InternalSoundcard (enum)
	{9, 149, 0, 0, Smoke::mf_static|Smoke::mf_enum, 264, 9},	//24 Solid::AudioInterface::UsbSoundcard (enum)
	{9, 68, 0, 0, Smoke::mf_static|Smoke::mf_enum, 264, 10},	//25 Solid::AudioInterface::FirewireSoundcard (enum)
	{9, 78, 0, 0, Smoke::mf_static|Smoke::mf_enum, 264, 11},	//26 Solid::AudioInterface::Headset (enum)
	{9, 96, 0, 0, Smoke::mf_static|Smoke::mf_enum, 264, 12},	//27 Solid::AudioInterface::Modem (enum)
	{9, 245, 0, 0, Smoke::mf_const, 302, 14},	//28 Solid::AudioInterface::metaObject() const
	{9, 272, 3, 3, 0, 310, 15},	//29 Solid::AudioInterface::qt_metacall(QMetaObject::Call, int, void**)
	{9, 196, 0, 0, Smoke::mf_const, 260, 16},	//30 Solid::AudioInterface::driver() const
	{9, 197, 0, 0, Smoke::mf_const, 227, 17},	//31 Solid::AudioInterface::driverHandle() const
	{9, 246, 0, 0, Smoke::mf_const, 181, 18},	//32 Solid::AudioInterface::name() const
	{9, 191, 0, 0, Smoke::mf_const, 262, 19},	//33 Solid::AudioInterface::deviceType() const
	{9, 281, 0, 0, Smoke::mf_const, 264, 20},	//34 Solid::AudioInterface::soundcardType() const
	{9, 186, 0, 0, Smoke::mf_static, 272, 21},	//35 Solid::AudioInterface::deviceInterfaceType()
	{9, 283, 0, 0, Smoke::mf_static, 301, 13},	//36 Solid::AudioInterface::staticMetaObject (static var)
	{10, 143, 0, 0, Smoke::mf_static|Smoke::mf_enum, 265, 1},	//37 Solid::Battery::UnknownBattery (enum)
	{10, 108, 0, 0, Smoke::mf_static|Smoke::mf_enum, 265, 2},	//38 Solid::Battery::PdaBattery (enum)
	{10, 147, 0, 0, Smoke::mf_static|Smoke::mf_enum, 265, 3},	//39 Solid::Battery::UpsBattery (enum)
	{10, 117, 0, 0, Smoke::mf_static|Smoke::mf_enum, 265, 4},	//40 Solid::Battery::PrimaryBattery (enum)
	{10, 97, 0, 0, Smoke::mf_static|Smoke::mf_enum, 265, 5},	//41 Solid::Battery::MouseBattery (enum)
	{10, 88, 0, 0, Smoke::mf_static|Smoke::mf_enum, 265, 6},	//42 Solid::Battery::KeyboardBattery (enum)
	{10, 89, 0, 0, Smoke::mf_static|Smoke::mf_enum, 265, 7},	//43 Solid::Battery::KeyboardMouseBattery (enum)
	{10, 20, 0, 0, Smoke::mf_static|Smoke::mf_enum, 265, 8},	//44 Solid::Battery::CameraBattery (enum)
	{10, 99, 0, 0, Smoke::mf_static|Smoke::mf_enum, 266, 9},	//45 Solid::Battery::NoCharge (enum)
	{10, 27, 0, 0, Smoke::mf_static|Smoke::mf_enum, 266, 10},	//46 Solid::Battery::Charging (enum)
	{10, 36, 0, 0, Smoke::mf_static|Smoke::mf_enum, 266, 11},	//47 Solid::Battery::Discharging (enum)
	{10, 245, 0, 0, Smoke::mf_const, 302, 13},	//48 Solid::Battery::metaObject() const
	{10, 272, 3, 3, 0, 310, 14},	//49 Solid::Battery::qt_metacall(QMetaObject::Call, int, void**)
	{10, 226, 0, 0, Smoke::mf_const, 299, 15},	//50 Solid::Battery::isPlugged() const
	{10, 300, 0, 0, Smoke::mf_const, 265, 16},	//51 Solid::Battery::type() const
	{10, 167, 0, 0, Smoke::mf_const, 310, 17},	//52 Solid::Battery::chargePercent() const
	{10, 227, 0, 0, Smoke::mf_const, 299, 18},	//53 Solid::Battery::isRechargeable() const
	{10, 170, 0, 0, Smoke::mf_const, 266, 19},	//54 Solid::Battery::chargeState() const
	{10, 186, 0, 0, Smoke::mf_static, 272, 20},	//55 Solid::Battery::deviceInterfaceType()
	{10, 283, 0, 0, Smoke::mf_static, 301, 12},	//56 Solid::Battery::staticMetaObject (static var)
	{11, 245, 0, 0, Smoke::mf_const, 302, 2},	//57 Solid::Block::metaObject() const
	{11, 272, 3, 3, 0, 310, 3},	//58 Solid::Block::qt_metacall(QMetaObject::Call, int, void**)
	{11, 187, 0, 0, Smoke::mf_const, 310, 4},	//59 Solid::Block::deviceMajor() const
	{11, 188, 0, 0, Smoke::mf_const, 310, 5},	//60 Solid::Block::deviceMinor() const
	{11, 181, 0, 0, Smoke::mf_const, 181, 6},	//61 Solid::Block::device() const
	{11, 186, 0, 0, Smoke::mf_static, 272, 7},	//62 Solid::Block::deviceInterfaceType()
	{11, 283, 0, 0, Smoke::mf_static, 301, 1},	//63 Solid::Block::staticMetaObject (static var)
	{12, 91, 0, 0, Smoke::mf_static|Smoke::mf_enum, 267, 1},	//64 Solid::Button::LidButton (enum)
	{12, 111, 0, 0, Smoke::mf_static|Smoke::mf_enum, 267, 2},	//65 Solid::Button::PowerButton (enum)
	{12, 127, 0, 0, Smoke::mf_static|Smoke::mf_enum, 267, 3},	//66 Solid::Button::SleepButton (enum)
	{12, 144, 0, 0, Smoke::mf_static|Smoke::mf_enum, 267, 4},	//67 Solid::Button::UnknownButtonType (enum)
	{12, 136, 0, 0, Smoke::mf_static|Smoke::mf_enum, 267, 5},	//68 Solid::Button::TabletButton (enum)
	{12, 245, 0, 0, Smoke::mf_const, 302, 7},	//69 Solid::Button::metaObject() const
	{12, 272, 3, 3, 0, 310, 8},	//70 Solid::Button::qt_metacall(QMetaObject::Call, int, void**)
	{12, 300, 0, 0, Smoke::mf_const, 267, 9},	//71 Solid::Button::type() const
	{12, 213, 0, 0, Smoke::mf_const, 299, 10},	//72 Solid::Button::hasState() const
	{12, 282, 0, 0, Smoke::mf_const, 299, 11},	//73 Solid::Button::stateValue() const
	{12, 186, 0, 0, Smoke::mf_static, 272, 12},	//74 Solid::Button::deviceInterfaceType()
	{12, 283, 0, 0, Smoke::mf_static, 301, 6},	//75 Solid::Button::staticMetaObject (static var)
	{13, 245, 0, 0, Smoke::mf_const, 302, 2},	//76 Solid::Camera::metaObject() const
	{13, 272, 3, 3, 0, 310, 3},	//77 Solid::Camera::qt_metacall(QMetaObject::Call, int, void**)
	{13, 292, 0, 0, Smoke::mf_const, 185, 4},	//78 Solid::Camera::supportedProtocols() const
	{13, 289, 10, 1, Smoke::mf_const, 185, 5},	//79 Solid::Camera::supportedDrivers(QString) const
	{13, 289, 0, 0, Smoke::mf_const, 185, 6},	//80 Solid::Camera::supportedDrivers() const
	{13, 197, 32, 1, Smoke::mf_const, 227, 7},	//81 Solid::Camera::driverHandle(const QString&) const
	{13, 186, 0, 0, Smoke::mf_static, 272, 8},	//82 Solid::Camera::deviceInterfaceType()
	{13, 283, 0, 0, Smoke::mf_static, 301, 1},	//83 Solid::Camera::staticMetaObject (static var)
	{14, 32, 32, 1, Smoke::mf_ctor, 270, 1},	//84 Solid::Device::Device(const QString&)
	{14, 32, 0, 0, Smoke::mf_ctor, 270, 2},	//85 Solid::Device::Device()
	{14, 32, 46, 1, Smoke::mf_copyctor|Smoke::mf_ctor, 270, 3},	//86 Solid::Device::Device(const Solid::Device&)
	{14, 316, 0, 0, Smoke::mf_dtor, 0, 21},	//87 Solid::Device::~Device()
	{14, 253, 46, 1, 0, 269, 4},	//88 Solid::Device::operator=(const Solid::Device&)
	{14, 230, 0, 0, Smoke::mf_const, 299, 5},	//89 Solid::Device::isValid() const
	{14, 303, 0, 0, Smoke::mf_const, 181, 6},	//90 Solid::Device::udi() const
	{14, 260, 0, 0, Smoke::mf_const, 181, 7},	//91 Solid::Device::parentUdi() const
	{14, 259, 0, 0, Smoke::mf_const, 268, 8},	//92 Solid::Device::parent() const
	{14, 307, 0, 0, Smoke::mf_const, 181, 9},	//93 Solid::Device::vendor() const
	{14, 265, 0, 0, Smoke::mf_const, 181, 10},	//94 Solid::Device::product() const
	{14, 215, 0, 0, Smoke::mf_const, 181, 11},	//95 Solid::Device::icon() const
	{14, 222, 48, 1, Smoke::mf_const, 299, 12},	//96 Solid::Device::isDeviceInterface(const Solid::DeviceInterface::Type&) const
	{14, 159, 48, 1, 0, 271, 13},	//97 Solid::Device::asDeviceInterface(const Solid::DeviceInterface::Type&)
	{14, 156, 0, 0, Smoke::mf_static, 147, 14},	//98 Solid::Device::allDevices()
	{14, 238, 50, 2, Smoke::mf_static, 147, 15},	//99 Solid::Device::listFromType(const Solid::DeviceInterface::Type&, const QString&)
	{14, 238, 48, 1, Smoke::mf_static, 147, 16},	//100 Solid::Device::listFromType(const Solid::DeviceInterface::Type&)
	{14, 233, 64, 2, Smoke::mf_static, 147, 17},	//101 Solid::Device::listFromQuery(const Solid::Predicate&, const QString&)
	{14, 233, 62, 1, Smoke::mf_static, 147, 18},	//102 Solid::Device::listFromQuery(const Solid::Predicate&)
	{14, 233, 34, 2, Smoke::mf_static, 147, 19},	//103 Solid::Device::listFromQuery(const QString&, const QString&)
	{14, 233, 32, 1, Smoke::mf_static, 147, 20},	//104 Solid::Device::listFromQuery(const QString&)
	{15, 140, 0, 0, Smoke::mf_static|Smoke::mf_enum, 272, 1},	//105 Solid::DeviceInterface::Unknown (enum)
	{15, 70, 0, 0, Smoke::mf_static|Smoke::mf_enum, 272, 2},	//106 Solid::DeviceInterface::GenericInterface (enum)
	{15, 118, 0, 0, Smoke::mf_static|Smoke::mf_enum, 272, 3},	//107 Solid::DeviceInterface::Processor (enum)
	{15, 14, 0, 0, Smoke::mf_static|Smoke::mf_enum, 272, 4},	//108 Solid::DeviceInterface::Block (enum)
	{15, 131, 0, 0, Smoke::mf_static|Smoke::mf_enum, 272, 5},	//109 Solid::DeviceInterface::StorageAccess (enum)
	{15, 132, 0, 0, Smoke::mf_static|Smoke::mf_enum, 272, 6},	//110 Solid::DeviceInterface::StorageDrive (enum)
	{15, 105, 0, 0, Smoke::mf_static|Smoke::mf_enum, 272, 7},	//111 Solid::DeviceInterface::OpticalDrive (enum)
	{15, 133, 0, 0, Smoke::mf_static|Smoke::mf_enum, 272, 8},	//112 Solid::DeviceInterface::StorageVolume (enum)
	{15, 104, 0, 0, Smoke::mf_static|Smoke::mf_enum, 272, 9},	//113 Solid::DeviceInterface::OpticalDisc (enum)
	{15, 19, 0, 0, Smoke::mf_static|Smoke::mf_enum, 272, 10},	//114 Solid::DeviceInterface::Camera (enum)
	{15, 110, 0, 0, Smoke::mf_static|Smoke::mf_enum, 272, 11},	//115 Solid::DeviceInterface::PortableMediaPlayer (enum)
	{15, 98, 0, 0, Smoke::mf_static|Smoke::mf_enum, 272, 12},	//116 Solid::DeviceInterface::NetworkInterface (enum)
	{15, 1, 0, 0, Smoke::mf_static|Smoke::mf_enum, 272, 13},	//117 Solid::DeviceInterface::AcAdapter (enum)
	{15, 10, 0, 0, Smoke::mf_static|Smoke::mf_enum, 272, 14},	//118 Solid::DeviceInterface::Battery (enum)
	{15, 18, 0, 0, Smoke::mf_static|Smoke::mf_enum, 272, 15},	//119 Solid::DeviceInterface::Button (enum)
	{15, 8, 0, 0, Smoke::mf_static|Smoke::mf_enum, 272, 16},	//120 Solid::DeviceInterface::AudioInterface (enum)
	{15, 43, 0, 0, Smoke::mf_static|Smoke::mf_enum, 272, 17},	//121 Solid::DeviceInterface::DvbInterface (enum)
	{15, 150, 0, 0, Smoke::mf_static|Smoke::mf_enum, 272, 18},	//122 Solid::DeviceInterface::Video (enum)
	{15, 126, 0, 0, Smoke::mf_static|Smoke::mf_enum, 272, 19},	//123 Solid::DeviceInterface::SerialInterface (enum)
	{15, 128, 0, 0, Smoke::mf_static|Smoke::mf_enum, 272, 20},	//124 Solid::DeviceInterface::SmartCardReader (enum)
	{15, 90, 0, 0, Smoke::mf_static|Smoke::mf_enum, 272, 21},	//125 Solid::DeviceInterface::Last (enum)
	{15, 245, 0, 0, Smoke::mf_const, 302, 23},	//126 Solid::DeviceInterface::metaObject() const
	{15, 272, 3, 3, 0, 310, 24},	//127 Solid::DeviceInterface::qt_metacall(QMetaObject::Call, int, void**)
	{15, 317, 0, 0, Smoke::mf_dtor, 0, 28},	//128 Solid::DeviceInterface::~DeviceInterface()
	{15, 230, 0, 0, Smoke::mf_const, 299, 25},	//129 Solid::DeviceInterface::isValid() const
	{15, 301, 17, 1, Smoke::mf_static, 181, 26},	//130 Solid::DeviceInterface::typeToString(Solid::DeviceInterface::Type)
	{15, 287, 32, 1, Smoke::mf_static, 272, 27},	//131 Solid::DeviceInterface::stringToType(const QString&)
	{15, 283, 0, 0, Smoke::mf_static, 301, 22},	//132 Solid::DeviceInterface::staticMetaObject (static var)
	{16, 245, 0, 0, Smoke::mf_const, 302, 2},	//133 Solid::DeviceNotifier::metaObject() const
	{16, 272, 3, 3, 0, 310, 3},	//134 Solid::DeviceNotifier::qt_metacall(QMetaObject::Call, int, void**)
	{16, 35, 0, 0, Smoke::mf_ctor, 273, 4},	//135 Solid::DeviceNotifier::DeviceNotifier()
	{16, 318, 0, 0, Smoke::mf_dtor, 0, 8},	//136 Solid::DeviceNotifier::~DeviceNotifier()
	{16, 183, 32, 1, 0, 0, 5},	//137 Solid::DeviceNotifier::deviceAdded(const QString&)
	{16, 189, 32, 1, 0, 0, 6},	//138 Solid::DeviceNotifier::deviceRemoved(const QString&)
	{16, 217, 0, 0, Smoke::mf_static, 273, 7},	//139 Solid::DeviceNotifier::instance()
	{16, 283, 0, 0, Smoke::mf_static, 301, 1},	//140 Solid::DeviceNotifier::staticMetaObject (static var)
	{17, 47, 0, 0, Smoke::mf_static|Smoke::mf_enum, 274, 1},	//141 Solid::DvbInterface::DvbUnknown (enum)
	{17, 38, 0, 0, Smoke::mf_static|Smoke::mf_enum, 274, 2},	//142 Solid::DvbInterface::DvbAudio (enum)
	{17, 39, 0, 0, Smoke::mf_static|Smoke::mf_enum, 274, 3},	//143 Solid::DvbInterface::DvbCa (enum)
	{17, 40, 0, 0, Smoke::mf_static|Smoke::mf_enum, 274, 4},	//144 Solid::DvbInterface::DvbDemux (enum)
	{17, 41, 0, 0, Smoke::mf_static|Smoke::mf_enum, 274, 5},	//145 Solid::DvbInterface::DvbDvr (enum)
	{17, 42, 0, 0, Smoke::mf_static|Smoke::mf_enum, 274, 6},	//146 Solid::DvbInterface::DvbFrontend (enum)
	{17, 44, 0, 0, Smoke::mf_static|Smoke::mf_enum, 274, 7},	//147 Solid::DvbInterface::DvbNet (enum)
	{17, 45, 0, 0, Smoke::mf_static|Smoke::mf_enum, 274, 8},	//148 Solid::DvbInterface::DvbOsd (enum)
	{17, 46, 0, 0, Smoke::mf_static|Smoke::mf_enum, 274, 9},	//149 Solid::DvbInterface::DvbSec (enum)
	{17, 48, 0, 0, Smoke::mf_static|Smoke::mf_enum, 274, 10},	//150 Solid::DvbInterface::DvbVideo (enum)
	{17, 245, 0, 0, Smoke::mf_const, 302, 12},	//151 Solid::DvbInterface::metaObject() const
	{17, 272, 3, 3, 0, 310, 13},	//152 Solid::DvbInterface::qt_metacall(QMetaObject::Call, int, void**)
	{17, 181, 0, 0, Smoke::mf_const, 181, 14},	//153 Solid::DvbInterface::device() const
	{17, 182, 0, 0, Smoke::mf_const, 310, 15},	//154 Solid::DvbInterface::deviceAdapter() const
	{17, 191, 0, 0, Smoke::mf_const, 274, 16},	//155 Solid::DvbInterface::deviceType() const
	{17, 185, 0, 0, Smoke::mf_const, 310, 17},	//156 Solid::DvbInterface::deviceIndex() const
	{17, 186, 0, 0, Smoke::mf_static, 272, 18},	//157 Solid::DvbInterface::deviceInterfaceType()
	{17, 283, 0, 0, Smoke::mf_static, 301, 11},	//158 Solid::DvbInterface::staticMetaObject (static var)
	{18, 120, 0, 0, Smoke::mf_static|Smoke::mf_enum, 276, 1},	//159 Solid::GenericInterface::PropertyModified (enum)
	{18, 119, 0, 0, Smoke::mf_static|Smoke::mf_enum, 276, 2},	//160 Solid::GenericInterface::PropertyAdded (enum)
	{18, 121, 0, 0, Smoke::mf_static|Smoke::mf_enum, 276, 3},	//161 Solid::GenericInterface::PropertyRemoved (enum)
	{18, 245, 0, 0, Smoke::mf_const, 302, 5},	//162 Solid::GenericInterface::metaObject() const
	{18, 272, 3, 3, 0, 310, 6},	//163 Solid::GenericInterface::qt_metacall(QMetaObject::Call, int, void**)
	{18, 266, 32, 1, Smoke::mf_const, 227, 7},	//164 Solid::GenericInterface::property(const QString&) const
	{18, 157, 0, 0, Smoke::mf_const, 153, 8},	//165 Solid::GenericInterface::allProperties() const
	{18, 270, 32, 1, Smoke::mf_const, 299, 9},	//166 Solid::GenericInterface::propertyExists(const QString&) const
	{18, 186, 0, 0, Smoke::mf_static, 272, 10},	//167 Solid::GenericInterface::deviceInterfaceType()
	{18, 283, 0, 0, Smoke::mf_static, 301, 4},	//168 Solid::GenericInterface::staticMetaObject (static var)
	{19, 245, 0, 0, Smoke::mf_const, 302, 2},	//169 Solid::NetworkInterface::metaObject() const
	{19, 272, 3, 3, 0, 310, 3},	//170 Solid::NetworkInterface::qt_metacall(QMetaObject::Call, int, void**)
	{19, 216, 0, 0, Smoke::mf_const, 181, 4},	//171 Solid::NetworkInterface::ifaceName() const
	{19, 231, 0, 0, Smoke::mf_const, 299, 5},	//172 Solid::NetworkInterface::isWireless() const
	{19, 214, 0, 0, Smoke::mf_const, 181, 6},	//173 Solid::NetworkInterface::hwAddress() const
	{19, 241, 0, 0, Smoke::mf_const, 311, 7},	//174 Solid::NetworkInterface::macAddress() const
	{19, 186, 0, 0, Smoke::mf_static, 272, 8},	//175 Solid::NetworkInterface::deviceInterfaceType()
	{19, 283, 0, 0, Smoke::mf_static, 301, 1},	//176 Solid::NetworkInterface::staticMetaObject (static var)
	{20, 140, 0, 0, Smoke::mf_static|Smoke::mf_enum, 279, 1},	//177 Solid::Networking::Unknown (enum)
	{20, 139, 0, 0, Smoke::mf_static|Smoke::mf_enum, 279, 2},	//178 Solid::Networking::Unconnected (enum)
	{20, 37, 0, 0, Smoke::mf_static|Smoke::mf_enum, 279, 3},	//179 Solid::Networking::Disconnecting (enum)
	{20, 30, 0, 0, Smoke::mf_static|Smoke::mf_enum, 279, 4},	//180 Solid::Networking::Connecting (enum)
	{20, 29, 0, 0, Smoke::mf_static|Smoke::mf_enum, 279, 5},	//181 Solid::Networking::Connected (enum)
	{20, 93, 0, 0, Smoke::mf_static|Smoke::mf_enum, 277, 6},	//182 Solid::Networking::Manual (enum)
	{20, 102, 0, 0, Smoke::mf_static|Smoke::mf_enum, 277, 7},	//183 Solid::Networking::OnNextStatusChange (enum)
	{20, 92, 0, 0, Smoke::mf_static|Smoke::mf_enum, 277, 8},	//184 Solid::Networking::Managed (enum)
	{20, 284, 0, 0, Smoke::mf_static, 279, 9},	//185 Solid::Networking::status()
	{20, 247, 0, 0, Smoke::mf_static, 278, 10},	//186 Solid::Networking::notifier()
	{22, 5, 0, 0, Smoke::mf_static|Smoke::mf_enum, 280, 1},	//187 Solid::OpticalDisc::Audio (enum)
	{22, 31, 0, 0, Smoke::mf_static|Smoke::mf_enum, 280, 2},	//188 Solid::OpticalDisc::Data (enum)
	{22, 151, 0, 0, Smoke::mf_static|Smoke::mf_enum, 280, 3},	//189 Solid::OpticalDisc::VideoCd (enum)
	{22, 134, 0, 0, Smoke::mf_static|Smoke::mf_enum, 280, 4},	//190 Solid::OpticalDisc::SuperVideoCd (enum)
	{22, 152, 0, 0, Smoke::mf_static|Smoke::mf_enum, 280, 5},	//191 Solid::OpticalDisc::VideoDvd (enum)
	{22, 145, 0, 0, Smoke::mf_static|Smoke::mf_enum, 283, 6},	//192 Solid::OpticalDisc::UnknownDiscType (enum)
	{22, 23, 0, 0, Smoke::mf_static|Smoke::mf_enum, 283, 7},	//193 Solid::OpticalDisc::CdRom (enum)
	{22, 21, 0, 0, Smoke::mf_static|Smoke::mf_enum, 283, 8},	//194 Solid::OpticalDisc::CdRecordable (enum)
	{22, 22, 0, 0, Smoke::mf_static|Smoke::mf_enum, 283, 9},	//195 Solid::OpticalDisc::CdRewritable (enum)
	{22, 57, 0, 0, Smoke::mf_static|Smoke::mf_enum, 283, 10},	//196 Solid::OpticalDisc::DvdRom (enum)
	{22, 54, 0, 0, Smoke::mf_static|Smoke::mf_enum, 283, 11},	//197 Solid::OpticalDisc::DvdRam (enum)
	{22, 55, 0, 0, Smoke::mf_static|Smoke::mf_enum, 283, 12},	//198 Solid::OpticalDisc::DvdRecordable (enum)
	{22, 56, 0, 0, Smoke::mf_static|Smoke::mf_enum, 283, 13},	//199 Solid::OpticalDisc::DvdRewritable (enum)
	{22, 50, 0, 0, Smoke::mf_static|Smoke::mf_enum, 283, 14},	//200 Solid::OpticalDisc::DvdPlusRecordable (enum)
	{22, 52, 0, 0, Smoke::mf_static|Smoke::mf_enum, 283, 15},	//201 Solid::OpticalDisc::DvdPlusRewritable (enum)
	{22, 51, 0, 0, Smoke::mf_static|Smoke::mf_enum, 283, 16},	//202 Solid::OpticalDisc::DvdPlusRecordableDuallayer (enum)
	{22, 53, 0, 0, Smoke::mf_static|Smoke::mf_enum, 283, 17},	//203 Solid::OpticalDisc::DvdPlusRewritableDuallayer (enum)
	{22, 17, 0, 0, Smoke::mf_static|Smoke::mf_enum, 283, 18},	//204 Solid::OpticalDisc::BluRayRom (enum)
	{22, 15, 0, 0, Smoke::mf_static|Smoke::mf_enum, 283, 19},	//205 Solid::OpticalDisc::BluRayRecordable (enum)
	{22, 16, 0, 0, Smoke::mf_static|Smoke::mf_enum, 283, 20},	//206 Solid::OpticalDisc::BluRayRewritable (enum)
	{22, 75, 0, 0, Smoke::mf_static|Smoke::mf_enum, 283, 21},	//207 Solid::OpticalDisc::HdDvdRom (enum)
	{22, 73, 0, 0, Smoke::mf_static|Smoke::mf_enum, 283, 22},	//208 Solid::OpticalDisc::HdDvdRecordable (enum)
	{22, 74, 0, 0, Smoke::mf_static|Smoke::mf_enum, 283, 23},	//209 Solid::OpticalDisc::HdDvdRewritable (enum)
	{22, 245, 0, 0, Smoke::mf_const, 302, 25},	//210 Solid::OpticalDisc::metaObject() const
	{22, 272, 3, 3, 0, 310, 26},	//211 Solid::OpticalDisc::qt_metacall(QMetaObject::Call, int, void**)
	{22, 161, 0, 0, Smoke::mf_const, 281, 27},	//212 Solid::OpticalDisc::availableContent() const
	{22, 192, 0, 0, Smoke::mf_const, 283, 28},	//213 Solid::OpticalDisc::discType() const
	{22, 220, 0, 0, Smoke::mf_const, 299, 29},	//214 Solid::OpticalDisc::isAppendable() const
	{22, 221, 0, 0, Smoke::mf_const, 299, 30},	//215 Solid::OpticalDisc::isBlank() const
	{22, 229, 0, 0, Smoke::mf_const, 299, 31},	//216 Solid::OpticalDisc::isRewritable() const
	{22, 166, 0, 0, Smoke::mf_const, 311, 32},	//217 Solid::OpticalDisc::capacity() const
	{22, 186, 0, 0, Smoke::mf_static, 272, 33},	//218 Solid::OpticalDisc::deviceInterfaceType()
	{22, 283, 0, 0, Smoke::mf_static, 301, 24},	//219 Solid::OpticalDisc::staticMetaObject (static var)
	{23, 24, 0, 0, Smoke::mf_static|Smoke::mf_enum, 284, 1},	//220 Solid::OpticalDrive::Cdr (enum)
	{23, 26, 0, 0, Smoke::mf_static|Smoke::mf_enum, 284, 2},	//221 Solid::OpticalDrive::Cdrw (enum)
	{23, 49, 0, 0, Smoke::mf_static|Smoke::mf_enum, 284, 3},	//222 Solid::OpticalDrive::Dvd (enum)
	{23, 62, 0, 0, Smoke::mf_static|Smoke::mf_enum, 284, 4},	//223 Solid::OpticalDrive::Dvdr (enum)
	{23, 64, 0, 0, Smoke::mf_static|Smoke::mf_enum, 284, 5},	//224 Solid::OpticalDrive::Dvdrw (enum)
	{23, 63, 0, 0, Smoke::mf_static|Smoke::mf_enum, 284, 6},	//225 Solid::OpticalDrive::Dvdram (enum)
	{23, 60, 0, 0, Smoke::mf_static|Smoke::mf_enum, 284, 7},	//226 Solid::OpticalDrive::Dvdplusr (enum)
	{23, 61, 0, 0, Smoke::mf_static|Smoke::mf_enum, 284, 8},	//227 Solid::OpticalDrive::Dvdplusrw (enum)
	{23, 58, 0, 0, Smoke::mf_static|Smoke::mf_enum, 284, 9},	//228 Solid::OpticalDrive::Dvdplusdl (enum)
	{23, 59, 0, 0, Smoke::mf_static|Smoke::mf_enum, 284, 10},	//229 Solid::OpticalDrive::Dvdplusdlrw (enum)
	{23, 11, 0, 0, Smoke::mf_static|Smoke::mf_enum, 284, 11},	//230 Solid::OpticalDrive::Bd (enum)
	{23, 12, 0, 0, Smoke::mf_static|Smoke::mf_enum, 284, 12},	//231 Solid::OpticalDrive::Bdr (enum)
	{23, 13, 0, 0, Smoke::mf_static|Smoke::mf_enum, 284, 13},	//232 Solid::OpticalDrive::Bdre (enum)
	{23, 72, 0, 0, Smoke::mf_static|Smoke::mf_enum, 284, 14},	//233 Solid::OpticalDrive::HdDvd (enum)
	{23, 76, 0, 0, Smoke::mf_static|Smoke::mf_enum, 284, 15},	//234 Solid::OpticalDrive::HdDvdr (enum)
	{23, 77, 0, 0, Smoke::mf_static|Smoke::mf_enum, 284, 16},	//235 Solid::OpticalDrive::HdDvdrw (enum)
	{23, 245, 0, 0, Smoke::mf_const, 302, 18},	//236 Solid::OpticalDrive::metaObject() const
	{23, 272, 3, 3, 0, 310, 19},	//237 Solid::OpticalDrive::qt_metacall(QMetaObject::Call, int, void**)
	{23, 291, 0, 0, Smoke::mf_const, 285, 20},	//238 Solid::OpticalDrive::supportedMedia() const
	{23, 274, 0, 0, Smoke::mf_const, 310, 21},	//239 Solid::OpticalDrive::readSpeed() const
	{23, 308, 0, 0, Smoke::mf_const, 310, 22},	//240 Solid::OpticalDrive::writeSpeed() const
	{23, 309, 0, 0, Smoke::mf_const, 148, 23},	//241 Solid::OpticalDrive::writeSpeeds() const
	{23, 199, 0, 0, 0, 299, 24},	//242 Solid::OpticalDrive::eject()
	{23, 186, 0, 0, Smoke::mf_static, 272, 25},	//243 Solid::OpticalDrive::deviceInterfaceType()
	{23, 283, 0, 0, Smoke::mf_static, 301, 17},	//244 Solid::OpticalDrive::staticMetaObject (static var)
	{24, 245, 0, 0, Smoke::mf_const, 302, 2},	//245 Solid::PortableMediaPlayer::metaObject() const
	{24, 272, 3, 3, 0, 310, 3},	//246 Solid::PortableMediaPlayer::qt_metacall(QMetaObject::Call, int, void**)
	{24, 292, 0, 0, Smoke::mf_const, 185, 4},	//247 Solid::PortableMediaPlayer::supportedProtocols() const
	{24, 289, 10, 1, Smoke::mf_const, 185, 5},	//248 Solid::PortableMediaPlayer::supportedDrivers(QString) const
	{24, 289, 0, 0, Smoke::mf_const, 185, 6},	//249 Solid::PortableMediaPlayer::supportedDrivers() const
	{24, 197, 32, 1, Smoke::mf_const, 227, 7},	//250 Solid::PortableMediaPlayer::driverHandle(const QString&) const
	{24, 186, 0, 0, Smoke::mf_static, 272, 8},	//251 Solid::PortableMediaPlayer::deviceInterfaceType()
	{24, 283, 0, 0, Smoke::mf_static, 301, 1},	//252 Solid::PortableMediaPlayer::staticMetaObject (static var)
	{25, 130, 0, 0, Smoke::mf_static|Smoke::mf_enum, 288, 1},	//253 Solid::PowerManagement::StandbyState (enum)
	{25, 135, 0, 0, Smoke::mf_static|Smoke::mf_enum, 288, 2},	//254 Solid::PowerManagement::SuspendState (enum)
	{25, 79, 0, 0, Smoke::mf_static|Smoke::mf_enum, 288, 3},	//255 Solid::PowerManagement::HibernateState (enum)
	{25, 158, 0, 0, Smoke::mf_static, 299, 4},	//256 Solid::PowerManagement::appShouldConserveResources()
	{25, 293, 0, 0, Smoke::mf_static, 176, 5},	//257 Solid::PowerManagement::supportedSleepStates()
	{25, 275, 23, 3, Smoke::mf_static, 0, 6},	//258 Solid::PowerManagement::requestSleep(Solid::PowerManagement::SleepState, QObject*, const char*)
	{25, 162, 32, 1, Smoke::mf_static, 310, 7},	//259 Solid::PowerManagement::beginSuppressingSleep(const QString&)
	{25, 162, 0, 0, Smoke::mf_static, 310, 8},	//260 Solid::PowerManagement::beginSuppressingSleep()
	{25, 285, 69, 1, Smoke::mf_static, 299, 9},	//261 Solid::PowerManagement::stopSuppressingSleep(int)
	{25, 247, 0, 0, Smoke::mf_static, 287, 10},	//262 Solid::PowerManagement::notifier()
	{27, 66, 0, 0, Smoke::mf_static|Smoke::mf_enum, 292, 1},	//263 Solid::Predicate::Equals (enum)
	{27, 94, 0, 0, Smoke::mf_static|Smoke::mf_enum, 292, 2},	//264 Solid::Predicate::Mask (enum)
	{27, 112, 0, 0, Smoke::mf_ctor, 291, 3},	//265 Solid::Predicate::Predicate()
	{27, 112, 62, 1, Smoke::mf_copyctor|Smoke::mf_ctor, 291, 4},	//266 Solid::Predicate::Predicate(const Solid::Predicate&)
	{27, 112, 57, 4, Smoke::mf_ctor, 291, 5},	//267 Solid::Predicate::Predicate(const Solid::DeviceInterface::Type&, const QString&, const QVariant&, Solid::Predicate::ComparisonOperator)
	{27, 112, 53, 3, Smoke::mf_ctor, 291, 6},	//268 Solid::Predicate::Predicate(const Solid::DeviceInterface::Type&, const QString&, const QVariant&)
	{27, 112, 41, 4, Smoke::mf_ctor, 291, 7},	//269 Solid::Predicate::Predicate(const QString&, const QString&, const QVariant&, Solid::Predicate::ComparisonOperator)
	{27, 112, 37, 3, Smoke::mf_ctor, 291, 8},	//270 Solid::Predicate::Predicate(const QString&, const QString&, const QVariant&)
	{27, 112, 48, 1, Smoke::mf_ctor, 291, 9},	//271 Solid::Predicate::Predicate(const Solid::DeviceInterface::Type&)
	{27, 112, 32, 1, Smoke::mf_ctor, 291, 10},	//272 Solid::Predicate::Predicate(const QString&)
	{27, 325, 0, 0, Smoke::mf_dtor, 0, 21},	//273 Solid::Predicate::~Predicate()
	{27, 253, 62, 1, 0, 290, 11},	//274 Solid::Predicate::operator=(const Solid::Predicate&)
	{27, 249, 62, 1, 0, 289, 12},	//275 Solid::Predicate::operator&(const Solid::Predicate&)
	{27, 251, 62, 1, 0, 290, 13},	//276 Solid::Predicate::operator&=(const Solid::Predicate&)
	{27, 255, 62, 1, 0, 289, 14},	//277 Solid::Predicate::operator|(const Solid::Predicate&)
	{27, 257, 62, 1, 0, 290, 15},	//278 Solid::Predicate::operator|=(const Solid::Predicate&)
	{27, 230, 0, 0, Smoke::mf_const, 299, 16},	//279 Solid::Predicate::isValid() const
	{27, 242, 46, 1, Smoke::mf_const, 299, 17},	//280 Solid::Predicate::matches(const Solid::Device&) const
	{27, 305, 0, 0, Smoke::mf_const, 175, 18},	//281 Solid::Predicate::usedTypes() const
	{27, 299, 0, 0, Smoke::mf_const, 181, 19},	//282 Solid::Predicate::toString() const
	{27, 210, 32, 1, Smoke::mf_static, 289, 20},	//283 Solid::Predicate::fromString(const QString&)
	{28, 101, 0, 0, Smoke::mf_static|Smoke::mf_enum, 293, 1},	//284 Solid::Processor::NoExtensions (enum)
	{28, 82, 0, 0, Smoke::mf_static|Smoke::mf_enum, 293, 2},	//285 Solid::Processor::IntelMmx (enum)
	{28, 83, 0, 0, Smoke::mf_static|Smoke::mf_enum, 293, 3},	//286 Solid::Processor::IntelSse (enum)
	{28, 84, 0, 0, Smoke::mf_static|Smoke::mf_enum, 293, 4},	//287 Solid::Processor::IntelSse2 (enum)
	{28, 85, 0, 0, Smoke::mf_static|Smoke::mf_enum, 293, 5},	//288 Solid::Processor::IntelSse3 (enum)
	{28, 86, 0, 0, Smoke::mf_static|Smoke::mf_enum, 293, 6},	//289 Solid::Processor::IntelSse4 (enum)
	{28, 4, 0, 0, Smoke::mf_static|Smoke::mf_enum, 293, 7},	//290 Solid::Processor::Amd3DNow (enum)
	{28, 3, 0, 0, Smoke::mf_static|Smoke::mf_enum, 293, 8},	//291 Solid::Processor::AltiVec (enum)
	{28, 245, 0, 0, Smoke::mf_const, 302, 10},	//292 Solid::Processor::metaObject() const
	{28, 272, 3, 3, 0, 310, 11},	//293 Solid::Processor::qt_metacall(QMetaObject::Call, int, void**)
	{28, 248, 0, 0, Smoke::mf_const, 310, 12},	//294 Solid::Processor::number() const
	{28, 244, 0, 0, Smoke::mf_const, 310, 13},	//295 Solid::Processor::maxSpeed() const
	{28, 165, 0, 0, Smoke::mf_const, 299, 14},	//296 Solid::Processor::canChangeFrequency() const
	{28, 218, 0, 0, Smoke::mf_const, 294, 15},	//297 Solid::Processor::instructionSets() const
	{28, 186, 0, 0, Smoke::mf_static, 272, 16},	//298 Solid::Processor::deviceInterfaceType()
	{28, 283, 0, 0, Smoke::mf_static, 301, 9},	//299 Solid::Processor::staticMetaObject (static var)
	{29, 245, 0, 0, Smoke::mf_const, 302, 2},	//300 Solid::StorageAccess::metaObject() const
	{29, 272, 3, 3, 0, 310, 3},	//301 Solid::StorageAccess::qt_metacall(QMetaObject::Call, int, void**)
	{29, 327, 0, 0, Smoke::mf_dtor, 0, 12},	//302 Solid::StorageAccess::~StorageAccess()
	{29, 219, 0, 0, Smoke::mf_const, 299, 4},	//303 Solid::StorageAccess::isAccessible() const
	{29, 209, 0, 0, Smoke::mf_const, 181, 5},	//304 Solid::StorageAccess::filePath() const
	{29, 277, 0, 0, 0, 299, 6},	//305 Solid::StorageAccess::setup()
	{29, 294, 0, 0, 0, 299, 7},	//306 Solid::StorageAccess::teardown()
	{29, 154, 27, 2, 0, 0, 8},	//307 Solid::StorageAccess::accessibilityChanged(bool, const QString&)
	{29, 278, 19, 3, 0, 0, 9},	//308 Solid::StorageAccess::setupDone(Solid::ErrorType, QVariant, const QString&)
	{29, 295, 19, 3, 0, 0, 10},	//309 Solid::StorageAccess::teardownDone(Solid::ErrorType, QVariant, const QString&)
	{29, 186, 0, 0, Smoke::mf_static, 272, 11},	//310 Solid::StorageAccess::deviceInterfaceType()
	{29, 283, 0, 0, Smoke::mf_static, 301, 1},	//311 Solid::StorageAccess::staticMetaObject (static var)
	{30, 80, 0, 0, Smoke::mf_static|Smoke::mf_enum, 296, 1},	//312 Solid::StorageDrive::Ide (enum)
	{30, 148, 0, 0, Smoke::mf_static|Smoke::mf_enum, 296, 2},	//313 Solid::StorageDrive::Usb (enum)
	{30, 81, 0, 0, Smoke::mf_static|Smoke::mf_enum, 296, 3},	//314 Solid::StorageDrive::Ieee1394 (enum)
	{30, 124, 0, 0, Smoke::mf_static|Smoke::mf_enum, 296, 4},	//315 Solid::StorageDrive::Scsi (enum)
	{30, 123, 0, 0, Smoke::mf_static|Smoke::mf_enum, 296, 5},	//316 Solid::StorageDrive::Sata (enum)
	{30, 109, 0, 0, Smoke::mf_static|Smoke::mf_enum, 296, 6},	//317 Solid::StorageDrive::Platform (enum)
	{30, 71, 0, 0, Smoke::mf_static|Smoke::mf_enum, 297, 7},	//318 Solid::StorageDrive::HardDisk (enum)
	{30, 25, 0, 0, Smoke::mf_static|Smoke::mf_enum, 297, 8},	//319 Solid::StorageDrive::CdromDrive (enum)
	{30, 69, 0, 0, Smoke::mf_static|Smoke::mf_enum, 297, 9},	//320 Solid::StorageDrive::Floppy (enum)
	{30, 137, 0, 0, Smoke::mf_static|Smoke::mf_enum, 297, 10},	//321 Solid::StorageDrive::Tape (enum)
	{30, 28, 0, 0, Smoke::mf_static|Smoke::mf_enum, 297, 11},	//322 Solid::StorageDrive::CompactFlash (enum)
	{30, 95, 0, 0, Smoke::mf_static|Smoke::mf_enum, 297, 12},	//323 Solid::StorageDrive::MemoryStick (enum)
	{30, 129, 0, 0, Smoke::mf_static|Smoke::mf_enum, 297, 13},	//324 Solid::StorageDrive::SmartMedia (enum)
	{30, 125, 0, 0, Smoke::mf_static|Smoke::mf_enum, 297, 14},	//325 Solid::StorageDrive::SdMmc (enum)
	{30, 153, 0, 0, Smoke::mf_static|Smoke::mf_enum, 297, 15},	//326 Solid::StorageDrive::Xd (enum)
	{30, 245, 0, 0, Smoke::mf_const, 302, 17},	//327 Solid::StorageDrive::metaObject() const
	{30, 272, 3, 3, 0, 310, 18},	//328 Solid::StorageDrive::qt_metacall(QMetaObject::Call, int, void**)
	{30, 328, 0, 0, Smoke::mf_dtor, 0, 24},	//329 Solid::StorageDrive::~StorageDrive()
	{30, 164, 0, 0, Smoke::mf_const, 296, 19},	//330 Solid::StorageDrive::bus() const
	{30, 195, 0, 0, Smoke::mf_const, 297, 20},	//331 Solid::StorageDrive::driveType() const
	{30, 228, 0, 0, Smoke::mf_const, 299, 21},	//332 Solid::StorageDrive::isRemovable() const
	{30, 224, 0, 0, Smoke::mf_const, 299, 22},	//333 Solid::StorageDrive::isHotpluggable() const
	{30, 186, 0, 0, Smoke::mf_static, 272, 23},	//334 Solid::StorageDrive::deviceInterfaceType()
	{30, 283, 0, 0, Smoke::mf_static, 301, 16},	//335 Solid::StorageDrive::staticMetaObject (static var)
	{31, 106, 0, 0, Smoke::mf_static|Smoke::mf_enum, 298, 1},	//336 Solid::StorageVolume::Other (enum)
	{31, 146, 0, 0, Smoke::mf_static|Smoke::mf_enum, 298, 2},	//337 Solid::StorageVolume::Unused (enum)
	{31, 67, 0, 0, Smoke::mf_static|Smoke::mf_enum, 298, 3},	//338 Solid::StorageVolume::FileSystem (enum)
	{31, 107, 0, 0, Smoke::mf_static|Smoke::mf_enum, 298, 4},	//339 Solid::StorageVolume::PartitionTable (enum)
	{31, 122, 0, 0, Smoke::mf_static|Smoke::mf_enum, 298, 5},	//340 Solid::StorageVolume::Raid (enum)
	{31, 65, 0, 0, Smoke::mf_static|Smoke::mf_enum, 298, 6},	//341 Solid::StorageVolume::Encrypted (enum)
	{31, 245, 0, 0, Smoke::mf_const, 302, 8},	//342 Solid::StorageVolume::metaObject() const
	{31, 272, 3, 3, 0, 310, 9},	//343 Solid::StorageVolume::qt_metacall(QMetaObject::Call, int, void**)
	{31, 329, 0, 0, Smoke::mf_dtor, 0, 18},	//344 Solid::StorageVolume::~StorageVolume()
	{31, 225, 0, 0, Smoke::mf_const, 299, 10},	//345 Solid::StorageVolume::isIgnored() const
	{31, 304, 0, 0, Smoke::mf_const, 298, 11},	//346 Solid::StorageVolume::usage() const
	{31, 212, 0, 0, Smoke::mf_const, 181, 12},	//347 Solid::StorageVolume::fsType() const
	{31, 232, 0, 0, Smoke::mf_const, 181, 13},	//348 Solid::StorageVolume::label() const
	{31, 306, 0, 0, Smoke::mf_const, 181, 14},	//349 Solid::StorageVolume::uuid() const
	{31, 280, 0, 0, Smoke::mf_const, 311, 15},	//350 Solid::StorageVolume::size() const
	{31, 204, 0, 0, Smoke::mf_const, 268, 16},	//351 Solid::StorageVolume::encryptedContainer() const
	{31, 186, 0, 0, Smoke::mf_static, 272, 17},	//352 Solid::StorageVolume::deviceInterfaceType()
	{31, 283, 0, 0, Smoke::mf_static, 301, 7},	//353 Solid::StorageVolume::staticMetaObject (static var)
	{32, 245, 0, 0, Smoke::mf_const, 302, 2},	//354 Solid::Video::metaObject() const
	{32, 272, 3, 3, 0, 310, 3},	//355 Solid::Video::qt_metacall(QMetaObject::Call, int, void**)
	{32, 292, 0, 0, Smoke::mf_const, 185, 4},	//356 Solid::Video::supportedProtocols() const
	{32, 289, 10, 1, Smoke::mf_const, 185, 5},	//357 Solid::Video::supportedDrivers(QString) const
	{32, 289, 0, 0, Smoke::mf_const, 185, 6},	//358 Solid::Video::supportedDrivers() const
	{32, 197, 32, 1, Smoke::mf_const, 227, 7},	//359 Solid::Video::driverHandle(const QString&) const
	{32, 186, 0, 0, Smoke::mf_static, 272, 8},	//360 Solid::Video::deviceInterfaceType()
	{32, 283, 0, 0, Smoke::mf_static, 301, 1},	//361 Solid::Video::staticMetaObject (static var)
};

// Class ID, munged name ID (index into methodNames), method def (see methods) if >0 or number of overloads if <0
static Smoke::MethodMap solid_methodMaps[] = {
	{ 0, 0, 0 },	//0 (no method)
	{7, 100, 9},	//1 Solid::NoError
	{7, 138, 10},	//2 Solid::UnauthorizedOperation
	{8, 186, 14},	//3 Solid::AcAdapter::deviceInterfaceType
	{8, 226, 13},	//4 Solid::AcAdapter::isPlugged
	{8, 245, 11},	//5 Solid::AcAdapter::metaObject
	{8, 273, 12},	//6 Solid::AcAdapter::qt_metacall$$?
	{8, 283, 15},	//7 Solid::AcAdapter::staticMetaObject
	{9, 2, 16},	//8 Solid::AudioInterface::Alsa
	{9, 6, 20},	//9 Solid::AudioInterface::AudioControl
	{9, 7, 21},	//10 Solid::AudioInterface::AudioInput
	{9, 9, 22},	//11 Solid::AudioInterface::AudioOutput
	{9, 68, 25},	//12 Solid::AudioInterface::FirewireSoundcard
	{9, 78, 26},	//13 Solid::AudioInterface::Headset
	{9, 87, 23},	//14 Solid::AudioInterface::InternalSoundcard
	{9, 96, 27},	//15 Solid::AudioInterface::Modem
	{9, 103, 17},	//16 Solid::AudioInterface::OpenSoundSystem
	{9, 141, 18},	//17 Solid::AudioInterface::UnknownAudioDriver
	{9, 142, 19},	//18 Solid::AudioInterface::UnknownAudioInterfaceType
	{9, 149, 24},	//19 Solid::AudioInterface::UsbSoundcard
	{9, 186, 35},	//20 Solid::AudioInterface::deviceInterfaceType
	{9, 191, 33},	//21 Solid::AudioInterface::deviceType
	{9, 196, 30},	//22 Solid::AudioInterface::driver
	{9, 197, 31},	//23 Solid::AudioInterface::driverHandle
	{9, 245, 28},	//24 Solid::AudioInterface::metaObject
	{9, 246, 32},	//25 Solid::AudioInterface::name
	{9, 273, 29},	//26 Solid::AudioInterface::qt_metacall$$?
	{9, 281, 34},	//27 Solid::AudioInterface::soundcardType
	{9, 283, 36},	//28 Solid::AudioInterface::staticMetaObject
	{10, 20, 44},	//29 Solid::Battery::CameraBattery
	{10, 27, 46},	//30 Solid::Battery::Charging
	{10, 36, 47},	//31 Solid::Battery::Discharging
	{10, 88, 42},	//32 Solid::Battery::KeyboardBattery
	{10, 89, 43},	//33 Solid::Battery::KeyboardMouseBattery
	{10, 97, 41},	//34 Solid::Battery::MouseBattery
	{10, 99, 45},	//35 Solid::Battery::NoCharge
	{10, 108, 38},	//36 Solid::Battery::PdaBattery
	{10, 117, 40},	//37 Solid::Battery::PrimaryBattery
	{10, 143, 37},	//38 Solid::Battery::UnknownBattery
	{10, 147, 39},	//39 Solid::Battery::UpsBattery
	{10, 167, 52},	//40 Solid::Battery::chargePercent
	{10, 170, 54},	//41 Solid::Battery::chargeState
	{10, 186, 55},	//42 Solid::Battery::deviceInterfaceType
	{10, 226, 50},	//43 Solid::Battery::isPlugged
	{10, 227, 53},	//44 Solid::Battery::isRechargeable
	{10, 245, 48},	//45 Solid::Battery::metaObject
	{10, 273, 49},	//46 Solid::Battery::qt_metacall$$?
	{10, 283, 56},	//47 Solid::Battery::staticMetaObject
	{10, 300, 51},	//48 Solid::Battery::type
	{11, 181, 61},	//49 Solid::Block::device
	{11, 186, 62},	//50 Solid::Block::deviceInterfaceType
	{11, 187, 59},	//51 Solid::Block::deviceMajor
	{11, 188, 60},	//52 Solid::Block::deviceMinor
	{11, 245, 57},	//53 Solid::Block::metaObject
	{11, 273, 58},	//54 Solid::Block::qt_metacall$$?
	{11, 283, 63},	//55 Solid::Block::staticMetaObject
	{12, 91, 64},	//56 Solid::Button::LidButton
	{12, 111, 65},	//57 Solid::Button::PowerButton
	{12, 127, 66},	//58 Solid::Button::SleepButton
	{12, 136, 68},	//59 Solid::Button::TabletButton
	{12, 144, 67},	//60 Solid::Button::UnknownButtonType
	{12, 186, 74},	//61 Solid::Button::deviceInterfaceType
	{12, 213, 72},	//62 Solid::Button::hasState
	{12, 245, 69},	//63 Solid::Button::metaObject
	{12, 273, 70},	//64 Solid::Button::qt_metacall$$?
	{12, 282, 73},	//65 Solid::Button::stateValue
	{12, 283, 75},	//66 Solid::Button::staticMetaObject
	{12, 300, 71},	//67 Solid::Button::type
	{13, 186, 82},	//68 Solid::Camera::deviceInterfaceType
	{13, 198, 81},	//69 Solid::Camera::driverHandle$
	{13, 245, 76},	//70 Solid::Camera::metaObject
	{13, 273, 77},	//71 Solid::Camera::qt_metacall$$?
	{13, 283, 83},	//72 Solid::Camera::staticMetaObject
	{13, 289, 80},	//73 Solid::Camera::supportedDrivers
	{13, 290, 79},	//74 Solid::Camera::supportedDrivers$
	{13, 292, 78},	//75 Solid::Camera::supportedProtocols
	{14, 32, 85},	//76 Solid::Device::Device
	{14, 33, 86},	//77 Solid::Device::Device#
	{14, 34, 84},	//78 Solid::Device::Device$
	{14, 156, 98},	//79 Solid::Device::allDevices
	{14, 160, 97},	//80 Solid::Device::asDeviceInterface$
	{14, 215, 95},	//81 Solid::Device::icon
	{14, 223, 96},	//82 Solid::Device::isDeviceInterface$
	{14, 230, 89},	//83 Solid::Device::isValid
	{14, 234, 102},	//84 Solid::Device::listFromQuery#
	{14, 235, 101},	//85 Solid::Device::listFromQuery#$
	{14, 236, 104},	//86 Solid::Device::listFromQuery$
	{14, 237, 103},	//87 Solid::Device::listFromQuery$$
	{14, 239, 100},	//88 Solid::Device::listFromType$
	{14, 240, 99},	//89 Solid::Device::listFromType$$
	{14, 254, 88},	//90 Solid::Device::operator=#
	{14, 259, 92},	//91 Solid::Device::parent
	{14, 260, 91},	//92 Solid::Device::parentUdi
	{14, 265, 94},	//93 Solid::Device::product
	{14, 303, 90},	//94 Solid::Device::udi
	{14, 307, 93},	//95 Solid::Device::vendor
	{14, 316, 87},	//96 Solid::Device::~Device
	{15, 1, 117},	//97 Solid::DeviceInterface::AcAdapter
	{15, 8, 120},	//98 Solid::DeviceInterface::AudioInterface
	{15, 10, 118},	//99 Solid::DeviceInterface::Battery
	{15, 14, 108},	//100 Solid::DeviceInterface::Block
	{15, 18, 119},	//101 Solid::DeviceInterface::Button
	{15, 19, 114},	//102 Solid::DeviceInterface::Camera
	{15, 43, 121},	//103 Solid::DeviceInterface::DvbInterface
	{15, 70, 106},	//104 Solid::DeviceInterface::GenericInterface
	{15, 90, 125},	//105 Solid::DeviceInterface::Last
	{15, 98, 116},	//106 Solid::DeviceInterface::NetworkInterface
	{15, 104, 113},	//107 Solid::DeviceInterface::OpticalDisc
	{15, 105, 111},	//108 Solid::DeviceInterface::OpticalDrive
	{15, 110, 115},	//109 Solid::DeviceInterface::PortableMediaPlayer
	{15, 118, 107},	//110 Solid::DeviceInterface::Processor
	{15, 126, 123},	//111 Solid::DeviceInterface::SerialInterface
	{15, 128, 124},	//112 Solid::DeviceInterface::SmartCardReader
	{15, 131, 109},	//113 Solid::DeviceInterface::StorageAccess
	{15, 132, 110},	//114 Solid::DeviceInterface::StorageDrive
	{15, 133, 112},	//115 Solid::DeviceInterface::StorageVolume
	{15, 140, 105},	//116 Solid::DeviceInterface::Unknown
	{15, 150, 122},	//117 Solid::DeviceInterface::Video
	{15, 230, 129},	//118 Solid::DeviceInterface::isValid
	{15, 245, 126},	//119 Solid::DeviceInterface::metaObject
	{15, 273, 127},	//120 Solid::DeviceInterface::qt_metacall$$?
	{15, 283, 132},	//121 Solid::DeviceInterface::staticMetaObject
	{15, 288, 131},	//122 Solid::DeviceInterface::stringToType$
	{15, 302, 130},	//123 Solid::DeviceInterface::typeToString$
	{15, 317, 128},	//124 Solid::DeviceInterface::~DeviceInterface
	{16, 35, 135},	//125 Solid::DeviceNotifier::DeviceNotifier
	{16, 184, 137},	//126 Solid::DeviceNotifier::deviceAdded$
	{16, 190, 138},	//127 Solid::DeviceNotifier::deviceRemoved$
	{16, 217, 139},	//128 Solid::DeviceNotifier::instance
	{16, 245, 133},	//129 Solid::DeviceNotifier::metaObject
	{16, 273, 134},	//130 Solid::DeviceNotifier::qt_metacall$$?
	{16, 283, 140},	//131 Solid::DeviceNotifier::staticMetaObject
	{16, 318, 136},	//132 Solid::DeviceNotifier::~DeviceNotifier
	{17, 38, 142},	//133 Solid::DvbInterface::DvbAudio
	{17, 39, 143},	//134 Solid::DvbInterface::DvbCa
	{17, 40, 144},	//135 Solid::DvbInterface::DvbDemux
	{17, 41, 145},	//136 Solid::DvbInterface::DvbDvr
	{17, 42, 146},	//137 Solid::DvbInterface::DvbFrontend
	{17, 44, 147},	//138 Solid::DvbInterface::DvbNet
	{17, 45, 148},	//139 Solid::DvbInterface::DvbOsd
	{17, 46, 149},	//140 Solid::DvbInterface::DvbSec
	{17, 47, 141},	//141 Solid::DvbInterface::DvbUnknown
	{17, 48, 150},	//142 Solid::DvbInterface::DvbVideo
	{17, 181, 153},	//143 Solid::DvbInterface::device
	{17, 182, 154},	//144 Solid::DvbInterface::deviceAdapter
	{17, 185, 156},	//145 Solid::DvbInterface::deviceIndex
	{17, 186, 157},	//146 Solid::DvbInterface::deviceInterfaceType
	{17, 191, 155},	//147 Solid::DvbInterface::deviceType
	{17, 245, 151},	//148 Solid::DvbInterface::metaObject
	{17, 273, 152},	//149 Solid::DvbInterface::qt_metacall$$?
	{17, 283, 158},	//150 Solid::DvbInterface::staticMetaObject
	{18, 119, 160},	//151 Solid::GenericInterface::PropertyAdded
	{18, 120, 159},	//152 Solid::GenericInterface::PropertyModified
	{18, 121, 161},	//153 Solid::GenericInterface::PropertyRemoved
	{18, 157, 165},	//154 Solid::GenericInterface::allProperties
	{18, 186, 167},	//155 Solid::GenericInterface::deviceInterfaceType
	{18, 245, 162},	//156 Solid::GenericInterface::metaObject
	{18, 267, 164},	//157 Solid::GenericInterface::property$
	{18, 271, 166},	//158 Solid::GenericInterface::propertyExists$
	{18, 273, 163},	//159 Solid::GenericInterface::qt_metacall$$?
	{18, 283, 168},	//160 Solid::GenericInterface::staticMetaObject
	{19, 186, 175},	//161 Solid::NetworkInterface::deviceInterfaceType
	{19, 214, 173},	//162 Solid::NetworkInterface::hwAddress
	{19, 216, 171},	//163 Solid::NetworkInterface::ifaceName
	{19, 231, 172},	//164 Solid::NetworkInterface::isWireless
	{19, 241, 174},	//165 Solid::NetworkInterface::macAddress
	{19, 245, 169},	//166 Solid::NetworkInterface::metaObject
	{19, 273, 170},	//167 Solid::NetworkInterface::qt_metacall$$?
	{19, 283, 176},	//168 Solid::NetworkInterface::staticMetaObject
	{20, 29, 181},	//169 Solid::Networking::Connected
	{20, 30, 180},	//170 Solid::Networking::Connecting
	{20, 37, 179},	//171 Solid::Networking::Disconnecting
	{20, 92, 184},	//172 Solid::Networking::Managed
	{20, 93, 182},	//173 Solid::Networking::Manual
	{20, 102, 183},	//174 Solid::Networking::OnNextStatusChange
	{20, 139, 178},	//175 Solid::Networking::Unconnected
	{20, 140, 177},	//176 Solid::Networking::Unknown
	{20, 247, 186},	//177 Solid::Networking::notifier
	{20, 284, 185},	//178 Solid::Networking::status
	{22, 5, 187},	//179 Solid::OpticalDisc::Audio
	{22, 15, 205},	//180 Solid::OpticalDisc::BluRayRecordable
	{22, 16, 206},	//181 Solid::OpticalDisc::BluRayRewritable
	{22, 17, 204},	//182 Solid::OpticalDisc::BluRayRom
	{22, 21, 194},	//183 Solid::OpticalDisc::CdRecordable
	{22, 22, 195},	//184 Solid::OpticalDisc::CdRewritable
	{22, 23, 193},	//185 Solid::OpticalDisc::CdRom
	{22, 31, 188},	//186 Solid::OpticalDisc::Data
	{22, 50, 200},	//187 Solid::OpticalDisc::DvdPlusRecordable
	{22, 51, 202},	//188 Solid::OpticalDisc::DvdPlusRecordableDuallayer
	{22, 52, 201},	//189 Solid::OpticalDisc::DvdPlusRewritable
	{22, 53, 203},	//190 Solid::OpticalDisc::DvdPlusRewritableDuallayer
	{22, 54, 197},	//191 Solid::OpticalDisc::DvdRam
	{22, 55, 198},	//192 Solid::OpticalDisc::DvdRecordable
	{22, 56, 199},	//193 Solid::OpticalDisc::DvdRewritable
	{22, 57, 196},	//194 Solid::OpticalDisc::DvdRom
	{22, 73, 208},	//195 Solid::OpticalDisc::HdDvdRecordable
	{22, 74, 209},	//196 Solid::OpticalDisc::HdDvdRewritable
	{22, 75, 207},	//197 Solid::OpticalDisc::HdDvdRom
	{22, 134, 190},	//198 Solid::OpticalDisc::SuperVideoCd
	{22, 145, 192},	//199 Solid::OpticalDisc::UnknownDiscType
	{22, 151, 189},	//200 Solid::OpticalDisc::VideoCd
	{22, 152, 191},	//201 Solid::OpticalDisc::VideoDvd
	{22, 161, 212},	//202 Solid::OpticalDisc::availableContent
	{22, 166, 217},	//203 Solid::OpticalDisc::capacity
	{22, 186, 218},	//204 Solid::OpticalDisc::deviceInterfaceType
	{22, 192, 213},	//205 Solid::OpticalDisc::discType
	{22, 220, 214},	//206 Solid::OpticalDisc::isAppendable
	{22, 221, 215},	//207 Solid::OpticalDisc::isBlank
	{22, 229, 216},	//208 Solid::OpticalDisc::isRewritable
	{22, 245, 210},	//209 Solid::OpticalDisc::metaObject
	{22, 273, 211},	//210 Solid::OpticalDisc::qt_metacall$$?
	{22, 283, 219},	//211 Solid::OpticalDisc::staticMetaObject
	{23, 11, 230},	//212 Solid::OpticalDrive::Bd
	{23, 12, 231},	//213 Solid::OpticalDrive::Bdr
	{23, 13, 232},	//214 Solid::OpticalDrive::Bdre
	{23, 24, 220},	//215 Solid::OpticalDrive::Cdr
	{23, 26, 221},	//216 Solid::OpticalDrive::Cdrw
	{23, 49, 222},	//217 Solid::OpticalDrive::Dvd
	{23, 58, 228},	//218 Solid::OpticalDrive::Dvdplusdl
	{23, 59, 229},	//219 Solid::OpticalDrive::Dvdplusdlrw
	{23, 60, 226},	//220 Solid::OpticalDrive::Dvdplusr
	{23, 61, 227},	//221 Solid::OpticalDrive::Dvdplusrw
	{23, 62, 223},	//222 Solid::OpticalDrive::Dvdr
	{23, 63, 225},	//223 Solid::OpticalDrive::Dvdram
	{23, 64, 224},	//224 Solid::OpticalDrive::Dvdrw
	{23, 72, 233},	//225 Solid::OpticalDrive::HdDvd
	{23, 76, 234},	//226 Solid::OpticalDrive::HdDvdr
	{23, 77, 235},	//227 Solid::OpticalDrive::HdDvdrw
	{23, 186, 243},	//228 Solid::OpticalDrive::deviceInterfaceType
	{23, 199, 242},	//229 Solid::OpticalDrive::eject
	{23, 245, 236},	//230 Solid::OpticalDrive::metaObject
	{23, 273, 237},	//231 Solid::OpticalDrive::qt_metacall$$?
	{23, 274, 239},	//232 Solid::OpticalDrive::readSpeed
	{23, 283, 244},	//233 Solid::OpticalDrive::staticMetaObject
	{23, 291, 238},	//234 Solid::OpticalDrive::supportedMedia
	{23, 308, 240},	//235 Solid::OpticalDrive::writeSpeed
	{23, 309, 241},	//236 Solid::OpticalDrive::writeSpeeds
	{24, 186, 251},	//237 Solid::PortableMediaPlayer::deviceInterfaceType
	{24, 198, 250},	//238 Solid::PortableMediaPlayer::driverHandle$
	{24, 245, 245},	//239 Solid::PortableMediaPlayer::metaObject
	{24, 273, 246},	//240 Solid::PortableMediaPlayer::qt_metacall$$?
	{24, 283, 252},	//241 Solid::PortableMediaPlayer::staticMetaObject
	{24, 289, 249},	//242 Solid::PortableMediaPlayer::supportedDrivers
	{24, 290, 248},	//243 Solid::PortableMediaPlayer::supportedDrivers$
	{24, 292, 247},	//244 Solid::PortableMediaPlayer::supportedProtocols
	{25, 79, 255},	//245 Solid::PowerManagement::HibernateState
	{25, 130, 253},	//246 Solid::PowerManagement::StandbyState
	{25, 135, 254},	//247 Solid::PowerManagement::SuspendState
	{25, 158, 256},	//248 Solid::PowerManagement::appShouldConserveResources
	{25, 162, 260},	//249 Solid::PowerManagement::beginSuppressingSleep
	{25, 163, 259},	//250 Solid::PowerManagement::beginSuppressingSleep$
	{25, 247, 262},	//251 Solid::PowerManagement::notifier
	{25, 276, 258},	//252 Solid::PowerManagement::requestSleep$#$
	{25, 286, 261},	//253 Solid::PowerManagement::stopSuppressingSleep$
	{25, 293, 257},	//254 Solid::PowerManagement::supportedSleepStates
	{27, 66, 263},	//255 Solid::Predicate::Equals
	{27, 94, 264},	//256 Solid::Predicate::Mask
	{27, 112, 265},	//257 Solid::Predicate::Predicate
	{27, 113, 266},	//258 Solid::Predicate::Predicate#
	{27, 114, -1},	//259 Solid::Predicate::Predicate$
	{27, 115, -4},	//260 Solid::Predicate::Predicate$$#
	{27, 116, -7},	//261 Solid::Predicate::Predicate$$#$
	{27, 211, 283},	//262 Solid::Predicate::fromString$
	{27, 230, 279},	//263 Solid::Predicate::isValid
	{27, 243, 280},	//264 Solid::Predicate::matches#
	{27, 250, 275},	//265 Solid::Predicate::operator&#
	{27, 252, 276},	//266 Solid::Predicate::operator&=#
	{27, 254, 274},	//267 Solid::Predicate::operator=#
	{27, 256, 277},	//268 Solid::Predicate::operator|#
	{27, 258, 278},	//269 Solid::Predicate::operator|=#
	{27, 299, 282},	//270 Solid::Predicate::toString
	{27, 305, 281},	//271 Solid::Predicate::usedTypes
	{27, 325, 273},	//272 Solid::Predicate::~Predicate
	{28, 3, 291},	//273 Solid::Processor::AltiVec
	{28, 4, 290},	//274 Solid::Processor::Amd3DNow
	{28, 82, 285},	//275 Solid::Processor::IntelMmx
	{28, 83, 286},	//276 Solid::Processor::IntelSse
	{28, 84, 287},	//277 Solid::Processor::IntelSse2
	{28, 85, 288},	//278 Solid::Processor::IntelSse3
	{28, 86, 289},	//279 Solid::Processor::IntelSse4
	{28, 101, 284},	//280 Solid::Processor::NoExtensions
	{28, 165, 296},	//281 Solid::Processor::canChangeFrequency
	{28, 186, 298},	//282 Solid::Processor::deviceInterfaceType
	{28, 218, 297},	//283 Solid::Processor::instructionSets
	{28, 244, 295},	//284 Solid::Processor::maxSpeed
	{28, 245, 292},	//285 Solid::Processor::metaObject
	{28, 248, 294},	//286 Solid::Processor::number
	{28, 273, 293},	//287 Solid::Processor::qt_metacall$$?
	{28, 283, 299},	//288 Solid::Processor::staticMetaObject
	{29, 155, 307},	//289 Solid::StorageAccess::accessibilityChanged$$
	{29, 186, 310},	//290 Solid::StorageAccess::deviceInterfaceType
	{29, 209, 304},	//291 Solid::StorageAccess::filePath
	{29, 219, 303},	//292 Solid::StorageAccess::isAccessible
	{29, 245, 300},	//293 Solid::StorageAccess::metaObject
	{29, 273, 301},	//294 Solid::StorageAccess::qt_metacall$$?
	{29, 277, 305},	//295 Solid::StorageAccess::setup
	{29, 279, 308},	//296 Solid::StorageAccess::setupDone$#$
	{29, 283, 311},	//297 Solid::StorageAccess::staticMetaObject
	{29, 294, 306},	//298 Solid::StorageAccess::teardown
	{29, 296, 309},	//299 Solid::StorageAccess::teardownDone$#$
	{29, 327, 302},	//300 Solid::StorageAccess::~StorageAccess
	{30, 25, 319},	//301 Solid::StorageDrive::CdromDrive
	{30, 28, 322},	//302 Solid::StorageDrive::CompactFlash
	{30, 69, 320},	//303 Solid::StorageDrive::Floppy
	{30, 71, 318},	//304 Solid::StorageDrive::HardDisk
	{30, 80, 312},	//305 Solid::StorageDrive::Ide
	{30, 81, 314},	//306 Solid::StorageDrive::Ieee1394
	{30, 95, 323},	//307 Solid::StorageDrive::MemoryStick
	{30, 109, 317},	//308 Solid::StorageDrive::Platform
	{30, 123, 316},	//309 Solid::StorageDrive::Sata
	{30, 124, 315},	//310 Solid::StorageDrive::Scsi
	{30, 125, 325},	//311 Solid::StorageDrive::SdMmc
	{30, 129, 324},	//312 Solid::StorageDrive::SmartMedia
	{30, 137, 321},	//313 Solid::StorageDrive::Tape
	{30, 148, 313},	//314 Solid::StorageDrive::Usb
	{30, 153, 326},	//315 Solid::StorageDrive::Xd
	{30, 164, 330},	//316 Solid::StorageDrive::bus
	{30, 186, 334},	//317 Solid::StorageDrive::deviceInterfaceType
	{30, 195, 331},	//318 Solid::StorageDrive::driveType
	{30, 224, 333},	//319 Solid::StorageDrive::isHotpluggable
	{30, 228, 332},	//320 Solid::StorageDrive::isRemovable
	{30, 245, 327},	//321 Solid::StorageDrive::metaObject
	{30, 273, 328},	//322 Solid::StorageDrive::qt_metacall$$?
	{30, 283, 335},	//323 Solid::StorageDrive::staticMetaObject
	{30, 328, 329},	//324 Solid::StorageDrive::~StorageDrive
	{31, 65, 341},	//325 Solid::StorageVolume::Encrypted
	{31, 67, 338},	//326 Solid::StorageVolume::FileSystem
	{31, 106, 336},	//327 Solid::StorageVolume::Other
	{31, 107, 339},	//328 Solid::StorageVolume::PartitionTable
	{31, 122, 340},	//329 Solid::StorageVolume::Raid
	{31, 146, 337},	//330 Solid::StorageVolume::Unused
	{31, 186, 352},	//331 Solid::StorageVolume::deviceInterfaceType
	{31, 204, 351},	//332 Solid::StorageVolume::encryptedContainer
	{31, 212, 347},	//333 Solid::StorageVolume::fsType
	{31, 225, 345},	//334 Solid::StorageVolume::isIgnored
	{31, 232, 348},	//335 Solid::StorageVolume::label
	{31, 245, 342},	//336 Solid::StorageVolume::metaObject
	{31, 273, 343},	//337 Solid::StorageVolume::qt_metacall$$?
	{31, 280, 350},	//338 Solid::StorageVolume::size
	{31, 283, 353},	//339 Solid::StorageVolume::staticMetaObject
	{31, 304, 346},	//340 Solid::StorageVolume::usage
	{31, 306, 349},	//341 Solid::StorageVolume::uuid
	{31, 329, 344},	//342 Solid::StorageVolume::~StorageVolume
	{32, 186, 360},	//343 Solid::Video::deviceInterfaceType
	{32, 198, 359},	//344 Solid::Video::driverHandle$
	{32, 245, 354},	//345 Solid::Video::metaObject
	{32, 273, 355},	//346 Solid::Video::qt_metacall$$?
	{32, 283, 361},	//347 Solid::Video::staticMetaObject
	{32, 289, 358},	//348 Solid::Video::supportedDrivers
	{32, 290, 357},	//349 Solid::Video::supportedDrivers$
	{32, 292, 356},	//350 Solid::Video::supportedProtocols
};

static Smoke::Index solid_ambiguousMethodList[] = {
    0,
    272,  // Solid::Predicate::Predicate(const QString&)
    271,  // Solid::Predicate::Predicate(const Solid::DeviceInterface::Type&)
    0,
    270,  // Solid::Predicate::Predicate(const QString&, const QString&, const QVariant&)
    268,  // Solid::Predicate::Predicate(const Solid::DeviceInterface::Type&, const QString&, const QVariant&)
    0,
    267,  // Solid::Predicate::Predicate(const Solid::DeviceInterface::Type&, const QString&, const QVariant&, Solid::Predicate::ComparisonOperator)
    269,  // Solid::Predicate::Predicate(const QString&, const QString&, const QVariant&, Solid::Predicate::ComparisonOperator)
    0,
};


void init_qt_Smoke();

static bool initialized = false;
Smoke *solid_Smoke = 0;

// Create the Smoke instance encapsulating all the above.
void init_solid_Smoke() {
    if (initialized) return;
    init_qt_Smoke();
    solid_Smoke = new Smoke(
        "solid",
        solid_classes, 32,
        solid_methods, 362,
        solid_methodMaps, 350,
        solid_methodNames, 330,
        solid_types, 312,
        solid_inheritanceList,
        solid_argumentList,
        solid_ambiguousMethodList,
        solid_cast );
    initialized = true;
}
