#include <qabstractitemmodel.h>
#include <qaction.h>
#include <qbrush.h>
#include <qchar.h>
#include <qcoreevent.h>
#include <qdom.h>
#include <qevent.h>
#include <qfont.h>
#include <qimage.h>
#include <qline.h>
#include <qmenu.h>
#include <qmimedata.h>
#include <qnamespace.h>
#include <qobject.h>
#include <qobjectdefs.h>
#include <qpaintdevice.h>
#include <qpaintengine.h>
#include <qpainterpath.h>
#include <qpalette.h>
#include <qpixmap.h>
#include <qpoint.h>
#include <qrect.h>
#include <qsize.h>
#include <qstyle.h>
#include <qtextformat.h>
#include <qvariant.h>
#include <qwidget.h>
#include <kaboutdata.h>
#include <kaction.h>
#include <kactioncollection.h>
#include <kcompletion.h>
#include <kcomponentdata.h>
#include <kconfig.h>
#include <kconfiggroup.h>
#include <kicon.h>
#include <kparts/browserextension.h>
#include <kparts/event.h>
#include <kparts/factory.h>
#include <kparts/part.h>
#include <kparts/partmanager.h>
#include <kpluginfactory.h>
#include <ktexteditor/annotationinterface.h>
#include <ktexteditor/attribute.h>
#include <ktexteditor/codecompletioninterface.h>
#include <ktexteditor/codecompletionmodel.h>
#include <ktexteditor/commandinterface.h>
#include <ktexteditor/configinterface.h>
#include <ktexteditor/configpage.h>
#include <ktexteditor/containerinterface.h>
#include <ktexteditor/cursor.h>
#include <ktexteditor/cursorfeedback.h>
#include <ktexteditor/document.h>
#include <ktexteditor/editor.h>
#include <ktexteditor/editorchooser.h>
#include <ktexteditor/factory.h>
#include <ktexteditor/markinterface.h>
#include <ktexteditor/modificationinterface.h>
#include <ktexteditor/plugin.h>
#include <ktexteditor/range.h>
#include <ktexteditor/rangefeedback.h>
#include <ktexteditor/searchinterface.h>
#include <ktexteditor/sessionconfiginterface.h>
#include <ktexteditor/smartcursor.h>
#include <ktexteditor/smartinterface.h>
#include <ktexteditor/smartrange.h>
#include <ktexteditor/templateinterface.h>
#include <ktexteditor/texthintinterface.h>
#include <ktexteditor/variableinterface.h>
#include <ktexteditor/view.h>
#include <kurl.h>
#include <kxmlguiclient.h>

#include <smoke.h>

#include <ktexteditor_smoke.h>

static void *ktexteditor_cast(void *xptr, Smoke::Index from, Smoke::Index to) {
    switch(from) {
      case 1:	//KAboutData
	switch(to) {
	    case 1: return (void*)(KAboutData*)(KAboutData*)xptr;
	  default: return xptr;
	}
      case 2:	//KAction
	switch(to) {
	    case 61: return (void*)(QAction*)(KAction*)xptr;
	    case 89: return (void*)(QObject*)(KAction*)xptr;
	    case 2: return (void*)(KAction*)(KAction*)xptr;
	  default: return xptr;
	}
      case 3:	//KActionCollection
	switch(to) {
	    case 89: return (void*)(QObject*)(KActionCollection*)xptr;
	    case 3: return (void*)(KActionCollection*)(KActionCollection*)xptr;
	  default: return xptr;
	}
      case 4:	//KCompletion
	switch(to) {
	    case 89: return (void*)(QObject*)(KCompletion*)xptr;
	    case 4: return (void*)(KCompletion*)(KCompletion*)xptr;
	  default: return xptr;
	}
      case 5:	//KComponentData
	switch(to) {
	    case 5: return (void*)(KComponentData*)(KComponentData*)xptr;
	  default: return xptr;
	}
      case 6:	//KConfig
	switch(to) {
	    case 6: return (void*)(KConfig*)(KConfig*)xptr;
	  default: return xptr;
	}
      case 7:	//KConfigGroup
	switch(to) {
	    case 7: return (void*)(KConfigGroup*)(KConfigGroup*)xptr;
	  default: return xptr;
	}
      case 8:	//KIcon
	switch(to) {
	    case 8: return (void*)(KIcon*)(KIcon*)xptr;
	  default: return xptr;
	}
      case 10:	//KParts::Factory
	switch(to) {
	    case 19: return (void*)(KPluginFactory*)(KParts::Factory*)xptr;
	    case 89: return (void*)(QObject*)(KParts::Factory*)xptr;
	    case 10: return (void*)(KParts::Factory*)(KParts::Factory*)xptr;
	    case 38: return (void*)(KTextEditor::Factory*)(KParts::Factory*)xptr;
	  default: return xptr;
	}
      case 11:	//KParts::GUIActivateEvent
	switch(to) {
	    case 74: return (void*)(QEvent*)(KParts::GUIActivateEvent*)xptr;
	    case 11: return (void*)(KParts::GUIActivateEvent*)(KParts::GUIActivateEvent*)xptr;
	  default: return xptr;
	}
      case 12:	//KParts::Part
	switch(to) {
	    case 14: return (void*)(KParts::PartBase*)(KParts::Part*)xptr;
	    case 59: return (void*)(KXMLGUIClient*)(KParts::Part*)xptr;
	    case 89: return (void*)(QObject*)(KParts::Part*)xptr;
	    case 12: return (void*)(KParts::Part*)(KParts::Part*)xptr;
	    case 17: return (void*)(KParts::ReadOnlyPart*)(KParts::Part*)xptr;
	    case 18: return (void*)(KParts::ReadWritePart*)(KParts::Part*)xptr;
	    case 35: return (void*)(KTextEditor::Document*)(KParts::Part*)xptr;
	  default: return xptr;
	}
      case 13:	//KParts::PartActivateEvent
	switch(to) {
	    case 74: return (void*)(QEvent*)(KParts::PartActivateEvent*)xptr;
	    case 13: return (void*)(KParts::PartActivateEvent*)(KParts::PartActivateEvent*)xptr;
	  default: return xptr;
	}
      case 14:	//KParts::PartBase
	switch(to) {
	    case 59: return (void*)(KXMLGUIClient*)(KParts::PartBase*)xptr;
	    case 14: return (void*)(KParts::PartBase*)(KParts::PartBase*)xptr;
	    case 12: return (void*)(KParts::Part*)(KParts::PartBase*)xptr;
	    case 17: return (void*)(KParts::ReadOnlyPart*)(KParts::PartBase*)xptr;
	    case 18: return (void*)(KParts::ReadWritePart*)(KParts::PartBase*)xptr;
	    case 35: return (void*)(KTextEditor::Document*)(KParts::PartBase*)xptr;
	  default: return xptr;
	}
      case 15:	//KParts::PartManager
	switch(to) {
	    case 89: return (void*)(QObject*)(KParts::PartManager*)xptr;
	    case 15: return (void*)(KParts::PartManager*)(KParts::PartManager*)xptr;
	  default: return xptr;
	}
      case 16:	//KParts::PartSelectEvent
	switch(to) {
	    case 74: return (void*)(QEvent*)(KParts::PartSelectEvent*)xptr;
	    case 16: return (void*)(KParts::PartSelectEvent*)(KParts::PartSelectEvent*)xptr;
	  default: return xptr;
	}
      case 17:	//KParts::ReadOnlyPart
	switch(to) {
	    case 12: return (void*)(KParts::Part*)(KParts::ReadOnlyPart*)xptr;
	    case 14: return (void*)(KParts::PartBase*)(KParts::ReadOnlyPart*)xptr;
	    case 59: return (void*)(KXMLGUIClient*)(KParts::ReadOnlyPart*)xptr;
	    case 89: return (void*)(QObject*)(KParts::ReadOnlyPart*)xptr;
	    case 17: return (void*)(KParts::ReadOnlyPart*)(KParts::ReadOnlyPart*)xptr;
	    case 18: return (void*)(KParts::ReadWritePart*)(KParts::ReadOnlyPart*)xptr;
	    case 35: return (void*)(KTextEditor::Document*)(KParts::ReadOnlyPart*)xptr;
	  default: return xptr;
	}
      case 18:	//KParts::ReadWritePart
	switch(to) {
	    case 17: return (void*)(KParts::ReadOnlyPart*)(KParts::ReadWritePart*)xptr;
	    case 12: return (void*)(KParts::Part*)(KParts::ReadWritePart*)xptr;
	    case 14: return (void*)(KParts::PartBase*)(KParts::ReadWritePart*)xptr;
	    case 59: return (void*)(KXMLGUIClient*)(KParts::ReadWritePart*)xptr;
	    case 89: return (void*)(QObject*)(KParts::ReadWritePart*)xptr;
	    case 18: return (void*)(KParts::ReadWritePart*)(KParts::ReadWritePart*)xptr;
	    case 35: return (void*)(KTextEditor::Document*)(KParts::ReadWritePart*)xptr;
	  default: return xptr;
	}
      case 19:	//KPluginFactory
	switch(to) {
	    case 89: return (void*)(QObject*)(KPluginFactory*)xptr;
	    case 19: return (void*)(KPluginFactory*)(KPluginFactory*)xptr;
	    case 10: return (void*)(KParts::Factory*)(KPluginFactory*)xptr;
	    case 38: return (void*)(KTextEditor::Factory*)(KPluginFactory*)xptr;
	  default: return xptr;
	}
      case 21:	//KTextEditor::AnnotationInterface
	switch(to) {
	    case 21: return (void*)(KTextEditor::AnnotationInterface*)(KTextEditor::AnnotationInterface*)xptr;
	    case 23: return (void*)(KTextEditor::AnnotationViewInterface*)(KTextEditor::AnnotationInterface*)xptr;
	  default: return xptr;
	}
      case 22:	//KTextEditor::AnnotationModel
	switch(to) {
	    case 89: return (void*)(QObject*)(KTextEditor::AnnotationModel*)xptr;
	    case 22: return (void*)(KTextEditor::AnnotationModel*)(KTextEditor::AnnotationModel*)xptr;
	  default: return xptr;
	}
      case 23:	//KTextEditor::AnnotationViewInterface
	switch(to) {
	    case 21: return (void*)(KTextEditor::AnnotationInterface*)(KTextEditor::AnnotationViewInterface*)xptr;
	    case 23: return (void*)(KTextEditor::AnnotationViewInterface*)(KTextEditor::AnnotationViewInterface*)xptr;
	  default: return xptr;
	}
      case 24:	//KTextEditor::Attribute
	switch(to) {
	    case 106: return (void*)(QTextCharFormat*)(KTextEditor::Attribute*)xptr;
	    case 107: return (void*)(QTextFormat*)(KTextEditor::Attribute*)xptr;
	    case 24: return (void*)(KTextEditor::Attribute*)(KTextEditor::Attribute*)xptr;
	  default: return xptr;
	}
      case 25:	//KTextEditor::CodeCompletionInterface
	switch(to) {
	    case 25: return (void*)(KTextEditor::CodeCompletionInterface*)(KTextEditor::CodeCompletionInterface*)xptr;
	  default: return xptr;
	}
      case 26:	//KTextEditor::CodeCompletionModel
	switch(to) {
	    case 60: return (void*)(QAbstractItemModel*)(KTextEditor::CodeCompletionModel*)xptr;
	    case 89: return (void*)(QObject*)(KTextEditor::CodeCompletionModel*)xptr;
	    case 26: return (void*)(KTextEditor::CodeCompletionModel*)(KTextEditor::CodeCompletionModel*)xptr;
	    case 27: return (void*)(KTextEditor::CodeCompletionModel2*)(KTextEditor::CodeCompletionModel*)xptr;
	  default: return xptr;
	}
      case 27:	//KTextEditor::CodeCompletionModel2
	switch(to) {
	    case 26: return (void*)(KTextEditor::CodeCompletionModel*)(KTextEditor::CodeCompletionModel2*)xptr;
	    case 60: return (void*)(QAbstractItemModel*)(KTextEditor::CodeCompletionModel2*)xptr;
	    case 89: return (void*)(QObject*)(KTextEditor::CodeCompletionModel2*)xptr;
	    case 27: return (void*)(KTextEditor::CodeCompletionModel2*)(KTextEditor::CodeCompletionModel2*)xptr;
	  default: return xptr;
	}
      case 28:	//KTextEditor::Command
	switch(to) {
	    case 28: return (void*)(KTextEditor::Command*)(KTextEditor::Command*)xptr;
	  default: return xptr;
	}
      case 29:	//KTextEditor::CommandExtension
	switch(to) {
	    case 29: return (void*)(KTextEditor::CommandExtension*)(KTextEditor::CommandExtension*)xptr;
	  default: return xptr;
	}
      case 30:	//KTextEditor::CommandInterface
	switch(to) {
	    case 30: return (void*)(KTextEditor::CommandInterface*)(KTextEditor::CommandInterface*)xptr;
	  default: return xptr;
	}
      case 31:	//KTextEditor::ConfigInterface
	switch(to) {
	    case 31: return (void*)(KTextEditor::ConfigInterface*)(KTextEditor::ConfigInterface*)xptr;
	  default: return xptr;
	}
      case 32:	//KTextEditor::ConfigPage
	switch(to) {
	    case 111: return (void*)(QWidget*)(KTextEditor::ConfigPage*)xptr;
	    case 89: return (void*)(QObject*)(KTextEditor::ConfigPage*)xptr;
	    case 90: return (void*)(QPaintDevice*)(KTextEditor::ConfigPage*)xptr;
	    case 32: return (void*)(KTextEditor::ConfigPage*)(KTextEditor::ConfigPage*)xptr;
	  default: return xptr;
	}
      case 33:	//KTextEditor::ContainerInterface
	switch(to) {
	    case 33: return (void*)(KTextEditor::ContainerInterface*)(KTextEditor::ContainerInterface*)xptr;
	  default: return xptr;
	}
      case 34:	//KTextEditor::Cursor
	switch(to) {
	    case 34: return (void*)(KTextEditor::Cursor*)(KTextEditor::Cursor*)xptr;
	    case 47: return (void*)(KTextEditor::SmartCursor*)(KTextEditor::Cursor*)xptr;
	  default: return xptr;
	}
      case 35:	//KTextEditor::Document
	switch(to) {
	    case 18: return (void*)(KParts::ReadWritePart*)(KTextEditor::Document*)xptr;
	    case 17: return (void*)(KParts::ReadOnlyPart*)(KTextEditor::Document*)xptr;
	    case 12: return (void*)(KParts::Part*)(KTextEditor::Document*)xptr;
	    case 14: return (void*)(KParts::PartBase*)(KTextEditor::Document*)xptr;
	    case 59: return (void*)(KXMLGUIClient*)(KTextEditor::Document*)xptr;
	    case 89: return (void*)(QObject*)(KTextEditor::Document*)xptr;
	    case 35: return (void*)(KTextEditor::Document*)(KTextEditor::Document*)xptr;
	  default: return xptr;
	}
      case 36:	//KTextEditor::Editor
	switch(to) {
	    case 89: return (void*)(QObject*)(KTextEditor::Editor*)xptr;
	    case 36: return (void*)(KTextEditor::Editor*)(KTextEditor::Editor*)xptr;
	  default: return xptr;
	}
      case 37:	//KTextEditor::EditorChooser
	switch(to) {
	    case 111: return (void*)(QWidget*)(KTextEditor::EditorChooser*)xptr;
	    case 89: return (void*)(QObject*)(KTextEditor::EditorChooser*)xptr;
	    case 90: return (void*)(QPaintDevice*)(KTextEditor::EditorChooser*)xptr;
	    case 37: return (void*)(KTextEditor::EditorChooser*)(KTextEditor::EditorChooser*)xptr;
	  default: return xptr;
	}
      case 38:	//KTextEditor::Factory
	switch(to) {
	    case 10: return (void*)(KParts::Factory*)(KTextEditor::Factory*)xptr;
	    case 19: return (void*)(KPluginFactory*)(KTextEditor::Factory*)xptr;
	    case 89: return (void*)(QObject*)(KTextEditor::Factory*)xptr;
	    case 38: return (void*)(KTextEditor::Factory*)(KTextEditor::Factory*)xptr;
	  default: return xptr;
	}
      case 39:	//KTextEditor::Mark
	switch(to) {
	    case 39: return (void*)(KTextEditor::Mark*)(KTextEditor::Mark*)xptr;
	  default: return xptr;
	}
      case 40:	//KTextEditor::MarkInterface
	switch(to) {
	    case 40: return (void*)(KTextEditor::MarkInterface*)(KTextEditor::MarkInterface*)xptr;
	  default: return xptr;
	}
      case 41:	//KTextEditor::MdiContainer
	switch(to) {
	    case 41: return (void*)(KTextEditor::MdiContainer*)(KTextEditor::MdiContainer*)xptr;
	  default: return xptr;
	}
      case 42:	//KTextEditor::ModificationInterface
	switch(to) {
	    case 42: return (void*)(KTextEditor::ModificationInterface*)(KTextEditor::ModificationInterface*)xptr;
	  default: return xptr;
	}
      case 43:	//KTextEditor::Plugin
	switch(to) {
	    case 89: return (void*)(QObject*)(KTextEditor::Plugin*)xptr;
	    case 43: return (void*)(KTextEditor::Plugin*)(KTextEditor::Plugin*)xptr;
	  default: return xptr;
	}
      case 44:	//KTextEditor::Range
	switch(to) {
	    case 44: return (void*)(KTextEditor::Range*)(KTextEditor::Range*)xptr;
	    case 51: return (void*)(KTextEditor::SmartRange*)(KTextEditor::Range*)xptr;
	  default: return xptr;
	}
      case 45:	//KTextEditor::SearchInterface
	switch(to) {
	    case 45: return (void*)(KTextEditor::SearchInterface*)(KTextEditor::SearchInterface*)xptr;
	  default: return xptr;
	}
      case 46:	//KTextEditor::SessionConfigInterface
	switch(to) {
	    case 46: return (void*)(KTextEditor::SessionConfigInterface*)(KTextEditor::SessionConfigInterface*)xptr;
	  default: return xptr;
	}
      case 47:	//KTextEditor::SmartCursor
	switch(to) {
	    case 34: return (void*)(KTextEditor::Cursor*)(KTextEditor::SmartCursor*)xptr;
	    case 47: return (void*)(KTextEditor::SmartCursor*)(KTextEditor::SmartCursor*)xptr;
	  default: return xptr;
	}
      case 48:	//KTextEditor::SmartCursorNotifier
	switch(to) {
	    case 89: return (void*)(QObject*)(KTextEditor::SmartCursorNotifier*)xptr;
	    case 48: return (void*)(KTextEditor::SmartCursorNotifier*)(KTextEditor::SmartCursorNotifier*)xptr;
	  default: return xptr;
	}
      case 49:	//KTextEditor::SmartCursorWatcher
	switch(to) {
	    case 49: return (void*)(KTextEditor::SmartCursorWatcher*)(KTextEditor::SmartCursorWatcher*)xptr;
	  default: return xptr;
	}
      case 50:	//KTextEditor::SmartInterface
	switch(to) {
	    case 50: return (void*)(KTextEditor::SmartInterface*)(KTextEditor::SmartInterface*)xptr;
	  default: return xptr;
	}
      case 51:	//KTextEditor::SmartRange
	switch(to) {
	    case 44: return (void*)(KTextEditor::Range*)(KTextEditor::SmartRange*)xptr;
	    case 51: return (void*)(KTextEditor::SmartRange*)(KTextEditor::SmartRange*)xptr;
	  default: return xptr;
	}
      case 52:	//KTextEditor::SmartRangeNotifier
	switch(to) {
	    case 89: return (void*)(QObject*)(KTextEditor::SmartRangeNotifier*)xptr;
	    case 52: return (void*)(KTextEditor::SmartRangeNotifier*)(KTextEditor::SmartRangeNotifier*)xptr;
	  default: return xptr;
	}
      case 53:	//KTextEditor::SmartRangeWatcher
	switch(to) {
	    case 53: return (void*)(KTextEditor::SmartRangeWatcher*)(KTextEditor::SmartRangeWatcher*)xptr;
	  default: return xptr;
	}
      case 54:	//KTextEditor::TemplateInterface
	switch(to) {
	    case 54: return (void*)(KTextEditor::TemplateInterface*)(KTextEditor::TemplateInterface*)xptr;
	  default: return xptr;
	}
      case 55:	//KTextEditor::TextHintInterface
	switch(to) {
	    case 55: return (void*)(KTextEditor::TextHintInterface*)(KTextEditor::TextHintInterface*)xptr;
	  default: return xptr;
	}
      case 56:	//KTextEditor::VariableInterface
	switch(to) {
	    case 56: return (void*)(KTextEditor::VariableInterface*)(KTextEditor::VariableInterface*)xptr;
	  default: return xptr;
	}
      case 57:	//KTextEditor::View
	switch(to) {
	    case 59: return (void*)(KXMLGUIClient*)(KTextEditor::View*)xptr;
	    case 111: return (void*)(QWidget*)(KTextEditor::View*)xptr;
	    case 89: return (void*)(QObject*)(KTextEditor::View*)xptr;
	    case 90: return (void*)(QPaintDevice*)(KTextEditor::View*)xptr;
	    case 57: return (void*)(KTextEditor::View*)(KTextEditor::View*)xptr;
	  default: return xptr;
	}
      case 58:	//KUrl
	switch(to) {
	    case 58: return (void*)(KUrl*)(KUrl*)xptr;
	  default: return xptr;
	}
      case 59:	//KXMLGUIClient
	switch(to) {
	    case 59: return (void*)(KXMLGUIClient*)(KXMLGUIClient*)xptr;
	    case 57: return (void*)(KTextEditor::View*)(KXMLGUIClient*)xptr;
	  default: return xptr;
	}
      case 60:	//QAbstractItemModel
	switch(to) {
	    case 89: return (void*)(QObject*)(QAbstractItemModel*)xptr;
	    case 60: return (void*)(QAbstractItemModel*)(QAbstractItemModel*)xptr;
	    case 26: return (void*)(KTextEditor::CodeCompletionModel*)(QAbstractItemModel*)xptr;
	    case 27: return (void*)(KTextEditor::CodeCompletionModel2*)(QAbstractItemModel*)xptr;
	  default: return xptr;
	}
      case 61:	//QAction
	switch(to) {
	    case 89: return (void*)(QObject*)(QAction*)xptr;
	    case 61: return (void*)(QAction*)(QAction*)xptr;
	    case 2: return (void*)(KAction*)(QAction*)xptr;
	  default: return xptr;
	}
      case 62:	//QActionEvent
	switch(to) {
	    case 74: return (void*)(QEvent*)(QActionEvent*)xptr;
	    case 62: return (void*)(QActionEvent*)(QActionEvent*)xptr;
	  default: return xptr;
	}
      case 63:	//QBrush
	switch(to) {
	    case 63: return (void*)(QBrush*)(QBrush*)xptr;
	  default: return xptr;
	}
      case 64:	//QChar
	switch(to) {
	    case 64: return (void*)(QChar*)(QChar*)xptr;
	  default: return xptr;
	}
      case 65:	//QChildEvent
	switch(to) {
	    case 74: return (void*)(QEvent*)(QChildEvent*)xptr;
	    case 65: return (void*)(QChildEvent*)(QChildEvent*)xptr;
	  default: return xptr;
	}
      case 66:	//QCloseEvent
	switch(to) {
	    case 74: return (void*)(QEvent*)(QCloseEvent*)xptr;
	    case 66: return (void*)(QCloseEvent*)(QCloseEvent*)xptr;
	  default: return xptr;
	}
      case 67:	//QContextMenuEvent
	switch(to) {
	    case 74: return (void*)(QEvent*)(QContextMenuEvent*)xptr;
	    case 67: return (void*)(QContextMenuEvent*)(QContextMenuEvent*)xptr;
	  default: return xptr;
	}
      case 68:	//QDomDocument
	switch(to) {
	    case 68: return (void*)(QDomDocument*)(QDomDocument*)xptr;
	  default: return xptr;
	}
      case 69:	//QDomElement
	switch(to) {
	    case 69: return (void*)(QDomElement*)(QDomElement*)xptr;
	  default: return xptr;
	}
      case 70:	//QDragEnterEvent
	switch(to) {
	    case 72: return (void*)(QDragMoveEvent*)(QDragEnterEvent*)xptr;
	    case 73: return (void*)(QDropEvent*)(QDragEnterEvent*)xptr;
	    case 74: return (void*)(QEvent*)(QDragEnterEvent*)xptr;
	    case 70: return (void*)(QDragEnterEvent*)(QDragEnterEvent*)xptr;
	  default: return xptr;
	}
      case 71:	//QDragLeaveEvent
	switch(to) {
	    case 74: return (void*)(QEvent*)(QDragLeaveEvent*)xptr;
	    case 71: return (void*)(QDragLeaveEvent*)(QDragLeaveEvent*)xptr;
	  default: return xptr;
	}
      case 72:	//QDragMoveEvent
	switch(to) {
	    case 73: return (void*)(QDropEvent*)(QDragMoveEvent*)xptr;
	    case 74: return (void*)(QEvent*)(QDragMoveEvent*)xptr;
	    case 72: return (void*)(QDragMoveEvent*)(QDragMoveEvent*)xptr;
	    case 70: return (void*)(QDragEnterEvent*)(QDragMoveEvent*)xptr;
	  default: return xptr;
	}
      case 73:	//QDropEvent
	switch(to) {
	    case 74: return (void*)(QEvent*)(QDropEvent*)xptr;
	    case 73: return (void*)(QDropEvent*)(QDropEvent*)xptr;
	    case 70: return (void*)(QDragEnterEvent*)(QDropEvent*)xptr;
	    case 72: return (void*)(QDragMoveEvent*)(QDropEvent*)xptr;
	  default: return xptr;
	}
      case 74:	//QEvent
	switch(to) {
	    case 74: return (void*)(QEvent*)(QEvent*)xptr;
	    case 11: return (void*)(KParts::GUIActivateEvent*)(QEvent*)xptr;
	    case 13: return (void*)(KParts::PartActivateEvent*)(QEvent*)xptr;
	    case 16: return (void*)(KParts::PartSelectEvent*)(QEvent*)xptr;
	    case 62: return (void*)(QActionEvent*)(QEvent*)xptr;
	    case 65: return (void*)(QChildEvent*)(QEvent*)xptr;
	    case 66: return (void*)(QCloseEvent*)(QEvent*)xptr;
	    case 67: return (void*)(QContextMenuEvent*)(QEvent*)xptr;
	    case 70: return (void*)(QDragEnterEvent*)(QEvent*)xptr;
	    case 71: return (void*)(QDragLeaveEvent*)(QEvent*)xptr;
	    case 72: return (void*)(QDragMoveEvent*)(QEvent*)xptr;
	    case 73: return (void*)(QDropEvent*)(QEvent*)xptr;
	    case 75: return (void*)(QFocusEvent*)(QEvent*)xptr;
	    case 77: return (void*)(QHideEvent*)(QEvent*)xptr;
	    case 79: return (void*)(QInputMethodEvent*)(QEvent*)xptr;
	    case 80: return (void*)(QKeyEvent*)(QEvent*)xptr;
	    case 87: return (void*)(QMouseEvent*)(QEvent*)xptr;
	    case 88: return (void*)(QMoveEvent*)(QEvent*)xptr;
	    case 93: return (void*)(QPaintEvent*)(QEvent*)xptr;
	    case 101: return (void*)(QResizeEvent*)(QEvent*)xptr;
	    case 102: return (void*)(QShowEvent*)(QEvent*)xptr;
	    case 105: return (void*)(QTabletEvent*)(QEvent*)xptr;
	    case 108: return (void*)(QTimerEvent*)(QEvent*)xptr;
	    case 110: return (void*)(QWheelEvent*)(QEvent*)xptr;
	  default: return xptr;
	}
      case 75:	//QFocusEvent
	switch(to) {
	    case 74: return (void*)(QEvent*)(QFocusEvent*)xptr;
	    case 75: return (void*)(QFocusEvent*)(QFocusEvent*)xptr;
	  default: return xptr;
	}
      case 76:	//QFont
	switch(to) {
	    case 76: return (void*)(QFont*)(QFont*)xptr;
	  default: return xptr;
	}
      case 77:	//QHideEvent
	switch(to) {
	    case 74: return (void*)(QEvent*)(QHideEvent*)xptr;
	    case 77: return (void*)(QHideEvent*)(QHideEvent*)xptr;
	  default: return xptr;
	}
      case 78:	//QImage
	switch(to) {
	    case 90: return (void*)(QPaintDevice*)(QImage*)xptr;
	    case 78: return (void*)(QImage*)(QImage*)xptr;
	  default: return xptr;
	}
      case 79:	//QInputMethodEvent
	switch(to) {
	    case 74: return (void*)(QEvent*)(QInputMethodEvent*)xptr;
	    case 79: return (void*)(QInputMethodEvent*)(QInputMethodEvent*)xptr;
	  default: return xptr;
	}
      case 80:	//QKeyEvent
	switch(to) {
	    case 74: return (void*)(QEvent*)(QKeyEvent*)xptr;
	    case 80: return (void*)(QKeyEvent*)(QKeyEvent*)xptr;
	  default: return xptr;
	}
      case 81:	//QLine
	switch(to) {
	    case 81: return (void*)(QLine*)(QLine*)xptr;
	  default: return xptr;
	}
      case 82:	//QLineF
	switch(to) {
	    case 82: return (void*)(QLineF*)(QLineF*)xptr;
	  default: return xptr;
	}
      case 83:	//QMenu
	switch(to) {
	    case 111: return (void*)(QWidget*)(QMenu*)xptr;
	    case 89: return (void*)(QObject*)(QMenu*)xptr;
	    case 90: return (void*)(QPaintDevice*)(QMenu*)xptr;
	    case 83: return (void*)(QMenu*)(QMenu*)xptr;
	  default: return xptr;
	}
      case 84:	//QMetaObject
	switch(to) {
	    case 84: return (void*)(QMetaObject*)(QMetaObject*)xptr;
	  default: return xptr;
	}
      case 85:	//QMimeData
	switch(to) {
	    case 89: return (void*)(QObject*)(QMimeData*)xptr;
	    case 85: return (void*)(QMimeData*)(QMimeData*)xptr;
	  default: return xptr;
	}
      case 86:	//QModelIndex
	switch(to) {
	    case 86: return (void*)(QModelIndex*)(QModelIndex*)xptr;
	  default: return xptr;
	}
      case 87:	//QMouseEvent
	switch(to) {
	    case 74: return (void*)(QEvent*)(QMouseEvent*)xptr;
	    case 87: return (void*)(QMouseEvent*)(QMouseEvent*)xptr;
	  default: return xptr;
	}
      case 88:	//QMoveEvent
	switch(to) {
	    case 74: return (void*)(QEvent*)(QMoveEvent*)xptr;
	    case 88: return (void*)(QMoveEvent*)(QMoveEvent*)xptr;
	  default: return xptr;
	}
      case 89:	//QObject
	switch(to) {
	    case 89: return (void*)(QObject*)(QObject*)xptr;
	    case 2: return (void*)(KAction*)(QObject*)xptr;
	    case 3: return (void*)(KActionCollection*)(QObject*)xptr;
	    case 4: return (void*)(KCompletion*)(QObject*)xptr;
	    case 10: return (void*)(KParts::Factory*)(QObject*)xptr;
	    case 12: return (void*)(KParts::Part*)(QObject*)xptr;
	    case 15: return (void*)(KParts::PartManager*)(QObject*)xptr;
	    case 17: return (void*)(KParts::ReadOnlyPart*)(QObject*)xptr;
	    case 18: return (void*)(KParts::ReadWritePart*)(QObject*)xptr;
	    case 19: return (void*)(KPluginFactory*)(QObject*)xptr;
	    case 22: return (void*)(KTextEditor::AnnotationModel*)(QObject*)xptr;
	    case 26: return (void*)(KTextEditor::CodeCompletionModel*)(QObject*)xptr;
	    case 27: return (void*)(KTextEditor::CodeCompletionModel2*)(QObject*)xptr;
	    case 32: return (void*)(KTextEditor::ConfigPage*)(QObject*)xptr;
	    case 35: return (void*)(KTextEditor::Document*)(QObject*)xptr;
	    case 36: return (void*)(KTextEditor::Editor*)(QObject*)xptr;
	    case 37: return (void*)(KTextEditor::EditorChooser*)(QObject*)xptr;
	    case 38: return (void*)(KTextEditor::Factory*)(QObject*)xptr;
	    case 43: return (void*)(KTextEditor::Plugin*)(QObject*)xptr;
	    case 48: return (void*)(KTextEditor::SmartCursorNotifier*)(QObject*)xptr;
	    case 52: return (void*)(KTextEditor::SmartRangeNotifier*)(QObject*)xptr;
	    case 57: return (void*)(KTextEditor::View*)(QObject*)xptr;
	    case 60: return (void*)(QAbstractItemModel*)(QObject*)xptr;
	    case 61: return (void*)(QAction*)(QObject*)xptr;
	    case 83: return (void*)(QMenu*)(QObject*)xptr;
	    case 85: return (void*)(QMimeData*)(QObject*)xptr;
	    case 104: return (void*)(QStyle*)(QObject*)xptr;
	    case 111: return (void*)(QWidget*)(QObject*)xptr;
	  default: return xptr;
	}
      case 90:	//QPaintDevice
	switch(to) {
	    case 90: return (void*)(QPaintDevice*)(QPaintDevice*)xptr;
	    case 32: return (void*)(KTextEditor::ConfigPage*)(QPaintDevice*)xptr;
	    case 37: return (void*)(KTextEditor::EditorChooser*)(QPaintDevice*)xptr;
	    case 57: return (void*)(KTextEditor::View*)(QPaintDevice*)xptr;
	    case 78: return (void*)(QImage*)(QPaintDevice*)xptr;
	    case 83: return (void*)(QMenu*)(QPaintDevice*)xptr;
	    case 96: return (void*)(QPixmap*)(QPaintDevice*)xptr;
	    case 111: return (void*)(QWidget*)(QPaintDevice*)xptr;
	  default: return xptr;
	}
      case 91:	//QPaintEngine
	switch(to) {
	    case 91: return (void*)(QPaintEngine*)(QPaintEngine*)xptr;
	  default: return xptr;
	}
      case 92:	//QPaintEngineState
	switch(to) {
	    case 92: return (void*)(QPaintEngineState*)(QPaintEngineState*)xptr;
	  default: return xptr;
	}
      case 93:	//QPaintEvent
	switch(to) {
	    case 74: return (void*)(QEvent*)(QPaintEvent*)xptr;
	    case 93: return (void*)(QPaintEvent*)(QPaintEvent*)xptr;
	  default: return xptr;
	}
      case 94:	//QPainterPath
	switch(to) {
	    case 94: return (void*)(QPainterPath*)(QPainterPath*)xptr;
	  default: return xptr;
	}
      case 95:	//QPalette
	switch(to) {
	    case 95: return (void*)(QPalette*)(QPalette*)xptr;
	  default: return xptr;
	}
      case 96:	//QPixmap
	switch(to) {
	    case 90: return (void*)(QPaintDevice*)(QPixmap*)xptr;
	    case 96: return (void*)(QPixmap*)(QPixmap*)xptr;
	  default: return xptr;
	}
      case 97:	//QPoint
	switch(to) {
	    case 97: return (void*)(QPoint*)(QPoint*)xptr;
	  default: return xptr;
	}
      case 98:	//QPointF
	switch(to) {
	    case 98: return (void*)(QPointF*)(QPointF*)xptr;
	  default: return xptr;
	}
      case 99:	//QRect
	switch(to) {
	    case 99: return (void*)(QRect*)(QRect*)xptr;
	  default: return xptr;
	}
      case 100:	//QRectF
	switch(to) {
	    case 100: return (void*)(QRectF*)(QRectF*)xptr;
	  default: return xptr;
	}
      case 101:	//QResizeEvent
	switch(to) {
	    case 74: return (void*)(QEvent*)(QResizeEvent*)xptr;
	    case 101: return (void*)(QResizeEvent*)(QResizeEvent*)xptr;
	  default: return xptr;
	}
      case 102:	//QShowEvent
	switch(to) {
	    case 74: return (void*)(QEvent*)(QShowEvent*)xptr;
	    case 102: return (void*)(QShowEvent*)(QShowEvent*)xptr;
	  default: return xptr;
	}
      case 103:	//QSize
	switch(to) {
	    case 103: return (void*)(QSize*)(QSize*)xptr;
	  default: return xptr;
	}
      case 104:	//QStyle
	switch(to) {
	    case 89: return (void*)(QObject*)(QStyle*)xptr;
	    case 104: return (void*)(QStyle*)(QStyle*)xptr;
	  default: return xptr;
	}
      case 105:	//QTabletEvent
	switch(to) {
	    case 74: return (void*)(QEvent*)(QTabletEvent*)xptr;
	    case 105: return (void*)(QTabletEvent*)(QTabletEvent*)xptr;
	  default: return xptr;
	}
      case 106:	//QTextCharFormat
	switch(to) {
	    case 107: return (void*)(QTextFormat*)(QTextCharFormat*)xptr;
	    case 106: return (void*)(QTextCharFormat*)(QTextCharFormat*)xptr;
	    case 24: return (void*)(KTextEditor::Attribute*)(QTextCharFormat*)xptr;
	  default: return xptr;
	}
      case 107:	//QTextFormat
	switch(to) {
	    case 107: return (void*)(QTextFormat*)(QTextFormat*)xptr;
	    case 24: return (void*)(KTextEditor::Attribute*)(QTextFormat*)xptr;
	    case 106: return (void*)(QTextCharFormat*)(QTextFormat*)xptr;
	  default: return xptr;
	}
      case 108:	//QTimerEvent
	switch(to) {
	    case 74: return (void*)(QEvent*)(QTimerEvent*)xptr;
	    case 108: return (void*)(QTimerEvent*)(QTimerEvent*)xptr;
	  default: return xptr;
	}
      case 109:	//QVariant
	switch(to) {
	    case 109: return (void*)(QVariant*)(QVariant*)xptr;
	  default: return xptr;
	}
      case 110:	//QWheelEvent
	switch(to) {
	    case 74: return (void*)(QEvent*)(QWheelEvent*)xptr;
	    case 110: return (void*)(QWheelEvent*)(QWheelEvent*)xptr;
	  default: return xptr;
	}
      case 111:	//QWidget
	switch(to) {
	    case 89: return (void*)(QObject*)(QWidget*)xptr;
	    case 90: return (void*)(QPaintDevice*)(QWidget*)xptr;
	    case 111: return (void*)(QWidget*)(QWidget*)xptr;
	    case 32: return (void*)(KTextEditor::ConfigPage*)(QWidget*)xptr;
	    case 37: return (void*)(KTextEditor::EditorChooser*)(QWidget*)xptr;
	    case 57: return (void*)(KTextEditor::View*)(QWidget*)xptr;
	    case 83: return (void*)(QMenu*)(QWidget*)xptr;
	  default: return xptr;
	}
      default: return xptr;
    }
}

// Group of Indexes (0 separated) used as super class lists.
// Classes with super classes have an index into this array.
static Smoke::Index ktexteditor_inheritanceList[] = {
	0,	// 0: (no super class)
	89, 0,	// 1: QObject
	21, 0,	// 3: KTextEditor::AnnotationInterface
	106, 0,	// 5: KShared, QTextCharFormat
	60, 0,	// 7: QAbstractItemModel
	26, 0,	// 9: KTextEditor::CodeCompletionModel
	111, 0,	// 11: QWidget
	18, 0,	// 13: KParts::ReadWritePart
	10, 0,	// 15: KParts::Factory
	34, 0,	// 17: KTextEditor::Cursor
	44, 0,	// 19: KTextEditor::Range
	59, 111, 0,	// 21: KXMLGUIClient, QWidget
};

// These are the xenum functions for manipulating enum pointers
void xenum_KTextEditor__View(Smoke::EnumOperation, Smoke::Index, void*&, long&);
void xenum_KTextEditor__CodeCompletionModel(Smoke::EnumOperation, Smoke::Index, void*&, long&);
void xenum_KTextEditor__SmartRange(Smoke::EnumOperation, Smoke::Index, void*&, long&);
void xenum_KTextEditor__Attribute(Smoke::EnumOperation, Smoke::Index, void*&, long&);
void xenum_KTextEditor__ModificationInterface(Smoke::EnumOperation, Smoke::Index, void*&, long&);
void xenum_KTextEditor__MarkInterface(Smoke::EnumOperation, Smoke::Index, void*&, long&);
void xenum_KTextEditor__SmartCursor(Smoke::EnumOperation, Smoke::Index, void*&, long&);

// Those are the xcall functions defined in each x_*.cpp file, for dispatching method calls
void xcall_KTextEditor(Smoke::Index, void*, Smoke::Stack);
void xcall_KTextEditor__AnnotationInterface(Smoke::Index, void*, Smoke::Stack);
void xcall_KTextEditor__AnnotationModel(Smoke::Index, void*, Smoke::Stack);
void xcall_KTextEditor__AnnotationViewInterface(Smoke::Index, void*, Smoke::Stack);
void xcall_KTextEditor__Attribute(Smoke::Index, void*, Smoke::Stack);
void xcall_KTextEditor__CodeCompletionInterface(Smoke::Index, void*, Smoke::Stack);
void xcall_KTextEditor__CodeCompletionModel(Smoke::Index, void*, Smoke::Stack);
void xcall_KTextEditor__CodeCompletionModel2(Smoke::Index, void*, Smoke::Stack);
void xcall_KTextEditor__Command(Smoke::Index, void*, Smoke::Stack);
void xcall_KTextEditor__CommandExtension(Smoke::Index, void*, Smoke::Stack);
void xcall_KTextEditor__CommandInterface(Smoke::Index, void*, Smoke::Stack);
void xcall_KTextEditor__ConfigInterface(Smoke::Index, void*, Smoke::Stack);
void xcall_KTextEditor__ConfigPage(Smoke::Index, void*, Smoke::Stack);
void xcall_KTextEditor__ContainerInterface(Smoke::Index, void*, Smoke::Stack);
void xcall_KTextEditor__Cursor(Smoke::Index, void*, Smoke::Stack);
void xcall_KTextEditor__Document(Smoke::Index, void*, Smoke::Stack);
void xcall_KTextEditor__Editor(Smoke::Index, void*, Smoke::Stack);
void xcall_KTextEditor__EditorChooser(Smoke::Index, void*, Smoke::Stack);
void xcall_KTextEditor__Factory(Smoke::Index, void*, Smoke::Stack);
void xcall_KTextEditor__Mark(Smoke::Index, void*, Smoke::Stack);
void xcall_KTextEditor__MarkInterface(Smoke::Index, void*, Smoke::Stack);
void xcall_KTextEditor__MdiContainer(Smoke::Index, void*, Smoke::Stack);
void xcall_KTextEditor__ModificationInterface(Smoke::Index, void*, Smoke::Stack);
void xcall_KTextEditor__Plugin(Smoke::Index, void*, Smoke::Stack);
void xcall_KTextEditor__Range(Smoke::Index, void*, Smoke::Stack);
void xcall_KTextEditor__SearchInterface(Smoke::Index, void*, Smoke::Stack);
void xcall_KTextEditor__SessionConfigInterface(Smoke::Index, void*, Smoke::Stack);
void xcall_KTextEditor__SmartCursor(Smoke::Index, void*, Smoke::Stack);
void xcall_KTextEditor__SmartCursorNotifier(Smoke::Index, void*, Smoke::Stack);
void xcall_KTextEditor__SmartCursorWatcher(Smoke::Index, void*, Smoke::Stack);
void xcall_KTextEditor__SmartInterface(Smoke::Index, void*, Smoke::Stack);
void xcall_KTextEditor__SmartRange(Smoke::Index, void*, Smoke::Stack);
void xcall_KTextEditor__SmartRangeNotifier(Smoke::Index, void*, Smoke::Stack);
void xcall_KTextEditor__SmartRangeWatcher(Smoke::Index, void*, Smoke::Stack);
void xcall_KTextEditor__TemplateInterface(Smoke::Index, void*, Smoke::Stack);
void xcall_KTextEditor__TextHintInterface(Smoke::Index, void*, Smoke::Stack);
void xcall_KTextEditor__VariableInterface(Smoke::Index, void*, Smoke::Stack);
void xcall_KTextEditor__View(Smoke::Index, void*, Smoke::Stack);

// List of all classes
// Name, index into inheritanceList, method dispatcher, enum dispatcher, class flags
static Smoke::Class ktexteditor_classes[] = {
	{ 0L, false, 0, 0, 0, 0 }, 	// 0 (no class)
	{ "KAboutData", true, 0, 0, 0, 0 }, 	// 1
	{ "KAction", true, 0, 0, 0, 0 }, 	// 2
	{ "KActionCollection", true, 0, 0, 0, 0 }, 	// 3
	{ "KCompletion", true, 0, 0, 0, 0 }, 	// 4
	{ "KComponentData", true, 0, 0, 0, 0 }, 	// 5
	{ "KConfig", true, 0, 0, 0, 0 }, 	// 6
	{ "KConfigGroup", true, 0, 0, 0, 0 }, 	// 7
	{ "KIcon", true, 0, 0, 0, 0 }, 	// 8
	{ "KParts", true, 0, 0, 0, 0 }, 	// 9
	{ "KParts::Factory", true, 0, 0, 0, 0 }, 	// 10
	{ "KParts::GUIActivateEvent", true, 0, 0, 0, 0 }, 	// 11
	{ "KParts::Part", true, 0, 0, 0, 0 }, 	// 12
	{ "KParts::PartActivateEvent", true, 0, 0, 0, 0 }, 	// 13
	{ "KParts::PartBase", true, 0, 0, 0, 0 }, 	// 14
	{ "KParts::PartManager", true, 0, 0, 0, 0 }, 	// 15
	{ "KParts::PartSelectEvent", true, 0, 0, 0, 0 }, 	// 16
	{ "KParts::ReadOnlyPart", true, 0, 0, 0, 0 }, 	// 17
	{ "KParts::ReadWritePart", true, 0, 0, 0, 0 }, 	// 18
	{ "KPluginFactory", true, 0, 0, 0, 0 }, 	// 19
	{ "KTextEditor", false, 0, xcall_KTextEditor, 0, Smoke::cf_deepcopy }, 	//20
	{ "KTextEditor::AnnotationInterface", false, 0, xcall_KTextEditor__AnnotationInterface, 0, Smoke::cf_constructor|Smoke::cf_deepcopy|Smoke::cf_virtual }, 	//21
	{ "KTextEditor::AnnotationModel", false, 1, xcall_KTextEditor__AnnotationModel, 0, Smoke::cf_constructor|Smoke::cf_virtual }, 	//22
	{ "KTextEditor::AnnotationViewInterface", false, 3, xcall_KTextEditor__AnnotationViewInterface, 0, Smoke::cf_constructor|Smoke::cf_deepcopy|Smoke::cf_virtual }, 	//23
	{ "KTextEditor::Attribute", false, 5, xcall_KTextEditor__Attribute, xenum_KTextEditor__Attribute, Smoke::cf_constructor|Smoke::cf_virtual }, 	//24
	{ "KTextEditor::CodeCompletionInterface", false, 0, xcall_KTextEditor__CodeCompletionInterface, 0, Smoke::cf_constructor|Smoke::cf_deepcopy|Smoke::cf_virtual }, 	//25
	{ "KTextEditor::CodeCompletionModel", false, 7, xcall_KTextEditor__CodeCompletionModel, xenum_KTextEditor__CodeCompletionModel, Smoke::cf_constructor|Smoke::cf_virtual }, 	//26
	{ "KTextEditor::CodeCompletionModel2", false, 9, xcall_KTextEditor__CodeCompletionModel2, 0, Smoke::cf_constructor|Smoke::cf_virtual }, 	//27
	{ "KTextEditor::Command", false, 0, xcall_KTextEditor__Command, 0, Smoke::cf_constructor|Smoke::cf_deepcopy|Smoke::cf_virtual }, 	//28
	{ "KTextEditor::CommandExtension", false, 0, xcall_KTextEditor__CommandExtension, 0, Smoke::cf_constructor|Smoke::cf_deepcopy|Smoke::cf_virtual }, 	//29
	{ "KTextEditor::CommandInterface", false, 0, xcall_KTextEditor__CommandInterface, 0, Smoke::cf_constructor|Smoke::cf_deepcopy|Smoke::cf_virtual }, 	//30
	{ "KTextEditor::ConfigInterface", false, 0, xcall_KTextEditor__ConfigInterface, 0, Smoke::cf_constructor|Smoke::cf_deepcopy|Smoke::cf_virtual }, 	//31
	{ "KTextEditor::ConfigPage", false, 11, xcall_KTextEditor__ConfigPage, 0, Smoke::cf_constructor|Smoke::cf_virtual }, 	//32
	{ "KTextEditor::ContainerInterface", false, 0, xcall_KTextEditor__ContainerInterface, 0, Smoke::cf_constructor|Smoke::cf_deepcopy|Smoke::cf_virtual }, 	//33
	{ "KTextEditor::Cursor", false, 0, xcall_KTextEditor__Cursor, 0, Smoke::cf_constructor|Smoke::cf_deepcopy|Smoke::cf_virtual }, 	//34
	{ "KTextEditor::Document", false, 13, xcall_KTextEditor__Document, 0, Smoke::cf_constructor|Smoke::cf_virtual }, 	//35
	{ "KTextEditor::Editor", false, 1, xcall_KTextEditor__Editor, 0, Smoke::cf_constructor|Smoke::cf_virtual }, 	//36
	{ "KTextEditor::EditorChooser", false, 11, xcall_KTextEditor__EditorChooser, 0, Smoke::cf_constructor|Smoke::cf_virtual }, 	//37
	{ "KTextEditor::Factory", false, 15, xcall_KTextEditor__Factory, 0, Smoke::cf_constructor|Smoke::cf_virtual }, 	//38
	{ "KTextEditor::Mark", false, 0, xcall_KTextEditor__Mark, 0, Smoke::cf_constructor|Smoke::cf_deepcopy }, 	//39
	{ "KTextEditor::MarkInterface", false, 0, xcall_KTextEditor__MarkInterface, xenum_KTextEditor__MarkInterface, Smoke::cf_constructor|Smoke::cf_deepcopy|Smoke::cf_virtual }, 	//40
	{ "KTextEditor::MdiContainer", false, 0, xcall_KTextEditor__MdiContainer, 0, Smoke::cf_constructor|Smoke::cf_deepcopy|Smoke::cf_virtual }, 	//41
	{ "KTextEditor::ModificationInterface", false, 0, xcall_KTextEditor__ModificationInterface, xenum_KTextEditor__ModificationInterface, Smoke::cf_constructor|Smoke::cf_deepcopy|Smoke::cf_virtual }, 	//42
	{ "KTextEditor::Plugin", false, 1, xcall_KTextEditor__Plugin, 0, Smoke::cf_constructor|Smoke::cf_virtual }, 	//43
	{ "KTextEditor::Range", false, 0, xcall_KTextEditor__Range, 0, Smoke::cf_constructor|Smoke::cf_deepcopy|Smoke::cf_virtual }, 	//44
	{ "KTextEditor::SearchInterface", false, 0, xcall_KTextEditor__SearchInterface, 0, Smoke::cf_constructor|Smoke::cf_deepcopy|Smoke::cf_virtual }, 	//45
	{ "KTextEditor::SessionConfigInterface", false, 0, xcall_KTextEditor__SessionConfigInterface, 0, Smoke::cf_constructor|Smoke::cf_deepcopy|Smoke::cf_virtual }, 	//46
	{ "KTextEditor::SmartCursor", false, 17, xcall_KTextEditor__SmartCursor, xenum_KTextEditor__SmartCursor, Smoke::cf_constructor|Smoke::cf_virtual }, 	//47
	{ "KTextEditor::SmartCursorNotifier", false, 1, xcall_KTextEditor__SmartCursorNotifier, 0, Smoke::cf_constructor|Smoke::cf_virtual }, 	//48
	{ "KTextEditor::SmartCursorWatcher", false, 0, xcall_KTextEditor__SmartCursorWatcher, 0, Smoke::cf_constructor|Smoke::cf_deepcopy|Smoke::cf_virtual }, 	//49
	{ "KTextEditor::SmartInterface", false, 0, xcall_KTextEditor__SmartInterface, 0, Smoke::cf_constructor|Smoke::cf_deepcopy|Smoke::cf_virtual }, 	//50
	{ "KTextEditor::SmartRange", false, 19, xcall_KTextEditor__SmartRange, xenum_KTextEditor__SmartRange, Smoke::cf_constructor|Smoke::cf_virtual }, 	//51
	{ "KTextEditor::SmartRangeNotifier", false, 1, xcall_KTextEditor__SmartRangeNotifier, 0, Smoke::cf_constructor|Smoke::cf_virtual }, 	//52
	{ "KTextEditor::SmartRangeWatcher", false, 0, xcall_KTextEditor__SmartRangeWatcher, 0, Smoke::cf_constructor|Smoke::cf_deepcopy|Smoke::cf_virtual }, 	//53
	{ "KTextEditor::TemplateInterface", false, 0, xcall_KTextEditor__TemplateInterface, 0, Smoke::cf_constructor|Smoke::cf_deepcopy|Smoke::cf_virtual }, 	//54
	{ "KTextEditor::TextHintInterface", false, 0, xcall_KTextEditor__TextHintInterface, 0, Smoke::cf_constructor|Smoke::cf_deepcopy|Smoke::cf_virtual }, 	//55
	{ "KTextEditor::VariableInterface", false, 0, xcall_KTextEditor__VariableInterface, 0, Smoke::cf_constructor|Smoke::cf_deepcopy|Smoke::cf_virtual }, 	//56
	{ "KTextEditor::View", false, 21, xcall_KTextEditor__View, xenum_KTextEditor__View, Smoke::cf_constructor|Smoke::cf_virtual }, 	//57
	{ "KUrl", true, 0, 0, 0, 0 }, 	// 58
	{ "KXMLGUIClient", true, 0, 0, 0, 0 }, 	// 59
	{ "QAbstractItemModel", true, 0, 0, 0, 0 }, 	// 60
	{ "QAction", true, 0, 0, 0, 0 }, 	// 61
	{ "QActionEvent", true, 0, 0, 0, 0 }, 	// 62
	{ "QBrush", true, 0, 0, 0, 0 }, 	// 63
	{ "QChar", true, 0, 0, 0, 0 }, 	// 64
	{ "QChildEvent", true, 0, 0, 0, 0 }, 	// 65
	{ "QCloseEvent", true, 0, 0, 0, 0 }, 	// 66
	{ "QContextMenuEvent", true, 0, 0, 0, 0 }, 	// 67
	{ "QDomDocument", true, 0, 0, 0, 0 }, 	// 68
	{ "QDomElement", true, 0, 0, 0, 0 }, 	// 69
	{ "QDragEnterEvent", true, 0, 0, 0, 0 }, 	// 70
	{ "QDragLeaveEvent", true, 0, 0, 0, 0 }, 	// 71
	{ "QDragMoveEvent", true, 0, 0, 0, 0 }, 	// 72
	{ "QDropEvent", true, 0, 0, 0, 0 }, 	// 73
	{ "QEvent", true, 0, 0, 0, 0 }, 	// 74
	{ "QFocusEvent", true, 0, 0, 0, 0 }, 	// 75
	{ "QFont", true, 0, 0, 0, 0 }, 	// 76
	{ "QHideEvent", true, 0, 0, 0, 0 }, 	// 77
	{ "QImage", true, 0, 0, 0, 0 }, 	// 78
	{ "QInputMethodEvent", true, 0, 0, 0, 0 }, 	// 79
	{ "QKeyEvent", true, 0, 0, 0, 0 }, 	// 80
	{ "QLine", true, 0, 0, 0, 0 }, 	// 81
	{ "QLineF", true, 0, 0, 0, 0 }, 	// 82
	{ "QMenu", true, 0, 0, 0, 0 }, 	// 83
	{ "QMetaObject", true, 0, 0, 0, 0 }, 	// 84
	{ "QMimeData", true, 0, 0, 0, 0 }, 	// 85
	{ "QModelIndex", true, 0, 0, 0, 0 }, 	// 86
	{ "QMouseEvent", true, 0, 0, 0, 0 }, 	// 87
	{ "QMoveEvent", true, 0, 0, 0, 0 }, 	// 88
	{ "QObject", true, 0, 0, 0, 0 }, 	// 89
	{ "QPaintDevice", true, 0, 0, 0, 0 }, 	// 90
	{ "QPaintEngine", true, 0, 0, 0, 0 }, 	// 91
	{ "QPaintEngineState", true, 0, 0, 0, 0 }, 	// 92
	{ "QPaintEvent", true, 0, 0, 0, 0 }, 	// 93
	{ "QPainterPath", true, 0, 0, 0, 0 }, 	// 94
	{ "QPalette", true, 0, 0, 0, 0 }, 	// 95
	{ "QPixmap", true, 0, 0, 0, 0 }, 	// 96
	{ "QPoint", true, 0, 0, 0, 0 }, 	// 97
	{ "QPointF", true, 0, 0, 0, 0 }, 	// 98
	{ "QRect", true, 0, 0, 0, 0 }, 	// 99
	{ "QRectF", true, 0, 0, 0, 0 }, 	// 100
	{ "QResizeEvent", true, 0, 0, 0, 0 }, 	// 101
	{ "QShowEvent", true, 0, 0, 0, 0 }, 	// 102
	{ "QSize", true, 0, 0, 0, 0 }, 	// 103
	{ "QStyle", true, 0, 0, 0, 0 }, 	// 104
	{ "QTabletEvent", true, 0, 0, 0, 0 }, 	// 105
	{ "QTextCharFormat", true, 0, 0, 0, 0 }, 	// 106
	{ "QTextFormat", true, 0, 0, 0, 0 }, 	// 107
	{ "QTimerEvent", true, 0, 0, 0, 0 }, 	// 108
	{ "QVariant", true, 0, 0, 0, 0 }, 	// 109
	{ "QWheelEvent", true, 0, 0, 0, 0 }, 	// 110
	{ "QWidget", true, 0, 0, 0, 0 }, 	// 111
	{ "Qt", true, 0, 0, 0, 0 }, 	// 112
};

// List of all types needed by the methods (arguments and return values)
// Name, class ID if arg is a class, and TypeId
static Smoke::Type ktexteditor_types[] = {
	{ 0, 0, 0 },	//0 (no type)
	{ "KAction*", 2, Smoke::t_class | Smoke::tf_ptr },	//1
	{ "KAction::ShortcutTypes", 0, Smoke::t_uint | Smoke::tf_stack },	//2
	{ "KAction::ShortcutTypes&", 0, Smoke::t_voidp | Smoke::tf_ref },	//3
	{ "KActionCollection*", 3, Smoke::t_class | Smoke::tf_ptr },	//4
	{ "KAutostart::Conditions", 0, Smoke::t_uint | Smoke::tf_stack },	//5
	{ "KAutostart::Conditions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//6
	{ "KCModule::Buttons", 0, Smoke::t_uint | Smoke::tf_stack },	//7
	{ "KCModule::Buttons&", 0, Smoke::t_voidp | Smoke::tf_ref },	//8
	{ "KCmdLineArgs::StdCmdLineArgs", 0, Smoke::t_uint | Smoke::tf_stack },	//9
	{ "KCmdLineArgs::StdCmdLineArgs&", 0, Smoke::t_voidp | Smoke::tf_ref },	//10
	{ "KCompletion*", 4, Smoke::t_class | Smoke::tf_ptr },	//11
	{ "KComponentData", 5, Smoke::t_class | Smoke::tf_stack },	//12
	{ "KConfig*", 6, Smoke::t_class | Smoke::tf_ptr },	//13
	{ "KConfig::OpenFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//14
	{ "KConfig::OpenFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//15
	{ "KConfigBase::WriteConfigFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//16
	{ "KConfigBase::WriteConfigFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//17
	{ "KConfigGroup&", 7, Smoke::t_class | Smoke::tf_ref },	//18
	{ "KCrash::CrashFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//19
	{ "KCrash::CrashFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//20
	{ "KDialog::ButtonCodes", 0, Smoke::t_uint | Smoke::tf_stack },	//21
	{ "KDialog::ButtonCodes&", 0, Smoke::t_voidp | Smoke::tf_ref },	//22
	{ "KDialog::ButtonPopupModes", 0, Smoke::t_uint | Smoke::tf_stack },	//23
	{ "KDialog::ButtonPopupModes&", 0, Smoke::t_voidp | Smoke::tf_ref },	//24
	{ "KDialog::CaptionFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//25
	{ "KDialog::CaptionFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//26
	{ "KDirLister::OpenUrlFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//27
	{ "KDirLister::OpenUrlFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//28
	{ "KDirModel::DropsAllowed", 0, Smoke::t_uint | Smoke::tf_stack },	//29
	{ "KDirModel::DropsAllowed&", 0, Smoke::t_voidp | Smoke::tf_ref },	//30
	{ "KDirWatch::WatchModes", 0, Smoke::t_uint | Smoke::tf_stack },	//31
	{ "KDirWatch::WatchModes&", 0, Smoke::t_voidp | Smoke::tf_ref },	//32
	{ "KEditListBox::Buttons", 0, Smoke::t_uint | Smoke::tf_stack },	//33
	{ "KEditListBox::Buttons&", 0, Smoke::t_voidp | Smoke::tf_ref },	//34
	{ "KFile::Modes", 0, Smoke::t_uint | Smoke::tf_stack },	//35
	{ "KFile::Modes&", 0, Smoke::t_voidp | Smoke::tf_ref },	//36
	{ "KFileMetaInfo::WhatFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//37
	{ "KFileMetaInfo::WhatFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//38
	{ "KFontChooser::DisplayFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//39
	{ "KFontChooser::DisplayFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//40
	{ "KFontChooser::FontDiffFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//41
	{ "KFontChooser::FontDiffFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//42
	{ "KGlobalSettings::GraphicEffects", 0, Smoke::t_uint | Smoke::tf_stack },	//43
	{ "KGlobalSettings::GraphicEffects&", 0, Smoke::t_voidp | Smoke::tf_ref },	//44
	{ "KIO::JobFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//45
	{ "KIO::JobFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//46
	{ "KIO::NetRC::LookUpMode", 0, Smoke::t_uint | Smoke::tf_stack },	//47
	{ "KIO::NetRC::LookUpMode&", 0, Smoke::t_voidp | Smoke::tf_ref },	//48
	{ "KIO::TCPSlaveBase::SslResult", 0, Smoke::t_uint | Smoke::tf_stack },	//49
	{ "KIO::TCPSlaveBase::SslResult&", 0, Smoke::t_voidp | Smoke::tf_ref },	//50
	{ "KIcon", 8, Smoke::t_class | Smoke::tf_stack },	//51
	{ "KJob::Capabilities", 0, Smoke::t_uint | Smoke::tf_stack },	//52
	{ "KJob::Capabilities&", 0, Smoke::t_voidp | Smoke::tf_ref },	//53
	{ "KKeySequenceWidget::ShortcutTypes", 0, Smoke::t_uint | Smoke::tf_stack },	//54
	{ "KKeySequenceWidget::ShortcutTypes&", 0, Smoke::t_voidp | Smoke::tf_ref },	//55
	{ "KLocale::DateTimeFormatOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//56
	{ "KLocale::DateTimeFormatOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//57
	{ "KLockFile::LockFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//58
	{ "KLockFile::LockFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//59
	{ "KMessageBox::Options", 0, Smoke::t_uint | Smoke::tf_stack },	//60
	{ "KMessageBox::Options&", 0, Smoke::t_voidp | Smoke::tf_ref },	//61
	{ "KNotification::NotificationFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//62
	{ "KNotification::NotificationFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//63
	{ "KNotificationRestrictions::Services", 0, Smoke::t_uint | Smoke::tf_stack },	//64
	{ "KNotificationRestrictions::Services&", 0, Smoke::t_voidp | Smoke::tf_ref },	//65
	{ "KParts::BrowserExtension::PopupFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//66
	{ "KParts::BrowserExtension::PopupFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//67
	{ "KParts::GUIActivateEvent*", 11, Smoke::t_class | Smoke::tf_ptr },	//68
	{ "KParts::Part*", 12, Smoke::t_class | Smoke::tf_ptr },	//69
	{ "KParts::PartActivateEvent*", 13, Smoke::t_class | Smoke::tf_ptr },	//70
	{ "KParts::PartBase::PluginLoadingMode", 14, Smoke::t_enum | Smoke::tf_stack },	//71
	{ "KParts::PartManager*", 15, Smoke::t_class | Smoke::tf_ptr },	//72
	{ "KParts::PartManager::Reason", 15, Smoke::t_enum | Smoke::tf_stack },	//73
	{ "KParts::PartManager::SelectionPolicy", 15, Smoke::t_enum | Smoke::tf_stack },	//74
	{ "KParts::PartSelectEvent*", 16, Smoke::t_class | Smoke::tf_ptr },	//75
	{ "KPasswordDialog::KPasswordDialogFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//76
	{ "KPasswordDialog::KPasswordDialogFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//77
	{ "KPlotObject::PlotTypes", 0, Smoke::t_uint | Smoke::tf_stack },	//78
	{ "KPlotObject::PlotTypes&", 0, Smoke::t_voidp | Smoke::tf_ref },	//79
	{ "KServiceGroup::EntriesOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//80
	{ "KServiceGroup::EntriesOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//81
	{ "KSharedPtr<KService>", 0, Smoke::t_voidp | Smoke::tf_stack },	//82
	{ "KSharedPtr<KTextEditor::Attribute>", 0, Smoke::t_voidp | Smoke::tf_stack },	//83
	{ "KShell::Options", 0, Smoke::t_uint | Smoke::tf_stack },	//84
	{ "KShell::Options&", 0, Smoke::t_voidp | Smoke::tf_ref },	//85
	{ "KShortcutsEditor::ActionTypes", 0, Smoke::t_uint | Smoke::tf_stack },	//86
	{ "KShortcutsEditor::ActionTypes&", 0, Smoke::t_voidp | Smoke::tf_ref },	//87
	{ "KStandardDirs::SearchOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//88
	{ "KStandardDirs::SearchOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//89
	{ "KTextEditor::AnnotationInterface*", 21, Smoke::t_class | Smoke::tf_ptr },	//90
	{ "KTextEditor::AnnotationModel*", 22, Smoke::t_class | Smoke::tf_ptr },	//91
	{ "KTextEditor::AnnotationViewInterface*", 23, Smoke::t_class | Smoke::tf_ptr },	//92
	{ "KTextEditor::Attribute&", 24, Smoke::t_class | Smoke::tf_ref },	//93
	{ "KTextEditor::Attribute*", 24, Smoke::t_class | Smoke::tf_ptr },	//94
	{ "KTextEditor::Attribute::ActivationType", 24, Smoke::t_enum | Smoke::tf_stack },	//95
	{ "KTextEditor::Attribute::CustomProperties", 24, Smoke::t_enum | Smoke::tf_stack },	//96
	{ "KTextEditor::Attribute::Effect", 24, Smoke::t_enum | Smoke::tf_stack },	//97
	{ "KTextEditor::Attribute::Effects", 0, Smoke::t_uint | Smoke::tf_stack },	//98
	{ "KTextEditor::Attribute::Effects&", 0, Smoke::t_voidp | Smoke::tf_ref },	//99
	{ "KTextEditor::Attribute::Ptr", 0, Smoke::t_voidp | Smoke::tf_stack },	//100
	{ "KTextEditor::CodeCompletionInterface*", 25, Smoke::t_class | Smoke::tf_ptr },	//101
	{ "KTextEditor::CodeCompletionModel*", 26, Smoke::t_class | Smoke::tf_ptr },	//102
	{ "KTextEditor::CodeCompletionModel2*", 27, Smoke::t_class | Smoke::tf_ptr },	//103
	{ "KTextEditor::CodeCompletionModel::Columns", 26, Smoke::t_enum | Smoke::tf_stack },	//104
	{ "KTextEditor::CodeCompletionModel::CompletionProperties", 0, Smoke::t_uint | Smoke::tf_stack },	//105
	{ "KTextEditor::CodeCompletionModel::CompletionProperties&", 0, Smoke::t_voidp | Smoke::tf_ref },	//106
	{ "KTextEditor::CodeCompletionModel::CompletionProperty", 26, Smoke::t_enum | Smoke::tf_stack },	//107
	{ "KTextEditor::CodeCompletionModel::ExtraItemDataRoles", 26, Smoke::t_enum | Smoke::tf_stack },	//108
	{ "KTextEditor::CodeCompletionModel::HighlightMethod", 26, Smoke::t_enum | Smoke::tf_stack },	//109
	{ "KTextEditor::CodeCompletionModel::HighlightMethods", 0, Smoke::t_uint | Smoke::tf_stack },	//110
	{ "KTextEditor::CodeCompletionModel::HighlightMethods&", 0, Smoke::t_voidp | Smoke::tf_ref },	//111
	{ "KTextEditor::CodeCompletionModel::InvocationType", 26, Smoke::t_enum | Smoke::tf_stack },	//112
	{ "KTextEditor::Command*", 28, Smoke::t_class | Smoke::tf_ptr },	//113
	{ "KTextEditor::CommandExtension*", 29, Smoke::t_class | Smoke::tf_ptr },	//114
	{ "KTextEditor::CommandInterface*", 30, Smoke::t_class | Smoke::tf_ptr },	//115
	{ "KTextEditor::ConfigInterface*", 31, Smoke::t_class | Smoke::tf_ptr },	//116
	{ "KTextEditor::ConfigPage*", 32, Smoke::t_class | Smoke::tf_ptr },	//117
	{ "KTextEditor::ContainerInterface*", 33, Smoke::t_class | Smoke::tf_ptr },	//118
	{ "KTextEditor::Cursor", 34, Smoke::t_class | Smoke::tf_stack },	//119
	{ "KTextEditor::Cursor&", 34, Smoke::t_class | Smoke::tf_ref },	//120
	{ "KTextEditor::Cursor*", 34, Smoke::t_class | Smoke::tf_ptr },	//121
	{ "KTextEditor::Document*", 35, Smoke::t_class | Smoke::tf_ptr },	//122
	{ "KTextEditor::Editor*", 36, Smoke::t_class | Smoke::tf_ptr },	//123
	{ "KTextEditor::EditorChooser*", 37, Smoke::t_class | Smoke::tf_ptr },	//124
	{ "KTextEditor::Factory*", 38, Smoke::t_class | Smoke::tf_ptr },	//125
	{ "KTextEditor::Mark", 39, Smoke::t_class | Smoke::tf_stack },	//126
	{ "KTextEditor::Mark*", 39, Smoke::t_class | Smoke::tf_ptr },	//127
	{ "KTextEditor::MarkInterface*", 40, Smoke::t_class | Smoke::tf_ptr },	//128
	{ "KTextEditor::MarkInterface::MarkChangeAction", 40, Smoke::t_enum | Smoke::tf_stack },	//129
	{ "KTextEditor::MarkInterface::MarkTypes", 40, Smoke::t_enum | Smoke::tf_stack },	//130
	{ "KTextEditor::MdiContainer*", 41, Smoke::t_class | Smoke::tf_ptr },	//131
	{ "KTextEditor::ModificationInterface*", 42, Smoke::t_class | Smoke::tf_ptr },	//132
	{ "KTextEditor::ModificationInterface::ModifiedOnDiskReason", 42, Smoke::t_enum | Smoke::tf_stack },	//133
	{ "KTextEditor::Plugin*", 43, Smoke::t_class | Smoke::tf_ptr },	//134
	{ "KTextEditor::Range", 44, Smoke::t_class | Smoke::tf_stack },	//135
	{ "KTextEditor::Range&", 44, Smoke::t_class | Smoke::tf_ref },	//136
	{ "KTextEditor::Range*", 44, Smoke::t_class | Smoke::tf_ptr },	//137
	{ "KTextEditor::Search::SearchOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//138
	{ "KTextEditor::Search::SearchOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//139
	{ "KTextEditor::SearchInterface*", 45, Smoke::t_class | Smoke::tf_ptr },	//140
	{ "KTextEditor::SessionConfigInterface*", 46, Smoke::t_class | Smoke::tf_ptr },	//141
	{ "KTextEditor::SmartCursor&", 47, Smoke::t_class | Smoke::tf_ref },	//142
	{ "KTextEditor::SmartCursor*", 47, Smoke::t_class | Smoke::tf_ptr },	//143
	{ "KTextEditor::SmartCursor::AdvanceMode", 47, Smoke::t_enum | Smoke::tf_stack },	//144
	{ "KTextEditor::SmartCursor::InsertBehavior", 47, Smoke::t_enum | Smoke::tf_stack },	//145
	{ "KTextEditor::SmartCursorNotifier*", 48, Smoke::t_class | Smoke::tf_ptr },	//146
	{ "KTextEditor::SmartCursorWatcher*", 49, Smoke::t_class | Smoke::tf_ptr },	//147
	{ "KTextEditor::SmartInterface*", 50, Smoke::t_class | Smoke::tf_ptr },	//148
	{ "KTextEditor::SmartRange&", 51, Smoke::t_class | Smoke::tf_ref },	//149
	{ "KTextEditor::SmartRange*", 51, Smoke::t_class | Smoke::tf_ptr },	//150
	{ "KTextEditor::SmartRange::InsertBehavior", 51, Smoke::t_enum | Smoke::tf_stack },	//151
	{ "KTextEditor::SmartRange::InsertBehaviors", 0, Smoke::t_uint | Smoke::tf_stack },	//152
	{ "KTextEditor::SmartRange::InsertBehaviors&", 0, Smoke::t_voidp | Smoke::tf_ref },	//153
	{ "KTextEditor::SmartRangeNotifier*", 52, Smoke::t_class | Smoke::tf_ptr },	//154
	{ "KTextEditor::SmartRangeWatcher*", 53, Smoke::t_class | Smoke::tf_ptr },	//155
	{ "KTextEditor::TemplateInterface*", 54, Smoke::t_class | Smoke::tf_ptr },	//156
	{ "KTextEditor::TextHintInterface*", 55, Smoke::t_class | Smoke::tf_ptr },	//157
	{ "KTextEditor::VariableInterface*", 56, Smoke::t_class | Smoke::tf_ptr },	//158
	{ "KTextEditor::View*", 57, Smoke::t_class | Smoke::tf_ptr },	//159
	{ "KTextEditor::View::EditMode", 57, Smoke::t_enum | Smoke::tf_stack },	//160
	{ "KUniqueApplication::StartFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//161
	{ "KUniqueApplication::StartFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//162
	{ "KUrl&", 58, Smoke::t_class | Smoke::tf_ref },	//163
	{ "KUrl::AdjustPathOption", 58, Smoke::t_enum | Smoke::tf_stack },	//164
	{ "KUrl::CleanPathOption", 58, Smoke::t_enum | Smoke::tf_stack },	//165
	{ "KUrl::CleanPathOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//166
	{ "KUrl::CleanPathOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//167
	{ "KUrl::DirectoryOption", 58, Smoke::t_enum | Smoke::tf_stack },	//168
	{ "KUrl::DirectoryOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//169
	{ "KUrl::DirectoryOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//170
	{ "KUrl::EncodedPathAndQueryOption", 58, Smoke::t_enum | Smoke::tf_stack },	//171
	{ "KUrl::EncodedPathAndQueryOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//172
	{ "KUrl::EncodedPathAndQueryOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//173
	{ "KUrl::EqualsOption", 58, Smoke::t_enum | Smoke::tf_stack },	//174
	{ "KUrl::EqualsOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//175
	{ "KUrl::EqualsOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//176
	{ "KUrl::MimeDataFlags", 58, Smoke::t_enum | Smoke::tf_stack },	//177
	{ "KUrl::QueryItemsOption", 58, Smoke::t_enum | Smoke::tf_stack },	//178
	{ "KUrl::QueryItemsOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//179
	{ "KUrl::QueryItemsOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//180
	{ "KXMLGUIClient::ReverseStateChange", 59, Smoke::t_enum | Smoke::tf_stack },	//181
	{ "KXmlGuiWindow::StandardWindowOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//182
	{ "KXmlGuiWindow::StandardWindowOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//183
	{ "QAbstractFileEngine::FileFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//184
	{ "QAbstractFileEngine::FileFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//185
	{ "QAbstractItemView::EditTriggers", 0, Smoke::t_uint | Smoke::tf_stack },	//186
	{ "QAbstractItemView::EditTriggers&", 0, Smoke::t_voidp | Smoke::tf_ref },	//187
	{ "QAbstractPrintDialog::PrintDialogOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//188
	{ "QAbstractPrintDialog::PrintDialogOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//189
	{ "QAbstractSpinBox::StepEnabled", 0, Smoke::t_uint | Smoke::tf_stack },	//190
	{ "QAbstractSpinBox::StepEnabled&", 0, Smoke::t_voidp | Smoke::tf_ref },	//191
	{ "QAccessible::Relation", 0, Smoke::t_uint | Smoke::tf_stack },	//192
	{ "QAccessible::Relation&", 0, Smoke::t_voidp | Smoke::tf_ref },	//193
	{ "QAccessible::State", 0, Smoke::t_uint | Smoke::tf_stack },	//194
	{ "QAccessible::State&", 0, Smoke::t_voidp | Smoke::tf_ref },	//195
	{ "QAction*", 61, Smoke::t_class | Smoke::tf_ptr },	//196
	{ "QAction::ActionEvent", 61, Smoke::t_enum | Smoke::tf_stack },	//197
	{ "QAction::MenuRole", 61, Smoke::t_enum | Smoke::tf_stack },	//198
	{ "QActionEvent*", 62, Smoke::t_class | Smoke::tf_ptr },	//199
	{ "QBrush", 63, Smoke::t_class | Smoke::tf_stack },	//200
	{ "QChar", 64, Smoke::t_class | Smoke::tf_stack },	//201
	{ "QChar::Category", 64, Smoke::t_enum | Smoke::tf_stack },	//202
	{ "QChar::CombiningClass", 64, Smoke::t_enum | Smoke::tf_stack },	//203
	{ "QChar::Decomposition", 64, Smoke::t_enum | Smoke::tf_stack },	//204
	{ "QChar::Direction", 64, Smoke::t_enum | Smoke::tf_stack },	//205
	{ "QChar::Joining", 64, Smoke::t_enum | Smoke::tf_stack },	//206
	{ "QChar::SpecialCharacter", 64, Smoke::t_enum | Smoke::tf_stack },	//207
	{ "QChar::UnicodeVersion", 64, Smoke::t_enum | Smoke::tf_stack },	//208
	{ "QChildEvent*", 65, Smoke::t_class | Smoke::tf_ptr },	//209
	{ "QCloseEvent*", 66, Smoke::t_class | Smoke::tf_ptr },	//210
	{ "QColorDialog::ColorDialogOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//211
	{ "QColorDialog::ColorDialogOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//212
	{ "QContextMenuEvent*", 67, Smoke::t_class | Smoke::tf_ptr },	//213
	{ "QDBusConnection::RegisterOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//214
	{ "QDBusConnection::RegisterOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//215
	{ "QDateTimeEdit::Sections", 0, Smoke::t_uint | Smoke::tf_stack },	//216
	{ "QDateTimeEdit::Sections&", 0, Smoke::t_voidp | Smoke::tf_ref },	//217
	{ "QDialogButtonBox::StandardButtons", 0, Smoke::t_uint | Smoke::tf_stack },	//218
	{ "QDialogButtonBox::StandardButtons&", 0, Smoke::t_voidp | Smoke::tf_ref },	//219
	{ "QDir::Filters", 0, Smoke::t_uint | Smoke::tf_stack },	//220
	{ "QDir::Filters&", 0, Smoke::t_voidp | Smoke::tf_ref },	//221
	{ "QDir::SortFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//222
	{ "QDir::SortFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//223
	{ "QDirIterator::IteratorFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//224
	{ "QDirIterator::IteratorFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//225
	{ "QDockWidget::DockWidgetFeatures", 0, Smoke::t_uint | Smoke::tf_stack },	//226
	{ "QDockWidget::DockWidgetFeatures&", 0, Smoke::t_voidp | Smoke::tf_ref },	//227
	{ "QDomDocument", 68, Smoke::t_class | Smoke::tf_stack },	//228
	{ "QDragEnterEvent*", 70, Smoke::t_class | Smoke::tf_ptr },	//229
	{ "QDragLeaveEvent*", 71, Smoke::t_class | Smoke::tf_ptr },	//230
	{ "QDragMoveEvent*", 72, Smoke::t_class | Smoke::tf_ptr },	//231
	{ "QDropEvent*", 73, Smoke::t_class | Smoke::tf_ptr },	//232
	{ "QEvent*", 74, Smoke::t_class | Smoke::tf_ptr },	//233
	{ "QEvent::Type", 74, Smoke::t_enum | Smoke::tf_stack },	//234
	{ "QEventLoop::ProcessEventsFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//235
	{ "QEventLoop::ProcessEventsFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//236
	{ "QFile::Permissions", 0, Smoke::t_uint | Smoke::tf_stack },	//237
	{ "QFile::Permissions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//238
	{ "QFileDialog::Options", 0, Smoke::t_uint | Smoke::tf_stack },	//239
	{ "QFileDialog::Options&", 0, Smoke::t_voidp | Smoke::tf_ref },	//240
	{ "QFocusEvent*", 75, Smoke::t_class | Smoke::tf_ptr },	//241
	{ "QFontComboBox::FontFilters", 0, Smoke::t_uint | Smoke::tf_stack },	//242
	{ "QFontComboBox::FontFilters&", 0, Smoke::t_voidp | Smoke::tf_ref },	//243
	{ "QFontDialog::FontDialogOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//244
	{ "QFontDialog::FontDialogOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//245
	{ "QGL::FormatOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//246
	{ "QGL::FormatOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//247
	{ "QGLFormat::OpenGLVersionFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//248
	{ "QGLFormat::OpenGLVersionFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//249
	{ "QGraphicsItem::GraphicsItemFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//250
	{ "QGraphicsItem::GraphicsItemFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//251
	{ "QGraphicsScene::SceneLayers", 0, Smoke::t_uint | Smoke::tf_stack },	//252
	{ "QGraphicsScene::SceneLayers&", 0, Smoke::t_voidp | Smoke::tf_ref },	//253
	{ "QGraphicsView::CacheMode", 0, Smoke::t_uint | Smoke::tf_stack },	//254
	{ "QGraphicsView::CacheMode&", 0, Smoke::t_voidp | Smoke::tf_ref },	//255
	{ "QGraphicsView::OptimizationFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//256
	{ "QGraphicsView::OptimizationFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//257
	{ "QHideEvent*", 77, Smoke::t_class | Smoke::tf_ptr },	//258
	{ "QIODevice::OpenMode", 0, Smoke::t_uint | Smoke::tf_stack },	//259
	{ "QIODevice::OpenMode&", 0, Smoke::t_voidp | Smoke::tf_ref },	//260
	{ "QInputDialog::InputDialogOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//261
	{ "QInputDialog::InputDialogOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//262
	{ "QInputMethodEvent*", 79, Smoke::t_class | Smoke::tf_ptr },	//263
	{ "QItemSelectionModel::SelectionFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//264
	{ "QItemSelectionModel::SelectionFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//265
	{ "QKeyEvent*", 80, Smoke::t_class | Smoke::tf_ptr },	//266
	{ "QLibrary::LoadHints", 0, Smoke::t_uint | Smoke::tf_stack },	//267
	{ "QLibrary::LoadHints&", 0, Smoke::t_voidp | Smoke::tf_ref },	//268
	{ "QList<KTextEditor::Command*>", 0, Smoke::t_voidp | Smoke::tf_stack },	//269
	{ "QList<KTextEditor::SmartRange*>", 0, Smoke::t_voidp | Smoke::tf_stack },	//270
	{ "QList<QModelIndex>", 0, Smoke::t_voidp | Smoke::tf_stack },	//271
	{ "QLocale::NumberOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//272
	{ "QLocale::NumberOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//273
	{ "QMainWindow::DockOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//274
	{ "QMainWindow::DockOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//275
	{ "QMap<QString,QString>&", 0, Smoke::t_voidp | Smoke::tf_ref },	//276
	{ "QMap<int,QVariant>", 0, Smoke::t_voidp | Smoke::tf_stack },	//277
	{ "QMdiArea::AreaOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//278
	{ "QMdiArea::AreaOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//279
	{ "QMdiSubWindow::SubWindowOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//280
	{ "QMdiSubWindow::SubWindowOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//281
	{ "QMenu*", 83, Smoke::t_class | Smoke::tf_ptr },	//282
	{ "QMessageBox::StandardButtons", 0, Smoke::t_uint | Smoke::tf_stack },	//283
	{ "QMessageBox::StandardButtons&", 0, Smoke::t_voidp | Smoke::tf_ref },	//284
	{ "QMetaObject::Call", 84, Smoke::t_enum | Smoke::tf_stack },	//285
	{ "QMimeData*", 85, Smoke::t_class | Smoke::tf_ptr },	//286
	{ "QModelIndex", 86, Smoke::t_class | Smoke::tf_stack },	//287
	{ "QMouseEvent*", 87, Smoke::t_class | Smoke::tf_ptr },	//288
	{ "QMoveEvent*", 88, Smoke::t_class | Smoke::tf_ptr },	//289
	{ "QMutex*", 0, Smoke::t_voidp | Smoke::tf_ptr },	//290
	{ "QNetworkInterface::InterfaceFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//291
	{ "QNetworkInterface::InterfaceFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//292
	{ "QNetworkProxy::Capabilities", 0, Smoke::t_uint | Smoke::tf_stack },	//293
	{ "QNetworkProxy::Capabilities&", 0, Smoke::t_voidp | Smoke::tf_ref },	//294
	{ "QObject*", 89, Smoke::t_class | Smoke::tf_ptr },	//295
	{ "QPageSetupDialog::PageSetupDialogOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//296
	{ "QPageSetupDialog::PageSetupDialogOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//297
	{ "QPaintDevice*", 90, Smoke::t_class | Smoke::tf_ptr },	//298
	{ "QPaintDevice::PaintDeviceMetric", 90, Smoke::t_enum | Smoke::tf_stack },	//299
	{ "QPaintEngine*", 91, Smoke::t_class | Smoke::tf_ptr },	//300
	{ "QPaintEngine::DirtyFlag", 91, Smoke::t_enum | Smoke::tf_stack },	//301
	{ "QPaintEngine::DirtyFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//302
	{ "QPaintEngine::DirtyFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//303
	{ "QPaintEngine::PaintEngineFeature", 91, Smoke::t_enum | Smoke::tf_stack },	//304
	{ "QPaintEngine::PaintEngineFeatures", 0, Smoke::t_uint | Smoke::tf_stack },	//305
	{ "QPaintEngine::PaintEngineFeatures&", 0, Smoke::t_voidp | Smoke::tf_ref },	//306
	{ "QPaintEngine::PolygonDrawMode", 91, Smoke::t_enum | Smoke::tf_stack },	//307
	{ "QPaintEngine::Type", 91, Smoke::t_enum | Smoke::tf_stack },	//308
	{ "QPaintEvent*", 93, Smoke::t_class | Smoke::tf_ptr },	//309
	{ "QPainter::RenderHints", 0, Smoke::t_uint | Smoke::tf_stack },	//310
	{ "QPainter::RenderHints&", 0, Smoke::t_voidp | Smoke::tf_ref },	//311
	{ "QPainterPath::ElementType", 94, Smoke::t_enum | Smoke::tf_stack },	//312
	{ "QPixmap", 96, Smoke::t_class | Smoke::tf_stack },	//313
	{ "QPixmap::Type", 96, Smoke::t_enum | Smoke::tf_stack },	//314
	{ "QPoint", 97, Smoke::t_class | Smoke::tf_stack },	//315
	{ "QResizeEvent*", 101, Smoke::t_class | Smoke::tf_ptr },	//316
	{ "QShowEvent*", 102, Smoke::t_class | Smoke::tf_ptr },	//317
	{ "QSize", 103, Smoke::t_class | Smoke::tf_stack },	//318
	{ "QSizePolicy::ControlTypes", 0, Smoke::t_uint | Smoke::tf_stack },	//319
	{ "QSizePolicy::ControlTypes&", 0, Smoke::t_voidp | Smoke::tf_ref },	//320
	{ "QSql::ParamType", 0, Smoke::t_uint | Smoke::tf_stack },	//321
	{ "QSql::ParamType&", 0, Smoke::t_voidp | Smoke::tf_ref },	//322
	{ "QStack<KTextEditor::SmartRange*>*", 0, Smoke::t_voidp | Smoke::tf_ptr },	//323
	{ "QString", 0, Smoke::t_voidp | Smoke::tf_stack },	//324
	{ "QString&", 0, Smoke::t_voidp | Smoke::tf_ref },	//325
	{ "QString::SectionFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//326
	{ "QString::SectionFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//327
	{ "QStringList", 0, Smoke::t_voidp | Smoke::tf_stack },	//328
	{ "QStringList&", 0, Smoke::t_voidp | Smoke::tf_ref },	//329
	{ "QStyle&", 104, Smoke::t_class | Smoke::tf_ref },	//330
	{ "QStyle::State", 0, Smoke::t_uint | Smoke::tf_stack },	//331
	{ "QStyle::State&", 0, Smoke::t_voidp | Smoke::tf_ref },	//332
	{ "QStyle::SubControls", 0, Smoke::t_uint | Smoke::tf_stack },	//333
	{ "QStyle::SubControls&", 0, Smoke::t_voidp | Smoke::tf_ref },	//334
	{ "QStyleOptionButton::ButtonFeatures", 0, Smoke::t_uint | Smoke::tf_stack },	//335
	{ "QStyleOptionButton::ButtonFeatures&", 0, Smoke::t_voidp | Smoke::tf_ref },	//336
	{ "QStyleOptionFrameV2::FrameFeatures", 0, Smoke::t_uint | Smoke::tf_stack },	//337
	{ "QStyleOptionFrameV2::FrameFeatures&", 0, Smoke::t_voidp | Smoke::tf_ref },	//338
	{ "QStyleOptionQ3ListViewItem::Q3ListViewItemFeatures", 0, Smoke::t_uint | Smoke::tf_stack },	//339
	{ "QStyleOptionQ3ListViewItem::Q3ListViewItemFeatures&", 0, Smoke::t_voidp | Smoke::tf_ref },	//340
	{ "QStyleOptionTab::CornerWidgets", 0, Smoke::t_uint | Smoke::tf_stack },	//341
	{ "QStyleOptionTab::CornerWidgets&", 0, Smoke::t_voidp | Smoke::tf_ref },	//342
	{ "QStyleOptionToolBar::ToolBarFeatures", 0, Smoke::t_uint | Smoke::tf_stack },	//343
	{ "QStyleOptionToolBar::ToolBarFeatures&", 0, Smoke::t_voidp | Smoke::tf_ref },	//344
	{ "QStyleOptionToolButton::ToolButtonFeatures", 0, Smoke::t_uint | Smoke::tf_stack },	//345
	{ "QStyleOptionToolButton::ToolButtonFeatures&", 0, Smoke::t_voidp | Smoke::tf_ref },	//346
	{ "QStyleOptionViewItemV2::ViewItemFeatures", 0, Smoke::t_uint | Smoke::tf_stack },	//347
	{ "QStyleOptionViewItemV2::ViewItemFeatures&", 0, Smoke::t_voidp | Smoke::tf_ref },	//348
	{ "QTabletEvent*", 105, Smoke::t_class | Smoke::tf_ptr },	//349
	{ "QTextBoundaryFinder::BoundaryReasons", 0, Smoke::t_uint | Smoke::tf_stack },	//350
	{ "QTextBoundaryFinder::BoundaryReasons&", 0, Smoke::t_voidp | Smoke::tf_ref },	//351
	{ "QTextCharFormat::UnderlineStyle", 106, Smoke::t_enum | Smoke::tf_stack },	//352
	{ "QTextCharFormat::VerticalAlignment", 106, Smoke::t_enum | Smoke::tf_stack },	//353
	{ "QTextCodec::ConversionFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//354
	{ "QTextCodec::ConversionFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//355
	{ "QTextDocument::FindFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//356
	{ "QTextDocument::FindFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//357
	{ "QTextEdit::AutoFormatting", 0, Smoke::t_uint | Smoke::tf_stack },	//358
	{ "QTextEdit::AutoFormatting&", 0, Smoke::t_voidp | Smoke::tf_ref },	//359
	{ "QTextFormat::FormatType", 107, Smoke::t_enum | Smoke::tf_stack },	//360
	{ "QTextFormat::ObjectTypes", 107, Smoke::t_enum | Smoke::tf_stack },	//361
	{ "QTextFormat::PageBreakFlag", 107, Smoke::t_enum | Smoke::tf_stack },	//362
	{ "QTextFormat::PageBreakFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//363
	{ "QTextFormat::PageBreakFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//364
	{ "QTextFormat::Property", 107, Smoke::t_enum | Smoke::tf_stack },	//365
	{ "QTextItem::RenderFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//366
	{ "QTextItem::RenderFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//367
	{ "QTextOption::Flags", 0, Smoke::t_uint | Smoke::tf_stack },	//368
	{ "QTextOption::Flags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//369
	{ "QTextStream::NumberFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//370
	{ "QTextStream::NumberFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//371
	{ "QTimerEvent*", 108, Smoke::t_class | Smoke::tf_ptr },	//372
	{ "QTreeWidgetItemIterator::IteratorFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//373
	{ "QTreeWidgetItemIterator::IteratorFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//374
	{ "QUdpSocket::BindMode", 0, Smoke::t_uint | Smoke::tf_stack },	//375
	{ "QUdpSocket::BindMode&", 0, Smoke::t_voidp | Smoke::tf_ref },	//376
	{ "QUrl::FormattingOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//377
	{ "QUrl::FormattingOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//378
	{ "QVariant", 109, Smoke::t_class | Smoke::tf_stack },	//379
	{ "QVariant::Type", 109, Smoke::t_enum | Smoke::tf_stack },	//380
	{ "QVector<KTextEditor::Range>", 0, Smoke::t_voidp | Smoke::tf_stack },	//381
	{ "QWebPage::FindFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//382
	{ "QWebPage::FindFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//383
	{ "QWheelEvent*", 110, Smoke::t_class | Smoke::tf_ptr },	//384
	{ "QWidget*", 111, Smoke::t_class | Smoke::tf_ptr },	//385
	{ "QWidget::RenderFlag", 111, Smoke::t_enum | Smoke::tf_stack },	//386
	{ "QWidget::RenderFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//387
	{ "QWidget::RenderFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//388
	{ "QWizard::WizardOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//389
	{ "QWizard::WizardOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//390
	{ "Qt::Alignment", 0, Smoke::t_uint | Smoke::tf_stack },	//391
	{ "Qt::Alignment&", 0, Smoke::t_voidp | Smoke::tf_ref },	//392
	{ "Qt::AlignmentFlag", 112, Smoke::t_enum | Smoke::tf_stack },	//393
	{ "Qt::AnchorAttribute", 112, Smoke::t_enum | Smoke::tf_stack },	//394
	{ "Qt::ApplicationAttribute", 112, Smoke::t_enum | Smoke::tf_stack },	//395
	{ "Qt::ArrowType", 112, Smoke::t_enum | Smoke::tf_stack },	//396
	{ "Qt::AspectRatioMode", 112, Smoke::t_enum | Smoke::tf_stack },	//397
	{ "Qt::Axis", 112, Smoke::t_enum | Smoke::tf_stack },	//398
	{ "Qt::BGMode", 112, Smoke::t_enum | Smoke::tf_stack },	//399
	{ "Qt::BrushStyle", 112, Smoke::t_enum | Smoke::tf_stack },	//400
	{ "Qt::CaseSensitivity", 112, Smoke::t_enum | Smoke::tf_stack },	//401
	{ "Qt::CheckState", 112, Smoke::t_enum | Smoke::tf_stack },	//402
	{ "Qt::ClipOperation", 112, Smoke::t_enum | Smoke::tf_stack },	//403
	{ "Qt::ConnectionType", 112, Smoke::t_enum | Smoke::tf_stack },	//404
	{ "Qt::ContextMenuPolicy", 112, Smoke::t_enum | Smoke::tf_stack },	//405
	{ "Qt::Corner", 112, Smoke::t_enum | Smoke::tf_stack },	//406
	{ "Qt::CursorShape", 112, Smoke::t_enum | Smoke::tf_stack },	//407
	{ "Qt::DateFormat", 112, Smoke::t_enum | Smoke::tf_stack },	//408
	{ "Qt::DayOfWeek", 112, Smoke::t_enum | Smoke::tf_stack },	//409
	{ "Qt::DockWidgetArea", 112, Smoke::t_enum | Smoke::tf_stack },	//410
	{ "Qt::DockWidgetAreaSizes", 112, Smoke::t_enum | Smoke::tf_stack },	//411
	{ "Qt::DockWidgetAreas", 0, Smoke::t_uint | Smoke::tf_stack },	//412
	{ "Qt::DockWidgetAreas&", 0, Smoke::t_voidp | Smoke::tf_ref },	//413
	{ "Qt::DropAction", 112, Smoke::t_enum | Smoke::tf_stack },	//414
	{ "Qt::DropActions", 0, Smoke::t_uint | Smoke::tf_stack },	//415
	{ "Qt::DropActions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//416
	{ "Qt::EventPriority", 112, Smoke::t_enum | Smoke::tf_stack },	//417
	{ "Qt::FillRule", 112, Smoke::t_enum | Smoke::tf_stack },	//418
	{ "Qt::FocusPolicy", 112, Smoke::t_enum | Smoke::tf_stack },	//419
	{ "Qt::FocusReason", 112, Smoke::t_enum | Smoke::tf_stack },	//420
	{ "Qt::GlobalColor", 112, Smoke::t_enum | Smoke::tf_stack },	//421
	{ "Qt::HitTestAccuracy", 112, Smoke::t_enum | Smoke::tf_stack },	//422
	{ "Qt::ImageConversionFlag", 112, Smoke::t_enum | Smoke::tf_stack },	//423
	{ "Qt::ImageConversionFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//424
	{ "Qt::ImageConversionFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//425
	{ "Qt::InputMethodQuery", 112, Smoke::t_enum | Smoke::tf_stack },	//426
	{ "Qt::ItemDataRole", 112, Smoke::t_enum | Smoke::tf_stack },	//427
	{ "Qt::ItemFlag", 112, Smoke::t_enum | Smoke::tf_stack },	//428
	{ "Qt::ItemFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//429
	{ "Qt::ItemFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//430
	{ "Qt::ItemSelectionMode", 112, Smoke::t_enum | Smoke::tf_stack },	//431
	{ "Qt::Key", 112, Smoke::t_enum | Smoke::tf_stack },	//432
	{ "Qt::KeyboardModifier", 112, Smoke::t_enum | Smoke::tf_stack },	//433
	{ "Qt::KeyboardModifiers", 0, Smoke::t_uint | Smoke::tf_stack },	//434
	{ "Qt::KeyboardModifiers&", 0, Smoke::t_voidp | Smoke::tf_ref },	//435
	{ "Qt::LayoutDirection", 112, Smoke::t_enum | Smoke::tf_stack },	//436
	{ "Qt::MaskMode", 112, Smoke::t_enum | Smoke::tf_stack },	//437
	{ "Qt::MatchFlag", 112, Smoke::t_enum | Smoke::tf_stack },	//438
	{ "Qt::MatchFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//439
	{ "Qt::MatchFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//440
	{ "Qt::Modifier", 112, Smoke::t_enum | Smoke::tf_stack },	//441
	{ "Qt::MouseButton", 112, Smoke::t_enum | Smoke::tf_stack },	//442
	{ "Qt::MouseButtons", 0, Smoke::t_uint | Smoke::tf_stack },	//443
	{ "Qt::MouseButtons&", 0, Smoke::t_voidp | Smoke::tf_ref },	//444
	{ "Qt::Orientation", 112, Smoke::t_enum | Smoke::tf_stack },	//445
	{ "Qt::Orientations", 0, Smoke::t_uint | Smoke::tf_stack },	//446
	{ "Qt::Orientations&", 0, Smoke::t_voidp | Smoke::tf_ref },	//447
	{ "Qt::PenCapStyle", 112, Smoke::t_enum | Smoke::tf_stack },	//448
	{ "Qt::PenJoinStyle", 112, Smoke::t_enum | Smoke::tf_stack },	//449
	{ "Qt::PenStyle", 112, Smoke::t_enum | Smoke::tf_stack },	//450
	{ "Qt::ScrollBarPolicy", 112, Smoke::t_enum | Smoke::tf_stack },	//451
	{ "Qt::ShortcutContext", 112, Smoke::t_enum | Smoke::tf_stack },	//452
	{ "Qt::SizeHint", 112, Smoke::t_enum | Smoke::tf_stack },	//453
	{ "Qt::SizeMode", 112, Smoke::t_enum | Smoke::tf_stack },	//454
	{ "Qt::SortOrder", 112, Smoke::t_enum | Smoke::tf_stack },	//455
	{ "Qt::TextElideMode", 112, Smoke::t_enum | Smoke::tf_stack },	//456
	{ "Qt::TextFlag", 112, Smoke::t_enum | Smoke::tf_stack },	//457
	{ "Qt::TextFormat", 112, Smoke::t_enum | Smoke::tf_stack },	//458
	{ "Qt::TextInteractionFlag", 112, Smoke::t_enum | Smoke::tf_stack },	//459
	{ "Qt::TextInteractionFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//460
	{ "Qt::TextInteractionFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//461
	{ "Qt::TimeSpec", 112, Smoke::t_enum | Smoke::tf_stack },	//462
	{ "Qt::ToolBarArea", 112, Smoke::t_enum | Smoke::tf_stack },	//463
	{ "Qt::ToolBarAreaSizes", 112, Smoke::t_enum | Smoke::tf_stack },	//464
	{ "Qt::ToolBarAreas", 0, Smoke::t_uint | Smoke::tf_stack },	//465
	{ "Qt::ToolBarAreas&", 0, Smoke::t_voidp | Smoke::tf_ref },	//466
	{ "Qt::ToolButtonStyle", 112, Smoke::t_enum | Smoke::tf_stack },	//467
	{ "Qt::TransformationMode", 112, Smoke::t_enum | Smoke::tf_stack },	//468
	{ "Qt::UIEffect", 112, Smoke::t_enum | Smoke::tf_stack },	//469
	{ "Qt::WhiteSpaceMode", 112, Smoke::t_enum | Smoke::tf_stack },	//470
	{ "Qt::WidgetAttribute", 112, Smoke::t_enum | Smoke::tf_stack },	//471
	{ "Qt::WindowFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//472
	{ "Qt::WindowFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//473
	{ "Qt::WindowFrameSection", 112, Smoke::t_enum | Smoke::tf_stack },	//474
	{ "Qt::WindowModality", 112, Smoke::t_enum | Smoke::tf_stack },	//475
	{ "Qt::WindowState", 112, Smoke::t_enum | Smoke::tf_stack },	//476
	{ "Qt::WindowStates", 0, Smoke::t_uint | Smoke::tf_stack },	//477
	{ "Qt::WindowStates&", 0, Smoke::t_voidp | Smoke::tf_ref },	//478
	{ "Qt::WindowType", 112, Smoke::t_enum | Smoke::tf_stack },	//479
	{ "bool", 0, Smoke::t_bool | Smoke::tf_stack },	//480
	{ "const KAboutData*", 1, Smoke::t_class | Smoke::tf_ptr | Smoke::tf_const },	//481
	{ "const KComponentData&", 5, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//482
	{ "const KConfigGroup&", 7, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//483
	{ "const KTextEditor::AnnotationInterface&", 21, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//484
	{ "const KTextEditor::AnnotationViewInterface&", 23, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//485
	{ "const KTextEditor::Attribute&", 24, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//486
	{ "const KTextEditor::CodeCompletionInterface&", 25, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//487
	{ "const KTextEditor::Command&", 28, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//488
	{ "const KTextEditor::CommandExtension&", 29, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//489
	{ "const KTextEditor::CommandInterface&", 30, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//490
	{ "const KTextEditor::ConfigInterface&", 31, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//491
	{ "const KTextEditor::ContainerInterface&", 33, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//492
	{ "const KTextEditor::Cursor&", 34, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//493
	{ "const KTextEditor::Mark&", 39, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//494
	{ "const KTextEditor::MarkInterface&", 40, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//495
	{ "const KTextEditor::MdiContainer&", 41, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//496
	{ "const KTextEditor::ModificationInterface&", 42, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//497
	{ "const KTextEditor::Range&", 44, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//498
	{ "const KTextEditor::Search::SearchOptions", 0, Smoke::t_uint | Smoke::tf_stack | Smoke::tf_const },	//499
	{ "const KTextEditor::SearchInterface&", 45, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//500
	{ "const KTextEditor::SessionConfigInterface&", 46, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//501
	{ "const KTextEditor::SmartCursor&", 47, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//502
	{ "const KTextEditor::SmartCursorWatcher&", 49, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//503
	{ "const KTextEditor::SmartInterface&", 50, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//504
	{ "const KTextEditor::SmartRange&", 51, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//505
	{ "const KTextEditor::SmartRange*", 51, Smoke::t_class | Smoke::tf_ptr | Smoke::tf_const },	//506
	{ "const KTextEditor::SmartRangeWatcher&", 53, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//507
	{ "const KTextEditor::TemplateInterface&", 54, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//508
	{ "const KTextEditor::TextHintInterface&", 55, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//509
	{ "const KTextEditor::VariableInterface&", 56, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//510
	{ "const KUrl&", 58, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//511
	{ "const QBrush&", 63, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//512
	{ "const QDomDocument&", 68, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//513
	{ "const QDomElement&", 69, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//514
	{ "const QFont&", 76, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//515
	{ "const QHash<int,KTextEditor::Mark*>&", 0, Smoke::t_voidp | Smoke::tf_ref | Smoke::tf_const },	//516
	{ "const QImage&", 78, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//517
	{ "const QLine*", 81, Smoke::t_class | Smoke::tf_ptr | Smoke::tf_const },	//518
	{ "const QLineF*", 82, Smoke::t_class | Smoke::tf_ptr | Smoke::tf_const },	//519
	{ "const QList<KAction*>&", 0, Smoke::t_voidp | Smoke::tf_ref | Smoke::tf_const },	//520
	{ "const QList<KTextEditor::Document*>&", 0, Smoke::t_voidp | Smoke::tf_ref | Smoke::tf_const },	//521
	{ "const QList<KTextEditor::SmartRange*>", 0, Smoke::t_voidp | Smoke::tf_stack | Smoke::tf_const },	//522
	{ "const QList<KTextEditor::SmartRange*>&", 0, Smoke::t_voidp | Smoke::tf_ref | Smoke::tf_const },	//523
	{ "const QList<KTextEditor::SmartRangeNotifier*>", 0, Smoke::t_voidp | Smoke::tf_stack | Smoke::tf_const },	//524
	{ "const QList<KTextEditor::SmartRangeWatcher*>&", 0, Smoke::t_voidp | Smoke::tf_ref | Smoke::tf_const },	//525
	{ "const QList<KTextEditor::View*>&", 0, Smoke::t_voidp | Smoke::tf_ref | Smoke::tf_const },	//526
	{ "const QList<QModelIndex>&", 0, Smoke::t_voidp | Smoke::tf_ref | Smoke::tf_const },	//527
	{ "const QList<QVariant>&", 0, Smoke::t_voidp | Smoke::tf_ref | Smoke::tf_const },	//528
	{ "const QMap<QString,QString>&", 0, Smoke::t_voidp | Smoke::tf_ref | Smoke::tf_const },	//529
	{ "const QMap<int,QVariant>&", 0, Smoke::t_voidp | Smoke::tf_ref | Smoke::tf_const },	//530
	{ "const QMetaObject", 84, Smoke::t_class | Smoke::tf_stack | Smoke::tf_const },	//531
	{ "const QMetaObject*", 84, Smoke::t_class | Smoke::tf_ptr | Smoke::tf_const },	//532
	{ "const QMimeData*", 85, Smoke::t_class | Smoke::tf_ptr | Smoke::tf_const },	//533
	{ "const QModelIndex&", 86, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//534
	{ "const QPaintEngineState&", 92, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//535
	{ "const QPainterPath&", 94, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//536
	{ "const QPalette&", 95, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//537
	{ "const QPixmap&", 96, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//538
	{ "const QPoint&", 97, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//539
	{ "const QPoint*", 97, Smoke::t_class | Smoke::tf_ptr | Smoke::tf_const },	//540
	{ "const QPointF&", 98, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//541
	{ "const QPointF*", 98, Smoke::t_class | Smoke::tf_ptr | Smoke::tf_const },	//542
	{ "const QRect&", 99, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//543
	{ "const QRect*", 99, Smoke::t_class | Smoke::tf_ptr | Smoke::tf_const },	//544
	{ "const QRectF&", 100, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//545
	{ "const QRectF*", 100, Smoke::t_class | Smoke::tf_ptr | Smoke::tf_const },	//546
	{ "const QString&", 0, Smoke::t_voidp | Smoke::tf_ref | Smoke::tf_const },	//547
	{ "const QStringList&", 0, Smoke::t_voidp | Smoke::tf_ref | Smoke::tf_const },	//548
	{ "const QVariant&", 109, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//549
	{ "const QVariant::Handler*", 0, Smoke::t_voidp | Smoke::tf_ptr | Smoke::tf_const },	//550
	{ "const char*", 0, Smoke::t_voidp | Smoke::tf_ptr | Smoke::tf_const },	//551
	{ "const int", 0, Smoke::t_int | Smoke::tf_stack | Smoke::tf_const },	//552
	{ "enum EditMode", 0, Smoke::t_voidp | Smoke::tf_stack },	//553
	{ "int", 0, Smoke::t_int | Smoke::tf_stack },	//554
	{ "int&", 0, Smoke::t_voidp | Smoke::tf_ref },	//555
	{ "uint", 0, Smoke::t_uint | Smoke::tf_stack },	//556
	{ "void**", 0, Smoke::t_voidp | Smoke::tf_ptr },	//557
};

static Smoke::Index ktexteditor_argumentList[] = {
	0,	//0  (void)
	1, 0,	//1  KAction*  
	102, 0,	//3  KTextEditor::CodeCompletionModel*  
	102, 480, 0,	//5  KTextEditor::CodeCompletionModel*, bool  
	113, 0,	//8  KTextEditor::Command*  
	119, 0,	//10  KTextEditor::Cursor  
	121, 121, 0,	//12  KTextEditor::Cursor*, KTextEditor::Cursor*  
	121, 498, 0,	//15  KTextEditor::Cursor*, const KTextEditor::Range&  
	122, 0,	//18  KTextEditor::Document*  
	122, 126, 129, 0,	//20  KTextEditor::Document*, KTextEditor::Mark, KTextEditor::MarkInterface::MarkChangeAction  
	122, 159, 0,	//24  KTextEditor::Document*, KTextEditor::View*  
	122, 480, 0,	//27  KTextEditor::Document*, bool  
	122, 480, 133, 0,	//30  KTextEditor::Document*, bool, KTextEditor::ModificationInterface::ModifiedOnDiskReason  
	122, 498, 0,	//34  KTextEditor::Document*, const KTextEditor::Range&  
	122, 498, 498, 0,	//37  KTextEditor::Document*, const KTextEditor::Range&, const KTextEditor::Range&  
	122, 498, 534, 0,	//41  KTextEditor::Document*, const KTextEditor::Range&, const QModelIndex&  
	122, 547, 547, 0,	//45  KTextEditor::Document*, const QString&, const QString&  
	123, 122, 0,	//49  KTextEditor::Editor*, KTextEditor::Document*  
	13, 0,	//52  KConfig*  
	130, 0,	//54  KTextEditor::MarkInterface::MarkTypes  
	130, 538, 0,	//56  KTextEditor::MarkInterface::MarkTypes, const QPixmap&  
	130, 547, 0,	//59  KTextEditor::MarkInterface::MarkTypes, const QString&  
	133, 0,	//62  KTextEditor::ModificationInterface::ModifiedOnDiskReason  
	137, 0,	//64  KTextEditor::Range*  
	143, 0,	//66  KTextEditor::SmartCursor*  
	143, 143, 0,	//68  KTextEditor::SmartCursor*, KTextEditor::SmartCursor*  
	143, 143, 150, 0,	//71  KTextEditor::SmartCursor*, KTextEditor::SmartCursor*, KTextEditor::SmartRange*  
	143, 143, 150, 152, 0,	//75  KTextEditor::SmartCursor*, KTextEditor::SmartCursor*, KTextEditor::SmartRange*, KTextEditor::SmartRange::InsertBehaviors  
	143, 480, 0,	//80  KTextEditor::SmartCursor*, bool  
	145, 0,	//83  KTextEditor::SmartCursor::InsertBehavior  
	147, 0,	//85  KTextEditor::SmartCursorWatcher*  
	150, 0,	//87  KTextEditor::SmartRange*  
	150, 150, 0,	//89  KTextEditor::SmartRange*, KTextEditor::SmartRange*  
	150, 150, 150, 0,	//92  KTextEditor::SmartRange*, KTextEditor::SmartRange*, KTextEditor::SmartRange*  
	150, 159, 0,	//96  KTextEditor::SmartRange*, KTextEditor::View*  
	150, 480, 0,	//99  KTextEditor::SmartRange*, bool  
	150, 83, 83, 0,	//102  KTextEditor::SmartRange*, KSharedPtr<KTextEditor::Attribute>, KSharedPtr<KTextEditor::Attribute>  
	152, 0,	//106  KTextEditor::SmartRange::InsertBehaviors  
	154, 0,	//108  KTextEditor::SmartRangeNotifier*  
	155, 0,	//110  KTextEditor::SmartRangeWatcher*  
	159, 0,	//112  KTextEditor::View*  
	159, 150, 0,	//114  KTextEditor::View*, KTextEditor::SmartRange*  
	159, 150, 480, 0,	//117  KTextEditor::View*, KTextEditor::SmartRange*, bool  
	159, 160, 0,	//121  KTextEditor::View*, KTextEditor::View::EditMode  
	159, 282, 0,	//124  KTextEditor::View*, QMenu*  
	159, 282, 554, 0,	//127  KTextEditor::View*, QMenu*, int  
	159, 480, 0,	//131  KTextEditor::View*, bool  
	159, 493, 0,	//134  KTextEditor::View*, const KTextEditor::Cursor&  
	159, 493, 547, 0,	//137  KTextEditor::View*, const KTextEditor::Cursor&, const QString&  
	159, 498, 112, 0,	//141  KTextEditor::View*, const KTextEditor::Range&, KTextEditor::CodeCompletionModel::InvocationType  
	159, 547, 0,	//145  KTextEditor::View*, const QString&  
	159, 547, 325, 0,	//148  KTextEditor::View*, const QString&, QString&  
	159, 554, 0,	//152  KTextEditor::View*, int  
	18, 0,	//155  KConfigGroup&  
	199, 0,	//157  QActionEvent*  
	209, 0,	//159  QChildEvent*  
	210, 0,	//161  QCloseEvent*  
	213, 0,	//163  QContextMenuEvent*  
	229, 0,	//165  QDragEnterEvent*  
	230, 0,	//167  QDragLeaveEvent*  
	231, 0,	//169  QDragMoveEvent*  
	232, 0,	//171  QDropEvent*  
	233, 0,	//173  QEvent*  
	241, 0,	//175  QFocusEvent*  
	258, 0,	//177  QHideEvent*  
	263, 0,	//179  QInputMethodEvent*  
	266, 0,	//181  QKeyEvent*  
	276, 385, 0,	//183  QMap<QString,QString>&, QWidget*  
	282, 0,	//186  QMenu*  
	285, 554, 557, 0,	//188  QMetaObject::Call, int, void**  
	288, 0,	//192  QMouseEvent*  
	289, 0,	//194  QMoveEvent*  
	295, 0,	//196  QObject*  
	295, 233, 0,	//198  QObject*, QEvent*  
	295, 551, 0,	//201  QObject*, const char*  
	295, 551, 548, 0,	//204  QObject*, const char*, const QStringList&  
	299, 0,	//208  QPaintDevice::PaintDeviceMetric  
	309, 0,	//210  QPaintEvent*  
	316, 0,	//212  QResizeEvent*  
	317, 0,	//214  QShowEvent*  
	329, 0,	//216  QStringList&  
	330, 0,	//218  QStyle&  
	349, 0,	//220  QTabletEvent*  
	372, 0,	//222  QTimerEvent*  
	384, 0,	//224  QWheelEvent*  
	385, 0,	//226  QWidget*  
	385, 295, 0,	//228  QWidget*, QObject*  
	385, 295, 551, 0,	//231  QWidget*, QObject*, const char*  
	385, 295, 551, 548, 0,	//235  QWidget*, QObject*, const char*, const QStringList&  
	385, 539, 0,	//240  QWidget*, const QPoint&  
	426, 0,	//243  Qt::InputMethodQuery  
	480, 0,	//245  bool  
	482, 0,	//247  const KComponentData&  
	482, 480, 0,	//249  const KComponentData&, bool  
	483, 0,	//252  const KConfigGroup&  
	484, 0,	//254  const KTextEditor::AnnotationInterface&  
	485, 0,	//256  const KTextEditor::AnnotationViewInterface&  
	486, 0,	//258  const KTextEditor::Attribute&  
	487, 0,	//260  const KTextEditor::CodeCompletionInterface&  
	488, 0,	//262  const KTextEditor::Command&  
	489, 0,	//264  const KTextEditor::CommandExtension&  
	490, 0,	//266  const KTextEditor::CommandInterface&  
	491, 0,	//268  const KTextEditor::ConfigInterface&  
	492, 0,	//270  const KTextEditor::ContainerInterface&  
	493, 0,	//272  const KTextEditor::Cursor&  
	493, 122, 145, 0,	//274  const KTextEditor::Cursor&, KTextEditor::Document*, KTextEditor::SmartCursor::InsertBehavior  
	493, 145, 0,	//278  const KTextEditor::Cursor&, KTextEditor::SmartCursor::InsertBehavior  
	493, 323, 0,	//281  const KTextEditor::Cursor&, QStack<KTextEditor::SmartRange*>*  
	493, 323, 323, 0,	//284  const KTextEditor::Cursor&, QStack<KTextEditor::SmartRange*>*, QStack<KTextEditor::SmartRange*>*  
	493, 325, 0,	//288  const KTextEditor::Cursor&, QString&  
	493, 493, 0,	//291  const KTextEditor::Cursor&, const KTextEditor::Cursor&  
	493, 493, 150, 0,	//294  const KTextEditor::Cursor&, const KTextEditor::Cursor&, KTextEditor::SmartRange*  
	493, 493, 150, 152, 0,	//298  const KTextEditor::Cursor&, const KTextEditor::Cursor&, KTextEditor::SmartRange*, KTextEditor::SmartRange::InsertBehaviors  
	493, 547, 0,	//303  const KTextEditor::Cursor&, const QString&  
	493, 547, 480, 0,	//306  const KTextEditor::Cursor&, const QString&, bool  
	493, 547, 529, 0,	//310  const KTextEditor::Cursor&, const QString&, const QMap<QString,QString>&  
	493, 548, 0,	//314  const KTextEditor::Cursor&, const QStringList&  
	493, 548, 480, 0,	//317  const KTextEditor::Cursor&, const QStringList&, bool  
	493, 554, 0,	//321  const KTextEditor::Cursor&, int  
	493, 554, 480, 0,	//324  const KTextEditor::Cursor&, int, bool  
	493, 554, 554, 0,	//328  const KTextEditor::Cursor&, int, int  
	494, 0,	//332  const KTextEditor::Mark&  
	495, 0,	//334  const KTextEditor::MarkInterface&  
	496, 0,	//336  const KTextEditor::MdiContainer&  
	497, 0,	//338  const KTextEditor::ModificationInterface&  
	498, 0,	//340  const KTextEditor::Range&  
	498, 102, 0,	//342  const KTextEditor::Range&, KTextEditor::CodeCompletionModel*  
	498, 150, 0,	//345  const KTextEditor::Range&, KTextEditor::SmartRange*  
	498, 150, 152, 0,	//348  const KTextEditor::Range&, KTextEditor::SmartRange*, KTextEditor::SmartRange::InsertBehaviors  
	498, 152, 0,	//352  const KTextEditor::Range&, KTextEditor::SmartRange::InsertBehaviors  
	498, 480, 0,	//355  const KTextEditor::Range&, bool  
	498, 547, 0,	//358  const KTextEditor::Range&, const QString&  
	498, 547, 480, 0,	//361  const KTextEditor::Range&, const QString&, bool  
	498, 547, 499, 0,	//365  const KTextEditor::Range&, const QString&, const KTextEditor::Search::SearchOptions  
	498, 548, 0,	//369  const KTextEditor::Range&, const QStringList&  
	498, 548, 480, 0,	//372  const KTextEditor::Range&, const QStringList&, bool  
	500, 0,	//376  const KTextEditor::SearchInterface&  
	501, 0,	//378  const KTextEditor::SessionConfigInterface&  
	502, 0,	//380  const KTextEditor::SmartCursor&  
	503, 0,	//382  const KTextEditor::SmartCursorWatcher&  
	504, 0,	//384  const KTextEditor::SmartInterface&  
	505, 0,	//386  const KTextEditor::SmartRange&  
	506, 0,	//388  const KTextEditor::SmartRange*  
	507, 0,	//390  const KTextEditor::SmartRangeWatcher&  
	508, 0,	//392  const KTextEditor::TemplateInterface&  
	509, 0,	//394  const KTextEditor::TextHintInterface&  
	510, 0,	//396  const KTextEditor::VariableInterface&  
	511, 0,	//398  const KUrl&  
	512, 0,	//400  const QBrush&  
	513, 0,	//402  const QDomDocument&  
	513, 480, 0,	//404  const QDomDocument&, bool  
	514, 0,	//407  const QDomElement&  
	515, 0,	//409  const QFont&  
	527, 0,	//411  const QList<QModelIndex>&  
	533, 414, 554, 554, 534, 0,	//413  const QMimeData*, Qt::DropAction, int, int, const QModelIndex&  
	534, 0,	//419  const QModelIndex&  
	534, 530, 0,	//421  const QModelIndex&, const QMap<int,QVariant>&  
	534, 549, 0,	//424  const QModelIndex&, const QVariant&  
	534, 549, 554, 0,	//427  const QModelIndex&, const QVariant&, int  
	534, 554, 0,	//431  const QModelIndex&, int  
	534, 554, 549, 0,	//434  const QModelIndex&, int, const QVariant&  
	534, 554, 549, 554, 0,	//438  const QModelIndex&, int, const QVariant&, int  
	534, 554, 549, 554, 439, 0,	//443  const QModelIndex&, int, const QVariant&, int, Qt::MatchFlags  
	537, 0,	//449  const QPalette&  
	547, 0,	//451  const QString&  
	547, 181, 0,	//453  const QString&, KXMLGUIClient::ReverseStateChange  
	547, 480, 0,	//456  const QString&, bool  
	547, 480, 480, 0,	//459  const QString&, bool, bool  
	547, 549, 0,	//463  const QString&, const QVariant&  
	548, 0,	//466  const QStringList&  
	548, 480, 0,	//468  const QStringList&, bool  
	551, 0,	//471  const char*  
	551, 385, 295, 528, 547, 0,	//473  const char*, QWidget*, QObject*, const QList<QVariant>&, const QString&  
	554, 0,	//479  int  
	554, 144, 0,	//481  int, KTextEditor::SmartCursor::AdvanceMode  
	554, 385, 0,	//484  int, QWidget*  
	554, 427, 0,	//487  int, Qt::ItemDataRole  
	554, 445, 0,	//490  int, Qt::Orientation  
	554, 445, 549, 0,	//493  int, Qt::Orientation, const QVariant&  
	554, 445, 549, 554, 0,	//497  int, Qt::Orientation, const QVariant&, int  
	554, 445, 554, 0,	//502  int, Qt::Orientation, int  
	554, 455, 0,	//506  int, Qt::SortOrder  
	554, 547, 0,	//509  int, const QString&  
	554, 548, 0,	//512  int, const QStringList&  
	554, 554, 0,	//515  int, int  
	554, 554, 145, 0,	//518  int, int, KTextEditor::SmartCursor::InsertBehavior  
	554, 554, 534, 0,	//522  int, int, const QModelIndex&  
	554, 554, 554, 554, 0,	//526  int, int, int, int  
	554, 554, 554, 554, 150, 0,	//531  int, int, int, int, KTextEditor::SmartRange*  
	554, 554, 554, 554, 150, 152, 0,	//537  int, int, int, int, KTextEditor::SmartRange*, KTextEditor::SmartRange::InsertBehaviors  
	554, 556, 0,	//544  int, uint  
	555, 555, 0,	//547  int&, int&  
	556, 0,	//550  uint  
	68, 0,	//552  KParts::GUIActivateEvent*  
	70, 0,	//554  KParts::PartActivateEvent*  
	72, 0,	//556  KParts::PartManager*  
	75, 0,	//558  KParts::PartSelectEvent*  
	82, 295, 0,	//560  KSharedPtr<KService>, QObject*  
	83, 0,	//563  KSharedPtr<KTextEditor::Attribute>  
	91, 0,	//565  KTextEditor::AnnotationModel*  
	95, 0,	//567  KTextEditor::Attribute::ActivationType  
	95, 83, 0,	//569  KTextEditor::Attribute::ActivationType, KSharedPtr<KTextEditor::Attribute>  
	98, 0,	//572  KTextEditor::Attribute::Effects  
};

// Raw list of all methods, using munged names
static const char *ktexteditor_methodNames[] = {
    "",	//0
    "AccessibilityAccept",	//1
    "AccessibilityNext",	//2
    "AccessibilityPrevious",	//3
    "ActivateCaretIn",	//4
    "ActivateMouseIn",	//5
    "AnnotationInterface",	//6
    "AnnotationInterface#",	//7
    "AnnotationModel",	//8
    "AnnotationViewInterface",	//9
    "AnnotationViewInterface#",	//10
    "ArgumentHintDepth",	//11
    "Arguments",	//12
    "Attribute",	//13
    "Attribute#",	//14
    "AttributeDynamicEffect",	//15
    "AttributeInternalProperty",	//16
    "AttributeUserProperty",	//17
    "AutomaticInvocation",	//18
    "BackgroundFillWhitespace",	//19
    "BestMatchesCount",	//20
    "Bookmark",	//21
    "BreakpointActive",	//22
    "BreakpointDisabled",	//23
    "BreakpointReached",	//24
    "ByCharacter",	//25
    "ByCursorPosition",	//26
    "Class",	//27
    "CodeCompletionInterface",	//28
    "CodeCompletionInterface#",	//29
    "CodeCompletionModel",	//30
    "CodeCompletionModel#",	//31
    "CodeCompletionModel2",	//32
    "CodeCompletionModel2#",	//33
    "ColumnCount",	//34
    "Command",	//35
    "Command#",	//36
    "CommandExtension",	//37
    "CommandExtension#",	//38
    "CommandInterface",	//39
    "CommandInterface#",	//40
    "CompletionRole",	//41
    "ConfigInterface",	//42
    "ConfigInterface#",	//43
    "ConfigPage",	//44
    "ConfigPage#",	//45
    "Const",	//46
    "ContainerInterface",	//47
    "ContainerInterface#",	//48
    "Cursor",	//49
    "Cursor#",	//50
    "Cursor$$",	//51
    "CustomHighlight",	//52
    "CustomHighlighting",	//53
    "DoNotExpand",	//54
    "Document",	//55
    "Document#",	//56
    "EditInsert",	//57
    "EditOverwrite",	//58
    "Editor",	//59
    "Editor#",	//60
    "EditorChooser",	//61
    "EditorChooser#",	//62
    "EffectCycleGradient",	//63
    "EffectFadeIn",	//64
    "EffectFadeOut",	//65
    "EffectNone",	//66
    "EffectPulse",	//67
    "Enum",	//68
    "Error",	//69
    "Execution",	//70
    "ExpandLeft",	//71
    "ExpandRight",	//72
    "ExpandingWidget",	//73
    "Factory",	//74
    "Factory#",	//75
    "FirstProperty",	//76
    "Friend",	//77
    "Function",	//78
    "GlobalScope",	//79
    "GroupRole",	//80
    "HighlightingMethod",	//81
    "Icon",	//82
    "InheritanceDepth",	//83
    "Inline",	//84
    "InternalHighlighting",	//85
    "IsExpandable",	//86
    "ItemSelected",	//87
    "LastItemDataRole",	//88
    "LastProperty",	//89
    "LocalScope",	//90
    "ManualInvocation",	//91
    "Mark",	//92
    "Mark#",	//93
    "MarkAdded",	//94
    "MarkInterface",	//95
    "MarkInterface#",	//96
    "MarkRemoved",	//97
    "MatchQuality",	//98
    "MdiContainer",	//99
    "MdiContainer#",	//100
    "ModificationInterface",	//101
    "ModificationInterface#",	//102
    "MoveOnInsert",	//103
    "Name",	//104
    "Namespace",	//105
    "NamespaceScope",	//106
    "NoHighlighting",	//107
    "NoProperty",	//108
    "OnDiskCreated",	//109
    "OnDiskDeleted",	//110
    "OnDiskModified",	//111
    "OnDiskUnmodified",	//112
    "Outline",	//113
    "Override",	//114
    "Plugin",	//115
    "Plugin#",	//116
    "Postfix",	//117
    "Prefix",	//118
    "Private",	//119
    "Protected",	//120
    "Public",	//121
    "Range",	//122
    "Range#",	//123
    "Range##",	//124
    "Range#$",	//125
    "Range#$$",	//126
    "Range$$$$",	//127
    "Scope",	//128
    "ScopeIndex",	//129
    "SearchInterface",	//130
    "SearchInterface#",	//131
    "SelectedBackground",	//132
    "SelectedForeground",	//133
    "SessionConfigInterface",	//134
    "SessionConfigInterface#",	//135
    "SetMatchContext",	//136
    "Signal",	//137
    "Slot",	//138
    "SmartCursor",	//139
    "SmartCursor##$",	//140
    "SmartCursorNotifier",	//141
    "SmartCursorWatcher",	//142
    "SmartCursorWatcher#",	//143
    "SmartInterface",	//144
    "SmartInterface#",	//145
    "SmartRange",	//146
    "SmartRange##",	//147
    "SmartRange###",	//148
    "SmartRange###$",	//149
    "SmartRangeNotifier",	//150
    "SmartRangeWatcher",	//151
    "SmartRangeWatcher#",	//152
    "Static",	//153
    "StayOnInsert",	//154
    "Struct",	//155
    "Template",	//156
    "TemplateInterface",	//157
    "TemplateInterface#",	//158
    "TextHintInterface",	//159
    "TextHintInterface#",	//160
    "TypeAlias",	//161
    "Union",	//162
    "UserInvocation",	//163
    "Variable",	//164
    "VariableInterface",	//165
    "VariableInterface#",	//166
    "View",	//167
    "View#",	//168
    "Virtual",	//169
    "Warning",	//170
    "abortCompletion",	//171
    "aboutData",	//172
    "aboutToClose",	//173
    "aboutToClose#",	//174
    "aboutToReload",	//175
    "aboutToReload#",	//176
    "action",	//177
    "action#",	//178
    "actionCollection",	//179
    "actionEvent",	//180
    "actionEvent#",	//181
    "activeView",	//182
    "addActionsToDocument",	//183
    "addActionsToDocument#",	//184
    "addActionsToView",	//185
    "addActionsToView##",	//186
    "addDocument",	//187
    "addDocument#",	//188
    "addHighlightToDocument",	//189
    "addHighlightToDocument#",	//190
    "addHighlightToDocument#$",	//191
    "addHighlightToView",	//192
    "addHighlightToView##",	//193
    "addHighlightToView##$",	//194
    "addMark",	//195
    "addMark$$",	//196
    "addNotifier",	//197
    "addNotifier#",	//198
    "addView",	//199
    "addView#",	//200
    "addWatcher",	//201
    "addWatcher#",	//202
    "advance",	//203
    "advance$",	//204
    "advance$$",	//205
    "annotationActivated",	//206
    "annotationActivated#$",	//207
    "annotationBorderVisibilityChanged",	//208
    "annotationBorderVisibilityChanged#$",	//209
    "annotationContextMenuAboutToShow",	//210
    "annotationContextMenuAboutToShow##$",	//211
    "annotationModel",	//212
    "apply",	//213
    "associateAction",	//214
    "associateAction#",	//215
    "associatedActions",	//216
    "atEndOfDocument",	//217
    "atEndOfLine",	//218
    "atStartOfDocument",	//219
    "atStartOfLine",	//220
    "attribute",	//221
    "attributeDynamic",	//222
    "attributeDynamic?",	//223
    "attributeNotDynamic",	//224
    "attributeNotDynamic?",	//225
    "backgroundFillWhitespace",	//226
    "blockSelection",	//227
    "boundaryAtCursor",	//228
    "boundaryAtCursor#",	//229
    "boundaryOnLine",	//230
    "boundaryOnLine$",	//231
    "buddy",	//232
    "buddy#",	//233
    "canFetchMore",	//234
    "canFetchMore#",	//235
    "caretEnteredRange",	//236
    "caretEnteredRange##",	//237
    "caretExitedRange",	//238
    "caretExitedRange##",	//239
    "changeEvent",	//240
    "changeEvent#",	//241
    "changed",	//242
    "character",	//243
    "character#",	//244
    "characterDeleted",	//245
    "characterDeleted#$",	//246
    "characterInserted",	//247
    "characterInserted#$",	//248
    "checkFeedback",	//249
    "childAfter",	//250
    "childAfter#",	//251
    "childBefore",	//252
    "childBefore#",	//253
    "childEvent",	//254
    "childEvent#",	//255
    "childRangeInserted",	//256
    "childRangeInserted##",	//257
    "childRangeRemoved",	//258
    "childRangeRemoved##",	//259
    "childRanges",	//260
    "clear",	//261
    "clearAndDeleteChildRanges",	//262
    "clearAssociatedActions",	//263
    "clearChildRanges",	//264
    "clearDocumentActions",	//265
    "clearDocumentHighlights",	//266
    "clearMark",	//267
    "clearMark$",	//268
    "clearMarks",	//269
    "clearOnDocumentReload",	//270
    "clearRevision",	//271
    "clearSmartInterface",	//272
    "clearViewActions",	//273
    "clearViewActions#",	//274
    "clearViewHighlights",	//275
    "clearViewHighlights#",	//276
    "closeDocument",	//277
    "closeDocument#",	//278
    "closeEvent",	//279
    "closeEvent#",	//280
    "closeUrl",	//281
    "closeUrl$",	//282
    "closeView",	//283
    "closeView#",	//284
    "cmds",	//285
    "column",	//286
    "columnCount",	//287
    "columnCount#",	//288
    "columnWidth",	//289
    "commandList",	//290
    "commands",	//291
    "completionInvoked",	//292
    "completionInvoked##$",	//293
    "completionObject",	//294
    "completionObject#$",	//295
    "componentData",	//296
    "configDialog",	//297
    "configDialog#",	//298
    "configDialogSupported",	//299
    "configKeys",	//300
    "configPage",	//301
    "configPage$#",	//302
    "configPageFullName",	//303
    "configPageFullName$",	//304
    "configPageIcon",	//305
    "configPageIcon$",	//306
    "configPageName",	//307
    "configPageName$",	//308
    "configPages",	//309
    "configValue",	//310
    "configValue$",	//311
    "confineToRange",	//312
    "confineToRange#",	//313
    "connectNotify",	//314
    "connectNotify$",	//315
    "container",	//316
    "contains",	//317
    "contains#",	//318
    "containsColumn",	//319
    "containsColumn$",	//320
    "containsLine",	//321
    "containsLine$",	//322
    "contextMenu",	//323
    "contextMenuAboutToShow",	//324
    "contextMenuAboutToShow##",	//325
    "contextMenuEvent",	//326
    "contextMenuEvent#",	//327
    "create",	//328
    "create$##?$",	//329
    "createDocument",	//330
    "createDocument#",	//331
    "createNotifier",	//332
    "createObject",	//333
    "createObject#",	//334
    "createObject#$",	//335
    "createObject#$?",	//336
    "createPartObject",	//337
    "createPartObject#",	//338
    "createPartObject##",	//339
    "createPartObject##$",	//340
    "createPartObject##$?",	//341
    "createPlugin",	//342
    "createPlugin?#",	//343
    "createView",	//344
    "createView#",	//345
    "currentRevision",	//346
    "cursorChangedDirectly",	//347
    "cursorChangedDirectly#",	//348
    "cursorInText",	//349
    "cursorInText#",	//350
    "cursorPosition",	//351
    "cursorPositionChanged",	//352
    "cursorPositionChanged##",	//353
    "cursorPositionCoordinates",	//354
    "cursorPositionVirtual",	//355
    "cursorToCoordinate",	//356
    "cursorToCoordinate#",	//357
    "customEvent",	//358
    "customEvent#",	//359
    "data",	//360
    "data#",	//361
    "data#$",	//362
    "data$$",	//363
    "deepestRangeContaining",	//364
    "deepestRangeContaining#",	//365
    "deepestRangeContaining#?",	//366
    "deepestRangeContaining#??",	//367
    "deepestRangesContaining",	//368
    "deepestRangesContaining#",	//369
    "defaultContextMenu",	//370
    "defaultContextMenu#",	//371
    "defaults",	//372
    "deleteChildRanges",	//373
    "deleteCursors",	//374
    "deleteNotifier",	//375
    "deletePrimaryNotifier",	//376
    "deleteRanges",	//377
    "deleted",	//378
    "deleted#",	//379
    "depth",	//380
    "devType",	//381
    "disableTextHints",	//382
    "disconnectNotify",	//383
    "disconnectNotify$",	//384
    "dissociateAction",	//385
    "dissociateAction#",	//386
    "document",	//387
    "documentActions",	//388
    "documentCreated",	//389
    "documentCreated##",	//390
    "documentEnd",	//391
    "documentHighlights",	//392
    "documentName",	//393
    "documentNameChanged",	//394
    "documentNameChanged#",	//395
    "documentRange",	//396
    "documentReload",	//397
    "documentSave",	//398
    "documentSaveAs",	//399
    "documentSavedOrUploaded",	//400
    "documentSavedOrUploaded#$",	//401
    "documentUrlChanged",	//402
    "documentUrlChanged#",	//403
    "documents",	//404
    "domDocument",	//405
    "dragEnterEvent",	//406
    "dragEnterEvent#",	//407
    "dragLeaveEvent",	//408
    "dragLeaveEvent#",	//409
    "dragMoveEvent",	//410
    "dragMoveEvent#",	//411
    "dropEvent",	//412
    "dropEvent#",	//413
    "dropMimeData",	//414
    "dropMimeData#$$$#",	//415
    "dynamicAttribute",	//416
    "dynamicAttribute$",	//417
    "editableMarks",	//418
    "editor",	//419
    "editor$",	//420
    "editor$$",	//421
    "effects",	//422
    "embed",	//423
    "embed#",	//424
    "enableTextHints",	//425
    "enableTextHints$",	//426
    "enabledChange",	//427
    "enabledChange$",	//428
    "encoding",	//429
    "encompass",	//430
    "encompass#",	//431
    "end",	//432
    "endEditing",	//433
    "endOfLine",	//434
    "endOfLine$",	//435
    "enterEvent",	//436
    "enterEvent#",	//437
    "event",	//438
    "event#",	//439
    "eventFilter",	//440
    "eventFilter##",	//441
    "exec",	//442
    "exec#$$",	//443
    "executeCompletionItem2",	//444
    "executeCompletionItem2###",	//445
    "expandMacros",	//446
    "expandMacros?#",	//447
    "expandToRange",	//448
    "expandToRange#",	//449
    "fetchMore",	//450
    "fetchMore#",	//451
    "firstRangeContaining",	//452
    "firstRangeContaining#",	//453
    "flagCompletions",	//454
    "flagCompletions?",	//455
    "flags",	//456
    "flags#",	//457
    "focusIn",	//458
    "focusIn#",	//459
    "focusInEvent",	//460
    "focusInEvent#",	//461
    "focusNextPrevChild",	//462
    "focusNextPrevChild$",	//463
    "focusOut",	//464
    "focusOut#",	//465
    "focusOutEvent",	//466
    "focusOutEvent#",	//467
    "fontBold",	//468
    "fontChange",	//469
    "fontChange#",	//470
    "forceCompletion",	//471
    "guiActivateEvent",	//472
    "guiActivateEvent#",	//473
    "hasAnyProperty",	//474
    "hasChildren",	//475
    "hasChildren#",	//476
    "hasGroups",	//477
    "hasGroupsChanged",	//478
    "hasGroupsChanged#$",	//479
    "hasNotifier",	//480
    "hasParent",	//481
    "hasParent#",	//482
    "headerData",	//483
    "headerData$$",	//484
    "headerData$$$",	//485
    "heightForWidth",	//486
    "heightForWidth$",	//487
    "help",	//488
    "help#$$",	//489
    "hideEvent",	//490
    "hideEvent#",	//491
    "highlightingMode",	//492
    "highlightingModeChanged",	//493
    "highlightingModeChanged#",	//494
    "highlightingModeSection",	//495
    "highlightingModeSection$",	//496
    "highlightingModes",	//497
    "hitTest",	//498
    "hitTest##",	//499
    "horizontalScrollPositionChanged",	//500
    "horizontalScrollPositionChanged#",	//501
    "index",	//502
    "index$$",	//503
    "index$$#",	//504
    "informationMessage",	//505
    "informationMessage#$",	//506
    "inputMethodEvent",	//507
    "inputMethodEvent#",	//508
    "inputMethodQuery",	//509
    "inputMethodQuery$",	//510
    "insertBehavior",	//511
    "insertColumns",	//512
    "insertColumns$$",	//513
    "insertColumns$$#",	//514
    "insertLine",	//515
    "insertLine$$",	//516
    "insertLines",	//517
    "insertLines$?",	//518
    "insertRows",	//519
    "insertRows$$",	//520
    "insertRows$$#",	//521
    "insertTemplateText",	//522
    "insertTemplateText#$?",	//523
    "insertTemplateTextImplementation",	//524
    "insertTemplateTextImplementation#$?",	//525
    "insertText",	//526
    "insertText#$",	//527
    "insertText#$$",	//528
    "insertText#?",	//529
    "insertText#?$",	//530
    "insertText$",	//531
    "insertText?",	//532
    "insertText?$",	//533
    "intersect",	//534
    "intersect#",	//535
    "invalid",	//536
    "isActiveView",	//537
    "isAnnotationBorderVisible",	//538
    "isAutomaticInvocationEnabled",	//539
    "isCompletionActive",	//540
    "isEmpty",	//541
    "isSmartCursor",	//542
    "isSmartRange",	//543
    "isValid",	//544
    "itemData",	//545
    "itemData#",	//546
    "keyPressEvent",	//547
    "keyPressEvent#",	//548
    "keyReleaseEvent",	//549
    "keyReleaseEvent#",	//550
    "languageChange",	//551
    "leaveEvent",	//552
    "leaveEvent#",	//553
    "line",	//554
    "line$",	//555
    "lineChanged",	//556
    "lineChanged$",	//557
    "lineLength",	//558
    "lineLength$",	//559
    "lines",	//560
    "localXMLFile",	//561
    "mark",	//562
    "mark$",	//563
    "markChanged",	//564
    "markChanged##$",	//565
    "markDescription",	//566
    "markDescription$",	//567
    "markPixmap",	//568
    "markPixmap$",	//569
    "markType01",	//570
    "markType02",	//571
    "markType03",	//572
    "markType04",	//573
    "markType05",	//574
    "markType06",	//575
    "markType07",	//576
    "markType08",	//577
    "markType09",	//578
    "markType10",	//579
    "markType11",	//580
    "markType12",	//581
    "markType13",	//582
    "markType14",	//583
    "markType15",	//584
    "markType16",	//585
    "markType17",	//586
    "markType18",	//587
    "markType19",	//588
    "markType20",	//589
    "markType21",	//590
    "markType22",	//591
    "markType23",	//592
    "markType24",	//593
    "markType25",	//594
    "markType26",	//595
    "markType27",	//596
    "markType28",	//597
    "markType29",	//598
    "markType30",	//599
    "markType31",	//600
    "markType32",	//601
    "marks",	//602
    "marksChanged",	//603
    "marksChanged#",	//604
    "match",	//605
    "match#$#",	//606
    "match#$#$",	//607
    "match#$#$$",	//608
    "metaObject",	//609
    "metric",	//610
    "metric$",	//611
    "mimeData",	//612
    "mimeData?",	//613
    "mimeType",	//614
    "mimeTypes",	//615
    "minimumSizeHint",	//616
    "mode",	//617
    "modeChanged",	//618
    "modeChanged#",	//619
    "modeSection",	//620
    "modeSection$",	//621
    "modes",	//622
    "modifiedChanged",	//623
    "modifiedChanged#",	//624
    "modifiedOnDisk",	//625
    "modifiedOnDisk#$$",	//626
    "mostSpecificRange",	//627
    "mostSpecificRange#",	//628
    "mouseDoubleClickEvent",	//629
    "mouseDoubleClickEvent#",	//630
    "mouseEnteredRange",	//631
    "mouseEnteredRange##",	//632
    "mouseExitedRange",	//633
    "mouseExitedRange##",	//634
    "mouseMoveEvent",	//635
    "mouseMoveEvent#",	//636
    "mousePositionChanged",	//637
    "mousePositionChanged##",	//638
    "mousePressEvent",	//639
    "mousePressEvent#",	//640
    "mouseReleaseEvent",	//641
    "mouseReleaseEvent#",	//642
    "mouseTrackingEnabled",	//643
    "moveEvent",	//644
    "moveEvent#",	//645
    "needTextHint",	//646
    "needTextHint#$",	//647
    "newSmartCursor",	//648
    "newSmartCursor#",	//649
    "newSmartCursor#$",	//650
    "newSmartCursor$$",	//651
    "newSmartCursor$$$",	//652
    "newSmartRange",	//653
    "newSmartRange#",	//654
    "newSmartRange##",	//655
    "newSmartRange###",	//656
    "newSmartRange###$",	//657
    "newSmartRange##$",	//658
    "newSmartRange$$$$",	//659
    "newSmartRange$$$$#",	//660
    "newSmartRange$$$$#$",	//661
    "notifier",	//662
    "notifiers",	//663
    "numberOfLines",	//664
    "onSingleLine",	//665
    "openFile",	//666
    "openUrl",	//667
    "openUrl#",	//668
    "openingError",	//669
    "openingErrorMessage",	//670
    "operator+=",	//671
    "operator+=#",	//672
    "operator=",	//673
    "operator=#",	//674
    "outline",	//675
    "overlapCount",	//676
    "overlaps",	//677
    "overlaps#",	//678
    "overlapsColumn",	//679
    "overlapsColumn$",	//680
    "overlapsLine",	//681
    "overlapsLine$",	//682
    "paintEngine",	//683
    "paintEvent",	//684
    "paintEvent#",	//685
    "paletteChange",	//686
    "paletteChange#",	//687
    "parent",	//688
    "parent#",	//689
    "parentRange",	//690
    "parentRangeChanged",	//691
    "parentRangeChanged###",	//692
    "partActivateEvent",	//693
    "partActivateEvent#",	//694
    "partComponentData",	//695
    "partSelectEvent",	//696
    "partSelectEvent#",	//697
    "position",	//698
    "position$$",	//699
    "positionChanged",	//700
    "positionChanged#",	//701
    "positionDeleted",	//702
    "positionDeleted#",	//703
    "positionRelativeToCursor",	//704
    "positionRelativeToCursor#",	//705
    "positionRelativeToLine",	//706
    "positionRelativeToLine$",	//707
    "primaryNotifier",	//708
    "processText",	//709
    "processText#$",	//710
    "qt_metacall",	//711
    "qt_metacall$$?",	//712
    "queryClose",	//713
    "queryCommand",	//714
    "queryCommand$",	//715
    "range",	//716
    "rangeAttributeChanged",	//717
    "rangeAttributeChanged#??",	//718
    "rangeChanged",	//719
    "rangeChanged##",	//720
    "rangeContentsChanged",	//721
    "rangeContentsChanged#",	//722
    "rangeContentsChanged##",	//723
    "rangeDeleted",	//724
    "rangeDeleted#",	//725
    "rangeEliminated",	//726
    "rangeEliminated#",	//727
    "rangePositionChanged",	//728
    "rangePositionChanged#",	//729
    "readAppSetting",	//730
    "readAppSetting$",	//731
    "readConfig",	//732
    "readConfig#",	//733
    "readSessionConfig",	//734
    "readSessionConfig#",	//735
    "rebuildChildStructure",	//736
    "registerCommand",	//737
    "registerCommand#",	//738
    "registerCompletionModel",	//739
    "registerCompletionModel#",	//740
    "releaseRevision",	//741
    "releaseRevision$",	//742
    "removeActionsFromDocument",	//743
    "removeActionsFromDocument#",	//744
    "removeActionsFromView",	//745
    "removeActionsFromView##",	//746
    "removeColumns",	//747
    "removeColumns$$",	//748
    "removeColumns$$#",	//749
    "removeDocument",	//750
    "removeDocument#",	//751
    "removeHighlightFromDocument",	//752
    "removeHighlightFromDocument#",	//753
    "removeHighlightFromView",	//754
    "removeHighlightFromView##",	//755
    "removeLine",	//756
    "removeLine$",	//757
    "removeMark",	//758
    "removeMark$$",	//759
    "removeNotifier",	//760
    "removeNotifier#",	//761
    "removeRows",	//762
    "removeRows$$",	//763
    "removeRows$$#",	//764
    "removeSelection",	//765
    "removeSelectionText",	//766
    "removeText",	//767
    "removeText#",	//768
    "removeText#$",	//769
    "removeText$",	//770
    "removeView",	//771
    "removeView#",	//772
    "removeWatcher",	//773
    "removeWatcher#",	//774
    "replaceText",	//775
    "replaceText#$",	//776
    "replaceText#$$",	//777
    "replaceText#?",	//778
    "replaceText#?$",	//779
    "replaceText?",	//780
    "replaceText?$",	//781
    "reservedMarkersCount",	//782
    "reset",	//783
    "resizeEvent",	//784
    "resizeEvent#",	//785
    "revert",	//786
    "rowCount",	//787
    "rowCount#",	//788
    "save",	//789
    "saveAs",	//790
    "saveAs#",	//791
    "saveFile",	//792
    "saveToUrl",	//793
    "searchText",	//794
    "searchText#$",	//795
    "searchText#$$",	//796
    "selectedBackground",	//797
    "selectedForeground",	//798
    "selection",	//799
    "selectionChanged",	//800
    "selectionChanged#",	//801
    "selectionRange",	//802
    "selectionText",	//803
    "setActiveView",	//804
    "setActiveView#",	//805
    "setAnnotationBorderVisible",	//806
    "setAnnotationBorderVisible$",	//807
    "setAnnotationModel",	//808
    "setAnnotationModel#",	//809
    "setAttribute",	//810
    "setAttribute?",	//811
    "setAutomaticInvocationEnabled",	//812
    "setAutomaticInvocationEnabled$",	//813
    "setBackgroundFillWhitespace",	//814
    "setBackgroundFillWhitespace$",	//815
    "setBlockSelection",	//816
    "setBlockSelection$",	//817
    "setBothColumns",	//818
    "setBothColumns$",	//819
    "setBothLines",	//820
    "setBothLines$",	//821
    "setClearOnDocumentReload",	//822
    "setClearOnDocumentReload$",	//823
    "setColumn",	//824
    "setColumn$",	//825
    "setComponentData",	//826
    "setComponentData#",	//827
    "setComponentData#$",	//828
    "setConfigValue",	//829
    "setConfigValue$#",	//830
    "setContainer",	//831
    "setContainer#",	//832
    "setContextMenu",	//833
    "setContextMenu#",	//834
    "setCursorPosition",	//835
    "setCursorPosition#",	//836
    "setDOMDocument",	//837
    "setDOMDocument#",	//838
    "setDOMDocument#$",	//839
    "setData",	//840
    "setData##",	//841
    "setData##$",	//842
    "setDynamicAttribute",	//843
    "setDynamicAttribute$?",	//844
    "setEditableMarks",	//845
    "setEditableMarks$",	//846
    "setEffects",	//847
    "setEffects$",	//848
    "setEncoding",	//849
    "setEncoding$",	//850
    "setFontBold",	//851
    "setFontBold$",	//852
    "setHasGroups",	//853
    "setHasGroups$",	//854
    "setHeaderData",	//855
    "setHeaderData$$#",	//856
    "setHeaderData$$#$",	//857
    "setHighlightingMode",	//858
    "setHighlightingMode$",	//859
    "setInsertBehavior",	//860
    "setInsertBehavior$",	//861
    "setItemData",	//862
    "setItemData#?",	//863
    "setLine",	//864
    "setLine$",	//865
    "setLocalXMLFile",	//866
    "setLocalXMLFile$",	//867
    "setManager",	//868
    "setManager#",	//869
    "setMark",	//870
    "setMark$$",	//871
    "setMarkDescription",	//872
    "setMarkDescription$$",	//873
    "setMarkPixmap",	//874
    "setMarkPixmap$#",	//875
    "setMode",	//876
    "setMode$",	//877
    "setModified",	//878
    "setModified$",	//879
    "setModifiedOnDisk",	//880
    "setModifiedOnDisk$",	//881
    "setModifiedOnDiskWarning",	//882
    "setModifiedOnDiskWarning$",	//883
    "setMouseTrackingEnabled",	//884
    "setMouseTrackingEnabled$",	//885
    "setOpeningError",	//886
    "setOpeningError$",	//887
    "setOpeningErrorMessage",	//888
    "setOpeningErrorMessage$",	//889
    "setOutline",	//890
    "setOutline#",	//891
    "setParentRange",	//892
    "setParentRange#",	//893
    "setPosition",	//894
    "setPosition#",	//895
    "setPosition$$",	//896
    "setRange",	//897
    "setRange#",	//898
    "setRange##",	//899
    "setReadWrite",	//900
    "setReadWrite$",	//901
    "setRowCount",	//902
    "setRowCount$",	//903
    "setSelectable",	//904
    "setSelectable$",	//905
    "setSelectedBackground",	//906
    "setSelectedBackground#",	//907
    "setSelectedForeground",	//908
    "setSelectedForeground#",	//909
    "setSelection",	//910
    "setSelection#",	//911
    "setSelection#$",	//912
    "setSelection#$$",	//913
    "setSimpleMode",	//914
    "setSimpleMode$",	//915
    "setSuppressOpeningErrorDialogs",	//916
    "setSuppressOpeningErrorDialogs$",	//917
    "setText",	//918
    "setText$",	//919
    "setText?",	//920
    "setType",	//921
    "setType$",	//922
    "setVisible",	//923
    "setVisible$",	//924
    "setWantsDirectChanges",	//925
    "setWantsDirectChanges$",	//926
    "setWatcher",	//927
    "setWatcher#",	//928
    "setWidget",	//929
    "setWidget#",	//930
    "setXML",	//931
    "setXML$",	//932
    "setXML$$",	//933
    "setXMLFile",	//934
    "setXMLFile$",	//935
    "setXMLFile$$",	//936
    "setXMLFile$$$",	//937
    "setupTranslations",	//938
    "showEvent",	//939
    "showEvent#",	//940
    "simpleMode",	//941
    "sizeHint",	//942
    "slotModifiedOnDisk",	//943
    "slotModifiedOnDisk#",	//944
    "smartEnd",	//945
    "smartMutex",	//946
    "smartRange",	//947
    "smartStart",	//948
    "sort",	//949
    "sort$",	//950
    "sort$$",	//951
    "span",	//952
    "span#",	//953
    "start",	//954
    "startCompletion",	//955
    "startCompletion##",	//956
    "startEditing",	//957
    "stateChanged",	//958
    "stateChanged$",	//959
    "stateChanged$$",	//960
    "staticMetaObject",	//961
    "styleChange",	//962
    "styleChange#",	//963
    "submit",	//964
    "supportedDropActions",	//965
    "supportedSearchOptions",	//966
    "suppressOpeningErrorDialogs",	//967
    "tabletEvent",	//968
    "tabletEvent#",	//969
    "text",	//970
    "text#",	//971
    "text#$",	//972
    "text$",	//973
    "textChanged",	//974
    "textChanged#",	//975
    "textChanged###",	//976
    "textInserted",	//977
    "textInserted##",	//978
    "textInserted##$",	//979
    "textLines",	//980
    "textLines#",	//981
    "textLines#$",	//982
    "textRemoved",	//983
    "textRemoved##",	//984
    "timerEvent",	//985
    "timerEvent#",	//986
    "toSmartCursor",	//987
    "toSmartRange",	//988
    "topParentRange",	//989
    "totalCharacters",	//990
    "translateFromRevision",	//991
    "translateFromRevision#",	//992
    "translateFromRevision#$",	//993
    "type",	//994
    "unbindSmartRange",	//995
    "unbindSmartRange#",	//996
    "unregisterCommand",	//997
    "unregisterCommand#",	//998
    "unregisterCompletionModel",	//999
    "unregisterCompletionModel#",	//1000
    "useRevision",	//1001
    "useRevision$",	//1002
    "variable",	//1003
    "variable$",	//1004
    "variableChanged",	//1005
    "variableChanged#$$",	//1006
    "verticalScrollPositionChanged",	//1007
    "verticalScrollPositionChanged##",	//1008
    "viewActions",	//1009
    "viewActions#",	//1010
    "viewCreated",	//1011
    "viewCreated##",	//1012
    "viewEditMode",	//1013
    "viewEditModeChanged",	//1014
    "viewEditModeChanged#$",	//1015
    "viewHighlights",	//1016
    "viewHighlights#",	//1017
    "viewMode",	//1018
    "viewModeChanged",	//1019
    "viewModeChanged#",	//1020
    "views",	//1021
    "waitForReset",	//1022
    "wantsDirectChanges",	//1023
    "wantsToProcessText",	//1024
    "wantsToProcessText$",	//1025
    "watcher",	//1026
    "watchers",	//1027
    "wheelEvent",	//1028
    "wheelEvent#",	//1029
    "widget",	//1030
    "windowActivationChange",	//1031
    "windowActivationChange$",	//1032
    "writeAppSetting",	//1033
    "writeAppSetting$",	//1034
    "writeConfig",	//1035
    "writeConfig#",	//1036
    "writeSessionConfig",	//1037
    "writeSessionConfig#",	//1038
    "xmlFile",	//1039
    "~AnnotationInterface",	//1040
    "~AnnotationModel",	//1041
    "~AnnotationViewInterface",	//1042
    "~Attribute",	//1043
    "~CodeCompletionInterface",	//1044
    "~CodeCompletionModel",	//1045
    "~CodeCompletionModel2",	//1046
    "~Command",	//1047
    "~CommandExtension",	//1048
    "~CommandInterface",	//1049
    "~ConfigInterface",	//1050
    "~ConfigPage",	//1051
    "~ContainerInterface",	//1052
    "~Cursor",	//1053
    "~Document",	//1054
    "~Editor",	//1055
    "~EditorChooser",	//1056
    "~Factory",	//1057
    "~Mark",	//1058
    "~MarkInterface",	//1059
    "~MdiContainer",	//1060
    "~ModificationInterface",	//1061
    "~Plugin",	//1062
    "~Range",	//1063
    "~SearchInterface",	//1064
    "~SessionConfigInterface",	//1065
    "~SmartCursor",	//1066
    "~SmartCursorNotifier",	//1067
    "~SmartCursorWatcher",	//1068
    "~SmartInterface",	//1069
    "~SmartRange",	//1070
    "~SmartRangeNotifier",	//1071
    "~SmartRangeWatcher",	//1072
    "~TemplateInterface",	//1073
    "~TextHintInterface",	//1074
    "~VariableInterface",	//1075
    "~View",	//1076
};

// (classId, name (index in methodNames), argumentList index, number of args, method flags, return type (index in types), xcall() index)
static Smoke::Method ktexteditor_methods[] = {
	{10, 609, 0, 0, Smoke::mf_const, 532, 2},	//0 KParts::Factory::metaObject() const
	{10, 711, 188, 3, 0, 554, 3},	//1 KParts::Factory::qt_metacall(QMetaObject::Call, int, void**)
	{10, 695, 0, 0, 0, 12, 11},	//2 KParts::Factory::partComponentData()
	{10, 337, 235, 4, Smoke::mf_protected, 69, 13},	//3 KParts::Factory::createPartObject(QWidget*, QObject*, const char*, const QStringList&) [pure virtual]
	{10, 337, 231, 3, Smoke::mf_protected, 69, -1},	//4 KParts::Factory::createPartObject(QWidget*, QObject*, const char*) [pure virtual]
	{10, 337, 228, 2, Smoke::mf_protected, 69, -1},	//5 KParts::Factory::createPartObject(QWidget*, QObject*) [pure virtual]
	{10, 337, 226, 1, Smoke::mf_protected, 69, -1},	//6 KParts::Factory::createPartObject(QWidget*) [pure virtual]
	{10, 337, 0, 0, Smoke::mf_protected, 69, -1},	//7 KParts::Factory::createPartObject() [pure virtual]
	{10, 333, 204, 3, Smoke::mf_protected, 295, 14},	//8 KParts::Factory::createObject(QObject*, const char*, const QStringList&)
	{10, 333, 201, 2, Smoke::mf_protected, 295, 15},	//9 KParts::Factory::createObject(QObject*, const char*)
	{10, 333, 196, 1, Smoke::mf_protected, 295, 16},	//10 KParts::Factory::createObject(QObject*)
	{10, 333, 0, 0, Smoke::mf_protected, 295, 17},	//11 KParts::Factory::createObject()
	{12, 609, 0, 0, Smoke::mf_const, 532, 2},	//12 KParts::Part::metaObject() const
	{12, 711, 188, 3, 0, 554, 3},	//13 KParts::Part::qt_metacall(QMetaObject::Call, int, void**)
	{12, 423, 226, 1, 0, 0, 6},	//14 KParts::Part::embed(QWidget*)
	{12, 1030, 0, 0, 0, 385, 7},	//15 KParts::Part::widget()
	{12, 868, 556, 1, 0, 0, 8},	//16 KParts::Part::setManager(KParts::PartManager*)
	{12, 498, 240, 2, 0, 69, 12},	//17 KParts::Part::hitTest(QWidget*, const QPoint&)
	{12, 904, 245, 1, 0, 0, 13},	//18 KParts::Part::setSelectable(bool)
	{12, 929, 226, 1, Smoke::mf_protected, 0, 18},	//19 KParts::Part::setWidget(QWidget*)
	{12, 358, 173, 1, Smoke::mf_protected, 0, 19},	//20 KParts::Part::customEvent(QEvent*)
	{12, 693, 554, 1, Smoke::mf_protected, 0, 20},	//21 KParts::Part::partActivateEvent(KParts::PartActivateEvent*)
	{12, 696, 558, 1, Smoke::mf_protected, 0, 21},	//22 KParts::Part::partSelectEvent(KParts::PartSelectEvent*)
	{12, 472, 552, 1, Smoke::mf_protected, 0, 22},	//23 KParts::Part::guiActivateEvent(KParts::GUIActivateEvent*)
	{14, 826, 247, 1, Smoke::mf_protected, 0, 7},	//24 KParts::PartBase::setComponentData(const KComponentData&)
	{14, 826, 249, 2, Smoke::mf_protected, 0, 8},	//25 KParts::PartBase::setComponentData(const KComponentData&, bool)
	{17, 609, 0, 0, Smoke::mf_const, 532, 2},	//26 KParts::ReadOnlyPart::metaObject() const
	{17, 711, 188, 3, 0, 554, 3},	//27 KParts::ReadOnlyPart::qt_metacall(QMetaObject::Call, int, void**)
	{17, 281, 0, 0, 0, 480, 10},	//28 KParts::ReadOnlyPart::closeUrl()
	{17, 667, 398, 1, 0, 480, 17},	//29 KParts::ReadOnlyPart::openUrl(const KUrl&)
	{17, 666, 0, 0, Smoke::mf_protected, 480, 22},	//30 KParts::ReadOnlyPart::openFile() [pure virtual]
	{17, 472, 552, 1, Smoke::mf_protected, 0, 24},	//31 KParts::ReadOnlyPart::guiActivateEvent(KParts::GUIActivateEvent*)
	{18, 609, 0, 0, Smoke::mf_const, 532, 2},	//32 KParts::ReadWritePart::metaObject() const
	{18, 711, 188, 3, 0, 554, 3},	//33 KParts::ReadWritePart::qt_metacall(QMetaObject::Call, int, void**)
	{18, 900, 245, 1, 0, 0, 7},	//34 KParts::ReadWritePart::setReadWrite(bool)
	{18, 900, 0, 0, 0, 0, 8},	//35 KParts::ReadWritePart::setReadWrite()
	{18, 713, 0, 0, 0, 480, 10},	//36 KParts::ReadWritePart::queryClose()
	{18, 281, 0, 0, 0, 480, 11},	//37 KParts::ReadWritePart::closeUrl()
	{18, 281, 245, 1, 0, 480, 12},	//38 KParts::ReadWritePart::closeUrl(bool)
	{18, 790, 398, 1, 0, 480, 13},	//39 KParts::ReadWritePart::saveAs(const KUrl&)
	{18, 878, 245, 1, 0, 0, 14},	//40 KParts::ReadWritePart::setModified(bool)
	{18, 789, 0, 0, 0, 480, 16},	//41 KParts::ReadWritePart::save()
	{18, 792, 0, 0, Smoke::mf_protected, 480, 19},	//42 KParts::ReadWritePart::saveFile() [pure virtual]
	{18, 793, 0, 0, Smoke::mf_protected, 480, 20},	//43 KParts::ReadWritePart::saveToUrl()
	{19, 609, 0, 0, Smoke::mf_const, 532, 2},	//44 KPluginFactory::metaObject() const
	{19, 711, 188, 3, 0, 554, 3},	//45 KPluginFactory::qt_metacall(QMetaObject::Call, int, void**)
	{19, 938, 0, 0, Smoke::mf_protected, 0, 14},	//46 KPluginFactory::setupTranslations()
	{19, 328, 473, 5, Smoke::mf_protected, 295, 16},	//47 KPluginFactory::create(const char*, QWidget*, QObject*, const QList<QVariant>&, const QString&)
	{20, 419, 471, 1, Smoke::mf_static, 123, 1},	//48 KTextEditor::editor(const char*)
	{20, 342, 560, 2, Smoke::mf_static, 134, 2},	//49 KTextEditor::createPlugin(KSharedPtr<KService>, QObject*)
	{21, 1040, 0, 0, Smoke::mf_dtor, 0, 5},	//50 KTextEditor::AnnotationInterface::~AnnotationInterface()
	{21, 808, 565, 1, 0, 0, 1},	//51 KTextEditor::AnnotationInterface::setAnnotationModel(KTextEditor::AnnotationModel*) [pure virtual]
	{21, 212, 0, 0, Smoke::mf_const, 91, 2},	//52 KTextEditor::AnnotationInterface::annotationModel() const [pure virtual]
	{21, 6, 0, 0, Smoke::mf_ctor, 90, 3},	//53 KTextEditor::AnnotationInterface::AnnotationInterface()
	{21, 6, 254, 1, Smoke::mf_copyctor|Smoke::mf_internal|Smoke::mf_ctor, 90, 4},	//54 KTextEditor::AnnotationInterface::AnnotationInterface(const KTextEditor::AnnotationInterface&)
	{22, 609, 0, 0, Smoke::mf_const, 532, 2},	//55 KTextEditor::AnnotationModel::metaObject() const
	{22, 711, 188, 3, 0, 554, 3},	//56 KTextEditor::AnnotationModel::qt_metacall(QMetaObject::Call, int, void**)
	{22, 1041, 0, 0, Smoke::mf_dtor, 0, 8},	//57 KTextEditor::AnnotationModel::~AnnotationModel()
	{22, 360, 487, 2, Smoke::mf_const, 379, 4},	//58 KTextEditor::AnnotationModel::data(int, Qt::ItemDataRole) const [pure virtual]
	{22, 8, 0, 0, Smoke::mf_ctor, 91, 5},	//59 KTextEditor::AnnotationModel::AnnotationModel()
	{22, 783, 0, 0, 0, 0, 6},	//60 KTextEditor::AnnotationModel::reset()
	{22, 556, 479, 1, 0, 0, 7},	//61 KTextEditor::AnnotationModel::lineChanged(int)
	{22, 961, 0, 0, Smoke::mf_static, 531, 1},	//62 KTextEditor::AnnotationModel::staticMetaObject (static var)
	{23, 1042, 0, 0, Smoke::mf_dtor, 0, 8},	//63 KTextEditor::AnnotationViewInterface::~AnnotationViewInterface()
	{23, 806, 245, 1, 0, 0, 1},	//64 KTextEditor::AnnotationViewInterface::setAnnotationBorderVisible(bool) [pure virtual]
	{23, 538, 0, 0, Smoke::mf_const, 480, 2},	//65 KTextEditor::AnnotationViewInterface::isAnnotationBorderVisible() const [pure virtual]
	{23, 210, 127, 3, 0, 0, 3},	//66 KTextEditor::AnnotationViewInterface::annotationContextMenuAboutToShow(KTextEditor::View*, QMenu*, int) [pure virtual]
	{23, 206, 152, 2, 0, 0, 4},	//67 KTextEditor::AnnotationViewInterface::annotationActivated(KTextEditor::View*, int) [pure virtual]
	{23, 208, 131, 2, 0, 0, 5},	//68 KTextEditor::AnnotationViewInterface::annotationBorderVisibilityChanged(KTextEditor::View*, bool) [pure virtual]
	{23, 9, 0, 0, Smoke::mf_ctor, 92, 6},	//69 KTextEditor::AnnotationViewInterface::AnnotationViewInterface()
	{23, 9, 256, 1, Smoke::mf_copyctor|Smoke::mf_internal|Smoke::mf_ctor, 92, 7},	//70 KTextEditor::AnnotationViewInterface::AnnotationViewInterface(const KTextEditor::AnnotationViewInterface&)
	{24, 113, 0, 0, Smoke::mf_static|Smoke::mf_enum, 96, 1},	//71 KTextEditor::Attribute::Outline (enum)
	{24, 133, 0, 0, Smoke::mf_static|Smoke::mf_enum, 96, 2},	//72 KTextEditor::Attribute::SelectedForeground (enum)
	{24, 132, 0, 0, Smoke::mf_static|Smoke::mf_enum, 96, 3},	//73 KTextEditor::Attribute::SelectedBackground (enum)
	{24, 19, 0, 0, Smoke::mf_static|Smoke::mf_enum, 96, 4},	//74 KTextEditor::Attribute::BackgroundFillWhitespace (enum)
	{24, 15, 0, 0, Smoke::mf_static|Smoke::mf_enum, 96, 5},	//75 KTextEditor::Attribute::AttributeDynamicEffect (enum)
	{24, 16, 0, 0, Smoke::mf_static|Smoke::mf_enum, 96, 6},	//76 KTextEditor::Attribute::AttributeInternalProperty (enum)
	{24, 17, 0, 0, Smoke::mf_static|Smoke::mf_enum, 96, 7},	//77 KTextEditor::Attribute::AttributeUserProperty (enum)
	{24, 5, 0, 0, Smoke::mf_static|Smoke::mf_enum, 95, 8},	//78 KTextEditor::Attribute::ActivateMouseIn (enum)
	{24, 4, 0, 0, Smoke::mf_static|Smoke::mf_enum, 95, 9},	//79 KTextEditor::Attribute::ActivateCaretIn (enum)
	{24, 66, 0, 0, Smoke::mf_static|Smoke::mf_enum, 97, 10},	//80 KTextEditor::Attribute::EffectNone (enum)
	{24, 64, 0, 0, Smoke::mf_static|Smoke::mf_enum, 97, 11},	//81 KTextEditor::Attribute::EffectFadeIn (enum)
	{24, 65, 0, 0, Smoke::mf_static|Smoke::mf_enum, 97, 12},	//82 KTextEditor::Attribute::EffectFadeOut (enum)
	{24, 67, 0, 0, Smoke::mf_static|Smoke::mf_enum, 97, 13},	//83 KTextEditor::Attribute::EffectPulse (enum)
	{24, 63, 0, 0, Smoke::mf_static|Smoke::mf_enum, 97, 14},	//84 KTextEditor::Attribute::EffectCycleGradient (enum)
	{24, 13, 0, 0, Smoke::mf_ctor, 94, 15},	//85 KTextEditor::Attribute::Attribute()
	{24, 13, 258, 1, Smoke::mf_copyctor|Smoke::mf_ctor, 94, 16},	//86 KTextEditor::Attribute::Attribute(const KTextEditor::Attribute&)
	{24, 1043, 0, 0, Smoke::mf_dtor, 0, 38},	//87 KTextEditor::Attribute::~Attribute()
	{24, 468, 0, 0, Smoke::mf_const, 480, 17},	//88 KTextEditor::Attribute::fontBold() const
	{24, 851, 245, 1, 0, 0, 18},	//89 KTextEditor::Attribute::setFontBold(bool)
	{24, 851, 0, 0, 0, 0, 19},	//90 KTextEditor::Attribute::setFontBold()
	{24, 675, 0, 0, Smoke::mf_const, 200, 20},	//91 KTextEditor::Attribute::outline() const
	{24, 890, 400, 1, 0, 0, 21},	//92 KTextEditor::Attribute::setOutline(const QBrush&)
	{24, 798, 0, 0, Smoke::mf_const, 200, 22},	//93 KTextEditor::Attribute::selectedForeground() const
	{24, 908, 400, 1, 0, 0, 23},	//94 KTextEditor::Attribute::setSelectedForeground(const QBrush&)
	{24, 797, 0, 0, Smoke::mf_const, 200, 24},	//95 KTextEditor::Attribute::selectedBackground() const
	{24, 906, 400, 1, 0, 0, 25},	//96 KTextEditor::Attribute::setSelectedBackground(const QBrush&)
	{24, 226, 0, 0, Smoke::mf_const, 480, 26},	//97 KTextEditor::Attribute::backgroundFillWhitespace() const
	{24, 814, 245, 1, 0, 0, 27},	//98 KTextEditor::Attribute::setBackgroundFillWhitespace(bool)
	{24, 261, 0, 0, 0, 0, 28},	//99 KTextEditor::Attribute::clear()
	{24, 474, 0, 0, Smoke::mf_const, 480, 29},	//100 KTextEditor::Attribute::hasAnyProperty() const
	{24, 216, 0, 0, Smoke::mf_const, 520, 30},	//101 KTextEditor::Attribute::associatedActions() const
	{24, 263, 0, 0, 0, 0, 31},	//102 KTextEditor::Attribute::clearAssociatedActions()
	{24, 416, 567, 1, Smoke::mf_const, 83, 32},	//103 KTextEditor::Attribute::dynamicAttribute(KTextEditor::Attribute::ActivationType) const
	{24, 843, 569, 2, 0, 0, 33},	//104 KTextEditor::Attribute::setDynamicAttribute(KTextEditor::Attribute::ActivationType, KSharedPtr<KTextEditor::Attribute>)
	{24, 422, 0, 0, Smoke::mf_const, 98, 34},	//105 KTextEditor::Attribute::effects() const
	{24, 847, 572, 1, 0, 0, 35},	//106 KTextEditor::Attribute::setEffects(KTextEditor::Attribute::Effects)
	{24, 671, 258, 1, 0, 93, 36},	//107 KTextEditor::Attribute::operator+=(const KTextEditor::Attribute&)
	{24, 673, 258, 1, 0, 93, 37},	//108 KTextEditor::Attribute::operator=(const KTextEditor::Attribute&)
	{25, 1044, 0, 0, Smoke::mf_dtor, 0, 11},	//109 KTextEditor::CodeCompletionInterface::~CodeCompletionInterface()
	{25, 540, 0, 0, Smoke::mf_const, 480, 1},	//110 KTextEditor::CodeCompletionInterface::isCompletionActive() const [pure virtual]
	{25, 955, 342, 2, 0, 0, 2},	//111 KTextEditor::CodeCompletionInterface::startCompletion(const KTextEditor::Range&, KTextEditor::CodeCompletionModel*) [pure virtual]
	{25, 171, 0, 0, 0, 0, 3},	//112 KTextEditor::CodeCompletionInterface::abortCompletion() [pure virtual]
	{25, 471, 0, 0, 0, 0, 4},	//113 KTextEditor::CodeCompletionInterface::forceCompletion() [pure virtual]
	{25, 739, 3, 1, 0, 0, 5},	//114 KTextEditor::CodeCompletionInterface::registerCompletionModel(KTextEditor::CodeCompletionModel*) [pure virtual]
	{25, 999, 3, 1, 0, 0, 6},	//115 KTextEditor::CodeCompletionInterface::unregisterCompletionModel(KTextEditor::CodeCompletionModel*) [pure virtual]
	{25, 539, 0, 0, Smoke::mf_const, 480, 7},	//116 KTextEditor::CodeCompletionInterface::isAutomaticInvocationEnabled() const [pure virtual]
	{25, 812, 245, 1, 0, 0, 8},	//117 KTextEditor::CodeCompletionInterface::setAutomaticInvocationEnabled(bool) [pure virtual]
	{25, 812, 0, 0, 0, 0, -1},	//118 KTextEditor::CodeCompletionInterface::setAutomaticInvocationEnabled() [pure virtual]
	{25, 28, 0, 0, Smoke::mf_ctor, 101, 9},	//119 KTextEditor::CodeCompletionInterface::CodeCompletionInterface()
	{25, 28, 260, 1, Smoke::mf_copyctor|Smoke::mf_internal|Smoke::mf_ctor, 101, 10},	//120 KTextEditor::CodeCompletionInterface::CodeCompletionInterface(const KTextEditor::CodeCompletionInterface&)
	{26, 118, 0, 0, Smoke::mf_static|Smoke::mf_enum, 104, 1},	//121 KTextEditor::CodeCompletionModel::Prefix (enum)
	{26, 82, 0, 0, Smoke::mf_static|Smoke::mf_enum, 104, 2},	//122 KTextEditor::CodeCompletionModel::Icon (enum)
	{26, 128, 0, 0, Smoke::mf_static|Smoke::mf_enum, 104, 3},	//123 KTextEditor::CodeCompletionModel::Scope (enum)
	{26, 104, 0, 0, Smoke::mf_static|Smoke::mf_enum, 104, 4},	//124 KTextEditor::CodeCompletionModel::Name (enum)
	{26, 12, 0, 0, Smoke::mf_static|Smoke::mf_enum, 104, 5},	//125 KTextEditor::CodeCompletionModel::Arguments (enum)
	{26, 117, 0, 0, Smoke::mf_static|Smoke::mf_enum, 104, 6},	//126 KTextEditor::CodeCompletionModel::Postfix (enum)
	{26, 108, 0, 0, Smoke::mf_static|Smoke::mf_enum, 107, 7},	//127 KTextEditor::CodeCompletionModel::NoProperty (enum)
	{26, 76, 0, 0, Smoke::mf_static|Smoke::mf_enum, 107, 8},	//128 KTextEditor::CodeCompletionModel::FirstProperty (enum)
	{26, 121, 0, 0, Smoke::mf_static|Smoke::mf_enum, 107, 9},	//129 KTextEditor::CodeCompletionModel::Public (enum)
	{26, 120, 0, 0, Smoke::mf_static|Smoke::mf_enum, 107, 10},	//130 KTextEditor::CodeCompletionModel::Protected (enum)
	{26, 119, 0, 0, Smoke::mf_static|Smoke::mf_enum, 107, 11},	//131 KTextEditor::CodeCompletionModel::Private (enum)
	{26, 153, 0, 0, Smoke::mf_static|Smoke::mf_enum, 107, 12},	//132 KTextEditor::CodeCompletionModel::Static (enum)
	{26, 46, 0, 0, Smoke::mf_static|Smoke::mf_enum, 107, 13},	//133 KTextEditor::CodeCompletionModel::Const (enum)
	{26, 105, 0, 0, Smoke::mf_static|Smoke::mf_enum, 107, 14},	//134 KTextEditor::CodeCompletionModel::Namespace (enum)
	{26, 27, 0, 0, Smoke::mf_static|Smoke::mf_enum, 107, 15},	//135 KTextEditor::CodeCompletionModel::Class (enum)
	{26, 155, 0, 0, Smoke::mf_static|Smoke::mf_enum, 107, 16},	//136 KTextEditor::CodeCompletionModel::Struct (enum)
	{26, 162, 0, 0, Smoke::mf_static|Smoke::mf_enum, 107, 17},	//137 KTextEditor::CodeCompletionModel::Union (enum)
	{26, 78, 0, 0, Smoke::mf_static|Smoke::mf_enum, 107, 18},	//138 KTextEditor::CodeCompletionModel::Function (enum)
	{26, 164, 0, 0, Smoke::mf_static|Smoke::mf_enum, 107, 19},	//139 KTextEditor::CodeCompletionModel::Variable (enum)
	{26, 68, 0, 0, Smoke::mf_static|Smoke::mf_enum, 107, 20},	//140 KTextEditor::CodeCompletionModel::Enum (enum)
	{26, 156, 0, 0, Smoke::mf_static|Smoke::mf_enum, 107, 21},	//141 KTextEditor::CodeCompletionModel::Template (enum)
	{26, 161, 0, 0, Smoke::mf_static|Smoke::mf_enum, 107, 22},	//142 KTextEditor::CodeCompletionModel::TypeAlias (enum)
	{26, 169, 0, 0, Smoke::mf_static|Smoke::mf_enum, 107, 23},	//143 KTextEditor::CodeCompletionModel::Virtual (enum)
	{26, 114, 0, 0, Smoke::mf_static|Smoke::mf_enum, 107, 24},	//144 KTextEditor::CodeCompletionModel::Override (enum)
	{26, 84, 0, 0, Smoke::mf_static|Smoke::mf_enum, 107, 25},	//145 KTextEditor::CodeCompletionModel::Inline (enum)
	{26, 77, 0, 0, Smoke::mf_static|Smoke::mf_enum, 107, 26},	//146 KTextEditor::CodeCompletionModel::Friend (enum)
	{26, 137, 0, 0, Smoke::mf_static|Smoke::mf_enum, 107, 27},	//147 KTextEditor::CodeCompletionModel::Signal (enum)
	{26, 138, 0, 0, Smoke::mf_static|Smoke::mf_enum, 107, 28},	//148 KTextEditor::CodeCompletionModel::Slot (enum)
	{26, 90, 0, 0, Smoke::mf_static|Smoke::mf_enum, 107, 29},	//149 KTextEditor::CodeCompletionModel::LocalScope (enum)
	{26, 106, 0, 0, Smoke::mf_static|Smoke::mf_enum, 107, 30},	//150 KTextEditor::CodeCompletionModel::NamespaceScope (enum)
	{26, 79, 0, 0, Smoke::mf_static|Smoke::mf_enum, 107, 31},	//151 KTextEditor::CodeCompletionModel::GlobalScope (enum)
	{26, 89, 0, 0, Smoke::mf_static|Smoke::mf_enum, 107, 32},	//152 KTextEditor::CodeCompletionModel::LastProperty (enum)
	{26, 107, 0, 0, Smoke::mf_static|Smoke::mf_enum, 109, 33},	//153 KTextEditor::CodeCompletionModel::NoHighlighting (enum)
	{26, 85, 0, 0, Smoke::mf_static|Smoke::mf_enum, 109, 34},	//154 KTextEditor::CodeCompletionModel::InternalHighlighting (enum)
	{26, 53, 0, 0, Smoke::mf_static|Smoke::mf_enum, 109, 35},	//155 KTextEditor::CodeCompletionModel::CustomHighlighting (enum)
	{26, 41, 0, 0, Smoke::mf_static|Smoke::mf_enum, 108, 36},	//156 KTextEditor::CodeCompletionModel::CompletionRole (enum)
	{26, 129, 0, 0, Smoke::mf_static|Smoke::mf_enum, 108, 37},	//157 KTextEditor::CodeCompletionModel::ScopeIndex (enum)
	{26, 98, 0, 0, Smoke::mf_static|Smoke::mf_enum, 108, 38},	//158 KTextEditor::CodeCompletionModel::MatchQuality (enum)
	{26, 136, 0, 0, Smoke::mf_static|Smoke::mf_enum, 108, 39},	//159 KTextEditor::CodeCompletionModel::SetMatchContext (enum)
	{26, 81, 0, 0, Smoke::mf_static|Smoke::mf_enum, 108, 40},	//160 KTextEditor::CodeCompletionModel::HighlightingMethod (enum)
	{26, 52, 0, 0, Smoke::mf_static|Smoke::mf_enum, 108, 41},	//161 KTextEditor::CodeCompletionModel::CustomHighlight (enum)
	{26, 83, 0, 0, Smoke::mf_static|Smoke::mf_enum, 108, 42},	//162 KTextEditor::CodeCompletionModel::InheritanceDepth (enum)
	{26, 86, 0, 0, Smoke::mf_static|Smoke::mf_enum, 108, 43},	//163 KTextEditor::CodeCompletionModel::IsExpandable (enum)
	{26, 73, 0, 0, Smoke::mf_static|Smoke::mf_enum, 108, 44},	//164 KTextEditor::CodeCompletionModel::ExpandingWidget (enum)
	{26, 87, 0, 0, Smoke::mf_static|Smoke::mf_enum, 108, 45},	//165 KTextEditor::CodeCompletionModel::ItemSelected (enum)
	{26, 11, 0, 0, Smoke::mf_static|Smoke::mf_enum, 108, 46},	//166 KTextEditor::CodeCompletionModel::ArgumentHintDepth (enum)
	{26, 20, 0, 0, Smoke::mf_static|Smoke::mf_enum, 108, 47},	//167 KTextEditor::CodeCompletionModel::BestMatchesCount (enum)
	{26, 2, 0, 0, Smoke::mf_static|Smoke::mf_enum, 108, 48},	//168 KTextEditor::CodeCompletionModel::AccessibilityNext (enum)
	{26, 3, 0, 0, Smoke::mf_static|Smoke::mf_enum, 108, 49},	//169 KTextEditor::CodeCompletionModel::AccessibilityPrevious (enum)
	{26, 1, 0, 0, Smoke::mf_static|Smoke::mf_enum, 108, 50},	//170 KTextEditor::CodeCompletionModel::AccessibilityAccept (enum)
	{26, 80, 0, 0, Smoke::mf_static|Smoke::mf_enum, 108, 51},	//171 KTextEditor::CodeCompletionModel::GroupRole (enum)
	{26, 18, 0, 0, Smoke::mf_static|Smoke::mf_enum, 112, 52},	//172 KTextEditor::CodeCompletionModel::AutomaticInvocation (enum)
	{26, 163, 0, 0, Smoke::mf_static|Smoke::mf_enum, 112, 53},	//173 KTextEditor::CodeCompletionModel::UserInvocation (enum)
	{26, 91, 0, 0, Smoke::mf_static|Smoke::mf_enum, 112, 54},	//174 KTextEditor::CodeCompletionModel::ManualInvocation (enum)
	{26, 609, 0, 0, Smoke::mf_const, 532, 58},	//175 KTextEditor::CodeCompletionModel::metaObject() const
	{26, 711, 188, 3, 0, 554, 59},	//176 KTextEditor::CodeCompletionModel::qt_metacall(QMetaObject::Call, int, void**)
	{26, 30, 196, 1, Smoke::mf_ctor, 102, 60},	//177 KTextEditor::CodeCompletionModel::CodeCompletionModel(QObject*)
	{26, 1045, 0, 0, Smoke::mf_dtor, 0, 75},	//178 KTextEditor::CodeCompletionModel::~CodeCompletionModel()
	{26, 902, 479, 1, 0, 0, 61},	//179 KTextEditor::CodeCompletionModel::setRowCount(int)
	{26, 292, 141, 3, 0, 0, 62},	//180 KTextEditor::CodeCompletionModel::completionInvoked(KTextEditor::View*, const KTextEditor::Range&, KTextEditor::CodeCompletionModel::InvocationType)
	{26, 287, 419, 1, Smoke::mf_const, 554, 63},	//181 KTextEditor::CodeCompletionModel::columnCount(const QModelIndex&) const
	{26, 287, 0, 0, Smoke::mf_const, 554, 64},	//182 KTextEditor::CodeCompletionModel::columnCount() const
	{26, 502, 522, 3, Smoke::mf_const, 287, 65},	//183 KTextEditor::CodeCompletionModel::index(int, int, const QModelIndex&) const
	{26, 502, 515, 2, Smoke::mf_const, 287, 66},	//184 KTextEditor::CodeCompletionModel::index(int, int) const
	{26, 545, 419, 1, Smoke::mf_const, 277, 67},	//185 KTextEditor::CodeCompletionModel::itemData(const QModelIndex&) const
	{26, 688, 419, 1, Smoke::mf_const, 287, 68},	//186 KTextEditor::CodeCompletionModel::parent(const QModelIndex&) const
	{26, 787, 419, 1, Smoke::mf_const, 554, 69},	//187 KTextEditor::CodeCompletionModel::rowCount(const QModelIndex&) const
	{26, 787, 0, 0, Smoke::mf_const, 554, 70},	//188 KTextEditor::CodeCompletionModel::rowCount() const
	{26, 477, 0, 0, Smoke::mf_const, 480, 71},	//189 KTextEditor::CodeCompletionModel::hasGroups() const
	{26, 1022, 0, 0, 0, 0, 72},	//190 KTextEditor::CodeCompletionModel::waitForReset()
	{26, 478, 5, 2, 0, 0, 73},	//191 KTextEditor::CodeCompletionModel::hasGroupsChanged(KTextEditor::CodeCompletionModel*, bool)
	{26, 961, 0, 0, Smoke::mf_static, 531, 55},	//192 KTextEditor::CodeCompletionModel::staticMetaObject (static var)
	{26, 34, 0, 0, Smoke::mf_static, 552, 56},	//193 KTextEditor::CodeCompletionModel::ColumnCount (static var)
	{26, 88, 0, 0, Smoke::mf_static, 552, 57},	//194 KTextEditor::CodeCompletionModel::LastItemDataRole (static var)
	{26, 853, 245, 1, Smoke::mf_protected, 0, 74},	//195 KTextEditor::CodeCompletionModel::setHasGroups(bool)
	{27, 609, 0, 0, Smoke::mf_const, 532, 2},	//196 KTextEditor::CodeCompletionModel2::metaObject() const
	{27, 711, 188, 3, 0, 554, 3},	//197 KTextEditor::CodeCompletionModel2::qt_metacall(QMetaObject::Call, int, void**)
	{27, 32, 196, 1, Smoke::mf_ctor, 103, 4},	//198 KTextEditor::CodeCompletionModel2::CodeCompletionModel2(QObject*)
	{27, 444, 41, 3, Smoke::mf_const, 0, 5},	//199 KTextEditor::CodeCompletionModel2::executeCompletionItem2(KTextEditor::Document*, const KTextEditor::Range&, const QModelIndex&) const
	{27, 1046, 0, 0, Smoke::mf_dtor, 0, 6},	//200 KTextEditor::CodeCompletionModel2::~CodeCompletionModel2()
	{27, 961, 0, 0, Smoke::mf_static, 531, 1},	//201 KTextEditor::CodeCompletionModel2::staticMetaObject (static var)
	{28, 1047, 0, 0, Smoke::mf_dtor, 0, 6},	//202 KTextEditor::Command::~Command()
	{28, 285, 0, 0, 0, 548, 1},	//203 KTextEditor::Command::cmds() [pure virtual]
	{28, 442, 148, 3, 0, 480, 2},	//204 KTextEditor::Command::exec(KTextEditor::View*, const QString&, QString&) [pure virtual]
	{28, 488, 148, 3, 0, 480, 3},	//205 KTextEditor::Command::help(KTextEditor::View*, const QString&, QString&) [pure virtual]
	{28, 35, 0, 0, Smoke::mf_ctor, 113, 4},	//206 KTextEditor::Command::Command()
	{28, 35, 262, 1, Smoke::mf_copyctor|Smoke::mf_internal|Smoke::mf_ctor, 113, 5},	//207 KTextEditor::Command::Command(const KTextEditor::Command&)
	{29, 1048, 0, 0, Smoke::mf_dtor, 0, 7},	//208 KTextEditor::CommandExtension::~CommandExtension()
	{29, 454, 216, 1, 0, 0, 1},	//209 KTextEditor::CommandExtension::flagCompletions(QStringList&) [pure virtual]
	{29, 294, 145, 2, 0, 11, 2},	//210 KTextEditor::CommandExtension::completionObject(KTextEditor::View*, const QString&) [pure virtual]
	{29, 1024, 451, 1, 0, 480, 3},	//211 KTextEditor::CommandExtension::wantsToProcessText(const QString&) [pure virtual]
	{29, 709, 145, 2, 0, 0, 4},	//212 KTextEditor::CommandExtension::processText(KTextEditor::View*, const QString&) [pure virtual]
	{29, 37, 0, 0, Smoke::mf_ctor, 114, 5},	//213 KTextEditor::CommandExtension::CommandExtension()
	{29, 37, 264, 1, Smoke::mf_copyctor|Smoke::mf_internal|Smoke::mf_ctor, 114, 6},	//214 KTextEditor::CommandExtension::CommandExtension(const KTextEditor::CommandExtension&)
	{30, 1049, 0, 0, Smoke::mf_dtor, 0, 8},	//215 KTextEditor::CommandInterface::~CommandInterface()
	{30, 737, 8, 1, 0, 480, 1},	//216 KTextEditor::CommandInterface::registerCommand(KTextEditor::Command*) [pure virtual]
	{30, 997, 8, 1, 0, 480, 2},	//217 KTextEditor::CommandInterface::unregisterCommand(KTextEditor::Command*) [pure virtual]
	{30, 714, 451, 1, Smoke::mf_const, 113, 3},	//218 KTextEditor::CommandInterface::queryCommand(const QString&) const [pure virtual]
	{30, 291, 0, 0, Smoke::mf_const, 269, 4},	//219 KTextEditor::CommandInterface::commands() const [pure virtual]
	{30, 290, 0, 0, Smoke::mf_const, 328, 5},	//220 KTextEditor::CommandInterface::commandList() const [pure virtual]
	{30, 39, 0, 0, Smoke::mf_ctor, 115, 6},	//221 KTextEditor::CommandInterface::CommandInterface()
	{30, 39, 266, 1, Smoke::mf_copyctor|Smoke::mf_internal|Smoke::mf_ctor, 115, 7},	//222 KTextEditor::CommandInterface::CommandInterface(const KTextEditor::CommandInterface&)
	{31, 42, 0, 0, Smoke::mf_ctor, 116, 1},	//223 KTextEditor::ConfigInterface::ConfigInterface()
	{31, 1050, 0, 0, Smoke::mf_dtor, 0, 6},	//224 KTextEditor::ConfigInterface::~ConfigInterface()
	{31, 300, 0, 0, Smoke::mf_const, 328, 2},	//225 KTextEditor::ConfigInterface::configKeys() const [pure virtual]
	{31, 310, 451, 1, 0, 379, 3},	//226 KTextEditor::ConfigInterface::configValue(const QString&) [pure virtual]
	{31, 829, 463, 2, 0, 0, 4},	//227 KTextEditor::ConfigInterface::setConfigValue(const QString&, const QVariant&) [pure virtual]
	{31, 42, 268, 1, Smoke::mf_copyctor|Smoke::mf_internal|Smoke::mf_ctor, 116, 5},	//228 KTextEditor::ConfigInterface::ConfigInterface(const KTextEditor::ConfigInterface&)
	{32, 609, 0, 0, Smoke::mf_const, 532, 2},	//229 KTextEditor::ConfigPage::metaObject() const
	{32, 711, 188, 3, 0, 554, 3},	//230 KTextEditor::ConfigPage::qt_metacall(QMetaObject::Call, int, void**)
	{32, 44, 226, 1, Smoke::mf_ctor, 117, 4},	//231 KTextEditor::ConfigPage::ConfigPage(QWidget*)
	{32, 1051, 0, 0, Smoke::mf_dtor, 0, 9},	//232 KTextEditor::ConfigPage::~ConfigPage()
	{32, 213, 0, 0, 0, 0, 5},	//233 KTextEditor::ConfigPage::apply() [pure virtual]
	{32, 783, 0, 0, 0, 0, 6},	//234 KTextEditor::ConfigPage::reset() [pure virtual]
	{32, 372, 0, 0, 0, 0, 7},	//235 KTextEditor::ConfigPage::defaults() [pure virtual]
	{32, 242, 0, 0, 0, 0, 8},	//236 KTextEditor::ConfigPage::changed()
	{32, 961, 0, 0, Smoke::mf_static, 531, 1},	//237 KTextEditor::ConfigPage::staticMetaObject (static var)
	{33, 47, 0, 0, Smoke::mf_ctor, 118, 1},	//238 KTextEditor::ContainerInterface::ContainerInterface()
	{33, 1052, 0, 0, Smoke::mf_dtor, 0, 5},	//239 KTextEditor::ContainerInterface::~ContainerInterface()
	{33, 831, 196, 1, 0, 0, 2},	//240 KTextEditor::ContainerInterface::setContainer(QObject*) [pure virtual]
	{33, 316, 0, 0, 0, 295, 3},	//241 KTextEditor::ContainerInterface::container() [pure virtual]
	{33, 47, 270, 1, Smoke::mf_copyctor|Smoke::mf_internal|Smoke::mf_ctor, 118, 4},	//242 KTextEditor::ContainerInterface::ContainerInterface(const KTextEditor::ContainerInterface&)
	{34, 49, 0, 0, Smoke::mf_ctor, 121, 1},	//243 KTextEditor::Cursor::Cursor()
	{34, 49, 515, 2, Smoke::mf_ctor, 121, 2},	//244 KTextEditor::Cursor::Cursor(int, int)
	{34, 49, 272, 1, Smoke::mf_copyctor|Smoke::mf_ctor, 121, 3},	//245 KTextEditor::Cursor::Cursor(const KTextEditor::Cursor&)
	{34, 1053, 0, 0, Smoke::mf_dtor, 0, 21},	//246 KTextEditor::Cursor::~Cursor()
	{34, 544, 0, 0, Smoke::mf_const, 480, 4},	//247 KTextEditor::Cursor::isValid() const
	{34, 542, 0, 0, Smoke::mf_const, 480, 5},	//248 KTextEditor::Cursor::isSmartCursor() const
	{34, 987, 0, 0, Smoke::mf_const, 143, 6},	//249 KTextEditor::Cursor::toSmartCursor() const
	{34, 894, 272, 1, 0, 0, 7},	//250 KTextEditor::Cursor::setPosition(const KTextEditor::Cursor&)
	{34, 894, 515, 2, 0, 0, 8},	//251 KTextEditor::Cursor::setPosition(int, int)
	{34, 554, 0, 0, Smoke::mf_const, 554, 9},	//252 KTextEditor::Cursor::line() const
	{34, 864, 479, 1, 0, 0, 10},	//253 KTextEditor::Cursor::setLine(int)
	{34, 286, 0, 0, Smoke::mf_const, 554, 11},	//254 KTextEditor::Cursor::column() const
	{34, 824, 479, 1, 0, 0, 12},	//255 KTextEditor::Cursor::setColumn(int)
	{34, 220, 0, 0, Smoke::mf_const, 480, 13},	//256 KTextEditor::Cursor::atStartOfLine() const
	{34, 219, 0, 0, Smoke::mf_const, 480, 14},	//257 KTextEditor::Cursor::atStartOfDocument() const
	{34, 698, 547, 2, Smoke::mf_const, 0, 15},	//258 KTextEditor::Cursor::position(int&, int&) const
	{34, 716, 0, 0, Smoke::mf_const, 137, 16},	//259 KTextEditor::Cursor::range() const
	{34, 536, 0, 0, Smoke::mf_static, 119, 17},	//260 KTextEditor::Cursor::invalid()
	{34, 954, 0, 0, Smoke::mf_static, 119, 18},	//261 KTextEditor::Cursor::start()
	{34, 897, 64, 1, Smoke::mf_protected, 0, 19},	//262 KTextEditor::Cursor::setRange(KTextEditor::Range*)
	{34, 347, 272, 1, Smoke::mf_protected, 0, 20},	//263 KTextEditor::Cursor::cursorChangedDirectly(const KTextEditor::Cursor&)
	{35, 609, 0, 0, Smoke::mf_const, 532, 2},	//264 KTextEditor::Document::metaObject() const
	{35, 711, 188, 3, 0, 554, 3},	//265 KTextEditor::Document::qt_metacall(QMetaObject::Call, int, void**)
	{35, 55, 196, 1, Smoke::mf_ctor, 122, 4},	//266 KTextEditor::Document::Document(QObject*)
	{35, 55, 0, 0, Smoke::mf_ctor, 122, 5},	//267 KTextEditor::Document::Document()
	{35, 1054, 0, 0, Smoke::mf_dtor, 0, 72},	//268 KTextEditor::Document::~Document()
	{35, 419, 0, 0, 0, 123, 6},	//269 KTextEditor::Document::editor() [pure virtual]
	{35, 344, 226, 1, 0, 159, 7},	//270 KTextEditor::Document::createView(QWidget*) [pure virtual]
	{35, 182, 0, 0, Smoke::mf_const, 159, 8},	//271 KTextEditor::Document::activeView() const [pure virtual]
	{35, 1021, 0, 0, Smoke::mf_const, 526, 9},	//272 KTextEditor::Document::views() const [pure virtual]
	{35, 393, 0, 0, Smoke::mf_const, 547, 10},	//273 KTextEditor::Document::documentName() const [pure virtual]
	{35, 614, 0, 0, 0, 324, 11},	//274 KTextEditor::Document::mimeType() [pure virtual]
	{35, 849, 451, 1, 0, 480, 12},	//275 KTextEditor::Document::setEncoding(const QString&) [pure virtual]
	{35, 429, 0, 0, Smoke::mf_const, 547, 13},	//276 KTextEditor::Document::encoding() const [pure virtual]
	{35, 397, 0, 0, 0, 480, 14},	//277 KTextEditor::Document::documentReload() [pure virtual]
	{35, 398, 0, 0, 0, 480, 15},	//278 KTextEditor::Document::documentSave() [pure virtual]
	{35, 399, 0, 0, 0, 480, 16},	//279 KTextEditor::Document::documentSaveAs() [pure virtual]
	{35, 957, 0, 0, 0, 480, 17},	//280 KTextEditor::Document::startEditing() [pure virtual]
	{35, 433, 0, 0, 0, 480, 18},	//281 KTextEditor::Document::endEditing() [pure virtual]
	{35, 970, 0, 0, Smoke::mf_const, 324, 19},	//282 KTextEditor::Document::text() const [pure virtual]
	{35, 970, 355, 2, Smoke::mf_const, 324, 20},	//283 KTextEditor::Document::text(const KTextEditor::Range&, bool) const [pure virtual]
	{35, 970, 340, 1, Smoke::mf_const, 324, -1},	//284 KTextEditor::Document::text(const KTextEditor::Range&) const [pure virtual]
	{35, 243, 272, 1, Smoke::mf_const, 201, 21},	//285 KTextEditor::Document::character(const KTextEditor::Cursor&) const [pure virtual]
	{35, 980, 355, 2, Smoke::mf_const, 328, 22},	//286 KTextEditor::Document::textLines(const KTextEditor::Range&, bool) const [pure virtual]
	{35, 980, 340, 1, Smoke::mf_const, 328, -1},	//287 KTextEditor::Document::textLines(const KTextEditor::Range&) const [pure virtual]
	{35, 554, 479, 1, Smoke::mf_const, 324, 23},	//288 KTextEditor::Document::line(int) const [pure virtual]
	{35, 560, 0, 0, Smoke::mf_const, 554, 24},	//289 KTextEditor::Document::lines() const [pure virtual]
	{35, 391, 0, 0, Smoke::mf_const, 119, 25},	//290 KTextEditor::Document::documentEnd() const [pure virtual]
	{35, 396, 0, 0, Smoke::mf_const, 135, 26},	//291 KTextEditor::Document::documentRange() const
	{35, 990, 0, 0, Smoke::mf_const, 554, 27},	//292 KTextEditor::Document::totalCharacters() const [pure virtual]
	{35, 541, 0, 0, Smoke::mf_const, 480, 28},	//293 KTextEditor::Document::isEmpty() const
	{35, 558, 479, 1, Smoke::mf_const, 554, 29},	//294 KTextEditor::Document::lineLength(int) const [pure virtual]
	{35, 434, 479, 1, Smoke::mf_const, 119, 30},	//295 KTextEditor::Document::endOfLine(int) const
	{35, 918, 451, 1, 0, 480, 31},	//296 KTextEditor::Document::setText(const QString&) [pure virtual]
	{35, 918, 466, 1, 0, 480, 32},	//297 KTextEditor::Document::setText(const QStringList&) [pure virtual]
	{35, 261, 0, 0, 0, 480, 33},	//298 KTextEditor::Document::clear() [pure virtual]
	{35, 526, 306, 3, 0, 480, 34},	//299 KTextEditor::Document::insertText(const KTextEditor::Cursor&, const QString&, bool) [pure virtual]
	{35, 526, 303, 2, 0, 480, -1},	//300 KTextEditor::Document::insertText(const KTextEditor::Cursor&, const QString&) [pure virtual]
	{35, 526, 317, 3, 0, 480, 35},	//301 KTextEditor::Document::insertText(const KTextEditor::Cursor&, const QStringList&, bool) [pure virtual]
	{35, 526, 314, 2, 0, 480, -1},	//302 KTextEditor::Document::insertText(const KTextEditor::Cursor&, const QStringList&) [pure virtual]
	{35, 775, 361, 3, 0, 480, 36},	//303 KTextEditor::Document::replaceText(const KTextEditor::Range&, const QString&, bool)
	{35, 775, 358, 2, 0, 480, 37},	//304 KTextEditor::Document::replaceText(const KTextEditor::Range&, const QString&)
	{35, 775, 372, 3, 0, 480, 38},	//305 KTextEditor::Document::replaceText(const KTextEditor::Range&, const QStringList&, bool)
	{35, 775, 369, 2, 0, 480, 39},	//306 KTextEditor::Document::replaceText(const KTextEditor::Range&, const QStringList&)
	{35, 767, 355, 2, 0, 480, 40},	//307 KTextEditor::Document::removeText(const KTextEditor::Range&, bool) [pure virtual]
	{35, 767, 340, 1, 0, 480, -1},	//308 KTextEditor::Document::removeText(const KTextEditor::Range&) [pure virtual]
	{35, 349, 272, 1, 0, 480, 41},	//309 KTextEditor::Document::cursorInText(const KTextEditor::Cursor&)
	{35, 515, 509, 2, 0, 480, 42},	//310 KTextEditor::Document::insertLine(int, const QString&) [pure virtual]
	{35, 517, 512, 2, 0, 480, 43},	//311 KTextEditor::Document::insertLines(int, const QStringList&) [pure virtual]
	{35, 756, 479, 1, 0, 480, 44},	//312 KTextEditor::Document::removeLine(int) [pure virtual]
	{35, 617, 0, 0, Smoke::mf_const, 324, 45},	//313 KTextEditor::Document::mode() const [pure virtual]
	{35, 492, 0, 0, Smoke::mf_const, 324, 46},	//314 KTextEditor::Document::highlightingMode() const [pure virtual]
	{35, 622, 0, 0, Smoke::mf_const, 328, 47},	//315 KTextEditor::Document::modes() const [pure virtual]
	{35, 497, 0, 0, Smoke::mf_const, 328, 48},	//316 KTextEditor::Document::highlightingModes() const [pure virtual]
	{35, 876, 451, 1, 0, 480, 49},	//317 KTextEditor::Document::setMode(const QString&) [pure virtual]
	{35, 858, 451, 1, 0, 480, 50},	//318 KTextEditor::Document::setHighlightingMode(const QString&) [pure virtual]
	{35, 495, 479, 1, Smoke::mf_const, 324, 51},	//319 KTextEditor::Document::highlightingModeSection(int) const [pure virtual]
	{35, 620, 479, 1, Smoke::mf_const, 324, 52},	//320 KTextEditor::Document::modeSection(int) const [pure virtual]
	{35, 916, 245, 1, 0, 0, 53},	//321 KTextEditor::Document::setSuppressOpeningErrorDialogs(bool)
	{35, 967, 0, 0, Smoke::mf_const, 480, 54},	//322 KTextEditor::Document::suppressOpeningErrorDialogs() const
	{35, 669, 0, 0, Smoke::mf_const, 480, 55},	//323 KTextEditor::Document::openingError() const
	{35, 670, 0, 0, Smoke::mf_const, 324, 56},	//324 KTextEditor::Document::openingErrorMessage() const
	{35, 1011, 24, 2, 0, 0, 57},	//325 KTextEditor::Document::viewCreated(KTextEditor::Document*, KTextEditor::View*)
	{35, 394, 18, 1, 0, 0, 58},	//326 KTextEditor::Document::documentNameChanged(KTextEditor::Document*)
	{35, 402, 18, 1, 0, 0, 59},	//327 KTextEditor::Document::documentUrlChanged(KTextEditor::Document*)
	{35, 623, 18, 1, 0, 0, 60},	//328 KTextEditor::Document::modifiedChanged(KTextEditor::Document*)
	{35, 400, 27, 2, 0, 0, 61},	//329 KTextEditor::Document::documentSavedOrUploaded(KTextEditor::Document*, bool)
	{35, 974, 18, 1, 0, 0, 62},	//330 KTextEditor::Document::textChanged(KTextEditor::Document*)
	{35, 977, 34, 2, 0, 0, 63},	//331 KTextEditor::Document::textInserted(KTextEditor::Document*, const KTextEditor::Range&)
	{35, 983, 34, 2, 0, 0, 64},	//332 KTextEditor::Document::textRemoved(KTextEditor::Document*, const KTextEditor::Range&)
	{35, 974, 37, 3, 0, 0, 65},	//333 KTextEditor::Document::textChanged(KTextEditor::Document*, const KTextEditor::Range&, const KTextEditor::Range&)
	{35, 173, 18, 1, 0, 0, 66},	//334 KTextEditor::Document::aboutToClose(KTextEditor::Document*)
	{35, 175, 18, 1, 0, 0, 67},	//335 KTextEditor::Document::aboutToReload(KTextEditor::Document*)
	{35, 618, 18, 1, 0, 0, 68},	//336 KTextEditor::Document::modeChanged(KTextEditor::Document*)
	{35, 493, 18, 1, 0, 0, 69},	//337 KTextEditor::Document::highlightingModeChanged(KTextEditor::Document*)
	{35, 961, 0, 0, Smoke::mf_static, 531, 1},	//338 KTextEditor::Document::staticMetaObject (static var)
	{35, 886, 245, 1, Smoke::mf_protected, 0, 70},	//339 KTextEditor::Document::setOpeningError(bool)
	{35, 888, 451, 1, Smoke::mf_protected, 0, 71},	//340 KTextEditor::Document::setOpeningErrorMessage(const QString&)
	{36, 609, 0, 0, Smoke::mf_const, 532, 2},	//341 KTextEditor::Editor::metaObject() const
	{36, 711, 188, 3, 0, 554, 3},	//342 KTextEditor::Editor::qt_metacall(QMetaObject::Call, int, void**)
	{36, 59, 196, 1, Smoke::mf_ctor, 123, 4},	//343 KTextEditor::Editor::Editor(QObject*)
	{36, 1055, 0, 0, Smoke::mf_dtor, 0, 20},	//344 KTextEditor::Editor::~Editor()
	{36, 914, 245, 1, 0, 0, 5},	//345 KTextEditor::Editor::setSimpleMode(bool)
	{36, 941, 0, 0, Smoke::mf_const, 480, 6},	//346 KTextEditor::Editor::simpleMode() const
	{36, 330, 196, 1, 0, 122, 7},	//347 KTextEditor::Editor::createDocument(QObject*) [pure virtual]
	{36, 404, 0, 0, 0, 521, 8},	//348 KTextEditor::Editor::documents() [pure virtual]
	{36, 172, 0, 0, Smoke::mf_const, 481, 9},	//349 KTextEditor::Editor::aboutData() const [pure virtual]
	{36, 732, 52, 1, 0, 0, 10},	//350 KTextEditor::Editor::readConfig(KConfig*) [pure virtual]
	{36, 732, 0, 0, 0, 0, -1},	//351 KTextEditor::Editor::readConfig() [pure virtual]
	{36, 1035, 52, 1, 0, 0, 11},	//352 KTextEditor::Editor::writeConfig(KConfig*) [pure virtual]
	{36, 1035, 0, 0, 0, 0, -1},	//353 KTextEditor::Editor::writeConfig() [pure virtual]
	{36, 299, 0, 0, Smoke::mf_const, 480, 12},	//354 KTextEditor::Editor::configDialogSupported() const [pure virtual]
	{36, 297, 226, 1, 0, 0, 13},	//355 KTextEditor::Editor::configDialog(QWidget*) [pure virtual]
	{36, 309, 0, 0, Smoke::mf_const, 554, 14},	//356 KTextEditor::Editor::configPages() const [pure virtual]
	{36, 301, 484, 2, 0, 117, 15},	//357 KTextEditor::Editor::configPage(int, QWidget*) [pure virtual]
	{36, 307, 479, 1, Smoke::mf_const, 324, 16},	//358 KTextEditor::Editor::configPageName(int) const [pure virtual]
	{36, 303, 479, 1, Smoke::mf_const, 324, 17},	//359 KTextEditor::Editor::configPageFullName(int) const [pure virtual]
	{36, 305, 479, 1, Smoke::mf_const, 51, 18},	//360 KTextEditor::Editor::configPageIcon(int) const [pure virtual]
	{36, 389, 49, 2, 0, 0, 19},	//361 KTextEditor::Editor::documentCreated(KTextEditor::Editor*, KTextEditor::Document*)
	{36, 961, 0, 0, Smoke::mf_static, 531, 1},	//362 KTextEditor::Editor::staticMetaObject (static var)
	{37, 609, 0, 0, Smoke::mf_const, 532, 2},	//363 KTextEditor::EditorChooser::metaObject() const
	{37, 711, 188, 3, 0, 554, 3},	//364 KTextEditor::EditorChooser::qt_metacall(QMetaObject::Call, int, void**)
	{37, 61, 226, 1, Smoke::mf_ctor, 124, 4},	//365 KTextEditor::EditorChooser::EditorChooser(QWidget*)
	{37, 61, 0, 0, Smoke::mf_ctor, 124, 5},	//366 KTextEditor::EditorChooser::EditorChooser()
	{37, 1056, 0, 0, Smoke::mf_dtor, 0, 14},	//367 KTextEditor::EditorChooser::~EditorChooser()
	{37, 730, 451, 1, 0, 0, 6},	//368 KTextEditor::EditorChooser::readAppSetting(const QString&)
	{37, 730, 0, 0, 0, 0, 7},	//369 KTextEditor::EditorChooser::readAppSetting()
	{37, 1033, 451, 1, 0, 0, 8},	//370 KTextEditor::EditorChooser::writeAppSetting(const QString&)
	{37, 1033, 0, 0, 0, 0, 9},	//371 KTextEditor::EditorChooser::writeAppSetting()
	{37, 242, 0, 0, 0, 0, 10},	//372 KTextEditor::EditorChooser::changed()
	{37, 419, 456, 2, Smoke::mf_static, 123, 11},	//373 KTextEditor::EditorChooser::editor(const QString&, bool)
	{37, 419, 451, 1, Smoke::mf_static, 123, 12},	//374 KTextEditor::EditorChooser::editor(const QString&)
	{37, 419, 0, 0, Smoke::mf_static, 123, 13},	//375 KTextEditor::EditorChooser::editor()
	{37, 961, 0, 0, Smoke::mf_static, 531, 1},	//376 KTextEditor::EditorChooser::staticMetaObject (static var)
	{38, 609, 0, 0, Smoke::mf_const, 532, 2},	//377 KTextEditor::Factory::metaObject() const
	{38, 711, 188, 3, 0, 554, 3},	//378 KTextEditor::Factory::qt_metacall(QMetaObject::Call, int, void**)
	{38, 74, 196, 1, Smoke::mf_ctor, 125, 4},	//379 KTextEditor::Factory::Factory(QObject*)
	{38, 1057, 0, 0, Smoke::mf_dtor, 0, 6},	//380 KTextEditor::Factory::~Factory()
	{38, 419, 0, 0, 0, 123, 5},	//381 KTextEditor::Factory::editor() [pure virtual]
	{38, 961, 0, 0, Smoke::mf_static, 531, 1},	//382 KTextEditor::Factory::staticMetaObject (static var)
	{39, 864, 479, 1, 0, 0, 3},	//383 KTextEditor::Mark::setLine(int)
	{39, 921, 550, 1, 0, 0, 4},	//384 KTextEditor::Mark::setType(uint)
	{39, 92, 0, 0, Smoke::mf_ctor, 127, 5},	//385 KTextEditor::Mark::Mark()
	{39, 1058, 0, 0, Smoke::mf_dtor, 0, 7},	//386 KTextEditor::Mark::~Mark()
	{39, 92, 332, 1, Smoke::mf_copyctor|Smoke::mf_internal|Smoke::mf_ctor, 127, 6},	//387 KTextEditor::Mark::Mark(const KTextEditor::Mark&)
	{39, 554, 0, 0, 0, 554, 1},	//388 KTextEditor::Mark::line (var)
	{39, 994, 0, 0, 0, 556, 2},	//389 KTextEditor::Mark::type (var)
	{40, 570, 0, 0, Smoke::mf_static|Smoke::mf_enum, 130, 1},	//390 KTextEditor::MarkInterface::markType01 (enum)
	{40, 571, 0, 0, Smoke::mf_static|Smoke::mf_enum, 130, 2},	//391 KTextEditor::MarkInterface::markType02 (enum)
	{40, 572, 0, 0, Smoke::mf_static|Smoke::mf_enum, 130, 3},	//392 KTextEditor::MarkInterface::markType03 (enum)
	{40, 573, 0, 0, Smoke::mf_static|Smoke::mf_enum, 130, 4},	//393 KTextEditor::MarkInterface::markType04 (enum)
	{40, 574, 0, 0, Smoke::mf_static|Smoke::mf_enum, 130, 5},	//394 KTextEditor::MarkInterface::markType05 (enum)
	{40, 575, 0, 0, Smoke::mf_static|Smoke::mf_enum, 130, 6},	//395 KTextEditor::MarkInterface::markType06 (enum)
	{40, 576, 0, 0, Smoke::mf_static|Smoke::mf_enum, 130, 7},	//396 KTextEditor::MarkInterface::markType07 (enum)
	{40, 577, 0, 0, Smoke::mf_static|Smoke::mf_enum, 130, 8},	//397 KTextEditor::MarkInterface::markType08 (enum)
	{40, 578, 0, 0, Smoke::mf_static|Smoke::mf_enum, 130, 9},	//398 KTextEditor::MarkInterface::markType09 (enum)
	{40, 579, 0, 0, Smoke::mf_static|Smoke::mf_enum, 130, 10},	//399 KTextEditor::MarkInterface::markType10 (enum)
	{40, 580, 0, 0, Smoke::mf_static|Smoke::mf_enum, 130, 11},	//400 KTextEditor::MarkInterface::markType11 (enum)
	{40, 581, 0, 0, Smoke::mf_static|Smoke::mf_enum, 130, 12},	//401 KTextEditor::MarkInterface::markType12 (enum)
	{40, 582, 0, 0, Smoke::mf_static|Smoke::mf_enum, 130, 13},	//402 KTextEditor::MarkInterface::markType13 (enum)
	{40, 583, 0, 0, Smoke::mf_static|Smoke::mf_enum, 130, 14},	//403 KTextEditor::MarkInterface::markType14 (enum)
	{40, 584, 0, 0, Smoke::mf_static|Smoke::mf_enum, 130, 15},	//404 KTextEditor::MarkInterface::markType15 (enum)
	{40, 585, 0, 0, Smoke::mf_static|Smoke::mf_enum, 130, 16},	//405 KTextEditor::MarkInterface::markType16 (enum)
	{40, 586, 0, 0, Smoke::mf_static|Smoke::mf_enum, 130, 17},	//406 KTextEditor::MarkInterface::markType17 (enum)
	{40, 587, 0, 0, Smoke::mf_static|Smoke::mf_enum, 130, 18},	//407 KTextEditor::MarkInterface::markType18 (enum)
	{40, 588, 0, 0, Smoke::mf_static|Smoke::mf_enum, 130, 19},	//408 KTextEditor::MarkInterface::markType19 (enum)
	{40, 589, 0, 0, Smoke::mf_static|Smoke::mf_enum, 130, 20},	//409 KTextEditor::MarkInterface::markType20 (enum)
	{40, 590, 0, 0, Smoke::mf_static|Smoke::mf_enum, 130, 21},	//410 KTextEditor::MarkInterface::markType21 (enum)
	{40, 591, 0, 0, Smoke::mf_static|Smoke::mf_enum, 130, 22},	//411 KTextEditor::MarkInterface::markType22 (enum)
	{40, 592, 0, 0, Smoke::mf_static|Smoke::mf_enum, 130, 23},	//412 KTextEditor::MarkInterface::markType23 (enum)
	{40, 593, 0, 0, Smoke::mf_static|Smoke::mf_enum, 130, 24},	//413 KTextEditor::MarkInterface::markType24 (enum)
	{40, 594, 0, 0, Smoke::mf_static|Smoke::mf_enum, 130, 25},	//414 KTextEditor::MarkInterface::markType25 (enum)
	{40, 595, 0, 0, Smoke::mf_static|Smoke::mf_enum, 130, 26},	//415 KTextEditor::MarkInterface::markType26 (enum)
	{40, 596, 0, 0, Smoke::mf_static|Smoke::mf_enum, 130, 27},	//416 KTextEditor::MarkInterface::markType27 (enum)
	{40, 597, 0, 0, Smoke::mf_static|Smoke::mf_enum, 130, 28},	//417 KTextEditor::MarkInterface::markType28 (enum)
	{40, 598, 0, 0, Smoke::mf_static|Smoke::mf_enum, 130, 29},	//418 KTextEditor::MarkInterface::markType29 (enum)
	{40, 599, 0, 0, Smoke::mf_static|Smoke::mf_enum, 130, 30},	//419 KTextEditor::MarkInterface::markType30 (enum)
	{40, 600, 0, 0, Smoke::mf_static|Smoke::mf_enum, 130, 31},	//420 KTextEditor::MarkInterface::markType31 (enum)
	{40, 601, 0, 0, Smoke::mf_static|Smoke::mf_enum, 130, 32},	//421 KTextEditor::MarkInterface::markType32 (enum)
	{40, 21, 0, 0, Smoke::mf_static|Smoke::mf_enum, 130, 33},	//422 KTextEditor::MarkInterface::Bookmark (enum)
	{40, 22, 0, 0, Smoke::mf_static|Smoke::mf_enum, 130, 34},	//423 KTextEditor::MarkInterface::BreakpointActive (enum)
	{40, 24, 0, 0, Smoke::mf_static|Smoke::mf_enum, 130, 35},	//424 KTextEditor::MarkInterface::BreakpointReached (enum)
	{40, 23, 0, 0, Smoke::mf_static|Smoke::mf_enum, 130, 36},	//425 KTextEditor::MarkInterface::BreakpointDisabled (enum)
	{40, 70, 0, 0, Smoke::mf_static|Smoke::mf_enum, 130, 37},	//426 KTextEditor::MarkInterface::Execution (enum)
	{40, 170, 0, 0, Smoke::mf_static|Smoke::mf_enum, 130, 38},	//427 KTextEditor::MarkInterface::Warning (enum)
	{40, 69, 0, 0, Smoke::mf_static|Smoke::mf_enum, 130, 39},	//428 KTextEditor::MarkInterface::Error (enum)
	{40, 94, 0, 0, Smoke::mf_static|Smoke::mf_enum, 129, 40},	//429 KTextEditor::MarkInterface::MarkAdded (enum)
	{40, 97, 0, 0, Smoke::mf_static|Smoke::mf_enum, 129, 41},	//430 KTextEditor::MarkInterface::MarkRemoved (enum)
	{40, 95, 0, 0, Smoke::mf_ctor, 128, 42},	//431 KTextEditor::MarkInterface::MarkInterface()
	{40, 1059, 0, 0, Smoke::mf_dtor, 0, 60},	//432 KTextEditor::MarkInterface::~MarkInterface()
	{40, 562, 479, 1, 0, 556, 43},	//433 KTextEditor::MarkInterface::mark(int) [pure virtual]
	{40, 870, 544, 2, 0, 0, 44},	//434 KTextEditor::MarkInterface::setMark(int, uint) [pure virtual]
	{40, 267, 479, 1, 0, 0, 45},	//435 KTextEditor::MarkInterface::clearMark(int) [pure virtual]
	{40, 195, 544, 2, 0, 0, 46},	//436 KTextEditor::MarkInterface::addMark(int, uint) [pure virtual]
	{40, 758, 544, 2, 0, 0, 47},	//437 KTextEditor::MarkInterface::removeMark(int, uint) [pure virtual]
	{40, 602, 0, 0, 0, 516, 48},	//438 KTextEditor::MarkInterface::marks() [pure virtual]
	{40, 269, 0, 0, 0, 0, 49},	//439 KTextEditor::MarkInterface::clearMarks() [pure virtual]
	{40, 603, 18, 1, 0, 0, 50},	//440 KTextEditor::MarkInterface::marksChanged(KTextEditor::Document*) [pure virtual]
	{40, 874, 56, 2, 0, 0, 51},	//441 KTextEditor::MarkInterface::setMarkPixmap(KTextEditor::MarkInterface::MarkTypes, const QPixmap&) [pure virtual]
	{40, 568, 54, 1, Smoke::mf_const, 313, 52},	//442 KTextEditor::MarkInterface::markPixmap(KTextEditor::MarkInterface::MarkTypes) const [pure virtual]
	{40, 872, 59, 2, 0, 0, 53},	//443 KTextEditor::MarkInterface::setMarkDescription(KTextEditor::MarkInterface::MarkTypes, const QString&) [pure virtual]
	{40, 566, 54, 1, Smoke::mf_const, 324, 54},	//444 KTextEditor::MarkInterface::markDescription(KTextEditor::MarkInterface::MarkTypes) const [pure virtual]
	{40, 845, 550, 1, 0, 0, 55},	//445 KTextEditor::MarkInterface::setEditableMarks(uint) [pure virtual]
	{40, 418, 0, 0, Smoke::mf_const, 556, 56},	//446 KTextEditor::MarkInterface::editableMarks() const [pure virtual]
	{40, 564, 20, 3, 0, 0, 57},	//447 KTextEditor::MarkInterface::markChanged(KTextEditor::Document*, KTextEditor::Mark, KTextEditor::MarkInterface::MarkChangeAction) [pure virtual]
	{40, 95, 334, 1, Smoke::mf_copyctor|Smoke::mf_internal|Smoke::mf_ctor, 128, 58},	//448 KTextEditor::MarkInterface::MarkInterface(const KTextEditor::MarkInterface&)
	{40, 782, 0, 0, Smoke::mf_static, 554, 59},	//449 KTextEditor::MarkInterface::reservedMarkersCount()
	{41, 99, 0, 0, Smoke::mf_ctor, 131, 1},	//450 KTextEditor::MdiContainer::MdiContainer()
	{41, 1060, 0, 0, Smoke::mf_dtor, 0, 9},	//451 KTextEditor::MdiContainer::~MdiContainer()
	{41, 804, 112, 1, 0, 0, 2},	//452 KTextEditor::MdiContainer::setActiveView(KTextEditor::View*) [pure virtual]
	{41, 182, 0, 0, 0, 159, 3},	//453 KTextEditor::MdiContainer::activeView() [pure virtual]
	{41, 330, 0, 0, 0, 122, 4},	//454 KTextEditor::MdiContainer::createDocument() [pure virtual]
	{41, 277, 18, 1, 0, 480, 5},	//455 KTextEditor::MdiContainer::closeDocument(KTextEditor::Document*) [pure virtual]
	{41, 344, 18, 1, 0, 159, 6},	//456 KTextEditor::MdiContainer::createView(KTextEditor::Document*) [pure virtual]
	{41, 283, 112, 1, 0, 480, 7},	//457 KTextEditor::MdiContainer::closeView(KTextEditor::View*) [pure virtual]
	{41, 99, 336, 1, Smoke::mf_copyctor|Smoke::mf_internal|Smoke::mf_ctor, 131, 8},	//458 KTextEditor::MdiContainer::MdiContainer(const KTextEditor::MdiContainer&)
	{42, 112, 0, 0, Smoke::mf_static|Smoke::mf_enum, 133, 1},	//459 KTextEditor::ModificationInterface::OnDiskUnmodified (enum)
	{42, 111, 0, 0, Smoke::mf_static|Smoke::mf_enum, 133, 2},	//460 KTextEditor::ModificationInterface::OnDiskModified (enum)
	{42, 109, 0, 0, Smoke::mf_static|Smoke::mf_enum, 133, 3},	//461 KTextEditor::ModificationInterface::OnDiskCreated (enum)
	{42, 110, 0, 0, Smoke::mf_static|Smoke::mf_enum, 133, 4},	//462 KTextEditor::ModificationInterface::OnDiskDeleted (enum)
	{42, 101, 0, 0, Smoke::mf_ctor, 132, 5},	//463 KTextEditor::ModificationInterface::ModificationInterface()
	{42, 1061, 0, 0, Smoke::mf_dtor, 0, 11},	//464 KTextEditor::ModificationInterface::~ModificationInterface()
	{42, 880, 62, 1, 0, 0, 6},	//465 KTextEditor::ModificationInterface::setModifiedOnDisk(KTextEditor::ModificationInterface::ModifiedOnDiskReason) [pure virtual]
	{42, 882, 245, 1, 0, 0, 7},	//466 KTextEditor::ModificationInterface::setModifiedOnDiskWarning(bool) [pure virtual]
	{42, 943, 112, 1, 0, 0, 8},	//467 KTextEditor::ModificationInterface::slotModifiedOnDisk(KTextEditor::View*) [pure virtual]
	{42, 943, 0, 0, 0, 0, -1},	//468 KTextEditor::ModificationInterface::slotModifiedOnDisk() [pure virtual]
	{42, 625, 30, 3, 0, 0, 9},	//469 KTextEditor::ModificationInterface::modifiedOnDisk(KTextEditor::Document*, bool, KTextEditor::ModificationInterface::ModifiedOnDiskReason) [pure virtual]
	{42, 101, 338, 1, Smoke::mf_copyctor|Smoke::mf_internal|Smoke::mf_ctor, 132, 10},	//470 KTextEditor::ModificationInterface::ModificationInterface(const KTextEditor::ModificationInterface&)
	{43, 609, 0, 0, Smoke::mf_const, 532, 2},	//471 KTextEditor::Plugin::metaObject() const
	{43, 711, 188, 3, 0, 554, 3},	//472 KTextEditor::Plugin::qt_metacall(QMetaObject::Call, int, void**)
	{43, 115, 196, 1, Smoke::mf_ctor, 134, 4},	//473 KTextEditor::Plugin::Plugin(QObject*)
	{43, 1062, 0, 0, Smoke::mf_dtor, 0, 9},	//474 KTextEditor::Plugin::~Plugin()
	{43, 187, 18, 1, 0, 0, 5},	//475 KTextEditor::Plugin::addDocument(KTextEditor::Document*)
	{43, 750, 18, 1, 0, 0, 6},	//476 KTextEditor::Plugin::removeDocument(KTextEditor::Document*)
	{43, 199, 112, 1, 0, 0, 7},	//477 KTextEditor::Plugin::addView(KTextEditor::View*)
	{43, 771, 112, 1, 0, 0, 8},	//478 KTextEditor::Plugin::removeView(KTextEditor::View*)
	{43, 961, 0, 0, Smoke::mf_static, 531, 1},	//479 KTextEditor::Plugin::staticMetaObject (static var)
	{44, 122, 0, 0, Smoke::mf_ctor, 137, 1},	//480 KTextEditor::Range::Range()
	{44, 122, 291, 2, Smoke::mf_ctor, 137, 2},	//481 KTextEditor::Range::Range(const KTextEditor::Cursor&, const KTextEditor::Cursor&)
	{44, 122, 321, 2, Smoke::mf_ctor, 137, 3},	//482 KTextEditor::Range::Range(const KTextEditor::Cursor&, int)
	{44, 122, 328, 3, Smoke::mf_ctor, 137, 4},	//483 KTextEditor::Range::Range(const KTextEditor::Cursor&, int, int)
	{44, 122, 526, 4, Smoke::mf_ctor, 137, 5},	//484 KTextEditor::Range::Range(int, int, int, int)
	{44, 122, 340, 1, Smoke::mf_copyctor|Smoke::mf_ctor, 137, 6},	//485 KTextEditor::Range::Range(const KTextEditor::Range&)
	{44, 1063, 0, 0, Smoke::mf_dtor, 0, 38},	//486 KTextEditor::Range::~Range()
	{44, 544, 0, 0, Smoke::mf_const, 480, 7},	//487 KTextEditor::Range::isValid() const
	{44, 543, 0, 0, Smoke::mf_const, 480, 8},	//488 KTextEditor::Range::isSmartRange() const
	{44, 988, 0, 0, Smoke::mf_const, 150, 9},	//489 KTextEditor::Range::toSmartRange() const
	{44, 954, 0, 0, 0, 120, 10},	//490 KTextEditor::Range::start()
	{44, 432, 0, 0, 0, 120, 11},	//491 KTextEditor::Range::end()
	{44, 820, 479, 1, 0, 0, 12},	//492 KTextEditor::Range::setBothLines(int)
	{44, 818, 479, 1, 0, 0, 13},	//493 KTextEditor::Range::setBothColumns(int)
	{44, 897, 340, 1, 0, 0, 14},	//494 KTextEditor::Range::setRange(const KTextEditor::Range&)
	{44, 897, 291, 2, 0, 0, 15},	//495 KTextEditor::Range::setRange(const KTextEditor::Cursor&, const KTextEditor::Cursor&)
	{44, 448, 340, 1, 0, 480, 16},	//496 KTextEditor::Range::expandToRange(const KTextEditor::Range&)
	{44, 312, 340, 1, 0, 480, 17},	//497 KTextEditor::Range::confineToRange(const KTextEditor::Range&)
	{44, 665, 0, 0, Smoke::mf_const, 480, 18},	//498 KTextEditor::Range::onSingleLine() const
	{44, 664, 0, 0, Smoke::mf_const, 554, 19},	//499 KTextEditor::Range::numberOfLines() const
	{44, 289, 0, 0, Smoke::mf_const, 554, 20},	//500 KTextEditor::Range::columnWidth() const
	{44, 541, 0, 0, Smoke::mf_const, 480, 21},	//501 KTextEditor::Range::isEmpty() const
	{44, 317, 340, 1, Smoke::mf_const, 480, 22},	//502 KTextEditor::Range::contains(const KTextEditor::Range&) const
	{44, 317, 272, 1, Smoke::mf_const, 480, 23},	//503 KTextEditor::Range::contains(const KTextEditor::Cursor&) const
	{44, 321, 479, 1, Smoke::mf_const, 480, 24},	//504 KTextEditor::Range::containsLine(int) const
	{44, 319, 479, 1, Smoke::mf_const, 480, 25},	//505 KTextEditor::Range::containsColumn(int) const
	{44, 677, 340, 1, Smoke::mf_const, 480, 26},	//506 KTextEditor::Range::overlaps(const KTextEditor::Range&) const
	{44, 681, 479, 1, Smoke::mf_const, 480, 27},	//507 KTextEditor::Range::overlapsLine(int) const
	{44, 679, 479, 1, Smoke::mf_const, 480, 28},	//508 KTextEditor::Range::overlapsColumn(int) const
	{44, 704, 272, 1, Smoke::mf_const, 554, 29},	//509 KTextEditor::Range::positionRelativeToCursor(const KTextEditor::Cursor&) const
	{44, 706, 479, 1, Smoke::mf_const, 554, 30},	//510 KTextEditor::Range::positionRelativeToLine(int) const
	{44, 228, 272, 1, Smoke::mf_const, 480, 31},	//511 KTextEditor::Range::boundaryAtCursor(const KTextEditor::Cursor&) const
	{44, 230, 479, 1, Smoke::mf_const, 480, 32},	//512 KTextEditor::Range::boundaryOnLine(int) const
	{44, 534, 340, 1, Smoke::mf_const, 135, 33},	//513 KTextEditor::Range::intersect(const KTextEditor::Range&) const
	{44, 430, 340, 1, Smoke::mf_const, 135, 34},	//514 KTextEditor::Range::encompass(const KTextEditor::Range&) const
	{44, 536, 0, 0, Smoke::mf_static, 135, 35},	//515 KTextEditor::Range::invalid()
	{44, 122, 12, 2, Smoke::mf_ctor|Smoke::mf_protected, 137, 36},	//516 KTextEditor::Range::Range(KTextEditor::Cursor*, KTextEditor::Cursor*)
	{44, 719, 15, 2, Smoke::mf_protected, 0, 37},	//517 KTextEditor::Range::rangeChanged(KTextEditor::Cursor*, const KTextEditor::Range&)
	{45, 130, 0, 0, Smoke::mf_ctor, 140, 1},	//518 KTextEditor::SearchInterface::SearchInterface()
	{45, 1064, 0, 0, Smoke::mf_dtor, 0, 5},	//519 KTextEditor::SearchInterface::~SearchInterface()
	{45, 794, 365, 3, 0, 381, 2},	//520 KTextEditor::SearchInterface::searchText(const KTextEditor::Range&, const QString&, const KTextEditor::Search::SearchOptions) [pure virtual]
	{45, 794, 358, 2, 0, 381, -1},	//521 KTextEditor::SearchInterface::searchText(const KTextEditor::Range&, const QString&) [pure virtual]
	{45, 966, 0, 0, Smoke::mf_const, 138, 3},	//522 KTextEditor::SearchInterface::supportedSearchOptions() const [pure virtual]
	{45, 130, 376, 1, Smoke::mf_copyctor|Smoke::mf_internal|Smoke::mf_ctor, 140, 4},	//523 KTextEditor::SearchInterface::SearchInterface(const KTextEditor::SearchInterface&)
	{46, 134, 0, 0, Smoke::mf_ctor, 141, 1},	//524 KTextEditor::SessionConfigInterface::SessionConfigInterface()
	{46, 1065, 0, 0, Smoke::mf_dtor, 0, 5},	//525 KTextEditor::SessionConfigInterface::~SessionConfigInterface()
	{46, 734, 252, 1, 0, 0, 2},	//526 KTextEditor::SessionConfigInterface::readSessionConfig(const KConfigGroup&) [pure virtual]
	{46, 1037, 155, 1, 0, 0, 3},	//527 KTextEditor::SessionConfigInterface::writeSessionConfig(KConfigGroup&) [pure virtual]
	{46, 134, 378, 1, Smoke::mf_copyctor|Smoke::mf_internal|Smoke::mf_ctor, 141, 4},	//528 KTextEditor::SessionConfigInterface::SessionConfigInterface(const KTextEditor::SessionConfigInterface&)
	{47, 25, 0, 0, Smoke::mf_static|Smoke::mf_enum, 144, 1},	//529 KTextEditor::SmartCursor::ByCharacter (enum)
	{47, 26, 0, 0, Smoke::mf_static|Smoke::mf_enum, 144, 2},	//530 KTextEditor::SmartCursor::ByCursorPosition (enum)
	{47, 154, 0, 0, Smoke::mf_static|Smoke::mf_enum, 145, 3},	//531 KTextEditor::SmartCursor::StayOnInsert (enum)
	{47, 103, 0, 0, Smoke::mf_static|Smoke::mf_enum, 145, 4},	//532 KTextEditor::SmartCursor::MoveOnInsert (enum)
	{47, 1066, 0, 0, Smoke::mf_dtor, 0, 26},	//533 KTextEditor::SmartCursor::~SmartCursor()
	{47, 542, 0, 0, Smoke::mf_const, 480, 5},	//534 KTextEditor::SmartCursor::isSmartCursor() const
	{47, 987, 0, 0, Smoke::mf_const, 143, 6},	//535 KTextEditor::SmartCursor::toSmartCursor() const
	{47, 947, 0, 0, Smoke::mf_const, 150, 7},	//536 KTextEditor::SmartCursor::smartRange() const
	{47, 387, 0, 0, Smoke::mf_const, 122, 8},	//537 KTextEditor::SmartCursor::document() const
	{47, 218, 0, 0, Smoke::mf_const, 480, 9},	//538 KTextEditor::SmartCursor::atEndOfLine() const
	{47, 217, 0, 0, Smoke::mf_const, 480, 10},	//539 KTextEditor::SmartCursor::atEndOfDocument() const
	{47, 544, 0, 0, Smoke::mf_const, 480, 11},	//540 KTextEditor::SmartCursor::isValid() const
	{47, 243, 0, 0, Smoke::mf_const, 201, 12},	//541 KTextEditor::SmartCursor::character() const
	{47, 526, 468, 2, 0, 480, 13},	//542 KTextEditor::SmartCursor::insertText(const QStringList&, bool)
	{47, 526, 466, 1, 0, 480, 14},	//543 KTextEditor::SmartCursor::insertText(const QStringList&)
	{47, 203, 481, 2, 0, 480, 15},	//544 KTextEditor::SmartCursor::advance(int, KTextEditor::SmartCursor::AdvanceMode)
	{47, 203, 479, 1, 0, 480, 16},	//545 KTextEditor::SmartCursor::advance(int)
	{47, 511, 0, 0, Smoke::mf_const, 145, 17},	//546 KTextEditor::SmartCursor::insertBehavior() const
	{47, 860, 83, 1, 0, 0, 18},	//547 KTextEditor::SmartCursor::setInsertBehavior(KTextEditor::SmartCursor::InsertBehavior)
	{47, 480, 0, 0, Smoke::mf_const, 480, 19},	//548 KTextEditor::SmartCursor::hasNotifier() const [pure virtual]
	{47, 662, 0, 0, 0, 146, 20},	//549 KTextEditor::SmartCursor::notifier() [pure virtual]
	{47, 375, 0, 0, 0, 0, 21},	//550 KTextEditor::SmartCursor::deleteNotifier() [pure virtual]
	{47, 1026, 0, 0, Smoke::mf_const, 147, 22},	//551 KTextEditor::SmartCursor::watcher() const [pure virtual]
	{47, 927, 85, 1, 0, 0, 23},	//552 KTextEditor::SmartCursor::setWatcher(KTextEditor::SmartCursorWatcher*) [pure virtual]
	{47, 927, 0, 0, 0, 0, -1},	//553 KTextEditor::SmartCursor::setWatcher() [pure virtual]
	{47, 673, 380, 1, 0, 142, 24},	//554 KTextEditor::SmartCursor::operator=(const KTextEditor::SmartCursor&)
	{47, 139, 274, 3, Smoke::mf_ctor|Smoke::mf_protected, 143, 25},	//555 KTextEditor::SmartCursor::SmartCursor(const KTextEditor::Cursor&, KTextEditor::Document*, KTextEditor::SmartCursor::InsertBehavior)
	{48, 609, 0, 0, Smoke::mf_const, 532, 2},	//556 KTextEditor::SmartCursorNotifier::metaObject() const
	{48, 711, 188, 3, 0, 554, 3},	//557 KTextEditor::SmartCursorNotifier::qt_metacall(QMetaObject::Call, int, void**)
	{48, 141, 0, 0, Smoke::mf_ctor, 146, 4},	//558 KTextEditor::SmartCursorNotifier::SmartCursorNotifier()
	{48, 1023, 0, 0, Smoke::mf_const, 480, 5},	//559 KTextEditor::SmartCursorNotifier::wantsDirectChanges() const
	{48, 925, 245, 1, 0, 0, 6},	//560 KTextEditor::SmartCursorNotifier::setWantsDirectChanges(bool)
	{48, 1067, 0, 0, Smoke::mf_dtor, 0, 12},	//561 KTextEditor::SmartCursorNotifier::~SmartCursorNotifier()
	{48, 700, 66, 1, 0, 0, 7},	//562 KTextEditor::SmartCursorNotifier::positionChanged(KTextEditor::SmartCursor*)
	{48, 702, 66, 1, 0, 0, 8},	//563 KTextEditor::SmartCursorNotifier::positionDeleted(KTextEditor::SmartCursor*)
	{48, 245, 80, 2, 0, 0, 9},	//564 KTextEditor::SmartCursorNotifier::characterDeleted(KTextEditor::SmartCursor*, bool)
	{48, 247, 80, 2, 0, 0, 10},	//565 KTextEditor::SmartCursorNotifier::characterInserted(KTextEditor::SmartCursor*, bool)
	{48, 378, 66, 1, 0, 0, 11},	//566 KTextEditor::SmartCursorNotifier::deleted(KTextEditor::SmartCursor*)
	{48, 961, 0, 0, Smoke::mf_static, 531, 1},	//567 KTextEditor::SmartCursorNotifier::staticMetaObject (static var)
	{49, 142, 0, 0, Smoke::mf_ctor, 147, 1},	//568 KTextEditor::SmartCursorWatcher::SmartCursorWatcher()
	{49, 1068, 0, 0, Smoke::mf_dtor, 0, 10},	//569 KTextEditor::SmartCursorWatcher::~SmartCursorWatcher()
	{49, 1023, 0, 0, Smoke::mf_const, 480, 2},	//570 KTextEditor::SmartCursorWatcher::wantsDirectChanges() const
	{49, 925, 245, 1, 0, 0, 3},	//571 KTextEditor::SmartCursorWatcher::setWantsDirectChanges(bool)
	{49, 700, 66, 1, 0, 0, 4},	//572 KTextEditor::SmartCursorWatcher::positionChanged(KTextEditor::SmartCursor*)
	{49, 702, 66, 1, 0, 0, 5},	//573 KTextEditor::SmartCursorWatcher::positionDeleted(KTextEditor::SmartCursor*)
	{49, 245, 80, 2, 0, 0, 6},	//574 KTextEditor::SmartCursorWatcher::characterDeleted(KTextEditor::SmartCursor*, bool)
	{49, 247, 80, 2, 0, 0, 7},	//575 KTextEditor::SmartCursorWatcher::characterInserted(KTextEditor::SmartCursor*, bool)
	{49, 378, 66, 1, 0, 0, 8},	//576 KTextEditor::SmartCursorWatcher::deleted(KTextEditor::SmartCursor*)
	{49, 142, 382, 1, Smoke::mf_copyctor|Smoke::mf_internal|Smoke::mf_ctor, 147, 9},	//577 KTextEditor::SmartCursorWatcher::SmartCursorWatcher(const KTextEditor::SmartCursorWatcher&)
	{50, 144, 0, 0, Smoke::mf_ctor, 148, 1},	//578 KTextEditor::SmartInterface::SmartInterface()
	{50, 1069, 0, 0, Smoke::mf_dtor, 0, 47},	//579 KTextEditor::SmartInterface::~SmartInterface()
	{50, 946, 0, 0, Smoke::mf_const, 290, 2},	//580 KTextEditor::SmartInterface::smartMutex() const
	{50, 272, 0, 0, 0, 0, 3},	//581 KTextEditor::SmartInterface::clearSmartInterface() [pure virtual]
	{50, 270, 0, 0, Smoke::mf_const, 480, 4},	//582 KTextEditor::SmartInterface::clearOnDocumentReload() const
	{50, 822, 245, 1, 0, 0, 5},	//583 KTextEditor::SmartInterface::setClearOnDocumentReload(bool)
	{50, 346, 0, 0, Smoke::mf_const, 554, 6},	//584 KTextEditor::SmartInterface::currentRevision() const [pure virtual]
	{50, 741, 479, 1, Smoke::mf_const, 0, 7},	//585 KTextEditor::SmartInterface::releaseRevision(int) const [pure virtual]
	{50, 1001, 479, 1, 0, 0, 8},	//586 KTextEditor::SmartInterface::useRevision(int) [pure virtual]
	{50, 271, 0, 0, 0, 0, 9},	//587 KTextEditor::SmartInterface::clearRevision()
	{50, 991, 278, 2, Smoke::mf_const, 119, 10},	//588 KTextEditor::SmartInterface::translateFromRevision(const KTextEditor::Cursor&, KTextEditor::SmartCursor::InsertBehavior) const
	{50, 991, 272, 1, Smoke::mf_const, 119, 11},	//589 KTextEditor::SmartInterface::translateFromRevision(const KTextEditor::Cursor&) const
	{50, 991, 352, 2, Smoke::mf_const, 135, 12},	//590 KTextEditor::SmartInterface::translateFromRevision(const KTextEditor::Range&, KTextEditor::SmartRange::InsertBehaviors) const
	{50, 991, 340, 1, Smoke::mf_const, 135, 13},	//591 KTextEditor::SmartInterface::translateFromRevision(const KTextEditor::Range&) const
	{50, 648, 278, 2, 0, 143, 14},	//592 KTextEditor::SmartInterface::newSmartCursor(const KTextEditor::Cursor&, KTextEditor::SmartCursor::InsertBehavior) [pure virtual]
	{50, 648, 272, 1, 0, 143, -1},	//593 KTextEditor::SmartInterface::newSmartCursor(const KTextEditor::Cursor&) [pure virtual]
	{50, 648, 0, 0, 0, 143, -1},	//594 KTextEditor::SmartInterface::newSmartCursor() [pure virtual]
	{50, 648, 518, 3, 0, 143, 15},	//595 KTextEditor::SmartInterface::newSmartCursor(int, int, KTextEditor::SmartCursor::InsertBehavior)
	{50, 648, 515, 2, 0, 143, 16},	//596 KTextEditor::SmartInterface::newSmartCursor(int, int)
	{50, 374, 0, 0, 0, 0, 17},	//597 KTextEditor::SmartInterface::deleteCursors() [pure virtual]
	{50, 653, 348, 3, 0, 150, 18},	//598 KTextEditor::SmartInterface::newSmartRange(const KTextEditor::Range&, KTextEditor::SmartRange*, KTextEditor::SmartRange::InsertBehaviors) [pure virtual]
	{50, 653, 345, 2, 0, 150, -1},	//599 KTextEditor::SmartInterface::newSmartRange(const KTextEditor::Range&, KTextEditor::SmartRange*) [pure virtual]
	{50, 653, 340, 1, 0, 150, -1},	//600 KTextEditor::SmartInterface::newSmartRange(const KTextEditor::Range&) [pure virtual]
	{50, 653, 0, 0, 0, 150, -1},	//601 KTextEditor::SmartInterface::newSmartRange() [pure virtual]
	{50, 653, 298, 4, 0, 150, 19},	//602 KTextEditor::SmartInterface::newSmartRange(const KTextEditor::Cursor&, const KTextEditor::Cursor&, KTextEditor::SmartRange*, KTextEditor::SmartRange::InsertBehaviors)
	{50, 653, 294, 3, 0, 150, 20},	//603 KTextEditor::SmartInterface::newSmartRange(const KTextEditor::Cursor&, const KTextEditor::Cursor&, KTextEditor::SmartRange*)
	{50, 653, 291, 2, 0, 150, 21},	//604 KTextEditor::SmartInterface::newSmartRange(const KTextEditor::Cursor&, const KTextEditor::Cursor&)
	{50, 653, 537, 6, 0, 150, 22},	//605 KTextEditor::SmartInterface::newSmartRange(int, int, int, int, KTextEditor::SmartRange*, KTextEditor::SmartRange::InsertBehaviors)
	{50, 653, 531, 5, 0, 150, 23},	//606 KTextEditor::SmartInterface::newSmartRange(int, int, int, int, KTextEditor::SmartRange*)
	{50, 653, 526, 4, 0, 150, 24},	//607 KTextEditor::SmartInterface::newSmartRange(int, int, int, int)
	{50, 653, 75, 4, 0, 150, 25},	//608 KTextEditor::SmartInterface::newSmartRange(KTextEditor::SmartCursor*, KTextEditor::SmartCursor*, KTextEditor::SmartRange*, KTextEditor::SmartRange::InsertBehaviors) [pure virtual]
	{50, 653, 71, 3, 0, 150, -1},	//609 KTextEditor::SmartInterface::newSmartRange(KTextEditor::SmartCursor*, KTextEditor::SmartCursor*, KTextEditor::SmartRange*) [pure virtual]
	{50, 653, 68, 2, 0, 150, -1},	//610 KTextEditor::SmartInterface::newSmartRange(KTextEditor::SmartCursor*, KTextEditor::SmartCursor*) [pure virtual]
	{50, 995, 87, 1, 0, 0, 26},	//611 KTextEditor::SmartInterface::unbindSmartRange(KTextEditor::SmartRange*) [pure virtual]
	{50, 377, 0, 0, 0, 0, 27},	//612 KTextEditor::SmartInterface::deleteRanges() [pure virtual]
	{50, 189, 99, 2, 0, 0, 28},	//613 KTextEditor::SmartInterface::addHighlightToDocument(KTextEditor::SmartRange*, bool) [pure virtual]
	{50, 189, 87, 1, 0, 0, -1},	//614 KTextEditor::SmartInterface::addHighlightToDocument(KTextEditor::SmartRange*) [pure virtual]
	{50, 752, 87, 1, 0, 0, 29},	//615 KTextEditor::SmartInterface::removeHighlightFromDocument(KTextEditor::SmartRange*) [pure virtual]
	{50, 392, 0, 0, Smoke::mf_const, 522, 30},	//616 KTextEditor::SmartInterface::documentHighlights() const [pure virtual]
	{50, 266, 0, 0, 0, 0, 31},	//617 KTextEditor::SmartInterface::clearDocumentHighlights() [pure virtual]
	{50, 192, 117, 3, 0, 0, 32},	//618 KTextEditor::SmartInterface::addHighlightToView(KTextEditor::View*, KTextEditor::SmartRange*, bool) [pure virtual]
	{50, 192, 114, 2, 0, 0, -1},	//619 KTextEditor::SmartInterface::addHighlightToView(KTextEditor::View*, KTextEditor::SmartRange*) [pure virtual]
	{50, 754, 114, 2, 0, 0, 33},	//620 KTextEditor::SmartInterface::removeHighlightFromView(KTextEditor::View*, KTextEditor::SmartRange*) [pure virtual]
	{50, 1016, 112, 1, Smoke::mf_const, 522, 34},	//621 KTextEditor::SmartInterface::viewHighlights(KTextEditor::View*) const [pure virtual]
	{50, 275, 112, 1, 0, 0, 35},	//622 KTextEditor::SmartInterface::clearViewHighlights(KTextEditor::View*) [pure virtual]
	{50, 183, 87, 1, 0, 0, 36},	//623 KTextEditor::SmartInterface::addActionsToDocument(KTextEditor::SmartRange*) [pure virtual]
	{50, 743, 87, 1, 0, 0, 37},	//624 KTextEditor::SmartInterface::removeActionsFromDocument(KTextEditor::SmartRange*) [pure virtual]
	{50, 388, 0, 0, Smoke::mf_const, 522, 38},	//625 KTextEditor::SmartInterface::documentActions() const [pure virtual]
	{50, 265, 0, 0, 0, 0, 39},	//626 KTextEditor::SmartInterface::clearDocumentActions() [pure virtual]
	{50, 185, 114, 2, 0, 0, 40},	//627 KTextEditor::SmartInterface::addActionsToView(KTextEditor::View*, KTextEditor::SmartRange*) [pure virtual]
	{50, 745, 114, 2, 0, 0, 41},	//628 KTextEditor::SmartInterface::removeActionsFromView(KTextEditor::View*, KTextEditor::SmartRange*) [pure virtual]
	{50, 1009, 112, 1, Smoke::mf_const, 522, 42},	//629 KTextEditor::SmartInterface::viewActions(KTextEditor::View*) const [pure virtual]
	{50, 273, 112, 1, 0, 0, 43},	//630 KTextEditor::SmartInterface::clearViewActions(KTextEditor::View*) [pure virtual]
	{50, 144, 384, 1, Smoke::mf_copyctor|Smoke::mf_internal|Smoke::mf_ctor, 148, 44},	//631 KTextEditor::SmartInterface::SmartInterface(const KTextEditor::SmartInterface&)
	{50, 222, 563, 1, Smoke::mf_protected, 0, 45},	//632 KTextEditor::SmartInterface::attributeDynamic(KSharedPtr<KTextEditor::Attribute>) [pure virtual]
	{50, 224, 563, 1, Smoke::mf_protected, 0, 46},	//633 KTextEditor::SmartInterface::attributeNotDynamic(KSharedPtr<KTextEditor::Attribute>) [pure virtual]
	{51, 54, 0, 0, Smoke::mf_static|Smoke::mf_enum, 151, 1},	//634 KTextEditor::SmartRange::DoNotExpand (enum)
	{51, 71, 0, 0, Smoke::mf_static|Smoke::mf_enum, 151, 2},	//635 KTextEditor::SmartRange::ExpandLeft (enum)
	{51, 72, 0, 0, Smoke::mf_static|Smoke::mf_enum, 151, 3},	//636 KTextEditor::SmartRange::ExpandRight (enum)
	{51, 1070, 0, 0, Smoke::mf_dtor, 0, 61},	//637 KTextEditor::SmartRange::~SmartRange()
	{51, 543, 0, 0, Smoke::mf_const, 480, 4},	//638 KTextEditor::SmartRange::isSmartRange() const
	{51, 988, 0, 0, Smoke::mf_const, 150, 5},	//639 KTextEditor::SmartRange::toSmartRange() const
	{51, 897, 340, 1, 0, 0, 6},	//640 KTextEditor::SmartRange::setRange(const KTextEditor::Range&)
	{51, 948, 0, 0, 0, 142, 7},	//641 KTextEditor::SmartRange::smartStart()
	{51, 945, 0, 0, 0, 142, 8},	//642 KTextEditor::SmartRange::smartEnd()
	{51, 312, 340, 1, 0, 480, 9},	//643 KTextEditor::SmartRange::confineToRange(const KTextEditor::Range&)
	{51, 448, 340, 1, 0, 480, 10},	//644 KTextEditor::SmartRange::expandToRange(const KTextEditor::Range&)
	{51, 387, 0, 0, Smoke::mf_const, 122, 11},	//645 KTextEditor::SmartRange::document() const
	{51, 970, 245, 1, Smoke::mf_const, 328, 12},	//646 KTextEditor::SmartRange::text(bool) const
	{51, 970, 0, 0, Smoke::mf_const, 328, 13},	//647 KTextEditor::SmartRange::text() const
	{51, 775, 468, 2, 0, 480, 14},	//648 KTextEditor::SmartRange::replaceText(const QStringList&, bool)
	{51, 775, 466, 1, 0, 480, 15},	//649 KTextEditor::SmartRange::replaceText(const QStringList&)
	{51, 767, 245, 1, 0, 480, 16},	//650 KTextEditor::SmartRange::removeText(bool)
	{51, 767, 0, 0, 0, 480, 17},	//651 KTextEditor::SmartRange::removeText()
	{51, 511, 0, 0, Smoke::mf_const, 152, 18},	//652 KTextEditor::SmartRange::insertBehavior() const
	{51, 860, 106, 1, 0, 0, 19},	//653 KTextEditor::SmartRange::setInsertBehavior(KTextEditor::SmartRange::InsertBehaviors)
	{51, 690, 0, 0, Smoke::mf_const, 150, 20},	//654 KTextEditor::SmartRange::parentRange() const
	{51, 892, 87, 1, 0, 0, 21},	//655 KTextEditor::SmartRange::setParentRange(KTextEditor::SmartRange*)
	{51, 481, 87, 1, Smoke::mf_const, 480, 22},	//656 KTextEditor::SmartRange::hasParent(KTextEditor::SmartRange*) const
	{51, 380, 0, 0, Smoke::mf_const, 554, 23},	//657 KTextEditor::SmartRange::depth() const
	{51, 989, 0, 0, Smoke::mf_const, 150, 24},	//658 KTextEditor::SmartRange::topParentRange() const
	{51, 260, 0, 0, Smoke::mf_const, 523, 25},	//659 KTextEditor::SmartRange::childRanges() const
	{51, 264, 0, 0, 0, 0, 26},	//660 KTextEditor::SmartRange::clearChildRanges()
	{51, 373, 0, 0, 0, 0, 27},	//661 KTextEditor::SmartRange::deleteChildRanges()
	{51, 262, 0, 0, 0, 0, 28},	//662 KTextEditor::SmartRange::clearAndDeleteChildRanges()
	{51, 252, 388, 1, Smoke::mf_const, 150, 29},	//663 KTextEditor::SmartRange::childBefore(const KTextEditor::SmartRange*) const
	{51, 250, 388, 1, Smoke::mf_const, 150, 30},	//664 KTextEditor::SmartRange::childAfter(const KTextEditor::SmartRange*) const
	{51, 627, 340, 1, Smoke::mf_const, 150, 31},	//665 KTextEditor::SmartRange::mostSpecificRange(const KTextEditor::Range&) const
	{51, 452, 272, 1, Smoke::mf_const, 150, 32},	//666 KTextEditor::SmartRange::firstRangeContaining(const KTextEditor::Cursor&) const
	{51, 364, 284, 3, Smoke::mf_const, 150, 33},	//667 KTextEditor::SmartRange::deepestRangeContaining(const KTextEditor::Cursor&, QStack<KTextEditor::SmartRange*>*, QStack<KTextEditor::SmartRange*>*) const
	{51, 364, 281, 2, Smoke::mf_const, 150, 34},	//668 KTextEditor::SmartRange::deepestRangeContaining(const KTextEditor::Cursor&, QStack<KTextEditor::SmartRange*>*) const
	{51, 364, 272, 1, Smoke::mf_const, 150, 35},	//669 KTextEditor::SmartRange::deepestRangeContaining(const KTextEditor::Cursor&) const
	{51, 368, 272, 1, Smoke::mf_const, 270, 36},	//670 KTextEditor::SmartRange::deepestRangesContaining(const KTextEditor::Cursor&) const
	{51, 676, 0, 0, Smoke::mf_const, 554, 37},	//671 KTextEditor::SmartRange::overlapCount() const
	{51, 221, 0, 0, Smoke::mf_const, 83, 38},	//672 KTextEditor::SmartRange::attribute() const
	{51, 810, 563, 1, 0, 0, 39},	//673 KTextEditor::SmartRange::setAttribute(KSharedPtr<KTextEditor::Attribute>)
	{51, 214, 1, 1, 0, 0, 40},	//674 KTextEditor::SmartRange::associateAction(KAction*)
	{51, 385, 1, 1, 0, 0, 41},	//675 KTextEditor::SmartRange::dissociateAction(KAction*)
	{51, 216, 0, 0, Smoke::mf_const, 520, 42},	//676 KTextEditor::SmartRange::associatedActions() const
	{51, 263, 0, 0, 0, 0, 43},	//677 KTextEditor::SmartRange::clearAssociatedActions()
	{51, 708, 0, 0, 0, 154, 44},	//678 KTextEditor::SmartRange::primaryNotifier()
	{51, 663, 0, 0, Smoke::mf_const, 524, 45},	//679 KTextEditor::SmartRange::notifiers() const
	{51, 197, 108, 1, 0, 0, 46},	//680 KTextEditor::SmartRange::addNotifier(KTextEditor::SmartRangeNotifier*)
	{51, 760, 108, 1, 0, 0, 47},	//681 KTextEditor::SmartRange::removeNotifier(KTextEditor::SmartRangeNotifier*)
	{51, 376, 0, 0, 0, 0, 48},	//682 KTextEditor::SmartRange::deletePrimaryNotifier()
	{51, 1027, 0, 0, Smoke::mf_const, 525, 49},	//683 KTextEditor::SmartRange::watchers() const
	{51, 201, 110, 1, 0, 0, 50},	//684 KTextEditor::SmartRange::addWatcher(KTextEditor::SmartRangeWatcher*)
	{51, 773, 110, 1, 0, 0, 51},	//685 KTextEditor::SmartRange::removeWatcher(KTextEditor::SmartRangeWatcher*)
	{51, 673, 386, 1, 0, 149, 52},	//686 KTextEditor::SmartRange::operator=(const KTextEditor::SmartRange&)
	{51, 673, 340, 1, 0, 149, 53},	//687 KTextEditor::SmartRange::operator=(const KTextEditor::Range&)
	{51, 146, 75, 4, Smoke::mf_ctor|Smoke::mf_protected, 150, 54},	//688 KTextEditor::SmartRange::SmartRange(KTextEditor::SmartCursor*, KTextEditor::SmartCursor*, KTextEditor::SmartRange*, KTextEditor::SmartRange::InsertBehaviors)
	{51, 146, 71, 3, Smoke::mf_ctor|Smoke::mf_protected, 150, 55},	//689 KTextEditor::SmartRange::SmartRange(KTextEditor::SmartCursor*, KTextEditor::SmartCursor*, KTextEditor::SmartRange*)
	{51, 146, 68, 2, Smoke::mf_ctor|Smoke::mf_protected, 150, 56},	//690 KTextEditor::SmartRange::SmartRange(KTextEditor::SmartCursor*, KTextEditor::SmartCursor*)
	{51, 719, 15, 2, Smoke::mf_protected, 0, 57},	//691 KTextEditor::SmartRange::rangeChanged(KTextEditor::Cursor*, const KTextEditor::Range&)
	{51, 249, 0, 0, Smoke::mf_protected, 0, 58},	//692 KTextEditor::SmartRange::checkFeedback()
	{51, 332, 0, 0, Smoke::mf_protected, 154, 59},	//693 KTextEditor::SmartRange::createNotifier() [pure virtual]
	{51, 736, 0, 0, Smoke::mf_protected, 0, 60},	//694 KTextEditor::SmartRange::rebuildChildStructure()
	{52, 609, 0, 0, Smoke::mf_const, 532, 2},	//695 KTextEditor::SmartRangeNotifier::metaObject() const
	{52, 711, 188, 3, 0, 554, 3},	//696 KTextEditor::SmartRangeNotifier::qt_metacall(QMetaObject::Call, int, void**)
	{52, 150, 0, 0, Smoke::mf_ctor, 154, 4},	//697 KTextEditor::SmartRangeNotifier::SmartRangeNotifier()
	{52, 1023, 0, 0, Smoke::mf_const, 480, 5},	//698 KTextEditor::SmartRangeNotifier::wantsDirectChanges() const
	{52, 925, 245, 1, 0, 0, 6},	//699 KTextEditor::SmartRangeNotifier::setWantsDirectChanges(bool)
	{52, 1071, 0, 0, Smoke::mf_dtor, 0, 20},	//700 KTextEditor::SmartRangeNotifier::~SmartRangeNotifier()
	{52, 728, 87, 1, 0, 0, 7},	//701 KTextEditor::SmartRangeNotifier::rangePositionChanged(KTextEditor::SmartRange*)
	{52, 721, 87, 1, 0, 0, 8},	//702 KTextEditor::SmartRangeNotifier::rangeContentsChanged(KTextEditor::SmartRange*)
	{52, 721, 89, 2, 0, 0, 9},	//703 KTextEditor::SmartRangeNotifier::rangeContentsChanged(KTextEditor::SmartRange*, KTextEditor::SmartRange*)
	{52, 631, 96, 2, 0, 0, 10},	//704 KTextEditor::SmartRangeNotifier::mouseEnteredRange(KTextEditor::SmartRange*, KTextEditor::View*)
	{52, 633, 96, 2, 0, 0, 11},	//705 KTextEditor::SmartRangeNotifier::mouseExitedRange(KTextEditor::SmartRange*, KTextEditor::View*)
	{52, 236, 96, 2, 0, 0, 12},	//706 KTextEditor::SmartRangeNotifier::caretEnteredRange(KTextEditor::SmartRange*, KTextEditor::View*)
	{52, 238, 96, 2, 0, 0, 13},	//707 KTextEditor::SmartRangeNotifier::caretExitedRange(KTextEditor::SmartRange*, KTextEditor::View*)
	{52, 726, 87, 1, 0, 0, 14},	//708 KTextEditor::SmartRangeNotifier::rangeEliminated(KTextEditor::SmartRange*)
	{52, 724, 87, 1, 0, 0, 15},	//709 KTextEditor::SmartRangeNotifier::rangeDeleted(KTextEditor::SmartRange*)
	{52, 691, 92, 3, 0, 0, 16},	//710 KTextEditor::SmartRangeNotifier::parentRangeChanged(KTextEditor::SmartRange*, KTextEditor::SmartRange*, KTextEditor::SmartRange*)
	{52, 256, 89, 2, 0, 0, 17},	//711 KTextEditor::SmartRangeNotifier::childRangeInserted(KTextEditor::SmartRange*, KTextEditor::SmartRange*)
	{52, 258, 89, 2, 0, 0, 18},	//712 KTextEditor::SmartRangeNotifier::childRangeRemoved(KTextEditor::SmartRange*, KTextEditor::SmartRange*)
	{52, 717, 102, 3, 0, 0, 19},	//713 KTextEditor::SmartRangeNotifier::rangeAttributeChanged(KTextEditor::SmartRange*, KSharedPtr<KTextEditor::Attribute>, KSharedPtr<KTextEditor::Attribute>)
	{52, 961, 0, 0, Smoke::mf_static, 531, 1},	//714 KTextEditor::SmartRangeNotifier::staticMetaObject (static var)
	{53, 151, 0, 0, Smoke::mf_ctor, 155, 1},	//715 KTextEditor::SmartRangeWatcher::SmartRangeWatcher()
	{53, 1072, 0, 0, Smoke::mf_dtor, 0, 18},	//716 KTextEditor::SmartRangeWatcher::~SmartRangeWatcher()
	{53, 1023, 0, 0, Smoke::mf_const, 480, 2},	//717 KTextEditor::SmartRangeWatcher::wantsDirectChanges() const
	{53, 925, 245, 1, 0, 0, 3},	//718 KTextEditor::SmartRangeWatcher::setWantsDirectChanges(bool)
	{53, 728, 87, 1, 0, 0, 4},	//719 KTextEditor::SmartRangeWatcher::rangePositionChanged(KTextEditor::SmartRange*)
	{53, 721, 87, 1, 0, 0, 5},	//720 KTextEditor::SmartRangeWatcher::rangeContentsChanged(KTextEditor::SmartRange*)
	{53, 721, 89, 2, 0, 0, 6},	//721 KTextEditor::SmartRangeWatcher::rangeContentsChanged(KTextEditor::SmartRange*, KTextEditor::SmartRange*)
	{53, 631, 96, 2, 0, 0, 7},	//722 KTextEditor::SmartRangeWatcher::mouseEnteredRange(KTextEditor::SmartRange*, KTextEditor::View*)
	{53, 633, 96, 2, 0, 0, 8},	//723 KTextEditor::SmartRangeWatcher::mouseExitedRange(KTextEditor::SmartRange*, KTextEditor::View*)
	{53, 236, 96, 2, 0, 0, 9},	//724 KTextEditor::SmartRangeWatcher::caretEnteredRange(KTextEditor::SmartRange*, KTextEditor::View*)
	{53, 238, 96, 2, 0, 0, 10},	//725 KTextEditor::SmartRangeWatcher::caretExitedRange(KTextEditor::SmartRange*, KTextEditor::View*)
	{53, 726, 87, 1, 0, 0, 11},	//726 KTextEditor::SmartRangeWatcher::rangeEliminated(KTextEditor::SmartRange*)
	{53, 724, 87, 1, 0, 0, 12},	//727 KTextEditor::SmartRangeWatcher::rangeDeleted(KTextEditor::SmartRange*)
	{53, 691, 92, 3, 0, 0, 13},	//728 KTextEditor::SmartRangeWatcher::parentRangeChanged(KTextEditor::SmartRange*, KTextEditor::SmartRange*, KTextEditor::SmartRange*)
	{53, 256, 89, 2, 0, 0, 14},	//729 KTextEditor::SmartRangeWatcher::childRangeInserted(KTextEditor::SmartRange*, KTextEditor::SmartRange*)
	{53, 258, 89, 2, 0, 0, 15},	//730 KTextEditor::SmartRangeWatcher::childRangeRemoved(KTextEditor::SmartRange*, KTextEditor::SmartRange*)
	{53, 717, 102, 3, 0, 0, 16},	//731 KTextEditor::SmartRangeWatcher::rangeAttributeChanged(KTextEditor::SmartRange*, KSharedPtr<KTextEditor::Attribute>, KSharedPtr<KTextEditor::Attribute>)
	{53, 151, 390, 1, Smoke::mf_copyctor|Smoke::mf_internal|Smoke::mf_ctor, 155, 17},	//732 KTextEditor::SmartRangeWatcher::SmartRangeWatcher(const KTextEditor::SmartRangeWatcher&)
	{54, 157, 0, 0, Smoke::mf_ctor, 156, 1},	//733 KTextEditor::TemplateInterface::TemplateInterface()
	{54, 1073, 0, 0, Smoke::mf_dtor, 0, 6},	//734 KTextEditor::TemplateInterface::~TemplateInterface()
	{54, 522, 310, 3, 0, 480, 2},	//735 KTextEditor::TemplateInterface::insertTemplateText(const KTextEditor::Cursor&, const QString&, const QMap<QString,QString>&)
	{54, 157, 392, 1, Smoke::mf_copyctor|Smoke::mf_internal|Smoke::mf_ctor, 156, 3},	//736 KTextEditor::TemplateInterface::TemplateInterface(const KTextEditor::TemplateInterface&)
	{54, 446, 183, 2, Smoke::mf_static, 480, 4},	//737 KTextEditor::TemplateInterface::expandMacros(QMap<QString,QString>&, QWidget*)
	{54, 524, 310, 3, Smoke::mf_protected, 480, 5},	//738 KTextEditor::TemplateInterface::insertTemplateTextImplementation(const KTextEditor::Cursor&, const QString&, const QMap<QString,QString>&) [pure virtual]
	{55, 159, 0, 0, Smoke::mf_ctor, 157, 1},	//739 KTextEditor::TextHintInterface::TextHintInterface()
	{55, 1074, 0, 0, Smoke::mf_dtor, 0, 6},	//740 KTextEditor::TextHintInterface::~TextHintInterface()
	{55, 425, 479, 1, 0, 0, 2},	//741 KTextEditor::TextHintInterface::enableTextHints(int) [pure virtual]
	{55, 382, 0, 0, 0, 0, 3},	//742 KTextEditor::TextHintInterface::disableTextHints() [pure virtual]
	{55, 646, 288, 2, 0, 0, 4},	//743 KTextEditor::TextHintInterface::needTextHint(const KTextEditor::Cursor&, QString&) [pure virtual]
	{55, 159, 394, 1, Smoke::mf_copyctor|Smoke::mf_internal|Smoke::mf_ctor, 157, 5},	//744 KTextEditor::TextHintInterface::TextHintInterface(const KTextEditor::TextHintInterface&)
	{56, 165, 0, 0, Smoke::mf_ctor, 158, 1},	//745 KTextEditor::VariableInterface::VariableInterface()
	{56, 1075, 0, 0, Smoke::mf_dtor, 0, 5},	//746 KTextEditor::VariableInterface::~VariableInterface()
	{56, 1003, 451, 1, Smoke::mf_const, 324, 2},	//747 KTextEditor::VariableInterface::variable(const QString&) const [pure virtual]
	{56, 1005, 45, 3, 0, 0, 3},	//748 KTextEditor::VariableInterface::variableChanged(KTextEditor::Document*, const QString&, const QString&) [pure virtual]
	{56, 165, 396, 1, Smoke::mf_copyctor|Smoke::mf_internal|Smoke::mf_ctor, 158, 4},	//749 KTextEditor::VariableInterface::VariableInterface(const KTextEditor::VariableInterface&)
	{57, 57, 0, 0, Smoke::mf_static|Smoke::mf_enum, 160, 1},	//750 KTextEditor::View::EditInsert (enum)
	{57, 58, 0, 0, Smoke::mf_static|Smoke::mf_enum, 160, 2},	//751 KTextEditor::View::EditOverwrite (enum)
	{57, 609, 0, 0, Smoke::mf_const, 532, 4},	//752 KTextEditor::View::metaObject() const
	{57, 711, 188, 3, 0, 554, 5},	//753 KTextEditor::View::qt_metacall(QMetaObject::Call, int, void**)
	{57, 167, 226, 1, Smoke::mf_ctor, 159, 6},	//754 KTextEditor::View::View(QWidget*)
	{57, 1076, 0, 0, Smoke::mf_dtor, 0, 44},	//755 KTextEditor::View::~View()
	{57, 387, 0, 0, Smoke::mf_const, 122, 7},	//756 KTextEditor::View::document() const [pure virtual]
	{57, 537, 0, 0, Smoke::mf_const, 480, 8},	//757 KTextEditor::View::isActiveView() const
	{57, 1018, 0, 0, Smoke::mf_const, 324, 9},	//758 KTextEditor::View::viewMode() const [pure virtual]
	{57, 1013, 0, 0, Smoke::mf_const, 553, 10},	//759 KTextEditor::View::viewEditMode() const [pure virtual]
	{57, 833, 186, 1, 0, 0, 11},	//760 KTextEditor::View::setContextMenu(QMenu*) [pure virtual]
	{57, 323, 0, 0, Smoke::mf_const, 282, 12},	//761 KTextEditor::View::contextMenu() const [pure virtual]
	{57, 370, 186, 1, Smoke::mf_const, 282, 13},	//762 KTextEditor::View::defaultContextMenu(QMenu*) const [pure virtual]
	{57, 370, 0, 0, Smoke::mf_const, 282, -1},	//763 KTextEditor::View::defaultContextMenu() const [pure virtual]
	{57, 835, 10, 1, 0, 480, 14},	//764 KTextEditor::View::setCursorPosition(KTextEditor::Cursor) [pure virtual]
	{57, 351, 0, 0, Smoke::mf_const, 119, 15},	//765 KTextEditor::View::cursorPosition() const [pure virtual]
	{57, 355, 0, 0, Smoke::mf_const, 119, 16},	//766 KTextEditor::View::cursorPositionVirtual() const [pure virtual]
	{57, 356, 272, 1, Smoke::mf_const, 315, 17},	//767 KTextEditor::View::cursorToCoordinate(const KTextEditor::Cursor&) const [pure virtual]
	{57, 354, 0, 0, Smoke::mf_const, 315, 18},	//768 KTextEditor::View::cursorPositionCoordinates() const [pure virtual]
	{57, 643, 0, 0, Smoke::mf_const, 480, 19},	//769 KTextEditor::View::mouseTrackingEnabled() const [pure virtual]
	{57, 884, 245, 1, 0, 480, 20},	//770 KTextEditor::View::setMouseTrackingEnabled(bool) [pure virtual]
	{57, 910, 340, 1, 0, 480, 21},	//771 KTextEditor::View::setSelection(const KTextEditor::Range&) [pure virtual]
	{57, 910, 324, 3, 0, 480, 22},	//772 KTextEditor::View::setSelection(const KTextEditor::Cursor&, int, bool)
	{57, 910, 321, 2, 0, 480, 23},	//773 KTextEditor::View::setSelection(const KTextEditor::Cursor&, int)
	{57, 799, 0, 0, Smoke::mf_const, 480, 24},	//774 KTextEditor::View::selection() const [pure virtual]
	{57, 802, 0, 0, Smoke::mf_const, 498, 25},	//775 KTextEditor::View::selectionRange() const [pure virtual]
	{57, 803, 0, 0, Smoke::mf_const, 324, 26},	//776 KTextEditor::View::selectionText() const [pure virtual]
	{57, 765, 0, 0, 0, 480, 27},	//777 KTextEditor::View::removeSelection() [pure virtual]
	{57, 766, 0, 0, 0, 480, 28},	//778 KTextEditor::View::removeSelectionText() [pure virtual]
	{57, 816, 245, 1, 0, 480, 29},	//779 KTextEditor::View::setBlockSelection(bool) [pure virtual]
	{57, 227, 0, 0, Smoke::mf_const, 480, 30},	//780 KTextEditor::View::blockSelection() const [pure virtual]
	{57, 526, 451, 1, 0, 480, 31},	//781 KTextEditor::View::insertText(const QString&)
	{57, 458, 112, 1, 0, 0, 32},	//782 KTextEditor::View::focusIn(KTextEditor::View*)
	{57, 464, 112, 1, 0, 0, 33},	//783 KTextEditor::View::focusOut(KTextEditor::View*)
	{57, 1019, 112, 1, 0, 0, 34},	//784 KTextEditor::View::viewModeChanged(KTextEditor::View*)
	{57, 1014, 121, 2, 0, 0, 35},	//785 KTextEditor::View::viewEditModeChanged(KTextEditor::View*, KTextEditor::View::EditMode)
	{57, 505, 145, 2, 0, 0, 36},	//786 KTextEditor::View::informationMessage(KTextEditor::View*, const QString&)
	{57, 977, 137, 3, 0, 0, 37},	//787 KTextEditor::View::textInserted(KTextEditor::View*, const KTextEditor::Cursor&, const QString&)
	{57, 324, 124, 2, 0, 0, 38},	//788 KTextEditor::View::contextMenuAboutToShow(KTextEditor::View*, QMenu*)
	{57, 352, 134, 2, 0, 0, 39},	//789 KTextEditor::View::cursorPositionChanged(KTextEditor::View*, const KTextEditor::Cursor&)
	{57, 1007, 134, 2, 0, 0, 40},	//790 KTextEditor::View::verticalScrollPositionChanged(KTextEditor::View*, const KTextEditor::Cursor&)
	{57, 500, 112, 1, 0, 0, 41},	//791 KTextEditor::View::horizontalScrollPositionChanged(KTextEditor::View*)
	{57, 637, 134, 2, 0, 0, 42},	//792 KTextEditor::View::mousePositionChanged(KTextEditor::View*, const KTextEditor::Cursor&)
	{57, 800, 112, 1, 0, 0, 43},	//793 KTextEditor::View::selectionChanged(KTextEditor::View*)
	{57, 961, 0, 0, Smoke::mf_static, 531, 3},	//794 KTextEditor::View::staticMetaObject (static var)
	{59, 177, 407, 1, Smoke::mf_const, 196, 6},	//795 KXMLGUIClient::action(const QDomElement&) const
	{59, 179, 0, 0, Smoke::mf_const, 4, 7},	//796 KXMLGUIClient::actionCollection() const
	{59, 296, 0, 0, Smoke::mf_const, 12, 8},	//797 KXMLGUIClient::componentData() const
	{59, 405, 0, 0, Smoke::mf_const, 228, 9},	//798 KXMLGUIClient::domDocument() const
	{59, 1039, 0, 0, Smoke::mf_const, 324, 10},	//799 KXMLGUIClient::xmlFile() const
	{59, 561, 0, 0, Smoke::mf_const, 324, 11},	//800 KXMLGUIClient::localXMLFile() const
	{59, 826, 247, 1, Smoke::mf_protected, 0, 33},	//801 KXMLGUIClient::setComponentData(const KComponentData&)
	{59, 934, 459, 3, Smoke::mf_protected, 0, 34},	//802 KXMLGUIClient::setXMLFile(const QString&, bool, bool)
	{59, 934, 456, 2, Smoke::mf_protected, 0, 35},	//803 KXMLGUIClient::setXMLFile(const QString&, bool)
	{59, 934, 451, 1, Smoke::mf_protected, 0, 36},	//804 KXMLGUIClient::setXMLFile(const QString&)
	{59, 866, 451, 1, Smoke::mf_protected, 0, 37},	//805 KXMLGUIClient::setLocalXMLFile(const QString&)
	{59, 931, 456, 2, Smoke::mf_protected, 0, 38},	//806 KXMLGUIClient::setXML(const QString&, bool)
	{59, 931, 451, 1, Smoke::mf_protected, 0, 39},	//807 KXMLGUIClient::setXML(const QString&)
	{59, 837, 404, 2, Smoke::mf_protected, 0, 40},	//808 KXMLGUIClient::setDOMDocument(const QDomDocument&, bool)
	{59, 837, 402, 1, Smoke::mf_protected, 0, 41},	//809 KXMLGUIClient::setDOMDocument(const QDomDocument&)
	{59, 958, 453, 2, Smoke::mf_protected, 0, 42},	//810 KXMLGUIClient::stateChanged(const QString&, KXMLGUIClient::ReverseStateChange)
	{59, 958, 451, 1, Smoke::mf_protected, 0, 43},	//811 KXMLGUIClient::stateChanged(const QString&)
	{60, 609, 0, 0, Smoke::mf_const, 532, 2},	//812 QAbstractItemModel::metaObject() const
	{60, 711, 188, 3, 0, 554, 3},	//813 QAbstractItemModel::qt_metacall(QMetaObject::Call, int, void**)
	{60, 502, 522, 3, Smoke::mf_const, 287, 8},	//814 QAbstractItemModel::index(int, int, const QModelIndex&) const [pure virtual]
	{60, 502, 515, 2, Smoke::mf_const, 287, -1},	//815 QAbstractItemModel::index(int, int) const [pure virtual]
	{60, 688, 419, 1, Smoke::mf_const, 287, 9},	//816 QAbstractItemModel::parent(const QModelIndex&) const [pure virtual]
	{60, 787, 419, 1, Smoke::mf_const, 554, 11},	//817 QAbstractItemModel::rowCount(const QModelIndex&) const [pure virtual]
	{60, 787, 0, 0, Smoke::mf_const, 554, -1},	//818 QAbstractItemModel::rowCount() const [pure virtual]
	{60, 287, 419, 1, Smoke::mf_const, 554, 12},	//819 QAbstractItemModel::columnCount(const QModelIndex&) const [pure virtual]
	{60, 287, 0, 0, Smoke::mf_const, 554, -1},	//820 QAbstractItemModel::columnCount() const [pure virtual]
	{60, 475, 419, 1, Smoke::mf_const, 480, 13},	//821 QAbstractItemModel::hasChildren(const QModelIndex&) const
	{60, 475, 0, 0, Smoke::mf_const, 480, 14},	//822 QAbstractItemModel::hasChildren() const
	{60, 360, 431, 2, Smoke::mf_const, 379, 15},	//823 QAbstractItemModel::data(const QModelIndex&, int) const [pure virtual]
	{60, 360, 419, 1, Smoke::mf_const, 379, -1},	//824 QAbstractItemModel::data(const QModelIndex&) const [pure virtual]
	{60, 840, 427, 3, 0, 480, 16},	//825 QAbstractItemModel::setData(const QModelIndex&, const QVariant&, int)
	{60, 840, 424, 2, 0, 480, 17},	//826 QAbstractItemModel::setData(const QModelIndex&, const QVariant&)
	{60, 483, 502, 3, Smoke::mf_const, 379, 18},	//827 QAbstractItemModel::headerData(int, Qt::Orientation, int) const
	{60, 483, 490, 2, Smoke::mf_const, 379, 19},	//828 QAbstractItemModel::headerData(int, Qt::Orientation) const
	{60, 855, 497, 4, 0, 480, 20},	//829 QAbstractItemModel::setHeaderData(int, Qt::Orientation, const QVariant&, int)
	{60, 855, 493, 3, 0, 480, 21},	//830 QAbstractItemModel::setHeaderData(int, Qt::Orientation, const QVariant&)
	{60, 545, 419, 1, Smoke::mf_const, 277, 22},	//831 QAbstractItemModel::itemData(const QModelIndex&) const
	{60, 862, 421, 2, 0, 480, 23},	//832 QAbstractItemModel::setItemData(const QModelIndex&, const QMap<int,QVariant>&)
	{60, 615, 0, 0, Smoke::mf_const, 328, 24},	//833 QAbstractItemModel::mimeTypes() const
	{60, 612, 411, 1, Smoke::mf_const, 286, 25},	//834 QAbstractItemModel::mimeData(const QList<QModelIndex>&) const
	{60, 414, 413, 5, 0, 480, 26},	//835 QAbstractItemModel::dropMimeData(const QMimeData*, Qt::DropAction, int, int, const QModelIndex&)
	{60, 965, 0, 0, Smoke::mf_const, 415, 27},	//836 QAbstractItemModel::supportedDropActions() const
	{60, 519, 522, 3, 0, 480, 30},	//837 QAbstractItemModel::insertRows(int, int, const QModelIndex&)
	{60, 519, 515, 2, 0, 480, 31},	//838 QAbstractItemModel::insertRows(int, int)
	{60, 512, 522, 3, 0, 480, 32},	//839 QAbstractItemModel::insertColumns(int, int, const QModelIndex&)
	{60, 512, 515, 2, 0, 480, 33},	//840 QAbstractItemModel::insertColumns(int, int)
	{60, 762, 522, 3, 0, 480, 34},	//841 QAbstractItemModel::removeRows(int, int, const QModelIndex&)
	{60, 762, 515, 2, 0, 480, 35},	//842 QAbstractItemModel::removeRows(int, int)
	{60, 747, 522, 3, 0, 480, 36},	//843 QAbstractItemModel::removeColumns(int, int, const QModelIndex&)
	{60, 747, 515, 2, 0, 480, 37},	//844 QAbstractItemModel::removeColumns(int, int)
	{60, 450, 419, 1, 0, 0, 46},	//845 QAbstractItemModel::fetchMore(const QModelIndex&)
	{60, 234, 419, 1, Smoke::mf_const, 480, 47},	//846 QAbstractItemModel::canFetchMore(const QModelIndex&) const
	{60, 456, 419, 1, Smoke::mf_const, 429, 48},	//847 QAbstractItemModel::flags(const QModelIndex&) const
	{60, 949, 506, 2, 0, 0, 49},	//848 QAbstractItemModel::sort(int, Qt::SortOrder)
	{60, 949, 479, 1, 0, 0, 50},	//849 QAbstractItemModel::sort(int)
	{60, 232, 419, 1, Smoke::mf_const, 287, 51},	//850 QAbstractItemModel::buddy(const QModelIndex&) const
	{60, 605, 443, 5, Smoke::mf_const, 271, 52},	//851 QAbstractItemModel::match(const QModelIndex&, int, const QVariant&, int, Qt::MatchFlags) const
	{60, 605, 438, 4, Smoke::mf_const, 271, 53},	//852 QAbstractItemModel::match(const QModelIndex&, int, const QVariant&, int) const
	{60, 605, 434, 3, Smoke::mf_const, 271, 54},	//853 QAbstractItemModel::match(const QModelIndex&, int, const QVariant&) const
	{60, 952, 419, 1, Smoke::mf_const, 318, 55},	//854 QAbstractItemModel::span(const QModelIndex&) const
	{60, 964, 0, 0, 0, 480, 57},	//855 QAbstractItemModel::submit()
	{60, 786, 0, 0, 0, 0, 58},	//856 QAbstractItemModel::revert()
	{89, 609, 0, 0, Smoke::mf_const, 532, 2},	//857 QObject::metaObject() const
	{89, 711, 188, 3, 0, 554, 3},	//858 QObject::qt_metacall(QMetaObject::Call, int, void**)
	{89, 438, 173, 1, 0, 480, 6},	//859 QObject::event(QEvent*)
	{89, 440, 198, 2, 0, 480, 7},	//860 QObject::eventFilter(QObject*, QEvent*)
	{89, 985, 222, 1, Smoke::mf_protected, 0, 49},	//861 QObject::timerEvent(QTimerEvent*)
	{89, 254, 159, 1, Smoke::mf_protected, 0, 50},	//862 QObject::childEvent(QChildEvent*)
	{89, 358, 173, 1, Smoke::mf_protected, 0, 51},	//863 QObject::customEvent(QEvent*)
	{89, 314, 471, 1, Smoke::mf_protected, 0, 52},	//864 QObject::connectNotify(const char*)
	{89, 383, 471, 1, Smoke::mf_protected, 0, 53},	//865 QObject::disconnectNotify(const char*)
	{90, 381, 0, 0, Smoke::mf_const, 554, 11},	//866 QPaintDevice::devType() const
	{90, 683, 0, 0, Smoke::mf_const, 300, 13},	//867 QPaintDevice::paintEngine() const [pure virtual]
	{90, 610, 208, 1, Smoke::mf_const|Smoke::mf_protected, 554, 25},	//868 QPaintDevice::metric(QPaintDevice::PaintDeviceMetric) const
	{111, 609, 0, 0, Smoke::mf_const, 532, 5},	//869 QWidget::metaObject() const
	{111, 711, 188, 3, 0, 554, 6},	//870 QWidget::qt_metacall(QMetaObject::Call, int, void**)
	{111, 942, 0, 0, Smoke::mf_const, 318, 181},	//871 QWidget::sizeHint() const
	{111, 616, 0, 0, Smoke::mf_const, 318, 182},	//872 QWidget::minimumSizeHint() const
	{111, 486, 479, 1, Smoke::mf_const, 554, 186},	//873 QWidget::heightForWidth(int) const
	{111, 509, 243, 1, Smoke::mf_const, 379, 227},	//874 QWidget::inputMethodQuery(Qt::InputMethodQuery) const
	{111, 923, 245, 1, 0, 0, 236},	//875 QWidget::setVisible(bool)
	{111, 639, 192, 1, Smoke::mf_protected, 0, 256},	//876 QWidget::mousePressEvent(QMouseEvent*)
	{111, 641, 192, 1, Smoke::mf_protected, 0, 257},	//877 QWidget::mouseReleaseEvent(QMouseEvent*)
	{111, 629, 192, 1, Smoke::mf_protected, 0, 258},	//878 QWidget::mouseDoubleClickEvent(QMouseEvent*)
	{111, 635, 192, 1, Smoke::mf_protected, 0, 259},	//879 QWidget::mouseMoveEvent(QMouseEvent*)
	{111, 1028, 224, 1, Smoke::mf_protected, 0, 260},	//880 QWidget::wheelEvent(QWheelEvent*)
	{111, 547, 181, 1, Smoke::mf_protected, 0, 261},	//881 QWidget::keyPressEvent(QKeyEvent*)
	{111, 549, 181, 1, Smoke::mf_protected, 0, 262},	//882 QWidget::keyReleaseEvent(QKeyEvent*)
	{111, 460, 175, 1, Smoke::mf_protected, 0, 263},	//883 QWidget::focusInEvent(QFocusEvent*)
	{111, 466, 175, 1, Smoke::mf_protected, 0, 264},	//884 QWidget::focusOutEvent(QFocusEvent*)
	{111, 436, 173, 1, Smoke::mf_protected, 0, 265},	//885 QWidget::enterEvent(QEvent*)
	{111, 552, 173, 1, Smoke::mf_protected, 0, 266},	//886 QWidget::leaveEvent(QEvent*)
	{111, 684, 210, 1, Smoke::mf_protected, 0, 267},	//887 QWidget::paintEvent(QPaintEvent*)
	{111, 644, 194, 1, Smoke::mf_protected, 0, 268},	//888 QWidget::moveEvent(QMoveEvent*)
	{111, 784, 212, 1, Smoke::mf_protected, 0, 269},	//889 QWidget::resizeEvent(QResizeEvent*)
	{111, 279, 161, 1, Smoke::mf_protected, 0, 270},	//890 QWidget::closeEvent(QCloseEvent*)
	{111, 326, 163, 1, Smoke::mf_protected, 0, 271},	//891 QWidget::contextMenuEvent(QContextMenuEvent*)
	{111, 968, 220, 1, Smoke::mf_protected, 0, 272},	//892 QWidget::tabletEvent(QTabletEvent*)
	{111, 180, 157, 1, Smoke::mf_protected, 0, 273},	//893 QWidget::actionEvent(QActionEvent*)
	{111, 406, 165, 1, Smoke::mf_protected, 0, 274},	//894 QWidget::dragEnterEvent(QDragEnterEvent*)
	{111, 410, 169, 1, Smoke::mf_protected, 0, 275},	//895 QWidget::dragMoveEvent(QDragMoveEvent*)
	{111, 408, 167, 1, Smoke::mf_protected, 0, 276},	//896 QWidget::dragLeaveEvent(QDragLeaveEvent*)
	{111, 412, 171, 1, Smoke::mf_protected, 0, 277},	//897 QWidget::dropEvent(QDropEvent*)
	{111, 939, 214, 1, Smoke::mf_protected, 0, 278},	//898 QWidget::showEvent(QShowEvent*)
	{111, 490, 177, 1, Smoke::mf_protected, 0, 279},	//899 QWidget::hideEvent(QHideEvent*)
	{111, 240, 173, 1, Smoke::mf_protected, 0, 280},	//900 QWidget::changeEvent(QEvent*)
	{111, 507, 179, 1, Smoke::mf_protected, 0, 282},	//901 QWidget::inputMethodEvent(QInputMethodEvent*)
	{111, 462, 245, 1, Smoke::mf_protected, 480, 291},	//902 QWidget::focusNextPrevChild(bool)
	{111, 962, 218, 1, Smoke::mf_protected, 0, 294},	//903 QWidget::styleChange(QStyle&)
	{111, 427, 245, 1, Smoke::mf_protected, 0, 295},	//904 QWidget::enabledChange(bool)
	{111, 686, 449, 1, Smoke::mf_protected, 0, 296},	//905 QWidget::paletteChange(const QPalette&)
	{111, 469, 409, 1, Smoke::mf_protected, 0, 297},	//906 QWidget::fontChange(const QFont&)
	{111, 1031, 245, 1, Smoke::mf_protected, 0, 298},	//907 QWidget::windowActivationChange(bool)
	{111, 551, 0, 0, Smoke::mf_protected, 0, 299},	//908 QWidget::languageChange()
};

// Class ID, munged name ID (index into methodNames), method def (see methods) if >0 or number of overloads if <0
static Smoke::MethodMap ktexteditor_methodMaps[] = {
	{ 0, 0, 0 },	//0 (no method)
	{20, 343, 49},	//1 KTextEditor::createPlugin?#
	{20, 420, 48},	//2 KTextEditor::editor$
	{21, 6, 53},	//3 KTextEditor::AnnotationInterface::AnnotationInterface
	{21, 7, 54},	//4 KTextEditor::AnnotationInterface::AnnotationInterface#
	{21, 212, 52},	//5 KTextEditor::AnnotationInterface::annotationModel
	{21, 809, 51},	//6 KTextEditor::AnnotationInterface::setAnnotationModel#
	{21, 1040, 50},	//7 KTextEditor::AnnotationInterface::~AnnotationInterface
	{22, 8, 59},	//8 KTextEditor::AnnotationModel::AnnotationModel
	{22, 363, 58},	//9 KTextEditor::AnnotationModel::data$$
	{22, 557, 61},	//10 KTextEditor::AnnotationModel::lineChanged$
	{22, 609, 55},	//11 KTextEditor::AnnotationModel::metaObject
	{22, 712, 56},	//12 KTextEditor::AnnotationModel::qt_metacall$$?
	{22, 783, 60},	//13 KTextEditor::AnnotationModel::reset
	{22, 961, 62},	//14 KTextEditor::AnnotationModel::staticMetaObject
	{22, 1041, 57},	//15 KTextEditor::AnnotationModel::~AnnotationModel
	{23, 9, 69},	//16 KTextEditor::AnnotationViewInterface::AnnotationViewInterface
	{23, 10, 70},	//17 KTextEditor::AnnotationViewInterface::AnnotationViewInterface#
	{23, 207, 67},	//18 KTextEditor::AnnotationViewInterface::annotationActivated#$
	{23, 209, 68},	//19 KTextEditor::AnnotationViewInterface::annotationBorderVisibilityChanged#$
	{23, 211, 66},	//20 KTextEditor::AnnotationViewInterface::annotationContextMenuAboutToShow##$
	{23, 538, 65},	//21 KTextEditor::AnnotationViewInterface::isAnnotationBorderVisible
	{23, 807, 64},	//22 KTextEditor::AnnotationViewInterface::setAnnotationBorderVisible$
	{23, 1042, 63},	//23 KTextEditor::AnnotationViewInterface::~AnnotationViewInterface
	{24, 4, 79},	//24 KTextEditor::Attribute::ActivateCaretIn
	{24, 5, 78},	//25 KTextEditor::Attribute::ActivateMouseIn
	{24, 13, 85},	//26 KTextEditor::Attribute::Attribute
	{24, 14, 86},	//27 KTextEditor::Attribute::Attribute#
	{24, 15, 75},	//28 KTextEditor::Attribute::AttributeDynamicEffect
	{24, 16, 76},	//29 KTextEditor::Attribute::AttributeInternalProperty
	{24, 17, 77},	//30 KTextEditor::Attribute::AttributeUserProperty
	{24, 19, 74},	//31 KTextEditor::Attribute::BackgroundFillWhitespace
	{24, 63, 84},	//32 KTextEditor::Attribute::EffectCycleGradient
	{24, 64, 81},	//33 KTextEditor::Attribute::EffectFadeIn
	{24, 65, 82},	//34 KTextEditor::Attribute::EffectFadeOut
	{24, 66, 80},	//35 KTextEditor::Attribute::EffectNone
	{24, 67, 83},	//36 KTextEditor::Attribute::EffectPulse
	{24, 113, 71},	//37 KTextEditor::Attribute::Outline
	{24, 132, 73},	//38 KTextEditor::Attribute::SelectedBackground
	{24, 133, 72},	//39 KTextEditor::Attribute::SelectedForeground
	{24, 216, 101},	//40 KTextEditor::Attribute::associatedActions
	{24, 226, 97},	//41 KTextEditor::Attribute::backgroundFillWhitespace
	{24, 261, 99},	//42 KTextEditor::Attribute::clear
	{24, 263, 102},	//43 KTextEditor::Attribute::clearAssociatedActions
	{24, 417, 103},	//44 KTextEditor::Attribute::dynamicAttribute$
	{24, 422, 105},	//45 KTextEditor::Attribute::effects
	{24, 468, 88},	//46 KTextEditor::Attribute::fontBold
	{24, 474, 100},	//47 KTextEditor::Attribute::hasAnyProperty
	{24, 672, 107},	//48 KTextEditor::Attribute::operator+=#
	{24, 674, 108},	//49 KTextEditor::Attribute::operator=#
	{24, 675, 91},	//50 KTextEditor::Attribute::outline
	{24, 797, 95},	//51 KTextEditor::Attribute::selectedBackground
	{24, 798, 93},	//52 KTextEditor::Attribute::selectedForeground
	{24, 815, 98},	//53 KTextEditor::Attribute::setBackgroundFillWhitespace$
	{24, 844, 104},	//54 KTextEditor::Attribute::setDynamicAttribute$?
	{24, 848, 106},	//55 KTextEditor::Attribute::setEffects$
	{24, 851, 90},	//56 KTextEditor::Attribute::setFontBold
	{24, 852, 89},	//57 KTextEditor::Attribute::setFontBold$
	{24, 891, 92},	//58 KTextEditor::Attribute::setOutline#
	{24, 907, 96},	//59 KTextEditor::Attribute::setSelectedBackground#
	{24, 909, 94},	//60 KTextEditor::Attribute::setSelectedForeground#
	{24, 1043, 87},	//61 KTextEditor::Attribute::~Attribute
	{25, 28, 119},	//62 KTextEditor::CodeCompletionInterface::CodeCompletionInterface
	{25, 29, 120},	//63 KTextEditor::CodeCompletionInterface::CodeCompletionInterface#
	{25, 171, 112},	//64 KTextEditor::CodeCompletionInterface::abortCompletion
	{25, 471, 113},	//65 KTextEditor::CodeCompletionInterface::forceCompletion
	{25, 539, 116},	//66 KTextEditor::CodeCompletionInterface::isAutomaticInvocationEnabled
	{25, 540, 110},	//67 KTextEditor::CodeCompletionInterface::isCompletionActive
	{25, 740, 114},	//68 KTextEditor::CodeCompletionInterface::registerCompletionModel#
	{25, 812, 118},	//69 KTextEditor::CodeCompletionInterface::setAutomaticInvocationEnabled
	{25, 813, 117},	//70 KTextEditor::CodeCompletionInterface::setAutomaticInvocationEnabled$
	{25, 956, 111},	//71 KTextEditor::CodeCompletionInterface::startCompletion##
	{25, 1000, 115},	//72 KTextEditor::CodeCompletionInterface::unregisterCompletionModel#
	{25, 1044, 109},	//73 KTextEditor::CodeCompletionInterface::~CodeCompletionInterface
	{26, 1, 170},	//74 KTextEditor::CodeCompletionModel::AccessibilityAccept
	{26, 2, 168},	//75 KTextEditor::CodeCompletionModel::AccessibilityNext
	{26, 3, 169},	//76 KTextEditor::CodeCompletionModel::AccessibilityPrevious
	{26, 11, 166},	//77 KTextEditor::CodeCompletionModel::ArgumentHintDepth
	{26, 12, 125},	//78 KTextEditor::CodeCompletionModel::Arguments
	{26, 18, 172},	//79 KTextEditor::CodeCompletionModel::AutomaticInvocation
	{26, 20, 167},	//80 KTextEditor::CodeCompletionModel::BestMatchesCount
	{26, 27, 135},	//81 KTextEditor::CodeCompletionModel::Class
	{26, 31, 177},	//82 KTextEditor::CodeCompletionModel::CodeCompletionModel#
	{26, 34, 193},	//83 KTextEditor::CodeCompletionModel::ColumnCount
	{26, 41, 156},	//84 KTextEditor::CodeCompletionModel::CompletionRole
	{26, 46, 133},	//85 KTextEditor::CodeCompletionModel::Const
	{26, 52, 161},	//86 KTextEditor::CodeCompletionModel::CustomHighlight
	{26, 53, 155},	//87 KTextEditor::CodeCompletionModel::CustomHighlighting
	{26, 68, 140},	//88 KTextEditor::CodeCompletionModel::Enum
	{26, 73, 164},	//89 KTextEditor::CodeCompletionModel::ExpandingWidget
	{26, 76, 128},	//90 KTextEditor::CodeCompletionModel::FirstProperty
	{26, 77, 146},	//91 KTextEditor::CodeCompletionModel::Friend
	{26, 78, 138},	//92 KTextEditor::CodeCompletionModel::Function
	{26, 79, 151},	//93 KTextEditor::CodeCompletionModel::GlobalScope
	{26, 80, 171},	//94 KTextEditor::CodeCompletionModel::GroupRole
	{26, 81, 160},	//95 KTextEditor::CodeCompletionModel::HighlightingMethod
	{26, 82, 122},	//96 KTextEditor::CodeCompletionModel::Icon
	{26, 83, 162},	//97 KTextEditor::CodeCompletionModel::InheritanceDepth
	{26, 84, 145},	//98 KTextEditor::CodeCompletionModel::Inline
	{26, 85, 154},	//99 KTextEditor::CodeCompletionModel::InternalHighlighting
	{26, 86, 163},	//100 KTextEditor::CodeCompletionModel::IsExpandable
	{26, 87, 165},	//101 KTextEditor::CodeCompletionModel::ItemSelected
	{26, 88, 194},	//102 KTextEditor::CodeCompletionModel::LastItemDataRole
	{26, 89, 152},	//103 KTextEditor::CodeCompletionModel::LastProperty
	{26, 90, 149},	//104 KTextEditor::CodeCompletionModel::LocalScope
	{26, 91, 174},	//105 KTextEditor::CodeCompletionModel::ManualInvocation
	{26, 98, 158},	//106 KTextEditor::CodeCompletionModel::MatchQuality
	{26, 104, 124},	//107 KTextEditor::CodeCompletionModel::Name
	{26, 105, 134},	//108 KTextEditor::CodeCompletionModel::Namespace
	{26, 106, 150},	//109 KTextEditor::CodeCompletionModel::NamespaceScope
	{26, 107, 153},	//110 KTextEditor::CodeCompletionModel::NoHighlighting
	{26, 108, 127},	//111 KTextEditor::CodeCompletionModel::NoProperty
	{26, 114, 144},	//112 KTextEditor::CodeCompletionModel::Override
	{26, 117, 126},	//113 KTextEditor::CodeCompletionModel::Postfix
	{26, 118, 121},	//114 KTextEditor::CodeCompletionModel::Prefix
	{26, 119, 131},	//115 KTextEditor::CodeCompletionModel::Private
	{26, 120, 130},	//116 KTextEditor::CodeCompletionModel::Protected
	{26, 121, 129},	//117 KTextEditor::CodeCompletionModel::Public
	{26, 128, 123},	//118 KTextEditor::CodeCompletionModel::Scope
	{26, 129, 157},	//119 KTextEditor::CodeCompletionModel::ScopeIndex
	{26, 136, 159},	//120 KTextEditor::CodeCompletionModel::SetMatchContext
	{26, 137, 147},	//121 KTextEditor::CodeCompletionModel::Signal
	{26, 138, 148},	//122 KTextEditor::CodeCompletionModel::Slot
	{26, 153, 132},	//123 KTextEditor::CodeCompletionModel::Static
	{26, 155, 136},	//124 KTextEditor::CodeCompletionModel::Struct
	{26, 156, 141},	//125 KTextEditor::CodeCompletionModel::Template
	{26, 161, 142},	//126 KTextEditor::CodeCompletionModel::TypeAlias
	{26, 162, 137},	//127 KTextEditor::CodeCompletionModel::Union
	{26, 163, 173},	//128 KTextEditor::CodeCompletionModel::UserInvocation
	{26, 164, 139},	//129 KTextEditor::CodeCompletionModel::Variable
	{26, 169, 143},	//130 KTextEditor::CodeCompletionModel::Virtual
	{26, 287, 182},	//131 KTextEditor::CodeCompletionModel::columnCount
	{26, 288, 181},	//132 KTextEditor::CodeCompletionModel::columnCount#
	{26, 293, 180},	//133 KTextEditor::CodeCompletionModel::completionInvoked##$
	{26, 477, 189},	//134 KTextEditor::CodeCompletionModel::hasGroups
	{26, 479, 191},	//135 KTextEditor::CodeCompletionModel::hasGroupsChanged#$
	{26, 503, 184},	//136 KTextEditor::CodeCompletionModel::index$$
	{26, 504, 183},	//137 KTextEditor::CodeCompletionModel::index$$#
	{26, 546, 185},	//138 KTextEditor::CodeCompletionModel::itemData#
	{26, 609, 175},	//139 KTextEditor::CodeCompletionModel::metaObject
	{26, 689, 186},	//140 KTextEditor::CodeCompletionModel::parent#
	{26, 712, 176},	//141 KTextEditor::CodeCompletionModel::qt_metacall$$?
	{26, 787, 188},	//142 KTextEditor::CodeCompletionModel::rowCount
	{26, 788, 187},	//143 KTextEditor::CodeCompletionModel::rowCount#
	{26, 854, 195},	//144 KTextEditor::CodeCompletionModel::setHasGroups$
	{26, 903, 179},	//145 KTextEditor::CodeCompletionModel::setRowCount$
	{26, 961, 192},	//146 KTextEditor::CodeCompletionModel::staticMetaObject
	{26, 1022, 190},	//147 KTextEditor::CodeCompletionModel::waitForReset
	{26, 1045, 178},	//148 KTextEditor::CodeCompletionModel::~CodeCompletionModel
	{27, 33, 198},	//149 KTextEditor::CodeCompletionModel2::CodeCompletionModel2#
	{27, 445, 199},	//150 KTextEditor::CodeCompletionModel2::executeCompletionItem2###
	{27, 609, 196},	//151 KTextEditor::CodeCompletionModel2::metaObject
	{27, 712, 197},	//152 KTextEditor::CodeCompletionModel2::qt_metacall$$?
	{27, 961, 201},	//153 KTextEditor::CodeCompletionModel2::staticMetaObject
	{27, 1046, 200},	//154 KTextEditor::CodeCompletionModel2::~CodeCompletionModel2
	{28, 35, 206},	//155 KTextEditor::Command::Command
	{28, 36, 207},	//156 KTextEditor::Command::Command#
	{28, 285, 203},	//157 KTextEditor::Command::cmds
	{28, 443, 204},	//158 KTextEditor::Command::exec#$$
	{28, 489, 205},	//159 KTextEditor::Command::help#$$
	{28, 1047, 202},	//160 KTextEditor::Command::~Command
	{29, 37, 213},	//161 KTextEditor::CommandExtension::CommandExtension
	{29, 38, 214},	//162 KTextEditor::CommandExtension::CommandExtension#
	{29, 295, 210},	//163 KTextEditor::CommandExtension::completionObject#$
	{29, 455, 209},	//164 KTextEditor::CommandExtension::flagCompletions?
	{29, 710, 212},	//165 KTextEditor::CommandExtension::processText#$
	{29, 1025, 211},	//166 KTextEditor::CommandExtension::wantsToProcessText$
	{29, 1048, 208},	//167 KTextEditor::CommandExtension::~CommandExtension
	{30, 39, 221},	//168 KTextEditor::CommandInterface::CommandInterface
	{30, 40, 222},	//169 KTextEditor::CommandInterface::CommandInterface#
	{30, 290, 220},	//170 KTextEditor::CommandInterface::commandList
	{30, 291, 219},	//171 KTextEditor::CommandInterface::commands
	{30, 715, 218},	//172 KTextEditor::CommandInterface::queryCommand$
	{30, 738, 216},	//173 KTextEditor::CommandInterface::registerCommand#
	{30, 998, 217},	//174 KTextEditor::CommandInterface::unregisterCommand#
	{30, 1049, 215},	//175 KTextEditor::CommandInterface::~CommandInterface
	{31, 42, 223},	//176 KTextEditor::ConfigInterface::ConfigInterface
	{31, 43, 228},	//177 KTextEditor::ConfigInterface::ConfigInterface#
	{31, 300, 225},	//178 KTextEditor::ConfigInterface::configKeys
	{31, 311, 226},	//179 KTextEditor::ConfigInterface::configValue$
	{31, 830, 227},	//180 KTextEditor::ConfigInterface::setConfigValue$#
	{31, 1050, 224},	//181 KTextEditor::ConfigInterface::~ConfigInterface
	{32, 45, 231},	//182 KTextEditor::ConfigPage::ConfigPage#
	{32, 213, 233},	//183 KTextEditor::ConfigPage::apply
	{32, 242, 236},	//184 KTextEditor::ConfigPage::changed
	{32, 372, 235},	//185 KTextEditor::ConfigPage::defaults
	{32, 609, 229},	//186 KTextEditor::ConfigPage::metaObject
	{32, 712, 230},	//187 KTextEditor::ConfigPage::qt_metacall$$?
	{32, 783, 234},	//188 KTextEditor::ConfigPage::reset
	{32, 961, 237},	//189 KTextEditor::ConfigPage::staticMetaObject
	{32, 1051, 232},	//190 KTextEditor::ConfigPage::~ConfigPage
	{33, 47, 238},	//191 KTextEditor::ContainerInterface::ContainerInterface
	{33, 48, 242},	//192 KTextEditor::ContainerInterface::ContainerInterface#
	{33, 316, 241},	//193 KTextEditor::ContainerInterface::container
	{33, 832, 240},	//194 KTextEditor::ContainerInterface::setContainer#
	{33, 1052, 239},	//195 KTextEditor::ContainerInterface::~ContainerInterface
	{34, 49, 243},	//196 KTextEditor::Cursor::Cursor
	{34, 50, 245},	//197 KTextEditor::Cursor::Cursor#
	{34, 51, 244},	//198 KTextEditor::Cursor::Cursor$$
	{34, 219, 257},	//199 KTextEditor::Cursor::atStartOfDocument
	{34, 220, 256},	//200 KTextEditor::Cursor::atStartOfLine
	{34, 286, 254},	//201 KTextEditor::Cursor::column
	{34, 348, 263},	//202 KTextEditor::Cursor::cursorChangedDirectly#
	{34, 536, 260},	//203 KTextEditor::Cursor::invalid
	{34, 542, 248},	//204 KTextEditor::Cursor::isSmartCursor
	{34, 544, 247},	//205 KTextEditor::Cursor::isValid
	{34, 554, 252},	//206 KTextEditor::Cursor::line
	{34, 699, 258},	//207 KTextEditor::Cursor::position$$
	{34, 716, 259},	//208 KTextEditor::Cursor::range
	{34, 825, 255},	//209 KTextEditor::Cursor::setColumn$
	{34, 865, 253},	//210 KTextEditor::Cursor::setLine$
	{34, 895, 250},	//211 KTextEditor::Cursor::setPosition#
	{34, 896, 251},	//212 KTextEditor::Cursor::setPosition$$
	{34, 898, 262},	//213 KTextEditor::Cursor::setRange#
	{34, 954, 261},	//214 KTextEditor::Cursor::start
	{34, 987, 249},	//215 KTextEditor::Cursor::toSmartCursor
	{34, 1053, 246},	//216 KTextEditor::Cursor::~Cursor
	{35, 55, 267},	//217 KTextEditor::Document::Document
	{35, 56, 266},	//218 KTextEditor::Document::Document#
	{35, 174, 334},	//219 KTextEditor::Document::aboutToClose#
	{35, 176, 335},	//220 KTextEditor::Document::aboutToReload#
	{35, 182, 271},	//221 KTextEditor::Document::activeView
	{35, 244, 285},	//222 KTextEditor::Document::character#
	{35, 261, 298},	//223 KTextEditor::Document::clear
	{35, 345, 270},	//224 KTextEditor::Document::createView#
	{35, 350, 309},	//225 KTextEditor::Document::cursorInText#
	{35, 391, 290},	//226 KTextEditor::Document::documentEnd
	{35, 393, 273},	//227 KTextEditor::Document::documentName
	{35, 395, 326},	//228 KTextEditor::Document::documentNameChanged#
	{35, 396, 291},	//229 KTextEditor::Document::documentRange
	{35, 397, 277},	//230 KTextEditor::Document::documentReload
	{35, 398, 278},	//231 KTextEditor::Document::documentSave
	{35, 399, 279},	//232 KTextEditor::Document::documentSaveAs
	{35, 401, 329},	//233 KTextEditor::Document::documentSavedOrUploaded#$
	{35, 403, 327},	//234 KTextEditor::Document::documentUrlChanged#
	{35, 419, 269},	//235 KTextEditor::Document::editor
	{35, 429, 276},	//236 KTextEditor::Document::encoding
	{35, 433, 281},	//237 KTextEditor::Document::endEditing
	{35, 435, 295},	//238 KTextEditor::Document::endOfLine$
	{35, 492, 314},	//239 KTextEditor::Document::highlightingMode
	{35, 494, 337},	//240 KTextEditor::Document::highlightingModeChanged#
	{35, 496, 319},	//241 KTextEditor::Document::highlightingModeSection$
	{35, 497, 316},	//242 KTextEditor::Document::highlightingModes
	{35, 516, 310},	//243 KTextEditor::Document::insertLine$$
	{35, 518, 311},	//244 KTextEditor::Document::insertLines$?
	{35, 527, 300},	//245 KTextEditor::Document::insertText#$
	{35, 528, 299},	//246 KTextEditor::Document::insertText#$$
	{35, 529, 302},	//247 KTextEditor::Document::insertText#?
	{35, 530, 301},	//248 KTextEditor::Document::insertText#?$
	{35, 541, 293},	//249 KTextEditor::Document::isEmpty
	{35, 555, 288},	//250 KTextEditor::Document::line$
	{35, 559, 294},	//251 KTextEditor::Document::lineLength$
	{35, 560, 289},	//252 KTextEditor::Document::lines
	{35, 609, 264},	//253 KTextEditor::Document::metaObject
	{35, 614, 274},	//254 KTextEditor::Document::mimeType
	{35, 617, 313},	//255 KTextEditor::Document::mode
	{35, 619, 336},	//256 KTextEditor::Document::modeChanged#
	{35, 621, 320},	//257 KTextEditor::Document::modeSection$
	{35, 622, 315},	//258 KTextEditor::Document::modes
	{35, 624, 328},	//259 KTextEditor::Document::modifiedChanged#
	{35, 669, 323},	//260 KTextEditor::Document::openingError
	{35, 670, 324},	//261 KTextEditor::Document::openingErrorMessage
	{35, 712, 265},	//262 KTextEditor::Document::qt_metacall$$?
	{35, 757, 312},	//263 KTextEditor::Document::removeLine$
	{35, 768, 308},	//264 KTextEditor::Document::removeText#
	{35, 769, 307},	//265 KTextEditor::Document::removeText#$
	{35, 776, 304},	//266 KTextEditor::Document::replaceText#$
	{35, 777, 303},	//267 KTextEditor::Document::replaceText#$$
	{35, 778, 306},	//268 KTextEditor::Document::replaceText#?
	{35, 779, 305},	//269 KTextEditor::Document::replaceText#?$
	{35, 850, 275},	//270 KTextEditor::Document::setEncoding$
	{35, 859, 318},	//271 KTextEditor::Document::setHighlightingMode$
	{35, 877, 317},	//272 KTextEditor::Document::setMode$
	{35, 887, 339},	//273 KTextEditor::Document::setOpeningError$
	{35, 889, 340},	//274 KTextEditor::Document::setOpeningErrorMessage$
	{35, 917, 321},	//275 KTextEditor::Document::setSuppressOpeningErrorDialogs$
	{35, 919, 296},	//276 KTextEditor::Document::setText$
	{35, 920, 297},	//277 KTextEditor::Document::setText?
	{35, 957, 280},	//278 KTextEditor::Document::startEditing
	{35, 961, 338},	//279 KTextEditor::Document::staticMetaObject
	{35, 967, 322},	//280 KTextEditor::Document::suppressOpeningErrorDialogs
	{35, 970, 282},	//281 KTextEditor::Document::text
	{35, 971, 284},	//282 KTextEditor::Document::text#
	{35, 972, 283},	//283 KTextEditor::Document::text#$
	{35, 975, 330},	//284 KTextEditor::Document::textChanged#
	{35, 976, 333},	//285 KTextEditor::Document::textChanged###
	{35, 978, 331},	//286 KTextEditor::Document::textInserted##
	{35, 981, 287},	//287 KTextEditor::Document::textLines#
	{35, 982, 286},	//288 KTextEditor::Document::textLines#$
	{35, 984, 332},	//289 KTextEditor::Document::textRemoved##
	{35, 990, 292},	//290 KTextEditor::Document::totalCharacters
	{35, 1012, 325},	//291 KTextEditor::Document::viewCreated##
	{35, 1021, 272},	//292 KTextEditor::Document::views
	{35, 1054, 268},	//293 KTextEditor::Document::~Document
	{36, 60, 343},	//294 KTextEditor::Editor::Editor#
	{36, 172, 349},	//295 KTextEditor::Editor::aboutData
	{36, 298, 355},	//296 KTextEditor::Editor::configDialog#
	{36, 299, 354},	//297 KTextEditor::Editor::configDialogSupported
	{36, 302, 357},	//298 KTextEditor::Editor::configPage$#
	{36, 304, 359},	//299 KTextEditor::Editor::configPageFullName$
	{36, 306, 360},	//300 KTextEditor::Editor::configPageIcon$
	{36, 308, 358},	//301 KTextEditor::Editor::configPageName$
	{36, 309, 356},	//302 KTextEditor::Editor::configPages
	{36, 331, 347},	//303 KTextEditor::Editor::createDocument#
	{36, 390, 361},	//304 KTextEditor::Editor::documentCreated##
	{36, 404, 348},	//305 KTextEditor::Editor::documents
	{36, 609, 341},	//306 KTextEditor::Editor::metaObject
	{36, 712, 342},	//307 KTextEditor::Editor::qt_metacall$$?
	{36, 732, 351},	//308 KTextEditor::Editor::readConfig
	{36, 733, 350},	//309 KTextEditor::Editor::readConfig#
	{36, 915, 345},	//310 KTextEditor::Editor::setSimpleMode$
	{36, 941, 346},	//311 KTextEditor::Editor::simpleMode
	{36, 961, 362},	//312 KTextEditor::Editor::staticMetaObject
	{36, 1035, 353},	//313 KTextEditor::Editor::writeConfig
	{36, 1036, 352},	//314 KTextEditor::Editor::writeConfig#
	{36, 1055, 344},	//315 KTextEditor::Editor::~Editor
	{37, 61, 366},	//316 KTextEditor::EditorChooser::EditorChooser
	{37, 62, 365},	//317 KTextEditor::EditorChooser::EditorChooser#
	{37, 242, 372},	//318 KTextEditor::EditorChooser::changed
	{37, 419, 375},	//319 KTextEditor::EditorChooser::editor
	{37, 420, 374},	//320 KTextEditor::EditorChooser::editor$
	{37, 421, 373},	//321 KTextEditor::EditorChooser::editor$$
	{37, 609, 363},	//322 KTextEditor::EditorChooser::metaObject
	{37, 712, 364},	//323 KTextEditor::EditorChooser::qt_metacall$$?
	{37, 730, 369},	//324 KTextEditor::EditorChooser::readAppSetting
	{37, 731, 368},	//325 KTextEditor::EditorChooser::readAppSetting$
	{37, 961, 376},	//326 KTextEditor::EditorChooser::staticMetaObject
	{37, 1033, 371},	//327 KTextEditor::EditorChooser::writeAppSetting
	{37, 1034, 370},	//328 KTextEditor::EditorChooser::writeAppSetting$
	{37, 1056, 367},	//329 KTextEditor::EditorChooser::~EditorChooser
	{38, 75, 379},	//330 KTextEditor::Factory::Factory#
	{38, 419, 381},	//331 KTextEditor::Factory::editor
	{38, 609, 377},	//332 KTextEditor::Factory::metaObject
	{38, 712, 378},	//333 KTextEditor::Factory::qt_metacall$$?
	{38, 961, 382},	//334 KTextEditor::Factory::staticMetaObject
	{38, 1057, 380},	//335 KTextEditor::Factory::~Factory
	{39, 92, 385},	//336 KTextEditor::Mark::Mark
	{39, 93, 387},	//337 KTextEditor::Mark::Mark#
	{39, 554, 388},	//338 KTextEditor::Mark::line
	{39, 865, 383},	//339 KTextEditor::Mark::setLine$
	{39, 922, 384},	//340 KTextEditor::Mark::setType$
	{39, 994, 389},	//341 KTextEditor::Mark::type
	{39, 1058, 386},	//342 KTextEditor::Mark::~Mark
	{40, 21, 422},	//343 KTextEditor::MarkInterface::Bookmark
	{40, 22, 423},	//344 KTextEditor::MarkInterface::BreakpointActive
	{40, 23, 425},	//345 KTextEditor::MarkInterface::BreakpointDisabled
	{40, 24, 424},	//346 KTextEditor::MarkInterface::BreakpointReached
	{40, 69, 428},	//347 KTextEditor::MarkInterface::Error
	{40, 70, 426},	//348 KTextEditor::MarkInterface::Execution
	{40, 94, 429},	//349 KTextEditor::MarkInterface::MarkAdded
	{40, 95, 431},	//350 KTextEditor::MarkInterface::MarkInterface
	{40, 96, 448},	//351 KTextEditor::MarkInterface::MarkInterface#
	{40, 97, 430},	//352 KTextEditor::MarkInterface::MarkRemoved
	{40, 170, 427},	//353 KTextEditor::MarkInterface::Warning
	{40, 196, 436},	//354 KTextEditor::MarkInterface::addMark$$
	{40, 268, 435},	//355 KTextEditor::MarkInterface::clearMark$
	{40, 269, 439},	//356 KTextEditor::MarkInterface::clearMarks
	{40, 418, 446},	//357 KTextEditor::MarkInterface::editableMarks
	{40, 563, 433},	//358 KTextEditor::MarkInterface::mark$
	{40, 565, 447},	//359 KTextEditor::MarkInterface::markChanged##$
	{40, 567, 444},	//360 KTextEditor::MarkInterface::markDescription$
	{40, 569, 442},	//361 KTextEditor::MarkInterface::markPixmap$
	{40, 570, 390},	//362 KTextEditor::MarkInterface::markType01
	{40, 571, 391},	//363 KTextEditor::MarkInterface::markType02
	{40, 572, 392},	//364 KTextEditor::MarkInterface::markType03
	{40, 573, 393},	//365 KTextEditor::MarkInterface::markType04
	{40, 574, 394},	//366 KTextEditor::MarkInterface::markType05
	{40, 575, 395},	//367 KTextEditor::MarkInterface::markType06
	{40, 576, 396},	//368 KTextEditor::MarkInterface::markType07
	{40, 577, 397},	//369 KTextEditor::MarkInterface::markType08
	{40, 578, 398},	//370 KTextEditor::MarkInterface::markType09
	{40, 579, 399},	//371 KTextEditor::MarkInterface::markType10
	{40, 580, 400},	//372 KTextEditor::MarkInterface::markType11
	{40, 581, 401},	//373 KTextEditor::MarkInterface::markType12
	{40, 582, 402},	//374 KTextEditor::MarkInterface::markType13
	{40, 583, 403},	//375 KTextEditor::MarkInterface::markType14
	{40, 584, 404},	//376 KTextEditor::MarkInterface::markType15
	{40, 585, 405},	//377 KTextEditor::MarkInterface::markType16
	{40, 586, 406},	//378 KTextEditor::MarkInterface::markType17
	{40, 587, 407},	//379 KTextEditor::MarkInterface::markType18
	{40, 588, 408},	//380 KTextEditor::MarkInterface::markType19
	{40, 589, 409},	//381 KTextEditor::MarkInterface::markType20
	{40, 590, 410},	//382 KTextEditor::MarkInterface::markType21
	{40, 591, 411},	//383 KTextEditor::MarkInterface::markType22
	{40, 592, 412},	//384 KTextEditor::MarkInterface::markType23
	{40, 593, 413},	//385 KTextEditor::MarkInterface::markType24
	{40, 594, 414},	//386 KTextEditor::MarkInterface::markType25
	{40, 595, 415},	//387 KTextEditor::MarkInterface::markType26
	{40, 596, 416},	//388 KTextEditor::MarkInterface::markType27
	{40, 597, 417},	//389 KTextEditor::MarkInterface::markType28
	{40, 598, 418},	//390 KTextEditor::MarkInterface::markType29
	{40, 599, 419},	//391 KTextEditor::MarkInterface::markType30
	{40, 600, 420},	//392 KTextEditor::MarkInterface::markType31
	{40, 601, 421},	//393 KTextEditor::MarkInterface::markType32
	{40, 602, 438},	//394 KTextEditor::MarkInterface::marks
	{40, 604, 440},	//395 KTextEditor::MarkInterface::marksChanged#
	{40, 759, 437},	//396 KTextEditor::MarkInterface::removeMark$$
	{40, 782, 449},	//397 KTextEditor::MarkInterface::reservedMarkersCount
	{40, 846, 445},	//398 KTextEditor::MarkInterface::setEditableMarks$
	{40, 871, 434},	//399 KTextEditor::MarkInterface::setMark$$
	{40, 873, 443},	//400 KTextEditor::MarkInterface::setMarkDescription$$
	{40, 875, 441},	//401 KTextEditor::MarkInterface::setMarkPixmap$#
	{40, 1059, 432},	//402 KTextEditor::MarkInterface::~MarkInterface
	{41, 99, 450},	//403 KTextEditor::MdiContainer::MdiContainer
	{41, 100, 458},	//404 KTextEditor::MdiContainer::MdiContainer#
	{41, 182, 453},	//405 KTextEditor::MdiContainer::activeView
	{41, 278, 455},	//406 KTextEditor::MdiContainer::closeDocument#
	{41, 284, 457},	//407 KTextEditor::MdiContainer::closeView#
	{41, 330, 454},	//408 KTextEditor::MdiContainer::createDocument
	{41, 345, 456},	//409 KTextEditor::MdiContainer::createView#
	{41, 805, 452},	//410 KTextEditor::MdiContainer::setActiveView#
	{41, 1060, 451},	//411 KTextEditor::MdiContainer::~MdiContainer
	{42, 101, 463},	//412 KTextEditor::ModificationInterface::ModificationInterface
	{42, 102, 470},	//413 KTextEditor::ModificationInterface::ModificationInterface#
	{42, 109, 461},	//414 KTextEditor::ModificationInterface::OnDiskCreated
	{42, 110, 462},	//415 KTextEditor::ModificationInterface::OnDiskDeleted
	{42, 111, 460},	//416 KTextEditor::ModificationInterface::OnDiskModified
	{42, 112, 459},	//417 KTextEditor::ModificationInterface::OnDiskUnmodified
	{42, 626, 469},	//418 KTextEditor::ModificationInterface::modifiedOnDisk#$$
	{42, 881, 465},	//419 KTextEditor::ModificationInterface::setModifiedOnDisk$
	{42, 883, 466},	//420 KTextEditor::ModificationInterface::setModifiedOnDiskWarning$
	{42, 943, 468},	//421 KTextEditor::ModificationInterface::slotModifiedOnDisk
	{42, 944, 467},	//422 KTextEditor::ModificationInterface::slotModifiedOnDisk#
	{42, 1061, 464},	//423 KTextEditor::ModificationInterface::~ModificationInterface
	{43, 116, 473},	//424 KTextEditor::Plugin::Plugin#
	{43, 188, 475},	//425 KTextEditor::Plugin::addDocument#
	{43, 200, 477},	//426 KTextEditor::Plugin::addView#
	{43, 609, 471},	//427 KTextEditor::Plugin::metaObject
	{43, 712, 472},	//428 KTextEditor::Plugin::qt_metacall$$?
	{43, 751, 476},	//429 KTextEditor::Plugin::removeDocument#
	{43, 772, 478},	//430 KTextEditor::Plugin::removeView#
	{43, 961, 479},	//431 KTextEditor::Plugin::staticMetaObject
	{43, 1062, 474},	//432 KTextEditor::Plugin::~Plugin
	{44, 122, 480},	//433 KTextEditor::Range::Range
	{44, 123, 485},	//434 KTextEditor::Range::Range#
	{44, 124, -1},	//435 KTextEditor::Range::Range##
	{44, 125, 482},	//436 KTextEditor::Range::Range#$
	{44, 126, 483},	//437 KTextEditor::Range::Range#$$
	{44, 127, 484},	//438 KTextEditor::Range::Range$$$$
	{44, 229, 511},	//439 KTextEditor::Range::boundaryAtCursor#
	{44, 231, 512},	//440 KTextEditor::Range::boundaryOnLine$
	{44, 289, 500},	//441 KTextEditor::Range::columnWidth
	{44, 313, 497},	//442 KTextEditor::Range::confineToRange#
	{44, 318, -4},	//443 KTextEditor::Range::contains#
	{44, 320, 505},	//444 KTextEditor::Range::containsColumn$
	{44, 322, 504},	//445 KTextEditor::Range::containsLine$
	{44, 431, 514},	//446 KTextEditor::Range::encompass#
	{44, 432, 491},	//447 KTextEditor::Range::end
	{44, 449, 496},	//448 KTextEditor::Range::expandToRange#
	{44, 535, 513},	//449 KTextEditor::Range::intersect#
	{44, 536, 515},	//450 KTextEditor::Range::invalid
	{44, 541, 501},	//451 KTextEditor::Range::isEmpty
	{44, 543, 488},	//452 KTextEditor::Range::isSmartRange
	{44, 544, 487},	//453 KTextEditor::Range::isValid
	{44, 664, 499},	//454 KTextEditor::Range::numberOfLines
	{44, 665, 498},	//455 KTextEditor::Range::onSingleLine
	{44, 678, 506},	//456 KTextEditor::Range::overlaps#
	{44, 680, 508},	//457 KTextEditor::Range::overlapsColumn$
	{44, 682, 507},	//458 KTextEditor::Range::overlapsLine$
	{44, 705, 509},	//459 KTextEditor::Range::positionRelativeToCursor#
	{44, 707, 510},	//460 KTextEditor::Range::positionRelativeToLine$
	{44, 720, 517},	//461 KTextEditor::Range::rangeChanged##
	{44, 819, 493},	//462 KTextEditor::Range::setBothColumns$
	{44, 821, 492},	//463 KTextEditor::Range::setBothLines$
	{44, 898, 494},	//464 KTextEditor::Range::setRange#
	{44, 899, 495},	//465 KTextEditor::Range::setRange##
	{44, 954, 490},	//466 KTextEditor::Range::start
	{44, 988, 489},	//467 KTextEditor::Range::toSmartRange
	{44, 1063, 486},	//468 KTextEditor::Range::~Range
	{45, 130, 518},	//469 KTextEditor::SearchInterface::SearchInterface
	{45, 131, 523},	//470 KTextEditor::SearchInterface::SearchInterface#
	{45, 795, 521},	//471 KTextEditor::SearchInterface::searchText#$
	{45, 796, 520},	//472 KTextEditor::SearchInterface::searchText#$$
	{45, 966, 522},	//473 KTextEditor::SearchInterface::supportedSearchOptions
	{45, 1064, 519},	//474 KTextEditor::SearchInterface::~SearchInterface
	{46, 134, 524},	//475 KTextEditor::SessionConfigInterface::SessionConfigInterface
	{46, 135, 528},	//476 KTextEditor::SessionConfigInterface::SessionConfigInterface#
	{46, 735, 526},	//477 KTextEditor::SessionConfigInterface::readSessionConfig#
	{46, 1038, 527},	//478 KTextEditor::SessionConfigInterface::writeSessionConfig#
	{46, 1065, 525},	//479 KTextEditor::SessionConfigInterface::~SessionConfigInterface
	{47, 25, 529},	//480 KTextEditor::SmartCursor::ByCharacter
	{47, 26, 530},	//481 KTextEditor::SmartCursor::ByCursorPosition
	{47, 103, 532},	//482 KTextEditor::SmartCursor::MoveOnInsert
	{47, 140, 555},	//483 KTextEditor::SmartCursor::SmartCursor##$
	{47, 154, 531},	//484 KTextEditor::SmartCursor::StayOnInsert
	{47, 204, 545},	//485 KTextEditor::SmartCursor::advance$
	{47, 205, 544},	//486 KTextEditor::SmartCursor::advance$$
	{47, 217, 539},	//487 KTextEditor::SmartCursor::atEndOfDocument
	{47, 218, 538},	//488 KTextEditor::SmartCursor::atEndOfLine
	{47, 243, 541},	//489 KTextEditor::SmartCursor::character
	{47, 375, 550},	//490 KTextEditor::SmartCursor::deleteNotifier
	{47, 387, 537},	//491 KTextEditor::SmartCursor::document
	{47, 480, 548},	//492 KTextEditor::SmartCursor::hasNotifier
	{47, 511, 546},	//493 KTextEditor::SmartCursor::insertBehavior
	{47, 532, 543},	//494 KTextEditor::SmartCursor::insertText?
	{47, 533, 542},	//495 KTextEditor::SmartCursor::insertText?$
	{47, 542, 534},	//496 KTextEditor::SmartCursor::isSmartCursor
	{47, 544, 540},	//497 KTextEditor::SmartCursor::isValid
	{47, 662, 549},	//498 KTextEditor::SmartCursor::notifier
	{47, 674, 554},	//499 KTextEditor::SmartCursor::operator=#
	{47, 861, 547},	//500 KTextEditor::SmartCursor::setInsertBehavior$
	{47, 927, 553},	//501 KTextEditor::SmartCursor::setWatcher
	{47, 928, 552},	//502 KTextEditor::SmartCursor::setWatcher#
	{47, 947, 536},	//503 KTextEditor::SmartCursor::smartRange
	{47, 987, 535},	//504 KTextEditor::SmartCursor::toSmartCursor
	{47, 1026, 551},	//505 KTextEditor::SmartCursor::watcher
	{47, 1066, 533},	//506 KTextEditor::SmartCursor::~SmartCursor
	{48, 141, 558},	//507 KTextEditor::SmartCursorNotifier::SmartCursorNotifier
	{48, 246, 564},	//508 KTextEditor::SmartCursorNotifier::characterDeleted#$
	{48, 248, 565},	//509 KTextEditor::SmartCursorNotifier::characterInserted#$
	{48, 379, 566},	//510 KTextEditor::SmartCursorNotifier::deleted#
	{48, 609, 556},	//511 KTextEditor::SmartCursorNotifier::metaObject
	{48, 701, 562},	//512 KTextEditor::SmartCursorNotifier::positionChanged#
	{48, 703, 563},	//513 KTextEditor::SmartCursorNotifier::positionDeleted#
	{48, 712, 557},	//514 KTextEditor::SmartCursorNotifier::qt_metacall$$?
	{48, 926, 560},	//515 KTextEditor::SmartCursorNotifier::setWantsDirectChanges$
	{48, 961, 567},	//516 KTextEditor::SmartCursorNotifier::staticMetaObject
	{48, 1023, 559},	//517 KTextEditor::SmartCursorNotifier::wantsDirectChanges
	{48, 1067, 561},	//518 KTextEditor::SmartCursorNotifier::~SmartCursorNotifier
	{49, 142, 568},	//519 KTextEditor::SmartCursorWatcher::SmartCursorWatcher
	{49, 143, 577},	//520 KTextEditor::SmartCursorWatcher::SmartCursorWatcher#
	{49, 246, 574},	//521 KTextEditor::SmartCursorWatcher::characterDeleted#$
	{49, 248, 575},	//522 KTextEditor::SmartCursorWatcher::characterInserted#$
	{49, 379, 576},	//523 KTextEditor::SmartCursorWatcher::deleted#
	{49, 701, 572},	//524 KTextEditor::SmartCursorWatcher::positionChanged#
	{49, 703, 573},	//525 KTextEditor::SmartCursorWatcher::positionDeleted#
	{49, 926, 571},	//526 KTextEditor::SmartCursorWatcher::setWantsDirectChanges$
	{49, 1023, 570},	//527 KTextEditor::SmartCursorWatcher::wantsDirectChanges
	{49, 1068, 569},	//528 KTextEditor::SmartCursorWatcher::~SmartCursorWatcher
	{50, 144, 578},	//529 KTextEditor::SmartInterface::SmartInterface
	{50, 145, 631},	//530 KTextEditor::SmartInterface::SmartInterface#
	{50, 184, 623},	//531 KTextEditor::SmartInterface::addActionsToDocument#
	{50, 186, 627},	//532 KTextEditor::SmartInterface::addActionsToView##
	{50, 190, 614},	//533 KTextEditor::SmartInterface::addHighlightToDocument#
	{50, 191, 613},	//534 KTextEditor::SmartInterface::addHighlightToDocument#$
	{50, 193, 619},	//535 KTextEditor::SmartInterface::addHighlightToView##
	{50, 194, 618},	//536 KTextEditor::SmartInterface::addHighlightToView##$
	{50, 223, 632},	//537 KTextEditor::SmartInterface::attributeDynamic?
	{50, 225, 633},	//538 KTextEditor::SmartInterface::attributeNotDynamic?
	{50, 265, 626},	//539 KTextEditor::SmartInterface::clearDocumentActions
	{50, 266, 617},	//540 KTextEditor::SmartInterface::clearDocumentHighlights
	{50, 270, 582},	//541 KTextEditor::SmartInterface::clearOnDocumentReload
	{50, 271, 587},	//542 KTextEditor::SmartInterface::clearRevision
	{50, 272, 581},	//543 KTextEditor::SmartInterface::clearSmartInterface
	{50, 274, 630},	//544 KTextEditor::SmartInterface::clearViewActions#
	{50, 276, 622},	//545 KTextEditor::SmartInterface::clearViewHighlights#
	{50, 346, 584},	//546 KTextEditor::SmartInterface::currentRevision
	{50, 374, 597},	//547 KTextEditor::SmartInterface::deleteCursors
	{50, 377, 612},	//548 KTextEditor::SmartInterface::deleteRanges
	{50, 388, 625},	//549 KTextEditor::SmartInterface::documentActions
	{50, 392, 616},	//550 KTextEditor::SmartInterface::documentHighlights
	{50, 648, 594},	//551 KTextEditor::SmartInterface::newSmartCursor
	{50, 649, 593},	//552 KTextEditor::SmartInterface::newSmartCursor#
	{50, 650, 592},	//553 KTextEditor::SmartInterface::newSmartCursor#$
	{50, 651, 596},	//554 KTextEditor::SmartInterface::newSmartCursor$$
	{50, 652, 595},	//555 KTextEditor::SmartInterface::newSmartCursor$$$
	{50, 653, 601},	//556 KTextEditor::SmartInterface::newSmartRange
	{50, 654, 600},	//557 KTextEditor::SmartInterface::newSmartRange#
	{50, 655, -7},	//558 KTextEditor::SmartInterface::newSmartRange##
	{50, 656, -11},	//559 KTextEditor::SmartInterface::newSmartRange###
	{50, 657, -14},	//560 KTextEditor::SmartInterface::newSmartRange###$
	{50, 658, 598},	//561 KTextEditor::SmartInterface::newSmartRange##$
	{50, 659, 607},	//562 KTextEditor::SmartInterface::newSmartRange$$$$
	{50, 660, 606},	//563 KTextEditor::SmartInterface::newSmartRange$$$$#
	{50, 661, 605},	//564 KTextEditor::SmartInterface::newSmartRange$$$$#$
	{50, 742, 585},	//565 KTextEditor::SmartInterface::releaseRevision$
	{50, 744, 624},	//566 KTextEditor::SmartInterface::removeActionsFromDocument#
	{50, 746, 628},	//567 KTextEditor::SmartInterface::removeActionsFromView##
	{50, 753, 615},	//568 KTextEditor::SmartInterface::removeHighlightFromDocument#
	{50, 755, 620},	//569 KTextEditor::SmartInterface::removeHighlightFromView##
	{50, 823, 583},	//570 KTextEditor::SmartInterface::setClearOnDocumentReload$
	{50, 946, 580},	//571 KTextEditor::SmartInterface::smartMutex
	{50, 992, -17},	//572 KTextEditor::SmartInterface::translateFromRevision#
	{50, 993, -20},	//573 KTextEditor::SmartInterface::translateFromRevision#$
	{50, 996, 611},	//574 KTextEditor::SmartInterface::unbindSmartRange#
	{50, 1002, 586},	//575 KTextEditor::SmartInterface::useRevision$
	{50, 1010, 629},	//576 KTextEditor::SmartInterface::viewActions#
	{50, 1017, 621},	//577 KTextEditor::SmartInterface::viewHighlights#
	{50, 1069, 579},	//578 KTextEditor::SmartInterface::~SmartInterface
	{51, 54, 634},	//579 KTextEditor::SmartRange::DoNotExpand
	{51, 71, 635},	//580 KTextEditor::SmartRange::ExpandLeft
	{51, 72, 636},	//581 KTextEditor::SmartRange::ExpandRight
	{51, 147, 690},	//582 KTextEditor::SmartRange::SmartRange##
	{51, 148, 689},	//583 KTextEditor::SmartRange::SmartRange###
	{51, 149, 688},	//584 KTextEditor::SmartRange::SmartRange###$
	{51, 198, 680},	//585 KTextEditor::SmartRange::addNotifier#
	{51, 202, 684},	//586 KTextEditor::SmartRange::addWatcher#
	{51, 215, 674},	//587 KTextEditor::SmartRange::associateAction#
	{51, 216, 676},	//588 KTextEditor::SmartRange::associatedActions
	{51, 221, 672},	//589 KTextEditor::SmartRange::attribute
	{51, 249, 692},	//590 KTextEditor::SmartRange::checkFeedback
	{51, 251, 664},	//591 KTextEditor::SmartRange::childAfter#
	{51, 253, 663},	//592 KTextEditor::SmartRange::childBefore#
	{51, 260, 659},	//593 KTextEditor::SmartRange::childRanges
	{51, 262, 662},	//594 KTextEditor::SmartRange::clearAndDeleteChildRanges
	{51, 263, 677},	//595 KTextEditor::SmartRange::clearAssociatedActions
	{51, 264, 660},	//596 KTextEditor::SmartRange::clearChildRanges
	{51, 313, 643},	//597 KTextEditor::SmartRange::confineToRange#
	{51, 332, 693},	//598 KTextEditor::SmartRange::createNotifier
	{51, 365, 669},	//599 KTextEditor::SmartRange::deepestRangeContaining#
	{51, 366, 668},	//600 KTextEditor::SmartRange::deepestRangeContaining#?
	{51, 367, 667},	//601 KTextEditor::SmartRange::deepestRangeContaining#??
	{51, 369, 670},	//602 KTextEditor::SmartRange::deepestRangesContaining#
	{51, 373, 661},	//603 KTextEditor::SmartRange::deleteChildRanges
	{51, 376, 682},	//604 KTextEditor::SmartRange::deletePrimaryNotifier
	{51, 380, 657},	//605 KTextEditor::SmartRange::depth
	{51, 386, 675},	//606 KTextEditor::SmartRange::dissociateAction#
	{51, 387, 645},	//607 KTextEditor::SmartRange::document
	{51, 449, 644},	//608 KTextEditor::SmartRange::expandToRange#
	{51, 453, 666},	//609 KTextEditor::SmartRange::firstRangeContaining#
	{51, 482, 656},	//610 KTextEditor::SmartRange::hasParent#
	{51, 511, 652},	//611 KTextEditor::SmartRange::insertBehavior
	{51, 543, 638},	//612 KTextEditor::SmartRange::isSmartRange
	{51, 628, 665},	//613 KTextEditor::SmartRange::mostSpecificRange#
	{51, 663, 679},	//614 KTextEditor::SmartRange::notifiers
	{51, 674, -23},	//615 KTextEditor::SmartRange::operator=#
	{51, 676, 671},	//616 KTextEditor::SmartRange::overlapCount
	{51, 690, 654},	//617 KTextEditor::SmartRange::parentRange
	{51, 708, 678},	//618 KTextEditor::SmartRange::primaryNotifier
	{51, 720, 691},	//619 KTextEditor::SmartRange::rangeChanged##
	{51, 736, 694},	//620 KTextEditor::SmartRange::rebuildChildStructure
	{51, 761, 681},	//621 KTextEditor::SmartRange::removeNotifier#
	{51, 767, 651},	//622 KTextEditor::SmartRange::removeText
	{51, 770, 650},	//623 KTextEditor::SmartRange::removeText$
	{51, 774, 685},	//624 KTextEditor::SmartRange::removeWatcher#
	{51, 780, 649},	//625 KTextEditor::SmartRange::replaceText?
	{51, 781, 648},	//626 KTextEditor::SmartRange::replaceText?$
	{51, 811, 673},	//627 KTextEditor::SmartRange::setAttribute?
	{51, 861, 653},	//628 KTextEditor::SmartRange::setInsertBehavior$
	{51, 893, 655},	//629 KTextEditor::SmartRange::setParentRange#
	{51, 898, 640},	//630 KTextEditor::SmartRange::setRange#
	{51, 945, 642},	//631 KTextEditor::SmartRange::smartEnd
	{51, 948, 641},	//632 KTextEditor::SmartRange::smartStart
	{51, 970, 647},	//633 KTextEditor::SmartRange::text
	{51, 973, 646},	//634 KTextEditor::SmartRange::text$
	{51, 988, 639},	//635 KTextEditor::SmartRange::toSmartRange
	{51, 989, 658},	//636 KTextEditor::SmartRange::topParentRange
	{51, 1027, 683},	//637 KTextEditor::SmartRange::watchers
	{51, 1070, 637},	//638 KTextEditor::SmartRange::~SmartRange
	{52, 150, 697},	//639 KTextEditor::SmartRangeNotifier::SmartRangeNotifier
	{52, 237, 706},	//640 KTextEditor::SmartRangeNotifier::caretEnteredRange##
	{52, 239, 707},	//641 KTextEditor::SmartRangeNotifier::caretExitedRange##
	{52, 257, 711},	//642 KTextEditor::SmartRangeNotifier::childRangeInserted##
	{52, 259, 712},	//643 KTextEditor::SmartRangeNotifier::childRangeRemoved##
	{52, 609, 695},	//644 KTextEditor::SmartRangeNotifier::metaObject
	{52, 632, 704},	//645 KTextEditor::SmartRangeNotifier::mouseEnteredRange##
	{52, 634, 705},	//646 KTextEditor::SmartRangeNotifier::mouseExitedRange##
	{52, 692, 710},	//647 KTextEditor::SmartRangeNotifier::parentRangeChanged###
	{52, 712, 696},	//648 KTextEditor::SmartRangeNotifier::qt_metacall$$?
	{52, 718, 713},	//649 KTextEditor::SmartRangeNotifier::rangeAttributeChanged#??
	{52, 722, 702},	//650 KTextEditor::SmartRangeNotifier::rangeContentsChanged#
	{52, 723, 703},	//651 KTextEditor::SmartRangeNotifier::rangeContentsChanged##
	{52, 725, 709},	//652 KTextEditor::SmartRangeNotifier::rangeDeleted#
	{52, 727, 708},	//653 KTextEditor::SmartRangeNotifier::rangeEliminated#
	{52, 729, 701},	//654 KTextEditor::SmartRangeNotifier::rangePositionChanged#
	{52, 926, 699},	//655 KTextEditor::SmartRangeNotifier::setWantsDirectChanges$
	{52, 961, 714},	//656 KTextEditor::SmartRangeNotifier::staticMetaObject
	{52, 1023, 698},	//657 KTextEditor::SmartRangeNotifier::wantsDirectChanges
	{52, 1071, 700},	//658 KTextEditor::SmartRangeNotifier::~SmartRangeNotifier
	{53, 151, 715},	//659 KTextEditor::SmartRangeWatcher::SmartRangeWatcher
	{53, 152, 732},	//660 KTextEditor::SmartRangeWatcher::SmartRangeWatcher#
	{53, 237, 724},	//661 KTextEditor::SmartRangeWatcher::caretEnteredRange##
	{53, 239, 725},	//662 KTextEditor::SmartRangeWatcher::caretExitedRange##
	{53, 257, 729},	//663 KTextEditor::SmartRangeWatcher::childRangeInserted##
	{53, 259, 730},	//664 KTextEditor::SmartRangeWatcher::childRangeRemoved##
	{53, 632, 722},	//665 KTextEditor::SmartRangeWatcher::mouseEnteredRange##
	{53, 634, 723},	//666 KTextEditor::SmartRangeWatcher::mouseExitedRange##
	{53, 692, 728},	//667 KTextEditor::SmartRangeWatcher::parentRangeChanged###
	{53, 718, 731},	//668 KTextEditor::SmartRangeWatcher::rangeAttributeChanged#??
	{53, 722, 720},	//669 KTextEditor::SmartRangeWatcher::rangeContentsChanged#
	{53, 723, 721},	//670 KTextEditor::SmartRangeWatcher::rangeContentsChanged##
	{53, 725, 727},	//671 KTextEditor::SmartRangeWatcher::rangeDeleted#
	{53, 727, 726},	//672 KTextEditor::SmartRangeWatcher::rangeEliminated#
	{53, 729, 719},	//673 KTextEditor::SmartRangeWatcher::rangePositionChanged#
	{53, 926, 718},	//674 KTextEditor::SmartRangeWatcher::setWantsDirectChanges$
	{53, 1023, 717},	//675 KTextEditor::SmartRangeWatcher::wantsDirectChanges
	{53, 1072, 716},	//676 KTextEditor::SmartRangeWatcher::~SmartRangeWatcher
	{54, 157, 733},	//677 KTextEditor::TemplateInterface::TemplateInterface
	{54, 158, 736},	//678 KTextEditor::TemplateInterface::TemplateInterface#
	{54, 447, 737},	//679 KTextEditor::TemplateInterface::expandMacros?#
	{54, 523, 735},	//680 KTextEditor::TemplateInterface::insertTemplateText#$?
	{54, 525, 738},	//681 KTextEditor::TemplateInterface::insertTemplateTextImplementation#$?
	{54, 1073, 734},	//682 KTextEditor::TemplateInterface::~TemplateInterface
	{55, 159, 739},	//683 KTextEditor::TextHintInterface::TextHintInterface
	{55, 160, 744},	//684 KTextEditor::TextHintInterface::TextHintInterface#
	{55, 382, 742},	//685 KTextEditor::TextHintInterface::disableTextHints
	{55, 426, 741},	//686 KTextEditor::TextHintInterface::enableTextHints$
	{55, 647, 743},	//687 KTextEditor::TextHintInterface::needTextHint#$
	{55, 1074, 740},	//688 KTextEditor::TextHintInterface::~TextHintInterface
	{56, 165, 745},	//689 KTextEditor::VariableInterface::VariableInterface
	{56, 166, 749},	//690 KTextEditor::VariableInterface::VariableInterface#
	{56, 1004, 747},	//691 KTextEditor::VariableInterface::variable$
	{56, 1006, 748},	//692 KTextEditor::VariableInterface::variableChanged#$$
	{56, 1075, 746},	//693 KTextEditor::VariableInterface::~VariableInterface
	{57, 57, 750},	//694 KTextEditor::View::EditInsert
	{57, 58, 751},	//695 KTextEditor::View::EditOverwrite
	{57, 168, 754},	//696 KTextEditor::View::View#
	{57, 227, 780},	//697 KTextEditor::View::blockSelection
	{57, 323, 761},	//698 KTextEditor::View::contextMenu
	{57, 325, 788},	//699 KTextEditor::View::contextMenuAboutToShow##
	{57, 351, 765},	//700 KTextEditor::View::cursorPosition
	{57, 353, 789},	//701 KTextEditor::View::cursorPositionChanged##
	{57, 354, 768},	//702 KTextEditor::View::cursorPositionCoordinates
	{57, 355, 766},	//703 KTextEditor::View::cursorPositionVirtual
	{57, 357, 767},	//704 KTextEditor::View::cursorToCoordinate#
	{57, 370, 763},	//705 KTextEditor::View::defaultContextMenu
	{57, 371, 762},	//706 KTextEditor::View::defaultContextMenu#
	{57, 387, 756},	//707 KTextEditor::View::document
	{57, 459, 782},	//708 KTextEditor::View::focusIn#
	{57, 465, 783},	//709 KTextEditor::View::focusOut#
	{57, 501, 791},	//710 KTextEditor::View::horizontalScrollPositionChanged#
	{57, 506, 786},	//711 KTextEditor::View::informationMessage#$
	{57, 531, 781},	//712 KTextEditor::View::insertText$
	{57, 537, 757},	//713 KTextEditor::View::isActiveView
	{57, 609, 752},	//714 KTextEditor::View::metaObject
	{57, 638, 792},	//715 KTextEditor::View::mousePositionChanged##
	{57, 643, 769},	//716 KTextEditor::View::mouseTrackingEnabled
	{57, 712, 753},	//717 KTextEditor::View::qt_metacall$$?
	{57, 765, 777},	//718 KTextEditor::View::removeSelection
	{57, 766, 778},	//719 KTextEditor::View::removeSelectionText
	{57, 799, 774},	//720 KTextEditor::View::selection
	{57, 801, 793},	//721 KTextEditor::View::selectionChanged#
	{57, 802, 775},	//722 KTextEditor::View::selectionRange
	{57, 803, 776},	//723 KTextEditor::View::selectionText
	{57, 817, 779},	//724 KTextEditor::View::setBlockSelection$
	{57, 834, 760},	//725 KTextEditor::View::setContextMenu#
	{57, 836, 764},	//726 KTextEditor::View::setCursorPosition#
	{57, 885, 770},	//727 KTextEditor::View::setMouseTrackingEnabled$
	{57, 911, 771},	//728 KTextEditor::View::setSelection#
	{57, 912, 773},	//729 KTextEditor::View::setSelection#$
	{57, 913, 772},	//730 KTextEditor::View::setSelection#$$
	{57, 961, 794},	//731 KTextEditor::View::staticMetaObject
	{57, 979, 787},	//732 KTextEditor::View::textInserted##$
	{57, 1008, 790},	//733 KTextEditor::View::verticalScrollPositionChanged##
	{57, 1013, 759},	//734 KTextEditor::View::viewEditMode
	{57, 1015, 785},	//735 KTextEditor::View::viewEditModeChanged#$
	{57, 1018, 758},	//736 KTextEditor::View::viewMode
	{57, 1020, 784},	//737 KTextEditor::View::viewModeChanged#
	{57, 1076, 755},	//738 KTextEditor::View::~View
};

static Smoke::Index ktexteditor_ambiguousMethodList[] = {
    0,
    481,  // KTextEditor::Range::Range(const KTextEditor::Cursor&, const KTextEditor::Cursor&)
    516,  // KTextEditor::Range::Range(KTextEditor::Cursor*, KTextEditor::Cursor*)
    0,
    503,  // KTextEditor::Range::contains(const KTextEditor::Cursor&) const
    502,  // KTextEditor::Range::contains(const KTextEditor::Range&) const
    0,
    610,  // KTextEditor::SmartInterface::newSmartRange(KTextEditor::SmartCursor*, KTextEditor::SmartCursor*)
    599,  // KTextEditor::SmartInterface::newSmartRange(const KTextEditor::Range&, KTextEditor::SmartRange*)
    604,  // KTextEditor::SmartInterface::newSmartRange(const KTextEditor::Cursor&, const KTextEditor::Cursor&)
    0,
    603,  // KTextEditor::SmartInterface::newSmartRange(const KTextEditor::Cursor&, const KTextEditor::Cursor&, KTextEditor::SmartRange*)
    609,  // KTextEditor::SmartInterface::newSmartRange(KTextEditor::SmartCursor*, KTextEditor::SmartCursor*, KTextEditor::SmartRange*)
    0,
    602,  // KTextEditor::SmartInterface::newSmartRange(const KTextEditor::Cursor&, const KTextEditor::Cursor&, KTextEditor::SmartRange*, KTextEditor::SmartRange::InsertBehaviors)
    608,  // KTextEditor::SmartInterface::newSmartRange(KTextEditor::SmartCursor*, KTextEditor::SmartCursor*, KTextEditor::SmartRange*, KTextEditor::SmartRange::InsertBehaviors)
    0,
    589,  // KTextEditor::SmartInterface::translateFromRevision(const KTextEditor::Cursor&) const
    591,  // KTextEditor::SmartInterface::translateFromRevision(const KTextEditor::Range&) const
    0,
    588,  // KTextEditor::SmartInterface::translateFromRevision(const KTextEditor::Cursor&, KTextEditor::SmartCursor::InsertBehavior) const
    590,  // KTextEditor::SmartInterface::translateFromRevision(const KTextEditor::Range&, KTextEditor::SmartRange::InsertBehaviors) const
    0,
    687,  // KTextEditor::SmartRange::operator=(const KTextEditor::Range&)
    686,  // KTextEditor::SmartRange::operator=(const KTextEditor::SmartRange&)
    0,
};


void init_qt_Smoke();
void init_kde_Smoke();

static bool initialized = false;
Smoke *ktexteditor_Smoke = 0;

// Create the Smoke instance encapsulating all the above.
void init_ktexteditor_Smoke() {
    if (initialized) return;
    init_qt_Smoke();
    init_kde_Smoke();
    ktexteditor_Smoke = new Smoke(
        "ktexteditor",
        ktexteditor_classes, 112,
        ktexteditor_methods, 909,
        ktexteditor_methodMaps, 738,
        ktexteditor_methodNames, 1076,
        ktexteditor_types, 557,
        ktexteditor_inheritanceList,
        ktexteditor_argumentList,
        ktexteditor_ambiguousMethodList,
        ktexteditor_cast );
    initialized = true;
}
