#include <qcoreevent.h>
#include <qdatetime.h>
#include <qevent.h>
#include <qfont.h>
#include <qframe.h>
#include <qicon.h>
#include <qimage.h>
#include <qline.h>
#include <qnamespace.h>
#include <qobject.h>
#include <qobjectdefs.h>
#include <qpaintdevice.h>
#include <qpaintengine.h>
#include <qpainter.h>
#include <qpainterpath.h>
#include <qpalette.h>
#include <qpixmap.h>
#include <qpoint.h>
#include <qrect.h>
#include <qsize.h>
#include <qstyle.h>
#include <qtextstream.h>
#include <qurl.h>
#include <qvariant.h>
#include <qwidget.h>
#include <nepomuk/class.h>
#include <nepomuk/entity.h>
#include <nepomuk/kmetadatatagcloud.h>
#include <nepomuk/kmetadatatagwidget.h>
#include <nepomuk/kratingpainter.h>
#include <nepomuk/kratingwidget.h>
#include <nepomuk/ktagcloudwidget.h>
#include <nepomuk/ktagdisplaywidget.h>
#include <nepomuk/literal.h>
#include <nepomuk/nepomukservice.h>
#include <nepomuk/ontology.h>
#include <nepomuk/property.h>
#include <nepomuk/resource.h>
#include <nepomuk/resourcemanager.h>
#include <nepomuk/tag.h>
#include <nepomuk/thing.h>
#include <nepomuk/variant.h>
#include <soprano/indexfiltermodel.h>
#include <soprano/locator.h>
#include <soprano/model.h>
#include <soprano/node.h>
#include <soprano/nodeiterator.h>
#include <soprano/queryresultiterator.h>
#include <soprano/statement.h>
#include <soprano/statementiterator.h>

#include <smoke.h>

#include <nepomuk_smoke.h>

static void *nepomuk_cast(void *xptr, Smoke::Index from, Smoke::Index to) {
    switch(from) {
      case 1:	//KRatingPainter
	switch(to) {
	    case 1: return (void*)(KRatingPainter*)(KRatingPainter*)xptr;
	  default: return xptr;
	}
      case 2:	//KRatingWidget
	switch(to) {
	    case 34: return (void*)(QFrame*)(KRatingWidget*)xptr;
	    case 69: return (void*)(QWidget*)(KRatingWidget*)xptr;
	    case 45: return (void*)(QObject*)(KRatingWidget*)xptr;
	    case 46: return (void*)(QPaintDevice*)(KRatingWidget*)xptr;
	    case 2: return (void*)(KRatingWidget*)(KRatingWidget*)xptr;
	  default: return xptr;
	}
      case 3:	//KTagCloudWidget
	switch(to) {
	    case 69: return (void*)(QWidget*)(KTagCloudWidget*)xptr;
	    case 45: return (void*)(QObject*)(KTagCloudWidget*)xptr;
	    case 46: return (void*)(QPaintDevice*)(KTagCloudWidget*)xptr;
	    case 3: return (void*)(KTagCloudWidget*)(KTagCloudWidget*)xptr;
	    case 11: return (void*)(Nepomuk::TagCloud*)(KTagCloudWidget*)xptr;
	  default: return xptr;
	}
      case 4:	//KTagDisplayWidget
	switch(to) {
	    case 69: return (void*)(QWidget*)(KTagDisplayWidget*)xptr;
	    case 45: return (void*)(QObject*)(KTagDisplayWidget*)xptr;
	    case 46: return (void*)(QPaintDevice*)(KTagDisplayWidget*)xptr;
	    case 4: return (void*)(KTagDisplayWidget*)(KTagDisplayWidget*)xptr;
	  default: return xptr;
	}
      case 7:	//Nepomuk::Resource
	switch(to) {
	    case 7: return (void*)(Nepomuk::Resource*)(Nepomuk::Resource*)xptr;
	    case 10: return (void*)(Nepomuk::Tag*)(Nepomuk::Resource*)xptr;
	    case 13: return (void*)(Nepomuk::Thing*)(Nepomuk::Resource*)xptr;
	  default: return xptr;
	}
      case 8:	//Nepomuk::ResourceManager
	switch(to) {
	    case 45: return (void*)(QObject*)(Nepomuk::ResourceManager*)xptr;
	    case 8: return (void*)(Nepomuk::ResourceManager*)(Nepomuk::ResourceManager*)xptr;
	  default: return xptr;
	}
      case 9:	//Nepomuk::Service
	switch(to) {
	    case 45: return (void*)(QObject*)(Nepomuk::Service*)xptr;
	    case 9: return (void*)(Nepomuk::Service*)(Nepomuk::Service*)xptr;
	  default: return xptr;
	}
      case 10:	//Nepomuk::Tag
	switch(to) {
	    case 7: return (void*)(Nepomuk::Resource*)(Nepomuk::Tag*)xptr;
	    case 10: return (void*)(Nepomuk::Tag*)(Nepomuk::Tag*)xptr;
	  default: return xptr;
	}
      case 11:	//Nepomuk::TagCloud
	switch(to) {
	    case 3: return (void*)(KTagCloudWidget*)(Nepomuk::TagCloud*)xptr;
	    case 69: return (void*)(QWidget*)(Nepomuk::TagCloud*)xptr;
	    case 45: return (void*)(QObject*)(Nepomuk::TagCloud*)xptr;
	    case 46: return (void*)(QPaintDevice*)(Nepomuk::TagCloud*)xptr;
	    case 11: return (void*)(Nepomuk::TagCloud*)(Nepomuk::TagCloud*)xptr;
	  default: return xptr;
	}
      case 12:	//Nepomuk::TagWidget
	switch(to) {
	    case 69: return (void*)(QWidget*)(Nepomuk::TagWidget*)xptr;
	    case 45: return (void*)(QObject*)(Nepomuk::TagWidget*)xptr;
	    case 46: return (void*)(QPaintDevice*)(Nepomuk::TagWidget*)xptr;
	    case 12: return (void*)(Nepomuk::TagWidget*)(Nepomuk::TagWidget*)xptr;
	  default: return xptr;
	}
      case 13:	//Nepomuk::Thing
	switch(to) {
	    case 7: return (void*)(Nepomuk::Resource*)(Nepomuk::Thing*)xptr;
	    case 13: return (void*)(Nepomuk::Thing*)(Nepomuk::Thing*)xptr;
	  default: return xptr;
	}
      case 15:	//Nepomuk::Types::Class
	switch(to) {
	    case 16: return (void*)(Nepomuk::Types::Entity*)(Nepomuk::Types::Class*)xptr;
	    case 15: return (void*)(Nepomuk::Types::Class*)(Nepomuk::Types::Class*)xptr;
	  default: return xptr;
	}
      case 16:	//Nepomuk::Types::Entity
	switch(to) {
	    case 16: return (void*)(Nepomuk::Types::Entity*)(Nepomuk::Types::Entity*)xptr;
	    case 15: return (void*)(Nepomuk::Types::Class*)(Nepomuk::Types::Entity*)xptr;
	    case 18: return (void*)(Nepomuk::Types::Ontology*)(Nepomuk::Types::Entity*)xptr;
	    case 19: return (void*)(Nepomuk::Types::Property*)(Nepomuk::Types::Entity*)xptr;
	  default: return xptr;
	}
      case 17:	//Nepomuk::Types::Literal
	switch(to) {
	    case 17: return (void*)(Nepomuk::Types::Literal*)(Nepomuk::Types::Literal*)xptr;
	  default: return xptr;
	}
      case 18:	//Nepomuk::Types::Ontology
	switch(to) {
	    case 16: return (void*)(Nepomuk::Types::Entity*)(Nepomuk::Types::Ontology*)xptr;
	    case 18: return (void*)(Nepomuk::Types::Ontology*)(Nepomuk::Types::Ontology*)xptr;
	  default: return xptr;
	}
      case 19:	//Nepomuk::Types::Property
	switch(to) {
	    case 16: return (void*)(Nepomuk::Types::Entity*)(Nepomuk::Types::Property*)xptr;
	    case 19: return (void*)(Nepomuk::Types::Property*)(Nepomuk::Types::Property*)xptr;
	  default: return xptr;
	}
      case 20:	//Nepomuk::Variant
	switch(to) {
	    case 20: return (void*)(Nepomuk::Variant*)(Nepomuk::Variant*)xptr;
	  default: return xptr;
	}
      case 21:	//QActionEvent
	switch(to) {
	    case 31: return (void*)(QEvent*)(QActionEvent*)xptr;
	    case 21: return (void*)(QActionEvent*)(QActionEvent*)xptr;
	  default: return xptr;
	}
      case 22:	//QChildEvent
	switch(to) {
	    case 31: return (void*)(QEvent*)(QChildEvent*)xptr;
	    case 22: return (void*)(QChildEvent*)(QChildEvent*)xptr;
	  default: return xptr;
	}
      case 23:	//QCloseEvent
	switch(to) {
	    case 31: return (void*)(QEvent*)(QCloseEvent*)xptr;
	    case 23: return (void*)(QCloseEvent*)(QCloseEvent*)xptr;
	  default: return xptr;
	}
      case 24:	//QContextMenuEvent
	switch(to) {
	    case 31: return (void*)(QEvent*)(QContextMenuEvent*)xptr;
	    case 24: return (void*)(QContextMenuEvent*)(QContextMenuEvent*)xptr;
	  default: return xptr;
	}
      case 25:	//QDate
	switch(to) {
	    case 25: return (void*)(QDate*)(QDate*)xptr;
	  default: return xptr;
	}
      case 26:	//QDateTime
	switch(to) {
	    case 26: return (void*)(QDateTime*)(QDateTime*)xptr;
	  default: return xptr;
	}
      case 27:	//QDragEnterEvent
	switch(to) {
	    case 29: return (void*)(QDragMoveEvent*)(QDragEnterEvent*)xptr;
	    case 30: return (void*)(QDropEvent*)(QDragEnterEvent*)xptr;
	    case 31: return (void*)(QEvent*)(QDragEnterEvent*)xptr;
	    case 27: return (void*)(QDragEnterEvent*)(QDragEnterEvent*)xptr;
	  default: return xptr;
	}
      case 28:	//QDragLeaveEvent
	switch(to) {
	    case 31: return (void*)(QEvent*)(QDragLeaveEvent*)xptr;
	    case 28: return (void*)(QDragLeaveEvent*)(QDragLeaveEvent*)xptr;
	  default: return xptr;
	}
      case 29:	//QDragMoveEvent
	switch(to) {
	    case 30: return (void*)(QDropEvent*)(QDragMoveEvent*)xptr;
	    case 31: return (void*)(QEvent*)(QDragMoveEvent*)xptr;
	    case 29: return (void*)(QDragMoveEvent*)(QDragMoveEvent*)xptr;
	    case 27: return (void*)(QDragEnterEvent*)(QDragMoveEvent*)xptr;
	  default: return xptr;
	}
      case 30:	//QDropEvent
	switch(to) {
	    case 31: return (void*)(QEvent*)(QDropEvent*)xptr;
	    case 30: return (void*)(QDropEvent*)(QDropEvent*)xptr;
	    case 27: return (void*)(QDragEnterEvent*)(QDropEvent*)xptr;
	    case 29: return (void*)(QDragMoveEvent*)(QDropEvent*)xptr;
	  default: return xptr;
	}
      case 31:	//QEvent
	switch(to) {
	    case 31: return (void*)(QEvent*)(QEvent*)xptr;
	    case 21: return (void*)(QActionEvent*)(QEvent*)xptr;
	    case 22: return (void*)(QChildEvent*)(QEvent*)xptr;
	    case 23: return (void*)(QCloseEvent*)(QEvent*)xptr;
	    case 24: return (void*)(QContextMenuEvent*)(QEvent*)xptr;
	    case 27: return (void*)(QDragEnterEvent*)(QEvent*)xptr;
	    case 28: return (void*)(QDragLeaveEvent*)(QEvent*)xptr;
	    case 29: return (void*)(QDragMoveEvent*)(QEvent*)xptr;
	    case 30: return (void*)(QDropEvent*)(QEvent*)xptr;
	    case 32: return (void*)(QFocusEvent*)(QEvent*)xptr;
	    case 35: return (void*)(QHideEvent*)(QEvent*)xptr;
	    case 38: return (void*)(QInputMethodEvent*)(QEvent*)xptr;
	    case 39: return (void*)(QKeyEvent*)(QEvent*)xptr;
	    case 43: return (void*)(QMouseEvent*)(QEvent*)xptr;
	    case 44: return (void*)(QMoveEvent*)(QEvent*)xptr;
	    case 49: return (void*)(QPaintEvent*)(QEvent*)xptr;
	    case 58: return (void*)(QResizeEvent*)(QEvent*)xptr;
	    case 59: return (void*)(QShowEvent*)(QEvent*)xptr;
	    case 62: return (void*)(QTabletEvent*)(QEvent*)xptr;
	    case 65: return (void*)(QTimerEvent*)(QEvent*)xptr;
	    case 68: return (void*)(QWheelEvent*)(QEvent*)xptr;
	  default: return xptr;
	}
      case 32:	//QFocusEvent
	switch(to) {
	    case 31: return (void*)(QEvent*)(QFocusEvent*)xptr;
	    case 32: return (void*)(QFocusEvent*)(QFocusEvent*)xptr;
	  default: return xptr;
	}
      case 33:	//QFont
	switch(to) {
	    case 33: return (void*)(QFont*)(QFont*)xptr;
	  default: return xptr;
	}
      case 34:	//QFrame
	switch(to) {
	    case 69: return (void*)(QWidget*)(QFrame*)xptr;
	    case 45: return (void*)(QObject*)(QFrame*)xptr;
	    case 46: return (void*)(QPaintDevice*)(QFrame*)xptr;
	    case 34: return (void*)(QFrame*)(QFrame*)xptr;
	    case 2: return (void*)(KRatingWidget*)(QFrame*)xptr;
	  default: return xptr;
	}
      case 35:	//QHideEvent
	switch(to) {
	    case 31: return (void*)(QEvent*)(QHideEvent*)xptr;
	    case 35: return (void*)(QHideEvent*)(QHideEvent*)xptr;
	  default: return xptr;
	}
      case 36:	//QIcon
	switch(to) {
	    case 36: return (void*)(QIcon*)(QIcon*)xptr;
	  default: return xptr;
	}
      case 37:	//QImage
	switch(to) {
	    case 46: return (void*)(QPaintDevice*)(QImage*)xptr;
	    case 37: return (void*)(QImage*)(QImage*)xptr;
	  default: return xptr;
	}
      case 38:	//QInputMethodEvent
	switch(to) {
	    case 31: return (void*)(QEvent*)(QInputMethodEvent*)xptr;
	    case 38: return (void*)(QInputMethodEvent*)(QInputMethodEvent*)xptr;
	  default: return xptr;
	}
      case 39:	//QKeyEvent
	switch(to) {
	    case 31: return (void*)(QEvent*)(QKeyEvent*)xptr;
	    case 39: return (void*)(QKeyEvent*)(QKeyEvent*)xptr;
	  default: return xptr;
	}
      case 40:	//QLine
	switch(to) {
	    case 40: return (void*)(QLine*)(QLine*)xptr;
	  default: return xptr;
	}
      case 41:	//QLineF
	switch(to) {
	    case 41: return (void*)(QLineF*)(QLineF*)xptr;
	  default: return xptr;
	}
      case 42:	//QMetaObject
	switch(to) {
	    case 42: return (void*)(QMetaObject*)(QMetaObject*)xptr;
	  default: return xptr;
	}
      case 43:	//QMouseEvent
	switch(to) {
	    case 31: return (void*)(QEvent*)(QMouseEvent*)xptr;
	    case 43: return (void*)(QMouseEvent*)(QMouseEvent*)xptr;
	  default: return xptr;
	}
      case 44:	//QMoveEvent
	switch(to) {
	    case 31: return (void*)(QEvent*)(QMoveEvent*)xptr;
	    case 44: return (void*)(QMoveEvent*)(QMoveEvent*)xptr;
	  default: return xptr;
	}
      case 45:	//QObject
	switch(to) {
	    case 45: return (void*)(QObject*)(QObject*)xptr;
	    case 2: return (void*)(KRatingWidget*)(QObject*)xptr;
	    case 3: return (void*)(KTagCloudWidget*)(QObject*)xptr;
	    case 4: return (void*)(KTagDisplayWidget*)(QObject*)xptr;
	    case 8: return (void*)(Nepomuk::ResourceManager*)(QObject*)xptr;
	    case 9: return (void*)(Nepomuk::Service*)(QObject*)xptr;
	    case 11: return (void*)(Nepomuk::TagCloud*)(QObject*)xptr;
	    case 12: return (void*)(Nepomuk::TagWidget*)(QObject*)xptr;
	    case 34: return (void*)(QFrame*)(QObject*)xptr;
	    case 61: return (void*)(QStyle*)(QObject*)xptr;
	    case 69: return (void*)(QWidget*)(QObject*)xptr;
	    case 73: return (void*)(Soprano::Model*)(QObject*)xptr;
	  default: return xptr;
	}
      case 46:	//QPaintDevice
	switch(to) {
	    case 46: return (void*)(QPaintDevice*)(QPaintDevice*)xptr;
	    case 2: return (void*)(KRatingWidget*)(QPaintDevice*)xptr;
	    case 3: return (void*)(KTagCloudWidget*)(QPaintDevice*)xptr;
	    case 4: return (void*)(KTagDisplayWidget*)(QPaintDevice*)xptr;
	    case 11: return (void*)(Nepomuk::TagCloud*)(QPaintDevice*)xptr;
	    case 12: return (void*)(Nepomuk::TagWidget*)(QPaintDevice*)xptr;
	    case 34: return (void*)(QFrame*)(QPaintDevice*)xptr;
	    case 37: return (void*)(QImage*)(QPaintDevice*)xptr;
	    case 53: return (void*)(QPixmap*)(QPaintDevice*)xptr;
	    case 69: return (void*)(QWidget*)(QPaintDevice*)xptr;
	  default: return xptr;
	}
      case 47:	//QPaintEngine
	switch(to) {
	    case 47: return (void*)(QPaintEngine*)(QPaintEngine*)xptr;
	  default: return xptr;
	}
      case 48:	//QPaintEngineState
	switch(to) {
	    case 48: return (void*)(QPaintEngineState*)(QPaintEngineState*)xptr;
	  default: return xptr;
	}
      case 49:	//QPaintEvent
	switch(to) {
	    case 31: return (void*)(QEvent*)(QPaintEvent*)xptr;
	    case 49: return (void*)(QPaintEvent*)(QPaintEvent*)xptr;
	  default: return xptr;
	}
      case 50:	//QPainter
	switch(to) {
	    case 50: return (void*)(QPainter*)(QPainter*)xptr;
	  default: return xptr;
	}
      case 51:	//QPainterPath
	switch(to) {
	    case 51: return (void*)(QPainterPath*)(QPainterPath*)xptr;
	  default: return xptr;
	}
      case 52:	//QPalette
	switch(to) {
	    case 52: return (void*)(QPalette*)(QPalette*)xptr;
	  default: return xptr;
	}
      case 53:	//QPixmap
	switch(to) {
	    case 46: return (void*)(QPaintDevice*)(QPixmap*)xptr;
	    case 53: return (void*)(QPixmap*)(QPixmap*)xptr;
	  default: return xptr;
	}
      case 54:	//QPoint
	switch(to) {
	    case 54: return (void*)(QPoint*)(QPoint*)xptr;
	  default: return xptr;
	}
      case 55:	//QPointF
	switch(to) {
	    case 55: return (void*)(QPointF*)(QPointF*)xptr;
	  default: return xptr;
	}
      case 56:	//QRect
	switch(to) {
	    case 56: return (void*)(QRect*)(QRect*)xptr;
	  default: return xptr;
	}
      case 57:	//QRectF
	switch(to) {
	    case 57: return (void*)(QRectF*)(QRectF*)xptr;
	  default: return xptr;
	}
      case 58:	//QResizeEvent
	switch(to) {
	    case 31: return (void*)(QEvent*)(QResizeEvent*)xptr;
	    case 58: return (void*)(QResizeEvent*)(QResizeEvent*)xptr;
	  default: return xptr;
	}
      case 59:	//QShowEvent
	switch(to) {
	    case 31: return (void*)(QEvent*)(QShowEvent*)xptr;
	    case 59: return (void*)(QShowEvent*)(QShowEvent*)xptr;
	  default: return xptr;
	}
      case 60:	//QSize
	switch(to) {
	    case 60: return (void*)(QSize*)(QSize*)xptr;
	  default: return xptr;
	}
      case 61:	//QStyle
	switch(to) {
	    case 45: return (void*)(QObject*)(QStyle*)xptr;
	    case 61: return (void*)(QStyle*)(QStyle*)xptr;
	  default: return xptr;
	}
      case 62:	//QTabletEvent
	switch(to) {
	    case 31: return (void*)(QEvent*)(QTabletEvent*)xptr;
	    case 62: return (void*)(QTabletEvent*)(QTabletEvent*)xptr;
	  default: return xptr;
	}
      case 63:	//QTextStream
	switch(to) {
	    case 63: return (void*)(QTextStream*)(QTextStream*)xptr;
	  default: return xptr;
	}
      case 64:	//QTime
	switch(to) {
	    case 64: return (void*)(QTime*)(QTime*)xptr;
	  default: return xptr;
	}
      case 65:	//QTimerEvent
	switch(to) {
	    case 31: return (void*)(QEvent*)(QTimerEvent*)xptr;
	    case 65: return (void*)(QTimerEvent*)(QTimerEvent*)xptr;
	  default: return xptr;
	}
      case 66:	//QUrl
	switch(to) {
	    case 66: return (void*)(QUrl*)(QUrl*)xptr;
	  default: return xptr;
	}
      case 67:	//QVariant
	switch(to) {
	    case 67: return (void*)(QVariant*)(QVariant*)xptr;
	  default: return xptr;
	}
      case 68:	//QWheelEvent
	switch(to) {
	    case 31: return (void*)(QEvent*)(QWheelEvent*)xptr;
	    case 68: return (void*)(QWheelEvent*)(QWheelEvent*)xptr;
	  default: return xptr;
	}
      case 69:	//QWidget
	switch(to) {
	    case 45: return (void*)(QObject*)(QWidget*)xptr;
	    case 46: return (void*)(QPaintDevice*)(QWidget*)xptr;
	    case 69: return (void*)(QWidget*)(QWidget*)xptr;
	    case 2: return (void*)(KRatingWidget*)(QWidget*)xptr;
	    case 3: return (void*)(KTagCloudWidget*)(QWidget*)xptr;
	    case 4: return (void*)(KTagDisplayWidget*)(QWidget*)xptr;
	    case 11: return (void*)(Nepomuk::TagCloud*)(QWidget*)xptr;
	    case 12: return (void*)(Nepomuk::TagWidget*)(QWidget*)xptr;
	    case 34: return (void*)(QFrame*)(QWidget*)xptr;
	  default: return xptr;
	}
      case 73:	//Soprano::Model
	switch(to) {
	    case 45: return (void*)(QObject*)(Soprano::Model*)xptr;
	    case 73: return (void*)(Soprano::Model*)(Soprano::Model*)xptr;
	  default: return xptr;
	}
      case 74:	//Soprano::Node
	switch(to) {
	    case 74: return (void*)(Soprano::Node*)(Soprano::Node*)xptr;
	  default: return xptr;
	}
      case 75:	//Soprano::NodeIterator
	switch(to) {
	    case 75: return (void*)(Soprano::NodeIterator*)(Soprano::NodeIterator*)xptr;
	  default: return xptr;
	}
      case 77:	//Soprano::QueryResultIterator
	switch(to) {
	    case 77: return (void*)(Soprano::QueryResultIterator*)(Soprano::QueryResultIterator*)xptr;
	  default: return xptr;
	}
      case 78:	//Soprano::Statement
	switch(to) {
	    case 78: return (void*)(Soprano::Statement*)(Soprano::Statement*)xptr;
	  default: return xptr;
	}
      case 79:	//Soprano::StatementIterator
	switch(to) {
	    case 79: return (void*)(Soprano::StatementIterator*)(Soprano::StatementIterator*)xptr;
	  default: return xptr;
	}
      default: return xptr;
    }
}

// Group of Indexes (0 separated) used as super class lists.
// Classes with super classes have an index into this array.
static Smoke::Index nepomuk_inheritanceList[] = {
	0,	// 0: (no super class)
	34, 0,	// 1: QFrame
	69, 0,	// 3: QWidget
	45, 0,	// 5: QObject
	7, 0,	// 7: Nepomuk::Resource
	3, 0,	// 9: KTagCloudWidget
	16, 0,	// 11: Nepomuk::Types::Entity
};

// These are the xenum functions for manipulating enum pointers
void xenum_Nepomuk(Smoke::EnumOperation, Smoke::Index, void*&, long&);

// Those are the xcall functions defined in each x_*.cpp file, for dispatching method calls
void xcall_KRatingPainter(Smoke::Index, void*, Smoke::Stack);
void xcall_KRatingWidget(Smoke::Index, void*, Smoke::Stack);
void xcall_KTagCloudWidget(Smoke::Index, void*, Smoke::Stack);
void xcall_KTagDisplayWidget(Smoke::Index, void*, Smoke::Stack);
void xcall_Nepomuk(Smoke::Index, void*, Smoke::Stack);
void xcall_Nepomuk__Middleware(Smoke::Index, void*, Smoke::Stack);
void xcall_Nepomuk__Resource(Smoke::Index, void*, Smoke::Stack);
void xcall_Nepomuk__ResourceManager(Smoke::Index, void*, Smoke::Stack);
void xcall_Nepomuk__Service(Smoke::Index, void*, Smoke::Stack);
void xcall_Nepomuk__Tag(Smoke::Index, void*, Smoke::Stack);
void xcall_Nepomuk__TagCloud(Smoke::Index, void*, Smoke::Stack);
void xcall_Nepomuk__TagWidget(Smoke::Index, void*, Smoke::Stack);
void xcall_Nepomuk__Thing(Smoke::Index, void*, Smoke::Stack);
void xcall_Nepomuk__Types(Smoke::Index, void*, Smoke::Stack);
void xcall_Nepomuk__Types__Class(Smoke::Index, void*, Smoke::Stack);
void xcall_Nepomuk__Types__Entity(Smoke::Index, void*, Smoke::Stack);
void xcall_Nepomuk__Types__Literal(Smoke::Index, void*, Smoke::Stack);
void xcall_Nepomuk__Types__Ontology(Smoke::Index, void*, Smoke::Stack);
void xcall_Nepomuk__Types__Property(Smoke::Index, void*, Smoke::Stack);
void xcall_Nepomuk__Variant(Smoke::Index, void*, Smoke::Stack);

// List of all classes
// Name, index into inheritanceList, method dispatcher, enum dispatcher, class flags
static Smoke::Class nepomuk_classes[] = {
	{ 0L, false, 0, 0, 0, 0 }, 	// 0 (no class)
	{ "KRatingPainter", false, 0, xcall_KRatingPainter, 0, Smoke::cf_constructor|Smoke::cf_deepcopy }, 	//1
	{ "KRatingWidget", false, 1, xcall_KRatingWidget, 0, Smoke::cf_constructor|Smoke::cf_virtual }, 	//2
	{ "KTagCloudWidget", false, 3, xcall_KTagCloudWidget, 0, Smoke::cf_constructor|Smoke::cf_virtual }, 	//3
	{ "KTagDisplayWidget", false, 3, xcall_KTagDisplayWidget, 0, Smoke::cf_constructor|Smoke::cf_virtual }, 	//4
	{ "Nepomuk", false, 0, xcall_Nepomuk, xenum_Nepomuk, Smoke::cf_deepcopy }, 	//5
	{ "Nepomuk::Middleware", false, 0, xcall_Nepomuk__Middleware, 0, Smoke::cf_deepcopy }, 	//6
	{ "Nepomuk::Resource", false, 0, xcall_Nepomuk__Resource, 0, Smoke::cf_constructor|Smoke::cf_deepcopy|Smoke::cf_virtual }, 	//7
	{ "Nepomuk::ResourceManager", false, 5, xcall_Nepomuk__ResourceManager, 0, Smoke::cf_virtual }, 	//8
	{ "Nepomuk::Service", false, 5, xcall_Nepomuk__Service, 0, Smoke::cf_constructor|Smoke::cf_virtual }, 	//9
	{ "Nepomuk::Tag", false, 7, xcall_Nepomuk__Tag, 0, Smoke::cf_constructor|Smoke::cf_deepcopy|Smoke::cf_virtual }, 	//10
	{ "Nepomuk::TagCloud", false, 9, xcall_Nepomuk__TagCloud, 0, Smoke::cf_constructor|Smoke::cf_virtual }, 	//11
	{ "Nepomuk::TagWidget", false, 3, xcall_Nepomuk__TagWidget, 0, Smoke::cf_constructor|Smoke::cf_virtual }, 	//12
	{ "Nepomuk::Thing", false, 7, xcall_Nepomuk__Thing, 0, Smoke::cf_constructor|Smoke::cf_deepcopy|Smoke::cf_virtual }, 	//13
	{ "Nepomuk::Types", false, 0, xcall_Nepomuk__Types, 0, Smoke::cf_deepcopy }, 	//14
	{ "Nepomuk::Types::Class", false, 11, xcall_Nepomuk__Types__Class, 0, Smoke::cf_constructor|Smoke::cf_deepcopy|Smoke::cf_virtual }, 	//15
	{ "Nepomuk::Types::Entity", false, 0, xcall_Nepomuk__Types__Entity, 0, Smoke::cf_constructor|Smoke::cf_deepcopy|Smoke::cf_virtual }, 	//16
	{ "Nepomuk::Types::Literal", false, 0, xcall_Nepomuk__Types__Literal, 0, Smoke::cf_constructor|Smoke::cf_deepcopy }, 	//17
	{ "Nepomuk::Types::Ontology", false, 11, xcall_Nepomuk__Types__Ontology, 0, Smoke::cf_constructor|Smoke::cf_deepcopy|Smoke::cf_virtual }, 	//18
	{ "Nepomuk::Types::Property", false, 11, xcall_Nepomuk__Types__Property, 0, Smoke::cf_constructor|Smoke::cf_deepcopy|Smoke::cf_virtual }, 	//19
	{ "Nepomuk::Variant", false, 0, xcall_Nepomuk__Variant, 0, Smoke::cf_constructor|Smoke::cf_deepcopy }, 	//20
	{ "QActionEvent", true, 0, 0, 0, 0 }, 	// 21
	{ "QChildEvent", true, 0, 0, 0, 0 }, 	// 22
	{ "QCloseEvent", true, 0, 0, 0, 0 }, 	// 23
	{ "QContextMenuEvent", true, 0, 0, 0, 0 }, 	// 24
	{ "QDate", true, 0, 0, 0, 0 }, 	// 25
	{ "QDateTime", true, 0, 0, 0, 0 }, 	// 26
	{ "QDragEnterEvent", true, 0, 0, 0, 0 }, 	// 27
	{ "QDragLeaveEvent", true, 0, 0, 0, 0 }, 	// 28
	{ "QDragMoveEvent", true, 0, 0, 0, 0 }, 	// 29
	{ "QDropEvent", true, 0, 0, 0, 0 }, 	// 30
	{ "QEvent", true, 0, 0, 0, 0 }, 	// 31
	{ "QFocusEvent", true, 0, 0, 0, 0 }, 	// 32
	{ "QFont", true, 0, 0, 0, 0 }, 	// 33
	{ "QFrame", true, 0, 0, 0, 0 }, 	// 34
	{ "QHideEvent", true, 0, 0, 0, 0 }, 	// 35
	{ "QIcon", true, 0, 0, 0, 0 }, 	// 36
	{ "QImage", true, 0, 0, 0, 0 }, 	// 37
	{ "QInputMethodEvent", true, 0, 0, 0, 0 }, 	// 38
	{ "QKeyEvent", true, 0, 0, 0, 0 }, 	// 39
	{ "QLine", true, 0, 0, 0, 0 }, 	// 40
	{ "QLineF", true, 0, 0, 0, 0 }, 	// 41
	{ "QMetaObject", true, 0, 0, 0, 0 }, 	// 42
	{ "QMouseEvent", true, 0, 0, 0, 0 }, 	// 43
	{ "QMoveEvent", true, 0, 0, 0, 0 }, 	// 44
	{ "QObject", true, 0, 0, 0, 0 }, 	// 45
	{ "QPaintDevice", true, 0, 0, 0, 0 }, 	// 46
	{ "QPaintEngine", true, 0, 0, 0, 0 }, 	// 47
	{ "QPaintEngineState", true, 0, 0, 0, 0 }, 	// 48
	{ "QPaintEvent", true, 0, 0, 0, 0 }, 	// 49
	{ "QPainter", true, 0, 0, 0, 0 }, 	// 50
	{ "QPainterPath", true, 0, 0, 0, 0 }, 	// 51
	{ "QPalette", true, 0, 0, 0, 0 }, 	// 52
	{ "QPixmap", true, 0, 0, 0, 0 }, 	// 53
	{ "QPoint", true, 0, 0, 0, 0 }, 	// 54
	{ "QPointF", true, 0, 0, 0, 0 }, 	// 55
	{ "QRect", true, 0, 0, 0, 0 }, 	// 56
	{ "QRectF", true, 0, 0, 0, 0 }, 	// 57
	{ "QResizeEvent", true, 0, 0, 0, 0 }, 	// 58
	{ "QShowEvent", true, 0, 0, 0, 0 }, 	// 59
	{ "QSize", true, 0, 0, 0, 0 }, 	// 60
	{ "QStyle", true, 0, 0, 0, 0 }, 	// 61
	{ "QTabletEvent", true, 0, 0, 0, 0 }, 	// 62
	{ "QTextStream", true, 0, 0, 0, 0 }, 	// 63
	{ "QTime", true, 0, 0, 0, 0 }, 	// 64
	{ "QTimerEvent", true, 0, 0, 0, 0 }, 	// 65
	{ "QUrl", true, 0, 0, 0, 0 }, 	// 66
	{ "QVariant", true, 0, 0, 0, 0 }, 	// 67
	{ "QWheelEvent", true, 0, 0, 0, 0 }, 	// 68
	{ "QWidget", true, 0, 0, 0, 0 }, 	// 69
	{ "Qt", true, 0, 0, 0, 0 }, 	// 70
	{ "Soprano", true, 0, 0, 0, 0 }, 	// 71
	{ "Soprano::Error", true, 0, 0, 0, 0 }, 	// 72
	{ "Soprano::Model", true, 0, 0, 0, 0 }, 	// 73
	{ "Soprano::Node", true, 0, 0, 0, 0 }, 	// 74
	{ "Soprano::NodeIterator", true, 0, 0, 0, 0 }, 	// 75
	{ "Soprano::Query", true, 0, 0, 0, 0 }, 	// 76
	{ "Soprano::QueryResultIterator", true, 0, 0, 0, 0 }, 	// 77
	{ "Soprano::Statement", true, 0, 0, 0, 0 }, 	// 78
	{ "Soprano::StatementIterator", true, 0, 0, 0, 0 }, 	// 79
};

// List of all types needed by the methods (arguments and return values)
// Name, class ID if arg is a class, and TypeId
static Smoke::Type nepomuk_types[] = {
	{ 0, 0, 0 },	//0 (no type)
	{ "KAction::ShortcutTypes", 0, Smoke::t_uint | Smoke::tf_stack },	//1
	{ "KAction::ShortcutTypes&", 0, Smoke::t_voidp | Smoke::tf_ref },	//2
	{ "KAutostart::Conditions", 0, Smoke::t_uint | Smoke::tf_stack },	//3
	{ "KAutostart::Conditions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//4
	{ "KCModule::Buttons", 0, Smoke::t_uint | Smoke::tf_stack },	//5
	{ "KCModule::Buttons&", 0, Smoke::t_voidp | Smoke::tf_ref },	//6
	{ "KCmdLineArgs::StdCmdLineArgs", 0, Smoke::t_uint | Smoke::tf_stack },	//7
	{ "KCmdLineArgs::StdCmdLineArgs&", 0, Smoke::t_voidp | Smoke::tf_ref },	//8
	{ "KConfig::OpenFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//9
	{ "KConfig::OpenFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//10
	{ "KConfigBase::WriteConfigFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//11
	{ "KConfigBase::WriteConfigFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//12
	{ "KCrash::CrashFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//13
	{ "KCrash::CrashFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//14
	{ "KDialog::ButtonCodes", 0, Smoke::t_uint | Smoke::tf_stack },	//15
	{ "KDialog::ButtonCodes&", 0, Smoke::t_voidp | Smoke::tf_ref },	//16
	{ "KDialog::ButtonPopupModes", 0, Smoke::t_uint | Smoke::tf_stack },	//17
	{ "KDialog::ButtonPopupModes&", 0, Smoke::t_voidp | Smoke::tf_ref },	//18
	{ "KDialog::CaptionFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//19
	{ "KDialog::CaptionFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//20
	{ "KDirLister::OpenUrlFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//21
	{ "KDirLister::OpenUrlFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//22
	{ "KDirModel::DropsAllowed", 0, Smoke::t_uint | Smoke::tf_stack },	//23
	{ "KDirModel::DropsAllowed&", 0, Smoke::t_voidp | Smoke::tf_ref },	//24
	{ "KDirWatch::WatchModes", 0, Smoke::t_uint | Smoke::tf_stack },	//25
	{ "KDirWatch::WatchModes&", 0, Smoke::t_voidp | Smoke::tf_ref },	//26
	{ "KEditListBox::Buttons", 0, Smoke::t_uint | Smoke::tf_stack },	//27
	{ "KEditListBox::Buttons&", 0, Smoke::t_voidp | Smoke::tf_ref },	//28
	{ "KFileMetaInfo::WhatFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//29
	{ "KFileMetaInfo::WhatFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//30
	{ "KFontChooser::DisplayFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//31
	{ "KFontChooser::DisplayFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//32
	{ "KFontChooser::FontDiffFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//33
	{ "KFontChooser::FontDiffFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//34
	{ "KGlobalSettings::GraphicEffects", 0, Smoke::t_uint | Smoke::tf_stack },	//35
	{ "KGlobalSettings::GraphicEffects&", 0, Smoke::t_voidp | Smoke::tf_ref },	//36
	{ "KIO::JobFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//37
	{ "KIO::JobFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//38
	{ "KIO::NetRC::LookUpMode", 0, Smoke::t_uint | Smoke::tf_stack },	//39
	{ "KIO::NetRC::LookUpMode&", 0, Smoke::t_voidp | Smoke::tf_ref },	//40
	{ "KIO::TCPSlaveBase::SslResult", 0, Smoke::t_uint | Smoke::tf_stack },	//41
	{ "KIO::TCPSlaveBase::SslResult&", 0, Smoke::t_voidp | Smoke::tf_ref },	//42
	{ "KJob::Capabilities", 0, Smoke::t_uint | Smoke::tf_stack },	//43
	{ "KJob::Capabilities&", 0, Smoke::t_voidp | Smoke::tf_ref },	//44
	{ "KKeySequenceWidget::ShortcutTypes", 0, Smoke::t_uint | Smoke::tf_stack },	//45
	{ "KKeySequenceWidget::ShortcutTypes&", 0, Smoke::t_voidp | Smoke::tf_ref },	//46
	{ "KLocale::DateTimeFormatOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//47
	{ "KLocale::DateTimeFormatOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//48
	{ "KLockFile::LockFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//49
	{ "KLockFile::LockFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//50
	{ "KMessageBox::Options", 0, Smoke::t_uint | Smoke::tf_stack },	//51
	{ "KMessageBox::Options&", 0, Smoke::t_voidp | Smoke::tf_ref },	//52
	{ "KNTLM::AuthFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//53
	{ "KNTLM::AuthFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//54
	{ "KNotification::NotificationFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//55
	{ "KNotification::NotificationFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//56
	{ "KNotificationRestrictions::Services", 0, Smoke::t_uint | Smoke::tf_stack },	//57
	{ "KNotificationRestrictions::Services&", 0, Smoke::t_voidp | Smoke::tf_ref },	//58
	{ "KParts::BrowserExtension::PopupFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//59
	{ "KParts::BrowserExtension::PopupFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//60
	{ "KPasswordDialog::KPasswordDialogFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//61
	{ "KPasswordDialog::KPasswordDialogFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//62
	{ "KPlotObject::PlotTypes", 0, Smoke::t_uint | Smoke::tf_stack },	//63
	{ "KPlotObject::PlotTypes&", 0, Smoke::t_voidp | Smoke::tf_ref },	//64
	{ "KRatingPainter*", 1, Smoke::t_class | Smoke::tf_ptr },	//65
	{ "KRatingWidget*", 2, Smoke::t_class | Smoke::tf_ptr },	//66
	{ "KServiceGroup::EntriesOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//67
	{ "KServiceGroup::EntriesOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//68
	{ "KShell::Options", 0, Smoke::t_uint | Smoke::tf_stack },	//69
	{ "KShell::Options&", 0, Smoke::t_voidp | Smoke::tf_ref },	//70
	{ "KShortcutsEditor::ActionTypes", 0, Smoke::t_uint | Smoke::tf_stack },	//71
	{ "KShortcutsEditor::ActionTypes&", 0, Smoke::t_voidp | Smoke::tf_ref },	//72
	{ "KStandardDirs::SearchOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//73
	{ "KStandardDirs::SearchOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//74
	{ "KTagCloudWidget*", 3, Smoke::t_class | Smoke::tf_ptr },	//75
	{ "KTagDisplayWidget*", 4, Smoke::t_class | Smoke::tf_ptr },	//76
	{ "KUniqueApplication::StartFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//77
	{ "KUniqueApplication::StartFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//78
	{ "KUrl::CleanPathOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//79
	{ "KUrl::CleanPathOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//80
	{ "KUrl::DirectoryOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//81
	{ "KUrl::DirectoryOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//82
	{ "KUrl::EncodedPathAndQueryOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//83
	{ "KUrl::EncodedPathAndQueryOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//84
	{ "KUrl::EqualsOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//85
	{ "KUrl::EqualsOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//86
	{ "KUrl::QueryItemsOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//87
	{ "KUrl::QueryItemsOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//88
	{ "KXmlGuiWindow::StandardWindowOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//89
	{ "KXmlGuiWindow::StandardWindowOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//90
	{ "Nepomuk::ErrorCode", 5, Smoke::t_enum | Smoke::tf_stack },	//91
	{ "Nepomuk::Resource", 7, Smoke::t_class | Smoke::tf_stack },	//92
	{ "Nepomuk::Resource&", 7, Smoke::t_class | Smoke::tf_ref },	//93
	{ "Nepomuk::Resource*", 7, Smoke::t_class | Smoke::tf_ptr },	//94
	{ "Nepomuk::ResourceData*", 0, Smoke::t_voidp | Smoke::tf_ptr },	//95
	{ "Nepomuk::ResourceManager*", 8, Smoke::t_class | Smoke::tf_ptr },	//96
	{ "Nepomuk::Service*", 9, Smoke::t_class | Smoke::tf_ptr },	//97
	{ "Nepomuk::Tag", 10, Smoke::t_class | Smoke::tf_stack },	//98
	{ "Nepomuk::Tag&", 10, Smoke::t_class | Smoke::tf_ref },	//99
	{ "Nepomuk::Tag*", 10, Smoke::t_class | Smoke::tf_ptr },	//100
	{ "Nepomuk::TagCloud*", 11, Smoke::t_class | Smoke::tf_ptr },	//101
	{ "Nepomuk::TagWidget*", 12, Smoke::t_class | Smoke::tf_ptr },	//102
	{ "Nepomuk::Thing", 13, Smoke::t_class | Smoke::tf_stack },	//103
	{ "Nepomuk::Thing&", 13, Smoke::t_class | Smoke::tf_ref },	//104
	{ "Nepomuk::Thing*", 13, Smoke::t_class | Smoke::tf_ptr },	//105
	{ "Nepomuk::Types::Class", 15, Smoke::t_class | Smoke::tf_stack },	//106
	{ "Nepomuk::Types::Class&", 15, Smoke::t_class | Smoke::tf_ref },	//107
	{ "Nepomuk::Types::Class*", 15, Smoke::t_class | Smoke::tf_ptr },	//108
	{ "Nepomuk::Types::Entity&", 16, Smoke::t_class | Smoke::tf_ref },	//109
	{ "Nepomuk::Types::Entity*", 16, Smoke::t_class | Smoke::tf_ptr },	//110
	{ "Nepomuk::Types::Literal", 17, Smoke::t_class | Smoke::tf_stack },	//111
	{ "Nepomuk::Types::Literal&", 17, Smoke::t_class | Smoke::tf_ref },	//112
	{ "Nepomuk::Types::Literal*", 17, Smoke::t_class | Smoke::tf_ptr },	//113
	{ "Nepomuk::Types::Ontology&", 18, Smoke::t_class | Smoke::tf_ref },	//114
	{ "Nepomuk::Types::Ontology*", 18, Smoke::t_class | Smoke::tf_ptr },	//115
	{ "Nepomuk::Types::Property", 19, Smoke::t_class | Smoke::tf_stack },	//116
	{ "Nepomuk::Types::Property&", 19, Smoke::t_class | Smoke::tf_ref },	//117
	{ "Nepomuk::Types::Property*", 19, Smoke::t_class | Smoke::tf_ptr },	//118
	{ "Nepomuk::Variant", 20, Smoke::t_class | Smoke::tf_stack },	//119
	{ "Nepomuk::Variant&", 20, Smoke::t_class | Smoke::tf_ref },	//120
	{ "Nepomuk::Variant*", 20, Smoke::t_class | Smoke::tf_ptr },	//121
	{ "QAbstractFileEngine::FileFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//122
	{ "QAbstractFileEngine::FileFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//123
	{ "QAbstractItemView::EditTriggers", 0, Smoke::t_uint | Smoke::tf_stack },	//124
	{ "QAbstractItemView::EditTriggers&", 0, Smoke::t_voidp | Smoke::tf_ref },	//125
	{ "QAbstractPrintDialog::PrintDialogOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//126
	{ "QAbstractPrintDialog::PrintDialogOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//127
	{ "QAbstractSpinBox::StepEnabled", 0, Smoke::t_uint | Smoke::tf_stack },	//128
	{ "QAbstractSpinBox::StepEnabled&", 0, Smoke::t_voidp | Smoke::tf_ref },	//129
	{ "QAccessible::Relation", 0, Smoke::t_uint | Smoke::tf_stack },	//130
	{ "QAccessible::Relation&", 0, Smoke::t_voidp | Smoke::tf_ref },	//131
	{ "QAccessible::State", 0, Smoke::t_uint | Smoke::tf_stack },	//132
	{ "QAccessible::State&", 0, Smoke::t_voidp | Smoke::tf_ref },	//133
	{ "QActionEvent*", 21, Smoke::t_class | Smoke::tf_ptr },	//134
	{ "QChildEvent*", 22, Smoke::t_class | Smoke::tf_ptr },	//135
	{ "QCloseEvent*", 23, Smoke::t_class | Smoke::tf_ptr },	//136
	{ "QColorDialog::ColorDialogOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//137
	{ "QColorDialog::ColorDialogOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//138
	{ "QContextMenuEvent*", 24, Smoke::t_class | Smoke::tf_ptr },	//139
	{ "QDBusConnection::RegisterOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//140
	{ "QDBusConnection::RegisterOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//141
	{ "QDate", 25, Smoke::t_class | Smoke::tf_stack },	//142
	{ "QDate::MonthNameType", 25, Smoke::t_enum | Smoke::tf_stack },	//143
	{ "QDateTime", 26, Smoke::t_class | Smoke::tf_stack },	//144
	{ "QDateTimeEdit::Sections", 0, Smoke::t_uint | Smoke::tf_stack },	//145
	{ "QDateTimeEdit::Sections&", 0, Smoke::t_voidp | Smoke::tf_ref },	//146
	{ "QDialogButtonBox::StandardButtons", 0, Smoke::t_uint | Smoke::tf_stack },	//147
	{ "QDialogButtonBox::StandardButtons&", 0, Smoke::t_voidp | Smoke::tf_ref },	//148
	{ "QDir::Filters", 0, Smoke::t_uint | Smoke::tf_stack },	//149
	{ "QDir::Filters&", 0, Smoke::t_voidp | Smoke::tf_ref },	//150
	{ "QDir::SortFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//151
	{ "QDir::SortFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//152
	{ "QDirIterator::IteratorFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//153
	{ "QDirIterator::IteratorFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//154
	{ "QDockWidget::DockWidgetFeatures", 0, Smoke::t_uint | Smoke::tf_stack },	//155
	{ "QDockWidget::DockWidgetFeatures&", 0, Smoke::t_voidp | Smoke::tf_ref },	//156
	{ "QDragEnterEvent*", 27, Smoke::t_class | Smoke::tf_ptr },	//157
	{ "QDragLeaveEvent*", 28, Smoke::t_class | Smoke::tf_ptr },	//158
	{ "QDragMoveEvent*", 29, Smoke::t_class | Smoke::tf_ptr },	//159
	{ "QDropEvent*", 30, Smoke::t_class | Smoke::tf_ptr },	//160
	{ "QEvent*", 31, Smoke::t_class | Smoke::tf_ptr },	//161
	{ "QEvent::Type", 31, Smoke::t_enum | Smoke::tf_stack },	//162
	{ "QEventLoop::ProcessEventsFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//163
	{ "QEventLoop::ProcessEventsFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//164
	{ "QFile::Permissions", 0, Smoke::t_uint | Smoke::tf_stack },	//165
	{ "QFile::Permissions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//166
	{ "QFileDialog::Options", 0, Smoke::t_uint | Smoke::tf_stack },	//167
	{ "QFileDialog::Options&", 0, Smoke::t_voidp | Smoke::tf_ref },	//168
	{ "QFocusEvent*", 32, Smoke::t_class | Smoke::tf_ptr },	//169
	{ "QFontComboBox::FontFilters", 0, Smoke::t_uint | Smoke::tf_stack },	//170
	{ "QFontComboBox::FontFilters&", 0, Smoke::t_voidp | Smoke::tf_ref },	//171
	{ "QFontDialog::FontDialogOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//172
	{ "QFontDialog::FontDialogOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//173
	{ "QFrame::Shadow", 34, Smoke::t_enum | Smoke::tf_stack },	//174
	{ "QFrame::Shape", 34, Smoke::t_enum | Smoke::tf_stack },	//175
	{ "QFrame::StyleMask", 34, Smoke::t_enum | Smoke::tf_stack },	//176
	{ "QGL::FormatOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//177
	{ "QGL::FormatOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//178
	{ "QGLFormat::OpenGLVersionFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//179
	{ "QGLFormat::OpenGLVersionFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//180
	{ "QGraphicsItem::GraphicsItemFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//181
	{ "QGraphicsItem::GraphicsItemFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//182
	{ "QGraphicsScene::SceneLayers", 0, Smoke::t_uint | Smoke::tf_stack },	//183
	{ "QGraphicsScene::SceneLayers&", 0, Smoke::t_voidp | Smoke::tf_ref },	//184
	{ "QGraphicsView::CacheMode", 0, Smoke::t_uint | Smoke::tf_stack },	//185
	{ "QGraphicsView::CacheMode&", 0, Smoke::t_voidp | Smoke::tf_ref },	//186
	{ "QGraphicsView::OptimizationFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//187
	{ "QGraphicsView::OptimizationFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//188
	{ "QHash<QUrl,Nepomuk::Variant>", 0, Smoke::t_voidp | Smoke::tf_stack },	//189
	{ "QHideEvent*", 35, Smoke::t_class | Smoke::tf_ptr },	//190
	{ "QIODevice::OpenMode", 0, Smoke::t_uint | Smoke::tf_stack },	//191
	{ "QIODevice::OpenMode&", 0, Smoke::t_voidp | Smoke::tf_ref },	//192
	{ "QIcon", 36, Smoke::t_class | Smoke::tf_stack },	//193
	{ "QIcon&", 36, Smoke::t_class | Smoke::tf_ref },	//194
	{ "QIcon::Mode", 36, Smoke::t_enum | Smoke::tf_stack },	//195
	{ "QIcon::State", 36, Smoke::t_enum | Smoke::tf_stack },	//196
	{ "QInputDialog::InputDialogOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//197
	{ "QInputDialog::InputDialogOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//198
	{ "QInputMethodEvent*", 38, Smoke::t_class | Smoke::tf_ptr },	//199
	{ "QItemSelectionModel::SelectionFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//200
	{ "QItemSelectionModel::SelectionFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//201
	{ "QKeyEvent*", 39, Smoke::t_class | Smoke::tf_ptr },	//202
	{ "QLibrary::LoadHints", 0, Smoke::t_uint | Smoke::tf_stack },	//203
	{ "QLibrary::LoadHints&", 0, Smoke::t_voidp | Smoke::tf_ref },	//204
	{ "QList<Nepomuk::Resource>", 0, Smoke::t_voidp | Smoke::tf_stack },	//205
	{ "QList<Nepomuk::Tag>", 0, Smoke::t_voidp | Smoke::tf_stack },	//206
	{ "QList<Nepomuk::Types::Class>", 0, Smoke::t_voidp | Smoke::tf_stack },	//207
	{ "QList<Nepomuk::Types::Property>", 0, Smoke::t_voidp | Smoke::tf_stack },	//208
	{ "QList<Nepomuk::Variant>", 0, Smoke::t_voidp | Smoke::tf_stack },	//209
	{ "QList<QDate>", 0, Smoke::t_voidp | Smoke::tf_stack },	//210
	{ "QList<QDateTime>", 0, Smoke::t_voidp | Smoke::tf_stack },	//211
	{ "QList<QTime>", 0, Smoke::t_voidp | Smoke::tf_stack },	//212
	{ "QList<QUrl>", 0, Smoke::t_voidp | Smoke::tf_stack },	//213
	{ "QList<Resource>&", 0, Smoke::t_voidp | Smoke::tf_ref },	//214
	{ "QList<Soprano::Node>", 0, Smoke::t_voidp | Smoke::tf_stack },	//215
	{ "QList<Tag>&", 0, Smoke::t_voidp | Smoke::tf_ref },	//216
	{ "QList<bool>", 0, Smoke::t_voidp | Smoke::tf_stack },	//217
	{ "QList<double>", 0, Smoke::t_voidp | Smoke::tf_stack },	//218
	{ "QList<int>", 0, Smoke::t_voidp | Smoke::tf_stack },	//219
	{ "QList<qlonglong>", 0, Smoke::t_voidp | Smoke::tf_stack },	//220
	{ "QList<qulonglong>", 0, Smoke::t_voidp | Smoke::tf_stack },	//221
	{ "QList<uint>", 0, Smoke::t_voidp | Smoke::tf_stack },	//222
	{ "QLocale::NumberOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//223
	{ "QLocale::NumberOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//224
	{ "QMainWindow::DockOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//225
	{ "QMainWindow::DockOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//226
	{ "QMap<QString,int>&", 0, Smoke::t_voidp | Smoke::tf_ref },	//227
	{ "QMdiArea::AreaOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//228
	{ "QMdiArea::AreaOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//229
	{ "QMdiSubWindow::SubWindowOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//230
	{ "QMdiSubWindow::SubWindowOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//231
	{ "QMessageBox::StandardButtons", 0, Smoke::t_uint | Smoke::tf_stack },	//232
	{ "QMessageBox::StandardButtons&", 0, Smoke::t_voidp | Smoke::tf_ref },	//233
	{ "QMetaObject::Call", 42, Smoke::t_enum | Smoke::tf_stack },	//234
	{ "QMouseEvent*", 43, Smoke::t_class | Smoke::tf_ptr },	//235
	{ "QMoveEvent*", 44, Smoke::t_class | Smoke::tf_ptr },	//236
	{ "QNetworkInterface::InterfaceFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//237
	{ "QNetworkInterface::InterfaceFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//238
	{ "QNetworkProxy::Capabilities", 0, Smoke::t_uint | Smoke::tf_stack },	//239
	{ "QNetworkProxy::Capabilities&", 0, Smoke::t_voidp | Smoke::tf_ref },	//240
	{ "QObject*", 45, Smoke::t_class | Smoke::tf_ptr },	//241
	{ "QPageSetupDialog::PageSetupDialogOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//242
	{ "QPageSetupDialog::PageSetupDialogOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//243
	{ "QPaintDevice*", 46, Smoke::t_class | Smoke::tf_ptr },	//244
	{ "QPaintDevice::PaintDeviceMetric", 46, Smoke::t_enum | Smoke::tf_stack },	//245
	{ "QPaintEngine*", 47, Smoke::t_class | Smoke::tf_ptr },	//246
	{ "QPaintEngine::DirtyFlag", 47, Smoke::t_enum | Smoke::tf_stack },	//247
	{ "QPaintEngine::DirtyFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//248
	{ "QPaintEngine::DirtyFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//249
	{ "QPaintEngine::PaintEngineFeature", 47, Smoke::t_enum | Smoke::tf_stack },	//250
	{ "QPaintEngine::PaintEngineFeatures", 0, Smoke::t_uint | Smoke::tf_stack },	//251
	{ "QPaintEngine::PaintEngineFeatures&", 0, Smoke::t_voidp | Smoke::tf_ref },	//252
	{ "QPaintEngine::PolygonDrawMode", 47, Smoke::t_enum | Smoke::tf_stack },	//253
	{ "QPaintEngine::Type", 47, Smoke::t_enum | Smoke::tf_stack },	//254
	{ "QPaintEvent*", 49, Smoke::t_class | Smoke::tf_ptr },	//255
	{ "QPainter*", 50, Smoke::t_class | Smoke::tf_ptr },	//256
	{ "QPainter::CompositionMode", 50, Smoke::t_enum | Smoke::tf_stack },	//257
	{ "QPainter::RenderHint", 50, Smoke::t_enum | Smoke::tf_stack },	//258
	{ "QPainter::RenderHints", 0, Smoke::t_uint | Smoke::tf_stack },	//259
	{ "QPainter::RenderHints&", 0, Smoke::t_voidp | Smoke::tf_ref },	//260
	{ "QPainterPath::ElementType", 51, Smoke::t_enum | Smoke::tf_stack },	//261
	{ "QPixmap", 53, Smoke::t_class | Smoke::tf_stack },	//262
	{ "QPixmap&", 53, Smoke::t_class | Smoke::tf_ref },	//263
	{ "QPixmap::Type", 53, Smoke::t_enum | Smoke::tf_stack },	//264
	{ "QPoint", 54, Smoke::t_class | Smoke::tf_stack },	//265
	{ "QResizeEvent*", 58, Smoke::t_class | Smoke::tf_ptr },	//266
	{ "QShowEvent*", 59, Smoke::t_class | Smoke::tf_ptr },	//267
	{ "QSize", 60, Smoke::t_class | Smoke::tf_stack },	//268
	{ "QSizePolicy::ControlTypes", 0, Smoke::t_uint | Smoke::tf_stack },	//269
	{ "QSizePolicy::ControlTypes&", 0, Smoke::t_voidp | Smoke::tf_ref },	//270
	{ "QSql::ParamType", 0, Smoke::t_uint | Smoke::tf_stack },	//271
	{ "QSql::ParamType&", 0, Smoke::t_voidp | Smoke::tf_ref },	//272
	{ "QString", 0, Smoke::t_voidp | Smoke::tf_stack },	//273
	{ "QString&", 0, Smoke::t_voidp | Smoke::tf_ref },	//274
	{ "QString::SectionFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//275
	{ "QString::SectionFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//276
	{ "QStringList", 0, Smoke::t_voidp | Smoke::tf_stack },	//277
	{ "QStringList&", 0, Smoke::t_voidp | Smoke::tf_ref },	//278
	{ "QStyle&", 61, Smoke::t_class | Smoke::tf_ref },	//279
	{ "QStyle::State", 0, Smoke::t_uint | Smoke::tf_stack },	//280
	{ "QStyle::State&", 0, Smoke::t_voidp | Smoke::tf_ref },	//281
	{ "QStyle::SubControls", 0, Smoke::t_uint | Smoke::tf_stack },	//282
	{ "QStyle::SubControls&", 0, Smoke::t_voidp | Smoke::tf_ref },	//283
	{ "QStyleOptionButton::ButtonFeatures", 0, Smoke::t_uint | Smoke::tf_stack },	//284
	{ "QStyleOptionButton::ButtonFeatures&", 0, Smoke::t_voidp | Smoke::tf_ref },	//285
	{ "QStyleOptionFrameV2::FrameFeatures", 0, Smoke::t_uint | Smoke::tf_stack },	//286
	{ "QStyleOptionFrameV2::FrameFeatures&", 0, Smoke::t_voidp | Smoke::tf_ref },	//287
	{ "QStyleOptionQ3ListViewItem::Q3ListViewItemFeatures", 0, Smoke::t_uint | Smoke::tf_stack },	//288
	{ "QStyleOptionQ3ListViewItem::Q3ListViewItemFeatures&", 0, Smoke::t_voidp | Smoke::tf_ref },	//289
	{ "QStyleOptionTab::CornerWidgets", 0, Smoke::t_uint | Smoke::tf_stack },	//290
	{ "QStyleOptionTab::CornerWidgets&", 0, Smoke::t_voidp | Smoke::tf_ref },	//291
	{ "QStyleOptionToolBar::ToolBarFeatures", 0, Smoke::t_uint | Smoke::tf_stack },	//292
	{ "QStyleOptionToolBar::ToolBarFeatures&", 0, Smoke::t_voidp | Smoke::tf_ref },	//293
	{ "QStyleOptionToolButton::ToolButtonFeatures", 0, Smoke::t_uint | Smoke::tf_stack },	//294
	{ "QStyleOptionToolButton::ToolButtonFeatures&", 0, Smoke::t_voidp | Smoke::tf_ref },	//295
	{ "QStyleOptionViewItemV2::ViewItemFeatures", 0, Smoke::t_uint | Smoke::tf_stack },	//296
	{ "QStyleOptionViewItemV2::ViewItemFeatures&", 0, Smoke::t_voidp | Smoke::tf_ref },	//297
	{ "QTabletEvent*", 62, Smoke::t_class | Smoke::tf_ptr },	//298
	{ "QTextBoundaryFinder::BoundaryReasons", 0, Smoke::t_uint | Smoke::tf_stack },	//299
	{ "QTextBoundaryFinder::BoundaryReasons&", 0, Smoke::t_voidp | Smoke::tf_ref },	//300
	{ "QTextCodec::ConversionFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//301
	{ "QTextCodec::ConversionFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//302
	{ "QTextDocument::FindFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//303
	{ "QTextDocument::FindFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//304
	{ "QTextEdit::AutoFormatting", 0, Smoke::t_uint | Smoke::tf_stack },	//305
	{ "QTextEdit::AutoFormatting&", 0, Smoke::t_voidp | Smoke::tf_ref },	//306
	{ "QTextFormat::PageBreakFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//307
	{ "QTextFormat::PageBreakFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//308
	{ "QTextItem::RenderFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//309
	{ "QTextItem::RenderFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//310
	{ "QTextOption::Flags", 0, Smoke::t_uint | Smoke::tf_stack },	//311
	{ "QTextOption::Flags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//312
	{ "QTextStream&", 63, Smoke::t_class | Smoke::tf_ref },	//313
	{ "QTextStream::NumberFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//314
	{ "QTextStream::NumberFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//315
	{ "QTime", 64, Smoke::t_class | Smoke::tf_stack },	//316
	{ "QTime::TimeFlag", 64, Smoke::t_enum | Smoke::tf_stack },	//317
	{ "QTimerEvent*", 65, Smoke::t_class | Smoke::tf_ptr },	//318
	{ "QTreeWidgetItemIterator::IteratorFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//319
	{ "QTreeWidgetItemIterator::IteratorFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//320
	{ "QUdpSocket::BindMode", 0, Smoke::t_uint | Smoke::tf_stack },	//321
	{ "QUdpSocket::BindMode&", 0, Smoke::t_voidp | Smoke::tf_ref },	//322
	{ "QUrl", 66, Smoke::t_class | Smoke::tf_stack },	//323
	{ "QUrl::FormattingOption", 66, Smoke::t_enum | Smoke::tf_stack },	//324
	{ "QUrl::FormattingOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//325
	{ "QUrl::FormattingOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//326
	{ "QUrl::ParsingMode", 66, Smoke::t_enum | Smoke::tf_stack },	//327
	{ "QVariant", 67, Smoke::t_class | Smoke::tf_stack },	//328
	{ "QVariant::Type", 67, Smoke::t_enum | Smoke::tf_stack },	//329
	{ "QWebPage::FindFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//330
	{ "QWebPage::FindFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//331
	{ "QWheelEvent*", 68, Smoke::t_class | Smoke::tf_ptr },	//332
	{ "QWidget*", 69, Smoke::t_class | Smoke::tf_ptr },	//333
	{ "QWidget::RenderFlag", 69, Smoke::t_enum | Smoke::tf_stack },	//334
	{ "QWidget::RenderFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//335
	{ "QWidget::RenderFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//336
	{ "QWizard::WizardOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//337
	{ "QWizard::WizardOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//338
	{ "Qt::Alignment", 0, Smoke::t_uint | Smoke::tf_stack },	//339
	{ "Qt::Alignment&", 0, Smoke::t_voidp | Smoke::tf_ref },	//340
	{ "Qt::AlignmentFlag", 70, Smoke::t_enum | Smoke::tf_stack },	//341
	{ "Qt::AnchorAttribute", 70, Smoke::t_enum | Smoke::tf_stack },	//342
	{ "Qt::ApplicationAttribute", 70, Smoke::t_enum | Smoke::tf_stack },	//343
	{ "Qt::ArrowType", 70, Smoke::t_enum | Smoke::tf_stack },	//344
	{ "Qt::AspectRatioMode", 70, Smoke::t_enum | Smoke::tf_stack },	//345
	{ "Qt::Axis", 70, Smoke::t_enum | Smoke::tf_stack },	//346
	{ "Qt::BGMode", 70, Smoke::t_enum | Smoke::tf_stack },	//347
	{ "Qt::BrushStyle", 70, Smoke::t_enum | Smoke::tf_stack },	//348
	{ "Qt::CaseSensitivity", 70, Smoke::t_enum | Smoke::tf_stack },	//349
	{ "Qt::CheckState", 70, Smoke::t_enum | Smoke::tf_stack },	//350
	{ "Qt::ClipOperation", 70, Smoke::t_enum | Smoke::tf_stack },	//351
	{ "Qt::ConnectionType", 70, Smoke::t_enum | Smoke::tf_stack },	//352
	{ "Qt::ContextMenuPolicy", 70, Smoke::t_enum | Smoke::tf_stack },	//353
	{ "Qt::Corner", 70, Smoke::t_enum | Smoke::tf_stack },	//354
	{ "Qt::CursorShape", 70, Smoke::t_enum | Smoke::tf_stack },	//355
	{ "Qt::DateFormat", 70, Smoke::t_enum | Smoke::tf_stack },	//356
	{ "Qt::DayOfWeek", 70, Smoke::t_enum | Smoke::tf_stack },	//357
	{ "Qt::DockWidgetArea", 70, Smoke::t_enum | Smoke::tf_stack },	//358
	{ "Qt::DockWidgetAreaSizes", 70, Smoke::t_enum | Smoke::tf_stack },	//359
	{ "Qt::DockWidgetAreas", 0, Smoke::t_uint | Smoke::tf_stack },	//360
	{ "Qt::DockWidgetAreas&", 0, Smoke::t_voidp | Smoke::tf_ref },	//361
	{ "Qt::DropAction", 70, Smoke::t_enum | Smoke::tf_stack },	//362
	{ "Qt::DropActions", 0, Smoke::t_uint | Smoke::tf_stack },	//363
	{ "Qt::DropActions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//364
	{ "Qt::EventPriority", 70, Smoke::t_enum | Smoke::tf_stack },	//365
	{ "Qt::FillRule", 70, Smoke::t_enum | Smoke::tf_stack },	//366
	{ "Qt::FocusPolicy", 70, Smoke::t_enum | Smoke::tf_stack },	//367
	{ "Qt::FocusReason", 70, Smoke::t_enum | Smoke::tf_stack },	//368
	{ "Qt::GlobalColor", 70, Smoke::t_enum | Smoke::tf_stack },	//369
	{ "Qt::HitTestAccuracy", 70, Smoke::t_enum | Smoke::tf_stack },	//370
	{ "Qt::ImageConversionFlag", 70, Smoke::t_enum | Smoke::tf_stack },	//371
	{ "Qt::ImageConversionFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//372
	{ "Qt::ImageConversionFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//373
	{ "Qt::InputMethodQuery", 70, Smoke::t_enum | Smoke::tf_stack },	//374
	{ "Qt::ItemDataRole", 70, Smoke::t_enum | Smoke::tf_stack },	//375
	{ "Qt::ItemFlag", 70, Smoke::t_enum | Smoke::tf_stack },	//376
	{ "Qt::ItemFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//377
	{ "Qt::ItemFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//378
	{ "Qt::ItemSelectionMode", 70, Smoke::t_enum | Smoke::tf_stack },	//379
	{ "Qt::Key", 70, Smoke::t_enum | Smoke::tf_stack },	//380
	{ "Qt::KeyboardModifier", 70, Smoke::t_enum | Smoke::tf_stack },	//381
	{ "Qt::KeyboardModifiers", 0, Smoke::t_uint | Smoke::tf_stack },	//382
	{ "Qt::KeyboardModifiers&", 0, Smoke::t_voidp | Smoke::tf_ref },	//383
	{ "Qt::LayoutDirection", 70, Smoke::t_enum | Smoke::tf_stack },	//384
	{ "Qt::MaskMode", 70, Smoke::t_enum | Smoke::tf_stack },	//385
	{ "Qt::MatchFlag", 70, Smoke::t_enum | Smoke::tf_stack },	//386
	{ "Qt::MatchFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//387
	{ "Qt::MatchFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//388
	{ "Qt::Modifier", 70, Smoke::t_enum | Smoke::tf_stack },	//389
	{ "Qt::MouseButton", 70, Smoke::t_enum | Smoke::tf_stack },	//390
	{ "Qt::MouseButtons", 0, Smoke::t_uint | Smoke::tf_stack },	//391
	{ "Qt::MouseButtons&", 0, Smoke::t_voidp | Smoke::tf_ref },	//392
	{ "Qt::Orientation", 70, Smoke::t_enum | Smoke::tf_stack },	//393
	{ "Qt::Orientations", 0, Smoke::t_uint | Smoke::tf_stack },	//394
	{ "Qt::Orientations&", 0, Smoke::t_voidp | Smoke::tf_ref },	//395
	{ "Qt::PenCapStyle", 70, Smoke::t_enum | Smoke::tf_stack },	//396
	{ "Qt::PenJoinStyle", 70, Smoke::t_enum | Smoke::tf_stack },	//397
	{ "Qt::PenStyle", 70, Smoke::t_enum | Smoke::tf_stack },	//398
	{ "Qt::ScrollBarPolicy", 70, Smoke::t_enum | Smoke::tf_stack },	//399
	{ "Qt::ShortcutContext", 70, Smoke::t_enum | Smoke::tf_stack },	//400
	{ "Qt::SizeHint", 70, Smoke::t_enum | Smoke::tf_stack },	//401
	{ "Qt::SizeMode", 70, Smoke::t_enum | Smoke::tf_stack },	//402
	{ "Qt::SortOrder", 70, Smoke::t_enum | Smoke::tf_stack },	//403
	{ "Qt::TextElideMode", 70, Smoke::t_enum | Smoke::tf_stack },	//404
	{ "Qt::TextFlag", 70, Smoke::t_enum | Smoke::tf_stack },	//405
	{ "Qt::TextFormat", 70, Smoke::t_enum | Smoke::tf_stack },	//406
	{ "Qt::TextInteractionFlag", 70, Smoke::t_enum | Smoke::tf_stack },	//407
	{ "Qt::TextInteractionFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//408
	{ "Qt::TextInteractionFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//409
	{ "Qt::TimeSpec", 70, Smoke::t_enum | Smoke::tf_stack },	//410
	{ "Qt::ToolBarArea", 70, Smoke::t_enum | Smoke::tf_stack },	//411
	{ "Qt::ToolBarAreaSizes", 70, Smoke::t_enum | Smoke::tf_stack },	//412
	{ "Qt::ToolBarAreas", 0, Smoke::t_uint | Smoke::tf_stack },	//413
	{ "Qt::ToolBarAreas&", 0, Smoke::t_voidp | Smoke::tf_ref },	//414
	{ "Qt::ToolButtonStyle", 70, Smoke::t_enum | Smoke::tf_stack },	//415
	{ "Qt::TransformationMode", 70, Smoke::t_enum | Smoke::tf_stack },	//416
	{ "Qt::UIEffect", 70, Smoke::t_enum | Smoke::tf_stack },	//417
	{ "Qt::WhiteSpaceMode", 70, Smoke::t_enum | Smoke::tf_stack },	//418
	{ "Qt::WidgetAttribute", 70, Smoke::t_enum | Smoke::tf_stack },	//419
	{ "Qt::WindowFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//420
	{ "Qt::WindowFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//421
	{ "Qt::WindowFrameSection", 70, Smoke::t_enum | Smoke::tf_stack },	//422
	{ "Qt::WindowModality", 70, Smoke::t_enum | Smoke::tf_stack },	//423
	{ "Qt::WindowState", 70, Smoke::t_enum | Smoke::tf_stack },	//424
	{ "Qt::WindowStates", 0, Smoke::t_uint | Smoke::tf_stack },	//425
	{ "Qt::WindowStates&", 0, Smoke::t_voidp | Smoke::tf_ref },	//426
	{ "Qt::WindowType", 70, Smoke::t_enum | Smoke::tf_stack },	//427
	{ "Resource&", 0, Smoke::t_voidp | Smoke::tf_ref },	//428
	{ "Soprano::BackendFeature", 71, Smoke::t_enum | Smoke::tf_stack },	//429
	{ "Soprano::BackendFeatures", 0, Smoke::t_uint | Smoke::tf_stack },	//430
	{ "Soprano::BackendFeatures&", 0, Smoke::t_voidp | Smoke::tf_ref },	//431
	{ "Soprano::BackendOption", 71, Smoke::t_enum | Smoke::tf_stack },	//432
	{ "Soprano::BackendOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//433
	{ "Soprano::BackendOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//434
	{ "Soprano::Error::ErrorCode", 72, Smoke::t_enum | Smoke::tf_stack },	//435
	{ "Soprano::Model*", 73, Smoke::t_class | Smoke::tf_ptr },	//436
	{ "Soprano::Node", 74, Smoke::t_class | Smoke::tf_stack },	//437
	{ "Soprano::Node::Type", 74, Smoke::t_enum | Smoke::tf_stack },	//438
	{ "Soprano::NodeIterator", 75, Smoke::t_class | Smoke::tf_stack },	//439
	{ "Soprano::Query::QueryLanguage", 76, Smoke::t_enum | Smoke::tf_stack },	//440
	{ "Soprano::Query::QueryLanguages", 0, Smoke::t_uint | Smoke::tf_stack },	//441
	{ "Soprano::Query::QueryLanguages&", 0, Smoke::t_voidp | Smoke::tf_ref },	//442
	{ "Soprano::QueryResultIterator", 77, Smoke::t_class | Smoke::tf_stack },	//443
	{ "Soprano::RdfSerialization", 71, Smoke::t_enum | Smoke::tf_stack },	//444
	{ "Soprano::RdfSerializations", 0, Smoke::t_uint | Smoke::tf_stack },	//445
	{ "Soprano::RdfSerializations&", 0, Smoke::t_voidp | Smoke::tf_ref },	//446
	{ "Soprano::StatementIterator", 79, Smoke::t_class | Smoke::tf_stack },	//447
	{ "Tag", 0, Smoke::t_voidp | Smoke::tf_stack },	//448
	{ "bool", 0, Smoke::t_bool | Smoke::tf_stack },	//449
	{ "const KRatingPainter&", 1, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//450
	{ "const Nepomuk::Resource&", 7, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//451
	{ "const Nepomuk::Tag&", 10, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//452
	{ "const Nepomuk::Thing&", 13, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//453
	{ "const Nepomuk::Types::Class&", 15, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//454
	{ "const Nepomuk::Types::Entity&", 16, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//455
	{ "const Nepomuk::Types::Literal&", 17, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//456
	{ "const Nepomuk::Types::Ontology&", 18, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//457
	{ "const Nepomuk::Types::Property&", 19, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//458
	{ "const Nepomuk::Variant&", 20, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//459
	{ "const QDate&", 25, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//460
	{ "const QDateTime&", 26, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//461
	{ "const QFont&", 33, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//462
	{ "const QIcon&", 36, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//463
	{ "const QImage&", 37, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//464
	{ "const QLine*", 40, Smoke::t_class | Smoke::tf_ptr | Smoke::tf_const },	//465
	{ "const QLineF*", 41, Smoke::t_class | Smoke::tf_ptr | Smoke::tf_const },	//466
	{ "const QList<Nepomuk::Resource>&", 0, Smoke::t_voidp | Smoke::tf_ref | Smoke::tf_const },	//467
	{ "const QList<Nepomuk::Tag>&", 0, Smoke::t_voidp | Smoke::tf_ref | Smoke::tf_const },	//468
	{ "const QList<Nepomuk::Variant>&", 0, Smoke::t_voidp | Smoke::tf_ref | Smoke::tf_const },	//469
	{ "const QList<QDate>&", 0, Smoke::t_voidp | Smoke::tf_ref | Smoke::tf_const },	//470
	{ "const QList<QDateTime>&", 0, Smoke::t_voidp | Smoke::tf_ref | Smoke::tf_const },	//471
	{ "const QList<QTime>&", 0, Smoke::t_voidp | Smoke::tf_ref | Smoke::tf_const },	//472
	{ "const QList<QUrl>&", 0, Smoke::t_voidp | Smoke::tf_ref | Smoke::tf_const },	//473
	{ "const QList<bool>&", 0, Smoke::t_voidp | Smoke::tf_ref | Smoke::tf_const },	//474
	{ "const QList<double>&", 0, Smoke::t_voidp | Smoke::tf_ref | Smoke::tf_const },	//475
	{ "const QList<int>&", 0, Smoke::t_voidp | Smoke::tf_ref | Smoke::tf_const },	//476
	{ "const QList<qlonglong>&", 0, Smoke::t_voidp | Smoke::tf_ref | Smoke::tf_const },	//477
	{ "const QList<qulonglong>&", 0, Smoke::t_voidp | Smoke::tf_ref | Smoke::tf_const },	//478
	{ "const QList<uint>&", 0, Smoke::t_voidp | Smoke::tf_ref | Smoke::tf_const },	//479
	{ "const QMap<QString,int>&", 0, Smoke::t_voidp | Smoke::tf_ref | Smoke::tf_const },	//480
	{ "const QMetaObject", 42, Smoke::t_class | Smoke::tf_stack | Smoke::tf_const },	//481
	{ "const QMetaObject*", 42, Smoke::t_class | Smoke::tf_ptr | Smoke::tf_const },	//482
	{ "const QPaintEngineState&", 48, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//483
	{ "const QPainterPath&", 51, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//484
	{ "const QPalette&", 52, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//485
	{ "const QPixmap&", 53, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//486
	{ "const QPoint&", 54, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//487
	{ "const QPoint*", 54, Smoke::t_class | Smoke::tf_ptr | Smoke::tf_const },	//488
	{ "const QPointF&", 55, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//489
	{ "const QPointF*", 55, Smoke::t_class | Smoke::tf_ptr | Smoke::tf_const },	//490
	{ "const QRect&", 56, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//491
	{ "const QRect*", 56, Smoke::t_class | Smoke::tf_ptr | Smoke::tf_const },	//492
	{ "const QRectF&", 57, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//493
	{ "const QRectF*", 57, Smoke::t_class | Smoke::tf_ptr | Smoke::tf_const },	//494
	{ "const QString&", 0, Smoke::t_voidp | Smoke::tf_ref | Smoke::tf_const },	//495
	{ "const QStringList&", 0, Smoke::t_voidp | Smoke::tf_ref | Smoke::tf_const },	//496
	{ "const QTime&", 64, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//497
	{ "const QUrl&", 66, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//498
	{ "const QVariant&", 67, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//499
	{ "const QVariant::Handler*", 0, Smoke::t_voidp | Smoke::tf_ptr | Smoke::tf_const },	//500
	{ "const Soprano::Node&", 74, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//501
	{ "const Soprano::Statement&", 78, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//502
	{ "const char*", 0, Smoke::t_voidp | Smoke::tf_ptr | Smoke::tf_const },	//503
	{ "const unsigned int&", 0, Smoke::t_voidp | Smoke::tf_ref | Smoke::tf_const },	//504
	{ "double", 0, Smoke::t_double | Smoke::tf_stack },	//505
	{ "int", 0, Smoke::t_int | Smoke::tf_stack },	//506
	{ "qlonglong", 0, Smoke::t_voidp | Smoke::tf_stack },	//507
	{ "qulonglong", 0, Smoke::t_voidp | Smoke::tf_stack },	//508
	{ "uint", 0, Smoke::t_uint | Smoke::tf_stack },	//509
	{ "unsigned int", 0, Smoke::t_uint | Smoke::tf_stack },	//510
	{ "void**", 0, Smoke::t_voidp | Smoke::tf_ptr },	//511
};

static Smoke::Index nepomuk_argumentList[] = {
	0,	//0  (void)
	134, 0,	//1  QActionEvent*  
	135, 0,	//3  QChildEvent*  
	136, 0,	//5  QCloseEvent*  
	139, 0,	//7  QContextMenuEvent*  
	157, 0,	//9  QDragEnterEvent*  
	158, 0,	//11  QDragLeaveEvent*  
	159, 0,	//13  QDragMoveEvent*  
	160, 0,	//15  QDropEvent*  
	161, 0,	//17  QEvent*  
	169, 0,	//19  QFocusEvent*  
	190, 0,	//21  QHideEvent*  
	199, 0,	//23  QInputMethodEvent*  
	202, 0,	//25  QKeyEvent*  
	234, 506, 511, 0,	//27  QMetaObject::Call, int, void**  
	235, 0,	//31  QMouseEvent*  
	236, 0,	//33  QMoveEvent*  
	241, 0,	//35  QObject*  
	241, 161, 0,	//37  QObject*, QEvent*  
	241, 449, 0,	//40  QObject*, bool  
	245, 0,	//43  QPaintDevice::PaintDeviceMetric  
	255, 0,	//45  QPaintEvent*  
	256, 491, 339, 506, 0,	//47  QPainter*, const QRect&, Qt::Alignment, int  
	256, 491, 339, 506, 506, 0,	//52  QPainter*, const QRect&, Qt::Alignment, int, int  
	256, 491, 506, 0,	//58  QPainter*, const QRect&, int  
	256, 491, 506, 506, 0,	//62  QPainter*, const QRect&, int, int  
	266, 0,	//67  QResizeEvent*  
	267, 0,	//69  QShowEvent*  
	279, 0,	//71  QStyle&  
	298, 0,	//73  QTabletEvent*  
	318, 0,	//75  QTimerEvent*  
	332, 0,	//77  QWheelEvent*  
	333, 0,	//79  QWidget*  
	339, 0,	//81  Qt::Alignment  
	374, 0,	//83  Qt::InputMethodQuery  
	384, 0,	//85  Qt::LayoutDirection  
	436, 0,	//87  Soprano::Model*  
	449, 0,	//89  bool  
	450, 0,	//91  const KRatingPainter&  
	451, 0,	//93  const Nepomuk::Resource&  
	451, 333, 0,	//95  const Nepomuk::Resource&, QWidget*  
	452, 0,	//98  const Nepomuk::Tag&  
	453, 0,	//100  const Nepomuk::Thing&  
	454, 0,	//102  const Nepomuk::Types::Class&  
	455, 0,	//104  const Nepomuk::Types::Entity&  
	456, 0,	//106  const Nepomuk::Types::Literal&  
	457, 0,	//108  const Nepomuk::Types::Ontology&  
	458, 0,	//110  const Nepomuk::Types::Property&  
	459, 0,	//112  const Nepomuk::Variant&  
	460, 0,	//114  const QDate&  
	461, 0,	//116  const QDateTime&  
	462, 0,	//118  const QFont&  
	463, 0,	//120  const QIcon&  
	467, 0,	//122  const QList<Nepomuk::Resource>&  
	468, 0,	//124  const QList<Nepomuk::Tag>&  
	469, 0,	//126  const QList<Nepomuk::Variant>&  
	470, 0,	//128  const QList<QDate>&  
	471, 0,	//130  const QList<QDateTime>&  
	472, 0,	//132  const QList<QTime>&  
	473, 0,	//134  const QList<QUrl>&  
	474, 0,	//136  const QList<bool>&  
	475, 0,	//138  const QList<double>&  
	476, 0,	//140  const QList<int>&  
	477, 0,	//142  const QList<qlonglong>&  
	478, 0,	//144  const QList<qulonglong>&  
	479, 0,	//146  const QList<uint>&  
	480, 0,	//148  const QMap<QString,int>&  
	485, 0,	//150  const QPalette&  
	486, 0,	//152  const QPixmap&  
	491, 339, 384, 487, 0,	//154  const QRect&, Qt::Alignment, Qt::LayoutDirection, const QPoint&  
	491, 487, 0,	//159  const QRect&, const QPoint&  
	495, 0,	//162  const QString&  
	495, 495, 0,	//164  const QString&, const QString&  
	495, 498, 0,	//167  const QString&, const QUrl&  
	495, 498, 96, 0,	//170  const QString&, const QUrl&, Nepomuk::ResourceManager*  
	495, 506, 0,	//174  const QString&, int  
	495, 96, 0,	//177  const QString&, Nepomuk::ResourceManager*  
	496, 0,	//180  const QStringList&  
	497, 0,	//182  const QTime&  
	498, 0,	//184  const QUrl&  
	498, 459, 0,	//186  const QUrl&, const Nepomuk::Variant&  
	498, 498, 0,	//189  const QUrl&, const QUrl&  
	498, 498, 96, 0,	//192  const QUrl&, const QUrl&, Nepomuk::ResourceManager*  
	498, 96, 0,	//196  const QUrl&, Nepomuk::ResourceManager*  
	499, 0,	//199  const QVariant&  
	501, 0,	//201  const Soprano::Node&  
	503, 0,	//203  const char*  
	504, 0,	//205  const unsigned int&  
	505, 0,	//207  double  
	506, 0,	//209  int  
	507, 0,	//211  qlonglong  
	508, 0,	//213  qulonglong  
	509, 0,	//215  uint  
	510, 0,	//217  unsigned int  
	91, 0,	//219  Nepomuk::ErrorCode  
	95, 0,	//221  Nepomuk::ResourceData*  
	96, 0,	//223  Nepomuk::ResourceManager*  
	98, 0,	//225  Nepomuk::Tag  
};

// Raw list of all methods, using munged names
static const char *nepomuk_methodNames[] = {
    "",	//0
    "Class",	//1
    "Class#",	//2
    "CommunicationError",	//3
    "Entity",	//4
    "Entity#",	//5
    "InvalidType",	//6
    "KRatingPainter",	//7
    "KRatingPainter#",	//8
    "KRatingWidget",	//9
    "KRatingWidget#",	//10
    "KTagCloudWidget",	//11
    "KTagCloudWidget#",	//12
    "KTagDisplayWidget",	//13
    "KTagDisplayWidget#",	//14
    "Literal",	//15
    "Literal#",	//16
    "NoError",	//17
    "Ontology",	//18
    "Ontology#",	//19
    "Property",	//20
    "Property#",	//21
    "RDFLiteralToValue",	//22
    "RDFLiteralToValue#",	//23
    "Resource",	//24
    "Resource#",	//25
    "Resource##",	//26
    "Resource###",	//27
    "Resource$",	//28
    "Resource$#",	//29
    "Resource$##",	//30
    "Resource?",	//31
    "Service",	//32
    "Service#",	//33
    "Service#$",	//34
    "Tag",	//35
    "Tag#",	//36
    "Tag##",	//37
    "Tag###",	//38
    "Tag$",	//39
    "Tag$#",	//40
    "Tag$##",	//41
    "TagCloud",	//42
    "TagCloud#",	//43
    "TagWidget",	//44
    "TagWidget#",	//45
    "TagWidget##",	//46
    "Thing",	//47
    "Thing#",	//48
    "Thing##",	//49
    "Thing###",	//50
    "Thing$",	//51
    "Thing$#",	//52
    "Thing$##",	//53
    "Thing?",	//54
    "UnknownError",	//55
    "Variant",	//56
    "Variant#",	//57
    "Variant$",	//58
    "Variant?",	//59
    "actionEvent",	//60
    "actionEvent#",	//61
    "addAltLabel",	//62
    "addAltLabel$",	//63
    "addAnnotation",	//64
    "addAnnotation#",	//65
    "addIdentifier",	//66
    "addIdentifier$",	//67
    "addIsRelated",	//68
    "addIsRelated#",	//69
    "addIsTopicOf",	//70
    "addIsTopicOf#",	//71
    "addProperty",	//72
    "addProperty##",	//73
    "addSymbol",	//74
    "addSymbol$",	//75
    "addTag",	//76
    "addTag#",	//77
    "addTag$",	//78
    "addTag$$",	//79
    "addTags",	//80
    "addTags?",	//81
    "addTopic",	//82
    "addTopic#",	//83
    "addType",	//84
    "addType#",	//85
    "alignment",	//86
    "allClasses",	//87
    "allParentClasses",	//88
    "allProperties",	//89
    "allResources",	//90
    "allResourcesOfType",	//91
    "allResourcesOfType#",	//92
    "allResourcesWithProperty",	//93
    "allResourcesWithProperty##",	//94
    "allSubClasses",	//95
    "allTags",	//96
    "altLabelUri",	//97
    "altLabels",	//98
    "annotationOf",	//99
    "annotationUri",	//100
    "annotations",	//101
    "append",	//102
    "append#",	//103
    "append$",	//104
    "assignedTags",	//105
    "autoUpdate",	//106
    "cardinality",	//107
    "changeEvent",	//108
    "changeEvent#",	//109
    "childEvent",	//110
    "childEvent#",	//111
    "className",	//112
    "clear",	//113
    "closeEvent",	//114
    "closeEvent#",	//115
    "comment",	//116
    "comment$",	//117
    "connectNotify",	//118
    "connectNotify$",	//119
    "contextMenuEvent",	//120
    "contextMenuEvent#",	//121
    "createManagerForModel",	//122
    "createManagerForModel#",	//123
    "customEvent",	//124
    "customEvent#",	//125
    "customPixmap",	//126
    "dataType",	//127
    "dataTypeUri",	//128
    "deleteInstance",	//129
    "description",	//130
    "descriptionUri",	//131
    "devType",	//132
    "disconnectNotify",	//133
    "disconnectNotify$",	//134
    "domain",	//135
    "domainOf",	//136
    "dragEnterEvent",	//137
    "dragEnterEvent#",	//138
    "dragLeaveEvent",	//139
    "dragLeaveEvent#",	//140
    "dragMoveEvent",	//141
    "dragMoveEvent#",	//142
    "dropEvent",	//143
    "dropEvent#",	//144
    "enabledChange",	//145
    "enabledChange$",	//146
    "enterEvent",	//147
    "enterEvent#",	//148
    "error",	//149
    "error$$",	//150
    "errorString",	//151
    "errorString$",	//152
    "event",	//153
    "event#",	//154
    "eventFilter",	//155
    "eventFilter##",	//156
    "exists",	//157
    "findClassByLabel",	//158
    "findClassByLabel$",	//159
    "findClassByLabel$$",	//160
    "findClassByName",	//161
    "findClassByName$",	//162
    "findPropertyByLabel",	//163
    "findPropertyByLabel$",	//164
    "findPropertyByLabel$$",	//165
    "findPropertyByName",	//166
    "findPropertyByName$",	//167
    "focusInEvent",	//168
    "focusInEvent#",	//169
    "focusNextPrevChild",	//170
    "focusNextPrevChild$",	//171
    "focusOutEvent",	//172
    "focusOutEvent#",	//173
    "fontChange",	//174
    "fontChange#",	//175
    "fromString",	//176
    "fromString$$",	//177
    "generateUniqueUri",	//178
    "generateUniqueUri$",	//179
    "genericDescription",	//180
    "genericIcon",	//181
    "genericLabel",	//182
    "getRatingFromPosition",	//183
    "getRatingFromPosition#$$#",	//184
    "groundingOccurrences",	//185
    "halfStepsEnabled",	//186
    "hasProperty",	//187
    "hasProperty#",	//188
    "hasType",	//189
    "hasType#",	//190
    "heightForWidth",	//191
    "heightForWidth$",	//192
    "hideEvent",	//193
    "hideEvent#",	//194
    "icon",	//195
    "identifierUri",	//196
    "identifiers",	//197
    "init",	//198
    "initialized",	//199
    "inputMethodEvent",	//200
    "inputMethodEvent#",	//201
    "inputMethodQuery",	//202
    "inputMethodQuery$",	//203
    "instance",	//204
    "inverseProperty",	//205
    "isAvailable",	//206
    "isBool",	//207
    "isBoolList",	//208
    "isDate",	//209
    "isDateList",	//210
    "isDateTime",	//211
    "isDateTimeList",	//212
    "isDouble",	//213
    "isDoubleList",	//214
    "isEnabled",	//215
    "isInt",	//216
    "isInt64",	//217
    "isInt64List",	//218
    "isIntList",	//219
    "isList",	//220
    "isParentOf",	//221
    "isParentOf#",	//222
    "isRelatedOf",	//223
    "isRelatedUri",	//224
    "isRelateds",	//225
    "isResource",	//226
    "isResourceList",	//227
    "isString",	//228
    "isStringList",	//229
    "isSubClassOf",	//230
    "isSubClassOf#",	//231
    "isSubPropertyOf",	//232
    "isSubPropertyOf#",	//233
    "isTime",	//234
    "isTimeList",	//235
    "isTopicOfUri",	//236
    "isTopicOfs",	//237
    "isUnsignedInt",	//238
    "isUnsignedInt64",	//239
    "isUnsignedInt64List",	//240
    "isUnsignedIntList",	//241
    "isUrl",	//242
    "isUrlList",	//243
    "isValid",	//244
    "keyPressEvent",	//245
    "keyPressEvent#",	//246
    "keyReleaseEvent",	//247
    "keyReleaseEvent#",	//248
    "label",	//249
    "label$",	//250
    "labelUri",	//251
    "languageChange",	//252
    "layoutDirection",	//253
    "leaveEvent",	//254
    "leaveEvent#",	//255
    "literalRangeType",	//256
    "mainModel",	//257
    "manager",	//258
    "maxCardinality",	//259
    "maxRating",	//260
    "metaObject",	//261
    "metric",	//262
    "metric$",	//263
    "minCardinality",	//264
    "minimumSizeHint",	//265
    "mouseDoubleClickEvent",	//266
    "mouseDoubleClickEvent#",	//267
    "mouseMoveEvent",	//268
    "mouseMoveEvent#",	//269
    "mousePressEvent",	//270
    "mousePressEvent#",	//271
    "mouseReleaseEvent",	//272
    "mouseReleaseEvent#",	//273
    "moveEvent",	//274
    "moveEvent#",	//275
    "name",	//276
    "notifyError",	//277
    "notifyError$$",	//278
    "occurrences",	//279
    "operator QUrl",	//280
    "operator!=",	//281
    "operator!=#",	//282
    "operator=",	//283
    "operator=#",	//284
    "operator=$",	//285
    "operator==",	//286
    "operator==#",	//287
    "operator=?",	//288
    "paint",	//289
    "paint##$",	//290
    "paint##$$",	//291
    "paintEngine",	//292
    "paintEvent",	//293
    "paintEvent#",	//294
    "paintRating",	//295
    "paintRating##$$",	//296
    "paintRating##$$$",	//297
    "paletteChange",	//298
    "paletteChange#",	//299
    "parentClasses",	//300
    "parentProperties",	//301
    "pimoThing",	//302
    "properties",	//303
    "property",	//304
    "property#",	//305
    "qt_metacall",	//306
    "qt_metacall$$?",	//307
    "range",	//308
    "rangeOf",	//309
    "rating",	//310
    "ratingChanged",	//311
    "ratingChanged$",	//312
    "ratingFromPosition",	//313
    "ratingFromPosition##",	//314
    "ratingUri",	//315
    "referencingOccurrences",	//316
    "remove",	//317
    "removeProperty",	//318
    "removeProperty#",	//319
    "removeProperty##",	//320
    "removeResource",	//321
    "removeResource$",	//322
    "reset",	//323
    "reset$",	//324
    "resizeEvent",	//325
    "resizeEvent#",	//326
    "resourceModified",	//327
    "resourceModified$",	//328
    "resourceType",	//329
    "resourceTypeUri",	//330
    "resourceUri",	//331
    "setAlignment",	//332
    "setAlignment$",	//333
    "setAltLabels",	//334
    "setAltLabels?",	//335
    "setAnnotations",	//336
    "setAnnotations?",	//337
    "setAssignedTags",	//338
    "setAssignedTags?",	//339
    "setAutoUpdate",	//340
    "setAutoUpdate$",	//341
    "setCustomPixmap",	//342
    "setCustomPixmap#",	//343
    "setDescription",	//344
    "setDescription$",	//345
    "setEnabled",	//346
    "setEnabled$",	//347
    "setHalfStepsEnabled",	//348
    "setHalfStepsEnabled$",	//349
    "setIcon",	//350
    "setIcon#",	//351
    "setIdentifiers",	//352
    "setIdentifiers?",	//353
    "setIsRelateds",	//354
    "setIsRelateds?",	//355
    "setIsTopicOfs",	//356
    "setIsTopicOfs?",	//357
    "setLabel",	//358
    "setLabel$",	//359
    "setLayoutDirection",	//360
    "setLayoutDirection$",	//361
    "setMaxFontSize",	//362
    "setMaxFontSize$",	//363
    "setMaxRating",	//364
    "setMaxRating$",	//365
    "setMinFontSize",	//366
    "setMinFontSize$",	//367
    "setOverrideMainModel",	//368
    "setOverrideMainModel#",	//369
    "setPixmapSize",	//370
    "setPixmapSize$",	//371
    "setProperty",	//372
    "setProperty##",	//373
    "setRating",	//374
    "setRating$",	//375
    "setServiceInitialized",	//376
    "setServiceInitialized$",	//377
    "setSpacing",	//378
    "setSpacing$",	//379
    "setSymbols",	//380
    "setSymbols?",	//381
    "setTaggedResource",	//382
    "setTaggedResource#",	//383
    "setTaggedResources",	//384
    "setTaggedResources?",	//385
    "setTags",	//386
    "setTags?",	//387
    "setTopics",	//388
    "setTopics?",	//389
    "setTypes",	//390
    "setTypes?",	//391
    "setVisible",	//392
    "setVisible$",	//393
    "showEvent",	//394
    "showEvent#",	//395
    "simpleType",	//396
    "sizeHint",	//397
    "spacing",	//398
    "staticMetaObject",	//399
    "styleChange",	//400
    "styleChange#",	//401
    "subClasses",	//402
    "subProperties",	//403
    "symbolUri",	//404
    "symbols",	//405
    "tabletEvent",	//406
    "tabletEvent#",	//407
    "tagClicked",	//408
    "tagClicked#",	//409
    "tagClicked$",	//410
    "tagOf",	//411
    "tagUri",	//412
    "tagWeight",	//413
    "tagWeight$",	//414
    "taggedResources",	//415
    "tags",	//416
    "timerEvent",	//417
    "timerEvent#",	//418
    "toBool",	//419
    "toBoolList",	//420
    "toDate",	//421
    "toDateList",	//422
    "toDateTime",	//423
    "toDateTimeList",	//424
    "toDouble",	//425
    "toDoubleList",	//426
    "toInt",	//427
    "toInt64",	//428
    "toInt64List",	//429
    "toIntList",	//430
    "toResource",	//431
    "toResourceList",	//432
    "toString",	//433
    "toStringList",	//434
    "toTime",	//435
    "toTimeList",	//436
    "toUnsignedInt",	//437
    "toUnsignedInt64",	//438
    "toUnsignedInt64List",	//439
    "toUnsignedIntList",	//440
    "toUrl",	//441
    "toUrlList",	//442
    "toVariantList",	//443
    "topicUri",	//444
    "topics",	//445
    "type",	//446
    "types",	//447
    "updateTags",	//448
    "uri",	//449
    "valueToRDFNode",	//450
    "valueToRDFNode#",	//451
    "valuesToRDFNodes",	//452
    "valuesToRDFNodes#",	//453
    "variant",	//454
    "wheelEvent",	//455
    "wheelEvent#",	//456
    "windowActivationChange",	//457
    "windowActivationChange$",	//458
    "~Class",	//459
    "~Entity",	//460
    "~KRatingPainter",	//461
    "~KRatingWidget",	//462
    "~KTagCloudWidget",	//463
    "~KTagDisplayWidget",	//464
    "~Literal",	//465
    "~Ontology",	//466
    "~Property",	//467
    "~Resource",	//468
    "~Service",	//469
    "~Tag",	//470
    "~TagCloud",	//471
    "~TagWidget",	//472
    "~Thing",	//473
    "~Variant",	//474
};

// (classId, name (index in methodNames), argumentList index, number of args, method flags, return type (index in types), xcall() index)
static Smoke::Method nepomuk_methods[] = {
	{1, 7, 0, 0, Smoke::mf_ctor, 65, 1},	//0 KRatingPainter::KRatingPainter()
	{1, 461, 0, 0, Smoke::mf_dtor, 0, 25},	//1 KRatingPainter::~KRatingPainter()
	{1, 260, 0, 0, Smoke::mf_const, 506, 2},	//2 KRatingPainter::maxRating() const
	{1, 186, 0, 0, Smoke::mf_const, 449, 3},	//3 KRatingPainter::halfStepsEnabled() const
	{1, 86, 0, 0, Smoke::mf_const, 339, 4},	//4 KRatingPainter::alignment() const
	{1, 253, 0, 0, Smoke::mf_const, 384, 5},	//5 KRatingPainter::layoutDirection() const
	{1, 195, 0, 0, Smoke::mf_const, 193, 6},	//6 KRatingPainter::icon() const
	{1, 215, 0, 0, Smoke::mf_const, 449, 7},	//7 KRatingPainter::isEnabled() const
	{1, 126, 0, 0, Smoke::mf_const, 262, 8},	//8 KRatingPainter::customPixmap() const
	{1, 398, 0, 0, Smoke::mf_const, 506, 9},	//9 KRatingPainter::spacing() const
	{1, 364, 209, 1, 0, 0, 10},	//10 KRatingPainter::setMaxRating(int)
	{1, 348, 89, 1, 0, 0, 11},	//11 KRatingPainter::setHalfStepsEnabled(bool)
	{1, 332, 81, 1, 0, 0, 12},	//12 KRatingPainter::setAlignment(Qt::Alignment)
	{1, 360, 85, 1, 0, 0, 13},	//13 KRatingPainter::setLayoutDirection(Qt::LayoutDirection)
	{1, 350, 120, 1, 0, 0, 14},	//14 KRatingPainter::setIcon(const QIcon&)
	{1, 346, 89, 1, 0, 0, 15},	//15 KRatingPainter::setEnabled(bool)
	{1, 342, 152, 1, 0, 0, 16},	//16 KRatingPainter::setCustomPixmap(const QPixmap&)
	{1, 378, 209, 1, 0, 0, 17},	//17 KRatingPainter::setSpacing(int)
	{1, 289, 62, 4, Smoke::mf_const, 0, 18},	//18 KRatingPainter::paint(QPainter*, const QRect&, int, int) const
	{1, 289, 58, 3, Smoke::mf_const, 0, 19},	//19 KRatingPainter::paint(QPainter*, const QRect&, int) const
	{1, 313, 159, 2, Smoke::mf_const, 506, 20},	//20 KRatingPainter::ratingFromPosition(const QRect&, const QPoint&) const
	{1, 7, 91, 1, Smoke::mf_copyctor|Smoke::mf_internal|Smoke::mf_ctor, 65, 21},	//21 KRatingPainter::KRatingPainter(const KRatingPainter&)
	{1, 295, 52, 5, Smoke::mf_static, 0, 22},	//22 KRatingPainter::paintRating(QPainter*, const QRect&, Qt::Alignment, int, int)
	{1, 295, 47, 4, Smoke::mf_static, 0, 23},	//23 KRatingPainter::paintRating(QPainter*, const QRect&, Qt::Alignment, int)
	{1, 183, 154, 4, Smoke::mf_static, 506, 24},	//24 KRatingPainter::getRatingFromPosition(const QRect&, Qt::Alignment, Qt::LayoutDirection, const QPoint&)
	{2, 261, 0, 0, Smoke::mf_const, 482, 2},	//25 KRatingWidget::metaObject() const
	{2, 306, 27, 3, 0, 506, 3},	//26 KRatingWidget::qt_metacall(QMetaObject::Call, int, void**)
	{2, 9, 79, 1, Smoke::mf_ctor, 66, 4},	//27 KRatingWidget::KRatingWidget(QWidget*)
	{2, 9, 0, 0, Smoke::mf_ctor, 66, 5},	//28 KRatingWidget::KRatingWidget()
	{2, 462, 0, 0, Smoke::mf_dtor, 0, 30},	//29 KRatingWidget::~KRatingWidget()
	{2, 310, 0, 0, Smoke::mf_const, 510, 6},	//30 KRatingWidget::rating() const
	{2, 260, 0, 0, Smoke::mf_const, 506, 7},	//31 KRatingWidget::maxRating() const
	{2, 86, 0, 0, Smoke::mf_const, 339, 8},	//32 KRatingWidget::alignment() const
	{2, 253, 0, 0, Smoke::mf_const, 384, 9},	//33 KRatingWidget::layoutDirection() const
	{2, 398, 0, 0, Smoke::mf_const, 506, 10},	//34 KRatingWidget::spacing() const
	{2, 397, 0, 0, Smoke::mf_const, 268, 11},	//35 KRatingWidget::sizeHint() const
	{2, 186, 0, 0, Smoke::mf_const, 449, 12},	//36 KRatingWidget::halfStepsEnabled() const
	{2, 195, 0, 0, Smoke::mf_const, 193, 13},	//37 KRatingWidget::icon() const
	{2, 374, 209, 1, 0, 0, 14},	//38 KRatingWidget::setRating(int)
	{2, 364, 209, 1, 0, 0, 15},	//39 KRatingWidget::setMaxRating(int)
	{2, 348, 89, 1, 0, 0, 16},	//40 KRatingWidget::setHalfStepsEnabled(bool)
	{2, 378, 209, 1, 0, 0, 17},	//41 KRatingWidget::setSpacing(int)
	{2, 332, 81, 1, 0, 0, 18},	//42 KRatingWidget::setAlignment(Qt::Alignment)
	{2, 360, 85, 1, 0, 0, 19},	//43 KRatingWidget::setLayoutDirection(Qt::LayoutDirection)
	{2, 350, 120, 1, 0, 0, 20},	//44 KRatingWidget::setIcon(const QIcon&)
	{2, 342, 152, 1, 0, 0, 21},	//45 KRatingWidget::setCustomPixmap(const QPixmap&)
	{2, 370, 209, 1, 0, 0, 22},	//46 KRatingWidget::setPixmapSize(int)
	{2, 311, 217, 1, 0, 0, 23},	//47 KRatingWidget::ratingChanged(unsigned int)
	{2, 311, 209, 1, 0, 0, 24},	//48 KRatingWidget::ratingChanged(int)
	{2, 399, 0, 0, Smoke::mf_static, 481, 1},	//49 KRatingWidget::staticMetaObject (static var)
	{2, 270, 31, 1, Smoke::mf_protected, 0, 25},	//50 KRatingWidget::mousePressEvent(QMouseEvent*)
	{2, 268, 31, 1, Smoke::mf_protected, 0, 26},	//51 KRatingWidget::mouseMoveEvent(QMouseEvent*)
	{2, 254, 17, 1, Smoke::mf_protected, 0, 27},	//52 KRatingWidget::leaveEvent(QEvent*)
	{2, 293, 45, 1, Smoke::mf_protected, 0, 28},	//53 KRatingWidget::paintEvent(QPaintEvent*)
	{2, 325, 67, 1, Smoke::mf_protected, 0, 29},	//54 KRatingWidget::resizeEvent(QResizeEvent*)
	{3, 261, 0, 0, Smoke::mf_const, 482, 2},	//55 KTagCloudWidget::metaObject() const
	{3, 306, 27, 3, 0, 506, 3},	//56 KTagCloudWidget::qt_metacall(QMetaObject::Call, int, void**)
	{3, 11, 79, 1, Smoke::mf_ctor, 75, 4},	//57 KTagCloudWidget::KTagCloudWidget(QWidget*)
	{3, 11, 0, 0, Smoke::mf_ctor, 75, 5},	//58 KTagCloudWidget::KTagCloudWidget()
	{3, 463, 0, 0, Smoke::mf_dtor, 0, 14},	//59 KTagCloudWidget::~KTagCloudWidget()
	{3, 413, 162, 1, Smoke::mf_const, 506, 6},	//60 KTagCloudWidget::tagWeight(const QString&) const
	{3, 76, 174, 2, 0, 0, 7},	//61 KTagCloudWidget::addTag(const QString&, int)
	{3, 80, 148, 1, 0, 0, 8},	//62 KTagCloudWidget::addTags(const QMap<QString,int>&)
	{3, 113, 0, 0, 0, 0, 9},	//63 KTagCloudWidget::clear()
	{3, 362, 209, 1, 0, 0, 10},	//64 KTagCloudWidget::setMaxFontSize(int)
	{3, 366, 209, 1, 0, 0, 11},	//65 KTagCloudWidget::setMinFontSize(int)
	{3, 408, 162, 1, 0, 0, 12},	//66 KTagCloudWidget::tagClicked(const QString&)
	{3, 399, 0, 0, Smoke::mf_static, 481, 1},	//67 KTagCloudWidget::staticMetaObject (static var)
	{3, 325, 67, 1, Smoke::mf_protected, 0, 13},	//68 KTagCloudWidget::resizeEvent(QResizeEvent*)
	{4, 261, 0, 0, Smoke::mf_const, 482, 2},	//69 KTagDisplayWidget::metaObject() const
	{4, 306, 27, 3, 0, 506, 3},	//70 KTagDisplayWidget::qt_metacall(QMetaObject::Call, int, void**)
	{4, 13, 79, 1, Smoke::mf_ctor, 76, 4},	//71 KTagDisplayWidget::KTagDisplayWidget(QWidget*)
	{4, 13, 0, 0, Smoke::mf_ctor, 76, 5},	//72 KTagDisplayWidget::KTagDisplayWidget()
	{4, 464, 0, 0, Smoke::mf_dtor, 0, 11},	//73 KTagDisplayWidget::~KTagDisplayWidget()
	{4, 386, 180, 1, 0, 0, 6},	//74 KTagDisplayWidget::setTags(const QStringList&)
	{4, 76, 162, 1, 0, 0, 7},	//75 KTagDisplayWidget::addTag(const QString&)
	{4, 80, 180, 1, 0, 0, 8},	//76 KTagDisplayWidget::addTags(const QStringList&)
	{4, 113, 0, 0, 0, 0, 9},	//77 KTagDisplayWidget::clear()
	{4, 408, 162, 1, 0, 0, 10},	//78 KTagDisplayWidget::tagClicked(const QString&)
	{4, 399, 0, 0, Smoke::mf_static, 481, 1},	//79 KTagDisplayWidget::staticMetaObject (static var)
	{5, 17, 0, 0, Smoke::mf_static|Smoke::mf_enum, 91, 1},	//80 Nepomuk::NoError (enum)
	{5, 3, 0, 0, Smoke::mf_static|Smoke::mf_enum, 91, 2},	//81 Nepomuk::CommunicationError (enum)
	{5, 6, 0, 0, Smoke::mf_static|Smoke::mf_enum, 91, 3},	//82 Nepomuk::InvalidType (enum)
	{5, 55, 0, 0, Smoke::mf_static|Smoke::mf_enum, 91, 4},	//83 Nepomuk::UnknownError (enum)
	{5, 151, 219, 1, Smoke::mf_static, 273, 5},	//84 Nepomuk::errorString(Nepomuk::ErrorCode)
	{5, 452, 112, 1, Smoke::mf_static, 215, 6},	//85 Nepomuk::valuesToRDFNodes(const Nepomuk::Variant&)
	{5, 450, 112, 1, Smoke::mf_static, 437, 7},	//86 Nepomuk::valueToRDFNode(const Nepomuk::Variant&)
	{5, 22, 201, 1, Smoke::mf_static, 119, 8},	//87 Nepomuk::RDFLiteralToValue(const Soprano::Node&)
	{7, 24, 0, 0, Smoke::mf_ctor, 94, 1},	//88 Nepomuk::Resource::Resource()
	{7, 24, 223, 1, Smoke::mf_ctor, 94, 2},	//89 Nepomuk::Resource::Resource(Nepomuk::ResourceManager*)
	{7, 24, 93, 1, Smoke::mf_copyctor|Smoke::mf_ctor, 94, 3},	//90 Nepomuk::Resource::Resource(const Nepomuk::Resource&)
	{7, 24, 167, 2, Smoke::mf_ctor, 94, 4},	//91 Nepomuk::Resource::Resource(const QString&, const QUrl&)
	{7, 24, 162, 1, Smoke::mf_ctor, 94, 5},	//92 Nepomuk::Resource::Resource(const QString&)
	{7, 24, 170, 3, Smoke::mf_ctor, 94, 6},	//93 Nepomuk::Resource::Resource(const QString&, const QUrl&, Nepomuk::ResourceManager*)
	{7, 24, 189, 2, Smoke::mf_ctor, 94, 7},	//94 Nepomuk::Resource::Resource(const QUrl&, const QUrl&)
	{7, 24, 184, 1, Smoke::mf_ctor, 94, 8},	//95 Nepomuk::Resource::Resource(const QUrl&)
	{7, 24, 192, 3, Smoke::mf_ctor, 94, 9},	//96 Nepomuk::Resource::Resource(const QUrl&, const QUrl&, Nepomuk::ResourceManager*)
	{7, 24, 221, 1, Smoke::mf_ctor, 94, 10},	//97 Nepomuk::Resource::Resource(Nepomuk::ResourceData*)
	{7, 468, 0, 0, Smoke::mf_dtor, 0, 80},	//98 Nepomuk::Resource::~Resource()
	{7, 283, 93, 1, 0, 93, 11},	//99 Nepomuk::Resource::operator=(const Nepomuk::Resource&)
	{7, 283, 184, 1, 0, 93, 12},	//100 Nepomuk::Resource::operator=(const QUrl&)
	{7, 258, 0, 0, Smoke::mf_const, 96, 13},	//101 Nepomuk::Resource::manager() const
	{7, 331, 0, 0, Smoke::mf_const, 323, 14},	//102 Nepomuk::Resource::resourceUri() const
	{7, 329, 0, 0, Smoke::mf_const, 323, 15},	//103 Nepomuk::Resource::resourceType() const
	{7, 447, 0, 0, Smoke::mf_const, 213, 16},	//104 Nepomuk::Resource::types() const
	{7, 390, 134, 1, 0, 0, 17},	//105 Nepomuk::Resource::setTypes(const QList<QUrl>&)
	{7, 84, 184, 1, 0, 0, 18},	//106 Nepomuk::Resource::addType(const QUrl&)
	{7, 189, 184, 1, Smoke::mf_const, 449, 19},	//107 Nepomuk::Resource::hasType(const QUrl&) const
	{7, 112, 0, 0, Smoke::mf_const, 273, 20},	//108 Nepomuk::Resource::className() const
	{7, 303, 0, 0, Smoke::mf_const, 189, 21},	//109 Nepomuk::Resource::properties() const
	{7, 187, 184, 1, Smoke::mf_const, 449, 22},	//110 Nepomuk::Resource::hasProperty(const QUrl&) const
	{7, 304, 184, 1, Smoke::mf_const, 119, 23},	//111 Nepomuk::Resource::property(const QUrl&) const
	{7, 372, 186, 2, 0, 0, 24},	//112 Nepomuk::Resource::setProperty(const QUrl&, const Nepomuk::Variant&)
	{7, 72, 186, 2, 0, 0, 25},	//113 Nepomuk::Resource::addProperty(const QUrl&, const Nepomuk::Variant&)
	{7, 318, 184, 1, 0, 0, 26},	//114 Nepomuk::Resource::removeProperty(const QUrl&)
	{7, 318, 186, 2, 0, 0, 27},	//115 Nepomuk::Resource::removeProperty(const QUrl&, const Nepomuk::Variant&)
	{7, 317, 0, 0, 0, 0, 28},	//116 Nepomuk::Resource::remove()
	{7, 157, 0, 0, Smoke::mf_const, 449, 29},	//117 Nepomuk::Resource::exists() const
	{7, 244, 0, 0, Smoke::mf_const, 449, 30},	//118 Nepomuk::Resource::isValid() const
	{7, 182, 0, 0, Smoke::mf_const, 273, 31},	//119 Nepomuk::Resource::genericLabel() const
	{7, 180, 0, 0, Smoke::mf_const, 273, 32},	//120 Nepomuk::Resource::genericDescription() const
	{7, 181, 0, 0, Smoke::mf_const, 273, 33},	//121 Nepomuk::Resource::genericIcon() const
	{7, 302, 0, 0, 0, 103, 34},	//122 Nepomuk::Resource::pimoThing()
	{7, 286, 93, 1, Smoke::mf_const, 449, 35},	//123 Nepomuk::Resource::operator==(const Nepomuk::Resource&) const
	{7, 130, 0, 0, Smoke::mf_const, 273, 36},	//124 Nepomuk::Resource::description() const
	{7, 344, 162, 1, 0, 0, 37},	//125 Nepomuk::Resource::setDescription(const QString&)
	{7, 197, 0, 0, Smoke::mf_const, 277, 38},	//126 Nepomuk::Resource::identifiers() const
	{7, 352, 180, 1, 0, 0, 39},	//127 Nepomuk::Resource::setIdentifiers(const QStringList&)
	{7, 66, 162, 1, 0, 0, 40},	//128 Nepomuk::Resource::addIdentifier(const QString&)
	{7, 98, 0, 0, Smoke::mf_const, 277, 41},	//129 Nepomuk::Resource::altLabels() const
	{7, 334, 180, 1, 0, 0, 42},	//130 Nepomuk::Resource::setAltLabels(const QStringList&)
	{7, 62, 162, 1, 0, 0, 43},	//131 Nepomuk::Resource::addAltLabel(const QString&)
	{7, 101, 0, 0, Smoke::mf_const, 205, 44},	//132 Nepomuk::Resource::annotations() const
	{7, 336, 122, 1, 0, 0, 45},	//133 Nepomuk::Resource::setAnnotations(const QList<Nepomuk::Resource>&)
	{7, 64, 93, 1, 0, 0, 46},	//134 Nepomuk::Resource::addAnnotation(const Nepomuk::Resource&)
	{7, 416, 0, 0, Smoke::mf_const, 206, 47},	//135 Nepomuk::Resource::tags() const
	{7, 386, 124, 1, 0, 0, 48},	//136 Nepomuk::Resource::setTags(const QList<Nepomuk::Tag>&)
	{7, 76, 98, 1, 0, 0, 49},	//137 Nepomuk::Resource::addTag(const Nepomuk::Tag&)
	{7, 445, 0, 0, Smoke::mf_const, 205, 50},	//138 Nepomuk::Resource::topics() const
	{7, 388, 122, 1, 0, 0, 51},	//139 Nepomuk::Resource::setTopics(const QList<Nepomuk::Resource>&)
	{7, 82, 93, 1, 0, 0, 52},	//140 Nepomuk::Resource::addTopic(const Nepomuk::Resource&)
	{7, 237, 0, 0, Smoke::mf_const, 205, 53},	//141 Nepomuk::Resource::isTopicOfs() const
	{7, 356, 122, 1, 0, 0, 54},	//142 Nepomuk::Resource::setIsTopicOfs(const QList<Nepomuk::Resource>&)
	{7, 70, 93, 1, 0, 0, 55},	//143 Nepomuk::Resource::addIsTopicOf(const Nepomuk::Resource&)
	{7, 225, 0, 0, Smoke::mf_const, 205, 56},	//144 Nepomuk::Resource::isRelateds() const
	{7, 354, 122, 1, 0, 0, 57},	//145 Nepomuk::Resource::setIsRelateds(const QList<Nepomuk::Resource>&)
	{7, 68, 93, 1, 0, 0, 58},	//146 Nepomuk::Resource::addIsRelated(const Nepomuk::Resource&)
	{7, 249, 0, 0, Smoke::mf_const, 273, 59},	//147 Nepomuk::Resource::label() const
	{7, 358, 162, 1, 0, 0, 60},	//148 Nepomuk::Resource::setLabel(const QString&)
	{7, 310, 0, 0, Smoke::mf_const, 510, 61},	//149 Nepomuk::Resource::rating() const
	{7, 374, 205, 1, 0, 0, 62},	//150 Nepomuk::Resource::setRating(const unsigned int&)
	{7, 405, 0, 0, Smoke::mf_const, 277, 63},	//151 Nepomuk::Resource::symbols() const
	{7, 380, 180, 1, 0, 0, 64},	//152 Nepomuk::Resource::setSymbols(const QStringList&)
	{7, 74, 162, 1, 0, 0, 65},	//153 Nepomuk::Resource::addSymbol(const QString&)
	{7, 99, 0, 0, Smoke::mf_const, 205, 66},	//154 Nepomuk::Resource::annotationOf() const
	{7, 223, 0, 0, Smoke::mf_const, 205, 67},	//155 Nepomuk::Resource::isRelatedOf() const
	{7, 131, 0, 0, Smoke::mf_static, 273, 68},	//156 Nepomuk::Resource::descriptionUri()
	{7, 196, 0, 0, Smoke::mf_static, 273, 69},	//157 Nepomuk::Resource::identifierUri()
	{7, 97, 0, 0, Smoke::mf_static, 273, 70},	//158 Nepomuk::Resource::altLabelUri()
	{7, 100, 0, 0, Smoke::mf_static, 273, 71},	//159 Nepomuk::Resource::annotationUri()
	{7, 412, 0, 0, Smoke::mf_static, 273, 72},	//160 Nepomuk::Resource::tagUri()
	{7, 444, 0, 0, Smoke::mf_static, 273, 73},	//161 Nepomuk::Resource::topicUri()
	{7, 236, 0, 0, Smoke::mf_static, 273, 74},	//162 Nepomuk::Resource::isTopicOfUri()
	{7, 224, 0, 0, Smoke::mf_static, 273, 75},	//163 Nepomuk::Resource::isRelatedUri()
	{7, 251, 0, 0, Smoke::mf_static, 273, 76},	//164 Nepomuk::Resource::labelUri()
	{7, 315, 0, 0, Smoke::mf_static, 273, 77},	//165 Nepomuk::Resource::ratingUri()
	{7, 404, 0, 0, Smoke::mf_static, 273, 78},	//166 Nepomuk::Resource::symbolUri()
	{7, 90, 0, 0, Smoke::mf_static, 205, 79},	//167 Nepomuk::Resource::allResources()
	{8, 261, 0, 0, Smoke::mf_const, 482, 2},	//168 Nepomuk::ResourceManager::metaObject() const
	{8, 306, 27, 3, 0, 506, 3},	//169 Nepomuk::ResourceManager::qt_metacall(QMetaObject::Call, int, void**)
	{8, 129, 0, 0, 0, 0, 4},	//170 Nepomuk::ResourceManager::deleteInstance()
	{8, 198, 0, 0, 0, 506, 5},	//171 Nepomuk::ResourceManager::init()
	{8, 199, 0, 0, Smoke::mf_const, 449, 6},	//172 Nepomuk::ResourceManager::initialized() const
	{8, 257, 0, 0, 0, 436, 7},	//173 Nepomuk::ResourceManager::mainModel()
	{8, 368, 87, 1, 0, 0, 8},	//174 Nepomuk::ResourceManager::setOverrideMainModel(Soprano::Model*)
	{8, 321, 162, 1, 0, 0, 9},	//175 Nepomuk::ResourceManager::removeResource(const QString&)
	{8, 91, 184, 1, 0, 205, 10},	//176 Nepomuk::ResourceManager::allResourcesOfType(const QUrl&)
	{8, 93, 186, 2, 0, 205, 11},	//177 Nepomuk::ResourceManager::allResourcesWithProperty(const QUrl&, const Nepomuk::Variant&)
	{8, 178, 162, 1, 0, 323, 12},	//178 Nepomuk::ResourceManager::generateUniqueUri(const QString&)
	{8, 277, 174, 2, 0, 0, 13},	//179 Nepomuk::ResourceManager::notifyError(const QString&, int)
	{8, 204, 0, 0, Smoke::mf_static, 96, 14},	//180 Nepomuk::ResourceManager::instance()
	{8, 122, 87, 1, Smoke::mf_static, 96, 15},	//181 Nepomuk::ResourceManager::createManagerForModel(Soprano::Model*)
	{8, 399, 0, 0, Smoke::mf_static, 481, 1},	//182 Nepomuk::ResourceManager::staticMetaObject (static var)
	{9, 261, 0, 0, Smoke::mf_const, 482, 2},	//183 Nepomuk::Service::metaObject() const
	{9, 306, 27, 3, 0, 506, 3},	//184 Nepomuk::Service::qt_metacall(QMetaObject::Call, int, void**)
	{9, 32, 40, 2, Smoke::mf_ctor, 97, 4},	//185 Nepomuk::Service::Service(QObject*, bool)
	{9, 32, 35, 1, Smoke::mf_ctor, 97, 5},	//186 Nepomuk::Service::Service(QObject*)
	{9, 32, 0, 0, Smoke::mf_ctor, 97, 6},	//187 Nepomuk::Service::Service()
	{9, 469, 0, 0, Smoke::mf_dtor, 0, 9},	//188 Nepomuk::Service::~Service()
	{9, 399, 0, 0, Smoke::mf_static, 481, 1},	//189 Nepomuk::Service::staticMetaObject (static var)
	{9, 257, 0, 0, Smoke::mf_protected, 436, 7},	//190 Nepomuk::Service::mainModel()
	{9, 376, 89, 1, Smoke::mf_protected, 0, 8},	//191 Nepomuk::Service::setServiceInitialized(bool)
	{10, 35, 0, 0, Smoke::mf_ctor, 100, 1},	//192 Nepomuk::Tag::Tag()
	{10, 35, 223, 1, Smoke::mf_ctor, 100, 2},	//193 Nepomuk::Tag::Tag(Nepomuk::ResourceManager*)
	{10, 35, 98, 1, Smoke::mf_copyctor|Smoke::mf_ctor, 100, 3},	//194 Nepomuk::Tag::Tag(const Nepomuk::Tag&)
	{10, 35, 93, 1, Smoke::mf_ctor, 100, 4},	//195 Nepomuk::Tag::Tag(const Nepomuk::Resource&)
	{10, 35, 162, 1, Smoke::mf_ctor, 100, 5},	//196 Nepomuk::Tag::Tag(const QString&)
	{10, 35, 177, 2, Smoke::mf_ctor, 100, 6},	//197 Nepomuk::Tag::Tag(const QString&, Nepomuk::ResourceManager*)
	{10, 35, 184, 1, Smoke::mf_ctor, 100, 7},	//198 Nepomuk::Tag::Tag(const QUrl&)
	{10, 35, 196, 2, Smoke::mf_ctor, 100, 8},	//199 Nepomuk::Tag::Tag(const QUrl&, Nepomuk::ResourceManager*)
	{10, 470, 0, 0, Smoke::mf_dtor, 0, 17},	//200 Nepomuk::Tag::~Tag()
	{10, 283, 98, 1, 0, 99, 9},	//201 Nepomuk::Tag::operator=(const Nepomuk::Tag&)
	{10, 411, 0, 0, Smoke::mf_const, 205, 10},	//202 Nepomuk::Tag::tagOf() const
	{10, 96, 0, 0, Smoke::mf_static, 206, 11},	//203 Nepomuk::Tag::allTags()
	{10, 330, 0, 0, Smoke::mf_static, 273, 12},	//204 Nepomuk::Tag::resourceTypeUri()
	{10, 35, 167, 2, Smoke::mf_ctor|Smoke::mf_protected, 100, 13},	//205 Nepomuk::Tag::Tag(const QString&, const QUrl&)
	{10, 35, 189, 2, Smoke::mf_ctor|Smoke::mf_protected, 100, 14},	//206 Nepomuk::Tag::Tag(const QUrl&, const QUrl&)
	{10, 35, 170, 3, Smoke::mf_ctor|Smoke::mf_protected, 100, 15},	//207 Nepomuk::Tag::Tag(const QString&, const QUrl&, Nepomuk::ResourceManager*)
	{10, 35, 192, 3, Smoke::mf_ctor|Smoke::mf_protected, 100, 16},	//208 Nepomuk::Tag::Tag(const QUrl&, const QUrl&, Nepomuk::ResourceManager*)
	{11, 261, 0, 0, Smoke::mf_const, 482, 2},	//209 Nepomuk::TagCloud::metaObject() const
	{11, 306, 27, 3, 0, 506, 3},	//210 Nepomuk::TagCloud::qt_metacall(QMetaObject::Call, int, void**)
	{11, 42, 79, 1, Smoke::mf_ctor, 101, 4},	//211 Nepomuk::TagCloud::TagCloud(QWidget*)
	{11, 42, 0, 0, Smoke::mf_ctor, 101, 5},	//212 Nepomuk::TagCloud::TagCloud()
	{11, 471, 0, 0, Smoke::mf_dtor, 0, 10},	//213 Nepomuk::TagCloud::~TagCloud()
	{11, 106, 0, 0, Smoke::mf_const, 449, 6},	//214 Nepomuk::TagCloud::autoUpdate() const
	{11, 448, 0, 0, 0, 0, 7},	//215 Nepomuk::TagCloud::updateTags()
	{11, 340, 89, 1, 0, 0, 8},	//216 Nepomuk::TagCloud::setAutoUpdate(bool)
	{11, 408, 225, 1, 0, 0, 9},	//217 Nepomuk::TagCloud::tagClicked(Nepomuk::Tag)
	{11, 399, 0, 0, Smoke::mf_static, 481, 1},	//218 Nepomuk::TagCloud::staticMetaObject (static var)
	{12, 261, 0, 0, Smoke::mf_const, 482, 2},	//219 Nepomuk::TagWidget::metaObject() const
	{12, 306, 27, 3, 0, 506, 3},	//220 Nepomuk::TagWidget::qt_metacall(QMetaObject::Call, int, void**)
	{12, 44, 95, 2, Smoke::mf_ctor, 102, 4},	//221 Nepomuk::TagWidget::TagWidget(const Nepomuk::Resource&, QWidget*)
	{12, 44, 93, 1, Smoke::mf_ctor, 102, 5},	//222 Nepomuk::TagWidget::TagWidget(const Nepomuk::Resource&)
	{12, 44, 79, 1, Smoke::mf_ctor, 102, 6},	//223 Nepomuk::TagWidget::TagWidget(QWidget*)
	{12, 44, 0, 0, Smoke::mf_ctor, 102, 7},	//224 Nepomuk::TagWidget::TagWidget()
	{12, 472, 0, 0, Smoke::mf_dtor, 0, 14},	//225 Nepomuk::TagWidget::~TagWidget()
	{12, 415, 0, 0, Smoke::mf_const, 205, 8},	//226 Nepomuk::TagWidget::taggedResources() const
	{12, 105, 0, 0, Smoke::mf_const, 206, 9},	//227 Nepomuk::TagWidget::assignedTags() const
	{12, 382, 93, 1, 0, 0, 10},	//228 Nepomuk::TagWidget::setTaggedResource(const Nepomuk::Resource&)
	{12, 384, 122, 1, 0, 0, 11},	//229 Nepomuk::TagWidget::setTaggedResources(const QList<Nepomuk::Resource>&)
	{12, 338, 124, 1, 0, 0, 12},	//230 Nepomuk::TagWidget::setAssignedTags(const QList<Nepomuk::Tag>&)
	{12, 408, 225, 1, 0, 0, 13},	//231 Nepomuk::TagWidget::tagClicked(Nepomuk::Tag)
	{12, 399, 0, 0, Smoke::mf_static, 481, 1},	//232 Nepomuk::TagWidget::staticMetaObject (static var)
	{13, 47, 189, 2, Smoke::mf_ctor, 105, 1},	//233 Nepomuk::Thing::Thing(const QUrl&, const QUrl&)
	{13, 47, 184, 1, Smoke::mf_ctor, 105, 2},	//234 Nepomuk::Thing::Thing(const QUrl&)
	{13, 47, 0, 0, Smoke::mf_ctor, 105, 3},	//235 Nepomuk::Thing::Thing()
	{13, 47, 192, 3, Smoke::mf_ctor, 105, 4},	//236 Nepomuk::Thing::Thing(const QUrl&, const QUrl&, Nepomuk::ResourceManager*)
	{13, 47, 167, 2, Smoke::mf_ctor, 105, 5},	//237 Nepomuk::Thing::Thing(const QString&, const QUrl&)
	{13, 47, 162, 1, Smoke::mf_ctor, 105, 6},	//238 Nepomuk::Thing::Thing(const QString&)
	{13, 47, 170, 3, Smoke::mf_ctor, 105, 7},	//239 Nepomuk::Thing::Thing(const QString&, const QUrl&, Nepomuk::ResourceManager*)
	{13, 47, 100, 1, Smoke::mf_copyctor|Smoke::mf_ctor, 105, 8},	//240 Nepomuk::Thing::Thing(const Nepomuk::Thing&)
	{13, 47, 93, 1, Smoke::mf_ctor, 105, 9},	//241 Nepomuk::Thing::Thing(const Nepomuk::Resource&)
	{13, 47, 221, 1, Smoke::mf_ctor, 105, 10},	//242 Nepomuk::Thing::Thing(Nepomuk::ResourceData*)
	{13, 473, 0, 0, Smoke::mf_dtor, 0, 17},	//243 Nepomuk::Thing::~Thing()
	{13, 283, 100, 1, 0, 104, 11},	//244 Nepomuk::Thing::operator=(const Nepomuk::Thing&)
	{13, 283, 93, 1, 0, 104, 12},	//245 Nepomuk::Thing::operator=(const Nepomuk::Resource&)
	{13, 283, 184, 1, 0, 104, 13},	//246 Nepomuk::Thing::operator=(const QUrl&)
	{13, 185, 0, 0, Smoke::mf_const, 205, 14},	//247 Nepomuk::Thing::groundingOccurrences() const
	{13, 316, 0, 0, Smoke::mf_const, 205, 15},	//248 Nepomuk::Thing::referencingOccurrences() const
	{13, 279, 0, 0, Smoke::mf_const, 205, 16},	//249 Nepomuk::Thing::occurrences() const
	{15, 1, 0, 0, Smoke::mf_ctor, 108, 1},	//250 Nepomuk::Types::Class::Class()
	{15, 1, 184, 1, Smoke::mf_ctor, 108, 2},	//251 Nepomuk::Types::Class::Class(const QUrl&)
	{15, 1, 102, 1, Smoke::mf_copyctor|Smoke::mf_ctor, 108, 3},	//252 Nepomuk::Types::Class::Class(const Nepomuk::Types::Class&)
	{15, 459, 0, 0, Smoke::mf_dtor, 0, 16},	//253 Nepomuk::Types::Class::~Class()
	{15, 283, 102, 1, 0, 107, 4},	//254 Nepomuk::Types::Class::operator=(const Nepomuk::Types::Class&)
	{15, 309, 0, 0, 0, 208, 5},	//255 Nepomuk::Types::Class::rangeOf()
	{15, 136, 0, 0, 0, 208, 6},	//256 Nepomuk::Types::Class::domainOf()
	{15, 166, 162, 1, 0, 116, 7},	//257 Nepomuk::Types::Class::findPropertyByName(const QString&)
	{15, 163, 164, 2, 0, 116, 8},	//258 Nepomuk::Types::Class::findPropertyByLabel(const QString&, const QString&)
	{15, 163, 162, 1, 0, 116, 9},	//259 Nepomuk::Types::Class::findPropertyByLabel(const QString&)
	{15, 300, 0, 0, 0, 207, 10},	//260 Nepomuk::Types::Class::parentClasses()
	{15, 402, 0, 0, 0, 207, 11},	//261 Nepomuk::Types::Class::subClasses()
	{15, 88, 0, 0, 0, 207, 12},	//262 Nepomuk::Types::Class::allParentClasses()
	{15, 95, 0, 0, 0, 207, 13},	//263 Nepomuk::Types::Class::allSubClasses()
	{15, 221, 102, 1, 0, 449, 14},	//264 Nepomuk::Types::Class::isParentOf(const Nepomuk::Types::Class&)
	{15, 230, 102, 1, 0, 449, 15},	//265 Nepomuk::Types::Class::isSubClassOf(const Nepomuk::Types::Class&)
	{16, 4, 104, 1, Smoke::mf_copyctor|Smoke::mf_ctor, 110, 1},	//266 Nepomuk::Types::Entity::Entity(const Nepomuk::Types::Entity&)
	{16, 460, 0, 0, Smoke::mf_dtor, 0, 18},	//267 Nepomuk::Types::Entity::~Entity()
	{16, 283, 104, 1, 0, 109, 2},	//268 Nepomuk::Types::Entity::operator=(const Nepomuk::Types::Entity&)
	{16, 276, 0, 0, Smoke::mf_const, 273, 3},	//269 Nepomuk::Types::Entity::name() const
	{16, 449, 0, 0, Smoke::mf_const, 323, 4},	//270 Nepomuk::Types::Entity::uri() const
	{16, 249, 162, 1, 0, 273, 5},	//271 Nepomuk::Types::Entity::label(const QString&)
	{16, 249, 0, 0, 0, 273, 6},	//272 Nepomuk::Types::Entity::label()
	{16, 116, 162, 1, 0, 273, 7},	//273 Nepomuk::Types::Entity::comment(const QString&)
	{16, 116, 0, 0, 0, 273, 8},	//274 Nepomuk::Types::Entity::comment()
	{16, 195, 0, 0, 0, 193, 9},	//275 Nepomuk::Types::Entity::icon()
	{16, 244, 0, 0, Smoke::mf_const, 449, 10},	//276 Nepomuk::Types::Entity::isValid() const
	{16, 206, 0, 0, 0, 449, 11},	//277 Nepomuk::Types::Entity::isAvailable()
	{16, 323, 89, 1, 0, 0, 12},	//278 Nepomuk::Types::Entity::reset(bool)
	{16, 323, 0, 0, 0, 0, 13},	//279 Nepomuk::Types::Entity::reset()
	{16, 280, 0, 0, Smoke::mf_const, 323, 14},	//280 Nepomuk::Types::Entity::operator QUrl() const
	{16, 286, 104, 1, Smoke::mf_const, 449, 15},	//281 Nepomuk::Types::Entity::operator==(const Nepomuk::Types::Entity&) const
	{16, 281, 104, 1, Smoke::mf_const, 449, 16},	//282 Nepomuk::Types::Entity::operator!=(const Nepomuk::Types::Entity&) const
	{16, 4, 0, 0, Smoke::mf_ctor|Smoke::mf_protected, 110, 17},	//283 Nepomuk::Types::Entity::Entity()
	{17, 15, 0, 0, Smoke::mf_ctor, 113, 1},	//284 Nepomuk::Types::Literal::Literal()
	{17, 15, 106, 1, Smoke::mf_copyctor|Smoke::mf_ctor, 113, 2},	//285 Nepomuk::Types::Literal::Literal(const Nepomuk::Types::Literal&)
	{17, 15, 184, 1, Smoke::mf_ctor, 113, 3},	//286 Nepomuk::Types::Literal::Literal(const QUrl&)
	{17, 465, 0, 0, Smoke::mf_dtor, 0, 8},	//287 Nepomuk::Types::Literal::~Literal()
	{17, 283, 106, 1, 0, 112, 4},	//288 Nepomuk::Types::Literal::operator=(const Nepomuk::Types::Literal&)
	{17, 128, 0, 0, Smoke::mf_const, 323, 5},	//289 Nepomuk::Types::Literal::dataTypeUri() const
	{17, 127, 0, 0, Smoke::mf_const, 329, 6},	//290 Nepomuk::Types::Literal::dataType() const
	{17, 244, 0, 0, Smoke::mf_const, 449, 7},	//291 Nepomuk::Types::Literal::isValid() const
	{18, 18, 0, 0, Smoke::mf_ctor, 115, 1},	//292 Nepomuk::Types::Ontology::Ontology()
	{18, 18, 184, 1, Smoke::mf_ctor, 115, 2},	//293 Nepomuk::Types::Ontology::Ontology(const QUrl&)
	{18, 18, 108, 1, Smoke::mf_copyctor|Smoke::mf_ctor, 115, 3},	//294 Nepomuk::Types::Ontology::Ontology(const Nepomuk::Types::Ontology&)
	{18, 466, 0, 0, Smoke::mf_dtor, 0, 13},	//295 Nepomuk::Types::Ontology::~Ontology()
	{18, 283, 108, 1, 0, 114, 4},	//296 Nepomuk::Types::Ontology::operator=(const Nepomuk::Types::Ontology&)
	{18, 87, 0, 0, 0, 207, 5},	//297 Nepomuk::Types::Ontology::allClasses()
	{18, 161, 162, 1, 0, 106, 6},	//298 Nepomuk::Types::Ontology::findClassByName(const QString&)
	{18, 158, 164, 2, 0, 106, 7},	//299 Nepomuk::Types::Ontology::findClassByLabel(const QString&, const QString&)
	{18, 158, 162, 1, 0, 106, 8},	//300 Nepomuk::Types::Ontology::findClassByLabel(const QString&)
	{18, 89, 0, 0, 0, 208, 9},	//301 Nepomuk::Types::Ontology::allProperties()
	{18, 166, 162, 1, 0, 116, 10},	//302 Nepomuk::Types::Ontology::findPropertyByName(const QString&)
	{18, 163, 164, 2, 0, 116, 11},	//303 Nepomuk::Types::Ontology::findPropertyByLabel(const QString&, const QString&)
	{18, 163, 162, 1, 0, 116, 12},	//304 Nepomuk::Types::Ontology::findPropertyByLabel(const QString&)
	{19, 20, 0, 0, Smoke::mf_ctor, 118, 1},	//305 Nepomuk::Types::Property::Property()
	{19, 20, 184, 1, Smoke::mf_ctor, 118, 2},	//306 Nepomuk::Types::Property::Property(const QUrl&)
	{19, 20, 110, 1, Smoke::mf_copyctor|Smoke::mf_ctor, 118, 3},	//307 Nepomuk::Types::Property::Property(const Nepomuk::Types::Property&)
	{19, 467, 0, 0, Smoke::mf_dtor, 0, 16},	//308 Nepomuk::Types::Property::~Property()
	{19, 283, 110, 1, 0, 117, 4},	//309 Nepomuk::Types::Property::operator=(const Nepomuk::Types::Property&)
	{19, 301, 0, 0, 0, 208, 5},	//310 Nepomuk::Types::Property::parentProperties()
	{19, 403, 0, 0, 0, 208, 6},	//311 Nepomuk::Types::Property::subProperties()
	{19, 205, 0, 0, 0, 116, 7},	//312 Nepomuk::Types::Property::inverseProperty()
	{19, 308, 0, 0, 0, 106, 8},	//313 Nepomuk::Types::Property::range()
	{19, 256, 0, 0, 0, 111, 9},	//314 Nepomuk::Types::Property::literalRangeType()
	{19, 135, 0, 0, 0, 106, 10},	//315 Nepomuk::Types::Property::domain()
	{19, 107, 0, 0, 0, 506, 11},	//316 Nepomuk::Types::Property::cardinality()
	{19, 264, 0, 0, 0, 506, 12},	//317 Nepomuk::Types::Property::minCardinality()
	{19, 259, 0, 0, 0, 506, 13},	//318 Nepomuk::Types::Property::maxCardinality()
	{19, 221, 110, 1, 0, 449, 14},	//319 Nepomuk::Types::Property::isParentOf(const Nepomuk::Types::Property&)
	{19, 232, 110, 1, 0, 449, 15},	//320 Nepomuk::Types::Property::isSubPropertyOf(const Nepomuk::Types::Property&)
	{20, 56, 0, 0, Smoke::mf_ctor, 121, 1},	//321 Nepomuk::Variant::Variant()
	{20, 474, 0, 0, Smoke::mf_dtor, 0, 125},	//322 Nepomuk::Variant::~Variant()
	{20, 56, 112, 1, Smoke::mf_copyctor|Smoke::mf_ctor, 121, 2},	//323 Nepomuk::Variant::Variant(const Nepomuk::Variant&)
	{20, 56, 199, 1, Smoke::mf_copyctor|Smoke::mf_ctor, 121, 3},	//324 Nepomuk::Variant::Variant(const QVariant&)
	{20, 56, 209, 1, Smoke::mf_ctor, 121, 4},	//325 Nepomuk::Variant::Variant(int)
	{20, 56, 211, 1, Smoke::mf_ctor, 121, 5},	//326 Nepomuk::Variant::Variant(qlonglong)
	{20, 56, 215, 1, Smoke::mf_ctor, 121, 6},	//327 Nepomuk::Variant::Variant(uint)
	{20, 56, 213, 1, Smoke::mf_ctor, 121, 7},	//328 Nepomuk::Variant::Variant(qulonglong)
	{20, 56, 89, 1, Smoke::mf_ctor, 121, 8},	//329 Nepomuk::Variant::Variant(bool)
	{20, 56, 207, 1, Smoke::mf_ctor, 121, 9},	//330 Nepomuk::Variant::Variant(double)
	{20, 56, 203, 1, Smoke::mf_ctor, 121, 10},	//331 Nepomuk::Variant::Variant(const char*)
	{20, 56, 162, 1, Smoke::mf_ctor, 121, 11},	//332 Nepomuk::Variant::Variant(const QString&)
	{20, 56, 114, 1, Smoke::mf_ctor, 121, 12},	//333 Nepomuk::Variant::Variant(const QDate&)
	{20, 56, 182, 1, Smoke::mf_ctor, 121, 13},	//334 Nepomuk::Variant::Variant(const QTime&)
	{20, 56, 116, 1, Smoke::mf_ctor, 121, 14},	//335 Nepomuk::Variant::Variant(const QDateTime&)
	{20, 56, 184, 1, Smoke::mf_ctor, 121, 15},	//336 Nepomuk::Variant::Variant(const QUrl&)
	{20, 56, 93, 1, Smoke::mf_ctor, 121, 16},	//337 Nepomuk::Variant::Variant(const Nepomuk::Resource&)
	{20, 56, 140, 1, Smoke::mf_ctor, 121, 17},	//338 Nepomuk::Variant::Variant(const QList<int>&)
	{20, 56, 142, 1, Smoke::mf_ctor, 121, 18},	//339 Nepomuk::Variant::Variant(const QList<qlonglong>&)
	{20, 56, 146, 1, Smoke::mf_ctor, 121, 19},	//340 Nepomuk::Variant::Variant(const QList<uint>&)
	{20, 56, 144, 1, Smoke::mf_ctor, 121, 20},	//341 Nepomuk::Variant::Variant(const QList<qulonglong>&)
	{20, 56, 136, 1, Smoke::mf_ctor, 121, 21},	//342 Nepomuk::Variant::Variant(const QList<bool>&)
	{20, 56, 138, 1, Smoke::mf_ctor, 121, 22},	//343 Nepomuk::Variant::Variant(const QList<double>&)
	{20, 56, 180, 1, Smoke::mf_ctor, 121, 23},	//344 Nepomuk::Variant::Variant(const QStringList&)
	{20, 56, 128, 1, Smoke::mf_ctor, 121, 24},	//345 Nepomuk::Variant::Variant(const QList<QDate>&)
	{20, 56, 132, 1, Smoke::mf_ctor, 121, 25},	//346 Nepomuk::Variant::Variant(const QList<QTime>&)
	{20, 56, 130, 1, Smoke::mf_ctor, 121, 26},	//347 Nepomuk::Variant::Variant(const QList<QDateTime>&)
	{20, 56, 134, 1, Smoke::mf_ctor, 121, 27},	//348 Nepomuk::Variant::Variant(const QList<QUrl>&)
	{20, 56, 122, 1, Smoke::mf_ctor, 121, 28},	//349 Nepomuk::Variant::Variant(const QList<Nepomuk::Resource>&)
	{20, 56, 126, 1, Smoke::mf_ctor, 121, 29},	//350 Nepomuk::Variant::Variant(const QList<Nepomuk::Variant>&)
	{20, 283, 112, 1, 0, 120, 30},	//351 Nepomuk::Variant::operator=(const Nepomuk::Variant&)
	{20, 283, 209, 1, 0, 120, 31},	//352 Nepomuk::Variant::operator=(int)
	{20, 283, 211, 1, 0, 120, 32},	//353 Nepomuk::Variant::operator=(qlonglong)
	{20, 283, 215, 1, 0, 120, 33},	//354 Nepomuk::Variant::operator=(uint)
	{20, 283, 213, 1, 0, 120, 34},	//355 Nepomuk::Variant::operator=(qulonglong)
	{20, 283, 89, 1, 0, 120, 35},	//356 Nepomuk::Variant::operator=(bool)
	{20, 283, 207, 1, 0, 120, 36},	//357 Nepomuk::Variant::operator=(double)
	{20, 283, 162, 1, 0, 120, 37},	//358 Nepomuk::Variant::operator=(const QString&)
	{20, 283, 114, 1, 0, 120, 38},	//359 Nepomuk::Variant::operator=(const QDate&)
	{20, 283, 182, 1, 0, 120, 39},	//360 Nepomuk::Variant::operator=(const QTime&)
	{20, 283, 116, 1, 0, 120, 40},	//361 Nepomuk::Variant::operator=(const QDateTime&)
	{20, 283, 184, 1, 0, 120, 41},	//362 Nepomuk::Variant::operator=(const QUrl&)
	{20, 283, 93, 1, 0, 120, 42},	//363 Nepomuk::Variant::operator=(const Nepomuk::Resource&)
	{20, 283, 140, 1, 0, 120, 43},	//364 Nepomuk::Variant::operator=(const QList<int>&)
	{20, 283, 142, 1, 0, 120, 44},	//365 Nepomuk::Variant::operator=(const QList<qlonglong>&)
	{20, 283, 146, 1, 0, 120, 45},	//366 Nepomuk::Variant::operator=(const QList<uint>&)
	{20, 283, 144, 1, 0, 120, 46},	//367 Nepomuk::Variant::operator=(const QList<qulonglong>&)
	{20, 283, 136, 1, 0, 120, 47},	//368 Nepomuk::Variant::operator=(const QList<bool>&)
	{20, 283, 138, 1, 0, 120, 48},	//369 Nepomuk::Variant::operator=(const QList<double>&)
	{20, 283, 180, 1, 0, 120, 49},	//370 Nepomuk::Variant::operator=(const QStringList&)
	{20, 283, 128, 1, 0, 120, 50},	//371 Nepomuk::Variant::operator=(const QList<QDate>&)
	{20, 283, 132, 1, 0, 120, 51},	//372 Nepomuk::Variant::operator=(const QList<QTime>&)
	{20, 283, 130, 1, 0, 120, 52},	//373 Nepomuk::Variant::operator=(const QList<QDateTime>&)
	{20, 283, 134, 1, 0, 120, 53},	//374 Nepomuk::Variant::operator=(const QList<QUrl>&)
	{20, 283, 122, 1, 0, 120, 54},	//375 Nepomuk::Variant::operator=(const QList<Nepomuk::Resource>&)
	{20, 102, 209, 1, 0, 0, 55},	//376 Nepomuk::Variant::append(int)
	{20, 102, 211, 1, 0, 0, 56},	//377 Nepomuk::Variant::append(qlonglong)
	{20, 102, 215, 1, 0, 0, 57},	//378 Nepomuk::Variant::append(uint)
	{20, 102, 213, 1, 0, 0, 58},	//379 Nepomuk::Variant::append(qulonglong)
	{20, 102, 89, 1, 0, 0, 59},	//380 Nepomuk::Variant::append(bool)
	{20, 102, 207, 1, 0, 0, 60},	//381 Nepomuk::Variant::append(double)
	{20, 102, 162, 1, 0, 0, 61},	//382 Nepomuk::Variant::append(const QString&)
	{20, 102, 114, 1, 0, 0, 62},	//383 Nepomuk::Variant::append(const QDate&)
	{20, 102, 182, 1, 0, 0, 63},	//384 Nepomuk::Variant::append(const QTime&)
	{20, 102, 116, 1, 0, 0, 64},	//385 Nepomuk::Variant::append(const QDateTime&)
	{20, 102, 184, 1, 0, 0, 65},	//386 Nepomuk::Variant::append(const QUrl&)
	{20, 102, 93, 1, 0, 0, 66},	//387 Nepomuk::Variant::append(const Nepomuk::Resource&)
	{20, 102, 112, 1, 0, 0, 67},	//388 Nepomuk::Variant::append(const Nepomuk::Variant&)
	{20, 286, 112, 1, Smoke::mf_const, 449, 68},	//389 Nepomuk::Variant::operator==(const Nepomuk::Variant&) const
	{20, 281, 112, 1, Smoke::mf_const, 449, 69},	//390 Nepomuk::Variant::operator!=(const Nepomuk::Variant&) const
	{20, 244, 0, 0, Smoke::mf_const, 449, 70},	//391 Nepomuk::Variant::isValid() const
	{20, 446, 0, 0, Smoke::mf_const, 506, 71},	//392 Nepomuk::Variant::type() const
	{20, 396, 0, 0, Smoke::mf_const, 506, 72},	//393 Nepomuk::Variant::simpleType() const
	{20, 220, 0, 0, Smoke::mf_const, 449, 73},	//394 Nepomuk::Variant::isList() const
	{20, 216, 0, 0, Smoke::mf_const, 449, 74},	//395 Nepomuk::Variant::isInt() const
	{20, 217, 0, 0, Smoke::mf_const, 449, 75},	//396 Nepomuk::Variant::isInt64() const
	{20, 238, 0, 0, Smoke::mf_const, 449, 76},	//397 Nepomuk::Variant::isUnsignedInt() const
	{20, 239, 0, 0, Smoke::mf_const, 449, 77},	//398 Nepomuk::Variant::isUnsignedInt64() const
	{20, 207, 0, 0, Smoke::mf_const, 449, 78},	//399 Nepomuk::Variant::isBool() const
	{20, 213, 0, 0, Smoke::mf_const, 449, 79},	//400 Nepomuk::Variant::isDouble() const
	{20, 228, 0, 0, Smoke::mf_const, 449, 80},	//401 Nepomuk::Variant::isString() const
	{20, 209, 0, 0, Smoke::mf_const, 449, 81},	//402 Nepomuk::Variant::isDate() const
	{20, 234, 0, 0, Smoke::mf_const, 449, 82},	//403 Nepomuk::Variant::isTime() const
	{20, 211, 0, 0, Smoke::mf_const, 449, 83},	//404 Nepomuk::Variant::isDateTime() const
	{20, 242, 0, 0, Smoke::mf_const, 449, 84},	//405 Nepomuk::Variant::isUrl() const
	{20, 226, 0, 0, Smoke::mf_const, 449, 85},	//406 Nepomuk::Variant::isResource() const
	{20, 219, 0, 0, Smoke::mf_const, 449, 86},	//407 Nepomuk::Variant::isIntList() const
	{20, 218, 0, 0, Smoke::mf_const, 449, 87},	//408 Nepomuk::Variant::isInt64List() const
	{20, 241, 0, 0, Smoke::mf_const, 449, 88},	//409 Nepomuk::Variant::isUnsignedIntList() const
	{20, 240, 0, 0, Smoke::mf_const, 449, 89},	//410 Nepomuk::Variant::isUnsignedInt64List() const
	{20, 208, 0, 0, Smoke::mf_const, 449, 90},	//411 Nepomuk::Variant::isBoolList() const
	{20, 214, 0, 0, Smoke::mf_const, 449, 91},	//412 Nepomuk::Variant::isDoubleList() const
	{20, 229, 0, 0, Smoke::mf_const, 449, 92},	//413 Nepomuk::Variant::isStringList() const
	{20, 210, 0, 0, Smoke::mf_const, 449, 93},	//414 Nepomuk::Variant::isDateList() const
	{20, 235, 0, 0, Smoke::mf_const, 449, 94},	//415 Nepomuk::Variant::isTimeList() const
	{20, 212, 0, 0, Smoke::mf_const, 449, 95},	//416 Nepomuk::Variant::isDateTimeList() const
	{20, 243, 0, 0, Smoke::mf_const, 449, 96},	//417 Nepomuk::Variant::isUrlList() const
	{20, 227, 0, 0, Smoke::mf_const, 449, 97},	//418 Nepomuk::Variant::isResourceList() const
	{20, 454, 0, 0, Smoke::mf_const, 328, 98},	//419 Nepomuk::Variant::variant() const
	{20, 427, 0, 0, Smoke::mf_const, 506, 99},	//420 Nepomuk::Variant::toInt() const
	{20, 428, 0, 0, Smoke::mf_const, 507, 100},	//421 Nepomuk::Variant::toInt64() const
	{20, 437, 0, 0, Smoke::mf_const, 509, 101},	//422 Nepomuk::Variant::toUnsignedInt() const
	{20, 438, 0, 0, Smoke::mf_const, 508, 102},	//423 Nepomuk::Variant::toUnsignedInt64() const
	{20, 419, 0, 0, Smoke::mf_const, 449, 103},	//424 Nepomuk::Variant::toBool() const
	{20, 425, 0, 0, Smoke::mf_const, 505, 104},	//425 Nepomuk::Variant::toDouble() const
	{20, 433, 0, 0, Smoke::mf_const, 273, 105},	//426 Nepomuk::Variant::toString() const
	{20, 421, 0, 0, Smoke::mf_const, 142, 106},	//427 Nepomuk::Variant::toDate() const
	{20, 435, 0, 0, Smoke::mf_const, 316, 107},	//428 Nepomuk::Variant::toTime() const
	{20, 423, 0, 0, Smoke::mf_const, 144, 108},	//429 Nepomuk::Variant::toDateTime() const
	{20, 441, 0, 0, Smoke::mf_const, 323, 109},	//430 Nepomuk::Variant::toUrl() const
	{20, 431, 0, 0, Smoke::mf_const, 92, 110},	//431 Nepomuk::Variant::toResource() const
	{20, 430, 0, 0, Smoke::mf_const, 219, 111},	//432 Nepomuk::Variant::toIntList() const
	{20, 429, 0, 0, Smoke::mf_const, 220, 112},	//433 Nepomuk::Variant::toInt64List() const
	{20, 440, 0, 0, Smoke::mf_const, 222, 113},	//434 Nepomuk::Variant::toUnsignedIntList() const
	{20, 439, 0, 0, Smoke::mf_const, 221, 114},	//435 Nepomuk::Variant::toUnsignedInt64List() const
	{20, 420, 0, 0, Smoke::mf_const, 217, 115},	//436 Nepomuk::Variant::toBoolList() const
	{20, 426, 0, 0, Smoke::mf_const, 218, 116},	//437 Nepomuk::Variant::toDoubleList() const
	{20, 434, 0, 0, Smoke::mf_const, 277, 117},	//438 Nepomuk::Variant::toStringList() const
	{20, 422, 0, 0, Smoke::mf_const, 210, 118},	//439 Nepomuk::Variant::toDateList() const
	{20, 436, 0, 0, Smoke::mf_const, 212, 119},	//440 Nepomuk::Variant::toTimeList() const
	{20, 424, 0, 0, Smoke::mf_const, 211, 120},	//441 Nepomuk::Variant::toDateTimeList() const
	{20, 442, 0, 0, Smoke::mf_const, 213, 121},	//442 Nepomuk::Variant::toUrlList() const
	{20, 432, 0, 0, Smoke::mf_const, 205, 122},	//443 Nepomuk::Variant::toResourceList() const
	{20, 443, 0, 0, Smoke::mf_const, 209, 123},	//444 Nepomuk::Variant::toVariantList() const
	{20, 176, 174, 2, Smoke::mf_static, 119, 124},	//445 Nepomuk::Variant::fromString(const QString&, int)
	{34, 261, 0, 0, Smoke::mf_const, 482, 14},	//446 QFrame::metaObject() const
	{34, 306, 27, 3, 0, 506, 15},	//447 QFrame::qt_metacall(QMetaObject::Call, int, void**)
	{45, 261, 0, 0, Smoke::mf_const, 482, 2},	//448 QObject::metaObject() const
	{45, 306, 27, 3, 0, 506, 3},	//449 QObject::qt_metacall(QMetaObject::Call, int, void**)
	{45, 153, 17, 1, 0, 449, 6},	//450 QObject::event(QEvent*)
	{45, 155, 37, 2, 0, 449, 7},	//451 QObject::eventFilter(QObject*, QEvent*)
	{45, 417, 75, 1, Smoke::mf_protected, 0, 49},	//452 QObject::timerEvent(QTimerEvent*)
	{45, 110, 3, 1, Smoke::mf_protected, 0, 50},	//453 QObject::childEvent(QChildEvent*)
	{45, 124, 17, 1, Smoke::mf_protected, 0, 51},	//454 QObject::customEvent(QEvent*)
	{45, 118, 203, 1, Smoke::mf_protected, 0, 52},	//455 QObject::connectNotify(const char*)
	{45, 133, 203, 1, Smoke::mf_protected, 0, 53},	//456 QObject::disconnectNotify(const char*)
	{46, 132, 0, 0, Smoke::mf_const, 506, 11},	//457 QPaintDevice::devType() const
	{46, 292, 0, 0, Smoke::mf_const, 246, 13},	//458 QPaintDevice::paintEngine() const [pure virtual]
	{46, 262, 43, 1, Smoke::mf_const|Smoke::mf_protected, 506, 25},	//459 QPaintDevice::metric(QPaintDevice::PaintDeviceMetric) const
	{69, 261, 0, 0, Smoke::mf_const, 482, 5},	//460 QWidget::metaObject() const
	{69, 306, 27, 3, 0, 506, 6},	//461 QWidget::qt_metacall(QMetaObject::Call, int, void**)
	{69, 397, 0, 0, Smoke::mf_const, 268, 181},	//462 QWidget::sizeHint() const
	{69, 265, 0, 0, Smoke::mf_const, 268, 182},	//463 QWidget::minimumSizeHint() const
	{69, 191, 209, 1, Smoke::mf_const, 506, 186},	//464 QWidget::heightForWidth(int) const
	{69, 202, 83, 1, Smoke::mf_const, 328, 227},	//465 QWidget::inputMethodQuery(Qt::InputMethodQuery) const
	{69, 392, 89, 1, 0, 0, 236},	//466 QWidget::setVisible(bool)
	{69, 270, 31, 1, Smoke::mf_protected, 0, 256},	//467 QWidget::mousePressEvent(QMouseEvent*)
	{69, 272, 31, 1, Smoke::mf_protected, 0, 257},	//468 QWidget::mouseReleaseEvent(QMouseEvent*)
	{69, 266, 31, 1, Smoke::mf_protected, 0, 258},	//469 QWidget::mouseDoubleClickEvent(QMouseEvent*)
	{69, 268, 31, 1, Smoke::mf_protected, 0, 259},	//470 QWidget::mouseMoveEvent(QMouseEvent*)
	{69, 455, 77, 1, Smoke::mf_protected, 0, 260},	//471 QWidget::wheelEvent(QWheelEvent*)
	{69, 245, 25, 1, Smoke::mf_protected, 0, 261},	//472 QWidget::keyPressEvent(QKeyEvent*)
	{69, 247, 25, 1, Smoke::mf_protected, 0, 262},	//473 QWidget::keyReleaseEvent(QKeyEvent*)
	{69, 168, 19, 1, Smoke::mf_protected, 0, 263},	//474 QWidget::focusInEvent(QFocusEvent*)
	{69, 172, 19, 1, Smoke::mf_protected, 0, 264},	//475 QWidget::focusOutEvent(QFocusEvent*)
	{69, 147, 17, 1, Smoke::mf_protected, 0, 265},	//476 QWidget::enterEvent(QEvent*)
	{69, 254, 17, 1, Smoke::mf_protected, 0, 266},	//477 QWidget::leaveEvent(QEvent*)
	{69, 293, 45, 1, Smoke::mf_protected, 0, 267},	//478 QWidget::paintEvent(QPaintEvent*)
	{69, 274, 33, 1, Smoke::mf_protected, 0, 268},	//479 QWidget::moveEvent(QMoveEvent*)
	{69, 325, 67, 1, Smoke::mf_protected, 0, 269},	//480 QWidget::resizeEvent(QResizeEvent*)
	{69, 114, 5, 1, Smoke::mf_protected, 0, 270},	//481 QWidget::closeEvent(QCloseEvent*)
	{69, 120, 7, 1, Smoke::mf_protected, 0, 271},	//482 QWidget::contextMenuEvent(QContextMenuEvent*)
	{69, 406, 73, 1, Smoke::mf_protected, 0, 272},	//483 QWidget::tabletEvent(QTabletEvent*)
	{69, 60, 1, 1, Smoke::mf_protected, 0, 273},	//484 QWidget::actionEvent(QActionEvent*)
	{69, 137, 9, 1, Smoke::mf_protected, 0, 274},	//485 QWidget::dragEnterEvent(QDragEnterEvent*)
	{69, 141, 13, 1, Smoke::mf_protected, 0, 275},	//486 QWidget::dragMoveEvent(QDragMoveEvent*)
	{69, 139, 11, 1, Smoke::mf_protected, 0, 276},	//487 QWidget::dragLeaveEvent(QDragLeaveEvent*)
	{69, 143, 15, 1, Smoke::mf_protected, 0, 277},	//488 QWidget::dropEvent(QDropEvent*)
	{69, 394, 69, 1, Smoke::mf_protected, 0, 278},	//489 QWidget::showEvent(QShowEvent*)
	{69, 193, 21, 1, Smoke::mf_protected, 0, 279},	//490 QWidget::hideEvent(QHideEvent*)
	{69, 108, 17, 1, Smoke::mf_protected, 0, 280},	//491 QWidget::changeEvent(QEvent*)
	{69, 200, 23, 1, Smoke::mf_protected, 0, 282},	//492 QWidget::inputMethodEvent(QInputMethodEvent*)
	{69, 170, 89, 1, Smoke::mf_protected, 449, 291},	//493 QWidget::focusNextPrevChild(bool)
	{69, 400, 71, 1, Smoke::mf_protected, 0, 294},	//494 QWidget::styleChange(QStyle&)
	{69, 145, 89, 1, Smoke::mf_protected, 0, 295},	//495 QWidget::enabledChange(bool)
	{69, 298, 150, 1, Smoke::mf_protected, 0, 296},	//496 QWidget::paletteChange(const QPalette&)
	{69, 174, 118, 1, Smoke::mf_protected, 0, 297},	//497 QWidget::fontChange(const QFont&)
	{69, 457, 89, 1, Smoke::mf_protected, 0, 298},	//498 QWidget::windowActivationChange(bool)
	{69, 252, 0, 0, Smoke::mf_protected, 0, 299},	//499 QWidget::languageChange()
};

// Class ID, munged name ID (index into methodNames), method def (see methods) if >0 or number of overloads if <0
static Smoke::MethodMap nepomuk_methodMaps[] = {
	{ 0, 0, 0 },	//0 (no method)
	{1, 7, 0},	//1 KRatingPainter::KRatingPainter
	{1, 8, 21},	//2 KRatingPainter::KRatingPainter#
	{1, 86, 4},	//3 KRatingPainter::alignment
	{1, 126, 8},	//4 KRatingPainter::customPixmap
	{1, 184, 24},	//5 KRatingPainter::getRatingFromPosition#$$#
	{1, 186, 3},	//6 KRatingPainter::halfStepsEnabled
	{1, 195, 6},	//7 KRatingPainter::icon
	{1, 215, 7},	//8 KRatingPainter::isEnabled
	{1, 253, 5},	//9 KRatingPainter::layoutDirection
	{1, 260, 2},	//10 KRatingPainter::maxRating
	{1, 290, 19},	//11 KRatingPainter::paint##$
	{1, 291, 18},	//12 KRatingPainter::paint##$$
	{1, 296, 23},	//13 KRatingPainter::paintRating##$$
	{1, 297, 22},	//14 KRatingPainter::paintRating##$$$
	{1, 314, 20},	//15 KRatingPainter::ratingFromPosition##
	{1, 333, 12},	//16 KRatingPainter::setAlignment$
	{1, 343, 16},	//17 KRatingPainter::setCustomPixmap#
	{1, 347, 15},	//18 KRatingPainter::setEnabled$
	{1, 349, 11},	//19 KRatingPainter::setHalfStepsEnabled$
	{1, 351, 14},	//20 KRatingPainter::setIcon#
	{1, 361, 13},	//21 KRatingPainter::setLayoutDirection$
	{1, 365, 10},	//22 KRatingPainter::setMaxRating$
	{1, 379, 17},	//23 KRatingPainter::setSpacing$
	{1, 398, 9},	//24 KRatingPainter::spacing
	{1, 461, 1},	//25 KRatingPainter::~KRatingPainter
	{2, 9, 28},	//26 KRatingWidget::KRatingWidget
	{2, 10, 27},	//27 KRatingWidget::KRatingWidget#
	{2, 86, 32},	//28 KRatingWidget::alignment
	{2, 186, 36},	//29 KRatingWidget::halfStepsEnabled
	{2, 195, 37},	//30 KRatingWidget::icon
	{2, 253, 33},	//31 KRatingWidget::layoutDirection
	{2, 255, 52},	//32 KRatingWidget::leaveEvent#
	{2, 260, 31},	//33 KRatingWidget::maxRating
	{2, 261, 25},	//34 KRatingWidget::metaObject
	{2, 269, 51},	//35 KRatingWidget::mouseMoveEvent#
	{2, 271, 50},	//36 KRatingWidget::mousePressEvent#
	{2, 294, 53},	//37 KRatingWidget::paintEvent#
	{2, 307, 26},	//38 KRatingWidget::qt_metacall$$?
	{2, 310, 30},	//39 KRatingWidget::rating
	{2, 312, -1},	//40 KRatingWidget::ratingChanged$
	{2, 326, 54},	//41 KRatingWidget::resizeEvent#
	{2, 333, 42},	//42 KRatingWidget::setAlignment$
	{2, 343, 45},	//43 KRatingWidget::setCustomPixmap#
	{2, 349, 40},	//44 KRatingWidget::setHalfStepsEnabled$
	{2, 351, 44},	//45 KRatingWidget::setIcon#
	{2, 361, 43},	//46 KRatingWidget::setLayoutDirection$
	{2, 365, 39},	//47 KRatingWidget::setMaxRating$
	{2, 371, 46},	//48 KRatingWidget::setPixmapSize$
	{2, 375, 38},	//49 KRatingWidget::setRating$
	{2, 379, 41},	//50 KRatingWidget::setSpacing$
	{2, 397, 35},	//51 KRatingWidget::sizeHint
	{2, 398, 34},	//52 KRatingWidget::spacing
	{2, 399, 49},	//53 KRatingWidget::staticMetaObject
	{2, 462, 29},	//54 KRatingWidget::~KRatingWidget
	{3, 11, 58},	//55 KTagCloudWidget::KTagCloudWidget
	{3, 12, 57},	//56 KTagCloudWidget::KTagCloudWidget#
	{3, 79, 61},	//57 KTagCloudWidget::addTag$$
	{3, 81, 62},	//58 KTagCloudWidget::addTags?
	{3, 113, 63},	//59 KTagCloudWidget::clear
	{3, 261, 55},	//60 KTagCloudWidget::metaObject
	{3, 307, 56},	//61 KTagCloudWidget::qt_metacall$$?
	{3, 326, 68},	//62 KTagCloudWidget::resizeEvent#
	{3, 363, 64},	//63 KTagCloudWidget::setMaxFontSize$
	{3, 367, 65},	//64 KTagCloudWidget::setMinFontSize$
	{3, 399, 67},	//65 KTagCloudWidget::staticMetaObject
	{3, 410, 66},	//66 KTagCloudWidget::tagClicked$
	{3, 414, 60},	//67 KTagCloudWidget::tagWeight$
	{3, 463, 59},	//68 KTagCloudWidget::~KTagCloudWidget
	{4, 13, 72},	//69 KTagDisplayWidget::KTagDisplayWidget
	{4, 14, 71},	//70 KTagDisplayWidget::KTagDisplayWidget#
	{4, 78, 75},	//71 KTagDisplayWidget::addTag$
	{4, 81, 76},	//72 KTagDisplayWidget::addTags?
	{4, 113, 77},	//73 KTagDisplayWidget::clear
	{4, 261, 69},	//74 KTagDisplayWidget::metaObject
	{4, 307, 70},	//75 KTagDisplayWidget::qt_metacall$$?
	{4, 387, 74},	//76 KTagDisplayWidget::setTags?
	{4, 399, 79},	//77 KTagDisplayWidget::staticMetaObject
	{4, 410, 78},	//78 KTagDisplayWidget::tagClicked$
	{4, 464, 73},	//79 KTagDisplayWidget::~KTagDisplayWidget
	{5, 3, 81},	//80 Nepomuk::CommunicationError
	{5, 6, 82},	//81 Nepomuk::InvalidType
	{5, 17, 80},	//82 Nepomuk::NoError
	{5, 23, 87},	//83 Nepomuk::RDFLiteralToValue#
	{5, 55, 83},	//84 Nepomuk::UnknownError
	{5, 152, 84},	//85 Nepomuk::errorString$
	{5, 451, 86},	//86 Nepomuk::valueToRDFNode#
	{5, 453, 85},	//87 Nepomuk::valuesToRDFNodes#
	{7, 24, 88},	//88 Nepomuk::Resource::Resource
	{7, 25, -4},	//89 Nepomuk::Resource::Resource#
	{7, 26, 94},	//90 Nepomuk::Resource::Resource##
	{7, 27, 96},	//91 Nepomuk::Resource::Resource###
	{7, 28, 92},	//92 Nepomuk::Resource::Resource$
	{7, 29, 91},	//93 Nepomuk::Resource::Resource$#
	{7, 30, 93},	//94 Nepomuk::Resource::Resource$##
	{7, 31, 97},	//95 Nepomuk::Resource::Resource?
	{7, 63, 131},	//96 Nepomuk::Resource::addAltLabel$
	{7, 65, 134},	//97 Nepomuk::Resource::addAnnotation#
	{7, 67, 128},	//98 Nepomuk::Resource::addIdentifier$
	{7, 69, 146},	//99 Nepomuk::Resource::addIsRelated#
	{7, 71, 143},	//100 Nepomuk::Resource::addIsTopicOf#
	{7, 73, 113},	//101 Nepomuk::Resource::addProperty##
	{7, 75, 153},	//102 Nepomuk::Resource::addSymbol$
	{7, 77, 137},	//103 Nepomuk::Resource::addTag#
	{7, 83, 140},	//104 Nepomuk::Resource::addTopic#
	{7, 85, 106},	//105 Nepomuk::Resource::addType#
	{7, 90, 167},	//106 Nepomuk::Resource::allResources
	{7, 97, 158},	//107 Nepomuk::Resource::altLabelUri
	{7, 98, 129},	//108 Nepomuk::Resource::altLabels
	{7, 99, 154},	//109 Nepomuk::Resource::annotationOf
	{7, 100, 159},	//110 Nepomuk::Resource::annotationUri
	{7, 101, 132},	//111 Nepomuk::Resource::annotations
	{7, 112, 108},	//112 Nepomuk::Resource::className
	{7, 130, 124},	//113 Nepomuk::Resource::description
	{7, 131, 156},	//114 Nepomuk::Resource::descriptionUri
	{7, 157, 117},	//115 Nepomuk::Resource::exists
	{7, 180, 120},	//116 Nepomuk::Resource::genericDescription
	{7, 181, 121},	//117 Nepomuk::Resource::genericIcon
	{7, 182, 119},	//118 Nepomuk::Resource::genericLabel
	{7, 188, 110},	//119 Nepomuk::Resource::hasProperty#
	{7, 190, 107},	//120 Nepomuk::Resource::hasType#
	{7, 196, 157},	//121 Nepomuk::Resource::identifierUri
	{7, 197, 126},	//122 Nepomuk::Resource::identifiers
	{7, 223, 155},	//123 Nepomuk::Resource::isRelatedOf
	{7, 224, 163},	//124 Nepomuk::Resource::isRelatedUri
	{7, 225, 144},	//125 Nepomuk::Resource::isRelateds
	{7, 236, 162},	//126 Nepomuk::Resource::isTopicOfUri
	{7, 237, 141},	//127 Nepomuk::Resource::isTopicOfs
	{7, 244, 118},	//128 Nepomuk::Resource::isValid
	{7, 249, 147},	//129 Nepomuk::Resource::label
	{7, 251, 164},	//130 Nepomuk::Resource::labelUri
	{7, 258, 101},	//131 Nepomuk::Resource::manager
	{7, 284, -8},	//132 Nepomuk::Resource::operator=#
	{7, 287, 123},	//133 Nepomuk::Resource::operator==#
	{7, 302, 122},	//134 Nepomuk::Resource::pimoThing
	{7, 303, 109},	//135 Nepomuk::Resource::properties
	{7, 305, 111},	//136 Nepomuk::Resource::property#
	{7, 310, 149},	//137 Nepomuk::Resource::rating
	{7, 315, 165},	//138 Nepomuk::Resource::ratingUri
	{7, 317, 116},	//139 Nepomuk::Resource::remove
	{7, 319, 114},	//140 Nepomuk::Resource::removeProperty#
	{7, 320, 115},	//141 Nepomuk::Resource::removeProperty##
	{7, 329, 103},	//142 Nepomuk::Resource::resourceType
	{7, 331, 102},	//143 Nepomuk::Resource::resourceUri
	{7, 335, 130},	//144 Nepomuk::Resource::setAltLabels?
	{7, 337, 133},	//145 Nepomuk::Resource::setAnnotations?
	{7, 345, 125},	//146 Nepomuk::Resource::setDescription$
	{7, 353, 127},	//147 Nepomuk::Resource::setIdentifiers?
	{7, 355, 145},	//148 Nepomuk::Resource::setIsRelateds?
	{7, 357, 142},	//149 Nepomuk::Resource::setIsTopicOfs?
	{7, 359, 148},	//150 Nepomuk::Resource::setLabel$
	{7, 373, 112},	//151 Nepomuk::Resource::setProperty##
	{7, 375, 150},	//152 Nepomuk::Resource::setRating$
	{7, 381, 152},	//153 Nepomuk::Resource::setSymbols?
	{7, 387, 136},	//154 Nepomuk::Resource::setTags?
	{7, 389, 139},	//155 Nepomuk::Resource::setTopics?
	{7, 391, 105},	//156 Nepomuk::Resource::setTypes?
	{7, 404, 166},	//157 Nepomuk::Resource::symbolUri
	{7, 405, 151},	//158 Nepomuk::Resource::symbols
	{7, 412, 160},	//159 Nepomuk::Resource::tagUri
	{7, 416, 135},	//160 Nepomuk::Resource::tags
	{7, 444, 161},	//161 Nepomuk::Resource::topicUri
	{7, 445, 138},	//162 Nepomuk::Resource::topics
	{7, 447, 104},	//163 Nepomuk::Resource::types
	{7, 468, 98},	//164 Nepomuk::Resource::~Resource
	{8, 92, 176},	//165 Nepomuk::ResourceManager::allResourcesOfType#
	{8, 94, 177},	//166 Nepomuk::ResourceManager::allResourcesWithProperty##
	{8, 123, 181},	//167 Nepomuk::ResourceManager::createManagerForModel#
	{8, 129, 170},	//168 Nepomuk::ResourceManager::deleteInstance
	{8, 179, 178},	//169 Nepomuk::ResourceManager::generateUniqueUri$
	{8, 198, 171},	//170 Nepomuk::ResourceManager::init
	{8, 199, 172},	//171 Nepomuk::ResourceManager::initialized
	{8, 204, 180},	//172 Nepomuk::ResourceManager::instance
	{8, 257, 173},	//173 Nepomuk::ResourceManager::mainModel
	{8, 261, 168},	//174 Nepomuk::ResourceManager::metaObject
	{8, 278, 179},	//175 Nepomuk::ResourceManager::notifyError$$
	{8, 307, 169},	//176 Nepomuk::ResourceManager::qt_metacall$$?
	{8, 322, 175},	//177 Nepomuk::ResourceManager::removeResource$
	{8, 369, 174},	//178 Nepomuk::ResourceManager::setOverrideMainModel#
	{8, 399, 182},	//179 Nepomuk::ResourceManager::staticMetaObject
	{9, 32, 187},	//180 Nepomuk::Service::Service
	{9, 33, 186},	//181 Nepomuk::Service::Service#
	{9, 34, 185},	//182 Nepomuk::Service::Service#$
	{9, 257, 190},	//183 Nepomuk::Service::mainModel
	{9, 261, 183},	//184 Nepomuk::Service::metaObject
	{9, 307, 184},	//185 Nepomuk::Service::qt_metacall$$?
	{9, 377, 191},	//186 Nepomuk::Service::setServiceInitialized$
	{9, 399, 189},	//187 Nepomuk::Service::staticMetaObject
	{9, 469, 188},	//188 Nepomuk::Service::~Service
	{10, 35, 192},	//189 Nepomuk::Tag::Tag
	{10, 36, -11},	//190 Nepomuk::Tag::Tag#
	{10, 37, -16},	//191 Nepomuk::Tag::Tag##
	{10, 38, 208},	//192 Nepomuk::Tag::Tag###
	{10, 39, 196},	//193 Nepomuk::Tag::Tag$
	{10, 40, -19},	//194 Nepomuk::Tag::Tag$#
	{10, 41, 207},	//195 Nepomuk::Tag::Tag$##
	{10, 96, 203},	//196 Nepomuk::Tag::allTags
	{10, 284, 201},	//197 Nepomuk::Tag::operator=#
	{10, 330, 204},	//198 Nepomuk::Tag::resourceTypeUri
	{10, 411, 202},	//199 Nepomuk::Tag::tagOf
	{10, 470, 200},	//200 Nepomuk::Tag::~Tag
	{11, 42, 212},	//201 Nepomuk::TagCloud::TagCloud
	{11, 43, 211},	//202 Nepomuk::TagCloud::TagCloud#
	{11, 106, 214},	//203 Nepomuk::TagCloud::autoUpdate
	{11, 261, 209},	//204 Nepomuk::TagCloud::metaObject
	{11, 307, 210},	//205 Nepomuk::TagCloud::qt_metacall$$?
	{11, 341, 216},	//206 Nepomuk::TagCloud::setAutoUpdate$
	{11, 399, 218},	//207 Nepomuk::TagCloud::staticMetaObject
	{11, 409, 217},	//208 Nepomuk::TagCloud::tagClicked#
	{11, 448, 215},	//209 Nepomuk::TagCloud::updateTags
	{11, 471, 213},	//210 Nepomuk::TagCloud::~TagCloud
	{12, 44, 224},	//211 Nepomuk::TagWidget::TagWidget
	{12, 45, -22},	//212 Nepomuk::TagWidget::TagWidget#
	{12, 46, 221},	//213 Nepomuk::TagWidget::TagWidget##
	{12, 105, 227},	//214 Nepomuk::TagWidget::assignedTags
	{12, 261, 219},	//215 Nepomuk::TagWidget::metaObject
	{12, 307, 220},	//216 Nepomuk::TagWidget::qt_metacall$$?
	{12, 339, 230},	//217 Nepomuk::TagWidget::setAssignedTags?
	{12, 383, 228},	//218 Nepomuk::TagWidget::setTaggedResource#
	{12, 385, 229},	//219 Nepomuk::TagWidget::setTaggedResources?
	{12, 399, 232},	//220 Nepomuk::TagWidget::staticMetaObject
	{12, 409, 231},	//221 Nepomuk::TagWidget::tagClicked#
	{12, 415, 226},	//222 Nepomuk::TagWidget::taggedResources
	{12, 472, 225},	//223 Nepomuk::TagWidget::~TagWidget
	{13, 47, 235},	//224 Nepomuk::Thing::Thing
	{13, 48, -25},	//225 Nepomuk::Thing::Thing#
	{13, 49, 233},	//226 Nepomuk::Thing::Thing##
	{13, 50, 236},	//227 Nepomuk::Thing::Thing###
	{13, 51, 238},	//228 Nepomuk::Thing::Thing$
	{13, 52, 237},	//229 Nepomuk::Thing::Thing$#
	{13, 53, 239},	//230 Nepomuk::Thing::Thing$##
	{13, 54, 242},	//231 Nepomuk::Thing::Thing?
	{13, 185, 247},	//232 Nepomuk::Thing::groundingOccurrences
	{13, 279, 249},	//233 Nepomuk::Thing::occurrences
	{13, 284, -29},	//234 Nepomuk::Thing::operator=#
	{13, 316, 248},	//235 Nepomuk::Thing::referencingOccurrences
	{13, 473, 243},	//236 Nepomuk::Thing::~Thing
	{15, 1, 250},	//237 Nepomuk::Types::Class::Class
	{15, 2, -33},	//238 Nepomuk::Types::Class::Class#
	{15, 88, 262},	//239 Nepomuk::Types::Class::allParentClasses
	{15, 95, 263},	//240 Nepomuk::Types::Class::allSubClasses
	{15, 136, 256},	//241 Nepomuk::Types::Class::domainOf
	{15, 164, 259},	//242 Nepomuk::Types::Class::findPropertyByLabel$
	{15, 165, 258},	//243 Nepomuk::Types::Class::findPropertyByLabel$$
	{15, 167, 257},	//244 Nepomuk::Types::Class::findPropertyByName$
	{15, 222, 264},	//245 Nepomuk::Types::Class::isParentOf#
	{15, 231, 265},	//246 Nepomuk::Types::Class::isSubClassOf#
	{15, 284, 254},	//247 Nepomuk::Types::Class::operator=#
	{15, 300, 260},	//248 Nepomuk::Types::Class::parentClasses
	{15, 309, 255},	//249 Nepomuk::Types::Class::rangeOf
	{15, 402, 261},	//250 Nepomuk::Types::Class::subClasses
	{15, 459, 253},	//251 Nepomuk::Types::Class::~Class
	{16, 4, 283},	//252 Nepomuk::Types::Entity::Entity
	{16, 5, 266},	//253 Nepomuk::Types::Entity::Entity#
	{16, 116, 274},	//254 Nepomuk::Types::Entity::comment
	{16, 117, 273},	//255 Nepomuk::Types::Entity::comment$
	{16, 195, 275},	//256 Nepomuk::Types::Entity::icon
	{16, 206, 277},	//257 Nepomuk::Types::Entity::isAvailable
	{16, 244, 276},	//258 Nepomuk::Types::Entity::isValid
	{16, 249, 272},	//259 Nepomuk::Types::Entity::label
	{16, 250, 271},	//260 Nepomuk::Types::Entity::label$
	{16, 276, 269},	//261 Nepomuk::Types::Entity::name
	{16, 280, 280},	//262 Nepomuk::Types::Entity::operator QUrl
	{16, 282, 282},	//263 Nepomuk::Types::Entity::operator!=#
	{16, 284, 268},	//264 Nepomuk::Types::Entity::operator=#
	{16, 287, 281},	//265 Nepomuk::Types::Entity::operator==#
	{16, 323, 279},	//266 Nepomuk::Types::Entity::reset
	{16, 324, 278},	//267 Nepomuk::Types::Entity::reset$
	{16, 449, 270},	//268 Nepomuk::Types::Entity::uri
	{16, 460, 267},	//269 Nepomuk::Types::Entity::~Entity
	{17, 15, 284},	//270 Nepomuk::Types::Literal::Literal
	{17, 16, -36},	//271 Nepomuk::Types::Literal::Literal#
	{17, 127, 290},	//272 Nepomuk::Types::Literal::dataType
	{17, 128, 289},	//273 Nepomuk::Types::Literal::dataTypeUri
	{17, 244, 291},	//274 Nepomuk::Types::Literal::isValid
	{17, 284, 288},	//275 Nepomuk::Types::Literal::operator=#
	{17, 465, 287},	//276 Nepomuk::Types::Literal::~Literal
	{18, 18, 292},	//277 Nepomuk::Types::Ontology::Ontology
	{18, 19, -39},	//278 Nepomuk::Types::Ontology::Ontology#
	{18, 87, 297},	//279 Nepomuk::Types::Ontology::allClasses
	{18, 89, 301},	//280 Nepomuk::Types::Ontology::allProperties
	{18, 159, 300},	//281 Nepomuk::Types::Ontology::findClassByLabel$
	{18, 160, 299},	//282 Nepomuk::Types::Ontology::findClassByLabel$$
	{18, 162, 298},	//283 Nepomuk::Types::Ontology::findClassByName$
	{18, 164, 304},	//284 Nepomuk::Types::Ontology::findPropertyByLabel$
	{18, 165, 303},	//285 Nepomuk::Types::Ontology::findPropertyByLabel$$
	{18, 167, 302},	//286 Nepomuk::Types::Ontology::findPropertyByName$
	{18, 284, 296},	//287 Nepomuk::Types::Ontology::operator=#
	{18, 466, 295},	//288 Nepomuk::Types::Ontology::~Ontology
	{19, 20, 305},	//289 Nepomuk::Types::Property::Property
	{19, 21, -42},	//290 Nepomuk::Types::Property::Property#
	{19, 107, 316},	//291 Nepomuk::Types::Property::cardinality
	{19, 135, 315},	//292 Nepomuk::Types::Property::domain
	{19, 205, 312},	//293 Nepomuk::Types::Property::inverseProperty
	{19, 222, 319},	//294 Nepomuk::Types::Property::isParentOf#
	{19, 233, 320},	//295 Nepomuk::Types::Property::isSubPropertyOf#
	{19, 256, 314},	//296 Nepomuk::Types::Property::literalRangeType
	{19, 259, 318},	//297 Nepomuk::Types::Property::maxCardinality
	{19, 264, 317},	//298 Nepomuk::Types::Property::minCardinality
	{19, 284, 309},	//299 Nepomuk::Types::Property::operator=#
	{19, 301, 310},	//300 Nepomuk::Types::Property::parentProperties
	{19, 308, 313},	//301 Nepomuk::Types::Property::range
	{19, 403, 311},	//302 Nepomuk::Types::Property::subProperties
	{19, 467, 308},	//303 Nepomuk::Types::Property::~Property
	{20, 56, 321},	//304 Nepomuk::Variant::Variant
	{20, 57, -45},	//305 Nepomuk::Variant::Variant#
	{20, 58, -53},	//306 Nepomuk::Variant::Variant$
	{20, 59, -62},	//307 Nepomuk::Variant::Variant?
	{20, 103, -76},	//308 Nepomuk::Variant::append#
	{20, 104, -83},	//309 Nepomuk::Variant::append$
	{20, 177, 445},	//310 Nepomuk::Variant::fromString$$
	{20, 207, 399},	//311 Nepomuk::Variant::isBool
	{20, 208, 411},	//312 Nepomuk::Variant::isBoolList
	{20, 209, 402},	//313 Nepomuk::Variant::isDate
	{20, 210, 414},	//314 Nepomuk::Variant::isDateList
	{20, 211, 404},	//315 Nepomuk::Variant::isDateTime
	{20, 212, 416},	//316 Nepomuk::Variant::isDateTimeList
	{20, 213, 400},	//317 Nepomuk::Variant::isDouble
	{20, 214, 412},	//318 Nepomuk::Variant::isDoubleList
	{20, 216, 395},	//319 Nepomuk::Variant::isInt
	{20, 217, 396},	//320 Nepomuk::Variant::isInt64
	{20, 218, 408},	//321 Nepomuk::Variant::isInt64List
	{20, 219, 407},	//322 Nepomuk::Variant::isIntList
	{20, 220, 394},	//323 Nepomuk::Variant::isList
	{20, 226, 406},	//324 Nepomuk::Variant::isResource
	{20, 227, 418},	//325 Nepomuk::Variant::isResourceList
	{20, 228, 401},	//326 Nepomuk::Variant::isString
	{20, 229, 413},	//327 Nepomuk::Variant::isStringList
	{20, 234, 403},	//328 Nepomuk::Variant::isTime
	{20, 235, 415},	//329 Nepomuk::Variant::isTimeList
	{20, 238, 397},	//330 Nepomuk::Variant::isUnsignedInt
	{20, 239, 398},	//331 Nepomuk::Variant::isUnsignedInt64
	{20, 240, 410},	//332 Nepomuk::Variant::isUnsignedInt64List
	{20, 241, 409},	//333 Nepomuk::Variant::isUnsignedIntList
	{20, 242, 405},	//334 Nepomuk::Variant::isUrl
	{20, 243, 417},	//335 Nepomuk::Variant::isUrlList
	{20, 244, 391},	//336 Nepomuk::Variant::isValid
	{20, 282, 390},	//337 Nepomuk::Variant::operator!=#
	{20, 284, -91},	//338 Nepomuk::Variant::operator=#
	{20, 285, -98},	//339 Nepomuk::Variant::operator=$
	{20, 287, 389},	//340 Nepomuk::Variant::operator==#
	{20, 288, -106},	//341 Nepomuk::Variant::operator=?
	{20, 396, 393},	//342 Nepomuk::Variant::simpleType
	{20, 419, 424},	//343 Nepomuk::Variant::toBool
	{20, 420, 436},	//344 Nepomuk::Variant::toBoolList
	{20, 421, 427},	//345 Nepomuk::Variant::toDate
	{20, 422, 439},	//346 Nepomuk::Variant::toDateList
	{20, 423, 429},	//347 Nepomuk::Variant::toDateTime
	{20, 424, 441},	//348 Nepomuk::Variant::toDateTimeList
	{20, 425, 425},	//349 Nepomuk::Variant::toDouble
	{20, 426, 437},	//350 Nepomuk::Variant::toDoubleList
	{20, 427, 420},	//351 Nepomuk::Variant::toInt
	{20, 428, 421},	//352 Nepomuk::Variant::toInt64
	{20, 429, 433},	//353 Nepomuk::Variant::toInt64List
	{20, 430, 432},	//354 Nepomuk::Variant::toIntList
	{20, 431, 431},	//355 Nepomuk::Variant::toResource
	{20, 432, 443},	//356 Nepomuk::Variant::toResourceList
	{20, 433, 426},	//357 Nepomuk::Variant::toString
	{20, 434, 438},	//358 Nepomuk::Variant::toStringList
	{20, 435, 428},	//359 Nepomuk::Variant::toTime
	{20, 436, 440},	//360 Nepomuk::Variant::toTimeList
	{20, 437, 422},	//361 Nepomuk::Variant::toUnsignedInt
	{20, 438, 423},	//362 Nepomuk::Variant::toUnsignedInt64
	{20, 439, 435},	//363 Nepomuk::Variant::toUnsignedInt64List
	{20, 440, 434},	//364 Nepomuk::Variant::toUnsignedIntList
	{20, 441, 430},	//365 Nepomuk::Variant::toUrl
	{20, 442, 442},	//366 Nepomuk::Variant::toUrlList
	{20, 443, 444},	//367 Nepomuk::Variant::toVariantList
	{20, 446, 392},	//368 Nepomuk::Variant::type
	{20, 454, 419},	//369 Nepomuk::Variant::variant
	{20, 474, 322},	//370 Nepomuk::Variant::~Variant
};

static Smoke::Index nepomuk_ambiguousMethodList[] = {
    0,
    48,  // KRatingWidget::ratingChanged(int)
    47,  // KRatingWidget::ratingChanged(unsigned int)
    0,
    90,  // Nepomuk::Resource::Resource(const Nepomuk::Resource&)
    95,  // Nepomuk::Resource::Resource(const QUrl&)
    89,  // Nepomuk::Resource::Resource(Nepomuk::ResourceManager*)
    0,
    100,  // Nepomuk::Resource::operator=(const QUrl&)
    99,  // Nepomuk::Resource::operator=(const Nepomuk::Resource&)
    0,
    194,  // Nepomuk::Tag::Tag(const Nepomuk::Tag&)
    198,  // Nepomuk::Tag::Tag(const QUrl&)
    193,  // Nepomuk::Tag::Tag(Nepomuk::ResourceManager*)
    195,  // Nepomuk::Tag::Tag(const Nepomuk::Resource&)
    0,
    206,  // Nepomuk::Tag::Tag(const QUrl&, const QUrl&)
    199,  // Nepomuk::Tag::Tag(const QUrl&, Nepomuk::ResourceManager*)
    0,
    205,  // Nepomuk::Tag::Tag(const QString&, const QUrl&)
    197,  // Nepomuk::Tag::Tag(const QString&, Nepomuk::ResourceManager*)
    0,
    223,  // Nepomuk::TagWidget::TagWidget(QWidget*)
    222,  // Nepomuk::TagWidget::TagWidget(const Nepomuk::Resource&)
    0,
    241,  // Nepomuk::Thing::Thing(const Nepomuk::Resource&)
    234,  // Nepomuk::Thing::Thing(const QUrl&)
    240,  // Nepomuk::Thing::Thing(const Nepomuk::Thing&)
    0,
    246,  // Nepomuk::Thing::operator=(const QUrl&)
    245,  // Nepomuk::Thing::operator=(const Nepomuk::Resource&)
    244,  // Nepomuk::Thing::operator=(const Nepomuk::Thing&)
    0,
    252,  // Nepomuk::Types::Class::Class(const Nepomuk::Types::Class&)
    251,  // Nepomuk::Types::Class::Class(const QUrl&)
    0,
    285,  // Nepomuk::Types::Literal::Literal(const Nepomuk::Types::Literal&)
    286,  // Nepomuk::Types::Literal::Literal(const QUrl&)
    0,
    293,  // Nepomuk::Types::Ontology::Ontology(const QUrl&)
    294,  // Nepomuk::Types::Ontology::Ontology(const Nepomuk::Types::Ontology&)
    0,
    307,  // Nepomuk::Types::Property::Property(const Nepomuk::Types::Property&)
    306,  // Nepomuk::Types::Property::Property(const QUrl&)
    0,
    336,  // Nepomuk::Variant::Variant(const QUrl&)
    335,  // Nepomuk::Variant::Variant(const QDateTime&)
    337,  // Nepomuk::Variant::Variant(const Nepomuk::Resource&)
    324,  // Nepomuk::Variant::Variant(const QVariant&)
    333,  // Nepomuk::Variant::Variant(const QDate&)
    323,  // Nepomuk::Variant::Variant(const Nepomuk::Variant&)
    334,  // Nepomuk::Variant::Variant(const QTime&)
    0,
    327,  // Nepomuk::Variant::Variant(uint)
    328,  // Nepomuk::Variant::Variant(qulonglong)
    332,  // Nepomuk::Variant::Variant(const QString&)
    331,  // Nepomuk::Variant::Variant(const char*)
    329,  // Nepomuk::Variant::Variant(bool)
    325,  // Nepomuk::Variant::Variant(int)
    330,  // Nepomuk::Variant::Variant(double)
    326,  // Nepomuk::Variant::Variant(qlonglong)
    0,
    339,  // Nepomuk::Variant::Variant(const QList<qlonglong>&)
    340,  // Nepomuk::Variant::Variant(const QList<uint>&)
    341,  // Nepomuk::Variant::Variant(const QList<qulonglong>&)
    349,  // Nepomuk::Variant::Variant(const QList<Nepomuk::Resource>&)
    350,  // Nepomuk::Variant::Variant(const QList<Nepomuk::Variant>&)
    338,  // Nepomuk::Variant::Variant(const QList<int>&)
    345,  // Nepomuk::Variant::Variant(const QList<QDate>&)
    346,  // Nepomuk::Variant::Variant(const QList<QTime>&)
    342,  // Nepomuk::Variant::Variant(const QList<bool>&)
    344,  // Nepomuk::Variant::Variant(const QStringList&)
    343,  // Nepomuk::Variant::Variant(const QList<double>&)
    347,  // Nepomuk::Variant::Variant(const QList<QDateTime>&)
    348,  // Nepomuk::Variant::Variant(const QList<QUrl>&)
    0,
    383,  // Nepomuk::Variant::append(const QDate&)
    387,  // Nepomuk::Variant::append(const Nepomuk::Resource&)
    388,  // Nepomuk::Variant::append(const Nepomuk::Variant&)
    385,  // Nepomuk::Variant::append(const QDateTime&)
    384,  // Nepomuk::Variant::append(const QTime&)
    386,  // Nepomuk::Variant::append(const QUrl&)
    0,
    376,  // Nepomuk::Variant::append(int)
    380,  // Nepomuk::Variant::append(bool)
    378,  // Nepomuk::Variant::append(uint)
    379,  // Nepomuk::Variant::append(qulonglong)
    381,  // Nepomuk::Variant::append(double)
    377,  // Nepomuk::Variant::append(qlonglong)
    382,  // Nepomuk::Variant::append(const QString&)
    0,
    362,  // Nepomuk::Variant::operator=(const QUrl&)
    359,  // Nepomuk::Variant::operator=(const QDate&)
    363,  // Nepomuk::Variant::operator=(const Nepomuk::Resource&)
    351,  // Nepomuk::Variant::operator=(const Nepomuk::Variant&)
    360,  // Nepomuk::Variant::operator=(const QTime&)
    361,  // Nepomuk::Variant::operator=(const QDateTime&)
    0,
    352,  // Nepomuk::Variant::operator=(int)
    356,  // Nepomuk::Variant::operator=(bool)
    357,  // Nepomuk::Variant::operator=(double)
    353,  // Nepomuk::Variant::operator=(qlonglong)
    354,  // Nepomuk::Variant::operator=(uint)
    358,  // Nepomuk::Variant::operator=(const QString&)
    355,  // Nepomuk::Variant::operator=(qulonglong)
    0,
    374,  // Nepomuk::Variant::operator=(const QList<QUrl>&)
    373,  // Nepomuk::Variant::operator=(const QList<QDateTime>&)
    365,  // Nepomuk::Variant::operator=(const QList<qlonglong>&)
    368,  // Nepomuk::Variant::operator=(const QList<bool>&)
    375,  // Nepomuk::Variant::operator=(const QList<Nepomuk::Resource>&)
    372,  // Nepomuk::Variant::operator=(const QList<QTime>&)
    371,  // Nepomuk::Variant::operator=(const QList<QDate>&)
    364,  // Nepomuk::Variant::operator=(const QList<int>&)
    367,  // Nepomuk::Variant::operator=(const QList<qulonglong>&)
    369,  // Nepomuk::Variant::operator=(const QList<double>&)
    366,  // Nepomuk::Variant::operator=(const QList<uint>&)
    370,  // Nepomuk::Variant::operator=(const QStringList&)
    0,
};


void init_qt_Smoke();
void init_soprano_Smoke();
void init_kde_Smoke();

static bool initialized = false;
Smoke *nepomuk_Smoke = 0;

// Create the Smoke instance encapsulating all the above.
void init_nepomuk_Smoke() {
    if (initialized) return;
    init_qt_Smoke();
    init_soprano_Smoke();
    init_kde_Smoke();
    nepomuk_Smoke = new Smoke(
        "nepomuk",
        nepomuk_classes, 79,
        nepomuk_methods, 500,
        nepomuk_methodMaps, 370,
        nepomuk_methodNames, 474,
        nepomuk_types, 511,
        nepomuk_inheritanceList,
        nepomuk_argumentList,
        nepomuk_ambiguousMethodList,
        nepomuk_cast );
    initialized = true;
}
