#include <qaction.h>
#include <qbytearray.h>
#include <qcolor.h>
#include <qcoreevent.h>
#include <qdatetime.h>
#include <qdom.h>
#include <qevent.h>
#include <qfont.h>
#include <qimage.h>
#include <qline.h>
#include <qmatrix.h>
#include <qnamespace.h>
#include <qobject.h>
#include <qobjectdefs.h>
#include <qpaintdevice.h>
#include <qpaintengine.h>
#include <qpainterpath.h>
#include <qpalette.h>
#include <qpixmap.h>
#include <qpoint.h>
#include <qpolygon.h>
#include <qprinter.h>
#include <qrect.h>
#include <qsize.h>
#include <qstyle.h>
#include <qtextdocument.h>
#include <qtextformat.h>
#include <qtextobject.h>
#include <qurl.h>
#include <qvariant.h>
#include <qwidget.h>
#include <kactioncollection.h>
#include <kcomponentdata.h>
#include <kconfigdialog.h>
#include <kicon.h>
#include <kurl.h>
#include <kxmlguiclient.h>
#include <okular/core/action.h>
#include <okular/core/annotations.h>
#include <okular/core/area.h>
#include <okular/core/document.h>
#include <okular/core/fileprinter.h>
#include <okular/core/fontinfo.h>
#include <okular/core/form.h>
#include <okular/core/generator.h>
#include <okular/core/page.h>
#include <okular/core/pagesize.h>
#include <okular/core/pagetransition.h>
#include <okular/core/sound.h>
#include <okular/core/sourcereference.h>
#include <okular/core/textdocumentgenerator.h>
#include <okular/core/textpage.h>
#include <okular/core/utils.h>
#include <okular/interfaces/configinterface.h>
#include <okular/interfaces/guiinterface.h>
#include <okular/interfaces/printinterface.h>

#include <smoke.h>

#include <okular_smoke.h>

static void *okular_cast(void *xptr, Smoke::Index from, Smoke::Index to) {
    switch(from) {
      case 1:	//KActionCollection
	switch(to) {
	    case 90: return (void*)(QObject*)(KActionCollection*)xptr;
	    case 1: return (void*)(KActionCollection*)(KActionCollection*)xptr;
	  default: return xptr;
	}
      case 2:	//KComponentData
	switch(to) {
	    case 2: return (void*)(KComponentData*)(KComponentData*)xptr;
	  default: return xptr;
	}
      case 3:	//KConfigDialog
	switch(to) {
	    case 118: return (void*)(QWidget*)(KConfigDialog*)xptr;
	    case 90: return (void*)(QObject*)(KConfigDialog*)xptr;
	    case 91: return (void*)(QPaintDevice*)(KConfigDialog*)xptr;
	    case 3: return (void*)(KConfigDialog*)(KConfigDialog*)xptr;
	  default: return xptr;
	}
      case 4:	//KIcon
	switch(to) {
	    case 4: return (void*)(KIcon*)(KIcon*)xptr;
	  default: return xptr;
	}
      case 5:	//KUrl
	switch(to) {
	    case 115: return (void*)(QUrl*)(KUrl*)xptr;
	    case 5: return (void*)(KUrl*)(KUrl*)xptr;
	  default: return xptr;
	}
      case 6:	//KXMLGUIClient
	switch(to) {
	    case 6: return (void*)(KXMLGUIClient*)(KXMLGUIClient*)xptr;
	    case 35: return (void*)(Okular::GuiInterface*)(KXMLGUIClient*)xptr;
	  default: return xptr;
	}
      case 8:	//Okular::Action
	switch(to) {
	    case 8: return (void*)(Okular::Action*)(Okular::Action*)xptr;
	    case 14: return (void*)(Okular::BrowseAction*)(Okular::Action*)xptr;
	    case 18: return (void*)(Okular::DocumentAction*)(Okular::Action*)xptr;
	    case 23: return (void*)(Okular::ExecuteAction*)(Okular::Action*)xptr;
	    case 34: return (void*)(Okular::GotoAction*)(Okular::Action*)xptr;
	    case 48: return (void*)(Okular::ScriptAction*)(Okular::Action*)xptr;
	    case 50: return (void*)(Okular::SoundAction*)(Okular::Action*)xptr;
	  default: return xptr;
	}
      case 9:	//Okular::Annotation
	switch(to) {
	    case 9: return (void*)(Okular::Annotation*)(Okular::Annotation*)xptr;
	    case 15: return (void*)(Okular::CaretAnnotation*)(Okular::Annotation*)xptr;
	    case 25: return (void*)(Okular::FileAttachmentAnnotation*)(Okular::Annotation*)xptr;
	    case 33: return (void*)(Okular::GeomAnnotation*)(Okular::Annotation*)xptr;
	    case 36: return (void*)(Okular::HighlightAnnotation*)(Okular::Annotation*)xptr;
	    case 37: return (void*)(Okular::InkAnnotation*)(Okular::Annotation*)xptr;
	    case 38: return (void*)(Okular::LineAnnotation*)(Okular::Annotation*)xptr;
	    case 51: return (void*)(Okular::SoundAnnotation*)(Okular::Annotation*)xptr;
	    case 54: return (void*)(Okular::StampAnnotation*)(Okular::Annotation*)xptr;
	    case 55: return (void*)(Okular::TextAnnotation*)(Okular::Annotation*)xptr;
	  default: return xptr;
	}
      case 10:	//Okular::Annotation::Style
	switch(to) {
	    case 10: return (void*)(Okular::Annotation::Style*)(Okular::Annotation::Style*)xptr;
	  default: return xptr;
	}
      case 11:	//Okular::Annotation::Window
	switch(to) {
	    case 11: return (void*)(Okular::Annotation::Window*)(Okular::Annotation::Window*)xptr;
	  default: return xptr;
	}
      case 12:	//Okular::AnnotationObjectRect
	switch(to) {
	    case 41: return (void*)(Okular::ObjectRect*)(Okular::AnnotationObjectRect*)xptr;
	    case 12: return (void*)(Okular::AnnotationObjectRect*)(Okular::AnnotationObjectRect*)xptr;
	  default: return xptr;
	}
      case 13:	//Okular::AnnotationUtils
	switch(to) {
	    case 13: return (void*)(Okular::AnnotationUtils*)(Okular::AnnotationUtils*)xptr;
	  default: return xptr;
	}
      case 14:	//Okular::BrowseAction
	switch(to) {
	    case 8: return (void*)(Okular::Action*)(Okular::BrowseAction*)xptr;
	    case 14: return (void*)(Okular::BrowseAction*)(Okular::BrowseAction*)xptr;
	  default: return xptr;
	}
      case 15:	//Okular::CaretAnnotation
	switch(to) {
	    case 9: return (void*)(Okular::Annotation*)(Okular::CaretAnnotation*)xptr;
	    case 15: return (void*)(Okular::CaretAnnotation*)(Okular::CaretAnnotation*)xptr;
	  default: return xptr;
	}
      case 16:	//Okular::ConfigInterface
	switch(to) {
	    case 16: return (void*)(Okular::ConfigInterface*)(Okular::ConfigInterface*)xptr;
	  default: return xptr;
	}
      case 17:	//Okular::Document
	switch(to) {
	    case 90: return (void*)(QObject*)(Okular::Document*)xptr;
	    case 17: return (void*)(Okular::Document*)(Okular::Document*)xptr;
	  default: return xptr;
	}
      case 18:	//Okular::DocumentAction
	switch(to) {
	    case 8: return (void*)(Okular::Action*)(Okular::DocumentAction*)xptr;
	    case 18: return (void*)(Okular::DocumentAction*)(Okular::DocumentAction*)xptr;
	  default: return xptr;
	}
      case 19:	//Okular::DocumentInfo
	switch(to) {
	    case 70: return (void*)(QDomDocument*)(Okular::DocumentInfo*)xptr;
	    case 72: return (void*)(QDomNode*)(Okular::DocumentInfo*)xptr;
	    case 19: return (void*)(Okular::DocumentInfo*)(Okular::DocumentInfo*)xptr;
	  default: return xptr;
	}
      case 20:	//Okular::DocumentSynopsis
	switch(to) {
	    case 70: return (void*)(QDomDocument*)(Okular::DocumentSynopsis*)xptr;
	    case 72: return (void*)(QDomNode*)(Okular::DocumentSynopsis*)xptr;
	    case 20: return (void*)(Okular::DocumentSynopsis*)(Okular::DocumentSynopsis*)xptr;
	  default: return xptr;
	}
      case 21:	//Okular::DocumentViewport
	switch(to) {
	    case 21: return (void*)(Okular::DocumentViewport*)(Okular::DocumentViewport*)xptr;
	  default: return xptr;
	}
      case 22:	//Okular::EmbeddedFile
	switch(to) {
	    case 22: return (void*)(Okular::EmbeddedFile*)(Okular::EmbeddedFile*)xptr;
	  default: return xptr;
	}
      case 23:	//Okular::ExecuteAction
	switch(to) {
	    case 8: return (void*)(Okular::Action*)(Okular::ExecuteAction*)xptr;
	    case 23: return (void*)(Okular::ExecuteAction*)(Okular::ExecuteAction*)xptr;
	  default: return xptr;
	}
      case 24:	//Okular::ExportFormat
	switch(to) {
	    case 24: return (void*)(Okular::ExportFormat*)(Okular::ExportFormat*)xptr;
	  default: return xptr;
	}
      case 25:	//Okular::FileAttachmentAnnotation
	switch(to) {
	    case 9: return (void*)(Okular::Annotation*)(Okular::FileAttachmentAnnotation*)xptr;
	    case 25: return (void*)(Okular::FileAttachmentAnnotation*)(Okular::FileAttachmentAnnotation*)xptr;
	  default: return xptr;
	}
      case 26:	//Okular::FilePrinter
	switch(to) {
	    case 26: return (void*)(Okular::FilePrinter*)(Okular::FilePrinter*)xptr;
	  default: return xptr;
	}
      case 27:	//Okular::FontInfo
	switch(to) {
	    case 27: return (void*)(Okular::FontInfo*)(Okular::FontInfo*)xptr;
	  default: return xptr;
	}
      case 28:	//Okular::FormField
	switch(to) {
	    case 28: return (void*)(Okular::FormField*)(Okular::FormField*)xptr;
	    case 29: return (void*)(Okular::FormFieldButton*)(Okular::FormField*)xptr;
	    case 30: return (void*)(Okular::FormFieldChoice*)(Okular::FormField*)xptr;
	    case 31: return (void*)(Okular::FormFieldText*)(Okular::FormField*)xptr;
	  default: return xptr;
	}
      case 29:	//Okular::FormFieldButton
	switch(to) {
	    case 28: return (void*)(Okular::FormField*)(Okular::FormFieldButton*)xptr;
	    case 29: return (void*)(Okular::FormFieldButton*)(Okular::FormFieldButton*)xptr;
	  default: return xptr;
	}
      case 30:	//Okular::FormFieldChoice
	switch(to) {
	    case 28: return (void*)(Okular::FormField*)(Okular::FormFieldChoice*)xptr;
	    case 30: return (void*)(Okular::FormFieldChoice*)(Okular::FormFieldChoice*)xptr;
	  default: return xptr;
	}
      case 31:	//Okular::FormFieldText
	switch(to) {
	    case 28: return (void*)(Okular::FormField*)(Okular::FormFieldText*)xptr;
	    case 31: return (void*)(Okular::FormFieldText*)(Okular::FormFieldText*)xptr;
	  default: return xptr;
	}
      case 32:	//Okular::Generator
	switch(to) {
	    case 90: return (void*)(QObject*)(Okular::Generator*)xptr;
	    case 32: return (void*)(Okular::Generator*)(Okular::Generator*)xptr;
	    case 57: return (void*)(Okular::TextDocumentGenerator*)(Okular::Generator*)xptr;
	  default: return xptr;
	}
      case 33:	//Okular::GeomAnnotation
	switch(to) {
	    case 9: return (void*)(Okular::Annotation*)(Okular::GeomAnnotation*)xptr;
	    case 33: return (void*)(Okular::GeomAnnotation*)(Okular::GeomAnnotation*)xptr;
	  default: return xptr;
	}
      case 34:	//Okular::GotoAction
	switch(to) {
	    case 8: return (void*)(Okular::Action*)(Okular::GotoAction*)xptr;
	    case 34: return (void*)(Okular::GotoAction*)(Okular::GotoAction*)xptr;
	  default: return xptr;
	}
      case 35:	//Okular::GuiInterface
	switch(to) {
	    case 6: return (void*)(KXMLGUIClient*)(Okular::GuiInterface*)xptr;
	    case 35: return (void*)(Okular::GuiInterface*)(Okular::GuiInterface*)xptr;
	  default: return xptr;
	}
      case 36:	//Okular::HighlightAnnotation
	switch(to) {
	    case 9: return (void*)(Okular::Annotation*)(Okular::HighlightAnnotation*)xptr;
	    case 36: return (void*)(Okular::HighlightAnnotation*)(Okular::HighlightAnnotation*)xptr;
	  default: return xptr;
	}
      case 37:	//Okular::InkAnnotation
	switch(to) {
	    case 9: return (void*)(Okular::Annotation*)(Okular::InkAnnotation*)xptr;
	    case 37: return (void*)(Okular::InkAnnotation*)(Okular::InkAnnotation*)xptr;
	  default: return xptr;
	}
      case 38:	//Okular::LineAnnotation
	switch(to) {
	    case 9: return (void*)(Okular::Annotation*)(Okular::LineAnnotation*)xptr;
	    case 38: return (void*)(Okular::LineAnnotation*)(Okular::LineAnnotation*)xptr;
	  default: return xptr;
	}
      case 39:	//Okular::NormalizedPoint
	switch(to) {
	    case 39: return (void*)(Okular::NormalizedPoint*)(Okular::NormalizedPoint*)xptr;
	  default: return xptr;
	}
      case 40:	//Okular::NormalizedRect
	switch(to) {
	    case 40: return (void*)(Okular::NormalizedRect*)(Okular::NormalizedRect*)xptr;
	  default: return xptr;
	}
      case 41:	//Okular::ObjectRect
	switch(to) {
	    case 41: return (void*)(Okular::ObjectRect*)(Okular::ObjectRect*)xptr;
	    case 12: return (void*)(Okular::AnnotationObjectRect*)(Okular::ObjectRect*)xptr;
	    case 52: return (void*)(Okular::SourceRefObjectRect*)(Okular::ObjectRect*)xptr;
	  default: return xptr;
	}
      case 42:	//Okular::Page
	switch(to) {
	    case 42: return (void*)(Okular::Page*)(Okular::Page*)xptr;
	  default: return xptr;
	}
      case 43:	//Okular::PageSize
	switch(to) {
	    case 43: return (void*)(Okular::PageSize*)(Okular::PageSize*)xptr;
	  default: return xptr;
	}
      case 44:	//Okular::PageTransition
	switch(to) {
	    case 44: return (void*)(Okular::PageTransition*)(Okular::PageTransition*)xptr;
	  default: return xptr;
	}
      case 45:	//Okular::PixmapRequest
	switch(to) {
	    case 45: return (void*)(Okular::PixmapRequest*)(Okular::PixmapRequest*)xptr;
	  default: return xptr;
	}
      case 46:	//Okular::PrintInterface
	switch(to) {
	    case 46: return (void*)(Okular::PrintInterface*)(Okular::PrintInterface*)xptr;
	  default: return xptr;
	}
      case 47:	//Okular::RegularAreaRect
	switch(to) {
	    case 47: return (void*)(Okular::RegularAreaRect*)(Okular::RegularAreaRect*)xptr;
	  default: return xptr;
	}
      case 48:	//Okular::ScriptAction
	switch(to) {
	    case 8: return (void*)(Okular::Action*)(Okular::ScriptAction*)xptr;
	    case 48: return (void*)(Okular::ScriptAction*)(Okular::ScriptAction*)xptr;
	  default: return xptr;
	}
      case 49:	//Okular::Sound
	switch(to) {
	    case 49: return (void*)(Okular::Sound*)(Okular::Sound*)xptr;
	  default: return xptr;
	}
      case 50:	//Okular::SoundAction
	switch(to) {
	    case 8: return (void*)(Okular::Action*)(Okular::SoundAction*)xptr;
	    case 50: return (void*)(Okular::SoundAction*)(Okular::SoundAction*)xptr;
	  default: return xptr;
	}
      case 51:	//Okular::SoundAnnotation
	switch(to) {
	    case 9: return (void*)(Okular::Annotation*)(Okular::SoundAnnotation*)xptr;
	    case 51: return (void*)(Okular::SoundAnnotation*)(Okular::SoundAnnotation*)xptr;
	  default: return xptr;
	}
      case 52:	//Okular::SourceRefObjectRect
	switch(to) {
	    case 41: return (void*)(Okular::ObjectRect*)(Okular::SourceRefObjectRect*)xptr;
	    case 52: return (void*)(Okular::SourceRefObjectRect*)(Okular::SourceRefObjectRect*)xptr;
	  default: return xptr;
	}
      case 53:	//Okular::SourceReference
	switch(to) {
	    case 53: return (void*)(Okular::SourceReference*)(Okular::SourceReference*)xptr;
	  default: return xptr;
	}
      case 54:	//Okular::StampAnnotation
	switch(to) {
	    case 9: return (void*)(Okular::Annotation*)(Okular::StampAnnotation*)xptr;
	    case 54: return (void*)(Okular::StampAnnotation*)(Okular::StampAnnotation*)xptr;
	  default: return xptr;
	}
      case 55:	//Okular::TextAnnotation
	switch(to) {
	    case 9: return (void*)(Okular::Annotation*)(Okular::TextAnnotation*)xptr;
	    case 55: return (void*)(Okular::TextAnnotation*)(Okular::TextAnnotation*)xptr;
	  default: return xptr;
	}
      case 56:	//Okular::TextDocumentConverter
	switch(to) {
	    case 90: return (void*)(QObject*)(Okular::TextDocumentConverter*)xptr;
	    case 56: return (void*)(Okular::TextDocumentConverter*)(Okular::TextDocumentConverter*)xptr;
	  default: return xptr;
	}
      case 57:	//Okular::TextDocumentGenerator
	switch(to) {
	    case 32: return (void*)(Okular::Generator*)(Okular::TextDocumentGenerator*)xptr;
	    case 90: return (void*)(QObject*)(Okular::TextDocumentGenerator*)xptr;
	    case 57: return (void*)(Okular::TextDocumentGenerator*)(Okular::TextDocumentGenerator*)xptr;
	  default: return xptr;
	}
      case 58:	//Okular::TextEntity
	switch(to) {
	    case 58: return (void*)(Okular::TextEntity*)(Okular::TextEntity*)xptr;
	  default: return xptr;
	}
      case 59:	//Okular::TextPage
	switch(to) {
	    case 59: return (void*)(Okular::TextPage*)(Okular::TextPage*)xptr;
	  default: return xptr;
	}
      case 60:	//Okular::Utils
	switch(to) {
	    case 60: return (void*)(Okular::Utils*)(Okular::Utils*)xptr;
	  default: return xptr;
	}
      case 61:	//Okular::VisiblePageRect
	switch(to) {
	    case 61: return (void*)(Okular::VisiblePageRect*)(Okular::VisiblePageRect*)xptr;
	  default: return xptr;
	}
      case 62:	//QAction
	switch(to) {
	    case 90: return (void*)(QObject*)(QAction*)xptr;
	    case 62: return (void*)(QAction*)(QAction*)xptr;
	  default: return xptr;
	}
      case 63:	//QActionEvent
	switch(to) {
	    case 77: return (void*)(QEvent*)(QActionEvent*)xptr;
	    case 63: return (void*)(QActionEvent*)(QActionEvent*)xptr;
	  default: return xptr;
	}
      case 64:	//QByteArray
	switch(to) {
	    case 64: return (void*)(QByteArray*)(QByteArray*)xptr;
	  default: return xptr;
	}
      case 65:	//QChildEvent
	switch(to) {
	    case 77: return (void*)(QEvent*)(QChildEvent*)xptr;
	    case 65: return (void*)(QChildEvent*)(QChildEvent*)xptr;
	  default: return xptr;
	}
      case 66:	//QCloseEvent
	switch(to) {
	    case 77: return (void*)(QEvent*)(QCloseEvent*)xptr;
	    case 66: return (void*)(QCloseEvent*)(QCloseEvent*)xptr;
	  default: return xptr;
	}
      case 67:	//QColor
	switch(to) {
	    case 67: return (void*)(QColor*)(QColor*)xptr;
	  default: return xptr;
	}
      case 68:	//QContextMenuEvent
	switch(to) {
	    case 77: return (void*)(QEvent*)(QContextMenuEvent*)xptr;
	    case 68: return (void*)(QContextMenuEvent*)(QContextMenuEvent*)xptr;
	  default: return xptr;
	}
      case 69:	//QDateTime
	switch(to) {
	    case 69: return (void*)(QDateTime*)(QDateTime*)xptr;
	  default: return xptr;
	}
      case 70:	//QDomDocument
	switch(to) {
	    case 72: return (void*)(QDomNode*)(QDomDocument*)xptr;
	    case 70: return (void*)(QDomDocument*)(QDomDocument*)xptr;
	    case 19: return (void*)(Okular::DocumentInfo*)(QDomDocument*)xptr;
	    case 20: return (void*)(Okular::DocumentSynopsis*)(QDomDocument*)xptr;
	  default: return xptr;
	}
      case 71:	//QDomElement
	switch(to) {
	    case 72: return (void*)(QDomNode*)(QDomElement*)xptr;
	    case 71: return (void*)(QDomElement*)(QDomElement*)xptr;
	  default: return xptr;
	}
      case 72:	//QDomNode
	switch(to) {
	    case 72: return (void*)(QDomNode*)(QDomNode*)xptr;
	    case 19: return (void*)(Okular::DocumentInfo*)(QDomNode*)xptr;
	    case 20: return (void*)(Okular::DocumentSynopsis*)(QDomNode*)xptr;
	    case 70: return (void*)(QDomDocument*)(QDomNode*)xptr;
	    case 71: return (void*)(QDomElement*)(QDomNode*)xptr;
	  default: return xptr;
	}
      case 73:	//QDragEnterEvent
	switch(to) {
	    case 75: return (void*)(QDragMoveEvent*)(QDragEnterEvent*)xptr;
	    case 76: return (void*)(QDropEvent*)(QDragEnterEvent*)xptr;
	    case 77: return (void*)(QEvent*)(QDragEnterEvent*)xptr;
	    case 73: return (void*)(QDragEnterEvent*)(QDragEnterEvent*)xptr;
	  default: return xptr;
	}
      case 74:	//QDragLeaveEvent
	switch(to) {
	    case 77: return (void*)(QEvent*)(QDragLeaveEvent*)xptr;
	    case 74: return (void*)(QDragLeaveEvent*)(QDragLeaveEvent*)xptr;
	  default: return xptr;
	}
      case 75:	//QDragMoveEvent
	switch(to) {
	    case 76: return (void*)(QDropEvent*)(QDragMoveEvent*)xptr;
	    case 77: return (void*)(QEvent*)(QDragMoveEvent*)xptr;
	    case 75: return (void*)(QDragMoveEvent*)(QDragMoveEvent*)xptr;
	    case 73: return (void*)(QDragEnterEvent*)(QDragMoveEvent*)xptr;
	  default: return xptr;
	}
      case 76:	//QDropEvent
	switch(to) {
	    case 77: return (void*)(QEvent*)(QDropEvent*)xptr;
	    case 76: return (void*)(QDropEvent*)(QDropEvent*)xptr;
	    case 73: return (void*)(QDragEnterEvent*)(QDropEvent*)xptr;
	    case 75: return (void*)(QDragMoveEvent*)(QDropEvent*)xptr;
	  default: return xptr;
	}
      case 77:	//QEvent
	switch(to) {
	    case 77: return (void*)(QEvent*)(QEvent*)xptr;
	    case 63: return (void*)(QActionEvent*)(QEvent*)xptr;
	    case 65: return (void*)(QChildEvent*)(QEvent*)xptr;
	    case 66: return (void*)(QCloseEvent*)(QEvent*)xptr;
	    case 68: return (void*)(QContextMenuEvent*)(QEvent*)xptr;
	    case 73: return (void*)(QDragEnterEvent*)(QEvent*)xptr;
	    case 74: return (void*)(QDragLeaveEvent*)(QEvent*)xptr;
	    case 75: return (void*)(QDragMoveEvent*)(QEvent*)xptr;
	    case 76: return (void*)(QDropEvent*)(QEvent*)xptr;
	    case 78: return (void*)(QFocusEvent*)(QEvent*)xptr;
	    case 80: return (void*)(QHideEvent*)(QEvent*)xptr;
	    case 82: return (void*)(QInputMethodEvent*)(QEvent*)xptr;
	    case 83: return (void*)(QKeyEvent*)(QEvent*)xptr;
	    case 88: return (void*)(QMouseEvent*)(QEvent*)xptr;
	    case 89: return (void*)(QMoveEvent*)(QEvent*)xptr;
	    case 94: return (void*)(QPaintEvent*)(QEvent*)xptr;
	    case 104: return (void*)(QResizeEvent*)(QEvent*)xptr;
	    case 105: return (void*)(QShowEvent*)(QEvent*)xptr;
	    case 109: return (void*)(QTabletEvent*)(QEvent*)xptr;
	    case 114: return (void*)(QTimerEvent*)(QEvent*)xptr;
	    case 117: return (void*)(QWheelEvent*)(QEvent*)xptr;
	  default: return xptr;
	}
      case 78:	//QFocusEvent
	switch(to) {
	    case 77: return (void*)(QEvent*)(QFocusEvent*)xptr;
	    case 78: return (void*)(QFocusEvent*)(QFocusEvent*)xptr;
	  default: return xptr;
	}
      case 79:	//QFont
	switch(to) {
	    case 79: return (void*)(QFont*)(QFont*)xptr;
	  default: return xptr;
	}
      case 80:	//QHideEvent
	switch(to) {
	    case 77: return (void*)(QEvent*)(QHideEvent*)xptr;
	    case 80: return (void*)(QHideEvent*)(QHideEvent*)xptr;
	  default: return xptr;
	}
      case 81:	//QImage
	switch(to) {
	    case 91: return (void*)(QPaintDevice*)(QImage*)xptr;
	    case 81: return (void*)(QImage*)(QImage*)xptr;
	  default: return xptr;
	}
      case 82:	//QInputMethodEvent
	switch(to) {
	    case 77: return (void*)(QEvent*)(QInputMethodEvent*)xptr;
	    case 82: return (void*)(QInputMethodEvent*)(QInputMethodEvent*)xptr;
	  default: return xptr;
	}
      case 83:	//QKeyEvent
	switch(to) {
	    case 77: return (void*)(QEvent*)(QKeyEvent*)xptr;
	    case 83: return (void*)(QKeyEvent*)(QKeyEvent*)xptr;
	  default: return xptr;
	}
      case 84:	//QLine
	switch(to) {
	    case 84: return (void*)(QLine*)(QLine*)xptr;
	  default: return xptr;
	}
      case 85:	//QLineF
	switch(to) {
	    case 85: return (void*)(QLineF*)(QLineF*)xptr;
	  default: return xptr;
	}
      case 86:	//QMatrix
	switch(to) {
	    case 86: return (void*)(QMatrix*)(QMatrix*)xptr;
	  default: return xptr;
	}
      case 87:	//QMetaObject
	switch(to) {
	    case 87: return (void*)(QMetaObject*)(QMetaObject*)xptr;
	  default: return xptr;
	}
      case 88:	//QMouseEvent
	switch(to) {
	    case 77: return (void*)(QEvent*)(QMouseEvent*)xptr;
	    case 88: return (void*)(QMouseEvent*)(QMouseEvent*)xptr;
	  default: return xptr;
	}
      case 89:	//QMoveEvent
	switch(to) {
	    case 77: return (void*)(QEvent*)(QMoveEvent*)xptr;
	    case 89: return (void*)(QMoveEvent*)(QMoveEvent*)xptr;
	  default: return xptr;
	}
      case 90:	//QObject
	switch(to) {
	    case 90: return (void*)(QObject*)(QObject*)xptr;
	    case 1: return (void*)(KActionCollection*)(QObject*)xptr;
	    case 3: return (void*)(KConfigDialog*)(QObject*)xptr;
	    case 17: return (void*)(Okular::Document*)(QObject*)xptr;
	    case 32: return (void*)(Okular::Generator*)(QObject*)xptr;
	    case 56: return (void*)(Okular::TextDocumentConverter*)(QObject*)xptr;
	    case 57: return (void*)(Okular::TextDocumentGenerator*)(QObject*)xptr;
	    case 62: return (void*)(QAction*)(QObject*)xptr;
	    case 108: return (void*)(QStyle*)(QObject*)xptr;
	    case 111: return (void*)(QTextDocument*)(QObject*)xptr;
	    case 113: return (void*)(QTextObject*)(QObject*)xptr;
	    case 118: return (void*)(QWidget*)(QObject*)xptr;
	  default: return xptr;
	}
      case 91:	//QPaintDevice
	switch(to) {
	    case 91: return (void*)(QPaintDevice*)(QPaintDevice*)xptr;
	    case 3: return (void*)(KConfigDialog*)(QPaintDevice*)xptr;
	    case 81: return (void*)(QImage*)(QPaintDevice*)xptr;
	    case 97: return (void*)(QPixmap*)(QPaintDevice*)xptr;
	    case 101: return (void*)(QPrinter*)(QPaintDevice*)xptr;
	    case 118: return (void*)(QWidget*)(QPaintDevice*)xptr;
	  default: return xptr;
	}
      case 92:	//QPaintEngine
	switch(to) {
	    case 92: return (void*)(QPaintEngine*)(QPaintEngine*)xptr;
	  default: return xptr;
	}
      case 93:	//QPaintEngineState
	switch(to) {
	    case 93: return (void*)(QPaintEngineState*)(QPaintEngineState*)xptr;
	  default: return xptr;
	}
      case 94:	//QPaintEvent
	switch(to) {
	    case 77: return (void*)(QEvent*)(QPaintEvent*)xptr;
	    case 94: return (void*)(QPaintEvent*)(QPaintEvent*)xptr;
	  default: return xptr;
	}
      case 95:	//QPainterPath
	switch(to) {
	    case 95: return (void*)(QPainterPath*)(QPainterPath*)xptr;
	  default: return xptr;
	}
      case 96:	//QPalette
	switch(to) {
	    case 96: return (void*)(QPalette*)(QPalette*)xptr;
	  default: return xptr;
	}
      case 97:	//QPixmap
	switch(to) {
	    case 91: return (void*)(QPaintDevice*)(QPixmap*)xptr;
	    case 97: return (void*)(QPixmap*)(QPixmap*)xptr;
	  default: return xptr;
	}
      case 98:	//QPoint
	switch(to) {
	    case 98: return (void*)(QPoint*)(QPoint*)xptr;
	  default: return xptr;
	}
      case 99:	//QPointF
	switch(to) {
	    case 99: return (void*)(QPointF*)(QPointF*)xptr;
	  default: return xptr;
	}
      case 100:	//QPolygonF
	switch(to) {
	    case 100: return (void*)(QPolygonF*)(QPolygonF*)xptr;
	  default: return xptr;
	}
      case 101:	//QPrinter
	switch(to) {
	    case 91: return (void*)(QPaintDevice*)(QPrinter*)xptr;
	    case 101: return (void*)(QPrinter*)(QPrinter*)xptr;
	  default: return xptr;
	}
      case 102:	//QRect
	switch(to) {
	    case 102: return (void*)(QRect*)(QRect*)xptr;
	  default: return xptr;
	}
      case 103:	//QRectF
	switch(to) {
	    case 103: return (void*)(QRectF*)(QRectF*)xptr;
	  default: return xptr;
	}
      case 104:	//QResizeEvent
	switch(to) {
	    case 77: return (void*)(QEvent*)(QResizeEvent*)xptr;
	    case 104: return (void*)(QResizeEvent*)(QResizeEvent*)xptr;
	  default: return xptr;
	}
      case 105:	//QShowEvent
	switch(to) {
	    case 77: return (void*)(QEvent*)(QShowEvent*)xptr;
	    case 105: return (void*)(QShowEvent*)(QShowEvent*)xptr;
	  default: return xptr;
	}
      case 106:	//QSize
	switch(to) {
	    case 106: return (void*)(QSize*)(QSize*)xptr;
	  default: return xptr;
	}
      case 107:	//QSizeF
	switch(to) {
	    case 107: return (void*)(QSizeF*)(QSizeF*)xptr;
	  default: return xptr;
	}
      case 108:	//QStyle
	switch(to) {
	    case 90: return (void*)(QObject*)(QStyle*)xptr;
	    case 108: return (void*)(QStyle*)(QStyle*)xptr;
	  default: return xptr;
	}
      case 109:	//QTabletEvent
	switch(to) {
	    case 77: return (void*)(QEvent*)(QTabletEvent*)xptr;
	    case 109: return (void*)(QTabletEvent*)(QTabletEvent*)xptr;
	  default: return xptr;
	}
      case 110:	//QTextBlock
	switch(to) {
	    case 110: return (void*)(QTextBlock*)(QTextBlock*)xptr;
	  default: return xptr;
	}
      case 111:	//QTextDocument
	switch(to) {
	    case 90: return (void*)(QObject*)(QTextDocument*)xptr;
	    case 111: return (void*)(QTextDocument*)(QTextDocument*)xptr;
	  default: return xptr;
	}
      case 112:	//QTextFormat
	switch(to) {
	    case 112: return (void*)(QTextFormat*)(QTextFormat*)xptr;
	  default: return xptr;
	}
      case 113:	//QTextObject
	switch(to) {
	    case 90: return (void*)(QObject*)(QTextObject*)xptr;
	    case 113: return (void*)(QTextObject*)(QTextObject*)xptr;
	  default: return xptr;
	}
      case 114:	//QTimerEvent
	switch(to) {
	    case 77: return (void*)(QEvent*)(QTimerEvent*)xptr;
	    case 114: return (void*)(QTimerEvent*)(QTimerEvent*)xptr;
	  default: return xptr;
	}
      case 115:	//QUrl
	switch(to) {
	    case 115: return (void*)(QUrl*)(QUrl*)xptr;
	    case 5: return (void*)(KUrl*)(QUrl*)xptr;
	  default: return xptr;
	}
      case 116:	//QVariant
	switch(to) {
	    case 116: return (void*)(QVariant*)(QVariant*)xptr;
	  default: return xptr;
	}
      case 117:	//QWheelEvent
	switch(to) {
	    case 77: return (void*)(QEvent*)(QWheelEvent*)xptr;
	    case 117: return (void*)(QWheelEvent*)(QWheelEvent*)xptr;
	  default: return xptr;
	}
      case 118:	//QWidget
	switch(to) {
	    case 90: return (void*)(QObject*)(QWidget*)xptr;
	    case 91: return (void*)(QPaintDevice*)(QWidget*)xptr;
	    case 118: return (void*)(QWidget*)(QWidget*)xptr;
	    case 3: return (void*)(KConfigDialog*)(QWidget*)xptr;
	  default: return xptr;
	}
      default: return xptr;
    }
}

// Group of Indexes (0 separated) used as super class lists.
// Classes with super classes have an index into this array.
static Smoke::Index okular_inheritanceList[] = {
	0,	// 0: (no super class)
	41, 0,	// 1: Okular::ObjectRect
	8, 0,	// 3: Okular::Action
	9, 0,	// 5: Okular::Annotation
	90, 0,	// 7: QObject
	70, 0,	// 9: QDomDocument
	28, 0,	// 11: Okular::FormField
	6, 0,	// 13: KXMLGUIClient
	32, 0,	// 15: Okular::Generator
};

// These are the xenum functions for manipulating enum pointers
void xenum_Okular__LineAnnotation(Smoke::EnumOperation, Smoke::Index, void*&, long&);
void xenum_Okular__GeomAnnotation(Smoke::EnumOperation, Smoke::Index, void*&, long&);
void xenum_Okular__Action(Smoke::EnumOperation, Smoke::Index, void*&, long&);
void xenum_Okular__DocumentViewport(Smoke::EnumOperation, Smoke::Index, void*&, long&);
void xenum_Okular__FilePrinter(Smoke::EnumOperation, Smoke::Index, void*&, long&);
void xenum_Okular__FormFieldButton(Smoke::EnumOperation, Smoke::Index, void*&, long&);
void xenum_Okular__CaretAnnotation(Smoke::EnumOperation, Smoke::Index, void*&, long&);
void xenum_Okular__DocumentInfo(Smoke::EnumOperation, Smoke::Index, void*&, long&);
void xenum_Okular__HighlightAnnotation(Smoke::EnumOperation, Smoke::Index, void*&, long&);
void xenum_Okular__Annotation(Smoke::EnumOperation, Smoke::Index, void*&, long&);
void xenum_Okular__Generator(Smoke::EnumOperation, Smoke::Index, void*&, long&);
void xenum_Okular__Document(Smoke::EnumOperation, Smoke::Index, void*&, long&);
void xenum_Okular__TextAnnotation(Smoke::EnumOperation, Smoke::Index, void*&, long&);
void xenum_Okular__FontInfo(Smoke::EnumOperation, Smoke::Index, void*&, long&);
void xenum_Okular__Page(Smoke::EnumOperation, Smoke::Index, void*&, long&);
void xenum_Okular__ObjectRect(Smoke::EnumOperation, Smoke::Index, void*&, long&);
void xenum_Okular__Sound(Smoke::EnumOperation, Smoke::Index, void*&, long&);
void xenum_Okular__FormFieldChoice(Smoke::EnumOperation, Smoke::Index, void*&, long&);
void xenum_Okular__FormFieldText(Smoke::EnumOperation, Smoke::Index, void*&, long&);
void xenum_Okular__PageTransition(Smoke::EnumOperation, Smoke::Index, void*&, long&);
void xenum_Okular__DocumentAction(Smoke::EnumOperation, Smoke::Index, void*&, long&);
void xenum_Okular__FormField(Smoke::EnumOperation, Smoke::Index, void*&, long&);
void xenum_Okular__ExportFormat(Smoke::EnumOperation, Smoke::Index, void*&, long&);

// Those are the xcall functions defined in each x_*.cpp file, for dispatching method calls
void xcall_Okular__Action(Smoke::Index, void*, Smoke::Stack);
void xcall_Okular__Annotation(Smoke::Index, void*, Smoke::Stack);
void xcall_Okular__AnnotationObjectRect(Smoke::Index, void*, Smoke::Stack);
void xcall_Okular__AnnotationUtils(Smoke::Index, void*, Smoke::Stack);
void xcall_Okular__BrowseAction(Smoke::Index, void*, Smoke::Stack);
void xcall_Okular__CaretAnnotation(Smoke::Index, void*, Smoke::Stack);
void xcall_Okular__ConfigInterface(Smoke::Index, void*, Smoke::Stack);
void xcall_Okular__Document(Smoke::Index, void*, Smoke::Stack);
void xcall_Okular__DocumentAction(Smoke::Index, void*, Smoke::Stack);
void xcall_Okular__DocumentInfo(Smoke::Index, void*, Smoke::Stack);
void xcall_Okular__DocumentSynopsis(Smoke::Index, void*, Smoke::Stack);
void xcall_Okular__DocumentViewport(Smoke::Index, void*, Smoke::Stack);
void xcall_Okular__EmbeddedFile(Smoke::Index, void*, Smoke::Stack);
void xcall_Okular__ExecuteAction(Smoke::Index, void*, Smoke::Stack);
void xcall_Okular__ExportFormat(Smoke::Index, void*, Smoke::Stack);
void xcall_Okular__FileAttachmentAnnotation(Smoke::Index, void*, Smoke::Stack);
void xcall_Okular__FilePrinter(Smoke::Index, void*, Smoke::Stack);
void xcall_Okular__FontInfo(Smoke::Index, void*, Smoke::Stack);
void xcall_Okular__FormField(Smoke::Index, void*, Smoke::Stack);
void xcall_Okular__FormFieldButton(Smoke::Index, void*, Smoke::Stack);
void xcall_Okular__FormFieldChoice(Smoke::Index, void*, Smoke::Stack);
void xcall_Okular__FormFieldText(Smoke::Index, void*, Smoke::Stack);
void xcall_Okular__Generator(Smoke::Index, void*, Smoke::Stack);
void xcall_Okular__GeomAnnotation(Smoke::Index, void*, Smoke::Stack);
void xcall_Okular__GotoAction(Smoke::Index, void*, Smoke::Stack);
void xcall_Okular__GuiInterface(Smoke::Index, void*, Smoke::Stack);
void xcall_Okular__HighlightAnnotation(Smoke::Index, void*, Smoke::Stack);
void xcall_Okular__InkAnnotation(Smoke::Index, void*, Smoke::Stack);
void xcall_Okular__LineAnnotation(Smoke::Index, void*, Smoke::Stack);
void xcall_Okular__NormalizedPoint(Smoke::Index, void*, Smoke::Stack);
void xcall_Okular__NormalizedRect(Smoke::Index, void*, Smoke::Stack);
void xcall_Okular__ObjectRect(Smoke::Index, void*, Smoke::Stack);
void xcall_Okular__Page(Smoke::Index, void*, Smoke::Stack);
void xcall_Okular__PageSize(Smoke::Index, void*, Smoke::Stack);
void xcall_Okular__PageTransition(Smoke::Index, void*, Smoke::Stack);
void xcall_Okular__PixmapRequest(Smoke::Index, void*, Smoke::Stack);
void xcall_Okular__PrintInterface(Smoke::Index, void*, Smoke::Stack);
void xcall_Okular__RegularAreaRect(Smoke::Index, void*, Smoke::Stack);
void xcall_Okular__ScriptAction(Smoke::Index, void*, Smoke::Stack);
void xcall_Okular__Sound(Smoke::Index, void*, Smoke::Stack);
void xcall_Okular__SoundAction(Smoke::Index, void*, Smoke::Stack);
void xcall_Okular__SoundAnnotation(Smoke::Index, void*, Smoke::Stack);
void xcall_Okular__SourceRefObjectRect(Smoke::Index, void*, Smoke::Stack);
void xcall_Okular__SourceReference(Smoke::Index, void*, Smoke::Stack);
void xcall_Okular__StampAnnotation(Smoke::Index, void*, Smoke::Stack);
void xcall_Okular__TextAnnotation(Smoke::Index, void*, Smoke::Stack);
void xcall_Okular__TextDocumentConverter(Smoke::Index, void*, Smoke::Stack);
void xcall_Okular__TextDocumentGenerator(Smoke::Index, void*, Smoke::Stack);
void xcall_Okular__TextEntity(Smoke::Index, void*, Smoke::Stack);
void xcall_Okular__TextPage(Smoke::Index, void*, Smoke::Stack);
void xcall_Okular__Utils(Smoke::Index, void*, Smoke::Stack);
void xcall_Okular__VisiblePageRect(Smoke::Index, void*, Smoke::Stack);

// List of all classes
// Name, index into inheritanceList, method dispatcher, enum dispatcher, class flags
static Smoke::Class okular_classes[] = {
	{ 0L, false, 0, 0, 0, 0 }, 	// 0 (no class)
	{ "KActionCollection", true, 0, 0, 0, 0 }, 	// 1
	{ "KComponentData", true, 0, 0, 0, 0 }, 	// 2
	{ "KConfigDialog", true, 0, 0, 0, 0 }, 	// 3
	{ "KIcon", true, 0, 0, 0, 0 }, 	// 4
	{ "KUrl", true, 0, 0, 0, 0 }, 	// 5
	{ "KXMLGUIClient", true, 0, 0, 0, 0 }, 	// 6
	{ "Okular", true, 0, 0, 0, 0 }, 	// 7
	{ "Okular::Action", false, 0, xcall_Okular__Action, xenum_Okular__Action, Smoke::cf_constructor|Smoke::cf_virtual }, 	//8
	{ "Okular::Annotation", false, 0, xcall_Okular__Annotation, xenum_Okular__Annotation, Smoke::cf_constructor|Smoke::cf_virtual }, 	//9
	{ "Okular::Annotation::Style", true, 0, 0, 0, 0 }, 	// 10
	{ "Okular::Annotation::Window", true, 0, 0, 0, 0 }, 	// 11
	{ "Okular::AnnotationObjectRect", false, 1, xcall_Okular__AnnotationObjectRect, 0, Smoke::cf_constructor|Smoke::cf_deepcopy|Smoke::cf_virtual }, 	//12
	{ "Okular::AnnotationUtils", false, 0, xcall_Okular__AnnotationUtils, 0, Smoke::cf_constructor|Smoke::cf_deepcopy }, 	//13
	{ "Okular::BrowseAction", false, 3, xcall_Okular__BrowseAction, 0, Smoke::cf_constructor|Smoke::cf_virtual }, 	//14
	{ "Okular::CaretAnnotation", false, 5, xcall_Okular__CaretAnnotation, xenum_Okular__CaretAnnotation, Smoke::cf_constructor|Smoke::cf_virtual }, 	//15
	{ "Okular::ConfigInterface", false, 0, xcall_Okular__ConfigInterface, 0, Smoke::cf_constructor|Smoke::cf_deepcopy|Smoke::cf_virtual }, 	//16
	{ "Okular::Document", false, 7, xcall_Okular__Document, xenum_Okular__Document, Smoke::cf_constructor|Smoke::cf_virtual }, 	//17
	{ "Okular::DocumentAction", false, 3, xcall_Okular__DocumentAction, xenum_Okular__DocumentAction, Smoke::cf_constructor|Smoke::cf_virtual }, 	//18
	{ "Okular::DocumentInfo", false, 9, xcall_Okular__DocumentInfo, xenum_Okular__DocumentInfo, Smoke::cf_constructor|Smoke::cf_deepcopy }, 	//19
	{ "Okular::DocumentSynopsis", false, 9, xcall_Okular__DocumentSynopsis, 0, Smoke::cf_constructor|Smoke::cf_deepcopy }, 	//20
	{ "Okular::DocumentViewport", false, 0, xcall_Okular__DocumentViewport, xenum_Okular__DocumentViewport, Smoke::cf_constructor|Smoke::cf_deepcopy }, 	//21
	{ "Okular::EmbeddedFile", false, 0, xcall_Okular__EmbeddedFile, 0, Smoke::cf_constructor|Smoke::cf_deepcopy|Smoke::cf_virtual }, 	//22
	{ "Okular::ExecuteAction", false, 3, xcall_Okular__ExecuteAction, 0, Smoke::cf_constructor|Smoke::cf_virtual }, 	//23
	{ "Okular::ExportFormat", false, 0, xcall_Okular__ExportFormat, xenum_Okular__ExportFormat, Smoke::cf_constructor|Smoke::cf_deepcopy }, 	//24
	{ "Okular::FileAttachmentAnnotation", false, 5, xcall_Okular__FileAttachmentAnnotation, 0, Smoke::cf_constructor|Smoke::cf_virtual }, 	//25
	{ "Okular::FilePrinter", false, 0, xcall_Okular__FilePrinter, xenum_Okular__FilePrinter, Smoke::cf_constructor|Smoke::cf_deepcopy }, 	//26
	{ "Okular::FontInfo", false, 0, xcall_Okular__FontInfo, xenum_Okular__FontInfo, Smoke::cf_constructor|Smoke::cf_deepcopy }, 	//27
	{ "Okular::FormField", false, 0, xcall_Okular__FormField, xenum_Okular__FormField, Smoke::cf_constructor|Smoke::cf_virtual }, 	//28
	{ "Okular::FormFieldButton", false, 11, xcall_Okular__FormFieldButton, xenum_Okular__FormFieldButton, Smoke::cf_constructor|Smoke::cf_virtual }, 	//29
	{ "Okular::FormFieldChoice", false, 11, xcall_Okular__FormFieldChoice, xenum_Okular__FormFieldChoice, Smoke::cf_constructor|Smoke::cf_virtual }, 	//30
	{ "Okular::FormFieldText", false, 11, xcall_Okular__FormFieldText, xenum_Okular__FormFieldText, Smoke::cf_constructor|Smoke::cf_virtual }, 	//31
	{ "Okular::Generator", false, 7, xcall_Okular__Generator, xenum_Okular__Generator, Smoke::cf_constructor|Smoke::cf_virtual }, 	//32
	{ "Okular::GeomAnnotation", false, 5, xcall_Okular__GeomAnnotation, xenum_Okular__GeomAnnotation, Smoke::cf_constructor|Smoke::cf_virtual }, 	//33
	{ "Okular::GotoAction", false, 3, xcall_Okular__GotoAction, 0, Smoke::cf_constructor|Smoke::cf_virtual }, 	//34
	{ "Okular::GuiInterface", false, 13, xcall_Okular__GuiInterface, 0, Smoke::cf_constructor|Smoke::cf_deepcopy|Smoke::cf_virtual }, 	//35
	{ "Okular::HighlightAnnotation", false, 5, xcall_Okular__HighlightAnnotation, xenum_Okular__HighlightAnnotation, Smoke::cf_constructor|Smoke::cf_virtual }, 	//36
	{ "Okular::InkAnnotation", false, 5, xcall_Okular__InkAnnotation, 0, Smoke::cf_constructor|Smoke::cf_virtual }, 	//37
	{ "Okular::LineAnnotation", false, 5, xcall_Okular__LineAnnotation, xenum_Okular__LineAnnotation, Smoke::cf_constructor|Smoke::cf_virtual }, 	//38
	{ "Okular::NormalizedPoint", false, 0, xcall_Okular__NormalizedPoint, 0, Smoke::cf_constructor|Smoke::cf_deepcopy }, 	//39
	{ "Okular::NormalizedRect", false, 0, xcall_Okular__NormalizedRect, 0, Smoke::cf_constructor|Smoke::cf_deepcopy }, 	//40
	{ "Okular::ObjectRect", false, 0, xcall_Okular__ObjectRect, xenum_Okular__ObjectRect, Smoke::cf_constructor|Smoke::cf_deepcopy|Smoke::cf_virtual }, 	//41
	{ "Okular::Page", false, 0, xcall_Okular__Page, xenum_Okular__Page, Smoke::cf_constructor }, 	//42
	{ "Okular::PageSize", false, 0, xcall_Okular__PageSize, 0, Smoke::cf_constructor|Smoke::cf_deepcopy }, 	//43
	{ "Okular::PageTransition", false, 0, xcall_Okular__PageTransition, xenum_Okular__PageTransition, Smoke::cf_constructor|Smoke::cf_deepcopy }, 	//44
	{ "Okular::PixmapRequest", false, 0, xcall_Okular__PixmapRequest, 0, Smoke::cf_constructor }, 	//45
	{ "Okular::PrintInterface", false, 0, xcall_Okular__PrintInterface, 0, Smoke::cf_constructor|Smoke::cf_deepcopy|Smoke::cf_virtual }, 	//46
	{ "Okular::RegularAreaRect", false, 0, xcall_Okular__RegularAreaRect, 0, Smoke::cf_constructor }, 	//47
	{ "Okular::ScriptAction", false, 3, xcall_Okular__ScriptAction, 0, Smoke::cf_constructor|Smoke::cf_virtual }, 	//48
	{ "Okular::Sound", false, 0, xcall_Okular__Sound, xenum_Okular__Sound, Smoke::cf_constructor }, 	//49
	{ "Okular::SoundAction", false, 3, xcall_Okular__SoundAction, 0, Smoke::cf_constructor|Smoke::cf_virtual }, 	//50
	{ "Okular::SoundAnnotation", false, 5, xcall_Okular__SoundAnnotation, 0, Smoke::cf_constructor|Smoke::cf_virtual }, 	//51
	{ "Okular::SourceRefObjectRect", false, 1, xcall_Okular__SourceRefObjectRect, 0, Smoke::cf_constructor|Smoke::cf_deepcopy|Smoke::cf_virtual }, 	//52
	{ "Okular::SourceReference", false, 0, xcall_Okular__SourceReference, 0, Smoke::cf_constructor }, 	//53
	{ "Okular::StampAnnotation", false, 5, xcall_Okular__StampAnnotation, 0, Smoke::cf_constructor|Smoke::cf_virtual }, 	//54
	{ "Okular::TextAnnotation", false, 5, xcall_Okular__TextAnnotation, xenum_Okular__TextAnnotation, Smoke::cf_constructor|Smoke::cf_virtual }, 	//55
	{ "Okular::TextDocumentConverter", false, 7, xcall_Okular__TextDocumentConverter, 0, Smoke::cf_constructor|Smoke::cf_virtual }, 	//56
	{ "Okular::TextDocumentGenerator", false, 15, xcall_Okular__TextDocumentGenerator, 0, Smoke::cf_constructor|Smoke::cf_virtual }, 	//57
	{ "Okular::TextEntity", false, 0, xcall_Okular__TextEntity, 0, Smoke::cf_constructor }, 	//58
	{ "Okular::TextPage", false, 0, xcall_Okular__TextPage, 0, Smoke::cf_constructor }, 	//59
	{ "Okular::Utils", false, 0, xcall_Okular__Utils, 0, Smoke::cf_constructor|Smoke::cf_deepcopy }, 	//60
	{ "Okular::VisiblePageRect", false, 0, xcall_Okular__VisiblePageRect, 0, Smoke::cf_constructor|Smoke::cf_deepcopy }, 	//61
	{ "QAction", true, 0, 0, 0, 0 }, 	// 62
	{ "QActionEvent", true, 0, 0, 0, 0 }, 	// 63
	{ "QByteArray", true, 0, 0, 0, 0 }, 	// 64
	{ "QChildEvent", true, 0, 0, 0, 0 }, 	// 65
	{ "QCloseEvent", true, 0, 0, 0, 0 }, 	// 66
	{ "QColor", true, 0, 0, 0, 0 }, 	// 67
	{ "QContextMenuEvent", true, 0, 0, 0, 0 }, 	// 68
	{ "QDateTime", true, 0, 0, 0, 0 }, 	// 69
	{ "QDomDocument", true, 0, 0, 0, 0 }, 	// 70
	{ "QDomElement", true, 0, 0, 0, 0 }, 	// 71
	{ "QDomNode", true, 0, 0, 0, 0 }, 	// 72
	{ "QDragEnterEvent", true, 0, 0, 0, 0 }, 	// 73
	{ "QDragLeaveEvent", true, 0, 0, 0, 0 }, 	// 74
	{ "QDragMoveEvent", true, 0, 0, 0, 0 }, 	// 75
	{ "QDropEvent", true, 0, 0, 0, 0 }, 	// 76
	{ "QEvent", true, 0, 0, 0, 0 }, 	// 77
	{ "QFocusEvent", true, 0, 0, 0, 0 }, 	// 78
	{ "QFont", true, 0, 0, 0, 0 }, 	// 79
	{ "QHideEvent", true, 0, 0, 0, 0 }, 	// 80
	{ "QImage", true, 0, 0, 0, 0 }, 	// 81
	{ "QInputMethodEvent", true, 0, 0, 0, 0 }, 	// 82
	{ "QKeyEvent", true, 0, 0, 0, 0 }, 	// 83
	{ "QLine", true, 0, 0, 0, 0 }, 	// 84
	{ "QLineF", true, 0, 0, 0, 0 }, 	// 85
	{ "QMatrix", true, 0, 0, 0, 0 }, 	// 86
	{ "QMetaObject", true, 0, 0, 0, 0 }, 	// 87
	{ "QMouseEvent", true, 0, 0, 0, 0 }, 	// 88
	{ "QMoveEvent", true, 0, 0, 0, 0 }, 	// 89
	{ "QObject", true, 0, 0, 0, 0 }, 	// 90
	{ "QPaintDevice", true, 0, 0, 0, 0 }, 	// 91
	{ "QPaintEngine", true, 0, 0, 0, 0 }, 	// 92
	{ "QPaintEngineState", true, 0, 0, 0, 0 }, 	// 93
	{ "QPaintEvent", true, 0, 0, 0, 0 }, 	// 94
	{ "QPainterPath", true, 0, 0, 0, 0 }, 	// 95
	{ "QPalette", true, 0, 0, 0, 0 }, 	// 96
	{ "QPixmap", true, 0, 0, 0, 0 }, 	// 97
	{ "QPoint", true, 0, 0, 0, 0 }, 	// 98
	{ "QPointF", true, 0, 0, 0, 0 }, 	// 99
	{ "QPolygonF", true, 0, 0, 0, 0 }, 	// 100
	{ "QPrinter", true, 0, 0, 0, 0 }, 	// 101
	{ "QRect", true, 0, 0, 0, 0 }, 	// 102
	{ "QRectF", true, 0, 0, 0, 0 }, 	// 103
	{ "QResizeEvent", true, 0, 0, 0, 0 }, 	// 104
	{ "QShowEvent", true, 0, 0, 0, 0 }, 	// 105
	{ "QSize", true, 0, 0, 0, 0 }, 	// 106
	{ "QSizeF", true, 0, 0, 0, 0 }, 	// 107
	{ "QStyle", true, 0, 0, 0, 0 }, 	// 108
	{ "QTabletEvent", true, 0, 0, 0, 0 }, 	// 109
	{ "QTextBlock", true, 0, 0, 0, 0 }, 	// 110
	{ "QTextDocument", true, 0, 0, 0, 0 }, 	// 111
	{ "QTextFormat", true, 0, 0, 0, 0 }, 	// 112
	{ "QTextObject", true, 0, 0, 0, 0 }, 	// 113
	{ "QTimerEvent", true, 0, 0, 0, 0 }, 	// 114
	{ "QUrl", true, 0, 0, 0, 0 }, 	// 115
	{ "QVariant", true, 0, 0, 0, 0 }, 	// 116
	{ "QWheelEvent", true, 0, 0, 0, 0 }, 	// 117
	{ "QWidget", true, 0, 0, 0, 0 }, 	// 118
	{ "Qt", true, 0, 0, 0, 0 }, 	// 119
};

// List of all types needed by the methods (arguments and return values)
// Name, class ID if arg is a class, and TypeId
static Smoke::Type okular_types[] = {
	{ 0, 0, 0 },	//0 (no type)
	{ "Action*", 0, Smoke::t_voidp | Smoke::tf_ptr },	//1
	{ "Annotation*", 0, Smoke::t_voidp | Smoke::tf_ptr },	//2
	{ "DisposeDataFunction", 0, Smoke::t_voidp | Smoke::tf_stack },	//3
	{ "DocumentInfo::Key", 0, Smoke::t_voidp | Smoke::tf_stack },	//4
	{ "KAction::ShortcutTypes", 0, Smoke::t_uint | Smoke::tf_stack },	//5
	{ "KAction::ShortcutTypes&", 0, Smoke::t_voidp | Smoke::tf_ref },	//6
	{ "KActionCollection*", 1, Smoke::t_class | Smoke::tf_ptr },	//7
	{ "KAutostart::Conditions", 0, Smoke::t_uint | Smoke::tf_stack },	//8
	{ "KAutostart::Conditions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//9
	{ "KCModule::Buttons", 0, Smoke::t_uint | Smoke::tf_stack },	//10
	{ "KCModule::Buttons&", 0, Smoke::t_voidp | Smoke::tf_ref },	//11
	{ "KCmdLineArgs::StdCmdLineArgs", 0, Smoke::t_uint | Smoke::tf_stack },	//12
	{ "KCmdLineArgs::StdCmdLineArgs&", 0, Smoke::t_voidp | Smoke::tf_ref },	//13
	{ "KComponentData", 2, Smoke::t_class | Smoke::tf_stack },	//14
	{ "KConfig::OpenFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//15
	{ "KConfig::OpenFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//16
	{ "KConfigBase::WriteConfigFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//17
	{ "KConfigBase::WriteConfigFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//18
	{ "KConfigDialog*", 3, Smoke::t_class | Smoke::tf_ptr },	//19
	{ "KCrash::CrashFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//20
	{ "KCrash::CrashFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//21
	{ "KDialog::ButtonCodes", 0, Smoke::t_uint | Smoke::tf_stack },	//22
	{ "KDialog::ButtonCodes&", 0, Smoke::t_voidp | Smoke::tf_ref },	//23
	{ "KDialog::ButtonPopupModes", 0, Smoke::t_uint | Smoke::tf_stack },	//24
	{ "KDialog::ButtonPopupModes&", 0, Smoke::t_voidp | Smoke::tf_ref },	//25
	{ "KDialog::CaptionFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//26
	{ "KDialog::CaptionFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//27
	{ "KDirLister::OpenUrlFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//28
	{ "KDirLister::OpenUrlFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//29
	{ "KDirModel::DropsAllowed", 0, Smoke::t_uint | Smoke::tf_stack },	//30
	{ "KDirModel::DropsAllowed&", 0, Smoke::t_voidp | Smoke::tf_ref },	//31
	{ "KDirWatch::WatchModes", 0, Smoke::t_uint | Smoke::tf_stack },	//32
	{ "KDirWatch::WatchModes&", 0, Smoke::t_voidp | Smoke::tf_ref },	//33
	{ "KEditListBox::Buttons", 0, Smoke::t_uint | Smoke::tf_stack },	//34
	{ "KEditListBox::Buttons&", 0, Smoke::t_voidp | Smoke::tf_ref },	//35
	{ "KFileMetaInfo::WhatFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//36
	{ "KFileMetaInfo::WhatFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//37
	{ "KFontChooser::DisplayFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//38
	{ "KFontChooser::DisplayFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//39
	{ "KFontChooser::FontDiffFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//40
	{ "KFontChooser::FontDiffFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//41
	{ "KGlobalSettings::GraphicEffects", 0, Smoke::t_uint | Smoke::tf_stack },	//42
	{ "KGlobalSettings::GraphicEffects&", 0, Smoke::t_voidp | Smoke::tf_ref },	//43
	{ "KIO::JobFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//44
	{ "KIO::JobFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//45
	{ "KIO::NetRC::LookUpMode", 0, Smoke::t_uint | Smoke::tf_stack },	//46
	{ "KIO::NetRC::LookUpMode&", 0, Smoke::t_voidp | Smoke::tf_ref },	//47
	{ "KIO::TCPSlaveBase::SslResult", 0, Smoke::t_uint | Smoke::tf_stack },	//48
	{ "KIO::TCPSlaveBase::SslResult&", 0, Smoke::t_voidp | Smoke::tf_ref },	//49
	{ "KIcon", 4, Smoke::t_class | Smoke::tf_stack },	//50
	{ "KJob::Capabilities", 0, Smoke::t_uint | Smoke::tf_stack },	//51
	{ "KJob::Capabilities&", 0, Smoke::t_voidp | Smoke::tf_ref },	//52
	{ "KKeySequenceWidget::ShortcutTypes", 0, Smoke::t_uint | Smoke::tf_stack },	//53
	{ "KKeySequenceWidget::ShortcutTypes&", 0, Smoke::t_voidp | Smoke::tf_ref },	//54
	{ "KLocale::DateTimeFormatOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//55
	{ "KLocale::DateTimeFormatOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//56
	{ "KLockFile::LockFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//57
	{ "KLockFile::LockFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//58
	{ "KMessageBox::Options", 0, Smoke::t_uint | Smoke::tf_stack },	//59
	{ "KMessageBox::Options&", 0, Smoke::t_voidp | Smoke::tf_ref },	//60
	{ "KNTLM::AuthFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//61
	{ "KNTLM::AuthFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//62
	{ "KNotification::NotificationFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//63
	{ "KNotification::NotificationFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//64
	{ "KNotificationRestrictions::Services", 0, Smoke::t_uint | Smoke::tf_stack },	//65
	{ "KNotificationRestrictions::Services&", 0, Smoke::t_voidp | Smoke::tf_ref },	//66
	{ "KParts::BrowserExtension::PopupFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//67
	{ "KParts::BrowserExtension::PopupFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//68
	{ "KPasswordDialog::KPasswordDialogFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//69
	{ "KPasswordDialog::KPasswordDialogFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//70
	{ "KPlotObject::PlotTypes", 0, Smoke::t_uint | Smoke::tf_stack },	//71
	{ "KPlotObject::PlotTypes&", 0, Smoke::t_voidp | Smoke::tf_ref },	//72
	{ "KServiceGroup::EntriesOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//73
	{ "KServiceGroup::EntriesOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//74
	{ "KSharedPtr<KMimeType>", 0, Smoke::t_voidp | Smoke::tf_stack },	//75
	{ "KShell::Options", 0, Smoke::t_uint | Smoke::tf_stack },	//76
	{ "KShell::Options&", 0, Smoke::t_voidp | Smoke::tf_ref },	//77
	{ "KShortcutsEditor::ActionTypes", 0, Smoke::t_uint | Smoke::tf_stack },	//78
	{ "KShortcutsEditor::ActionTypes&", 0, Smoke::t_voidp | Smoke::tf_ref },	//79
	{ "KStandardDirs::SearchOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//80
	{ "KStandardDirs::SearchOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//81
	{ "KUniqueApplication::StartFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//82
	{ "KUniqueApplication::StartFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//83
	{ "KUrl", 5, Smoke::t_class | Smoke::tf_stack },	//84
	{ "KUrl&", 5, Smoke::t_class | Smoke::tf_ref },	//85
	{ "KUrl::CleanPathOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//86
	{ "KUrl::CleanPathOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//87
	{ "KUrl::DirectoryOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//88
	{ "KUrl::DirectoryOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//89
	{ "KUrl::EncodedPathAndQueryOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//90
	{ "KUrl::EncodedPathAndQueryOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//91
	{ "KUrl::EqualsOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//92
	{ "KUrl::EqualsOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//93
	{ "KUrl::QueryItemsOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//94
	{ "KUrl::QueryItemsOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//95
	{ "KXMLGUIClient*", 6, Smoke::t_class | Smoke::tf_ptr },	//96
	{ "KXMLGUIClient::ReverseStateChange", 6, Smoke::t_enum | Smoke::tf_stack },	//97
	{ "KXmlGuiWindow::StandardWindowOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//98
	{ "KXmlGuiWindow::StandardWindowOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//99
	{ "Okular::Action*", 8, Smoke::t_class | Smoke::tf_ptr },	//100
	{ "Okular::Action::ActionType", 8, Smoke::t_enum | Smoke::tf_stack },	//101
	{ "Okular::Annotation*", 9, Smoke::t_class | Smoke::tf_ptr },	//102
	{ "Okular::Annotation::Flag", 9, Smoke::t_enum | Smoke::tf_stack },	//103
	{ "Okular::Annotation::LineEffect", 9, Smoke::t_enum | Smoke::tf_stack },	//104
	{ "Okular::Annotation::LineStyle", 9, Smoke::t_enum | Smoke::tf_stack },	//105
	{ "Okular::Annotation::RevisionScope", 9, Smoke::t_enum | Smoke::tf_stack },	//106
	{ "Okular::Annotation::RevisionType", 9, Smoke::t_enum | Smoke::tf_stack },	//107
	{ "Okular::Annotation::Style&", 10, Smoke::t_class | Smoke::tf_ref },	//108
	{ "Okular::Annotation::SubType", 9, Smoke::t_enum | Smoke::tf_stack },	//109
	{ "Okular::Annotation::Window&", 11, Smoke::t_class | Smoke::tf_ref },	//110
	{ "Okular::AnnotationObjectRect*", 12, Smoke::t_class | Smoke::tf_ptr },	//111
	{ "Okular::AnnotationUtils*", 13, Smoke::t_class | Smoke::tf_ptr },	//112
	{ "Okular::BookmarkManager*", 0, Smoke::t_voidp | Smoke::tf_ptr },	//113
	{ "Okular::BrowseAction*", 14, Smoke::t_class | Smoke::tf_ptr },	//114
	{ "Okular::CaretAnnotation*", 15, Smoke::t_class | Smoke::tf_ptr },	//115
	{ "Okular::CaretAnnotation::CaretSymbol", 15, Smoke::t_enum | Smoke::tf_stack },	//116
	{ "Okular::ConfigInterface*", 16, Smoke::t_class | Smoke::tf_ptr },	//117
	{ "Okular::Document*", 17, Smoke::t_class | Smoke::tf_ptr },	//118
	{ "Okular::Document::PixmapRequestFlag", 17, Smoke::t_enum | Smoke::tf_stack },	//119
	{ "Okular::Document::PixmapRequestFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//120
	{ "Okular::Document::PixmapRequestFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//121
	{ "Okular::Document::PrintingType", 17, Smoke::t_enum | Smoke::tf_stack },	//122
	{ "Okular::Document::SearchStatus", 17, Smoke::t_enum | Smoke::tf_stack },	//123
	{ "Okular::Document::SearchType", 17, Smoke::t_enum | Smoke::tf_stack },	//124
	{ "Okular::DocumentAction*", 18, Smoke::t_class | Smoke::tf_ptr },	//125
	{ "Okular::DocumentAction::DocumentActionType", 18, Smoke::t_enum | Smoke::tf_stack },	//126
	{ "Okular::DocumentInfo*", 19, Smoke::t_class | Smoke::tf_ptr },	//127
	{ "Okular::DocumentInfo::Key", 19, Smoke::t_enum | Smoke::tf_stack },	//128
	{ "Okular::DocumentObserver*", 0, Smoke::t_voidp | Smoke::tf_ptr },	//129
	{ "Okular::DocumentSynopsis*", 20, Smoke::t_class | Smoke::tf_ptr },	//130
	{ "Okular::DocumentViewport", 21, Smoke::t_class | Smoke::tf_stack },	//131
	{ "Okular::DocumentViewport*", 21, Smoke::t_class | Smoke::tf_ptr },	//132
	{ "Okular::DocumentViewport::Position", 21, Smoke::t_enum | Smoke::tf_stack },	//133
	{ "Okular::EmbeddedFile*", 22, Smoke::t_class | Smoke::tf_ptr },	//134
	{ "Okular::ExecuteAction*", 23, Smoke::t_class | Smoke::tf_ptr },	//135
	{ "Okular::ExportFormat", 24, Smoke::t_class | Smoke::tf_stack },	//136
	{ "Okular::ExportFormat&", 24, Smoke::t_class | Smoke::tf_ref },	//137
	{ "Okular::ExportFormat*", 24, Smoke::t_class | Smoke::tf_ptr },	//138
	{ "Okular::ExportFormat::StandardExportFormat", 24, Smoke::t_enum | Smoke::tf_stack },	//139
	{ "Okular::FileAttachmentAnnotation*", 25, Smoke::t_class | Smoke::tf_ptr },	//140
	{ "Okular::FilePrinter*", 26, Smoke::t_class | Smoke::tf_ptr },	//141
	{ "Okular::FilePrinter::FileDeletePolicy", 26, Smoke::t_enum | Smoke::tf_stack },	//142
	{ "Okular::FilePrinter::PageSelectPolicy", 26, Smoke::t_enum | Smoke::tf_stack },	//143
	{ "Okular::FontInfo&", 27, Smoke::t_class | Smoke::tf_ref },	//144
	{ "Okular::FontInfo*", 27, Smoke::t_class | Smoke::tf_ptr },	//145
	{ "Okular::FontInfo::EmbedType", 27, Smoke::t_enum | Smoke::tf_stack },	//146
	{ "Okular::FontInfo::FontType", 27, Smoke::t_enum | Smoke::tf_stack },	//147
	{ "Okular::FormField::FieldType", 28, Smoke::t_enum | Smoke::tf_stack },	//148
	{ "Okular::FormFieldButton*", 29, Smoke::t_class | Smoke::tf_ptr },	//149
	{ "Okular::FormFieldButton::ButtonType", 29, Smoke::t_enum | Smoke::tf_stack },	//150
	{ "Okular::FormFieldChoice*", 30, Smoke::t_class | Smoke::tf_ptr },	//151
	{ "Okular::FormFieldChoice::ChoiceType", 30, Smoke::t_enum | Smoke::tf_stack },	//152
	{ "Okular::FormFieldText*", 31, Smoke::t_class | Smoke::tf_ptr },	//153
	{ "Okular::FormFieldText::TextType", 31, Smoke::t_enum | Smoke::tf_stack },	//154
	{ "Okular::Generator*", 32, Smoke::t_class | Smoke::tf_ptr },	//155
	{ "Okular::Generator::GeneratorFeature", 32, Smoke::t_enum | Smoke::tf_stack },	//156
	{ "Okular::Generator::PageSizeMetric", 32, Smoke::t_enum | Smoke::tf_stack },	//157
	{ "Okular::GeomAnnotation*", 33, Smoke::t_class | Smoke::tf_ptr },	//158
	{ "Okular::GeomAnnotation::GeomType", 33, Smoke::t_enum | Smoke::tf_stack },	//159
	{ "Okular::GotoAction*", 34, Smoke::t_class | Smoke::tf_ptr },	//160
	{ "Okular::GuiInterface*", 35, Smoke::t_class | Smoke::tf_ptr },	//161
	{ "Okular::HighlightAnnotation*", 36, Smoke::t_class | Smoke::tf_ptr },	//162
	{ "Okular::HighlightAnnotation::HighlightType", 36, Smoke::t_enum | Smoke::tf_stack },	//163
	{ "Okular::InkAnnotation*", 37, Smoke::t_class | Smoke::tf_ptr },	//164
	{ "Okular::LineAnnotation*", 38, Smoke::t_class | Smoke::tf_ptr },	//165
	{ "Okular::LineAnnotation::LineIntent", 38, Smoke::t_enum | Smoke::tf_stack },	//166
	{ "Okular::LineAnnotation::TermStyle", 38, Smoke::t_enum | Smoke::tf_stack },	//167
	{ "Okular::NormalizedPoint", 39, Smoke::t_class | Smoke::tf_stack },	//168
	{ "Okular::NormalizedPoint&", 39, Smoke::t_class | Smoke::tf_ref },	//169
	{ "Okular::NormalizedPoint*", 39, Smoke::t_class | Smoke::tf_ptr },	//170
	{ "Okular::NormalizedRect", 40, Smoke::t_class | Smoke::tf_stack },	//171
	{ "Okular::NormalizedRect&", 40, Smoke::t_class | Smoke::tf_ref },	//172
	{ "Okular::NormalizedRect*", 40, Smoke::t_class | Smoke::tf_ptr },	//173
	{ "Okular::ObjectRect*", 41, Smoke::t_class | Smoke::tf_ptr },	//174
	{ "Okular::ObjectRect::ObjectType", 41, Smoke::t_enum | Smoke::tf_stack },	//175
	{ "Okular::Page*", 42, Smoke::t_class | Smoke::tf_ptr },	//176
	{ "Okular::Page::PageAction", 42, Smoke::t_enum | Smoke::tf_stack },	//177
	{ "Okular::PageSize&", 43, Smoke::t_class | Smoke::tf_ref },	//178
	{ "Okular::PageSize*", 43, Smoke::t_class | Smoke::tf_ptr },	//179
	{ "Okular::PageTransition&", 44, Smoke::t_class | Smoke::tf_ref },	//180
	{ "Okular::PageTransition*", 44, Smoke::t_class | Smoke::tf_ptr },	//181
	{ "Okular::PageTransition::Alignment", 44, Smoke::t_enum | Smoke::tf_stack },	//182
	{ "Okular::PageTransition::Direction", 44, Smoke::t_enum | Smoke::tf_stack },	//183
	{ "Okular::PageTransition::Type", 44, Smoke::t_enum | Smoke::tf_stack },	//184
	{ "Okular::Permission", 7, Smoke::t_enum | Smoke::tf_stack },	//185
	{ "Okular::Permissions", 0, Smoke::t_uint | Smoke::tf_stack },	//186
	{ "Okular::Permissions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//187
	{ "Okular::PixmapRequest*", 45, Smoke::t_class | Smoke::tf_ptr },	//188
	{ "Okular::PrintInterface*", 46, Smoke::t_class | Smoke::tf_ptr },	//189
	{ "Okular::RegularAreaRect&", 47, Smoke::t_class | Smoke::tf_ref },	//190
	{ "Okular::RegularAreaRect*", 47, Smoke::t_class | Smoke::tf_ptr },	//191
	{ "Okular::Rotation", 7, Smoke::t_enum | Smoke::tf_stack },	//192
	{ "Okular::ScriptAction*", 48, Smoke::t_class | Smoke::tf_ptr },	//193
	{ "Okular::ScriptType", 7, Smoke::t_enum | Smoke::tf_stack },	//194
	{ "Okular::SearchDirection", 7, Smoke::t_enum | Smoke::tf_stack },	//195
	{ "Okular::Sound*", 49, Smoke::t_class | Smoke::tf_ptr },	//196
	{ "Okular::Sound::SoundEncoding", 49, Smoke::t_enum | Smoke::tf_stack },	//197
	{ "Okular::Sound::SoundType", 49, Smoke::t_enum | Smoke::tf_stack },	//198
	{ "Okular::SoundAction*", 50, Smoke::t_class | Smoke::tf_ptr },	//199
	{ "Okular::SoundAnnotation*", 51, Smoke::t_class | Smoke::tf_ptr },	//200
	{ "Okular::SourceRefObjectRect*", 52, Smoke::t_class | Smoke::tf_ptr },	//201
	{ "Okular::SourceReference*", 53, Smoke::t_class | Smoke::tf_ptr },	//202
	{ "Okular::StampAnnotation*", 54, Smoke::t_class | Smoke::tf_ptr },	//203
	{ "Okular::TextAnnotation*", 55, Smoke::t_class | Smoke::tf_ptr },	//204
	{ "Okular::TextAnnotation::InplaceIntent", 55, Smoke::t_enum | Smoke::tf_stack },	//205
	{ "Okular::TextAnnotation::TextType", 55, Smoke::t_enum | Smoke::tf_stack },	//206
	{ "Okular::TextDocumentConverter*", 56, Smoke::t_class | Smoke::tf_ptr },	//207
	{ "Okular::TextDocumentGenerator*", 57, Smoke::t_class | Smoke::tf_ptr },	//208
	{ "Okular::TextEntity*", 58, Smoke::t_class | Smoke::tf_ptr },	//209
	{ "Okular::TextPage*", 59, Smoke::t_class | Smoke::tf_ptr },	//210
	{ "Okular::TextSelection*", 0, Smoke::t_voidp | Smoke::tf_ptr },	//211
	{ "Okular::Utils*", 60, Smoke::t_class | Smoke::tf_ptr },	//212
	{ "Okular::View*", 0, Smoke::t_voidp | Smoke::tf_ptr },	//213
	{ "Okular::VisiblePageRect*", 61, Smoke::t_class | Smoke::tf_ptr },	//214
	{ "PageSize&", 0, Smoke::t_voidp | Smoke::tf_ref },	//215
	{ "QAbstractFileEngine::FileFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//216
	{ "QAbstractFileEngine::FileFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//217
	{ "QAbstractItemView::EditTriggers", 0, Smoke::t_uint | Smoke::tf_stack },	//218
	{ "QAbstractItemView::EditTriggers&", 0, Smoke::t_voidp | Smoke::tf_ref },	//219
	{ "QAbstractPrintDialog::PrintDialogOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//220
	{ "QAbstractPrintDialog::PrintDialogOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//221
	{ "QAbstractSpinBox::StepEnabled", 0, Smoke::t_uint | Smoke::tf_stack },	//222
	{ "QAbstractSpinBox::StepEnabled&", 0, Smoke::t_voidp | Smoke::tf_ref },	//223
	{ "QAccessible::Relation", 0, Smoke::t_uint | Smoke::tf_stack },	//224
	{ "QAccessible::Relation&", 0, Smoke::t_voidp | Smoke::tf_ref },	//225
	{ "QAccessible::State", 0, Smoke::t_uint | Smoke::tf_stack },	//226
	{ "QAccessible::State&", 0, Smoke::t_voidp | Smoke::tf_ref },	//227
	{ "QAction*", 62, Smoke::t_class | Smoke::tf_ptr },	//228
	{ "QAction::ActionEvent", 62, Smoke::t_enum | Smoke::tf_stack },	//229
	{ "QAction::MenuRole", 62, Smoke::t_enum | Smoke::tf_stack },	//230
	{ "QActionEvent*", 63, Smoke::t_class | Smoke::tf_ptr },	//231
	{ "QByteArray", 64, Smoke::t_class | Smoke::tf_stack },	//232
	{ "QByteArray*", 64, Smoke::t_class | Smoke::tf_ptr },	//233
	{ "QChildEvent*", 65, Smoke::t_class | Smoke::tf_ptr },	//234
	{ "QCloseEvent*", 66, Smoke::t_class | Smoke::tf_ptr },	//235
	{ "QColor", 67, Smoke::t_class | Smoke::tf_stack },	//236
	{ "QColor::Spec", 67, Smoke::t_enum | Smoke::tf_stack },	//237
	{ "QColorDialog::ColorDialogOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//238
	{ "QColorDialog::ColorDialogOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//239
	{ "QContextMenuEvent*", 68, Smoke::t_class | Smoke::tf_ptr },	//240
	{ "QDBusConnection::RegisterOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//241
	{ "QDBusConnection::RegisterOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//242
	{ "QDateTime", 69, Smoke::t_class | Smoke::tf_stack },	//243
	{ "QDateTimeEdit::Sections", 0, Smoke::t_uint | Smoke::tf_stack },	//244
	{ "QDateTimeEdit::Sections&", 0, Smoke::t_voidp | Smoke::tf_ref },	//245
	{ "QDialogButtonBox::StandardButtons", 0, Smoke::t_uint | Smoke::tf_stack },	//246
	{ "QDialogButtonBox::StandardButtons&", 0, Smoke::t_voidp | Smoke::tf_ref },	//247
	{ "QDir::Filters", 0, Smoke::t_uint | Smoke::tf_stack },	//248
	{ "QDir::Filters&", 0, Smoke::t_voidp | Smoke::tf_ref },	//249
	{ "QDir::SortFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//250
	{ "QDir::SortFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//251
	{ "QDirIterator::IteratorFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//252
	{ "QDirIterator::IteratorFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//253
	{ "QDockWidget::DockWidgetFeatures", 0, Smoke::t_uint | Smoke::tf_stack },	//254
	{ "QDockWidget::DockWidgetFeatures&", 0, Smoke::t_voidp | Smoke::tf_ref },	//255
	{ "QDomDocument", 70, Smoke::t_class | Smoke::tf_stack },	//256
	{ "QDomDocument&", 70, Smoke::t_class | Smoke::tf_ref },	//257
	{ "QDomElement", 71, Smoke::t_class | Smoke::tf_stack },	//258
	{ "QDomElement&", 71, Smoke::t_class | Smoke::tf_ref },	//259
	{ "QDomNode&", 72, Smoke::t_class | Smoke::tf_ref },	//260
	{ "QDomNode::EncodingPolicy", 72, Smoke::t_enum | Smoke::tf_stack },	//261
	{ "QDomNode::NodeType", 72, Smoke::t_enum | Smoke::tf_stack },	//262
	{ "QDragEnterEvent*", 73, Smoke::t_class | Smoke::tf_ptr },	//263
	{ "QDragLeaveEvent*", 74, Smoke::t_class | Smoke::tf_ptr },	//264
	{ "QDragMoveEvent*", 75, Smoke::t_class | Smoke::tf_ptr },	//265
	{ "QDropEvent*", 76, Smoke::t_class | Smoke::tf_ptr },	//266
	{ "QEvent*", 77, Smoke::t_class | Smoke::tf_ptr },	//267
	{ "QEventLoop::ProcessEventsFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//268
	{ "QEventLoop::ProcessEventsFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//269
	{ "QFile::Permissions", 0, Smoke::t_uint | Smoke::tf_stack },	//270
	{ "QFile::Permissions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//271
	{ "QFileDialog::Options", 0, Smoke::t_uint | Smoke::tf_stack },	//272
	{ "QFileDialog::Options&", 0, Smoke::t_voidp | Smoke::tf_ref },	//273
	{ "QFocusEvent*", 78, Smoke::t_class | Smoke::tf_ptr },	//274
	{ "QFont", 79, Smoke::t_class | Smoke::tf_stack },	//275
	{ "QFont::Capitalization", 79, Smoke::t_enum | Smoke::tf_stack },	//276
	{ "QFont::ResolveProperties", 79, Smoke::t_enum | Smoke::tf_stack },	//277
	{ "QFont::SpacingType", 79, Smoke::t_enum | Smoke::tf_stack },	//278
	{ "QFont::Stretch", 79, Smoke::t_enum | Smoke::tf_stack },	//279
	{ "QFont::Style", 79, Smoke::t_enum | Smoke::tf_stack },	//280
	{ "QFont::StyleHint", 79, Smoke::t_enum | Smoke::tf_stack },	//281
	{ "QFont::StyleStrategy", 79, Smoke::t_enum | Smoke::tf_stack },	//282
	{ "QFont::Weight", 79, Smoke::t_enum | Smoke::tf_stack },	//283
	{ "QFontComboBox::FontFilters", 0, Smoke::t_uint | Smoke::tf_stack },	//284
	{ "QFontComboBox::FontFilters&", 0, Smoke::t_voidp | Smoke::tf_ref },	//285
	{ "QFontDialog::FontDialogOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//286
	{ "QFontDialog::FontDialogOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//287
	{ "QGL::FormatOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//288
	{ "QGL::FormatOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//289
	{ "QGLFormat::OpenGLVersionFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//290
	{ "QGLFormat::OpenGLVersionFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//291
	{ "QGraphicsItem::GraphicsItemFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//292
	{ "QGraphicsItem::GraphicsItemFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//293
	{ "QGraphicsScene::SceneLayers", 0, Smoke::t_uint | Smoke::tf_stack },	//294
	{ "QGraphicsScene::SceneLayers&", 0, Smoke::t_voidp | Smoke::tf_ref },	//295
	{ "QGraphicsView::CacheMode", 0, Smoke::t_uint | Smoke::tf_stack },	//296
	{ "QGraphicsView::CacheMode&", 0, Smoke::t_voidp | Smoke::tf_ref },	//297
	{ "QGraphicsView::OptimizationFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//298
	{ "QGraphicsView::OptimizationFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//299
	{ "QHideEvent*", 80, Smoke::t_class | Smoke::tf_ptr },	//300
	{ "QIODevice::OpenMode", 0, Smoke::t_uint | Smoke::tf_stack },	//301
	{ "QIODevice::OpenMode&", 0, Smoke::t_voidp | Smoke::tf_ref },	//302
	{ "QImage", 81, Smoke::t_class | Smoke::tf_stack },	//303
	{ "QImage::Format", 81, Smoke::t_enum | Smoke::tf_stack },	//304
	{ "QImage::InvertMode", 81, Smoke::t_enum | Smoke::tf_stack },	//305
	{ "QInputDialog::InputDialogOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//306
	{ "QInputDialog::InputDialogOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//307
	{ "QInputMethodEvent*", 82, Smoke::t_class | Smoke::tf_ptr },	//308
	{ "QItemSelectionModel::SelectionFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//309
	{ "QItemSelectionModel::SelectionFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//310
	{ "QKeyEvent*", 83, Smoke::t_class | Smoke::tf_ptr },	//311
	{ "QLibrary::LoadHints", 0, Smoke::t_uint | Smoke::tf_stack },	//312
	{ "QLibrary::LoadHints&", 0, Smoke::t_voidp | Smoke::tf_ref },	//313
	{ "QLinkedList<Okular::Annotation*>", 0, Smoke::t_voidp | Smoke::tf_stack },	//314
	{ "QLinkedList<Okular::Annotation::Revision>&", 0, Smoke::t_voidp | Smoke::tf_ref },	//315
	{ "QLinkedList<Okular::FormField*>", 0, Smoke::t_voidp | Smoke::tf_stack },	//316
	{ "QLinkedList<Okular::NormalizedPoint>", 0, Smoke::t_voidp | Smoke::tf_stack },	//317
	{ "QList<Okular::ExportFormat>", 0, Smoke::t_voidp | Smoke::tf_stack },	//318
	{ "QList<Okular::FontInfo>", 0, Smoke::t_voidp | Smoke::tf_stack },	//319
	{ "QList<Okular::HighlightAnnotation::Quad>&", 0, Smoke::t_voidp | Smoke::tf_ref },	//320
	{ "QList<Okular::PageSize>", 0, Smoke::t_voidp | Smoke::tf_stack },	//321
	{ "QList<QLinkedList<Okular::NormalizedPoint> >", 0, Smoke::t_voidp | Smoke::tf_stack },	//322
	{ "QList<int>", 0, Smoke::t_voidp | Smoke::tf_stack },	//323
	{ "QLocale::NumberOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//324
	{ "QLocale::NumberOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//325
	{ "QMainWindow::DockOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//326
	{ "QMainWindow::DockOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//327
	{ "QMdiArea::AreaOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//328
	{ "QMdiArea::AreaOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//329
	{ "QMdiSubWindow::SubWindowOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//330
	{ "QMdiSubWindow::SubWindowOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//331
	{ "QMessageBox::StandardButtons", 0, Smoke::t_uint | Smoke::tf_stack },	//332
	{ "QMessageBox::StandardButtons&", 0, Smoke::t_voidp | Smoke::tf_ref },	//333
	{ "QMetaObject::Call", 87, Smoke::t_enum | Smoke::tf_stack },	//334
	{ "QMouseEvent*", 88, Smoke::t_class | Smoke::tf_ptr },	//335
	{ "QMoveEvent*", 89, Smoke::t_class | Smoke::tf_ptr },	//336
	{ "QMutex*", 0, Smoke::t_voidp | Smoke::tf_ptr },	//337
	{ "QNetworkInterface::InterfaceFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//338
	{ "QNetworkInterface::InterfaceFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//339
	{ "QNetworkProxy::Capabilities", 0, Smoke::t_uint | Smoke::tf_stack },	//340
	{ "QNetworkProxy::Capabilities&", 0, Smoke::t_voidp | Smoke::tf_ref },	//341
	{ "QObject*", 90, Smoke::t_class | Smoke::tf_ptr },	//342
	{ "QPageSetupDialog::PageSetupDialogOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//343
	{ "QPageSetupDialog::PageSetupDialogOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//344
	{ "QPaintDevice*", 91, Smoke::t_class | Smoke::tf_ptr },	//345
	{ "QPaintDevice::PaintDeviceMetric", 91, Smoke::t_enum | Smoke::tf_stack },	//346
	{ "QPaintEngine*", 92, Smoke::t_class | Smoke::tf_ptr },	//347
	{ "QPaintEngine::DirtyFlag", 92, Smoke::t_enum | Smoke::tf_stack },	//348
	{ "QPaintEngine::DirtyFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//349
	{ "QPaintEngine::DirtyFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//350
	{ "QPaintEngine::PaintEngineFeature", 92, Smoke::t_enum | Smoke::tf_stack },	//351
	{ "QPaintEngine::PaintEngineFeatures", 0, Smoke::t_uint | Smoke::tf_stack },	//352
	{ "QPaintEngine::PaintEngineFeatures&", 0, Smoke::t_voidp | Smoke::tf_ref },	//353
	{ "QPaintEngine::PolygonDrawMode", 92, Smoke::t_enum | Smoke::tf_stack },	//354
	{ "QPaintEngine::Type", 92, Smoke::t_enum | Smoke::tf_stack },	//355
	{ "QPaintEvent*", 94, Smoke::t_class | Smoke::tf_ptr },	//356
	{ "QPainter::RenderHints", 0, Smoke::t_uint | Smoke::tf_stack },	//357
	{ "QPainter::RenderHints&", 0, Smoke::t_voidp | Smoke::tf_ref },	//358
	{ "QPainterPath::ElementType", 95, Smoke::t_enum | Smoke::tf_stack },	//359
	{ "QPixmap*", 97, Smoke::t_class | Smoke::tf_ptr },	//360
	{ "QPixmap::Type", 97, Smoke::t_enum | Smoke::tf_stack },	//361
	{ "QPoint", 98, Smoke::t_class | Smoke::tf_stack },	//362
	{ "QPrinter&", 101, Smoke::t_class | Smoke::tf_ref },	//363
	{ "QPrinter::ColorMode", 101, Smoke::t_enum | Smoke::tf_stack },	//364
	{ "QPrinter::DuplexMode", 101, Smoke::t_enum | Smoke::tf_stack },	//365
	{ "QPrinter::Orientation", 101, Smoke::t_enum | Smoke::tf_stack },	//366
	{ "QPrinter::OutputFormat", 101, Smoke::t_enum | Smoke::tf_stack },	//367
	{ "QPrinter::PageOrder", 101, Smoke::t_enum | Smoke::tf_stack },	//368
	{ "QPrinter::PageSize", 101, Smoke::t_enum | Smoke::tf_stack },	//369
	{ "QPrinter::PaperSource", 101, Smoke::t_enum | Smoke::tf_stack },	//370
	{ "QPrinter::PrintRange", 101, Smoke::t_enum | Smoke::tf_stack },	//371
	{ "QPrinter::PrinterMode", 101, Smoke::t_enum | Smoke::tf_stack },	//372
	{ "QPrinter::PrinterState", 101, Smoke::t_enum | Smoke::tf_stack },	//373
	{ "QPrinter::Unit", 101, Smoke::t_enum | Smoke::tf_stack },	//374
	{ "QRect", 102, Smoke::t_class | Smoke::tf_stack },	//375
	{ "QResizeEvent*", 104, Smoke::t_class | Smoke::tf_ptr },	//376
	{ "QShowEvent*", 105, Smoke::t_class | Smoke::tf_ptr },	//377
	{ "QSize", 106, Smoke::t_class | Smoke::tf_stack },	//378
	{ "QSizeF", 107, Smoke::t_class | Smoke::tf_stack },	//379
	{ "QSizePolicy::ControlTypes", 0, Smoke::t_uint | Smoke::tf_stack },	//380
	{ "QSizePolicy::ControlTypes&", 0, Smoke::t_voidp | Smoke::tf_ref },	//381
	{ "QSql::ParamType", 0, Smoke::t_uint | Smoke::tf_stack },	//382
	{ "QSql::ParamType&", 0, Smoke::t_voidp | Smoke::tf_ref },	//383
	{ "QString", 0, Smoke::t_voidp | Smoke::tf_stack },	//384
	{ "QString&", 0, Smoke::t_voidp | Smoke::tf_ref },	//385
	{ "QString::SectionFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//386
	{ "QString::SectionFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//387
	{ "QStringList", 0, Smoke::t_voidp | Smoke::tf_stack },	//388
	{ "QStyle&", 108, Smoke::t_class | Smoke::tf_ref },	//389
	{ "QStyle::State", 0, Smoke::t_uint | Smoke::tf_stack },	//390
	{ "QStyle::State&", 0, Smoke::t_voidp | Smoke::tf_ref },	//391
	{ "QStyle::SubControls", 0, Smoke::t_uint | Smoke::tf_stack },	//392
	{ "QStyle::SubControls&", 0, Smoke::t_voidp | Smoke::tf_ref },	//393
	{ "QStyleOptionButton::ButtonFeatures", 0, Smoke::t_uint | Smoke::tf_stack },	//394
	{ "QStyleOptionButton::ButtonFeatures&", 0, Smoke::t_voidp | Smoke::tf_ref },	//395
	{ "QStyleOptionFrameV2::FrameFeatures", 0, Smoke::t_uint | Smoke::tf_stack },	//396
	{ "QStyleOptionFrameV2::FrameFeatures&", 0, Smoke::t_voidp | Smoke::tf_ref },	//397
	{ "QStyleOptionQ3ListViewItem::Q3ListViewItemFeatures", 0, Smoke::t_uint | Smoke::tf_stack },	//398
	{ "QStyleOptionQ3ListViewItem::Q3ListViewItemFeatures&", 0, Smoke::t_voidp | Smoke::tf_ref },	//399
	{ "QStyleOptionTab::CornerWidgets", 0, Smoke::t_uint | Smoke::tf_stack },	//400
	{ "QStyleOptionTab::CornerWidgets&", 0, Smoke::t_voidp | Smoke::tf_ref },	//401
	{ "QStyleOptionToolBar::ToolBarFeatures", 0, Smoke::t_uint | Smoke::tf_stack },	//402
	{ "QStyleOptionToolBar::ToolBarFeatures&", 0, Smoke::t_voidp | Smoke::tf_ref },	//403
	{ "QStyleOptionToolButton::ToolButtonFeatures", 0, Smoke::t_uint | Smoke::tf_stack },	//404
	{ "QStyleOptionToolButton::ToolButtonFeatures&", 0, Smoke::t_voidp | Smoke::tf_ref },	//405
	{ "QStyleOptionViewItemV2::ViewItemFeatures", 0, Smoke::t_uint | Smoke::tf_stack },	//406
	{ "QStyleOptionViewItemV2::ViewItemFeatures&", 0, Smoke::t_voidp | Smoke::tf_ref },	//407
	{ "QTabletEvent*", 109, Smoke::t_class | Smoke::tf_ptr },	//408
	{ "QTextBlock&", 110, Smoke::t_class | Smoke::tf_ref },	//409
	{ "QTextBoundaryFinder::BoundaryReasons", 0, Smoke::t_uint | Smoke::tf_stack },	//410
	{ "QTextBoundaryFinder::BoundaryReasons&", 0, Smoke::t_voidp | Smoke::tf_ref },	//411
	{ "QTextCodec::ConversionFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//412
	{ "QTextCodec::ConversionFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//413
	{ "QTextDocument*", 111, Smoke::t_class | Smoke::tf_ptr },	//414
	{ "QTextDocument::FindFlag", 111, Smoke::t_enum | Smoke::tf_stack },	//415
	{ "QTextDocument::FindFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//416
	{ "QTextDocument::FindFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//417
	{ "QTextDocument::MetaInformation", 111, Smoke::t_enum | Smoke::tf_stack },	//418
	{ "QTextDocument::ResourceType", 111, Smoke::t_enum | Smoke::tf_stack },	//419
	{ "QTextEdit::AutoFormatting", 0, Smoke::t_uint | Smoke::tf_stack },	//420
	{ "QTextEdit::AutoFormatting&", 0, Smoke::t_voidp | Smoke::tf_ref },	//421
	{ "QTextFormat::FormatType", 112, Smoke::t_enum | Smoke::tf_stack },	//422
	{ "QTextFormat::ObjectTypes", 112, Smoke::t_enum | Smoke::tf_stack },	//423
	{ "QTextFormat::PageBreakFlag", 112, Smoke::t_enum | Smoke::tf_stack },	//424
	{ "QTextFormat::PageBreakFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//425
	{ "QTextFormat::PageBreakFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//426
	{ "QTextFormat::Property", 112, Smoke::t_enum | Smoke::tf_stack },	//427
	{ "QTextItem::RenderFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//428
	{ "QTextItem::RenderFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//429
	{ "QTextObject*", 113, Smoke::t_class | Smoke::tf_ptr },	//430
	{ "QTextOption::Flags", 0, Smoke::t_uint | Smoke::tf_stack },	//431
	{ "QTextOption::Flags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//432
	{ "QTextStream::NumberFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//433
	{ "QTextStream::NumberFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//434
	{ "QTimerEvent*", 114, Smoke::t_class | Smoke::tf_ptr },	//435
	{ "QTreeWidgetItemIterator::IteratorFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//436
	{ "QTreeWidgetItemIterator::IteratorFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//437
	{ "QUdpSocket::BindMode", 0, Smoke::t_uint | Smoke::tf_stack },	//438
	{ "QUdpSocket::BindMode&", 0, Smoke::t_voidp | Smoke::tf_ref },	//439
	{ "QUrl::FormattingOption", 115, Smoke::t_enum | Smoke::tf_stack },	//440
	{ "QUrl::FormattingOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//441
	{ "QUrl::FormattingOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//442
	{ "QUrl::ParsingMode", 115, Smoke::t_enum | Smoke::tf_stack },	//443
	{ "QVariant", 116, Smoke::t_class | Smoke::tf_stack },	//444
	{ "QVariant::Type", 116, Smoke::t_enum | Smoke::tf_stack },	//445
	{ "QVector<Okular::Page*>&", 0, Smoke::t_voidp | Smoke::tf_ref },	//446
	{ "QWebPage::FindFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//447
	{ "QWebPage::FindFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//448
	{ "QWheelEvent*", 117, Smoke::t_class | Smoke::tf_ptr },	//449
	{ "QWidget*", 118, Smoke::t_class | Smoke::tf_ptr },	//450
	{ "QWidget::RenderFlag", 118, Smoke::t_enum | Smoke::tf_stack },	//451
	{ "QWidget::RenderFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//452
	{ "QWidget::RenderFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//453
	{ "QWizard::WizardOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//454
	{ "QWizard::WizardOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//455
	{ "Qt::Alignment", 0, Smoke::t_uint | Smoke::tf_stack },	//456
	{ "Qt::Alignment&", 0, Smoke::t_voidp | Smoke::tf_ref },	//457
	{ "Qt::AlignmentFlag", 119, Smoke::t_enum | Smoke::tf_stack },	//458
	{ "Qt::AnchorAttribute", 119, Smoke::t_enum | Smoke::tf_stack },	//459
	{ "Qt::ApplicationAttribute", 119, Smoke::t_enum | Smoke::tf_stack },	//460
	{ "Qt::ArrowType", 119, Smoke::t_enum | Smoke::tf_stack },	//461
	{ "Qt::AspectRatioMode", 119, Smoke::t_enum | Smoke::tf_stack },	//462
	{ "Qt::Axis", 119, Smoke::t_enum | Smoke::tf_stack },	//463
	{ "Qt::BGMode", 119, Smoke::t_enum | Smoke::tf_stack },	//464
	{ "Qt::BrushStyle", 119, Smoke::t_enum | Smoke::tf_stack },	//465
	{ "Qt::CaseSensitivity", 119, Smoke::t_enum | Smoke::tf_stack },	//466
	{ "Qt::CheckState", 119, Smoke::t_enum | Smoke::tf_stack },	//467
	{ "Qt::ClipOperation", 119, Smoke::t_enum | Smoke::tf_stack },	//468
	{ "Qt::ConnectionType", 119, Smoke::t_enum | Smoke::tf_stack },	//469
	{ "Qt::ContextMenuPolicy", 119, Smoke::t_enum | Smoke::tf_stack },	//470
	{ "Qt::Corner", 119, Smoke::t_enum | Smoke::tf_stack },	//471
	{ "Qt::CursorShape", 119, Smoke::t_enum | Smoke::tf_stack },	//472
	{ "Qt::DateFormat", 119, Smoke::t_enum | Smoke::tf_stack },	//473
	{ "Qt::DayOfWeek", 119, Smoke::t_enum | Smoke::tf_stack },	//474
	{ "Qt::DockWidgetArea", 119, Smoke::t_enum | Smoke::tf_stack },	//475
	{ "Qt::DockWidgetAreaSizes", 119, Smoke::t_enum | Smoke::tf_stack },	//476
	{ "Qt::DockWidgetAreas", 0, Smoke::t_uint | Smoke::tf_stack },	//477
	{ "Qt::DockWidgetAreas&", 0, Smoke::t_voidp | Smoke::tf_ref },	//478
	{ "Qt::DropAction", 119, Smoke::t_enum | Smoke::tf_stack },	//479
	{ "Qt::DropActions", 0, Smoke::t_uint | Smoke::tf_stack },	//480
	{ "Qt::DropActions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//481
	{ "Qt::EventPriority", 119, Smoke::t_enum | Smoke::tf_stack },	//482
	{ "Qt::FillRule", 119, Smoke::t_enum | Smoke::tf_stack },	//483
	{ "Qt::FocusPolicy", 119, Smoke::t_enum | Smoke::tf_stack },	//484
	{ "Qt::FocusReason", 119, Smoke::t_enum | Smoke::tf_stack },	//485
	{ "Qt::GlobalColor", 119, Smoke::t_enum | Smoke::tf_stack },	//486
	{ "Qt::HitTestAccuracy", 119, Smoke::t_enum | Smoke::tf_stack },	//487
	{ "Qt::ImageConversionFlag", 119, Smoke::t_enum | Smoke::tf_stack },	//488
	{ "Qt::ImageConversionFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//489
	{ "Qt::ImageConversionFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//490
	{ "Qt::InputMethodQuery", 119, Smoke::t_enum | Smoke::tf_stack },	//491
	{ "Qt::ItemDataRole", 119, Smoke::t_enum | Smoke::tf_stack },	//492
	{ "Qt::ItemFlag", 119, Smoke::t_enum | Smoke::tf_stack },	//493
	{ "Qt::ItemFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//494
	{ "Qt::ItemFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//495
	{ "Qt::ItemSelectionMode", 119, Smoke::t_enum | Smoke::tf_stack },	//496
	{ "Qt::Key", 119, Smoke::t_enum | Smoke::tf_stack },	//497
	{ "Qt::KeyboardModifier", 119, Smoke::t_enum | Smoke::tf_stack },	//498
	{ "Qt::KeyboardModifiers", 0, Smoke::t_uint | Smoke::tf_stack },	//499
	{ "Qt::KeyboardModifiers&", 0, Smoke::t_voidp | Smoke::tf_ref },	//500
	{ "Qt::LayoutDirection", 119, Smoke::t_enum | Smoke::tf_stack },	//501
	{ "Qt::MaskMode", 119, Smoke::t_enum | Smoke::tf_stack },	//502
	{ "Qt::MatchFlag", 119, Smoke::t_enum | Smoke::tf_stack },	//503
	{ "Qt::MatchFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//504
	{ "Qt::MatchFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//505
	{ "Qt::Modifier", 119, Smoke::t_enum | Smoke::tf_stack },	//506
	{ "Qt::MouseButton", 119, Smoke::t_enum | Smoke::tf_stack },	//507
	{ "Qt::MouseButtons", 0, Smoke::t_uint | Smoke::tf_stack },	//508
	{ "Qt::MouseButtons&", 0, Smoke::t_voidp | Smoke::tf_ref },	//509
	{ "Qt::Orientation", 119, Smoke::t_enum | Smoke::tf_stack },	//510
	{ "Qt::Orientations", 0, Smoke::t_uint | Smoke::tf_stack },	//511
	{ "Qt::Orientations&", 0, Smoke::t_voidp | Smoke::tf_ref },	//512
	{ "Qt::PenCapStyle", 119, Smoke::t_enum | Smoke::tf_stack },	//513
	{ "Qt::PenJoinStyle", 119, Smoke::t_enum | Smoke::tf_stack },	//514
	{ "Qt::PenStyle", 119, Smoke::t_enum | Smoke::tf_stack },	//515
	{ "Qt::ScrollBarPolicy", 119, Smoke::t_enum | Smoke::tf_stack },	//516
	{ "Qt::ShortcutContext", 119, Smoke::t_enum | Smoke::tf_stack },	//517
	{ "Qt::SizeHint", 119, Smoke::t_enum | Smoke::tf_stack },	//518
	{ "Qt::SizeMode", 119, Smoke::t_enum | Smoke::tf_stack },	//519
	{ "Qt::SortOrder", 119, Smoke::t_enum | Smoke::tf_stack },	//520
	{ "Qt::TextElideMode", 119, Smoke::t_enum | Smoke::tf_stack },	//521
	{ "Qt::TextFlag", 119, Smoke::t_enum | Smoke::tf_stack },	//522
	{ "Qt::TextFormat", 119, Smoke::t_enum | Smoke::tf_stack },	//523
	{ "Qt::TextInteractionFlag", 119, Smoke::t_enum | Smoke::tf_stack },	//524
	{ "Qt::TextInteractionFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//525
	{ "Qt::TextInteractionFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//526
	{ "Qt::TimeSpec", 119, Smoke::t_enum | Smoke::tf_stack },	//527
	{ "Qt::ToolBarArea", 119, Smoke::t_enum | Smoke::tf_stack },	//528
	{ "Qt::ToolBarAreaSizes", 119, Smoke::t_enum | Smoke::tf_stack },	//529
	{ "Qt::ToolBarAreas", 0, Smoke::t_uint | Smoke::tf_stack },	//530
	{ "Qt::ToolBarAreas&", 0, Smoke::t_voidp | Smoke::tf_ref },	//531
	{ "Qt::ToolButtonStyle", 119, Smoke::t_enum | Smoke::tf_stack },	//532
	{ "Qt::TransformationMode", 119, Smoke::t_enum | Smoke::tf_stack },	//533
	{ "Qt::UIEffect", 119, Smoke::t_enum | Smoke::tf_stack },	//534
	{ "Qt::WhiteSpaceMode", 119, Smoke::t_enum | Smoke::tf_stack },	//535
	{ "Qt::WidgetAttribute", 119, Smoke::t_enum | Smoke::tf_stack },	//536
	{ "Qt::WindowFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//537
	{ "Qt::WindowFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//538
	{ "Qt::WindowFrameSection", 119, Smoke::t_enum | Smoke::tf_stack },	//539
	{ "Qt::WindowModality", 119, Smoke::t_enum | Smoke::tf_stack },	//540
	{ "Qt::WindowState", 119, Smoke::t_enum | Smoke::tf_stack },	//541
	{ "Qt::WindowStates", 0, Smoke::t_uint | Smoke::tf_stack },	//542
	{ "Qt::WindowStates&", 0, Smoke::t_voidp | Smoke::tf_ref },	//543
	{ "Qt::WindowType", 119, Smoke::t_enum | Smoke::tf_stack },	//544
	{ "bool", 0, Smoke::t_bool | Smoke::tf_stack },	//545
	{ "const KComponentData&", 2, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//546
	{ "const KComponentData*", 2, Smoke::t_class | Smoke::tf_ptr | Smoke::tf_const },	//547
	{ "const KIcon&", 4, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//548
	{ "const KSharedPtr<KMimeType>&", 0, Smoke::t_voidp | Smoke::tf_ref | Smoke::tf_const },	//549
	{ "const KUrl&", 5, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//550
	{ "const Okular::Action*", 8, Smoke::t_class | Smoke::tf_ptr | Smoke::tf_const },	//551
	{ "const Okular::Annotation*", 9, Smoke::t_class | Smoke::tf_ptr | Smoke::tf_const },	//552
	{ "const Okular::Annotation::Style&", 10, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//553
	{ "const Okular::Annotation::Window&", 11, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//554
	{ "const Okular::AnnotationObjectRect&", 12, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//555
	{ "const Okular::AnnotationUtils&", 13, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//556
	{ "const Okular::ConfigInterface&", 16, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//557
	{ "const Okular::Document*", 17, Smoke::t_class | Smoke::tf_ptr | Smoke::tf_const },	//558
	{ "const Okular::DocumentInfo&", 19, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//559
	{ "const Okular::DocumentInfo*", 19, Smoke::t_class | Smoke::tf_ptr | Smoke::tf_const },	//560
	{ "const Okular::DocumentSynopsis&", 20, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//561
	{ "const Okular::DocumentSynopsis*", 20, Smoke::t_class | Smoke::tf_ptr | Smoke::tf_const },	//562
	{ "const Okular::DocumentViewport&", 21, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//563
	{ "const Okular::EmbeddedFile&", 22, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//564
	{ "const Okular::ExportFormat&", 24, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//565
	{ "const Okular::FilePrinter&", 26, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//566
	{ "const Okular::FontInfo&", 27, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//567
	{ "const Okular::GuiInterface&", 35, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//568
	{ "const Okular::NormalizedPoint&", 39, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//569
	{ "const Okular::NormalizedRect&", 40, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//570
	{ "const Okular::NormalizedRect*", 40, Smoke::t_class | Smoke::tf_ptr | Smoke::tf_const },	//571
	{ "const Okular::ObjectRect&", 41, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//572
	{ "const Okular::ObjectRect*", 41, Smoke::t_class | Smoke::tf_ptr | Smoke::tf_const },	//573
	{ "const Okular::Page*", 42, Smoke::t_class | Smoke::tf_ptr | Smoke::tf_const },	//574
	{ "const Okular::PageSize&", 43, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//575
	{ "const Okular::PageTransition&", 44, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//576
	{ "const Okular::PageTransition*", 44, Smoke::t_class | Smoke::tf_ptr | Smoke::tf_const },	//577
	{ "const Okular::PrintInterface&", 46, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//578
	{ "const Okular::RegularAreaRect&", 47, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//579
	{ "const Okular::RegularAreaRect*", 47, Smoke::t_class | Smoke::tf_ptr | Smoke::tf_const },	//580
	{ "const Okular::SourceRefObjectRect&", 52, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//581
	{ "const Okular::SourceReference*", 53, Smoke::t_class | Smoke::tf_ptr | Smoke::tf_const },	//582
	{ "const Okular::Utils&", 60, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//583
	{ "const Okular::VisiblePageRect&", 61, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//584
	{ "const QByteArray&", 64, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//585
	{ "const QColor&", 67, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//586
	{ "const QDateTime&", 69, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//587
	{ "const QDomDocument&", 70, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//588
	{ "const QDomElement&", 71, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//589
	{ "const QDomNode&", 72, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//590
	{ "const QFont&", 79, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//591
	{ "const QImage&", 81, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//592
	{ "const QImage*", 81, Smoke::t_class | Smoke::tf_ptr | Smoke::tf_const },	//593
	{ "const QLine*", 84, Smoke::t_class | Smoke::tf_ptr | Smoke::tf_const },	//594
	{ "const QLineF*", 85, Smoke::t_class | Smoke::tf_ptr | Smoke::tf_const },	//595
	{ "const QLinkedList<Okular::Annotation::Revision>&", 0, Smoke::t_voidp | Smoke::tf_ref | Smoke::tf_const },	//596
	{ "const QLinkedList<Okular::FormField*>&", 0, Smoke::t_voidp | Smoke::tf_ref | Smoke::tf_const },	//597
	{ "const QLinkedList<Okular::NormalizedPoint>&", 0, Smoke::t_voidp | Smoke::tf_ref | Smoke::tf_const },	//598
	{ "const QLinkedList<Okular::ObjectRect*>&", 0, Smoke::t_voidp | Smoke::tf_ref | Smoke::tf_const },	//599
	{ "const QLinkedList<Okular::PixmapRequest*>&", 0, Smoke::t_voidp | Smoke::tf_ref | Smoke::tf_const },	//600
	{ "const QLinkedList<Okular::SourceRefObjectRect*>&", 0, Smoke::t_voidp | Smoke::tf_ref | Smoke::tf_const },	//601
	{ "const QList<Okular::Annotation*>&", 0, Smoke::t_voidp | Smoke::tf_ref | Smoke::tf_const },	//602
	{ "const QList<Okular::EmbeddedFile*>*", 0, Smoke::t_voidp | Smoke::tf_ptr | Smoke::tf_const },	//603
	{ "const QList<Okular::TextEntity*>&", 0, Smoke::t_voidp | Smoke::tf_ref | Smoke::tf_const },	//604
	{ "const QList<QLinkedList<Okular::NormalizedPoint> >&", 0, Smoke::t_voidp | Smoke::tf_ref | Smoke::tf_const },	//605
	{ "const QList<QVariant>&", 0, Smoke::t_voidp | Smoke::tf_ref | Smoke::tf_const },	//606
	{ "const QList<int>&", 0, Smoke::t_voidp | Smoke::tf_ref | Smoke::tf_const },	//607
	{ "const QMatrix&", 86, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//608
	{ "const QMetaObject", 87, Smoke::t_class | Smoke::tf_stack | Smoke::tf_const },	//609
	{ "const QMetaObject*", 87, Smoke::t_class | Smoke::tf_ptr | Smoke::tf_const },	//610
	{ "const QPaintEngineState&", 93, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//611
	{ "const QPainterPath&", 95, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//612
	{ "const QPalette&", 96, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//613
	{ "const QPixmap&", 97, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//614
	{ "const QPoint*", 98, Smoke::t_class | Smoke::tf_ptr | Smoke::tf_const },	//615
	{ "const QPointF&", 99, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//616
	{ "const QPointF*", 99, Smoke::t_class | Smoke::tf_ptr | Smoke::tf_const },	//617
	{ "const QPolygonF&", 100, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//618
	{ "const QRect&", 102, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//619
	{ "const QRect*", 102, Smoke::t_class | Smoke::tf_ptr | Smoke::tf_const },	//620
	{ "const QRectF&", 103, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//621
	{ "const QRectF*", 103, Smoke::t_class | Smoke::tf_ptr | Smoke::tf_const },	//622
	{ "const QString", 0, Smoke::t_voidp | Smoke::tf_stack | Smoke::tf_const },	//623
	{ "const QString&", 0, Smoke::t_voidp | Smoke::tf_ref | Smoke::tf_const },	//624
	{ "const QStringList", 0, Smoke::t_voidp | Smoke::tf_stack | Smoke::tf_const },	//625
	{ "const QStringList&", 0, Smoke::t_voidp | Smoke::tf_ref | Smoke::tf_const },	//626
	{ "const QTextBlock&", 110, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//627
	{ "const QTextFormat&", 112, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//628
	{ "const QUrl&", 115, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//629
	{ "const QVariant&", 116, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//630
	{ "const QVariant::Handler*", 0, Smoke::t_voidp | Smoke::tf_ptr | Smoke::tf_const },	//631
	{ "const QVector<Okular::VisiblePageRect*>&", 0, Smoke::t_voidp | Smoke::tf_ref | Smoke::tf_const },	//632
	{ "const char*", 0, Smoke::t_voidp | Smoke::tf_ptr | Smoke::tf_const },	//633
	{ "const void*", 0, Smoke::t_voidp | Smoke::tf_ptr | Smoke::tf_const },	//634
	{ "double", 0, Smoke::t_double | Smoke::tf_stack },	//635
	{ "double*", 0, Smoke::t_voidp | Smoke::tf_ptr },	//636
	{ "int", 0, Smoke::t_int | Smoke::tf_stack },	//637
	{ "uint", 0, Smoke::t_uint | Smoke::tf_stack },	//638
	{ "void*", 0, Smoke::t_voidp | Smoke::tf_stack },	//639
	{ "void**", 0, Smoke::t_voidp | Smoke::tf_ptr },	//640
};

static Smoke::Index okular_argumentList[] = {
	0,	//0  (void)
	100, 0,	//1  Okular::Action*  
	100, 637, 637, 0,	//3  Okular::Action*, int, int  
	102, 0,	//7  Okular::Annotation*  
	102, 637, 637, 0,	//9  Okular::Annotation*, int, int  
	116, 0,	//13  Okular::CaretAnnotation::CaretSymbol  
	126, 0,	//15  Okular::DocumentAction::DocumentActionType  
	128, 624, 0,	//17  Okular::DocumentInfo::Key, const QString&  
	129, 0,	//20  Okular::DocumentObserver*  
	134, 0,	//22  Okular::EmbeddedFile*  
	139, 0,	//24  Okular::ExportFormat::StandardExportFormat  
	146, 0,	//26  Okular::FontInfo::EmbedType  
	147, 0,	//28  Okular::FontInfo::FontType  
	156, 0,	//30  Okular::Generator::GeneratorFeature  
	156, 545, 0,	//32  Okular::Generator::GeneratorFeature, bool  
	159, 0,	//35  Okular::GeomAnnotation::GeomType  
	163, 0,	//37  Okular::HighlightAnnotation::HighlightType  
	166, 0,	//39  Okular::LineAnnotation::LineIntent  
	167, 0,	//41  Okular::LineAnnotation::TermStyle  
	171, 0,	//43  Okular::NormalizedRect  
	175, 635, 635, 635, 635, 0,	//45  Okular::ObjectRect::ObjectType, double, double, double, double  
	175, 635, 635, 635, 635, 636, 0,	//51  Okular::ObjectRect::ObjectType, double, double, double, double, double*  
	176, 0,	//58  Okular::Page*  
	176, 210, 0,	//60  Okular::Page*, Okular::TextPage*  
	177, 0,	//63  Okular::Page::PageAction  
	177, 100, 0,	//65  Okular::Page::PageAction, Okular::Action*  
	181, 0,	//68  Okular::PageTransition*  
	182, 0,	//70  Okular::PageTransition::Alignment  
	183, 0,	//72  Okular::PageTransition::Direction  
	184, 0,	//74  Okular::PageTransition::Type  
	185, 0,	//76  Okular::Permission  
	188, 0,	//78  Okular::PixmapRequest*  
	19, 0,	//80  KConfigDialog*  
	192, 192, 0,	//82  Okular::Rotation, Okular::Rotation  
	194, 624, 0,	//85  Okular::ScriptType, const QString&  
	196, 0,	//88  Okular::Sound*  
	197, 0,	//90  Okular::Sound::SoundEncoding  
	205, 0,	//92  Okular::TextAnnotation::InplaceIntent  
	206, 0,	//94  Okular::TextAnnotation::TextType  
	207, 342, 606, 0,	//96  Okular::TextDocumentConverter*, QObject*, const QList<QVariant>&  
	210, 0,	//100  Okular::TextPage*  
	211, 0,	//102  Okular::TextSelection*  
	213, 0,	//104  Okular::View*  
	234, 0,	//106  QChildEvent*  
	260, 257, 0,	//108  QDomNode&, QDomDocument&  
	267, 0,	//111  QEvent*  
	3, 0,	//113  DisposeDataFunction  
	334, 637, 640, 0,	//115  QMetaObject::Call, int, void**  
	342, 267, 0,	//119  QObject*, QEvent*  
	342, 606, 0,	//122  QObject*, const QList<QVariant>&  
	363, 0,	//125  QPrinter&  
	363, 142, 143, 545, 624, 624, 0,	//127  QPrinter&, Okular::FilePrinter::FileDeletePolicy, Okular::FilePrinter::PageSelectPolicy, bool, const QString&, const QString&  
	363, 142, 624, 0,	//134  QPrinter&, Okular::FilePrinter::FileDeletePolicy, const QString&  
	363, 143, 624, 545, 624, 0,	//138  QPrinter&, Okular::FilePrinter::PageSelectPolicy, const QString&, bool, const QString&  
	363, 623, 0,	//144  QPrinter&, const QString  
	363, 623, 142, 0,	//147  QPrinter&, const QString, Okular::FilePrinter::FileDeletePolicy  
	363, 623, 142, 143, 0,	//151  QPrinter&, const QString, Okular::FilePrinter::FileDeletePolicy, Okular::FilePrinter::PageSelectPolicy  
	363, 623, 142, 143, 624, 0,	//156  QPrinter&, const QString, Okular::FilePrinter::FileDeletePolicy, Okular::FilePrinter::PageSelectPolicy, const QString&  
	363, 624, 0,	//162  QPrinter&, const QString&  
	363, 625, 142, 143, 624, 0,	//165  QPrinter&, const QStringList, Okular::FilePrinter::FileDeletePolicy, Okular::FilePrinter::PageSelectPolicy, const QString&  
	363, 626, 0,	//171  QPrinter&, const QStringList&  
	363, 626, 142, 0,	//174  QPrinter&, const QStringList&, Okular::FilePrinter::FileDeletePolicy  
	363, 637, 607, 0,	//178  QPrinter&, int, const QList<int>&  
	414, 627, 0,	//182  QTextDocument*, const QTextBlock&  
	435, 0,	//185  QTimerEvent*  
	450, 0,	//187  QWidget*  
	545, 0,	//189  bool  
	546, 0,	//191  const KComponentData&  
	548, 624, 549, 0,	//193  const KIcon&, const QString&, const KSharedPtr<KMimeType>&  
	550, 0,	//197  const KUrl&  
	551, 0,	//199  const Okular::Action*  
	552, 259, 257, 0,	//201  const Okular::Annotation*, QDomElement&, QDomDocument&  
	552, 635, 635, 0,	//205  const Okular::Annotation*, double, double  
	555, 0,	//209  const Okular::AnnotationObjectRect&  
	556, 0,	//211  const Okular::AnnotationUtils&  
	557, 0,	//213  const Okular::ConfigInterface&  
	559, 0,	//215  const Okular::DocumentInfo&  
	561, 0,	//217  const Okular::DocumentSynopsis&  
	563, 0,	//219  const Okular::DocumentViewport&  
	563, 637, 0,	//221  const Okular::DocumentViewport&, int  
	563, 637, 545, 0,	//224  const Okular::DocumentViewport&, int, bool  
	564, 0,	//228  const Okular::EmbeddedFile&  
	565, 0,	//230  const Okular::ExportFormat&  
	566, 0,	//232  const Okular::FilePrinter&  
	567, 0,	//234  const Okular::FontInfo&  
	567, 233, 0,	//236  const Okular::FontInfo&, QByteArray*  
	568, 0,	//239  const Okular::GuiInterface&  
	569, 0,	//241  const Okular::NormalizedPoint&  
	569, 637, 0,	//243  const Okular::NormalizedPoint&, int  
	569, 639, 0,	//246  const Okular::NormalizedPoint&, void*  
	570, 0,	//249  const Okular::NormalizedRect&  
	570, 545, 175, 639, 0,	//251  const Okular::NormalizedRect&, bool, Okular::ObjectRect::ObjectType, void*  
	571, 0,	//256  const Okular::NormalizedRect*  
	572, 0,	//258  const Okular::ObjectRect&  
	575, 0,	//260  const Okular::PageSize&  
	575, 575, 0,	//262  const Okular::PageSize&, const Okular::PageSize&  
	576, 0,	//265  const Okular::PageTransition&  
	578, 0,	//267  const Okular::PrintInterface&  
	579, 0,	//269  const Okular::RegularAreaRect&  
	580, 0,	//271  const Okular::RegularAreaRect*  
	581, 0,	//273  const Okular::SourceRefObjectRect&  
	582, 0,	//275  const Okular::SourceReference*  
	583, 0,	//277  const Okular::Utils&  
	584, 0,	//279  const Okular::VisiblePageRect&  
	585, 0,	//281  const QByteArray&  
	585, 446, 0,	//283  const QByteArray&, QVector<Okular::Page*>&  
	586, 0,	//286  const QColor&  
	587, 0,	//288  const QDateTime&  
	588, 0,	//290  const QDomDocument&  
	588, 545, 0,	//292  const QDomDocument&, bool  
	589, 0,	//295  const QDomElement&  
	590, 0,	//297  const QDomNode&  
	590, 624, 0,	//299  const QDomNode&, const QString&  
	591, 0,	//302  const QFont&  
	593, 0,	//304  const QImage*  
	597, 0,	//306  const QLinkedList<Okular::FormField*>&  
	598, 0,	//308  const QLinkedList<Okular::NormalizedPoint>&  
	599, 0,	//310  const QLinkedList<Okular::ObjectRect*>&  
	600, 0,	//312  const QLinkedList<Okular::PixmapRequest*>&  
	600, 120, 0,	//314  const QLinkedList<Okular::PixmapRequest*>&, Okular::Document::PixmapRequestFlags  
	601, 0,	//317  const QLinkedList<Okular::SourceRefObjectRect*>&  
	604, 0,	//319  const QList<Okular::TextEntity*>&  
	605, 0,	//321  const QList<QLinkedList<Okular::NormalizedPoint> >&  
	607, 0,	//323  const QList<int>&  
	608, 0,	//325  const QMatrix&  
	618, 175, 639, 0,	//327  const QPolygonF&, Okular::ObjectRect::ObjectType, void*  
	619, 635, 635, 0,	//331  const QRect&, double, double  
	619, 637, 637, 637, 0,	//335  const QRect&, int, int, int  
	621, 0,	//340  const QRectF&  
	624, 0,	//342  const QString&  
	624, 173, 0,	//344  const QString&, Okular::NormalizedRect*  
	624, 446, 0,	//347  const QString&, QVector<Okular::Page*>&  
	624, 545, 0,	//350  const QString&, bool  
	624, 545, 545, 0,	//353  const QString&, bool, bool  
	624, 549, 0,	//357  const QString&, const KSharedPtr<KMimeType>&  
	624, 550, 0,	//360  const QString&, const KUrl&  
	624, 550, 549, 0,	//363  const QString&, const KUrl&, const KSharedPtr<KMimeType>&  
	624, 563, 0,	//367  const QString&, const Okular::DocumentViewport&  
	624, 565, 0,	//370  const QString&, const Okular::ExportFormat&  
	624, 624, 0,	//373  const QString&, const QString&  
	624, 624, 624, 0,	//376  const QString&, const QString&, const QString&  
	624, 630, 0,	//380  const QString&, const QVariant&  
	624, 637, 0,	//383  const QString&, int  
	624, 637, 637, 0,	//386  const QString&, int, int  
	624, 97, 0,	//390  const QString&, KXMLGUIClient::ReverseStateChange  
	630, 0,	//393  const QVariant&  
	632, 0,	//395  const QVector<Okular::VisiblePageRect*>&  
	632, 637, 0,	//397  const QVector<Okular::VisiblePageRect*>&, int  
	633, 0,	//400  const char*  
	635, 0,	//402  double  
	635, 545, 545, 545, 196, 0,	//404  double, bool, bool, bool, Okular::Sound*  
	635, 635, 0,	//410  double, double  
	635, 635, 624, 0,	//413  double, double, const QString&  
	635, 635, 635, 635, 0,	//417  double, double, double, double  
	635, 635, 635, 635, 545, 175, 639, 0,	//422  double, double, double, double, bool, Okular::ObjectRect::ObjectType, void*  
	637, 0,	//430  int  
	637, 102, 0,	//432  int, Okular::Annotation*  
	637, 123, 0,	//435  int, Okular::Document::SearchStatus  
	637, 124, 0,	//438  int, Okular::Document::SearchType  
	637, 191, 586, 0,	//441  int, Okular::RegularAreaRect*, const QColor&  
	637, 360, 0,	//445  int, QPixmap*  
	637, 570, 0,	//448  int, const Okular::NormalizedRect&  
	637, 602, 0,	//451  int, const QList<Okular::Annotation*>&  
	637, 624, 195, 466, 0,	//454  int, const QString&, Okular::SearchDirection, Qt::CaseSensitivity  
	637, 624, 195, 466, 580, 0,	//459  int, const QString&, Okular::SearchDirection, Qt::CaseSensitivity, const Okular::RegularAreaRect*  
	637, 624, 545, 466, 124, 545, 586, 0,	//465  int, const QString&, bool, Qt::CaseSensitivity, Okular::Document::SearchType, bool, const QColor&  
	637, 624, 545, 466, 124, 545, 586, 545, 0,	//473  int, const QString&, bool, Qt::CaseSensitivity, Okular::Document::SearchType, bool, const QColor&, bool  
	637, 624, 627, 0,	//482  int, const QString&, const QTextBlock&  
	637, 637, 0,	//486  int, int  
	637, 637, 545, 0,	//489  int, int, bool  
	637, 637, 637, 0,	//493  int, int, int  
	637, 637, 637, 637, 0,	//497  int, int, int, int  
	637, 637, 637, 637, 637, 545, 0,	//502  int, int, int, int, int, bool  
	638, 0,	//509  uint  
	638, 635, 635, 192, 0,	//511  uint, double, double, Okular::Rotation  
};

// Raw list of all methods, using munged names
static const char *okular_methodNames[] = {
    "",	//0
    "ACaret",	//1
    "AFileAttachment",	//2
    "AGeom",	//3
    "AHighlight",	//4
    "AInk",	//5
    "ALaw",	//6
    "ALine",	//7
    "AMovie",	//8
    "ASound",	//9
    "AStamp",	//10
    "AText",	//11
    "A_BASE",	//12
    "Accepted",	//13
    "Action",	//14
    "AllDocument",	//15
    "AnnotationObjectRect",	//16
    "AnnotationObjectRect#",	//17
    "AnnotationUtils",	//18
    "AnnotationUtils#",	//19
    "ApplicationDeletesFiles",	//20
    "ApplicationSelectsPages",	//21
    "Arrow",	//22
    "Author",	//23
    "Beveled",	//24
    "Blinds",	//25
    "Box",	//26
    "Browse",	//27
    "BrowseAction",	//28
    "BrowseAction$",	//29
    "Butt",	//30
    "CIDTrueType",	//31
    "CIDTrueTypeOT",	//32
    "CIDType0",	//33
    "CIDType0C",	//34
    "CIDType0COT",	//35
    "Callout",	//36
    "Cancelled",	//37
    "CaretAnnotation",	//38
    "CaretAnnotation#",	//39
    "Category",	//40
    "Center",	//41
    "CheckBox",	//42
    "Circle",	//43
    "Close",	//44
    "ClosedArrow",	//45
    "Closing",	//46
    "Cloudy",	//47
    "ComboBox",	//48
    "Completed",	//49
    "ConfigInterface",	//50
    "ConfigInterface#",	//51
    "Copyright",	//52
    "Cover",	//53
    "CreationDate",	//54
    "Creator",	//55
    "Dashed",	//56
    "Delete",	//57
    "DenyDelete",	//58
    "DenyPrint",	//59
    "DenyWrite",	//60
    "Description",	//61
    "Diamond",	//62
    "Dimension",	//63
    "Dissolve",	//64
    "DocAction",	//65
    "Document",	//66
    "Document#",	//67
    "DocumentAction",	//68
    "DocumentAction$",	//69
    "DocumentInfo",	//70
    "DocumentInfo#",	//71
    "DocumentSynopsis",	//72
    "DocumentSynopsis#",	//73
    "DocumentViewport",	//74
    "DocumentViewport#",	//75
    "DocumentViewport$",	//76
    "Embedded",	//77
    "EmbeddedFile",	//78
    "EmbeddedFile#",	//79
    "EmbeddedSubset",	//80
    "EndPresentation",	//81
    "Execute",	//82
    "ExecuteAction",	//83
    "ExecuteAction$$",	//84
    "ExportFormat",	//85
    "ExportFormat#",	//86
    "ExportFormat#$?",	//87
    "ExportFormat$?",	//88
    "External",	//89
    "Fade",	//90
    "FileAttachmentAnnotation",	//91
    "FileAttachmentAnnotation#",	//92
    "FilePrinter",	//93
    "FilePrinter#",	//94
    "FileSelect",	//95
    "Find",	//96
    "FixedRotation",	//97
    "FixedSize",	//98
    "Fly",	//99
    "FontInfo",	//100
    "FontInfo#",	//101
    "FormButton",	//102
    "FormChoice",	//103
    "FormFieldButton",	//104
    "FormFieldChoice",	//105
    "FormFieldText",	//106
    "FormSignature",	//107
    "FormText",	//108
    "FullyEmbedded",	//109
    "Generator",	//110
    "Generator#?",	//111
    "GeomAnnotation",	//112
    "GeomAnnotation#",	//113
    "Glitter",	//114
    "GoToPage",	//115
    "GoogleAll",	//116
    "GoogleAny",	//117
    "Goto",	//118
    "GotoAction",	//119
    "GotoAction$#",	//120
    "GotoAction$$",	//121
    "Group",	//122
    "GuiInterface",	//123
    "GuiInterface#",	//124
    "HTML",	//125
    "Hidden",	//126
    "Highlight",	//127
    "HighlightAnnotation",	//128
    "HighlightAnnotation#",	//129
    "HistoryBack",	//130
    "HistoryForward",	//131
    "Horizontal",	//132
    "Image",	//133
    "InPlace",	//134
    "InkAnnotation",	//135
    "InkAnnotation#",	//136
    "InscribedCircle",	//137
    "InscribedSquare",	//138
    "Inset",	//139
    "Inward",	//140
    "Keywords",	//141
    "LineAnnotation",	//142
    "LineAnnotation#",	//143
    "Linked",	//144
    "ListBox",	//145
    "Marked",	//146
    "MatchFound",	//147
    "MimeType",	//148
    "ModificationDate",	//149
    "Movie",	//150
    "Multiline",	//151
    "NativePrinting",	//152
    "NextMatch",	//153
    "NoEffect",	//154
    "NoMatchFound",	//155
    "NoOption",	//156
    "NoPrinting",	//157
    "None",	//158
    "Normal",	//159
    "NormalizedPoint",	//160
    "NormalizedPoint#",	//161
    "NormalizedPoint$$",	//162
    "NormalizedPoint$$$$",	//163
    "NormalizedRect",	//164
    "NormalizedRect#",	//165
    "NormalizedRect#$$",	//166
    "NormalizedRect$$$$",	//167
    "NotEmbedded",	//168
    "OAnnotation",	//169
    "ObjectRect",	//170
    "ObjectRect#",	//171
    "ObjectRect#$$",	//172
    "ObjectRect#$$$",	//173
    "ObjectRect$$$$$$$",	//174
    "OpenArrow",	//175
    "OpenDocumentText",	//176
    "Opening",	//177
    "Outward",	//178
    "P",	//179
    "PDF",	//180
    "Page",	//181
    "Page$$$$",	//182
    "PageFirst",	//183
    "PageLast",	//184
    "PageNext",	//185
    "PagePrev",	//186
    "PageSize",	//187
    "PageSize#",	//188
    "PageSize$$$",	//189
    "PageSizes",	//190
    "PageTransition",	//191
    "PageTransition#",	//192
    "PageTransition$",	//193
    "Pages",	//194
    "PixmapRequest",	//195
    "PixmapRequest$$$$$$",	//196
    "PlainText",	//197
    "Points",	//198
    "PolygonCloud",	//199
    "PostscriptPrinting",	//200
    "Presentation",	//201
    "PreviousMatch",	//202
    "PrintInterface",	//203
    "PrintInterface#",	//204
    "PrintNative",	//205
    "PrintPostscript",	//206
    "PrintToFile",	//207
    "Producer",	//208
    "Push",	//209
    "Quit",	//210
    "RClosedArrow",	//211
    "ROpenArrow",	//212
    "Radio",	//213
    "Raw",	//214
    "ReadRawData",	//215
    "RegularAreaRect",	//216
    "RegularAreaRect#",	//217
    "Rejected",	//218
    "RemoveAllPrevious",	//219
    "Replace",	//220
    "Reply",	//221
    "Script",	//222
    "ScriptAction",	//223
    "ScriptAction$$",	//224
    "SearchCancelled",	//225
    "Signed",	//226
    "Slash",	//227
    "Solid",	//228
    "Sound",	//229
    "Sound#",	//230
    "Sound$",	//231
    "SoundAction",	//232
    "SoundAction$$$$#",	//233
    "SoundAnnotation",	//234
    "SoundAnnotation#",	//235
    "SourceRef",	//236
    "SourceRefObjectRect",	//237
    "SourceRefObjectRect#",	//238
    "SourceRefObjectRect#$",	//239
    "SourceReference",	//240
    "SourceReference$$",	//241
    "SourceReference$$$",	//242
    "Split",	//243
    "Square",	//244
    "Squiggly",	//245
    "StampAnnotation",	//246
    "StampAnnotation#",	//247
    "StrikeOut",	//248
    "Subject",	//249
    "SystemDeletesFiles",	//250
    "SystemSelectsPages",	//251
    "TextAnnotation",	//252
    "TextAnnotation#",	//253
    "TextDocumentConverter",	//254
    "TextDocumentGenerator",	//255
    "TextDocumentGenerator##?",	//256
    "TextEntity",	//257
    "TextEntity$#",	//258
    "TextExtraction",	//259
    "TextPage",	//260
    "TextPage?",	//261
    "Threaded",	//262
    "Title",	//263
    "ToggleHidingOnMouse",	//264
    "TopLeft",	//265
    "TrueType",	//266
    "TrueTypeOT",	//267
    "Type1",	//268
    "Type1C",	//269
    "Type1COT",	//270
    "Type3",	//271
    "TypeWriter",	//272
    "Uncover",	//273
    "Underline",	//274
    "Unknown",	//275
    "Unmarked",	//276
    "Utils",	//277
    "Utils#",	//278
    "Vertical",	//279
    "VisiblePageRect",	//280
    "VisiblePageRect#",	//281
    "VisiblePageRect$",	//282
    "VisiblePageRect$#",	//283
    "Wipe",	//284
    "action",	//285
    "action#",	//286
    "actionCollection",	//287
    "actionTip",	//288
    "actionType",	//289
    "activationAction",	//290
    "addAction",	//291
    "addAction#$$",	//292
    "addAnnotation",	//293
    "addAnnotation#",	//294
    "addAnnotation#$$",	//295
    "addMetaData",	//296
    "addMetaData$$",	//297
    "addMetaData$$$",	//298
    "addObserver",	//299
    "addObserver?",	//300
    "addPageAnnotation",	//301
    "addPageAnnotation$#",	//302
    "addPages",	//303
    "addPages#",	//304
    "addTitle",	//305
    "addTitle$$#",	//306
    "alignment",	//307
    "allPagesSize",	//308
    "angle",	//309
    "annotation",	//310
    "annotationGeometry",	//311
    "annotationGeometry#$$",	//312
    "annotations",	//313
    "append",	//314
    "append$#",	//315
    "area",	//316
    "asynchronous",	//317
    "author",	//318
    "bitsPerSample",	//319
    "bookmarkManager",	//320
    "bookmarkedPageList",	//321
    "bookmarkedPageRange",	//322
    "bottom",	//323
    "boundingBox",	//324
    "boundingRect",	//325
    "boundingRect$$",	//326
    "boundingRectangle",	//327
    "buttonType",	//328
    "calculateViewport",	//329
    "calculateViewport##",	//330
    "canBeExtracted",	//331
    "canBeMoved",	//332
    "canBeSpellChecked",	//333
    "canConfigurePrinter",	//334
    "canExportToText",	//335
    "canGeneratePixmap",	//336
    "canGenerateTextPage",	//337
    "canProvideFontInformation",	//338
    "canSaveChanges",	//339
    "cancelSearch",	//340
    "caption",	//341
    "caretSymbol",	//342
    "channels",	//343
    "childEvent",	//344
    "childEvent#",	//345
    "choiceType",	//346
    "choices",	//347
    "close",	//348
    "closeDocument",	//349
    "column",	//350
    "componentData",	//351
    "configurableGenerators",	//352
    "connectNotify",	//353
    "connectNotify$",	//354
    "contains",	//355
    "contains$$",	//356
    "contains$$$$",	//357
    "contents",	//358
    "continueSearch",	//359
    "continueSearch$",	//360
    "continueSearch$$",	//361
    "convert",	//362
    "convert$",	//363
    "copies",	//364
    "copies#$",	//365
    "createAnnotation",	//366
    "createAnnotation#",	//367
    "creationDate",	//368
    "cupsAvailable",	//369
    "cupsOptions",	//370
    "cupsOptions#",	//371
    "currentChoices",	//372
    "currentDocument",	//373
    "currentPage",	//374
    "customEvent",	//375
    "customEvent#",	//376
    "data",	//377
    "deleteAnnotations",	//378
    "deleteFile",	//379
    "deleteFile#$$",	//380
    "deletePixmap",	//381
    "deletePixmap$",	//382
    "deletePixmaps",	//383
    "deleteRects",	//384
    "deleteSourceReferences",	//385
    "description",	//386
    "destViewport",	//387
    "destination",	//388
    "destination#$",	//389
    "destinationName",	//390
    "detectCupsConfig",	//391
    "detectCupsService",	//392
    "direction",	//393
    "disconnectNotify",	//394
    "disconnectNotify$",	//395
    "distanceSqr",	//396
    "distanceSqr$$$$",	//397
    "doCloseDocument",	//398
    "doPrintFiles",	//399
    "doPrintFiles#?$$$",	//400
    "document",	//401
    "documentActionType",	//402
    "documentInfo",	//403
    "documentMetaData",	//404
    "documentMetaData$",	//405
    "documentMetaData$#",	//406
    "documentSynopsis",	//407
    "domDocument",	//408
    "dpiX",	//409
    "dpiY",	//410
    "duration",	//411
    "embedType",	//412
    "embeddedFile",	//413
    "embeddedFiles",	//414
    "error",	//415
    "error$$",	//416
    "event",	//417
    "event#",	//418
    "eventFilter",	//419
    "eventFilter##",	//420
    "exportFormats",	//421
    "exportTo",	//422
    "exportTo$#",	//423
    "exportToText",	//424
    "exportToText$",	//425
    "file",	//426
    "fileIconName",	//427
    "fileName",	//428
    "fillConfigDialog",	//429
    "fillConfigDialog#",	//430
    "findChildElement",	//431
    "findChildElement#$",	//432
    "findText",	//433
    "findText$$$$",	//434
    "findText$$$$#",	//435
    "flags",	//436
    "fontData",	//437
    "fontData#",	//438
    "fontReadingEnded",	//439
    "fontReadingProgress",	//440
    "fontReadingProgress$",	//441
    "fontsForPage",	//442
    "fontsForPage$",	//443
    "formFields",	//444
    "fromQRectF",	//445
    "fromQRectF#",	//446
    "generateDocumentInfo",	//447
    "generateDocumentSynopsis",	//448
    "generatePixmap",	//449
    "generatePixmap#",	//450
    "generateTextPage",	//451
    "generateTextPage#",	//452
    "generator",	//453
    "geometricalInnerColor",	//454
    "geometricalType",	//455
    "geometry",	//456
    "geometry$$",	//457
    "get",	//458
    "get$",	//459
    "gotFont",	//460
    "gotFont#",	//461
    "guiClient",	//462
    "hasAnnotations",	//463
    "hasFeature",	//464
    "hasFeature$",	//465
    "hasHighlights",	//466
    "hasHighlights$",	//467
    "hasObjectRect",	//468
    "hasObjectRect$$$$",	//469
    "hasPixmap",	//470
    "hasPixmap$",	//471
    "hasPixmap$$",	//472
    "hasPixmap$$$",	//473
    "hasTextPage",	//474
    "hasTransition",	//475
    "height",	//476
    "highlightQuads",	//477
    "highlightType",	//478
    "historyAtBegin",	//479
    "historyAtEnd",	//480
    "icon",	//481
    "id",	//482
    "image",	//483
    "image#",	//484
    "imageBoundingBox",	//485
    "imageBoundingBox#",	//486
    "inkPaths",	//487
    "inplaceAlignment",	//488
    "inplaceCallout",	//489
    "inplaceCallout$",	//490
    "inplaceIntent",	//491
    "inplaceText",	//492
    "intersects",	//493
    "intersects#",	//494
    "intersects$$$$",	//495
    "isAllowed",	//496
    "isAllowed$",	//497
    "isBoundingBoxKnown",	//498
    "isEditable",	//499
    "isExternal",	//500
    "isNull",	//501
    "isOpened",	//502
    "isPassword",	//503
    "isReadOnly",	//504
    "isRectangular",	//505
    "isRichText",	//506
    "isValid",	//507
    "isVisible",	//508
    "jobname",	//509
    "jobname#$",	//510
    "label",	//511
    "left",	//512
    "lineClosed",	//513
    "lineEndStyle",	//514
    "lineInnerColor",	//515
    "lineIntent",	//516
    "lineLeadingBackwardPoint",	//517
    "lineLeadingForwardPoint",	//518
    "linePoints",	//519
    "lineStartStyle",	//520
    "linkEndPresentation",	//521
    "linkFind",	//522
    "linkGoToPage",	//523
    "linkPresentation",	//524
    "loadDocument",	//525
    "loadDocument$?",	//526
    "loadDocumentFromData",	//527
    "loadDocumentFromData#?",	//528
    "localXMLFile",	//529
    "maximumLength",	//530
    "mediaPageSize",	//531
    "mediaPageSize#",	//532
    "mediaPaperSource",	//533
    "mediaPaperSource#",	//534
    "metaData",	//535
    "metaData$",	//536
    "metaData$#",	//537
    "metaObject",	//538
    "mimeType",	//539
    "mix",	//540
    "modificationDate",	//541
    "modifyPageAnnotation",	//542
    "modifyPageAnnotation$#",	//543
    "muLaw",	//544
    "multiSelect",	//545
    "name",	//546
    "nativeId",	//547
    "nearestObjectRect",	//548
    "nearestObjectRect$$$$$$",	//549
    "notice",	//550
    "notice$$",	//551
    "number",	//552
    "object",	//553
    "objectRect",	//554
    "objectRect$$$$$",	//555
    "objectType",	//556
    "openDocument",	//557
    "openDocument$#?",	//558
    "openDocumentArchive",	//559
    "openDocumentArchive$#",	//560
    "openUrl",	//561
    "openUrl#",	//562
    "operator!=",	//563
    "operator!=#",	//564
    "operator&",	//565
    "operator&#",	//566
    "operator=",	//567
    "operator=#",	//568
    "operator==",	//569
    "operator==#",	//570
    "operator|",	//571
    "operator|#",	//572
    "operator|=",	//573
    "operator|=#",	//574
    "optionCollateCopies",	//575
    "optionCollateCopies#",	//576
    "optionCupsProperties",	//577
    "optionCupsProperties#",	//578
    "optionDoubleSidedPrinting",	//579
    "optionDoubleSidedPrinting#",	//580
    "optionMedia",	//581
    "optionMedia#",	//582
    "optionOrientation",	//583
    "optionOrientation#",	//584
    "optionPageMargins",	//585
    "optionPageMargins#",	//586
    "optionPageOrder",	//587
    "optionPageOrder#",	//588
    "orientation",	//589
    "page",	//590
    "page$",	//591
    "pageAction",	//592
    "pageAction$",	//593
    "pageList",	//594
    "pageList#$?",	//595
    "pageListToPageRange",	//596
    "pageListToPageRange?",	//597
    "pageNumber",	//598
    "pageRange",	//599
    "pageRange#$?",	//600
    "pageSizeChanged",	//601
    "pageSizeChanged##",	//602
    "pageSizeString",	//603
    "pageSizeString$",	//604
    "pageSizes",	//605
    "pages",	//606
    "pages#$$$$",	//607
    "pagesSizeMetric",	//608
    "parameters",	//609
    "pdf2psAvailable",	//610
    "print",	//611
    "print#",	//612
    "printArguments",	//613
    "printArguments#$$$$$",	//614
    "printConfigurationWidget",	//615
    "printFile",	//616
    "printFile#$",	//617
    "printFile#$$",	//618
    "printFile#$$$",	//619
    "printFile#$$$$",	//620
    "printFiles",	//621
    "printFiles#?",	//622
    "printFiles#?$",	//623
    "printingSupport",	//624
    "priority",	//625
    "processAction",	//626
    "processAction#",	//627
    "processSourceReference",	//628
    "processSourceReference#",	//629
    "ps2pdfAvailable",	//630
    "psPaperSize",	//631
    "psPaperSize#",	//632
    "qt_metacall",	//633
    "qt_metacall$$?",	//634
    "quit",	//635
    "ratio",	//636
    "realDpiX",	//637
    "realDpiY",	//638
    "rect",	//639
    "region",	//640
    "registerView",	//641
    "registerView?",	//642
    "removeAnnotation",	//643
    "removeAnnotation#",	//644
    "removeObserver",	//645
    "removeObserver?",	//646
    "removePageAnnotation",	//647
    "removePageAnnotation$#",	//648
    "removePageAnnotations",	//649
    "removePageAnnotations$?",	//650
    "reparseConfig",	//651
    "repeat",	//652
    "requestFontData",	//653
    "requestFontData##",	//654
    "requestPixmaps",	//655
    "requestPixmaps?",	//656
    "requestPixmaps?$",	//657
    "requestTextPage",	//658
    "requestTextPage$",	//659
    "resetSearch",	//660
    "resetSearch$",	//661
    "revisions",	//662
    "right",	//663
    "rotateRect",	//664
    "rotateRect#$$$",	//665
    "rotation",	//666
    "rotationChanged",	//667
    "rotationChanged$$",	//668
    "row",	//669
    "samplingRate",	//670
    "saveChanges",	//671
    "saveChanges$",	//672
    "saveDocumentArchive",	//673
    "saveDocumentArchive$",	//674
    "scale",	//675
    "script",	//676
    "scriptType",	//677
    "searchFinished",	//678
    "searchFinished$$",	//679
    "searchText",	//680
    "searchText$$$$$$#",	//681
    "searchText$$$$$$#$",	//682
    "set",	//683
    "set$$",	//684
    "set$$$",	//685
    "setActivationAction",	//686
    "setActivationAction#",	//687
    "setAlignment",	//688
    "setAlignment$",	//689
    "setAngle",	//690
    "setAngle$",	//691
    "setAuthor",	//692
    "setAuthor$",	//693
    "setBitsPerSample",	//694
    "setBitsPerSample$",	//695
    "setBottom",	//696
    "setBottom$",	//697
    "setBoundingBox",	//698
    "setBoundingBox#",	//699
    "setBoundingRectangle",	//700
    "setBoundingRectangle#",	//701
    "setCanBeExtracted",	//702
    "setCanBeExtracted$",	//703
    "setCaretSymbol",	//704
    "setCaretSymbol$",	//705
    "setChannels",	//706
    "setChannels$",	//707
    "setComponentData",	//708
    "setComponentData#",	//709
    "setContents",	//710
    "setContents$",	//711
    "setCreationDate",	//712
    "setCreationDate#",	//713
    "setCurrentChoices",	//714
    "setCurrentChoices?",	//715
    "setDOMDocument",	//716
    "setDOMDocument#",	//717
    "setDOMDocument#$",	//718
    "setDirection",	//719
    "setDirection$",	//720
    "setDisposeDataFunction",	//721
    "setDisposeDataFunction?",	//722
    "setDuration",	//723
    "setDuration$",	//724
    "setEmbedType",	//725
    "setEmbedType$",	//726
    "setEmbeddedFile",	//727
    "setEmbeddedFile#",	//728
    "setFeature",	//729
    "setFeature$",	//730
    "setFeature$$",	//731
    "setFile",	//732
    "setFile$",	//733
    "setFileIconName",	//734
    "setFileIconName$",	//735
    "setFlags",	//736
    "setFlags$",	//737
    "setFormFields",	//738
    "setFormFields?",	//739
    "setGeometricalInnerColor",	//740
    "setGeometricalInnerColor#",	//741
    "setGeometricalType",	//742
    "setGeometricalType$",	//743
    "setHighlightType",	//744
    "setHighlightType$",	//745
    "setInkPaths",	//746
    "setInkPaths?",	//747
    "setInplaceAlignment",	//748
    "setInplaceAlignment$",	//749
    "setInplaceCallout",	//750
    "setInplaceCallout#$",	//751
    "setInplaceIntent",	//752
    "setInplaceIntent$",	//753
    "setInplaceText",	//754
    "setInplaceText$",	//755
    "setIsRectangular",	//756
    "setIsRectangular$",	//757
    "setLabel",	//758
    "setLabel$",	//759
    "setLeft",	//760
    "setLeft$",	//761
    "setLineClosed",	//762
    "setLineClosed$",	//763
    "setLineEndStyle",	//764
    "setLineEndStyle$",	//765
    "setLineInnerColor",	//766
    "setLineInnerColor#",	//767
    "setLineIntent",	//768
    "setLineIntent$",	//769
    "setLineLeadingBackwardPoint",	//770
    "setLineLeadingBackwardPoint$",	//771
    "setLineLeadingForwardPoint",	//772
    "setLineLeadingForwardPoint$",	//773
    "setLinePoints",	//774
    "setLinePoints?",	//775
    "setLineStartStyle",	//776
    "setLineStartStyle$",	//777
    "setLocalXMLFile",	//778
    "setLocalXMLFile$",	//779
    "setModificationDate",	//780
    "setModificationDate#",	//781
    "setName",	//782
    "setName$",	//783
    "setNativeId",	//784
    "setNativeId#",	//785
    "setNextDocumentDestination",	//786
    "setNextDocumentDestination$",	//787
    "setNextDocumentViewport",	//788
    "setNextDocumentViewport#",	//789
    "setNextViewport",	//790
    "setObjectRects",	//791
    "setObjectRects?",	//792
    "setPageAction",	//793
    "setPageAction$#",	//794
    "setPageNumber",	//795
    "setPageNumber$",	//796
    "setPageSize",	//797
    "setPageSize#",	//798
    "setPageTextSelection",	//799
    "setPageTextSelection$##",	//800
    "setPixmap",	//801
    "setPixmap$#",	//802
    "setPrevViewport",	//803
    "setRect",	//804
    "setRect#",	//805
    "setRight",	//806
    "setRight$",	//807
    "setRotation",	//808
    "setRotation$",	//809
    "setSamplingRate",	//810
    "setSamplingRate$",	//811
    "setScale",	//812
    "setScale$",	//813
    "setShowCaption",	//814
    "setShowCaption$",	//815
    "setSound",	//816
    "setSound#",	//817
    "setSoundEncoding",	//818
    "setSoundEncoding$",	//819
    "setSoundIconName",	//820
    "setSoundIconName$",	//821
    "setSourceReferences",	//822
    "setSourceReferences?",	//823
    "setStampIconName",	//824
    "setStampIconName$",	//825
    "setState",	//826
    "setState$",	//827
    "setText",	//828
    "setText$",	//829
    "setTextFont",	//830
    "setTextFont#",	//831
    "setTextIcon",	//832
    "setTextIcon$",	//833
    "setTextPage",	//834
    "setTextPage#",	//835
    "setTextType",	//836
    "setTextType$",	//837
    "setTop",	//838
    "setTop$",	//839
    "setTransition",	//840
    "setTransition#",	//841
    "setType",	//842
    "setType$",	//843
    "setUniqueName",	//844
    "setUniqueName$",	//845
    "setViewport",	//846
    "setViewport#",	//847
    "setViewport#$",	//848
    "setViewport#$$",	//849
    "setViewportPage",	//850
    "setViewportPage$",	//851
    "setViewportPage$$",	//852
    "setViewportPage$$$",	//853
    "setVisiblePageRects",	//854
    "setVisiblePageRects?",	//855
    "setVisiblePageRects?$",	//856
    "setX",	//857
    "setX$",	//858
    "setXML",	//859
    "setXML$",	//860
    "setXML$$",	//861
    "setXMLFile",	//862
    "setXMLFile$",	//863
    "setXMLFile$$",	//864
    "setXMLFile$$$",	//865
    "setY",	//866
    "setY$",	//867
    "setZoom",	//868
    "setZoom$",	//869
    "setZoom$$",	//870
    "showCaption",	//871
    "siblings",	//872
    "signalPixmapRequestDone",	//873
    "signalPixmapRequestDone#",	//874
    "signalTextGenerationDone",	//875
    "signalTextGenerationDone##",	//876
    "size",	//877
    "sound",	//878
    "soundEncoding",	//879
    "soundIconName",	//880
    "soundType",	//881
    "stampIconName",	//882
    "standardFormat",	//883
    "standardFormat$",	//884
    "startFontReading",	//885
    "state",	//886
    "stateChanged",	//887
    "stateChanged$",	//888
    "stateChanged$$",	//889
    "staticMetaObject",	//890
    "stopFontReading",	//891
    "store",	//892
    "store##",	//893
    "storeAnnotation",	//894
    "storeAnnotation###",	//895
    "style",	//896
    "subType",	//897
    "supportedMimeTypes",	//898
    "supportsPageSizes",	//899
    "supportsPrintToFile",	//900
    "supportsSearching",	//901
    "synchronous",	//902
    "text",	//903
    "text#",	//904
    "textAlignment",	//905
    "textArea",	//906
    "textArea?",	//907
    "textFont",	//908
    "textIcon",	//909
    "textPage",	//910
    "textPage#",	//911
    "textSelection",	//912
    "textSelectionColor",	//913
    "textType",	//914
    "timerEvent",	//915
    "timerEvent#",	//916
    "toString",	//917
    "top",	//918
    "totalOrientation",	//919
    "transform",	//920
    "transform#",	//921
    "transformedArea",	//922
    "transformedArea#",	//923
    "transformedBoundingRectangle",	//924
    "transformedInkPaths",	//925
    "transformedInplaceCallout",	//926
    "transformedInplaceCallout$",	//927
    "transformedLinePoints",	//928
    "transition",	//929
    "translate",	//930
    "translate#",	//931
    "type",	//932
    "uiName",	//933
    "uniqueName",	//934
    "unregisterView",	//935
    "unregisterView?",	//936
    "updatePageBoundingBox",	//937
    "updatePageBoundingBox$#",	//938
    "url",	//939
    "userMutex",	//940
    "viewport",	//941
    "visiblePageRects",	//942
    "volume",	//943
    "warning",	//944
    "warning$$",	//945
    "widget",	//946
    "width",	//947
    "window",	//948
    "x",	//949
    "xmlFile",	//950
    "y",	//951
    "~Action",	//952
    "~Annotation",	//953
    "~AnnotationObjectRect",	//954
    "~AnnotationUtils",	//955
    "~BrowseAction",	//956
    "~CaretAnnotation",	//957
    "~ConfigInterface",	//958
    "~Document",	//959
    "~DocumentAction",	//960
    "~DocumentInfo",	//961
    "~DocumentSynopsis",	//962
    "~DocumentViewport",	//963
    "~EmbeddedFile",	//964
    "~ExecuteAction",	//965
    "~ExportFormat",	//966
    "~FileAttachmentAnnotation",	//967
    "~FilePrinter",	//968
    "~FontInfo",	//969
    "~FormField",	//970
    "~FormFieldButton",	//971
    "~FormFieldChoice",	//972
    "~FormFieldText",	//973
    "~Generator",	//974
    "~GeomAnnotation",	//975
    "~GotoAction",	//976
    "~GuiInterface",	//977
    "~HighlightAnnotation",	//978
    "~InkAnnotation",	//979
    "~LineAnnotation",	//980
    "~NormalizedPoint",	//981
    "~NormalizedRect",	//982
    "~ObjectRect",	//983
    "~Page",	//984
    "~PageSize",	//985
    "~PageTransition",	//986
    "~PixmapRequest",	//987
    "~PrintInterface",	//988
    "~RegularAreaRect",	//989
    "~ScriptAction",	//990
    "~Sound",	//991
    "~SoundAction",	//992
    "~SoundAnnotation",	//993
    "~SourceRefObjectRect",	//994
    "~SourceReference",	//995
    "~StampAnnotation",	//996
    "~TextAnnotation",	//997
    "~TextDocumentConverter",	//998
    "~TextDocumentGenerator",	//999
    "~TextEntity",	//1000
    "~TextPage",	//1001
    "~Utils",	//1002
    "~VisiblePageRect",	//1003
};

// (classId, name (index in methodNames), argumentList index, number of args, method flags, return type (index in types), xcall() index)
static Smoke::Method okular_methods[] = {
	{6, 285, 295, 1, Smoke::mf_const, 228, 6},	//0 KXMLGUIClient::action(const QDomElement&) const
	{6, 287, 0, 0, Smoke::mf_const, 7, 7},	//1 KXMLGUIClient::actionCollection() const
	{6, 351, 0, 0, Smoke::mf_const, 14, 8},	//2 KXMLGUIClient::componentData() const
	{6, 408, 0, 0, Smoke::mf_const, 256, 9},	//3 KXMLGUIClient::domDocument() const
	{6, 950, 0, 0, Smoke::mf_const, 384, 10},	//4 KXMLGUIClient::xmlFile() const
	{6, 529, 0, 0, Smoke::mf_const, 384, 11},	//5 KXMLGUIClient::localXMLFile() const
	{6, 708, 191, 1, Smoke::mf_protected, 0, 33},	//6 KXMLGUIClient::setComponentData(const KComponentData&)
	{6, 862, 353, 3, Smoke::mf_protected, 0, 34},	//7 KXMLGUIClient::setXMLFile(const QString&, bool, bool)
	{6, 862, 350, 2, Smoke::mf_protected, 0, 35},	//8 KXMLGUIClient::setXMLFile(const QString&, bool)
	{6, 862, 342, 1, Smoke::mf_protected, 0, 36},	//9 KXMLGUIClient::setXMLFile(const QString&)
	{6, 778, 342, 1, Smoke::mf_protected, 0, 37},	//10 KXMLGUIClient::setLocalXMLFile(const QString&)
	{6, 859, 350, 2, Smoke::mf_protected, 0, 38},	//11 KXMLGUIClient::setXML(const QString&, bool)
	{6, 859, 342, 1, Smoke::mf_protected, 0, 39},	//12 KXMLGUIClient::setXML(const QString&)
	{6, 716, 292, 2, Smoke::mf_protected, 0, 40},	//13 KXMLGUIClient::setDOMDocument(const QDomDocument&, bool)
	{6, 716, 290, 1, Smoke::mf_protected, 0, 41},	//14 KXMLGUIClient::setDOMDocument(const QDomDocument&)
	{6, 887, 390, 2, Smoke::mf_protected, 0, 42},	//15 KXMLGUIClient::stateChanged(const QString&, KXMLGUIClient::ReverseStateChange)
	{6, 887, 342, 1, Smoke::mf_protected, 0, 43},	//16 KXMLGUIClient::stateChanged(const QString&)
	{8, 118, 0, 0, Smoke::mf_static|Smoke::mf_enum, 101, 1},	//17 Okular::Action::Goto (enum)
	{8, 82, 0, 0, Smoke::mf_static|Smoke::mf_enum, 101, 2},	//18 Okular::Action::Execute (enum)
	{8, 27, 0, 0, Smoke::mf_static|Smoke::mf_enum, 101, 3},	//19 Okular::Action::Browse (enum)
	{8, 65, 0, 0, Smoke::mf_static|Smoke::mf_enum, 101, 4},	//20 Okular::Action::DocAction (enum)
	{8, 229, 0, 0, Smoke::mf_static|Smoke::mf_enum, 101, 5},	//21 Okular::Action::Sound (enum)
	{8, 150, 0, 0, Smoke::mf_static|Smoke::mf_enum, 101, 6},	//22 Okular::Action::Movie (enum)
	{8, 222, 0, 0, Smoke::mf_static|Smoke::mf_enum, 101, 7},	//23 Okular::Action::Script (enum)
	{8, 952, 0, 0, Smoke::mf_dtor, 0, 10},	//24 Okular::Action::~Action()
	{8, 289, 0, 0, Smoke::mf_const, 101, 8},	//25 Okular::Action::actionType() const [pure virtual]
	{8, 288, 0, 0, Smoke::mf_const, 384, 9},	//26 Okular::Action::actionTip() const
	{9, 11, 0, 0, Smoke::mf_static|Smoke::mf_enum, 109, 1},	//27 Okular::Annotation::AText (enum)
	{9, 7, 0, 0, Smoke::mf_static|Smoke::mf_enum, 109, 2},	//28 Okular::Annotation::ALine (enum)
	{9, 3, 0, 0, Smoke::mf_static|Smoke::mf_enum, 109, 3},	//29 Okular::Annotation::AGeom (enum)
	{9, 4, 0, 0, Smoke::mf_static|Smoke::mf_enum, 109, 4},	//30 Okular::Annotation::AHighlight (enum)
	{9, 10, 0, 0, Smoke::mf_static|Smoke::mf_enum, 109, 5},	//31 Okular::Annotation::AStamp (enum)
	{9, 5, 0, 0, Smoke::mf_static|Smoke::mf_enum, 109, 6},	//32 Okular::Annotation::AInk (enum)
	{9, 1, 0, 0, Smoke::mf_static|Smoke::mf_enum, 109, 7},	//33 Okular::Annotation::ACaret (enum)
	{9, 2, 0, 0, Smoke::mf_static|Smoke::mf_enum, 109, 8},	//34 Okular::Annotation::AFileAttachment (enum)
	{9, 9, 0, 0, Smoke::mf_static|Smoke::mf_enum, 109, 9},	//35 Okular::Annotation::ASound (enum)
	{9, 8, 0, 0, Smoke::mf_static|Smoke::mf_enum, 109, 10},	//36 Okular::Annotation::AMovie (enum)
	{9, 12, 0, 0, Smoke::mf_static|Smoke::mf_enum, 109, 11},	//37 Okular::Annotation::A_BASE (enum)
	{9, 126, 0, 0, Smoke::mf_static|Smoke::mf_enum, 103, 12},	//38 Okular::Annotation::Hidden (enum)
	{9, 98, 0, 0, Smoke::mf_static|Smoke::mf_enum, 103, 13},	//39 Okular::Annotation::FixedSize (enum)
	{9, 97, 0, 0, Smoke::mf_static|Smoke::mf_enum, 103, 14},	//40 Okular::Annotation::FixedRotation (enum)
	{9, 59, 0, 0, Smoke::mf_static|Smoke::mf_enum, 103, 15},	//41 Okular::Annotation::DenyPrint (enum)
	{9, 60, 0, 0, Smoke::mf_static|Smoke::mf_enum, 103, 16},	//42 Okular::Annotation::DenyWrite (enum)
	{9, 58, 0, 0, Smoke::mf_static|Smoke::mf_enum, 103, 17},	//43 Okular::Annotation::DenyDelete (enum)
	{9, 264, 0, 0, Smoke::mf_static|Smoke::mf_enum, 103, 18},	//44 Okular::Annotation::ToggleHidingOnMouse (enum)
	{9, 89, 0, 0, Smoke::mf_static|Smoke::mf_enum, 103, 19},	//45 Okular::Annotation::External (enum)
	{9, 228, 0, 0, Smoke::mf_static|Smoke::mf_enum, 105, 20},	//46 Okular::Annotation::Solid (enum)
	{9, 56, 0, 0, Smoke::mf_static|Smoke::mf_enum, 105, 21},	//47 Okular::Annotation::Dashed (enum)
	{9, 24, 0, 0, Smoke::mf_static|Smoke::mf_enum, 105, 22},	//48 Okular::Annotation::Beveled (enum)
	{9, 139, 0, 0, Smoke::mf_static|Smoke::mf_enum, 105, 23},	//49 Okular::Annotation::Inset (enum)
	{9, 274, 0, 0, Smoke::mf_static|Smoke::mf_enum, 105, 24},	//50 Okular::Annotation::Underline (enum)
	{9, 154, 0, 0, Smoke::mf_static|Smoke::mf_enum, 104, 25},	//51 Okular::Annotation::NoEffect (enum)
	{9, 47, 0, 0, Smoke::mf_static|Smoke::mf_enum, 104, 26},	//52 Okular::Annotation::Cloudy (enum)
	{9, 221, 0, 0, Smoke::mf_static|Smoke::mf_enum, 106, 27},	//53 Okular::Annotation::Reply (enum)
	{9, 122, 0, 0, Smoke::mf_static|Smoke::mf_enum, 106, 28},	//54 Okular::Annotation::Group (enum)
	{9, 57, 0, 0, Smoke::mf_static|Smoke::mf_enum, 106, 29},	//55 Okular::Annotation::Delete (enum)
	{9, 158, 0, 0, Smoke::mf_static|Smoke::mf_enum, 107, 30},	//56 Okular::Annotation::None (enum)
	{9, 146, 0, 0, Smoke::mf_static|Smoke::mf_enum, 107, 31},	//57 Okular::Annotation::Marked (enum)
	{9, 276, 0, 0, Smoke::mf_static|Smoke::mf_enum, 107, 32},	//58 Okular::Annotation::Unmarked (enum)
	{9, 13, 0, 0, Smoke::mf_static|Smoke::mf_enum, 107, 33},	//59 Okular::Annotation::Accepted (enum)
	{9, 218, 0, 0, Smoke::mf_static|Smoke::mf_enum, 107, 34},	//60 Okular::Annotation::Rejected (enum)
	{9, 37, 0, 0, Smoke::mf_static|Smoke::mf_enum, 107, 35},	//61 Okular::Annotation::Cancelled (enum)
	{9, 49, 0, 0, Smoke::mf_static|Smoke::mf_enum, 107, 36},	//62 Okular::Annotation::Completed (enum)
	{9, 953, 0, 0, Smoke::mf_dtor, 0, 62},	//63 Okular::Annotation::~Annotation()
	{9, 692, 342, 1, 0, 0, 37},	//64 Okular::Annotation::setAuthor(const QString&)
	{9, 318, 0, 0, Smoke::mf_const, 384, 38},	//65 Okular::Annotation::author() const
	{9, 710, 342, 1, 0, 0, 39},	//66 Okular::Annotation::setContents(const QString&)
	{9, 358, 0, 0, Smoke::mf_const, 384, 40},	//67 Okular::Annotation::contents() const
	{9, 844, 342, 1, 0, 0, 41},	//68 Okular::Annotation::setUniqueName(const QString&)
	{9, 934, 0, 0, Smoke::mf_const, 384, 42},	//69 Okular::Annotation::uniqueName() const
	{9, 780, 288, 1, 0, 0, 43},	//70 Okular::Annotation::setModificationDate(const QDateTime&)
	{9, 541, 0, 0, Smoke::mf_const, 243, 44},	//71 Okular::Annotation::modificationDate() const
	{9, 712, 288, 1, 0, 0, 45},	//72 Okular::Annotation::setCreationDate(const QDateTime&)
	{9, 368, 0, 0, Smoke::mf_const, 243, 46},	//73 Okular::Annotation::creationDate() const
	{9, 736, 430, 1, 0, 0, 47},	//74 Okular::Annotation::setFlags(int)
	{9, 436, 0, 0, Smoke::mf_const, 637, 48},	//75 Okular::Annotation::flags() const
	{9, 700, 249, 1, 0, 0, 49},	//76 Okular::Annotation::setBoundingRectangle(const Okular::NormalizedRect&)
	{9, 327, 0, 0, Smoke::mf_const, 171, 50},	//77 Okular::Annotation::boundingRectangle() const
	{9, 924, 0, 0, Smoke::mf_const, 171, 51},	//78 Okular::Annotation::transformedBoundingRectangle() const
	{9, 930, 241, 1, 0, 0, 52},	//79 Okular::Annotation::translate(const Okular::NormalizedPoint&)
	{9, 896, 0, 0, 0, 108, 53},	//80 Okular::Annotation::style()
	{9, 948, 0, 0, 0, 110, 54},	//81 Okular::Annotation::window()
	{9, 662, 0, 0, 0, 315, 55},	//82 Okular::Annotation::revisions()
	{9, 784, 393, 1, 0, 0, 56},	//83 Okular::Annotation::setNativeId(const QVariant&)
	{9, 547, 0, 0, Smoke::mf_const, 444, 57},	//84 Okular::Annotation::nativeId() const
	{9, 721, 113, 1, 0, 0, 58},	//85 Okular::Annotation::setDisposeDataFunction(DisposeDataFunction)
	{9, 332, 0, 0, Smoke::mf_const, 545, 59},	//86 Okular::Annotation::canBeMoved() const
	{9, 897, 0, 0, Smoke::mf_const, 109, 60},	//87 Okular::Annotation::subType() const [pure virtual]
	{9, 892, 108, 2, Smoke::mf_const, 0, 61},	//88 Okular::Annotation::store(QDomNode&, QDomDocument&) const
	{12, 16, 7, 1, Smoke::mf_ctor, 111, 1},	//89 Okular::AnnotationObjectRect::AnnotationObjectRect(Okular::Annotation*)
	{12, 954, 0, 0, Smoke::mf_dtor, 0, 7},	//90 Okular::AnnotationObjectRect::~AnnotationObjectRect()
	{12, 310, 0, 0, Smoke::mf_const, 102, 2},	//91 Okular::AnnotationObjectRect::annotation() const
	{12, 325, 410, 2, Smoke::mf_const, 375, 3},	//92 Okular::AnnotationObjectRect::boundingRect(double, double) const
	{12, 355, 417, 4, Smoke::mf_const, 545, 4},	//93 Okular::AnnotationObjectRect::contains(double, double, double, double) const
	{12, 920, 325, 1, 0, 0, 5},	//94 Okular::AnnotationObjectRect::transform(const QMatrix&)
	{12, 16, 209, 1, Smoke::mf_copyctor|Smoke::mf_internal|Smoke::mf_ctor, 111, 6},	//95 Okular::AnnotationObjectRect::AnnotationObjectRect(const Okular::AnnotationObjectRect&)
	{13, 18, 0, 0, Smoke::mf_ctor, 112, 1},	//96 Okular::AnnotationUtils::AnnotationUtils()
	{13, 955, 0, 0, Smoke::mf_dtor, 0, 7},	//97 Okular::AnnotationUtils::~AnnotationUtils()
	{13, 18, 211, 1, Smoke::mf_copyctor|Smoke::mf_internal|Smoke::mf_ctor, 112, 2},	//98 Okular::AnnotationUtils::AnnotationUtils(const Okular::AnnotationUtils&)
	{13, 366, 295, 1, Smoke::mf_static, 102, 3},	//99 Okular::AnnotationUtils::createAnnotation(const QDomElement&)
	{13, 894, 201, 3, Smoke::mf_static, 0, 4},	//100 Okular::AnnotationUtils::storeAnnotation(const Okular::Annotation*, QDomElement&, QDomDocument&)
	{13, 431, 299, 2, Smoke::mf_static, 258, 5},	//101 Okular::AnnotationUtils::findChildElement(const QDomNode&, const QString&)
	{13, 311, 205, 3, Smoke::mf_static, 375, 6},	//102 Okular::AnnotationUtils::annotationGeometry(const Okular::Annotation*, double, double)
	{14, 28, 342, 1, Smoke::mf_ctor, 114, 1},	//103 Okular::BrowseAction::BrowseAction(const QString&)
	{14, 956, 0, 0, Smoke::mf_dtor, 0, 5},	//104 Okular::BrowseAction::~BrowseAction()
	{14, 289, 0, 0, Smoke::mf_const, 101, 2},	//105 Okular::BrowseAction::actionType() const
	{14, 288, 0, 0, Smoke::mf_const, 384, 3},	//106 Okular::BrowseAction::actionTip() const
	{14, 939, 0, 0, Smoke::mf_const, 384, 4},	//107 Okular::BrowseAction::url() const
	{15, 158, 0, 0, Smoke::mf_static|Smoke::mf_enum, 116, 1},	//108 Okular::CaretAnnotation::None (enum)
	{15, 179, 0, 0, Smoke::mf_static|Smoke::mf_enum, 116, 2},	//109 Okular::CaretAnnotation::P (enum)
	{15, 38, 0, 0, Smoke::mf_ctor, 115, 3},	//110 Okular::CaretAnnotation::CaretAnnotation()
	{15, 38, 297, 1, Smoke::mf_ctor, 115, 4},	//111 Okular::CaretAnnotation::CaretAnnotation(const QDomNode&)
	{15, 957, 0, 0, Smoke::mf_dtor, 0, 9},	//112 Okular::CaretAnnotation::~CaretAnnotation()
	{15, 704, 13, 1, 0, 0, 5},	//113 Okular::CaretAnnotation::setCaretSymbol(Okular::CaretAnnotation::CaretSymbol)
	{15, 342, 0, 0, Smoke::mf_const, 116, 6},	//114 Okular::CaretAnnotation::caretSymbol() const
	{15, 897, 0, 0, Smoke::mf_const, 109, 7},	//115 Okular::CaretAnnotation::subType() const
	{15, 892, 108, 2, Smoke::mf_const, 0, 8},	//116 Okular::CaretAnnotation::store(QDomNode&, QDomDocument&) const
	{16, 958, 0, 0, Smoke::mf_dtor, 0, 5},	//117 Okular::ConfigInterface::~ConfigInterface()
	{16, 651, 0, 0, 0, 545, 1},	//118 Okular::ConfigInterface::reparseConfig() [pure virtual]
	{16, 303, 80, 1, 0, 0, 2},	//119 Okular::ConfigInterface::addPages(KConfigDialog*) [pure virtual]
	{16, 50, 0, 0, Smoke::mf_ctor, 117, 3},	//120 Okular::ConfigInterface::ConfigInterface()
	{16, 50, 213, 1, Smoke::mf_copyctor|Smoke::mf_internal|Smoke::mf_ctor, 117, 4},	//121 Okular::ConfigInterface::ConfigInterface(const Okular::ConfigInterface&)
	{17, 156, 0, 0, Smoke::mf_static|Smoke::mf_enum, 119, 1},	//122 Okular::Document::NoOption (enum)
	{17, 219, 0, 0, Smoke::mf_static|Smoke::mf_enum, 119, 2},	//123 Okular::Document::RemoveAllPrevious (enum)
	{17, 153, 0, 0, Smoke::mf_static|Smoke::mf_enum, 124, 3},	//124 Okular::Document::NextMatch (enum)
	{17, 202, 0, 0, Smoke::mf_static|Smoke::mf_enum, 124, 4},	//125 Okular::Document::PreviousMatch (enum)
	{17, 15, 0, 0, Smoke::mf_static|Smoke::mf_enum, 124, 5},	//126 Okular::Document::AllDocument (enum)
	{17, 116, 0, 0, Smoke::mf_static|Smoke::mf_enum, 124, 6},	//127 Okular::Document::GoogleAll (enum)
	{17, 117, 0, 0, Smoke::mf_static|Smoke::mf_enum, 124, 7},	//128 Okular::Document::GoogleAny (enum)
	{17, 147, 0, 0, Smoke::mf_static|Smoke::mf_enum, 123, 8},	//129 Okular::Document::MatchFound (enum)
	{17, 155, 0, 0, Smoke::mf_static|Smoke::mf_enum, 123, 9},	//130 Okular::Document::NoMatchFound (enum)
	{17, 225, 0, 0, Smoke::mf_static|Smoke::mf_enum, 123, 10},	//131 Okular::Document::SearchCancelled (enum)
	{17, 157, 0, 0, Smoke::mf_static|Smoke::mf_enum, 122, 11},	//132 Okular::Document::NoPrinting (enum)
	{17, 152, 0, 0, Smoke::mf_static|Smoke::mf_enum, 122, 12},	//133 Okular::Document::NativePrinting (enum)
	{17, 200, 0, 0, Smoke::mf_static|Smoke::mf_enum, 122, 13},	//134 Okular::Document::PostscriptPrinting (enum)
	{17, 538, 0, 0, Smoke::mf_const, 610, 15},	//135 Okular::Document::metaObject() const
	{17, 633, 115, 3, 0, 637, 16},	//136 Okular::Document::qt_metacall(QMetaObject::Call, int, void**)
	{17, 66, 187, 1, Smoke::mf_ctor, 118, 17},	//137 Okular::Document::Document(QWidget*)
	{17, 959, 0, 0, Smoke::mf_dtor, 0, 118},	//138 Okular::Document::~Document()
	{17, 557, 363, 3, 0, 545, 18},	//139 Okular::Document::openDocument(const QString&, const KUrl&, const KSharedPtr<KMimeType>&)
	{17, 349, 0, 0, 0, 0, 19},	//140 Okular::Document::closeDocument()
	{17, 299, 20, 1, 0, 0, 20},	//141 Okular::Document::addObserver(Okular::DocumentObserver*)
	{17, 645, 20, 1, 0, 0, 21},	//142 Okular::Document::removeObserver(Okular::DocumentObserver*)
	{17, 651, 0, 0, 0, 0, 22},	//143 Okular::Document::reparseConfig()
	{17, 946, 0, 0, Smoke::mf_const, 450, 23},	//144 Okular::Document::widget() const
	{17, 502, 0, 0, Smoke::mf_const, 545, 24},	//145 Okular::Document::isOpened() const
	{17, 403, 0, 0, Smoke::mf_const, 560, 25},	//146 Okular::Document::documentInfo() const
	{17, 407, 0, 0, Smoke::mf_const, 562, 26},	//147 Okular::Document::documentSynopsis() const
	{17, 885, 0, 0, 0, 0, 27},	//148 Okular::Document::startFontReading()
	{17, 891, 0, 0, 0, 0, 28},	//149 Okular::Document::stopFontReading()
	{17, 338, 0, 0, Smoke::mf_const, 545, 29},	//150 Okular::Document::canProvideFontInformation() const
	{17, 414, 0, 0, Smoke::mf_const, 603, 30},	//151 Okular::Document::embeddedFiles() const
	{17, 590, 430, 1, Smoke::mf_const, 574, 31},	//152 Okular::Document::page(int) const
	{17, 941, 0, 0, Smoke::mf_const, 563, 32},	//153 Okular::Document::viewport() const
	{17, 854, 397, 2, 0, 0, 33},	//154 Okular::Document::setVisiblePageRects(const QVector<Okular::VisiblePageRect*>&, int)
	{17, 854, 395, 1, 0, 0, 34},	//155 Okular::Document::setVisiblePageRects(const QVector<Okular::VisiblePageRect*>&)
	{17, 942, 0, 0, Smoke::mf_const, 632, 35},	//156 Okular::Document::visiblePageRects() const
	{17, 374, 0, 0, Smoke::mf_const, 638, 36},	//157 Okular::Document::currentPage() const
	{17, 606, 0, 0, Smoke::mf_const, 638, 37},	//158 Okular::Document::pages() const
	{17, 373, 0, 0, Smoke::mf_const, 84, 38},	//159 Okular::Document::currentDocument() const
	{17, 496, 76, 1, Smoke::mf_const, 545, 39},	//160 Okular::Document::isAllowed(Okular::Permission) const
	{17, 901, 0, 0, Smoke::mf_const, 545, 40},	//161 Okular::Document::supportsSearching() const
	{17, 899, 0, 0, Smoke::mf_const, 545, 41},	//162 Okular::Document::supportsPageSizes() const
	{17, 605, 0, 0, Smoke::mf_const, 321, 42},	//163 Okular::Document::pageSizes() const
	{17, 335, 0, 0, Smoke::mf_const, 545, 43},	//164 Okular::Document::canExportToText() const
	{17, 424, 342, 1, Smoke::mf_const, 545, 44},	//165 Okular::Document::exportToText(const QString&) const
	{17, 421, 0, 0, Smoke::mf_const, 318, 45},	//166 Okular::Document::exportFormats() const
	{17, 422, 370, 2, Smoke::mf_const, 545, 46},	//167 Okular::Document::exportTo(const QString&, const Okular::ExportFormat&) const
	{17, 479, 0, 0, Smoke::mf_const, 545, 47},	//168 Okular::Document::historyAtBegin() const
	{17, 480, 0, 0, Smoke::mf_const, 545, 48},	//169 Okular::Document::historyAtEnd() const
	{17, 535, 380, 2, Smoke::mf_const, 444, 49},	//170 Okular::Document::metaData(const QString&, const QVariant&) const
	{17, 535, 342, 1, Smoke::mf_const, 444, 50},	//171 Okular::Document::metaData(const QString&) const
	{17, 666, 0, 0, Smoke::mf_const, 192, 51},	//172 Okular::Document::rotation() const
	{17, 308, 0, 0, Smoke::mf_const, 379, 52},	//173 Okular::Document::allPagesSize() const
	{17, 603, 430, 1, Smoke::mf_const, 384, 53},	//174 Okular::Document::pageSizeString(int) const
	{17, 462, 0, 0, 0, 96, 54},	//175 Okular::Document::guiClient()
	{17, 850, 489, 3, 0, 0, 55},	//176 Okular::Document::setViewportPage(int, int, bool)
	{17, 850, 486, 2, 0, 0, 56},	//177 Okular::Document::setViewportPage(int, int)
	{17, 850, 430, 1, 0, 0, 57},	//178 Okular::Document::setViewportPage(int)
	{17, 846, 224, 3, 0, 0, 58},	//179 Okular::Document::setViewport(const Okular::DocumentViewport&, int, bool)
	{17, 846, 221, 2, 0, 0, 59},	//180 Okular::Document::setViewport(const Okular::DocumentViewport&, int)
	{17, 846, 219, 1, 0, 0, 60},	//181 Okular::Document::setViewport(const Okular::DocumentViewport&)
	{17, 803, 0, 0, 0, 0, 61},	//182 Okular::Document::setPrevViewport()
	{17, 790, 0, 0, 0, 0, 62},	//183 Okular::Document::setNextViewport()
	{17, 788, 219, 1, 0, 0, 63},	//184 Okular::Document::setNextDocumentViewport(const Okular::DocumentViewport&)
	{17, 786, 342, 1, 0, 0, 64},	//185 Okular::Document::setNextDocumentDestination(const QString&)
	{17, 868, 486, 2, 0, 0, 65},	//186 Okular::Document::setZoom(int, int)
	{17, 868, 430, 1, 0, 0, 66},	//187 Okular::Document::setZoom(int)
	{17, 655, 312, 1, 0, 0, 67},	//188 Okular::Document::requestPixmaps(const QLinkedList<Okular::PixmapRequest*>&)
	{17, 655, 314, 2, 0, 0, 68},	//189 Okular::Document::requestPixmaps(const QLinkedList<Okular::PixmapRequest*>&, Okular::Document::PixmapRequestFlags)
	{17, 658, 509, 1, 0, 0, 69},	//190 Okular::Document::requestTextPage(uint)
	{17, 301, 432, 2, 0, 0, 70},	//191 Okular::Document::addPageAnnotation(int, Okular::Annotation*)
	{17, 542, 432, 2, 0, 0, 71},	//192 Okular::Document::modifyPageAnnotation(int, Okular::Annotation*)
	{17, 647, 432, 2, 0, 0, 72},	//193 Okular::Document::removePageAnnotation(int, Okular::Annotation*)
	{17, 649, 451, 2, 0, 0, 73},	//194 Okular::Document::removePageAnnotations(int, const QList<Okular::Annotation*>&)
	{17, 799, 441, 3, 0, 0, 74},	//195 Okular::Document::setPageTextSelection(int, Okular::RegularAreaRect*, const QColor&)
	{17, 680, 473, 8, 0, 0, 75},	//196 Okular::Document::searchText(int, const QString&, bool, Qt::CaseSensitivity, Okular::Document::SearchType, bool, const QColor&, bool)
	{17, 680, 465, 7, 0, 0, 76},	//197 Okular::Document::searchText(int, const QString&, bool, Qt::CaseSensitivity, Okular::Document::SearchType, bool, const QColor&)
	{17, 359, 430, 1, 0, 0, 77},	//198 Okular::Document::continueSearch(int)
	{17, 359, 438, 2, 0, 0, 78},	//199 Okular::Document::continueSearch(int, Okular::Document::SearchType)
	{17, 660, 430, 1, 0, 0, 79},	//200 Okular::Document::resetSearch(int)
	{17, 320, 0, 0, Smoke::mf_const, 113, 80},	//201 Okular::Document::bookmarkManager() const
	{17, 626, 199, 1, 0, 0, 81},	//202 Okular::Document::processAction(const Okular::Action*)
	{17, 321, 0, 0, Smoke::mf_const, 323, 82},	//203 Okular::Document::bookmarkedPageList() const
	{17, 322, 0, 0, Smoke::mf_const, 384, 83},	//204 Okular::Document::bookmarkedPageRange() const
	{17, 628, 275, 1, 0, 0, 84},	//205 Okular::Document::processSourceReference(const Okular::SourceReference*)
	{17, 334, 0, 0, Smoke::mf_const, 545, 85},	//206 Okular::Document::canConfigurePrinter() const
	{17, 624, 0, 0, Smoke::mf_const, 122, 86},	//207 Okular::Document::printingSupport() const
	{17, 900, 0, 0, Smoke::mf_const, 545, 87},	//208 Okular::Document::supportsPrintToFile() const
	{17, 611, 125, 1, 0, 545, 88},	//209 Okular::Document::print(QPrinter&)
	{17, 615, 0, 0, Smoke::mf_const, 450, 89},	//210 Okular::Document::printConfigurationWidget() const
	{17, 429, 80, 1, 0, 0, 90},	//211 Okular::Document::fillConfigDialog(KConfigDialog*)
	{17, 352, 0, 0, Smoke::mf_const, 637, 91},	//212 Okular::Document::configurableGenerators() const
	{17, 898, 0, 0, Smoke::mf_const, 388, 92},	//213 Okular::Document::supportedMimeTypes() const
	{17, 351, 0, 0, Smoke::mf_const, 547, 93},	//214 Okular::Document::componentData() const
	{17, 339, 0, 0, Smoke::mf_const, 545, 94},	//215 Okular::Document::canSaveChanges() const
	{17, 671, 342, 1, 0, 545, 95},	//216 Okular::Document::saveChanges(const QString&)
	{17, 641, 104, 1, 0, 0, 96},	//217 Okular::Document::registerView(Okular::View*)
	{17, 935, 104, 1, 0, 0, 97},	//218 Okular::Document::unregisterView(Okular::View*)
	{17, 437, 234, 1, Smoke::mf_const, 232, 98},	//219 Okular::Document::fontData(const Okular::FontInfo&) const
	{17, 559, 360, 2, 0, 545, 99},	//220 Okular::Document::openDocumentArchive(const QString&, const KUrl&)
	{17, 673, 342, 1, 0, 545, 100},	//221 Okular::Document::saveDocumentArchive(const QString&)
	{17, 808, 430, 1, 0, 0, 101},	//222 Okular::Document::setRotation(int)
	{17, 797, 260, 1, 0, 0, 102},	//223 Okular::Document::setPageSize(const Okular::PageSize&)
	{17, 340, 0, 0, 0, 0, 103},	//224 Okular::Document::cancelSearch()
	{17, 348, 0, 0, 0, 0, 104},	//225 Okular::Document::close()
	{17, 635, 0, 0, 0, 0, 105},	//226 Okular::Document::quit()
	{17, 522, 0, 0, 0, 0, 106},	//227 Okular::Document::linkFind()
	{17, 523, 0, 0, 0, 0, 107},	//228 Okular::Document::linkGoToPage()
	{17, 524, 0, 0, 0, 0, 108},	//229 Okular::Document::linkPresentation()
	{17, 521, 0, 0, 0, 0, 109},	//230 Okular::Document::linkEndPresentation()
	{17, 561, 197, 1, 0, 0, 110},	//231 Okular::Document::openUrl(const KUrl&)
	{17, 415, 383, 2, 0, 0, 111},	//232 Okular::Document::error(const QString&, int)
	{17, 944, 383, 2, 0, 0, 112},	//233 Okular::Document::warning(const QString&, int)
	{17, 550, 383, 2, 0, 0, 113},	//234 Okular::Document::notice(const QString&, int)
	{17, 460, 234, 1, 0, 0, 114},	//235 Okular::Document::gotFont(const Okular::FontInfo&)
	{17, 440, 430, 1, 0, 0, 115},	//236 Okular::Document::fontReadingProgress(int)
	{17, 439, 0, 0, 0, 0, 116},	//237 Okular::Document::fontReadingEnded()
	{17, 678, 435, 2, 0, 0, 117},	//238 Okular::Document::searchFinished(int, Okular::Document::SearchStatus)
	{17, 890, 0, 0, Smoke::mf_static, 609, 14},	//239 Okular::Document::staticMetaObject (static var)
	{18, 183, 0, 0, Smoke::mf_static|Smoke::mf_enum, 126, 1},	//240 Okular::DocumentAction::PageFirst (enum)
	{18, 186, 0, 0, Smoke::mf_static|Smoke::mf_enum, 126, 2},	//241 Okular::DocumentAction::PagePrev (enum)
	{18, 185, 0, 0, Smoke::mf_static|Smoke::mf_enum, 126, 3},	//242 Okular::DocumentAction::PageNext (enum)
	{18, 184, 0, 0, Smoke::mf_static|Smoke::mf_enum, 126, 4},	//243 Okular::DocumentAction::PageLast (enum)
	{18, 130, 0, 0, Smoke::mf_static|Smoke::mf_enum, 126, 5},	//244 Okular::DocumentAction::HistoryBack (enum)
	{18, 131, 0, 0, Smoke::mf_static|Smoke::mf_enum, 126, 6},	//245 Okular::DocumentAction::HistoryForward (enum)
	{18, 210, 0, 0, Smoke::mf_static|Smoke::mf_enum, 126, 7},	//246 Okular::DocumentAction::Quit (enum)
	{18, 201, 0, 0, Smoke::mf_static|Smoke::mf_enum, 126, 8},	//247 Okular::DocumentAction::Presentation (enum)
	{18, 81, 0, 0, Smoke::mf_static|Smoke::mf_enum, 126, 9},	//248 Okular::DocumentAction::EndPresentation (enum)
	{18, 96, 0, 0, Smoke::mf_static|Smoke::mf_enum, 126, 10},	//249 Okular::DocumentAction::Find (enum)
	{18, 115, 0, 0, Smoke::mf_static|Smoke::mf_enum, 126, 11},	//250 Okular::DocumentAction::GoToPage (enum)
	{18, 44, 0, 0, Smoke::mf_static|Smoke::mf_enum, 126, 12},	//251 Okular::DocumentAction::Close (enum)
	{18, 68, 15, 1, Smoke::mf_ctor, 125, 13},	//252 Okular::DocumentAction::DocumentAction(Okular::DocumentAction::DocumentActionType)
	{18, 960, 0, 0, Smoke::mf_dtor, 0, 17},	//253 Okular::DocumentAction::~DocumentAction()
	{18, 289, 0, 0, Smoke::mf_const, 101, 14},	//254 Okular::DocumentAction::actionType() const
	{18, 288, 0, 0, Smoke::mf_const, 384, 15},	//255 Okular::DocumentAction::actionTip() const
	{18, 402, 0, 0, Smoke::mf_const, 126, 16},	//256 Okular::DocumentAction::documentActionType() const
	{19, 263, 0, 0, Smoke::mf_static|Smoke::mf_enum, 128, 1},	//257 Okular::DocumentInfo::Title (enum)
	{19, 249, 0, 0, Smoke::mf_static|Smoke::mf_enum, 128, 2},	//258 Okular::DocumentInfo::Subject (enum)
	{19, 61, 0, 0, Smoke::mf_static|Smoke::mf_enum, 128, 3},	//259 Okular::DocumentInfo::Description (enum)
	{19, 23, 0, 0, Smoke::mf_static|Smoke::mf_enum, 128, 4},	//260 Okular::DocumentInfo::Author (enum)
	{19, 55, 0, 0, Smoke::mf_static|Smoke::mf_enum, 128, 5},	//261 Okular::DocumentInfo::Creator (enum)
	{19, 208, 0, 0, Smoke::mf_static|Smoke::mf_enum, 128, 6},	//262 Okular::DocumentInfo::Producer (enum)
	{19, 52, 0, 0, Smoke::mf_static|Smoke::mf_enum, 128, 7},	//263 Okular::DocumentInfo::Copyright (enum)
	{19, 194, 0, 0, Smoke::mf_static|Smoke::mf_enum, 128, 8},	//264 Okular::DocumentInfo::Pages (enum)
	{19, 54, 0, 0, Smoke::mf_static|Smoke::mf_enum, 128, 9},	//265 Okular::DocumentInfo::CreationDate (enum)
	{19, 149, 0, 0, Smoke::mf_static|Smoke::mf_enum, 128, 10},	//266 Okular::DocumentInfo::ModificationDate (enum)
	{19, 148, 0, 0, Smoke::mf_static|Smoke::mf_enum, 128, 11},	//267 Okular::DocumentInfo::MimeType (enum)
	{19, 40, 0, 0, Smoke::mf_static|Smoke::mf_enum, 128, 12},	//268 Okular::DocumentInfo::Category (enum)
	{19, 141, 0, 0, Smoke::mf_static|Smoke::mf_enum, 128, 13},	//269 Okular::DocumentInfo::Keywords (enum)
	{19, 70, 0, 0, Smoke::mf_ctor, 127, 14},	//270 Okular::DocumentInfo::DocumentInfo()
	{19, 683, 376, 3, 0, 0, 15},	//271 Okular::DocumentInfo::set(const QString&, const QString&, const QString&)
	{19, 683, 373, 2, 0, 0, 16},	//272 Okular::DocumentInfo::set(const QString&, const QString&)
	{19, 683, 17, 2, 0, 0, 17},	//273 Okular::DocumentInfo::set(Okular::DocumentInfo::Key, const QString&)
	{19, 458, 342, 1, Smoke::mf_const, 384, 18},	//274 Okular::DocumentInfo::get(const QString&) const
	{19, 961, 0, 0, Smoke::mf_dtor, 0, 20},	//275 Okular::DocumentInfo::~DocumentInfo()
	{19, 70, 215, 1, Smoke::mf_copyctor|Smoke::mf_internal|Smoke::mf_ctor, 127, 19},	//276 Okular::DocumentInfo::DocumentInfo(const Okular::DocumentInfo&)
	{20, 72, 0, 0, Smoke::mf_ctor, 130, 1},	//277 Okular::DocumentSynopsis::DocumentSynopsis()
	{20, 72, 290, 1, Smoke::mf_ctor, 130, 2},	//278 Okular::DocumentSynopsis::DocumentSynopsis(const QDomDocument&)
	{20, 962, 0, 0, Smoke::mf_dtor, 0, 4},	//279 Okular::DocumentSynopsis::~DocumentSynopsis()
	{20, 72, 217, 1, Smoke::mf_copyctor|Smoke::mf_internal|Smoke::mf_ctor, 130, 3},	//280 Okular::DocumentSynopsis::DocumentSynopsis(const Okular::DocumentSynopsis&)
	{21, 41, 0, 0, Smoke::mf_static|Smoke::mf_enum, 133, 1},	//281 Okular::DocumentViewport::Center (enum)
	{21, 265, 0, 0, Smoke::mf_static|Smoke::mf_enum, 133, 2},	//282 Okular::DocumentViewport::TopLeft (enum)
	{21, 74, 430, 1, Smoke::mf_ctor, 132, 4},	//283 Okular::DocumentViewport::DocumentViewport(int)
	{21, 74, 0, 0, Smoke::mf_ctor, 132, 5},	//284 Okular::DocumentViewport::DocumentViewport()
	{21, 74, 342, 1, Smoke::mf_ctor, 132, 6},	//285 Okular::DocumentViewport::DocumentViewport(const QString&)
	{21, 917, 0, 0, Smoke::mf_const, 384, 7},	//286 Okular::DocumentViewport::toString() const
	{21, 507, 0, 0, Smoke::mf_const, 545, 8},	//287 Okular::DocumentViewport::isValid() const
	{21, 569, 219, 1, Smoke::mf_const, 545, 9},	//288 Okular::DocumentViewport::operator==(const Okular::DocumentViewport&) const
	{21, 795, 430, 1, 0, 0, 10},	//289 Okular::DocumentViewport::setPageNumber(int)
	{21, 963, 0, 0, Smoke::mf_dtor, 0, 12},	//290 Okular::DocumentViewport::~DocumentViewport()
	{21, 74, 219, 1, Smoke::mf_copyctor|Smoke::mf_internal|Smoke::mf_ctor, 132, 11},	//291 Okular::DocumentViewport::DocumentViewport(const Okular::DocumentViewport&)
	{21, 598, 0, 0, 0, 637, 3},	//292 Okular::DocumentViewport::pageNumber (var)
	{22, 78, 0, 0, Smoke::mf_ctor, 134, 1},	//293 Okular::EmbeddedFile::EmbeddedFile()
	{22, 964, 0, 0, Smoke::mf_dtor, 0, 9},	//294 Okular::EmbeddedFile::~EmbeddedFile()
	{22, 546, 0, 0, Smoke::mf_const, 384, 2},	//295 Okular::EmbeddedFile::name() const [pure virtual]
	{22, 386, 0, 0, Smoke::mf_const, 384, 3},	//296 Okular::EmbeddedFile::description() const [pure virtual]
	{22, 377, 0, 0, Smoke::mf_const, 232, 4},	//297 Okular::EmbeddedFile::data() const [pure virtual]
	{22, 877, 0, 0, Smoke::mf_const, 637, 5},	//298 Okular::EmbeddedFile::size() const [pure virtual]
	{22, 541, 0, 0, Smoke::mf_const, 243, 6},	//299 Okular::EmbeddedFile::modificationDate() const [pure virtual]
	{22, 368, 0, 0, Smoke::mf_const, 243, 7},	//300 Okular::EmbeddedFile::creationDate() const [pure virtual]
	{22, 78, 228, 1, Smoke::mf_copyctor|Smoke::mf_internal|Smoke::mf_ctor, 134, 8},	//301 Okular::EmbeddedFile::EmbeddedFile(const Okular::EmbeddedFile&)
	{23, 83, 373, 2, Smoke::mf_ctor, 135, 1},	//302 Okular::ExecuteAction::ExecuteAction(const QString&, const QString&)
	{23, 965, 0, 0, Smoke::mf_dtor, 0, 6},	//303 Okular::ExecuteAction::~ExecuteAction()
	{23, 289, 0, 0, Smoke::mf_const, 101, 2},	//304 Okular::ExecuteAction::actionType() const
	{23, 288, 0, 0, Smoke::mf_const, 384, 3},	//305 Okular::ExecuteAction::actionTip() const
	{23, 428, 0, 0, Smoke::mf_const, 384, 4},	//306 Okular::ExecuteAction::fileName() const
	{23, 609, 0, 0, Smoke::mf_const, 384, 5},	//307 Okular::ExecuteAction::parameters() const
	{24, 197, 0, 0, Smoke::mf_static|Smoke::mf_enum, 139, 1},	//308 Okular::ExportFormat::PlainText (enum)
	{24, 180, 0, 0, Smoke::mf_static|Smoke::mf_enum, 139, 2},	//309 Okular::ExportFormat::PDF (enum)
	{24, 176, 0, 0, Smoke::mf_static|Smoke::mf_enum, 139, 3},	//310 Okular::ExportFormat::OpenDocumentText (enum)
	{24, 125, 0, 0, Smoke::mf_static|Smoke::mf_enum, 139, 4},	//311 Okular::ExportFormat::HTML (enum)
	{24, 85, 0, 0, Smoke::mf_ctor, 138, 5},	//312 Okular::ExportFormat::ExportFormat()
	{24, 85, 357, 2, Smoke::mf_ctor, 138, 6},	//313 Okular::ExportFormat::ExportFormat(const QString&, const KSharedPtr<KMimeType>&)
	{24, 85, 193, 3, Smoke::mf_ctor, 138, 7},	//314 Okular::ExportFormat::ExportFormat(const KIcon&, const QString&, const KSharedPtr<KMimeType>&)
	{24, 966, 0, 0, Smoke::mf_dtor, 0, 17},	//315 Okular::ExportFormat::~ExportFormat()
	{24, 85, 230, 1, Smoke::mf_copyctor|Smoke::mf_ctor, 138, 8},	//316 Okular::ExportFormat::ExportFormat(const Okular::ExportFormat&)
	{24, 567, 230, 1, 0, 137, 9},	//317 Okular::ExportFormat::operator=(const Okular::ExportFormat&)
	{24, 386, 0, 0, Smoke::mf_const, 384, 10},	//318 Okular::ExportFormat::description() const
	{24, 539, 0, 0, Smoke::mf_const, 75, 11},	//319 Okular::ExportFormat::mimeType() const
	{24, 481, 0, 0, Smoke::mf_const, 50, 12},	//320 Okular::ExportFormat::icon() const
	{24, 501, 0, 0, Smoke::mf_const, 545, 13},	//321 Okular::ExportFormat::isNull() const
	{24, 569, 230, 1, Smoke::mf_const, 545, 14},	//322 Okular::ExportFormat::operator==(const Okular::ExportFormat&) const
	{24, 563, 230, 1, Smoke::mf_const, 545, 15},	//323 Okular::ExportFormat::operator!=(const Okular::ExportFormat&) const
	{24, 883, 24, 1, Smoke::mf_static, 136, 16},	//324 Okular::ExportFormat::standardFormat(Okular::ExportFormat::StandardExportFormat)
	{25, 91, 0, 0, Smoke::mf_ctor, 140, 1},	//325 Okular::FileAttachmentAnnotation::FileAttachmentAnnotation()
	{25, 91, 297, 1, Smoke::mf_ctor, 140, 2},	//326 Okular::FileAttachmentAnnotation::FileAttachmentAnnotation(const QDomNode&)
	{25, 967, 0, 0, Smoke::mf_dtor, 0, 9},	//327 Okular::FileAttachmentAnnotation::~FileAttachmentAnnotation()
	{25, 427, 0, 0, Smoke::mf_const, 384, 3},	//328 Okular::FileAttachmentAnnotation::fileIconName() const
	{25, 734, 342, 1, 0, 0, 4},	//329 Okular::FileAttachmentAnnotation::setFileIconName(const QString&)
	{25, 413, 0, 0, Smoke::mf_const, 134, 5},	//330 Okular::FileAttachmentAnnotation::embeddedFile() const
	{25, 727, 22, 1, 0, 0, 6},	//331 Okular::FileAttachmentAnnotation::setEmbeddedFile(Okular::EmbeddedFile*)
	{25, 897, 0, 0, Smoke::mf_const, 109, 7},	//332 Okular::FileAttachmentAnnotation::subType() const
	{25, 892, 108, 2, Smoke::mf_const, 0, 8},	//333 Okular::FileAttachmentAnnotation::store(QDomNode&, QDomDocument&) const
	{26, 20, 0, 0, Smoke::mf_static|Smoke::mf_enum, 142, 1},	//334 Okular::FilePrinter::ApplicationDeletesFiles (enum)
	{26, 250, 0, 0, Smoke::mf_static|Smoke::mf_enum, 142, 2},	//335 Okular::FilePrinter::SystemDeletesFiles (enum)
	{26, 21, 0, 0, Smoke::mf_static|Smoke::mf_enum, 143, 3},	//336 Okular::FilePrinter::ApplicationSelectsPages (enum)
	{26, 251, 0, 0, Smoke::mf_static|Smoke::mf_enum, 143, 4},	//337 Okular::FilePrinter::SystemSelectsPages (enum)
	{26, 93, 0, 0, Smoke::mf_ctor, 141, 5},	//338 Okular::FilePrinter::FilePrinter()
	{26, 968, 0, 0, Smoke::mf_dtor, 0, 39},	//339 Okular::FilePrinter::~FilePrinter()
	{26, 93, 232, 1, Smoke::mf_copyctor|Smoke::mf_internal|Smoke::mf_ctor, 141, 6},	//340 Okular::FilePrinter::FilePrinter(const Okular::FilePrinter&)
	{26, 616, 156, 5, Smoke::mf_static, 637, 7},	//341 Okular::FilePrinter::printFile(QPrinter&, const QString, Okular::FilePrinter::FileDeletePolicy, Okular::FilePrinter::PageSelectPolicy, const QString&)
	{26, 616, 151, 4, Smoke::mf_static, 637, 8},	//342 Okular::FilePrinter::printFile(QPrinter&, const QString, Okular::FilePrinter::FileDeletePolicy, Okular::FilePrinter::PageSelectPolicy)
	{26, 616, 147, 3, Smoke::mf_static, 637, 9},	//343 Okular::FilePrinter::printFile(QPrinter&, const QString, Okular::FilePrinter::FileDeletePolicy)
	{26, 616, 144, 2, Smoke::mf_static, 637, 10},	//344 Okular::FilePrinter::printFile(QPrinter&, const QString)
	{26, 621, 174, 3, Smoke::mf_static, 637, 11},	//345 Okular::FilePrinter::printFiles(QPrinter&, const QStringList&, Okular::FilePrinter::FileDeletePolicy)
	{26, 621, 171, 2, Smoke::mf_static, 637, 12},	//346 Okular::FilePrinter::printFiles(QPrinter&, const QStringList&)
	{26, 594, 178, 3, Smoke::mf_static, 323, 13},	//347 Okular::FilePrinter::pageList(QPrinter&, int, const QList<int>&)
	{26, 599, 178, 3, Smoke::mf_static, 384, 14},	//348 Okular::FilePrinter::pageRange(QPrinter&, int, const QList<int>&)
	{26, 596, 323, 1, Smoke::mf_static, 384, 15},	//349 Okular::FilePrinter::pageListToPageRange(const QList<int>&)
	{26, 630, 0, 0, Smoke::mf_static, 545, 16},	//350 Okular::FilePrinter::ps2pdfAvailable()
	{26, 610, 0, 0, Smoke::mf_static, 545, 17},	//351 Okular::FilePrinter::pdf2psAvailable()
	{26, 369, 0, 0, Smoke::mf_static, 545, 18},	//352 Okular::FilePrinter::cupsAvailable()
	{26, 631, 125, 1, Smoke::mf_static, 378, 19},	//353 Okular::FilePrinter::psPaperSize(QPrinter&)
	{26, 392, 0, 0, Smoke::mf_protected, 545, 20},	//354 Okular::FilePrinter::detectCupsService()
	{26, 391, 0, 0, Smoke::mf_protected, 545, 21},	//355 Okular::FilePrinter::detectCupsConfig()
	{26, 399, 165, 5, Smoke::mf_protected, 637, 22},	//356 Okular::FilePrinter::doPrintFiles(QPrinter&, const QStringList, Okular::FilePrinter::FileDeletePolicy, Okular::FilePrinter::PageSelectPolicy, const QString&)
	{26, 613, 127, 6, Smoke::mf_protected, 388, 23},	//357 Okular::FilePrinter::printArguments(QPrinter&, Okular::FilePrinter::FileDeletePolicy, Okular::FilePrinter::PageSelectPolicy, bool, const QString&, const QString&)
	{26, 388, 162, 2, Smoke::mf_protected, 388, 24},	//358 Okular::FilePrinter::destination(QPrinter&, const QString&)
	{26, 364, 162, 2, Smoke::mf_protected, 388, 25},	//359 Okular::FilePrinter::copies(QPrinter&, const QString&)
	{26, 509, 162, 2, Smoke::mf_protected, 388, 26},	//360 Okular::FilePrinter::jobname(QPrinter&, const QString&)
	{26, 379, 134, 3, Smoke::mf_protected, 388, 27},	//361 Okular::FilePrinter::deleteFile(QPrinter&, Okular::FilePrinter::FileDeletePolicy, const QString&)
	{26, 606, 138, 5, Smoke::mf_protected, 388, 28},	//362 Okular::FilePrinter::pages(QPrinter&, Okular::FilePrinter::PageSelectPolicy, const QString&, bool, const QString&)
	{26, 370, 125, 1, Smoke::mf_protected, 388, 29},	//363 Okular::FilePrinter::cupsOptions(QPrinter&)
	{26, 581, 125, 1, Smoke::mf_protected, 388, 30},	//364 Okular::FilePrinter::optionMedia(QPrinter&)
	{26, 531, 125, 1, Smoke::mf_protected, 384, 31},	//365 Okular::FilePrinter::mediaPageSize(QPrinter&)
	{26, 533, 125, 1, Smoke::mf_protected, 384, 32},	//366 Okular::FilePrinter::mediaPaperSource(QPrinter&)
	{26, 583, 125, 1, Smoke::mf_protected, 388, 33},	//367 Okular::FilePrinter::optionOrientation(QPrinter&)
	{26, 579, 125, 1, Smoke::mf_protected, 388, 34},	//368 Okular::FilePrinter::optionDoubleSidedPrinting(QPrinter&)
	{26, 587, 125, 1, Smoke::mf_protected, 388, 35},	//369 Okular::FilePrinter::optionPageOrder(QPrinter&)
	{26, 575, 125, 1, Smoke::mf_protected, 388, 36},	//370 Okular::FilePrinter::optionCollateCopies(QPrinter&)
	{26, 585, 125, 1, Smoke::mf_protected, 388, 37},	//371 Okular::FilePrinter::optionPageMargins(QPrinter&)
	{26, 577, 125, 1, Smoke::mf_protected, 388, 38},	//372 Okular::FilePrinter::optionCupsProperties(QPrinter&)
	{27, 275, 0, 0, Smoke::mf_static|Smoke::mf_enum, 147, 1},	//373 Okular::FontInfo::Unknown (enum)
	{27, 268, 0, 0, Smoke::mf_static|Smoke::mf_enum, 147, 2},	//374 Okular::FontInfo::Type1 (enum)
	{27, 269, 0, 0, Smoke::mf_static|Smoke::mf_enum, 147, 3},	//375 Okular::FontInfo::Type1C (enum)
	{27, 270, 0, 0, Smoke::mf_static|Smoke::mf_enum, 147, 4},	//376 Okular::FontInfo::Type1COT (enum)
	{27, 271, 0, 0, Smoke::mf_static|Smoke::mf_enum, 147, 5},	//377 Okular::FontInfo::Type3 (enum)
	{27, 266, 0, 0, Smoke::mf_static|Smoke::mf_enum, 147, 6},	//378 Okular::FontInfo::TrueType (enum)
	{27, 267, 0, 0, Smoke::mf_static|Smoke::mf_enum, 147, 7},	//379 Okular::FontInfo::TrueTypeOT (enum)
	{27, 33, 0, 0, Smoke::mf_static|Smoke::mf_enum, 147, 8},	//380 Okular::FontInfo::CIDType0 (enum)
	{27, 34, 0, 0, Smoke::mf_static|Smoke::mf_enum, 147, 9},	//381 Okular::FontInfo::CIDType0C (enum)
	{27, 35, 0, 0, Smoke::mf_static|Smoke::mf_enum, 147, 10},	//382 Okular::FontInfo::CIDType0COT (enum)
	{27, 31, 0, 0, Smoke::mf_static|Smoke::mf_enum, 147, 11},	//383 Okular::FontInfo::CIDTrueType (enum)
	{27, 32, 0, 0, Smoke::mf_static|Smoke::mf_enum, 147, 12},	//384 Okular::FontInfo::CIDTrueTypeOT (enum)
	{27, 168, 0, 0, Smoke::mf_static|Smoke::mf_enum, 146, 13},	//385 Okular::FontInfo::NotEmbedded (enum)
	{27, 80, 0, 0, Smoke::mf_static|Smoke::mf_enum, 146, 14},	//386 Okular::FontInfo::EmbeddedSubset (enum)
	{27, 109, 0, 0, Smoke::mf_static|Smoke::mf_enum, 146, 15},	//387 Okular::FontInfo::FullyEmbedded (enum)
	{27, 100, 0, 0, Smoke::mf_ctor, 145, 16},	//388 Okular::FontInfo::FontInfo()
	{27, 100, 234, 1, Smoke::mf_copyctor|Smoke::mf_ctor, 145, 17},	//389 Okular::FontInfo::FontInfo(const Okular::FontInfo&)
	{27, 969, 0, 0, Smoke::mf_dtor, 0, 33},	//390 Okular::FontInfo::~FontInfo()
	{27, 546, 0, 0, Smoke::mf_const, 384, 18},	//391 Okular::FontInfo::name() const
	{27, 782, 342, 1, 0, 0, 19},	//392 Okular::FontInfo::setName(const QString&)
	{27, 932, 0, 0, Smoke::mf_const, 147, 20},	//393 Okular::FontInfo::type() const
	{27, 842, 28, 1, 0, 0, 21},	//394 Okular::FontInfo::setType(Okular::FontInfo::FontType)
	{27, 412, 0, 0, Smoke::mf_const, 146, 22},	//395 Okular::FontInfo::embedType() const
	{27, 725, 26, 1, 0, 0, 23},	//396 Okular::FontInfo::setEmbedType(Okular::FontInfo::EmbedType)
	{27, 426, 0, 0, Smoke::mf_const, 384, 24},	//397 Okular::FontInfo::file() const
	{27, 732, 342, 1, 0, 0, 25},	//398 Okular::FontInfo::setFile(const QString&)
	{27, 331, 0, 0, Smoke::mf_const, 545, 26},	//399 Okular::FontInfo::canBeExtracted() const
	{27, 702, 189, 1, 0, 0, 27},	//400 Okular::FontInfo::setCanBeExtracted(bool)
	{27, 784, 393, 1, 0, 0, 28},	//401 Okular::FontInfo::setNativeId(const QVariant&)
	{27, 547, 0, 0, Smoke::mf_const, 444, 29},	//402 Okular::FontInfo::nativeId() const
	{27, 567, 234, 1, 0, 144, 30},	//403 Okular::FontInfo::operator=(const Okular::FontInfo&)
	{27, 569, 234, 1, Smoke::mf_const, 545, 31},	//404 Okular::FontInfo::operator==(const Okular::FontInfo&) const
	{27, 563, 234, 1, Smoke::mf_const, 545, 32},	//405 Okular::FontInfo::operator!=(const Okular::FontInfo&) const
	{28, 102, 0, 0, Smoke::mf_static|Smoke::mf_enum, 148, 1},	//406 Okular::FormField::FormButton (enum)
	{28, 108, 0, 0, Smoke::mf_static|Smoke::mf_enum, 148, 2},	//407 Okular::FormField::FormText (enum)
	{28, 103, 0, 0, Smoke::mf_static|Smoke::mf_enum, 148, 3},	//408 Okular::FormField::FormChoice (enum)
	{28, 107, 0, 0, Smoke::mf_static|Smoke::mf_enum, 148, 4},	//409 Okular::FormField::FormSignature (enum)
	{28, 970, 0, 0, Smoke::mf_dtor, 0, 14},	//410 Okular::FormField::~FormField()
	{28, 932, 0, 0, Smoke::mf_const, 148, 5},	//411 Okular::FormField::type() const
	{28, 639, 0, 0, Smoke::mf_const, 171, 6},	//412 Okular::FormField::rect() const [pure virtual]
	{28, 482, 0, 0, Smoke::mf_const, 637, 7},	//413 Okular::FormField::id() const [pure virtual]
	{28, 546, 0, 0, Smoke::mf_const, 384, 8},	//414 Okular::FormField::name() const [pure virtual]
	{28, 933, 0, 0, Smoke::mf_const, 384, 9},	//415 Okular::FormField::uiName() const [pure virtual]
	{28, 504, 0, 0, Smoke::mf_const, 545, 10},	//416 Okular::FormField::isReadOnly() const
	{28, 508, 0, 0, Smoke::mf_const, 545, 11},	//417 Okular::FormField::isVisible() const
	{28, 290, 0, 0, Smoke::mf_const, 100, 12},	//418 Okular::FormField::activationAction() const
	{28, 686, 1, 1, Smoke::mf_protected, 0, 13},	//419 Okular::FormField::setActivationAction(Okular::Action*)
	{29, 209, 0, 0, Smoke::mf_static|Smoke::mf_enum, 150, 1},	//420 Okular::FormFieldButton::Push (enum)
	{29, 42, 0, 0, Smoke::mf_static|Smoke::mf_enum, 150, 2},	//421 Okular::FormFieldButton::CheckBox (enum)
	{29, 213, 0, 0, Smoke::mf_static|Smoke::mf_enum, 150, 3},	//422 Okular::FormFieldButton::Radio (enum)
	{29, 971, 0, 0, Smoke::mf_dtor, 0, 10},	//423 Okular::FormFieldButton::~FormFieldButton()
	{29, 328, 0, 0, Smoke::mf_const, 150, 4},	//424 Okular::FormFieldButton::buttonType() const [pure virtual]
	{29, 341, 0, 0, Smoke::mf_const, 384, 5},	//425 Okular::FormFieldButton::caption() const [pure virtual]
	{29, 886, 0, 0, Smoke::mf_const, 545, 6},	//426 Okular::FormFieldButton::state() const [pure virtual]
	{29, 826, 189, 1, 0, 0, 7},	//427 Okular::FormFieldButton::setState(bool)
	{29, 872, 0, 0, Smoke::mf_const, 323, 8},	//428 Okular::FormFieldButton::siblings() const [pure virtual]
	{29, 104, 0, 0, Smoke::mf_ctor|Smoke::mf_protected, 149, 9},	//429 Okular::FormFieldButton::FormFieldButton()
	{30, 48, 0, 0, Smoke::mf_static|Smoke::mf_enum, 152, 1},	//430 Okular::FormFieldChoice::ComboBox (enum)
	{30, 145, 0, 0, Smoke::mf_static|Smoke::mf_enum, 152, 2},	//431 Okular::FormFieldChoice::ListBox (enum)
	{30, 972, 0, 0, Smoke::mf_dtor, 0, 12},	//432 Okular::FormFieldChoice::~FormFieldChoice()
	{30, 346, 0, 0, Smoke::mf_const, 152, 3},	//433 Okular::FormFieldChoice::choiceType() const [pure virtual]
	{30, 347, 0, 0, Smoke::mf_const, 388, 4},	//434 Okular::FormFieldChoice::choices() const [pure virtual]
	{30, 499, 0, 0, Smoke::mf_const, 545, 5},	//435 Okular::FormFieldChoice::isEditable() const
	{30, 545, 0, 0, Smoke::mf_const, 545, 6},	//436 Okular::FormFieldChoice::multiSelect() const
	{30, 372, 0, 0, Smoke::mf_const, 323, 7},	//437 Okular::FormFieldChoice::currentChoices() const [pure virtual]
	{30, 714, 323, 1, 0, 0, 8},	//438 Okular::FormFieldChoice::setCurrentChoices(const QList<int>&)
	{30, 905, 0, 0, Smoke::mf_const, 456, 9},	//439 Okular::FormFieldChoice::textAlignment() const
	{30, 333, 0, 0, Smoke::mf_const, 545, 10},	//440 Okular::FormFieldChoice::canBeSpellChecked() const
	{30, 105, 0, 0, Smoke::mf_ctor|Smoke::mf_protected, 151, 11},	//441 Okular::FormFieldChoice::FormFieldChoice()
	{31, 159, 0, 0, Smoke::mf_static|Smoke::mf_enum, 154, 1},	//442 Okular::FormFieldText::Normal (enum)
	{31, 151, 0, 0, Smoke::mf_static|Smoke::mf_enum, 154, 2},	//443 Okular::FormFieldText::Multiline (enum)
	{31, 95, 0, 0, Smoke::mf_static|Smoke::mf_enum, 154, 3},	//444 Okular::FormFieldText::FileSelect (enum)
	{31, 973, 0, 0, Smoke::mf_dtor, 0, 13},	//445 Okular::FormFieldText::~FormFieldText()
	{31, 914, 0, 0, Smoke::mf_const, 154, 4},	//446 Okular::FormFieldText::textType() const [pure virtual]
	{31, 903, 0, 0, Smoke::mf_const, 384, 5},	//447 Okular::FormFieldText::text() const [pure virtual]
	{31, 828, 342, 1, 0, 0, 6},	//448 Okular::FormFieldText::setText(const QString&)
	{31, 503, 0, 0, Smoke::mf_const, 545, 7},	//449 Okular::FormFieldText::isPassword() const
	{31, 506, 0, 0, Smoke::mf_const, 545, 8},	//450 Okular::FormFieldText::isRichText() const
	{31, 530, 0, 0, Smoke::mf_const, 637, 9},	//451 Okular::FormFieldText::maximumLength() const
	{31, 905, 0, 0, Smoke::mf_const, 456, 10},	//452 Okular::FormFieldText::textAlignment() const
	{31, 333, 0, 0, Smoke::mf_const, 545, 11},	//453 Okular::FormFieldText::canBeSpellChecked() const
	{31, 106, 0, 0, Smoke::mf_ctor|Smoke::mf_protected, 153, 12},	//454 Okular::FormFieldText::FormFieldText()
	{32, 262, 0, 0, Smoke::mf_static|Smoke::mf_enum, 156, 1},	//455 Okular::Generator::Threaded (enum)
	{32, 259, 0, 0, Smoke::mf_static|Smoke::mf_enum, 156, 2},	//456 Okular::Generator::TextExtraction (enum)
	{32, 215, 0, 0, Smoke::mf_static|Smoke::mf_enum, 156, 3},	//457 Okular::Generator::ReadRawData (enum)
	{32, 100, 0, 0, Smoke::mf_static|Smoke::mf_enum, 156, 4},	//458 Okular::Generator::FontInfo (enum)
	{32, 190, 0, 0, Smoke::mf_static|Smoke::mf_enum, 156, 5},	//459 Okular::Generator::PageSizes (enum)
	{32, 205, 0, 0, Smoke::mf_static|Smoke::mf_enum, 156, 6},	//460 Okular::Generator::PrintNative (enum)
	{32, 206, 0, 0, Smoke::mf_static|Smoke::mf_enum, 156, 7},	//461 Okular::Generator::PrintPostscript (enum)
	{32, 207, 0, 0, Smoke::mf_static|Smoke::mf_enum, 156, 8},	//462 Okular::Generator::PrintToFile (enum)
	{32, 158, 0, 0, Smoke::mf_static|Smoke::mf_enum, 157, 9},	//463 Okular::Generator::None (enum)
	{32, 198, 0, 0, Smoke::mf_static|Smoke::mf_enum, 157, 10},	//464 Okular::Generator::Points (enum)
	{32, 538, 0, 0, Smoke::mf_const, 610, 12},	//465 Okular::Generator::metaObject() const
	{32, 633, 115, 3, 0, 637, 13},	//466 Okular::Generator::qt_metacall(QMetaObject::Call, int, void**)
	{32, 110, 122, 2, Smoke::mf_ctor, 155, 14},	//467 Okular::Generator::Generator(QObject*, const QList<QVariant>&)
	{32, 974, 0, 0, Smoke::mf_dtor, 0, 52},	//468 Okular::Generator::~Generator()
	{32, 525, 347, 2, 0, 545, 15},	//469 Okular::Generator::loadDocument(const QString&, QVector<Okular::Page*>&) [pure virtual]
	{32, 527, 283, 2, 0, 545, 16},	//470 Okular::Generator::loadDocumentFromData(const QByteArray&, QVector<Okular::Page*>&)
	{32, 349, 0, 0, 0, 545, 17},	//471 Okular::Generator::closeDocument()
	{32, 336, 0, 0, Smoke::mf_const, 545, 18},	//472 Okular::Generator::canGeneratePixmap() const
	{32, 449, 78, 1, 0, 0, 19},	//473 Okular::Generator::generatePixmap(Okular::PixmapRequest*)
	{32, 337, 0, 0, Smoke::mf_const, 545, 20},	//474 Okular::Generator::canGenerateTextPage() const
	{32, 451, 58, 1, 0, 0, 21},	//475 Okular::Generator::generateTextPage(Okular::Page*)
	{32, 447, 0, 0, 0, 560, 22},	//476 Okular::Generator::generateDocumentInfo()
	{32, 448, 0, 0, 0, 562, 23},	//477 Okular::Generator::generateDocumentSynopsis()
	{32, 442, 430, 1, 0, 319, 24},	//478 Okular::Generator::fontsForPage(int)
	{32, 414, 0, 0, Smoke::mf_const, 603, 25},	//479 Okular::Generator::embeddedFiles() const
	{32, 608, 0, 0, Smoke::mf_const, 157, 26},	//480 Okular::Generator::pagesSizeMetric() const
	{32, 496, 76, 1, Smoke::mf_const, 545, 27},	//481 Okular::Generator::isAllowed(Okular::Permission) const
	{32, 667, 82, 2, 0, 0, 28},	//482 Okular::Generator::rotationChanged(Okular::Rotation, Okular::Rotation)
	{32, 605, 0, 0, Smoke::mf_const, 321, 29},	//483 Okular::Generator::pageSizes() const
	{32, 601, 262, 2, 0, 0, 30},	//484 Okular::Generator::pageSizeChanged(const Okular::PageSize&, const Okular::PageSize&)
	{32, 611, 125, 1, 0, 545, 31},	//485 Okular::Generator::print(QPrinter&)
	{32, 535, 380, 2, Smoke::mf_const, 444, 32},	//486 Okular::Generator::metaData(const QString&, const QVariant&) const
	{32, 421, 0, 0, Smoke::mf_const, 318, 33},	//487 Okular::Generator::exportFormats() const
	{32, 422, 370, 2, 0, 545, 34},	//488 Okular::Generator::exportTo(const QString&, const Okular::ExportFormat&)
	{32, 464, 30, 1, Smoke::mf_const, 545, 35},	//489 Okular::Generator::hasFeature(Okular::Generator::GeneratorFeature) const
	{32, 415, 383, 2, 0, 0, 36},	//490 Okular::Generator::error(const QString&, int)
	{32, 944, 383, 2, 0, 0, 37},	//491 Okular::Generator::warning(const QString&, int)
	{32, 550, 383, 2, 0, 0, 38},	//492 Okular::Generator::notice(const QString&, int)
	{32, 890, 0, 0, Smoke::mf_static, 609, 11},	//493 Okular::Generator::staticMetaObject (static var)
	{32, 873, 78, 1, Smoke::mf_protected, 0, 39},	//494 Okular::Generator::signalPixmapRequestDone(Okular::PixmapRequest*)
	{32, 875, 60, 2, Smoke::mf_protected, 0, 40},	//495 Okular::Generator::signalTextGenerationDone(Okular::Page*, Okular::TextPage*)
	{32, 398, 0, 0, Smoke::mf_protected, 545, 41},	//496 Okular::Generator::doCloseDocument() [pure virtual]
	{32, 483, 78, 1, Smoke::mf_protected, 303, 42},	//497 Okular::Generator::image(Okular::PixmapRequest*)
	{32, 910, 58, 1, Smoke::mf_protected, 210, 43},	//498 Okular::Generator::textPage(Okular::Page*)
	{32, 401, 0, 0, Smoke::mf_const|Smoke::mf_protected, 558, 44},	//499 Okular::Generator::document() const
	{32, 729, 32, 2, Smoke::mf_protected, 0, 45},	//500 Okular::Generator::setFeature(Okular::Generator::GeneratorFeature, bool)
	{32, 729, 30, 1, Smoke::mf_protected, 0, 46},	//501 Okular::Generator::setFeature(Okular::Generator::GeneratorFeature)
	{32, 404, 380, 2, Smoke::mf_const|Smoke::mf_protected, 444, 47},	//502 Okular::Generator::documentMetaData(const QString&, const QVariant&) const
	{32, 404, 342, 1, Smoke::mf_const|Smoke::mf_protected, 444, 48},	//503 Okular::Generator::documentMetaData(const QString&) const
	{32, 940, 0, 0, Smoke::mf_const|Smoke::mf_protected, 337, 49},	//504 Okular::Generator::userMutex() const
	{32, 937, 448, 2, Smoke::mf_protected, 0, 50},	//505 Okular::Generator::updatePageBoundingBox(int, const Okular::NormalizedRect&)
	{32, 653, 236, 2, Smoke::mf_protected, 0, 51},	//506 Okular::Generator::requestFontData(const Okular::FontInfo&, QByteArray*)
	{33, 138, 0, 0, Smoke::mf_static|Smoke::mf_enum, 159, 1},	//507 Okular::GeomAnnotation::InscribedSquare (enum)
	{33, 137, 0, 0, Smoke::mf_static|Smoke::mf_enum, 159, 2},	//508 Okular::GeomAnnotation::InscribedCircle (enum)
	{33, 112, 0, 0, Smoke::mf_ctor, 158, 3},	//509 Okular::GeomAnnotation::GeomAnnotation()
	{33, 112, 297, 1, Smoke::mf_ctor, 158, 4},	//510 Okular::GeomAnnotation::GeomAnnotation(const QDomNode&)
	{33, 975, 0, 0, Smoke::mf_dtor, 0, 11},	//511 Okular::GeomAnnotation::~GeomAnnotation()
	{33, 742, 35, 1, 0, 0, 5},	//512 Okular::GeomAnnotation::setGeometricalType(Okular::GeomAnnotation::GeomType)
	{33, 455, 0, 0, Smoke::mf_const, 159, 6},	//513 Okular::GeomAnnotation::geometricalType() const
	{33, 740, 286, 1, 0, 0, 7},	//514 Okular::GeomAnnotation::setGeometricalInnerColor(const QColor&)
	{33, 454, 0, 0, Smoke::mf_const, 236, 8},	//515 Okular::GeomAnnotation::geometricalInnerColor() const
	{33, 897, 0, 0, Smoke::mf_const, 109, 9},	//516 Okular::GeomAnnotation::subType() const
	{33, 892, 108, 2, Smoke::mf_const, 0, 10},	//517 Okular::GeomAnnotation::store(QDomNode&, QDomDocument&) const
	{34, 119, 367, 2, Smoke::mf_ctor, 160, 1},	//518 Okular::GotoAction::GotoAction(const QString&, const Okular::DocumentViewport&)
	{34, 119, 373, 2, Smoke::mf_ctor, 160, 2},	//519 Okular::GotoAction::GotoAction(const QString&, const QString&)
	{34, 976, 0, 0, Smoke::mf_dtor, 0, 9},	//520 Okular::GotoAction::~GotoAction()
	{34, 289, 0, 0, Smoke::mf_const, 101, 3},	//521 Okular::GotoAction::actionType() const
	{34, 288, 0, 0, Smoke::mf_const, 384, 4},	//522 Okular::GotoAction::actionTip() const
	{34, 500, 0, 0, Smoke::mf_const, 545, 5},	//523 Okular::GotoAction::isExternal() const
	{34, 428, 0, 0, Smoke::mf_const, 384, 6},	//524 Okular::GotoAction::fileName() const
	{34, 387, 0, 0, Smoke::mf_const, 131, 7},	//525 Okular::GotoAction::destViewport() const
	{34, 390, 0, 0, Smoke::mf_const, 384, 8},	//526 Okular::GotoAction::destinationName() const
	{35, 977, 0, 0, Smoke::mf_dtor, 0, 4},	//527 Okular::GuiInterface::~GuiInterface()
	{35, 462, 0, 0, 0, 96, 1},	//528 Okular::GuiInterface::guiClient()
	{35, 123, 0, 0, Smoke::mf_ctor, 161, 2},	//529 Okular::GuiInterface::GuiInterface()
	{35, 123, 239, 1, Smoke::mf_copyctor|Smoke::mf_internal|Smoke::mf_ctor, 161, 3},	//530 Okular::GuiInterface::GuiInterface(const Okular::GuiInterface&)
	{36, 127, 0, 0, Smoke::mf_static|Smoke::mf_enum, 163, 1},	//531 Okular::HighlightAnnotation::Highlight (enum)
	{36, 245, 0, 0, Smoke::mf_static|Smoke::mf_enum, 163, 2},	//532 Okular::HighlightAnnotation::Squiggly (enum)
	{36, 274, 0, 0, Smoke::mf_static|Smoke::mf_enum, 163, 3},	//533 Okular::HighlightAnnotation::Underline (enum)
	{36, 248, 0, 0, Smoke::mf_static|Smoke::mf_enum, 163, 4},	//534 Okular::HighlightAnnotation::StrikeOut (enum)
	{36, 128, 0, 0, Smoke::mf_ctor, 162, 5},	//535 Okular::HighlightAnnotation::HighlightAnnotation()
	{36, 128, 297, 1, Smoke::mf_ctor, 162, 6},	//536 Okular::HighlightAnnotation::HighlightAnnotation(const QDomNode&)
	{36, 978, 0, 0, Smoke::mf_dtor, 0, 12},	//537 Okular::HighlightAnnotation::~HighlightAnnotation()
	{36, 744, 37, 1, 0, 0, 7},	//538 Okular::HighlightAnnotation::setHighlightType(Okular::HighlightAnnotation::HighlightType)
	{36, 478, 0, 0, Smoke::mf_const, 163, 8},	//539 Okular::HighlightAnnotation::highlightType() const
	{36, 477, 0, 0, 0, 320, 9},	//540 Okular::HighlightAnnotation::highlightQuads()
	{36, 897, 0, 0, Smoke::mf_const, 109, 10},	//541 Okular::HighlightAnnotation::subType() const
	{36, 892, 108, 2, Smoke::mf_const, 0, 11},	//542 Okular::HighlightAnnotation::store(QDomNode&, QDomDocument&) const
	{37, 135, 0, 0, Smoke::mf_ctor, 164, 1},	//543 Okular::InkAnnotation::InkAnnotation()
	{37, 135, 297, 1, Smoke::mf_ctor, 164, 2},	//544 Okular::InkAnnotation::InkAnnotation(const QDomNode&)
	{37, 979, 0, 0, Smoke::mf_dtor, 0, 8},	//545 Okular::InkAnnotation::~InkAnnotation()
	{37, 746, 321, 1, 0, 0, 3},	//546 Okular::InkAnnotation::setInkPaths(const QList<QLinkedList<Okular::NormalizedPoint> >&)
	{37, 487, 0, 0, Smoke::mf_const, 322, 4},	//547 Okular::InkAnnotation::inkPaths() const
	{37, 925, 0, 0, Smoke::mf_const, 322, 5},	//548 Okular::InkAnnotation::transformedInkPaths() const
	{37, 897, 0, 0, Smoke::mf_const, 109, 6},	//549 Okular::InkAnnotation::subType() const
	{37, 892, 108, 2, Smoke::mf_const, 0, 7},	//550 Okular::InkAnnotation::store(QDomNode&, QDomDocument&) const
	{38, 244, 0, 0, Smoke::mf_static|Smoke::mf_enum, 167, 1},	//551 Okular::LineAnnotation::Square (enum)
	{38, 43, 0, 0, Smoke::mf_static|Smoke::mf_enum, 167, 2},	//552 Okular::LineAnnotation::Circle (enum)
	{38, 62, 0, 0, Smoke::mf_static|Smoke::mf_enum, 167, 3},	//553 Okular::LineAnnotation::Diamond (enum)
	{38, 175, 0, 0, Smoke::mf_static|Smoke::mf_enum, 167, 4},	//554 Okular::LineAnnotation::OpenArrow (enum)
	{38, 45, 0, 0, Smoke::mf_static|Smoke::mf_enum, 167, 5},	//555 Okular::LineAnnotation::ClosedArrow (enum)
	{38, 158, 0, 0, Smoke::mf_static|Smoke::mf_enum, 167, 6},	//556 Okular::LineAnnotation::None (enum)
	{38, 30, 0, 0, Smoke::mf_static|Smoke::mf_enum, 167, 7},	//557 Okular::LineAnnotation::Butt (enum)
	{38, 212, 0, 0, Smoke::mf_static|Smoke::mf_enum, 167, 8},	//558 Okular::LineAnnotation::ROpenArrow (enum)
	{38, 211, 0, 0, Smoke::mf_static|Smoke::mf_enum, 167, 9},	//559 Okular::LineAnnotation::RClosedArrow (enum)
	{38, 227, 0, 0, Smoke::mf_static|Smoke::mf_enum, 167, 10},	//560 Okular::LineAnnotation::Slash (enum)
	{38, 275, 0, 0, Smoke::mf_static|Smoke::mf_enum, 166, 11},	//561 Okular::LineAnnotation::Unknown (enum)
	{38, 22, 0, 0, Smoke::mf_static|Smoke::mf_enum, 166, 12},	//562 Okular::LineAnnotation::Arrow (enum)
	{38, 63, 0, 0, Smoke::mf_static|Smoke::mf_enum, 166, 13},	//563 Okular::LineAnnotation::Dimension (enum)
	{38, 199, 0, 0, Smoke::mf_static|Smoke::mf_enum, 166, 14},	//564 Okular::LineAnnotation::PolygonCloud (enum)
	{38, 142, 0, 0, Smoke::mf_ctor, 165, 15},	//565 Okular::LineAnnotation::LineAnnotation()
	{38, 142, 297, 1, Smoke::mf_ctor, 165, 16},	//566 Okular::LineAnnotation::LineAnnotation(const QDomNode&)
	{38, 980, 0, 0, Smoke::mf_dtor, 0, 38},	//567 Okular::LineAnnotation::~LineAnnotation()
	{38, 774, 308, 1, 0, 0, 17},	//568 Okular::LineAnnotation::setLinePoints(const QLinkedList<Okular::NormalizedPoint>&)
	{38, 519, 0, 0, Smoke::mf_const, 317, 18},	//569 Okular::LineAnnotation::linePoints() const
	{38, 928, 0, 0, Smoke::mf_const, 317, 19},	//570 Okular::LineAnnotation::transformedLinePoints() const
	{38, 776, 41, 1, 0, 0, 20},	//571 Okular::LineAnnotation::setLineStartStyle(Okular::LineAnnotation::TermStyle)
	{38, 520, 0, 0, Smoke::mf_const, 167, 21},	//572 Okular::LineAnnotation::lineStartStyle() const
	{38, 764, 41, 1, 0, 0, 22},	//573 Okular::LineAnnotation::setLineEndStyle(Okular::LineAnnotation::TermStyle)
	{38, 514, 0, 0, Smoke::mf_const, 167, 23},	//574 Okular::LineAnnotation::lineEndStyle() const
	{38, 762, 189, 1, 0, 0, 24},	//575 Okular::LineAnnotation::setLineClosed(bool)
	{38, 513, 0, 0, Smoke::mf_const, 545, 25},	//576 Okular::LineAnnotation::lineClosed() const
	{38, 766, 286, 1, 0, 0, 26},	//577 Okular::LineAnnotation::setLineInnerColor(const QColor&)
	{38, 515, 0, 0, Smoke::mf_const, 236, 27},	//578 Okular::LineAnnotation::lineInnerColor() const
	{38, 772, 402, 1, 0, 0, 28},	//579 Okular::LineAnnotation::setLineLeadingForwardPoint(double)
	{38, 518, 0, 0, Smoke::mf_const, 635, 29},	//580 Okular::LineAnnotation::lineLeadingForwardPoint() const
	{38, 770, 402, 1, 0, 0, 30},	//581 Okular::LineAnnotation::setLineLeadingBackwardPoint(double)
	{38, 517, 0, 0, Smoke::mf_const, 635, 31},	//582 Okular::LineAnnotation::lineLeadingBackwardPoint() const
	{38, 814, 189, 1, 0, 0, 32},	//583 Okular::LineAnnotation::setShowCaption(bool)
	{38, 871, 0, 0, Smoke::mf_const, 545, 33},	//584 Okular::LineAnnotation::showCaption() const
	{38, 768, 39, 1, 0, 0, 34},	//585 Okular::LineAnnotation::setLineIntent(Okular::LineAnnotation::LineIntent)
	{38, 516, 0, 0, Smoke::mf_const, 166, 35},	//586 Okular::LineAnnotation::lineIntent() const
	{38, 897, 0, 0, Smoke::mf_const, 109, 36},	//587 Okular::LineAnnotation::subType() const
	{38, 892, 108, 2, Smoke::mf_const, 0, 37},	//588 Okular::LineAnnotation::store(QDomNode&, QDomDocument&) const
	{39, 160, 0, 0, Smoke::mf_ctor, 170, 3},	//589 Okular::NormalizedPoint::NormalizedPoint()
	{39, 160, 410, 2, Smoke::mf_ctor, 170, 4},	//590 Okular::NormalizedPoint::NormalizedPoint(double, double)
	{39, 160, 497, 4, Smoke::mf_ctor, 170, 5},	//591 Okular::NormalizedPoint::NormalizedPoint(int, int, int, int)
	{39, 567, 241, 1, 0, 169, 6},	//592 Okular::NormalizedPoint::operator=(const Okular::NormalizedPoint&)
	{39, 920, 325, 1, 0, 0, 7},	//593 Okular::NormalizedPoint::transform(const QMatrix&)
	{39, 857, 402, 1, 0, 0, 8},	//594 Okular::NormalizedPoint::setX(double)
	{39, 866, 402, 1, 0, 0, 9},	//595 Okular::NormalizedPoint::setY(double)
	{39, 981, 0, 0, Smoke::mf_dtor, 0, 11},	//596 Okular::NormalizedPoint::~NormalizedPoint()
	{39, 160, 241, 1, Smoke::mf_copyctor|Smoke::mf_internal|Smoke::mf_ctor, 170, 10},	//597 Okular::NormalizedPoint::NormalizedPoint(const Okular::NormalizedPoint&)
	{39, 949, 0, 0, 0, 635, 1},	//598 Okular::NormalizedPoint::x (var)
	{39, 951, 0, 0, 0, 635, 2},	//599 Okular::NormalizedPoint::y (var)
	{40, 164, 0, 0, Smoke::mf_ctor, 173, 5},	//600 Okular::NormalizedRect::NormalizedRect()
	{40, 164, 417, 4, Smoke::mf_ctor, 173, 6},	//601 Okular::NormalizedRect::NormalizedRect(double, double, double, double)
	{40, 164, 331, 3, Smoke::mf_ctor, 173, 7},	//602 Okular::NormalizedRect::NormalizedRect(const QRect&, double, double)
	{40, 164, 249, 1, Smoke::mf_copyctor|Smoke::mf_ctor, 173, 8},	//603 Okular::NormalizedRect::NormalizedRect(const Okular::NormalizedRect&)
	{40, 567, 249, 1, 0, 172, 9},	//604 Okular::NormalizedRect::operator=(const Okular::NormalizedRect&)
	{40, 501, 0, 0, Smoke::mf_const, 545, 10},	//605 Okular::NormalizedRect::isNull() const
	{40, 355, 410, 2, Smoke::mf_const, 545, 11},	//606 Okular::NormalizedRect::contains(double, double) const
	{40, 493, 249, 1, Smoke::mf_const, 545, 12},	//607 Okular::NormalizedRect::intersects(const Okular::NormalizedRect&) const
	{40, 493, 256, 1, Smoke::mf_const, 545, 13},	//608 Okular::NormalizedRect::intersects(const Okular::NormalizedRect*) const
	{40, 493, 417, 4, Smoke::mf_const, 545, 14},	//609 Okular::NormalizedRect::intersects(double, double, double, double) const
	{40, 456, 486, 2, Smoke::mf_const, 375, 15},	//610 Okular::NormalizedRect::geometry(int, int) const
	{40, 571, 249, 1, Smoke::mf_const, 171, 16},	//611 Okular::NormalizedRect::operator|(const Okular::NormalizedRect&) const
	{40, 573, 249, 1, 0, 172, 17},	//612 Okular::NormalizedRect::operator|=(const Okular::NormalizedRect&)
	{40, 565, 249, 1, Smoke::mf_const, 171, 18},	//613 Okular::NormalizedRect::operator&(const Okular::NormalizedRect&) const
	{40, 569, 249, 1, Smoke::mf_const, 545, 19},	//614 Okular::NormalizedRect::operator==(const Okular::NormalizedRect&) const
	{40, 920, 325, 1, 0, 0, 20},	//615 Okular::NormalizedRect::transform(const QMatrix&)
	{40, 760, 402, 1, 0, 0, 21},	//616 Okular::NormalizedRect::setLeft(double)
	{40, 838, 402, 1, 0, 0, 22},	//617 Okular::NormalizedRect::setTop(double)
	{40, 806, 402, 1, 0, 0, 23},	//618 Okular::NormalizedRect::setRight(double)
	{40, 696, 402, 1, 0, 0, 24},	//619 Okular::NormalizedRect::setBottom(double)
	{40, 982, 0, 0, Smoke::mf_dtor, 0, 26},	//620 Okular::NormalizedRect::~NormalizedRect()
	{40, 445, 340, 1, Smoke::mf_static, 171, 25},	//621 Okular::NormalizedRect::fromQRectF(const QRectF&)
	{40, 512, 0, 0, 0, 635, 1},	//622 Okular::NormalizedRect::left (var)
	{40, 918, 0, 0, 0, 635, 2},	//623 Okular::NormalizedRect::top (var)
	{40, 663, 0, 0, 0, 635, 3},	//624 Okular::NormalizedRect::right (var)
	{40, 323, 0, 0, 0, 635, 4},	//625 Okular::NormalizedRect::bottom (var)
	{41, 14, 0, 0, Smoke::mf_static|Smoke::mf_enum, 175, 1},	//626 Okular::ObjectRect::Action (enum)
	{41, 133, 0, 0, Smoke::mf_static|Smoke::mf_enum, 175, 2},	//627 Okular::ObjectRect::Image (enum)
	{41, 169, 0, 0, Smoke::mf_static|Smoke::mf_enum, 175, 3},	//628 Okular::ObjectRect::OAnnotation (enum)
	{41, 236, 0, 0, Smoke::mf_static|Smoke::mf_enum, 175, 4},	//629 Okular::ObjectRect::SourceRef (enum)
	{41, 170, 422, 7, Smoke::mf_ctor, 174, 5},	//630 Okular::ObjectRect::ObjectRect(double, double, double, double, bool, Okular::ObjectRect::ObjectType, void*)
	{41, 170, 251, 4, Smoke::mf_ctor, 174, 6},	//631 Okular::ObjectRect::ObjectRect(const Okular::NormalizedRect&, bool, Okular::ObjectRect::ObjectType, void*)
	{41, 170, 327, 3, Smoke::mf_ctor, 174, 7},	//632 Okular::ObjectRect::ObjectRect(const QPolygonF&, Okular::ObjectRect::ObjectType, void*)
	{41, 983, 0, 0, Smoke::mf_dtor, 0, 16},	//633 Okular::ObjectRect::~ObjectRect()
	{41, 556, 0, 0, Smoke::mf_const, 175, 8},	//634 Okular::ObjectRect::objectType() const
	{41, 553, 0, 0, Smoke::mf_const, 634, 9},	//635 Okular::ObjectRect::object() const
	{41, 640, 0, 0, Smoke::mf_const, 612, 10},	//636 Okular::ObjectRect::region() const
	{41, 325, 410, 2, Smoke::mf_const, 375, 11},	//637 Okular::ObjectRect::boundingRect(double, double) const
	{41, 355, 417, 4, Smoke::mf_const, 545, 12},	//638 Okular::ObjectRect::contains(double, double, double, double) const
	{41, 920, 325, 1, 0, 0, 13},	//639 Okular::ObjectRect::transform(const QMatrix&)
	{41, 396, 417, 4, Smoke::mf_const, 635, 14},	//640 Okular::ObjectRect::distanceSqr(double, double, double, double) const
	{41, 170, 258, 1, Smoke::mf_copyctor|Smoke::mf_internal|Smoke::mf_ctor, 174, 15},	//641 Okular::ObjectRect::ObjectRect(const Okular::ObjectRect&)
	{42, 177, 0, 0, Smoke::mf_static|Smoke::mf_enum, 177, 1},	//642 Okular::Page::Opening (enum)
	{42, 46, 0, 0, Smoke::mf_static|Smoke::mf_enum, 177, 2},	//643 Okular::Page::Closing (enum)
	{42, 181, 511, 4, Smoke::mf_ctor, 176, 3},	//644 Okular::Page::Page(uint, double, double, Okular::Rotation)
	{42, 984, 0, 0, Smoke::mf_dtor, 0, 54},	//645 Okular::Page::~Page()
	{42, 552, 0, 0, Smoke::mf_const, 637, 4},	//646 Okular::Page::number() const
	{42, 589, 0, 0, Smoke::mf_const, 192, 5},	//647 Okular::Page::orientation() const
	{42, 666, 0, 0, Smoke::mf_const, 192, 6},	//648 Okular::Page::rotation() const
	{42, 919, 0, 0, Smoke::mf_const, 192, 7},	//649 Okular::Page::totalOrientation() const
	{42, 947, 0, 0, Smoke::mf_const, 635, 8},	//650 Okular::Page::width() const
	{42, 476, 0, 0, Smoke::mf_const, 635, 9},	//651 Okular::Page::height() const
	{42, 636, 0, 0, Smoke::mf_const, 635, 10},	//652 Okular::Page::ratio() const
	{42, 324, 0, 0, Smoke::mf_const, 171, 11},	//653 Okular::Page::boundingBox() const
	{42, 498, 0, 0, Smoke::mf_const, 545, 12},	//654 Okular::Page::isBoundingBoxKnown() const
	{42, 698, 249, 1, 0, 0, 13},	//655 Okular::Page::setBoundingBox(const Okular::NormalizedRect&)
	{42, 470, 493, 3, Smoke::mf_const, 545, 14},	//656 Okular::Page::hasPixmap(int, int, int) const
	{42, 470, 486, 2, Smoke::mf_const, 545, 15},	//657 Okular::Page::hasPixmap(int, int) const
	{42, 470, 430, 1, Smoke::mf_const, 545, 16},	//658 Okular::Page::hasPixmap(int) const
	{42, 474, 0, 0, Smoke::mf_const, 545, 17},	//659 Okular::Page::hasTextPage() const
	{42, 468, 417, 4, Smoke::mf_const, 545, 18},	//660 Okular::Page::hasObjectRect(double, double, double, double) const
	{42, 466, 430, 1, Smoke::mf_const, 545, 19},	//661 Okular::Page::hasHighlights(int) const
	{42, 466, 0, 0, Smoke::mf_const, 545, 20},	//662 Okular::Page::hasHighlights() const
	{42, 475, 0, 0, Smoke::mf_const, 545, 21},	//663 Okular::Page::hasTransition() const
	{42, 463, 0, 0, Smoke::mf_const, 545, 22},	//664 Okular::Page::hasAnnotations() const
	{42, 433, 459, 5, Smoke::mf_const, 191, 23},	//665 Okular::Page::findText(int, const QString&, Okular::SearchDirection, Qt::CaseSensitivity, const Okular::RegularAreaRect*) const
	{42, 433, 454, 4, Smoke::mf_const, 191, 24},	//666 Okular::Page::findText(int, const QString&, Okular::SearchDirection, Qt::CaseSensitivity) const
	{42, 903, 271, 1, Smoke::mf_const, 384, 25},	//667 Okular::Page::text(const Okular::RegularAreaRect*) const
	{42, 903, 0, 0, Smoke::mf_const, 384, 26},	//668 Okular::Page::text() const
	{42, 906, 102, 1, Smoke::mf_const, 191, 27},	//669 Okular::Page::textArea(Okular::TextSelection*) const
	{42, 554, 45, 5, Smoke::mf_const, 573, 28},	//670 Okular::Page::objectRect(Okular::ObjectRect::ObjectType, double, double, double, double) const
	{42, 548, 51, 6, Smoke::mf_const, 573, 29},	//671 Okular::Page::nearestObjectRect(Okular::ObjectRect::ObjectType, double, double, double, double, double*) const
	{42, 929, 0, 0, Smoke::mf_const, 577, 30},	//672 Okular::Page::transition() const
	{42, 313, 0, 0, Smoke::mf_const, 314, 31},	//673 Okular::Page::annotations() const
	{42, 592, 63, 1, Smoke::mf_const, 551, 32},	//674 Okular::Page::pageAction(Okular::Page::PageAction) const
	{42, 444, 0, 0, Smoke::mf_const, 316, 33},	//675 Okular::Page::formFields() const
	{42, 801, 445, 2, 0, 0, 34},	//676 Okular::Page::setPixmap(int, QPixmap*)
	{42, 834, 100, 1, 0, 0, 35},	//677 Okular::Page::setTextPage(Okular::TextPage*)
	{42, 791, 310, 1, 0, 0, 36},	//678 Okular::Page::setObjectRects(const QLinkedList<Okular::ObjectRect*>&)
	{42, 822, 317, 1, 0, 0, 37},	//679 Okular::Page::setSourceReferences(const QLinkedList<Okular::SourceRefObjectRect*>&)
	{42, 723, 402, 1, 0, 0, 38},	//680 Okular::Page::setDuration(double)
	{42, 411, 0, 0, Smoke::mf_const, 635, 39},	//681 Okular::Page::duration() const
	{42, 758, 342, 1, 0, 0, 40},	//682 Okular::Page::setLabel(const QString&)
	{42, 511, 0, 0, Smoke::mf_const, 384, 41},	//683 Okular::Page::label() const
	{42, 912, 0, 0, Smoke::mf_const, 580, 42},	//684 Okular::Page::textSelection() const
	{42, 913, 0, 0, Smoke::mf_const, 236, 43},	//685 Okular::Page::textSelectionColor() const
	{42, 293, 7, 1, 0, 0, 44},	//686 Okular::Page::addAnnotation(Okular::Annotation*)
	{42, 643, 7, 1, 0, 545, 45},	//687 Okular::Page::removeAnnotation(Okular::Annotation*)
	{42, 840, 68, 1, 0, 0, 46},	//688 Okular::Page::setTransition(Okular::PageTransition*)
	{42, 793, 65, 2, 0, 0, 47},	//689 Okular::Page::setPageAction(Okular::Page::PageAction, Okular::Action*)
	{42, 738, 306, 1, 0, 0, 48},	//690 Okular::Page::setFormFields(const QLinkedList<Okular::FormField*>&)
	{42, 381, 430, 1, 0, 0, 49},	//691 Okular::Page::deletePixmap(int)
	{42, 383, 0, 0, 0, 0, 50},	//692 Okular::Page::deletePixmaps()
	{42, 384, 0, 0, 0, 0, 51},	//693 Okular::Page::deleteRects()
	{42, 385, 0, 0, 0, 0, 52},	//694 Okular::Page::deleteSourceReferences()
	{42, 378, 0, 0, 0, 0, 53},	//695 Okular::Page::deleteAnnotations()
	{43, 187, 0, 0, Smoke::mf_ctor, 179, 1},	//696 Okular::PageSize::PageSize()
	{43, 187, 413, 3, Smoke::mf_ctor, 179, 2},	//697 Okular::PageSize::PageSize(double, double, const QString&)
	{43, 187, 260, 1, Smoke::mf_copyctor|Smoke::mf_ctor, 179, 3},	//698 Okular::PageSize::PageSize(const Okular::PageSize&)
	{43, 985, 0, 0, Smoke::mf_dtor, 0, 11},	//699 Okular::PageSize::~PageSize()
	{43, 947, 0, 0, Smoke::mf_const, 635, 4},	//700 Okular::PageSize::width() const
	{43, 476, 0, 0, Smoke::mf_const, 635, 5},	//701 Okular::PageSize::height() const
	{43, 546, 0, 0, Smoke::mf_const, 384, 6},	//702 Okular::PageSize::name() const
	{43, 501, 0, 0, Smoke::mf_const, 545, 7},	//703 Okular::PageSize::isNull() const
	{43, 567, 260, 1, 0, 178, 8},	//704 Okular::PageSize::operator=(const Okular::PageSize&)
	{43, 569, 260, 1, Smoke::mf_const, 545, 9},	//705 Okular::PageSize::operator==(const Okular::PageSize&) const
	{43, 563, 260, 1, Smoke::mf_const, 545, 10},	//706 Okular::PageSize::operator!=(const Okular::PageSize&) const
	{44, 220, 0, 0, Smoke::mf_static|Smoke::mf_enum, 184, 1},	//707 Okular::PageTransition::Replace (enum)
	{44, 243, 0, 0, Smoke::mf_static|Smoke::mf_enum, 184, 2},	//708 Okular::PageTransition::Split (enum)
	{44, 25, 0, 0, Smoke::mf_static|Smoke::mf_enum, 184, 3},	//709 Okular::PageTransition::Blinds (enum)
	{44, 26, 0, 0, Smoke::mf_static|Smoke::mf_enum, 184, 4},	//710 Okular::PageTransition::Box (enum)
	{44, 284, 0, 0, Smoke::mf_static|Smoke::mf_enum, 184, 5},	//711 Okular::PageTransition::Wipe (enum)
	{44, 64, 0, 0, Smoke::mf_static|Smoke::mf_enum, 184, 6},	//712 Okular::PageTransition::Dissolve (enum)
	{44, 114, 0, 0, Smoke::mf_static|Smoke::mf_enum, 184, 7},	//713 Okular::PageTransition::Glitter (enum)
	{44, 99, 0, 0, Smoke::mf_static|Smoke::mf_enum, 184, 8},	//714 Okular::PageTransition::Fly (enum)
	{44, 209, 0, 0, Smoke::mf_static|Smoke::mf_enum, 184, 9},	//715 Okular::PageTransition::Push (enum)
	{44, 53, 0, 0, Smoke::mf_static|Smoke::mf_enum, 184, 10},	//716 Okular::PageTransition::Cover (enum)
	{44, 273, 0, 0, Smoke::mf_static|Smoke::mf_enum, 184, 11},	//717 Okular::PageTransition::Uncover (enum)
	{44, 90, 0, 0, Smoke::mf_static|Smoke::mf_enum, 184, 12},	//718 Okular::PageTransition::Fade (enum)
	{44, 132, 0, 0, Smoke::mf_static|Smoke::mf_enum, 182, 13},	//719 Okular::PageTransition::Horizontal (enum)
	{44, 279, 0, 0, Smoke::mf_static|Smoke::mf_enum, 182, 14},	//720 Okular::PageTransition::Vertical (enum)
	{44, 140, 0, 0, Smoke::mf_static|Smoke::mf_enum, 183, 15},	//721 Okular::PageTransition::Inward (enum)
	{44, 178, 0, 0, Smoke::mf_static|Smoke::mf_enum, 183, 16},	//722 Okular::PageTransition::Outward (enum)
	{44, 191, 74, 1, Smoke::mf_ctor, 181, 17},	//723 Okular::PageTransition::PageTransition(Okular::PageTransition::Type)
	{44, 191, 0, 0, Smoke::mf_ctor, 181, 18},	//724 Okular::PageTransition::PageTransition()
	{44, 191, 265, 1, Smoke::mf_copyctor|Smoke::mf_ctor, 181, 19},	//725 Okular::PageTransition::PageTransition(const Okular::PageTransition&)
	{44, 567, 265, 1, 0, 180, 20},	//726 Okular::PageTransition::operator=(const Okular::PageTransition&)
	{44, 986, 0, 0, Smoke::mf_dtor, 0, 35},	//727 Okular::PageTransition::~PageTransition()
	{44, 932, 0, 0, Smoke::mf_const, 184, 21},	//728 Okular::PageTransition::type() const
	{44, 411, 0, 0, Smoke::mf_const, 637, 22},	//729 Okular::PageTransition::duration() const
	{44, 307, 0, 0, Smoke::mf_const, 182, 23},	//730 Okular::PageTransition::alignment() const
	{44, 393, 0, 0, Smoke::mf_const, 183, 24},	//731 Okular::PageTransition::direction() const
	{44, 309, 0, 0, Smoke::mf_const, 637, 25},	//732 Okular::PageTransition::angle() const
	{44, 675, 0, 0, Smoke::mf_const, 635, 26},	//733 Okular::PageTransition::scale() const
	{44, 505, 0, 0, Smoke::mf_const, 545, 27},	//734 Okular::PageTransition::isRectangular() const
	{44, 842, 74, 1, 0, 0, 28},	//735 Okular::PageTransition::setType(Okular::PageTransition::Type)
	{44, 723, 430, 1, 0, 0, 29},	//736 Okular::PageTransition::setDuration(int)
	{44, 688, 70, 1, 0, 0, 30},	//737 Okular::PageTransition::setAlignment(Okular::PageTransition::Alignment)
	{44, 719, 72, 1, 0, 0, 31},	//738 Okular::PageTransition::setDirection(Okular::PageTransition::Direction)
	{44, 690, 430, 1, 0, 0, 32},	//739 Okular::PageTransition::setAngle(int)
	{44, 812, 402, 1, 0, 0, 33},	//740 Okular::PageTransition::setScale(double)
	{44, 756, 189, 1, 0, 0, 34},	//741 Okular::PageTransition::setIsRectangular(bool)
	{45, 195, 502, 6, Smoke::mf_ctor, 188, 1},	//742 Okular::PixmapRequest::PixmapRequest(int, int, int, int, int, bool)
	{45, 987, 0, 0, Smoke::mf_dtor, 0, 9},	//743 Okular::PixmapRequest::~PixmapRequest()
	{45, 482, 0, 0, Smoke::mf_const, 637, 2},	//744 Okular::PixmapRequest::id() const
	{45, 598, 0, 0, Smoke::mf_const, 637, 3},	//745 Okular::PixmapRequest::pageNumber() const
	{45, 947, 0, 0, Smoke::mf_const, 637, 4},	//746 Okular::PixmapRequest::width() const
	{45, 476, 0, 0, Smoke::mf_const, 637, 5},	//747 Okular::PixmapRequest::height() const
	{45, 625, 0, 0, Smoke::mf_const, 637, 6},	//748 Okular::PixmapRequest::priority() const
	{45, 317, 0, 0, Smoke::mf_const, 545, 7},	//749 Okular::PixmapRequest::asynchronous() const
	{45, 590, 0, 0, Smoke::mf_const, 176, 8},	//750 Okular::PixmapRequest::page() const
	{46, 988, 0, 0, Smoke::mf_dtor, 0, 4},	//751 Okular::PrintInterface::~PrintInterface()
	{46, 615, 0, 0, Smoke::mf_const, 450, 1},	//752 Okular::PrintInterface::printConfigurationWidget() const [pure virtual]
	{46, 203, 0, 0, Smoke::mf_ctor, 189, 2},	//753 Okular::PrintInterface::PrintInterface()
	{46, 203, 267, 1, Smoke::mf_copyctor|Smoke::mf_internal|Smoke::mf_ctor, 189, 3},	//754 Okular::PrintInterface::PrintInterface(const Okular::PrintInterface&)
	{47, 216, 0, 0, Smoke::mf_ctor, 191, 1},	//755 Okular::RegularAreaRect::RegularAreaRect()
	{47, 216, 269, 1, Smoke::mf_copyctor|Smoke::mf_ctor, 191, 2},	//756 Okular::RegularAreaRect::RegularAreaRect(const Okular::RegularAreaRect&)
	{47, 989, 0, 0, Smoke::mf_dtor, 0, 4},	//757 Okular::RegularAreaRect::~RegularAreaRect()
	{47, 567, 269, 1, 0, 190, 3},	//758 Okular::RegularAreaRect::operator=(const Okular::RegularAreaRect&)
	{48, 223, 85, 2, Smoke::mf_ctor, 193, 1},	//759 Okular::ScriptAction::ScriptAction(Okular::ScriptType, const QString&)
	{48, 990, 0, 0, Smoke::mf_dtor, 0, 6},	//760 Okular::ScriptAction::~ScriptAction()
	{48, 289, 0, 0, Smoke::mf_const, 101, 2},	//761 Okular::ScriptAction::actionType() const
	{48, 288, 0, 0, Smoke::mf_const, 384, 3},	//762 Okular::ScriptAction::actionTip() const
	{48, 677, 0, 0, Smoke::mf_const, 194, 4},	//763 Okular::ScriptAction::scriptType() const
	{48, 676, 0, 0, Smoke::mf_const, 384, 5},	//764 Okular::ScriptAction::script() const
	{49, 89, 0, 0, Smoke::mf_static|Smoke::mf_enum, 198, 1},	//765 Okular::Sound::External (enum)
	{49, 77, 0, 0, Smoke::mf_static|Smoke::mf_enum, 198, 2},	//766 Okular::Sound::Embedded (enum)
	{49, 214, 0, 0, Smoke::mf_static|Smoke::mf_enum, 197, 3},	//767 Okular::Sound::Raw (enum)
	{49, 226, 0, 0, Smoke::mf_static|Smoke::mf_enum, 197, 4},	//768 Okular::Sound::Signed (enum)
	{49, 544, 0, 0, Smoke::mf_static|Smoke::mf_enum, 197, 5},	//769 Okular::Sound::muLaw (enum)
	{49, 6, 0, 0, Smoke::mf_static|Smoke::mf_enum, 197, 6},	//770 Okular::Sound::ALaw (enum)
	{49, 229, 281, 1, Smoke::mf_ctor, 196, 7},	//771 Okular::Sound::Sound(const QByteArray&)
	{49, 229, 342, 1, Smoke::mf_ctor, 196, 8},	//772 Okular::Sound::Sound(const QString&)
	{49, 991, 0, 0, Smoke::mf_dtor, 0, 20},	//773 Okular::Sound::~Sound()
	{49, 881, 0, 0, Smoke::mf_const, 198, 9},	//774 Okular::Sound::soundType() const
	{49, 939, 0, 0, Smoke::mf_const, 384, 10},	//775 Okular::Sound::url() const
	{49, 377, 0, 0, Smoke::mf_const, 232, 11},	//776 Okular::Sound::data() const
	{49, 810, 402, 1, 0, 0, 12},	//777 Okular::Sound::setSamplingRate(double)
	{49, 670, 0, 0, Smoke::mf_const, 635, 13},	//778 Okular::Sound::samplingRate() const
	{49, 706, 430, 1, 0, 0, 14},	//779 Okular::Sound::setChannels(int)
	{49, 343, 0, 0, Smoke::mf_const, 637, 15},	//780 Okular::Sound::channels() const
	{49, 694, 430, 1, 0, 0, 16},	//781 Okular::Sound::setBitsPerSample(int)
	{49, 319, 0, 0, Smoke::mf_const, 637, 17},	//782 Okular::Sound::bitsPerSample() const
	{49, 818, 90, 1, 0, 0, 18},	//783 Okular::Sound::setSoundEncoding(Okular::Sound::SoundEncoding)
	{49, 879, 0, 0, Smoke::mf_const, 197, 19},	//784 Okular::Sound::soundEncoding() const
	{50, 232, 404, 5, Smoke::mf_ctor, 199, 1},	//785 Okular::SoundAction::SoundAction(double, bool, bool, bool, Okular::Sound*)
	{50, 992, 0, 0, Smoke::mf_dtor, 0, 9},	//786 Okular::SoundAction::~SoundAction()
	{50, 289, 0, 0, Smoke::mf_const, 101, 2},	//787 Okular::SoundAction::actionType() const
	{50, 288, 0, 0, Smoke::mf_const, 384, 3},	//788 Okular::SoundAction::actionTip() const
	{50, 943, 0, 0, Smoke::mf_const, 635, 4},	//789 Okular::SoundAction::volume() const
	{50, 902, 0, 0, Smoke::mf_const, 545, 5},	//790 Okular::SoundAction::synchronous() const
	{50, 652, 0, 0, Smoke::mf_const, 545, 6},	//791 Okular::SoundAction::repeat() const
	{50, 540, 0, 0, Smoke::mf_const, 545, 7},	//792 Okular::SoundAction::mix() const
	{50, 878, 0, 0, Smoke::mf_const, 196, 8},	//793 Okular::SoundAction::sound() const
	{51, 234, 0, 0, Smoke::mf_ctor, 200, 1},	//794 Okular::SoundAnnotation::SoundAnnotation()
	{51, 234, 297, 1, Smoke::mf_ctor, 200, 2},	//795 Okular::SoundAnnotation::SoundAnnotation(const QDomNode&)
	{51, 993, 0, 0, Smoke::mf_dtor, 0, 9},	//796 Okular::SoundAnnotation::~SoundAnnotation()
	{51, 880, 0, 0, Smoke::mf_const, 384, 3},	//797 Okular::SoundAnnotation::soundIconName() const
	{51, 820, 342, 1, 0, 0, 4},	//798 Okular::SoundAnnotation::setSoundIconName(const QString&)
	{51, 878, 0, 0, Smoke::mf_const, 196, 5},	//799 Okular::SoundAnnotation::sound() const
	{51, 816, 88, 1, 0, 0, 6},	//800 Okular::SoundAnnotation::setSound(Okular::Sound*)
	{51, 897, 0, 0, Smoke::mf_const, 109, 7},	//801 Okular::SoundAnnotation::subType() const
	{51, 892, 108, 2, Smoke::mf_const, 0, 8},	//802 Okular::SoundAnnotation::store(QDomNode&, QDomDocument&) const
	{52, 237, 246, 2, Smoke::mf_ctor, 201, 1},	//803 Okular::SourceRefObjectRect::SourceRefObjectRect(const Okular::NormalizedPoint&, void*)
	{52, 325, 410, 2, Smoke::mf_const, 375, 2},	//804 Okular::SourceRefObjectRect::boundingRect(double, double) const
	{52, 355, 417, 4, Smoke::mf_const, 545, 3},	//805 Okular::SourceRefObjectRect::contains(double, double, double, double) const
	{52, 994, 0, 0, Smoke::mf_dtor, 0, 5},	//806 Okular::SourceRefObjectRect::~SourceRefObjectRect()
	{52, 237, 273, 1, Smoke::mf_copyctor|Smoke::mf_internal|Smoke::mf_ctor, 201, 4},	//807 Okular::SourceRefObjectRect::SourceRefObjectRect(const Okular::SourceRefObjectRect&)
	{53, 240, 386, 3, Smoke::mf_ctor, 202, 1},	//808 Okular::SourceReference::SourceReference(const QString&, int, int)
	{53, 240, 383, 2, Smoke::mf_ctor, 202, 2},	//809 Okular::SourceReference::SourceReference(const QString&, int)
	{53, 995, 0, 0, Smoke::mf_dtor, 0, 6},	//810 Okular::SourceReference::~SourceReference()
	{53, 428, 0, 0, Smoke::mf_const, 384, 3},	//811 Okular::SourceReference::fileName() const
	{53, 669, 0, 0, Smoke::mf_const, 637, 4},	//812 Okular::SourceReference::row() const
	{53, 350, 0, 0, Smoke::mf_const, 637, 5},	//813 Okular::SourceReference::column() const
	{54, 246, 0, 0, Smoke::mf_ctor, 203, 1},	//814 Okular::StampAnnotation::StampAnnotation()
	{54, 246, 297, 1, Smoke::mf_ctor, 203, 2},	//815 Okular::StampAnnotation::StampAnnotation(const QDomNode&)
	{54, 996, 0, 0, Smoke::mf_dtor, 0, 7},	//816 Okular::StampAnnotation::~StampAnnotation()
	{54, 824, 342, 1, 0, 0, 3},	//817 Okular::StampAnnotation::setStampIconName(const QString&)
	{54, 882, 0, 0, Smoke::mf_const, 384, 4},	//818 Okular::StampAnnotation::stampIconName() const
	{54, 897, 0, 0, Smoke::mf_const, 109, 5},	//819 Okular::StampAnnotation::subType() const
	{54, 892, 108, 2, Smoke::mf_const, 0, 6},	//820 Okular::StampAnnotation::store(QDomNode&, QDomDocument&) const
	{55, 144, 0, 0, Smoke::mf_static|Smoke::mf_enum, 206, 1},	//821 Okular::TextAnnotation::Linked (enum)
	{55, 134, 0, 0, Smoke::mf_static|Smoke::mf_enum, 206, 2},	//822 Okular::TextAnnotation::InPlace (enum)
	{55, 275, 0, 0, Smoke::mf_static|Smoke::mf_enum, 205, 3},	//823 Okular::TextAnnotation::Unknown (enum)
	{55, 36, 0, 0, Smoke::mf_static|Smoke::mf_enum, 205, 4},	//824 Okular::TextAnnotation::Callout (enum)
	{55, 272, 0, 0, Smoke::mf_static|Smoke::mf_enum, 205, 5},	//825 Okular::TextAnnotation::TypeWriter (enum)
	{55, 252, 0, 0, Smoke::mf_ctor, 204, 6},	//826 Okular::TextAnnotation::TextAnnotation()
	{55, 252, 297, 1, Smoke::mf_ctor, 204, 7},	//827 Okular::TextAnnotation::TextAnnotation(const QDomNode&)
	{55, 997, 0, 0, Smoke::mf_dtor, 0, 25},	//828 Okular::TextAnnotation::~TextAnnotation()
	{55, 836, 94, 1, 0, 0, 8},	//829 Okular::TextAnnotation::setTextType(Okular::TextAnnotation::TextType)
	{55, 914, 0, 0, Smoke::mf_const, 206, 9},	//830 Okular::TextAnnotation::textType() const
	{55, 832, 342, 1, 0, 0, 10},	//831 Okular::TextAnnotation::setTextIcon(const QString&)
	{55, 909, 0, 0, Smoke::mf_const, 384, 11},	//832 Okular::TextAnnotation::textIcon() const
	{55, 830, 302, 1, 0, 0, 12},	//833 Okular::TextAnnotation::setTextFont(const QFont&)
	{55, 908, 0, 0, Smoke::mf_const, 275, 13},	//834 Okular::TextAnnotation::textFont() const
	{55, 748, 430, 1, 0, 0, 14},	//835 Okular::TextAnnotation::setInplaceAlignment(int)
	{55, 488, 0, 0, Smoke::mf_const, 637, 15},	//836 Okular::TextAnnotation::inplaceAlignment() const
	{55, 754, 342, 1, 0, 0, 16},	//837 Okular::TextAnnotation::setInplaceText(const QString&)
	{55, 492, 0, 0, Smoke::mf_const, 384, 17},	//838 Okular::TextAnnotation::inplaceText() const
	{55, 750, 243, 2, 0, 0, 18},	//839 Okular::TextAnnotation::setInplaceCallout(const Okular::NormalizedPoint&, int)
	{55, 489, 430, 1, Smoke::mf_const, 168, 19},	//840 Okular::TextAnnotation::inplaceCallout(int) const
	{55, 926, 430, 1, Smoke::mf_const, 168, 20},	//841 Okular::TextAnnotation::transformedInplaceCallout(int) const
	{55, 752, 92, 1, 0, 0, 21},	//842 Okular::TextAnnotation::setInplaceIntent(Okular::TextAnnotation::InplaceIntent)
	{55, 491, 0, 0, Smoke::mf_const, 205, 22},	//843 Okular::TextAnnotation::inplaceIntent() const
	{55, 897, 0, 0, Smoke::mf_const, 109, 23},	//844 Okular::TextAnnotation::subType() const
	{55, 892, 108, 2, Smoke::mf_const, 0, 24},	//845 Okular::TextAnnotation::store(QDomNode&, QDomDocument&) const
	{56, 538, 0, 0, Smoke::mf_const, 610, 2},	//846 Okular::TextDocumentConverter::metaObject() const
	{56, 633, 115, 3, 0, 637, 3},	//847 Okular::TextDocumentConverter::qt_metacall(QMetaObject::Call, int, void**)
	{56, 254, 0, 0, Smoke::mf_ctor, 207, 4},	//848 Okular::TextDocumentConverter::TextDocumentConverter()
	{56, 998, 0, 0, Smoke::mf_dtor, 0, 16},	//849 Okular::TextDocumentConverter::~TextDocumentConverter()
	{56, 362, 342, 1, 0, 414, 5},	//850 Okular::TextDocumentConverter::convert(const QString&) [pure virtual]
	{56, 291, 3, 3, 0, 0, 6},	//851 Okular::TextDocumentConverter::addAction(Okular::Action*, int, int)
	{56, 293, 9, 3, 0, 0, 7},	//852 Okular::TextDocumentConverter::addAnnotation(Okular::Annotation*, int, int)
	{56, 305, 482, 3, 0, 0, 8},	//853 Okular::TextDocumentConverter::addTitle(int, const QString&, const QTextBlock&)
	{56, 296, 376, 3, 0, 0, 9},	//854 Okular::TextDocumentConverter::addMetaData(const QString&, const QString&, const QString&)
	{56, 296, 17, 2, 0, 0, 10},	//855 Okular::TextDocumentConverter::addMetaData(Okular::DocumentInfo::Key, const QString&)
	{56, 415, 383, 2, 0, 0, 11},	//856 Okular::TextDocumentConverter::error(const QString&, int)
	{56, 944, 383, 2, 0, 0, 12},	//857 Okular::TextDocumentConverter::warning(const QString&, int)
	{56, 550, 383, 2, 0, 0, 13},	//858 Okular::TextDocumentConverter::notice(const QString&, int)
	{56, 890, 0, 0, Smoke::mf_static, 609, 1},	//859 Okular::TextDocumentConverter::staticMetaObject (static var)
	{56, 329, 182, 2, Smoke::mf_protected, 131, 14},	//860 Okular::TextDocumentConverter::calculateViewport(QTextDocument*, const QTextBlock&)
	{56, 453, 0, 0, Smoke::mf_const|Smoke::mf_protected, 208, 15},	//861 Okular::TextDocumentConverter::generator() const
	{57, 538, 0, 0, Smoke::mf_const, 610, 2},	//862 Okular::TextDocumentGenerator::metaObject() const
	{57, 633, 115, 3, 0, 637, 3},	//863 Okular::TextDocumentGenerator::qt_metacall(QMetaObject::Call, int, void**)
	{57, 255, 96, 3, Smoke::mf_ctor, 208, 4},	//864 Okular::TextDocumentGenerator::TextDocumentGenerator(Okular::TextDocumentConverter*, QObject*, const QList<QVariant>&)
	{57, 999, 0, 0, Smoke::mf_dtor, 0, 15},	//865 Okular::TextDocumentGenerator::~TextDocumentGenerator()
	{57, 525, 347, 2, 0, 545, 5},	//866 Okular::TextDocumentGenerator::loadDocument(const QString&, QVector<Okular::Page*>&)
	{57, 336, 0, 0, Smoke::mf_const, 545, 6},	//867 Okular::TextDocumentGenerator::canGeneratePixmap() const
	{57, 449, 78, 1, 0, 0, 7},	//868 Okular::TextDocumentGenerator::generatePixmap(Okular::PixmapRequest*)
	{57, 611, 125, 1, 0, 545, 8},	//869 Okular::TextDocumentGenerator::print(QPrinter&)
	{57, 421, 0, 0, Smoke::mf_const, 318, 9},	//870 Okular::TextDocumentGenerator::exportFormats() const
	{57, 422, 370, 2, 0, 545, 10},	//871 Okular::TextDocumentGenerator::exportTo(const QString&, const Okular::ExportFormat&)
	{57, 447, 0, 0, 0, 560, 11},	//872 Okular::TextDocumentGenerator::generateDocumentInfo()
	{57, 448, 0, 0, 0, 562, 12},	//873 Okular::TextDocumentGenerator::generateDocumentSynopsis()
	{57, 890, 0, 0, Smoke::mf_static, 609, 1},	//874 Okular::TextDocumentGenerator::staticMetaObject (static var)
	{57, 398, 0, 0, Smoke::mf_protected, 545, 13},	//875 Okular::TextDocumentGenerator::doCloseDocument()
	{57, 910, 58, 1, Smoke::mf_protected, 210, 14},	//876 Okular::TextDocumentGenerator::textPage(Okular::Page*)
	{58, 257, 344, 2, Smoke::mf_ctor, 209, 1},	//877 Okular::TextEntity::TextEntity(const QString&, Okular::NormalizedRect*)
	{58, 1000, 0, 0, Smoke::mf_dtor, 0, 5},	//878 Okular::TextEntity::~TextEntity()
	{58, 903, 0, 0, Smoke::mf_const, 384, 2},	//879 Okular::TextEntity::text() const
	{58, 316, 0, 0, Smoke::mf_const, 173, 3},	//880 Okular::TextEntity::area() const
	{58, 922, 325, 1, Smoke::mf_const, 171, 4},	//881 Okular::TextEntity::transformedArea(const QMatrix&) const
	{59, 260, 0, 0, Smoke::mf_ctor, 210, 1},	//882 Okular::TextPage::TextPage()
	{59, 260, 319, 1, Smoke::mf_ctor, 210, 2},	//883 Okular::TextPage::TextPage(const QList<Okular::TextEntity*>&)
	{59, 1001, 0, 0, Smoke::mf_dtor, 0, 8},	//884 Okular::TextPage::~TextPage()
	{59, 314, 344, 2, 0, 0, 3},	//885 Okular::TextPage::append(const QString&, Okular::NormalizedRect*)
	{59, 433, 459, 5, 0, 191, 4},	//886 Okular::TextPage::findText(int, const QString&, Okular::SearchDirection, Qt::CaseSensitivity, const Okular::RegularAreaRect*)
	{59, 903, 271, 1, Smoke::mf_const, 384, 5},	//887 Okular::TextPage::text(const Okular::RegularAreaRect*) const
	{59, 903, 0, 0, Smoke::mf_const, 384, 6},	//888 Okular::TextPage::text() const
	{59, 906, 102, 1, Smoke::mf_const, 191, 7},	//889 Okular::TextPage::textArea(Okular::TextSelection*) const
	{60, 277, 0, 0, Smoke::mf_ctor, 212, 1},	//890 Okular::Utils::Utils()
	{60, 1002, 0, 0, Smoke::mf_dtor, 0, 9},	//891 Okular::Utils::~Utils()
	{60, 277, 277, 1, Smoke::mf_copyctor|Smoke::mf_internal|Smoke::mf_ctor, 212, 2},	//892 Okular::Utils::Utils(const Okular::Utils&)
	{60, 664, 335, 4, Smoke::mf_static, 375, 3},	//893 Okular::Utils::rotateRect(const QRect&, int, int, int)
	{60, 409, 0, 0, Smoke::mf_static, 635, 4},	//894 Okular::Utils::dpiX()
	{60, 410, 0, 0, Smoke::mf_static, 635, 5},	//895 Okular::Utils::dpiY()
	{60, 637, 0, 0, Smoke::mf_static, 635, 6},	//896 Okular::Utils::realDpiX()
	{60, 638, 0, 0, Smoke::mf_static, 635, 7},	//897 Okular::Utils::realDpiY()
	{60, 485, 304, 1, Smoke::mf_static, 171, 8},	//898 Okular::Utils::imageBoundingBox(const QImage*)
	{61, 280, 448, 2, Smoke::mf_ctor, 214, 3},	//899 Okular::VisiblePageRect::VisiblePageRect(int, const Okular::NormalizedRect&)
	{61, 280, 430, 1, Smoke::mf_ctor, 214, 4},	//900 Okular::VisiblePageRect::VisiblePageRect(int)
	{61, 280, 0, 0, Smoke::mf_ctor, 214, 5},	//901 Okular::VisiblePageRect::VisiblePageRect()
	{61, 795, 430, 1, 0, 0, 6},	//902 Okular::VisiblePageRect::setPageNumber(int)
	{61, 804, 43, 1, 0, 0, 7},	//903 Okular::VisiblePageRect::setRect(Okular::NormalizedRect)
	{61, 1003, 0, 0, Smoke::mf_dtor, 0, 9},	//904 Okular::VisiblePageRect::~VisiblePageRect()
	{61, 280, 279, 1, Smoke::mf_copyctor|Smoke::mf_internal|Smoke::mf_ctor, 214, 8},	//905 Okular::VisiblePageRect::VisiblePageRect(const Okular::VisiblePageRect&)
	{61, 598, 0, 0, 0, 637, 1},	//906 Okular::VisiblePageRect::pageNumber (var)
	{61, 639, 0, 0, 0, 171, 2},	//907 Okular::VisiblePageRect::rect (var)
	{90, 538, 0, 0, Smoke::mf_const, 610, 2},	//908 QObject::metaObject() const
	{90, 633, 115, 3, 0, 637, 3},	//909 QObject::qt_metacall(QMetaObject::Call, int, void**)
	{90, 417, 111, 1, 0, 545, 6},	//910 QObject::event(QEvent*)
	{90, 419, 119, 2, 0, 545, 7},	//911 QObject::eventFilter(QObject*, QEvent*)
	{90, 915, 185, 1, Smoke::mf_protected, 0, 49},	//912 QObject::timerEvent(QTimerEvent*)
	{90, 344, 106, 1, Smoke::mf_protected, 0, 50},	//913 QObject::childEvent(QChildEvent*)
	{90, 375, 111, 1, Smoke::mf_protected, 0, 51},	//914 QObject::customEvent(QEvent*)
	{90, 353, 400, 1, Smoke::mf_protected, 0, 52},	//915 QObject::connectNotify(const char*)
	{90, 394, 400, 1, Smoke::mf_protected, 0, 53},	//916 QObject::disconnectNotify(const char*)
};

// Class ID, munged name ID (index into methodNames), method def (see methods) if >0 or number of overloads if <0
static Smoke::MethodMap okular_methodMaps[] = {
	{ 0, 0, 0 },	//0 (no method)
	{8, 27, 19},	//1 Okular::Action::Browse
	{8, 65, 20},	//2 Okular::Action::DocAction
	{8, 82, 18},	//3 Okular::Action::Execute
	{8, 118, 17},	//4 Okular::Action::Goto
	{8, 150, 22},	//5 Okular::Action::Movie
	{8, 222, 23},	//6 Okular::Action::Script
	{8, 229, 21},	//7 Okular::Action::Sound
	{8, 288, 26},	//8 Okular::Action::actionTip
	{8, 289, 25},	//9 Okular::Action::actionType
	{8, 952, 24},	//10 Okular::Action::~Action
	{9, 1, 33},	//11 Okular::Annotation::ACaret
	{9, 2, 34},	//12 Okular::Annotation::AFileAttachment
	{9, 3, 29},	//13 Okular::Annotation::AGeom
	{9, 4, 30},	//14 Okular::Annotation::AHighlight
	{9, 5, 32},	//15 Okular::Annotation::AInk
	{9, 7, 28},	//16 Okular::Annotation::ALine
	{9, 8, 36},	//17 Okular::Annotation::AMovie
	{9, 9, 35},	//18 Okular::Annotation::ASound
	{9, 10, 31},	//19 Okular::Annotation::AStamp
	{9, 11, 27},	//20 Okular::Annotation::AText
	{9, 12, 37},	//21 Okular::Annotation::A_BASE
	{9, 13, 59},	//22 Okular::Annotation::Accepted
	{9, 24, 48},	//23 Okular::Annotation::Beveled
	{9, 37, 61},	//24 Okular::Annotation::Cancelled
	{9, 47, 52},	//25 Okular::Annotation::Cloudy
	{9, 49, 62},	//26 Okular::Annotation::Completed
	{9, 56, 47},	//27 Okular::Annotation::Dashed
	{9, 57, 55},	//28 Okular::Annotation::Delete
	{9, 58, 43},	//29 Okular::Annotation::DenyDelete
	{9, 59, 41},	//30 Okular::Annotation::DenyPrint
	{9, 60, 42},	//31 Okular::Annotation::DenyWrite
	{9, 89, 45},	//32 Okular::Annotation::External
	{9, 97, 40},	//33 Okular::Annotation::FixedRotation
	{9, 98, 39},	//34 Okular::Annotation::FixedSize
	{9, 122, 54},	//35 Okular::Annotation::Group
	{9, 126, 38},	//36 Okular::Annotation::Hidden
	{9, 139, 49},	//37 Okular::Annotation::Inset
	{9, 146, 57},	//38 Okular::Annotation::Marked
	{9, 154, 51},	//39 Okular::Annotation::NoEffect
	{9, 158, 56},	//40 Okular::Annotation::None
	{9, 218, 60},	//41 Okular::Annotation::Rejected
	{9, 221, 53},	//42 Okular::Annotation::Reply
	{9, 228, 46},	//43 Okular::Annotation::Solid
	{9, 264, 44},	//44 Okular::Annotation::ToggleHidingOnMouse
	{9, 274, 50},	//45 Okular::Annotation::Underline
	{9, 276, 58},	//46 Okular::Annotation::Unmarked
	{9, 318, 65},	//47 Okular::Annotation::author
	{9, 327, 77},	//48 Okular::Annotation::boundingRectangle
	{9, 332, 86},	//49 Okular::Annotation::canBeMoved
	{9, 358, 67},	//50 Okular::Annotation::contents
	{9, 368, 73},	//51 Okular::Annotation::creationDate
	{9, 436, 75},	//52 Okular::Annotation::flags
	{9, 541, 71},	//53 Okular::Annotation::modificationDate
	{9, 547, 84},	//54 Okular::Annotation::nativeId
	{9, 662, 82},	//55 Okular::Annotation::revisions
	{9, 693, 64},	//56 Okular::Annotation::setAuthor$
	{9, 701, 76},	//57 Okular::Annotation::setBoundingRectangle#
	{9, 711, 66},	//58 Okular::Annotation::setContents$
	{9, 713, 72},	//59 Okular::Annotation::setCreationDate#
	{9, 722, 85},	//60 Okular::Annotation::setDisposeDataFunction?
	{9, 737, 74},	//61 Okular::Annotation::setFlags$
	{9, 781, 70},	//62 Okular::Annotation::setModificationDate#
	{9, 785, 83},	//63 Okular::Annotation::setNativeId#
	{9, 845, 68},	//64 Okular::Annotation::setUniqueName$
	{9, 893, 88},	//65 Okular::Annotation::store##
	{9, 896, 80},	//66 Okular::Annotation::style
	{9, 897, 87},	//67 Okular::Annotation::subType
	{9, 924, 78},	//68 Okular::Annotation::transformedBoundingRectangle
	{9, 931, 79},	//69 Okular::Annotation::translate#
	{9, 934, 69},	//70 Okular::Annotation::uniqueName
	{9, 948, 81},	//71 Okular::Annotation::window
	{9, 953, 63},	//72 Okular::Annotation::~Annotation
	{12, 17, -1},	//73 Okular::AnnotationObjectRect::AnnotationObjectRect#
	{12, 310, 91},	//74 Okular::AnnotationObjectRect::annotation
	{12, 326, 92},	//75 Okular::AnnotationObjectRect::boundingRect$$
	{12, 357, 93},	//76 Okular::AnnotationObjectRect::contains$$$$
	{12, 921, 94},	//77 Okular::AnnotationObjectRect::transform#
	{12, 954, 90},	//78 Okular::AnnotationObjectRect::~AnnotationObjectRect
	{13, 18, 96},	//79 Okular::AnnotationUtils::AnnotationUtils
	{13, 19, 98},	//80 Okular::AnnotationUtils::AnnotationUtils#
	{13, 312, 102},	//81 Okular::AnnotationUtils::annotationGeometry#$$
	{13, 367, 99},	//82 Okular::AnnotationUtils::createAnnotation#
	{13, 432, 101},	//83 Okular::AnnotationUtils::findChildElement#$
	{13, 895, 100},	//84 Okular::AnnotationUtils::storeAnnotation###
	{13, 955, 97},	//85 Okular::AnnotationUtils::~AnnotationUtils
	{14, 29, 103},	//86 Okular::BrowseAction::BrowseAction$
	{14, 288, 106},	//87 Okular::BrowseAction::actionTip
	{14, 289, 105},	//88 Okular::BrowseAction::actionType
	{14, 939, 107},	//89 Okular::BrowseAction::url
	{14, 956, 104},	//90 Okular::BrowseAction::~BrowseAction
	{15, 38, 110},	//91 Okular::CaretAnnotation::CaretAnnotation
	{15, 39, 111},	//92 Okular::CaretAnnotation::CaretAnnotation#
	{15, 158, 108},	//93 Okular::CaretAnnotation::None
	{15, 179, 109},	//94 Okular::CaretAnnotation::P
	{15, 342, 114},	//95 Okular::CaretAnnotation::caretSymbol
	{15, 705, 113},	//96 Okular::CaretAnnotation::setCaretSymbol$
	{15, 893, 116},	//97 Okular::CaretAnnotation::store##
	{15, 897, 115},	//98 Okular::CaretAnnotation::subType
	{15, 957, 112},	//99 Okular::CaretAnnotation::~CaretAnnotation
	{16, 50, 120},	//100 Okular::ConfigInterface::ConfigInterface
	{16, 51, 121},	//101 Okular::ConfigInterface::ConfigInterface#
	{16, 304, 119},	//102 Okular::ConfigInterface::addPages#
	{16, 651, 118},	//103 Okular::ConfigInterface::reparseConfig
	{16, 958, 117},	//104 Okular::ConfigInterface::~ConfigInterface
	{17, 15, 126},	//105 Okular::Document::AllDocument
	{17, 67, 137},	//106 Okular::Document::Document#
	{17, 116, 127},	//107 Okular::Document::GoogleAll
	{17, 117, 128},	//108 Okular::Document::GoogleAny
	{17, 147, 129},	//109 Okular::Document::MatchFound
	{17, 152, 133},	//110 Okular::Document::NativePrinting
	{17, 153, 124},	//111 Okular::Document::NextMatch
	{17, 155, 130},	//112 Okular::Document::NoMatchFound
	{17, 156, 122},	//113 Okular::Document::NoOption
	{17, 157, 132},	//114 Okular::Document::NoPrinting
	{17, 200, 134},	//115 Okular::Document::PostscriptPrinting
	{17, 202, 125},	//116 Okular::Document::PreviousMatch
	{17, 219, 123},	//117 Okular::Document::RemoveAllPrevious
	{17, 225, 131},	//118 Okular::Document::SearchCancelled
	{17, 300, 141},	//119 Okular::Document::addObserver?
	{17, 302, 191},	//120 Okular::Document::addPageAnnotation$#
	{17, 308, 173},	//121 Okular::Document::allPagesSize
	{17, 320, 201},	//122 Okular::Document::bookmarkManager
	{17, 321, 203},	//123 Okular::Document::bookmarkedPageList
	{17, 322, 204},	//124 Okular::Document::bookmarkedPageRange
	{17, 334, 206},	//125 Okular::Document::canConfigurePrinter
	{17, 335, 164},	//126 Okular::Document::canExportToText
	{17, 338, 150},	//127 Okular::Document::canProvideFontInformation
	{17, 339, 215},	//128 Okular::Document::canSaveChanges
	{17, 340, 224},	//129 Okular::Document::cancelSearch
	{17, 348, 225},	//130 Okular::Document::close
	{17, 349, 140},	//131 Okular::Document::closeDocument
	{17, 351, 214},	//132 Okular::Document::componentData
	{17, 352, 212},	//133 Okular::Document::configurableGenerators
	{17, 360, 198},	//134 Okular::Document::continueSearch$
	{17, 361, 199},	//135 Okular::Document::continueSearch$$
	{17, 373, 159},	//136 Okular::Document::currentDocument
	{17, 374, 157},	//137 Okular::Document::currentPage
	{17, 403, 146},	//138 Okular::Document::documentInfo
	{17, 407, 147},	//139 Okular::Document::documentSynopsis
	{17, 414, 151},	//140 Okular::Document::embeddedFiles
	{17, 416, 232},	//141 Okular::Document::error$$
	{17, 421, 166},	//142 Okular::Document::exportFormats
	{17, 423, 167},	//143 Okular::Document::exportTo$#
	{17, 425, 165},	//144 Okular::Document::exportToText$
	{17, 430, 211},	//145 Okular::Document::fillConfigDialog#
	{17, 438, 219},	//146 Okular::Document::fontData#
	{17, 439, 237},	//147 Okular::Document::fontReadingEnded
	{17, 441, 236},	//148 Okular::Document::fontReadingProgress$
	{17, 461, 235},	//149 Okular::Document::gotFont#
	{17, 462, 175},	//150 Okular::Document::guiClient
	{17, 479, 168},	//151 Okular::Document::historyAtBegin
	{17, 480, 169},	//152 Okular::Document::historyAtEnd
	{17, 497, 160},	//153 Okular::Document::isAllowed$
	{17, 502, 145},	//154 Okular::Document::isOpened
	{17, 521, 230},	//155 Okular::Document::linkEndPresentation
	{17, 522, 227},	//156 Okular::Document::linkFind
	{17, 523, 228},	//157 Okular::Document::linkGoToPage
	{17, 524, 229},	//158 Okular::Document::linkPresentation
	{17, 536, 171},	//159 Okular::Document::metaData$
	{17, 537, 170},	//160 Okular::Document::metaData$#
	{17, 538, 135},	//161 Okular::Document::metaObject
	{17, 543, 192},	//162 Okular::Document::modifyPageAnnotation$#
	{17, 551, 234},	//163 Okular::Document::notice$$
	{17, 558, 139},	//164 Okular::Document::openDocument$#?
	{17, 560, 220},	//165 Okular::Document::openDocumentArchive$#
	{17, 562, 231},	//166 Okular::Document::openUrl#
	{17, 591, 152},	//167 Okular::Document::page$
	{17, 604, 174},	//168 Okular::Document::pageSizeString$
	{17, 605, 163},	//169 Okular::Document::pageSizes
	{17, 606, 158},	//170 Okular::Document::pages
	{17, 612, 209},	//171 Okular::Document::print#
	{17, 615, 210},	//172 Okular::Document::printConfigurationWidget
	{17, 624, 207},	//173 Okular::Document::printingSupport
	{17, 627, 202},	//174 Okular::Document::processAction#
	{17, 629, 205},	//175 Okular::Document::processSourceReference#
	{17, 634, 136},	//176 Okular::Document::qt_metacall$$?
	{17, 635, 226},	//177 Okular::Document::quit
	{17, 642, 217},	//178 Okular::Document::registerView?
	{17, 646, 142},	//179 Okular::Document::removeObserver?
	{17, 648, 193},	//180 Okular::Document::removePageAnnotation$#
	{17, 650, 194},	//181 Okular::Document::removePageAnnotations$?
	{17, 651, 143},	//182 Okular::Document::reparseConfig
	{17, 656, 188},	//183 Okular::Document::requestPixmaps?
	{17, 657, 189},	//184 Okular::Document::requestPixmaps?$
	{17, 659, 190},	//185 Okular::Document::requestTextPage$
	{17, 661, 200},	//186 Okular::Document::resetSearch$
	{17, 666, 172},	//187 Okular::Document::rotation
	{17, 672, 216},	//188 Okular::Document::saveChanges$
	{17, 674, 221},	//189 Okular::Document::saveDocumentArchive$
	{17, 679, 238},	//190 Okular::Document::searchFinished$$
	{17, 681, 197},	//191 Okular::Document::searchText$$$$$$#
	{17, 682, 196},	//192 Okular::Document::searchText$$$$$$#$
	{17, 787, 185},	//193 Okular::Document::setNextDocumentDestination$
	{17, 789, 184},	//194 Okular::Document::setNextDocumentViewport#
	{17, 790, 183},	//195 Okular::Document::setNextViewport
	{17, 798, 223},	//196 Okular::Document::setPageSize#
	{17, 800, 195},	//197 Okular::Document::setPageTextSelection$##
	{17, 803, 182},	//198 Okular::Document::setPrevViewport
	{17, 809, 222},	//199 Okular::Document::setRotation$
	{17, 847, 181},	//200 Okular::Document::setViewport#
	{17, 848, 180},	//201 Okular::Document::setViewport#$
	{17, 849, 179},	//202 Okular::Document::setViewport#$$
	{17, 851, 178},	//203 Okular::Document::setViewportPage$
	{17, 852, 177},	//204 Okular::Document::setViewportPage$$
	{17, 853, 176},	//205 Okular::Document::setViewportPage$$$
	{17, 855, 155},	//206 Okular::Document::setVisiblePageRects?
	{17, 856, 154},	//207 Okular::Document::setVisiblePageRects?$
	{17, 869, 187},	//208 Okular::Document::setZoom$
	{17, 870, 186},	//209 Okular::Document::setZoom$$
	{17, 885, 148},	//210 Okular::Document::startFontReading
	{17, 890, 239},	//211 Okular::Document::staticMetaObject
	{17, 891, 149},	//212 Okular::Document::stopFontReading
	{17, 898, 213},	//213 Okular::Document::supportedMimeTypes
	{17, 899, 162},	//214 Okular::Document::supportsPageSizes
	{17, 900, 208},	//215 Okular::Document::supportsPrintToFile
	{17, 901, 161},	//216 Okular::Document::supportsSearching
	{17, 936, 218},	//217 Okular::Document::unregisterView?
	{17, 941, 153},	//218 Okular::Document::viewport
	{17, 942, 156},	//219 Okular::Document::visiblePageRects
	{17, 945, 233},	//220 Okular::Document::warning$$
	{17, 946, 144},	//221 Okular::Document::widget
	{17, 959, 138},	//222 Okular::Document::~Document
	{18, 44, 251},	//223 Okular::DocumentAction::Close
	{18, 69, 252},	//224 Okular::DocumentAction::DocumentAction$
	{18, 81, 248},	//225 Okular::DocumentAction::EndPresentation
	{18, 96, 249},	//226 Okular::DocumentAction::Find
	{18, 115, 250},	//227 Okular::DocumentAction::GoToPage
	{18, 130, 244},	//228 Okular::DocumentAction::HistoryBack
	{18, 131, 245},	//229 Okular::DocumentAction::HistoryForward
	{18, 183, 240},	//230 Okular::DocumentAction::PageFirst
	{18, 184, 243},	//231 Okular::DocumentAction::PageLast
	{18, 185, 242},	//232 Okular::DocumentAction::PageNext
	{18, 186, 241},	//233 Okular::DocumentAction::PagePrev
	{18, 201, 247},	//234 Okular::DocumentAction::Presentation
	{18, 210, 246},	//235 Okular::DocumentAction::Quit
	{18, 288, 255},	//236 Okular::DocumentAction::actionTip
	{18, 289, 254},	//237 Okular::DocumentAction::actionType
	{18, 402, 256},	//238 Okular::DocumentAction::documentActionType
	{18, 960, 253},	//239 Okular::DocumentAction::~DocumentAction
	{19, 23, 260},	//240 Okular::DocumentInfo::Author
	{19, 40, 268},	//241 Okular::DocumentInfo::Category
	{19, 52, 263},	//242 Okular::DocumentInfo::Copyright
	{19, 54, 265},	//243 Okular::DocumentInfo::CreationDate
	{19, 55, 261},	//244 Okular::DocumentInfo::Creator
	{19, 61, 259},	//245 Okular::DocumentInfo::Description
	{19, 70, 270},	//246 Okular::DocumentInfo::DocumentInfo
	{19, 71, 276},	//247 Okular::DocumentInfo::DocumentInfo#
	{19, 141, 269},	//248 Okular::DocumentInfo::Keywords
	{19, 148, 267},	//249 Okular::DocumentInfo::MimeType
	{19, 149, 266},	//250 Okular::DocumentInfo::ModificationDate
	{19, 194, 264},	//251 Okular::DocumentInfo::Pages
	{19, 208, 262},	//252 Okular::DocumentInfo::Producer
	{19, 249, 258},	//253 Okular::DocumentInfo::Subject
	{19, 263, 257},	//254 Okular::DocumentInfo::Title
	{19, 459, 274},	//255 Okular::DocumentInfo::get$
	{19, 684, -4},	//256 Okular::DocumentInfo::set$$
	{19, 685, 271},	//257 Okular::DocumentInfo::set$$$
	{19, 961, 275},	//258 Okular::DocumentInfo::~DocumentInfo
	{20, 72, 277},	//259 Okular::DocumentSynopsis::DocumentSynopsis
	{20, 73, -7},	//260 Okular::DocumentSynopsis::DocumentSynopsis#
	{20, 962, 279},	//261 Okular::DocumentSynopsis::~DocumentSynopsis
	{21, 41, 281},	//262 Okular::DocumentViewport::Center
	{21, 74, 284},	//263 Okular::DocumentViewport::DocumentViewport
	{21, 75, 291},	//264 Okular::DocumentViewport::DocumentViewport#
	{21, 76, -10},	//265 Okular::DocumentViewport::DocumentViewport$
	{21, 265, 282},	//266 Okular::DocumentViewport::TopLeft
	{21, 507, 287},	//267 Okular::DocumentViewport::isValid
	{21, 570, 288},	//268 Okular::DocumentViewport::operator==#
	{21, 598, 292},	//269 Okular::DocumentViewport::pageNumber
	{21, 796, 289},	//270 Okular::DocumentViewport::setPageNumber$
	{21, 917, 286},	//271 Okular::DocumentViewport::toString
	{21, 963, 290},	//272 Okular::DocumentViewport::~DocumentViewport
	{22, 78, 293},	//273 Okular::EmbeddedFile::EmbeddedFile
	{22, 79, 301},	//274 Okular::EmbeddedFile::EmbeddedFile#
	{22, 368, 300},	//275 Okular::EmbeddedFile::creationDate
	{22, 377, 297},	//276 Okular::EmbeddedFile::data
	{22, 386, 296},	//277 Okular::EmbeddedFile::description
	{22, 541, 299},	//278 Okular::EmbeddedFile::modificationDate
	{22, 546, 295},	//279 Okular::EmbeddedFile::name
	{22, 877, 298},	//280 Okular::EmbeddedFile::size
	{22, 964, 294},	//281 Okular::EmbeddedFile::~EmbeddedFile
	{23, 84, 302},	//282 Okular::ExecuteAction::ExecuteAction$$
	{23, 288, 305},	//283 Okular::ExecuteAction::actionTip
	{23, 289, 304},	//284 Okular::ExecuteAction::actionType
	{23, 428, 306},	//285 Okular::ExecuteAction::fileName
	{23, 609, 307},	//286 Okular::ExecuteAction::parameters
	{23, 965, 303},	//287 Okular::ExecuteAction::~ExecuteAction
	{24, 85, 312},	//288 Okular::ExportFormat::ExportFormat
	{24, 86, 316},	//289 Okular::ExportFormat::ExportFormat#
	{24, 87, 314},	//290 Okular::ExportFormat::ExportFormat#$?
	{24, 88, 313},	//291 Okular::ExportFormat::ExportFormat$?
	{24, 125, 311},	//292 Okular::ExportFormat::HTML
	{24, 176, 310},	//293 Okular::ExportFormat::OpenDocumentText
	{24, 180, 309},	//294 Okular::ExportFormat::PDF
	{24, 197, 308},	//295 Okular::ExportFormat::PlainText
	{24, 386, 318},	//296 Okular::ExportFormat::description
	{24, 481, 320},	//297 Okular::ExportFormat::icon
	{24, 501, 321},	//298 Okular::ExportFormat::isNull
	{24, 539, 319},	//299 Okular::ExportFormat::mimeType
	{24, 564, 323},	//300 Okular::ExportFormat::operator!=#
	{24, 568, 317},	//301 Okular::ExportFormat::operator=#
	{24, 570, 322},	//302 Okular::ExportFormat::operator==#
	{24, 884, 324},	//303 Okular::ExportFormat::standardFormat$
	{24, 966, 315},	//304 Okular::ExportFormat::~ExportFormat
	{25, 91, 325},	//305 Okular::FileAttachmentAnnotation::FileAttachmentAnnotation
	{25, 92, 326},	//306 Okular::FileAttachmentAnnotation::FileAttachmentAnnotation#
	{25, 413, 330},	//307 Okular::FileAttachmentAnnotation::embeddedFile
	{25, 427, 328},	//308 Okular::FileAttachmentAnnotation::fileIconName
	{25, 728, 331},	//309 Okular::FileAttachmentAnnotation::setEmbeddedFile#
	{25, 735, 329},	//310 Okular::FileAttachmentAnnotation::setFileIconName$
	{25, 893, 333},	//311 Okular::FileAttachmentAnnotation::store##
	{25, 897, 332},	//312 Okular::FileAttachmentAnnotation::subType
	{25, 967, 327},	//313 Okular::FileAttachmentAnnotation::~FileAttachmentAnnotation
	{26, 20, 334},	//314 Okular::FilePrinter::ApplicationDeletesFiles
	{26, 21, 336},	//315 Okular::FilePrinter::ApplicationSelectsPages
	{26, 93, 338},	//316 Okular::FilePrinter::FilePrinter
	{26, 94, 340},	//317 Okular::FilePrinter::FilePrinter#
	{26, 250, 335},	//318 Okular::FilePrinter::SystemDeletesFiles
	{26, 251, 337},	//319 Okular::FilePrinter::SystemSelectsPages
	{26, 365, 359},	//320 Okular::FilePrinter::copies#$
	{26, 369, 352},	//321 Okular::FilePrinter::cupsAvailable
	{26, 371, 363},	//322 Okular::FilePrinter::cupsOptions#
	{26, 380, 361},	//323 Okular::FilePrinter::deleteFile#$$
	{26, 389, 358},	//324 Okular::FilePrinter::destination#$
	{26, 391, 355},	//325 Okular::FilePrinter::detectCupsConfig
	{26, 392, 354},	//326 Okular::FilePrinter::detectCupsService
	{26, 400, 356},	//327 Okular::FilePrinter::doPrintFiles#?$$$
	{26, 510, 360},	//328 Okular::FilePrinter::jobname#$
	{26, 532, 365},	//329 Okular::FilePrinter::mediaPageSize#
	{26, 534, 366},	//330 Okular::FilePrinter::mediaPaperSource#
	{26, 576, 370},	//331 Okular::FilePrinter::optionCollateCopies#
	{26, 578, 372},	//332 Okular::FilePrinter::optionCupsProperties#
	{26, 580, 368},	//333 Okular::FilePrinter::optionDoubleSidedPrinting#
	{26, 582, 364},	//334 Okular::FilePrinter::optionMedia#
	{26, 584, 367},	//335 Okular::FilePrinter::optionOrientation#
	{26, 586, 371},	//336 Okular::FilePrinter::optionPageMargins#
	{26, 588, 369},	//337 Okular::FilePrinter::optionPageOrder#
	{26, 595, 347},	//338 Okular::FilePrinter::pageList#$?
	{26, 597, 349},	//339 Okular::FilePrinter::pageListToPageRange?
	{26, 600, 348},	//340 Okular::FilePrinter::pageRange#$?
	{26, 607, 362},	//341 Okular::FilePrinter::pages#$$$$
	{26, 610, 351},	//342 Okular::FilePrinter::pdf2psAvailable
	{26, 614, 357},	//343 Okular::FilePrinter::printArguments#$$$$$
	{26, 617, 344},	//344 Okular::FilePrinter::printFile#$
	{26, 618, 343},	//345 Okular::FilePrinter::printFile#$$
	{26, 619, 342},	//346 Okular::FilePrinter::printFile#$$$
	{26, 620, 341},	//347 Okular::FilePrinter::printFile#$$$$
	{26, 622, 346},	//348 Okular::FilePrinter::printFiles#?
	{26, 623, 345},	//349 Okular::FilePrinter::printFiles#?$
	{26, 630, 350},	//350 Okular::FilePrinter::ps2pdfAvailable
	{26, 632, 353},	//351 Okular::FilePrinter::psPaperSize#
	{26, 968, 339},	//352 Okular::FilePrinter::~FilePrinter
	{27, 31, 383},	//353 Okular::FontInfo::CIDTrueType
	{27, 32, 384},	//354 Okular::FontInfo::CIDTrueTypeOT
	{27, 33, 380},	//355 Okular::FontInfo::CIDType0
	{27, 34, 381},	//356 Okular::FontInfo::CIDType0C
	{27, 35, 382},	//357 Okular::FontInfo::CIDType0COT
	{27, 80, 386},	//358 Okular::FontInfo::EmbeddedSubset
	{27, 100, 388},	//359 Okular::FontInfo::FontInfo
	{27, 101, 389},	//360 Okular::FontInfo::FontInfo#
	{27, 109, 387},	//361 Okular::FontInfo::FullyEmbedded
	{27, 168, 385},	//362 Okular::FontInfo::NotEmbedded
	{27, 266, 378},	//363 Okular::FontInfo::TrueType
	{27, 267, 379},	//364 Okular::FontInfo::TrueTypeOT
	{27, 268, 374},	//365 Okular::FontInfo::Type1
	{27, 269, 375},	//366 Okular::FontInfo::Type1C
	{27, 270, 376},	//367 Okular::FontInfo::Type1COT
	{27, 271, 377},	//368 Okular::FontInfo::Type3
	{27, 275, 373},	//369 Okular::FontInfo::Unknown
	{27, 331, 399},	//370 Okular::FontInfo::canBeExtracted
	{27, 412, 395},	//371 Okular::FontInfo::embedType
	{27, 426, 397},	//372 Okular::FontInfo::file
	{27, 546, 391},	//373 Okular::FontInfo::name
	{27, 547, 402},	//374 Okular::FontInfo::nativeId
	{27, 564, 405},	//375 Okular::FontInfo::operator!=#
	{27, 568, 403},	//376 Okular::FontInfo::operator=#
	{27, 570, 404},	//377 Okular::FontInfo::operator==#
	{27, 703, 400},	//378 Okular::FontInfo::setCanBeExtracted$
	{27, 726, 396},	//379 Okular::FontInfo::setEmbedType$
	{27, 733, 398},	//380 Okular::FontInfo::setFile$
	{27, 783, 392},	//381 Okular::FontInfo::setName$
	{27, 785, 401},	//382 Okular::FontInfo::setNativeId#
	{27, 843, 394},	//383 Okular::FontInfo::setType$
	{27, 932, 393},	//384 Okular::FontInfo::type
	{27, 969, 390},	//385 Okular::FontInfo::~FontInfo
	{28, 102, 406},	//386 Okular::FormField::FormButton
	{28, 103, 408},	//387 Okular::FormField::FormChoice
	{28, 107, 409},	//388 Okular::FormField::FormSignature
	{28, 108, 407},	//389 Okular::FormField::FormText
	{28, 290, 418},	//390 Okular::FormField::activationAction
	{28, 482, 413},	//391 Okular::FormField::id
	{28, 504, 416},	//392 Okular::FormField::isReadOnly
	{28, 508, 417},	//393 Okular::FormField::isVisible
	{28, 546, 414},	//394 Okular::FormField::name
	{28, 639, 412},	//395 Okular::FormField::rect
	{28, 687, 419},	//396 Okular::FormField::setActivationAction#
	{28, 932, 411},	//397 Okular::FormField::type
	{28, 933, 415},	//398 Okular::FormField::uiName
	{28, 970, 410},	//399 Okular::FormField::~FormField
	{29, 42, 421},	//400 Okular::FormFieldButton::CheckBox
	{29, 104, 429},	//401 Okular::FormFieldButton::FormFieldButton
	{29, 209, 420},	//402 Okular::FormFieldButton::Push
	{29, 213, 422},	//403 Okular::FormFieldButton::Radio
	{29, 328, 424},	//404 Okular::FormFieldButton::buttonType
	{29, 341, 425},	//405 Okular::FormFieldButton::caption
	{29, 827, 427},	//406 Okular::FormFieldButton::setState$
	{29, 872, 428},	//407 Okular::FormFieldButton::siblings
	{29, 886, 426},	//408 Okular::FormFieldButton::state
	{29, 971, 423},	//409 Okular::FormFieldButton::~FormFieldButton
	{30, 48, 430},	//410 Okular::FormFieldChoice::ComboBox
	{30, 105, 441},	//411 Okular::FormFieldChoice::FormFieldChoice
	{30, 145, 431},	//412 Okular::FormFieldChoice::ListBox
	{30, 333, 440},	//413 Okular::FormFieldChoice::canBeSpellChecked
	{30, 346, 433},	//414 Okular::FormFieldChoice::choiceType
	{30, 347, 434},	//415 Okular::FormFieldChoice::choices
	{30, 372, 437},	//416 Okular::FormFieldChoice::currentChoices
	{30, 499, 435},	//417 Okular::FormFieldChoice::isEditable
	{30, 545, 436},	//418 Okular::FormFieldChoice::multiSelect
	{30, 715, 438},	//419 Okular::FormFieldChoice::setCurrentChoices?
	{30, 905, 439},	//420 Okular::FormFieldChoice::textAlignment
	{30, 972, 432},	//421 Okular::FormFieldChoice::~FormFieldChoice
	{31, 95, 444},	//422 Okular::FormFieldText::FileSelect
	{31, 106, 454},	//423 Okular::FormFieldText::FormFieldText
	{31, 151, 443},	//424 Okular::FormFieldText::Multiline
	{31, 159, 442},	//425 Okular::FormFieldText::Normal
	{31, 333, 453},	//426 Okular::FormFieldText::canBeSpellChecked
	{31, 503, 449},	//427 Okular::FormFieldText::isPassword
	{31, 506, 450},	//428 Okular::FormFieldText::isRichText
	{31, 530, 451},	//429 Okular::FormFieldText::maximumLength
	{31, 829, 448},	//430 Okular::FormFieldText::setText$
	{31, 903, 447},	//431 Okular::FormFieldText::text
	{31, 905, 452},	//432 Okular::FormFieldText::textAlignment
	{31, 914, 446},	//433 Okular::FormFieldText::textType
	{31, 973, 445},	//434 Okular::FormFieldText::~FormFieldText
	{32, 100, 458},	//435 Okular::Generator::FontInfo
	{32, 111, 467},	//436 Okular::Generator::Generator#?
	{32, 158, 463},	//437 Okular::Generator::None
	{32, 190, 459},	//438 Okular::Generator::PageSizes
	{32, 198, 464},	//439 Okular::Generator::Points
	{32, 205, 460},	//440 Okular::Generator::PrintNative
	{32, 206, 461},	//441 Okular::Generator::PrintPostscript
	{32, 207, 462},	//442 Okular::Generator::PrintToFile
	{32, 215, 457},	//443 Okular::Generator::ReadRawData
	{32, 259, 456},	//444 Okular::Generator::TextExtraction
	{32, 262, 455},	//445 Okular::Generator::Threaded
	{32, 336, 472},	//446 Okular::Generator::canGeneratePixmap
	{32, 337, 474},	//447 Okular::Generator::canGenerateTextPage
	{32, 349, 471},	//448 Okular::Generator::closeDocument
	{32, 398, 496},	//449 Okular::Generator::doCloseDocument
	{32, 401, 499},	//450 Okular::Generator::document
	{32, 405, 503},	//451 Okular::Generator::documentMetaData$
	{32, 406, 502},	//452 Okular::Generator::documentMetaData$#
	{32, 414, 479},	//453 Okular::Generator::embeddedFiles
	{32, 416, 490},	//454 Okular::Generator::error$$
	{32, 421, 487},	//455 Okular::Generator::exportFormats
	{32, 423, 488},	//456 Okular::Generator::exportTo$#
	{32, 443, 478},	//457 Okular::Generator::fontsForPage$
	{32, 447, 476},	//458 Okular::Generator::generateDocumentInfo
	{32, 448, 477},	//459 Okular::Generator::generateDocumentSynopsis
	{32, 450, 473},	//460 Okular::Generator::generatePixmap#
	{32, 452, 475},	//461 Okular::Generator::generateTextPage#
	{32, 465, 489},	//462 Okular::Generator::hasFeature$
	{32, 484, 497},	//463 Okular::Generator::image#
	{32, 497, 481},	//464 Okular::Generator::isAllowed$
	{32, 526, 469},	//465 Okular::Generator::loadDocument$?
	{32, 528, 470},	//466 Okular::Generator::loadDocumentFromData#?
	{32, 537, 486},	//467 Okular::Generator::metaData$#
	{32, 538, 465},	//468 Okular::Generator::metaObject
	{32, 551, 492},	//469 Okular::Generator::notice$$
	{32, 602, 484},	//470 Okular::Generator::pageSizeChanged##
	{32, 605, 483},	//471 Okular::Generator::pageSizes
	{32, 608, 480},	//472 Okular::Generator::pagesSizeMetric
	{32, 612, 485},	//473 Okular::Generator::print#
	{32, 634, 466},	//474 Okular::Generator::qt_metacall$$?
	{32, 654, 506},	//475 Okular::Generator::requestFontData##
	{32, 668, 482},	//476 Okular::Generator::rotationChanged$$
	{32, 730, 501},	//477 Okular::Generator::setFeature$
	{32, 731, 500},	//478 Okular::Generator::setFeature$$
	{32, 874, 494},	//479 Okular::Generator::signalPixmapRequestDone#
	{32, 876, 495},	//480 Okular::Generator::signalTextGenerationDone##
	{32, 890, 493},	//481 Okular::Generator::staticMetaObject
	{32, 911, 498},	//482 Okular::Generator::textPage#
	{32, 938, 505},	//483 Okular::Generator::updatePageBoundingBox$#
	{32, 940, 504},	//484 Okular::Generator::userMutex
	{32, 945, 491},	//485 Okular::Generator::warning$$
	{32, 974, 468},	//486 Okular::Generator::~Generator
	{33, 112, 509},	//487 Okular::GeomAnnotation::GeomAnnotation
	{33, 113, 510},	//488 Okular::GeomAnnotation::GeomAnnotation#
	{33, 137, 508},	//489 Okular::GeomAnnotation::InscribedCircle
	{33, 138, 507},	//490 Okular::GeomAnnotation::InscribedSquare
	{33, 454, 515},	//491 Okular::GeomAnnotation::geometricalInnerColor
	{33, 455, 513},	//492 Okular::GeomAnnotation::geometricalType
	{33, 741, 514},	//493 Okular::GeomAnnotation::setGeometricalInnerColor#
	{33, 743, 512},	//494 Okular::GeomAnnotation::setGeometricalType$
	{33, 893, 517},	//495 Okular::GeomAnnotation::store##
	{33, 897, 516},	//496 Okular::GeomAnnotation::subType
	{33, 975, 511},	//497 Okular::GeomAnnotation::~GeomAnnotation
	{34, 120, 518},	//498 Okular::GotoAction::GotoAction$#
	{34, 121, 519},	//499 Okular::GotoAction::GotoAction$$
	{34, 288, 522},	//500 Okular::GotoAction::actionTip
	{34, 289, 521},	//501 Okular::GotoAction::actionType
	{34, 387, 525},	//502 Okular::GotoAction::destViewport
	{34, 390, 526},	//503 Okular::GotoAction::destinationName
	{34, 428, 524},	//504 Okular::GotoAction::fileName
	{34, 500, 523},	//505 Okular::GotoAction::isExternal
	{34, 976, 520},	//506 Okular::GotoAction::~GotoAction
	{35, 123, 529},	//507 Okular::GuiInterface::GuiInterface
	{35, 124, 530},	//508 Okular::GuiInterface::GuiInterface#
	{35, 462, 528},	//509 Okular::GuiInterface::guiClient
	{35, 977, 527},	//510 Okular::GuiInterface::~GuiInterface
	{36, 127, 531},	//511 Okular::HighlightAnnotation::Highlight
	{36, 128, 535},	//512 Okular::HighlightAnnotation::HighlightAnnotation
	{36, 129, 536},	//513 Okular::HighlightAnnotation::HighlightAnnotation#
	{36, 245, 532},	//514 Okular::HighlightAnnotation::Squiggly
	{36, 248, 534},	//515 Okular::HighlightAnnotation::StrikeOut
	{36, 274, 533},	//516 Okular::HighlightAnnotation::Underline
	{36, 477, 540},	//517 Okular::HighlightAnnotation::highlightQuads
	{36, 478, 539},	//518 Okular::HighlightAnnotation::highlightType
	{36, 745, 538},	//519 Okular::HighlightAnnotation::setHighlightType$
	{36, 893, 542},	//520 Okular::HighlightAnnotation::store##
	{36, 897, 541},	//521 Okular::HighlightAnnotation::subType
	{36, 978, 537},	//522 Okular::HighlightAnnotation::~HighlightAnnotation
	{37, 135, 543},	//523 Okular::InkAnnotation::InkAnnotation
	{37, 136, 544},	//524 Okular::InkAnnotation::InkAnnotation#
	{37, 487, 547},	//525 Okular::InkAnnotation::inkPaths
	{37, 747, 546},	//526 Okular::InkAnnotation::setInkPaths?
	{37, 893, 550},	//527 Okular::InkAnnotation::store##
	{37, 897, 549},	//528 Okular::InkAnnotation::subType
	{37, 925, 548},	//529 Okular::InkAnnotation::transformedInkPaths
	{37, 979, 545},	//530 Okular::InkAnnotation::~InkAnnotation
	{38, 22, 562},	//531 Okular::LineAnnotation::Arrow
	{38, 30, 557},	//532 Okular::LineAnnotation::Butt
	{38, 43, 552},	//533 Okular::LineAnnotation::Circle
	{38, 45, 555},	//534 Okular::LineAnnotation::ClosedArrow
	{38, 62, 553},	//535 Okular::LineAnnotation::Diamond
	{38, 63, 563},	//536 Okular::LineAnnotation::Dimension
	{38, 142, 565},	//537 Okular::LineAnnotation::LineAnnotation
	{38, 143, 566},	//538 Okular::LineAnnotation::LineAnnotation#
	{38, 158, 556},	//539 Okular::LineAnnotation::None
	{38, 175, 554},	//540 Okular::LineAnnotation::OpenArrow
	{38, 199, 564},	//541 Okular::LineAnnotation::PolygonCloud
	{38, 211, 559},	//542 Okular::LineAnnotation::RClosedArrow
	{38, 212, 558},	//543 Okular::LineAnnotation::ROpenArrow
	{38, 227, 560},	//544 Okular::LineAnnotation::Slash
	{38, 244, 551},	//545 Okular::LineAnnotation::Square
	{38, 275, 561},	//546 Okular::LineAnnotation::Unknown
	{38, 513, 576},	//547 Okular::LineAnnotation::lineClosed
	{38, 514, 574},	//548 Okular::LineAnnotation::lineEndStyle
	{38, 515, 578},	//549 Okular::LineAnnotation::lineInnerColor
	{38, 516, 586},	//550 Okular::LineAnnotation::lineIntent
	{38, 517, 582},	//551 Okular::LineAnnotation::lineLeadingBackwardPoint
	{38, 518, 580},	//552 Okular::LineAnnotation::lineLeadingForwardPoint
	{38, 519, 569},	//553 Okular::LineAnnotation::linePoints
	{38, 520, 572},	//554 Okular::LineAnnotation::lineStartStyle
	{38, 763, 575},	//555 Okular::LineAnnotation::setLineClosed$
	{38, 765, 573},	//556 Okular::LineAnnotation::setLineEndStyle$
	{38, 767, 577},	//557 Okular::LineAnnotation::setLineInnerColor#
	{38, 769, 585},	//558 Okular::LineAnnotation::setLineIntent$
	{38, 771, 581},	//559 Okular::LineAnnotation::setLineLeadingBackwardPoint$
	{38, 773, 579},	//560 Okular::LineAnnotation::setLineLeadingForwardPoint$
	{38, 775, 568},	//561 Okular::LineAnnotation::setLinePoints?
	{38, 777, 571},	//562 Okular::LineAnnotation::setLineStartStyle$
	{38, 815, 583},	//563 Okular::LineAnnotation::setShowCaption$
	{38, 871, 584},	//564 Okular::LineAnnotation::showCaption
	{38, 893, 588},	//565 Okular::LineAnnotation::store##
	{38, 897, 587},	//566 Okular::LineAnnotation::subType
	{38, 928, 570},	//567 Okular::LineAnnotation::transformedLinePoints
	{38, 980, 567},	//568 Okular::LineAnnotation::~LineAnnotation
	{39, 160, 589},	//569 Okular::NormalizedPoint::NormalizedPoint
	{39, 161, 597},	//570 Okular::NormalizedPoint::NormalizedPoint#
	{39, 162, 590},	//571 Okular::NormalizedPoint::NormalizedPoint$$
	{39, 163, 591},	//572 Okular::NormalizedPoint::NormalizedPoint$$$$
	{39, 568, 592},	//573 Okular::NormalizedPoint::operator=#
	{39, 858, 594},	//574 Okular::NormalizedPoint::setX$
	{39, 867, 595},	//575 Okular::NormalizedPoint::setY$
	{39, 921, 593},	//576 Okular::NormalizedPoint::transform#
	{39, 949, 598},	//577 Okular::NormalizedPoint::x
	{39, 951, 599},	//578 Okular::NormalizedPoint::y
	{39, 981, 596},	//579 Okular::NormalizedPoint::~NormalizedPoint
	{40, 164, 600},	//580 Okular::NormalizedRect::NormalizedRect
	{40, 165, 603},	//581 Okular::NormalizedRect::NormalizedRect#
	{40, 166, 602},	//582 Okular::NormalizedRect::NormalizedRect#$$
	{40, 167, 601},	//583 Okular::NormalizedRect::NormalizedRect$$$$
	{40, 323, 625},	//584 Okular::NormalizedRect::bottom
	{40, 356, 606},	//585 Okular::NormalizedRect::contains$$
	{40, 446, 621},	//586 Okular::NormalizedRect::fromQRectF#
	{40, 457, 610},	//587 Okular::NormalizedRect::geometry$$
	{40, 494, -13},	//588 Okular::NormalizedRect::intersects#
	{40, 495, 609},	//589 Okular::NormalizedRect::intersects$$$$
	{40, 501, 605},	//590 Okular::NormalizedRect::isNull
	{40, 512, 622},	//591 Okular::NormalizedRect::left
	{40, 566, 613},	//592 Okular::NormalizedRect::operator&#
	{40, 568, 604},	//593 Okular::NormalizedRect::operator=#
	{40, 570, 614},	//594 Okular::NormalizedRect::operator==#
	{40, 572, 611},	//595 Okular::NormalizedRect::operator|#
	{40, 574, 612},	//596 Okular::NormalizedRect::operator|=#
	{40, 663, 624},	//597 Okular::NormalizedRect::right
	{40, 697, 619},	//598 Okular::NormalizedRect::setBottom$
	{40, 761, 616},	//599 Okular::NormalizedRect::setLeft$
	{40, 807, 618},	//600 Okular::NormalizedRect::setRight$
	{40, 839, 617},	//601 Okular::NormalizedRect::setTop$
	{40, 918, 623},	//602 Okular::NormalizedRect::top
	{40, 921, 615},	//603 Okular::NormalizedRect::transform#
	{40, 982, 620},	//604 Okular::NormalizedRect::~NormalizedRect
	{41, 14, 626},	//605 Okular::ObjectRect::Action
	{41, 133, 627},	//606 Okular::ObjectRect::Image
	{41, 169, 628},	//607 Okular::ObjectRect::OAnnotation
	{41, 171, 641},	//608 Okular::ObjectRect::ObjectRect#
	{41, 172, 632},	//609 Okular::ObjectRect::ObjectRect#$$
	{41, 173, 631},	//610 Okular::ObjectRect::ObjectRect#$$$
	{41, 174, 630},	//611 Okular::ObjectRect::ObjectRect$$$$$$$
	{41, 236, 629},	//612 Okular::ObjectRect::SourceRef
	{41, 326, 637},	//613 Okular::ObjectRect::boundingRect$$
	{41, 357, 638},	//614 Okular::ObjectRect::contains$$$$
	{41, 397, 640},	//615 Okular::ObjectRect::distanceSqr$$$$
	{41, 553, 635},	//616 Okular::ObjectRect::object
	{41, 556, 634},	//617 Okular::ObjectRect::objectType
	{41, 640, 636},	//618 Okular::ObjectRect::region
	{41, 921, 639},	//619 Okular::ObjectRect::transform#
	{41, 983, 633},	//620 Okular::ObjectRect::~ObjectRect
	{42, 46, 643},	//621 Okular::Page::Closing
	{42, 177, 642},	//622 Okular::Page::Opening
	{42, 182, 644},	//623 Okular::Page::Page$$$$
	{42, 294, 686},	//624 Okular::Page::addAnnotation#
	{42, 313, 673},	//625 Okular::Page::annotations
	{42, 324, 653},	//626 Okular::Page::boundingBox
	{42, 378, 695},	//627 Okular::Page::deleteAnnotations
	{42, 382, 691},	//628 Okular::Page::deletePixmap$
	{42, 383, 692},	//629 Okular::Page::deletePixmaps
	{42, 384, 693},	//630 Okular::Page::deleteRects
	{42, 385, 694},	//631 Okular::Page::deleteSourceReferences
	{42, 411, 681},	//632 Okular::Page::duration
	{42, 434, 666},	//633 Okular::Page::findText$$$$
	{42, 435, 665},	//634 Okular::Page::findText$$$$#
	{42, 444, 675},	//635 Okular::Page::formFields
	{42, 463, 664},	//636 Okular::Page::hasAnnotations
	{42, 466, 662},	//637 Okular::Page::hasHighlights
	{42, 467, 661},	//638 Okular::Page::hasHighlights$
	{42, 469, 660},	//639 Okular::Page::hasObjectRect$$$$
	{42, 471, 658},	//640 Okular::Page::hasPixmap$
	{42, 472, 657},	//641 Okular::Page::hasPixmap$$
	{42, 473, 656},	//642 Okular::Page::hasPixmap$$$
	{42, 474, 659},	//643 Okular::Page::hasTextPage
	{42, 475, 663},	//644 Okular::Page::hasTransition
	{42, 476, 651},	//645 Okular::Page::height
	{42, 498, 654},	//646 Okular::Page::isBoundingBoxKnown
	{42, 511, 683},	//647 Okular::Page::label
	{42, 549, 671},	//648 Okular::Page::nearestObjectRect$$$$$$
	{42, 552, 646},	//649 Okular::Page::number
	{42, 555, 670},	//650 Okular::Page::objectRect$$$$$
	{42, 589, 647},	//651 Okular::Page::orientation
	{42, 593, 674},	//652 Okular::Page::pageAction$
	{42, 636, 652},	//653 Okular::Page::ratio
	{42, 644, 687},	//654 Okular::Page::removeAnnotation#
	{42, 666, 648},	//655 Okular::Page::rotation
	{42, 699, 655},	//656 Okular::Page::setBoundingBox#
	{42, 724, 680},	//657 Okular::Page::setDuration$
	{42, 739, 690},	//658 Okular::Page::setFormFields?
	{42, 759, 682},	//659 Okular::Page::setLabel$
	{42, 792, 678},	//660 Okular::Page::setObjectRects?
	{42, 794, 689},	//661 Okular::Page::setPageAction$#
	{42, 802, 676},	//662 Okular::Page::setPixmap$#
	{42, 823, 679},	//663 Okular::Page::setSourceReferences?
	{42, 835, 677},	//664 Okular::Page::setTextPage#
	{42, 841, 688},	//665 Okular::Page::setTransition#
	{42, 903, 668},	//666 Okular::Page::text
	{42, 904, 667},	//667 Okular::Page::text#
	{42, 907, 669},	//668 Okular::Page::textArea?
	{42, 912, 684},	//669 Okular::Page::textSelection
	{42, 913, 685},	//670 Okular::Page::textSelectionColor
	{42, 919, 649},	//671 Okular::Page::totalOrientation
	{42, 929, 672},	//672 Okular::Page::transition
	{42, 947, 650},	//673 Okular::Page::width
	{42, 984, 645},	//674 Okular::Page::~Page
	{43, 187, 696},	//675 Okular::PageSize::PageSize
	{43, 188, 698},	//676 Okular::PageSize::PageSize#
	{43, 189, 697},	//677 Okular::PageSize::PageSize$$$
	{43, 476, 701},	//678 Okular::PageSize::height
	{43, 501, 703},	//679 Okular::PageSize::isNull
	{43, 546, 702},	//680 Okular::PageSize::name
	{43, 564, 706},	//681 Okular::PageSize::operator!=#
	{43, 568, 704},	//682 Okular::PageSize::operator=#
	{43, 570, 705},	//683 Okular::PageSize::operator==#
	{43, 947, 700},	//684 Okular::PageSize::width
	{43, 985, 699},	//685 Okular::PageSize::~PageSize
	{44, 25, 709},	//686 Okular::PageTransition::Blinds
	{44, 26, 710},	//687 Okular::PageTransition::Box
	{44, 53, 716},	//688 Okular::PageTransition::Cover
	{44, 64, 712},	//689 Okular::PageTransition::Dissolve
	{44, 90, 718},	//690 Okular::PageTransition::Fade
	{44, 99, 714},	//691 Okular::PageTransition::Fly
	{44, 114, 713},	//692 Okular::PageTransition::Glitter
	{44, 132, 719},	//693 Okular::PageTransition::Horizontal
	{44, 140, 721},	//694 Okular::PageTransition::Inward
	{44, 178, 722},	//695 Okular::PageTransition::Outward
	{44, 191, 724},	//696 Okular::PageTransition::PageTransition
	{44, 192, 725},	//697 Okular::PageTransition::PageTransition#
	{44, 193, 723},	//698 Okular::PageTransition::PageTransition$
	{44, 209, 715},	//699 Okular::PageTransition::Push
	{44, 220, 707},	//700 Okular::PageTransition::Replace
	{44, 243, 708},	//701 Okular::PageTransition::Split
	{44, 273, 717},	//702 Okular::PageTransition::Uncover
	{44, 279, 720},	//703 Okular::PageTransition::Vertical
	{44, 284, 711},	//704 Okular::PageTransition::Wipe
	{44, 307, 730},	//705 Okular::PageTransition::alignment
	{44, 309, 732},	//706 Okular::PageTransition::angle
	{44, 393, 731},	//707 Okular::PageTransition::direction
	{44, 411, 729},	//708 Okular::PageTransition::duration
	{44, 505, 734},	//709 Okular::PageTransition::isRectangular
	{44, 568, 726},	//710 Okular::PageTransition::operator=#
	{44, 675, 733},	//711 Okular::PageTransition::scale
	{44, 689, 737},	//712 Okular::PageTransition::setAlignment$
	{44, 691, 739},	//713 Okular::PageTransition::setAngle$
	{44, 720, 738},	//714 Okular::PageTransition::setDirection$
	{44, 724, 736},	//715 Okular::PageTransition::setDuration$
	{44, 757, 741},	//716 Okular::PageTransition::setIsRectangular$
	{44, 813, 740},	//717 Okular::PageTransition::setScale$
	{44, 843, 735},	//718 Okular::PageTransition::setType$
	{44, 932, 728},	//719 Okular::PageTransition::type
	{44, 986, 727},	//720 Okular::PageTransition::~PageTransition
	{45, 196, 742},	//721 Okular::PixmapRequest::PixmapRequest$$$$$$
	{45, 317, 749},	//722 Okular::PixmapRequest::asynchronous
	{45, 476, 747},	//723 Okular::PixmapRequest::height
	{45, 482, 744},	//724 Okular::PixmapRequest::id
	{45, 590, 750},	//725 Okular::PixmapRequest::page
	{45, 598, 745},	//726 Okular::PixmapRequest::pageNumber
	{45, 625, 748},	//727 Okular::PixmapRequest::priority
	{45, 947, 746},	//728 Okular::PixmapRequest::width
	{45, 987, 743},	//729 Okular::PixmapRequest::~PixmapRequest
	{46, 203, 753},	//730 Okular::PrintInterface::PrintInterface
	{46, 204, 754},	//731 Okular::PrintInterface::PrintInterface#
	{46, 615, 752},	//732 Okular::PrintInterface::printConfigurationWidget
	{46, 988, 751},	//733 Okular::PrintInterface::~PrintInterface
	{47, 216, 755},	//734 Okular::RegularAreaRect::RegularAreaRect
	{47, 217, 756},	//735 Okular::RegularAreaRect::RegularAreaRect#
	{47, 568, 758},	//736 Okular::RegularAreaRect::operator=#
	{47, 989, 757},	//737 Okular::RegularAreaRect::~RegularAreaRect
	{48, 224, 759},	//738 Okular::ScriptAction::ScriptAction$$
	{48, 288, 762},	//739 Okular::ScriptAction::actionTip
	{48, 289, 761},	//740 Okular::ScriptAction::actionType
	{48, 676, 764},	//741 Okular::ScriptAction::script
	{48, 677, 763},	//742 Okular::ScriptAction::scriptType
	{48, 990, 760},	//743 Okular::ScriptAction::~ScriptAction
	{49, 6, 770},	//744 Okular::Sound::ALaw
	{49, 77, 766},	//745 Okular::Sound::Embedded
	{49, 89, 765},	//746 Okular::Sound::External
	{49, 214, 767},	//747 Okular::Sound::Raw
	{49, 226, 768},	//748 Okular::Sound::Signed
	{49, 230, 771},	//749 Okular::Sound::Sound#
	{49, 231, 772},	//750 Okular::Sound::Sound$
	{49, 319, 782},	//751 Okular::Sound::bitsPerSample
	{49, 343, 780},	//752 Okular::Sound::channels
	{49, 377, 776},	//753 Okular::Sound::data
	{49, 544, 769},	//754 Okular::Sound::muLaw
	{49, 670, 778},	//755 Okular::Sound::samplingRate
	{49, 695, 781},	//756 Okular::Sound::setBitsPerSample$
	{49, 707, 779},	//757 Okular::Sound::setChannels$
	{49, 811, 777},	//758 Okular::Sound::setSamplingRate$
	{49, 819, 783},	//759 Okular::Sound::setSoundEncoding$
	{49, 879, 784},	//760 Okular::Sound::soundEncoding
	{49, 881, 774},	//761 Okular::Sound::soundType
	{49, 939, 775},	//762 Okular::Sound::url
	{49, 991, 773},	//763 Okular::Sound::~Sound
	{50, 233, 785},	//764 Okular::SoundAction::SoundAction$$$$#
	{50, 288, 788},	//765 Okular::SoundAction::actionTip
	{50, 289, 787},	//766 Okular::SoundAction::actionType
	{50, 540, 792},	//767 Okular::SoundAction::mix
	{50, 652, 791},	//768 Okular::SoundAction::repeat
	{50, 878, 793},	//769 Okular::SoundAction::sound
	{50, 902, 790},	//770 Okular::SoundAction::synchronous
	{50, 943, 789},	//771 Okular::SoundAction::volume
	{50, 992, 786},	//772 Okular::SoundAction::~SoundAction
	{51, 234, 794},	//773 Okular::SoundAnnotation::SoundAnnotation
	{51, 235, 795},	//774 Okular::SoundAnnotation::SoundAnnotation#
	{51, 817, 800},	//775 Okular::SoundAnnotation::setSound#
	{51, 821, 798},	//776 Okular::SoundAnnotation::setSoundIconName$
	{51, 878, 799},	//777 Okular::SoundAnnotation::sound
	{51, 880, 797},	//778 Okular::SoundAnnotation::soundIconName
	{51, 893, 802},	//779 Okular::SoundAnnotation::store##
	{51, 897, 801},	//780 Okular::SoundAnnotation::subType
	{51, 993, 796},	//781 Okular::SoundAnnotation::~SoundAnnotation
	{52, 238, 807},	//782 Okular::SourceRefObjectRect::SourceRefObjectRect#
	{52, 239, 803},	//783 Okular::SourceRefObjectRect::SourceRefObjectRect#$
	{52, 326, 804},	//784 Okular::SourceRefObjectRect::boundingRect$$
	{52, 357, 805},	//785 Okular::SourceRefObjectRect::contains$$$$
	{52, 994, 806},	//786 Okular::SourceRefObjectRect::~SourceRefObjectRect
	{53, 241, 809},	//787 Okular::SourceReference::SourceReference$$
	{53, 242, 808},	//788 Okular::SourceReference::SourceReference$$$
	{53, 350, 813},	//789 Okular::SourceReference::column
	{53, 428, 811},	//790 Okular::SourceReference::fileName
	{53, 669, 812},	//791 Okular::SourceReference::row
	{53, 995, 810},	//792 Okular::SourceReference::~SourceReference
	{54, 246, 814},	//793 Okular::StampAnnotation::StampAnnotation
	{54, 247, 815},	//794 Okular::StampAnnotation::StampAnnotation#
	{54, 825, 817},	//795 Okular::StampAnnotation::setStampIconName$
	{54, 882, 818},	//796 Okular::StampAnnotation::stampIconName
	{54, 893, 820},	//797 Okular::StampAnnotation::store##
	{54, 897, 819},	//798 Okular::StampAnnotation::subType
	{54, 996, 816},	//799 Okular::StampAnnotation::~StampAnnotation
	{55, 36, 824},	//800 Okular::TextAnnotation::Callout
	{55, 134, 822},	//801 Okular::TextAnnotation::InPlace
	{55, 144, 821},	//802 Okular::TextAnnotation::Linked
	{55, 252, 826},	//803 Okular::TextAnnotation::TextAnnotation
	{55, 253, 827},	//804 Okular::TextAnnotation::TextAnnotation#
	{55, 272, 825},	//805 Okular::TextAnnotation::TypeWriter
	{55, 275, 823},	//806 Okular::TextAnnotation::Unknown
	{55, 488, 836},	//807 Okular::TextAnnotation::inplaceAlignment
	{55, 490, 840},	//808 Okular::TextAnnotation::inplaceCallout$
	{55, 491, 843},	//809 Okular::TextAnnotation::inplaceIntent
	{55, 492, 838},	//810 Okular::TextAnnotation::inplaceText
	{55, 749, 835},	//811 Okular::TextAnnotation::setInplaceAlignment$
	{55, 751, 839},	//812 Okular::TextAnnotation::setInplaceCallout#$
	{55, 753, 842},	//813 Okular::TextAnnotation::setInplaceIntent$
	{55, 755, 837},	//814 Okular::TextAnnotation::setInplaceText$
	{55, 831, 833},	//815 Okular::TextAnnotation::setTextFont#
	{55, 833, 831},	//816 Okular::TextAnnotation::setTextIcon$
	{55, 837, 829},	//817 Okular::TextAnnotation::setTextType$
	{55, 893, 845},	//818 Okular::TextAnnotation::store##
	{55, 897, 844},	//819 Okular::TextAnnotation::subType
	{55, 908, 834},	//820 Okular::TextAnnotation::textFont
	{55, 909, 832},	//821 Okular::TextAnnotation::textIcon
	{55, 914, 830},	//822 Okular::TextAnnotation::textType
	{55, 927, 841},	//823 Okular::TextAnnotation::transformedInplaceCallout$
	{55, 997, 828},	//824 Okular::TextAnnotation::~TextAnnotation
	{56, 254, 848},	//825 Okular::TextDocumentConverter::TextDocumentConverter
	{56, 292, 851},	//826 Okular::TextDocumentConverter::addAction#$$
	{56, 295, 852},	//827 Okular::TextDocumentConverter::addAnnotation#$$
	{56, 297, 855},	//828 Okular::TextDocumentConverter::addMetaData$$
	{56, 298, 854},	//829 Okular::TextDocumentConverter::addMetaData$$$
	{56, 306, 853},	//830 Okular::TextDocumentConverter::addTitle$$#
	{56, 330, 860},	//831 Okular::TextDocumentConverter::calculateViewport##
	{56, 363, 850},	//832 Okular::TextDocumentConverter::convert$
	{56, 416, 856},	//833 Okular::TextDocumentConverter::error$$
	{56, 453, 861},	//834 Okular::TextDocumentConverter::generator
	{56, 538, 846},	//835 Okular::TextDocumentConverter::metaObject
	{56, 551, 858},	//836 Okular::TextDocumentConverter::notice$$
	{56, 634, 847},	//837 Okular::TextDocumentConverter::qt_metacall$$?
	{56, 890, 859},	//838 Okular::TextDocumentConverter::staticMetaObject
	{56, 945, 857},	//839 Okular::TextDocumentConverter::warning$$
	{56, 998, 849},	//840 Okular::TextDocumentConverter::~TextDocumentConverter
	{57, 256, 864},	//841 Okular::TextDocumentGenerator::TextDocumentGenerator##?
	{57, 336, 867},	//842 Okular::TextDocumentGenerator::canGeneratePixmap
	{57, 398, 875},	//843 Okular::TextDocumentGenerator::doCloseDocument
	{57, 421, 870},	//844 Okular::TextDocumentGenerator::exportFormats
	{57, 423, 871},	//845 Okular::TextDocumentGenerator::exportTo$#
	{57, 447, 872},	//846 Okular::TextDocumentGenerator::generateDocumentInfo
	{57, 448, 873},	//847 Okular::TextDocumentGenerator::generateDocumentSynopsis
	{57, 450, 868},	//848 Okular::TextDocumentGenerator::generatePixmap#
	{57, 526, 866},	//849 Okular::TextDocumentGenerator::loadDocument$?
	{57, 538, 862},	//850 Okular::TextDocumentGenerator::metaObject
	{57, 612, 869},	//851 Okular::TextDocumentGenerator::print#
	{57, 634, 863},	//852 Okular::TextDocumentGenerator::qt_metacall$$?
	{57, 890, 874},	//853 Okular::TextDocumentGenerator::staticMetaObject
	{57, 911, 876},	//854 Okular::TextDocumentGenerator::textPage#
	{57, 999, 865},	//855 Okular::TextDocumentGenerator::~TextDocumentGenerator
	{58, 258, 877},	//856 Okular::TextEntity::TextEntity$#
	{58, 316, 880},	//857 Okular::TextEntity::area
	{58, 903, 879},	//858 Okular::TextEntity::text
	{58, 923, 881},	//859 Okular::TextEntity::transformedArea#
	{58, 1000, 878},	//860 Okular::TextEntity::~TextEntity
	{59, 260, 882},	//861 Okular::TextPage::TextPage
	{59, 261, 883},	//862 Okular::TextPage::TextPage?
	{59, 315, 885},	//863 Okular::TextPage::append$#
	{59, 435, 886},	//864 Okular::TextPage::findText$$$$#
	{59, 903, 888},	//865 Okular::TextPage::text
	{59, 904, 887},	//866 Okular::TextPage::text#
	{59, 907, 889},	//867 Okular::TextPage::textArea?
	{59, 1001, 884},	//868 Okular::TextPage::~TextPage
	{60, 277, 890},	//869 Okular::Utils::Utils
	{60, 278, 892},	//870 Okular::Utils::Utils#
	{60, 409, 894},	//871 Okular::Utils::dpiX
	{60, 410, 895},	//872 Okular::Utils::dpiY
	{60, 486, 898},	//873 Okular::Utils::imageBoundingBox#
	{60, 637, 896},	//874 Okular::Utils::realDpiX
	{60, 638, 897},	//875 Okular::Utils::realDpiY
	{60, 665, 893},	//876 Okular::Utils::rotateRect#$$$
	{60, 1002, 891},	//877 Okular::Utils::~Utils
	{61, 280, 901},	//878 Okular::VisiblePageRect::VisiblePageRect
	{61, 281, 905},	//879 Okular::VisiblePageRect::VisiblePageRect#
	{61, 282, 900},	//880 Okular::VisiblePageRect::VisiblePageRect$
	{61, 283, 899},	//881 Okular::VisiblePageRect::VisiblePageRect$#
	{61, 598, 906},	//882 Okular::VisiblePageRect::pageNumber
	{61, 639, 907},	//883 Okular::VisiblePageRect::rect
	{61, 796, 902},	//884 Okular::VisiblePageRect::setPageNumber$
	{61, 805, 903},	//885 Okular::VisiblePageRect::setRect#
	{61, 1003, 904},	//886 Okular::VisiblePageRect::~VisiblePageRect
};

static Smoke::Index okular_ambiguousMethodList[] = {
    0,
    89,  // Okular::AnnotationObjectRect::AnnotationObjectRect(Okular::Annotation*)
    95,  // Okular::AnnotationObjectRect::AnnotationObjectRect(const Okular::AnnotationObjectRect&)
    0,
    272,  // Okular::DocumentInfo::set(const QString&, const QString&)
    273,  // Okular::DocumentInfo::set(Okular::DocumentInfo::Key, const QString&)
    0,
    278,  // Okular::DocumentSynopsis::DocumentSynopsis(const QDomDocument&)
    280,  // Okular::DocumentSynopsis::DocumentSynopsis(const Okular::DocumentSynopsis&)
    0,
    283,  // Okular::DocumentViewport::DocumentViewport(int)
    285,  // Okular::DocumentViewport::DocumentViewport(const QString&)
    0,
    608,  // Okular::NormalizedRect::intersects(const Okular::NormalizedRect*) const
    607,  // Okular::NormalizedRect::intersects(const Okular::NormalizedRect&) const
    0,
};


void init_qt_Smoke();
void init_kde_Smoke();

static bool initialized = false;
Smoke *okular_Smoke = 0;

// Create the Smoke instance encapsulating all the above.
void init_okular_Smoke() {
    if (initialized) return;
    init_qt_Smoke();
    init_kde_Smoke();
    okular_Smoke = new Smoke(
        "okular",
        okular_classes, 119,
        okular_methods, 917,
        okular_methodMaps, 886,
        okular_methodNames, 1003,
        okular_types, 640,
        okular_inheritanceList,
        okular_argumentList,
        okular_ambiguousMethodList,
        okular_cast );
    initialized = true;
}
