#include <qbytearray.h>
#include <qcoreevent.h>
#include <qdatetime.h>
#include <qhostaddress.h>
#include <qlocale.h>
#include <qobject.h>
#include <qobjectdefs.h>
#include <qtextstream.h>
#include <qurl.h>
#include <qvariant.h>
#include <soprano/asyncmodel.h>
#include <soprano/asyncresult.h>
#include <soprano/backend.h>
#include <soprano/bindingset.h>
#include <soprano/cluceneindex.h>
#include <soprano/dbusclient.h>
#include <soprano/dbusexportiterator.h>
#include <soprano/dbusexportmodel.h>
#include <soprano/dbusmodel.h>
#include <soprano/dbusnodeiterator.h>
#include <soprano/dbusqueryresultiterator.h>
#include <soprano/dbusstatementiterator.h>
#include <soprano/error.h>
#include <soprano/filtermodel.h>
#include <soprano/graph.h>
#include <soprano/indexfiltermodel.h>
#include <soprano/indexqueryhit.h>
#include <soprano/inferencemodel.h>
#include <soprano/inferencerule.h>
#include <soprano/inferenceruleparser.h>
#include <soprano/inferenceruleset.h>
#include <soprano/iteratorbackend.h>
#include <soprano/languagetag.h>
#include <soprano/literalvalue.h>
#include <soprano/localsocketclient.h>
#include <soprano/locator.h>
#include <soprano/model.h>
#include <soprano/mutexmodel.h>
#include <soprano/nao.h>
#include <soprano/node.h>
#include <soprano/nodeiterator.h>
#include <soprano/nodepattern.h>
#include <soprano/nrl.h>
#include <soprano/owl.h>
#include <soprano/parser.h>
#include <soprano/plugin.h>
#include <soprano/pluginmanager.h>
#include <soprano/queryresultiterator.h>
#include <soprano/rdf.h>
#include <soprano/rdfs.h>
#include <soprano/rdfschemamodel.h>
#include <soprano/readonlymodel.h>
#include <soprano/serializer.h>
#include <soprano/servercore.h>
#include <soprano/signalcachemodel.h>
#include <soprano/sil.h>
#include <soprano/simplenodeiterator.h>
#include <soprano/simplestatementiterator.h>
#include <soprano/sparqlmodel.h>
#include <soprano/statement.h>
#include <soprano/statementiterator.h>
#include <soprano/statementpattern.h>
#include <soprano/storagemodel.h>
#include <soprano/tcpclient.h>
#include <soprano/xesam.h>
#include <soprano/xsd.h>

#include <smoke.h>

#include <soprano_smoke.h>

static void *soprano_cast(void *xptr, Smoke::Index from, Smoke::Index to) {
    switch(from) {
      case 1:	//QByteArray
	switch(to) {
	    case 1: return (void*)(QByteArray*)(QByteArray*)xptr;
	  default: return xptr;
	}
      case 2:	//QChildEvent
	switch(to) {
	    case 5: return (void*)(QEvent*)(QChildEvent*)xptr;
	    case 2: return (void*)(QChildEvent*)(QChildEvent*)xptr;
	  default: return xptr;
	}
      case 3:	//QDate
	switch(to) {
	    case 3: return (void*)(QDate*)(QDate*)xptr;
	  default: return xptr;
	}
      case 4:	//QDateTime
	switch(to) {
	    case 4: return (void*)(QDateTime*)(QDateTime*)xptr;
	  default: return xptr;
	}
      case 5:	//QEvent
	switch(to) {
	    case 5: return (void*)(QEvent*)(QEvent*)xptr;
	    case 2: return (void*)(QChildEvent*)(QEvent*)xptr;
	    case 12: return (void*)(QTimerEvent*)(QEvent*)xptr;
	  default: return xptr;
	}
      case 6:	//QHostAddress
	switch(to) {
	    case 6: return (void*)(QHostAddress*)(QHostAddress*)xptr;
	  default: return xptr;
	}
      case 7:	//QLocale
	switch(to) {
	    case 7: return (void*)(QLocale*)(QLocale*)xptr;
	  default: return xptr;
	}
      case 8:	//QMetaObject
	switch(to) {
	    case 8: return (void*)(QMetaObject*)(QMetaObject*)xptr;
	  default: return xptr;
	}
      case 9:	//QObject
	switch(to) {
	    case 9: return (void*)(QObject*)(QObject*)xptr;
	    case 20: return (void*)(Soprano::Client::DBusClient*)(QObject*)xptr;
	    case 21: return (void*)(Soprano::Client::DBusModel*)(QObject*)xptr;
	    case 25: return (void*)(Soprano::Client::LocalSocketClient*)(QObject*)xptr;
	    case 26: return (void*)(Soprano::Client::SparqlModel*)(QObject*)xptr;
	    case 27: return (void*)(Soprano::Client::TcpClient*)(QObject*)xptr;
	    case 32: return (void*)(Soprano::FilterModel*)(QObject*)xptr;
	    case 36: return (void*)(Soprano::Index::IndexFilterModel*)(QObject*)xptr;
	    case 39: return (void*)(Soprano::Inference::InferenceModel*)(QObject*)xptr;
	    case 47: return (void*)(Soprano::Model*)(QObject*)xptr;
	    case 52: return (void*)(Soprano::PluginManager*)(QObject*)xptr;
	    case 55: return (void*)(Soprano::RdfSchemaModel*)(QObject*)xptr;
	    case 58: return (void*)(Soprano::Server::DBusExportIterator*)(QObject*)xptr;
	    case 59: return (void*)(Soprano::Server::DBusExportModel*)(QObject*)xptr;
	    case 60: return (void*)(Soprano::Server::ServerCore*)(QObject*)xptr;
	    case 63: return (void*)(Soprano::StorageModel*)(QObject*)xptr;
	    case 65: return (void*)(Soprano::Util::AsyncModel*)(QObject*)xptr;
	    case 66: return (void*)(Soprano::Util::AsyncResult*)(QObject*)xptr;
	    case 67: return (void*)(Soprano::Util::MutexModel*)(QObject*)xptr;
	    case 68: return (void*)(Soprano::Util::ReadOnlyModel*)(QObject*)xptr;
	    case 69: return (void*)(Soprano::Util::SignalCacheModel*)(QObject*)xptr;
	  default: return xptr;
	}
      case 10:	//QTextStream
	switch(to) {
	    case 10: return (void*)(QTextStream*)(QTextStream*)xptr;
	  default: return xptr;
	}
      case 11:	//QTime
	switch(to) {
	    case 11: return (void*)(QTime*)(QTime*)xptr;
	  default: return xptr;
	}
      case 12:	//QTimerEvent
	switch(to) {
	    case 5: return (void*)(QEvent*)(QTimerEvent*)xptr;
	    case 12: return (void*)(QTimerEvent*)(QTimerEvent*)xptr;
	  default: return xptr;
	}
      case 13:	//QUrl
	switch(to) {
	    case 13: return (void*)(QUrl*)(QUrl*)xptr;
	  default: return xptr;
	}
      case 14:	//QVariant
	switch(to) {
	    case 14: return (void*)(QVariant*)(QVariant*)xptr;
	  default: return xptr;
	}
      case 16:	//Soprano::Backend
	switch(to) {
	    case 51: return (void*)(Soprano::Plugin*)(Soprano::Backend*)xptr;
	    case 16: return (void*)(Soprano::Backend*)(Soprano::Backend*)xptr;
	  default: return xptr;
	}
      case 17:	//Soprano::BackendSetting
	switch(to) {
	    case 17: return (void*)(Soprano::BackendSetting*)(Soprano::BackendSetting*)xptr;
	  default: return xptr;
	}
      case 18:	//Soprano::BindingSet
	switch(to) {
	    case 18: return (void*)(Soprano::BindingSet*)(Soprano::BindingSet*)xptr;
	  default: return xptr;
	}
      case 20:	//Soprano::Client::DBusClient
	switch(to) {
	    case 9: return (void*)(QObject*)(Soprano::Client::DBusClient*)xptr;
	    case 20: return (void*)(Soprano::Client::DBusClient*)(Soprano::Client::DBusClient*)xptr;
	  default: return xptr;
	}
      case 21:	//Soprano::Client::DBusModel
	switch(to) {
	    case 63: return (void*)(Soprano::StorageModel*)(Soprano::Client::DBusModel*)xptr;
	    case 47: return (void*)(Soprano::Model*)(Soprano::Client::DBusModel*)xptr;
	    case 9: return (void*)(QObject*)(Soprano::Client::DBusModel*)xptr;
	    case 21: return (void*)(Soprano::Client::DBusModel*)(Soprano::Client::DBusModel*)xptr;
	  default: return xptr;
	}
      case 22:	//Soprano::Client::DBusNodeIterator
	switch(to) {
	    case 49: return (void*)(Soprano::NodeIterator*)(Soprano::Client::DBusNodeIterator*)xptr;
	    case 22: return (void*)(Soprano::Client::DBusNodeIterator*)(Soprano::Client::DBusNodeIterator*)xptr;
	  default: return xptr;
	}
      case 23:	//Soprano::Client::DBusQueryResultIterator
	switch(to) {
	    case 54: return (void*)(Soprano::QueryResultIterator*)(Soprano::Client::DBusQueryResultIterator*)xptr;
	    case 23: return (void*)(Soprano::Client::DBusQueryResultIterator*)(Soprano::Client::DBusQueryResultIterator*)xptr;
	  default: return xptr;
	}
      case 24:	//Soprano::Client::DBusStatementIterator
	switch(to) {
	    case 62: return (void*)(Soprano::StatementIterator*)(Soprano::Client::DBusStatementIterator*)xptr;
	    case 24: return (void*)(Soprano::Client::DBusStatementIterator*)(Soprano::Client::DBusStatementIterator*)xptr;
	  default: return xptr;
	}
      case 25:	//Soprano::Client::LocalSocketClient
	switch(to) {
	    case 9: return (void*)(QObject*)(Soprano::Client::LocalSocketClient*)xptr;
	    case 25: return (void*)(Soprano::Client::LocalSocketClient*)(Soprano::Client::LocalSocketClient*)xptr;
	  default: return xptr;
	}
      case 26:	//Soprano::Client::SparqlModel
	switch(to) {
	    case 47: return (void*)(Soprano::Model*)(Soprano::Client::SparqlModel*)xptr;
	    case 9: return (void*)(QObject*)(Soprano::Client::SparqlModel*)xptr;
	    case 26: return (void*)(Soprano::Client::SparqlModel*)(Soprano::Client::SparqlModel*)xptr;
	  default: return xptr;
	}
      case 27:	//Soprano::Client::TcpClient
	switch(to) {
	    case 9: return (void*)(QObject*)(Soprano::Client::TcpClient*)xptr;
	    case 27: return (void*)(Soprano::Client::TcpClient*)(Soprano::Client::TcpClient*)xptr;
	  default: return xptr;
	}
      case 29:	//Soprano::Error::Error
	switch(to) {
	    case 29: return (void*)(Soprano::Error::Error*)(Soprano::Error::Error*)xptr;
	    case 31: return (void*)(Soprano::Error::ParserError*)(Soprano::Error::Error*)xptr;
	  default: return xptr;
	}
      case 30:	//Soprano::Error::Locator
	switch(to) {
	    case 30: return (void*)(Soprano::Error::Locator*)(Soprano::Error::Locator*)xptr;
	  default: return xptr;
	}
      case 31:	//Soprano::Error::ParserError
	switch(to) {
	    case 29: return (void*)(Soprano::Error::Error*)(Soprano::Error::ParserError*)xptr;
	    case 31: return (void*)(Soprano::Error::ParserError*)(Soprano::Error::ParserError*)xptr;
	  default: return xptr;
	}
      case 32:	//Soprano::FilterModel
	switch(to) {
	    case 47: return (void*)(Soprano::Model*)(Soprano::FilterModel*)xptr;
	    case 9: return (void*)(QObject*)(Soprano::FilterModel*)xptr;
	    case 32: return (void*)(Soprano::FilterModel*)(Soprano::FilterModel*)xptr;
	    case 36: return (void*)(Soprano::Index::IndexFilterModel*)(Soprano::FilterModel*)xptr;
	    case 39: return (void*)(Soprano::Inference::InferenceModel*)(Soprano::FilterModel*)xptr;
	    case 55: return (void*)(Soprano::RdfSchemaModel*)(Soprano::FilterModel*)xptr;
	    case 59: return (void*)(Soprano::Server::DBusExportModel*)(Soprano::FilterModel*)xptr;
	    case 65: return (void*)(Soprano::Util::AsyncModel*)(Soprano::FilterModel*)xptr;
	    case 67: return (void*)(Soprano::Util::MutexModel*)(Soprano::FilterModel*)xptr;
	    case 69: return (void*)(Soprano::Util::SignalCacheModel*)(Soprano::FilterModel*)xptr;
	  default: return xptr;
	}
      case 33:	//Soprano::Graph
	switch(to) {
	    case 33: return (void*)(Soprano::Graph*)(Soprano::Graph*)xptr;
	  default: return xptr;
	}
      case 35:	//Soprano::Index::CLuceneIndex
	switch(to) {
	    case 35: return (void*)(Soprano::Index::CLuceneIndex*)(Soprano::Index::CLuceneIndex*)xptr;
	  default: return xptr;
	}
      case 36:	//Soprano::Index::IndexFilterModel
	switch(to) {
	    case 32: return (void*)(Soprano::FilterModel*)(Soprano::Index::IndexFilterModel*)xptr;
	    case 47: return (void*)(Soprano::Model*)(Soprano::Index::IndexFilterModel*)xptr;
	    case 9: return (void*)(QObject*)(Soprano::Index::IndexFilterModel*)xptr;
	    case 36: return (void*)(Soprano::Index::IndexFilterModel*)(Soprano::Index::IndexFilterModel*)xptr;
	  default: return xptr;
	}
      case 37:	//Soprano::Index::QueryHit
	switch(to) {
	    case 37: return (void*)(Soprano::Index::QueryHit*)(Soprano::Index::QueryHit*)xptr;
	  default: return xptr;
	}
      case 39:	//Soprano::Inference::InferenceModel
	switch(to) {
	    case 32: return (void*)(Soprano::FilterModel*)(Soprano::Inference::InferenceModel*)xptr;
	    case 47: return (void*)(Soprano::Model*)(Soprano::Inference::InferenceModel*)xptr;
	    case 9: return (void*)(QObject*)(Soprano::Inference::InferenceModel*)xptr;
	    case 39: return (void*)(Soprano::Inference::InferenceModel*)(Soprano::Inference::InferenceModel*)xptr;
	  default: return xptr;
	}
      case 40:	//Soprano::Inference::NodePattern
	switch(to) {
	    case 40: return (void*)(Soprano::Inference::NodePattern*)(Soprano::Inference::NodePattern*)xptr;
	  default: return xptr;
	}
      case 41:	//Soprano::Inference::Rule
	switch(to) {
	    case 41: return (void*)(Soprano::Inference::Rule*)(Soprano::Inference::Rule*)xptr;
	  default: return xptr;
	}
      case 42:	//Soprano::Inference::RuleParser
	switch(to) {
	    case 42: return (void*)(Soprano::Inference::RuleParser*)(Soprano::Inference::RuleParser*)xptr;
	  default: return xptr;
	}
      case 43:	//Soprano::Inference::RuleSet
	switch(to) {
	    case 43: return (void*)(Soprano::Inference::RuleSet*)(Soprano::Inference::RuleSet*)xptr;
	  default: return xptr;
	}
      case 44:	//Soprano::Inference::StatementPattern
	switch(to) {
	    case 44: return (void*)(Soprano::Inference::StatementPattern*)(Soprano::Inference::StatementPattern*)xptr;
	  default: return xptr;
	}
      case 45:	//Soprano::LanguageTag
	switch(to) {
	    case 45: return (void*)(Soprano::LanguageTag*)(Soprano::LanguageTag*)xptr;
	  default: return xptr;
	}
      case 46:	//Soprano::LiteralValue
	switch(to) {
	    case 46: return (void*)(Soprano::LiteralValue*)(Soprano::LiteralValue*)xptr;
	  default: return xptr;
	}
      case 47:	//Soprano::Model
	switch(to) {
	    case 9: return (void*)(QObject*)(Soprano::Model*)xptr;
	    case 47: return (void*)(Soprano::Model*)(Soprano::Model*)xptr;
	    case 21: return (void*)(Soprano::Client::DBusModel*)(Soprano::Model*)xptr;
	    case 26: return (void*)(Soprano::Client::SparqlModel*)(Soprano::Model*)xptr;
	    case 32: return (void*)(Soprano::FilterModel*)(Soprano::Model*)xptr;
	    case 36: return (void*)(Soprano::Index::IndexFilterModel*)(Soprano::Model*)xptr;
	    case 39: return (void*)(Soprano::Inference::InferenceModel*)(Soprano::Model*)xptr;
	    case 55: return (void*)(Soprano::RdfSchemaModel*)(Soprano::Model*)xptr;
	    case 59: return (void*)(Soprano::Server::DBusExportModel*)(Soprano::Model*)xptr;
	    case 63: return (void*)(Soprano::StorageModel*)(Soprano::Model*)xptr;
	    case 65: return (void*)(Soprano::Util::AsyncModel*)(Soprano::Model*)xptr;
	    case 67: return (void*)(Soprano::Util::MutexModel*)(Soprano::Model*)xptr;
	    case 68: return (void*)(Soprano::Util::ReadOnlyModel*)(Soprano::Model*)xptr;
	    case 69: return (void*)(Soprano::Util::SignalCacheModel*)(Soprano::Model*)xptr;
	  default: return xptr;
	}
      case 48:	//Soprano::Node
	switch(to) {
	    case 48: return (void*)(Soprano::Node*)(Soprano::Node*)xptr;
	  default: return xptr;
	}
      case 49:	//Soprano::NodeIterator
	switch(to) {
	    case 49: return (void*)(Soprano::NodeIterator*)(Soprano::NodeIterator*)xptr;
	    case 22: return (void*)(Soprano::Client::DBusNodeIterator*)(Soprano::NodeIterator*)xptr;
	    case 70: return (void*)(Soprano::Util::SimpleNodeIterator*)(Soprano::NodeIterator*)xptr;
	  default: return xptr;
	}
      case 50:	//Soprano::Parser
	switch(to) {
	    case 51: return (void*)(Soprano::Plugin*)(Soprano::Parser*)xptr;
	    case 50: return (void*)(Soprano::Parser*)(Soprano::Parser*)xptr;
	  default: return xptr;
	}
      case 51:	//Soprano::Plugin
	switch(to) {
	    case 51: return (void*)(Soprano::Plugin*)(Soprano::Plugin*)xptr;
	    case 16: return (void*)(Soprano::Backend*)(Soprano::Plugin*)xptr;
	    case 50: return (void*)(Soprano::Parser*)(Soprano::Plugin*)xptr;
	    case 56: return (void*)(Soprano::Serializer*)(Soprano::Plugin*)xptr;
	  default: return xptr;
	}
      case 52:	//Soprano::PluginManager
	switch(to) {
	    case 9: return (void*)(QObject*)(Soprano::PluginManager*)xptr;
	    case 52: return (void*)(Soprano::PluginManager*)(Soprano::PluginManager*)xptr;
	  default: return xptr;
	}
      case 54:	//Soprano::QueryResultIterator
	switch(to) {
	    case 54: return (void*)(Soprano::QueryResultIterator*)(Soprano::QueryResultIterator*)xptr;
	    case 23: return (void*)(Soprano::Client::DBusQueryResultIterator*)(Soprano::QueryResultIterator*)xptr;
	  default: return xptr;
	}
      case 55:	//Soprano::RdfSchemaModel
	switch(to) {
	    case 32: return (void*)(Soprano::FilterModel*)(Soprano::RdfSchemaModel*)xptr;
	    case 47: return (void*)(Soprano::Model*)(Soprano::RdfSchemaModel*)xptr;
	    case 9: return (void*)(QObject*)(Soprano::RdfSchemaModel*)xptr;
	    case 55: return (void*)(Soprano::RdfSchemaModel*)(Soprano::RdfSchemaModel*)xptr;
	  default: return xptr;
	}
      case 56:	//Soprano::Serializer
	switch(to) {
	    case 51: return (void*)(Soprano::Plugin*)(Soprano::Serializer*)xptr;
	    case 56: return (void*)(Soprano::Serializer*)(Soprano::Serializer*)xptr;
	  default: return xptr;
	}
      case 58:	//Soprano::Server::DBusExportIterator
	switch(to) {
	    case 9: return (void*)(QObject*)(Soprano::Server::DBusExportIterator*)xptr;
	    case 58: return (void*)(Soprano::Server::DBusExportIterator*)(Soprano::Server::DBusExportIterator*)xptr;
	  default: return xptr;
	}
      case 59:	//Soprano::Server::DBusExportModel
	switch(to) {
	    case 32: return (void*)(Soprano::FilterModel*)(Soprano::Server::DBusExportModel*)xptr;
	    case 47: return (void*)(Soprano::Model*)(Soprano::Server::DBusExportModel*)xptr;
	    case 9: return (void*)(QObject*)(Soprano::Server::DBusExportModel*)xptr;
	    case 59: return (void*)(Soprano::Server::DBusExportModel*)(Soprano::Server::DBusExportModel*)xptr;
	  default: return xptr;
	}
      case 60:	//Soprano::Server::ServerCore
	switch(to) {
	    case 9: return (void*)(QObject*)(Soprano::Server::ServerCore*)xptr;
	    case 60: return (void*)(Soprano::Server::ServerCore*)(Soprano::Server::ServerCore*)xptr;
	  default: return xptr;
	}
      case 61:	//Soprano::Statement
	switch(to) {
	    case 61: return (void*)(Soprano::Statement*)(Soprano::Statement*)xptr;
	  default: return xptr;
	}
      case 62:	//Soprano::StatementIterator
	switch(to) {
	    case 62: return (void*)(Soprano::StatementIterator*)(Soprano::StatementIterator*)xptr;
	    case 24: return (void*)(Soprano::Client::DBusStatementIterator*)(Soprano::StatementIterator*)xptr;
	  default: return xptr;
	}
      case 63:	//Soprano::StorageModel
	switch(to) {
	    case 47: return (void*)(Soprano::Model*)(Soprano::StorageModel*)xptr;
	    case 9: return (void*)(QObject*)(Soprano::StorageModel*)xptr;
	    case 63: return (void*)(Soprano::StorageModel*)(Soprano::StorageModel*)xptr;
	    case 21: return (void*)(Soprano::Client::DBusModel*)(Soprano::StorageModel*)xptr;
	  default: return xptr;
	}
      case 65:	//Soprano::Util::AsyncModel
	switch(to) {
	    case 32: return (void*)(Soprano::FilterModel*)(Soprano::Util::AsyncModel*)xptr;
	    case 47: return (void*)(Soprano::Model*)(Soprano::Util::AsyncModel*)xptr;
	    case 9: return (void*)(QObject*)(Soprano::Util::AsyncModel*)xptr;
	    case 65: return (void*)(Soprano::Util::AsyncModel*)(Soprano::Util::AsyncModel*)xptr;
	  default: return xptr;
	}
      case 66:	//Soprano::Util::AsyncResult
	switch(to) {
	    case 9: return (void*)(QObject*)(Soprano::Util::AsyncResult*)xptr;
	    case 66: return (void*)(Soprano::Util::AsyncResult*)(Soprano::Util::AsyncResult*)xptr;
	  default: return xptr;
	}
      case 67:	//Soprano::Util::MutexModel
	switch(to) {
	    case 32: return (void*)(Soprano::FilterModel*)(Soprano::Util::MutexModel*)xptr;
	    case 47: return (void*)(Soprano::Model*)(Soprano::Util::MutexModel*)xptr;
	    case 9: return (void*)(QObject*)(Soprano::Util::MutexModel*)xptr;
	    case 67: return (void*)(Soprano::Util::MutexModel*)(Soprano::Util::MutexModel*)xptr;
	  default: return xptr;
	}
      case 68:	//Soprano::Util::ReadOnlyModel
	switch(to) {
	    case 47: return (void*)(Soprano::Model*)(Soprano::Util::ReadOnlyModel*)xptr;
	    case 9: return (void*)(QObject*)(Soprano::Util::ReadOnlyModel*)xptr;
	    case 68: return (void*)(Soprano::Util::ReadOnlyModel*)(Soprano::Util::ReadOnlyModel*)xptr;
	  default: return xptr;
	}
      case 69:	//Soprano::Util::SignalCacheModel
	switch(to) {
	    case 32: return (void*)(Soprano::FilterModel*)(Soprano::Util::SignalCacheModel*)xptr;
	    case 47: return (void*)(Soprano::Model*)(Soprano::Util::SignalCacheModel*)xptr;
	    case 9: return (void*)(QObject*)(Soprano::Util::SignalCacheModel*)xptr;
	    case 69: return (void*)(Soprano::Util::SignalCacheModel*)(Soprano::Util::SignalCacheModel*)xptr;
	  default: return xptr;
	}
      case 70:	//Soprano::Util::SimpleNodeIterator
	switch(to) {
	    case 49: return (void*)(Soprano::NodeIterator*)(Soprano::Util::SimpleNodeIterator*)xptr;
	    case 70: return (void*)(Soprano::Util::SimpleNodeIterator*)(Soprano::Util::SimpleNodeIterator*)xptr;
	  default: return xptr;
	}
      default: return xptr;
    }
}

// Group of Indexes (0 separated) used as super class lists.
// Classes with super classes have an index into this array.
static Smoke::Index soprano_inheritanceList[] = {
	0,	// 0: (no super class)
	51, 0,	// 1: Soprano::Error::ErrorCache, Soprano::Plugin
	9, 0,	// 3: Soprano::Error::ErrorCache, QObject
	63, 0,	// 5: Soprano::StorageModel
	49, 0,	// 7: Soprano::NodeIterator
	54, 0,	// 9: Soprano::QueryResultIterator
	62, 0,	// 11: Soprano::StatementIterator
	47, 0,	// 13: Soprano::Model
	29, 0,	// 15: Soprano::Error::Error
	32, 0,	// 17: Soprano::FilterModel
};

// These are the xenum functions for manipulating enum pointers
void xenum_Soprano__Util__AsyncModel(Smoke::EnumOperation, Smoke::Index, void*&, long&);
void xenum_Soprano__Error(Smoke::EnumOperation, Smoke::Index, void*&, long&);
void xenum_Soprano__Util__MutexModel(Smoke::EnumOperation, Smoke::Index, void*&, long&);
void xenum_Soprano(Smoke::EnumOperation, Smoke::Index, void*&, long&);
void xenum_Soprano__Query(Smoke::EnumOperation, Smoke::Index, void*&, long&);
void xenum_Soprano__Inference(Smoke::EnumOperation, Smoke::Index, void*&, long&);
void xenum_Soprano__LanguageTag(Smoke::EnumOperation, Smoke::Index, void*&, long&);
void xenum_Soprano__Node(Smoke::EnumOperation, Smoke::Index, void*&, long&);

// Those are the xcall functions defined in each x_*.cpp file, for dispatching method calls
void xcall_Soprano(Smoke::Index, void*, Smoke::Stack);
void xcall_Soprano__Backend(Smoke::Index, void*, Smoke::Stack);
void xcall_Soprano__BackendSetting(Smoke::Index, void*, Smoke::Stack);
void xcall_Soprano__BindingSet(Smoke::Index, void*, Smoke::Stack);
void xcall_Soprano__Client(Smoke::Index, void*, Smoke::Stack);
void xcall_Soprano__Client__DBusClient(Smoke::Index, void*, Smoke::Stack);
void xcall_Soprano__Client__DBusModel(Smoke::Index, void*, Smoke::Stack);
void xcall_Soprano__Client__DBusNodeIterator(Smoke::Index, void*, Smoke::Stack);
void xcall_Soprano__Client__DBusQueryResultIterator(Smoke::Index, void*, Smoke::Stack);
void xcall_Soprano__Client__DBusStatementIterator(Smoke::Index, void*, Smoke::Stack);
void xcall_Soprano__Client__LocalSocketClient(Smoke::Index, void*, Smoke::Stack);
void xcall_Soprano__Client__SparqlModel(Smoke::Index, void*, Smoke::Stack);
void xcall_Soprano__Client__TcpClient(Smoke::Index, void*, Smoke::Stack);
void xcall_Soprano__Error(Smoke::Index, void*, Smoke::Stack);
void xcall_Soprano__Error__Error(Smoke::Index, void*, Smoke::Stack);
void xcall_Soprano__Error__Locator(Smoke::Index, void*, Smoke::Stack);
void xcall_Soprano__Error__ParserError(Smoke::Index, void*, Smoke::Stack);
void xcall_Soprano__FilterModel(Smoke::Index, void*, Smoke::Stack);
void xcall_Soprano__Graph(Smoke::Index, void*, Smoke::Stack);
void xcall_Soprano__Index(Smoke::Index, void*, Smoke::Stack);
void xcall_Soprano__Index__CLuceneIndex(Smoke::Index, void*, Smoke::Stack);
void xcall_Soprano__Index__IndexFilterModel(Smoke::Index, void*, Smoke::Stack);
void xcall_Soprano__Index__QueryHit(Smoke::Index, void*, Smoke::Stack);
void xcall_Soprano__Inference(Smoke::Index, void*, Smoke::Stack);
void xcall_Soprano__Inference__InferenceModel(Smoke::Index, void*, Smoke::Stack);
void xcall_Soprano__Inference__NodePattern(Smoke::Index, void*, Smoke::Stack);
void xcall_Soprano__Inference__Rule(Smoke::Index, void*, Smoke::Stack);
void xcall_Soprano__Inference__RuleParser(Smoke::Index, void*, Smoke::Stack);
void xcall_Soprano__Inference__RuleSet(Smoke::Index, void*, Smoke::Stack);
void xcall_Soprano__Inference__StatementPattern(Smoke::Index, void*, Smoke::Stack);
void xcall_Soprano__LanguageTag(Smoke::Index, void*, Smoke::Stack);
void xcall_Soprano__LiteralValue(Smoke::Index, void*, Smoke::Stack);
void xcall_Soprano__Model(Smoke::Index, void*, Smoke::Stack);
void xcall_Soprano__Node(Smoke::Index, void*, Smoke::Stack);
void xcall_Soprano__NodeIterator(Smoke::Index, void*, Smoke::Stack);
void xcall_Soprano__Parser(Smoke::Index, void*, Smoke::Stack);
void xcall_Soprano__Plugin(Smoke::Index, void*, Smoke::Stack);
void xcall_Soprano__PluginManager(Smoke::Index, void*, Smoke::Stack);
void xcall_Soprano__Query(Smoke::Index, void*, Smoke::Stack);
void xcall_Soprano__QueryResultIterator(Smoke::Index, void*, Smoke::Stack);
void xcall_Soprano__RdfSchemaModel(Smoke::Index, void*, Smoke::Stack);
void xcall_Soprano__Serializer(Smoke::Index, void*, Smoke::Stack);
void xcall_Soprano__Server(Smoke::Index, void*, Smoke::Stack);
void xcall_Soprano__Server__DBusExportIterator(Smoke::Index, void*, Smoke::Stack);
void xcall_Soprano__Server__DBusExportModel(Smoke::Index, void*, Smoke::Stack);
void xcall_Soprano__Server__ServerCore(Smoke::Index, void*, Smoke::Stack);
void xcall_Soprano__Statement(Smoke::Index, void*, Smoke::Stack);
void xcall_Soprano__StatementIterator(Smoke::Index, void*, Smoke::Stack);
void xcall_Soprano__StorageModel(Smoke::Index, void*, Smoke::Stack);
void xcall_Soprano__Util(Smoke::Index, void*, Smoke::Stack);
void xcall_Soprano__Util__AsyncModel(Smoke::Index, void*, Smoke::Stack);
void xcall_Soprano__Util__AsyncResult(Smoke::Index, void*, Smoke::Stack);
void xcall_Soprano__Util__MutexModel(Smoke::Index, void*, Smoke::Stack);
void xcall_Soprano__Util__ReadOnlyModel(Smoke::Index, void*, Smoke::Stack);
void xcall_Soprano__Util__SignalCacheModel(Smoke::Index, void*, Smoke::Stack);
void xcall_Soprano__Util__SimpleNodeIterator(Smoke::Index, void*, Smoke::Stack);
void xcall_Soprano__Vocabulary(Smoke::Index, void*, Smoke::Stack);
void xcall_Soprano__Vocabulary__NAO(Smoke::Index, void*, Smoke::Stack);
void xcall_Soprano__Vocabulary__NRL(Smoke::Index, void*, Smoke::Stack);
void xcall_Soprano__Vocabulary__OWL(Smoke::Index, void*, Smoke::Stack);
void xcall_Soprano__Vocabulary__RDF(Smoke::Index, void*, Smoke::Stack);
void xcall_Soprano__Vocabulary__RDFS(Smoke::Index, void*, Smoke::Stack);
void xcall_Soprano__Vocabulary__SIL(Smoke::Index, void*, Smoke::Stack);
void xcall_Soprano__Vocabulary__XMLSchema(Smoke::Index, void*, Smoke::Stack);
void xcall_Soprano__Vocabulary__Xesam(Smoke::Index, void*, Smoke::Stack);

// List of all classes
// Name, index into inheritanceList, method dispatcher, enum dispatcher, class flags
static Smoke::Class soprano_classes[] = {
	{ 0L, false, 0, 0, 0, 0 }, 	// 0 (no class)
	{ "QByteArray", true, 0, 0, 0, 0 }, 	// 1
	{ "QChildEvent", true, 0, 0, 0, 0 }, 	// 2
	{ "QDate", true, 0, 0, 0, 0 }, 	// 3
	{ "QDateTime", true, 0, 0, 0, 0 }, 	// 4
	{ "QEvent", true, 0, 0, 0, 0 }, 	// 5
	{ "QHostAddress", true, 0, 0, 0, 0 }, 	// 6
	{ "QLocale", true, 0, 0, 0, 0 }, 	// 7
	{ "QMetaObject", true, 0, 0, 0, 0 }, 	// 8
	{ "QObject", true, 0, 0, 0, 0 }, 	// 9
	{ "QTextStream", true, 0, 0, 0, 0 }, 	// 10
	{ "QTime", true, 0, 0, 0, 0 }, 	// 11
	{ "QTimerEvent", true, 0, 0, 0, 0 }, 	// 12
	{ "QUrl", true, 0, 0, 0, 0 }, 	// 13
	{ "QVariant", true, 0, 0, 0, 0 }, 	// 14
	{ "Soprano", false, 0, xcall_Soprano, xenum_Soprano, Smoke::cf_deepcopy }, 	//15
	{ "Soprano::Backend", false, 1, xcall_Soprano__Backend, 0, Smoke::cf_constructor|Smoke::cf_virtual }, 	//16
	{ "Soprano::BackendSetting", false, 0, xcall_Soprano__BackendSetting, 0, Smoke::cf_constructor|Smoke::cf_deepcopy }, 	//17
	{ "Soprano::BindingSet", false, 0, xcall_Soprano__BindingSet, 0, Smoke::cf_constructor|Smoke::cf_deepcopy }, 	//18
	{ "Soprano::Client", false, 0, xcall_Soprano__Client, 0, Smoke::cf_deepcopy }, 	//19
	{ "Soprano::Client::DBusClient", false, 3, xcall_Soprano__Client__DBusClient, 0, Smoke::cf_constructor|Smoke::cf_virtual }, 	//20
	{ "Soprano::Client::DBusModel", false, 5, xcall_Soprano__Client__DBusModel, 0, Smoke::cf_constructor|Smoke::cf_virtual }, 	//21
	{ "Soprano::Client::DBusNodeIterator", false, 7, xcall_Soprano__Client__DBusNodeIterator, 0, Smoke::cf_constructor|Smoke::cf_virtual }, 	//22
	{ "Soprano::Client::DBusQueryResultIterator", false, 9, xcall_Soprano__Client__DBusQueryResultIterator, 0, Smoke::cf_constructor|Smoke::cf_virtual }, 	//23
	{ "Soprano::Client::DBusStatementIterator", false, 11, xcall_Soprano__Client__DBusStatementIterator, 0, Smoke::cf_constructor|Smoke::cf_virtual }, 	//24
	{ "Soprano::Client::LocalSocketClient", false, 3, xcall_Soprano__Client__LocalSocketClient, 0, Smoke::cf_constructor|Smoke::cf_virtual }, 	//25
	{ "Soprano::Client::SparqlModel", false, 13, xcall_Soprano__Client__SparqlModel, 0, Smoke::cf_constructor|Smoke::cf_virtual }, 	//26
	{ "Soprano::Client::TcpClient", false, 3, xcall_Soprano__Client__TcpClient, 0, Smoke::cf_constructor|Smoke::cf_virtual }, 	//27
	{ "Soprano::Error", false, 0, xcall_Soprano__Error, xenum_Soprano__Error, Smoke::cf_deepcopy }, 	//28
	{ "Soprano::Error::Error", false, 0, xcall_Soprano__Error__Error, 0, Smoke::cf_constructor|Smoke::cf_deepcopy|Smoke::cf_virtual }, 	//29
	{ "Soprano::Error::Locator", false, 0, xcall_Soprano__Error__Locator, 0, Smoke::cf_constructor|Smoke::cf_deepcopy }, 	//30
	{ "Soprano::Error::ParserError", false, 15, xcall_Soprano__Error__ParserError, 0, Smoke::cf_constructor|Smoke::cf_deepcopy|Smoke::cf_virtual }, 	//31
	{ "Soprano::FilterModel", false, 13, xcall_Soprano__FilterModel, 0, Smoke::cf_constructor|Smoke::cf_virtual }, 	//32
	{ "Soprano::Graph", false, 0, xcall_Soprano__Graph, 0, Smoke::cf_constructor|Smoke::cf_deepcopy }, 	//33
	{ "Soprano::Index", false, 0, xcall_Soprano__Index, 0, Smoke::cf_deepcopy }, 	//34
	{ "Soprano::Index::CLuceneIndex", false, 0, xcall_Soprano__Index__CLuceneIndex, 0, Smoke::cf_constructor }, 	//35
	{ "Soprano::Index::IndexFilterModel", false, 17, xcall_Soprano__Index__IndexFilterModel, 0, Smoke::cf_constructor|Smoke::cf_virtual }, 	//36
	{ "Soprano::Index::QueryHit", false, 0, xcall_Soprano__Index__QueryHit, 0, Smoke::cf_constructor|Smoke::cf_deepcopy }, 	//37
	{ "Soprano::Inference", false, 0, xcall_Soprano__Inference, xenum_Soprano__Inference, Smoke::cf_deepcopy }, 	//38
	{ "Soprano::Inference::InferenceModel", false, 17, xcall_Soprano__Inference__InferenceModel, 0, Smoke::cf_constructor|Smoke::cf_virtual }, 	//39
	{ "Soprano::Inference::NodePattern", false, 0, xcall_Soprano__Inference__NodePattern, 0, Smoke::cf_constructor|Smoke::cf_deepcopy }, 	//40
	{ "Soprano::Inference::Rule", false, 0, xcall_Soprano__Inference__Rule, 0, Smoke::cf_constructor|Smoke::cf_deepcopy }, 	//41
	{ "Soprano::Inference::RuleParser", false, 0, xcall_Soprano__Inference__RuleParser, 0, Smoke::cf_constructor|Smoke::cf_deepcopy }, 	//42
	{ "Soprano::Inference::RuleSet", false, 0, xcall_Soprano__Inference__RuleSet, 0, Smoke::cf_constructor|Smoke::cf_deepcopy }, 	//43
	{ "Soprano::Inference::StatementPattern", false, 0, xcall_Soprano__Inference__StatementPattern, 0, Smoke::cf_constructor|Smoke::cf_deepcopy }, 	//44
	{ "Soprano::LanguageTag", false, 0, xcall_Soprano__LanguageTag, xenum_Soprano__LanguageTag, Smoke::cf_constructor|Smoke::cf_deepcopy }, 	//45
	{ "Soprano::LiteralValue", false, 0, xcall_Soprano__LiteralValue, 0, Smoke::cf_constructor|Smoke::cf_deepcopy }, 	//46
	{ "Soprano::Model", false, 3, xcall_Soprano__Model, 0, Smoke::cf_constructor|Smoke::cf_virtual }, 	//47
	{ "Soprano::Node", false, 0, xcall_Soprano__Node, xenum_Soprano__Node, Smoke::cf_constructor|Smoke::cf_deepcopy }, 	//48
	{ "Soprano::NodeIterator", false, 0, xcall_Soprano__NodeIterator, 0, Smoke::cf_constructor|Smoke::cf_virtual }, 	//49
	{ "Soprano::Parser", false, 1, xcall_Soprano__Parser, 0, Smoke::cf_constructor|Smoke::cf_virtual }, 	//50
	{ "Soprano::Plugin", false, 0, xcall_Soprano__Plugin, 0, Smoke::cf_constructor|Smoke::cf_deepcopy|Smoke::cf_virtual }, 	//51
	{ "Soprano::PluginManager", false, 3, xcall_Soprano__PluginManager, 0, Smoke::cf_virtual }, 	//52
	{ "Soprano::Query", false, 0, xcall_Soprano__Query, xenum_Soprano__Query, Smoke::cf_deepcopy }, 	//53
	{ "Soprano::QueryResultIterator", false, 0, xcall_Soprano__QueryResultIterator, 0, Smoke::cf_constructor|Smoke::cf_virtual }, 	//54
	{ "Soprano::RdfSchemaModel", false, 17, xcall_Soprano__RdfSchemaModel, 0, Smoke::cf_constructor|Smoke::cf_virtual }, 	//55
	{ "Soprano::Serializer", false, 1, xcall_Soprano__Serializer, 0, Smoke::cf_constructor|Smoke::cf_virtual }, 	//56
	{ "Soprano::Server", false, 0, xcall_Soprano__Server, 0, Smoke::cf_deepcopy }, 	//57
	{ "Soprano::Server::DBusExportIterator", false, 3, xcall_Soprano__Server__DBusExportIterator, 0, Smoke::cf_constructor|Smoke::cf_virtual }, 	//58
	{ "Soprano::Server::DBusExportModel", false, 17, xcall_Soprano__Server__DBusExportModel, 0, Smoke::cf_constructor|Smoke::cf_virtual }, 	//59
	{ "Soprano::Server::ServerCore", false, 3, xcall_Soprano__Server__ServerCore, 0, Smoke::cf_constructor|Smoke::cf_virtual }, 	//60
	{ "Soprano::Statement", false, 0, xcall_Soprano__Statement, 0, Smoke::cf_constructor|Smoke::cf_deepcopy|Smoke::cf_virtual }, 	//61
	{ "Soprano::StatementIterator", false, 0, xcall_Soprano__StatementIterator, 0, Smoke::cf_constructor|Smoke::cf_virtual }, 	//62
	{ "Soprano::StorageModel", false, 13, xcall_Soprano__StorageModel, 0, Smoke::cf_constructor|Smoke::cf_virtual }, 	//63
	{ "Soprano::Util", false, 0, xcall_Soprano__Util, 0, Smoke::cf_deepcopy }, 	//64
	{ "Soprano::Util::AsyncModel", false, 17, xcall_Soprano__Util__AsyncModel, xenum_Soprano__Util__AsyncModel, Smoke::cf_constructor|Smoke::cf_virtual }, 	//65
	{ "Soprano::Util::AsyncResult", false, 3, xcall_Soprano__Util__AsyncResult, 0, Smoke::cf_virtual }, 	//66
	{ "Soprano::Util::MutexModel", false, 17, xcall_Soprano__Util__MutexModel, xenum_Soprano__Util__MutexModel, Smoke::cf_constructor|Smoke::cf_virtual }, 	//67
	{ "Soprano::Util::ReadOnlyModel", false, 13, xcall_Soprano__Util__ReadOnlyModel, 0, Smoke::cf_constructor|Smoke::cf_virtual }, 	//68
	{ "Soprano::Util::SignalCacheModel", false, 17, xcall_Soprano__Util__SignalCacheModel, 0, Smoke::cf_constructor|Smoke::cf_virtual }, 	//69
	{ "Soprano::Util::SimpleNodeIterator", false, 7, xcall_Soprano__Util__SimpleNodeIterator, 0, Smoke::cf_constructor|Smoke::cf_virtual }, 	//70
	{ "Soprano::Vocabulary", false, 0, xcall_Soprano__Vocabulary, 0, Smoke::cf_deepcopy }, 	//71
	{ "Soprano::Vocabulary::NAO", false, 0, xcall_Soprano__Vocabulary__NAO, 0, Smoke::cf_deepcopy }, 	//72
	{ "Soprano::Vocabulary::NRL", false, 0, xcall_Soprano__Vocabulary__NRL, 0, Smoke::cf_deepcopy }, 	//73
	{ "Soprano::Vocabulary::OWL", false, 0, xcall_Soprano__Vocabulary__OWL, 0, Smoke::cf_deepcopy }, 	//74
	{ "Soprano::Vocabulary::RDF", false, 0, xcall_Soprano__Vocabulary__RDF, 0, Smoke::cf_deepcopy }, 	//75
	{ "Soprano::Vocabulary::RDFS", false, 0, xcall_Soprano__Vocabulary__RDFS, 0, Smoke::cf_deepcopy }, 	//76
	{ "Soprano::Vocabulary::SIL", false, 0, xcall_Soprano__Vocabulary__SIL, 0, Smoke::cf_deepcopy }, 	//77
	{ "Soprano::Vocabulary::XMLSchema", false, 0, xcall_Soprano__Vocabulary__XMLSchema, 0, Smoke::cf_deepcopy }, 	//78
	{ "Soprano::Vocabulary::Xesam", false, 0, xcall_Soprano__Vocabulary__Xesam, 0, Smoke::cf_deepcopy }, 	//79
	{ "lucene::analysis", true, 0, 0, 0, 0 }, 	// 80
	{ "lucene::document", true, 0, 0, 0, 0 }, 	// 81
};

// List of all types needed by the methods (arguments and return values)
// Name, class ID if arg is a class, and TypeId
static Smoke::Type soprano_types[] = {
	{ 0, 0, 0 },	//0 (no type)
	{ "QAbstractFileEngine::FileFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//1
	{ "QAbstractFileEngine::FileFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//2
	{ "QAbstractItemView::EditTriggers", 0, Smoke::t_uint | Smoke::tf_stack },	//3
	{ "QAbstractItemView::EditTriggers&", 0, Smoke::t_voidp | Smoke::tf_ref },	//4
	{ "QAbstractPrintDialog::PrintDialogOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//5
	{ "QAbstractPrintDialog::PrintDialogOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//6
	{ "QAbstractSpinBox::StepEnabled", 0, Smoke::t_uint | Smoke::tf_stack },	//7
	{ "QAbstractSpinBox::StepEnabled&", 0, Smoke::t_voidp | Smoke::tf_ref },	//8
	{ "QAccessible::Relation", 0, Smoke::t_uint | Smoke::tf_stack },	//9
	{ "QAccessible::Relation&", 0, Smoke::t_voidp | Smoke::tf_ref },	//10
	{ "QAccessible::State", 0, Smoke::t_uint | Smoke::tf_stack },	//11
	{ "QAccessible::State&", 0, Smoke::t_voidp | Smoke::tf_ref },	//12
	{ "QByteArray", 1, Smoke::t_class | Smoke::tf_stack },	//13
	{ "QChildEvent*", 2, Smoke::t_class | Smoke::tf_ptr },	//14
	{ "QColorDialog::ColorDialogOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//15
	{ "QColorDialog::ColorDialogOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//16
	{ "QDBusConnection::RegisterOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//17
	{ "QDBusConnection::RegisterOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//18
	{ "QDate", 3, Smoke::t_class | Smoke::tf_stack },	//19
	{ "QDateTime", 4, Smoke::t_class | Smoke::tf_stack },	//20
	{ "QDateTimeEdit::Sections", 0, Smoke::t_uint | Smoke::tf_stack },	//21
	{ "QDateTimeEdit::Sections&", 0, Smoke::t_voidp | Smoke::tf_ref },	//22
	{ "QDialogButtonBox::StandardButtons", 0, Smoke::t_uint | Smoke::tf_stack },	//23
	{ "QDialogButtonBox::StandardButtons&", 0, Smoke::t_voidp | Smoke::tf_ref },	//24
	{ "QDir::Filters", 0, Smoke::t_uint | Smoke::tf_stack },	//25
	{ "QDir::Filters&", 0, Smoke::t_voidp | Smoke::tf_ref },	//26
	{ "QDir::SortFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//27
	{ "QDir::SortFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//28
	{ "QDirIterator::IteratorFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//29
	{ "QDirIterator::IteratorFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//30
	{ "QDockWidget::DockWidgetFeatures", 0, Smoke::t_uint | Smoke::tf_stack },	//31
	{ "QDockWidget::DockWidgetFeatures&", 0, Smoke::t_voidp | Smoke::tf_ref },	//32
	{ "QEvent*", 5, Smoke::t_class | Smoke::tf_ptr },	//33
	{ "QEventLoop::ProcessEventsFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//34
	{ "QEventLoop::ProcessEventsFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//35
	{ "QFile::Permissions", 0, Smoke::t_uint | Smoke::tf_stack },	//36
	{ "QFile::Permissions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//37
	{ "QFileDialog::Options", 0, Smoke::t_uint | Smoke::tf_stack },	//38
	{ "QFileDialog::Options&", 0, Smoke::t_voidp | Smoke::tf_ref },	//39
	{ "QFontComboBox::FontFilters", 0, Smoke::t_uint | Smoke::tf_stack },	//40
	{ "QFontComboBox::FontFilters&", 0, Smoke::t_voidp | Smoke::tf_ref },	//41
	{ "QFontDialog::FontDialogOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//42
	{ "QFontDialog::FontDialogOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//43
	{ "QGL::FormatOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//44
	{ "QGL::FormatOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//45
	{ "QGLFormat::OpenGLVersionFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//46
	{ "QGLFormat::OpenGLVersionFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//47
	{ "QGraphicsItem::GraphicsItemFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//48
	{ "QGraphicsItem::GraphicsItemFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//49
	{ "QGraphicsScene::SceneLayers", 0, Smoke::t_uint | Smoke::tf_stack },	//50
	{ "QGraphicsScene::SceneLayers&", 0, Smoke::t_voidp | Smoke::tf_ref },	//51
	{ "QGraphicsView::CacheMode", 0, Smoke::t_uint | Smoke::tf_stack },	//52
	{ "QGraphicsView::CacheMode&", 0, Smoke::t_voidp | Smoke::tf_ref },	//53
	{ "QGraphicsView::OptimizationFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//54
	{ "QGraphicsView::OptimizationFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//55
	{ "QHash<QString,QUrl>", 0, Smoke::t_voidp | Smoke::tf_stack },	//56
	{ "QIODevice::OpenMode", 0, Smoke::t_uint | Smoke::tf_stack },	//57
	{ "QIODevice::OpenMode&", 0, Smoke::t_voidp | Smoke::tf_ref },	//58
	{ "QInputDialog::InputDialogOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//59
	{ "QInputDialog::InputDialogOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//60
	{ "QItemSelectionModel::SelectionFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//61
	{ "QItemSelectionModel::SelectionFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//62
	{ "QLibrary::LoadHints", 0, Smoke::t_uint | Smoke::tf_stack },	//63
	{ "QLibrary::LoadHints&", 0, Smoke::t_voidp | Smoke::tf_ref },	//64
	{ "QList<QUrl>", 0, Smoke::t_voidp | Smoke::tf_stack },	//65
	{ "QList<Soprano::BackendSetting>&", 0, Smoke::t_voidp | Smoke::tf_ref },	//66
	{ "QList<Soprano::BindingSet>", 0, Smoke::t_voidp | Smoke::tf_stack },	//67
	{ "QList<Soprano::Inference::Rule>", 0, Smoke::t_voidp | Smoke::tf_stack },	//68
	{ "QList<Soprano::Inference::StatementPattern>", 0, Smoke::t_voidp | Smoke::tf_stack },	//69
	{ "QList<Soprano::Node>", 0, Smoke::t_voidp | Smoke::tf_stack },	//70
	{ "QList<Soprano::Statement>", 0, Smoke::t_voidp | Smoke::tf_stack },	//71
	{ "QList<const Soprano::Backend*>", 0, Smoke::t_voidp | Smoke::tf_stack },	//72
	{ "QList<const Soprano::Parser*>", 0, Smoke::t_voidp | Smoke::tf_stack },	//73
	{ "QList<const Soprano::Serializer*>", 0, Smoke::t_voidp | Smoke::tf_stack },	//74
	{ "QLocale", 7, Smoke::t_class | Smoke::tf_stack },	//75
	{ "QLocale::Country", 7, Smoke::t_enum | Smoke::tf_stack },	//76
	{ "QLocale::Language", 7, Smoke::t_enum | Smoke::tf_stack },	//77
	{ "QLocale::NumberOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//78
	{ "QLocale::NumberOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//79
	{ "QMainWindow::DockOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//80
	{ "QMainWindow::DockOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//81
	{ "QMdiArea::AreaOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//82
	{ "QMdiArea::AreaOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//83
	{ "QMdiSubWindow::SubWindowOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//84
	{ "QMdiSubWindow::SubWindowOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//85
	{ "QMessageBox::StandardButtons", 0, Smoke::t_uint | Smoke::tf_stack },	//86
	{ "QMessageBox::StandardButtons&", 0, Smoke::t_voidp | Smoke::tf_ref },	//87
	{ "QMetaObject::Call", 8, Smoke::t_enum | Smoke::tf_stack },	//88
	{ "QNetworkInterface::InterfaceFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//89
	{ "QNetworkInterface::InterfaceFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//90
	{ "QNetworkProxy::Capabilities", 0, Smoke::t_uint | Smoke::tf_stack },	//91
	{ "QNetworkProxy::Capabilities&", 0, Smoke::t_voidp | Smoke::tf_ref },	//92
	{ "QObject*", 9, Smoke::t_class | Smoke::tf_ptr },	//93
	{ "QPageSetupDialog::PageSetupDialogOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//94
	{ "QPageSetupDialog::PageSetupDialogOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//95
	{ "QPaintEngine::DirtyFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//96
	{ "QPaintEngine::DirtyFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//97
	{ "QPaintEngine::PaintEngineFeatures", 0, Smoke::t_uint | Smoke::tf_stack },	//98
	{ "QPaintEngine::PaintEngineFeatures&", 0, Smoke::t_voidp | Smoke::tf_ref },	//99
	{ "QPainter::RenderHints", 0, Smoke::t_uint | Smoke::tf_stack },	//100
	{ "QPainter::RenderHints&", 0, Smoke::t_voidp | Smoke::tf_ref },	//101
	{ "QSizePolicy::ControlTypes", 0, Smoke::t_uint | Smoke::tf_stack },	//102
	{ "QSizePolicy::ControlTypes&", 0, Smoke::t_voidp | Smoke::tf_ref },	//103
	{ "QSql::ParamType", 0, Smoke::t_uint | Smoke::tf_stack },	//104
	{ "QSql::ParamType&", 0, Smoke::t_voidp | Smoke::tf_ref },	//105
	{ "QString", 0, Smoke::t_voidp | Smoke::tf_stack },	//106
	{ "QString&", 0, Smoke::t_voidp | Smoke::tf_ref },	//107
	{ "QString::SectionFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//108
	{ "QString::SectionFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//109
	{ "QStringList", 0, Smoke::t_voidp | Smoke::tf_stack },	//110
	{ "QStyle::State", 0, Smoke::t_uint | Smoke::tf_stack },	//111
	{ "QStyle::State&", 0, Smoke::t_voidp | Smoke::tf_ref },	//112
	{ "QStyle::SubControls", 0, Smoke::t_uint | Smoke::tf_stack },	//113
	{ "QStyle::SubControls&", 0, Smoke::t_voidp | Smoke::tf_ref },	//114
	{ "QStyleOptionButton::ButtonFeatures", 0, Smoke::t_uint | Smoke::tf_stack },	//115
	{ "QStyleOptionButton::ButtonFeatures&", 0, Smoke::t_voidp | Smoke::tf_ref },	//116
	{ "QStyleOptionFrameV2::FrameFeatures", 0, Smoke::t_uint | Smoke::tf_stack },	//117
	{ "QStyleOptionFrameV2::FrameFeatures&", 0, Smoke::t_voidp | Smoke::tf_ref },	//118
	{ "QStyleOptionQ3ListViewItem::Q3ListViewItemFeatures", 0, Smoke::t_uint | Smoke::tf_stack },	//119
	{ "QStyleOptionQ3ListViewItem::Q3ListViewItemFeatures&", 0, Smoke::t_voidp | Smoke::tf_ref },	//120
	{ "QStyleOptionTab::CornerWidgets", 0, Smoke::t_uint | Smoke::tf_stack },	//121
	{ "QStyleOptionTab::CornerWidgets&", 0, Smoke::t_voidp | Smoke::tf_ref },	//122
	{ "QStyleOptionToolBar::ToolBarFeatures", 0, Smoke::t_uint | Smoke::tf_stack },	//123
	{ "QStyleOptionToolBar::ToolBarFeatures&", 0, Smoke::t_voidp | Smoke::tf_ref },	//124
	{ "QStyleOptionToolButton::ToolButtonFeatures", 0, Smoke::t_uint | Smoke::tf_stack },	//125
	{ "QStyleOptionToolButton::ToolButtonFeatures&", 0, Smoke::t_voidp | Smoke::tf_ref },	//126
	{ "QStyleOptionViewItemV2::ViewItemFeatures", 0, Smoke::t_uint | Smoke::tf_stack },	//127
	{ "QStyleOptionViewItemV2::ViewItemFeatures&", 0, Smoke::t_voidp | Smoke::tf_ref },	//128
	{ "QTextCodec::ConversionFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//129
	{ "QTextCodec::ConversionFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//130
	{ "QTextDocument::FindFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//131
	{ "QTextDocument::FindFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//132
	{ "QTextEdit::AutoFormatting", 0, Smoke::t_uint | Smoke::tf_stack },	//133
	{ "QTextEdit::AutoFormatting&", 0, Smoke::t_voidp | Smoke::tf_ref },	//134
	{ "QTextFormat::PageBreakFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//135
	{ "QTextFormat::PageBreakFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//136
	{ "QTextItem::RenderFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//137
	{ "QTextItem::RenderFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//138
	{ "QTextOption::Flags", 0, Smoke::t_uint | Smoke::tf_stack },	//139
	{ "QTextOption::Flags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//140
	{ "QTextStream&", 10, Smoke::t_class | Smoke::tf_ref },	//141
	{ "QTextStream::NumberFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//142
	{ "QTextStream::NumberFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//143
	{ "QTime", 11, Smoke::t_class | Smoke::tf_stack },	//144
	{ "QTimerEvent*", 12, Smoke::t_class | Smoke::tf_ptr },	//145
	{ "QTreeWidgetItemIterator::IteratorFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//146
	{ "QTreeWidgetItemIterator::IteratorFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//147
	{ "QUdpSocket::BindMode", 0, Smoke::t_uint | Smoke::tf_stack },	//148
	{ "QUdpSocket::BindMode&", 0, Smoke::t_voidp | Smoke::tf_ref },	//149
	{ "QUrl", 13, Smoke::t_class | Smoke::tf_stack },	//150
	{ "QUrl::FormattingOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//151
	{ "QUrl::FormattingOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//152
	{ "QVariant", 14, Smoke::t_class | Smoke::tf_stack },	//153
	{ "QVariant::Type", 14, Smoke::t_enum | Smoke::tf_stack },	//154
	{ "QWidget::RenderFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//155
	{ "QWidget::RenderFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//156
	{ "QWizard::WizardOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//157
	{ "QWizard::WizardOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//158
	{ "Qt::Alignment", 0, Smoke::t_uint | Smoke::tf_stack },	//159
	{ "Qt::Alignment&", 0, Smoke::t_voidp | Smoke::tf_ref },	//160
	{ "Qt::DockWidgetAreas", 0, Smoke::t_uint | Smoke::tf_stack },	//161
	{ "Qt::DockWidgetAreas&", 0, Smoke::t_voidp | Smoke::tf_ref },	//162
	{ "Qt::DropActions", 0, Smoke::t_uint | Smoke::tf_stack },	//163
	{ "Qt::DropActions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//164
	{ "Qt::ImageConversionFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//165
	{ "Qt::ImageConversionFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//166
	{ "Qt::ItemFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//167
	{ "Qt::ItemFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//168
	{ "Qt::KeyboardModifiers", 0, Smoke::t_uint | Smoke::tf_stack },	//169
	{ "Qt::KeyboardModifiers&", 0, Smoke::t_voidp | Smoke::tf_ref },	//170
	{ "Qt::MatchFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//171
	{ "Qt::MatchFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//172
	{ "Qt::MouseButtons", 0, Smoke::t_uint | Smoke::tf_stack },	//173
	{ "Qt::MouseButtons&", 0, Smoke::t_voidp | Smoke::tf_ref },	//174
	{ "Qt::Orientations", 0, Smoke::t_uint | Smoke::tf_stack },	//175
	{ "Qt::Orientations&", 0, Smoke::t_voidp | Smoke::tf_ref },	//176
	{ "Qt::TextInteractionFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//177
	{ "Qt::TextInteractionFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//178
	{ "Qt::ToolBarAreas", 0, Smoke::t_uint | Smoke::tf_stack },	//179
	{ "Qt::ToolBarAreas&", 0, Smoke::t_voidp | Smoke::tf_ref },	//180
	{ "Qt::WindowFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//181
	{ "Qt::WindowFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//182
	{ "Qt::WindowStates", 0, Smoke::t_uint | Smoke::tf_stack },	//183
	{ "Qt::WindowStates&", 0, Smoke::t_voidp | Smoke::tf_ref },	//184
	{ "Soprano::Backend*", 16, Smoke::t_class | Smoke::tf_ptr },	//185
	{ "Soprano::BackendFeature", 15, Smoke::t_enum | Smoke::tf_stack },	//186
	{ "Soprano::BackendFeatures", 0, Smoke::t_uint | Smoke::tf_stack },	//187
	{ "Soprano::BackendFeatures&", 0, Smoke::t_voidp | Smoke::tf_ref },	//188
	{ "Soprano::BackendOption", 15, Smoke::t_enum | Smoke::tf_stack },	//189
	{ "Soprano::BackendOptions", 0, Smoke::t_uint | Smoke::tf_stack },	//190
	{ "Soprano::BackendOptions&", 0, Smoke::t_voidp | Smoke::tf_ref },	//191
	{ "Soprano::BackendSetting&", 17, Smoke::t_class | Smoke::tf_ref },	//192
	{ "Soprano::BackendSetting*", 17, Smoke::t_class | Smoke::tf_ptr },	//193
	{ "Soprano::BindingSet", 18, Smoke::t_class | Smoke::tf_stack },	//194
	{ "Soprano::BindingSet&", 18, Smoke::t_class | Smoke::tf_ref },	//195
	{ "Soprano::BindingSet*", 18, Smoke::t_class | Smoke::tf_ptr },	//196
	{ "Soprano::Client::DBusClient*", 20, Smoke::t_class | Smoke::tf_ptr },	//197
	{ "Soprano::Client::DBusModel*", 21, Smoke::t_class | Smoke::tf_ptr },	//198
	{ "Soprano::Client::DBusNodeIterator*", 22, Smoke::t_class | Smoke::tf_ptr },	//199
	{ "Soprano::Client::DBusQueryResultIterator*", 23, Smoke::t_class | Smoke::tf_ptr },	//200
	{ "Soprano::Client::DBusStatementIterator*", 24, Smoke::t_class | Smoke::tf_ptr },	//201
	{ "Soprano::Client::LocalSocketClient*", 25, Smoke::t_class | Smoke::tf_ptr },	//202
	{ "Soprano::Client::SparqlModel*", 26, Smoke::t_class | Smoke::tf_ptr },	//203
	{ "Soprano::Client::TcpClient*", 27, Smoke::t_class | Smoke::tf_ptr },	//204
	{ "Soprano::Error::Error&", 29, Smoke::t_class | Smoke::tf_ref },	//205
	{ "Soprano::Error::Error*", 29, Smoke::t_class | Smoke::tf_ptr },	//206
	{ "Soprano::Error::ErrorCode", 28, Smoke::t_enum | Smoke::tf_stack },	//207
	{ "Soprano::Error::ErrorData*", 0, Smoke::t_voidp | Smoke::tf_ptr },	//208
	{ "Soprano::Error::Locator", 30, Smoke::t_class | Smoke::tf_stack },	//209
	{ "Soprano::Error::Locator&", 30, Smoke::t_class | Smoke::tf_ref },	//210
	{ "Soprano::Error::Locator*", 30, Smoke::t_class | Smoke::tf_ptr },	//211
	{ "Soprano::Error::ParserError", 31, Smoke::t_class | Smoke::tf_stack },	//212
	{ "Soprano::Error::ParserError&", 31, Smoke::t_class | Smoke::tf_ref },	//213
	{ "Soprano::Error::ParserError*", 31, Smoke::t_class | Smoke::tf_ptr },	//214
	{ "Soprano::FilterModel*", 32, Smoke::t_class | Smoke::tf_ptr },	//215
	{ "Soprano::Graph", 33, Smoke::t_class | Smoke::tf_stack },	//216
	{ "Soprano::Graph&", 33, Smoke::t_class | Smoke::tf_ref },	//217
	{ "Soprano::Graph*", 33, Smoke::t_class | Smoke::tf_ptr },	//218
	{ "Soprano::Index::CLuceneIndex*", 35, Smoke::t_class | Smoke::tf_ptr },	//219
	{ "Soprano::Index::IndexFilterModel*", 36, Smoke::t_class | Smoke::tf_ptr },	//220
	{ "Soprano::Index::QueryHit&", 37, Smoke::t_class | Smoke::tf_ref },	//221
	{ "Soprano::Index::QueryHit*", 37, Smoke::t_class | Smoke::tf_ptr },	//222
	{ "Soprano::Inference::InferenceModel*", 39, Smoke::t_class | Smoke::tf_ptr },	//223
	{ "Soprano::Inference::NodePattern", 40, Smoke::t_class | Smoke::tf_stack },	//224
	{ "Soprano::Inference::NodePattern&", 40, Smoke::t_class | Smoke::tf_ref },	//225
	{ "Soprano::Inference::NodePattern*", 40, Smoke::t_class | Smoke::tf_ptr },	//226
	{ "Soprano::Inference::Rule", 41, Smoke::t_class | Smoke::tf_stack },	//227
	{ "Soprano::Inference::Rule&", 41, Smoke::t_class | Smoke::tf_ref },	//228
	{ "Soprano::Inference::Rule*", 41, Smoke::t_class | Smoke::tf_ptr },	//229
	{ "Soprano::Inference::RuleParser*", 42, Smoke::t_class | Smoke::tf_ptr },	//230
	{ "Soprano::Inference::RuleSet", 43, Smoke::t_class | Smoke::tf_stack },	//231
	{ "Soprano::Inference::RuleSet&", 43, Smoke::t_class | Smoke::tf_ref },	//232
	{ "Soprano::Inference::RuleSet*", 43, Smoke::t_class | Smoke::tf_ptr },	//233
	{ "Soprano::Inference::StandardRuleSet", 38, Smoke::t_enum | Smoke::tf_stack },	//234
	{ "Soprano::Inference::StatementPattern", 44, Smoke::t_class | Smoke::tf_stack },	//235
	{ "Soprano::Inference::StatementPattern*", 44, Smoke::t_class | Smoke::tf_ptr },	//236
	{ "Soprano::LanguageTag", 45, Smoke::t_class | Smoke::tf_stack },	//237
	{ "Soprano::LanguageTag&", 45, Smoke::t_class | Smoke::tf_ref },	//238
	{ "Soprano::LanguageTag*", 45, Smoke::t_class | Smoke::tf_ptr },	//239
	{ "Soprano::LanguageTag::LookupFlag", 45, Smoke::t_enum | Smoke::tf_stack },	//240
	{ "Soprano::LanguageTag::LookupFlags", 0, Smoke::t_uint | Smoke::tf_stack },	//241
	{ "Soprano::LanguageTag::LookupFlags&", 0, Smoke::t_voidp | Smoke::tf_ref },	//242
	{ "Soprano::LanguageTag::MatchFilter", 45, Smoke::t_enum | Smoke::tf_stack },	//243
	{ "Soprano::LiteralValue", 46, Smoke::t_class | Smoke::tf_stack },	//244
	{ "Soprano::LiteralValue&", 46, Smoke::t_class | Smoke::tf_ref },	//245
	{ "Soprano::LiteralValue*", 46, Smoke::t_class | Smoke::tf_ptr },	//246
	{ "Soprano::Model*", 47, Smoke::t_class | Smoke::tf_ptr },	//247
	{ "Soprano::Node", 48, Smoke::t_class | Smoke::tf_stack },	//248
	{ "Soprano::Node&", 48, Smoke::t_class | Smoke::tf_ref },	//249
	{ "Soprano::Node*", 48, Smoke::t_class | Smoke::tf_ptr },	//250
	{ "Soprano::Node::Type", 48, Smoke::t_enum | Smoke::tf_stack },	//251
	{ "Soprano::NodeIterator", 49, Smoke::t_class | Smoke::tf_stack },	//252
	{ "Soprano::NodeIterator&", 49, Smoke::t_class | Smoke::tf_ref },	//253
	{ "Soprano::NodeIterator*", 49, Smoke::t_class | Smoke::tf_ptr },	//254
	{ "Soprano::Parser*", 50, Smoke::t_class | Smoke::tf_ptr },	//255
	{ "Soprano::Plugin*", 51, Smoke::t_class | Smoke::tf_ptr },	//256
	{ "Soprano::PluginManager*", 52, Smoke::t_class | Smoke::tf_ptr },	//257
	{ "Soprano::Query::QueryLanguage", 53, Smoke::t_enum | Smoke::tf_stack },	//258
	{ "Soprano::Query::QueryLanguages", 0, Smoke::t_uint | Smoke::tf_stack },	//259
	{ "Soprano::Query::QueryLanguages&", 0, Smoke::t_voidp | Smoke::tf_ref },	//260
	{ "Soprano::QueryResultIterator", 54, Smoke::t_class | Smoke::tf_stack },	//261
	{ "Soprano::QueryResultIterator&", 54, Smoke::t_class | Smoke::tf_ref },	//262
	{ "Soprano::QueryResultIterator*", 54, Smoke::t_class | Smoke::tf_ptr },	//263
	{ "Soprano::QueryResultIteratorBackend*", 0, Smoke::t_voidp | Smoke::tf_ptr },	//264
	{ "Soprano::RdfSchemaModel*", 55, Smoke::t_class | Smoke::tf_ptr },	//265
	{ "Soprano::RdfSerialization", 15, Smoke::t_enum | Smoke::tf_stack },	//266
	{ "Soprano::RdfSerializations", 0, Smoke::t_uint | Smoke::tf_stack },	//267
	{ "Soprano::RdfSerializations&", 0, Smoke::t_voidp | Smoke::tf_ref },	//268
	{ "Soprano::Serializer*", 56, Smoke::t_class | Smoke::tf_ptr },	//269
	{ "Soprano::Server::DBusExportIterator*", 58, Smoke::t_class | Smoke::tf_ptr },	//270
	{ "Soprano::Server::DBusExportModel*", 59, Smoke::t_class | Smoke::tf_ptr },	//271
	{ "Soprano::Server::ServerCore*", 60, Smoke::t_class | Smoke::tf_ptr },	//272
	{ "Soprano::Statement", 61, Smoke::t_class | Smoke::tf_stack },	//273
	{ "Soprano::Statement&", 61, Smoke::t_class | Smoke::tf_ref },	//274
	{ "Soprano::Statement*", 61, Smoke::t_class | Smoke::tf_ptr },	//275
	{ "Soprano::StatementIterator", 62, Smoke::t_class | Smoke::tf_stack },	//276
	{ "Soprano::StatementIterator&", 62, Smoke::t_class | Smoke::tf_ref },	//277
	{ "Soprano::StatementIterator*", 62, Smoke::t_class | Smoke::tf_ptr },	//278
	{ "Soprano::StorageModel*", 63, Smoke::t_class | Smoke::tf_ptr },	//279
	{ "Soprano::Util::AsyncModel*", 65, Smoke::t_class | Smoke::tf_ptr },	//280
	{ "Soprano::Util::AsyncModel::AsyncModelMode", 65, Smoke::t_enum | Smoke::tf_stack },	//281
	{ "Soprano::Util::AsyncResult*", 66, Smoke::t_class | Smoke::tf_ptr },	//282
	{ "Soprano::Util::MutexModel*", 67, Smoke::t_class | Smoke::tf_ptr },	//283
	{ "Soprano::Util::MutexModel::ProtectionMode", 67, Smoke::t_enum | Smoke::tf_stack },	//284
	{ "Soprano::Util::ReadOnlyModel*", 68, Smoke::t_class | Smoke::tf_ptr },	//285
	{ "Soprano::Util::SignalCacheModel*", 69, Smoke::t_class | Smoke::tf_ptr },	//286
	{ "Soprano::Util::SimpleNodeIterator&", 70, Smoke::t_class | Smoke::tf_ref },	//287
	{ "Soprano::Util::SimpleNodeIterator*", 70, Smoke::t_class | Smoke::tf_ptr },	//288
	{ "bool", 0, Smoke::t_bool | Smoke::tf_stack },	//289
	{ "const QByteArray&", 1, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//290
	{ "const QDate&", 3, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//291
	{ "const QDateTime&", 4, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//292
	{ "const QHostAddress&", 6, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//293
	{ "const QLatin1String&", 0, Smoke::t_voidp | Smoke::tf_ref | Smoke::tf_const },	//294
	{ "const QList<QUrl>&", 0, Smoke::t_voidp | Smoke::tf_ref | Smoke::tf_const },	//295
	{ "const QList<Soprano::BackendSetting>&", 0, Smoke::t_voidp | Smoke::tf_ref | Smoke::tf_const },	//296
	{ "const QList<Soprano::Inference::Rule>&", 0, Smoke::t_voidp | Smoke::tf_ref | Smoke::tf_const },	//297
	{ "const QList<Soprano::LanguageTag>&", 0, Smoke::t_voidp | Smoke::tf_ref | Smoke::tf_const },	//298
	{ "const QList<Soprano::Node>&", 0, Smoke::t_voidp | Smoke::tf_ref | Smoke::tf_const },	//299
	{ "const QList<Soprano::Statement>&", 0, Smoke::t_voidp | Smoke::tf_ref | Smoke::tf_const },	//300
	{ "const QLocale&", 7, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//301
	{ "const QMetaObject", 8, Smoke::t_class | Smoke::tf_stack | Smoke::tf_const },	//302
	{ "const QMetaObject*", 8, Smoke::t_class | Smoke::tf_ptr | Smoke::tf_const },	//303
	{ "const QString", 0, Smoke::t_voidp | Smoke::tf_stack | Smoke::tf_const },	//304
	{ "const QString&", 0, Smoke::t_voidp | Smoke::tf_ref | Smoke::tf_const },	//305
	{ "const QStringList&", 0, Smoke::t_voidp | Smoke::tf_ref | Smoke::tf_const },	//306
	{ "const QTime&", 11, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//307
	{ "const QUrl&", 13, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//308
	{ "const QVariant&", 14, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//309
	{ "const Soprano::Backend*", 16, Smoke::t_class | Smoke::tf_ptr | Smoke::tf_const },	//310
	{ "const Soprano::BackendSetting&", 17, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//311
	{ "const Soprano::BindingSet&", 18, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//312
	{ "const Soprano::Error::Error&", 29, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//313
	{ "const Soprano::Error::Locator&", 30, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//314
	{ "const Soprano::Error::ParserError&", 31, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//315
	{ "const Soprano::Graph&", 33, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//316
	{ "const Soprano::Index::QueryHit&", 37, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//317
	{ "const Soprano::Inference::NodePattern&", 40, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//318
	{ "const Soprano::Inference::Rule&", 41, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//319
	{ "const Soprano::Inference::RuleParser&", 42, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//320
	{ "const Soprano::Inference::RuleSet&", 43, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//321
	{ "const Soprano::Inference::StatementPattern&", 44, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//322
	{ "const Soprano::LanguageTag&", 45, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//323
	{ "const Soprano::LiteralValue&", 46, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//324
	{ "const Soprano::Node&", 48, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//325
	{ "const Soprano::NodeIterator&", 49, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//326
	{ "const Soprano::Parser*", 50, Smoke::t_class | Smoke::tf_ptr | Smoke::tf_const },	//327
	{ "const Soprano::Plugin&", 51, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//328
	{ "const Soprano::QueryResultIterator&", 54, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//329
	{ "const Soprano::Serializer*", 56, Smoke::t_class | Smoke::tf_ptr | Smoke::tf_const },	//330
	{ "const Soprano::Statement&", 61, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//331
	{ "const Soprano::StatementIterator&", 62, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//332
	{ "const Soprano::Util::SimpleNodeIterator&", 70, Smoke::t_class | Smoke::tf_ref | Smoke::tf_const },	//333
	{ "const char*", 0, Smoke::t_voidp | Smoke::tf_ptr | Smoke::tf_const },	//334
	{ "const unsigned short", 0, Smoke::t_ushort | Smoke::tf_stack | Smoke::tf_const },	//335
	{ "double", 0, Smoke::t_double | Smoke::tf_stack },	//336
	{ "int", 0, Smoke::t_int | Smoke::tf_stack },	//337
	{ "lucene::analysis::Analyzer*", 0, Smoke::t_voidp | Smoke::tf_ptr },	//338
	{ "lucene::document::Document*", 0, Smoke::t_voidp | Smoke::tf_ptr },	//339
	{ "qlonglong", 0, Smoke::t_voidp | Smoke::tf_stack },	//340
	{ "qulonglong", 0, Smoke::t_voidp | Smoke::tf_stack },	//341
	{ "uint", 0, Smoke::t_uint | Smoke::tf_stack },	//342
	{ "unsigned int", 0, Smoke::t_uint | Smoke::tf_stack },	//343
	{ "unsigned short", 0, Smoke::t_ushort | Smoke::tf_stack },	//344
	{ "void**", 0, Smoke::t_voidp | Smoke::tf_ptr },	//345
};

static Smoke::Index soprano_argumentList[] = {
	0,	//0  (void)
	14, 0,	//1  QChildEvent*  
	141, 0,	//3  QTextStream&  
	141, 308, 266, 0,	//5  QTextStream&, const QUrl&, Soprano::RdfSerialization  
	141, 308, 266, 305, 0,	//9  QTextStream&, const QUrl&, Soprano::RdfSerialization, const QString&  
	145, 0,	//14  QTimerEvent*  
	154, 0,	//16  QVariant::Type  
	187, 0,	//18  Soprano::BackendFeatures  
	187, 306, 0,	//20  Soprano::BackendFeatures, const QStringList&  
	189, 0,	//23  Soprano::BackendOption  
	189, 309, 0,	//25  Soprano::BackendOption, const QVariant&  
	207, 0,	//28  Soprano::Error::ErrorCode  
	208, 0,	//30  Soprano::Error::ErrorData*  
	219, 0,	//32  Soprano::Index::CLuceneIndex*  
	219, 247, 0,	//34  Soprano::Index::CLuceneIndex*, Soprano::Model*  
	234, 0,	//37  Soprano::Inference::StandardRuleSet  
	247, 0,	//39  Soprano::Model*  
	252, 0,	//41  Soprano::NodeIterator  
	252, 93, 0,	//43  Soprano::NodeIterator, QObject*  
	258, 0,	//46  Soprano::Query::QueryLanguage  
	258, 305, 0,	//48  Soprano::Query::QueryLanguage, const QString&  
	261, 0,	//51  Soprano::QueryResultIterator  
	261, 93, 0,	//53  Soprano::QueryResultIterator, QObject*  
	264, 0,	//56  Soprano::QueryResultIteratorBackend*  
	266, 0,	//58  Soprano::RdfSerialization  
	266, 305, 0,	//60  Soprano::RdfSerialization, const QString&  
	276, 0,	//63  Soprano::StatementIterator  
	276, 141, 266, 0,	//65  Soprano::StatementIterator, QTextStream&, Soprano::RdfSerialization  
	276, 141, 266, 305, 0,	//69  Soprano::StatementIterator, QTextStream&, Soprano::RdfSerialization, const QString&  
	276, 93, 0,	//74  Soprano::StatementIterator, QObject*  
	281, 0,	//77  Soprano::Util::AsyncModel::AsyncModelMode  
	282, 0,	//79  Soprano::Util::AsyncResult*  
	284, 0,	//81  Soprano::Util::MutexModel::ProtectionMode  
	284, 247, 0,	//83  Soprano::Util::MutexModel::ProtectionMode, Soprano::Model*  
	289, 0,	//86  bool  
	290, 0,	//88  const QByteArray&  
	291, 0,	//90  const QDate&  
	292, 0,	//92  const QDateTime&  
	293, 0,	//94  const QHostAddress&  
	293, 337, 0,	//96  const QHostAddress&, int  
	294, 0,	//99  const QLatin1String&  
	295, 0,	//101  const QList<QUrl>&  
	296, 0,	//103  const QList<Soprano::BackendSetting>&  
	296, 189, 0,	//105  const QList<Soprano::BackendSetting>&, Soprano::BackendOption  
	296, 189, 305, 0,	//108  const QList<Soprano::BackendSetting>&, Soprano::BackendOption, const QString&  
	297, 0,	//112  const QList<Soprano::Inference::Rule>&  
	298, 298, 0,	//114  const QList<Soprano::LanguageTag>&, const QList<Soprano::LanguageTag>&  
	298, 298, 241, 0,	//117  const QList<Soprano::LanguageTag>&, const QList<Soprano::LanguageTag>&, Soprano::LanguageTag::LookupFlags  
	298, 298, 241, 243, 0,	//121  const QList<Soprano::LanguageTag>&, const QList<Soprano::LanguageTag>&, Soprano::LanguageTag::LookupFlags, Soprano::LanguageTag::MatchFilter  
	298, 323, 0,	//126  const QList<Soprano::LanguageTag>&, const Soprano::LanguageTag&  
	298, 323, 241, 0,	//129  const QList<Soprano::LanguageTag>&, const Soprano::LanguageTag&, Soprano::LanguageTag::LookupFlags  
	298, 323, 241, 243, 0,	//133  const QList<Soprano::LanguageTag>&, const Soprano::LanguageTag&, Soprano::LanguageTag::LookupFlags, Soprano::LanguageTag::MatchFilter  
	299, 0,	//138  const QList<Soprano::Node>&  
	300, 0,	//140  const QList<Soprano::Statement>&  
	301, 0,	//142  const QLocale&  
	304, 0,	//144  const QString  
	305, 0,	//146  const QString&  
	305, 154, 0,	//148  const QString&, QVariant::Type  
	305, 247, 0,	//151  const QString&, Soprano::Model*  
	305, 258, 0,	//154  const QString&, Soprano::Query::QueryLanguage  
	305, 258, 305, 0,	//157  const QString&, Soprano::Query::QueryLanguage, const QString&  
	305, 289, 0,	//161  const QString&, bool  
	305, 296, 0,	//164  const QString&, const QList<Soprano::BackendSetting>&  
	305, 305, 0,	//167  const QString&, const QString&  
	305, 305, 305, 0,	//170  const QString&, const QString&, const QString&  
	305, 305, 305, 305, 0,	//174  const QString&, const QString&, const QString&, const QString&  
	305, 305, 305, 305, 331, 0,	//179  const QString&, const QString&, const QString&, const QString&, const Soprano::Statement&  
	305, 305, 310, 0,	//185  const QString&, const QString&, const Soprano::Backend*  
	305, 308, 0,	//189  const QString&, const QUrl&  
	305, 308, 266, 0,	//192  const QString&, const QUrl&, Soprano::RdfSerialization  
	305, 308, 266, 305, 0,	//196  const QString&, const QUrl&, Soprano::RdfSerialization, const QString&  
	305, 309, 0,	//201  const QString&, const QVariant&  
	305, 319, 0,	//204  const QString&, const Soprano::Inference::Rule&  
	305, 323, 0,	//207  const QString&, const Soprano::LanguageTag&  
	305, 325, 0,	//210  const QString&, const Soprano::Node&  
	305, 337, 0,	//213  const QString&, int  
	305, 344, 0,	//216  const QString&, unsigned short  
	305, 344, 305, 0,	//219  const QString&, unsigned short, const QString&  
	305, 344, 305, 305, 0,	//223  const QString&, unsigned short, const QString&, const QString&  
	305, 93, 0,	//228  const QString&, QObject*  
	306, 0,	//231  const QStringList&  
	306, 289, 0,	//233  const QStringList&, bool  
	307, 0,	//236  const QTime&  
	308, 0,	//238  const QUrl&  
	309, 0,	//240  const QVariant&  
	310, 0,	//242  const Soprano::Backend*  
	311, 0,	//244  const Soprano::BackendSetting&  
	312, 0,	//246  const Soprano::BindingSet&  
	313, 0,	//248  const Soprano::Error::Error&  
	314, 0,	//250  const Soprano::Error::Locator&  
	314, 305, 0,	//252  const Soprano::Error::Locator&, const QString&  
	314, 305, 337, 0,	//255  const Soprano::Error::Locator&, const QString&, int  
	315, 0,	//259  const Soprano::Error::ParserError&  
	316, 0,	//261  const Soprano::Graph&  
	317, 0,	//263  const Soprano::Index::QueryHit&  
	318, 0,	//265  const Soprano::Inference::NodePattern&  
	318, 318, 318, 0,	//267  const Soprano::Inference::NodePattern&, const Soprano::Inference::NodePattern&, const Soprano::Inference::NodePattern&  
	319, 0,	//271  const Soprano::Inference::Rule&  
	320, 0,	//273  const Soprano::Inference::RuleParser&  
	321, 0,	//275  const Soprano::Inference::RuleSet&  
	322, 0,	//277  const Soprano::Inference::StatementPattern&  
	323, 0,	//279  const Soprano::LanguageTag&  
	323, 243, 0,	//281  const Soprano::LanguageTag&, Soprano::LanguageTag::MatchFilter  
	324, 0,	//284  const Soprano::LiteralValue&  
	325, 0,	//286  const Soprano::Node&  
	325, 325, 0,	//288  const Soprano::Node&, const Soprano::Node&  
	325, 325, 325, 0,	//291  const Soprano::Node&, const Soprano::Node&, const Soprano::Node&  
	325, 325, 325, 325, 0,	//295  const Soprano::Node&, const Soprano::Node&, const Soprano::Node&, const Soprano::Node&  
	325, 336, 0,	//300  const Soprano::Node&, double  
	326, 0,	//303  const Soprano::NodeIterator&  
	328, 0,	//305  const Soprano::Plugin&  
	329, 0,	//307  const Soprano::QueryResultIterator&  
	33, 0,	//309  QEvent*  
	331, 0,	//311  const Soprano::Statement&  
	332, 0,	//313  const Soprano::StatementIterator&  
	333, 0,	//315  const Soprano::Util::SimpleNodeIterator&  
	334, 0,	//317  const char*  
	336, 0,	//319  double  
	337, 0,	//321  int  
	337, 325, 0,	//323  int, const Soprano::Node&  
	337, 337, 0,	//326  int, int  
	337, 337, 337, 0,	//329  int, int, int  
	337, 337, 337, 305, 0,	//333  int, int, int, const QString&  
	338, 0,	//338  lucene::analysis::Analyzer*  
	339, 0,	//340  lucene::document::Document*  
	340, 0,	//342  qlonglong  
	341, 0,	//344  qulonglong  
	342, 0,	//346  uint  
	344, 0,	//348  unsigned short  
	66, 189, 0,	//350  QList<Soprano::BackendSetting>&, Soprano::BackendOption  
	66, 189, 305, 0,	//353  QList<Soprano::BackendSetting>&, Soprano::BackendOption, const QString&  
	77, 0,	//357  QLocale::Language  
	77, 76, 0,	//359  QLocale::Language, QLocale::Country  
	88, 337, 345, 0,	//362  QMetaObject::Call, int, void**  
	93, 0,	//366  QObject*  
	93, 33, 0,	//368  QObject*, QEvent*  
};

// Raw list of all methods, using munged names
static const char *soprano_methodNames[] = {
    "",	//0
    "AllDifferent",	//1
    "Alt",	//2
    "Annotation",	//3
    "AnnotationProperty",	//4
    "Archive",	//5
    "ArchivedFile",	//6
    "AsymmetricProperty",	//7
    "AsyncModel",	//8
    "AsyncModel#",	//9
    "Audio",	//10
    "AudioList",	//11
    "Backend",	//12
    "Backend$",	//13
    "BackendFeatureAddStatement",	//14
    "BackendFeatureAll",	//15
    "BackendFeatureContext",	//16
    "BackendFeatureInference",	//17
    "BackendFeatureInferenceOptional",	//18
    "BackendFeatureListStatements",	//19
    "BackendFeatureNone",	//20
    "BackendFeatureQuery",	//21
    "BackendFeatureRemoveStatements",	//22
    "BackendFeatureStorageMemory",	//23
    "BackendFeatureUser",	//24
    "BackendOptionEnableInference",	//25
    "BackendOptionHost",	//26
    "BackendOptionNone",	//27
    "BackendOptionPassword",	//28
    "BackendOptionPort",	//29
    "BackendOptionStorageDir",	//30
    "BackendOptionStorageMemory",	//31
    "BackendOptionUser",	//32
    "BackendOptionUsername",	//33
    "BackendSetting",	//34
    "BackendSetting#",	//35
    "BackendSetting$",	//36
    "BackendSetting$#",	//37
    "Bag",	//38
    "BindingSet",	//39
    "BindingSet#",	//40
    "BlankNode",	//41
    "BlockDevice",	//42
    "Bookmark",	//43
    "CLuceneIndex",	//44
    "CLuceneIndex?",	//45
    "Class",	//46
    "CommunicationChannel",	//47
    "Configuration",	//48
    "Contact",	//49
    "ContactGroup",	//50
    "Container",	//51
    "ContainerMembershipProperty",	//52
    "Content",	//53
    "DBusClient",	//54
    "DBusClient$",	//55
    "DBusClient$#",	//56
    "DBusExportIterator",	//57
    "DBusExportIterator#",	//58
    "DBusExportIterator##",	//59
    "DBusExportModel",	//60
    "DBusExportModel#",	//61
    "DBusModel",	//62
    "DBusModel$$",	//63
    "DBusModel$$#",	//64
    "DBusNodeIterator",	//65
    "DBusNodeIterator$$",	//66
    "DBusQueryResultIterator",	//67
    "DBusQueryResultIterator$$",	//68
    "DBusStatementIterator",	//69
    "DBusStatementIterator$$",	//70
    "DEFAULT_PORT",	//71
    "Data",	//72
    "DataObject",	//73
    "DataRange",	//74
    "Datatype",	//75
    "DatatypeProperty",	//76
    "DefaultGraph",	//77
    "DeletedFile",	//78
    "DeprecatedClass",	//79
    "DeprecatedProperty",	//80
    "Document",	//81
    "DocumentGraph",	//82
    "Documentation",	//83
    "Email",	//84
    "EmailAttachment",	//85
    "EmbeddedObject",	//86
    "EmptyNode",	//87
    "Error",	//88
    "Error#",	//89
    "Error$",	//90
    "Error$$",	//91
    "Error?",	//92
    "ErrorInvalidArgument",	//93
    "ErrorInvalidStatement",	//94
    "ErrorNone",	//95
    "ErrorNotSupported",	//96
    "ErrorParsingFailed",	//97
    "ErrorPermissionDenied",	//98
    "ErrorUnknown",	//99
    "ExternalViewSpecification",	//100
    "File",	//101
    "FileSystem",	//102
    "Filelike",	//103
    "FilterModel",	//104
    "FilterModel#",	//105
    "Folder",	//106
    "FreeDesktopIcon",	//107
    "FunctionalProperty",	//108
    "Graph",	//109
    "Graph#",	//110
    "Graph?",	//111
    "GraphMetadata",	//112
    "GraphView",	//113
    "IMAP4Message",	//114
    "IMMessage",	//115
    "Image",	//116
    "IndexFilterModel",	//117
    "IndexFilterModel#",	//118
    "IndexFilterModel##",	//119
    "IndexFilterModel$",	//120
    "IndexFilterModel$#",	//121
    "InferenceGraph",	//122
    "InferenceMetaData",	//123
    "InferenceModel",	//124
    "InferenceModel#",	//125
    "InstanceBase",	//126
    "InverseFunctionalProperty",	//127
    "KnowledgeBase",	//128
    "LanguageTag",	//129
    "LanguageTag#",	//130
    "LanguageTag$",	//131
    "LanguageTag$$",	//132
    "LanguageTag?",	//133
    "List",	//134
    "Literal",	//135
    "LiteralNode",	//136
    "LiteralValue",	//137
    "LiteralValue#",	//138
    "LiteralValue$",	//139
    "LiteralValue?",	//140
    "LocalSocketClient",	//141
    "LocalSocketClient#",	//142
    "Locator",	//143
    "Locator#",	//144
    "Locator$$",	//145
    "Locator$$$",	//146
    "Locator$$$$",	//147
    "LookupFlagNoFallback",	//148
    "LookupFlagNone",	//149
    "MailingList",	//150
    "MailingListEmail",	//151
    "MatchFilterBasic",	//152
    "MatchFilterExtended",	//153
    "Media",	//154
    "MediaList",	//155
    "Message",	//156
    "MessageboxMessage",	//157
    "Model",	//158
    "MultiThreaded",	//159
    "Music",	//160
    "MutexModel",	//161
    "MutexModel$",	//162
    "MutexModel$#",	//163
    "NRL",	//164
    "NewsGroup",	//165
    "NewsGroupEmail",	//166
    "Node",	//167
    "Node#",	//168
    "Node$",	//169
    "NodeIterator",	//170
    "NodeIterator#",	//171
    "NodePattern",	//172
    "NodePattern#",	//173
    "NodePattern$",	//174
    "Nothing",	//175
    "ObjectProperty",	//176
    "OfflineMedia",	//177
    "Ontology",	//178
    "OntologyProperty",	//179
    "Organization",	//180
    "POP3Message",	//181
    "Parser",	//182
    "Parser$",	//183
    "ParserError",	//184
    "ParserError#",	//185
    "ParserError#$",	//186
    "ParserError#$$",	//187
    "Party",	//188
    "Person",	//189
    "PersonalEmail",	//190
    "Photo",	//191
    "PlainMultiThreading",	//192
    "Plugin",	//193
    "Plugin#",	//194
    "Plugin$",	//195
    "Presentation",	//196
    "Project",	//197
    "Property",	//198
    "QUERY_LANGUAGE_NONE",	//199
    "QUERY_LANGUAGE_RDQL",	//200
    "QUERY_LANGUAGE_SERQL",	//201
    "QUERY_LANGUAGE_SPARQL",	//202
    "QUERY_LANGUAGE_USER",	//203
    "QueryHit",	//204
    "QueryHit#",	//205
    "QueryHit#$",	//206
    "QueryLanguageNone",	//207
    "QueryLanguageRdql",	//208
    "QueryLanguageSerql",	//209
    "QueryLanguageSparql",	//210
    "QueryLanguageUser",	//211
    "QueryResultIterator",	//212
    "QueryResultIterator#",	//213
    "QueryResultIterator?",	//214
    "RDFS",	//215
    "RSSFeed",	//216
    "RSSMessage",	//217
    "RdfSchemaModel",	//218
    "RdfSchemaModel#",	//219
    "ReadOnlyModel",	//220
    "ReadOnlyModel#",	//221
    "ReadWriteMultiThreading",	//222
    "ReadWriteSingleThreading",	//223
    "ReflexiveProperty",	//224
    "RemoteFile",	//225
    "RemoteMessageboxMessage",	//226
    "RemoteResource",	//227
    "Resource",	//228
    "ResourceNode",	//229
    "Restriction",	//230
    "RevisionControlledFile",	//231
    "RevisionControlledRepository",	//232
    "Rule",	//233
    "Rule#",	//234
    "RuleParser",	//235
    "RuleParser#",	//236
    "RuleSet",	//237
    "RuleSet#",	//238
    "RuleViewSpecification",	//239
    "Schema",	//240
    "Semantics",	//241
    "Seq",	//242
    "SerializationN3",	//243
    "SerializationNQuads",	//244
    "SerializationNTriples",	//245
    "SerializationRdfXml",	//246
    "SerializationTrig",	//247
    "SerializationTurtle",	//248
    "SerializationUnknown",	//249
    "SerializationUser",	//250
    "Serializer",	//251
    "Serializer$",	//252
    "ServerCore",	//253
    "ServerCore#",	//254
    "SignalCacheModel",	//255
    "SignalCacheModel#",	//256
    "SimpleNodeIterator",	//257
    "SimpleNodeIterator#",	//258
    "SimpleNodeIterator?",	//259
    "SingleThreaded",	//260
    "SoftwarePackage",	//261
    "Source",	//262
    "SourceCode",	//263
    "SparqlModel",	//264
    "SparqlModel$",	//265
    "SparqlModel$$",	//266
    "SparqlModel$$$",	//267
    "SparqlModel$$$$",	//268
    "Spreadsheet",	//269
    "Statement",	//270
    "Statement#",	//271
    "Statement###",	//272
    "Statement####",	//273
    "StatementIterator",	//274
    "StatementIterator#",	//275
    "StatementPattern",	//276
    "StatementPattern#",	//277
    "StatementPattern###",	//278
    "StorageModel",	//279
    "StorageModel#",	//280
    "Symbol",	//281
    "SymmetricProperty",	//282
    "SystemResource",	//283
    "Tag",	//284
    "TcpClient",	//285
    "TcpClient#",	//286
    "Text",	//287
    "TextDocument",	//288
    "Thing",	//289
    "TransitiveProperty",	//290
    "UncategorizedText",	//291
    "Video",	//292
    "ViewSpecification",	//293
    "Visual",	//294
    "XML",	//295
    "XMLLiteral",	//296
    "acl",	//297
    "addForceIndexPredicate",	//298
    "addForceIndexPredicate#",	//299
    "addIndexOnlyPredicate",	//300
    "addIndexOnlyPredicate#",	//301
    "addPrecondition",	//302
    "addPrecondition#",	//303
    "addPrefix",	//304
    "addPrefix$#",	//305
    "addRule",	//306
    "addRule#",	//307
    "addStatement",	//308
    "addStatement#",	//309
    "addStatement###",	//310
    "addStatement####",	//311
    "addStatementAsync",	//312
    "addStatementAsync#",	//313
    "addStatementAsync###",	//314
    "addStatementAsync####",	//315
    "addStatements",	//316
    "addStatements?",	//317
    "addStatementsAsync",	//318
    "addStatementsAsync?",	//319
    "album",	//320
    "albumArtist",	//321
    "albumGain",	//322
    "albumPeakGain",	//323
    "albumTrackCount",	//324
    "allBackends",	//325
    "allBindings",	//326
    "allModels",	//327
    "allNodes",	//328
    "allParsers",	//329
    "allRules",	//330
    "allSerializers",	//331
    "allStatements",	//332
    "allValuesFrom",	//333
    "altLabel",	//334
    "altSymbol",	//335
    "annotation",	//336
    "aperture",	//337
    "artist",	//338
    "asText",	//339
    "aspectRatio",	//340
    "asyncCalls",	//341
    "at",	//342
    "at$",	//343
    "attachmentEncoding",	//344
    "audioBPM",	//345
    "audioBitrate",	//346
    "audioChannels",	//347
    "audioCodec",	//348
    "audioCodecType",	//349
    "audioSampleBitDepth",	//350
    "audioSampleCount",	//351
    "audioSampleDataType",	//352
    "audioSampleRate",	//353
    "author",	//354
    "autoRating",	//355
    "backend",	//356
    "backwardCompatibleWith",	//357
    "base64Binary",	//358
    "baseRevisionID",	//359
    "bcc",	//360
    "bindEffect",	//361
    "bindEffect#",	//362
    "bindPreconditions",	//363
    "bindPreconditions#",	//364
    "bindToStatement",	//365
    "bindToStatement#",	//366
    "binding",	//367
    "binding$",	//368
    "bindingCount",	//369
    "bindingNames",	//370
    "birthDate",	//371
    "blankToN3",	//372
    "blankToN3$",	//373
    "blogContactURL",	//374
    "boolValue",	//375
    "boolean",	//376
    "boundToStatement",	//377
    "byte",	//378
    "cacheTime",	//379
    "cameraManufacturer",	//380
    "cameraModel",	//381
    "cardinality",	//382
    "cc",	//383
    "ccdWidth",	//384
    "cellPhoneNumber",	//385
    "changeCommitTime",	//386
    "changeCommitter",	//387
    "characterCount",	//388
    "charset",	//389
    "chatRoom",	//390
    "childEvent",	//391
    "childEvent#",	//392
    "classes",	//393
    "clear",	//394
    "clearInference",	//395
    "clearPrefixes",	//396
    "close",	//397
    "closeTransaction",	//398
    "closeTransaction$",	//399
    "code",	//400
    "colorCount",	//401
    "colorSpace",	//402
    "column",	//403
    "columnCount",	//404
    "comment",	//405
    "commentCharacterCount",	//406
    "commitDiff",	//407
    "communicationChannel",	//408
    "complementOf",	//409
    "composer",	//410
    "compressionAlgorithm",	//411
    "compressionLevel",	//412
    "conflicts",	//413
    "connect",	//414
    "connect#",	//415
    "connect#$",	//416
    "connect$",	//417
    "connectNotify",	//418
    "connectNotify$",	//419
    "contactMedium",	//420
    "contactNick",	//421
    "contactURL",	//422
    "contains",	//423
    "contains$",	//424
    "containsAnyStatement",	//425
    "containsAnyStatement#",	//426
    "containsAnyStatement###",	//427
    "containsAnyStatement####",	//428
    "containsAnyStatementAsync",	//429
    "containsAnyStatementAsync#",	//430
    "containsAnyStatementAsync###",	//431
    "containsAnyStatementAsync####",	//432
    "containsContext",	//433
    "containsContext#",	//434
    "containsStatement",	//435
    "containsStatement#",	//436
    "containsStatement###",	//437
    "containsStatement####",	//438
    "containsStatementAsync",	//439
    "containsStatementAsync#",	//440
    "containsStatementAsync###",	//441
    "containsStatementAsync####",	//442
    "contentComment",	//443
    "contentCreated",	//444
    "contentKeyword",	//445
    "contentModified",	//446
    "contentType",	//447
    "context",	//448
    "contributor",	//449
    "convertErrorCode",	//450
    "convertErrorCode$",	//451
    "copyright",	//452
    "coreGraphMetadataFor",	//453
    "count",	//454
    "createBlankNode",	//455
    "createBlankNode$",	//456
    "createBlankNodeAsync",	//457
    "createEmptyNode",	//458
    "createLiteralNode",	//459
    "createLiteralNode#",	//460
    "createModel",	//461
    "createModel$",	//462
    "createModel$?",	//463
    "createModel?",	//464
    "createPlainLiteral",	//465
    "createPlainLiteral$",	//466
    "createPlainLiteral$#",	//467
    "createResourceNode",	//468
    "createResourceNode#",	//469
    "createResult",	//470
    "createSparqlGraphPattern",	//471
    "createSparqlGraphPattern#",	//472
    "createSparqlNodePattern",	//473
    "createSparqlNodePattern#",	//474
    "createSparqlQuery",	//475
    "createSparqlQuery$",	//476
    "created",	//477
    "creator",	//478
    "currentBindings",	//479
    "currentStatement",	//480
    "customEvent",	//481
    "customEvent#",	//482
    "dataType",	//483
    "dataTypeUri",	//484
    "dataTypeUriFromType",	//485
    "dataTypeUriFromType$",	//486
    "date",	//487
    "dateTime",	//488
    "dbusObjectPath",	//489
    "decimal",	//490
    "defaultSearchField",	//491
    "definesClass",	//492
    "definesFunction",	//493
    "definesGlobalVariable",	//494
    "deleteModelData",	//495
    "deleteModelData?",	//496
    "deleteOnClose",	//497
    "deletionTime",	//498
    "depends",	//499
    "derivedFrom",	//500
    "description",	//501
    "differentFrom",	//502
    "directSubClassOf",	//503
    "directSubClassOf#",	//504
    "directSubClassOf##",	//505
    "directSubPropertyOf",	//506
    "directSubPropertyOf#",	//507
    "directSubPropertyOf##",	//508
    "directType",	//509
    "directType##",	//510
    "discNumber",	//511
    "disclaimer",	//512
    "disconnect",	//513
    "disconnectNotify",	//514
    "disconnectNotify$",	//515
    "discoverBackendByFeatures",	//516
    "discoverBackendByFeatures$",	//517
    "discoverBackendByFeatures$?",	//518
    "discoverBackendByName",	//519
    "discoverBackendByName$",	//520
    "discoverParserByName",	//521
    "discoverParserByName$",	//522
    "discoverParserForSerialization",	//523
    "discoverParserForSerialization$",	//524
    "discoverParserForSerialization$$",	//525
    "discoverSerializerByName",	//526
    "discoverSerializerByName$",	//527
    "discoverSerializerForSerialization",	//528
    "discoverSerializerForSerialization$",	//529
    "discoverSerializerForSerialization$$",	//530
    "disjointWith",	//531
    "distinctMembers",	//532
    "documentCategory",	//533
    "documentForResource",	//534
    "documentForResource#",	//535
    "domain",	//536
    "domain##",	//537
    "dump",	//538
    "dump#",	//539
    "effect",	//540
    "emailAddress",	//541
    "encodeStringForLuceneQuery",	//542
    "encodeStringForLuceneQuery$",	//543
    "encodeUriForLuceneQuery",	//544
    "encodeUriForLuceneQuery#",	//545
    "engineeringTool",	//546
    "equivalentClass",	//547
    "equivalentGraph",	//548
    "equivalentProperty",	//549
    "errorCode",	//550
    "errorMessage",	//551
    "errorMessage$",	//552
    "event",	//553
    "event#",	//554
    "eventFilter",	//555
    "eventFilter##",	//556
    "executeQuery",	//557
    "executeQuery$",	//558
    "executeQuery$$",	//559
    "executeQuery$$$",	//560
    "executeQueryAsync",	//561
    "executeQueryAsync$",	//562
    "executeQueryAsync$$",	//563
    "executeQueryAsync$$$",	//564
    "exposureBias",	//565
    "exposureProgram",	//566
    "exposureTime",	//567
    "externalRealizer",	//568
    "familyName",	//569
    "faxPhoneNumber",	//570
    "fileExtension",	//571
    "fileName",	//572
    "fileSystemType",	//573
    "fingerprint",	//574
    "first",	//575
    "firstUsed",	//576
    "flashUsed",	//577
    "focalLength",	//578
    "focusDistance",	//579
    "forceIndexPredicates",	//580
    "formatSubtype",	//581
    "frameCount",	//582
    "frameRate",	//583
    "freeSpace",	//584
    "fromString",	//585
    "fromString$#",	//586
    "fromString$$",	//587
    "gender",	//588
    "generator",	//589
    "generatorOptions",	//590
    "genre",	//591
    "getResource",	//592
    "getResource?",	//593
    "givenName",	//594
    "graphMetadataFor",	//595
    "group",	//596
    "hasDefaultNamespace",	//597
    "hasDefaultNamespaceAbbreviation",	//598
    "hasSemantics",	//599
    "hasSpecification",	//600
    "hasSubResource",	//601
    "hasSuperResource",	//602
    "hasSymbol",	//603
    "hasTag",	//604
    "hasTopic",	//605
    "hasValue",	//606
    "height",	//607
    "homeEmailAddress",	//608
    "homePhoneNumber",	//609
    "homePostalAddress",	//610
    "homepageContactURL",	//611
    "honorificPrefix",	//612
    "honorificSuffix",	//613
    "horizontalResolution",	//614
    "iconName",	//615
    "id",	//616
    "identifier",	//617
    "imContactMedium",	//618
    "imports",	//619
    "inReplyTo",	//620
    "incompatibleWith",	//621
    "index",	//622
    "indexOnlyPredicates",	//623
    "insert",	//624
    "insert$#",	//625
    "instance",	//626
    "integer",	//627
    "interest",	//628
    "interlaceMode",	//629
    "intersectionOf",	//630
    "inverseOf",	//631
    "inverseProperty",	//632
    "ircContactMedium",	//633
    "isAvailable",	//634
    "isBinding",	//635
    "isBlank",	//636
    "isBool",	//637
    "isByteArray",	//638
    "isClass",	//639
    "isClass#",	//640
    "isConnected",	//641
    "isContentEncrypted",	//642
    "isDate",	//643
    "isDateTime",	//644
    "isDefinedBy",	//645
    "isDirectSubClassOf",	//646
    "isDirectSubClassOf##",	//647
    "isDirectSubPropertyOf",	//648
    "isDirectSubPropertyOf##",	//649
    "isDirectType",	//650
    "isDirectType##",	//651
    "isDouble",	//652
    "isEmpty",	//653
    "isEmptyAsync",	//654
    "isEncrypted",	//655
    "isGraph",	//656
    "isImportant",	//657
    "isInProgress",	//658
    "isInt",	//659
    "isInt64",	//660
    "isLiteral",	//661
    "isOpen",	//662
    "isOptionInSettings",	//663
    "isOptionInSettings?$",	//664
    "isOptionInSettings?$$",	//665
    "isParserError",	//666
    "isPlain",	//667
    "isProperty",	//668
    "isProperty#",	//669
    "isPublicChannel",	//670
    "isRead",	//671
    "isRelated",	//672
    "isResource",	//673
    "isSourceEncrypted",	//674
    "isString",	//675
    "isSubClassOf",	//676
    "isSubClassOf##",	//677
    "isSubPropertyOf",	//678
    "isSubPropertyOf##",	//679
    "isTagFor",	//680
    "isTime",	//681
    "isTopicOf",	//682
    "isType",	//683
    "isType##",	//684
    "isUnsignedInt",	//685
    "isUnsignedInt64",	//686
    "isValid",	//687
    "isVariable",	//688
    "isoEquivalent",	//689
    "iterateBindings",	//690
    "iterateBindings$",	//691
    "iterateContexts",	//692
    "iterateObjects",	//693
    "iteratePredicates",	//694
    "iterateStatements",	//695
    "iterateStatementsFromBindings",	//696
    "iterateStatementsFromBindings$$$",	//697
    "iterateStatementsFromBindings$$$$",	//698
    "iterateStatementsFromBindings$$$$#",	//699
    "iterateSubjects",	//700
    "jabberContactMedium",	//701
    "keyword",	//702
    "knows",	//703
    "label",	//704
    "language",	//705
    "lastModified",	//706
    "lastRefreshed",	//707
    "lastUsed",	//708
    "legal",	//709
    "license",	//710
    "licenseType",	//711
    "line",	//712
    "lineCount",	//713
    "links",	//714
    "listContexts",	//715
    "listContextsAsync",	//716
    "listStatements",	//717
    "listStatements#",	//718
    "listStatements###",	//719
    "listStatements####",	//720
    "listStatementsAsync",	//721
    "listStatementsAsync#",	//722
    "listStatementsAsync###",	//723
    "listStatementsAsync####",	//724
    "listStatementsInContext",	//725
    "listStatementsInContext#",	//726
    "listen",	//727
    "listen$",	//728
    "literal",	//729
    "literalToN3",	//730
    "literalToN3#",	//731
    "localRevision",	//732
    "locator",	//733
    "lookup",	//734
    "lookup?#",	//735
    "lookup?#$",	//736
    "lookup?#$$",	//737
    "lookup??",	//738
    "lookup??$",	//739
    "lookup??$$",	//740
    "lyricist",	//741
    "mailingList",	//742
    "mailingPostalAddress",	//743
    "maintainer",	//744
    "markupCharacterCount",	//745
    "match",	//746
    "match#",	//747
    "matches",	//748
    "matches#",	//749
    "matches#$",	//750
    "maxCardinality",	//751
    "md5Hash",	//752
    "mediaBitrate",	//753
    "mediaCodec",	//754
    "mediaCodecType",	//755
    "mediaDuration",	//756
    "member",	//757
    "mergeConflict",	//758
    "message",	//759
    "metaObject",	//760
    "meteringMode",	//761
    "mimeType",	//762
    "mimeTypeToSerialization",	//763
    "mimeTypeToSerialization$",	//764
    "minCardinality",	//765
    "mode",	//766
    "model",	//767
    "model$",	//768
    "modified",	//769
    "mountPoint",	//770
    "name",	//771
    "naoNamespace",	//772
    "negativeInteger",	//773
    "newsGroup",	//774
    "nil",	//775
    "node",	//776
    "nodeIterator",	//777
    "nonNegativeInteger",	//778
    "nrlNamespace",	//779
    "numericRating",	//780
    "object",	//781
    "objectPattern",	//782
    "occupiedSpace",	//783
    "onProperty",	//784
    "oneOf",	//785
    "open",	//786
    "open$",	//787
    "open$$",	//788
    "operator QString",	//789
    "operator bool",	//790
    "operator!=",	//791
    "operator!=#",	//792
    "operator+",	//793
    "operator+#",	//794
    "operator+=",	//795
    "operator+=#",	//796
    "operator-",	//797
    "operator-#",	//798
    "operator-=",	//799
    "operator-=#",	//800
    "operator<",	//801
    "operator<#",	//802
    "operator<<",	//803
    "operator<<#",	//804
    "operator<=",	//805
    "operator<=#",	//806
    "operator=",	//807
    "operator=#",	//808
    "operator=$",	//809
    "operator==",	//810
    "operator==#",	//811
    "operator=?",	//812
    "operator>",	//813
    "operator>#",	//814
    "operator>=",	//815
    "operator>=#",	//816
    "operator[]",	//817
    "operator[]$",	//818
    "optimize",	//819
    "optimizeIndex",	//820
    "option",	//821
    "orientation",	//822
    "originURL",	//823
    "originalLocation",	//824
    "otherName",	//825
    "owlNamespace",	//826
    "owner",	//827
    "pageCount",	//828
    "paragraphCount",	//829
    "parentModel",	//830
    "parentStatementAdded",	//831
    "parentStatementAdded#",	//832
    "parentStatementRemoved",	//833
    "parentStatementRemoved#",	//834
    "parentStatementsAdded",	//835
    "parentStatementsRemoved",	//836
    "parseFile",	//837
    "parseFile$",	//838
    "parseFile$#$",	//839
    "parseFile$#$$",	//840
    "parseRule",	//841
    "parseRule$",	//842
    "parseStream",	//843
    "parseStream##$",	//844
    "parseStream##$$",	//845
    "parseString",	//846
    "parseString$#$",	//847
    "parseString$#$$",	//848
    "performInference",	//849
    "performer",	//850
    "permissions",	//851
    "personPhoto",	//852
    "personalIdentifier",	//853
    "phoneNumber",	//854
    "pixelDataBitDepth",	//855
    "pixelDataType",	//856
    "pluginName",	//857
    "pluralPrefLabel",	//858
    "postalAddress",	//859
    "preconditions",	//860
    "predicate",	//861
    "predicatePattern",	//862
    "prefLabel",	//863
    "prefSymbol",	//864
    "prefixes",	//865
    "primaryRecipient",	//866
    "priorVersion",	//867
    "programmingLanguage",	//868
    "properties",	//869
    "qt_metacall",	//870
    "qt_metacall$$?",	//871
    "queryAnalyzer",	//872
    "queryLanguageFromString",	//873
    "queryLanguageFromString$",	//874
    "queryLanguageToString",	//875
    "queryLanguageToString$",	//876
    "queryLanguageToString$$",	//877
    "queryResultIterator",	//878
    "range",	//879
    "range##",	//880
    "rating",	//881
    "rdfNamespace",	//882
    "rdfsNamespace",	//883
    "realizes",	//884
    "rebuildIndex",	//885
    "receptionTime",	//886
    "recipient",	//887
    "registerAsDBusObject",	//888
    "registerAsDBusObject$",	//889
    "registerIterator",	//890
    "registerIterator$",	//891
    "registerIterator$$",	//892
    "registerModel",	//893
    "registerModel$",	//894
    "related",	//895
    "remotePassword",	//896
    "remotePort",	//897
    "remoteServer",	//898
    "remoteUser",	//899
    "removeAllStatements",	//900
    "removeAllStatements#",	//901
    "removeAllStatements###",	//902
    "removeAllStatements####",	//903
    "removeAllStatementsAsync",	//904
    "removeAllStatementsAsync#",	//905
    "removeAllStatementsAsync###",	//906
    "removeAllStatementsAsync####",	//907
    "removeContext",	//908
    "removeContext#",	//909
    "removeModel",	//910
    "removeModel$",	//911
    "removeStatement",	//912
    "removeStatement#",	//913
    "removeStatement###",	//914
    "removeStatement####",	//915
    "removeStatementAsync",	//916
    "removeStatementAsync#",	//917
    "removeStatementAsync###",	//918
    "removeStatementAsync####",	//919
    "removeStatements",	//920
    "removeStatements?",	//921
    "removeStatementsAsync",	//922
    "removeStatementsAsync?",	//923
    "replace",	//924
    "replace$#",	//925
    "replyTo",	//926
    "resource",	//927
    "resourceCount",	//928
    "resourceToN3",	//929
    "resourceToN3#",	//930
    "rest",	//931
    "resultReady",	//932
    "resultReady#",	//933
    "rowCount",	//934
    "rssFeed",	//935
    "rule",	//936
    "rule$",	//937
    "ruleLanguage",	//938
    "ruleNames",	//939
    "rules",	//940
    "sameAs",	//941
    "sampleConfiguration",	//942
    "sampleDataBitDepth",	//943
    "sampleDataType",	//944
    "score",	//945
    "scoreParameter",	//946
    "secondaryRecipient",	//947
    "seeAlso",	//948
    "seenAttachedAs",	//949
    "semanticsDefinedBy",	//950
    "serializationLanguage",	//951
    "serializationMimeType",	//952
    "serializationMimeType$",	//953
    "serializationMimeType$$",	//954
    "serialize",	//955
    "serialize##$",	//956
    "serialize##$$",	//957
    "serverPort",	//958
    "setAsyncCalls",	//959
    "setAsyncCalls$",	//960
    "setBackend",	//961
    "setBackend#",	//962
    "setBackendSettings",	//963
    "setBackendSettings?",	//964
    "setByte",	//965
    "setByte$",	//966
    "setCacheTime",	//967
    "setCacheTime$",	//968
    "setColumn",	//969
    "setColumn$",	//970
    "setCompressedSourceStatements",	//971
    "setCompressedSourceStatements$",	//972
    "setContext",	//973
    "setContext#",	//974
    "setCount",	//975
    "setDeleteOnClose",	//976
    "setDeleteOnClose$",	//977
    "setEffect",	//978
    "setEffect#",	//979
    "setFileName",	//980
    "setFileName$",	//981
    "setForceIndexPredicates",	//982
    "setForceIndexPredicates?",	//983
    "setHost",	//984
    "setHost$",	//985
    "setHost$$",	//986
    "setIndexOnlyPredicates",	//987
    "setIndexOnlyPredicates?",	//988
    "setLine",	//989
    "setLine$",	//990
    "setMode",	//991
    "setMode$",	//992
    "setObject",	//993
    "setObject#",	//994
    "setOptimizedQueriesEnabled",	//995
    "setOptimizedQueriesEnabled$",	//996
    "setParentModel",	//997
    "setParentModel#",	//998
    "setPath",	//999
    "setPath$",	//1000
    "setPluginSearchPath",	//1001
    "setPluginSearchPath?",	//1002
    "setPluginSearchPath?$",	//1003
    "setPredicate",	//1004
    "setPredicate#",	//1005
    "setQueryAnalyzer",	//1006
    "setQueryAnalyzer?",	//1007
    "setRate",	//1008
    "setRules",	//1009
    "setRules?",	//1010
    "setSubject",	//1011
    "setSubject#",	//1012
    "setTransactionCacheSize",	//1013
    "setTransactionCacheSize$",	//1014
    "setUsedBackend",	//1015
    "setUsedBackend#",	//1016
    "setUser",	//1017
    "setUser$",	//1018
    "setUser$$",	//1019
    "setValue",	//1020
    "setValue#",	//1021
    "settingInSettings",	//1022
    "settingInSettings?$",	//1023
    "settingInSettings?$$",	//1024
    "sha1Hash",	//1025
    "silNamespace",	//1026
    "size",	//1027
    "someValuesFrom",	//1028
    "sourceCreated",	//1029
    "sourceModified",	//1030
    "sourceStatement",	//1031
    "standardRuleSet",	//1032
    "standardRuleSet$",	//1033
    "start",	//1034
    "start$",	//1035
    "startTransaction",	//1036
    "statementAdded",	//1037
    "statementAdded#",	//1038
    "statementCount",	//1039
    "statementCountAsync",	//1040
    "statementIterator",	//1041
    "statementRemoved",	//1042
    "statementRemoved#",	//1043
    "statementsAdded",	//1044
    "statementsRemoved",	//1045
    "staticMetaObject",	//1046
    "status",	//1047
    "storageSize",	//1048
    "string",	//1049
    "subClassOf",	//1050
    "subClassOf#",	//1051
    "subClassOf##",	//1052
    "subGraphOf",	//1053
    "subPropertyOf",	//1054
    "subPropertyOf#",	//1055
    "subPropertyOf##",	//1056
    "subTags",	//1057
    "subject",	//1058
    "subjectPattern",	//1059
    "summary",	//1060
    "superGraphOf",	//1061
    "supercedes",	//1062
    "supportedFeatures",	//1063
    "supportedSerializations",	//1064
    "supportedUserFeatures",	//1065
    "supportedUserSerializations",	//1066
    "supportsFeatures",	//1067
    "supportsFeatures$",	//1068
    "supportsFeatures$?",	//1069
    "supportsSerialization",	//1070
    "supportsSerialization$",	//1071
    "supportsSerialization$$",	//1072
    "targetQuality",	//1073
    "time",	//1074
    "timerEvent",	//1075
    "timerEvent#",	//1076
    "title",	//1077
    "to",	//1078
    "toBool",	//1079
    "toByteArray",	//1080
    "toDate",	//1081
    "toDateTime",	//1082
    "toDouble",	//1083
    "toInt",	//1084
    "toInt64",	//1085
    "toList",	//1086
    "toLocale",	//1087
    "toN3",	//1088
    "toParserError",	//1089
    "toPrettyString",	//1090
    "toString",	//1091
    "toTime",	//1092
    "toUnsignedInt",	//1093
    "toUnsignedInt64",	//1094
    "totalSpace",	//1095
    "totalUncompressedSize",	//1096
    "trackGain",	//1097
    "trackNumber",	//1098
    "trackPeakGain",	//1099
    "transactionCacheSize",	//1100
    "type",	//1101
    "type##",	//1102
    "typeFromDataTypeUri",	//1103
    "typeFromDataTypeUri#",	//1104
    "unionOf",	//1105
    "unregisterIterator",	//1106
    "unregisterModel",	//1107
    "unsignedInt",	//1108
    "unsignedLong",	//1109
    "unsignedShort",	//1110
    "updatable",	//1111
    "uri",	//1112
    "url",	//1113
    "useCount",	//1114
    "usedBackend",	//1115
    "userComment",	//1116
    "userKeyword",	//1117
    "userOptionName",	//1118
    "userRating",	//1119
    "usesNamespace",	//1120
    "value",	//1121
    "value$",	//1122
    "valueInSettings",	//1123
    "valueInSettings?$",	//1124
    "valueInSettings?$$",	//1125
    "variableName",	//1126
    "variant",	//1127
    "version",	//1128
    "versionInfo",	//1129
    "versionMajor",	//1130
    "versionMinor",	//1131
    "versionRelease",	//1132
    "versionString",	//1133
    "verticalResolution",	//1134
    "videoBitrate",	//1135
    "videoCodec",	//1136
    "videoCodecType",	//1137
    "viewOn",	//1138
    "whiteBalance",	//1139
    "width",	//1140
    "wordCount",	//1141
    "workEmailAddress",	//1142
    "workPhoneNumber",	//1143
    "workPostalAddress",	//1144
    "write",	//1145
    "write#",	//1146
    "xesam35mmEquivalent",	//1147
    "xesamNamespace",	//1148
    "xsdDouble",	//1149
    "xsdFloat",	//1150
    "xsdInt",	//1151
    "xsdLong",	//1152
    "xsdNamespace",	//1153
    "xsdShort",	//1154
    "~AsyncModel",	//1155
    "~AsyncResult",	//1156
    "~Backend",	//1157
    "~BackendSetting",	//1158
    "~BindingSet",	//1159
    "~CLuceneIndex",	//1160
    "~DBusClient",	//1161
    "~DBusExportIterator",	//1162
    "~DBusExportModel",	//1163
    "~DBusModel",	//1164
    "~DBusNodeIterator",	//1165
    "~DBusQueryResultIterator",	//1166
    "~DBusStatementIterator",	//1167
    "~Error",	//1168
    "~FilterModel",	//1169
    "~Graph",	//1170
    "~IndexFilterModel",	//1171
    "~InferenceModel",	//1172
    "~LanguageTag",	//1173
    "~LiteralValue",	//1174
    "~LocalSocketClient",	//1175
    "~Locator",	//1176
    "~Model",	//1177
    "~MutexModel",	//1178
    "~Node",	//1179
    "~NodeIterator",	//1180
    "~NodePattern",	//1181
    "~Parser",	//1182
    "~ParserError",	//1183
    "~Plugin",	//1184
    "~PluginManager",	//1185
    "~QueryHit",	//1186
    "~QueryResultIterator",	//1187
    "~RdfSchemaModel",	//1188
    "~ReadOnlyModel",	//1189
    "~Rule",	//1190
    "~RuleParser",	//1191
    "~RuleSet",	//1192
    "~Serializer",	//1193
    "~ServerCore",	//1194
    "~SignalCacheModel",	//1195
    "~SimpleNodeIterator",	//1196
    "~SparqlModel",	//1197
    "~Statement",	//1198
    "~StatementIterator",	//1199
    "~StatementPattern",	//1200
    "~StorageModel",	//1201
    "~TcpClient",	//1202
};

// (classId, name (index in methodNames), argumentList index, number of args, method flags, return type (index in types), xcall() index)
static Smoke::Method soprano_methods[] = {
	{9, 760, 0, 0, Smoke::mf_const, 303, 2},	//0 QObject::metaObject() const
	{9, 870, 362, 3, 0, 337, 3},	//1 QObject::qt_metacall(QMetaObject::Call, int, void**)
	{9, 553, 309, 1, 0, 289, 6},	//2 QObject::event(QEvent*)
	{9, 555, 368, 2, 0, 289, 7},	//3 QObject::eventFilter(QObject*, QEvent*)
	{9, 1075, 14, 1, Smoke::mf_protected, 0, 49},	//4 QObject::timerEvent(QTimerEvent*)
	{9, 391, 1, 1, Smoke::mf_protected, 0, 50},	//5 QObject::childEvent(QChildEvent*)
	{9, 481, 309, 1, Smoke::mf_protected, 0, 51},	//6 QObject::customEvent(QEvent*)
	{9, 418, 317, 1, Smoke::mf_protected, 0, 52},	//7 QObject::connectNotify(const char*)
	{9, 514, 317, 1, Smoke::mf_protected, 0, 53},	//8 QObject::disconnectNotify(const char*)
	{15, 249, 0, 0, Smoke::mf_static|Smoke::mf_enum, 266, 1},	//9 Soprano::SerializationUnknown (enum)
	{15, 246, 0, 0, Smoke::mf_static|Smoke::mf_enum, 266, 2},	//10 Soprano::SerializationRdfXml (enum)
	{15, 243, 0, 0, Smoke::mf_static|Smoke::mf_enum, 266, 3},	//11 Soprano::SerializationN3 (enum)
	{15, 245, 0, 0, Smoke::mf_static|Smoke::mf_enum, 266, 4},	//12 Soprano::SerializationNTriples (enum)
	{15, 248, 0, 0, Smoke::mf_static|Smoke::mf_enum, 266, 5},	//13 Soprano::SerializationTurtle (enum)
	{15, 247, 0, 0, Smoke::mf_static|Smoke::mf_enum, 266, 6},	//14 Soprano::SerializationTrig (enum)
	{15, 244, 0, 0, Smoke::mf_static|Smoke::mf_enum, 266, 7},	//15 Soprano::SerializationNQuads (enum)
	{15, 250, 0, 0, Smoke::mf_static|Smoke::mf_enum, 266, 8},	//16 Soprano::SerializationUser (enum)
	{15, 27, 0, 0, Smoke::mf_static|Smoke::mf_enum, 189, 9},	//17 Soprano::BackendOptionNone (enum)
	{15, 31, 0, 0, Smoke::mf_static|Smoke::mf_enum, 189, 10},	//18 Soprano::BackendOptionStorageMemory (enum)
	{15, 25, 0, 0, Smoke::mf_static|Smoke::mf_enum, 189, 11},	//19 Soprano::BackendOptionEnableInference (enum)
	{15, 30, 0, 0, Smoke::mf_static|Smoke::mf_enum, 189, 12},	//20 Soprano::BackendOptionStorageDir (enum)
	{15, 26, 0, 0, Smoke::mf_static|Smoke::mf_enum, 189, 13},	//21 Soprano::BackendOptionHost (enum)
	{15, 29, 0, 0, Smoke::mf_static|Smoke::mf_enum, 189, 14},	//22 Soprano::BackendOptionPort (enum)
	{15, 33, 0, 0, Smoke::mf_static|Smoke::mf_enum, 189, 15},	//23 Soprano::BackendOptionUsername (enum)
	{15, 28, 0, 0, Smoke::mf_static|Smoke::mf_enum, 189, 16},	//24 Soprano::BackendOptionPassword (enum)
	{15, 32, 0, 0, Smoke::mf_static|Smoke::mf_enum, 189, 17},	//25 Soprano::BackendOptionUser (enum)
	{15, 20, 0, 0, Smoke::mf_static|Smoke::mf_enum, 186, 18},	//26 Soprano::BackendFeatureNone (enum)
	{15, 14, 0, 0, Smoke::mf_static|Smoke::mf_enum, 186, 19},	//27 Soprano::BackendFeatureAddStatement (enum)
	{15, 22, 0, 0, Smoke::mf_static|Smoke::mf_enum, 186, 20},	//28 Soprano::BackendFeatureRemoveStatements (enum)
	{15, 19, 0, 0, Smoke::mf_static|Smoke::mf_enum, 186, 21},	//29 Soprano::BackendFeatureListStatements (enum)
	{15, 21, 0, 0, Smoke::mf_static|Smoke::mf_enum, 186, 22},	//30 Soprano::BackendFeatureQuery (enum)
	{15, 17, 0, 0, Smoke::mf_static|Smoke::mf_enum, 186, 23},	//31 Soprano::BackendFeatureInference (enum)
	{15, 18, 0, 0, Smoke::mf_static|Smoke::mf_enum, 186, 24},	//32 Soprano::BackendFeatureInferenceOptional (enum)
	{15, 16, 0, 0, Smoke::mf_static|Smoke::mf_enum, 186, 25},	//33 Soprano::BackendFeatureContext (enum)
	{15, 23, 0, 0, Smoke::mf_static|Smoke::mf_enum, 186, 26},	//34 Soprano::BackendFeatureStorageMemory (enum)
	{15, 15, 0, 0, Smoke::mf_static|Smoke::mf_enum, 186, 27},	//35 Soprano::BackendFeatureAll (enum)
	{15, 24, 0, 0, Smoke::mf_static|Smoke::mf_enum, 186, 28},	//36 Soprano::BackendFeatureUser (enum)
	{15, 952, 60, 2, Smoke::mf_static, 106, 29},	//37 Soprano::serializationMimeType(Soprano::RdfSerialization, const QString&)
	{15, 952, 58, 1, Smoke::mf_static, 106, 30},	//38 Soprano::serializationMimeType(Soprano::RdfSerialization)
	{15, 763, 146, 1, Smoke::mf_static, 266, 31},	//39 Soprano::mimeTypeToSerialization(const QString&)
	{15, 663, 108, 3, Smoke::mf_static, 289, 32},	//40 Soprano::isOptionInSettings(const QList<Soprano::BackendSetting>&, Soprano::BackendOption, const QString&)
	{15, 663, 105, 2, Smoke::mf_static, 289, 33},	//41 Soprano::isOptionInSettings(const QList<Soprano::BackendSetting>&, Soprano::BackendOption)
	{15, 1022, 353, 3, Smoke::mf_static, 192, 34},	//42 Soprano::settingInSettings(QList<Soprano::BackendSetting>&, Soprano::BackendOption, const QString&)
	{15, 1022, 350, 2, Smoke::mf_static, 192, 35},	//43 Soprano::settingInSettings(QList<Soprano::BackendSetting>&, Soprano::BackendOption)
	{15, 1123, 108, 3, Smoke::mf_static, 153, 36},	//44 Soprano::valueInSettings(const QList<Soprano::BackendSetting>&, Soprano::BackendOption, const QString&)
	{15, 1123, 105, 2, Smoke::mf_static, 153, 37},	//45 Soprano::valueInSettings(const QList<Soprano::BackendSetting>&, Soprano::BackendOption)
	{15, 519, 146, 1, Smoke::mf_static, 310, 38},	//46 Soprano::discoverBackendByName(const QString&)
	{15, 516, 20, 2, Smoke::mf_static, 310, 39},	//47 Soprano::discoverBackendByFeatures(Soprano::BackendFeatures, const QStringList&)
	{15, 516, 18, 1, Smoke::mf_static, 310, 40},	//48 Soprano::discoverBackendByFeatures(Soprano::BackendFeatures)
	{15, 1015, 242, 1, Smoke::mf_static, 0, 41},	//49 Soprano::setUsedBackend(const Soprano::Backend*)
	{15, 1115, 0, 0, Smoke::mf_static, 310, 42},	//50 Soprano::usedBackend()
	{15, 461, 103, 1, Smoke::mf_static, 247, 43},	//51 Soprano::createModel(const QList<Soprano::BackendSetting>&)
	{15, 461, 0, 0, Smoke::mf_static, 247, 44},	//52 Soprano::createModel()
	{15, 1130, 0, 0, Smoke::mf_static, 343, 45},	//53 Soprano::versionMajor()
	{15, 1131, 0, 0, Smoke::mf_static, 343, 46},	//54 Soprano::versionMinor()
	{15, 1132, 0, 0, Smoke::mf_static, 343, 47},	//55 Soprano::versionRelease()
	{15, 1133, 0, 0, Smoke::mf_static, 334, 48},	//56 Soprano::versionString()
	{16, 12, 146, 1, Smoke::mf_ctor, 185, 1},	//57 Soprano::Backend::Backend(const QString&)
	{16, 1157, 0, 0, Smoke::mf_dtor, 0, 8},	//58 Soprano::Backend::~Backend()
	{16, 461, 103, 1, Smoke::mf_const, 279, 2},	//59 Soprano::Backend::createModel(const QList<Soprano::BackendSetting>&) const [pure virtual]
	{16, 461, 0, 0, Smoke::mf_const, 279, -1},	//60 Soprano::Backend::createModel() const [pure virtual]
	{16, 495, 103, 1, Smoke::mf_const, 289, 3},	//61 Soprano::Backend::deleteModelData(const QList<Soprano::BackendSetting>&) const [pure virtual]
	{16, 1063, 0, 0, Smoke::mf_const, 187, 4},	//62 Soprano::Backend::supportedFeatures() const [pure virtual]
	{16, 1065, 0, 0, Smoke::mf_const, 110, 5},	//63 Soprano::Backend::supportedUserFeatures() const
	{16, 1067, 20, 2, Smoke::mf_const, 289, 6},	//64 Soprano::Backend::supportsFeatures(Soprano::BackendFeatures, const QStringList&) const
	{16, 1067, 18, 1, Smoke::mf_const, 289, 7},	//65 Soprano::Backend::supportsFeatures(Soprano::BackendFeatures) const
	{17, 34, 0, 0, Smoke::mf_ctor, 193, 1},	//66 Soprano::BackendSetting::BackendSetting()
	{17, 34, 23, 1, Smoke::mf_ctor, 193, 2},	//67 Soprano::BackendSetting::BackendSetting(Soprano::BackendOption)
	{17, 34, 25, 2, Smoke::mf_ctor, 193, 3},	//68 Soprano::BackendSetting::BackendSetting(Soprano::BackendOption, const QVariant&)
	{17, 34, 201, 2, Smoke::mf_ctor, 193, 4},	//69 Soprano::BackendSetting::BackendSetting(const QString&, const QVariant&)
	{17, 34, 244, 1, Smoke::mf_copyctor|Smoke::mf_ctor, 193, 5},	//70 Soprano::BackendSetting::BackendSetting(const Soprano::BackendSetting&)
	{17, 1158, 0, 0, Smoke::mf_dtor, 0, 11},	//71 Soprano::BackendSetting::~BackendSetting()
	{17, 807, 244, 1, 0, 192, 6},	//72 Soprano::BackendSetting::operator=(const Soprano::BackendSetting&)
	{17, 821, 0, 0, Smoke::mf_const, 189, 7},	//73 Soprano::BackendSetting::option() const
	{17, 1118, 0, 0, Smoke::mf_const, 106, 8},	//74 Soprano::BackendSetting::userOptionName() const
	{17, 1121, 0, 0, Smoke::mf_const, 153, 9},	//75 Soprano::BackendSetting::value() const
	{17, 1020, 240, 1, 0, 0, 10},	//76 Soprano::BackendSetting::setValue(const QVariant&)
	{18, 39, 0, 0, Smoke::mf_ctor, 196, 1},	//77 Soprano::BindingSet::BindingSet()
	{18, 39, 246, 1, Smoke::mf_copyctor|Smoke::mf_ctor, 196, 2},	//78 Soprano::BindingSet::BindingSet(const Soprano::BindingSet&)
	{18, 1159, 0, 0, Smoke::mf_dtor, 0, 14},	//79 Soprano::BindingSet::~BindingSet()
	{18, 807, 246, 1, 0, 195, 3},	//80 Soprano::BindingSet::operator=(const Soprano::BindingSet&)
	{18, 370, 0, 0, Smoke::mf_const, 110, 4},	//81 Soprano::BindingSet::bindingNames() const
	{18, 817, 321, 1, Smoke::mf_const, 248, 5},	//82 Soprano::BindingSet::operator[](int) const
	{18, 817, 144, 1, Smoke::mf_const, 248, 6},	//83 Soprano::BindingSet::operator[](const QString) const
	{18, 1121, 321, 1, Smoke::mf_const, 248, 7},	//84 Soprano::BindingSet::value(int) const
	{18, 1121, 146, 1, Smoke::mf_const, 248, 8},	//85 Soprano::BindingSet::value(const QString&) const
	{18, 423, 146, 1, Smoke::mf_const, 289, 9},	//86 Soprano::BindingSet::contains(const QString&) const
	{18, 454, 0, 0, Smoke::mf_const, 337, 10},	//87 Soprano::BindingSet::count() const
	{18, 624, 210, 2, 0, 0, 11},	//88 Soprano::BindingSet::insert(const QString&, const Soprano::Node&)
	{18, 924, 323, 2, 0, 0, 12},	//89 Soprano::BindingSet::replace(int, const Soprano::Node&)
	{18, 924, 210, 2, 0, 0, 13},	//90 Soprano::BindingSet::replace(const QString&, const Soprano::Node&)
	{20, 760, 0, 0, Smoke::mf_const, 303, 2},	//91 Soprano::Client::DBusClient::metaObject() const
	{20, 870, 362, 3, 0, 337, 3},	//92 Soprano::Client::DBusClient::qt_metacall(QMetaObject::Call, int, void**)
	{20, 54, 228, 2, Smoke::mf_ctor, 197, 4},	//93 Soprano::Client::DBusClient::DBusClient(const QString&, QObject*)
	{20, 54, 146, 1, Smoke::mf_ctor, 197, 5},	//94 Soprano::Client::DBusClient::DBusClient(const QString&)
	{20, 54, 0, 0, Smoke::mf_ctor, 197, 6},	//95 Soprano::Client::DBusClient::DBusClient()
	{20, 1161, 0, 0, Smoke::mf_dtor, 0, 12},	//96 Soprano::Client::DBusClient::~DBusClient()
	{20, 687, 0, 0, Smoke::mf_const, 289, 7},	//97 Soprano::Client::DBusClient::isValid() const
	{20, 327, 0, 0, Smoke::mf_const, 110, 8},	//98 Soprano::Client::DBusClient::allModels() const
	{20, 461, 164, 2, 0, 198, 9},	//99 Soprano::Client::DBusClient::createModel(const QString&, const QList<Soprano::BackendSetting>&)
	{20, 461, 146, 1, 0, 198, 10},	//100 Soprano::Client::DBusClient::createModel(const QString&)
	{20, 910, 146, 1, 0, 0, 11},	//101 Soprano::Client::DBusClient::removeModel(const QString&)
	{20, 1046, 0, 0, Smoke::mf_static, 302, 1},	//102 Soprano::Client::DBusClient::staticMetaObject (static var)
	{21, 760, 0, 0, Smoke::mf_const, 303, 2},	//103 Soprano::Client::DBusModel::metaObject() const
	{21, 870, 362, 3, 0, 337, 3},	//104 Soprano::Client::DBusModel::qt_metacall(QMetaObject::Call, int, void**)
	{21, 62, 185, 3, Smoke::mf_ctor, 198, 4},	//105 Soprano::Client::DBusModel::DBusModel(const QString&, const QString&, const Soprano::Backend*)
	{21, 62, 167, 2, Smoke::mf_ctor, 198, 5},	//106 Soprano::Client::DBusModel::DBusModel(const QString&, const QString&)
	{21, 1164, 0, 0, Smoke::mf_dtor, 0, 20},	//107 Soprano::Client::DBusModel::~DBusModel()
	{21, 959, 86, 1, 0, 0, 6},	//108 Soprano::Client::DBusModel::setAsyncCalls(bool)
	{21, 341, 0, 0, Smoke::mf_const, 289, 7},	//109 Soprano::Client::DBusModel::asyncCalls() const
	{21, 308, 311, 1, 0, 207, 8},	//110 Soprano::Client::DBusModel::addStatement(const Soprano::Statement&)
	{21, 715, 0, 0, Smoke::mf_const, 252, 9},	//111 Soprano::Client::DBusModel::listContexts() const
	{21, 557, 157, 3, Smoke::mf_const, 261, 10},	//112 Soprano::Client::DBusModel::executeQuery(const QString&, Soprano::Query::QueryLanguage, const QString&) const
	{21, 557, 154, 2, Smoke::mf_const, 261, 11},	//113 Soprano::Client::DBusModel::executeQuery(const QString&, Soprano::Query::QueryLanguage) const
	{21, 717, 311, 1, Smoke::mf_const, 276, 12},	//114 Soprano::Client::DBusModel::listStatements(const Soprano::Statement&) const
	{21, 912, 311, 1, 0, 207, 13},	//115 Soprano::Client::DBusModel::removeStatement(const Soprano::Statement&)
	{21, 900, 311, 1, 0, 207, 14},	//116 Soprano::Client::DBusModel::removeAllStatements(const Soprano::Statement&)
	{21, 1039, 0, 0, Smoke::mf_const, 337, 15},	//117 Soprano::Client::DBusModel::statementCount() const
	{21, 653, 0, 0, Smoke::mf_const, 289, 16},	//118 Soprano::Client::DBusModel::isEmpty() const
	{21, 435, 311, 1, Smoke::mf_const, 289, 17},	//119 Soprano::Client::DBusModel::containsStatement(const Soprano::Statement&) const
	{21, 425, 311, 1, Smoke::mf_const, 289, 18},	//120 Soprano::Client::DBusModel::containsAnyStatement(const Soprano::Statement&) const
	{21, 455, 0, 0, 0, 248, 19},	//121 Soprano::Client::DBusModel::createBlankNode()
	{21, 1046, 0, 0, Smoke::mf_static, 302, 1},	//122 Soprano::Client::DBusModel::staticMetaObject (static var)
	{22, 65, 167, 2, Smoke::mf_ctor, 199, 1},	//123 Soprano::Client::DBusNodeIterator::DBusNodeIterator(const QString&, const QString&)
	{22, 1165, 0, 0, Smoke::mf_dtor, 0, 2},	//124 Soprano::Client::DBusNodeIterator::~DBusNodeIterator()
	{23, 67, 167, 2, Smoke::mf_ctor, 200, 1},	//125 Soprano::Client::DBusQueryResultIterator::DBusQueryResultIterator(const QString&, const QString&)
	{23, 1166, 0, 0, Smoke::mf_dtor, 0, 2},	//126 Soprano::Client::DBusQueryResultIterator::~DBusQueryResultIterator()
	{24, 69, 167, 2, Smoke::mf_ctor, 201, 1},	//127 Soprano::Client::DBusStatementIterator::DBusStatementIterator(const QString&, const QString&)
	{24, 1167, 0, 0, Smoke::mf_dtor, 0, 2},	//128 Soprano::Client::DBusStatementIterator::~DBusStatementIterator()
	{25, 760, 0, 0, Smoke::mf_const, 303, 2},	//129 Soprano::Client::LocalSocketClient::metaObject() const
	{25, 870, 362, 3, 0, 337, 3},	//130 Soprano::Client::LocalSocketClient::qt_metacall(QMetaObject::Call, int, void**)
	{25, 141, 366, 1, Smoke::mf_ctor, 202, 4},	//131 Soprano::Client::LocalSocketClient::LocalSocketClient(QObject*)
	{25, 141, 0, 0, Smoke::mf_ctor, 202, 5},	//132 Soprano::Client::LocalSocketClient::LocalSocketClient()
	{25, 1175, 0, 0, Smoke::mf_dtor, 0, 13},	//133 Soprano::Client::LocalSocketClient::~LocalSocketClient()
	{25, 641, 0, 0, Smoke::mf_const, 289, 6},	//134 Soprano::Client::LocalSocketClient::isConnected() const
	{25, 461, 164, 2, 0, 247, 7},	//135 Soprano::Client::LocalSocketClient::createModel(const QString&, const QList<Soprano::BackendSetting>&)
	{25, 461, 146, 1, 0, 247, 8},	//136 Soprano::Client::LocalSocketClient::createModel(const QString&)
	{25, 910, 146, 1, 0, 0, 9},	//137 Soprano::Client::LocalSocketClient::removeModel(const QString&)
	{25, 414, 146, 1, 0, 289, 10},	//138 Soprano::Client::LocalSocketClient::connect(const QString&)
	{25, 414, 0, 0, 0, 289, 11},	//139 Soprano::Client::LocalSocketClient::connect()
	{25, 513, 0, 0, 0, 0, 12},	//140 Soprano::Client::LocalSocketClient::disconnect()
	{25, 1046, 0, 0, Smoke::mf_static, 302, 1},	//141 Soprano::Client::LocalSocketClient::staticMetaObject (static var)
	{26, 760, 0, 0, Smoke::mf_const, 303, 2},	//142 Soprano::Client::SparqlModel::metaObject() const
	{26, 870, 362, 3, 0, 337, 3},	//143 Soprano::Client::SparqlModel::qt_metacall(QMetaObject::Call, int, void**)
	{26, 264, 223, 4, Smoke::mf_ctor, 203, 4},	//144 Soprano::Client::SparqlModel::SparqlModel(const QString&, unsigned short, const QString&, const QString&)
	{26, 264, 219, 3, Smoke::mf_ctor, 203, 5},	//145 Soprano::Client::SparqlModel::SparqlModel(const QString&, unsigned short, const QString&)
	{26, 264, 216, 2, Smoke::mf_ctor, 203, 6},	//146 Soprano::Client::SparqlModel::SparqlModel(const QString&, unsigned short)
	{26, 264, 146, 1, Smoke::mf_ctor, 203, 7},	//147 Soprano::Client::SparqlModel::SparqlModel(const QString&)
	{26, 264, 0, 0, Smoke::mf_ctor, 203, 8},	//148 Soprano::Client::SparqlModel::SparqlModel()
	{26, 1197, 0, 0, Smoke::mf_dtor, 0, 30},	//149 Soprano::Client::SparqlModel::~SparqlModel()
	{26, 984, 216, 2, 0, 0, 9},	//150 Soprano::Client::SparqlModel::setHost(const QString&, unsigned short)
	{26, 984, 146, 1, 0, 0, 10},	//151 Soprano::Client::SparqlModel::setHost(const QString&)
	{26, 1017, 167, 2, 0, 0, 11},	//152 Soprano::Client::SparqlModel::setUser(const QString&, const QString&)
	{26, 1017, 146, 1, 0, 0, 12},	//153 Soprano::Client::SparqlModel::setUser(const QString&)
	{26, 999, 146, 1, 0, 0, 13},	//154 Soprano::Client::SparqlModel::setPath(const QString&)
	{26, 308, 311, 1, 0, 207, 14},	//155 Soprano::Client::SparqlModel::addStatement(const Soprano::Statement&)
	{26, 912, 311, 1, 0, 207, 15},	//156 Soprano::Client::SparqlModel::removeStatement(const Soprano::Statement&)
	{26, 900, 311, 1, 0, 207, 16},	//157 Soprano::Client::SparqlModel::removeAllStatements(const Soprano::Statement&)
	{26, 717, 311, 1, Smoke::mf_const, 276, 17},	//158 Soprano::Client::SparqlModel::listStatements(const Soprano::Statement&) const
	{26, 557, 157, 3, Smoke::mf_const, 261, 18},	//159 Soprano::Client::SparqlModel::executeQuery(const QString&, Soprano::Query::QueryLanguage, const QString&) const
	{26, 557, 154, 2, Smoke::mf_const, 261, 19},	//160 Soprano::Client::SparqlModel::executeQuery(const QString&, Soprano::Query::QueryLanguage) const
	{26, 557, 146, 1, Smoke::mf_const, 261, 20},	//161 Soprano::Client::SparqlModel::executeQuery(const QString&) const
	{26, 561, 157, 3, Smoke::mf_const, 282, 21},	//162 Soprano::Client::SparqlModel::executeQueryAsync(const QString&, Soprano::Query::QueryLanguage, const QString&) const
	{26, 561, 154, 2, Smoke::mf_const, 282, 22},	//163 Soprano::Client::SparqlModel::executeQueryAsync(const QString&, Soprano::Query::QueryLanguage) const
	{26, 561, 146, 1, Smoke::mf_const, 282, 23},	//164 Soprano::Client::SparqlModel::executeQueryAsync(const QString&) const
	{26, 715, 0, 0, Smoke::mf_const, 252, 24},	//165 Soprano::Client::SparqlModel::listContexts() const
	{26, 435, 311, 1, Smoke::mf_const, 289, 25},	//166 Soprano::Client::SparqlModel::containsStatement(const Soprano::Statement&) const
	{26, 425, 311, 1, Smoke::mf_const, 289, 26},	//167 Soprano::Client::SparqlModel::containsAnyStatement(const Soprano::Statement&) const
	{26, 1039, 0, 0, Smoke::mf_const, 337, 27},	//168 Soprano::Client::SparqlModel::statementCount() const
	{26, 653, 0, 0, Smoke::mf_const, 289, 28},	//169 Soprano::Client::SparqlModel::isEmpty() const
	{26, 455, 0, 0, 0, 248, 29},	//170 Soprano::Client::SparqlModel::createBlankNode()
	{26, 1046, 0, 0, Smoke::mf_static, 302, 1},	//171 Soprano::Client::SparqlModel::staticMetaObject (static var)
	{27, 760, 0, 0, Smoke::mf_const, 303, 3},	//172 Soprano::Client::TcpClient::metaObject() const
	{27, 870, 362, 3, 0, 337, 4},	//173 Soprano::Client::TcpClient::qt_metacall(QMetaObject::Call, int, void**)
	{27, 285, 366, 1, Smoke::mf_ctor, 204, 5},	//174 Soprano::Client::TcpClient::TcpClient(QObject*)
	{27, 285, 0, 0, Smoke::mf_ctor, 204, 6},	//175 Soprano::Client::TcpClient::TcpClient()
	{27, 1202, 0, 0, Smoke::mf_dtor, 0, 15},	//176 Soprano::Client::TcpClient::~TcpClient()
	{27, 414, 96, 2, 0, 289, 7},	//177 Soprano::Client::TcpClient::connect(const QHostAddress&, int)
	{27, 414, 94, 1, 0, 289, 8},	//178 Soprano::Client::TcpClient::connect(const QHostAddress&)
	{27, 414, 0, 0, 0, 289, 9},	//179 Soprano::Client::TcpClient::connect()
	{27, 641, 0, 0, 0, 289, 10},	//180 Soprano::Client::TcpClient::isConnected()
	{27, 513, 0, 0, 0, 0, 11},	//181 Soprano::Client::TcpClient::disconnect()
	{27, 461, 164, 2, 0, 247, 12},	//182 Soprano::Client::TcpClient::createModel(const QString&, const QList<Soprano::BackendSetting>&)
	{27, 461, 146, 1, 0, 247, 13},	//183 Soprano::Client::TcpClient::createModel(const QString&)
	{27, 910, 146, 1, 0, 0, 14},	//184 Soprano::Client::TcpClient::removeModel(const QString&)
	{27, 1046, 0, 0, Smoke::mf_static, 302, 1},	//185 Soprano::Client::TcpClient::staticMetaObject (static var)
	{27, 71, 0, 0, Smoke::mf_static, 335, 2},	//186 Soprano::Client::TcpClient::DEFAULT_PORT (static var)
	{28, 95, 0, 0, Smoke::mf_static|Smoke::mf_enum, 207, 1},	//187 Soprano::Error::ErrorNone (enum)
	{28, 93, 0, 0, Smoke::mf_static|Smoke::mf_enum, 207, 2},	//188 Soprano::Error::ErrorInvalidArgument (enum)
	{28, 94, 0, 0, Smoke::mf_static|Smoke::mf_enum, 207, 3},	//189 Soprano::Error::ErrorInvalidStatement (enum)
	{28, 96, 0, 0, Smoke::mf_static|Smoke::mf_enum, 207, 4},	//190 Soprano::Error::ErrorNotSupported (enum)
	{28, 97, 0, 0, Smoke::mf_static|Smoke::mf_enum, 207, 5},	//191 Soprano::Error::ErrorParsingFailed (enum)
	{28, 98, 0, 0, Smoke::mf_static|Smoke::mf_enum, 207, 6},	//192 Soprano::Error::ErrorPermissionDenied (enum)
	{28, 99, 0, 0, Smoke::mf_static|Smoke::mf_enum, 207, 7},	//193 Soprano::Error::ErrorUnknown (enum)
	{28, 551, 28, 1, Smoke::mf_static, 106, 8},	//194 Soprano::Error::errorMessage(Soprano::Error::ErrorCode)
	{28, 450, 321, 1, Smoke::mf_static, 207, 9},	//195 Soprano::Error::convertErrorCode(int)
	{29, 88, 0, 0, Smoke::mf_ctor, 206, 1},	//196 Soprano::Error::Error::Error()
	{29, 88, 213, 2, Smoke::mf_ctor, 206, 2},	//197 Soprano::Error::Error::Error(const QString&, int)
	{29, 88, 146, 1, Smoke::mf_ctor, 206, 3},	//198 Soprano::Error::Error::Error(const QString&)
	{29, 88, 248, 1, Smoke::mf_copyctor|Smoke::mf_ctor, 206, 4},	//199 Soprano::Error::Error::Error(const Soprano::Error::Error&)
	{29, 1168, 0, 0, Smoke::mf_dtor, 0, 12},	//200 Soprano::Error::Error::~Error()
	{29, 807, 248, 1, 0, 205, 5},	//201 Soprano::Error::Error::operator=(const Soprano::Error::Error&)
	{29, 790, 0, 0, Smoke::mf_const, 289, 6},	//202 Soprano::Error::Error::operator bool() const
	{29, 759, 0, 0, Smoke::mf_const, 106, 7},	//203 Soprano::Error::Error::message() const
	{29, 400, 0, 0, Smoke::mf_const, 337, 8},	//204 Soprano::Error::Error::code() const
	{29, 666, 0, 0, Smoke::mf_const, 289, 9},	//205 Soprano::Error::Error::isParserError() const
	{29, 1089, 0, 0, Smoke::mf_const, 212, 10},	//206 Soprano::Error::Error::toParserError() const
	{29, 88, 30, 1, Smoke::mf_ctor|Smoke::mf_protected, 206, 11},	//207 Soprano::Error::Error::Error(Soprano::Error::ErrorData*)
	{30, 143, 0, 0, Smoke::mf_ctor, 211, 1},	//208 Soprano::Error::Locator::Locator()
	{30, 143, 333, 4, Smoke::mf_ctor, 211, 2},	//209 Soprano::Error::Locator::Locator(int, int, int, const QString&)
	{30, 143, 329, 3, Smoke::mf_ctor, 211, 3},	//210 Soprano::Error::Locator::Locator(int, int, int)
	{30, 143, 326, 2, Smoke::mf_ctor, 211, 4},	//211 Soprano::Error::Locator::Locator(int, int)
	{30, 143, 250, 1, Smoke::mf_copyctor|Smoke::mf_ctor, 211, 5},	//212 Soprano::Error::Locator::Locator(const Soprano::Error::Locator&)
	{30, 1176, 0, 0, Smoke::mf_dtor, 0, 15},	//213 Soprano::Error::Locator::~Locator()
	{30, 807, 250, 1, 0, 210, 6},	//214 Soprano::Error::Locator::operator=(const Soprano::Error::Locator&)
	{30, 712, 0, 0, Smoke::mf_const, 337, 7},	//215 Soprano::Error::Locator::line() const
	{30, 403, 0, 0, Smoke::mf_const, 337, 8},	//216 Soprano::Error::Locator::column() const
	{30, 378, 0, 0, Smoke::mf_const, 337, 9},	//217 Soprano::Error::Locator::byte() const
	{30, 572, 0, 0, Smoke::mf_const, 106, 10},	//218 Soprano::Error::Locator::fileName() const
	{30, 989, 321, 1, 0, 0, 11},	//219 Soprano::Error::Locator::setLine(int)
	{30, 969, 321, 1, 0, 0, 12},	//220 Soprano::Error::Locator::setColumn(int)
	{30, 965, 321, 1, 0, 0, 13},	//221 Soprano::Error::Locator::setByte(int)
	{30, 980, 146, 1, 0, 0, 14},	//222 Soprano::Error::Locator::setFileName(const QString&)
	{31, 184, 0, 0, Smoke::mf_ctor, 214, 1},	//223 Soprano::Error::ParserError::ParserError()
	{31, 184, 255, 3, Smoke::mf_ctor, 214, 2},	//224 Soprano::Error::ParserError::ParserError(const Soprano::Error::Locator&, const QString&, int)
	{31, 184, 252, 2, Smoke::mf_ctor, 214, 3},	//225 Soprano::Error::ParserError::ParserError(const Soprano::Error::Locator&, const QString&)
	{31, 184, 250, 1, Smoke::mf_ctor, 214, 4},	//226 Soprano::Error::ParserError::ParserError(const Soprano::Error::Locator&)
	{31, 184, 248, 1, Smoke::mf_ctor, 214, 5},	//227 Soprano::Error::ParserError::ParserError(const Soprano::Error::Error&)
	{31, 1183, 0, 0, Smoke::mf_dtor, 0, 9},	//228 Soprano::Error::ParserError::~ParserError()
	{31, 807, 248, 1, 0, 213, 6},	//229 Soprano::Error::ParserError::operator=(const Soprano::Error::Error&)
	{31, 733, 0, 0, Smoke::mf_const, 209, 7},	//230 Soprano::Error::ParserError::locator() const
	{31, 184, 259, 1, Smoke::mf_copyctor|Smoke::mf_internal|Smoke::mf_ctor, 214, 8},	//231 Soprano::Error::ParserError::ParserError(const Soprano::Error::ParserError&)
	{32, 760, 0, 0, Smoke::mf_const, 303, 2},	//232 Soprano::FilterModel::metaObject() const
	{32, 870, 362, 3, 0, 337, 3},	//233 Soprano::FilterModel::qt_metacall(QMetaObject::Call, int, void**)
	{32, 1169, 0, 0, Smoke::mf_dtor, 0, 37},	//234 Soprano::FilterModel::~FilterModel()
	{32, 997, 39, 1, 0, 0, 4},	//235 Soprano::FilterModel::setParentModel(Soprano::Model*)
	{32, 830, 0, 0, Smoke::mf_const, 247, 5},	//236 Soprano::FilterModel::parentModel() const
	{32, 308, 311, 1, 0, 207, 6},	//237 Soprano::FilterModel::addStatement(const Soprano::Statement&)
	{32, 308, 295, 4, 0, 207, 7},	//238 Soprano::FilterModel::addStatement(const Soprano::Node&, const Soprano::Node&, const Soprano::Node&, const Soprano::Node&)
	{32, 308, 291, 3, 0, 207, 8},	//239 Soprano::FilterModel::addStatement(const Soprano::Node&, const Soprano::Node&, const Soprano::Node&)
	{32, 912, 311, 1, 0, 207, 9},	//240 Soprano::FilterModel::removeStatement(const Soprano::Statement&)
	{32, 912, 295, 4, 0, 207, 10},	//241 Soprano::FilterModel::removeStatement(const Soprano::Node&, const Soprano::Node&, const Soprano::Node&, const Soprano::Node&)
	{32, 912, 291, 3, 0, 207, 11},	//242 Soprano::FilterModel::removeStatement(const Soprano::Node&, const Soprano::Node&, const Soprano::Node&)
	{32, 900, 311, 1, 0, 207, 12},	//243 Soprano::FilterModel::removeAllStatements(const Soprano::Statement&)
	{32, 900, 295, 4, 0, 207, 13},	//244 Soprano::FilterModel::removeAllStatements(const Soprano::Node&, const Soprano::Node&, const Soprano::Node&, const Soprano::Node&)
	{32, 900, 291, 3, 0, 207, 14},	//245 Soprano::FilterModel::removeAllStatements(const Soprano::Node&, const Soprano::Node&, const Soprano::Node&)
	{32, 717, 311, 1, Smoke::mf_const, 276, 15},	//246 Soprano::FilterModel::listStatements(const Soprano::Statement&) const
	{32, 717, 295, 4, Smoke::mf_const, 276, 16},	//247 Soprano::FilterModel::listStatements(const Soprano::Node&, const Soprano::Node&, const Soprano::Node&, const Soprano::Node&) const
	{32, 717, 291, 3, Smoke::mf_const, 276, 17},	//248 Soprano::FilterModel::listStatements(const Soprano::Node&, const Soprano::Node&, const Soprano::Node&) const
	{32, 715, 0, 0, Smoke::mf_const, 252, 18},	//249 Soprano::FilterModel::listContexts() const
	{32, 557, 157, 3, Smoke::mf_const, 261, 19},	//250 Soprano::FilterModel::executeQuery(const QString&, Soprano::Query::QueryLanguage, const QString&) const
	{32, 557, 154, 2, Smoke::mf_const, 261, 20},	//251 Soprano::FilterModel::executeQuery(const QString&, Soprano::Query::QueryLanguage) const
	{32, 435, 311, 1, Smoke::mf_const, 289, 21},	//252 Soprano::FilterModel::containsStatement(const Soprano::Statement&) const
	{32, 435, 295, 4, Smoke::mf_const, 289, 22},	//253 Soprano::FilterModel::containsStatement(const Soprano::Node&, const Soprano::Node&, const Soprano::Node&, const Soprano::Node&) const
	{32, 435, 291, 3, Smoke::mf_const, 289, 23},	//254 Soprano::FilterModel::containsStatement(const Soprano::Node&, const Soprano::Node&, const Soprano::Node&) const
	{32, 425, 311, 1, Smoke::mf_const, 289, 24},	//255 Soprano::FilterModel::containsAnyStatement(const Soprano::Statement&) const
	{32, 425, 295, 4, Smoke::mf_const, 289, 25},	//256 Soprano::FilterModel::containsAnyStatement(const Soprano::Node&, const Soprano::Node&, const Soprano::Node&, const Soprano::Node&) const
	{32, 425, 291, 3, Smoke::mf_const, 289, 26},	//257 Soprano::FilterModel::containsAnyStatement(const Soprano::Node&, const Soprano::Node&, const Soprano::Node&) const
	{32, 653, 0, 0, Smoke::mf_const, 289, 27},	//258 Soprano::FilterModel::isEmpty() const
	{32, 1039, 0, 0, Smoke::mf_const, 337, 28},	//259 Soprano::FilterModel::statementCount() const
	{32, 1145, 3, 1, Smoke::mf_const, 207, 29},	//260 Soprano::FilterModel::write(QTextStream&) const
	{32, 455, 0, 0, 0, 248, 30},	//261 Soprano::FilterModel::createBlankNode()
	{32, 1046, 0, 0, Smoke::mf_static, 302, 1},	//262 Soprano::FilterModel::staticMetaObject (static var)
	{32, 104, 0, 0, Smoke::mf_ctor|Smoke::mf_protected, 215, 31},	//263 Soprano::FilterModel::FilterModel()
	{32, 104, 39, 1, Smoke::mf_ctor|Smoke::mf_protected, 215, 32},	//264 Soprano::FilterModel::FilterModel(Soprano::Model*)
	{32, 835, 0, 0, Smoke::mf_protected, 0, 33},	//265 Soprano::FilterModel::parentStatementsAdded()
	{32, 836, 0, 0, Smoke::mf_protected, 0, 34},	//266 Soprano::FilterModel::parentStatementsRemoved()
	{32, 831, 311, 1, Smoke::mf_protected, 0, 35},	//267 Soprano::FilterModel::parentStatementAdded(const Soprano::Statement&)
	{32, 833, 311, 1, Smoke::mf_protected, 0, 36},	//268 Soprano::FilterModel::parentStatementRemoved(const Soprano::Statement&)
	{33, 109, 0, 0, Smoke::mf_ctor, 218, 1},	//269 Soprano::Graph::Graph()
	{33, 109, 261, 1, Smoke::mf_copyctor|Smoke::mf_ctor, 218, 2},	//270 Soprano::Graph::Graph(const Soprano::Graph&)
	{33, 109, 140, 1, Smoke::mf_ctor, 218, 3},	//271 Soprano::Graph::Graph(const QList<Soprano::Statement>&)
	{33, 1170, 0, 0, Smoke::mf_dtor, 0, 47},	//272 Soprano::Graph::~Graph()
	{33, 308, 311, 1, 0, 0, 4},	//273 Soprano::Graph::addStatement(const Soprano::Statement&)
	{33, 308, 295, 4, 0, 0, 5},	//274 Soprano::Graph::addStatement(const Soprano::Node&, const Soprano::Node&, const Soprano::Node&, const Soprano::Node&)
	{33, 308, 291, 3, 0, 0, 6},	//275 Soprano::Graph::addStatement(const Soprano::Node&, const Soprano::Node&, const Soprano::Node&)
	{33, 316, 140, 1, 0, 0, 7},	//276 Soprano::Graph::addStatements(const QList<Soprano::Statement>&)
	{33, 912, 311, 1, 0, 0, 8},	//277 Soprano::Graph::removeStatement(const Soprano::Statement&)
	{33, 912, 295, 4, 0, 0, 9},	//278 Soprano::Graph::removeStatement(const Soprano::Node&, const Soprano::Node&, const Soprano::Node&, const Soprano::Node&)
	{33, 912, 291, 3, 0, 0, 10},	//279 Soprano::Graph::removeStatement(const Soprano::Node&, const Soprano::Node&, const Soprano::Node&)
	{33, 900, 311, 1, 0, 0, 11},	//280 Soprano::Graph::removeAllStatements(const Soprano::Statement&)
	{33, 900, 0, 0, 0, 0, 12},	//281 Soprano::Graph::removeAllStatements()
	{33, 900, 295, 4, 0, 0, 13},	//282 Soprano::Graph::removeAllStatements(const Soprano::Node&, const Soprano::Node&, const Soprano::Node&, const Soprano::Node&)
	{33, 900, 291, 3, 0, 0, 14},	//283 Soprano::Graph::removeAllStatements(const Soprano::Node&, const Soprano::Node&, const Soprano::Node&)
	{33, 920, 140, 1, 0, 0, 15},	//284 Soprano::Graph::removeStatements(const QList<Soprano::Statement>&)
	{33, 908, 286, 1, 0, 0, 16},	//285 Soprano::Graph::removeContext(const Soprano::Node&)
	{33, 717, 311, 1, Smoke::mf_const, 276, 17},	//286 Soprano::Graph::listStatements(const Soprano::Statement&) const
	{33, 717, 0, 0, Smoke::mf_const, 276, 18},	//287 Soprano::Graph::listStatements() const
	{33, 717, 295, 4, Smoke::mf_const, 276, 19},	//288 Soprano::Graph::listStatements(const Soprano::Node&, const Soprano::Node&, const Soprano::Node&, const Soprano::Node&) const
	{33, 717, 291, 3, Smoke::mf_const, 276, 20},	//289 Soprano::Graph::listStatements(const Soprano::Node&, const Soprano::Node&, const Soprano::Node&) const
	{33, 725, 286, 1, Smoke::mf_const, 276, 21},	//290 Soprano::Graph::listStatementsInContext(const Soprano::Node&) const
	{33, 715, 0, 0, Smoke::mf_const, 252, 22},	//291 Soprano::Graph::listContexts() const
	{33, 425, 311, 1, Smoke::mf_const, 289, 23},	//292 Soprano::Graph::containsAnyStatement(const Soprano::Statement&) const
	{33, 425, 295, 4, Smoke::mf_const, 289, 24},	//293 Soprano::Graph::containsAnyStatement(const Soprano::Node&, const Soprano::Node&, const Soprano::Node&, const Soprano::Node&) const
	{33, 425, 291, 3, Smoke::mf_const, 289, 25},	//294 Soprano::Graph::containsAnyStatement(const Soprano::Node&, const Soprano::Node&, const Soprano::Node&) const
	{33, 435, 311, 1, Smoke::mf_const, 289, 26},	//295 Soprano::Graph::containsStatement(const Soprano::Statement&) const
	{33, 435, 295, 4, Smoke::mf_const, 289, 27},	//296 Soprano::Graph::containsStatement(const Soprano::Node&, const Soprano::Node&, const Soprano::Node&, const Soprano::Node&) const
	{33, 435, 291, 3, Smoke::mf_const, 289, 28},	//297 Soprano::Graph::containsStatement(const Soprano::Node&, const Soprano::Node&, const Soprano::Node&) const
	{33, 433, 286, 1, Smoke::mf_const, 289, 29},	//298 Soprano::Graph::containsContext(const Soprano::Node&) const
	{33, 653, 0, 0, Smoke::mf_const, 289, 30},	//299 Soprano::Graph::isEmpty() const
	{33, 1039, 0, 0, Smoke::mf_const, 337, 31},	//300 Soprano::Graph::statementCount() const
	{33, 1086, 0, 0, Smoke::mf_const, 71, 32},	//301 Soprano::Graph::toList() const
	{33, 807, 261, 1, 0, 217, 33},	//302 Soprano::Graph::operator=(const Soprano::Graph&)
	{33, 807, 140, 1, 0, 217, 34},	//303 Soprano::Graph::operator=(const QList<Soprano::Statement>&)
	{33, 793, 261, 1, Smoke::mf_const, 216, 35},	//304 Soprano::Graph::operator+(const Soprano::Graph&) const
	{33, 793, 311, 1, Smoke::mf_const, 216, 36},	//305 Soprano::Graph::operator+(const Soprano::Statement&) const
	{33, 795, 261, 1, 0, 217, 37},	//306 Soprano::Graph::operator+=(const Soprano::Graph&)
	{33, 795, 311, 1, 0, 217, 38},	//307 Soprano::Graph::operator+=(const Soprano::Statement&)
	{33, 797, 261, 1, Smoke::mf_const, 216, 39},	//308 Soprano::Graph::operator-(const Soprano::Graph&) const
	{33, 797, 311, 1, Smoke::mf_const, 216, 40},	//309 Soprano::Graph::operator-(const Soprano::Statement&) const
	{33, 799, 261, 1, 0, 217, 41},	//310 Soprano::Graph::operator-=(const Soprano::Graph&)
	{33, 799, 311, 1, 0, 217, 42},	//311 Soprano::Graph::operator-=(const Soprano::Statement&)
	{33, 803, 261, 1, 0, 217, 43},	//312 Soprano::Graph::operator<<(const Soprano::Graph&)
	{33, 803, 311, 1, 0, 217, 44},	//313 Soprano::Graph::operator<<(const Soprano::Statement&)
	{33, 810, 261, 1, Smoke::mf_const, 289, 45},	//314 Soprano::Graph::operator==(const Soprano::Graph&) const
	{33, 791, 261, 1, Smoke::mf_const, 289, 46},	//315 Soprano::Graph::operator!=(const Soprano::Graph&) const
	{35, 44, 338, 1, Smoke::mf_ctor, 219, 1},	//316 Soprano::Index::CLuceneIndex::CLuceneIndex(lucene::analysis::Analyzer*)
	{35, 44, 0, 0, Smoke::mf_ctor, 219, 2},	//317 Soprano::Index::CLuceneIndex::CLuceneIndex()
	{35, 1160, 0, 0, Smoke::mf_dtor, 0, 20},	//318 Soprano::Index::CLuceneIndex::~CLuceneIndex()
	{35, 786, 161, 2, 0, 289, 3},	//319 Soprano::Index::CLuceneIndex::open(const QString&, bool)
	{35, 786, 146, 1, 0, 289, 4},	//320 Soprano::Index::CLuceneIndex::open(const QString&)
	{35, 397, 0, 0, 0, 0, 5},	//321 Soprano::Index::CLuceneIndex::close()
	{35, 662, 0, 0, Smoke::mf_const, 289, 6},	//322 Soprano::Index::CLuceneIndex::isOpen() const
	{35, 1006, 338, 1, 0, 0, 7},	//323 Soprano::Index::CLuceneIndex::setQueryAnalyzer(lucene::analysis::Analyzer*)
	{35, 872, 0, 0, Smoke::mf_const, 338, 8},	//324 Soprano::Index::CLuceneIndex::queryAnalyzer() const
	{35, 928, 0, 0, Smoke::mf_const, 337, 9},	//325 Soprano::Index::CLuceneIndex::resourceCount() const
	{35, 1036, 0, 0, 0, 337, 10},	//326 Soprano::Index::CLuceneIndex::startTransaction()
	{35, 398, 321, 1, 0, 289, 11},	//327 Soprano::Index::CLuceneIndex::closeTransaction(int)
	{35, 308, 311, 1, 0, 207, 12},	//328 Soprano::Index::CLuceneIndex::addStatement(const Soprano::Statement&)
	{35, 912, 311, 1, 0, 207, 13},	//329 Soprano::Index::CLuceneIndex::removeStatement(const Soprano::Statement&)
	{35, 534, 286, 1, 0, 339, 14},	//330 Soprano::Index::CLuceneIndex::documentForResource(const Soprano::Node&)
	{35, 538, 3, 1, Smoke::mf_const, 0, 15},	//331 Soprano::Index::CLuceneIndex::dump(QTextStream&) const
	{35, 394, 0, 0, 0, 0, 16},	//332 Soprano::Index::CLuceneIndex::clear()
	{35, 819, 0, 0, 0, 0, 17},	//333 Soprano::Index::CLuceneIndex::optimize()
	{35, 592, 340, 1, Smoke::mf_static, 248, 18},	//334 Soprano::Index::CLuceneIndex::getResource(lucene::document::Document*)
	{35, 491, 0, 0, Smoke::mf_static, 106, 19},	//335 Soprano::Index::CLuceneIndex::defaultSearchField()
	{36, 117, 151, 2, Smoke::mf_ctor, 220, 1},	//336 Soprano::Index::IndexFilterModel::IndexFilterModel(const QString&, Soprano::Model*)
	{36, 117, 146, 1, Smoke::mf_ctor, 220, 2},	//337 Soprano::Index::IndexFilterModel::IndexFilterModel(const QString&)
	{36, 117, 34, 2, Smoke::mf_ctor, 220, 3},	//338 Soprano::Index::IndexFilterModel::IndexFilterModel(Soprano::Index::CLuceneIndex*, Soprano::Model*)
	{36, 117, 32, 1, Smoke::mf_ctor, 220, 4},	//339 Soprano::Index::IndexFilterModel::IndexFilterModel(Soprano::Index::CLuceneIndex*)
	{36, 1171, 0, 0, Smoke::mf_dtor, 0, 23},	//340 Soprano::Index::IndexFilterModel::~IndexFilterModel()
	{36, 622, 0, 0, Smoke::mf_const, 219, 5},	//341 Soprano::Index::IndexFilterModel::index() const
	{36, 308, 311, 1, 0, 207, 6},	//342 Soprano::Index::IndexFilterModel::addStatement(const Soprano::Statement&)
	{36, 912, 311, 1, 0, 207, 7},	//343 Soprano::Index::IndexFilterModel::removeStatement(const Soprano::Statement&)
	{36, 900, 311, 1, 0, 207, 8},	//344 Soprano::Index::IndexFilterModel::removeAllStatements(const Soprano::Statement&)
	{36, 557, 157, 3, Smoke::mf_const, 261, 9},	//345 Soprano::Index::IndexFilterModel::executeQuery(const QString&, Soprano::Query::QueryLanguage, const QString&) const
	{36, 557, 154, 2, Smoke::mf_const, 261, 10},	//346 Soprano::Index::IndexFilterModel::executeQuery(const QString&, Soprano::Query::QueryLanguage) const
	{36, 1013, 321, 1, 0, 0, 11},	//347 Soprano::Index::IndexFilterModel::setTransactionCacheSize(int)
	{36, 1100, 0, 0, Smoke::mf_const, 337, 12},	//348 Soprano::Index::IndexFilterModel::transactionCacheSize() const
	{36, 885, 0, 0, 0, 0, 13},	//349 Soprano::Index::IndexFilterModel::rebuildIndex()
	{36, 820, 0, 0, 0, 0, 14},	//350 Soprano::Index::IndexFilterModel::optimizeIndex()
	{36, 300, 238, 1, 0, 0, 15},	//351 Soprano::Index::IndexFilterModel::addIndexOnlyPredicate(const QUrl&)
	{36, 987, 101, 1, 0, 0, 16},	//352 Soprano::Index::IndexFilterModel::setIndexOnlyPredicates(const QList<QUrl>&)
	{36, 623, 0, 0, Smoke::mf_const, 65, 17},	//353 Soprano::Index::IndexFilterModel::indexOnlyPredicates() const
	{36, 298, 238, 1, 0, 0, 18},	//354 Soprano::Index::IndexFilterModel::addForceIndexPredicate(const QUrl&)
	{36, 982, 101, 1, 0, 0, 19},	//355 Soprano::Index::IndexFilterModel::setForceIndexPredicates(const QList<QUrl>&)
	{36, 580, 0, 0, Smoke::mf_const, 65, 20},	//356 Soprano::Index::IndexFilterModel::forceIndexPredicates() const
	{36, 542, 146, 1, Smoke::mf_static, 106, 21},	//357 Soprano::Index::IndexFilterModel::encodeStringForLuceneQuery(const QString&)
	{36, 544, 238, 1, Smoke::mf_static, 106, 22},	//358 Soprano::Index::IndexFilterModel::encodeUriForLuceneQuery(const QUrl&)
	{37, 204, 0, 0, Smoke::mf_ctor, 222, 1},	//359 Soprano::Index::QueryHit::QueryHit()
	{37, 204, 263, 1, Smoke::mf_copyctor|Smoke::mf_ctor, 222, 2},	//360 Soprano::Index::QueryHit::QueryHit(const Soprano::Index::QueryHit&)
	{37, 204, 300, 2, Smoke::mf_ctor, 222, 3},	//361 Soprano::Index::QueryHit::QueryHit(const Soprano::Node&, double)
	{37, 1186, 0, 0, Smoke::mf_dtor, 0, 7},	//362 Soprano::Index::QueryHit::~QueryHit()
	{37, 807, 263, 1, 0, 221, 4},	//363 Soprano::Index::QueryHit::operator=(const Soprano::Index::QueryHit&)
	{37, 945, 0, 0, Smoke::mf_const, 336, 5},	//364 Soprano::Index::QueryHit::score() const
	{37, 927, 0, 0, Smoke::mf_const, 248, 6},	//365 Soprano::Index::QueryHit::resource() const
	{38, 215, 0, 0, Smoke::mf_static|Smoke::mf_enum, 234, 1},	//366 Soprano::Inference::RDFS (enum)
	{38, 164, 0, 0, Smoke::mf_static|Smoke::mf_enum, 234, 2},	//367 Soprano::Inference::NRL (enum)
	{39, 760, 0, 0, Smoke::mf_const, 303, 2},	//368 Soprano::Inference::InferenceModel::metaObject() const
	{39, 870, 362, 3, 0, 337, 3},	//369 Soprano::Inference::InferenceModel::qt_metacall(QMetaObject::Call, int, void**)
	{39, 124, 39, 1, Smoke::mf_ctor, 223, 4},	//370 Soprano::Inference::InferenceModel::InferenceModel(Soprano::Model*)
	{39, 1172, 0, 0, Smoke::mf_dtor, 0, 14},	//371 Soprano::Inference::InferenceModel::~InferenceModel()
	{39, 308, 311, 1, 0, 207, 5},	//372 Soprano::Inference::InferenceModel::addStatement(const Soprano::Statement&)
	{39, 912, 311, 1, 0, 207, 6},	//373 Soprano::Inference::InferenceModel::removeStatement(const Soprano::Statement&)
	{39, 900, 311, 1, 0, 207, 7},	//374 Soprano::Inference::InferenceModel::removeAllStatements(const Soprano::Statement&)
	{39, 306, 271, 1, 0, 0, 8},	//375 Soprano::Inference::InferenceModel::addRule(const Soprano::Inference::Rule&)
	{39, 1009, 112, 1, 0, 0, 9},	//376 Soprano::Inference::InferenceModel::setRules(const QList<Soprano::Inference::Rule>&)
	{39, 849, 0, 0, 0, 0, 10},	//377 Soprano::Inference::InferenceModel::performInference()
	{39, 395, 0, 0, 0, 0, 11},	//378 Soprano::Inference::InferenceModel::clearInference()
	{39, 971, 86, 1, 0, 0, 12},	//379 Soprano::Inference::InferenceModel::setCompressedSourceStatements(bool)
	{39, 995, 86, 1, 0, 0, 13},	//380 Soprano::Inference::InferenceModel::setOptimizedQueriesEnabled(bool)
	{39, 1046, 0, 0, Smoke::mf_static, 302, 1},	//381 Soprano::Inference::InferenceModel::staticMetaObject (static var)
	{40, 172, 0, 0, Smoke::mf_ctor, 226, 1},	//382 Soprano::Inference::NodePattern::NodePattern()
	{40, 172, 286, 1, Smoke::mf_ctor, 226, 2},	//383 Soprano::Inference::NodePattern::NodePattern(const Soprano::Node&)
	{40, 172, 146, 1, Smoke::mf_ctor, 226, 3},	//384 Soprano::Inference::NodePattern::NodePattern(const QString&)
	{40, 172, 265, 1, Smoke::mf_copyctor|Smoke::mf_ctor, 226, 4},	//385 Soprano::Inference::NodePattern::NodePattern(const Soprano::Inference::NodePattern&)
	{40, 1181, 0, 0, Smoke::mf_dtor, 0, 12},	//386 Soprano::Inference::NodePattern::~NodePattern()
	{40, 807, 265, 1, 0, 225, 5},	//387 Soprano::Inference::NodePattern::operator=(const Soprano::Inference::NodePattern&)
	{40, 688, 0, 0, Smoke::mf_const, 289, 6},	//388 Soprano::Inference::NodePattern::isVariable() const
	{40, 927, 0, 0, Smoke::mf_const, 248, 7},	//389 Soprano::Inference::NodePattern::resource() const
	{40, 1126, 0, 0, Smoke::mf_const, 106, 8},	//390 Soprano::Inference::NodePattern::variableName() const
	{40, 746, 286, 1, Smoke::mf_const, 289, 9},	//391 Soprano::Inference::NodePattern::match(const Soprano::Node&) const
	{40, 473, 246, 1, Smoke::mf_const, 106, 10},	//392 Soprano::Inference::NodePattern::createSparqlNodePattern(const Soprano::BindingSet&) const
	{40, 687, 0, 0, Smoke::mf_const, 289, 11},	//393 Soprano::Inference::NodePattern::isValid() const
	{41, 233, 0, 0, Smoke::mf_ctor, 229, 1},	//394 Soprano::Inference::Rule::Rule()
	{41, 233, 271, 1, Smoke::mf_copyctor|Smoke::mf_ctor, 229, 2},	//395 Soprano::Inference::Rule::Rule(const Soprano::Inference::Rule&)
	{41, 1190, 0, 0, Smoke::mf_dtor, 0, 16},	//396 Soprano::Inference::Rule::~Rule()
	{41, 807, 271, 1, 0, 228, 3},	//397 Soprano::Inference::Rule::operator=(const Soprano::Inference::Rule&)
	{41, 860, 0, 0, Smoke::mf_const, 69, 4},	//398 Soprano::Inference::Rule::preconditions() const
	{41, 302, 277, 1, 0, 0, 5},	//399 Soprano::Inference::Rule::addPrecondition(const Soprano::Inference::StatementPattern&)
	{41, 540, 0, 0, Smoke::mf_const, 235, 6},	//400 Soprano::Inference::Rule::effect() const
	{41, 978, 277, 1, 0, 0, 7},	//401 Soprano::Inference::Rule::setEffect(const Soprano::Inference::StatementPattern&)
	{41, 746, 311, 1, Smoke::mf_const, 289, 8},	//402 Soprano::Inference::Rule::match(const Soprano::Statement&) const
	{41, 365, 311, 1, 0, 0, 9},	//403 Soprano::Inference::Rule::bindToStatement(const Soprano::Statement&)
	{41, 377, 0, 0, Smoke::mf_const, 273, 10},	//404 Soprano::Inference::Rule::boundToStatement() const
	{41, 475, 86, 1, Smoke::mf_const, 106, 11},	//405 Soprano::Inference::Rule::createSparqlQuery(bool) const
	{41, 475, 0, 0, Smoke::mf_const, 106, 12},	//406 Soprano::Inference::Rule::createSparqlQuery() const
	{41, 361, 246, 1, Smoke::mf_const, 273, 13},	//407 Soprano::Inference::Rule::bindEffect(const Soprano::BindingSet&) const
	{41, 363, 246, 1, Smoke::mf_const, 71, 14},	//408 Soprano::Inference::Rule::bindPreconditions(const Soprano::BindingSet&) const
	{41, 687, 0, 0, Smoke::mf_const, 289, 15},	//409 Soprano::Inference::Rule::isValid() const
	{42, 235, 0, 0, Smoke::mf_ctor, 230, 1},	//410 Soprano::Inference::RuleParser::RuleParser()
	{42, 1191, 0, 0, Smoke::mf_dtor, 0, 9},	//411 Soprano::Inference::RuleParser::~RuleParser()
	{42, 837, 146, 1, 0, 289, 2},	//412 Soprano::Inference::RuleParser::parseFile(const QString&)
	{42, 841, 146, 1, 0, 227, 3},	//413 Soprano::Inference::RuleParser::parseRule(const QString&)
	{42, 940, 0, 0, Smoke::mf_const, 231, 4},	//414 Soprano::Inference::RuleParser::rules() const
	{42, 304, 189, 2, 0, 0, 5},	//415 Soprano::Inference::RuleParser::addPrefix(const QString&, const QUrl&)
	{42, 865, 0, 0, Smoke::mf_const, 56, 6},	//416 Soprano::Inference::RuleParser::prefixes() const
	{42, 394, 0, 0, 0, 0, 7},	//417 Soprano::Inference::RuleParser::clear()
	{42, 235, 273, 1, Smoke::mf_copyctor|Smoke::mf_internal|Smoke::mf_ctor, 230, 8},	//418 Soprano::Inference::RuleParser::RuleParser(const Soprano::Inference::RuleParser&)
	{43, 237, 0, 0, Smoke::mf_ctor, 233, 1},	//419 Soprano::Inference::RuleSet::RuleSet()
	{43, 237, 275, 1, Smoke::mf_copyctor|Smoke::mf_ctor, 233, 2},	//420 Soprano::Inference::RuleSet::RuleSet(const Soprano::Inference::RuleSet&)
	{43, 1192, 0, 0, Smoke::mf_dtor, 0, 14},	//421 Soprano::Inference::RuleSet::~RuleSet()
	{43, 807, 275, 1, 0, 232, 3},	//422 Soprano::Inference::RuleSet::operator=(const Soprano::Inference::RuleSet&)
	{43, 394, 0, 0, 0, 0, 4},	//423 Soprano::Inference::RuleSet::clear()
	{43, 624, 204, 2, 0, 0, 5},	//424 Soprano::Inference::RuleSet::insert(const QString&, const Soprano::Inference::Rule&)
	{43, 454, 0, 0, Smoke::mf_const, 337, 6},	//425 Soprano::Inference::RuleSet::count() const
	{43, 342, 321, 1, Smoke::mf_const, 227, 7},	//426 Soprano::Inference::RuleSet::at(int) const
	{43, 817, 321, 1, Smoke::mf_const, 227, 8},	//427 Soprano::Inference::RuleSet::operator[](int) const
	{43, 936, 146, 1, Smoke::mf_const, 227, 9},	//428 Soprano::Inference::RuleSet::rule(const QString&) const
	{43, 817, 146, 1, Smoke::mf_const, 227, 10},	//429 Soprano::Inference::RuleSet::operator[](const QString&) const
	{43, 939, 0, 0, Smoke::mf_const, 110, 11},	//430 Soprano::Inference::RuleSet::ruleNames() const
	{43, 330, 0, 0, Smoke::mf_const, 68, 12},	//431 Soprano::Inference::RuleSet::allRules() const
	{43, 1032, 37, 1, Smoke::mf_static, 231, 13},	//432 Soprano::Inference::RuleSet::standardRuleSet(Soprano::Inference::StandardRuleSet)
	{44, 276, 0, 0, Smoke::mf_ctor, 236, 1},	//433 Soprano::Inference::StatementPattern::StatementPattern()
	{44, 276, 267, 3, Smoke::mf_ctor, 236, 2},	//434 Soprano::Inference::StatementPattern::StatementPattern(const Soprano::Inference::NodePattern&, const Soprano::Inference::NodePattern&, const Soprano::Inference::NodePattern&)
	{44, 276, 277, 1, Smoke::mf_copyctor|Smoke::mf_ctor, 236, 3},	//435 Soprano::Inference::StatementPattern::StatementPattern(const Soprano::Inference::StatementPattern&)
	{44, 1200, 0, 0, Smoke::mf_dtor, 0, 11},	//436 Soprano::Inference::StatementPattern::~StatementPattern()
	{44, 807, 277, 1, 0, 235, 4},	//437 Soprano::Inference::StatementPattern::operator=(const Soprano::Inference::StatementPattern&)
	{44, 1059, 0, 0, Smoke::mf_const, 224, 5},	//438 Soprano::Inference::StatementPattern::subjectPattern() const
	{44, 862, 0, 0, Smoke::mf_const, 224, 6},	//439 Soprano::Inference::StatementPattern::predicatePattern() const
	{44, 782, 0, 0, Smoke::mf_const, 224, 7},	//440 Soprano::Inference::StatementPattern::objectPattern() const
	{44, 746, 311, 1, Smoke::mf_const, 289, 8},	//441 Soprano::Inference::StatementPattern::match(const Soprano::Statement&) const
	{44, 471, 246, 1, Smoke::mf_const, 106, 9},	//442 Soprano::Inference::StatementPattern::createSparqlGraphPattern(const Soprano::BindingSet&) const
	{44, 687, 0, 0, Smoke::mf_const, 289, 10},	//443 Soprano::Inference::StatementPattern::isValid() const
	{45, 152, 0, 0, Smoke::mf_static|Smoke::mf_enum, 243, 1},	//444 Soprano::LanguageTag::MatchFilterBasic (enum)
	{45, 153, 0, 0, Smoke::mf_static|Smoke::mf_enum, 243, 2},	//445 Soprano::LanguageTag::MatchFilterExtended (enum)
	{45, 149, 0, 0, Smoke::mf_static|Smoke::mf_enum, 240, 3},	//446 Soprano::LanguageTag::LookupFlagNone (enum)
	{45, 148, 0, 0, Smoke::mf_static|Smoke::mf_enum, 240, 4},	//447 Soprano::LanguageTag::LookupFlagNoFallback (enum)
	{45, 129, 0, 0, Smoke::mf_ctor, 239, 5},	//448 Soprano::LanguageTag::LanguageTag()
	{45, 129, 279, 1, Smoke::mf_copyctor|Smoke::mf_ctor, 239, 6},	//449 Soprano::LanguageTag::LanguageTag(const Soprano::LanguageTag&)
	{45, 129, 317, 1, Smoke::mf_ctor, 239, 7},	//450 Soprano::LanguageTag::LanguageTag(const char*)
	{45, 129, 99, 1, Smoke::mf_ctor, 239, 8},	//451 Soprano::LanguageTag::LanguageTag(const QLatin1String&)
	{45, 129, 146, 1, Smoke::mf_ctor, 239, 9},	//452 Soprano::LanguageTag::LanguageTag(const QString&)
	{45, 129, 142, 1, Smoke::mf_ctor, 239, 10},	//453 Soprano::LanguageTag::LanguageTag(const QLocale&)
	{45, 129, 359, 2, Smoke::mf_ctor, 239, 11},	//454 Soprano::LanguageTag::LanguageTag(QLocale::Language, QLocale::Country)
	{45, 129, 357, 1, Smoke::mf_ctor, 239, 12},	//455 Soprano::LanguageTag::LanguageTag(QLocale::Language)
	{45, 1173, 0, 0, Smoke::mf_dtor, 0, 35},	//456 Soprano::LanguageTag::~LanguageTag()
	{45, 807, 279, 1, 0, 238, 13},	//457 Soprano::LanguageTag::operator=(const Soprano::LanguageTag&)
	{45, 810, 279, 1, Smoke::mf_const, 289, 14},	//458 Soprano::LanguageTag::operator==(const Soprano::LanguageTag&) const
	{45, 791, 279, 1, Smoke::mf_const, 289, 15},	//459 Soprano::LanguageTag::operator!=(const Soprano::LanguageTag&) const
	{45, 801, 279, 1, Smoke::mf_const, 289, 16},	//460 Soprano::LanguageTag::operator<(const Soprano::LanguageTag&) const
	{45, 805, 279, 1, Smoke::mf_const, 289, 17},	//461 Soprano::LanguageTag::operator<=(const Soprano::LanguageTag&) const
	{45, 813, 279, 1, Smoke::mf_const, 289, 18},	//462 Soprano::LanguageTag::operator>(const Soprano::LanguageTag&) const
	{45, 815, 279, 1, Smoke::mf_const, 289, 19},	//463 Soprano::LanguageTag::operator>=(const Soprano::LanguageTag&) const
	{45, 748, 281, 2, Smoke::mf_const, 289, 20},	//464 Soprano::LanguageTag::matches(const Soprano::LanguageTag&, Soprano::LanguageTag::MatchFilter) const
	{45, 748, 279, 1, Smoke::mf_const, 289, 21},	//465 Soprano::LanguageTag::matches(const Soprano::LanguageTag&) const
	{45, 653, 0, 0, Smoke::mf_const, 289, 22},	//466 Soprano::LanguageTag::isEmpty() const
	{45, 687, 0, 0, Smoke::mf_const, 289, 23},	//467 Soprano::LanguageTag::isValid() const
	{45, 1057, 0, 0, Smoke::mf_const, 110, 24},	//468 Soprano::LanguageTag::subTags() const
	{45, 1091, 0, 0, Smoke::mf_const, 106, 25},	//469 Soprano::LanguageTag::toString() const
	{45, 1090, 0, 0, Smoke::mf_const, 106, 26},	//470 Soprano::LanguageTag::toPrettyString() const
	{45, 1087, 0, 0, Smoke::mf_const, 75, 27},	//471 Soprano::LanguageTag::toLocale() const
	{45, 789, 0, 0, Smoke::mf_const, 106, 28},	//472 Soprano::LanguageTag::operator QString() const
	{45, 734, 121, 4, Smoke::mf_static, 337, 29},	//473 Soprano::LanguageTag::lookup(const QList<Soprano::LanguageTag>&, const QList<Soprano::LanguageTag>&, Soprano::LanguageTag::LookupFlags, Soprano::LanguageTag::MatchFilter)
	{45, 734, 117, 3, Smoke::mf_static, 337, 30},	//474 Soprano::LanguageTag::lookup(const QList<Soprano::LanguageTag>&, const QList<Soprano::LanguageTag>&, Soprano::LanguageTag::LookupFlags)
	{45, 734, 114, 2, Smoke::mf_static, 337, 31},	//475 Soprano::LanguageTag::lookup(const QList<Soprano::LanguageTag>&, const QList<Soprano::LanguageTag>&)
	{45, 734, 133, 4, Smoke::mf_static, 337, 32},	//476 Soprano::LanguageTag::lookup(const QList<Soprano::LanguageTag>&, const Soprano::LanguageTag&, Soprano::LanguageTag::LookupFlags, Soprano::LanguageTag::MatchFilter)
	{45, 734, 129, 3, Smoke::mf_static, 337, 33},	//477 Soprano::LanguageTag::lookup(const QList<Soprano::LanguageTag>&, const Soprano::LanguageTag&, Soprano::LanguageTag::LookupFlags)
	{45, 734, 126, 2, Smoke::mf_static, 337, 34},	//478 Soprano::LanguageTag::lookup(const QList<Soprano::LanguageTag>&, const Soprano::LanguageTag&)
	{46, 137, 0, 0, Smoke::mf_ctor, 246, 1},	//479 Soprano::LiteralValue::LiteralValue()
	{46, 1174, 0, 0, Smoke::mf_dtor, 0, 66},	//480 Soprano::LiteralValue::~LiteralValue()
	{46, 137, 284, 1, Smoke::mf_copyctor|Smoke::mf_ctor, 246, 2},	//481 Soprano::LiteralValue::LiteralValue(const Soprano::LiteralValue&)
	{46, 137, 240, 1, Smoke::mf_ctor, 246, 3},	//482 Soprano::LiteralValue::LiteralValue(const QVariant&)
	{46, 137, 321, 1, Smoke::mf_ctor, 246, 4},	//483 Soprano::LiteralValue::LiteralValue(int)
	{46, 137, 342, 1, Smoke::mf_ctor, 246, 5},	//484 Soprano::LiteralValue::LiteralValue(qlonglong)
	{46, 137, 346, 1, Smoke::mf_ctor, 246, 6},	//485 Soprano::LiteralValue::LiteralValue(uint)
	{46, 137, 344, 1, Smoke::mf_ctor, 246, 7},	//486 Soprano::LiteralValue::LiteralValue(qulonglong)
	{46, 137, 86, 1, Smoke::mf_ctor, 246, 8},	//487 Soprano::LiteralValue::LiteralValue(bool)
	{46, 137, 319, 1, Smoke::mf_ctor, 246, 9},	//488 Soprano::LiteralValue::LiteralValue(double)
	{46, 137, 317, 1, Smoke::mf_ctor, 246, 10},	//489 Soprano::LiteralValue::LiteralValue(const char*)
	{46, 137, 99, 1, Smoke::mf_ctor, 246, 11},	//490 Soprano::LiteralValue::LiteralValue(const QLatin1String&)
	{46, 137, 146, 1, Smoke::mf_ctor, 246, 12},	//491 Soprano::LiteralValue::LiteralValue(const QString&)
	{46, 137, 90, 1, Smoke::mf_ctor, 246, 13},	//492 Soprano::LiteralValue::LiteralValue(const QDate&)
	{46, 137, 236, 1, Smoke::mf_ctor, 246, 14},	//493 Soprano::LiteralValue::LiteralValue(const QTime&)
	{46, 137, 92, 1, Smoke::mf_ctor, 246, 15},	//494 Soprano::LiteralValue::LiteralValue(const QDateTime&)
	{46, 137, 88, 1, Smoke::mf_ctor, 246, 16},	//495 Soprano::LiteralValue::LiteralValue(const QByteArray&)
	{46, 807, 284, 1, 0, 245, 17},	//496 Soprano::LiteralValue::operator=(const Soprano::LiteralValue&)
	{46, 807, 321, 1, 0, 245, 18},	//497 Soprano::LiteralValue::operator=(int)
	{46, 807, 342, 1, 0, 245, 19},	//498 Soprano::LiteralValue::operator=(qlonglong)
	{46, 807, 346, 1, 0, 245, 20},	//499 Soprano::LiteralValue::operator=(uint)
	{46, 807, 344, 1, 0, 245, 21},	//500 Soprano::LiteralValue::operator=(qulonglong)
	{46, 807, 86, 1, 0, 245, 22},	//501 Soprano::LiteralValue::operator=(bool)
	{46, 807, 319, 1, 0, 245, 23},	//502 Soprano::LiteralValue::operator=(double)
	{46, 807, 146, 1, 0, 245, 24},	//503 Soprano::LiteralValue::operator=(const QString&)
	{46, 807, 99, 1, 0, 245, 25},	//504 Soprano::LiteralValue::operator=(const QLatin1String&)
	{46, 807, 90, 1, 0, 245, 26},	//505 Soprano::LiteralValue::operator=(const QDate&)
	{46, 807, 236, 1, 0, 245, 27},	//506 Soprano::LiteralValue::operator=(const QTime&)
	{46, 807, 92, 1, 0, 245, 28},	//507 Soprano::LiteralValue::operator=(const QDateTime&)
	{46, 807, 88, 1, 0, 245, 29},	//508 Soprano::LiteralValue::operator=(const QByteArray&)
	{46, 810, 284, 1, Smoke::mf_const, 289, 30},	//509 Soprano::LiteralValue::operator==(const Soprano::LiteralValue&) const
	{46, 791, 284, 1, Smoke::mf_const, 289, 31},	//510 Soprano::LiteralValue::operator!=(const Soprano::LiteralValue&) const
	{46, 687, 0, 0, Smoke::mf_const, 289, 32},	//511 Soprano::LiteralValue::isValid() const
	{46, 667, 0, 0, Smoke::mf_const, 289, 33},	//512 Soprano::LiteralValue::isPlain() const
	{46, 659, 0, 0, Smoke::mf_const, 289, 34},	//513 Soprano::LiteralValue::isInt() const
	{46, 660, 0, 0, Smoke::mf_const, 289, 35},	//514 Soprano::LiteralValue::isInt64() const
	{46, 685, 0, 0, Smoke::mf_const, 289, 36},	//515 Soprano::LiteralValue::isUnsignedInt() const
	{46, 686, 0, 0, Smoke::mf_const, 289, 37},	//516 Soprano::LiteralValue::isUnsignedInt64() const
	{46, 637, 0, 0, Smoke::mf_const, 289, 38},	//517 Soprano::LiteralValue::isBool() const
	{46, 652, 0, 0, Smoke::mf_const, 289, 39},	//518 Soprano::LiteralValue::isDouble() const
	{46, 675, 0, 0, Smoke::mf_const, 289, 40},	//519 Soprano::LiteralValue::isString() const
	{46, 643, 0, 0, Smoke::mf_const, 289, 41},	//520 Soprano::LiteralValue::isDate() const
	{46, 681, 0, 0, Smoke::mf_const, 289, 42},	//521 Soprano::LiteralValue::isTime() const
	{46, 644, 0, 0, Smoke::mf_const, 289, 43},	//522 Soprano::LiteralValue::isDateTime() const
	{46, 638, 0, 0, Smoke::mf_const, 289, 44},	//523 Soprano::LiteralValue::isByteArray() const
	{46, 1084, 0, 0, Smoke::mf_const, 337, 45},	//524 Soprano::LiteralValue::toInt() const
	{46, 1085, 0, 0, Smoke::mf_const, 340, 46},	//525 Soprano::LiteralValue::toInt64() const
	{46, 1093, 0, 0, Smoke::mf_const, 342, 47},	//526 Soprano::LiteralValue::toUnsignedInt() const
	{46, 1094, 0, 0, Smoke::mf_const, 341, 48},	//527 Soprano::LiteralValue::toUnsignedInt64() const
	{46, 1079, 0, 0, Smoke::mf_const, 289, 49},	//528 Soprano::LiteralValue::toBool() const
	{46, 1083, 0, 0, Smoke::mf_const, 336, 50},	//529 Soprano::LiteralValue::toDouble() const
	{46, 1091, 0, 0, Smoke::mf_const, 106, 51},	//530 Soprano::LiteralValue::toString() const
	{46, 1081, 0, 0, Smoke::mf_const, 19, 52},	//531 Soprano::LiteralValue::toDate() const
	{46, 1092, 0, 0, Smoke::mf_const, 144, 53},	//532 Soprano::LiteralValue::toTime() const
	{46, 1082, 0, 0, Smoke::mf_const, 20, 54},	//533 Soprano::LiteralValue::toDateTime() const
	{46, 1080, 0, 0, Smoke::mf_const, 13, 55},	//534 Soprano::LiteralValue::toByteArray() const
	{46, 484, 0, 0, Smoke::mf_const, 150, 56},	//535 Soprano::LiteralValue::dataTypeUri() const
	{46, 705, 0, 0, Smoke::mf_const, 237, 57},	//536 Soprano::LiteralValue::language() const
	{46, 1101, 0, 0, Smoke::mf_const, 154, 58},	//537 Soprano::LiteralValue::type() const
	{46, 1127, 0, 0, Smoke::mf_const, 153, 59},	//538 Soprano::LiteralValue::variant() const
	{46, 585, 148, 2, Smoke::mf_static, 244, 60},	//539 Soprano::LiteralValue::fromString(const QString&, QVariant::Type)
	{46, 585, 189, 2, Smoke::mf_static, 244, 61},	//540 Soprano::LiteralValue::fromString(const QString&, const QUrl&)
	{46, 465, 207, 2, Smoke::mf_static, 244, 62},	//541 Soprano::LiteralValue::createPlainLiteral(const QString&, const Soprano::LanguageTag&)
	{46, 465, 146, 1, Smoke::mf_static, 244, 63},	//542 Soprano::LiteralValue::createPlainLiteral(const QString&)
	{46, 1103, 238, 1, Smoke::mf_static, 154, 64},	//543 Soprano::LiteralValue::typeFromDataTypeUri(const QUrl&)
	{46, 485, 16, 1, Smoke::mf_static, 150, 65},	//544 Soprano::LiteralValue::dataTypeUriFromType(QVariant::Type)
	{47, 760, 0, 0, Smoke::mf_const, 303, 2},	//545 Soprano::Model::metaObject() const
	{47, 870, 362, 3, 0, 337, 3},	//546 Soprano::Model::qt_metacall(QMetaObject::Call, int, void**)
	{47, 1177, 0, 0, Smoke::mf_dtor, 0, 40},	//547 Soprano::Model::~Model()
	{47, 308, 311, 1, 0, 207, 4},	//548 Soprano::Model::addStatement(const Soprano::Statement&) [pure virtual]
	{47, 308, 295, 4, 0, 207, 5},	//549 Soprano::Model::addStatement(const Soprano::Node&, const Soprano::Node&, const Soprano::Node&, const Soprano::Node&)
	{47, 308, 291, 3, 0, 207, 6},	//550 Soprano::Model::addStatement(const Soprano::Node&, const Soprano::Node&, const Soprano::Node&)
	{47, 316, 140, 1, 0, 207, 7},	//551 Soprano::Model::addStatements(const QList<Soprano::Statement>&)
	{47, 912, 311, 1, 0, 207, 8},	//552 Soprano::Model::removeStatement(const Soprano::Statement&) [pure virtual]
	{47, 912, 295, 4, 0, 207, 9},	//553 Soprano::Model::removeStatement(const Soprano::Node&, const Soprano::Node&, const Soprano::Node&, const Soprano::Node&)
	{47, 912, 291, 3, 0, 207, 10},	//554 Soprano::Model::removeStatement(const Soprano::Node&, const Soprano::Node&, const Soprano::Node&)
	{47, 900, 311, 1, 0, 207, 11},	//555 Soprano::Model::removeAllStatements(const Soprano::Statement&) [pure virtual]
	{47, 900, 295, 4, 0, 207, 12},	//556 Soprano::Model::removeAllStatements(const Soprano::Node&, const Soprano::Node&, const Soprano::Node&, const Soprano::Node&)
	{47, 900, 291, 3, 0, 207, 13},	//557 Soprano::Model::removeAllStatements(const Soprano::Node&, const Soprano::Node&, const Soprano::Node&)
	{47, 920, 140, 1, 0, 207, 14},	//558 Soprano::Model::removeStatements(const QList<Soprano::Statement>&)
	{47, 908, 286, 1, 0, 207, 15},	//559 Soprano::Model::removeContext(const Soprano::Node&)
	{47, 900, 0, 0, 0, 207, 16},	//560 Soprano::Model::removeAllStatements()
	{47, 717, 311, 1, Smoke::mf_const, 276, 17},	//561 Soprano::Model::listStatements(const Soprano::Statement&) const [pure virtual]
	{47, 717, 295, 4, Smoke::mf_const, 276, 18},	//562 Soprano::Model::listStatements(const Soprano::Node&, const Soprano::Node&, const Soprano::Node&, const Soprano::Node&) const
	{47, 717, 291, 3, Smoke::mf_const, 276, 19},	//563 Soprano::Model::listStatements(const Soprano::Node&, const Soprano::Node&, const Soprano::Node&) const
	{47, 717, 0, 0, Smoke::mf_const, 276, 20},	//564 Soprano::Model::listStatements() const
	{47, 725, 286, 1, Smoke::mf_const, 276, 21},	//565 Soprano::Model::listStatementsInContext(const Soprano::Node&) const
	{47, 715, 0, 0, Smoke::mf_const, 252, 22},	//566 Soprano::Model::listContexts() const [pure virtual]
	{47, 557, 157, 3, Smoke::mf_const, 261, 23},	//567 Soprano::Model::executeQuery(const QString&, Soprano::Query::QueryLanguage, const QString&) const [pure virtual]
	{47, 557, 154, 2, Smoke::mf_const, 261, -1},	//568 Soprano::Model::executeQuery(const QString&, Soprano::Query::QueryLanguage) const [pure virtual]
	{47, 425, 311, 1, Smoke::mf_const, 289, 24},	//569 Soprano::Model::containsAnyStatement(const Soprano::Statement&) const [pure virtual]
	{47, 425, 295, 4, Smoke::mf_const, 289, 25},	//570 Soprano::Model::containsAnyStatement(const Soprano::Node&, const Soprano::Node&, const Soprano::Node&, const Soprano::Node&) const
	{47, 425, 291, 3, Smoke::mf_const, 289, 26},	//571 Soprano::Model::containsAnyStatement(const Soprano::Node&, const Soprano::Node&, const Soprano::Node&) const
	{47, 435, 311, 1, Smoke::mf_const, 289, 27},	//572 Soprano::Model::containsStatement(const Soprano::Statement&) const [pure virtual]
	{47, 435, 295, 4, Smoke::mf_const, 289, 28},	//573 Soprano::Model::containsStatement(const Soprano::Node&, const Soprano::Node&, const Soprano::Node&, const Soprano::Node&) const
	{47, 435, 291, 3, Smoke::mf_const, 289, 29},	//574 Soprano::Model::containsStatement(const Soprano::Node&, const Soprano::Node&, const Soprano::Node&) const
	{47, 433, 286, 1, Smoke::mf_const, 289, 30},	//575 Soprano::Model::containsContext(const Soprano::Node&) const
	{47, 653, 0, 0, Smoke::mf_const, 289, 31},	//576 Soprano::Model::isEmpty() const [pure virtual]
	{47, 1039, 0, 0, Smoke::mf_const, 337, 32},	//577 Soprano::Model::statementCount() const [pure virtual]
	{47, 1145, 3, 1, Smoke::mf_const, 207, 33},	//578 Soprano::Model::write(QTextStream&) const
	{47, 455, 0, 0, 0, 248, 34},	//579 Soprano::Model::createBlankNode() [pure virtual]
	{47, 1044, 0, 0, 0, 0, 35},	//580 Soprano::Model::statementsAdded()
	{47, 1045, 0, 0, 0, 0, 36},	//581 Soprano::Model::statementsRemoved()
	{47, 1037, 311, 1, 0, 0, 37},	//582 Soprano::Model::statementAdded(const Soprano::Statement&)
	{47, 1042, 311, 1, 0, 0, 38},	//583 Soprano::Model::statementRemoved(const Soprano::Statement&)
	{47, 1046, 0, 0, Smoke::mf_static, 302, 1},	//584 Soprano::Model::staticMetaObject (static var)
	{47, 158, 0, 0, Smoke::mf_ctor|Smoke::mf_protected, 247, 39},	//585 Soprano::Model::Model()
	{48, 87, 0, 0, Smoke::mf_static|Smoke::mf_enum, 251, 1},	//586 Soprano::Node::EmptyNode (enum)
	{48, 229, 0, 0, Smoke::mf_static|Smoke::mf_enum, 251, 2},	//587 Soprano::Node::ResourceNode (enum)
	{48, 136, 0, 0, Smoke::mf_static|Smoke::mf_enum, 251, 3},	//588 Soprano::Node::LiteralNode (enum)
	{48, 41, 0, 0, Smoke::mf_static|Smoke::mf_enum, 251, 4},	//589 Soprano::Node::BlankNode (enum)
	{48, 167, 0, 0, Smoke::mf_ctor, 250, 5},	//590 Soprano::Node::Node()
	{48, 167, 238, 1, Smoke::mf_ctor, 250, 6},	//591 Soprano::Node::Node(const QUrl&)
	{48, 167, 146, 1, Smoke::mf_ctor, 250, 7},	//592 Soprano::Node::Node(const QString&)
	{48, 167, 284, 1, Smoke::mf_ctor, 250, 8},	//593 Soprano::Node::Node(const Soprano::LiteralValue&)
	{48, 167, 286, 1, Smoke::mf_copyctor|Smoke::mf_ctor, 250, 9},	//594 Soprano::Node::Node(const Soprano::Node&)
	{48, 1179, 0, 0, Smoke::mf_dtor, 0, 38},	//595 Soprano::Node::~Node()
	{48, 807, 286, 1, 0, 249, 10},	//596 Soprano::Node::operator=(const Soprano::Node&)
	{48, 807, 238, 1, 0, 249, 11},	//597 Soprano::Node::operator=(const QUrl&)
	{48, 807, 284, 1, 0, 249, 12},	//598 Soprano::Node::operator=(const Soprano::LiteralValue&)
	{48, 810, 286, 1, Smoke::mf_const, 289, 13},	//599 Soprano::Node::operator==(const Soprano::Node&) const
	{48, 791, 286, 1, Smoke::mf_const, 289, 14},	//600 Soprano::Node::operator!=(const Soprano::Node&) const
	{48, 810, 238, 1, Smoke::mf_const, 289, 15},	//601 Soprano::Node::operator==(const QUrl&) const
	{48, 810, 284, 1, Smoke::mf_const, 289, 16},	//602 Soprano::Node::operator==(const Soprano::LiteralValue&) const
	{48, 748, 286, 1, Smoke::mf_const, 289, 17},	//603 Soprano::Node::matches(const Soprano::Node&) const
	{48, 1101, 0, 0, Smoke::mf_const, 251, 18},	//604 Soprano::Node::type() const
	{48, 653, 0, 0, Smoke::mf_const, 289, 19},	//605 Soprano::Node::isEmpty() const
	{48, 687, 0, 0, Smoke::mf_const, 289, 20},	//606 Soprano::Node::isValid() const
	{48, 661, 0, 0, Smoke::mf_const, 289, 21},	//607 Soprano::Node::isLiteral() const
	{48, 673, 0, 0, Smoke::mf_const, 289, 22},	//608 Soprano::Node::isResource() const
	{48, 636, 0, 0, Smoke::mf_const, 289, 23},	//609 Soprano::Node::isBlank() const
	{48, 1112, 0, 0, Smoke::mf_const, 150, 24},	//610 Soprano::Node::uri() const
	{48, 617, 0, 0, Smoke::mf_const, 106, 25},	//611 Soprano::Node::identifier() const
	{48, 729, 0, 0, Smoke::mf_const, 244, 26},	//612 Soprano::Node::literal() const
	{48, 483, 0, 0, Smoke::mf_const, 150, 27},	//613 Soprano::Node::dataType() const
	{48, 705, 0, 0, Smoke::mf_const, 106, 28},	//614 Soprano::Node::language() const
	{48, 1091, 0, 0, Smoke::mf_const, 106, 29},	//615 Soprano::Node::toString() const
	{48, 1088, 0, 0, Smoke::mf_const, 106, 30},	//616 Soprano::Node::toN3() const
	{48, 458, 0, 0, Smoke::mf_static, 248, 31},	//617 Soprano::Node::createEmptyNode()
	{48, 468, 238, 1, Smoke::mf_static, 248, 32},	//618 Soprano::Node::createResourceNode(const QUrl&)
	{48, 455, 146, 1, Smoke::mf_static, 248, 33},	//619 Soprano::Node::createBlankNode(const QString&)
	{48, 459, 284, 1, Smoke::mf_static, 248, 34},	//620 Soprano::Node::createLiteralNode(const Soprano::LiteralValue&)
	{48, 929, 238, 1, Smoke::mf_static, 106, 35},	//621 Soprano::Node::resourceToN3(const QUrl&)
	{48, 372, 146, 1, Smoke::mf_static, 106, 36},	//622 Soprano::Node::blankToN3(const QString&)
	{48, 730, 284, 1, Smoke::mf_static, 106, 37},	//623 Soprano::Node::literalToN3(const Soprano::LiteralValue&)
	{49, 170, 0, 0, Smoke::mf_ctor, 254, 1},	//624 Soprano::NodeIterator::NodeIterator()
	{49, 170, 303, 1, Smoke::mf_copyctor|Smoke::mf_ctor, 254, 2},	//625 Soprano::NodeIterator::NodeIterator(const Soprano::NodeIterator&)
	{49, 1180, 0, 0, Smoke::mf_dtor, 0, 5},	//626 Soprano::NodeIterator::~NodeIterator()
	{49, 807, 303, 1, 0, 253, 3},	//627 Soprano::NodeIterator::operator=(const Soprano::NodeIterator&)
	{49, 328, 0, 0, 0, 70, 4},	//628 Soprano::NodeIterator::allNodes()
	{50, 1182, 0, 0, Smoke::mf_dtor, 0, 11},	//629 Soprano::Parser::~Parser()
	{50, 1064, 0, 0, Smoke::mf_const, 267, 1},	//630 Soprano::Parser::supportedSerializations() const [pure virtual]
	{50, 1066, 0, 0, Smoke::mf_const, 110, 2},	//631 Soprano::Parser::supportedUserSerializations() const
	{50, 1070, 60, 2, Smoke::mf_const, 289, 3},	//632 Soprano::Parser::supportsSerialization(Soprano::RdfSerialization, const QString&) const
	{50, 1070, 58, 1, Smoke::mf_const, 289, 4},	//633 Soprano::Parser::supportsSerialization(Soprano::RdfSerialization) const
	{50, 837, 196, 4, Smoke::mf_const, 276, 5},	//634 Soprano::Parser::parseFile(const QString&, const QUrl&, Soprano::RdfSerialization, const QString&) const
	{50, 837, 192, 3, Smoke::mf_const, 276, 6},	//635 Soprano::Parser::parseFile(const QString&, const QUrl&, Soprano::RdfSerialization) const
	{50, 846, 196, 4, Smoke::mf_const, 276, 7},	//636 Soprano::Parser::parseString(const QString&, const QUrl&, Soprano::RdfSerialization, const QString&) const
	{50, 846, 192, 3, Smoke::mf_const, 276, 8},	//637 Soprano::Parser::parseString(const QString&, const QUrl&, Soprano::RdfSerialization) const
	{50, 843, 9, 4, Smoke::mf_const, 276, 9},	//638 Soprano::Parser::parseStream(QTextStream&, const QUrl&, Soprano::RdfSerialization, const QString&) const [pure virtual]
	{50, 843, 5, 3, Smoke::mf_const, 276, -1},	//639 Soprano::Parser::parseStream(QTextStream&, const QUrl&, Soprano::RdfSerialization) const [pure virtual]
	{50, 182, 146, 1, Smoke::mf_ctor|Smoke::mf_protected, 255, 10},	//640 Soprano::Parser::Parser(const QString&)
	{51, 1184, 0, 0, Smoke::mf_dtor, 0, 5},	//641 Soprano::Plugin::~Plugin()
	{51, 857, 0, 0, Smoke::mf_const, 106, 1},	//642 Soprano::Plugin::pluginName() const
	{51, 634, 0, 0, Smoke::mf_const, 289, 2},	//643 Soprano::Plugin::isAvailable() const
	{51, 193, 305, 1, Smoke::mf_copyctor|Smoke::mf_internal|Smoke::mf_ctor, 256, 3},	//644 Soprano::Plugin::Plugin(const Soprano::Plugin&)
	{51, 193, 146, 1, Smoke::mf_ctor|Smoke::mf_protected, 256, 4},	//645 Soprano::Plugin::Plugin(const QString&)
	{52, 760, 0, 0, Smoke::mf_const, 303, 2},	//646 Soprano::PluginManager::metaObject() const
	{52, 870, 362, 3, 0, 337, 3},	//647 Soprano::PluginManager::qt_metacall(QMetaObject::Call, int, void**)
	{52, 1001, 233, 2, 0, 0, 4},	//648 Soprano::PluginManager::setPluginSearchPath(const QStringList&, bool)
	{52, 1001, 231, 1, 0, 0, 5},	//649 Soprano::PluginManager::setPluginSearchPath(const QStringList&)
	{52, 519, 146, 1, 0, 310, 6},	//650 Soprano::PluginManager::discoverBackendByName(const QString&)
	{52, 516, 20, 2, 0, 310, 7},	//651 Soprano::PluginManager::discoverBackendByFeatures(Soprano::BackendFeatures, const QStringList&)
	{52, 516, 18, 1, 0, 310, 8},	//652 Soprano::PluginManager::discoverBackendByFeatures(Soprano::BackendFeatures)
	{52, 325, 0, 0, 0, 72, 9},	//653 Soprano::PluginManager::allBackends()
	{52, 521, 146, 1, 0, 327, 10},	//654 Soprano::PluginManager::discoverParserByName(const QString&)
	{52, 523, 60, 2, 0, 327, 11},	//655 Soprano::PluginManager::discoverParserForSerialization(Soprano::RdfSerialization, const QString&)
	{52, 523, 58, 1, 0, 327, 12},	//656 Soprano::PluginManager::discoverParserForSerialization(Soprano::RdfSerialization)
	{52, 329, 0, 0, 0, 73, 13},	//657 Soprano::PluginManager::allParsers()
	{52, 526, 146, 1, 0, 330, 14},	//658 Soprano::PluginManager::discoverSerializerByName(const QString&)
	{52, 528, 60, 2, 0, 330, 15},	//659 Soprano::PluginManager::discoverSerializerForSerialization(Soprano::RdfSerialization, const QString&)
	{52, 528, 58, 1, 0, 330, 16},	//660 Soprano::PluginManager::discoverSerializerForSerialization(Soprano::RdfSerialization)
	{52, 331, 0, 0, 0, 74, 17},	//661 Soprano::PluginManager::allSerializers()
	{52, 626, 0, 0, Smoke::mf_static, 257, 18},	//662 Soprano::PluginManager::instance()
	{52, 1046, 0, 0, Smoke::mf_static, 302, 1},	//663 Soprano::PluginManager::staticMetaObject (static var)
	{53, 207, 0, 0, Smoke::mf_static|Smoke::mf_enum, 258, 1},	//664 Soprano::Query::QueryLanguageNone (enum)
	{53, 210, 0, 0, Smoke::mf_static|Smoke::mf_enum, 258, 2},	//665 Soprano::Query::QueryLanguageSparql (enum)
	{53, 208, 0, 0, Smoke::mf_static|Smoke::mf_enum, 258, 3},	//666 Soprano::Query::QueryLanguageRdql (enum)
	{53, 209, 0, 0, Smoke::mf_static|Smoke::mf_enum, 258, 4},	//667 Soprano::Query::QueryLanguageSerql (enum)
	{53, 211, 0, 0, Smoke::mf_static|Smoke::mf_enum, 258, 5},	//668 Soprano::Query::QueryLanguageUser (enum)
	{53, 199, 0, 0, Smoke::mf_static|Smoke::mf_enum, 258, 6},	//669 Soprano::Query::QUERY_LANGUAGE_NONE (enum)
	{53, 202, 0, 0, Smoke::mf_static|Smoke::mf_enum, 258, 7},	//670 Soprano::Query::QUERY_LANGUAGE_SPARQL (enum)
	{53, 200, 0, 0, Smoke::mf_static|Smoke::mf_enum, 258, 8},	//671 Soprano::Query::QUERY_LANGUAGE_RDQL (enum)
	{53, 201, 0, 0, Smoke::mf_static|Smoke::mf_enum, 258, 9},	//672 Soprano::Query::QUERY_LANGUAGE_SERQL (enum)
	{53, 203, 0, 0, Smoke::mf_static|Smoke::mf_enum, 258, 10},	//673 Soprano::Query::QUERY_LANGUAGE_USER (enum)
	{53, 875, 48, 2, Smoke::mf_static, 106, 11},	//674 Soprano::Query::queryLanguageToString(Soprano::Query::QueryLanguage, const QString&)
	{53, 875, 46, 1, Smoke::mf_static, 106, 12},	//675 Soprano::Query::queryLanguageToString(Soprano::Query::QueryLanguage)
	{53, 873, 146, 1, Smoke::mf_static, 258, 13},	//676 Soprano::Query::queryLanguageFromString(const QString&)
	{54, 212, 0, 0, Smoke::mf_ctor, 263, 1},	//677 Soprano::QueryResultIterator::QueryResultIterator()
	{54, 212, 307, 1, Smoke::mf_copyctor|Smoke::mf_ctor, 263, 2},	//678 Soprano::QueryResultIterator::QueryResultIterator(const Soprano::QueryResultIterator&)
	{54, 212, 56, 1, Smoke::mf_ctor, 263, 3},	//679 Soprano::QueryResultIterator::QueryResultIterator(Soprano::QueryResultIteratorBackend*)
	{54, 1187, 0, 0, Smoke::mf_dtor, 0, 24},	//680 Soprano::QueryResultIterator::~QueryResultIterator()
	{54, 807, 307, 1, 0, 262, 4},	//681 Soprano::QueryResultIterator::operator=(const Soprano::QueryResultIterator&)
	{54, 480, 0, 0, Smoke::mf_const, 273, 5},	//682 Soprano::QueryResultIterator::currentStatement() const
	{54, 479, 0, 0, Smoke::mf_const, 194, 6},	//683 Soprano::QueryResultIterator::currentBindings() const
	{54, 375, 0, 0, Smoke::mf_const, 289, 7},	//684 Soprano::QueryResultIterator::boolValue() const
	{54, 817, 321, 1, Smoke::mf_const, 248, 8},	//685 Soprano::QueryResultIterator::operator[](int) const
	{54, 817, 144, 1, Smoke::mf_const, 248, 9},	//686 Soprano::QueryResultIterator::operator[](const QString) const
	{54, 367, 146, 1, Smoke::mf_const, 248, 10},	//687 Soprano::QueryResultIterator::binding(const QString&) const
	{54, 367, 321, 1, Smoke::mf_const, 248, 11},	//688 Soprano::QueryResultIterator::binding(int) const
	{54, 369, 0, 0, Smoke::mf_const, 337, 12},	//689 Soprano::QueryResultIterator::bindingCount() const
	{54, 370, 0, 0, Smoke::mf_const, 110, 13},	//690 Soprano::QueryResultIterator::bindingNames() const
	{54, 656, 0, 0, Smoke::mf_const, 289, 14},	//691 Soprano::QueryResultIterator::isGraph() const
	{54, 635, 0, 0, Smoke::mf_const, 289, 15},	//692 Soprano::QueryResultIterator::isBinding() const
	{54, 637, 0, 0, Smoke::mf_const, 289, 16},	//693 Soprano::QueryResultIterator::isBool() const
	{54, 326, 0, 0, 0, 67, 17},	//694 Soprano::QueryResultIterator::allBindings()
	{54, 695, 0, 0, Smoke::mf_const, 276, 18},	//695 Soprano::QueryResultIterator::iterateStatements() const
	{54, 690, 146, 1, Smoke::mf_const, 252, 19},	//696 Soprano::QueryResultIterator::iterateBindings(const QString&) const
	{54, 690, 321, 1, Smoke::mf_const, 252, 20},	//697 Soprano::QueryResultIterator::iterateBindings(int) const
	{54, 696, 179, 5, Smoke::mf_const, 276, 21},	//698 Soprano::QueryResultIterator::iterateStatementsFromBindings(const QString&, const QString&, const QString&, const QString&, const Soprano::Statement&) const
	{54, 696, 174, 4, Smoke::mf_const, 276, 22},	//699 Soprano::QueryResultIterator::iterateStatementsFromBindings(const QString&, const QString&, const QString&, const QString&) const
	{54, 696, 170, 3, Smoke::mf_const, 276, 23},	//700 Soprano::QueryResultIterator::iterateStatementsFromBindings(const QString&, const QString&, const QString&) const
	{55, 218, 39, 1, Smoke::mf_ctor, 265, 1},	//701 Soprano::RdfSchemaModel::RdfSchemaModel(Soprano::Model*)
	{55, 218, 0, 0, Smoke::mf_ctor, 265, 2},	//702 Soprano::RdfSchemaModel::RdfSchemaModel()
	{55, 1188, 0, 0, Smoke::mf_dtor, 0, 25},	//703 Soprano::RdfSchemaModel::~RdfSchemaModel()
	{55, 393, 0, 0, Smoke::mf_const, 276, 3},	//704 Soprano::RdfSchemaModel::classes() const
	{55, 503, 288, 2, Smoke::mf_const, 276, 4},	//705 Soprano::RdfSchemaModel::directSubClassOf(const Soprano::Node&, const Soprano::Node&) const
	{55, 503, 286, 1, Smoke::mf_const, 276, 5},	//706 Soprano::RdfSchemaModel::directSubClassOf(const Soprano::Node&) const
	{55, 506, 288, 2, Smoke::mf_const, 276, 6},	//707 Soprano::RdfSchemaModel::directSubPropertyOf(const Soprano::Node&, const Soprano::Node&) const
	{55, 506, 286, 1, Smoke::mf_const, 276, 7},	//708 Soprano::RdfSchemaModel::directSubPropertyOf(const Soprano::Node&) const
	{55, 509, 288, 2, Smoke::mf_const, 276, 8},	//709 Soprano::RdfSchemaModel::directType(const Soprano::Node&, const Soprano::Node&) const
	{55, 536, 288, 2, Smoke::mf_const, 276, 9},	//710 Soprano::RdfSchemaModel::domain(const Soprano::Node&, const Soprano::Node&) const
	{55, 869, 0, 0, Smoke::mf_const, 276, 10},	//711 Soprano::RdfSchemaModel::properties() const
	{55, 879, 288, 2, Smoke::mf_const, 276, 11},	//712 Soprano::RdfSchemaModel::range(const Soprano::Node&, const Soprano::Node&) const
	{55, 1050, 288, 2, Smoke::mf_const, 276, 12},	//713 Soprano::RdfSchemaModel::subClassOf(const Soprano::Node&, const Soprano::Node&) const
	{55, 1050, 286, 1, Smoke::mf_const, 276, 13},	//714 Soprano::RdfSchemaModel::subClassOf(const Soprano::Node&) const
	{55, 1054, 288, 2, Smoke::mf_const, 276, 14},	//715 Soprano::RdfSchemaModel::subPropertyOf(const Soprano::Node&, const Soprano::Node&) const
	{55, 1054, 286, 1, Smoke::mf_const, 276, 15},	//716 Soprano::RdfSchemaModel::subPropertyOf(const Soprano::Node&) const
	{55, 1101, 288, 2, Smoke::mf_const, 276, 16},	//717 Soprano::RdfSchemaModel::type(const Soprano::Node&, const Soprano::Node&) const
	{55, 639, 286, 1, Smoke::mf_const, 289, 17},	//718 Soprano::RdfSchemaModel::isClass(const Soprano::Node&) const
	{55, 668, 286, 1, Smoke::mf_const, 289, 18},	//719 Soprano::RdfSchemaModel::isProperty(const Soprano::Node&) const
	{55, 646, 288, 2, Smoke::mf_const, 289, 19},	//720 Soprano::RdfSchemaModel::isDirectSubClassOf(const Soprano::Node&, const Soprano::Node&) const
	{55, 648, 288, 2, Smoke::mf_const, 289, 20},	//721 Soprano::RdfSchemaModel::isDirectSubPropertyOf(const Soprano::Node&, const Soprano::Node&) const
	{55, 650, 288, 2, Smoke::mf_const, 289, 21},	//722 Soprano::RdfSchemaModel::isDirectType(const Soprano::Node&, const Soprano::Node&) const
	{55, 676, 288, 2, Smoke::mf_const, 289, 22},	//723 Soprano::RdfSchemaModel::isSubClassOf(const Soprano::Node&, const Soprano::Node&) const
	{55, 678, 288, 2, Smoke::mf_const, 289, 23},	//724 Soprano::RdfSchemaModel::isSubPropertyOf(const Soprano::Node&, const Soprano::Node&) const
	{55, 683, 288, 2, Smoke::mf_const, 289, 24},	//725 Soprano::RdfSchemaModel::isType(const Soprano::Node&, const Soprano::Node&) const
	{56, 1193, 0, 0, Smoke::mf_dtor, 0, 10},	//726 Soprano::Serializer::~Serializer()
	{56, 1064, 0, 0, Smoke::mf_const, 267, 1},	//727 Soprano::Serializer::supportedSerializations() const [pure virtual]
	{56, 1066, 0, 0, Smoke::mf_const, 110, 2},	//728 Soprano::Serializer::supportedUserSerializations() const
	{56, 1070, 60, 2, Smoke::mf_const, 289, 3},	//729 Soprano::Serializer::supportsSerialization(Soprano::RdfSerialization, const QString&) const
	{56, 1070, 58, 1, Smoke::mf_const, 289, 4},	//730 Soprano::Serializer::supportsSerialization(Soprano::RdfSerialization) const
	{56, 955, 69, 4, Smoke::mf_const, 289, 5},	//731 Soprano::Serializer::serialize(Soprano::StatementIterator, QTextStream&, Soprano::RdfSerialization, const QString&) const [pure virtual]
	{56, 955, 65, 3, Smoke::mf_const, 289, -1},	//732 Soprano::Serializer::serialize(Soprano::StatementIterator, QTextStream&, Soprano::RdfSerialization) const [pure virtual]
	{56, 304, 189, 2, Smoke::mf_const, 0, 6},	//733 Soprano::Serializer::addPrefix(const QString&, const QUrl&) const
	{56, 396, 0, 0, Smoke::mf_const, 0, 7},	//734 Soprano::Serializer::clearPrefixes() const
	{56, 865, 0, 0, Smoke::mf_const, 56, 8},	//735 Soprano::Serializer::prefixes() const
	{56, 251, 146, 1, Smoke::mf_ctor|Smoke::mf_protected, 269, 9},	//736 Soprano::Serializer::Serializer(const QString&)
	{58, 760, 0, 0, Smoke::mf_const, 303, 2},	//737 Soprano::Server::DBusExportIterator::metaObject() const
	{58, 870, 362, 3, 0, 337, 3},	//738 Soprano::Server::DBusExportIterator::qt_metacall(QMetaObject::Call, int, void**)
	{58, 57, 74, 2, Smoke::mf_ctor, 270, 4},	//739 Soprano::Server::DBusExportIterator::DBusExportIterator(Soprano::StatementIterator, QObject*)
	{58, 57, 63, 1, Smoke::mf_ctor, 270, 5},	//740 Soprano::Server::DBusExportIterator::DBusExportIterator(Soprano::StatementIterator)
	{58, 57, 43, 2, Smoke::mf_ctor, 270, 6},	//741 Soprano::Server::DBusExportIterator::DBusExportIterator(Soprano::NodeIterator, QObject*)
	{58, 57, 41, 1, Smoke::mf_ctor, 270, 7},	//742 Soprano::Server::DBusExportIterator::DBusExportIterator(Soprano::NodeIterator)
	{58, 57, 53, 2, Smoke::mf_ctor, 270, 8},	//743 Soprano::Server::DBusExportIterator::DBusExportIterator(Soprano::QueryResultIterator, QObject*)
	{58, 57, 51, 1, Smoke::mf_ctor, 270, 9},	//744 Soprano::Server::DBusExportIterator::DBusExportIterator(Soprano::QueryResultIterator)
	{58, 1162, 0, 0, Smoke::mf_dtor, 0, 19},	//745 Soprano::Server::DBusExportIterator::~DBusExportIterator()
	{58, 1041, 0, 0, Smoke::mf_const, 276, 10},	//746 Soprano::Server::DBusExportIterator::statementIterator() const
	{58, 777, 0, 0, Smoke::mf_const, 252, 11},	//747 Soprano::Server::DBusExportIterator::nodeIterator() const
	{58, 878, 0, 0, Smoke::mf_const, 261, 12},	//748 Soprano::Server::DBusExportIterator::queryResultIterator() const
	{58, 489, 0, 0, Smoke::mf_const, 106, 13},	//749 Soprano::Server::DBusExportIterator::dbusObjectPath() const
	{58, 497, 0, 0, Smoke::mf_const, 289, 14},	//750 Soprano::Server::DBusExportIterator::deleteOnClose() const
	{58, 976, 86, 1, 0, 0, 15},	//751 Soprano::Server::DBusExportIterator::setDeleteOnClose(bool)
	{58, 890, 167, 2, 0, 289, 16},	//752 Soprano::Server::DBusExportIterator::registerIterator(const QString&, const QString&)
	{58, 890, 146, 1, 0, 289, 17},	//753 Soprano::Server::DBusExportIterator::registerIterator(const QString&)
	{58, 1106, 0, 0, 0, 0, 18},	//754 Soprano::Server::DBusExportIterator::unregisterIterator()
	{58, 1046, 0, 0, Smoke::mf_static, 302, 1},	//755 Soprano::Server::DBusExportIterator::staticMetaObject (static var)
	{59, 760, 0, 0, Smoke::mf_const, 303, 2},	//756 Soprano::Server::DBusExportModel::metaObject() const
	{59, 870, 362, 3, 0, 337, 3},	//757 Soprano::Server::DBusExportModel::qt_metacall(QMetaObject::Call, int, void**)
	{59, 60, 39, 1, Smoke::mf_ctor, 271, 4},	//758 Soprano::Server::DBusExportModel::DBusExportModel(Soprano::Model*)
	{59, 60, 0, 0, Smoke::mf_ctor, 271, 5},	//759 Soprano::Server::DBusExportModel::DBusExportModel()
	{59, 1163, 0, 0, Smoke::mf_dtor, 0, 9},	//760 Soprano::Server::DBusExportModel::~DBusExportModel()
	{59, 893, 146, 1, 0, 289, 6},	//761 Soprano::Server::DBusExportModel::registerModel(const QString&)
	{59, 1107, 0, 0, 0, 0, 7},	//762 Soprano::Server::DBusExportModel::unregisterModel()
	{59, 489, 0, 0, Smoke::mf_const, 106, 8},	//763 Soprano::Server::DBusExportModel::dbusObjectPath() const
	{59, 1046, 0, 0, Smoke::mf_static, 302, 1},	//764 Soprano::Server::DBusExportModel::staticMetaObject (static var)
	{60, 760, 0, 0, Smoke::mf_const, 303, 3},	//765 Soprano::Server::ServerCore::metaObject() const
	{60, 870, 362, 3, 0, 337, 4},	//766 Soprano::Server::ServerCore::qt_metacall(QMetaObject::Call, int, void**)
	{60, 253, 366, 1, Smoke::mf_ctor, 272, 5},	//767 Soprano::Server::ServerCore::ServerCore(QObject*)
	{60, 253, 0, 0, Smoke::mf_ctor, 272, 6},	//768 Soprano::Server::ServerCore::ServerCore()
	{60, 1194, 0, 0, Smoke::mf_dtor, 0, 21},	//769 Soprano::Server::ServerCore::~ServerCore()
	{60, 961, 242, 1, 0, 0, 7},	//770 Soprano::Server::ServerCore::setBackend(const Soprano::Backend*)
	{60, 356, 0, 0, Smoke::mf_const, 310, 8},	//771 Soprano::Server::ServerCore::backend() const
	{60, 963, 103, 1, 0, 0, 9},	//772 Soprano::Server::ServerCore::setBackendSettings(const QList<Soprano::BackendSetting>&)
	{60, 767, 146, 1, 0, 247, 10},	//773 Soprano::Server::ServerCore::model(const QString&)
	{60, 910, 146, 1, 0, 0, 11},	//774 Soprano::Server::ServerCore::removeModel(const QString&)
	{60, 327, 0, 0, Smoke::mf_const, 110, 12},	//775 Soprano::Server::ServerCore::allModels() const
	{60, 1034, 146, 1, 0, 289, 13},	//776 Soprano::Server::ServerCore::start(const QString&)
	{60, 1034, 0, 0, 0, 289, 14},	//777 Soprano::Server::ServerCore::start()
	{60, 727, 348, 1, 0, 289, 15},	//778 Soprano::Server::ServerCore::listen(unsigned short)
	{60, 727, 0, 0, 0, 289, 16},	//779 Soprano::Server::ServerCore::listen()
	{60, 958, 0, 0, Smoke::mf_const, 344, 17},	//780 Soprano::Server::ServerCore::serverPort() const
	{60, 888, 146, 1, 0, 0, 18},	//781 Soprano::Server::ServerCore::registerAsDBusObject(const QString&)
	{60, 888, 0, 0, 0, 0, 19},	//782 Soprano::Server::ServerCore::registerAsDBusObject()
	{60, 1046, 0, 0, Smoke::mf_static, 302, 1},	//783 Soprano::Server::ServerCore::staticMetaObject (static var)
	{60, 71, 0, 0, Smoke::mf_static, 335, 2},	//784 Soprano::Server::ServerCore::DEFAULT_PORT (static var)
	{60, 461, 103, 1, Smoke::mf_protected, 247, 20},	//785 Soprano::Server::ServerCore::createModel(const QList<Soprano::BackendSetting>&)
	{61, 270, 0, 0, Smoke::mf_ctor, 275, 1},	//786 Soprano::Statement::Statement()
	{61, 270, 295, 4, Smoke::mf_ctor, 275, 2},	//787 Soprano::Statement::Statement(const Soprano::Node&, const Soprano::Node&, const Soprano::Node&, const Soprano::Node&)
	{61, 270, 291, 3, Smoke::mf_ctor, 275, 3},	//788 Soprano::Statement::Statement(const Soprano::Node&, const Soprano::Node&, const Soprano::Node&)
	{61, 270, 311, 1, Smoke::mf_copyctor|Smoke::mf_ctor, 275, 4},	//789 Soprano::Statement::Statement(const Soprano::Statement&)
	{61, 1198, 0, 0, Smoke::mf_dtor, 0, 18},	//790 Soprano::Statement::~Statement()
	{61, 807, 311, 1, 0, 274, 5},	//791 Soprano::Statement::operator=(const Soprano::Statement&)
	{61, 810, 311, 1, Smoke::mf_const, 289, 6},	//792 Soprano::Statement::operator==(const Soprano::Statement&) const
	{61, 791, 311, 1, Smoke::mf_const, 289, 7},	//793 Soprano::Statement::operator!=(const Soprano::Statement&) const
	{61, 748, 311, 1, Smoke::mf_const, 289, 8},	//794 Soprano::Statement::matches(const Soprano::Statement&) const
	{61, 687, 0, 0, Smoke::mf_const, 289, 9},	//795 Soprano::Statement::isValid() const
	{61, 1058, 0, 0, Smoke::mf_const, 248, 10},	//796 Soprano::Statement::subject() const
	{61, 861, 0, 0, Smoke::mf_const, 248, 11},	//797 Soprano::Statement::predicate() const
	{61, 781, 0, 0, Smoke::mf_const, 248, 12},	//798 Soprano::Statement::object() const
	{61, 448, 0, 0, Smoke::mf_const, 248, 13},	//799 Soprano::Statement::context() const
	{61, 1011, 286, 1, 0, 0, 14},	//800 Soprano::Statement::setSubject(const Soprano::Node&)
	{61, 1004, 286, 1, 0, 0, 15},	//801 Soprano::Statement::setPredicate(const Soprano::Node&)
	{61, 993, 286, 1, 0, 0, 16},	//802 Soprano::Statement::setObject(const Soprano::Node&)
	{61, 973, 286, 1, 0, 0, 17},	//803 Soprano::Statement::setContext(const Soprano::Node&)
	{62, 274, 0, 0, Smoke::mf_ctor, 278, 1},	//804 Soprano::StatementIterator::StatementIterator()
	{62, 274, 313, 1, Smoke::mf_copyctor|Smoke::mf_ctor, 278, 2},	//805 Soprano::StatementIterator::StatementIterator(const Soprano::StatementIterator&)
	{62, 1199, 0, 0, Smoke::mf_dtor, 0, 9},	//806 Soprano::StatementIterator::~StatementIterator()
	{62, 807, 313, 1, 0, 277, 3},	//807 Soprano::StatementIterator::operator=(const Soprano::StatementIterator&)
	{62, 332, 0, 0, 0, 71, 4},	//808 Soprano::StatementIterator::allStatements()
	{62, 700, 0, 0, Smoke::mf_const, 252, 5},	//809 Soprano::StatementIterator::iterateSubjects() const
	{62, 694, 0, 0, Smoke::mf_const, 252, 6},	//810 Soprano::StatementIterator::iteratePredicates() const
	{62, 693, 0, 0, Smoke::mf_const, 252, 7},	//811 Soprano::StatementIterator::iterateObjects() const
	{62, 692, 0, 0, Smoke::mf_const, 252, 8},	//812 Soprano::StatementIterator::iterateContexts() const
	{63, 760, 0, 0, Smoke::mf_const, 303, 2},	//813 Soprano::StorageModel::metaObject() const
	{63, 870, 362, 3, 0, 337, 3},	//814 Soprano::StorageModel::qt_metacall(QMetaObject::Call, int, void**)
	{63, 1201, 0, 0, Smoke::mf_dtor, 0, 10},	//815 Soprano::StorageModel::~StorageModel()
	{63, 653, 0, 0, Smoke::mf_const, 289, 4},	//816 Soprano::StorageModel::isEmpty() const
	{63, 435, 311, 1, Smoke::mf_const, 289, 5},	//817 Soprano::StorageModel::containsStatement(const Soprano::Statement&) const
	{63, 425, 311, 1, Smoke::mf_const, 289, 6},	//818 Soprano::StorageModel::containsAnyStatement(const Soprano::Statement&) const
	{63, 900, 311, 1, 0, 207, 7},	//819 Soprano::StorageModel::removeAllStatements(const Soprano::Statement&)
	{63, 356, 0, 0, Smoke::mf_const, 310, 8},	//820 Soprano::StorageModel::backend() const
	{63, 1046, 0, 0, Smoke::mf_static, 302, 1},	//821 Soprano::StorageModel::staticMetaObject (static var)
	{63, 279, 242, 1, Smoke::mf_ctor|Smoke::mf_protected, 279, 9},	//822 Soprano::StorageModel::StorageModel(const Soprano::Backend*)
	{65, 260, 0, 0, Smoke::mf_static|Smoke::mf_enum, 281, 1},	//823 Soprano::Util::AsyncModel::SingleThreaded (enum)
	{65, 159, 0, 0, Smoke::mf_static|Smoke::mf_enum, 281, 2},	//824 Soprano::Util::AsyncModel::MultiThreaded (enum)
	{65, 760, 0, 0, Smoke::mf_const, 303, 4},	//825 Soprano::Util::AsyncModel::metaObject() const
	{65, 870, 362, 3, 0, 337, 5},	//826 Soprano::Util::AsyncModel::qt_metacall(QMetaObject::Call, int, void**)
	{65, 8, 39, 1, Smoke::mf_ctor, 280, 6},	//827 Soprano::Util::AsyncModel::AsyncModel(Soprano::Model*)
	{65, 8, 0, 0, Smoke::mf_ctor, 280, 7},	//828 Soprano::Util::AsyncModel::AsyncModel()
	{65, 1155, 0, 0, Smoke::mf_dtor, 0, 37},	//829 Soprano::Util::AsyncModel::~AsyncModel()
	{65, 991, 77, 1, 0, 0, 8},	//830 Soprano::Util::AsyncModel::setMode(Soprano::Util::AsyncModel::AsyncModelMode)
	{65, 766, 0, 0, Smoke::mf_const, 281, 9},	//831 Soprano::Util::AsyncModel::mode() const
	{65, 312, 311, 1, 0, 282, 10},	//832 Soprano::Util::AsyncModel::addStatementAsync(const Soprano::Statement&)
	{65, 312, 295, 4, 0, 282, 11},	//833 Soprano::Util::AsyncModel::addStatementAsync(const Soprano::Node&, const Soprano::Node&, const Soprano::Node&, const Soprano::Node&)
	{65, 312, 291, 3, 0, 282, 12},	//834 Soprano::Util::AsyncModel::addStatementAsync(const Soprano::Node&, const Soprano::Node&, const Soprano::Node&)
	{65, 318, 140, 1, 0, 282, 13},	//835 Soprano::Util::AsyncModel::addStatementsAsync(const QList<Soprano::Statement>&)
	{65, 916, 311, 1, 0, 282, 14},	//836 Soprano::Util::AsyncModel::removeStatementAsync(const Soprano::Statement&)
	{65, 916, 295, 4, 0, 282, 15},	//837 Soprano::Util::AsyncModel::removeStatementAsync(const Soprano::Node&, const Soprano::Node&, const Soprano::Node&, const Soprano::Node&)
	{65, 916, 291, 3, 0, 282, 16},	//838 Soprano::Util::AsyncModel::removeStatementAsync(const Soprano::Node&, const Soprano::Node&, const Soprano::Node&)
	{65, 922, 140, 1, 0, 282, 17},	//839 Soprano::Util::AsyncModel::removeStatementsAsync(const QList<Soprano::Statement>&)
	{65, 904, 311, 1, 0, 282, 18},	//840 Soprano::Util::AsyncModel::removeAllStatementsAsync(const Soprano::Statement&)
	{65, 904, 295, 4, 0, 282, 19},	//841 Soprano::Util::AsyncModel::removeAllStatementsAsync(const Soprano::Node&, const Soprano::Node&, const Soprano::Node&, const Soprano::Node&)
	{65, 904, 291, 3, 0, 282, 20},	//842 Soprano::Util::AsyncModel::removeAllStatementsAsync(const Soprano::Node&, const Soprano::Node&, const Soprano::Node&)
	{65, 654, 0, 0, Smoke::mf_const, 282, 21},	//843 Soprano::Util::AsyncModel::isEmptyAsync() const
	{65, 1040, 0, 0, Smoke::mf_const, 282, 22},	//844 Soprano::Util::AsyncModel::statementCountAsync() const
	{65, 721, 311, 1, Smoke::mf_const, 282, 23},	//845 Soprano::Util::AsyncModel::listStatementsAsync(const Soprano::Statement&) const
	{65, 721, 295, 4, Smoke::mf_const, 282, 24},	//846 Soprano::Util::AsyncModel::listStatementsAsync(const Soprano::Node&, const Soprano::Node&, const Soprano::Node&, const Soprano::Node&) const
	{65, 721, 291, 3, Smoke::mf_const, 282, 25},	//847 Soprano::Util::AsyncModel::listStatementsAsync(const Soprano::Node&, const Soprano::Node&, const Soprano::Node&) const
	{65, 721, 0, 0, Smoke::mf_const, 282, 26},	//848 Soprano::Util::AsyncModel::listStatementsAsync() const
	{65, 716, 0, 0, Smoke::mf_const, 282, 27},	//849 Soprano::Util::AsyncModel::listContextsAsync() const
	{65, 561, 157, 3, Smoke::mf_const, 282, 28},	//850 Soprano::Util::AsyncModel::executeQueryAsync(const QString&, Soprano::Query::QueryLanguage, const QString&) const
	{65, 561, 154, 2, Smoke::mf_const, 282, 29},	//851 Soprano::Util::AsyncModel::executeQueryAsync(const QString&, Soprano::Query::QueryLanguage) const
	{65, 439, 311, 1, Smoke::mf_const, 282, 30},	//852 Soprano::Util::AsyncModel::containsStatementAsync(const Soprano::Statement&) const
	{65, 439, 295, 4, Smoke::mf_const, 282, 31},	//853 Soprano::Util::AsyncModel::containsStatementAsync(const Soprano::Node&, const Soprano::Node&, const Soprano::Node&, const Soprano::Node&) const
	{65, 439, 291, 3, Smoke::mf_const, 282, 32},	//854 Soprano::Util::AsyncModel::containsStatementAsync(const Soprano::Node&, const Soprano::Node&, const Soprano::Node&) const
	{65, 429, 311, 1, Smoke::mf_const, 282, 33},	//855 Soprano::Util::AsyncModel::containsAnyStatementAsync(const Soprano::Statement&) const
	{65, 429, 295, 4, Smoke::mf_const, 282, 34},	//856 Soprano::Util::AsyncModel::containsAnyStatementAsync(const Soprano::Node&, const Soprano::Node&, const Soprano::Node&, const Soprano::Node&) const
	{65, 429, 291, 3, Smoke::mf_const, 282, 35},	//857 Soprano::Util::AsyncModel::containsAnyStatementAsync(const Soprano::Node&, const Soprano::Node&, const Soprano::Node&) const
	{65, 457, 0, 0, 0, 282, 36},	//858 Soprano::Util::AsyncModel::createBlankNodeAsync()
	{65, 1046, 0, 0, Smoke::mf_static, 302, 3},	//859 Soprano::Util::AsyncModel::staticMetaObject (static var)
	{66, 760, 0, 0, Smoke::mf_const, 303, 2},	//860 Soprano::Util::AsyncResult::metaObject() const
	{66, 870, 362, 3, 0, 337, 3},	//861 Soprano::Util::AsyncResult::qt_metacall(QMetaObject::Call, int, void**)
	{66, 1121, 0, 0, Smoke::mf_const, 153, 4},	//862 Soprano::Util::AsyncResult::value() const
	{66, 550, 0, 0, Smoke::mf_const, 207, 5},	//863 Soprano::Util::AsyncResult::errorCode() const
	{66, 1041, 0, 0, Smoke::mf_const, 276, 6},	//864 Soprano::Util::AsyncResult::statementIterator() const
	{66, 777, 0, 0, Smoke::mf_const, 252, 7},	//865 Soprano::Util::AsyncResult::nodeIterator() const
	{66, 878, 0, 0, Smoke::mf_const, 261, 8},	//866 Soprano::Util::AsyncResult::queryResultIterator() const
	{66, 776, 0, 0, Smoke::mf_const, 248, 9},	//867 Soprano::Util::AsyncResult::node() const
	{66, 470, 0, 0, Smoke::mf_static, 282, 10},	//868 Soprano::Util::AsyncResult::createResult()
	{66, 1046, 0, 0, Smoke::mf_static, 302, 1},	//869 Soprano::Util::AsyncResult::staticMetaObject (static var)
	{67, 192, 0, 0, Smoke::mf_static|Smoke::mf_enum, 284, 1},	//870 Soprano::Util::MutexModel::PlainMultiThreading (enum)
	{67, 222, 0, 0, Smoke::mf_static|Smoke::mf_enum, 284, 2},	//871 Soprano::Util::MutexModel::ReadWriteMultiThreading (enum)
	{67, 223, 0, 0, Smoke::mf_static|Smoke::mf_enum, 284, 3},	//872 Soprano::Util::MutexModel::ReadWriteSingleThreading (enum)
	{67, 760, 0, 0, Smoke::mf_const, 303, 5},	//873 Soprano::Util::MutexModel::metaObject() const
	{67, 870, 362, 3, 0, 337, 6},	//874 Soprano::Util::MutexModel::qt_metacall(QMetaObject::Call, int, void**)
	{67, 161, 83, 2, Smoke::mf_ctor, 283, 7},	//875 Soprano::Util::MutexModel::MutexModel(Soprano::Util::MutexModel::ProtectionMode, Soprano::Model*)
	{67, 161, 81, 1, Smoke::mf_ctor, 283, 8},	//876 Soprano::Util::MutexModel::MutexModel(Soprano::Util::MutexModel::ProtectionMode)
	{67, 1178, 0, 0, Smoke::mf_dtor, 0, 20},	//877 Soprano::Util::MutexModel::~MutexModel()
	{67, 308, 311, 1, 0, 207, 9},	//878 Soprano::Util::MutexModel::addStatement(const Soprano::Statement&)
	{67, 912, 311, 1, 0, 207, 10},	//879 Soprano::Util::MutexModel::removeStatement(const Soprano::Statement&)
	{67, 900, 311, 1, 0, 207, 11},	//880 Soprano::Util::MutexModel::removeAllStatements(const Soprano::Statement&)
	{67, 717, 311, 1, Smoke::mf_const, 276, 12},	//881 Soprano::Util::MutexModel::listStatements(const Soprano::Statement&) const
	{67, 715, 0, 0, Smoke::mf_const, 252, 13},	//882 Soprano::Util::MutexModel::listContexts() const
	{67, 557, 157, 3, Smoke::mf_const, 261, 14},	//883 Soprano::Util::MutexModel::executeQuery(const QString&, Soprano::Query::QueryLanguage, const QString&) const
	{67, 557, 154, 2, Smoke::mf_const, 261, 15},	//884 Soprano::Util::MutexModel::executeQuery(const QString&, Soprano::Query::QueryLanguage) const
	{67, 435, 311, 1, Smoke::mf_const, 289, 16},	//885 Soprano::Util::MutexModel::containsStatement(const Soprano::Statement&) const
	{67, 425, 311, 1, Smoke::mf_const, 289, 17},	//886 Soprano::Util::MutexModel::containsAnyStatement(const Soprano::Statement&) const
	{67, 653, 0, 0, Smoke::mf_const, 289, 18},	//887 Soprano::Util::MutexModel::isEmpty() const
	{67, 1039, 0, 0, Smoke::mf_const, 337, 19},	//888 Soprano::Util::MutexModel::statementCount() const
	{67, 1046, 0, 0, Smoke::mf_static, 302, 4},	//889 Soprano::Util::MutexModel::staticMetaObject (static var)
	{68, 760, 0, 0, Smoke::mf_const, 303, 2},	//890 Soprano::Util::ReadOnlyModel::metaObject() const
	{68, 870, 362, 3, 0, 337, 3},	//891 Soprano::Util::ReadOnlyModel::qt_metacall(QMetaObject::Call, int, void**)
	{68, 220, 39, 1, Smoke::mf_ctor, 285, 4},	//892 Soprano::Util::ReadOnlyModel::ReadOnlyModel(Soprano::Model*)
	{68, 220, 0, 0, Smoke::mf_ctor, 285, 5},	//893 Soprano::Util::ReadOnlyModel::ReadOnlyModel()
	{68, 1189, 0, 0, Smoke::mf_dtor, 0, 19},	//894 Soprano::Util::ReadOnlyModel::~ReadOnlyModel()
	{68, 997, 39, 1, 0, 0, 6},	//895 Soprano::Util::ReadOnlyModel::setParentModel(Soprano::Model*)
	{68, 717, 311, 1, Smoke::mf_const, 276, 7},	//896 Soprano::Util::ReadOnlyModel::listStatements(const Soprano::Statement&) const
	{68, 715, 0, 0, Smoke::mf_const, 252, 8},	//897 Soprano::Util::ReadOnlyModel::listContexts() const
	{68, 557, 157, 3, Smoke::mf_const, 261, 9},	//898 Soprano::Util::ReadOnlyModel::executeQuery(const QString&, Soprano::Query::QueryLanguage, const QString&) const
	{68, 557, 154, 2, Smoke::mf_const, 261, 10},	//899 Soprano::Util::ReadOnlyModel::executeQuery(const QString&, Soprano::Query::QueryLanguage) const
	{68, 435, 311, 1, Smoke::mf_const, 289, 11},	//900 Soprano::Util::ReadOnlyModel::containsStatement(const Soprano::Statement&) const
	{68, 425, 311, 1, Smoke::mf_const, 289, 12},	//901 Soprano::Util::ReadOnlyModel::containsAnyStatement(const Soprano::Statement&) const
	{68, 653, 0, 0, Smoke::mf_const, 289, 13},	//902 Soprano::Util::ReadOnlyModel::isEmpty() const
	{68, 1039, 0, 0, Smoke::mf_const, 337, 14},	//903 Soprano::Util::ReadOnlyModel::statementCount() const
	{68, 308, 311, 1, 0, 207, 15},	//904 Soprano::Util::ReadOnlyModel::addStatement(const Soprano::Statement&)
	{68, 912, 311, 1, 0, 207, 16},	//905 Soprano::Util::ReadOnlyModel::removeStatement(const Soprano::Statement&)
	{68, 900, 311, 1, 0, 207, 17},	//906 Soprano::Util::ReadOnlyModel::removeAllStatements(const Soprano::Statement&)
	{68, 455, 0, 0, 0, 248, 18},	//907 Soprano::Util::ReadOnlyModel::createBlankNode()
	{68, 1046, 0, 0, Smoke::mf_static, 302, 1},	//908 Soprano::Util::ReadOnlyModel::staticMetaObject (static var)
	{69, 760, 0, 0, Smoke::mf_const, 303, 2},	//909 Soprano::Util::SignalCacheModel::metaObject() const
	{69, 870, 362, 3, 0, 337, 3},	//910 Soprano::Util::SignalCacheModel::qt_metacall(QMetaObject::Call, int, void**)
	{69, 255, 39, 1, Smoke::mf_ctor, 286, 4},	//911 Soprano::Util::SignalCacheModel::SignalCacheModel(Soprano::Model*)
	{69, 255, 0, 0, Smoke::mf_ctor, 286, 5},	//912 Soprano::Util::SignalCacheModel::SignalCacheModel()
	{69, 1195, 0, 0, Smoke::mf_dtor, 0, 11},	//913 Soprano::Util::SignalCacheModel::~SignalCacheModel()
	{69, 379, 0, 0, Smoke::mf_const, 337, 6},	//914 Soprano::Util::SignalCacheModel::cacheTime() const
	{69, 967, 321, 1, 0, 0, 7},	//915 Soprano::Util::SignalCacheModel::setCacheTime(int)
	{69, 1046, 0, 0, Smoke::mf_static, 302, 1},	//916 Soprano::Util::SignalCacheModel::staticMetaObject (static var)
	{69, 835, 0, 0, Smoke::mf_protected, 0, 8},	//917 Soprano::Util::SignalCacheModel::parentStatementsAdded()
	{69, 836, 0, 0, Smoke::mf_protected, 0, 9},	//918 Soprano::Util::SignalCacheModel::parentStatementsRemoved()
	{69, 1075, 14, 1, Smoke::mf_protected, 0, 10},	//919 Soprano::Util::SignalCacheModel::timerEvent(QTimerEvent*)
	{70, 257, 0, 0, Smoke::mf_ctor, 288, 1},	//920 Soprano::Util::SimpleNodeIterator::SimpleNodeIterator()
	{70, 257, 138, 1, Smoke::mf_ctor, 288, 2},	//921 Soprano::Util::SimpleNodeIterator::SimpleNodeIterator(const QList<Soprano::Node>&)
	{70, 257, 315, 1, Smoke::mf_copyctor|Smoke::mf_ctor, 288, 3},	//922 Soprano::Util::SimpleNodeIterator::SimpleNodeIterator(const Soprano::Util::SimpleNodeIterator&)
	{70, 1196, 0, 0, Smoke::mf_dtor, 0, 6},	//923 Soprano::Util::SimpleNodeIterator::~SimpleNodeIterator()
	{70, 807, 138, 1, 0, 287, 4},	//924 Soprano::Util::SimpleNodeIterator::operator=(const QList<Soprano::Node>&)
	{70, 807, 315, 1, 0, 287, 5},	//925 Soprano::Util::SimpleNodeIterator::operator=(const Soprano::Util::SimpleNodeIterator&)
	{72, 772, 0, 0, Smoke::mf_static, 150, 1},	//926 Soprano::Vocabulary::NAO::naoNamespace()
	{72, 107, 0, 0, Smoke::mf_static, 150, 2},	//927 Soprano::Vocabulary::NAO::FreeDesktopIcon()
	{72, 188, 0, 0, Smoke::mf_static, 150, 3},	//928 Soprano::Vocabulary::NAO::Party()
	{72, 281, 0, 0, Smoke::mf_static, 150, 4},	//929 Soprano::Vocabulary::NAO::Symbol()
	{72, 284, 0, 0, Smoke::mf_static, 150, 5},	//930 Soprano::Vocabulary::NAO::Tag()
	{72, 334, 0, 0, Smoke::mf_static, 150, 6},	//931 Soprano::Vocabulary::NAO::altLabel()
	{72, 335, 0, 0, Smoke::mf_static, 150, 7},	//932 Soprano::Vocabulary::NAO::altSymbol()
	{72, 336, 0, 0, Smoke::mf_static, 150, 8},	//933 Soprano::Vocabulary::NAO::annotation()
	{72, 449, 0, 0, Smoke::mf_static, 150, 9},	//934 Soprano::Vocabulary::NAO::contributor()
	{72, 477, 0, 0, Smoke::mf_static, 150, 10},	//935 Soprano::Vocabulary::NAO::created()
	{72, 478, 0, 0, Smoke::mf_static, 150, 11},	//936 Soprano::Vocabulary::NAO::creator()
	{72, 501, 0, 0, Smoke::mf_static, 150, 12},	//937 Soprano::Vocabulary::NAO::description()
	{72, 546, 0, 0, Smoke::mf_static, 150, 13},	//938 Soprano::Vocabulary::NAO::engineeringTool()
	{72, 597, 0, 0, Smoke::mf_static, 150, 14},	//939 Soprano::Vocabulary::NAO::hasDefaultNamespace()
	{72, 598, 0, 0, Smoke::mf_static, 150, 15},	//940 Soprano::Vocabulary::NAO::hasDefaultNamespaceAbbreviation()
	{72, 601, 0, 0, Smoke::mf_static, 150, 16},	//941 Soprano::Vocabulary::NAO::hasSubResource()
	{72, 602, 0, 0, Smoke::mf_static, 150, 17},	//942 Soprano::Vocabulary::NAO::hasSuperResource()
	{72, 603, 0, 0, Smoke::mf_static, 150, 18},	//943 Soprano::Vocabulary::NAO::hasSymbol()
	{72, 604, 0, 0, Smoke::mf_static, 150, 19},	//944 Soprano::Vocabulary::NAO::hasTag()
	{72, 605, 0, 0, Smoke::mf_static, 150, 20},	//945 Soprano::Vocabulary::NAO::hasTopic()
	{72, 615, 0, 0, Smoke::mf_static, 150, 21},	//946 Soprano::Vocabulary::NAO::iconName()
	{72, 617, 0, 0, Smoke::mf_static, 150, 22},	//947 Soprano::Vocabulary::NAO::identifier()
	{72, 672, 0, 0, Smoke::mf_static, 150, 23},	//948 Soprano::Vocabulary::NAO::isRelated()
	{72, 680, 0, 0, Smoke::mf_static, 150, 24},	//949 Soprano::Vocabulary::NAO::isTagFor()
	{72, 682, 0, 0, Smoke::mf_static, 150, 25},	//950 Soprano::Vocabulary::NAO::isTopicOf()
	{72, 706, 0, 0, Smoke::mf_static, 150, 26},	//951 Soprano::Vocabulary::NAO::lastModified()
	{72, 769, 0, 0, Smoke::mf_static, 150, 27},	//952 Soprano::Vocabulary::NAO::modified()
	{72, 780, 0, 0, Smoke::mf_static, 150, 28},	//953 Soprano::Vocabulary::NAO::numericRating()
	{72, 853, 0, 0, Smoke::mf_static, 150, 29},	//954 Soprano::Vocabulary::NAO::personalIdentifier()
	{72, 858, 0, 0, Smoke::mf_static, 150, 30},	//955 Soprano::Vocabulary::NAO::pluralPrefLabel()
	{72, 863, 0, 0, Smoke::mf_static, 150, 31},	//956 Soprano::Vocabulary::NAO::prefLabel()
	{72, 864, 0, 0, Smoke::mf_static, 150, 32},	//957 Soprano::Vocabulary::NAO::prefSymbol()
	{72, 881, 0, 0, Smoke::mf_static, 150, 33},	//958 Soprano::Vocabulary::NAO::rating()
	{72, 945, 0, 0, Smoke::mf_static, 150, 34},	//959 Soprano::Vocabulary::NAO::score()
	{72, 946, 0, 0, Smoke::mf_static, 150, 35},	//960 Soprano::Vocabulary::NAO::scoreParameter()
	{72, 951, 0, 0, Smoke::mf_static, 150, 36},	//961 Soprano::Vocabulary::NAO::serializationLanguage()
	{72, 1047, 0, 0, Smoke::mf_static, 150, 37},	//962 Soprano::Vocabulary::NAO::status()
	{72, 1128, 0, 0, Smoke::mf_static, 150, 38},	//963 Soprano::Vocabulary::NAO::version()
	{73, 779, 0, 0, Smoke::mf_static, 150, 1},	//964 Soprano::Vocabulary::NRL::nrlNamespace()
	{73, 7, 0, 0, Smoke::mf_static, 150, 2},	//965 Soprano::Vocabulary::NRL::AsymmetricProperty()
	{73, 48, 0, 0, Smoke::mf_static, 150, 3},	//966 Soprano::Vocabulary::NRL::Configuration()
	{73, 72, 0, 0, Smoke::mf_static, 150, 4},	//967 Soprano::Vocabulary::NRL::Data()
	{73, 77, 0, 0, Smoke::mf_static, 150, 5},	//968 Soprano::Vocabulary::NRL::DefaultGraph()
	{73, 82, 0, 0, Smoke::mf_static, 150, 6},	//969 Soprano::Vocabulary::NRL::DocumentGraph()
	{73, 100, 0, 0, Smoke::mf_static, 150, 7},	//970 Soprano::Vocabulary::NRL::ExternalViewSpecification()
	{73, 108, 0, 0, Smoke::mf_static, 150, 8},	//971 Soprano::Vocabulary::NRL::FunctionalProperty()
	{73, 109, 0, 0, Smoke::mf_static, 150, 9},	//972 Soprano::Vocabulary::NRL::Graph()
	{73, 112, 0, 0, Smoke::mf_static, 150, 10},	//973 Soprano::Vocabulary::NRL::GraphMetadata()
	{73, 113, 0, 0, Smoke::mf_static, 150, 11},	//974 Soprano::Vocabulary::NRL::GraphView()
	{73, 126, 0, 0, Smoke::mf_static, 150, 12},	//975 Soprano::Vocabulary::NRL::InstanceBase()
	{73, 127, 0, 0, Smoke::mf_static, 150, 13},	//976 Soprano::Vocabulary::NRL::InverseFunctionalProperty()
	{73, 128, 0, 0, Smoke::mf_static, 150, 14},	//977 Soprano::Vocabulary::NRL::KnowledgeBase()
	{73, 178, 0, 0, Smoke::mf_static, 150, 15},	//978 Soprano::Vocabulary::NRL::Ontology()
	{73, 224, 0, 0, Smoke::mf_static, 150, 16},	//979 Soprano::Vocabulary::NRL::ReflexiveProperty()
	{73, 239, 0, 0, Smoke::mf_static, 150, 17},	//980 Soprano::Vocabulary::NRL::RuleViewSpecification()
	{73, 240, 0, 0, Smoke::mf_static, 150, 18},	//981 Soprano::Vocabulary::NRL::Schema()
	{73, 241, 0, 0, Smoke::mf_static, 150, 19},	//982 Soprano::Vocabulary::NRL::Semantics()
	{73, 282, 0, 0, Smoke::mf_static, 150, 20},	//983 Soprano::Vocabulary::NRL::SymmetricProperty()
	{73, 290, 0, 0, Smoke::mf_static, 150, 21},	//984 Soprano::Vocabulary::NRL::TransitiveProperty()
	{73, 293, 0, 0, Smoke::mf_static, 150, 22},	//985 Soprano::Vocabulary::NRL::ViewSpecification()
	{73, 382, 0, 0, Smoke::mf_static, 150, 23},	//986 Soprano::Vocabulary::NRL::cardinality()
	{73, 453, 0, 0, Smoke::mf_static, 150, 24},	//987 Soprano::Vocabulary::NRL::coreGraphMetadataFor()
	{73, 548, 0, 0, Smoke::mf_static, 150, 25},	//988 Soprano::Vocabulary::NRL::equivalentGraph()
	{73, 568, 0, 0, Smoke::mf_static, 150, 26},	//989 Soprano::Vocabulary::NRL::externalRealizer()
	{73, 595, 0, 0, Smoke::mf_static, 150, 27},	//990 Soprano::Vocabulary::NRL::graphMetadataFor()
	{73, 599, 0, 0, Smoke::mf_static, 150, 28},	//991 Soprano::Vocabulary::NRL::hasSemantics()
	{73, 600, 0, 0, Smoke::mf_static, 150, 29},	//992 Soprano::Vocabulary::NRL::hasSpecification()
	{73, 619, 0, 0, Smoke::mf_static, 150, 30},	//993 Soprano::Vocabulary::NRL::imports()
	{73, 632, 0, 0, Smoke::mf_static, 150, 31},	//994 Soprano::Vocabulary::NRL::inverseProperty()
	{73, 751, 0, 0, Smoke::mf_static, 150, 32},	//995 Soprano::Vocabulary::NRL::maxCardinality()
	{73, 765, 0, 0, Smoke::mf_static, 150, 33},	//996 Soprano::Vocabulary::NRL::minCardinality()
	{73, 884, 0, 0, Smoke::mf_static, 150, 34},	//997 Soprano::Vocabulary::NRL::realizes()
	{73, 936, 0, 0, Smoke::mf_static, 150, 35},	//998 Soprano::Vocabulary::NRL::rule()
	{73, 938, 0, 0, Smoke::mf_static, 150, 36},	//999 Soprano::Vocabulary::NRL::ruleLanguage()
	{73, 950, 0, 0, Smoke::mf_static, 150, 37},	//1000 Soprano::Vocabulary::NRL::semanticsDefinedBy()
	{73, 1053, 0, 0, Smoke::mf_static, 150, 38},	//1001 Soprano::Vocabulary::NRL::subGraphOf()
	{73, 1061, 0, 0, Smoke::mf_static, 150, 39},	//1002 Soprano::Vocabulary::NRL::superGraphOf()
	{73, 1111, 0, 0, Smoke::mf_static, 150, 40},	//1003 Soprano::Vocabulary::NRL::updatable()
	{73, 1138, 0, 0, Smoke::mf_static, 150, 41},	//1004 Soprano::Vocabulary::NRL::viewOn()
	{74, 826, 0, 0, Smoke::mf_static, 150, 1},	//1005 Soprano::Vocabulary::OWL::owlNamespace()
	{74, 1, 0, 0, Smoke::mf_static, 150, 2},	//1006 Soprano::Vocabulary::OWL::AllDifferent()
	{74, 4, 0, 0, Smoke::mf_static, 150, 3},	//1007 Soprano::Vocabulary::OWL::AnnotationProperty()
	{74, 46, 0, 0, Smoke::mf_static, 150, 4},	//1008 Soprano::Vocabulary::OWL::Class()
	{74, 74, 0, 0, Smoke::mf_static, 150, 5},	//1009 Soprano::Vocabulary::OWL::DataRange()
	{74, 76, 0, 0, Smoke::mf_static, 150, 6},	//1010 Soprano::Vocabulary::OWL::DatatypeProperty()
	{74, 79, 0, 0, Smoke::mf_static, 150, 7},	//1011 Soprano::Vocabulary::OWL::DeprecatedClass()
	{74, 80, 0, 0, Smoke::mf_static, 150, 8},	//1012 Soprano::Vocabulary::OWL::DeprecatedProperty()
	{74, 108, 0, 0, Smoke::mf_static, 150, 9},	//1013 Soprano::Vocabulary::OWL::FunctionalProperty()
	{74, 127, 0, 0, Smoke::mf_static, 150, 10},	//1014 Soprano::Vocabulary::OWL::InverseFunctionalProperty()
	{74, 175, 0, 0, Smoke::mf_static, 150, 11},	//1015 Soprano::Vocabulary::OWL::Nothing()
	{74, 176, 0, 0, Smoke::mf_static, 150, 12},	//1016 Soprano::Vocabulary::OWL::ObjectProperty()
	{74, 178, 0, 0, Smoke::mf_static, 150, 13},	//1017 Soprano::Vocabulary::OWL::Ontology()
	{74, 179, 0, 0, Smoke::mf_static, 150, 14},	//1018 Soprano::Vocabulary::OWL::OntologyProperty()
	{74, 230, 0, 0, Smoke::mf_static, 150, 15},	//1019 Soprano::Vocabulary::OWL::Restriction()
	{74, 282, 0, 0, Smoke::mf_static, 150, 16},	//1020 Soprano::Vocabulary::OWL::SymmetricProperty()
	{74, 289, 0, 0, Smoke::mf_static, 150, 17},	//1021 Soprano::Vocabulary::OWL::Thing()
	{74, 290, 0, 0, Smoke::mf_static, 150, 18},	//1022 Soprano::Vocabulary::OWL::TransitiveProperty()
	{74, 333, 0, 0, Smoke::mf_static, 150, 19},	//1023 Soprano::Vocabulary::OWL::allValuesFrom()
	{74, 357, 0, 0, Smoke::mf_static, 150, 20},	//1024 Soprano::Vocabulary::OWL::backwardCompatibleWith()
	{74, 382, 0, 0, Smoke::mf_static, 150, 21},	//1025 Soprano::Vocabulary::OWL::cardinality()
	{74, 409, 0, 0, Smoke::mf_static, 150, 22},	//1026 Soprano::Vocabulary::OWL::complementOf()
	{74, 502, 0, 0, Smoke::mf_static, 150, 23},	//1027 Soprano::Vocabulary::OWL::differentFrom()
	{74, 531, 0, 0, Smoke::mf_static, 150, 24},	//1028 Soprano::Vocabulary::OWL::disjointWith()
	{74, 532, 0, 0, Smoke::mf_static, 150, 25},	//1029 Soprano::Vocabulary::OWL::distinctMembers()
	{74, 547, 0, 0, Smoke::mf_static, 150, 26},	//1030 Soprano::Vocabulary::OWL::equivalentClass()
	{74, 549, 0, 0, Smoke::mf_static, 150, 27},	//1031 Soprano::Vocabulary::OWL::equivalentProperty()
	{74, 606, 0, 0, Smoke::mf_static, 150, 28},	//1032 Soprano::Vocabulary::OWL::hasValue()
	{74, 619, 0, 0, Smoke::mf_static, 150, 29},	//1033 Soprano::Vocabulary::OWL::imports()
	{74, 621, 0, 0, Smoke::mf_static, 150, 30},	//1034 Soprano::Vocabulary::OWL::incompatibleWith()
	{74, 630, 0, 0, Smoke::mf_static, 150, 31},	//1035 Soprano::Vocabulary::OWL::intersectionOf()
	{74, 631, 0, 0, Smoke::mf_static, 150, 32},	//1036 Soprano::Vocabulary::OWL::inverseOf()
	{74, 751, 0, 0, Smoke::mf_static, 150, 33},	//1037 Soprano::Vocabulary::OWL::maxCardinality()
	{74, 765, 0, 0, Smoke::mf_static, 150, 34},	//1038 Soprano::Vocabulary::OWL::minCardinality()
	{74, 784, 0, 0, Smoke::mf_static, 150, 35},	//1039 Soprano::Vocabulary::OWL::onProperty()
	{74, 785, 0, 0, Smoke::mf_static, 150, 36},	//1040 Soprano::Vocabulary::OWL::oneOf()
	{74, 867, 0, 0, Smoke::mf_static, 150, 37},	//1041 Soprano::Vocabulary::OWL::priorVersion()
	{74, 941, 0, 0, Smoke::mf_static, 150, 38},	//1042 Soprano::Vocabulary::OWL::sameAs()
	{74, 1028, 0, 0, Smoke::mf_static, 150, 39},	//1043 Soprano::Vocabulary::OWL::someValuesFrom()
	{74, 1105, 0, 0, Smoke::mf_static, 150, 40},	//1044 Soprano::Vocabulary::OWL::unionOf()
	{74, 1129, 0, 0, Smoke::mf_static, 150, 41},	//1045 Soprano::Vocabulary::OWL::versionInfo()
	{75, 882, 0, 0, Smoke::mf_static, 150, 1},	//1046 Soprano::Vocabulary::RDF::rdfNamespace()
	{75, 2, 0, 0, Smoke::mf_static, 150, 2},	//1047 Soprano::Vocabulary::RDF::Alt()
	{75, 38, 0, 0, Smoke::mf_static, 150, 3},	//1048 Soprano::Vocabulary::RDF::Bag()
	{75, 134, 0, 0, Smoke::mf_static, 150, 4},	//1049 Soprano::Vocabulary::RDF::List()
	{75, 198, 0, 0, Smoke::mf_static, 150, 5},	//1050 Soprano::Vocabulary::RDF::Property()
	{75, 242, 0, 0, Smoke::mf_static, 150, 6},	//1051 Soprano::Vocabulary::RDF::Seq()
	{75, 270, 0, 0, Smoke::mf_static, 150, 7},	//1052 Soprano::Vocabulary::RDF::Statement()
	{75, 296, 0, 0, Smoke::mf_static, 150, 8},	//1053 Soprano::Vocabulary::RDF::XMLLiteral()
	{75, 575, 0, 0, Smoke::mf_static, 150, 9},	//1054 Soprano::Vocabulary::RDF::first()
	{75, 775, 0, 0, Smoke::mf_static, 150, 10},	//1055 Soprano::Vocabulary::RDF::nil()
	{75, 781, 0, 0, Smoke::mf_static, 150, 11},	//1056 Soprano::Vocabulary::RDF::object()
	{75, 861, 0, 0, Smoke::mf_static, 150, 12},	//1057 Soprano::Vocabulary::RDF::predicate()
	{75, 931, 0, 0, Smoke::mf_static, 150, 13},	//1058 Soprano::Vocabulary::RDF::rest()
	{75, 1058, 0, 0, Smoke::mf_static, 150, 14},	//1059 Soprano::Vocabulary::RDF::subject()
	{75, 1101, 0, 0, Smoke::mf_static, 150, 15},	//1060 Soprano::Vocabulary::RDF::type()
	{75, 1121, 0, 0, Smoke::mf_static, 150, 16},	//1061 Soprano::Vocabulary::RDF::value()
	{76, 883, 0, 0, Smoke::mf_static, 150, 1},	//1062 Soprano::Vocabulary::RDFS::rdfsNamespace()
	{76, 46, 0, 0, Smoke::mf_static, 150, 2},	//1063 Soprano::Vocabulary::RDFS::Class()
	{76, 51, 0, 0, Smoke::mf_static, 150, 3},	//1064 Soprano::Vocabulary::RDFS::Container()
	{76, 52, 0, 0, Smoke::mf_static, 150, 4},	//1065 Soprano::Vocabulary::RDFS::ContainerMembershipProperty()
	{76, 75, 0, 0, Smoke::mf_static, 150, 5},	//1066 Soprano::Vocabulary::RDFS::Datatype()
	{76, 135, 0, 0, Smoke::mf_static, 150, 6},	//1067 Soprano::Vocabulary::RDFS::Literal()
	{76, 228, 0, 0, Smoke::mf_static, 150, 7},	//1068 Soprano::Vocabulary::RDFS::Resource()
	{76, 405, 0, 0, Smoke::mf_static, 150, 8},	//1069 Soprano::Vocabulary::RDFS::comment()
	{76, 536, 0, 0, Smoke::mf_static, 150, 9},	//1070 Soprano::Vocabulary::RDFS::domain()
	{76, 645, 0, 0, Smoke::mf_static, 150, 10},	//1071 Soprano::Vocabulary::RDFS::isDefinedBy()
	{76, 704, 0, 0, Smoke::mf_static, 150, 11},	//1072 Soprano::Vocabulary::RDFS::label()
	{76, 757, 0, 0, Smoke::mf_static, 150, 12},	//1073 Soprano::Vocabulary::RDFS::member()
	{76, 879, 0, 0, Smoke::mf_static, 150, 13},	//1074 Soprano::Vocabulary::RDFS::range()
	{76, 948, 0, 0, Smoke::mf_static, 150, 14},	//1075 Soprano::Vocabulary::RDFS::seeAlso()
	{76, 1050, 0, 0, Smoke::mf_static, 150, 15},	//1076 Soprano::Vocabulary::RDFS::subClassOf()
	{76, 1054, 0, 0, Smoke::mf_static, 150, 16},	//1077 Soprano::Vocabulary::RDFS::subPropertyOf()
	{77, 1026, 0, 0, Smoke::mf_static, 150, 1},	//1078 Soprano::Vocabulary::SIL::silNamespace()
	{77, 123, 0, 0, Smoke::mf_static, 150, 2},	//1079 Soprano::Vocabulary::SIL::InferenceMetaData()
	{77, 122, 0, 0, Smoke::mf_static, 150, 3},	//1080 Soprano::Vocabulary::SIL::InferenceGraph()
	{77, 1031, 0, 0, Smoke::mf_static, 150, 4},	//1081 Soprano::Vocabulary::SIL::sourceStatement()
	{77, 448, 0, 0, Smoke::mf_static, 150, 5},	//1082 Soprano::Vocabulary::SIL::context()
	{78, 1153, 0, 0, Smoke::mf_static, 150, 1},	//1083 Soprano::Vocabulary::XMLSchema::xsdNamespace()
	{78, 1151, 0, 0, Smoke::mf_static, 150, 2},	//1084 Soprano::Vocabulary::XMLSchema::xsdInt()
	{78, 627, 0, 0, Smoke::mf_static, 150, 3},	//1085 Soprano::Vocabulary::XMLSchema::integer()
	{78, 773, 0, 0, Smoke::mf_static, 150, 4},	//1086 Soprano::Vocabulary::XMLSchema::negativeInteger()
	{78, 778, 0, 0, Smoke::mf_static, 150, 5},	//1087 Soprano::Vocabulary::XMLSchema::nonNegativeInteger()
	{78, 490, 0, 0, Smoke::mf_static, 150, 6},	//1088 Soprano::Vocabulary::XMLSchema::decimal()
	{78, 1154, 0, 0, Smoke::mf_static, 150, 7},	//1089 Soprano::Vocabulary::XMLSchema::xsdShort()
	{78, 1152, 0, 0, Smoke::mf_static, 150, 8},	//1090 Soprano::Vocabulary::XMLSchema::xsdLong()
	{78, 1108, 0, 0, Smoke::mf_static, 150, 9},	//1091 Soprano::Vocabulary::XMLSchema::unsignedInt()
	{78, 1110, 0, 0, Smoke::mf_static, 150, 10},	//1092 Soprano::Vocabulary::XMLSchema::unsignedShort()
	{78, 1109, 0, 0, Smoke::mf_static, 150, 11},	//1093 Soprano::Vocabulary::XMLSchema::unsignedLong()
	{78, 1049, 0, 0, Smoke::mf_static, 150, 12},	//1094 Soprano::Vocabulary::XMLSchema::string()
	{78, 1150, 0, 0, Smoke::mf_static, 150, 13},	//1095 Soprano::Vocabulary::XMLSchema::xsdFloat()
	{78, 1149, 0, 0, Smoke::mf_static, 150, 14},	//1096 Soprano::Vocabulary::XMLSchema::xsdDouble()
	{78, 376, 0, 0, Smoke::mf_static, 150, 15},	//1097 Soprano::Vocabulary::XMLSchema::boolean()
	{78, 487, 0, 0, Smoke::mf_static, 150, 16},	//1098 Soprano::Vocabulary::XMLSchema::date()
	{78, 488, 0, 0, Smoke::mf_static, 150, 17},	//1099 Soprano::Vocabulary::XMLSchema::dateTime()
	{78, 1074, 0, 0, Smoke::mf_static, 150, 18},	//1100 Soprano::Vocabulary::XMLSchema::time()
	{78, 358, 0, 0, Smoke::mf_static, 150, 19},	//1101 Soprano::Vocabulary::XMLSchema::base64Binary()
	{79, 1148, 0, 0, Smoke::mf_static, 150, 1},	//1102 Soprano::Vocabulary::Xesam::xesamNamespace()
	{79, 1147, 0, 0, Smoke::mf_static, 150, 2},	//1103 Soprano::Vocabulary::Xesam::xesam35mmEquivalent()
	{79, 3, 0, 0, Smoke::mf_static, 150, 3},	//1104 Soprano::Vocabulary::Xesam::Annotation()
	{79, 5, 0, 0, Smoke::mf_static, 150, 4},	//1105 Soprano::Vocabulary::Xesam::Archive()
	{79, 6, 0, 0, Smoke::mf_static, 150, 5},	//1106 Soprano::Vocabulary::Xesam::ArchivedFile()
	{79, 10, 0, 0, Smoke::mf_static, 150, 6},	//1107 Soprano::Vocabulary::Xesam::Audio()
	{79, 11, 0, 0, Smoke::mf_static, 150, 7},	//1108 Soprano::Vocabulary::Xesam::AudioList()
	{79, 42, 0, 0, Smoke::mf_static, 150, 8},	//1109 Soprano::Vocabulary::Xesam::BlockDevice()
	{79, 43, 0, 0, Smoke::mf_static, 150, 9},	//1110 Soprano::Vocabulary::Xesam::Bookmark()
	{79, 47, 0, 0, Smoke::mf_static, 150, 10},	//1111 Soprano::Vocabulary::Xesam::CommunicationChannel()
	{79, 49, 0, 0, Smoke::mf_static, 150, 11},	//1112 Soprano::Vocabulary::Xesam::Contact()
	{79, 50, 0, 0, Smoke::mf_static, 150, 12},	//1113 Soprano::Vocabulary::Xesam::ContactGroup()
	{79, 53, 0, 0, Smoke::mf_static, 150, 13},	//1114 Soprano::Vocabulary::Xesam::Content()
	{79, 73, 0, 0, Smoke::mf_static, 150, 14},	//1115 Soprano::Vocabulary::Xesam::DataObject()
	{79, 78, 0, 0, Smoke::mf_static, 150, 15},	//1116 Soprano::Vocabulary::Xesam::DeletedFile()
	{79, 81, 0, 0, Smoke::mf_static, 150, 16},	//1117 Soprano::Vocabulary::Xesam::Document()
	{79, 83, 0, 0, Smoke::mf_static, 150, 17},	//1118 Soprano::Vocabulary::Xesam::Documentation()
	{79, 84, 0, 0, Smoke::mf_static, 150, 18},	//1119 Soprano::Vocabulary::Xesam::Email()
	{79, 85, 0, 0, Smoke::mf_static, 150, 19},	//1120 Soprano::Vocabulary::Xesam::EmailAttachment()
	{79, 86, 0, 0, Smoke::mf_static, 150, 20},	//1121 Soprano::Vocabulary::Xesam::EmbeddedObject()
	{79, 101, 0, 0, Smoke::mf_static, 150, 21},	//1122 Soprano::Vocabulary::Xesam::File()
	{79, 102, 0, 0, Smoke::mf_static, 150, 22},	//1123 Soprano::Vocabulary::Xesam::FileSystem()
	{79, 103, 0, 0, Smoke::mf_static, 150, 23},	//1124 Soprano::Vocabulary::Xesam::Filelike()
	{79, 106, 0, 0, Smoke::mf_static, 150, 24},	//1125 Soprano::Vocabulary::Xesam::Folder()
	{79, 114, 0, 0, Smoke::mf_static, 150, 25},	//1126 Soprano::Vocabulary::Xesam::IMAP4Message()
	{79, 115, 0, 0, Smoke::mf_static, 150, 26},	//1127 Soprano::Vocabulary::Xesam::IMMessage()
	{79, 116, 0, 0, Smoke::mf_static, 150, 27},	//1128 Soprano::Vocabulary::Xesam::Image()
	{79, 150, 0, 0, Smoke::mf_static, 150, 28},	//1129 Soprano::Vocabulary::Xesam::MailingList()
	{79, 151, 0, 0, Smoke::mf_static, 150, 29},	//1130 Soprano::Vocabulary::Xesam::MailingListEmail()
	{79, 154, 0, 0, Smoke::mf_static, 150, 30},	//1131 Soprano::Vocabulary::Xesam::Media()
	{79, 155, 0, 0, Smoke::mf_static, 150, 31},	//1132 Soprano::Vocabulary::Xesam::MediaList()
	{79, 156, 0, 0, Smoke::mf_static, 150, 32},	//1133 Soprano::Vocabulary::Xesam::Message()
	{79, 157, 0, 0, Smoke::mf_static, 150, 33},	//1134 Soprano::Vocabulary::Xesam::MessageboxMessage()
	{79, 160, 0, 0, Smoke::mf_static, 150, 34},	//1135 Soprano::Vocabulary::Xesam::Music()
	{79, 165, 0, 0, Smoke::mf_static, 150, 35},	//1136 Soprano::Vocabulary::Xesam::NewsGroup()
	{79, 166, 0, 0, Smoke::mf_static, 150, 36},	//1137 Soprano::Vocabulary::Xesam::NewsGroupEmail()
	{79, 177, 0, 0, Smoke::mf_static, 150, 37},	//1138 Soprano::Vocabulary::Xesam::OfflineMedia()
	{79, 180, 0, 0, Smoke::mf_static, 150, 38},	//1139 Soprano::Vocabulary::Xesam::Organization()
	{79, 181, 0, 0, Smoke::mf_static, 150, 39},	//1140 Soprano::Vocabulary::Xesam::POP3Message()
	{79, 189, 0, 0, Smoke::mf_static, 150, 40},	//1141 Soprano::Vocabulary::Xesam::Person()
	{79, 190, 0, 0, Smoke::mf_static, 150, 41},	//1142 Soprano::Vocabulary::Xesam::PersonalEmail()
	{79, 191, 0, 0, Smoke::mf_static, 150, 42},	//1143 Soprano::Vocabulary::Xesam::Photo()
	{79, 196, 0, 0, Smoke::mf_static, 150, 43},	//1144 Soprano::Vocabulary::Xesam::Presentation()
	{79, 197, 0, 0, Smoke::mf_static, 150, 44},	//1145 Soprano::Vocabulary::Xesam::Project()
	{79, 216, 0, 0, Smoke::mf_static, 150, 45},	//1146 Soprano::Vocabulary::Xesam::RSSFeed()
	{79, 217, 0, 0, Smoke::mf_static, 150, 46},	//1147 Soprano::Vocabulary::Xesam::RSSMessage()
	{79, 225, 0, 0, Smoke::mf_static, 150, 47},	//1148 Soprano::Vocabulary::Xesam::RemoteFile()
	{79, 226, 0, 0, Smoke::mf_static, 150, 48},	//1149 Soprano::Vocabulary::Xesam::RemoteMessageboxMessage()
	{79, 227, 0, 0, Smoke::mf_static, 150, 49},	//1150 Soprano::Vocabulary::Xesam::RemoteResource()
	{79, 231, 0, 0, Smoke::mf_static, 150, 50},	//1151 Soprano::Vocabulary::Xesam::RevisionControlledFile()
	{79, 232, 0, 0, Smoke::mf_static, 150, 51},	//1152 Soprano::Vocabulary::Xesam::RevisionControlledRepository()
	{79, 261, 0, 0, Smoke::mf_static, 150, 52},	//1153 Soprano::Vocabulary::Xesam::SoftwarePackage()
	{79, 262, 0, 0, Smoke::mf_static, 150, 53},	//1154 Soprano::Vocabulary::Xesam::Source()
	{79, 263, 0, 0, Smoke::mf_static, 150, 54},	//1155 Soprano::Vocabulary::Xesam::SourceCode()
	{79, 269, 0, 0, Smoke::mf_static, 150, 55},	//1156 Soprano::Vocabulary::Xesam::Spreadsheet()
	{79, 283, 0, 0, Smoke::mf_static, 150, 56},	//1157 Soprano::Vocabulary::Xesam::SystemResource()
	{79, 284, 0, 0, Smoke::mf_static, 150, 57},	//1158 Soprano::Vocabulary::Xesam::Tag()
	{79, 287, 0, 0, Smoke::mf_static, 150, 58},	//1159 Soprano::Vocabulary::Xesam::Text()
	{79, 288, 0, 0, Smoke::mf_static, 150, 59},	//1160 Soprano::Vocabulary::Xesam::TextDocument()
	{79, 291, 0, 0, Smoke::mf_static, 150, 60},	//1161 Soprano::Vocabulary::Xesam::UncategorizedText()
	{79, 292, 0, 0, Smoke::mf_static, 150, 61},	//1162 Soprano::Vocabulary::Xesam::Video()
	{79, 294, 0, 0, Smoke::mf_static, 150, 62},	//1163 Soprano::Vocabulary::Xesam::Visual()
	{79, 295, 0, 0, Smoke::mf_static, 150, 63},	//1164 Soprano::Vocabulary::Xesam::XML()
	{79, 297, 0, 0, Smoke::mf_static, 150, 64},	//1165 Soprano::Vocabulary::Xesam::acl()
	{79, 320, 0, 0, Smoke::mf_static, 150, 65},	//1166 Soprano::Vocabulary::Xesam::album()
	{79, 321, 0, 0, Smoke::mf_static, 150, 66},	//1167 Soprano::Vocabulary::Xesam::albumArtist()
	{79, 322, 0, 0, Smoke::mf_static, 150, 67},	//1168 Soprano::Vocabulary::Xesam::albumGain()
	{79, 323, 0, 0, Smoke::mf_static, 150, 68},	//1169 Soprano::Vocabulary::Xesam::albumPeakGain()
	{79, 324, 0, 0, Smoke::mf_static, 150, 69},	//1170 Soprano::Vocabulary::Xesam::albumTrackCount()
	{79, 337, 0, 0, Smoke::mf_static, 150, 70},	//1171 Soprano::Vocabulary::Xesam::aperture()
	{79, 338, 0, 0, Smoke::mf_static, 150, 71},	//1172 Soprano::Vocabulary::Xesam::artist()
	{79, 339, 0, 0, Smoke::mf_static, 150, 72},	//1173 Soprano::Vocabulary::Xesam::asText()
	{79, 340, 0, 0, Smoke::mf_static, 150, 73},	//1174 Soprano::Vocabulary::Xesam::aspectRatio()
	{79, 344, 0, 0, Smoke::mf_static, 150, 74},	//1175 Soprano::Vocabulary::Xesam::attachmentEncoding()
	{79, 345, 0, 0, Smoke::mf_static, 150, 75},	//1176 Soprano::Vocabulary::Xesam::audioBPM()
	{79, 346, 0, 0, Smoke::mf_static, 150, 76},	//1177 Soprano::Vocabulary::Xesam::audioBitrate()
	{79, 347, 0, 0, Smoke::mf_static, 150, 77},	//1178 Soprano::Vocabulary::Xesam::audioChannels()
	{79, 348, 0, 0, Smoke::mf_static, 150, 78},	//1179 Soprano::Vocabulary::Xesam::audioCodec()
	{79, 349, 0, 0, Smoke::mf_static, 150, 79},	//1180 Soprano::Vocabulary::Xesam::audioCodecType()
	{79, 350, 0, 0, Smoke::mf_static, 150, 80},	//1181 Soprano::Vocabulary::Xesam::audioSampleBitDepth()
	{79, 351, 0, 0, Smoke::mf_static, 150, 81},	//1182 Soprano::Vocabulary::Xesam::audioSampleCount()
	{79, 352, 0, 0, Smoke::mf_static, 150, 82},	//1183 Soprano::Vocabulary::Xesam::audioSampleDataType()
	{79, 353, 0, 0, Smoke::mf_static, 150, 83},	//1184 Soprano::Vocabulary::Xesam::audioSampleRate()
	{79, 354, 0, 0, Smoke::mf_static, 150, 84},	//1185 Soprano::Vocabulary::Xesam::author()
	{79, 355, 0, 0, Smoke::mf_static, 150, 85},	//1186 Soprano::Vocabulary::Xesam::autoRating()
	{79, 359, 0, 0, Smoke::mf_static, 150, 86},	//1187 Soprano::Vocabulary::Xesam::baseRevisionID()
	{79, 360, 0, 0, Smoke::mf_static, 150, 87},	//1188 Soprano::Vocabulary::Xesam::bcc()
	{79, 371, 0, 0, Smoke::mf_static, 150, 88},	//1189 Soprano::Vocabulary::Xesam::birthDate()
	{79, 374, 0, 0, Smoke::mf_static, 150, 89},	//1190 Soprano::Vocabulary::Xesam::blogContactURL()
	{79, 380, 0, 0, Smoke::mf_static, 150, 90},	//1191 Soprano::Vocabulary::Xesam::cameraManufacturer()
	{79, 381, 0, 0, Smoke::mf_static, 150, 91},	//1192 Soprano::Vocabulary::Xesam::cameraModel()
	{79, 383, 0, 0, Smoke::mf_static, 150, 92},	//1193 Soprano::Vocabulary::Xesam::cc()
	{79, 384, 0, 0, Smoke::mf_static, 150, 93},	//1194 Soprano::Vocabulary::Xesam::ccdWidth()
	{79, 385, 0, 0, Smoke::mf_static, 150, 94},	//1195 Soprano::Vocabulary::Xesam::cellPhoneNumber()
	{79, 386, 0, 0, Smoke::mf_static, 150, 95},	//1196 Soprano::Vocabulary::Xesam::changeCommitTime()
	{79, 387, 0, 0, Smoke::mf_static, 150, 96},	//1197 Soprano::Vocabulary::Xesam::changeCommitter()
	{79, 388, 0, 0, Smoke::mf_static, 150, 97},	//1198 Soprano::Vocabulary::Xesam::characterCount()
	{79, 389, 0, 0, Smoke::mf_static, 150, 98},	//1199 Soprano::Vocabulary::Xesam::charset()
	{79, 390, 0, 0, Smoke::mf_static, 150, 99},	//1200 Soprano::Vocabulary::Xesam::chatRoom()
	{79, 401, 0, 0, Smoke::mf_static, 150, 100},	//1201 Soprano::Vocabulary::Xesam::colorCount()
	{79, 402, 0, 0, Smoke::mf_static, 150, 101},	//1202 Soprano::Vocabulary::Xesam::colorSpace()
	{79, 404, 0, 0, Smoke::mf_static, 150, 102},	//1203 Soprano::Vocabulary::Xesam::columnCount()
	{79, 405, 0, 0, Smoke::mf_static, 150, 103},	//1204 Soprano::Vocabulary::Xesam::comment()
	{79, 406, 0, 0, Smoke::mf_static, 150, 104},	//1205 Soprano::Vocabulary::Xesam::commentCharacterCount()
	{79, 407, 0, 0, Smoke::mf_static, 150, 105},	//1206 Soprano::Vocabulary::Xesam::commitDiff()
	{79, 408, 0, 0, Smoke::mf_static, 150, 106},	//1207 Soprano::Vocabulary::Xesam::communicationChannel()
	{79, 410, 0, 0, Smoke::mf_static, 150, 107},	//1208 Soprano::Vocabulary::Xesam::composer()
	{79, 411, 0, 0, Smoke::mf_static, 150, 108},	//1209 Soprano::Vocabulary::Xesam::compressionAlgorithm()
	{79, 412, 0, 0, Smoke::mf_static, 150, 109},	//1210 Soprano::Vocabulary::Xesam::compressionLevel()
	{79, 413, 0, 0, Smoke::mf_static, 150, 110},	//1211 Soprano::Vocabulary::Xesam::conflicts()
	{79, 420, 0, 0, Smoke::mf_static, 150, 111},	//1212 Soprano::Vocabulary::Xesam::contactMedium()
	{79, 421, 0, 0, Smoke::mf_static, 150, 112},	//1213 Soprano::Vocabulary::Xesam::contactNick()
	{79, 422, 0, 0, Smoke::mf_static, 150, 113},	//1214 Soprano::Vocabulary::Xesam::contactURL()
	{79, 423, 0, 0, Smoke::mf_static, 150, 114},	//1215 Soprano::Vocabulary::Xesam::contains()
	{79, 443, 0, 0, Smoke::mf_static, 150, 115},	//1216 Soprano::Vocabulary::Xesam::contentComment()
	{79, 444, 0, 0, Smoke::mf_static, 150, 116},	//1217 Soprano::Vocabulary::Xesam::contentCreated()
	{79, 445, 0, 0, Smoke::mf_static, 150, 117},	//1218 Soprano::Vocabulary::Xesam::contentKeyword()
	{79, 446, 0, 0, Smoke::mf_static, 150, 118},	//1219 Soprano::Vocabulary::Xesam::contentModified()
	{79, 447, 0, 0, Smoke::mf_static, 150, 119},	//1220 Soprano::Vocabulary::Xesam::contentType()
	{79, 449, 0, 0, Smoke::mf_static, 150, 120},	//1221 Soprano::Vocabulary::Xesam::contributor()
	{79, 452, 0, 0, Smoke::mf_static, 150, 121},	//1222 Soprano::Vocabulary::Xesam::copyright()
	{79, 478, 0, 0, Smoke::mf_static, 150, 122},	//1223 Soprano::Vocabulary::Xesam::creator()
	{79, 492, 0, 0, Smoke::mf_static, 150, 123},	//1224 Soprano::Vocabulary::Xesam::definesClass()
	{79, 493, 0, 0, Smoke::mf_static, 150, 124},	//1225 Soprano::Vocabulary::Xesam::definesFunction()
	{79, 494, 0, 0, Smoke::mf_static, 150, 125},	//1226 Soprano::Vocabulary::Xesam::definesGlobalVariable()
	{79, 498, 0, 0, Smoke::mf_static, 150, 126},	//1227 Soprano::Vocabulary::Xesam::deletionTime()
	{79, 499, 0, 0, Smoke::mf_static, 150, 127},	//1228 Soprano::Vocabulary::Xesam::depends()
	{79, 500, 0, 0, Smoke::mf_static, 150, 128},	//1229 Soprano::Vocabulary::Xesam::derivedFrom()
	{79, 501, 0, 0, Smoke::mf_static, 150, 129},	//1230 Soprano::Vocabulary::Xesam::description()
	{79, 511, 0, 0, Smoke::mf_static, 150, 130},	//1231 Soprano::Vocabulary::Xesam::discNumber()
	{79, 512, 0, 0, Smoke::mf_static, 150, 131},	//1232 Soprano::Vocabulary::Xesam::disclaimer()
	{79, 533, 0, 0, Smoke::mf_static, 150, 132},	//1233 Soprano::Vocabulary::Xesam::documentCategory()
	{79, 541, 0, 0, Smoke::mf_static, 150, 133},	//1234 Soprano::Vocabulary::Xesam::emailAddress()
	{79, 565, 0, 0, Smoke::mf_static, 150, 134},	//1235 Soprano::Vocabulary::Xesam::exposureBias()
	{79, 566, 0, 0, Smoke::mf_static, 150, 135},	//1236 Soprano::Vocabulary::Xesam::exposureProgram()
	{79, 567, 0, 0, Smoke::mf_static, 150, 136},	//1237 Soprano::Vocabulary::Xesam::exposureTime()
	{79, 569, 0, 0, Smoke::mf_static, 150, 137},	//1238 Soprano::Vocabulary::Xesam::familyName()
	{79, 570, 0, 0, Smoke::mf_static, 150, 138},	//1239 Soprano::Vocabulary::Xesam::faxPhoneNumber()
	{79, 571, 0, 0, Smoke::mf_static, 150, 139},	//1240 Soprano::Vocabulary::Xesam::fileExtension()
	{79, 573, 0, 0, Smoke::mf_static, 150, 140},	//1241 Soprano::Vocabulary::Xesam::fileSystemType()
	{79, 574, 0, 0, Smoke::mf_static, 150, 141},	//1242 Soprano::Vocabulary::Xesam::fingerprint()
	{79, 576, 0, 0, Smoke::mf_static, 150, 142},	//1243 Soprano::Vocabulary::Xesam::firstUsed()
	{79, 577, 0, 0, Smoke::mf_static, 150, 143},	//1244 Soprano::Vocabulary::Xesam::flashUsed()
	{79, 578, 0, 0, Smoke::mf_static, 150, 144},	//1245 Soprano::Vocabulary::Xesam::focalLength()
	{79, 579, 0, 0, Smoke::mf_static, 150, 145},	//1246 Soprano::Vocabulary::Xesam::focusDistance()
	{79, 581, 0, 0, Smoke::mf_static, 150, 146},	//1247 Soprano::Vocabulary::Xesam::formatSubtype()
	{79, 582, 0, 0, Smoke::mf_static, 150, 147},	//1248 Soprano::Vocabulary::Xesam::frameCount()
	{79, 583, 0, 0, Smoke::mf_static, 150, 148},	//1249 Soprano::Vocabulary::Xesam::frameRate()
	{79, 584, 0, 0, Smoke::mf_static, 150, 149},	//1250 Soprano::Vocabulary::Xesam::freeSpace()
	{79, 588, 0, 0, Smoke::mf_static, 150, 150},	//1251 Soprano::Vocabulary::Xesam::gender()
	{79, 589, 0, 0, Smoke::mf_static, 150, 151},	//1252 Soprano::Vocabulary::Xesam::generator()
	{79, 590, 0, 0, Smoke::mf_static, 150, 152},	//1253 Soprano::Vocabulary::Xesam::generatorOptions()
	{79, 591, 0, 0, Smoke::mf_static, 150, 153},	//1254 Soprano::Vocabulary::Xesam::genre()
	{79, 594, 0, 0, Smoke::mf_static, 150, 154},	//1255 Soprano::Vocabulary::Xesam::givenName()
	{79, 596, 0, 0, Smoke::mf_static, 150, 155},	//1256 Soprano::Vocabulary::Xesam::group()
	{79, 607, 0, 0, Smoke::mf_static, 150, 156},	//1257 Soprano::Vocabulary::Xesam::height()
	{79, 608, 0, 0, Smoke::mf_static, 150, 157},	//1258 Soprano::Vocabulary::Xesam::homeEmailAddress()
	{79, 609, 0, 0, Smoke::mf_static, 150, 158},	//1259 Soprano::Vocabulary::Xesam::homePhoneNumber()
	{79, 610, 0, 0, Smoke::mf_static, 150, 159},	//1260 Soprano::Vocabulary::Xesam::homePostalAddress()
	{79, 611, 0, 0, Smoke::mf_static, 150, 160},	//1261 Soprano::Vocabulary::Xesam::homepageContactURL()
	{79, 612, 0, 0, Smoke::mf_static, 150, 161},	//1262 Soprano::Vocabulary::Xesam::honorificPrefix()
	{79, 613, 0, 0, Smoke::mf_static, 150, 162},	//1263 Soprano::Vocabulary::Xesam::honorificSuffix()
	{79, 614, 0, 0, Smoke::mf_static, 150, 163},	//1264 Soprano::Vocabulary::Xesam::horizontalResolution()
	{79, 616, 0, 0, Smoke::mf_static, 150, 164},	//1265 Soprano::Vocabulary::Xesam::id()
	{79, 618, 0, 0, Smoke::mf_static, 150, 165},	//1266 Soprano::Vocabulary::Xesam::imContactMedium()
	{79, 620, 0, 0, Smoke::mf_static, 150, 166},	//1267 Soprano::Vocabulary::Xesam::inReplyTo()
	{79, 628, 0, 0, Smoke::mf_static, 150, 167},	//1268 Soprano::Vocabulary::Xesam::interest()
	{79, 629, 0, 0, Smoke::mf_static, 150, 168},	//1269 Soprano::Vocabulary::Xesam::interlaceMode()
	{79, 633, 0, 0, Smoke::mf_static, 150, 169},	//1270 Soprano::Vocabulary::Xesam::ircContactMedium()
	{79, 642, 0, 0, Smoke::mf_static, 150, 170},	//1271 Soprano::Vocabulary::Xesam::isContentEncrypted()
	{79, 655, 0, 0, Smoke::mf_static, 150, 171},	//1272 Soprano::Vocabulary::Xesam::isEncrypted()
	{79, 657, 0, 0, Smoke::mf_static, 150, 172},	//1273 Soprano::Vocabulary::Xesam::isImportant()
	{79, 658, 0, 0, Smoke::mf_static, 150, 173},	//1274 Soprano::Vocabulary::Xesam::isInProgress()
	{79, 670, 0, 0, Smoke::mf_static, 150, 174},	//1275 Soprano::Vocabulary::Xesam::isPublicChannel()
	{79, 671, 0, 0, Smoke::mf_static, 150, 175},	//1276 Soprano::Vocabulary::Xesam::isRead()
	{79, 674, 0, 0, Smoke::mf_static, 150, 176},	//1277 Soprano::Vocabulary::Xesam::isSourceEncrypted()
	{79, 689, 0, 0, Smoke::mf_static, 150, 177},	//1278 Soprano::Vocabulary::Xesam::isoEquivalent()
	{79, 701, 0, 0, Smoke::mf_static, 150, 178},	//1279 Soprano::Vocabulary::Xesam::jabberContactMedium()
	{79, 702, 0, 0, Smoke::mf_static, 150, 179},	//1280 Soprano::Vocabulary::Xesam::keyword()
	{79, 703, 0, 0, Smoke::mf_static, 150, 180},	//1281 Soprano::Vocabulary::Xesam::knows()
	{79, 705, 0, 0, Smoke::mf_static, 150, 181},	//1282 Soprano::Vocabulary::Xesam::language()
	{79, 707, 0, 0, Smoke::mf_static, 150, 182},	//1283 Soprano::Vocabulary::Xesam::lastRefreshed()
	{79, 708, 0, 0, Smoke::mf_static, 150, 183},	//1284 Soprano::Vocabulary::Xesam::lastUsed()
	{79, 709, 0, 0, Smoke::mf_static, 150, 184},	//1285 Soprano::Vocabulary::Xesam::legal()
	{79, 710, 0, 0, Smoke::mf_static, 150, 185},	//1286 Soprano::Vocabulary::Xesam::license()
	{79, 711, 0, 0, Smoke::mf_static, 150, 186},	//1287 Soprano::Vocabulary::Xesam::licenseType()
	{79, 713, 0, 0, Smoke::mf_static, 150, 187},	//1288 Soprano::Vocabulary::Xesam::lineCount()
	{79, 714, 0, 0, Smoke::mf_static, 150, 188},	//1289 Soprano::Vocabulary::Xesam::links()
	{79, 732, 0, 0, Smoke::mf_static, 150, 189},	//1290 Soprano::Vocabulary::Xesam::localRevision()
	{79, 741, 0, 0, Smoke::mf_static, 150, 190},	//1291 Soprano::Vocabulary::Xesam::lyricist()
	{79, 742, 0, 0, Smoke::mf_static, 150, 191},	//1292 Soprano::Vocabulary::Xesam::mailingList()
	{79, 743, 0, 0, Smoke::mf_static, 150, 192},	//1293 Soprano::Vocabulary::Xesam::mailingPostalAddress()
	{79, 744, 0, 0, Smoke::mf_static, 150, 193},	//1294 Soprano::Vocabulary::Xesam::maintainer()
	{79, 745, 0, 0, Smoke::mf_static, 150, 194},	//1295 Soprano::Vocabulary::Xesam::markupCharacterCount()
	{79, 752, 0, 0, Smoke::mf_static, 150, 195},	//1296 Soprano::Vocabulary::Xesam::md5Hash()
	{79, 753, 0, 0, Smoke::mf_static, 150, 196},	//1297 Soprano::Vocabulary::Xesam::mediaBitrate()
	{79, 754, 0, 0, Smoke::mf_static, 150, 197},	//1298 Soprano::Vocabulary::Xesam::mediaCodec()
	{79, 755, 0, 0, Smoke::mf_static, 150, 198},	//1299 Soprano::Vocabulary::Xesam::mediaCodecType()
	{79, 756, 0, 0, Smoke::mf_static, 150, 199},	//1300 Soprano::Vocabulary::Xesam::mediaDuration()
	{79, 758, 0, 0, Smoke::mf_static, 150, 200},	//1301 Soprano::Vocabulary::Xesam::mergeConflict()
	{79, 761, 0, 0, Smoke::mf_static, 150, 201},	//1302 Soprano::Vocabulary::Xesam::meteringMode()
	{79, 762, 0, 0, Smoke::mf_static, 150, 202},	//1303 Soprano::Vocabulary::Xesam::mimeType()
	{79, 770, 0, 0, Smoke::mf_static, 150, 203},	//1304 Soprano::Vocabulary::Xesam::mountPoint()
	{79, 771, 0, 0, Smoke::mf_static, 150, 204},	//1305 Soprano::Vocabulary::Xesam::name()
	{79, 774, 0, 0, Smoke::mf_static, 150, 205},	//1306 Soprano::Vocabulary::Xesam::newsGroup()
	{79, 783, 0, 0, Smoke::mf_static, 150, 206},	//1307 Soprano::Vocabulary::Xesam::occupiedSpace()
	{79, 822, 0, 0, Smoke::mf_static, 150, 207},	//1308 Soprano::Vocabulary::Xesam::orientation()
	{79, 823, 0, 0, Smoke::mf_static, 150, 208},	//1309 Soprano::Vocabulary::Xesam::originURL()
	{79, 824, 0, 0, Smoke::mf_static, 150, 209},	//1310 Soprano::Vocabulary::Xesam::originalLocation()
	{79, 825, 0, 0, Smoke::mf_static, 150, 210},	//1311 Soprano::Vocabulary::Xesam::otherName()
	{79, 827, 0, 0, Smoke::mf_static, 150, 211},	//1312 Soprano::Vocabulary::Xesam::owner()
	{79, 828, 0, 0, Smoke::mf_static, 150, 212},	//1313 Soprano::Vocabulary::Xesam::pageCount()
	{79, 829, 0, 0, Smoke::mf_static, 150, 213},	//1314 Soprano::Vocabulary::Xesam::paragraphCount()
	{79, 850, 0, 0, Smoke::mf_static, 150, 214},	//1315 Soprano::Vocabulary::Xesam::performer()
	{79, 851, 0, 0, Smoke::mf_static, 150, 215},	//1316 Soprano::Vocabulary::Xesam::permissions()
	{79, 852, 0, 0, Smoke::mf_static, 150, 216},	//1317 Soprano::Vocabulary::Xesam::personPhoto()
	{79, 854, 0, 0, Smoke::mf_static, 150, 217},	//1318 Soprano::Vocabulary::Xesam::phoneNumber()
	{79, 855, 0, 0, Smoke::mf_static, 150, 218},	//1319 Soprano::Vocabulary::Xesam::pixelDataBitDepth()
	{79, 856, 0, 0, Smoke::mf_static, 150, 219},	//1320 Soprano::Vocabulary::Xesam::pixelDataType()
	{79, 859, 0, 0, Smoke::mf_static, 150, 220},	//1321 Soprano::Vocabulary::Xesam::postalAddress()
	{79, 866, 0, 0, Smoke::mf_static, 150, 221},	//1322 Soprano::Vocabulary::Xesam::primaryRecipient()
	{79, 868, 0, 0, Smoke::mf_static, 150, 222},	//1323 Soprano::Vocabulary::Xesam::programmingLanguage()
	{79, 886, 0, 0, Smoke::mf_static, 150, 223},	//1324 Soprano::Vocabulary::Xesam::receptionTime()
	{79, 887, 0, 0, Smoke::mf_static, 150, 224},	//1325 Soprano::Vocabulary::Xesam::recipient()
	{79, 895, 0, 0, Smoke::mf_static, 150, 225},	//1326 Soprano::Vocabulary::Xesam::related()
	{79, 896, 0, 0, Smoke::mf_static, 150, 226},	//1327 Soprano::Vocabulary::Xesam::remotePassword()
	{79, 897, 0, 0, Smoke::mf_static, 150, 227},	//1328 Soprano::Vocabulary::Xesam::remotePort()
	{79, 898, 0, 0, Smoke::mf_static, 150, 228},	//1329 Soprano::Vocabulary::Xesam::remoteServer()
	{79, 899, 0, 0, Smoke::mf_static, 150, 229},	//1330 Soprano::Vocabulary::Xesam::remoteUser()
	{79, 926, 0, 0, Smoke::mf_static, 150, 230},	//1331 Soprano::Vocabulary::Xesam::replyTo()
	{79, 934, 0, 0, Smoke::mf_static, 150, 231},	//1332 Soprano::Vocabulary::Xesam::rowCount()
	{79, 935, 0, 0, Smoke::mf_static, 150, 232},	//1333 Soprano::Vocabulary::Xesam::rssFeed()
	{79, 942, 0, 0, Smoke::mf_static, 150, 233},	//1334 Soprano::Vocabulary::Xesam::sampleConfiguration()
	{79, 943, 0, 0, Smoke::mf_static, 150, 234},	//1335 Soprano::Vocabulary::Xesam::sampleDataBitDepth()
	{79, 944, 0, 0, Smoke::mf_static, 150, 235},	//1336 Soprano::Vocabulary::Xesam::sampleDataType()
	{79, 947, 0, 0, Smoke::mf_static, 150, 236},	//1337 Soprano::Vocabulary::Xesam::secondaryRecipient()
	{79, 949, 0, 0, Smoke::mf_static, 150, 237},	//1338 Soprano::Vocabulary::Xesam::seenAttachedAs()
	{79, 975, 0, 0, Smoke::mf_static, 150, 238},	//1339 Soprano::Vocabulary::Xesam::setCount()
	{79, 1008, 0, 0, Smoke::mf_static, 150, 239},	//1340 Soprano::Vocabulary::Xesam::setRate()
	{79, 1025, 0, 0, Smoke::mf_static, 150, 240},	//1341 Soprano::Vocabulary::Xesam::sha1Hash()
	{79, 1027, 0, 0, Smoke::mf_static, 150, 241},	//1342 Soprano::Vocabulary::Xesam::size()
	{79, 1029, 0, 0, Smoke::mf_static, 150, 242},	//1343 Soprano::Vocabulary::Xesam::sourceCreated()
	{79, 1030, 0, 0, Smoke::mf_static, 150, 243},	//1344 Soprano::Vocabulary::Xesam::sourceModified()
	{79, 1048, 0, 0, Smoke::mf_static, 150, 244},	//1345 Soprano::Vocabulary::Xesam::storageSize()
	{79, 1058, 0, 0, Smoke::mf_static, 150, 245},	//1346 Soprano::Vocabulary::Xesam::subject()
	{79, 1060, 0, 0, Smoke::mf_static, 150, 246},	//1347 Soprano::Vocabulary::Xesam::summary()
	{79, 1062, 0, 0, Smoke::mf_static, 150, 247},	//1348 Soprano::Vocabulary::Xesam::supercedes()
	{79, 1073, 0, 0, Smoke::mf_static, 150, 248},	//1349 Soprano::Vocabulary::Xesam::targetQuality()
	{79, 1077, 0, 0, Smoke::mf_static, 150, 249},	//1350 Soprano::Vocabulary::Xesam::title()
	{79, 1078, 0, 0, Smoke::mf_static, 150, 250},	//1351 Soprano::Vocabulary::Xesam::to()
	{79, 1095, 0, 0, Smoke::mf_static, 150, 251},	//1352 Soprano::Vocabulary::Xesam::totalSpace()
	{79, 1096, 0, 0, Smoke::mf_static, 150, 252},	//1353 Soprano::Vocabulary::Xesam::totalUncompressedSize()
	{79, 1097, 0, 0, Smoke::mf_static, 150, 253},	//1354 Soprano::Vocabulary::Xesam::trackGain()
	{79, 1098, 0, 0, Smoke::mf_static, 150, 254},	//1355 Soprano::Vocabulary::Xesam::trackNumber()
	{79, 1099, 0, 0, Smoke::mf_static, 150, 255},	//1356 Soprano::Vocabulary::Xesam::trackPeakGain()
	{79, 1113, 0, 0, Smoke::mf_static, 150, 256},	//1357 Soprano::Vocabulary::Xesam::url()
	{79, 1114, 0, 0, Smoke::mf_static, 150, 257},	//1358 Soprano::Vocabulary::Xesam::useCount()
	{79, 1116, 0, 0, Smoke::mf_static, 150, 258},	//1359 Soprano::Vocabulary::Xesam::userComment()
	{79, 1117, 0, 0, Smoke::mf_static, 150, 259},	//1360 Soprano::Vocabulary::Xesam::userKeyword()
	{79, 1119, 0, 0, Smoke::mf_static, 150, 260},	//1361 Soprano::Vocabulary::Xesam::userRating()
	{79, 1120, 0, 0, Smoke::mf_static, 150, 261},	//1362 Soprano::Vocabulary::Xesam::usesNamespace()
	{79, 1128, 0, 0, Smoke::mf_static, 150, 262},	//1363 Soprano::Vocabulary::Xesam::version()
	{79, 1134, 0, 0, Smoke::mf_static, 150, 263},	//1364 Soprano::Vocabulary::Xesam::verticalResolution()
	{79, 1135, 0, 0, Smoke::mf_static, 150, 264},	//1365 Soprano::Vocabulary::Xesam::videoBitrate()
	{79, 1136, 0, 0, Smoke::mf_static, 150, 265},	//1366 Soprano::Vocabulary::Xesam::videoCodec()
	{79, 1137, 0, 0, Smoke::mf_static, 150, 266},	//1367 Soprano::Vocabulary::Xesam::videoCodecType()
	{79, 1139, 0, 0, Smoke::mf_static, 150, 267},	//1368 Soprano::Vocabulary::Xesam::whiteBalance()
	{79, 1140, 0, 0, Smoke::mf_static, 150, 268},	//1369 Soprano::Vocabulary::Xesam::width()
	{79, 1141, 0, 0, Smoke::mf_static, 150, 269},	//1370 Soprano::Vocabulary::Xesam::wordCount()
	{79, 1142, 0, 0, Smoke::mf_static, 150, 270},	//1371 Soprano::Vocabulary::Xesam::workEmailAddress()
	{79, 1143, 0, 0, Smoke::mf_static, 150, 271},	//1372 Soprano::Vocabulary::Xesam::workPhoneNumber()
	{79, 1144, 0, 0, Smoke::mf_static, 150, 272},	//1373 Soprano::Vocabulary::Xesam::workPostalAddress()
};

// Class ID, munged name ID (index into methodNames), method def (see methods) if >0 or number of overloads if <0
static Smoke::MethodMap soprano_methodMaps[] = {
	{ 0, 0, 0 },	//0 (no method)
	{15, 14, 27},	//1 Soprano::BackendFeatureAddStatement
	{15, 15, 35},	//2 Soprano::BackendFeatureAll
	{15, 16, 33},	//3 Soprano::BackendFeatureContext
	{15, 17, 31},	//4 Soprano::BackendFeatureInference
	{15, 18, 32},	//5 Soprano::BackendFeatureInferenceOptional
	{15, 19, 29},	//6 Soprano::BackendFeatureListStatements
	{15, 20, 26},	//7 Soprano::BackendFeatureNone
	{15, 21, 30},	//8 Soprano::BackendFeatureQuery
	{15, 22, 28},	//9 Soprano::BackendFeatureRemoveStatements
	{15, 23, 34},	//10 Soprano::BackendFeatureStorageMemory
	{15, 24, 36},	//11 Soprano::BackendFeatureUser
	{15, 25, 19},	//12 Soprano::BackendOptionEnableInference
	{15, 26, 21},	//13 Soprano::BackendOptionHost
	{15, 27, 17},	//14 Soprano::BackendOptionNone
	{15, 28, 24},	//15 Soprano::BackendOptionPassword
	{15, 29, 22},	//16 Soprano::BackendOptionPort
	{15, 30, 20},	//17 Soprano::BackendOptionStorageDir
	{15, 31, 18},	//18 Soprano::BackendOptionStorageMemory
	{15, 32, 25},	//19 Soprano::BackendOptionUser
	{15, 33, 23},	//20 Soprano::BackendOptionUsername
	{15, 243, 11},	//21 Soprano::SerializationN3
	{15, 244, 15},	//22 Soprano::SerializationNQuads
	{15, 245, 12},	//23 Soprano::SerializationNTriples
	{15, 246, 10},	//24 Soprano::SerializationRdfXml
	{15, 247, 14},	//25 Soprano::SerializationTrig
	{15, 248, 13},	//26 Soprano::SerializationTurtle
	{15, 249, 9},	//27 Soprano::SerializationUnknown
	{15, 250, 16},	//28 Soprano::SerializationUser
	{15, 461, 52},	//29 Soprano::createModel
	{15, 464, 51},	//30 Soprano::createModel?
	{15, 517, 48},	//31 Soprano::discoverBackendByFeatures$
	{15, 518, 47},	//32 Soprano::discoverBackendByFeatures$?
	{15, 520, 46},	//33 Soprano::discoverBackendByName$
	{15, 664, 41},	//34 Soprano::isOptionInSettings?$
	{15, 665, 40},	//35 Soprano::isOptionInSettings?$$
	{15, 764, 39},	//36 Soprano::mimeTypeToSerialization$
	{15, 953, 38},	//37 Soprano::serializationMimeType$
	{15, 954, 37},	//38 Soprano::serializationMimeType$$
	{15, 1016, 49},	//39 Soprano::setUsedBackend#
	{15, 1023, 43},	//40 Soprano::settingInSettings?$
	{15, 1024, 42},	//41 Soprano::settingInSettings?$$
	{15, 1115, 50},	//42 Soprano::usedBackend
	{15, 1124, 45},	//43 Soprano::valueInSettings?$
	{15, 1125, 44},	//44 Soprano::valueInSettings?$$
	{15, 1130, 53},	//45 Soprano::versionMajor
	{15, 1131, 54},	//46 Soprano::versionMinor
	{15, 1132, 55},	//47 Soprano::versionRelease
	{15, 1133, 56},	//48 Soprano::versionString
	{16, 13, 57},	//49 Soprano::Backend::Backend$
	{16, 461, 60},	//50 Soprano::Backend::createModel
	{16, 464, 59},	//51 Soprano::Backend::createModel?
	{16, 496, 61},	//52 Soprano::Backend::deleteModelData?
	{16, 1063, 62},	//53 Soprano::Backend::supportedFeatures
	{16, 1065, 63},	//54 Soprano::Backend::supportedUserFeatures
	{16, 1068, 65},	//55 Soprano::Backend::supportsFeatures$
	{16, 1069, 64},	//56 Soprano::Backend::supportsFeatures$?
	{16, 1157, 58},	//57 Soprano::Backend::~Backend
	{17, 34, 66},	//58 Soprano::BackendSetting::BackendSetting
	{17, 35, 70},	//59 Soprano::BackendSetting::BackendSetting#
	{17, 36, 67},	//60 Soprano::BackendSetting::BackendSetting$
	{17, 37, -1},	//61 Soprano::BackendSetting::BackendSetting$#
	{17, 808, 72},	//62 Soprano::BackendSetting::operator=#
	{17, 821, 73},	//63 Soprano::BackendSetting::option
	{17, 1021, 76},	//64 Soprano::BackendSetting::setValue#
	{17, 1118, 74},	//65 Soprano::BackendSetting::userOptionName
	{17, 1121, 75},	//66 Soprano::BackendSetting::value
	{17, 1158, 71},	//67 Soprano::BackendSetting::~BackendSetting
	{18, 39, 77},	//68 Soprano::BindingSet::BindingSet
	{18, 40, 78},	//69 Soprano::BindingSet::BindingSet#
	{18, 370, 81},	//70 Soprano::BindingSet::bindingNames
	{18, 424, 86},	//71 Soprano::BindingSet::contains$
	{18, 454, 87},	//72 Soprano::BindingSet::count
	{18, 625, 88},	//73 Soprano::BindingSet::insert$#
	{18, 808, 80},	//74 Soprano::BindingSet::operator=#
	{18, 818, -4},	//75 Soprano::BindingSet::operator[]$
	{18, 925, -7},	//76 Soprano::BindingSet::replace$#
	{18, 1122, -10},	//77 Soprano::BindingSet::value$
	{18, 1159, 79},	//78 Soprano::BindingSet::~BindingSet
	{20, 54, 95},	//79 Soprano::Client::DBusClient::DBusClient
	{20, 55, 94},	//80 Soprano::Client::DBusClient::DBusClient$
	{20, 56, 93},	//81 Soprano::Client::DBusClient::DBusClient$#
	{20, 327, 98},	//82 Soprano::Client::DBusClient::allModels
	{20, 462, 100},	//83 Soprano::Client::DBusClient::createModel$
	{20, 463, 99},	//84 Soprano::Client::DBusClient::createModel$?
	{20, 687, 97},	//85 Soprano::Client::DBusClient::isValid
	{20, 760, 91},	//86 Soprano::Client::DBusClient::metaObject
	{20, 871, 92},	//87 Soprano::Client::DBusClient::qt_metacall$$?
	{20, 911, 101},	//88 Soprano::Client::DBusClient::removeModel$
	{20, 1046, 102},	//89 Soprano::Client::DBusClient::staticMetaObject
	{20, 1161, 96},	//90 Soprano::Client::DBusClient::~DBusClient
	{21, 63, 106},	//91 Soprano::Client::DBusModel::DBusModel$$
	{21, 64, 105},	//92 Soprano::Client::DBusModel::DBusModel$$#
	{21, 309, 110},	//93 Soprano::Client::DBusModel::addStatement#
	{21, 341, 109},	//94 Soprano::Client::DBusModel::asyncCalls
	{21, 426, 120},	//95 Soprano::Client::DBusModel::containsAnyStatement#
	{21, 436, 119},	//96 Soprano::Client::DBusModel::containsStatement#
	{21, 455, 121},	//97 Soprano::Client::DBusModel::createBlankNode
	{21, 559, 113},	//98 Soprano::Client::DBusModel::executeQuery$$
	{21, 560, 112},	//99 Soprano::Client::DBusModel::executeQuery$$$
	{21, 653, 118},	//100 Soprano::Client::DBusModel::isEmpty
	{21, 715, 111},	//101 Soprano::Client::DBusModel::listContexts
	{21, 718, 114},	//102 Soprano::Client::DBusModel::listStatements#
	{21, 760, 103},	//103 Soprano::Client::DBusModel::metaObject
	{21, 871, 104},	//104 Soprano::Client::DBusModel::qt_metacall$$?
	{21, 901, 116},	//105 Soprano::Client::DBusModel::removeAllStatements#
	{21, 913, 115},	//106 Soprano::Client::DBusModel::removeStatement#
	{21, 960, 108},	//107 Soprano::Client::DBusModel::setAsyncCalls$
	{21, 1039, 117},	//108 Soprano::Client::DBusModel::statementCount
	{21, 1046, 122},	//109 Soprano::Client::DBusModel::staticMetaObject
	{21, 1164, 107},	//110 Soprano::Client::DBusModel::~DBusModel
	{22, 66, 123},	//111 Soprano::Client::DBusNodeIterator::DBusNodeIterator$$
	{22, 1165, 124},	//112 Soprano::Client::DBusNodeIterator::~DBusNodeIterator
	{23, 68, 125},	//113 Soprano::Client::DBusQueryResultIterator::DBusQueryResultIterator$$
	{23, 1166, 126},	//114 Soprano::Client::DBusQueryResultIterator::~DBusQueryResultIterator
	{24, 70, 127},	//115 Soprano::Client::DBusStatementIterator::DBusStatementIterator$$
	{24, 1167, 128},	//116 Soprano::Client::DBusStatementIterator::~DBusStatementIterator
	{25, 141, 132},	//117 Soprano::Client::LocalSocketClient::LocalSocketClient
	{25, 142, 131},	//118 Soprano::Client::LocalSocketClient::LocalSocketClient#
	{25, 414, 139},	//119 Soprano::Client::LocalSocketClient::connect
	{25, 417, 138},	//120 Soprano::Client::LocalSocketClient::connect$
	{25, 462, 136},	//121 Soprano::Client::LocalSocketClient::createModel$
	{25, 463, 135},	//122 Soprano::Client::LocalSocketClient::createModel$?
	{25, 513, 140},	//123 Soprano::Client::LocalSocketClient::disconnect
	{25, 641, 134},	//124 Soprano::Client::LocalSocketClient::isConnected
	{25, 760, 129},	//125 Soprano::Client::LocalSocketClient::metaObject
	{25, 871, 130},	//126 Soprano::Client::LocalSocketClient::qt_metacall$$?
	{25, 911, 137},	//127 Soprano::Client::LocalSocketClient::removeModel$
	{25, 1046, 141},	//128 Soprano::Client::LocalSocketClient::staticMetaObject
	{25, 1175, 133},	//129 Soprano::Client::LocalSocketClient::~LocalSocketClient
	{26, 264, 148},	//130 Soprano::Client::SparqlModel::SparqlModel
	{26, 265, 147},	//131 Soprano::Client::SparqlModel::SparqlModel$
	{26, 266, 146},	//132 Soprano::Client::SparqlModel::SparqlModel$$
	{26, 267, 145},	//133 Soprano::Client::SparqlModel::SparqlModel$$$
	{26, 268, 144},	//134 Soprano::Client::SparqlModel::SparqlModel$$$$
	{26, 309, 155},	//135 Soprano::Client::SparqlModel::addStatement#
	{26, 426, 167},	//136 Soprano::Client::SparqlModel::containsAnyStatement#
	{26, 436, 166},	//137 Soprano::Client::SparqlModel::containsStatement#
	{26, 455, 170},	//138 Soprano::Client::SparqlModel::createBlankNode
	{26, 558, 161},	//139 Soprano::Client::SparqlModel::executeQuery$
	{26, 559, 160},	//140 Soprano::Client::SparqlModel::executeQuery$$
	{26, 560, 159},	//141 Soprano::Client::SparqlModel::executeQuery$$$
	{26, 562, 164},	//142 Soprano::Client::SparqlModel::executeQueryAsync$
	{26, 563, 163},	//143 Soprano::Client::SparqlModel::executeQueryAsync$$
	{26, 564, 162},	//144 Soprano::Client::SparqlModel::executeQueryAsync$$$
	{26, 653, 169},	//145 Soprano::Client::SparqlModel::isEmpty
	{26, 715, 165},	//146 Soprano::Client::SparqlModel::listContexts
	{26, 718, 158},	//147 Soprano::Client::SparqlModel::listStatements#
	{26, 760, 142},	//148 Soprano::Client::SparqlModel::metaObject
	{26, 871, 143},	//149 Soprano::Client::SparqlModel::qt_metacall$$?
	{26, 901, 157},	//150 Soprano::Client::SparqlModel::removeAllStatements#
	{26, 913, 156},	//151 Soprano::Client::SparqlModel::removeStatement#
	{26, 985, 151},	//152 Soprano::Client::SparqlModel::setHost$
	{26, 986, 150},	//153 Soprano::Client::SparqlModel::setHost$$
	{26, 1000, 154},	//154 Soprano::Client::SparqlModel::setPath$
	{26, 1018, 153},	//155 Soprano::Client::SparqlModel::setUser$
	{26, 1019, 152},	//156 Soprano::Client::SparqlModel::setUser$$
	{26, 1039, 168},	//157 Soprano::Client::SparqlModel::statementCount
	{26, 1046, 171},	//158 Soprano::Client::SparqlModel::staticMetaObject
	{26, 1197, 149},	//159 Soprano::Client::SparqlModel::~SparqlModel
	{27, 71, 186},	//160 Soprano::Client::TcpClient::DEFAULT_PORT
	{27, 285, 175},	//161 Soprano::Client::TcpClient::TcpClient
	{27, 286, 174},	//162 Soprano::Client::TcpClient::TcpClient#
	{27, 414, 179},	//163 Soprano::Client::TcpClient::connect
	{27, 415, 178},	//164 Soprano::Client::TcpClient::connect#
	{27, 416, 177},	//165 Soprano::Client::TcpClient::connect#$
	{27, 462, 183},	//166 Soprano::Client::TcpClient::createModel$
	{27, 463, 182},	//167 Soprano::Client::TcpClient::createModel$?
	{27, 513, 181},	//168 Soprano::Client::TcpClient::disconnect
	{27, 641, 180},	//169 Soprano::Client::TcpClient::isConnected
	{27, 760, 172},	//170 Soprano::Client::TcpClient::metaObject
	{27, 871, 173},	//171 Soprano::Client::TcpClient::qt_metacall$$?
	{27, 911, 184},	//172 Soprano::Client::TcpClient::removeModel$
	{27, 1046, 185},	//173 Soprano::Client::TcpClient::staticMetaObject
	{27, 1202, 176},	//174 Soprano::Client::TcpClient::~TcpClient
	{28, 93, 188},	//175 Soprano::Error::ErrorInvalidArgument
	{28, 94, 189},	//176 Soprano::Error::ErrorInvalidStatement
	{28, 95, 187},	//177 Soprano::Error::ErrorNone
	{28, 96, 190},	//178 Soprano::Error::ErrorNotSupported
	{28, 97, 191},	//179 Soprano::Error::ErrorParsingFailed
	{28, 98, 192},	//180 Soprano::Error::ErrorPermissionDenied
	{28, 99, 193},	//181 Soprano::Error::ErrorUnknown
	{28, 451, 195},	//182 Soprano::Error::convertErrorCode$
	{28, 552, 194},	//183 Soprano::Error::errorMessage$
	{29, 88, 196},	//184 Soprano::Error::Error::Error
	{29, 89, 199},	//185 Soprano::Error::Error::Error#
	{29, 90, 198},	//186 Soprano::Error::Error::Error$
	{29, 91, 197},	//187 Soprano::Error::Error::Error$$
	{29, 92, 207},	//188 Soprano::Error::Error::Error?
	{29, 400, 204},	//189 Soprano::Error::Error::code
	{29, 666, 205},	//190 Soprano::Error::Error::isParserError
	{29, 759, 203},	//191 Soprano::Error::Error::message
	{29, 790, 202},	//192 Soprano::Error::Error::operator bool
	{29, 808, 201},	//193 Soprano::Error::Error::operator=#
	{29, 1089, 206},	//194 Soprano::Error::Error::toParserError
	{29, 1168, 200},	//195 Soprano::Error::Error::~Error
	{30, 143, 208},	//196 Soprano::Error::Locator::Locator
	{30, 144, 212},	//197 Soprano::Error::Locator::Locator#
	{30, 145, 211},	//198 Soprano::Error::Locator::Locator$$
	{30, 146, 210},	//199 Soprano::Error::Locator::Locator$$$
	{30, 147, 209},	//200 Soprano::Error::Locator::Locator$$$$
	{30, 378, 217},	//201 Soprano::Error::Locator::byte
	{30, 403, 216},	//202 Soprano::Error::Locator::column
	{30, 572, 218},	//203 Soprano::Error::Locator::fileName
	{30, 712, 215},	//204 Soprano::Error::Locator::line
	{30, 808, 214},	//205 Soprano::Error::Locator::operator=#
	{30, 966, 221},	//206 Soprano::Error::Locator::setByte$
	{30, 970, 220},	//207 Soprano::Error::Locator::setColumn$
	{30, 981, 222},	//208 Soprano::Error::Locator::setFileName$
	{30, 990, 219},	//209 Soprano::Error::Locator::setLine$
	{30, 1176, 213},	//210 Soprano::Error::Locator::~Locator
	{31, 184, 223},	//211 Soprano::Error::ParserError::ParserError
	{31, 185, -13},	//212 Soprano::Error::ParserError::ParserError#
	{31, 186, 225},	//213 Soprano::Error::ParserError::ParserError#$
	{31, 187, 224},	//214 Soprano::Error::ParserError::ParserError#$$
	{31, 733, 230},	//215 Soprano::Error::ParserError::locator
	{31, 808, 229},	//216 Soprano::Error::ParserError::operator=#
	{31, 1183, 228},	//217 Soprano::Error::ParserError::~ParserError
	{32, 104, 263},	//218 Soprano::FilterModel::FilterModel
	{32, 105, 264},	//219 Soprano::FilterModel::FilterModel#
	{32, 309, 237},	//220 Soprano::FilterModel::addStatement#
	{32, 310, 239},	//221 Soprano::FilterModel::addStatement###
	{32, 311, 238},	//222 Soprano::FilterModel::addStatement####
	{32, 426, 255},	//223 Soprano::FilterModel::containsAnyStatement#
	{32, 427, 257},	//224 Soprano::FilterModel::containsAnyStatement###
	{32, 428, 256},	//225 Soprano::FilterModel::containsAnyStatement####
	{32, 436, 252},	//226 Soprano::FilterModel::containsStatement#
	{32, 437, 254},	//227 Soprano::FilterModel::containsStatement###
	{32, 438, 253},	//228 Soprano::FilterModel::containsStatement####
	{32, 455, 261},	//229 Soprano::FilterModel::createBlankNode
	{32, 559, 251},	//230 Soprano::FilterModel::executeQuery$$
	{32, 560, 250},	//231 Soprano::FilterModel::executeQuery$$$
	{32, 653, 258},	//232 Soprano::FilterModel::isEmpty
	{32, 715, 249},	//233 Soprano::FilterModel::listContexts
	{32, 718, 246},	//234 Soprano::FilterModel::listStatements#
	{32, 719, 248},	//235 Soprano::FilterModel::listStatements###
	{32, 720, 247},	//236 Soprano::FilterModel::listStatements####
	{32, 760, 232},	//237 Soprano::FilterModel::metaObject
	{32, 830, 236},	//238 Soprano::FilterModel::parentModel
	{32, 832, 267},	//239 Soprano::FilterModel::parentStatementAdded#
	{32, 834, 268},	//240 Soprano::FilterModel::parentStatementRemoved#
	{32, 835, 265},	//241 Soprano::FilterModel::parentStatementsAdded
	{32, 836, 266},	//242 Soprano::FilterModel::parentStatementsRemoved
	{32, 871, 233},	//243 Soprano::FilterModel::qt_metacall$$?
	{32, 901, 243},	//244 Soprano::FilterModel::removeAllStatements#
	{32, 902, 245},	//245 Soprano::FilterModel::removeAllStatements###
	{32, 903, 244},	//246 Soprano::FilterModel::removeAllStatements####
	{32, 913, 240},	//247 Soprano::FilterModel::removeStatement#
	{32, 914, 242},	//248 Soprano::FilterModel::removeStatement###
	{32, 915, 241},	//249 Soprano::FilterModel::removeStatement####
	{32, 998, 235},	//250 Soprano::FilterModel::setParentModel#
	{32, 1039, 259},	//251 Soprano::FilterModel::statementCount
	{32, 1046, 262},	//252 Soprano::FilterModel::staticMetaObject
	{32, 1146, 260},	//253 Soprano::FilterModel::write#
	{32, 1169, 234},	//254 Soprano::FilterModel::~FilterModel
	{33, 109, 269},	//255 Soprano::Graph::Graph
	{33, 110, 270},	//256 Soprano::Graph::Graph#
	{33, 111, 271},	//257 Soprano::Graph::Graph?
	{33, 309, 273},	//258 Soprano::Graph::addStatement#
	{33, 310, 275},	//259 Soprano::Graph::addStatement###
	{33, 311, 274},	//260 Soprano::Graph::addStatement####
	{33, 317, 276},	//261 Soprano::Graph::addStatements?
	{33, 426, 292},	//262 Soprano::Graph::containsAnyStatement#
	{33, 427, 294},	//263 Soprano::Graph::containsAnyStatement###
	{33, 428, 293},	//264 Soprano::Graph::containsAnyStatement####
	{33, 434, 298},	//265 Soprano::Graph::containsContext#
	{33, 436, 295},	//266 Soprano::Graph::containsStatement#
	{33, 437, 297},	//267 Soprano::Graph::containsStatement###
	{33, 438, 296},	//268 Soprano::Graph::containsStatement####
	{33, 653, 299},	//269 Soprano::Graph::isEmpty
	{33, 715, 291},	//270 Soprano::Graph::listContexts
	{33, 717, 287},	//271 Soprano::Graph::listStatements
	{33, 718, 286},	//272 Soprano::Graph::listStatements#
	{33, 719, 289},	//273 Soprano::Graph::listStatements###
	{33, 720, 288},	//274 Soprano::Graph::listStatements####
	{33, 726, 290},	//275 Soprano::Graph::listStatementsInContext#
	{33, 792, 315},	//276 Soprano::Graph::operator!=#
	{33, 794, -17},	//277 Soprano::Graph::operator+#
	{33, 796, -20},	//278 Soprano::Graph::operator+=#
	{33, 798, -23},	//279 Soprano::Graph::operator-#
	{33, 800, -26},	//280 Soprano::Graph::operator-=#
	{33, 804, -29},	//281 Soprano::Graph::operator<<#
	{33, 808, 302},	//282 Soprano::Graph::operator=#
	{33, 811, 314},	//283 Soprano::Graph::operator==#
	{33, 812, 303},	//284 Soprano::Graph::operator=?
	{33, 900, 281},	//285 Soprano::Graph::removeAllStatements
	{33, 901, 280},	//286 Soprano::Graph::removeAllStatements#
	{33, 902, 283},	//287 Soprano::Graph::removeAllStatements###
	{33, 903, 282},	//288 Soprano::Graph::removeAllStatements####
	{33, 909, 285},	//289 Soprano::Graph::removeContext#
	{33, 913, 277},	//290 Soprano::Graph::removeStatement#
	{33, 914, 279},	//291 Soprano::Graph::removeStatement###
	{33, 915, 278},	//292 Soprano::Graph::removeStatement####
	{33, 921, 284},	//293 Soprano::Graph::removeStatements?
	{33, 1039, 300},	//294 Soprano::Graph::statementCount
	{33, 1086, 301},	//295 Soprano::Graph::toList
	{33, 1170, 272},	//296 Soprano::Graph::~Graph
	{35, 44, 317},	//297 Soprano::Index::CLuceneIndex::CLuceneIndex
	{35, 45, 316},	//298 Soprano::Index::CLuceneIndex::CLuceneIndex?
	{35, 309, 328},	//299 Soprano::Index::CLuceneIndex::addStatement#
	{35, 394, 332},	//300 Soprano::Index::CLuceneIndex::clear
	{35, 397, 321},	//301 Soprano::Index::CLuceneIndex::close
	{35, 399, 327},	//302 Soprano::Index::CLuceneIndex::closeTransaction$
	{35, 491, 335},	//303 Soprano::Index::CLuceneIndex::defaultSearchField
	{35, 535, 330},	//304 Soprano::Index::CLuceneIndex::documentForResource#
	{35, 539, 331},	//305 Soprano::Index::CLuceneIndex::dump#
	{35, 593, 334},	//306 Soprano::Index::CLuceneIndex::getResource?
	{35, 662, 322},	//307 Soprano::Index::CLuceneIndex::isOpen
	{35, 787, 320},	//308 Soprano::Index::CLuceneIndex::open$
	{35, 788, 319},	//309 Soprano::Index::CLuceneIndex::open$$
	{35, 819, 333},	//310 Soprano::Index::CLuceneIndex::optimize
	{35, 872, 324},	//311 Soprano::Index::CLuceneIndex::queryAnalyzer
	{35, 913, 329},	//312 Soprano::Index::CLuceneIndex::removeStatement#
	{35, 928, 325},	//313 Soprano::Index::CLuceneIndex::resourceCount
	{35, 1007, 323},	//314 Soprano::Index::CLuceneIndex::setQueryAnalyzer?
	{35, 1036, 326},	//315 Soprano::Index::CLuceneIndex::startTransaction
	{35, 1160, 318},	//316 Soprano::Index::CLuceneIndex::~CLuceneIndex
	{36, 118, 339},	//317 Soprano::Index::IndexFilterModel::IndexFilterModel#
	{36, 119, 338},	//318 Soprano::Index::IndexFilterModel::IndexFilterModel##
	{36, 120, 337},	//319 Soprano::Index::IndexFilterModel::IndexFilterModel$
	{36, 121, 336},	//320 Soprano::Index::IndexFilterModel::IndexFilterModel$#
	{36, 299, 354},	//321 Soprano::Index::IndexFilterModel::addForceIndexPredicate#
	{36, 301, 351},	//322 Soprano::Index::IndexFilterModel::addIndexOnlyPredicate#
	{36, 309, 342},	//323 Soprano::Index::IndexFilterModel::addStatement#
	{36, 543, 357},	//324 Soprano::Index::IndexFilterModel::encodeStringForLuceneQuery$
	{36, 545, 358},	//325 Soprano::Index::IndexFilterModel::encodeUriForLuceneQuery#
	{36, 559, 346},	//326 Soprano::Index::IndexFilterModel::executeQuery$$
	{36, 560, 345},	//327 Soprano::Index::IndexFilterModel::executeQuery$$$
	{36, 580, 356},	//328 Soprano::Index::IndexFilterModel::forceIndexPredicates
	{36, 622, 341},	//329 Soprano::Index::IndexFilterModel::index
	{36, 623, 353},	//330 Soprano::Index::IndexFilterModel::indexOnlyPredicates
	{36, 820, 350},	//331 Soprano::Index::IndexFilterModel::optimizeIndex
	{36, 885, 349},	//332 Soprano::Index::IndexFilterModel::rebuildIndex
	{36, 901, 344},	//333 Soprano::Index::IndexFilterModel::removeAllStatements#
	{36, 913, 343},	//334 Soprano::Index::IndexFilterModel::removeStatement#
	{36, 983, 355},	//335 Soprano::Index::IndexFilterModel::setForceIndexPredicates?
	{36, 988, 352},	//336 Soprano::Index::IndexFilterModel::setIndexOnlyPredicates?
	{36, 1014, 347},	//337 Soprano::Index::IndexFilterModel::setTransactionCacheSize$
	{36, 1100, 348},	//338 Soprano::Index::IndexFilterModel::transactionCacheSize
	{36, 1171, 340},	//339 Soprano::Index::IndexFilterModel::~IndexFilterModel
	{37, 204, 359},	//340 Soprano::Index::QueryHit::QueryHit
	{37, 205, 360},	//341 Soprano::Index::QueryHit::QueryHit#
	{37, 206, 361},	//342 Soprano::Index::QueryHit::QueryHit#$
	{37, 808, 363},	//343 Soprano::Index::QueryHit::operator=#
	{37, 927, 365},	//344 Soprano::Index::QueryHit::resource
	{37, 945, 364},	//345 Soprano::Index::QueryHit::score
	{37, 1186, 362},	//346 Soprano::Index::QueryHit::~QueryHit
	{38, 164, 367},	//347 Soprano::Inference::NRL
	{38, 215, 366},	//348 Soprano::Inference::RDFS
	{39, 125, 370},	//349 Soprano::Inference::InferenceModel::InferenceModel#
	{39, 307, 375},	//350 Soprano::Inference::InferenceModel::addRule#
	{39, 309, 372},	//351 Soprano::Inference::InferenceModel::addStatement#
	{39, 395, 378},	//352 Soprano::Inference::InferenceModel::clearInference
	{39, 760, 368},	//353 Soprano::Inference::InferenceModel::metaObject
	{39, 849, 377},	//354 Soprano::Inference::InferenceModel::performInference
	{39, 871, 369},	//355 Soprano::Inference::InferenceModel::qt_metacall$$?
	{39, 901, 374},	//356 Soprano::Inference::InferenceModel::removeAllStatements#
	{39, 913, 373},	//357 Soprano::Inference::InferenceModel::removeStatement#
	{39, 972, 379},	//358 Soprano::Inference::InferenceModel::setCompressedSourceStatements$
	{39, 996, 380},	//359 Soprano::Inference::InferenceModel::setOptimizedQueriesEnabled$
	{39, 1010, 376},	//360 Soprano::Inference::InferenceModel::setRules?
	{39, 1046, 381},	//361 Soprano::Inference::InferenceModel::staticMetaObject
	{39, 1172, 371},	//362 Soprano::Inference::InferenceModel::~InferenceModel
	{40, 172, 382},	//363 Soprano::Inference::NodePattern::NodePattern
	{40, 173, -32},	//364 Soprano::Inference::NodePattern::NodePattern#
	{40, 174, 384},	//365 Soprano::Inference::NodePattern::NodePattern$
	{40, 474, 392},	//366 Soprano::Inference::NodePattern::createSparqlNodePattern#
	{40, 687, 393},	//367 Soprano::Inference::NodePattern::isValid
	{40, 688, 388},	//368 Soprano::Inference::NodePattern::isVariable
	{40, 747, 391},	//369 Soprano::Inference::NodePattern::match#
	{40, 808, 387},	//370 Soprano::Inference::NodePattern::operator=#
	{40, 927, 389},	//371 Soprano::Inference::NodePattern::resource
	{40, 1126, 390},	//372 Soprano::Inference::NodePattern::variableName
	{40, 1181, 386},	//373 Soprano::Inference::NodePattern::~NodePattern
	{41, 233, 394},	//374 Soprano::Inference::Rule::Rule
	{41, 234, 395},	//375 Soprano::Inference::Rule::Rule#
	{41, 303, 399},	//376 Soprano::Inference::Rule::addPrecondition#
	{41, 362, 407},	//377 Soprano::Inference::Rule::bindEffect#
	{41, 364, 408},	//378 Soprano::Inference::Rule::bindPreconditions#
	{41, 366, 403},	//379 Soprano::Inference::Rule::bindToStatement#
	{41, 377, 404},	//380 Soprano::Inference::Rule::boundToStatement
	{41, 475, 406},	//381 Soprano::Inference::Rule::createSparqlQuery
	{41, 476, 405},	//382 Soprano::Inference::Rule::createSparqlQuery$
	{41, 540, 400},	//383 Soprano::Inference::Rule::effect
	{41, 687, 409},	//384 Soprano::Inference::Rule::isValid
	{41, 747, 402},	//385 Soprano::Inference::Rule::match#
	{41, 808, 397},	//386 Soprano::Inference::Rule::operator=#
	{41, 860, 398},	//387 Soprano::Inference::Rule::preconditions
	{41, 979, 401},	//388 Soprano::Inference::Rule::setEffect#
	{41, 1190, 396},	//389 Soprano::Inference::Rule::~Rule
	{42, 235, 410},	//390 Soprano::Inference::RuleParser::RuleParser
	{42, 236, 418},	//391 Soprano::Inference::RuleParser::RuleParser#
	{42, 305, 415},	//392 Soprano::Inference::RuleParser::addPrefix$#
	{42, 394, 417},	//393 Soprano::Inference::RuleParser::clear
	{42, 838, 412},	//394 Soprano::Inference::RuleParser::parseFile$
	{42, 842, 413},	//395 Soprano::Inference::RuleParser::parseRule$
	{42, 865, 416},	//396 Soprano::Inference::RuleParser::prefixes
	{42, 940, 414},	//397 Soprano::Inference::RuleParser::rules
	{42, 1191, 411},	//398 Soprano::Inference::RuleParser::~RuleParser
	{43, 237, 419},	//399 Soprano::Inference::RuleSet::RuleSet
	{43, 238, 420},	//400 Soprano::Inference::RuleSet::RuleSet#
	{43, 330, 431},	//401 Soprano::Inference::RuleSet::allRules
	{43, 343, 426},	//402 Soprano::Inference::RuleSet::at$
	{43, 394, 423},	//403 Soprano::Inference::RuleSet::clear
	{43, 454, 425},	//404 Soprano::Inference::RuleSet::count
	{43, 625, 424},	//405 Soprano::Inference::RuleSet::insert$#
	{43, 808, 422},	//406 Soprano::Inference::RuleSet::operator=#
	{43, 818, -35},	//407 Soprano::Inference::RuleSet::operator[]$
	{43, 937, 428},	//408 Soprano::Inference::RuleSet::rule$
	{43, 939, 430},	//409 Soprano::Inference::RuleSet::ruleNames
	{43, 1033, 432},	//410 Soprano::Inference::RuleSet::standardRuleSet$
	{43, 1192, 421},	//411 Soprano::Inference::RuleSet::~RuleSet
	{44, 276, 433},	//412 Soprano::Inference::StatementPattern::StatementPattern
	{44, 277, 435},	//413 Soprano::Inference::StatementPattern::StatementPattern#
	{44, 278, 434},	//414 Soprano::Inference::StatementPattern::StatementPattern###
	{44, 472, 442},	//415 Soprano::Inference::StatementPattern::createSparqlGraphPattern#
	{44, 687, 443},	//416 Soprano::Inference::StatementPattern::isValid
	{44, 747, 441},	//417 Soprano::Inference::StatementPattern::match#
	{44, 782, 440},	//418 Soprano::Inference::StatementPattern::objectPattern
	{44, 808, 437},	//419 Soprano::Inference::StatementPattern::operator=#
	{44, 862, 439},	//420 Soprano::Inference::StatementPattern::predicatePattern
	{44, 1059, 438},	//421 Soprano::Inference::StatementPattern::subjectPattern
	{44, 1200, 436},	//422 Soprano::Inference::StatementPattern::~StatementPattern
	{45, 129, 448},	//423 Soprano::LanguageTag::LanguageTag
	{45, 130, -38},	//424 Soprano::LanguageTag::LanguageTag#
	{45, 131, -41},	//425 Soprano::LanguageTag::LanguageTag$
	{45, 132, 454},	//426 Soprano::LanguageTag::LanguageTag$$
	{45, 133, 451},	//427 Soprano::LanguageTag::LanguageTag?
	{45, 148, 447},	//428 Soprano::LanguageTag::LookupFlagNoFallback
	{45, 149, 446},	//429 Soprano::LanguageTag::LookupFlagNone
	{45, 152, 444},	//430 Soprano::LanguageTag::MatchFilterBasic
	{45, 153, 445},	//431 Soprano::LanguageTag::MatchFilterExtended
	{45, 653, 466},	//432 Soprano::LanguageTag::isEmpty
	{45, 687, 467},	//433 Soprano::LanguageTag::isValid
	{45, 735, 478},	//434 Soprano::LanguageTag::lookup?#
	{45, 736, 477},	//435 Soprano::LanguageTag::lookup?#$
	{45, 737, 476},	//436 Soprano::LanguageTag::lookup?#$$
	{45, 738, 475},	//437 Soprano::LanguageTag::lookup??
	{45, 739, 474},	//438 Soprano::LanguageTag::lookup??$
	{45, 740, 473},	//439 Soprano::LanguageTag::lookup??$$
	{45, 749, 465},	//440 Soprano::LanguageTag::matches#
	{45, 750, 464},	//441 Soprano::LanguageTag::matches#$
	{45, 789, 472},	//442 Soprano::LanguageTag::operator QString
	{45, 792, 459},	//443 Soprano::LanguageTag::operator!=#
	{45, 802, 460},	//444 Soprano::LanguageTag::operator<#
	{45, 806, 461},	//445 Soprano::LanguageTag::operator<=#
	{45, 808, 457},	//446 Soprano::LanguageTag::operator=#
	{45, 811, 458},	//447 Soprano::LanguageTag::operator==#
	{45, 814, 462},	//448 Soprano::LanguageTag::operator>#
	{45, 816, 463},	//449 Soprano::LanguageTag::operator>=#
	{45, 1057, 468},	//450 Soprano::LanguageTag::subTags
	{45, 1087, 471},	//451 Soprano::LanguageTag::toLocale
	{45, 1090, 470},	//452 Soprano::LanguageTag::toPrettyString
	{45, 1091, 469},	//453 Soprano::LanguageTag::toString
	{45, 1173, 456},	//454 Soprano::LanguageTag::~LanguageTag
	{46, 137, 479},	//455 Soprano::LiteralValue::LiteralValue
	{46, 138, -45},	//456 Soprano::LiteralValue::LiteralValue#
	{46, 139, -52},	//457 Soprano::LiteralValue::LiteralValue$
	{46, 140, 490},	//458 Soprano::LiteralValue::LiteralValue?
	{46, 466, 542},	//459 Soprano::LiteralValue::createPlainLiteral$
	{46, 467, 541},	//460 Soprano::LiteralValue::createPlainLiteral$#
	{46, 484, 535},	//461 Soprano::LiteralValue::dataTypeUri
	{46, 486, 544},	//462 Soprano::LiteralValue::dataTypeUriFromType$
	{46, 586, 540},	//463 Soprano::LiteralValue::fromString$#
	{46, 587, 539},	//464 Soprano::LiteralValue::fromString$$
	{46, 637, 517},	//465 Soprano::LiteralValue::isBool
	{46, 638, 523},	//466 Soprano::LiteralValue::isByteArray
	{46, 643, 520},	//467 Soprano::LiteralValue::isDate
	{46, 644, 522},	//468 Soprano::LiteralValue::isDateTime
	{46, 652, 518},	//469 Soprano::LiteralValue::isDouble
	{46, 659, 513},	//470 Soprano::LiteralValue::isInt
	{46, 660, 514},	//471 Soprano::LiteralValue::isInt64
	{46, 667, 512},	//472 Soprano::LiteralValue::isPlain
	{46, 675, 519},	//473 Soprano::LiteralValue::isString
	{46, 681, 521},	//474 Soprano::LiteralValue::isTime
	{46, 685, 515},	//475 Soprano::LiteralValue::isUnsignedInt
	{46, 686, 516},	//476 Soprano::LiteralValue::isUnsignedInt64
	{46, 687, 511},	//477 Soprano::LiteralValue::isValid
	{46, 705, 536},	//478 Soprano::LiteralValue::language
	{46, 792, 510},	//479 Soprano::LiteralValue::operator!=#
	{46, 808, -61},	//480 Soprano::LiteralValue::operator=#
	{46, 809, -67},	//481 Soprano::LiteralValue::operator=$
	{46, 811, 509},	//482 Soprano::LiteralValue::operator==#
	{46, 812, 504},	//483 Soprano::LiteralValue::operator=?
	{46, 1079, 528},	//484 Soprano::LiteralValue::toBool
	{46, 1080, 534},	//485 Soprano::LiteralValue::toByteArray
	{46, 1081, 531},	//486 Soprano::LiteralValue::toDate
	{46, 1082, 533},	//487 Soprano::LiteralValue::toDateTime
	{46, 1083, 529},	//488 Soprano::LiteralValue::toDouble
	{46, 1084, 524},	//489 Soprano::LiteralValue::toInt
	{46, 1085, 525},	//490 Soprano::LiteralValue::toInt64
	{46, 1091, 530},	//491 Soprano::LiteralValue::toString
	{46, 1092, 532},	//492 Soprano::LiteralValue::toTime
	{46, 1093, 526},	//493 Soprano::LiteralValue::toUnsignedInt
	{46, 1094, 527},	//494 Soprano::LiteralValue::toUnsignedInt64
	{46, 1101, 537},	//495 Soprano::LiteralValue::type
	{46, 1104, 543},	//496 Soprano::LiteralValue::typeFromDataTypeUri#
	{46, 1127, 538},	//497 Soprano::LiteralValue::variant
	{46, 1174, 480},	//498 Soprano::LiteralValue::~LiteralValue
	{47, 158, 585},	//499 Soprano::Model::Model
	{47, 309, 548},	//500 Soprano::Model::addStatement#
	{47, 310, 550},	//501 Soprano::Model::addStatement###
	{47, 311, 549},	//502 Soprano::Model::addStatement####
	{47, 317, 551},	//503 Soprano::Model::addStatements?
	{47, 426, 569},	//504 Soprano::Model::containsAnyStatement#
	{47, 427, 571},	//505 Soprano::Model::containsAnyStatement###
	{47, 428, 570},	//506 Soprano::Model::containsAnyStatement####
	{47, 434, 575},	//507 Soprano::Model::containsContext#
	{47, 436, 572},	//508 Soprano::Model::containsStatement#
	{47, 437, 574},	//509 Soprano::Model::containsStatement###
	{47, 438, 573},	//510 Soprano::Model::containsStatement####
	{47, 455, 579},	//511 Soprano::Model::createBlankNode
	{47, 559, 568},	//512 Soprano::Model::executeQuery$$
	{47, 560, 567},	//513 Soprano::Model::executeQuery$$$
	{47, 653, 576},	//514 Soprano::Model::isEmpty
	{47, 715, 566},	//515 Soprano::Model::listContexts
	{47, 717, 564},	//516 Soprano::Model::listStatements
	{47, 718, 561},	//517 Soprano::Model::listStatements#
	{47, 719, 563},	//518 Soprano::Model::listStatements###
	{47, 720, 562},	//519 Soprano::Model::listStatements####
	{47, 726, 565},	//520 Soprano::Model::listStatementsInContext#
	{47, 760, 545},	//521 Soprano::Model::metaObject
	{47, 871, 546},	//522 Soprano::Model::qt_metacall$$?
	{47, 900, 560},	//523 Soprano::Model::removeAllStatements
	{47, 901, 555},	//524 Soprano::Model::removeAllStatements#
	{47, 902, 557},	//525 Soprano::Model::removeAllStatements###
	{47, 903, 556},	//526 Soprano::Model::removeAllStatements####
	{47, 909, 559},	//527 Soprano::Model::removeContext#
	{47, 913, 552},	//528 Soprano::Model::removeStatement#
	{47, 914, 554},	//529 Soprano::Model::removeStatement###
	{47, 915, 553},	//530 Soprano::Model::removeStatement####
	{47, 921, 558},	//531 Soprano::Model::removeStatements?
	{47, 1038, 582},	//532 Soprano::Model::statementAdded#
	{47, 1039, 577},	//533 Soprano::Model::statementCount
	{47, 1043, 583},	//534 Soprano::Model::statementRemoved#
	{47, 1044, 580},	//535 Soprano::Model::statementsAdded
	{47, 1045, 581},	//536 Soprano::Model::statementsRemoved
	{47, 1046, 584},	//537 Soprano::Model::staticMetaObject
	{47, 1146, 578},	//538 Soprano::Model::write#
	{47, 1177, 547},	//539 Soprano::Model::~Model
	{48, 41, 589},	//540 Soprano::Node::BlankNode
	{48, 87, 586},	//541 Soprano::Node::EmptyNode
	{48, 136, 588},	//542 Soprano::Node::LiteralNode
	{48, 167, 590},	//543 Soprano::Node::Node
	{48, 168, -75},	//544 Soprano::Node::Node#
	{48, 169, 592},	//545 Soprano::Node::Node$
	{48, 229, 587},	//546 Soprano::Node::ResourceNode
	{48, 373, 622},	//547 Soprano::Node::blankToN3$
	{48, 456, 619},	//548 Soprano::Node::createBlankNode$
	{48, 458, 617},	//549 Soprano::Node::createEmptyNode
	{48, 460, 620},	//550 Soprano::Node::createLiteralNode#
	{48, 469, 618},	//551 Soprano::Node::createResourceNode#
	{48, 483, 613},	//552 Soprano::Node::dataType
	{48, 617, 611},	//553 Soprano::Node::identifier
	{48, 636, 609},	//554 Soprano::Node::isBlank
	{48, 653, 605},	//555 Soprano::Node::isEmpty
	{48, 661, 607},	//556 Soprano::Node::isLiteral
	{48, 673, 608},	//557 Soprano::Node::isResource
	{48, 687, 606},	//558 Soprano::Node::isValid
	{48, 705, 614},	//559 Soprano::Node::language
	{48, 729, 612},	//560 Soprano::Node::literal
	{48, 731, 623},	//561 Soprano::Node::literalToN3#
	{48, 749, 603},	//562 Soprano::Node::matches#
	{48, 792, 600},	//563 Soprano::Node::operator!=#
	{48, 808, -79},	//564 Soprano::Node::operator=#
	{48, 811, -83},	//565 Soprano::Node::operator==#
	{48, 930, 621},	//566 Soprano::Node::resourceToN3#
	{48, 1088, 616},	//567 Soprano::Node::toN3
	{48, 1091, 615},	//568 Soprano::Node::toString
	{48, 1101, 604},	//569 Soprano::Node::type
	{48, 1112, 610},	//570 Soprano::Node::uri
	{48, 1179, 595},	//571 Soprano::Node::~Node
	{49, 170, 624},	//572 Soprano::NodeIterator::NodeIterator
	{49, 171, 625},	//573 Soprano::NodeIterator::NodeIterator#
	{49, 328, 628},	//574 Soprano::NodeIterator::allNodes
	{49, 808, 627},	//575 Soprano::NodeIterator::operator=#
	{49, 1180, 626},	//576 Soprano::NodeIterator::~NodeIterator
	{50, 183, 640},	//577 Soprano::Parser::Parser$
	{50, 839, 635},	//578 Soprano::Parser::parseFile$#$
	{50, 840, 634},	//579 Soprano::Parser::parseFile$#$$
	{50, 844, 639},	//580 Soprano::Parser::parseStream##$
	{50, 845, 638},	//581 Soprano::Parser::parseStream##$$
	{50, 847, 637},	//582 Soprano::Parser::parseString$#$
	{50, 848, 636},	//583 Soprano::Parser::parseString$#$$
	{50, 1064, 630},	//584 Soprano::Parser::supportedSerializations
	{50, 1066, 631},	//585 Soprano::Parser::supportedUserSerializations
	{50, 1071, 633},	//586 Soprano::Parser::supportsSerialization$
	{50, 1072, 632},	//587 Soprano::Parser::supportsSerialization$$
	{50, 1182, 629},	//588 Soprano::Parser::~Parser
	{51, 194, 644},	//589 Soprano::Plugin::Plugin#
	{51, 195, 645},	//590 Soprano::Plugin::Plugin$
	{51, 634, 643},	//591 Soprano::Plugin::isAvailable
	{51, 857, 642},	//592 Soprano::Plugin::pluginName
	{51, 1184, 641},	//593 Soprano::Plugin::~Plugin
	{52, 325, 653},	//594 Soprano::PluginManager::allBackends
	{52, 329, 657},	//595 Soprano::PluginManager::allParsers
	{52, 331, 661},	//596 Soprano::PluginManager::allSerializers
	{52, 517, 652},	//597 Soprano::PluginManager::discoverBackendByFeatures$
	{52, 518, 651},	//598 Soprano::PluginManager::discoverBackendByFeatures$?
	{52, 520, 650},	//599 Soprano::PluginManager::discoverBackendByName$
	{52, 522, 654},	//600 Soprano::PluginManager::discoverParserByName$
	{52, 524, 656},	//601 Soprano::PluginManager::discoverParserForSerialization$
	{52, 525, 655},	//602 Soprano::PluginManager::discoverParserForSerialization$$
	{52, 527, 658},	//603 Soprano::PluginManager::discoverSerializerByName$
	{52, 529, 660},	//604 Soprano::PluginManager::discoverSerializerForSerialization$
	{52, 530, 659},	//605 Soprano::PluginManager::discoverSerializerForSerialization$$
	{52, 626, 662},	//606 Soprano::PluginManager::instance
	{52, 760, 646},	//607 Soprano::PluginManager::metaObject
	{52, 871, 647},	//608 Soprano::PluginManager::qt_metacall$$?
	{52, 1002, 649},	//609 Soprano::PluginManager::setPluginSearchPath?
	{52, 1003, 648},	//610 Soprano::PluginManager::setPluginSearchPath?$
	{52, 1046, 663},	//611 Soprano::PluginManager::staticMetaObject
	{53, 199, 669},	//612 Soprano::Query::QUERY_LANGUAGE_NONE
	{53, 200, 671},	//613 Soprano::Query::QUERY_LANGUAGE_RDQL
	{53, 201, 672},	//614 Soprano::Query::QUERY_LANGUAGE_SERQL
	{53, 202, 670},	//615 Soprano::Query::QUERY_LANGUAGE_SPARQL
	{53, 203, 673},	//616 Soprano::Query::QUERY_LANGUAGE_USER
	{53, 207, 664},	//617 Soprano::Query::QueryLanguageNone
	{53, 208, 666},	//618 Soprano::Query::QueryLanguageRdql
	{53, 209, 667},	//619 Soprano::Query::QueryLanguageSerql
	{53, 210, 665},	//620 Soprano::Query::QueryLanguageSparql
	{53, 211, 668},	//621 Soprano::Query::QueryLanguageUser
	{53, 874, 676},	//622 Soprano::Query::queryLanguageFromString$
	{53, 876, 675},	//623 Soprano::Query::queryLanguageToString$
	{53, 877, 674},	//624 Soprano::Query::queryLanguageToString$$
	{54, 212, 677},	//625 Soprano::QueryResultIterator::QueryResultIterator
	{54, 213, 678},	//626 Soprano::QueryResultIterator::QueryResultIterator#
	{54, 214, 679},	//627 Soprano::QueryResultIterator::QueryResultIterator?
	{54, 326, 694},	//628 Soprano::QueryResultIterator::allBindings
	{54, 368, -87},	//629 Soprano::QueryResultIterator::binding$
	{54, 369, 689},	//630 Soprano::QueryResultIterator::bindingCount
	{54, 370, 690},	//631 Soprano::QueryResultIterator::bindingNames
	{54, 375, 684},	//632 Soprano::QueryResultIterator::boolValue
	{54, 479, 683},	//633 Soprano::QueryResultIterator::currentBindings
	{54, 480, 682},	//634 Soprano::QueryResultIterator::currentStatement
	{54, 635, 692},	//635 Soprano::QueryResultIterator::isBinding
	{54, 637, 693},	//636 Soprano::QueryResultIterator::isBool
	{54, 656, 691},	//637 Soprano::QueryResultIterator::isGraph
	{54, 691, -90},	//638 Soprano::QueryResultIterator::iterateBindings$
	{54, 695, 695},	//639 Soprano::QueryResultIterator::iterateStatements
	{54, 697, 700},	//640 Soprano::QueryResultIterator::iterateStatementsFromBindings$$$
	{54, 698, 699},	//641 Soprano::QueryResultIterator::iterateStatementsFromBindings$$$$
	{54, 699, 698},	//642 Soprano::QueryResultIterator::iterateStatementsFromBindings$$$$#
	{54, 808, 681},	//643 Soprano::QueryResultIterator::operator=#
	{54, 818, -93},	//644 Soprano::QueryResultIterator::operator[]$
	{54, 1187, 680},	//645 Soprano::QueryResultIterator::~QueryResultIterator
	{55, 218, 702},	//646 Soprano::RdfSchemaModel::RdfSchemaModel
	{55, 219, 701},	//647 Soprano::RdfSchemaModel::RdfSchemaModel#
	{55, 393, 704},	//648 Soprano::RdfSchemaModel::classes
	{55, 504, 706},	//649 Soprano::RdfSchemaModel::directSubClassOf#
	{55, 505, 705},	//650 Soprano::RdfSchemaModel::directSubClassOf##
	{55, 507, 708},	//651 Soprano::RdfSchemaModel::directSubPropertyOf#
	{55, 508, 707},	//652 Soprano::RdfSchemaModel::directSubPropertyOf##
	{55, 510, 709},	//653 Soprano::RdfSchemaModel::directType##
	{55, 537, 710},	//654 Soprano::RdfSchemaModel::domain##
	{55, 640, 718},	//655 Soprano::RdfSchemaModel::isClass#
	{55, 647, 720},	//656 Soprano::RdfSchemaModel::isDirectSubClassOf##
	{55, 649, 721},	//657 Soprano::RdfSchemaModel::isDirectSubPropertyOf##
	{55, 651, 722},	//658 Soprano::RdfSchemaModel::isDirectType##
	{55, 669, 719},	//659 Soprano::RdfSchemaModel::isProperty#
	{55, 677, 723},	//660 Soprano::RdfSchemaModel::isSubClassOf##
	{55, 679, 724},	//661 Soprano::RdfSchemaModel::isSubPropertyOf##
	{55, 684, 725},	//662 Soprano::RdfSchemaModel::isType##
	{55, 869, 711},	//663 Soprano::RdfSchemaModel::properties
	{55, 880, 712},	//664 Soprano::RdfSchemaModel::range##
	{55, 1051, 714},	//665 Soprano::RdfSchemaModel::subClassOf#
	{55, 1052, 713},	//666 Soprano::RdfSchemaModel::subClassOf##
	{55, 1055, 716},	//667 Soprano::RdfSchemaModel::subPropertyOf#
	{55, 1056, 715},	//668 Soprano::RdfSchemaModel::subPropertyOf##
	{55, 1102, 717},	//669 Soprano::RdfSchemaModel::type##
	{55, 1188, 703},	//670 Soprano::RdfSchemaModel::~RdfSchemaModel
	{56, 252, 736},	//671 Soprano::Serializer::Serializer$
	{56, 305, 733},	//672 Soprano::Serializer::addPrefix$#
	{56, 396, 734},	//673 Soprano::Serializer::clearPrefixes
	{56, 865, 735},	//674 Soprano::Serializer::prefixes
	{56, 956, 732},	//675 Soprano::Serializer::serialize##$
	{56, 957, 731},	//676 Soprano::Serializer::serialize##$$
	{56, 1064, 727},	//677 Soprano::Serializer::supportedSerializations
	{56, 1066, 728},	//678 Soprano::Serializer::supportedUserSerializations
	{56, 1071, 730},	//679 Soprano::Serializer::supportsSerialization$
	{56, 1072, 729},	//680 Soprano::Serializer::supportsSerialization$$
	{56, 1193, 726},	//681 Soprano::Serializer::~Serializer
	{58, 58, -96},	//682 Soprano::Server::DBusExportIterator::DBusExportIterator#
	{58, 59, -100},	//683 Soprano::Server::DBusExportIterator::DBusExportIterator##
	{58, 489, 749},	//684 Soprano::Server::DBusExportIterator::dbusObjectPath
	{58, 497, 750},	//685 Soprano::Server::DBusExportIterator::deleteOnClose
	{58, 760, 737},	//686 Soprano::Server::DBusExportIterator::metaObject
	{58, 777, 747},	//687 Soprano::Server::DBusExportIterator::nodeIterator
	{58, 871, 738},	//688 Soprano::Server::DBusExportIterator::qt_metacall$$?
	{58, 878, 748},	//689 Soprano::Server::DBusExportIterator::queryResultIterator
	{58, 891, 753},	//690 Soprano::Server::DBusExportIterator::registerIterator$
	{58, 892, 752},	//691 Soprano::Server::DBusExportIterator::registerIterator$$
	{58, 977, 751},	//692 Soprano::Server::DBusExportIterator::setDeleteOnClose$
	{58, 1041, 746},	//693 Soprano::Server::DBusExportIterator::statementIterator
	{58, 1046, 755},	//694 Soprano::Server::DBusExportIterator::staticMetaObject
	{58, 1106, 754},	//695 Soprano::Server::DBusExportIterator::unregisterIterator
	{58, 1162, 745},	//696 Soprano::Server::DBusExportIterator::~DBusExportIterator
	{59, 60, 759},	//697 Soprano::Server::DBusExportModel::DBusExportModel
	{59, 61, 758},	//698 Soprano::Server::DBusExportModel::DBusExportModel#
	{59, 489, 763},	//699 Soprano::Server::DBusExportModel::dbusObjectPath
	{59, 760, 756},	//700 Soprano::Server::DBusExportModel::metaObject
	{59, 871, 757},	//701 Soprano::Server::DBusExportModel::qt_metacall$$?
	{59, 894, 761},	//702 Soprano::Server::DBusExportModel::registerModel$
	{59, 1046, 764},	//703 Soprano::Server::DBusExportModel::staticMetaObject
	{59, 1107, 762},	//704 Soprano::Server::DBusExportModel::unregisterModel
	{59, 1163, 760},	//705 Soprano::Server::DBusExportModel::~DBusExportModel
	{60, 71, 784},	//706 Soprano::Server::ServerCore::DEFAULT_PORT
	{60, 253, 768},	//707 Soprano::Server::ServerCore::ServerCore
	{60, 254, 767},	//708 Soprano::Server::ServerCore::ServerCore#
	{60, 327, 775},	//709 Soprano::Server::ServerCore::allModels
	{60, 356, 771},	//710 Soprano::Server::ServerCore::backend
	{60, 464, 785},	//711 Soprano::Server::ServerCore::createModel?
	{60, 727, 779},	//712 Soprano::Server::ServerCore::listen
	{60, 728, 778},	//713 Soprano::Server::ServerCore::listen$
	{60, 760, 765},	//714 Soprano::Server::ServerCore::metaObject
	{60, 768, 773},	//715 Soprano::Server::ServerCore::model$
	{60, 871, 766},	//716 Soprano::Server::ServerCore::qt_metacall$$?
	{60, 888, 782},	//717 Soprano::Server::ServerCore::registerAsDBusObject
	{60, 889, 781},	//718 Soprano::Server::ServerCore::registerAsDBusObject$
	{60, 911, 774},	//719 Soprano::Server::ServerCore::removeModel$
	{60, 958, 780},	//720 Soprano::Server::ServerCore::serverPort
	{60, 962, 770},	//721 Soprano::Server::ServerCore::setBackend#
	{60, 964, 772},	//722 Soprano::Server::ServerCore::setBackendSettings?
	{60, 1034, 777},	//723 Soprano::Server::ServerCore::start
	{60, 1035, 776},	//724 Soprano::Server::ServerCore::start$
	{60, 1046, 783},	//725 Soprano::Server::ServerCore::staticMetaObject
	{60, 1194, 769},	//726 Soprano::Server::ServerCore::~ServerCore
	{61, 270, 786},	//727 Soprano::Statement::Statement
	{61, 271, 789},	//728 Soprano::Statement::Statement#
	{61, 272, 788},	//729 Soprano::Statement::Statement###
	{61, 273, 787},	//730 Soprano::Statement::Statement####
	{61, 448, 799},	//731 Soprano::Statement::context
	{61, 687, 795},	//732 Soprano::Statement::isValid
	{61, 749, 794},	//733 Soprano::Statement::matches#
	{61, 781, 798},	//734 Soprano::Statement::object
	{61, 792, 793},	//735 Soprano::Statement::operator!=#
	{61, 808, 791},	//736 Soprano::Statement::operator=#
	{61, 811, 792},	//737 Soprano::Statement::operator==#
	{61, 861, 797},	//738 Soprano::Statement::predicate
	{61, 974, 803},	//739 Soprano::Statement::setContext#
	{61, 994, 802},	//740 Soprano::Statement::setObject#
	{61, 1005, 801},	//741 Soprano::Statement::setPredicate#
	{61, 1012, 800},	//742 Soprano::Statement::setSubject#
	{61, 1058, 796},	//743 Soprano::Statement::subject
	{61, 1198, 790},	//744 Soprano::Statement::~Statement
	{62, 274, 804},	//745 Soprano::StatementIterator::StatementIterator
	{62, 275, 805},	//746 Soprano::StatementIterator::StatementIterator#
	{62, 332, 808},	//747 Soprano::StatementIterator::allStatements
	{62, 692, 812},	//748 Soprano::StatementIterator::iterateContexts
	{62, 693, 811},	//749 Soprano::StatementIterator::iterateObjects
	{62, 694, 810},	//750 Soprano::StatementIterator::iteratePredicates
	{62, 700, 809},	//751 Soprano::StatementIterator::iterateSubjects
	{62, 808, 807},	//752 Soprano::StatementIterator::operator=#
	{62, 1199, 806},	//753 Soprano::StatementIterator::~StatementIterator
	{63, 280, 822},	//754 Soprano::StorageModel::StorageModel#
	{63, 356, 820},	//755 Soprano::StorageModel::backend
	{63, 426, 818},	//756 Soprano::StorageModel::containsAnyStatement#
	{63, 436, 817},	//757 Soprano::StorageModel::containsStatement#
	{63, 653, 816},	//758 Soprano::StorageModel::isEmpty
	{63, 760, 813},	//759 Soprano::StorageModel::metaObject
	{63, 871, 814},	//760 Soprano::StorageModel::qt_metacall$$?
	{63, 901, 819},	//761 Soprano::StorageModel::removeAllStatements#
	{63, 1046, 821},	//762 Soprano::StorageModel::staticMetaObject
	{63, 1201, 815},	//763 Soprano::StorageModel::~StorageModel
	{65, 8, 828},	//764 Soprano::Util::AsyncModel::AsyncModel
	{65, 9, 827},	//765 Soprano::Util::AsyncModel::AsyncModel#
	{65, 159, 824},	//766 Soprano::Util::AsyncModel::MultiThreaded
	{65, 260, 823},	//767 Soprano::Util::AsyncModel::SingleThreaded
	{65, 313, 832},	//768 Soprano::Util::AsyncModel::addStatementAsync#
	{65, 314, 834},	//769 Soprano::Util::AsyncModel::addStatementAsync###
	{65, 315, 833},	//770 Soprano::Util::AsyncModel::addStatementAsync####
	{65, 319, 835},	//771 Soprano::Util::AsyncModel::addStatementsAsync?
	{65, 430, 855},	//772 Soprano::Util::AsyncModel::containsAnyStatementAsync#
	{65, 431, 857},	//773 Soprano::Util::AsyncModel::containsAnyStatementAsync###
	{65, 432, 856},	//774 Soprano::Util::AsyncModel::containsAnyStatementAsync####
	{65, 440, 852},	//775 Soprano::Util::AsyncModel::containsStatementAsync#
	{65, 441, 854},	//776 Soprano::Util::AsyncModel::containsStatementAsync###
	{65, 442, 853},	//777 Soprano::Util::AsyncModel::containsStatementAsync####
	{65, 457, 858},	//778 Soprano::Util::AsyncModel::createBlankNodeAsync
	{65, 563, 851},	//779 Soprano::Util::AsyncModel::executeQueryAsync$$
	{65, 564, 850},	//780 Soprano::Util::AsyncModel::executeQueryAsync$$$
	{65, 654, 843},	//781 Soprano::Util::AsyncModel::isEmptyAsync
	{65, 716, 849},	//782 Soprano::Util::AsyncModel::listContextsAsync
	{65, 721, 848},	//783 Soprano::Util::AsyncModel::listStatementsAsync
	{65, 722, 845},	//784 Soprano::Util::AsyncModel::listStatementsAsync#
	{65, 723, 847},	//785 Soprano::Util::AsyncModel::listStatementsAsync###
	{65, 724, 846},	//786 Soprano::Util::AsyncModel::listStatementsAsync####
	{65, 760, 825},	//787 Soprano::Util::AsyncModel::metaObject
	{65, 766, 831},	//788 Soprano::Util::AsyncModel::mode
	{65, 871, 826},	//789 Soprano::Util::AsyncModel::qt_metacall$$?
	{65, 905, 840},	//790 Soprano::Util::AsyncModel::removeAllStatementsAsync#
	{65, 906, 842},	//791 Soprano::Util::AsyncModel::removeAllStatementsAsync###
	{65, 907, 841},	//792 Soprano::Util::AsyncModel::removeAllStatementsAsync####
	{65, 917, 836},	//793 Soprano::Util::AsyncModel::removeStatementAsync#
	{65, 918, 838},	//794 Soprano::Util::AsyncModel::removeStatementAsync###
	{65, 919, 837},	//795 Soprano::Util::AsyncModel::removeStatementAsync####
	{65, 923, 839},	//796 Soprano::Util::AsyncModel::removeStatementsAsync?
	{65, 992, 830},	//797 Soprano::Util::AsyncModel::setMode$
	{65, 1040, 844},	//798 Soprano::Util::AsyncModel::statementCountAsync
	{65, 1046, 859},	//799 Soprano::Util::AsyncModel::staticMetaObject
	{65, 1155, 829},	//800 Soprano::Util::AsyncModel::~AsyncModel
	{66, 470, 868},	//801 Soprano::Util::AsyncResult::createResult
	{66, 550, 863},	//802 Soprano::Util::AsyncResult::errorCode
	{66, 760, 860},	//803 Soprano::Util::AsyncResult::metaObject
	{66, 776, 867},	//804 Soprano::Util::AsyncResult::node
	{66, 777, 865},	//805 Soprano::Util::AsyncResult::nodeIterator
	{66, 871, 861},	//806 Soprano::Util::AsyncResult::qt_metacall$$?
	{66, 878, 866},	//807 Soprano::Util::AsyncResult::queryResultIterator
	{66, 1041, 864},	//808 Soprano::Util::AsyncResult::statementIterator
	{66, 1046, 869},	//809 Soprano::Util::AsyncResult::staticMetaObject
	{66, 1121, 862},	//810 Soprano::Util::AsyncResult::value
	{67, 162, 876},	//811 Soprano::Util::MutexModel::MutexModel$
	{67, 163, 875},	//812 Soprano::Util::MutexModel::MutexModel$#
	{67, 192, 870},	//813 Soprano::Util::MutexModel::PlainMultiThreading
	{67, 222, 871},	//814 Soprano::Util::MutexModel::ReadWriteMultiThreading
	{67, 223, 872},	//815 Soprano::Util::MutexModel::ReadWriteSingleThreading
	{67, 309, 878},	//816 Soprano::Util::MutexModel::addStatement#
	{67, 426, 886},	//817 Soprano::Util::MutexModel::containsAnyStatement#
	{67, 436, 885},	//818 Soprano::Util::MutexModel::containsStatement#
	{67, 559, 884},	//819 Soprano::Util::MutexModel::executeQuery$$
	{67, 560, 883},	//820 Soprano::Util::MutexModel::executeQuery$$$
	{67, 653, 887},	//821 Soprano::Util::MutexModel::isEmpty
	{67, 715, 882},	//822 Soprano::Util::MutexModel::listContexts
	{67, 718, 881},	//823 Soprano::Util::MutexModel::listStatements#
	{67, 760, 873},	//824 Soprano::Util::MutexModel::metaObject
	{67, 871, 874},	//825 Soprano::Util::MutexModel::qt_metacall$$?
	{67, 901, 880},	//826 Soprano::Util::MutexModel::removeAllStatements#
	{67, 913, 879},	//827 Soprano::Util::MutexModel::removeStatement#
	{67, 1039, 888},	//828 Soprano::Util::MutexModel::statementCount
	{67, 1046, 889},	//829 Soprano::Util::MutexModel::staticMetaObject
	{67, 1178, 877},	//830 Soprano::Util::MutexModel::~MutexModel
	{68, 220, 893},	//831 Soprano::Util::ReadOnlyModel::ReadOnlyModel
	{68, 221, 892},	//832 Soprano::Util::ReadOnlyModel::ReadOnlyModel#
	{68, 309, 904},	//833 Soprano::Util::ReadOnlyModel::addStatement#
	{68, 426, 901},	//834 Soprano::Util::ReadOnlyModel::containsAnyStatement#
	{68, 436, 900},	//835 Soprano::Util::ReadOnlyModel::containsStatement#
	{68, 455, 907},	//836 Soprano::Util::ReadOnlyModel::createBlankNode
	{68, 559, 899},	//837 Soprano::Util::ReadOnlyModel::executeQuery$$
	{68, 560, 898},	//838 Soprano::Util::ReadOnlyModel::executeQuery$$$
	{68, 653, 902},	//839 Soprano::Util::ReadOnlyModel::isEmpty
	{68, 715, 897},	//840 Soprano::Util::ReadOnlyModel::listContexts
	{68, 718, 896},	//841 Soprano::Util::ReadOnlyModel::listStatements#
	{68, 760, 890},	//842 Soprano::Util::ReadOnlyModel::metaObject
	{68, 871, 891},	//843 Soprano::Util::ReadOnlyModel::qt_metacall$$?
	{68, 901, 906},	//844 Soprano::Util::ReadOnlyModel::removeAllStatements#
	{68, 913, 905},	//845 Soprano::Util::ReadOnlyModel::removeStatement#
	{68, 998, 895},	//846 Soprano::Util::ReadOnlyModel::setParentModel#
	{68, 1039, 903},	//847 Soprano::Util::ReadOnlyModel::statementCount
	{68, 1046, 908},	//848 Soprano::Util::ReadOnlyModel::staticMetaObject
	{68, 1189, 894},	//849 Soprano::Util::ReadOnlyModel::~ReadOnlyModel
	{69, 255, 912},	//850 Soprano::Util::SignalCacheModel::SignalCacheModel
	{69, 256, 911},	//851 Soprano::Util::SignalCacheModel::SignalCacheModel#
	{69, 379, 914},	//852 Soprano::Util::SignalCacheModel::cacheTime
	{69, 760, 909},	//853 Soprano::Util::SignalCacheModel::metaObject
	{69, 835, 917},	//854 Soprano::Util::SignalCacheModel::parentStatementsAdded
	{69, 836, 918},	//855 Soprano::Util::SignalCacheModel::parentStatementsRemoved
	{69, 871, 910},	//856 Soprano::Util::SignalCacheModel::qt_metacall$$?
	{69, 968, 915},	//857 Soprano::Util::SignalCacheModel::setCacheTime$
	{69, 1046, 916},	//858 Soprano::Util::SignalCacheModel::staticMetaObject
	{69, 1076, 919},	//859 Soprano::Util::SignalCacheModel::timerEvent#
	{69, 1195, 913},	//860 Soprano::Util::SignalCacheModel::~SignalCacheModel
	{70, 257, 920},	//861 Soprano::Util::SimpleNodeIterator::SimpleNodeIterator
	{70, 258, 922},	//862 Soprano::Util::SimpleNodeIterator::SimpleNodeIterator#
	{70, 259, 921},	//863 Soprano::Util::SimpleNodeIterator::SimpleNodeIterator?
	{70, 808, 925},	//864 Soprano::Util::SimpleNodeIterator::operator=#
	{70, 812, 924},	//865 Soprano::Util::SimpleNodeIterator::operator=?
	{70, 1196, 923},	//866 Soprano::Util::SimpleNodeIterator::~SimpleNodeIterator
	{72, 107, 927},	//867 Soprano::Vocabulary::NAO::FreeDesktopIcon
	{72, 188, 928},	//868 Soprano::Vocabulary::NAO::Party
	{72, 281, 929},	//869 Soprano::Vocabulary::NAO::Symbol
	{72, 284, 930},	//870 Soprano::Vocabulary::NAO::Tag
	{72, 334, 931},	//871 Soprano::Vocabulary::NAO::altLabel
	{72, 335, 932},	//872 Soprano::Vocabulary::NAO::altSymbol
	{72, 336, 933},	//873 Soprano::Vocabulary::NAO::annotation
	{72, 449, 934},	//874 Soprano::Vocabulary::NAO::contributor
	{72, 477, 935},	//875 Soprano::Vocabulary::NAO::created
	{72, 478, 936},	//876 Soprano::Vocabulary::NAO::creator
	{72, 501, 937},	//877 Soprano::Vocabulary::NAO::description
	{72, 546, 938},	//878 Soprano::Vocabulary::NAO::engineeringTool
	{72, 597, 939},	//879 Soprano::Vocabulary::NAO::hasDefaultNamespace
	{72, 598, 940},	//880 Soprano::Vocabulary::NAO::hasDefaultNamespaceAbbreviation
	{72, 601, 941},	//881 Soprano::Vocabulary::NAO::hasSubResource
	{72, 602, 942},	//882 Soprano::Vocabulary::NAO::hasSuperResource
	{72, 603, 943},	//883 Soprano::Vocabulary::NAO::hasSymbol
	{72, 604, 944},	//884 Soprano::Vocabulary::NAO::hasTag
	{72, 605, 945},	//885 Soprano::Vocabulary::NAO::hasTopic
	{72, 615, 946},	//886 Soprano::Vocabulary::NAO::iconName
	{72, 617, 947},	//887 Soprano::Vocabulary::NAO::identifier
	{72, 672, 948},	//888 Soprano::Vocabulary::NAO::isRelated
	{72, 680, 949},	//889 Soprano::Vocabulary::NAO::isTagFor
	{72, 682, 950},	//890 Soprano::Vocabulary::NAO::isTopicOf
	{72, 706, 951},	//891 Soprano::Vocabulary::NAO::lastModified
	{72, 769, 952},	//892 Soprano::Vocabulary::NAO::modified
	{72, 772, 926},	//893 Soprano::Vocabulary::NAO::naoNamespace
	{72, 780, 953},	//894 Soprano::Vocabulary::NAO::numericRating
	{72, 853, 954},	//895 Soprano::Vocabulary::NAO::personalIdentifier
	{72, 858, 955},	//896 Soprano::Vocabulary::NAO::pluralPrefLabel
	{72, 863, 956},	//897 Soprano::Vocabulary::NAO::prefLabel
	{72, 864, 957},	//898 Soprano::Vocabulary::NAO::prefSymbol
	{72, 881, 958},	//899 Soprano::Vocabulary::NAO::rating
	{72, 945, 959},	//900 Soprano::Vocabulary::NAO::score
	{72, 946, 960},	//901 Soprano::Vocabulary::NAO::scoreParameter
	{72, 951, 961},	//902 Soprano::Vocabulary::NAO::serializationLanguage
	{72, 1047, 962},	//903 Soprano::Vocabulary::NAO::status
	{72, 1128, 963},	//904 Soprano::Vocabulary::NAO::version
	{73, 7, 965},	//905 Soprano::Vocabulary::NRL::AsymmetricProperty
	{73, 48, 966},	//906 Soprano::Vocabulary::NRL::Configuration
	{73, 72, 967},	//907 Soprano::Vocabulary::NRL::Data
	{73, 77, 968},	//908 Soprano::Vocabulary::NRL::DefaultGraph
	{73, 82, 969},	//909 Soprano::Vocabulary::NRL::DocumentGraph
	{73, 100, 970},	//910 Soprano::Vocabulary::NRL::ExternalViewSpecification
	{73, 108, 971},	//911 Soprano::Vocabulary::NRL::FunctionalProperty
	{73, 109, 972},	//912 Soprano::Vocabulary::NRL::Graph
	{73, 112, 973},	//913 Soprano::Vocabulary::NRL::GraphMetadata
	{73, 113, 974},	//914 Soprano::Vocabulary::NRL::GraphView
	{73, 126, 975},	//915 Soprano::Vocabulary::NRL::InstanceBase
	{73, 127, 976},	//916 Soprano::Vocabulary::NRL::InverseFunctionalProperty
	{73, 128, 977},	//917 Soprano::Vocabulary::NRL::KnowledgeBase
	{73, 178, 978},	//918 Soprano::Vocabulary::NRL::Ontology
	{73, 224, 979},	//919 Soprano::Vocabulary::NRL::ReflexiveProperty
	{73, 239, 980},	//920 Soprano::Vocabulary::NRL::RuleViewSpecification
	{73, 240, 981},	//921 Soprano::Vocabulary::NRL::Schema
	{73, 241, 982},	//922 Soprano::Vocabulary::NRL::Semantics
	{73, 282, 983},	//923 Soprano::Vocabulary::NRL::SymmetricProperty
	{73, 290, 984},	//924 Soprano::Vocabulary::NRL::TransitiveProperty
	{73, 293, 985},	//925 Soprano::Vocabulary::NRL::ViewSpecification
	{73, 382, 986},	//926 Soprano::Vocabulary::NRL::cardinality
	{73, 453, 987},	//927 Soprano::Vocabulary::NRL::coreGraphMetadataFor
	{73, 548, 988},	//928 Soprano::Vocabulary::NRL::equivalentGraph
	{73, 568, 989},	//929 Soprano::Vocabulary::NRL::externalRealizer
	{73, 595, 990},	//930 Soprano::Vocabulary::NRL::graphMetadataFor
	{73, 599, 991},	//931 Soprano::Vocabulary::NRL::hasSemantics
	{73, 600, 992},	//932 Soprano::Vocabulary::NRL::hasSpecification
	{73, 619, 993},	//933 Soprano::Vocabulary::NRL::imports
	{73, 632, 994},	//934 Soprano::Vocabulary::NRL::inverseProperty
	{73, 751, 995},	//935 Soprano::Vocabulary::NRL::maxCardinality
	{73, 765, 996},	//936 Soprano::Vocabulary::NRL::minCardinality
	{73, 779, 964},	//937 Soprano::Vocabulary::NRL::nrlNamespace
	{73, 884, 997},	//938 Soprano::Vocabulary::NRL::realizes
	{73, 936, 998},	//939 Soprano::Vocabulary::NRL::rule
	{73, 938, 999},	//940 Soprano::Vocabulary::NRL::ruleLanguage
	{73, 950, 1000},	//941 Soprano::Vocabulary::NRL::semanticsDefinedBy
	{73, 1053, 1001},	//942 Soprano::Vocabulary::NRL::subGraphOf
	{73, 1061, 1002},	//943 Soprano::Vocabulary::NRL::superGraphOf
	{73, 1111, 1003},	//944 Soprano::Vocabulary::NRL::updatable
	{73, 1138, 1004},	//945 Soprano::Vocabulary::NRL::viewOn
	{74, 1, 1006},	//946 Soprano::Vocabulary::OWL::AllDifferent
	{74, 4, 1007},	//947 Soprano::Vocabulary::OWL::AnnotationProperty
	{74, 46, 1008},	//948 Soprano::Vocabulary::OWL::Class
	{74, 74, 1009},	//949 Soprano::Vocabulary::OWL::DataRange
	{74, 76, 1010},	//950 Soprano::Vocabulary::OWL::DatatypeProperty
	{74, 79, 1011},	//951 Soprano::Vocabulary::OWL::DeprecatedClass
	{74, 80, 1012},	//952 Soprano::Vocabulary::OWL::DeprecatedProperty
	{74, 108, 1013},	//953 Soprano::Vocabulary::OWL::FunctionalProperty
	{74, 127, 1014},	//954 Soprano::Vocabulary::OWL::InverseFunctionalProperty
	{74, 175, 1015},	//955 Soprano::Vocabulary::OWL::Nothing
	{74, 176, 1016},	//956 Soprano::Vocabulary::OWL::ObjectProperty
	{74, 178, 1017},	//957 Soprano::Vocabulary::OWL::Ontology
	{74, 179, 1018},	//958 Soprano::Vocabulary::OWL::OntologyProperty
	{74, 230, 1019},	//959 Soprano::Vocabulary::OWL::Restriction
	{74, 282, 1020},	//960 Soprano::Vocabulary::OWL::SymmetricProperty
	{74, 289, 1021},	//961 Soprano::Vocabulary::OWL::Thing
	{74, 290, 1022},	//962 Soprano::Vocabulary::OWL::TransitiveProperty
	{74, 333, 1023},	//963 Soprano::Vocabulary::OWL::allValuesFrom
	{74, 357, 1024},	//964 Soprano::Vocabulary::OWL::backwardCompatibleWith
	{74, 382, 1025},	//965 Soprano::Vocabulary::OWL::cardinality
	{74, 409, 1026},	//966 Soprano::Vocabulary::OWL::complementOf
	{74, 502, 1027},	//967 Soprano::Vocabulary::OWL::differentFrom
	{74, 531, 1028},	//968 Soprano::Vocabulary::OWL::disjointWith
	{74, 532, 1029},	//969 Soprano::Vocabulary::OWL::distinctMembers
	{74, 547, 1030},	//970 Soprano::Vocabulary::OWL::equivalentClass
	{74, 549, 1031},	//971 Soprano::Vocabulary::OWL::equivalentProperty
	{74, 606, 1032},	//972 Soprano::Vocabulary::OWL::hasValue
	{74, 619, 1033},	//973 Soprano::Vocabulary::OWL::imports
	{74, 621, 1034},	//974 Soprano::Vocabulary::OWL::incompatibleWith
	{74, 630, 1035},	//975 Soprano::Vocabulary::OWL::intersectionOf
	{74, 631, 1036},	//976 Soprano::Vocabulary::OWL::inverseOf
	{74, 751, 1037},	//977 Soprano::Vocabulary::OWL::maxCardinality
	{74, 765, 1038},	//978 Soprano::Vocabulary::OWL::minCardinality
	{74, 784, 1039},	//979 Soprano::Vocabulary::OWL::onProperty
	{74, 785, 1040},	//980 Soprano::Vocabulary::OWL::oneOf
	{74, 826, 1005},	//981 Soprano::Vocabulary::OWL::owlNamespace
	{74, 867, 1041},	//982 Soprano::Vocabulary::OWL::priorVersion
	{74, 941, 1042},	//983 Soprano::Vocabulary::OWL::sameAs
	{74, 1028, 1043},	//984 Soprano::Vocabulary::OWL::someValuesFrom
	{74, 1105, 1044},	//985 Soprano::Vocabulary::OWL::unionOf
	{74, 1129, 1045},	//986 Soprano::Vocabulary::OWL::versionInfo
	{75, 2, 1047},	//987 Soprano::Vocabulary::RDF::Alt
	{75, 38, 1048},	//988 Soprano::Vocabulary::RDF::Bag
	{75, 134, 1049},	//989 Soprano::Vocabulary::RDF::List
	{75, 198, 1050},	//990 Soprano::Vocabulary::RDF::Property
	{75, 242, 1051},	//991 Soprano::Vocabulary::RDF::Seq
	{75, 270, 1052},	//992 Soprano::Vocabulary::RDF::Statement
	{75, 296, 1053},	//993 Soprano::Vocabulary::RDF::XMLLiteral
	{75, 575, 1054},	//994 Soprano::Vocabulary::RDF::first
	{75, 775, 1055},	//995 Soprano::Vocabulary::RDF::nil
	{75, 781, 1056},	//996 Soprano::Vocabulary::RDF::object
	{75, 861, 1057},	//997 Soprano::Vocabulary::RDF::predicate
	{75, 882, 1046},	//998 Soprano::Vocabulary::RDF::rdfNamespace
	{75, 931, 1058},	//999 Soprano::Vocabulary::RDF::rest
	{75, 1058, 1059},	//1000 Soprano::Vocabulary::RDF::subject
	{75, 1101, 1060},	//1001 Soprano::Vocabulary::RDF::type
	{75, 1121, 1061},	//1002 Soprano::Vocabulary::RDF::value
	{76, 46, 1063},	//1003 Soprano::Vocabulary::RDFS::Class
	{76, 51, 1064},	//1004 Soprano::Vocabulary::RDFS::Container
	{76, 52, 1065},	//1005 Soprano::Vocabulary::RDFS::ContainerMembershipProperty
	{76, 75, 1066},	//1006 Soprano::Vocabulary::RDFS::Datatype
	{76, 135, 1067},	//1007 Soprano::Vocabulary::RDFS::Literal
	{76, 228, 1068},	//1008 Soprano::Vocabulary::RDFS::Resource
	{76, 405, 1069},	//1009 Soprano::Vocabulary::RDFS::comment
	{76, 536, 1070},	//1010 Soprano::Vocabulary::RDFS::domain
	{76, 645, 1071},	//1011 Soprano::Vocabulary::RDFS::isDefinedBy
	{76, 704, 1072},	//1012 Soprano::Vocabulary::RDFS::label
	{76, 757, 1073},	//1013 Soprano::Vocabulary::RDFS::member
	{76, 879, 1074},	//1014 Soprano::Vocabulary::RDFS::range
	{76, 883, 1062},	//1015 Soprano::Vocabulary::RDFS::rdfsNamespace
	{76, 948, 1075},	//1016 Soprano::Vocabulary::RDFS::seeAlso
	{76, 1050, 1076},	//1017 Soprano::Vocabulary::RDFS::subClassOf
	{76, 1054, 1077},	//1018 Soprano::Vocabulary::RDFS::subPropertyOf
	{77, 122, 1080},	//1019 Soprano::Vocabulary::SIL::InferenceGraph
	{77, 123, 1079},	//1020 Soprano::Vocabulary::SIL::InferenceMetaData
	{77, 448, 1082},	//1021 Soprano::Vocabulary::SIL::context
	{77, 1026, 1078},	//1022 Soprano::Vocabulary::SIL::silNamespace
	{77, 1031, 1081},	//1023 Soprano::Vocabulary::SIL::sourceStatement
	{78, 358, 1101},	//1024 Soprano::Vocabulary::XMLSchema::base64Binary
	{78, 376, 1097},	//1025 Soprano::Vocabulary::XMLSchema::boolean
	{78, 487, 1098},	//1026 Soprano::Vocabulary::XMLSchema::date
	{78, 488, 1099},	//1027 Soprano::Vocabulary::XMLSchema::dateTime
	{78, 490, 1088},	//1028 Soprano::Vocabulary::XMLSchema::decimal
	{78, 627, 1085},	//1029 Soprano::Vocabulary::XMLSchema::integer
	{78, 773, 1086},	//1030 Soprano::Vocabulary::XMLSchema::negativeInteger
	{78, 778, 1087},	//1031 Soprano::Vocabulary::XMLSchema::nonNegativeInteger
	{78, 1049, 1094},	//1032 Soprano::Vocabulary::XMLSchema::string
	{78, 1074, 1100},	//1033 Soprano::Vocabulary::XMLSchema::time
	{78, 1108, 1091},	//1034 Soprano::Vocabulary::XMLSchema::unsignedInt
	{78, 1109, 1093},	//1035 Soprano::Vocabulary::XMLSchema::unsignedLong
	{78, 1110, 1092},	//1036 Soprano::Vocabulary::XMLSchema::unsignedShort
	{78, 1149, 1096},	//1037 Soprano::Vocabulary::XMLSchema::xsdDouble
	{78, 1150, 1095},	//1038 Soprano::Vocabulary::XMLSchema::xsdFloat
	{78, 1151, 1084},	//1039 Soprano::Vocabulary::XMLSchema::xsdInt
	{78, 1152, 1090},	//1040 Soprano::Vocabulary::XMLSchema::xsdLong
	{78, 1153, 1083},	//1041 Soprano::Vocabulary::XMLSchema::xsdNamespace
	{78, 1154, 1089},	//1042 Soprano::Vocabulary::XMLSchema::xsdShort
	{79, 3, 1104},	//1043 Soprano::Vocabulary::Xesam::Annotation
	{79, 5, 1105},	//1044 Soprano::Vocabulary::Xesam::Archive
	{79, 6, 1106},	//1045 Soprano::Vocabulary::Xesam::ArchivedFile
	{79, 10, 1107},	//1046 Soprano::Vocabulary::Xesam::Audio
	{79, 11, 1108},	//1047 Soprano::Vocabulary::Xesam::AudioList
	{79, 42, 1109},	//1048 Soprano::Vocabulary::Xesam::BlockDevice
	{79, 43, 1110},	//1049 Soprano::Vocabulary::Xesam::Bookmark
	{79, 47, 1111},	//1050 Soprano::Vocabulary::Xesam::CommunicationChannel
	{79, 49, 1112},	//1051 Soprano::Vocabulary::Xesam::Contact
	{79, 50, 1113},	//1052 Soprano::Vocabulary::Xesam::ContactGroup
	{79, 53, 1114},	//1053 Soprano::Vocabulary::Xesam::Content
	{79, 73, 1115},	//1054 Soprano::Vocabulary::Xesam::DataObject
	{79, 78, 1116},	//1055 Soprano::Vocabulary::Xesam::DeletedFile
	{79, 81, 1117},	//1056 Soprano::Vocabulary::Xesam::Document
	{79, 83, 1118},	//1057 Soprano::Vocabulary::Xesam::Documentation
	{79, 84, 1119},	//1058 Soprano::Vocabulary::Xesam::Email
	{79, 85, 1120},	//1059 Soprano::Vocabulary::Xesam::EmailAttachment
	{79, 86, 1121},	//1060 Soprano::Vocabulary::Xesam::EmbeddedObject
	{79, 101, 1122},	//1061 Soprano::Vocabulary::Xesam::File
	{79, 102, 1123},	//1062 Soprano::Vocabulary::Xesam::FileSystem
	{79, 103, 1124},	//1063 Soprano::Vocabulary::Xesam::Filelike
	{79, 106, 1125},	//1064 Soprano::Vocabulary::Xesam::Folder
	{79, 114, 1126},	//1065 Soprano::Vocabulary::Xesam::IMAP4Message
	{79, 115, 1127},	//1066 Soprano::Vocabulary::Xesam::IMMessage
	{79, 116, 1128},	//1067 Soprano::Vocabulary::Xesam::Image
	{79, 150, 1129},	//1068 Soprano::Vocabulary::Xesam::MailingList
	{79, 151, 1130},	//1069 Soprano::Vocabulary::Xesam::MailingListEmail
	{79, 154, 1131},	//1070 Soprano::Vocabulary::Xesam::Media
	{79, 155, 1132},	//1071 Soprano::Vocabulary::Xesam::MediaList
	{79, 156, 1133},	//1072 Soprano::Vocabulary::Xesam::Message
	{79, 157, 1134},	//1073 Soprano::Vocabulary::Xesam::MessageboxMessage
	{79, 160, 1135},	//1074 Soprano::Vocabulary::Xesam::Music
	{79, 165, 1136},	//1075 Soprano::Vocabulary::Xesam::NewsGroup
	{79, 166, 1137},	//1076 Soprano::Vocabulary::Xesam::NewsGroupEmail
	{79, 177, 1138},	//1077 Soprano::Vocabulary::Xesam::OfflineMedia
	{79, 180, 1139},	//1078 Soprano::Vocabulary::Xesam::Organization
	{79, 181, 1140},	//1079 Soprano::Vocabulary::Xesam::POP3Message
	{79, 189, 1141},	//1080 Soprano::Vocabulary::Xesam::Person
	{79, 190, 1142},	//1081 Soprano::Vocabulary::Xesam::PersonalEmail
	{79, 191, 1143},	//1082 Soprano::Vocabulary::Xesam::Photo
	{79, 196, 1144},	//1083 Soprano::Vocabulary::Xesam::Presentation
	{79, 197, 1145},	//1084 Soprano::Vocabulary::Xesam::Project
	{79, 216, 1146},	//1085 Soprano::Vocabulary::Xesam::RSSFeed
	{79, 217, 1147},	//1086 Soprano::Vocabulary::Xesam::RSSMessage
	{79, 225, 1148},	//1087 Soprano::Vocabulary::Xesam::RemoteFile
	{79, 226, 1149},	//1088 Soprano::Vocabulary::Xesam::RemoteMessageboxMessage
	{79, 227, 1150},	//1089 Soprano::Vocabulary::Xesam::RemoteResource
	{79, 231, 1151},	//1090 Soprano::Vocabulary::Xesam::RevisionControlledFile
	{79, 232, 1152},	//1091 Soprano::Vocabulary::Xesam::RevisionControlledRepository
	{79, 261, 1153},	//1092 Soprano::Vocabulary::Xesam::SoftwarePackage
	{79, 262, 1154},	//1093 Soprano::Vocabulary::Xesam::Source
	{79, 263, 1155},	//1094 Soprano::Vocabulary::Xesam::SourceCode
	{79, 269, 1156},	//1095 Soprano::Vocabulary::Xesam::Spreadsheet
	{79, 283, 1157},	//1096 Soprano::Vocabulary::Xesam::SystemResource
	{79, 284, 1158},	//1097 Soprano::Vocabulary::Xesam::Tag
	{79, 287, 1159},	//1098 Soprano::Vocabulary::Xesam::Text
	{79, 288, 1160},	//1099 Soprano::Vocabulary::Xesam::TextDocument
	{79, 291, 1161},	//1100 Soprano::Vocabulary::Xesam::UncategorizedText
	{79, 292, 1162},	//1101 Soprano::Vocabulary::Xesam::Video
	{79, 294, 1163},	//1102 Soprano::Vocabulary::Xesam::Visual
	{79, 295, 1164},	//1103 Soprano::Vocabulary::Xesam::XML
	{79, 297, 1165},	//1104 Soprano::Vocabulary::Xesam::acl
	{79, 320, 1166},	//1105 Soprano::Vocabulary::Xesam::album
	{79, 321, 1167},	//1106 Soprano::Vocabulary::Xesam::albumArtist
	{79, 322, 1168},	//1107 Soprano::Vocabulary::Xesam::albumGain
	{79, 323, 1169},	//1108 Soprano::Vocabulary::Xesam::albumPeakGain
	{79, 324, 1170},	//1109 Soprano::Vocabulary::Xesam::albumTrackCount
	{79, 337, 1171},	//1110 Soprano::Vocabulary::Xesam::aperture
	{79, 338, 1172},	//1111 Soprano::Vocabulary::Xesam::artist
	{79, 339, 1173},	//1112 Soprano::Vocabulary::Xesam::asText
	{79, 340, 1174},	//1113 Soprano::Vocabulary::Xesam::aspectRatio
	{79, 344, 1175},	//1114 Soprano::Vocabulary::Xesam::attachmentEncoding
	{79, 345, 1176},	//1115 Soprano::Vocabulary::Xesam::audioBPM
	{79, 346, 1177},	//1116 Soprano::Vocabulary::Xesam::audioBitrate
	{79, 347, 1178},	//1117 Soprano::Vocabulary::Xesam::audioChannels
	{79, 348, 1179},	//1118 Soprano::Vocabulary::Xesam::audioCodec
	{79, 349, 1180},	//1119 Soprano::Vocabulary::Xesam::audioCodecType
	{79, 350, 1181},	//1120 Soprano::Vocabulary::Xesam::audioSampleBitDepth
	{79, 351, 1182},	//1121 Soprano::Vocabulary::Xesam::audioSampleCount
	{79, 352, 1183},	//1122 Soprano::Vocabulary::Xesam::audioSampleDataType
	{79, 353, 1184},	//1123 Soprano::Vocabulary::Xesam::audioSampleRate
	{79, 354, 1185},	//1124 Soprano::Vocabulary::Xesam::author
	{79, 355, 1186},	//1125 Soprano::Vocabulary::Xesam::autoRating
	{79, 359, 1187},	//1126 Soprano::Vocabulary::Xesam::baseRevisionID
	{79, 360, 1188},	//1127 Soprano::Vocabulary::Xesam::bcc
	{79, 371, 1189},	//1128 Soprano::Vocabulary::Xesam::birthDate
	{79, 374, 1190},	//1129 Soprano::Vocabulary::Xesam::blogContactURL
	{79, 380, 1191},	//1130 Soprano::Vocabulary::Xesam::cameraManufacturer
	{79, 381, 1192},	//1131 Soprano::Vocabulary::Xesam::cameraModel
	{79, 383, 1193},	//1132 Soprano::Vocabulary::Xesam::cc
	{79, 384, 1194},	//1133 Soprano::Vocabulary::Xesam::ccdWidth
	{79, 385, 1195},	//1134 Soprano::Vocabulary::Xesam::cellPhoneNumber
	{79, 386, 1196},	//1135 Soprano::Vocabulary::Xesam::changeCommitTime
	{79, 387, 1197},	//1136 Soprano::Vocabulary::Xesam::changeCommitter
	{79, 388, 1198},	//1137 Soprano::Vocabulary::Xesam::characterCount
	{79, 389, 1199},	//1138 Soprano::Vocabulary::Xesam::charset
	{79, 390, 1200},	//1139 Soprano::Vocabulary::Xesam::chatRoom
	{79, 401, 1201},	//1140 Soprano::Vocabulary::Xesam::colorCount
	{79, 402, 1202},	//1141 Soprano::Vocabulary::Xesam::colorSpace
	{79, 404, 1203},	//1142 Soprano::Vocabulary::Xesam::columnCount
	{79, 405, 1204},	//1143 Soprano::Vocabulary::Xesam::comment
	{79, 406, 1205},	//1144 Soprano::Vocabulary::Xesam::commentCharacterCount
	{79, 407, 1206},	//1145 Soprano::Vocabulary::Xesam::commitDiff
	{79, 408, 1207},	//1146 Soprano::Vocabulary::Xesam::communicationChannel
	{79, 410, 1208},	//1147 Soprano::Vocabulary::Xesam::composer
	{79, 411, 1209},	//1148 Soprano::Vocabulary::Xesam::compressionAlgorithm
	{79, 412, 1210},	//1149 Soprano::Vocabulary::Xesam::compressionLevel
	{79, 413, 1211},	//1150 Soprano::Vocabulary::Xesam::conflicts
	{79, 420, 1212},	//1151 Soprano::Vocabulary::Xesam::contactMedium
	{79, 421, 1213},	//1152 Soprano::Vocabulary::Xesam::contactNick
	{79, 422, 1214},	//1153 Soprano::Vocabulary::Xesam::contactURL
	{79, 423, 1215},	//1154 Soprano::Vocabulary::Xesam::contains
	{79, 443, 1216},	//1155 Soprano::Vocabulary::Xesam::contentComment
	{79, 444, 1217},	//1156 Soprano::Vocabulary::Xesam::contentCreated
	{79, 445, 1218},	//1157 Soprano::Vocabulary::Xesam::contentKeyword
	{79, 446, 1219},	//1158 Soprano::Vocabulary::Xesam::contentModified
	{79, 447, 1220},	//1159 Soprano::Vocabulary::Xesam::contentType
	{79, 449, 1221},	//1160 Soprano::Vocabulary::Xesam::contributor
	{79, 452, 1222},	//1161 Soprano::Vocabulary::Xesam::copyright
	{79, 478, 1223},	//1162 Soprano::Vocabulary::Xesam::creator
	{79, 492, 1224},	//1163 Soprano::Vocabulary::Xesam::definesClass
	{79, 493, 1225},	//1164 Soprano::Vocabulary::Xesam::definesFunction
	{79, 494, 1226},	//1165 Soprano::Vocabulary::Xesam::definesGlobalVariable
	{79, 498, 1227},	//1166 Soprano::Vocabulary::Xesam::deletionTime
	{79, 499, 1228},	//1167 Soprano::Vocabulary::Xesam::depends
	{79, 500, 1229},	//1168 Soprano::Vocabulary::Xesam::derivedFrom
	{79, 501, 1230},	//1169 Soprano::Vocabulary::Xesam::description
	{79, 511, 1231},	//1170 Soprano::Vocabulary::Xesam::discNumber
	{79, 512, 1232},	//1171 Soprano::Vocabulary::Xesam::disclaimer
	{79, 533, 1233},	//1172 Soprano::Vocabulary::Xesam::documentCategory
	{79, 541, 1234},	//1173 Soprano::Vocabulary::Xesam::emailAddress
	{79, 565, 1235},	//1174 Soprano::Vocabulary::Xesam::exposureBias
	{79, 566, 1236},	//1175 Soprano::Vocabulary::Xesam::exposureProgram
	{79, 567, 1237},	//1176 Soprano::Vocabulary::Xesam::exposureTime
	{79, 569, 1238},	//1177 Soprano::Vocabulary::Xesam::familyName
	{79, 570, 1239},	//1178 Soprano::Vocabulary::Xesam::faxPhoneNumber
	{79, 571, 1240},	//1179 Soprano::Vocabulary::Xesam::fileExtension
	{79, 573, 1241},	//1180 Soprano::Vocabulary::Xesam::fileSystemType
	{79, 574, 1242},	//1181 Soprano::Vocabulary::Xesam::fingerprint
	{79, 576, 1243},	//1182 Soprano::Vocabulary::Xesam::firstUsed
	{79, 577, 1244},	//1183 Soprano::Vocabulary::Xesam::flashUsed
	{79, 578, 1245},	//1184 Soprano::Vocabulary::Xesam::focalLength
	{79, 579, 1246},	//1185 Soprano::Vocabulary::Xesam::focusDistance
	{79, 581, 1247},	//1186 Soprano::Vocabulary::Xesam::formatSubtype
	{79, 582, 1248},	//1187 Soprano::Vocabulary::Xesam::frameCount
	{79, 583, 1249},	//1188 Soprano::Vocabulary::Xesam::frameRate
	{79, 584, 1250},	//1189 Soprano::Vocabulary::Xesam::freeSpace
	{79, 588, 1251},	//1190 Soprano::Vocabulary::Xesam::gender
	{79, 589, 1252},	//1191 Soprano::Vocabulary::Xesam::generator
	{79, 590, 1253},	//1192 Soprano::Vocabulary::Xesam::generatorOptions
	{79, 591, 1254},	//1193 Soprano::Vocabulary::Xesam::genre
	{79, 594, 1255},	//1194 Soprano::Vocabulary::Xesam::givenName
	{79, 596, 1256},	//1195 Soprano::Vocabulary::Xesam::group
	{79, 607, 1257},	//1196 Soprano::Vocabulary::Xesam::height
	{79, 608, 1258},	//1197 Soprano::Vocabulary::Xesam::homeEmailAddress
	{79, 609, 1259},	//1198 Soprano::Vocabulary::Xesam::homePhoneNumber
	{79, 610, 1260},	//1199 Soprano::Vocabulary::Xesam::homePostalAddress
	{79, 611, 1261},	//1200 Soprano::Vocabulary::Xesam::homepageContactURL
	{79, 612, 1262},	//1201 Soprano::Vocabulary::Xesam::honorificPrefix
	{79, 613, 1263},	//1202 Soprano::Vocabulary::Xesam::honorificSuffix
	{79, 614, 1264},	//1203 Soprano::Vocabulary::Xesam::horizontalResolution
	{79, 616, 1265},	//1204 Soprano::Vocabulary::Xesam::id
	{79, 618, 1266},	//1205 Soprano::Vocabulary::Xesam::imContactMedium
	{79, 620, 1267},	//1206 Soprano::Vocabulary::Xesam::inReplyTo
	{79, 628, 1268},	//1207 Soprano::Vocabulary::Xesam::interest
	{79, 629, 1269},	//1208 Soprano::Vocabulary::Xesam::interlaceMode
	{79, 633, 1270},	//1209 Soprano::Vocabulary::Xesam::ircContactMedium
	{79, 642, 1271},	//1210 Soprano::Vocabulary::Xesam::isContentEncrypted
	{79, 655, 1272},	//1211 Soprano::Vocabulary::Xesam::isEncrypted
	{79, 657, 1273},	//1212 Soprano::Vocabulary::Xesam::isImportant
	{79, 658, 1274},	//1213 Soprano::Vocabulary::Xesam::isInProgress
	{79, 670, 1275},	//1214 Soprano::Vocabulary::Xesam::isPublicChannel
	{79, 671, 1276},	//1215 Soprano::Vocabulary::Xesam::isRead
	{79, 674, 1277},	//1216 Soprano::Vocabulary::Xesam::isSourceEncrypted
	{79, 689, 1278},	//1217 Soprano::Vocabulary::Xesam::isoEquivalent
	{79, 701, 1279},	//1218 Soprano::Vocabulary::Xesam::jabberContactMedium
	{79, 702, 1280},	//1219 Soprano::Vocabulary::Xesam::keyword
	{79, 703, 1281},	//1220 Soprano::Vocabulary::Xesam::knows
	{79, 705, 1282},	//1221 Soprano::Vocabulary::Xesam::language
	{79, 707, 1283},	//1222 Soprano::Vocabulary::Xesam::lastRefreshed
	{79, 708, 1284},	//1223 Soprano::Vocabulary::Xesam::lastUsed
	{79, 709, 1285},	//1224 Soprano::Vocabulary::Xesam::legal
	{79, 710, 1286},	//1225 Soprano::Vocabulary::Xesam::license
	{79, 711, 1287},	//1226 Soprano::Vocabulary::Xesam::licenseType
	{79, 713, 1288},	//1227 Soprano::Vocabulary::Xesam::lineCount
	{79, 714, 1289},	//1228 Soprano::Vocabulary::Xesam::links
	{79, 732, 1290},	//1229 Soprano::Vocabulary::Xesam::localRevision
	{79, 741, 1291},	//1230 Soprano::Vocabulary::Xesam::lyricist
	{79, 742, 1292},	//1231 Soprano::Vocabulary::Xesam::mailingList
	{79, 743, 1293},	//1232 Soprano::Vocabulary::Xesam::mailingPostalAddress
	{79, 744, 1294},	//1233 Soprano::Vocabulary::Xesam::maintainer
	{79, 745, 1295},	//1234 Soprano::Vocabulary::Xesam::markupCharacterCount
	{79, 752, 1296},	//1235 Soprano::Vocabulary::Xesam::md5Hash
	{79, 753, 1297},	//1236 Soprano::Vocabulary::Xesam::mediaBitrate
	{79, 754, 1298},	//1237 Soprano::Vocabulary::Xesam::mediaCodec
	{79, 755, 1299},	//1238 Soprano::Vocabulary::Xesam::mediaCodecType
	{79, 756, 1300},	//1239 Soprano::Vocabulary::Xesam::mediaDuration
	{79, 758, 1301},	//1240 Soprano::Vocabulary::Xesam::mergeConflict
	{79, 761, 1302},	//1241 Soprano::Vocabulary::Xesam::meteringMode
	{79, 762, 1303},	//1242 Soprano::Vocabulary::Xesam::mimeType
	{79, 770, 1304},	//1243 Soprano::Vocabulary::Xesam::mountPoint
	{79, 771, 1305},	//1244 Soprano::Vocabulary::Xesam::name
	{79, 774, 1306},	//1245 Soprano::Vocabulary::Xesam::newsGroup
	{79, 783, 1307},	//1246 Soprano::Vocabulary::Xesam::occupiedSpace
	{79, 822, 1308},	//1247 Soprano::Vocabulary::Xesam::orientation
	{79, 823, 1309},	//1248 Soprano::Vocabulary::Xesam::originURL
	{79, 824, 1310},	//1249 Soprano::Vocabulary::Xesam::originalLocation
	{79, 825, 1311},	//1250 Soprano::Vocabulary::Xesam::otherName
	{79, 827, 1312},	//1251 Soprano::Vocabulary::Xesam::owner
	{79, 828, 1313},	//1252 Soprano::Vocabulary::Xesam::pageCount
	{79, 829, 1314},	//1253 Soprano::Vocabulary::Xesam::paragraphCount
	{79, 850, 1315},	//1254 Soprano::Vocabulary::Xesam::performer
	{79, 851, 1316},	//1255 Soprano::Vocabulary::Xesam::permissions
	{79, 852, 1317},	//1256 Soprano::Vocabulary::Xesam::personPhoto
	{79, 854, 1318},	//1257 Soprano::Vocabulary::Xesam::phoneNumber
	{79, 855, 1319},	//1258 Soprano::Vocabulary::Xesam::pixelDataBitDepth
	{79, 856, 1320},	//1259 Soprano::Vocabulary::Xesam::pixelDataType
	{79, 859, 1321},	//1260 Soprano::Vocabulary::Xesam::postalAddress
	{79, 866, 1322},	//1261 Soprano::Vocabulary::Xesam::primaryRecipient
	{79, 868, 1323},	//1262 Soprano::Vocabulary::Xesam::programmingLanguage
	{79, 886, 1324},	//1263 Soprano::Vocabulary::Xesam::receptionTime
	{79, 887, 1325},	//1264 Soprano::Vocabulary::Xesam::recipient
	{79, 895, 1326},	//1265 Soprano::Vocabulary::Xesam::related
	{79, 896, 1327},	//1266 Soprano::Vocabulary::Xesam::remotePassword
	{79, 897, 1328},	//1267 Soprano::Vocabulary::Xesam::remotePort
	{79, 898, 1329},	//1268 Soprano::Vocabulary::Xesam::remoteServer
	{79, 899, 1330},	//1269 Soprano::Vocabulary::Xesam::remoteUser
	{79, 926, 1331},	//1270 Soprano::Vocabulary::Xesam::replyTo
	{79, 934, 1332},	//1271 Soprano::Vocabulary::Xesam::rowCount
	{79, 935, 1333},	//1272 Soprano::Vocabulary::Xesam::rssFeed
	{79, 942, 1334},	//1273 Soprano::Vocabulary::Xesam::sampleConfiguration
	{79, 943, 1335},	//1274 Soprano::Vocabulary::Xesam::sampleDataBitDepth
	{79, 944, 1336},	//1275 Soprano::Vocabulary::Xesam::sampleDataType
	{79, 947, 1337},	//1276 Soprano::Vocabulary::Xesam::secondaryRecipient
	{79, 949, 1338},	//1277 Soprano::Vocabulary::Xesam::seenAttachedAs
	{79, 975, 1339},	//1278 Soprano::Vocabulary::Xesam::setCount
	{79, 1008, 1340},	//1279 Soprano::Vocabulary::Xesam::setRate
	{79, 1025, 1341},	//1280 Soprano::Vocabulary::Xesam::sha1Hash
	{79, 1027, 1342},	//1281 Soprano::Vocabulary::Xesam::size
	{79, 1029, 1343},	//1282 Soprano::Vocabulary::Xesam::sourceCreated
	{79, 1030, 1344},	//1283 Soprano::Vocabulary::Xesam::sourceModified
	{79, 1048, 1345},	//1284 Soprano::Vocabulary::Xesam::storageSize
	{79, 1058, 1346},	//1285 Soprano::Vocabulary::Xesam::subject
	{79, 1060, 1347},	//1286 Soprano::Vocabulary::Xesam::summary
	{79, 1062, 1348},	//1287 Soprano::Vocabulary::Xesam::supercedes
	{79, 1073, 1349},	//1288 Soprano::Vocabulary::Xesam::targetQuality
	{79, 1077, 1350},	//1289 Soprano::Vocabulary::Xesam::title
	{79, 1078, 1351},	//1290 Soprano::Vocabulary::Xesam::to
	{79, 1095, 1352},	//1291 Soprano::Vocabulary::Xesam::totalSpace
	{79, 1096, 1353},	//1292 Soprano::Vocabulary::Xesam::totalUncompressedSize
	{79, 1097, 1354},	//1293 Soprano::Vocabulary::Xesam::trackGain
	{79, 1098, 1355},	//1294 Soprano::Vocabulary::Xesam::trackNumber
	{79, 1099, 1356},	//1295 Soprano::Vocabulary::Xesam::trackPeakGain
	{79, 1113, 1357},	//1296 Soprano::Vocabulary::Xesam::url
	{79, 1114, 1358},	//1297 Soprano::Vocabulary::Xesam::useCount
	{79, 1116, 1359},	//1298 Soprano::Vocabulary::Xesam::userComment
	{79, 1117, 1360},	//1299 Soprano::Vocabulary::Xesam::userKeyword
	{79, 1119, 1361},	//1300 Soprano::Vocabulary::Xesam::userRating
	{79, 1120, 1362},	//1301 Soprano::Vocabulary::Xesam::usesNamespace
	{79, 1128, 1363},	//1302 Soprano::Vocabulary::Xesam::version
	{79, 1134, 1364},	//1303 Soprano::Vocabulary::Xesam::verticalResolution
	{79, 1135, 1365},	//1304 Soprano::Vocabulary::Xesam::videoBitrate
	{79, 1136, 1366},	//1305 Soprano::Vocabulary::Xesam::videoCodec
	{79, 1137, 1367},	//1306 Soprano::Vocabulary::Xesam::videoCodecType
	{79, 1139, 1368},	//1307 Soprano::Vocabulary::Xesam::whiteBalance
	{79, 1140, 1369},	//1308 Soprano::Vocabulary::Xesam::width
	{79, 1141, 1370},	//1309 Soprano::Vocabulary::Xesam::wordCount
	{79, 1142, 1371},	//1310 Soprano::Vocabulary::Xesam::workEmailAddress
	{79, 1143, 1372},	//1311 Soprano::Vocabulary::Xesam::workPhoneNumber
	{79, 1144, 1373},	//1312 Soprano::Vocabulary::Xesam::workPostalAddress
	{79, 1147, 1103},	//1313 Soprano::Vocabulary::Xesam::xesam35mmEquivalent
	{79, 1148, 1102},	//1314 Soprano::Vocabulary::Xesam::xesamNamespace
};

static Smoke::Index soprano_ambiguousMethodList[] = {
    0,
    69,  // Soprano::BackendSetting::BackendSetting(const QString&, const QVariant&)
    68,  // Soprano::BackendSetting::BackendSetting(Soprano::BackendOption, const QVariant&)
    0,
    83,  // Soprano::BindingSet::operator[](const QString) const
    82,  // Soprano::BindingSet::operator[](int) const
    0,
    89,  // Soprano::BindingSet::replace(int, const Soprano::Node&)
    90,  // Soprano::BindingSet::replace(const QString&, const Soprano::Node&)
    0,
    84,  // Soprano::BindingSet::value(int) const
    85,  // Soprano::BindingSet::value(const QString&) const
    0,
    226,  // Soprano::Error::ParserError::ParserError(const Soprano::Error::Locator&)
    231,  // Soprano::Error::ParserError::ParserError(const Soprano::Error::ParserError&)
    227,  // Soprano::Error::ParserError::ParserError(const Soprano::Error::Error&)
    0,
    304,  // Soprano::Graph::operator+(const Soprano::Graph&) const
    305,  // Soprano::Graph::operator+(const Soprano::Statement&) const
    0,
    306,  // Soprano::Graph::operator+=(const Soprano::Graph&)
    307,  // Soprano::Graph::operator+=(const Soprano::Statement&)
    0,
    308,  // Soprano::Graph::operator-(const Soprano::Graph&) const
    309,  // Soprano::Graph::operator-(const Soprano::Statement&) const
    0,
    311,  // Soprano::Graph::operator-=(const Soprano::Statement&)
    310,  // Soprano::Graph::operator-=(const Soprano::Graph&)
    0,
    312,  // Soprano::Graph::operator<<(const Soprano::Graph&)
    313,  // Soprano::Graph::operator<<(const Soprano::Statement&)
    0,
    385,  // Soprano::Inference::NodePattern::NodePattern(const Soprano::Inference::NodePattern&)
    383,  // Soprano::Inference::NodePattern::NodePattern(const Soprano::Node&)
    0,
    427,  // Soprano::Inference::RuleSet::operator[](int) const
    429,  // Soprano::Inference::RuleSet::operator[](const QString&) const
    0,
    453,  // Soprano::LanguageTag::LanguageTag(const QLocale&)
    449,  // Soprano::LanguageTag::LanguageTag(const Soprano::LanguageTag&)
    0,
    455,  // Soprano::LanguageTag::LanguageTag(QLocale::Language)
    450,  // Soprano::LanguageTag::LanguageTag(const char*)
    452,  // Soprano::LanguageTag::LanguageTag(const QString&)
    0,
    493,  // Soprano::LiteralValue::LiteralValue(const QTime&)
    495,  // Soprano::LiteralValue::LiteralValue(const QByteArray&)
    482,  // Soprano::LiteralValue::LiteralValue(const QVariant&)
    492,  // Soprano::LiteralValue::LiteralValue(const QDate&)
    481,  // Soprano::LiteralValue::LiteralValue(const Soprano::LiteralValue&)
    494,  // Soprano::LiteralValue::LiteralValue(const QDateTime&)
    0,
    491,  // Soprano::LiteralValue::LiteralValue(const QString&)
    489,  // Soprano::LiteralValue::LiteralValue(const char*)
    488,  // Soprano::LiteralValue::LiteralValue(double)
    483,  // Soprano::LiteralValue::LiteralValue(int)
    486,  // Soprano::LiteralValue::LiteralValue(qulonglong)
    487,  // Soprano::LiteralValue::LiteralValue(bool)
    484,  // Soprano::LiteralValue::LiteralValue(qlonglong)
    485,  // Soprano::LiteralValue::LiteralValue(uint)
    0,
    505,  // Soprano::LiteralValue::operator=(const QDate&)
    508,  // Soprano::LiteralValue::operator=(const QByteArray&)
    496,  // Soprano::LiteralValue::operator=(const Soprano::LiteralValue&)
    506,  // Soprano::LiteralValue::operator=(const QTime&)
    507,  // Soprano::LiteralValue::operator=(const QDateTime&)
    0,
    497,  // Soprano::LiteralValue::operator=(int)
    501,  // Soprano::LiteralValue::operator=(bool)
    502,  // Soprano::LiteralValue::operator=(double)
    498,  // Soprano::LiteralValue::operator=(qlonglong)
    499,  // Soprano::LiteralValue::operator=(uint)
    503,  // Soprano::LiteralValue::operator=(const QString&)
    500,  // Soprano::LiteralValue::operator=(qulonglong)
    0,
    591,  // Soprano::Node::Node(const QUrl&)
    594,  // Soprano::Node::Node(const Soprano::Node&)
    593,  // Soprano::Node::Node(const Soprano::LiteralValue&)
    0,
    597,  // Soprano::Node::operator=(const QUrl&)
    598,  // Soprano::Node::operator=(const Soprano::LiteralValue&)
    596,  // Soprano::Node::operator=(const Soprano::Node&)
    0,
    599,  // Soprano::Node::operator==(const Soprano::Node&) const
    601,  // Soprano::Node::operator==(const QUrl&) const
    602,  // Soprano::Node::operator==(const Soprano::LiteralValue&) const
    0,
    687,  // Soprano::QueryResultIterator::binding(const QString&) const
    688,  // Soprano::QueryResultIterator::binding(int) const
    0,
    696,  // Soprano::QueryResultIterator::iterateBindings(const QString&) const
    697,  // Soprano::QueryResultIterator::iterateBindings(int) const
    0,
    686,  // Soprano::QueryResultIterator::operator[](const QString) const
    685,  // Soprano::QueryResultIterator::operator[](int) const
    0,
    740,  // Soprano::Server::DBusExportIterator::DBusExportIterator(Soprano::StatementIterator)
    744,  // Soprano::Server::DBusExportIterator::DBusExportIterator(Soprano::QueryResultIterator)
    742,  // Soprano::Server::DBusExportIterator::DBusExportIterator(Soprano::NodeIterator)
    0,
    741,  // Soprano::Server::DBusExportIterator::DBusExportIterator(Soprano::NodeIterator, QObject*)
    743,  // Soprano::Server::DBusExportIterator::DBusExportIterator(Soprano::QueryResultIterator, QObject*)
    739,  // Soprano::Server::DBusExportIterator::DBusExportIterator(Soprano::StatementIterator, QObject*)
    0,
};


void init_qt_Smoke();

static bool initialized = false;
Smoke *soprano_Smoke = 0;

// Create the Smoke instance encapsulating all the above.
void init_soprano_Smoke() {
    if (initialized) return;
    init_qt_Smoke();
    soprano_Smoke = new Smoke(
        "soprano",
        soprano_classes, 81,
        soprano_methods, 1374,
        soprano_methodMaps, 1314,
        soprano_methodNames, 1202,
        soprano_types, 345,
        soprano_inheritanceList,
        soprano_argumentList,
        soprano_ambiguousMethodList,
        soprano_cast );
    initialized = true;
}
